/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
extern int net_gor_consensus(float *in, float *out, int init)      ;
extern int net_gor_noconsensus(float *in, float *out, int init)    ;
extern int net_gor_consensus111(float *in, float *out, int init)   ;
extern int net_gor_noconsensus111(float *in, float *out, int init) ;
extern int net_profil(float *in, float *out, int init)             ;
extern int net_profil111(float *in, float *out, int init)          ;
extern int net_phd(float *in, float *out, int init)                ;
extern int net_phd111(float *in, float *out, int init)             ;
extern int net_psi(float *in, float *out, int init)                ;
extern int net_psi111(float *in, float *out, int init)             ;
extern int step3_net(float *in, float *out, int init)              ;
extern int step3_net111(float *in, float *out, int init)           ;
extern int step4_net(float *in, float *out, int init)              ;
extern int step4_net111(float *in, float *out, int init)           ;

/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} net_gor_consensusREC = {147,3,net_gor_consensus};
/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} net_gor_noconsensusREC = {147,3,net_gor_noconsensus};
/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} net_gor_consensus111REC = {147,3,net_gor_consensus111};
/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} net_gor_noconsensus111REC = {147,3,net_gor_noconsensus111};
/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} net_profilREC = {273,3,net_profil};
/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} net_profil111REC = {273,3,net_profil111};
/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} net_phdREC = {273,3,net_phd};
/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} net_phd111REC = {273,3,net_phd111};
/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} net_psiREC = {357,3,net_psi};
/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} net_psi111REC = {357,3,net_psi111};
/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} step3_netREC = {312,3,step3_net};
/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} step3_net111REC = {312,3,step3_net111};
/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} step4_netREC = {234,3,step4_net};
/*******************************************************/
static struct {
  int NoOfInput;    /* Number of Input Units  */
  int NoOfOutput;   /* Number of Output Units */
  int(* propFunc)(float *, float*, int);
} step4_net111REC = {234,3,step4_net111};
/*******************************************************/

struct net_stage2
        {
         float nngorb_a   ;
         float nngorb_b   ;
         float nngorb_c   ;

         float nngoru_a   ;
         float nngoru_b   ;
         float nngoru_c   ;

         float nn_profb_a ;
         float nn_profb_b ;
         float nn_profb_c ;

         float nn_profu_a ;
         float nn_profu_b ;
         float nn_profu_c ;

         float nn_phdb_a ;
         float nn_phdb_b ;
         float nn_phdb_c ;

         float nn_phdu_a ;
         float nn_phdu_b ;
         float nn_phdu_c ;

         float nn_psib_a ;
         float nn_psib_b ;
         float nn_psib_c ;

         float nn_psiu_a ;
         float nn_psiu_b ;
         float nn_psiu_c ;
       }  ;
struct net_stage2 *step2 ;

struct net_stage3
       {
        float lpa ;
        float lpb ;
        float lpc ;

        float nnb_pa ;
        float nnb_pb ;
        float nnb_pc ;

        float nnu_pa ;
        float nnu_pb ;
        float nnu_pc ;
       } ;
struct net_stage3 *step3 ;

struct net_stage4
       {
        float nnb_pa ;
        float nnb_pb ;
        float nnb_pc ;

        float nnu_pa ;
        float nnu_pb ;
        float nnu_pc ;

        float pa     ;
        float pb     ;
        float pc     ;

        char stru    ;
       } ;
struct net_stage4 *step4 ;


