/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#define MAXLINE    900000     /* Maximum size of the title for nr database  */
#define MAX_TITLES  50000
#define MAX_SEQ      5000
#define MAX_ENV       200
#define MAX_COM       500
#define MAX_FIC       300

#define MLLC(PT,TYPE,TLL) PT=(TYPE*)malloc(TLL*sizeof(TYPE))


void usage(void)                       ;
void read_seq(void)                    ;
void call_psiblast(void)               ;
void extract(char **x)                 ;
void call_trimmer(void)                ;
void call_clustalw(void)               ;
void read_align(void)                  ;
void translate_align(void)             ;
void truncate_name(char *p , char *q)  ;
void compute_profils(void)             ;
void gorI(void)                        ;
void gorIII(void)                      ;
void gorIV(void)                       ;
void linear_gor(void)                  ;
void quadratic_gor(void)               ;
void write_all_gor(void)               ;
void call_gor_nets(void)               ;
void call_profils_nets(void)           ;
void call_phd_nets(void)               ;
void call_psi_nets(void)               ;
void write_step2(void)                 ;
void net_line_step3(void)              ;
void net_step4(void)                   ;
void del_int_files(void)               ;
float **alloue_2(int a , int b)        ;
char vote(float a , float b , float c) ;
void rematch_align(float **x,  int u)  ;

int mode          ;
int verbose       ;
int del_int       ;
int check_pred    ;  
int casp          ;
int nb_ali_seq    ;  /* total number of aligned sequences */
int length_query  ;  /* size of the query sequence after clustalW */
int *size_prot    ;  /* Table containing the size of each protein in the alignement without gaps */
int **i_seq       ;  /* Index of amino acid in the alignement without gap */

char *file_seq    ;
char *file_dat    ;
char *file_clu    ;
char *file_psi    ;
char *file_out    ;

char *name_matrix        ; /* string containing the file name of psi blast profil  */
char *name_step2         ; /* string containing the file name of step 2 output     */
char *name_step3         ; /* string containing the file name of step 3 output     */
char *file_trimmer       ;
char *name_blast         ;
char *input_clustal      ;
char *output_clustal     ;
char *name_profil1       ;  /* string containing the file name of profil with gaps */
char *name_phd           ;  /* string containing the file name of phd profil       */
char *name_all_gor       ;  /* string containing the file name of gor outputs      */ 
char *seq_query          ;
char **seq               ;


struct consen
    {
     int step1_a ;
     int step1_b ;
     int step1_c ;

     int step2_a ;
     int step2_b ;
     int step2_c ;

     int step3_a ;
     int step3_b ;
     int step3_c ;

     int step4_a ;
     int step4_b ;
     int step4_c ;
    } ;

struct consen *voix ;

