/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "Prof.h"

void call_clustalw(void)
{
int i             ;
char *clustal_dir ;
char *name_ali    ;
char *line_comand ;

MLLC(clustal_dir, char, MAX_ENV)        ;
MLLC(name_ali, char, MAX_FIC)           ;
MLLC(line_comand, char, MAX_COM)        ;
MLLC(output_clustal, char, MAX_FIC)     ;

strncpy(clustal_dir,   "" , MAX_ENV)    ;
strncpy(line_comand, "", MAX_COM)       ;
strncpy(output_clustal, "", MAX_FIC)    ;
strncpy(name_ali, "", MAX_FIC)          ;

strcpy(clustal_dir, getenv("CLUSTAL_DIR")) ;
strcat(line_comand, clustal_dir)           ;
strcat(line_comand, "/clustalw -infile=")          ;
strcat(line_comand, input_clustal)         ;
//  adk 21/11/01 strcat(line_comand, " > l ")               ;
strcat(line_comand, " -OUTORDER=INPUT > /dev/null ")               ;
if(verbose == 1) printf("Wait clustalW is running ....\n")  ;
if(verbose == 1) printf("%s\n", line_comand)                ;
system(line_comand)                        ;


truncate_name(input_clustal , name_ali) ;

strncpy(line_comand, "", MAX_COM)   ;
strcpy(line_comand, "rm ")          ;
strcat(line_comand, name_ali)       ;
strcat(line_comand, ".dnd")         ;
system(line_comand)                 ;
//  adk 21/11/01 system("rm l")                      ;

strcpy(output_clustal, name_ali)    ;
strcat(output_clustal, ".aln")      ;

if(verbose == 1) printf("clustalW completed ...\n") ;
if(verbose == 1) puts(output_clustal) ;



free(name_ali)      ;
free(line_comand)   ;
return ;
}
