/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include "Prof.h"
#include "All_net.h"

void call_gor_nets(void)
{
char res           ;
int i , j , k , u  ;
int *cons          ;
float **attrib     ;
float *netInput,  *netOutput  ;

FILE *fp ;

MLLC(netInput  , float, (net_gor_consensusREC.NoOfInput)   ) ;
MLLC(netOutput , float, (net_gor_consensusREC.NoOfOutput)  ) ;
step2 = (struct net_stage2 *) malloc( (size_prot[0])*sizeof (struct net_stage2) ) ;


MLLC(cons, int, size_prot[0])     ;
attrib = alloue_2( 21 , size_prot[0]) ;


if(verbose == 1) printf("gor networks are started ...\n") ;

if ((fp = fopen(name_all_gor , "r")) == NULL)
       {
       printf("Unable to open gor output in function call_gor_nets ...\n");
       exit(1);
       }
for(i = 0 ; i < size_prot[0] ; i++)
 {
  fscanf(fp,"%c %d %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f\n",
          &res, &cons[i],
          &attrib [0][i], &attrib [1][i], &attrib [2][i], &attrib [3][i], &attrib [4][i],
          &attrib [5][i], &attrib [6][i], &attrib [7][i], &attrib [8][i], &attrib [9][i],
          &attrib[10][i], &attrib[11][i], &attrib[12][i], &attrib[13][i], &attrib[14][i],
          &attrib[15][i], &attrib[16][i], &attrib[17][i], &attrib[18][i], &attrib[19][i],
          &attrib[20][i]) ;
 }
fclose(fp) ;

for(i = 0 ; i <  size_prot[0] ; i++)
 {
  u = 0 ;
  for(j=i-3 ; j <= i+3 ; j++) 
   {
    if( j >= 0 && j < size_prot[0])
     {
     for(k = 0 ; k < 21 ; k++) { netInput[u] = attrib[k][j] ; u++ ; }
     }
    else
     {
     for(k = 0 ; k < 21 ; k++) { netInput[u] = 0. ; u++ ; }
     }
   }
  if(cons[i] == 0) net_gor_noconsensus(netInput, netOutput, 0) ;
  else             net_gor_consensus(netInput, netOutput, 0)   ;
  step2[i].nngorb_a = netOutput[0] ;
  step2[i].nngorb_b = netOutput[1] ;
  step2[i].nngorb_c = netOutput[2] ;
  if(cons[i] == 0) net_gor_noconsensus111(netInput, netOutput, 0) ;
  else             net_gor_consensus111(netInput, netOutput, 0)   ;
  step2[i].nngoru_a = netOutput[0] ;
  step2[i].nngoru_b = netOutput[1] ;
  step2[i].nngoru_c = netOutput[2] ;
/*
  printf("%f %f %f %f %f %f\n", step2[i].nngorb_a, step2[i].nngorb_b, step2[i].nngorb_c,
                                step2[i].nngoru_a, step2[i].nngoru_b, step2[i].nngoru_c) ;
*/
 }



free(netInput)  ;
free(netOutput) ;
free(cons)        ;
for(i = 0; i < 21 ; i++) free(attrib[i]) ; free(attrib) ;

if(verbose == 1) printf("gor networks are completed ...\n") ;

return ;
}
