/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include "Prof.h"
#include "All_net.h"

void call_psi_nets(void)
{
char res, bidon[81] ;
int num             ;
int i , j , k , u   ;
float **attrib      ;
float *netInput,  *netOutput  ;
char junkonline[200];
FILE *fp ;

MLLC(netInput  , float, (net_psiREC.NoOfInput)   ) ;
MLLC(netOutput , float, (net_psiREC.NoOfOutput)  ) ;
attrib = alloue_2( 21 , size_prot[0]) ;

if(mode == 1)
 {
  MLLC(name_matrix, char, MAX_FIC)     ;
  strcpy(name_matrix, file_psi)        ;
 }

if(verbose == 1) printf("psi-blast neural networks are started ...\n") ;

if ((fp = fopen(name_matrix, "r")) == NULL)
       {
       printf("Unable to open psi-blast profil file in function call_psi_nets.c ...\n");
       exit(1);
       }
while(!strstr(fgets(bidon, 80, fp), "A  R  N  D  C  Q  E  G") ) ;
for(i = 0 ; i < size_prot[0] ; i++)
 {
  fscanf(fp,"%d %c %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f",
          &num, &res, 
          &attrib [0][i], &attrib [1][i], &attrib [2][i], &attrib [3][i], &attrib [4][i],
          &attrib [5][i], &attrib [6][i], &attrib [7][i], &attrib [8][i], &attrib [9][i],
          &attrib[10][i], &attrib[11][i], &attrib[12][i], &attrib[13][i], &attrib[14][i],
          &attrib[15][i], &attrib[16][i], &attrib[17][i], &attrib[18][i], &attrib[19][i]) ;
  attrib[20][i] = 0. ;
  /* throw away anything else on line */
  fgets(junkonline, 199, fp);
 }
fclose(fp) ;

for(i = 0 ; i <  size_prot[0] ; i++)
 {
  u = 0 ;
  for(j=i-8 ; j <= i+8 ; j++)
   {
    if( j >= 0 && j < size_prot[0])
     {
     for(k = 0 ; k < 21 ; k++) { netInput[u] = attrib[k][j] ; u++ ; }
     }
    else
     {
     for(k = 0 ; k < 20 ; k++) { netInput[u] = 0. ; u++ ; }
     netInput[u] = 1. ; u++ ;
     }
   }
  net_psi(netInput, netOutput, 0)      ;
  step2[i].nn_psib_a = netOutput[0]    ;
  step2[i].nn_psib_b = netOutput[1]    ;
  step2[i].nn_psib_c = netOutput[2]    ;
  net_psi111(netInput, netOutput, 0)   ;
  step2[i].nn_psiu_a = netOutput[0]    ;
  step2[i].nn_psiu_b = netOutput[1]    ;
  step2[i].nn_psiu_c = netOutput[2]    ;
/*
  printf("%f %f %f %f %f %f\n",
                                step2[i].nn_psib_a, step2[i].nn_psib_b, step2[i].nn_psib_c,
                                step2[i].nn_psiu_a, step2[i].nn_psiu_b, step2[i].nn_psiu_c) ;
*/
 }


free(netInput)  ;
free(netOutput) ;
for(i = 0; i < 21 ; i++) free(attrib[i]) ; free(attrib) ;

if(verbose == 1) printf("completed psi-blast neural networks ...\n") ;

return ;
}
