/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "Prof.h"

void call_psiblast(void)
{
int i, j                  ;
char *blast_dir           ;
char *blast_dat           ;
char *line_comand         ;
char *chaine              ;
char **masque             ;

FILE *fp                  ;

MLLC(blast_dir,    char, MAX_ENV)    ;
MLLC(blast_dat,    char, MAX_ENV)    ;
MLLC(line_comand,  char, MAX_COM)    ;
MLLC(name_matrix,  char, MAX_FIC)    ;
MLLC(name_blast ,  char, MAX_FIC)    ;
MLLC(file_trimmer, char, MAX_FIC)    ;

MLLC(chaine , char, MAX_SEQ)        ;

if ( ( masque = (char **) malloc(MAX_SEQ*sizeof(char *)) ) ) 
 {
  for(i = 0 ; i < MAX_SEQ ; i++) 
    {
     if( !(masque[i] = malloc(MAX_FIC)) ) 
      {
       printf ("Error in malloc 2 for masque in function call_psiblast ... \n") ;
       exit(1) ;
      }
    }
 }
else
 {
  printf ("Error in malloc 1 for masque in function call_psiblast ... \n") ;
  exit(1) ;
 }

strncpy(name_matrix, "" , MAX_FIC) ;
strncpy(name_blast , "" , MAX_FIC) ;
strncpy(file_trimmer,"" , MAX_FIC) ;
strncpy(blast_dir,   "" , MAX_ENV) ;
strncpy(line_comand, "" , MAX_COM) ;

truncate_name(file_seq , name_matrix) ;
strcpy(name_blast, name_matrix)       ;
strcpy(file_trimmer,name_matrix)      ;

strcat(name_matrix, ".matrix")  ;
strcat(name_blast, ".blast")    ;
strcat(file_trimmer, ".trim")   ;


strcpy(blast_dir, getenv("BLAST_DIR"))                    ;
strcpy(blast_dat, getenv("BLAST_DAT"))                    ;
strcpy(line_comand, blast_dir)                            ;
strcat(line_comand, "/blastpgp -j 3 -I T -F \"C;S\" -i ") ;
strcat(line_comand, file_seq)                             ;
strcat(line_comand, " -Q ")                               ;
strcat(line_comand, name_matrix)                          ;
strcat(line_comand, " -d ")                               ;
strcat(line_comand, blast_dat)                            ;
strcat(line_comand, "/")                                  ;
strcat(line_comand, file_dat)                             ;
strcat(line_comand, " > ")                                ;
strcat(line_comand, name_blast)                           ;

if(verbose == 1) printf("%s\n", line_comand) ;
if(verbose == 1) printf("Wait psi-blast is running ...\n") ;

system(line_comand)         ;

free(line_comand)           ;
printf("psi-blast run completed ...\n") ;

if ((fp = fopen(name_blast , "r")) == NULL)
       {
       printf("Unable to open blast output in function call_psiblast ...\n");
       exit(1);
       }
i = 0 ;
while(fgets(chaine, MAX_FIC , fp) != NULL)
 {
  if(strstr(chaine, "gi|") )
    {
     j = 0 ;
     while(chaine[j] != ' ') { masque[i][j] = chaine[j] ; j++ ; }
     i++ ;
    }
  if(chaine[0] == '>') break ;
 }
fclose(fp) ;
nb_ali_seq = i-1 ;

extract(masque) ;

for(i = 0 ; i < MAX_SEQ ; i++) free(masque[i]) ;
free(masque) ;

return ;
}
