/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "Prof.h"

void call_trimmer(void)
{
char *prof_dir     ;
char *line_comand  ;

MLLC(prof_dir, char, MAX_ENV)        ;
MLLC(input_clustal, char, MAX_FIC)   ;
MLLC(line_comand, char, MAX_COM)     ;

strcpy(input_clustal, file_trimmer) ;
strcat(input_clustal, "out")        ;

strncpy(prof_dir,   "" , MAX_ENV)    ;
strncpy(line_comand, "", MAX_COM)    ;
strcpy(prof_dir, getenv("PROF_DIR")) ;
strcat(line_comand, prof_dir)        ;
strcat(line_comand, "/trimmer10 -thresh2 25 -thresh 97.5  ")   ;
strcat(line_comand, file_trimmer)    ;
strcat(line_comand, " >  " )         ;
strcat(line_comand, input_clustal)   ;

if(verbose == 1) printf("%s\n", line_comand) ;
system(line_comand)         ;


free(line_comand)      ;

return ;
}
