/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include "Prof.h"

void compute_profils(void)
{
int i , j , k   ;
float f_e[21]   ;
FILE *fp , *fp1 ;

MLLC(name_profil1, char, MAX_FIC)    ;
MLLC(name_phd    , char, MAX_FIC)    ;

strncpy(name_profil1, "" , MAX_FIC)    ;
strncpy(name_phd    , "" , MAX_FIC)    ;

if(mode == 0) truncate_name(file_seq , name_profil1) ;
else          truncate_name(file_clu , name_profil1) ;
strcat(name_profil1, ".profil1")                     ;
if(mode == 0) truncate_name(file_seq , name_phd)     ;
else          truncate_name(file_clu , name_phd)     ;
strcat(name_phd, ".phd_like")                        ;

if ((fp=fopen(name_profil1, "w")) == NULL)
       {
       printf("Unable to open file for profil1 in function compute_profils ... \n");
       exit(1);
       }
if ((fp1=fopen(name_phd, "w")) == NULL)
       {
       printf("Unable to open file for profil phd_like in function compute_profils ... \n");
       exit(1);
       }
for(i = 0 ; i < length_query ; i++)
 {
  for(k = 0; k <=20 ; k++) f_e[k] =0.;
  for (j = 0; j < nb_ali_seq; j++)
   {
     switch(seq[j][i])
      {
       case 'A': f_e[0]  += 1. ; break ;
       case 'C': f_e[1]  += 1. ; break ;
       case 'D': f_e[2]  += 1. ; break ;
       case 'E': f_e[3]  += 1. ; break ;
       case 'F': f_e[4]  += 1. ; break ;
       case 'G': f_e[5]  += 1. ; break ;
       case 'H': f_e[6]  += 1. ; break ;
       case 'I': f_e[7]  += 1. ; break ;
       case 'K': f_e[8]  += 1. ; break ;
       case 'L': f_e[9]  += 1. ; break ;
       case 'M': f_e[10] += 1. ; break ;
       case 'N': f_e[11] += 1. ; break ;
       case 'P': f_e[12] += 1. ; break ;
       case 'Q': f_e[13] += 1. ; break ;
       case 'R': f_e[14] += 1. ; break ;
       case 'S': f_e[15] += 1. ; break ;
       case 'T': f_e[16] += 1. ; break ;
       case 'V': f_e[17] += 1. ; break ;
       case 'W': f_e[18] += 1. ; break ;
       case 'Y': f_e[19] += 1. ; break ;
       default : f_e[20] += 1. ; break ;
      }
   }
  if(seq[0][i] == '-' || seq[0][i] == '.') continue ;
  else {
         fprintf(fp, "%c ", seq[0][i]) ;
         fprintf(fp1, "%c ", seq[0][i]) ;
         for(k = 0; k <=20 ; k++) 
           fprintf(fp, "%5.3f ",  f_e[k] / (float) nb_ali_seq ) ;
           fprintf(fp, "\n") ;
         for(k = 0; k < 20 ; k++) 
           fprintf(fp1, "%5.3f ",  f_e[k] / ((float) nb_ali_seq - f_e[20]) ) ;
           fprintf(fp1, " 0.\n") ;
       }
 }
 fclose(fp)  ;
 fclose(fp1) ;

 return ;

}
