/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "Prof.h"

void extract(char **name_prot)
{
int i, comp     ;
char *name_base ;
char *chaine    ;
FILE *fp, *fp1  ;

MLLC(name_base, char, MAX_FIC)         ;
MLLC(chaine, char, MAXLINE)            ;
strncpy(name_base, "" , MAX_FIC)       ;
strcat(name_base, getenv("BLAST_DAT")) ;
strcat(name_base, "/")                 ;
strcat(name_base, file_dat)            ;

if(verbose == 1) printf("Wait extracting sequences ...\n") ;
if(verbose == 1) printf("The extracting procedure takes a while , sorry ...\n") ;

if ((fp = fopen(name_base, "r")) == NULL)
       {
       printf("Unable to open file for sequence extraction in function extract ... \n");
       exit(1);
       }

fp1 = fopen(file_trimmer, "w")          ; 

fprintf(fp1, ">P_query\n")              ;
fprintf(fp1, "%s\n",seq_query)          ;

comp = 0 ;
while(fgets(chaine, MAXLINE, fp) != NULL)
        {
         if(strstr(chaine, ">gi") )
          {
          for(i = 0 ; i < nb_ali_seq ; i++)
             {
              if(strstr(chaine, name_prot[i]))
                {
                  fprintf(fp1, ">%s\n" , name_prot[i]);
                  while(!strstr(fgets(chaine, MAXLINE, fp), ">gi"))
                   {
                    fprintf(fp1, "%s", chaine) ;
                   }
                 i = 0  ;
                 comp++ ;
                }
             }
         }
         if(comp == nb_ali_seq) break ;
        }

fclose(fp)  ;
fclose(fp1) ;
if(verbose == 1) printf("Extraction completed ...\n") ;

free(chaine)    ;
free(name_base) ;
return ;
}
