/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#define WINSIZE  16
#define OF_S      8

#define t1_a 1.88886951670269893297
#define t1_b 3.66980440786877853559
#define t1_c 1.27426704732623256835

#define const_1 -0.88235294117647058823
#define const_2  0.11764705882352941176


#define i_dira(i,j) i_dira[i*(WINSIZE+1) + j]
#define i_dirb(i,j) i_dirb[i*(WINSIZE+1) + j]
#define i_dirc(i,j) i_dirc[i*(WINSIZE+1) + j]

#define i_paira(i, j, m) i_paira[21*(WINSIZE+1)*i + (WINSIZE+1)*j + m]
#define i_pairb(i, j, m) i_pairb[21*(WINSIZE+1)*i + (WINSIZE+1)*j + m]
#define i_pairc(i, j, m) i_pairc[21*(WINSIZE+1)*i + (WINSIZE+1)*j + m]

#define ratio_s_ra(i,  j) ratio_s_ra[i*(WINSIZE+1) + j]
#define ratio_s_rb(i,  j) ratio_s_rb[i*(WINSIZE+1) + j]
#define ratio_s_rc(i,  j) ratio_s_rc[i*(WINSIZE+1) + j]

#define ratio_pair_paira(i, m, j, n) ratio_pair_paira[21*(WINSIZE+1)*(WINSIZE+1)*i + 21*(WINSIZE+1)*m + (WINSIZE+1)*j + n]
#define ratio_pair_pairb(i, m, j, n) ratio_pair_pairb[21*(WINSIZE+1)*(WINSIZE+1)*i + 21*(WINSIZE+1)*m + (WINSIZE+1)*j + n]
#define ratio_pair_pairc(i, m, j, n) ratio_pair_pairc[21*(WINSIZE+1)*(WINSIZE+1)*i + 21*(WINSIZE+1)*m + (WINSIZE+1)*j + n]

float *i_dira   ;
float *i_dirb   ;
float *i_dirc   ;

float *i_paira  ;
float *i_pairb  ;
float *i_pairc  ;

float *ratio_s_ra ;
float *ratio_s_rb ;
float *ratio_s_rc ;

float *ratio_pair_paira ;
float *ratio_pair_pairb ;
float *ratio_pair_pairc ;

float **infa1 , **infb1, **infc1 ;
float **infa3 , **infb3, **infc3 ;
float **ida4  , **idb4 , **idc4  ;

float **pa1, **pb1 , **pc1       ;
float **pa3, **pb3 , **pc3       ;
float **pa4, **pb4 , **pc4       ;

float *pa_l , *pb_l, *pc_l ;
float *pa_q , *pb_q, *pc_q ;

struct g1 {
           float info_a ;
           float info_b ;
           float info_c ;
           float p_a    ;
           float p_b    ;
           float p_c    ;
          }   ;
struct g1 *gor1 , *gor3 ;

struct g2 {
           float id_a ;
           float id_b ;
           float id_c ;
           float p_a  ;
           float p_b  ;
           float p_c  ;
          } ;
struct g2 *gor4       ;

