/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  net_gor_consensus.c
  --------------------------------------------------------
  generated at Thu Jun 24 17:48:41 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[165];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, 
Units + 158, Units + 159, Units + 160, Units + 161, 
Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, 
Units + 158, Units + 159, Units + 160, Units + 161, 
Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, 
Units + 158, Units + 159, Units + 160, Units + 161, 

  };

  /* Weigths definition section */
  static float Weights[] =  {
-0.916630, 0.594640, 0.265480, -0.383110, 0.005890, -0.034950, 0.421420, 0.126890, -0.229860, -0.078750, 
-0.104340, -0.241480, -0.197460, -0.102730, -0.170090, -0.162300, -0.107520, -0.095020, 0.378990, -0.943520, 
0.180940, -0.550650, 0.230220, 0.555790, -0.335150, 0.012700, -0.016490, 0.708820, -0.064010, -0.369260, 
-0.022190, -0.018060, -0.204360, -0.184200, -0.202900, -0.070390, -0.167330, -0.272280, 0.003890, 0.074580, 
-0.566250, 0.139030, -0.176240, -0.301110, 0.539480, -0.387070, -0.050400, 0.098610, 0.626500, -0.140970, 
-0.405710, -0.137820, -0.072460, -0.124220, -0.050230, -0.229350, -0.068750, -0.080860, -0.212340, -0.027930, 
0.167780, -0.230300, -0.191350, 0.492610, -0.206710, 0.190160, -0.324780, -0.028100, -0.001310, 0.874430, 
-0.774150, -0.655200, -0.220300, 0.034650, -0.119050, 0.058820, -0.102090, -0.262770, 0.107460, -0.120280, 
-0.341340, 0.350050, -0.112680, -0.623470, -0.133920, 0.213230, 0.701830, -0.371240, 0.056650, -0.109800, 
0.465570, -0.141930, -0.447960, -0.133750, -0.090760, -0.145630, -0.171690, -0.103940, -0.272030, 0.046480, 
-0.159140, -0.229230, 0.310340, -0.076760, -0.784740, -0.185670, -0.031100, 0.756210, -0.362200, -0.111690, 
-0.042600, 0.470430, 0.115230, -0.054080, -0.199040, -0.013720, -0.060480, -0.044430, -0.150570, -0.115860, 
-0.064720, -0.042000, -0.163660, 0.292570, -0.243800, -0.275160, -0.461760, 0.406050, 0.370420, -0.163050, 
-0.102870, 0.141350, 0.434110, -0.029750, 0.078300, -0.158260, -0.057680, 0.072460, -0.085840, -0.143120, 
-0.080880, 0.031560, -0.248960, -0.099680, 0.350980, -0.944180, 0.203070, 
0.173190, 0.015160, -0.103840, -0.151080, -0.046960, 0.086390, 0.163750, 0.169030, -0.240560, -0.067230, 
0.153490, -0.007330, -0.278700, -0.009780, 0.009470, -0.261180, 0.022180, 0.142590, -0.421430, 0.346390, 
0.172570, 0.071120, -0.453660, 0.305750, -0.089650, -0.099010, 0.072300, -0.258440, 0.134040, 0.540930, 
-0.156090, 0.057080, 0.002980, -0.130040, 0.034490, 0.110330, -0.332710, -0.028010, 0.174970, -0.383750, 
0.199540, 0.053550, -0.298890, -0.293050, 0.410690, -0.142950, -0.026420, 0.174540, -0.104550, 0.037260, 
-0.132250, -0.010540, -0.021970, 0.083790, -0.161020, -0.026640, 0.069880, -0.154120, -0.116670, 0.013310, 
-0.080860, 0.052420, -0.000750, 0.091540, 0.418610, -0.259460, -0.097430, -0.054920, -0.154000, 0.063200, 
0.350790, -0.290680, -0.066670, 0.001760, -0.026070, 0.035570, 0.095440, -0.200410, 0.077900, -0.162930, 
-0.191210, -0.011410, -0.178080, -0.108740, -0.230200, 0.813050, -0.102580, -0.300240, 0.096710, -0.046290, 
0.260580, 0.298000, -0.503370, -0.028890, 0.019580, -0.195890, -0.104520, 0.050950, -0.167930, 0.091810, 
-0.025060, -0.118700, 0.151820, -0.021590, -0.311760, -0.019510, 0.427980, -0.167870, -0.108620, -0.073290, 
-0.103210, 0.533170, 0.469190, -0.235690, -0.127150, -0.048580, -0.054800, -0.016910, -0.089150, -0.035760, 
0.111760, -0.124000, -0.123390, 0.496750, -0.450190, -0.328270, 0.079690, 0.272680, -0.173870, 0.015770, 
-0.008000, -0.073310, 0.780210, 0.258180, -0.512330, -0.034740, -0.067100, -0.035300, 0.198510, -0.149230, 
-0.122100, 0.153340, -0.232580, -0.225380, 0.630580, -0.501360, -0.112640, 
-0.587890, 0.613280, 0.126560, -0.270360, 0.015730, -0.054130, 0.017250, 0.131340, 0.120690, -0.153960, 
-0.092910, -0.208200, -0.193870, -0.072380, -0.010090, -0.108040, -0.189980, 0.084210, -0.007590, -0.300090, 
-0.099890, -0.396440, 0.348110, 0.385120, -0.239360, -0.033230, -0.144370, -0.092370, 0.199440, 0.345940, 
-0.119170, -0.109410, -0.081830, -0.305760, -0.022600, 0.001040, -0.330900, -0.056680, 0.025540, -0.134300, 
0.025580, -0.334310, -0.410300, 0.058280, 0.541240, -0.389190, -0.081830, -0.061380, -0.002460, 0.248880, 
0.027490, -0.125030, -0.097830, -0.066410, -0.270500, -0.117290, -0.179070, -0.234300, -0.144800, -0.227070, 
-0.276410, 0.095060, -0.290920, 0.273800, 0.188760, 0.037630, -0.316750, -0.065340, -0.066500, 0.740910, 
-0.449520, -0.695270, -0.144100, -0.064310, -0.260850, 0.000340, -0.139050, -0.334930, 0.026850, -0.073930, 
-0.267690, -0.051650, 0.054640, -0.275100, -0.328620, 0.417040, 0.318470, -0.455680, 0.014790, -0.031870, 
0.515280, -0.354600, 0.002850, -0.168640, -0.239550, -0.081980, -0.064300, -0.111360, -0.078150, -0.068170, 
-0.220640, -0.189370, -0.018930, -0.223640, -0.171370, -0.246490, 0.295440, 0.249420, -0.330020, -0.201000, 
0.058980, 0.889170, 0.065270, -0.365980, -0.117020, -0.145130, -0.092140, -0.107670, -0.272120, -0.213430, 
0.050270, -0.412500, -0.204870, 0.407410, -0.560930, -0.344460, -0.066870, 0.461390, -0.076380, -0.122730, 
-0.214440, -0.114810, 1.380570, 0.389910, -0.719890, 0.169870, -0.085860, -0.341430, 0.114300, -0.271980, 
-0.256420, 0.385350, -0.463640, -0.354940, 0.989870, -1.060990, -0.255510, 
0.628730, 0.203270, -0.331790, 0.011320, -0.110020, -0.221910, 0.222050, 0.279090, 0.149180, -0.048130, 
-0.019880, -0.214140, -0.052000, -0.136680, -0.248790, 0.046090, -0.070650, -0.221990, -0.103350, -0.164320, 
-0.163290, 0.367560, 0.373590, -0.268040, -0.083040, -0.109320, -0.165700, 0.443390, 0.286510, -0.442380, 
-0.082010, -0.043750, -0.103680, 0.033680, 0.028980, -0.165200, 0.066480, -0.145630, -0.186360, 0.037080, 
-0.065350, -0.067130, 0.300710, 0.589790, -0.341030, 0.004090, -0.129070, -0.122510, -0.044020, 0.449250, 
-0.195240, -0.144690, -0.034760, -0.099060, -0.131850, -0.092770, -0.229840, -0.015240, -0.077930, -0.155060, 
0.185140, -0.091960, -0.413840, 0.244010, 0.668490, -0.321430, -0.128250, -0.040900, -0.175740, -0.223520, 
0.130760, -0.125050, -0.148070, -0.077440, -0.046980, 0.061130, -0.049590, -0.286190, 0.139250, -0.122020, 
-0.157780, 0.189540, -0.144880, -0.234720, -0.309180, 0.074640, 0.320140, -0.046600, -0.134240, -0.142820, 
0.100340, 0.070810, -0.045740, -0.103320, -0.064170, -0.116620, -0.034510, 0.021700, -0.130790, -0.069690, 
-0.062910, -0.106650, -0.083630, -0.046210, -0.246560, 0.102020, -0.610700, 0.526590, -0.033010, -0.171290, 
-0.007520, 0.068840, -0.548630, 0.498160, -0.104210, -0.081030, 0.105360, -0.192760, -0.059220, -0.102630, 
-0.068500, -0.235060, -0.055460, -0.275970, -0.060630, 0.233210, 0.187690, 0.001940, 0.116000, -0.068490, 
-0.078220, -0.077300, 0.143840, 0.059360, 0.187510, -0.241360, -0.085300, -0.070940, -0.146930, 0.076760, 
-0.144740, -0.255360, -0.056050, 0.022040, -0.329580, -0.059060, 0.152650, 
0.590830, -0.402010, -0.299190, 0.246250, 0.046280, -0.164820, -0.285830, -0.289870, -0.205040, 0.057710, 
0.130620, -0.085370, 0.016570, 0.209300, -0.202640, -0.198750, 0.262710, -0.119550, -0.479450, 0.721820, 
-0.154320, 0.377500, -0.291850, -0.398110, 0.119940, -0.041600, -0.286320, -0.285840, -0.140570, -0.250230, 
-0.018220, 0.003830, -0.073340, -0.015250, 0.191210, -0.122020, 0.052720, 0.264680, -0.063050, -0.303460, 
0.393150, -0.053510, 0.127570, 0.140400, -0.528510, 0.133080, -0.009710, -0.303460, -0.698070, 0.293510, 
0.156070, 0.014030, 0.126080, -0.057730, 0.119280, 0.113700, -0.101420, -0.054450, 0.120110, -0.073990, 
-0.135000, 0.284950, -0.100090, -0.452500, 0.103930, -0.270520, 0.121100, 0.047420, -0.156160, -0.810740, 
0.493680, 0.457250, 0.127790, 0.027740, -0.113380, -0.154810, 0.147640, -0.022380, -0.139560, 0.099750, 
0.122650, -0.106270, 0.127950, -0.058720, 0.277320, -0.200930, -0.641480, 0.369740, 0.045270, -0.181630, 
-0.905500, 0.335980, 0.113550, -0.067650, -0.086560, -0.011120, 0.030880, 0.105010, -0.094360, -0.184980, 
0.082520, -0.122520, -0.038460, 0.156700, 0.042070, 0.488330, 0.043190, -0.622950, 0.248310, 0.011440, 
-0.253060, -0.464690, -0.312990, -0.190610, 0.094330, 0.009580, -0.080010, -0.174330, 0.146160, 0.009530, 
-0.051120, 0.196860, -0.203630, -0.246540, 0.444890, -0.263630, 0.500350, 0.086580, -0.393330, 0.155840, 
-0.012730, -0.324080, -0.401650, -0.198240, -0.328080, -0.034860, 0.095450, -0.103160, -0.177120, 0.126190, 
-0.031140, -0.372290, 0.324850, -0.078190, -0.767000, 1.165140, -0.335830, 
-0.123070, -0.071730, 0.122410, -0.049390, -0.091200, -0.002050, 0.161400, -0.317510, 0.118050, -0.078950, 
-0.040510, 0.004800, -0.019190, -0.025910, -0.147070, 0.179140, -0.270340, -0.009630, 0.776150, -0.846380, 
0.029780, 0.001360, 0.070550, 0.181990, -0.096310, -0.017970, 0.066610, 0.289220, -0.683550, 0.108280, 
0.025100, -0.161290, -0.118300, 0.055280, -0.103400, -0.010280, 0.089760, -0.262940, 0.037210, 0.333720, 
-0.618720, 0.053370, 0.153550, -0.147560, 0.196120, -0.177240, -0.112340, -0.003590, 0.254660, -0.250450, 
0.071640, 0.054940, -0.001750, -0.098120, -0.032590, -0.077910, -0.048680, -0.066300, -0.059270, -0.004610, 
-0.028480, -0.350660, 0.094650, 0.018960, -0.429990, 0.459350, -0.159910, 0.038040, -0.009720, 0.527770, 
-0.803090, 0.106270, 0.091990, -0.003640, -0.138680, -0.005580, -0.126510, 0.039080, 0.052060, -0.009970, 
0.020650, 0.061430, -0.138780, 0.047720, -0.057160, -0.210980, 0.400070, -0.081070, -0.040990, 0.104810, 
-0.112750, -0.014660, 0.188570, -0.010020, -0.029420, 0.037910, 0.070680, -0.127510, -0.050670, -0.094830, 
-0.003710, 0.018870, -0.100820, -0.017860, 0.053280, -0.212250, 0.014540, 0.221420, -0.045050, -0.031100, 
-0.070260, 0.314930, -0.172010, -0.001380, 0.053130, -0.019570, -0.093490, -0.034640, 0.043630, -0.005600, 
-0.020550, -0.093070, 0.008130, 0.012260, -0.159130, -0.025710, -0.114170, -0.062140, -0.130420, 0.032060, 
-0.023350, -0.118090, 0.010690, -0.035060, -0.097080, 0.016420, -0.162310, -0.066370, 0.000870, -0.014160, 
-0.099750, -0.002630, -0.181240, -0.020660, 0.199470, -0.429550, 0.024560, 
0.445130, -0.537150, -0.086810, -0.071000, -0.141950, -0.146110, -0.241360, 0.386750, 0.000240, -0.126900, 
0.022490, -0.202500, -0.075640, 0.047530, -0.173850, -0.391270, 0.124240, -0.127460, -0.455550, 0.147520, 
-0.108160, 0.292780, -0.102100, -0.170720, 0.027590, -0.063580, -0.241280, -0.456040, 0.249120, 0.410030, 
-0.212940, -0.018750, -0.155610, -0.186280, -0.085390, -0.312600, -0.293820, -0.025230, -0.002040, -0.246570, 
0.049980, -0.121290, 0.471240, 0.286880, -0.537290, 0.047470, -0.134460, -0.208020, -0.232150, 0.472700, 
-0.476840, -0.220770, -0.074550, -0.186810, -0.107280, 0.052380, -0.197120, -0.183660, -0.156750, -0.166800, 
-0.013980, -0.067170, -0.199790, 0.005390, 0.430790, -0.579060, 0.015880, 0.000370, -0.236180, -0.630790, 
0.605670, -0.251280, -0.216960, -0.064910, -0.205780, -0.246850, 0.118240, -0.179170, -0.197990, -0.168460, 
-0.157260, -0.005590, -0.074260, -0.142990, -0.039820, 0.115620, -0.058120, -0.165450, -0.053280, -0.239120, 
-0.704620, 0.011880, 0.092570, -0.111400, -0.126440, -0.070350, -0.225750, -0.120440, -0.208440, -0.139700, 
-0.036760, -0.034410, -0.001080, -0.309210, -0.061010, 0.293560, -0.100770, -0.084730, -0.059440, -0.098910, 
-0.251560, -0.038820, 0.349280, -0.039390, -0.141410, -0.128200, -0.247930, -0.179230, -0.121760, -0.147870, 
-0.266530, 0.045710, -0.067290, -0.147840, -0.063410, 0.058850, 0.532760, -0.346630, 0.112920, -0.091130, 
-0.042990, -0.245030, -0.424360, 0.642250, 0.410840, -0.243040, 0.096810, -0.165600, -0.301060, 0.057050, 
-0.101050, -0.465170, 0.086090, -0.142010, -0.449200, 0.259030, -0.156620, 
0.002600, 0.515090, -0.346100, -0.003840, 0.057120, -0.068680, 0.550570, -0.217860, -1.016080, 0.050000, 
0.051460, -0.192660, 0.104920, 0.176990, -0.187270, 0.129230, 0.037480, -0.234900, 0.285300, -0.030870, 
-0.317580, -0.294600, 0.181930, 0.077080, 0.043670, 0.138120, 0.009240, -0.237710, -0.374990, 0.226250, 
-0.139690, 0.033590, 0.046440, -0.073670, 0.164760, -0.186510, -0.092820, 0.156240, -0.051240, -0.055380, 
0.085480, 0.044020, -0.338090, 0.112080, 0.172330, -0.124960, -0.058980, -0.008270, -0.525080, -0.090710, 
0.535500, -0.062040, 0.038760, -0.018120, -0.016700, 0.113990, -0.004300, -0.094630, 0.103650, -0.017310, 
-0.268680, 0.002880, 0.242810, -0.777700, -0.249730, 0.575880, -0.006690, -0.093480, 0.029910, -0.731490, 
0.188720, 1.105920, -0.067920, -0.020420, 0.081420, -0.211840, -0.057280, 0.183400, -0.253980, 0.076120, 
0.168810, -0.229230, -0.053040, 0.210010, -0.058780, 0.155950, 0.001900, -0.007310, 0.080080, -0.001200, 
0.352110, 0.018300, 0.293580, 0.131250, 0.014350, 0.076430, -0.023270, -0.003430, -0.030790, -0.048150, 
0.147940, -0.063210, -0.139540, -0.038060, 0.069290, 0.124700, 0.427780, -0.359960, 0.019380, -0.036100, 
-0.057250, -0.125590, -0.320930, -0.029810, 0.165870, 0.001910, -0.031140, -0.069700, -0.006670, -0.039150, 
0.065270, 0.008140, -0.172870, 0.068060, -0.123250, -0.049820, 0.128170, 0.173370, -0.181080, 0.033190, 
-0.016250, -0.124590, 0.043030, -0.332710, -0.027180, 0.052150, -0.138330, 0.043630, -0.038910, -0.009420, 
-0.036880, -0.158700, 0.105450, 0.044040, -0.004520, -0.119810, -0.076320, 
-0.401500, 0.704690, -0.058270, -0.407590, -0.130690, -0.189590, 0.480540, -0.186680, 0.200800, -0.313170, 
-0.274380, -0.150220, -0.267720, -0.037330, -0.145880, -0.177300, -0.236580, -0.067790, 0.013310, -0.633590, 
-0.095370, -0.237900, 0.488550, -0.010600, -0.354690, -0.100100, -0.252670, 0.362900, -0.338030, -0.269600, 
-0.260810, -0.195240, -0.307100, -0.275370, -0.166670, -0.203440, -0.327460, -0.262400, -0.198940, -0.201470, 
-0.277960, -0.108740, -0.206860, 0.385590, 0.099650, -0.431820, -0.093960, -0.248130, 0.773110, -0.392710, 
-0.314740, -0.261740, -0.168800, -0.278340, -0.289210, -0.128140, -0.334060, -0.264960, -0.213800, -0.116020, 
-0.188500, -0.036550, -0.421160, 0.124750, 0.498110, 0.146260, -0.460120, -0.084350, -0.149150, 0.532040, 
-0.037160, -0.706410, -0.276260, 0.092440, -0.236660, -0.254860, 0.005370, -0.309730, -0.185860, 0.020250, 
-0.289080, 0.002870, 0.100600, -0.641820, -0.257610, 0.512430, 0.408530, -0.471920, -0.087960, -0.163790, 
0.890490, -0.101780, -0.425320, -0.118710, -0.062850, -0.241920, -0.246830, -0.206950, -0.284550, -0.171510, 
-0.098400, -0.293080, 0.112400, 0.042460, -0.800540, -0.197170, 0.431170, 0.559490, -0.406580, -0.193910, 
-0.088790, 1.224260, -0.317690, -0.494310, -0.165700, -0.178130, -0.228920, -0.074350, -0.167370, -0.184390, 
-0.100270, -0.337780, -0.315980, 0.261690, -0.429320, -0.497460, -0.252720, 0.544420, 0.142840, -0.300280, 
-0.050450, -0.020230, 1.237030, 0.215870, -0.278380, -0.057500, -0.265690, -0.178530, 0.050220, -0.081070, 
-0.335180, 0.178530, -0.428840, -0.109930, 0.595100, -0.835670, -0.109510, 
0.205930, -0.061360, 0.191280, -0.029720, -0.087690, -0.142290, 0.091260, -0.006000, -0.208780, -0.002220, 
0.025410, -0.151660, 0.068290, -0.174110, -0.248090, 0.042640, -0.197810, -0.239060, 0.455060, -0.625730, 
-0.237270, -0.151690, 0.008860, 0.205260, -0.087830, -0.094640, -0.063870, -0.180060, -0.043780, 0.131360, 
-0.164450, -0.156310, -0.037680, -0.103970, -0.135370, -0.091390, 0.076650, -0.123960, -0.135440, 0.049900, 
-0.239090, -0.011410, -0.104270, 0.002050, 0.155500, -0.110140, -0.055280, -0.080250, -0.314330, -0.116380, 
0.791990, -0.032830, -0.091820, 0.004370, -0.020300, -0.024900, -0.000460, -0.094320, -0.013520, -0.098720, 
-0.162870, -0.174880, 0.184600, -0.308210, -0.541220, 0.470530, 0.012490, -0.026080, -0.016890, -0.150320, 
-0.629370, 0.905080, -0.105980, -0.185320, -0.084510, -0.272310, -0.026630, 0.006110, -0.189040, 0.105510, 
0.057890, -0.286060, -0.051620, -0.000280, 0.456540, -0.103700, -0.471370, -0.069970, -0.022460, -0.304880, 
-0.089750, -0.037440, 0.254800, -0.140520, 0.004470, -0.177530, -0.162240, 0.004240, -0.156990, -0.240110, 
0.003780, -0.087110, -0.197410, -0.069310, -0.020500, 0.022000, 0.552970, -0.424260, -0.047010, -0.056040, 
-0.269970, -0.497230, 0.215240, 0.083350, 0.009610, -0.106350, -0.140270, -0.104870, 0.099650, -0.195010, 
-0.168400, 0.198380, -0.060790, -0.150500, -0.002880, 0.091830, 0.238600, 0.052800, -0.081930, -0.032510, 
-0.096780, -0.191740, -0.132190, -0.281370, 0.234990, -0.088390, -0.201940, 0.034210, -0.115400, 0.128980, 
-0.201150, -0.358570, 0.060280, -0.091510, -0.114010, -0.085030, -0.149000, 
0.080760, -0.428660, 0.271850, -0.029170, -0.106020, -0.165280, 0.044970, -0.499610, -0.047580, -0.049250, 
0.014550, -0.101130, -0.062680, 0.019170, -0.207980, -0.046470, -0.078830, -0.152210, 0.103910, -0.090870, 
-0.299300, 0.201760, -0.061770, -0.411020, 0.021310, -0.104820, -0.199830, 0.079790, -0.347720, 0.045620, 
-0.054520, -0.067500, -0.207030, -0.107420, 0.076270, -0.294970, 0.055710, 0.126780, -0.324600, 0.090350, 
-0.025250, -0.329610, 0.065340, 0.498740, -0.555190, -0.030960, 0.106290, -0.254910, 0.248360, 0.341330, 
-0.300380, 0.048670, 0.102830, -0.306200, -0.010660, 0.176970, -0.230470, -0.069320, 0.213390, -0.301110, 
-0.155870, -0.106750, 0.001320, -1.083870, 0.172160, 0.502090, -0.152180, -0.058270, -0.048040, -0.645100, 
0.507130, 0.909730, -0.044630, -0.070010, -0.016610, -0.215950, 0.121150, 0.021440, -0.415550, 0.142670, 
0.195980, -0.291510, 0.137340, 0.121500, -0.127140, -0.662100, 0.130470, -0.009700, -0.111710, -0.091330, 
-1.006240, -0.299720, 0.974630, -0.211420, 0.019040, 0.111910, -0.108410, -0.034910, -0.027350, -0.359240, 
0.023330, 0.100500, -0.238620, -0.026730, 0.062200, 0.165520, -0.391110, -0.100890, 0.095220, 0.020310, 
-0.258860, -0.197300, -0.879750, 0.244230, 0.104800, -0.160220, -0.131970, -0.055370, 0.088460, -0.052940, 
-0.176850, 0.035040, -0.211840, 0.026110, 0.073920, -0.313020, 0.875990, -1.074660, -0.081090, 0.057540, 
-0.064200, -0.243230, 0.086790, -0.605320, -0.080090, 0.013950, -0.133290, -0.042860, -0.067970, -0.180030, 
-0.188640, -0.163900, 0.025210, -0.129280, 0.138400, -0.009130, -0.426750, 
0.273060, -0.483800, -0.016330, 0.262570, 0.088590, 0.038630, -1.088070, 0.593240, 0.192120, -0.112760, 
0.181700, 0.119180, 0.122120, 0.018820, 0.242350, 0.056340, 0.152340, 0.029480, -0.328300, 0.814240, 
-0.136480, 0.132100, -0.157070, -0.246500, 0.165760, -0.076170, 0.000550, -1.045380, 0.620900, 0.541510, 
0.003490, 0.034820, 0.192320, 0.177880, 0.181350, 0.131580, 0.043250, 0.261470, 0.017160, -0.171230, 
0.476640, -0.062410, -0.115100, 0.052330, -0.352640, 0.228300, 0.015940, 0.086270, -0.962030, 0.244190, 
0.576050, 0.131020, -0.038960, 0.174920, 0.015990, 0.044790, 0.100270, 0.024550, 0.065460, 0.157320, 
-0.224990, 0.165630, 0.431890, -0.117950, -0.209430, -0.432240, 0.357940, -0.067760, 0.050910, -0.000960, 
-0.300550, 0.230770, 0.314590, -0.075130, 0.089700, -0.010080, 0.150240, 0.188490, -0.012980, 0.035820, 
0.174550, -0.139310, -0.053620, 0.435980, 0.565540, -0.029970, -1.048230, 0.408790, -0.077370, -0.110950, 
0.112040, -0.397970, -0.042080, 0.237550, 0.048730, 0.170860, 0.154430, 0.008380, 0.188830, 0.158250, 
0.127630, 0.096790, -0.055430, -0.192070, 0.607580, 0.302990, 0.154030, -0.913820, 0.347910, 0.100340, 
-0.055880, -0.497630, -0.063300, -0.027730, 0.087600, 0.061180, 0.174820, -0.004590, 0.135960, 0.124310, 
0.164230, 0.051590, 0.137990, -0.114130, 0.000130, 0.311910, 0.061820, -0.427050, -0.056460, 0.062660, 
0.061120, -0.051300, -0.604360, 0.171510, 0.091410, 0.056100, 0.047660, 0.043760, 0.061930, -0.100890, 
0.238140, -0.087920, 0.166700, 0.207950, -0.438620, 0.607600, -0.080260, 
0.060410, 0.331550, -0.200330, -0.010710, -0.007170, 0.041250, 0.519420, 0.295810, -0.281050, -0.026930, 
-0.026450, -0.037420, 0.006260, -0.092590, -0.124320, -0.079850, -0.014660, -0.135480, 0.251950, -0.297520, 
0.077630, 0.082730, 0.334010, -0.047050, -0.013440, -0.127290, -0.080670, 0.364820, 0.275880, -0.392900, 
0.019300, -0.050890, -0.187200, 0.008040, -0.128110, -0.068410, 0.077760, -0.180860, -0.138160, 0.165440, 
-0.274740, 0.033090, 0.075540, 0.504720, -0.130310, -0.099670, -0.102560, -0.138830, 0.271570, 0.546060, 
-0.598190, -0.028810, 0.103010, -0.131090, -0.116410, 0.035280, -0.165890, 0.019470, -0.131340, -0.025520, 
0.071640, -0.106890, -0.156240, 0.290740, 0.617800, -0.190420, -0.059650, -0.000950, -0.192120, -0.061080, 
0.139970, -0.460960, -0.115110, 0.023550, -0.112390, -0.027390, 0.010970, -0.320730, 0.140830, 0.038200, 
-0.285420, 0.168750, 0.021890, -0.380690, 0.062780, 0.375030, 0.065430, -0.037750, 0.034890, -0.051020, 
0.416310, 0.371940, -0.758720, -0.040750, -0.033420, -0.213440, -0.067840, 0.053760, -0.135530, 0.108210, 
0.038950, -0.093230, 0.174530, 0.186640, -0.486530, 0.021670, 0.041740, 0.358240, -0.190560, -0.078640, 
0.023020, 0.220400, 0.259280, -0.093640, -0.134020, 0.086940, 0.018840, -0.159020, -0.043580, -0.127840, 
-0.072400, -0.130290, -0.018160, -0.085040, 0.053940, -0.088510, 0.057550, 0.261240, 0.102240, -0.149440, 
-0.051920, 0.079780, -0.093250, 0.278830, 0.581010, -0.213260, -0.138560, 0.051930, -0.031130, -0.064250, 
-0.028890, -0.179130, -0.097160, 0.157540, -0.141180, -0.224160, 0.354620, 
-0.491500, 0.695790, 0.055630, 0.003240, 0.016120, 0.225930, 0.363200, 0.108580, -0.295620, 0.145480, 
0.026530, 0.010240, 0.056720, -0.094680, -0.006380, 0.353840, -0.205650, 0.019770, 0.605700, -0.616910, 
0.245430, -0.196950, 0.461780, -0.003160, -0.135090, 0.064080, 0.063470, 0.587600, -0.219680, -0.332000, 
0.076980, -0.041210, -0.044130, 0.024620, 0.007610, 0.105910, 0.207930, -0.069810, -0.117440, 0.093090, 
-0.287400, 0.218620, -0.455310, 0.225720, 0.590950, -0.246930, 0.148350, 0.155580, 0.628270, -0.384440, 
0.169060, -0.066230, -0.024630, 0.102330, 0.093860, -0.155030, 0.168850, -0.006530, 0.042240, 0.145320, 
-0.068660, -0.035260, 0.211670, -0.646310, -0.169600, 0.867120, -0.161960, 0.151700, 0.305570, 0.074640, 
-0.419940, 0.110830, -0.071140, 0.105800, 0.230230, -0.016470, -0.134170, 0.121460, 0.023150, 0.034940, 
0.132000, -0.129840, 0.160150, 0.048640, -0.509090, 0.032040, 0.716930, -0.238720, 0.025420, 0.218690, 
0.769480, -0.406180, -0.289260, -0.039630, 0.082360, 0.081680, 0.113270, -0.000720, 0.148280, -0.012410, 
-0.013930, 0.084450, 0.019170, 0.406960, -0.088850, -0.368170, 0.204570, 0.430970, -0.162300, -0.027550, 
0.137930, 0.711310, -0.383040, -0.312550, 0.083760, -0.103280, -0.011430, 0.065360, -0.019210, 0.030930, 
0.148970, -0.034180, -0.057810, 0.202460, 0.192170, -0.161410, -0.641010, 0.194110, 0.274250, 0.076030, 
0.003660, 0.296430, 0.605020, 0.169910, -0.152810, 0.280620, -0.059270, 0.051870, 0.200550, -0.093770, 
0.106320, 0.357020, -0.168800, 0.106530, 0.592270, -0.474300, 0.222120, 
0.541640, 0.565130, 1.176990, 0.478120, -1.092230, 0.338090, -1.689740, -0.750300, 1.059790, -0.798980, 
-0.962650, -1.042510, 0.624330, 0.947170, 
-1.091580, 0.612890, -1.150710, 0.686700, 0.764720, -0.840670, 0.886280, -0.402540, -1.164400, -0.674720, 
-0.144780, 1.028320, 0.239590, -0.997800, 
-0.864170, -0.741390, -0.653000, -0.770080, 0.134110, 0.476800, -1.006570, 0.720790, -1.134980, 0.723930, 
0.671510, 0.463880, -0.660910, 0.282730, 

  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[165] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.020710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, -0.068100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.029330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.010680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.036260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, -0.077290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.096880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, -0.016820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, 0.068130, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.023260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, -0.038200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, 0.088230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.079970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, 0.067290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, 0.068190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, -0.006610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.020830, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, -0.016540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.046010, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.021900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, 0.041320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.048480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, 0.040290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, 0.084890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, 0.019000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, -0.071480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.088390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.032570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, -0.069300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, 0.099450, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, 0.007520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, -0.006520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.057580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, 0.046880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, -0.096550, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.038640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, -0.020170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, -0.021740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, 0.057510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.077180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, 0.039070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.069630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, 0.032470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.022500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.028720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.050710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, -0.020720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, -0.006330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, 0.008130, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, -0.030500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, 0.034560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, -0.089270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, 0.026390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, -0.088780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, 0.098510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, -0.003320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, 0.045450, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, 0.095140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, -0.018390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, 0.059010, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.075540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, 0.088130, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.047830, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, 0.039430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, -0.078300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.000360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, -0.042010, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.042720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.072980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.035110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.008300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.091930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.054940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, 0.024690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, 0.054270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, 0.029090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, 0.039940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.033950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, -0.043790, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, -0.013190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, -0.064890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.021880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.063750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.068800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, 0.063910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.088680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.015020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.004130, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.086870, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, -0.082700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, -0.076520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, -0.052270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, 0.020220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, -0.037650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, -0.052310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.019000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, 0.074950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.003070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.055510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.074620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.005760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, 0.099720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, -0.072100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, 0.096260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, -0.062980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.051420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.037090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.093150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.087110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.061890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.001580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, 0.055970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, -0.015270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, 0.042190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.035790, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, 0.047740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, 0.065200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, 0.099640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.091040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, 0.051770, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, 0.016910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.040320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.055630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.000780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, 0.086590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.021390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.004100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.056370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.056100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, -0.083240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, 0.029960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, 0.061460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.057750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.026740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, 0.089290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, -0.056680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, 0.093870, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.011180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, 0.064720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.086440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, -0.081930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, 0.005430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.074340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.039110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.086040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, 0.008980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.020290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.474800, 147,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, -0.255950, 147,
       &Sources[147] , 
       &Weights[147] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, -0.464200, 147,
       &Sources[294] , 
       &Weights[294] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, -0.326500, 147,
       &Sources[441] , 
       &Weights[441] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, -0.001890, 147,
       &Sources[588] , 
       &Weights[588] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, -0.175380, 147,
       &Sources[735] , 
       &Weights[735] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, -0.449410, 147,
       &Sources[882] , 
       &Weights[882] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, -0.030120, 147,
       &Sources[1029] , 
       &Weights[1029] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, -0.555200, 147,
       &Sources[1176] , 
       &Weights[1176] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, -0.209010, 147,
       &Sources[1323] , 
       &Weights[1323] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, -0.205630, 147,
       &Sources[1470] , 
       &Weights[1470] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, 0.366660, 147,
       &Sources[1617] , 
       &Weights[1617] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, -0.146880, 147,
       &Sources[1764] , 
       &Weights[1764] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.083380, 147,
       &Sources[1911] , 
       &Weights[1911] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.565660, 14,
       &Sources[2058] , 
       &Weights[2058] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, -1.270450, 14,
       &Sources[2072] , 
       &Weights[2072] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, -0.921730, 14,
       &Sources[2086] , 
       &Weights[2086] , 
      }

  };



int net_gor_consensus(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[147] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147}; /* members */

  static pUnit Hidden1[14] = {Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161}; /* members */

  static pUnit Output1[3] = {Units + 162, Units + 163, Units + 164}; /* members */

  static int Output[3] = {162, 163, 164};

  for(member = 0; member < 147; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 14; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
