/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  net_gor_consensus111.c
  --------------------------------------------------------
  generated at Thu Jun 24 20:00:52 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[165];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, 
Units + 158, Units + 159, Units + 160, Units + 161, 
Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, 
Units + 158, Units + 159, Units + 160, Units + 161, 
Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, 
Units + 158, Units + 159, Units + 160, Units + 161, 

  };

  /* Weigths definition section */
  static float Weights[] =  {
0.049440, 0.251110, -0.185860, -0.074220, -0.042360, -0.048930, 0.009260, 0.224110, -0.014180, -0.043200, 
0.077020, -0.088690, -0.027210, 0.067780, -0.020770, 0.005600, 0.104740, -0.113820, 0.097020, -0.119320, 
-0.136110, 0.239740, 0.129050, -0.108360, 0.044970, -0.029420, -0.065970, 0.019260, 0.420720, -0.030200, 
-0.092020, -0.042990, -0.119330, -0.059460, -0.056280, -0.118480, 0.066310, 0.039330, 0.019720, 0.225080, 
-0.172900, -0.333050, 0.220840, 0.311900, -0.344010, 0.031660, 0.057420, 0.009390, 0.288450, 0.098330, 
-0.673610, 0.091670, -0.056190, -0.140580, -0.063860, -0.065500, -0.137720, 0.149580, -0.006220, -0.034300, 
0.389580, -0.124210, -0.340990, 0.388900, 0.538270, -0.591710, 0.012230, 0.041520, -0.069220, -0.024860, 
0.040370, -0.352730, -0.017690, -0.013450, -0.104680, 0.062270, -0.038500, -0.292300, 0.190770, -0.129510, 
-0.339360, 0.532380, -0.055340, -0.393790, 0.120160, 0.317780, -0.072230, -0.081190, 0.005000, -0.126450, 
0.118970, 0.456310, -0.594230, 0.099270, -0.027710, -0.184320, 0.002250, 0.114020, -0.148010, 0.066850, 
-0.130630, -0.184730, 0.402020, -0.065030, -0.510150, 0.009020, 0.025280, 0.177060, -0.060150, -0.079250, 
-0.048050, -0.155280, 0.388380, 0.139070, -0.108210, 0.109680, 0.067800, -0.090540, 0.047530, -0.121560, 
-0.016980, -0.131770, 0.059570, 0.210320, -0.235640, -0.131480, 0.041990, 0.392600, 0.171210, -0.005260, 
-0.069000, -0.053990, -0.149390, 0.358760, 0.251110, -0.045970, 0.055050, 0.146350, -0.013810, 0.066690, 
-0.001880, -0.025280, -0.018600, 0.040030, 0.138180, -0.191630, 0.145570, 
-0.467170, 0.041560, 0.651920, -0.238490, -0.142000, 0.269830, -0.011700, -0.028140, -0.113370, 0.012280, 
-0.016200, 0.038290, 0.075300, -0.001170, 0.141660, 0.256730, -0.357760, 0.206840, 1.105010, -1.132340, 
0.274520, -0.266480, 0.634670, -0.105970, -0.182920, 0.104220, 0.186980, 0.470920, -0.364680, -0.709440, 
0.106840, 0.093500, -0.101370, 0.037590, 0.037660, 0.082170, -0.018210, -0.059660, 0.092770, 0.199840, 
-0.397050, 0.332420, -0.140830, 0.516360, 0.235890, -0.268290, 0.103390, 0.100630, 0.513240, 0.063260, 
-0.003470, -0.101010, 0.033390, -0.054390, 0.084070, -0.108710, -0.030230, -0.114380, -0.068530, 0.018210, 
-0.152400, -0.058960, 0.268890, -0.313380, -0.102600, 0.621050, -0.202370, 0.184560, 0.158890, 0.418770, 
-1.632220, 0.271700, -0.092770, 0.009860, 0.300910, 0.021640, -0.220060, 0.185280, -0.078080, 0.021920, 
0.079400, 0.003090, 0.153060, -0.174170, -0.814950, 0.041920, 0.919330, -0.339850, 0.060380, 0.356700, 
0.752060, -1.073590, -0.514490, 0.028920, 0.014540, 0.112190, 0.051010, 0.015330, 0.128810, -0.113890, 
0.049060, 0.084860, -0.136820, 0.308400, -0.237930, -0.740610, 0.325300, 0.823930, -0.375150, 0.132480, 
0.159510, 0.724100, -1.223550, -0.237990, 0.172260, -0.211020, 0.039730, 0.015720, 0.141270, 0.002620, 
0.085060, -0.046240, 0.136230, -0.083130, 0.099240, -0.034100, -0.507880, 0.474920, 0.456340, -0.126700, 
0.186830, 0.037670, 0.325780, 0.608810, -0.787880, -0.053050, 0.010820, -0.024990, 0.183130, -0.014770, 
-0.010020, 0.279170, -0.205970, 0.094070, 0.667610, -0.696920, 0.128240, 
0.208500, 0.232860, -0.232090, -0.106680, 0.009320, 0.080550, 0.106370, 0.060700, 0.037520, -0.096170, 
-0.027700, 0.081830, -0.156660, 0.013930, 0.135680, -0.313940, 0.192270, 0.229240, -0.822420, 0.471270, 
0.361240, 0.266950, -0.905050, 0.284160, -0.080580, -0.066000, 0.180250, -0.122640, -0.040460, 0.575310, 
-0.095740, 0.048220, 0.127510, -0.128470, -0.159090, 0.174550, -0.338890, -0.104080, 0.270880, -0.589800, 
0.215410, 0.123570, -0.084550, -0.840180, 0.578100, -0.086560, -0.007010, 0.152260, -0.287810, 0.247980, 
-0.039760, -0.189880, -0.078000, 0.099190, -0.062090, -0.012150, 0.177620, -0.213880, -0.095720, 0.196410, 
-0.112950, 0.071020, 0.165820, 0.296650, 0.630190, -0.412730, -0.061520, -0.020430, -0.035230, 0.023990, 
0.190580, -0.621580, -0.152170, 0.091440, -0.009600, -0.003940, 0.083200, -0.065540, 0.120400, -0.063840, 
-0.028400, 0.035830, -0.176520, 0.054980, 0.073300, 0.820080, -0.342380, -0.230130, 0.093170, 0.031380, 
0.125490, 0.486750, -0.629670, -0.189020, 0.077840, -0.081960, -0.030860, -0.046060, -0.170560, 0.077830, 
0.039860, -0.234770, 0.250940, -0.201400, -0.244130, -0.077460, 0.161790, 0.186900, -0.193380, -0.031250, 
0.065900, 0.517660, 0.541790, -0.249910, 0.016320, 0.084870, -0.131770, 0.076470, 0.028420, -0.020710, 
0.215510, -0.144260, -0.022290, 0.544770, -0.509650, -0.072490, 0.085720, 0.142520, 0.016380, 0.041760, 
-0.128350, 0.122930, 0.499320, 0.235270, -0.101010, -0.016910, -0.036150, -0.022810, 0.098840, -0.094480, 
-0.125990, 0.199280, -0.222380, 0.052670, 0.552210, -0.552280, 0.112480, 
0.404910, 0.391260, -0.309040, -0.034640, -0.058600, -0.101330, 0.639630, 0.277980, 0.064960, 0.051150, 
-0.046980, -0.071610, -0.027150, -0.063790, -0.243650, -0.032830, -0.128210, -0.105980, -0.096120, -0.123320, 
-0.131310, 0.130960, 0.437070, -0.066090, -0.003360, -0.113480, -0.077450, 0.726540, -0.105580, -0.369320, 
-0.094450, -0.134220, -0.149540, -0.107190, 0.012260, -0.205420, -0.054660, -0.054520, -0.123520, -0.088270, 
-0.352590, 0.034590, 0.047450, 0.603150, -0.182620, -0.186840, -0.059110, -0.126340, -0.166110, 0.367770, 
-0.193130, -0.217090, 0.055340, -0.070560, 0.019020, 0.011810, -0.221850, 0.085180, -0.141610, -0.057810, 
0.245470, -0.325500, -0.242160, 0.172550, 0.601790, -0.268180, -0.084550, -0.133160, -0.127080, -0.340530, 
-0.209860, -0.271000, -0.118270, -0.008170, -0.128840, -0.000140, 0.056340, -0.296190, 0.146980, -0.148920, 
-0.286800, 0.309310, -0.104920, -0.258830, -0.448140, 0.240990, 0.681120, -0.246890, -0.038950, -0.025000, 
0.471520, 0.102790, -0.540430, 0.036450, -0.156090, -0.155720, -0.127730, -0.053880, -0.150380, -0.001510, 
-0.150830, -0.249700, 0.153730, -0.036140, -0.426070, 0.240490, -0.527540, 0.805710, -0.079210, -0.037600, 
-0.049920, 0.265360, -0.458590, 0.234360, -0.230580, 0.034590, 0.031620, -0.148250, -0.014730, -0.003500, 
-0.142000, -0.084730, 0.019610, -0.279290, 0.065840, 0.044360, -0.000060, 0.256730, 0.308810, -0.174070, 
0.052120, 0.014490, 0.298300, 0.371940, 0.224560, -0.228730, -0.113700, 0.031350, -0.190880, -0.065440, 
-0.001170, -0.103380, -0.058270, 0.063940, -0.495270, -0.225920, 0.445640, 
-0.715060, 0.392510, 0.174120, -0.422650, -0.059660, -0.064850, 0.791330, 0.099300, -0.218630, -0.337920, 
-0.265430, -0.263920, -0.398770, -0.155170, -0.133870, -0.296910, -0.463260, -0.058980, 0.222090, -0.831290, 
-0.143320, -0.474870, 0.405610, 0.223430, -0.555340, 0.060250, -0.076360, 0.058410, -0.067960, -0.182470, 
-0.290670, -0.147200, -0.220700, -0.362510, -0.059170, -0.163500, -0.329810, -0.165720, -0.045080, -0.371010, 
-0.356060, -0.132110, -0.347240, 0.390700, 0.312830, -0.624410, 0.001680, -0.148650, 0.589840, -0.228090, 
-0.741810, -0.332990, -0.114120, -0.294580, -0.343950, -0.002670, -0.231420, -0.547940, -0.126580, -0.194850, 
-0.424890, 0.070020, -0.472190, 0.249950, 0.272620, 0.056060, -0.570430, 0.040770, -0.110090, 0.327920, 
0.126810, -1.240400, -0.522560, 0.092910, -0.343490, -0.220530, -0.023370, -0.250970, -0.448350, 0.123050, 
-0.397740, -0.048430, 0.245620, -0.919210, -0.190650, 0.061030, 0.513080, -0.453950, -0.040680, -0.126930, 
0.855300, -0.531110, -0.429540, -0.376710, -0.030640, -0.227820, -0.254030, -0.287090, -0.144070, -0.290250, 
-0.160930, -0.128800, 0.129590, -0.019960, -0.720580, -0.163690, 0.229150, 0.406070, -0.396340, -0.210440, 
-0.038560, 1.526950, -0.300180, -0.798280, -0.070970, -0.201360, -0.371880, -0.122730, -0.229930, -0.336080, 
-0.087420, -0.446080, -0.115720, 0.287780, -0.466040, -0.447550, -0.306980, 0.735730, 0.334550, -0.367900, 
-0.151050, -0.162360, 1.670370, 0.072510, -0.263110, -0.252320, -0.375480, -0.137430, 0.073000, -0.223420, 
-0.362440, -0.082400, -0.447470, -0.281770, 0.783580, -1.186940, -0.224230, 
0.528390, -0.612020, -0.188720, 0.154010, -0.032030, 0.054520, -0.282170, 0.231610, 0.014200, 0.154520, 
-0.016680, 0.130180, 0.223400, -0.014990, 0.134650, 0.294580, 0.139630, -0.116970, -0.087680, 0.260980, 
-0.007890, 0.490460, -0.550620, -0.120930, 0.268960, 0.058890, 0.047810, -0.006440, 0.071360, -0.121350, 
0.070950, 0.088150, 0.165420, 0.351180, -0.054150, 0.115550, 0.384380, 0.069060, -0.053530, 0.210500, 
-0.081370, 0.184030, 0.302780, 0.066290, -0.540240, 0.335720, -0.055740, -0.051980, -0.208430, 0.228500, 
0.037860, 0.145650, 0.079910, 0.114760, 0.314420, 0.141650, 0.148160, 0.132330, 0.222790, -0.021470, 
0.240680, -0.135610, 0.307190, -0.223360, -0.136690, -0.074640, 0.212740, 0.023430, 0.181690, -0.567430, 
0.562500, 0.660670, 0.304580, -0.051740, 0.104160, 0.022130, 0.130980, 0.287850, 0.025900, 0.040480, 
0.221960, 0.007810, -0.024930, 0.444660, 0.272090, -0.318000, -0.447590, 0.504790, -0.060620, -0.020840, 
-0.410980, 0.197150, 0.170740, 0.162490, 0.017040, 0.171820, 0.072230, 0.261910, 0.125340, 0.119700, 
0.177660, 0.141470, -0.329000, 0.268720, 0.388440, 0.306340, -0.305820, -0.370160, 0.367270, 0.021800, 
-0.160510, -0.846290, -0.175010, 0.333980, 0.210750, -0.022280, 0.075780, 0.000190, 0.172890, 0.193080, 
0.001220, 0.249120, 0.104030, -0.519730, 0.672040, 0.338350, 0.118180, -0.647220, -0.161830, 0.289170, 
0.148720, 0.002460, -1.299270, -0.750650, 0.752780, -0.007720, 0.048480, 0.167650, -0.177520, 0.254750, 
0.253650, -0.440880, 0.514980, 0.314180, -1.047430, 1.039250, 0.134900, 
0.148120, -0.115050, 0.228020, -0.091200, -0.232130, -0.399760, 0.510180, -0.662040, 0.446890, 0.148400, 
-0.205970, -0.260260, -0.050720, -0.153380, -0.449060, 0.304810, -0.324770, -0.357680, 0.658410, -0.725770, 
-0.460420, 0.167070, 0.125840, -0.053140, 0.005860, -0.184610, -0.334720, -0.077210, -0.041630, 0.311160, 
-0.008820, -0.129590, -0.313020, 0.061510, -0.130080, -0.432030, 0.140670, -0.167240, -0.410400, 0.255500, 
-0.413820, -0.283240, 0.146640, 0.072450, 0.128430, 0.055990, -0.032450, -0.290050, -0.619280, 0.264720, 
0.526770, -0.196540, -0.147730, -0.129990, -0.180000, -0.127510, -0.377280, -0.293090, -0.210490, -0.106070, 
-0.467380, -0.267870, 0.217390, -0.334520, -0.468490, 0.544750, -0.040590, -0.120280, -0.282140, -0.730370, 
-0.311330, 1.414240, -0.155610, -0.223920, -0.174200, -0.235160, -0.034220, -0.114430, -0.217680, -0.037750, 
-0.039230, -0.545230, -0.216510, 0.351740, 0.433090, -0.432610, -0.181760, 0.098490, -0.127210, -0.433060, 
-0.678990, -0.386000, 0.287240, 0.045140, -0.164590, -0.373540, -0.033990, -0.041670, -0.450140, -0.041780, 
-0.093500, -0.302360, -0.058190, -0.264590, -0.001170, 0.226920, 0.000040, -0.392390, 0.017480, 0.003670, 
-0.257850, 0.064050, -0.574140, -0.098850, 0.010740, -0.201150, -0.343770, -0.097860, -0.008110, -0.410220, 
-0.245440, 0.103460, -0.232930, -0.126670, 0.032210, -0.409670, 0.440170, -0.500200, 0.031850, -0.054280, 
-0.037500, -0.359210, -0.251570, -0.216180, 0.040200, -0.138780, -0.144780, -0.324060, -0.271510, 0.004950, 
-0.361740, -0.267660, 0.154310, -0.175730, -0.000520, -0.319860, -0.131750, 
-0.902010, 0.781970, 0.181010, -0.343530, 0.091160, -0.009580, 0.193000, 0.175020, -0.096720, -0.129710, 
-0.000600, -0.227040, -0.168250, -0.076130, -0.246480, -0.098610, -0.179060, 0.036260, 0.721350, -1.192440, 
0.125200, -0.403230, -0.017850, 0.469370, -0.404620, -0.100010, -0.027990, 0.735620, -0.164320, -0.462450, 
-0.177720, -0.030010, -0.221580, -0.293000, -0.118880, -0.032100, -0.294110, -0.325240, 0.068700, 0.235430, 
-0.806820, 0.114370, -0.106700, -0.372190, 0.765000, -0.415300, -0.042770, 0.116540, 0.663550, -0.284260, 
-0.626210, -0.309190, -0.155620, -0.131830, -0.138160, -0.270600, -0.193320, -0.184400, -0.273550, 0.083030, 
0.167010, -0.397480, -0.242560, 0.625920, -0.072030, 0.230540, -0.294010, -0.114080, -0.001470, 0.661680, 
-0.622140, -0.994640, -0.242730, 0.092980, -0.217700, -0.103680, -0.261870, -0.339480, -0.161310, -0.109670, 
-0.322470, 0.536590, -0.284480, -0.734930, -0.101330, 0.135250, 0.777330, -0.549350, -0.028890, -0.001620, 
0.985510, -0.383350, -0.564460, -0.277210, 0.015500, -0.140660, -0.063210, -0.148940, -0.296150, -0.177310, 
-0.152580, -0.296900, 0.364070, -0.182960, -0.689490, -0.300340, -0.004530, 0.833650, -0.443700, -0.121380, 
0.056540, 0.795120, 0.120640, -0.177920, -0.282370, 0.012240, -0.132400, -0.098190, -0.060970, -0.150550, 
-0.206890, -0.104980, -0.026200, 0.024170, -0.352200, -0.158420, -0.651200, 0.516740, 0.629890, -0.342070, 
0.020620, 0.009630, 0.496000, 0.150770, 0.463400, -0.313720, -0.060200, 0.052370, -0.100060, 0.032600, 
-0.135960, -0.150900, -0.185570, -0.102960, 0.121290, -0.982230, 0.414100, 
-0.079720, -0.552240, 0.306720, 0.162980, 0.124040, 0.217580, -1.533530, 0.672490, 0.172830, 0.061400, 
0.320290, 0.154830, -0.053260, 0.094710, 0.433510, -0.091370, 0.363940, 0.340400, -0.562780, 0.905330, 
0.153650, -0.072080, 0.128210, -0.128780, 0.256740, 0.169460, 0.025100, -1.017280, 0.447140, 0.842080, 
0.109750, 0.027840, 0.159090, 0.123550, 0.053300, 0.281660, 0.116490, 0.369230, 0.144580, -0.211640, 
0.529690, 0.069230, 0.093900, 0.139350, -0.651800, 0.397610, -0.048600, -0.028100, -0.957940, 0.247420, 
0.725150, 0.124760, 0.096670, 0.189220, 0.152440, 0.154530, 0.189080, 0.227970, 0.072830, 0.056380, 
0.068960, -0.000590, 0.417910, -0.029570, -0.280690, -0.515810, 0.384740, -0.084490, 0.101530, -0.087410, 
-0.650630, 0.299650, 0.376550, -0.084070, 0.195800, 0.170510, 0.187620, 0.277550, 0.222000, 0.124070, 
0.127600, 0.124050, 0.029100, 0.238090, 0.530950, -0.328440, -0.968400, 0.392640, -0.027350, -0.078470, 
-0.144710, -0.397810, 0.097070, 0.229050, 0.002400, 0.250040, 0.082350, 0.109330, 0.286760, 0.246090, 
0.025780, 0.051770, 0.308830, -0.024380, 0.345060, -0.057620, 0.211570, -0.734170, 0.251930, 0.153210, 
0.088650, -0.590140, -0.044710, -0.273120, 0.233410, 0.130790, 0.206950, 0.107480, 0.121860, 0.116470, 
0.193050, 0.104210, 0.069990, 0.333750, 0.115720, -0.021610, 0.244230, -0.597530, -0.102570, 0.210230, 
-0.020150, 0.067290, -0.331520, 0.090010, -0.210930, 0.163400, 0.012450, 0.030300, 0.079730, 0.092050, 
0.157550, 0.001660, 0.177800, 0.192700, -0.217460, 0.683930, -0.098650, 
0.649650, -0.130600, -0.545990, 0.146160, 0.077560, -0.143290, 0.303300, -0.242830, -0.602320, 0.024510, 
-0.026440, -0.140120, -0.110520, 0.314510, -0.107420, -0.175450, 0.202010, -0.093770, -0.965500, 0.826040, 
0.199020, 0.545640, -0.513020, -0.147580, 0.120830, -0.131540, -0.032400, -0.516750, -0.145210, 0.203210, 
-0.133500, 0.071700, 0.045430, -0.130550, 0.131290, -0.080380, -0.230700, 0.061930, -0.070270, -0.515120, 
0.280040, -0.073060, -0.049640, -0.007740, -0.258090, 0.206940, 0.017900, -0.086110, -0.682590, 0.087550, 
0.470770, -0.092970, 0.077760, 0.105860, -0.125430, 0.311280, -0.184070, -0.112150, 0.118940, 0.042630, 
0.041650, 0.134730, -0.049710, -0.894660, 0.517410, 0.086880, -0.032420, -0.078800, -0.184020, -0.838850, 
1.100710, 0.356030, -0.155110, 0.034350, -0.029660, -0.312440, 0.173280, 0.070390, -0.359160, 0.189910, 
0.007140, -0.004010, -0.028680, -0.060640, -0.205380, 0.311430, -0.110170, 0.128160, -0.081040, -0.250460, 
-0.493550, 0.426500, 0.269340, 0.004230, -0.083620, -0.068280, -0.280690, 0.200510, -0.087500, -0.083360, 
0.075410, -0.140480, 0.087060, 0.025190, -0.258050, 0.569210, -0.107770, -0.253310, 0.194030, -0.110900, 
-0.250240, 0.260650, -0.525360, -0.227600, -0.063400, 0.069230, 0.058150, -0.041080, 0.155410, -0.055470, 
-0.176930, 0.120150, -0.165640, -0.140490, 0.052740, -0.066730, 0.433100, -0.196420, 0.157340, 0.166200, 
-0.068030, -0.188960, 0.369590, -0.639420, 0.318410, 0.054790, -0.115800, -0.011340, -0.239460, 0.004130, 
0.062860, -0.182370, 0.110580, -0.095660, -0.526530, 0.777020, -0.345040, 
-0.200560, 0.549850, -0.106040, -0.170460, 0.041440, -0.066860, 0.421230, -0.144500, -0.871410, 0.090460, 
0.041790, -0.329590, -0.070690, 0.043780, -0.103180, 0.111400, -0.038610, -0.297610, 0.725600, -0.340710, 
-0.669200, -0.241270, 0.347460, -0.102810, 0.058760, -0.050720, -0.134450, -0.378800, -0.754270, 0.468190, 
-0.124390, -0.099690, 0.181620, -0.103820, -0.087210, 0.012380, -0.012060, 0.098480, -0.256020, 0.023530, 
0.178340, -0.261350, -0.293960, -0.184180, 0.304350, -0.110990, 0.032950, -0.058300, -0.579300, -0.017870, 
0.885770, -0.191260, 0.002590, -0.054640, -0.089340, -0.101170, -0.043450, -0.122860, 0.059210, -0.079310, 
-0.480210, 0.044630, 0.240470, -0.599940, -0.404030, 0.785510, -0.133260, -0.082570, -0.021070, -0.388090, 
-0.613430, 1.405700, -0.054960, -0.217730, 0.060740, -0.310100, -0.078590, 0.234030, -0.308550, 0.032810, 
0.235480, -0.505760, 0.138350, 0.128600, 0.344390, 0.168710, -0.448400, 0.103100, -0.017350, -0.158370, 
0.232660, 0.033810, 0.457780, -0.075950, -0.029190, -0.031330, -0.139870, -0.121250, -0.102160, -0.070420, 
0.018340, 0.061190, 0.003580, -0.052070, -0.135440, -0.179670, 0.826490, -0.337020, -0.123830, -0.027500, 
-0.009930, -0.246060, 0.129530, 0.080130, -0.032220, -0.045910, 0.098740, -0.200400, 0.032150, -0.068320, 
-0.063830, 0.033540, -0.130240, 0.241430, -0.169630, -0.114810, -0.124900, 0.086260, 0.003940, -0.055950, 
0.031760, -0.033020, -0.003650, -0.233400, 0.237590, -0.160730, -0.075140, 0.012570, -0.118180, -0.056590, 
-0.006680, -0.266530, 0.105770, 0.085290, 0.443390, -0.559760, 0.209500, 
0.251130, -0.498630, 0.199990, -0.060860, -0.097100, -0.041480, -0.097300, -0.276500, 0.284060, -0.126840, 
-0.090480, -0.011100, -0.144630, -0.064160, 0.042830, -0.294650, 0.039600, 0.022560, -0.858670, 0.636320, 
0.035760, 0.217810, -0.179160, -0.067740, -0.059360, -0.017540, -0.147890, 0.204220, -0.178610, -0.007910, 
-0.073550, -0.136240, 0.004250, -0.034270, -0.182550, 0.051760, -0.118960, -0.136190, 0.015090, -0.232970, 
-0.088110, 0.007560, 0.168840, -0.133270, -0.306740, 0.089610, -0.181020, -0.181470, -0.234290, 0.506790, 
0.233120, -0.008910, -0.197250, 0.107160, -0.015150, -0.125000, 0.097650, -0.149850, -0.206280, 0.203620, 
0.119600, -0.391290, 0.199960, 0.436130, 0.119590, -0.762510, 0.276140, -0.103980, -0.246020, -0.224920, 
0.314040, 0.083520, 0.028730, -0.117800, -0.080640, 0.023960, -0.079380, -0.113930, -0.051050, -0.106050, 
-0.003110, 0.208260, -0.679720, 0.283250, 0.738510, -0.013600, -0.614990, 0.295940, -0.123420, -0.386780, 
-0.180940, 0.794680, -0.007600, 0.032880, -0.078180, -0.157490, 0.089120, -0.023350, -0.187120, 0.084340, 
-0.198690, -0.102770, -0.081100, -0.396470, 0.309770, 0.613270, -0.135840, -0.382890, 0.174470, -0.046930, 
-0.335760, -0.655990, 1.134840, 1.049400, -0.135550, -0.001200, 0.073640, 0.019670, 0.043580, -0.093850, 
-0.077030, -0.123990, 0.064210, 0.095670, -0.297790, -0.028010, 0.394340, 0.469780, -0.554990, 0.167050, 
-0.128150, -0.214740, -0.961290, 1.727670, 0.167430, -0.329810, 0.170700, -0.144290, -0.312530, 0.118800, 
-0.070460, -0.381320, 0.178150, -0.018170, -0.553920, 0.800800, -0.469150, 
0.025010, 0.501890, -0.175340, 0.025430, 0.068240, -0.039820, -0.186040, 0.438870, -0.255710, -0.008790, 
0.058740, 0.161710, 0.005410, 0.080980, 0.143100, -0.058660, 0.227420, 0.100970, -0.970020, 0.899690, 
0.090820, -0.152310, 0.425770, -0.345490, -0.070090, 0.010740, 0.111100, -0.014890, 0.603580, -0.422190, 
0.072680, 0.084440, -0.131220, 0.060010, 0.184570, 0.021070, 0.073070, 0.207730, -0.082510, -0.191520, 
0.556520, -0.217300, -0.348290, 0.707270, -0.235560, -0.111310, 0.154910, 0.097910, -0.338380, 0.645530, 
-0.077200, 0.012750, 0.073270, 0.028390, -0.161180, 0.282590, -0.008030, -0.026380, 0.141630, -0.035470, 
-0.153310, 0.441580, -0.087740, -0.161000, 0.800020, -0.489700, -0.060000, 0.119740, -0.105130, -0.680930, 
0.711940, 0.215160, -0.191260, 0.062400, 0.243090, -0.102730, 0.217940, -0.015100, -0.008050, 0.140570, 
0.016690, -0.148430, 0.365120, -0.084380, 0.252460, 0.330030, -0.409970, 0.133970, -0.090900, 0.016180, 
0.903330, -0.301420, -0.472550, 0.013060, -0.079750, -0.058740, -0.028490, 0.006690, 0.084430, 0.072020, 
0.049160, -0.150190, -0.055390, 0.044660, 0.044170, 0.023260, 0.197240, 0.008270, 0.095000, -0.074590, 
0.106310, 0.537830, 0.272010, -0.179940, -0.140320, 0.141900, 0.143810, 0.016270, -0.018920, 0.096510, 
0.029550, 0.049210, -0.021090, -0.114890, 0.107350, -0.027910, -0.140330, -0.158200, 0.523680, 0.073510, 
0.050010, 0.179890, -0.244570, 0.480360, 0.115790, -0.140870, 0.069470, 0.006360, -0.079980, 0.016040, 
0.089410, 0.137810, 0.016240, 0.011750, -0.561780, 0.812810, -0.029290, 
-0.523820, 1.134040, -0.408640, -0.155700, 0.198780, 0.086720, 0.468850, -0.212870, -0.486780, 0.133870, 
0.106450, -0.039040, 0.228670, 0.068810, -0.110720, 0.340630, -0.056640, -0.236690, 0.879410, -0.583170, 
-0.093720, -0.675020, 0.075480, 0.445280, -0.179940, -0.031670, 0.123640, 0.090610, -0.902340, 0.217650, 
-0.114980, 0.084890, 0.088310, 0.124910, -0.075870, 0.185730, 0.190720, -0.021450, 0.172840, 0.083370, 
-0.051570, 0.259950, -0.601900, -0.424050, 0.963870, -0.171250, -0.020870, 0.279870, 0.174970, -1.188900, 
0.594280, 0.047850, 0.006110, 0.231220, 0.068620, -0.068620, 0.334920, -0.049850, -0.166970, 0.355510, 
-0.131520, 0.070350, 0.191390, -0.138140, -0.104440, 0.597580, -0.186840, 0.223130, 0.213210, 0.360810, 
-0.201720, -0.339050, -0.015190, 0.192250, -0.003700, 0.096710, -0.034990, 0.030070, 0.147490, -0.001200, 
0.202050, -0.041060, 0.468210, -0.226200, -0.076920, 0.125010, 0.279940, 0.005090, 0.046160, 0.329490, 
0.428800, 0.755610, -0.590360, 0.155290, 0.130840, -0.066460, 0.145010, 0.046610, 0.113490, 0.131070, 
0.081130, 0.142900, 0.025520, 0.298380, -0.000040, -0.170150, 0.169030, 0.171390, -0.048180, 0.095840, 
0.159120, 0.105340, 0.972650, -0.227620, 0.143450, 0.153930, -0.013440, 0.241440, 0.026950, -0.088070, 
0.120650, 0.001050, 0.086390, 0.259310, 0.123490, 0.004620, -0.116800, -0.248580, -0.080250, 0.004620, 
0.119830, 0.241770, -0.012110, -0.386550, 0.127530, 0.075950, 0.109690, 0.125640, 0.188110, 0.106920, 
-0.129040, 0.144010, 0.114410, 0.163660, 0.784250, -0.583580, 0.059270, 
0.500770, 1.027090, 0.627570, 0.552100, 1.042730, -1.043630, -0.629630, 0.753030, -1.102850, -1.525320, 
-0.801620, -1.322810, -0.252600, 0.999120, 
0.517420, -0.987160, 0.306910, 0.442580, -1.561200, 0.260240, -0.958670, -1.051860, 1.381910, 0.712830, 
-0.547440, 1.062850, 0.622960, -1.049300, 
-0.850240, 0.619590, -0.731870, -0.694330, -0.812350, 0.630600, 0.778120, -0.896790, 0.183860, -0.179670, 
0.815440, -0.297760, -0.636030, 0.409740, 

  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[165] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.100000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, 0.099800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.091670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.064670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.027080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, 0.081730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.081540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, 0.002560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, -0.005350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.009110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, 0.053360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, -0.066260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.086350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, -0.013610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, -0.011220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, 0.089830, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.053410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, 0.096220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.049530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.040360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, -0.075200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.006310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, -0.084050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, -0.003090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, -0.062090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, 0.062320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.077260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.014120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, 0.084650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, -0.063050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, -0.096980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, 0.076330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.078780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, -0.056900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, 0.079820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.049340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, 0.096030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, 0.024320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, -0.035780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.036180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, -0.050540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.098750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, -0.024880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.074710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.023510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.054190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, 0.062690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, 0.000660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, -0.001900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, 0.036810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, -0.040340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, 0.026550, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, -0.075260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, 0.025800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, -0.005050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, 0.014430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, -0.008550, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, -0.033600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, 0.065770, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, -0.066160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.072380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, -0.053840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.089480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, -0.093350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, 0.033140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.083580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, 0.045940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.085150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.035250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.062030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.007160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.013840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.002440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, -0.017300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, -0.047750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, -0.074340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, -0.015590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.092940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, 0.033290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, 0.021430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, 0.064610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.077630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.070540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.062230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, -0.090980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.080860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.072220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.037240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.074600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, 0.099180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, 0.099900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, 0.061410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, -0.017360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, 0.025010, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, 0.094640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.007050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, -0.057070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.011550, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.042420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.070670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.005190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, -0.045680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, 0.046740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, -0.056700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, 0.006390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.060600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.010560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.045690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.093220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.051370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.006790, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, -0.073790, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, 0.073190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, -0.069210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.096380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, -0.088170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, -0.034020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, -0.059990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.071360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, -0.022090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, -0.081660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.054880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.026790, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.088860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, -0.076960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.010970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.067390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.015040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.004030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, 0.093770, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, -0.021690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, -0.058450, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.063500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.005020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, -0.079750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, 0.038240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, -0.088530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.022400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, -0.086100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.082280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, 0.032460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, -0.006560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.040420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.094200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.053620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, -0.050390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.081830, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.219460, 147,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, 0.010550, 147,
       &Sources[147] , 
       &Weights[147] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, -0.170020, 147,
       &Sources[294] , 
       &Weights[294] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, -0.260420, 147,
       &Sources[441] , 
       &Weights[441] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, -0.719890, 147,
       &Sources[588] , 
       &Weights[588] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, 0.370160, 147,
       &Sources[735] , 
       &Weights[735] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, -0.304930, 147,
       &Sources[882] , 
       &Weights[882] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, -0.526110, 147,
       &Sources[1029] , 
       &Weights[1029] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, 0.439260, 147,
       &Sources[1176] , 
       &Weights[1176] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, -0.020400, 147,
       &Sources[1323] , 
       &Weights[1323] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, -0.047200, 147,
       &Sources[1470] , 
       &Weights[1470] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, -0.138380, 147,
       &Sources[1617] , 
       &Weights[1617] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, -0.043160, 147,
       &Sources[1764] , 
       &Weights[1764] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.169250, 147,
       &Sources[1911] , 
       &Weights[1911] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.794880, 14,
       &Sources[2058] , 
       &Weights[2058] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, -1.015640, 14,
       &Sources[2072] , 
       &Weights[2072] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, -1.342470, 14,
       &Sources[2086] , 
       &Weights[2086] , 
      }

  };



int net_gor_consensus111(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[147] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147}; /* members */

  static pUnit Hidden1[14] = {Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161}; /* members */

  static pUnit Output1[3] = {Units + 162, Units + 163, Units + 164}; /* members */

  static int Output[3] = {162, 163, 164};

  for(member = 0; member < 147; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 14; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
