/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  net_gor_noconsensus.c
  --------------------------------------------------------
  generated at Thu Jun 24 17:49:18 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[165];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, 
Units + 158, Units + 159, Units + 160, Units + 161, 
Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, 
Units + 158, Units + 159, Units + 160, Units + 161, 
Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, 
Units + 158, Units + 159, Units + 160, Units + 161, 

  };

  /* Weigths definition section */
  static float Weights[] =  {
-0.806930, 0.602560, 0.562180, -0.199360, -0.066040, -0.079880, 0.708130, -0.267690, -0.086290, 0.119610, 
-0.141230, -0.336070, 0.010080, -0.233270, -0.180210, 0.227220, -0.273800, -0.251380, 0.256050, -0.570000, 
-0.002740, -0.414080, 0.111590, 0.643870, -0.195440, 0.016210, -0.134820, 0.554510, -0.096160, -0.407230, 
0.124920, -0.056360, -0.288320, 0.031360, -0.221240, -0.242730, 0.140140, -0.317790, -0.233210, -0.067530, 
-0.007490, -0.252770, -0.661230, -0.288960, 0.786390, -0.396160, 0.046460, -0.030090, 0.236040, -0.384740, 
-0.574010, -0.107250, 0.015720, -0.283910, -0.039090, -0.069370, -0.280830, -0.111540, -0.034630, -0.215890, 
0.108350, 0.412540, -0.815700, 0.286900, -0.352760, 0.165240, -0.454600, 0.060920, -0.308490, 0.662160, 
-0.479530, -1.113590, -0.379760, 0.199510, -0.472440, -0.091190, 0.042300, -0.605130, -0.167900, 0.112550, 
-0.646790, 0.492020, 0.274100, -1.500210, 0.019600, -0.424510, 0.662660, -0.352390, 0.083270, -0.188550, 
0.609500, -0.640830, -0.633850, -0.208620, -0.004830, -0.189960, -0.229400, 0.082360, -0.433910, -0.213260, 
-0.001060, -0.160850, 0.236480, 0.084800, -0.905740, -0.492690, -0.055430, 0.789490, -0.317540, -0.097910, 
-0.023850, 0.606150, -0.134600, -0.279660, -0.023340, -0.103140, -0.069550, -0.087570, 0.000990, -0.147070, 
-0.078640, -0.093180, -0.021350, 0.393990, -0.199730, -0.343460, -0.737750, 0.595830, 0.188090, 0.024620, 
-0.095810, 0.245230, 0.851980, 0.219710, -0.307310, 0.096430, -0.034020, 0.092730, 0.045080, -0.008950, 
-0.047340, 0.172350, -0.349210, 0.158410, 0.567000, -0.877160, 0.218620, 
0.478000, 0.055720, 0.173350, 0.017840, -0.090660, 0.102200, 0.954700, 0.191290, 0.272800, 0.114250, 
0.005270, 0.100440, 0.027680, -0.029570, -0.136110, 0.036870, -0.190180, 0.197920, -0.082370, 0.113520, 
0.207410, 0.527640, -0.133540, 0.051690, 0.103900, -0.039170, -0.003080, 0.603730, 0.605250, -0.264260, 
0.058010, 0.089430, -0.065470, 0.126850, 0.116790, -0.050850, -0.151400, -0.054740, 0.198390, -0.149550, 
0.144810, 0.052090, 0.396430, 0.211080, -0.193280, -0.008950, 0.040480, -0.047090, -0.052260, 0.656630, 
-0.472240, 0.017980, 0.107690, -0.095110, -0.033090, 0.105140, -0.210550, -0.149310, -0.028630, -0.100270, 
0.166580, 0.154720, -0.371210, 0.439740, 0.473060, -0.229470, -0.270980, -0.206330, -0.558620, 0.110440, 
0.489600, 0.120310, -0.322170, -0.189640, -0.308760, -0.208480, 0.071830, -0.662320, -0.148280, -0.130900, 
-0.726650, 0.265820, -0.015280, -1.278350, 0.128490, 0.383650, -0.019420, -0.048000, 0.092470, 0.005940, 
-0.105590, 0.071890, -0.009450, 0.068460, 0.037940, -0.011360, -0.024890, 0.336690, -0.233070, -0.013250, 
0.109030, 0.152500, -0.070610, 0.213940, -0.024620, 0.109760, -0.012070, 0.366760, 0.113490, -0.031050, 
-0.044700, -0.213400, -0.302060, 0.432960, -0.015710, -0.140260, 0.248310, 0.001160, 0.214200, -0.034320, 
-0.025250, 0.030660, 0.181820, -0.266390, 0.048000, 0.259530, 0.144680, 0.148860, 0.518420, 0.107150, 
0.054350, -0.104310, 0.491550, -0.027200, -0.111260, -0.038310, -0.018010, 0.041920, 0.085890, 0.058200, 
-0.094180, -0.113170, -0.096590, 0.027880, -0.686150, 0.182000, 0.643450, 
-0.215000, 0.232010, 0.256300, -0.175180, -0.065770, -0.106960, 0.134240, 0.081020, 0.310470, -0.140080, 
-0.127920, -0.226220, -0.065800, -0.224890, -0.024820, 0.085260, -0.261070, -0.077150, 0.124990, -0.460220, 
-0.111490, -0.121560, 0.439880, 0.235350, -0.130090, -0.061880, -0.217520, 0.198750, 0.418360, 0.044390, 
0.035630, -0.195100, -0.143480, -0.143200, -0.098280, -0.078360, -0.041780, -0.149890, -0.162900, 0.008740, 
-0.277450, -0.166860, -0.403680, 0.269230, 0.485730, -0.317520, -0.116380, -0.134640, 0.149200, 0.054840, 
0.054750, 0.014980, -0.185790, -0.154590, -0.215250, -0.155110, -0.232620, -0.105130, -0.214840, -0.322310, 
-0.154230, -0.202490, -0.151680, -0.167780, -0.098930, 0.453830, -0.198600, -0.024970, 0.052800, 0.253900, 
-0.362680, -0.285920, -0.047110, -0.059380, -0.084940, 0.024950, -0.031180, -0.189590, -0.003020, -0.085130, 
0.051200, 0.103770, -0.042040, -0.056000, -0.302060, -0.022360, 0.447190, -0.368000, 0.002180, -0.086970, 
0.138520, 0.445440, -0.682980, -0.200100, -0.065870, -0.204230, -0.112300, 0.005330, -0.126870, -0.207780, 
-0.115630, -0.134800, 0.039940, 0.070260, -0.504180, -0.058260, -0.038940, 0.213780, -0.244590, -0.158780, 
0.009530, 0.892060, -0.428240, -0.563630, 0.007630, -0.149710, -0.134000, -0.155910, -0.093510, -0.265590, 
-0.049150, -0.270930, -0.168830, 0.310080, -0.082180, -0.647680, 0.177580, 0.128100, -0.198440, 0.006120, 
-0.147320, -0.111120, 1.074070, -0.300230, -0.482210, 0.160540, -0.016110, -0.202190, 0.060820, -0.019600, 
-0.255660, 0.161970, -0.220510, -0.175040, 0.739040, -0.281610, -0.584410, 
0.756690, -0.305580, -0.096610, 0.006780, -0.097190, -0.228460, 0.087580, -0.310610, 0.318500, -0.129940, 
0.016630, -0.167110, -0.118850, -0.073950, -0.242930, -0.112750, -0.028830, -0.103220, -0.420440, 0.017680, 
-0.026460, 0.365480, -0.716920, 0.155440, -0.000820, -0.100280, -0.073000, -0.044720, -0.337890, 0.424690, 
-0.156030, -0.002120, 0.112680, 0.052150, 0.100570, -0.071290, -0.128380, -0.050190, 0.097030, 0.092340, 
-0.037990, 0.034220, 0.626890, -0.347620, -0.247680, 0.158040, -0.139050, -0.070570, -0.524830, 0.063230, 
0.323650, -0.077220, -0.009890, 0.004490, -0.060610, -0.030170, -0.167780, -0.153470, 0.005410, 0.095740, 
0.050010, -0.128020, -0.046750, 0.432290, 0.281950, -0.399440, -0.166330, -0.136870, -0.391810, -0.083880, 
0.662760, -0.331670, -0.243040, -0.096110, -0.283470, -0.090180, -0.112680, -0.421920, -0.042400, -0.057050, 
-0.391230, 0.080180, -0.215240, -0.405120, 0.122620, 0.173980, -0.344580, 0.088920, -0.103180, -0.264140, 
-0.375110, 0.494990, 0.284760, -0.176170, 0.048790, -0.111490, -0.025010, 0.089800, -0.163140, -0.121370, 
0.102030, -0.174670, -0.062660, -0.150900, -0.117590, 0.164270, -0.037990, -0.361440, 0.114700, -0.052930, 
-0.118320, -0.684650, 0.599910, 0.315030, -0.077360, 0.086320, 0.066430, -0.169690, 0.054330, -0.083980, 
-0.051980, 0.035130, -0.186900, -0.109480, -0.002690, 0.164050, 0.523550, -0.030890, -0.659800, 0.099870, 
0.035050, -0.157170, -0.573410, 0.450660, -0.034030, -0.184710, 0.060660, -0.071790, -0.065870, 0.148940, 
-0.096230, -0.255650, 0.206550, -0.038510, -0.298170, 0.186010, 0.077910, 
0.716120, -0.292240, -0.276820, 0.097770, -0.001390, -0.122450, -0.453370, 0.300090, 0.462440, -0.133670, 
0.108780, -0.025920, -0.143250, 0.175250, -0.162560, -0.484930, 0.152500, 0.123070, -0.726360, 0.505620, 
0.155010, 0.413060, -0.194440, -0.267500, 0.000930, -0.069300, -0.229650, -0.511060, 0.071540, 0.208190, 
-0.163470, -0.024420, 0.010130, -0.158460, 0.184750, -0.062370, -0.213770, 0.183470, 0.194600, -0.116550, 
-0.017720, 0.080420, 0.368070, 0.342540, -0.401600, 0.037040, -0.020620, -0.236620, -0.502790, 0.412990, 
-0.006370, 0.037700, 0.074510, -0.069930, 0.056480, 0.182010, -0.147050, -0.161660, 0.024180, 0.089030, 
-0.022580, -0.153250, 0.185560, 0.174160, 0.543750, -0.476070, -0.080330, -0.007420, -0.317540, -0.779110, 
0.504630, 0.040630, -0.044110, -0.047220, -0.284170, -0.232220, 0.170290, -0.385280, -0.133180, 0.083720, 
-0.285350, -0.015390, -0.219220, -0.220090, 0.006150, 0.110220, -0.316440, 0.191980, 0.073790, -0.080690, 
-0.600010, 0.645090, 0.018330, -0.081970, -0.003570, -0.128090, -0.029670, 0.153650, -0.130750, -0.169240, 
0.089880, -0.193920, 0.016280, -0.041710, 0.137450, 0.445900, -0.296150, -0.176480, 0.148170, -0.015080, 
-0.119870, -0.479010, 0.246350, 0.053190, -0.014470, 0.122980, -0.078100, -0.168960, 0.088120, 0.068730, 
-0.118780, 0.184460, -0.117060, -0.176820, 0.194360, -0.076300, 0.775760, -0.477780, -0.218880, 0.092750, 
-0.050000, -0.227980, -0.514410, 0.015990, -0.000100, -0.148090, 0.130140, -0.028880, -0.083130, -0.048740, 
0.045540, -0.300610, 0.207140, -0.036410, -0.660340, 0.585330, 0.133050, 
0.133170, -0.700760, 0.322410, -0.087480, -0.166270, -0.031240, 0.668460, -1.000570, -0.002800, -0.082870, 
-0.062040, -0.112090, -0.160240, -0.190010, 0.015740, 0.105170, -0.172690, -0.175660, 0.364040, -0.393710, 
-0.153130, 0.072500, 0.061710, 0.140990, -0.150290, -0.103300, 0.003920, 0.128450, -0.383090, 0.540850, 
-0.073590, -0.190720, -0.192190, -0.095420, -0.238430, 0.073450, 0.050540, -0.221440, -0.167060, 0.026310, 
-0.240320, -0.219610, 0.003320, -0.028690, 0.092330, -0.209940, -0.235870, -0.065520, -0.150550, 0.119160, 
0.306390, -0.101120, -0.012710, -0.149260, -0.214880, -0.307970, 0.145500, -0.064430, -0.102610, -0.181290, 
-0.238270, -0.195440, -0.068940, -0.454980, -0.359830, 0.500940, 0.059130, 0.059460, 0.254120, -0.558330, 
-0.270910, 0.941480, 0.217060, -0.019330, 0.256260, -0.018100, -0.150370, 0.579780, 0.050100, -0.061060, 
0.578020, -0.344100, -0.097420, 0.916190, -0.013380, 0.281810, 0.051790, -0.098600, -0.076470, -0.005000, 
-0.421110, -0.152050, 0.760130, -0.082600, -0.174580, 0.092830, -0.084900, -0.316650, 0.131240, -0.198020, 
-0.063820, 0.019360, -0.423480, -0.033190, 0.228450, 0.487970, 0.044220, -0.242920, 0.013480, -0.112820, 
-0.199860, -0.083550, 0.100550, 0.348350, -0.117620, -0.036440, -0.058640, -0.083860, -0.116900, 0.051370, 
-0.093770, -0.155340, -0.009150, -0.247610, -0.153580, 0.075850, 0.236410, -0.208380, -0.196850, 0.064240, 
-0.088610, -0.234360, -0.372720, -0.056500, 0.174080, 0.003440, -0.199300, -0.165760, -0.145740, -0.018260, 
-0.098390, -0.146450, -0.100340, -0.107090, -0.041670, -0.022270, -0.290930, 
0.602740, -0.320510, -0.273520, 0.038550, -0.066010, -0.090820, -0.474310, 0.298560, 0.418750, -0.109830, 
0.028910, 0.014780, -0.043270, 0.094840, -0.012760, -0.484590, 0.200080, 0.130790, -0.844900, 0.376700, 
0.292760, 0.521180, -0.097010, -0.479660, 0.208640, 0.076460, -0.179860, -0.414410, 0.336440, -0.013910, 
-0.081200, 0.110860, -0.034440, -0.077810, 0.038020, -0.161970, -0.319700, 0.161650, 0.219480, -0.155300, 
0.113370, 0.106560, 0.585830, 0.216080, -0.685070, 0.251860, -0.019670, -0.106830, -0.392260, 0.278100, 
-0.116210, -0.005530, -0.036750, -0.019480, 0.053090, 0.241470, -0.126190, -0.157670, -0.016310, 0.087130, 
0.078050, -0.172920, 0.234310, 0.283240, 0.207310, -0.695710, 0.063650, -0.012300, -0.333280, -0.627020, 
0.440880, -0.069580, -0.223110, -0.067850, -0.258680, -0.239800, 0.190200, -0.320180, -0.221350, -0.012910, 
-0.351440, 0.090620, -0.152890, -0.222560, 0.072360, -0.145240, -0.169060, 0.019020, 0.048400, -0.204030, 
-0.467270, 0.269050, -0.044500, 0.053220, 0.055380, -0.095570, -0.095530, 0.059710, -0.197590, -0.080150, 
0.253380, -0.062870, -0.066380, -0.123310, 0.139610, 0.552130, -0.553590, -0.167710, 0.127720, -0.018810, 
-0.224490, -0.618190, -0.034120, 0.122930, -0.116970, 0.057380, -0.163620, -0.034320, -0.020800, -0.099430, 
-0.258580, 0.326270, -0.061480, -0.295980, 0.341590, 0.096320, 0.843260, -0.412980, -0.294680, 0.024200, 
0.008270, -0.291720, -0.533400, 0.250270, 0.351150, -0.266600, 0.175530, -0.100840, -0.185600, 0.009060, 
-0.048610, -0.412840, 0.191880, -0.180220, -0.828690, 0.543970, 0.057810, 
0.506950, -0.843430, -0.171600, -0.092510, -0.121630, -0.012990, 0.132840, -0.590830, 0.006640, -0.138210, 
-0.114170, -0.050540, -0.052900, -0.210920, 0.146730, -0.011640, -0.073770, -0.194510, 0.045010, 0.034200, 
-0.354100, 0.153340, 0.127200, -0.388900, -0.050840, 0.070380, -0.106980, -0.118670, -0.299180, 0.125610, 
-0.180690, -0.037040, -0.120390, -0.209130, -0.097660, -0.067110, -0.144420, 0.164220, -0.286080, -0.235680, 
0.105010, -0.073670, 0.139690, 0.466860, -0.480570, -0.151110, -0.147690, -0.179340, -0.203900, 0.817270, 
0.246250, -0.226530, 0.050990, -0.151780, -0.074340, -0.204010, 0.085410, -0.102410, 0.141140, -0.332960, 
-0.312620, 0.120080, -0.116380, -1.213940, -0.127010, 0.515770, 0.148860, -0.071090, 0.293210, -0.949710, 
0.638900, 0.909550, 0.177900, -0.010360, 0.266790, -0.060760, -0.246280, 0.662570, -0.072930, 0.000970, 
0.504160, -0.625030, -0.084970, 1.078960, -0.005900, -0.061910, -0.154700, -0.147410, -0.067950, -0.249710, 
-0.234900, 0.267470, 0.149020, -0.081590, -0.092860, -0.140160, -0.109930, -0.563420, 0.079230, -0.053130, 
-0.053160, -0.393780, -0.391020, -0.053550, -0.200380, 0.901260, -0.690620, -0.508240, -0.071470, -0.248900, 
-0.254400, -0.169210, -0.230460, 0.469490, -0.111200, -0.056070, -0.196910, -0.023510, -0.512840, -0.080000, 
0.063800, -0.195040, -0.469050, -0.281200, -0.143490, -0.181120, 0.739100, -1.209890, -0.012310, -0.060820, 
-0.208580, -0.181380, 0.122710, -0.468530, 0.081410, -0.044550, -0.200960, -0.140160, 0.008710, -0.326720, 
-0.110310, -0.112090, -0.041260, -0.198990, -0.016830, -0.259970, -0.266980, 
0.052590, 0.302680, 0.184780, -0.136710, -0.090370, -0.161140, 1.138150, 0.060480, -0.612080, -0.005640, 
-0.128650, -0.263810, 0.214170, 0.024250, -0.349690, 0.311440, -0.221270, -0.232180, 0.556730, -0.445540, 
-0.487170, -0.395010, -0.245260, 0.907720, -0.203470, -0.154240, -0.097650, 0.937180, -0.015360, -0.224830, 
-0.048840, -0.223180, -0.239010, 0.048610, -0.161450, -0.280540, -0.026540, -0.342720, -0.167430, 0.271740, 
-0.226970, -0.380820, -0.431940, 0.074670, 0.804670, -0.343000, -0.146970, -0.147580, 1.182440, -0.334890, 
-0.494420, -0.092560, -0.147820, -0.332130, -0.113580, -0.109550, -0.391930, -0.089470, -0.256610, -0.112350, 
0.186530, 0.037010, -0.733380, -0.148490, 0.663090, 0.590110, -0.471480, -0.064820, -0.091720, 0.250610, 
0.174400, -0.025540, -0.305480, 0.095070, -0.144480, -0.253030, 0.075880, -0.316450, -0.233820, -0.002280, 
-0.152980, -0.069600, 0.202660, -0.605820, 0.044070, 0.518070, 0.310780, -0.265570, -0.005060, -0.114650, 
0.708270, -0.009640, 0.115910, -0.088920, 0.027610, -0.023760, -0.164030, 0.021810, -0.257730, -0.284050, 
0.016530, 0.042920, -0.363470, 0.086860, -0.030670, -0.025020, 0.605470, 0.348730, -0.153210, -0.073610, 
-0.108430, 0.451820, -0.261550, 0.085900, -0.081830, -0.108410, -0.028450, -0.023610, 0.089010, -0.137440, 
-0.190870, -0.227560, 0.018460, -0.184540, -0.326920, 0.200430, -0.323590, 0.377320, 0.313320, -0.018610, 
0.054100, 0.032340, 0.424980, 0.190640, 0.164750, 0.153780, -0.168680, -0.048040, 0.135470, 0.193400, 
-0.256120, 0.162850, -0.338020, 0.253730, -0.001530, -0.413270, 0.503550, 
-0.159560, 0.044220, 0.047580, -0.213480, -0.079080, -0.061410, -0.474770, 0.241800, 0.181580, -0.199910, 
0.006510, -0.029340, -0.152040, -0.235360, -0.060770, -0.201390, -0.115280, -0.171820, 0.322160, -0.621180, 
-0.203160, 0.021770, 0.468990, -0.365470, -0.217740, -0.065110, -0.038690, -0.022610, 0.652030, -0.073860, 
-0.181990, -0.062750, -0.188910, -0.241900, -0.163470, -0.000540, -0.086620, -0.012820, -0.158510, -0.268890, 
-0.204260, 0.197350, 0.024100, -0.312240, 0.076520, -0.176370, -0.118040, 0.017110, -0.028700, -0.244440, 
0.650250, -0.093080, -0.104470, 0.045630, -0.076660, -0.247210, 0.246580, -0.115340, -0.063980, -0.058880, 
-0.370270, -0.085610, 0.271100, -0.142280, -1.082880, 0.571910, 0.289050, -0.004590, 0.451110, 0.411340, 
-0.605330, 0.390250, 0.280610, -0.097000, 0.206620, 0.046400, -0.114000, 0.540800, 0.095700, -0.107240, 
0.751940, -0.337170, -0.053820, 0.819070, 0.165580, -0.199630, -0.084660, -0.211880, -0.185670, -0.203010, 
0.466590, -0.397820, 0.152010, -0.131960, -0.166140, -0.218740, -0.198020, -0.329150, 0.008940, -0.140070, 
-0.306150, -0.080480, -0.062170, -0.138290, -0.290020, 0.180950, 0.247240, -0.478000, -0.071650, -0.196870, 
-0.248960, -0.254510, 0.512000, -0.372020, -0.022100, -0.091370, -0.268000, -0.024430, -0.138600, -0.181660, 
-0.039490, -0.003900, -0.131870, 0.216150, -0.248180, -0.173990, 0.051310, -0.456670, 0.114930, -0.031520, 
-0.193120, -0.110210, -0.037060, 0.308810, -0.133580, 0.043060, -0.153080, -0.159910, 0.002610, 0.041910, 
-0.245890, -0.117070, -0.092630, -0.193900, 0.656500, -0.499700, -0.518640, 
0.185270, -0.218950, -0.149610, -0.230240, -0.152390, -0.313990, 0.094660, -0.322420, -0.469800, -0.258650, 
0.028150, -0.301480, -0.017590, -0.150760, -0.479290, 0.075010, -0.177800, -0.570870, 0.106010, -0.093160, 
-0.695230, 0.219220, -0.128480, -0.226860, -0.337720, -0.285990, -0.328740, -0.501950, -0.362970, 0.118550, 
-0.435880, -0.105030, -0.457240, -0.323750, -0.324410, -0.347050, -0.116000, -0.153600, -0.541620, -0.563480, 
-0.096940, -0.273190, 0.175050, 0.112950, -0.346410, -0.424250, -0.166770, -0.586990, -0.059960, -0.035330, 
0.099420, -0.428010, -0.111140, -0.613980, -0.384020, -0.488130, -0.190450, -0.287670, -0.218760, -0.649030, 
-0.508230, -0.404000, -0.347520, 0.036450, -0.480890, -0.385940, 0.548620, 0.208350, 0.433670, -0.258780, 
-0.048030, -0.402890, 0.576550, 0.258020, 0.483300, 0.425900, 0.354070, 0.595810, -0.029970, 0.091440, 
1.310750, -0.304100, -0.153930, 1.874510, -0.248890, -0.116020, 0.134720, -0.342820, -0.308870, -0.423790, 
0.079290, 0.250950, 0.261760, -0.322470, -0.206710, -0.414030, -0.400550, -0.361850, -0.271010, -0.543050, 
-0.340560, -0.214570, -0.636120, -0.351170, -0.078600, -0.101470, -0.179410, 0.256800, -0.257640, -0.213220, 
-0.400130, -0.219930, 0.332890, -0.541640, -0.196470, -0.166050, -0.552550, -0.331660, -0.009160, -0.406700, 
-0.436630, -0.282650, -0.362030, -0.573810, -0.333180, -0.033680, -0.160580, 0.447640, -0.041710, -0.378780, 
0.003270, -0.341780, 0.212990, -0.163380, 0.019540, -0.193730, -0.256870, -0.179030, -0.449400, 0.181520, 
-0.636170, -0.450560, -0.042960, -0.241870, -0.214610, -0.145460, -0.404820, 
0.134840, 0.188320, -0.212280, -0.186030, 0.085580, -0.299090, -0.236370, 0.147650, -0.262270, -0.432550, 
0.083420, -0.252080, -0.195730, 0.053710, -0.264040, -0.400370, 0.082210, -0.233010, -0.610380, 0.179170, 
-0.008650, -0.064530, 0.392580, -0.317010, -0.232980, -0.066730, -0.271170, -0.314910, -0.076810, -0.235690, 
-0.168950, -0.017480, -0.243960, -0.148280, 0.311030, -0.332960, -0.432100, 0.258770, -0.165800, -0.661620, 
0.069640, 0.173940, -0.280720, 0.232790, -0.079530, -0.135110, -0.022290, -0.082610, -0.261710, -0.810780, 
0.566910, -0.111870, -0.143350, -0.048330, -0.259820, 0.109190, -0.258860, -0.395190, 0.032710, 0.039280, 
-0.615030, 0.150020, 0.267000, -0.130620, -0.145920, -0.148940, 0.272740, -0.027300, 0.146580, -0.338330, 
-0.225330, 0.318470, 0.199810, -0.025820, 0.206090, -0.030230, 0.370910, 0.038900, -0.256860, 0.056440, 
0.448760, -0.449360, 0.290300, 0.453030, 0.175730, 0.072000, -0.256780, 0.031040, -0.182580, -0.214120, 
-0.362950, 0.111580, 0.241690, -0.100870, 0.002810, -0.030940, -0.157170, 0.061220, -0.138550, -0.227820, 
0.111710, -0.087370, -0.542970, 0.184720, 0.132190, 0.304740, 0.199390, -0.356800, -0.021000, -0.009130, 
-0.171470, -0.021730, 0.008760, 0.258640, -0.224870, 0.040600, -0.086090, -0.311680, 0.203650, -0.230250, 
-0.232960, 0.016550, -0.023730, -0.659210, 0.025700, 0.237460, 0.027750, 0.358660, -0.151800, -0.250400, 
0.103650, -0.184060, -0.165850, 0.630820, 0.095440, -0.192400, 0.046530, -0.109900, -0.236110, 0.147860, 
-0.115840, -0.435170, 0.260570, 0.058060, -0.526990, 0.074280, 0.138160, 
0.107230, 0.392170, 0.076260, 0.159710, 0.045720, 0.123970, -0.256770, 0.550640, 0.471920, 0.065460, 
-0.017090, 0.166880, -0.061500, 0.244300, -0.087410, -0.300770, 0.013150, 0.363670, -0.192380, -0.090870, 
0.621360, -0.129130, 0.038660, 0.575590, 0.067600, -0.097340, 0.022940, 0.249910, 0.340520, -0.090660, 
0.140480, -0.085090, -0.059590, -0.035010, 0.134440, -0.073310, -0.073130, -0.205400, 0.251860, -0.075910, 
-0.191230, 0.405510, -0.186660, 0.091890, 0.560290, -0.103800, -0.067240, -0.017310, 0.178770, 0.037600, 
-0.045430, 0.057970, 0.041120, -0.003250, -0.210180, 0.382890, -0.266990, -0.188120, -0.120670, 0.324130, 
-0.180410, -0.077620, 0.219250, 0.950030, 0.354680, -0.150190, -0.274360, -0.082040, -0.528890, 0.759930, 
-0.379960, -0.439340, -0.347680, -0.088220, -0.400630, -0.284330, 0.163080, -0.848470, -0.167650, 0.066540, 
-0.637880, 0.303060, -0.099950, -1.025740, 0.599810, 0.611850, -0.248050, 0.072140, 0.200590, 0.021190, 
0.651000, -0.240760, 0.007980, -0.052130, 0.052980, 0.059340, -0.110200, 0.523080, -0.214700, -0.089980, 
0.254850, 0.236860, 0.231720, 0.082210, -0.091480, 0.144380, 0.727500, -0.143750, -0.021490, 0.151400, 
0.130870, 0.800590, 1.038440, -0.400100, 0.135080, 0.213920, 0.129700, -0.110350, 0.416000, -0.129150, 
-0.040060, 0.048720, 0.277430, 0.146240, 0.159200, 0.081900, -0.088620, 0.908480, -0.135900, 0.043390, 
0.118000, 0.237930, 0.402230, 0.779450, 0.070770, 0.085370, -0.007930, 0.143560, 0.127680, 0.266850, 
0.002090, -0.031850, -0.067350, 0.501330, 0.074450, -0.226230, 0.661950, 
0.134540, 0.068700, 0.220680, 0.079990, -0.106030, 0.083780, 0.389080, -0.143590, -0.133010, 0.148740, 
-0.012810, -0.141230, -0.035930, 0.095900, -0.291860, 0.116670, -0.191820, 0.055560, 0.791440, -0.630780, 
-0.113960, 0.287600, 0.171180, 0.201720, -0.109220, -0.105140, -0.095840, 0.565700, -0.598890, 0.415440, 
0.074460, -0.220210, -0.165250, -0.092570, 0.158500, -0.230440, 0.034330, -0.216650, -0.099660, 0.208290, 
-0.407690, -0.078940, 0.296390, 0.259530, 0.356680, -0.139490, 0.020240, -0.095030, 0.297580, -0.360510, 
0.445050, -0.130010, -0.097250, -0.032540, -0.022130, -0.010420, -0.131040, -0.146370, -0.076250, 0.132380, 
0.112710, -0.127220, -0.149000, 0.175210, -0.025020, 0.407590, 0.178750, 0.213620, 0.275200, 0.633120, 
-0.063550, -0.058300, 0.237740, 0.133990, 0.265430, 0.053150, 0.211650, 0.078300, -0.036270, -0.053340, 
0.651990, -0.108660, 0.057620, 0.502270, 0.123420, 0.443740, 0.476020, -0.240150, -0.094980, -0.040680, 
0.802890, 0.003490, 0.559860, -0.156390, -0.090810, -0.009590, -0.085250, 0.080740, -0.115840, -0.276940, 
-0.241260, 0.195100, 0.055590, 0.011420, -0.110920, 0.012850, 0.593370, 0.386560, -0.258210, -0.157190, 
-0.065570, 0.252270, 0.004230, 0.896410, -0.112560, -0.277640, -0.069810, -0.237080, 0.040700, -0.155600, 
-0.195110, -0.247400, 0.070430, 0.115870, -0.384200, 0.072500, -0.254960, 0.215300, 0.412190, 0.042220, 
-0.077420, 0.125120, 0.532840, 0.233100, 0.522390, 0.205450, -0.120900, -0.097550, -0.128060, 0.134320, 
-0.079370, -0.090580, -0.167860, 0.266990, 0.391490, -0.606590, 0.268990, 
0.680390, 0.705610, 0.819000, -0.907640, -0.988180, -0.527490, -1.013330, -0.848660, 0.915570, -0.305640, 
-2.141160, -1.106700, 0.847720, 0.753320, 
-1.771220, 0.683620, -0.974940, 0.873680, 0.401720, -0.494440, 0.558000, -0.019870, -1.182140, -0.832310, 
-1.224650, -0.092230, 0.360670, -1.410530, 
-0.870960, -0.807720, -0.062830, -0.092640, -0.417940, 0.533280, -0.367940, 0.554270, -0.583370, 0.590450, 
2.412000, 0.513890, -0.807690, 0.041000, 

  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[165] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.020710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, -0.068100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.029330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.010680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.036260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, -0.077290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.096880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, -0.016820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, 0.068130, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.023260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, -0.038200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, 0.088230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.079970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, 0.067290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, 0.068190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, -0.006610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.020830, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, -0.016540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.046010, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.021900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, 0.041320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.048480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, 0.040290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, 0.084890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, 0.019000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, -0.071480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.088390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.032570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, -0.069300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, 0.099450, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, 0.007520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, -0.006520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.057580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, 0.046880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, -0.096550, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.038640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, -0.020170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, -0.021740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, 0.057510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.077180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, 0.039070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.069630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, 0.032470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.022500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.028720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.050710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, -0.020720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, -0.006330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, 0.008130, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, -0.030500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, 0.034560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, -0.089270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, 0.026390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, -0.088780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, 0.098510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, -0.003320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, 0.045450, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, 0.095140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, -0.018390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, 0.059010, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.075540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, 0.088130, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.047830, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, 0.039430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, -0.078300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.000360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, -0.042010, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.042720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.072980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.035110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.008300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.091930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.054940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, 0.024690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, 0.054270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, 0.029090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, 0.039940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.033950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, -0.043790, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, -0.013190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, -0.064890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.021880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.063750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.068800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, 0.063910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.088680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.015020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.004130, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.086870, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, -0.082700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, -0.076520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, -0.052270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, 0.020220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, -0.037650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, -0.052310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.019000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, 0.074950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.003070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.055510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.074620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.005760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, 0.099720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, -0.072100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, 0.096260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, -0.062980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.051420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.037090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.093150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.087110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.061890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.001580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, 0.055970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, -0.015270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, 0.042190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.035790, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, 0.047740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, 0.065200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, 0.099640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.091040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, 0.051770, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, 0.016910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.040320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.055630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.000780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, 0.086590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.021390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.004100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.056370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.056100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, -0.083240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, 0.029960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, 0.061460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.057750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.026740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, 0.089290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, -0.056680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, 0.093870, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.011180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, 0.064720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.086440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, -0.081930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, 0.005430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.074340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.039110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.086040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, 0.008980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.020290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.822810, 147,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, -0.985520, 147,
       &Sources[147] , 
       &Weights[147] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, -0.186380, 147,
       &Sources[294] , 
       &Weights[294] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, -0.676660, 147,
       &Sources[441] , 
       &Weights[441] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, -0.419540, 147,
       &Sources[588] , 
       &Weights[588] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, 0.328930, 147,
       &Sources[735] , 
       &Weights[735] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, -0.511390, 147,
       &Sources[882] , 
       &Weights[882] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, 0.411130, 147,
       &Sources[1029] , 
       &Weights[1029] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, -0.489590, 147,
       &Sources[1176] , 
       &Weights[1176] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, 0.557020, 147,
       &Sources[1323] , 
       &Weights[1323] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, 1.243510, 147,
       &Sources[1470] , 
       &Weights[1470] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, 0.417600, 147,
       &Sources[1617] , 
       &Weights[1617] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, -0.779440, 147,
       &Sources[1764] , 
       &Weights[1764] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.455670, 147,
       &Sources[1911] , 
       &Weights[1911] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.856620, 14,
       &Sources[2058] , 
       &Weights[2058] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, -0.622110, 14,
       &Sources[2072] , 
       &Weights[2072] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, -0.145850, 14,
       &Sources[2086] , 
       &Weights[2086] , 
      }

  };



int net_gor_noconsensus(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[147] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147}; /* members */

  static pUnit Hidden1[14] = {Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161}; /* members */

  static pUnit Output1[3] = {Units + 162, Units + 163, Units + 164}; /* members */

  static int Output[3] = {162, 163, 164};

  for(member = 0; member < 147; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 14; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
