/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  net_gor_noconsensus111.c
  --------------------------------------------------------
  generated at Thu Jun 24 20:01:16 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[165];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, 
Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, 
Units + 158, Units + 159, Units + 160, Units + 161, 
Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, 
Units + 158, Units + 159, Units + 160, Units + 161, 
Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, 
Units + 158, Units + 159, Units + 160, Units + 161, 

  };

  /* Weigths definition section */
  static float Weights[] =  {
-0.568200, 0.452020, 0.200540, -0.104970, -0.060100, -0.026130, -0.640730, -0.196990, 0.092360, -0.006540, 
0.038240, -0.112270, 0.054050, 0.023270, -0.083210, 0.132060, 0.020890, -0.182130, 0.231780, -0.476480, 
0.060590, 0.282970, -0.244170, 0.127290, 0.022600, -0.083390, -0.107670, -0.048530, 0.010580, 0.039340, 
-0.048370, -0.175950, -0.148050, 0.021060, -0.149560, -0.223760, 0.116160, -0.039280, -0.069570, -0.004540, 
-0.234390, -0.159990, 0.256290, -0.180660, 0.127950, -0.081470, 0.037170, -0.082640, -0.457520, 0.046340, 
0.102090, -0.074090, -0.087440, -0.168990, -0.108460, -0.153950, -0.230080, 0.000710, 0.005670, -0.122740, 
0.307770, -0.110090, -0.498720, 1.047320, -0.239940, -0.208090, -0.173110, -0.065440, -0.289550, 0.670470, 
-0.439420, 0.035420, -0.306660, -0.066290, -0.275490, -0.067090, -0.267270, -0.446790, -0.003420, -0.201980, 
-0.585330, 0.671960, -0.034730, -1.066600, 0.423050, -0.092800, 0.252600, -0.191360, -0.092700, -0.167180, 
0.678030, -0.677420, 0.154300, -0.001480, -0.242940, -0.116950, -0.165240, 0.000730, -0.115840, -0.073620, 
-0.237730, -0.185770, 0.397020, -0.231930, -0.586840, -0.607600, 0.278670, 0.475950, -0.082960, -0.055970, 
0.056740, 0.495310, -0.009020, -0.100040, 0.162370, -0.012020, 0.024170, -0.226970, 0.132100, 0.035580, 
0.046580, -0.232530, 0.202030, 0.316890, -0.296690, -0.071740, -1.151590, 0.597820, 0.652250, 0.137050, 
0.011250, 0.176740, 0.086350, 0.189620, -0.125470, 0.275600, 0.123090, 0.210040, 0.046940, 0.231080, 
0.226270, 0.159410, -0.102940, 0.392980, 0.355740, -0.219280, 0.408960, 
-0.201130, 0.526700, 0.319870, -0.173870, -0.170580, -0.132300, 1.335520, -0.021180, -0.847020, 0.226640, 
-0.162840, -0.395510, 0.297760, -0.134330, -0.313710, 0.540440, -0.414640, -0.386050, 0.674740, -0.382910, 
-0.410690, -0.694180, -0.253390, 1.007110, -0.295630, -0.176040, 0.060370, 0.771830, 0.018190, -0.383150, 
0.044080, -0.138710, -0.325980, 0.106030, -0.291240, -0.176960, 0.088740, -0.389450, -0.203980, 0.218680, 
-0.094290, -0.508730, -0.786040, -0.033750, 1.214190, -0.487760, -0.110810, -0.027950, 0.832510, -0.347140, 
-0.768060, -0.205760, -0.097760, -0.380740, -0.055990, -0.258260, -0.302890, -0.166800, -0.226920, -0.333250, 
0.043070, 0.354790, -0.902580, -0.266530, 0.436560, 0.579300, -0.462830, 0.019740, -0.325760, 0.232730, 
0.136400, -0.564560, -0.400310, 0.043510, -0.335150, -0.280310, -0.288210, -0.354540, -0.345280, 0.000520, 
-0.541940, 0.018550, 0.309280, -1.255770, 0.170030, 0.367000, 0.199400, -0.306850, -0.107410, -0.097010, 
1.231690, -0.220610, -0.155810, -0.147000, -0.115410, -0.170420, -0.066020, -0.055550, -0.271760, -0.277880, 
-0.043240, -0.247330, -0.242230, 0.086100, -0.498710, -0.029470, 0.677760, 0.237560, -0.203640, 0.010940, 
-0.137580, 0.638900, -0.279650, -0.014040, 0.041040, -0.237550, -0.049630, 0.009170, 0.124640, -0.221300, 
0.066330, -0.214460, 0.076060, -0.173920, -0.426480, 0.335280, -0.443840, 0.652960, 0.417300, 0.059600, 
0.103400, 0.018960, 0.473580, 0.324320, 0.006060, 0.147550, -0.182150, 0.051550, 0.093790, 0.126330, 
0.022380, 0.267250, -0.366190, 0.350370, 0.294840, -0.870110, 0.758370, 
0.092170, 0.258080, 0.496620, 0.096890, -0.055670, 0.187230, 0.763940, 0.695750, 0.403540, 0.142270, 
-0.140120, 0.201080, 0.227490, -0.017000, 0.027750, 0.078050, -0.082810, 0.357620, -0.070930, 0.070740, 
0.255580, 0.640900, -0.088140, -0.015620, 0.161290, 0.034070, 0.065750, 0.781780, 1.069710, -0.430360, 
0.174790, 0.135690, -0.003050, 0.198720, -0.053420, -0.030880, -0.076180, -0.104130, 0.235650, -0.069010, 
-0.082710, 0.128340, 0.530680, 0.169350, -0.108360, 0.150850, 0.153640, -0.038440, 0.108520, 0.501760, 
-0.664240, 0.017990, 0.099250, -0.078580, 0.194170, 0.280530, -0.163970, -0.094390, 0.044660, 0.143890, 
0.209770, -0.024800, 0.146260, 0.741400, 0.748620, -0.210950, -0.232740, -0.193130, -0.458880, 0.506260, 
0.303890, -0.259530, -0.322810, -0.128490, -0.386600, -0.193890, 0.062200, -0.622140, -0.022870, -0.091610, 
-0.624910, 0.189560, -0.092130, -0.950700, 0.397670, 0.393980, 0.004630, 0.022030, 0.085980, 0.092320, 
-0.260300, 0.304310, -0.011850, -0.094870, 0.072340, 0.135290, 0.046830, 0.269400, -0.257820, -0.091320, 
0.170830, 0.109310, -0.118860, 0.010780, 0.219400, 0.263080, 0.167350, 0.440060, -0.022090, 0.089270, 
-0.058230, -0.254980, -0.598030, 0.531470, 0.013670, -0.000110, 0.123550, 0.007180, 0.358410, -0.113740, 
-0.090510, 0.140610, 0.166520, -0.394490, 0.125910, 0.398900, 0.429170, 0.495030, 0.335240, 0.083490, 
-0.011740, -0.117570, 0.376490, -0.041450, -0.101670, -0.085120, 0.047210, -0.120130, -0.082430, 0.101690, 
-0.223050, -0.109770, -0.045720, 0.102900, -0.920660, 0.398780, 0.552130, 
0.335600, 0.576020, -0.285210, -0.035730, 0.032550, -0.051300, 0.160740, 0.330400, 0.279820, 0.068470, 
-0.041410, 0.045590, -0.116150, 0.216480, -0.294840, -0.374000, -0.181360, 0.428420, -0.714060, -0.165680, 
0.669060, -0.466030, 0.042460, 0.654410, -0.073550, -0.049390, 0.037740, 0.043590, -0.033950, -0.002060, 
-0.156490, -0.060600, -0.052060, -0.131600, 0.191820, -0.251510, -0.325610, -0.072790, 0.274760, -0.333670, 
-0.255430, 0.291880, -0.296850, 0.189060, 0.357490, -0.207060, 0.056470, 0.008530, -0.025180, -0.170010, 
-0.425900, -0.008190, 0.061560, -0.055450, 0.056230, 0.364910, -0.381920, -0.052590, -0.100680, 0.269260, 
-0.165640, -0.240060, 0.313760, 0.887260, 0.451730, -0.592440, -0.217680, -0.163410, -0.472060, 0.579330, 
-0.304540, -0.639900, -0.293850, -0.004840, -0.464990, -0.063970, 0.235970, -0.920370, -0.058640, -0.055430, 
-0.683050, 0.463990, -0.172040, -0.854750, 0.522210, 0.758300, -0.416300, 0.002030, 0.188130, 0.056190, 
0.771260, -0.458410, -0.098570, 0.144800, 0.011900, 0.125120, 0.099250, 0.450120, -0.324180, 0.015830, 
0.063970, 0.075360, 0.338500, -0.169520, 0.079740, 0.113160, 0.430510, -0.137480, 0.148910, 0.269770, 
0.121730, 0.333780, 1.086250, -0.478890, 0.093890, 0.342110, 0.106760, 0.085290, 0.487350, -0.031980, 
0.045350, 0.177710, 0.276950, 0.232100, 0.045820, 0.260130, -0.035540, 0.497840, -0.309040, 0.102370, 
0.275900, 0.275870, -0.170030, 0.810190, -0.287160, 0.091670, 0.140950, 0.217900, 0.138280, 0.315070, 
0.050770, 0.128940, 0.082870, 0.452070, -0.026090, -0.257640, 0.769770, 
0.001980, 0.411940, 0.326820, -0.060570, -0.108490, -0.049090, 0.947900, 0.310940, 0.111730, 0.040310, 
-0.299770, -0.278800, 0.097320, -0.300610, -0.155510, 0.331660, -0.577730, -0.244060, 0.626690, -0.862340, 
-0.187890, -0.419390, 0.444470, 0.858420, -0.289610, -0.059130, 0.020880, 1.158510, 0.206480, -0.167480, 
0.217790, -0.286940, -0.345820, 0.103880, -0.221090, -0.224360, 0.380290, -0.426210, -0.251080, -0.197270, 
-0.455360, 0.037050, -0.776700, 0.407270, 1.030800, -0.448610, -0.084410, -0.162250, 0.445920, -0.036500, 
-0.323070, -0.107750, -0.139090, -0.418720, -0.063570, -0.121830, -0.316560, -0.163520, -0.296380, -0.333380, 
-0.427570, -0.099040, -0.224330, -0.208280, 0.125310, 0.499780, -0.404490, 0.169670, -0.008990, 0.609970, 
-0.204100, -0.680940, -0.250040, 0.136280, -0.263450, -0.040570, 0.160060, -0.218420, -0.366600, 0.192180, 
-0.152680, -0.061060, 0.048770, -0.313770, -0.622920, 0.043700, 0.717260, -0.357130, 0.087040, -0.027480, 
0.316850, 0.043610, -0.610090, -0.328990, 0.153090, -0.135260, -0.219850, -0.004360, -0.136990, -0.351650, 
0.011520, 0.084140, -0.132900, 0.000170, -0.154170, -0.180810, 0.130720, 0.276570, -0.169260, -0.094350, 
0.055210, 0.811430, -0.332620, -0.616270, 0.060400, -0.097120, -0.170520, -0.042880, 0.076680, -0.285590, 
-0.059800, -0.286090, 0.133630, 0.031020, -0.069280, -0.150600, 0.025280, 0.428670, -0.147030, 0.111400, 
-0.133640, 0.020400, 1.634030, 0.090090, -0.357830, 0.217330, -0.298960, -0.004130, 0.306030, 0.025090, 
-0.164510, 0.216850, -0.438050, 0.089050, 0.577530, -0.655850, 0.130150, 
0.263350, -0.309740, -0.152080, -0.297160, -0.244700, -0.331600, -0.298140, -0.264570, 0.028710, -0.276220, 
-0.206720, -0.299000, -0.214260, -0.036840, -0.455800, -0.102620, -0.158560, -0.471540, 0.111160, -0.487570, 
-0.508130, 0.116630, -0.015440, 0.003140, -0.256890, -0.119510, -0.332000, -0.127370, -0.211030, 0.271860, 
-0.332570, -0.077780, -0.349190, -0.129460, -0.106890, -0.435130, -0.084570, -0.242220, -0.357340, -0.309110, 
-0.342460, -0.119320, 0.012680, 0.592590, -0.370990, -0.403850, -0.289870, -0.671980, -0.069440, -0.120590, 
0.262060, -0.504680, -0.241600, -0.507130, -0.303110, -0.269590, -0.416790, -0.439210, -0.210900, -0.609970, 
-0.306960, -0.372300, -0.502200, -0.203560, -0.078860, -0.329610, 0.498650, 0.371530, 0.597960, -0.266120, 
0.214810, -0.499900, 0.662540, 0.358790, 0.385950, 0.500480, 0.578150, 0.412610, -0.012720, -0.011700, 
1.363030, -0.447000, -0.291130, 2.215910, -0.242940, 0.298670, 0.145070, -0.281840, -0.344520, -0.506190, 
0.257260, 0.411170, 0.521540, -0.424870, -0.306790, -0.472870, -0.434360, -0.148570, -0.513490, -0.540990, 
-0.417970, -0.158100, -0.634040, -0.288830, -0.304870, 0.148020, -0.146800, 0.024720, -0.200930, -0.335620, 
-0.407780, 0.112560, 0.054160, 0.440830, -0.142660, -0.328550, -0.437430, -0.250240, -0.115630, -0.440870, 
-0.390040, -0.422350, -0.006120, -0.377450, -0.464850, 0.160050, -0.104450, -0.136180, -0.011860, -0.131190, 
-0.091270, -0.192460, 0.215660, 0.142380, -0.113840, -0.122890, -0.221220, -0.302740, -0.189500, 0.160380, 
-0.495260, -0.501010, -0.111260, 0.145260, 0.004600, -0.677670, -0.055480, 
0.169930, 0.059000, -0.143070, -0.336670, -0.156280, -0.399050, 0.434370, -0.374310, -0.739170, -0.206190, 
-0.024020, -0.256490, -0.282050, -0.146840, -0.393160, 0.024700, -0.091750, -0.479460, -0.193160, 0.019370, 
-0.522870, 0.313990, 0.225210, -0.242220, -0.231110, -0.148120, -0.350400, -0.619530, -0.459170, 0.092020, 
-0.256550, 0.037150, -0.448190, -0.213390, -0.179840, -0.323520, -0.132790, 0.019010, -0.539350, -0.690060, 
0.401510, -0.369140, 0.463980, -0.617180, 0.002440, -0.128670, -0.187820, -0.385830, -0.009520, -0.484450, 
0.108740, -0.356880, -0.252460, -0.300710, -0.436300, -0.441190, -0.243100, -0.373000, -0.283270, -0.389170, 
-0.708250, 0.009920, -0.255300, 0.017180, -0.981860, 0.086920, 0.315050, 0.016770, 0.164420, -0.213200, 
-0.376970, 0.517380, 0.176680, -0.021560, 0.230400, -0.006640, 0.118810, 0.443260, -0.099020, -0.028870, 
0.772460, -0.428200, 0.011000, 0.946470, -0.188330, 0.092720, 0.182230, -0.299540, -0.200030, -0.483770, 
-0.365130, 0.134590, 0.694410, -0.254330, -0.372150, -0.388090, -0.467630, -0.231010, -0.348720, -0.417190, 
-0.226640, -0.315380, -0.338130, -0.066320, -0.441050, -0.089020, 0.286230, 0.121700, -0.338210, -0.126240, 
-0.313440, -0.238210, 0.773880, -0.692500, -0.285250, -0.116480, -0.673670, -0.440940, -0.149440, -0.467010, 
-0.554220, -0.078030, -0.283850, -0.444490, -0.156470, -0.444350, -0.315060, 0.753300, 0.256720, -0.304170, 
0.046880, -0.374910, 0.399280, 0.049860, 0.192350, -0.116370, -0.258780, -0.413670, -0.449420, 0.219750, 
-0.579830, -0.276070, 0.001850, -0.196040, -0.315410, 0.087420, -0.405350, 
-0.716780, 0.818800, 0.557540, -0.227380, 0.009790, 0.025070, -0.230250, 0.074890, 0.713740, -0.038560, 
-0.111910, -0.137470, -0.381100, -0.243520, 0.203180, -0.132060, -0.174120, 0.134190, -0.378950, -0.219200, 
0.321610, -0.217900, 0.507790, 0.232100, -0.106270, -0.050100, -0.140270, -0.119660, 0.765240, -0.089360, 
0.060790, 0.028130, -0.282260, -0.226840, -0.075400, 0.094240, -0.030320, -0.217610, -0.066750, -0.553600, 
0.228420, 0.104100, -0.409490, -0.328260, 0.910940, -0.221400, -0.058060, -0.019200, 0.065380, 0.275350, 
-0.254010, -0.028770, -0.268900, -0.256120, -0.182290, -0.179800, -0.197130, -0.024560, -0.260250, -0.047260, 
-0.440290, 0.404320, -0.394240, 0.557050, -0.445940, -0.001550, -0.159800, -0.187600, -0.279500, 0.609900, 
-0.352220, -0.847030, -0.179760, 0.058510, -0.463550, -0.232990, -0.265750, -0.423650, -0.146370, -0.126660, 
-0.537760, 0.421800, -0.007380, -1.114610, 0.091750, -0.823040, 0.509740, -0.313880, -0.231310, -0.065060, 
0.477600, 0.200120, -0.883030, -0.283200, 0.011280, -0.160850, -0.093710, -0.158620, -0.286380, -0.184580, 
-0.253700, -0.218920, 0.509170, -0.116490, -0.931470, -0.345240, -0.508980, 0.385610, -0.130070, -0.282090, 
0.097730, 0.446480, 0.408690, -0.473760, 0.017880, -0.186850, -0.039460, 0.045240, -0.097950, -0.062890, 
0.114920, -0.414720, 0.155820, 0.619000, -0.184440, -0.726920, -0.146910, 0.181090, -0.229480, 0.083250, 
-0.102890, 0.050770, 0.875670, 0.213720, -0.002720, 0.011140, -0.099710, 0.109950, 0.248710, 0.010080, 
-0.119260, 0.256790, -0.410460, 0.057220, 0.928990, -0.705320, -0.327600, 
-0.030640, -0.325740, 0.196630, -0.181740, -0.030560, -0.027030, -0.196600, 0.172650, 0.930380, -0.207150, 
0.052860, -0.053120, -0.421990, 0.140680, 0.012330, -0.559770, 0.070350, 0.358450, -0.725130, 0.141810, 
0.335570, 0.382850, 0.327540, -0.505200, -0.080190, 0.022360, -0.287960, -0.172810, 0.467480, -0.102730, 
-0.180700, -0.161640, -0.158050, -0.275470, 0.021900, -0.084990, -0.302240, 0.084140, 0.051330, -0.262580, 
-0.219730, 0.072560, -0.241850, 0.952000, -0.548470, -0.159260, -0.132410, -0.323420, -0.010080, 0.923200, 
-0.475010, -0.279180, 0.020990, -0.267170, -0.355300, 0.113900, -0.198560, -0.242220, -0.083090, -0.253510, 
0.009060, -0.282560, -0.176220, -0.765630, 0.384510, -0.054130, -0.094590, -0.094230, 0.006540, -0.274970, 
-0.173870, 0.506570, -0.006860, -0.193030, 0.104110, -0.243490, 0.210620, 0.084480, -0.260540, 0.082250, 
0.067890, -0.289100, 0.004620, 0.091660, 0.615910, -0.643070, -0.493860, 0.078660, -0.115820, -0.280760, 
-0.161510, 0.166030, 0.346540, -0.143860, 0.038360, -0.017760, -0.124710, 0.061460, -0.063060, -0.160070, 
0.060620, -0.181650, -0.162290, 0.177750, 0.009280, 0.887630, -0.885100, -0.227940, 0.047680, -0.034370, 
-0.166950, 0.119200, -0.547480, 0.610620, -0.088150, 0.017330, -0.005470, 0.034950, -0.053820, -0.282770, 
-0.099280, 0.008620, -0.189530, -0.387750, 0.014760, 0.153420, 0.522930, -0.459520, 0.319380, -0.251980, 
-0.169850, -0.280180, 0.364720, -0.258530, 0.145830, -0.235730, -0.223680, -0.293810, -0.195660, -0.216030, 
-0.218350, -0.273220, -0.076160, -0.237830, -0.765470, 0.072020, 0.101940, 
0.696490, -0.249820, -0.387110, 0.042510, 0.158400, -0.250670, -0.646000, 0.011410, -0.320310, -0.276800, 
0.335550, -0.330990, -0.220950, 0.386020, -0.198690, -0.475990, 0.411720, -0.133140, -0.960500, 0.833710, 
0.056180, 0.240300, -0.127190, -0.375650, 0.097690, 0.010110, -0.198340, -0.865590, 0.128070, -0.522260, 
-0.216730, 0.391510, -0.238580, -0.178290, 0.359990, -0.308780, -0.439360, 0.368770, -0.215880, -0.289680, 
0.157230, -0.223140, 0.117440, -0.485560, -0.299580, 0.311500, 0.025090, -0.078800, -0.490770, 0.278940, 
0.041270, 0.027080, 0.171290, 0.011330, -0.027780, 0.549220, -0.400620, -0.220730, 0.219420, 0.169770, 
0.178510, -0.035210, 0.102420, 0.136860, -0.097170, -0.628090, 0.246800, -0.088960, -0.138680, -0.746180, 
0.214380, -0.273150, 0.184430, 0.001650, -0.022110, -0.028920, 0.444050, -0.169520, -0.144110, 0.220890, 
0.075510, 0.155250, -0.180170, 0.245990, 0.053770, -0.164810, -0.398290, 0.225730, -0.099150, -0.265030, 
-0.710360, 0.319770, -0.280480, 0.074120, 0.090640, -0.247540, -0.229260, 0.410130, -0.283650, -0.098010, 
0.220940, -0.206440, -0.208020, 0.098140, 0.028980, 0.556380, -0.283240, -0.352560, 0.049270, -0.067820, 
-0.310470, -1.145790, 0.706120, 0.338900, -0.327690, 0.267150, -0.037380, -0.236370, 0.304050, -0.170730, 
-0.525390, 0.355450, -0.214370, -0.460680, 0.093210, 0.051100, 1.072360, 0.115250, -0.783040, -0.098210, 
0.136970, -0.336320, -0.809100, 0.196080, 0.118360, -0.401600, 0.153280, -0.030820, -0.441770, 0.190800, 
-0.128270, -0.609740, 0.527050, -0.291550, -0.966870, 0.606480, 0.059050, 
0.037090, -0.372420, 0.239740, -0.199820, -0.185380, 0.044510, -0.017210, -0.366710, 0.216200, -0.098260, 
-0.159470, -0.084410, -0.174580, -0.127710, 0.027390, -0.036480, -0.315980, -0.017170, 0.489000, -0.775060, 
-0.143100, 0.022250, 0.507930, -0.283900, -0.038760, -0.162560, -0.105440, -0.019680, 0.202120, 0.188850, 
-0.039530, -0.088570, -0.094720, -0.199510, -0.093000, -0.066490, -0.092260, -0.024930, -0.232750, -0.007050, 
-0.257470, 0.024710, -0.238750, -0.184260, 0.254830, -0.103510, -0.093700, -0.067000, -0.508620, 0.238360, 
1.018670, -0.272960, -0.075260, -0.022970, -0.115410, -0.253040, 0.006630, -0.110880, -0.151210, -0.008750, 
-0.293500, -0.217550, 0.188080, -0.443140, -0.972260, 1.053590, 0.116250, -0.103380, 0.321850, 0.091670, 
-0.559780, 0.644180, 0.298640, -0.167320, 0.228330, -0.074800, -0.076520, 0.568270, -0.204110, -0.198620, 
0.934050, -0.622580, -0.058750, 1.014120, 0.261000, 0.024670, 0.041340, -0.059640, -0.152320, -0.259290, 
0.271010, -0.577050, 0.599190, -0.158240, -0.248530, -0.128350, -0.266990, -0.310460, -0.184460, -0.236980, 
-0.197880, 0.045350, -0.334020, -0.117530, -0.131010, 0.664470, -0.042370, -0.283660, -0.058960, -0.209620, 
-0.102620, -0.588770, 0.375270, 0.186250, -0.136150, -0.017520, -0.035640, -0.044940, -0.088780, -0.312780, 
-0.082130, -0.156840, -0.131490, -0.019240, -0.103610, -0.130090, 0.739420, -0.892750, 0.115970, 0.106490, 
-0.178760, -0.153030, 0.005360, 0.497160, 0.548090, -0.031050, -0.006920, -0.353410, 0.130870, -0.103300, 
-0.377110, -0.113730, -0.077540, -0.052290, 0.555740, -0.407320, -0.223370, 
1.118830, -0.474190, -0.431460, -0.119280, -0.029070, -0.446730, -0.181130, -0.167660, 0.809010, -0.420350, 
-0.000700, -0.203020, -0.284370, 0.170960, -0.448200, -0.693320, 0.179740, -0.114560, -1.190890, 0.297890, 
0.310760, 0.713760, -0.759030, -0.275230, -0.031310, 0.083100, -0.359200, -0.451580, -0.192300, 0.576730, 
-0.305670, -0.002140, 0.019660, -0.198500, 0.124190, -0.173380, -0.594330, 0.131420, 0.140220, -0.315450, 
-0.057590, -0.023100, 0.576180, 0.024490, -0.659710, 0.102580, -0.050430, -0.353560, -0.770140, 0.500430, 
0.275590, 0.002590, -0.133080, 0.002950, -0.092360, 0.206820, -0.185500, -0.410630, 0.035490, 0.194100, 
0.037100, -0.303700, 0.166330, 0.456940, 0.620620, -0.843550, 0.046280, -0.080950, -0.442050, -0.846940, 
0.570590, -0.444830, -0.182700, -0.094340, -0.295540, -0.184220, 0.030630, -0.418610, -0.238350, 0.106320, 
-0.431030, 0.232780, -0.718780, -0.105080, 0.068360, 0.203860, -0.436730, 0.210760, -0.046500, -0.326080, 
-0.915540, 0.868790, 0.231690, -0.069790, 0.076190, -0.156720, 0.000990, 0.043880, -0.113750, -0.020740, 
-0.007550, -0.136370, 0.270890, -0.615090, 0.228870, 0.306130, -0.502220, -0.250380, 0.126320, 0.098780, 
-0.185340, -0.562590, 0.585750, 0.079770, -0.101490, 0.250200, 0.036160, -0.011670, 0.058300, 0.170740, 
-0.220580, 0.259780, 0.071950, 0.205130, -0.408370, 0.221100, 0.827650, -0.617120, -0.605790, 0.224620, 
0.050000, -0.016110, -0.682710, 0.233280, -0.455190, -0.218750, 0.300360, 0.049330, -0.132110, 0.037420, 
0.264830, -0.297360, 0.463420, 0.046940, -0.600320, 0.296590, 0.515820, 
0.540510, -0.089950, -0.038060, 0.016320, -0.055290, -0.133670, -0.031470, 0.776130, 0.564740, -0.052560, 
-0.085880, 0.123630, -0.016170, -0.006200, 0.025370, -0.181180, 0.029600, 0.194830, -0.510010, 0.046700, 
0.257290, 0.393870, -0.387040, -0.117690, -0.032350, -0.131550, 0.017510, -0.034340, 0.196630, 0.192230, 
-0.064180, -0.042020, -0.066050, 0.067140, 0.039160, -0.038790, -0.102870, -0.006690, 0.109700, 0.124080, 
0.034020, -0.208560, 0.486970, 0.353590, -0.395580, 0.019750, 0.103690, -0.097060, -0.055920, 0.230680, 
-0.219740, 0.144100, -0.083340, -0.061480, 0.031830, 0.287840, -0.321440, 0.021070, -0.091630, 0.035220, 
0.160160, -0.016450, -0.058310, 0.323630, 0.761220, -0.581890, -0.243060, -0.001690, -0.524080, -0.580610, 
0.813670, -0.251040, -0.339330, -0.019550, -0.250350, -0.138450, 0.165730, -0.650610, -0.040910, 0.069390, 
-0.602710, 0.411660, 0.111110, -1.113900, -0.581560, 0.585330, -0.011130, 0.034350, -0.000490, 0.034160, 
-0.262670, 0.356990, -0.178640, -0.035000, 0.027410, -0.109080, 0.007880, 0.267350, -0.203840, -0.009900, 
0.122310, -0.132660, 0.082080, 0.031430, -0.071300, -0.214160, -0.081080, 0.302130, 0.083590, 0.007800, 
0.089150, -0.022930, 0.044850, -0.460390, -0.091610, 0.196210, 0.094610, 0.039460, 0.165550, -0.057350, 
-0.137720, 0.212300, 0.036910, -0.155250, 0.186640, -0.013020, 0.572700, -0.312760, 0.039440, 0.097410, 
0.155540, 0.016050, -0.039760, -0.354740, 0.120660, -0.327870, 0.117330, 0.111090, 0.005950, 0.079670, 
-0.094570, -0.043200, 0.130340, 0.044250, -0.671260, 0.581960, 0.276600, 
0.415710, 0.081740, 0.232090, 0.043210, -0.006160, 0.162090, 0.852490, 0.162550, -0.170260, 0.257760, 
-0.001410, 0.014260, 0.259760, 0.498600, -0.502250, 0.086100, -0.186260, 0.216810, 0.605330, -0.632780, 
0.299320, 0.382880, 0.109720, 0.570720, -0.121230, -0.190320, -0.034360, 1.047080, -0.349160, 0.109340, 
0.054300, -0.095010, -0.159020, 0.012510, 0.338550, -0.374230, -0.031310, -0.150230, 0.265690, 0.325270, 
-0.303890, 0.012420, 0.363850, 0.169700, 0.717460, -0.152220, -0.121560, -0.019750, 0.881700, -0.269630, 
-0.134330, 0.036580, 0.027590, -0.160270, -0.088860, 0.303000, -0.260500, -0.195280, -0.230660, 0.183340, 
0.148470, -0.222830, -0.176700, 0.393880, 0.146130, 0.888050, -0.193190, 0.226200, 0.116580, 0.999760, 
-0.404790, 0.372060, -0.059410, 0.048890, 0.083960, -0.134870, 0.361310, -0.234580, -0.182990, -0.149640, 
0.581050, -0.120030, 0.120000, 0.101050, 0.126470, 0.930920, 0.711490, -0.146320, 0.012380, -0.018380, 
0.641560, 0.168010, 0.690050, -0.052480, -0.079800, -0.181130, -0.274370, 0.248290, -0.201910, -0.255940, 
-0.038970, 0.116940, -0.007390, -0.042810, -0.159010, 0.108730, 0.874770, 0.657210, -0.157490, 0.048320, 
-0.079080, 0.291240, 0.061690, 0.986600, -0.078820, -0.025080, -0.007190, -0.100200, 0.226120, -0.340640, 
-0.138510, -0.186210, 0.137760, 0.126470, -0.203530, 0.069450, 0.265420, 0.069880, 0.517890, 0.034110, 
-0.008280, 0.062650, 0.475980, -0.192540, 0.979450, 0.071150, -0.055190, 0.017580, -0.146650, 0.316760, 
-0.281870, -0.053720, -0.101630, 0.299670, 0.466950, -0.742120, 0.257390, 
0.677380, 1.116470, 0.806640, 0.679680, 0.696610, -1.357020, -1.137110, 1.150320, -1.242140, -1.323040, 
-0.576520, -0.918510, -0.230730, 0.794830, 
-1.249270, -1.204240, 0.451410, 0.382240, -1.411950, -2.078270, -0.805970, -0.881540, 0.736800, 0.597500, 
-0.620060, 0.792190, 0.432580, -1.348610, 
-0.519720, -0.885260, -0.916500, -0.783320, -0.323140, 2.853920, 1.164170, -0.457920, -0.035520, -0.136930, 
0.643590, -0.357940, -0.592780, -0.057010, 

  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[165] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.100000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, 0.099800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.091670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.064670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.027080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, 0.081730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.081540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, 0.002560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, -0.005350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.009110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, 0.053360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, -0.066260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.086350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, -0.013610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, -0.011220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, 0.089830, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.053410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, 0.096220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.049530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.040360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, -0.075200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.006310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, -0.084050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, -0.003090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, -0.062090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, 0.062320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.077260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.014120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, 0.084650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, -0.063050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, -0.096980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, 0.076330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.078780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, -0.056900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, 0.079820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.049340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, 0.096030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, 0.024320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, -0.035780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.036180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, -0.050540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.098750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, -0.024880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.074710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.023510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.054190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, 0.062690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, 0.000660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, -0.001900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, 0.036810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, -0.040340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, 0.026550, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, -0.075260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, 0.025800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, -0.005050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, 0.014430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, -0.008550, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, -0.033600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, 0.065770, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, -0.066160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.072380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, -0.053840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.089480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, -0.093350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, 0.033140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.083580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, 0.045940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.085150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.035250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.062030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.007160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.013840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.002440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, -0.017300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, -0.047750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, -0.074340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, -0.015590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.092940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, 0.033290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, 0.021430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, 0.064610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.077630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.070540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.062230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, -0.090980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.080860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.072220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.037240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.074600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, 0.099180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, 0.099900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, 0.061410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, -0.017360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, 0.025010, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, 0.094640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.007050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, -0.057070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.011550, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.042420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.070670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.005190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, -0.045680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, 0.046740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, -0.056700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, 0.006390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.060600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.010560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.045690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.093220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.051370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.006790, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, -0.073790, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, 0.073190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, -0.069210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.096380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, -0.088170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, -0.034020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, -0.059990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.071360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, -0.022090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, -0.081660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.054880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.026790, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.088860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, -0.076960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.010970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.067390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.015040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.004030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, 0.093770, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, -0.021690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, -0.058450, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.063500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.005020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, -0.079750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, 0.038240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, -0.088530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.022400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, -0.086100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.082280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, 0.032460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, -0.006560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.040420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.094200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.053620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, -0.050390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.081830, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.732070, 147,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, -0.899370, 147,
       &Sources[147] , 
       &Weights[147] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, -0.937580, 147,
       &Sources[294] , 
       &Weights[294] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, -0.768810, 147,
       &Sources[441] , 
       &Weights[441] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, -0.323960, 147,
       &Sources[588] , 
       &Weights[588] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, 1.420430, 147,
       &Sources[735] , 
       &Weights[735] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, 0.634310, 147,
       &Sources[882] , 
       &Weights[882] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, -0.743480, 147,
       &Sources[1029] , 
       &Weights[1029] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, -0.144800, 147,
       &Sources[1176] , 
       &Weights[1176] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, 0.293990, 147,
       &Sources[1323] , 
       &Weights[1323] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, 0.524390, 147,
       &Sources[1470] , 
       &Weights[1470] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, -0.541230, 147,
       &Sources[1617] , 
       &Weights[1617] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, -0.766630, 147,
       &Sources[1764] , 
       &Weights[1764] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.069330, 147,
       &Sources[1911] , 
       &Weights[1911] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.991400, 14,
       &Sources[2058] , 
       &Weights[2058] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, -0.741880, 14,
       &Sources[2072] , 
       &Weights[2072] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, 0.085380, 14,
       &Sources[2086] , 
       &Weights[2086] , 
      }

  };



int net_gor_noconsensus111(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[147] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147}; /* members */

  static pUnit Hidden1[14] = {Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161}; /* members */

  static pUnit Output1[3] = {Units + 162, Units + 163, Units + 164}; /* members */

  static int Output[3] = {162, 163, 164};

  for(member = 0; member < 147; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 14; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
