/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include "Prof.h"
#include "All_net.h"

void net_step4(void)
{
int i , j , k , u            ;
char *res , v[3]             ;
float w1, w2, wt, denom      ;
float pconf                  ;
float **attrib               ;
float *netInput,  *netOutput ;

FILE *fp ;

MLLC(netInput  , float, (step4_netREC.NoOfInput)   )                              ;
MLLC(netOutput , float, (step4_netREC.NoOfOutput)  )                              ;
MLLC(res , char, size_prot[0])                                                    ;
attrib = alloue_2( 18 , size_prot[0])                                             ;
step4 = (struct net_stage4 *) malloc( (size_prot[0])*sizeof (struct net_stage4) ) ;

if(verbose == 1) printf("final steps are started ... \n") ;

k = 0 ;
for(i = 0 ; i < length_query ; i++)
 {
  if(seq[0][i] == '-' || seq[0][i] == '.') continue ;
  else { res[k] = seq[0][i] ; k++ ; }
 }

if ((fp=fopen(name_step3, "r")) == NULL)
       {
       printf("Unable to open file for reading in function net_step4 ... \n") ;
       exit(1);
       }
for(i = 0 ; i < size_prot[0] ; i++)
 {
  fscanf(fp, "%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f\n",
             &attrib [0][i], &attrib [1][i], &attrib [2][i], &attrib [3][i], &attrib [4][i],
             &attrib [5][i], &attrib [6][i], &attrib [7][i], &attrib [8][i], &attrib [9][i],
             &attrib[10][i], &attrib[11][i], &attrib[12][i], &attrib[13][i], &attrib[14][i],
             &attrib[15][i], &attrib[16][i], &attrib[17][i]) ;
 }
fclose(fp) ;

for(i = 0 ; i <  size_prot[0] ; i++)
 {
  u = 0 ;
  for(j=i-6 ; j <= i+6 ; j++)
   {
    if(j >= 0 && j < size_prot[0])
     {
     for(k = 0 ; k < 18 ; k++) { netInput[u] = attrib[k][j] ; u++ ; }
     }
    else
     {
     for(k = 0 ; k < 18 ; k++) { netInput[u] = 0. ; u++ ; }
     }
   }
  step4_net(netInput, netOutput, 0)     ;
  step4[i].nnb_pa = netOutput[0]        ;
  step4[i].nnb_pb = netOutput[1]        ;
  step4[i].nnb_pc = netOutput[2]        ;
  step4_net111(netInput, netOutput, 0)  ;
  step4[i].nnu_pa = netOutput[0]        ;
  step4[i].nnu_pb = netOutput[1]        ;
  step4[i].nnu_pc = netOutput[2]        ;
 }

w1 = 1.5 ; w2 = 1. ; wt = w1+w2 ;

for(i = 0 ; i <  size_prot[0] ; i++)
 {
  step4[i].pa = (w1*step4[i].nnb_pa + w2*step4[i].nnu_pa) / wt ;
  step4[i].pb = (w1*step4[i].nnb_pb + w2*step4[i].nnu_pb) / wt ;
  step4[i].pc = (w1*step4[i].nnb_pc + w2*step4[i].nnu_pc) / wt ;
  denom = step4[i].pa + step4[i].pb + step4[i].pc ;
  step4[i].pa /= denom ;
  step4[i].pb /= denom ;
  step4[i].pc /= denom ;

 if(check_pred == 1)
  {
     voix[i].step4_a = voix[i].step4_b = voix[i].step4_c = 0 ;
     v[0] = vote(step4[i].nnu_pa, step4[i].nnu_pb, step4[i].nnu_pc)    ;
     v[1] = vote(step4[i].nnb_pa, step4[i].nnb_pb, step4[i].nnb_pc)    ;
     v[2] = vote(step4[i].pa, step4[i].pb, step4[i].pc)                ;
     for(k=0 ; k < 3 ; k++)
      {
       if(v[k] == 'a') voix[i].step4_a++ ;
       if(v[k] == 'b') voix[i].step4_b++ ;
       if(v[k] == 'c') voix[i].step4_c++ ;
      }
  }

 }


if ((fp=fopen(file_out, "w")) == NULL)
       {
       printf("Unable to open file for writing in function net_step4 ... \n") ;
       exit(1);
       }
if(casp == 0)
 {
  if(! check_pred)
    {
     fprintf(fp,"_______________________________\n") ;
     fprintf(fp,"|                             |\n") ;
     fprintf(fp,"|AA  pH      pE     pC  PRED  |\n") ;
     fprintf(fp,"|_____________________________|\n") ;
     fprintf(fp,"|                             |\n") ;
     for(i = 0 ; i <  size_prot[0] ; i++)
      {
            if(step4[i].pa >= step4[i].pb && step4[i].pa > step4[i].pc) step4[i].stru = 'H' ;
       else if(step4[i].pb >  step4[i].pa && step4[i].pb > step4[i].pc) step4[i].stru = 'E' ;
       else if(step4[i].pc >= step4[i].pa && step4[i].pc > step4[i].pb) step4[i].stru = 'C' ;
       else                                                             step4[i].stru = 'C' ;
       fprintf(fp , "| %c %6.3f %6.3f %6.3f %c    |\n",
                     res[i], step4[i].pa, step4[i].pb, step4[i].pc, step4[i].stru) ;
      }
    fprintf(fp,"|_____________________________|\n") ;
   }
 else
   {
    fprintf(fp,"    __________________________________________________________________________________________________________\n") ;
    fprintf(fp,"    |                  |                  |                  |                  |                             |\n") ;
    fprintf(fp,"    |   Vote step 1    |   Vote step 2    |   Vote step 3    |   Vote step 4    |     Final Classifier        |\n") ;
    fprintf(fp,"    | of 7 classifiers | of 8 classifiers | of 3 classifiers |of 3 classifiers  |                             |\n") ;
    fprintf(fp,"----|------------------|------------------|------------------|------------------|-----------------------------|\n") ;
    fprintf(fp,"|AA |  H     E     C   |  H     E     C   |  H     E     C   |  H     E     C   |   pH      pE     pC  PRED   |\n") ;
    fprintf(fp,"|___|__________________|__________________|__________________|__________________|_____________________________|\n") ;
    fprintf(fp,"|   |                  |                  |                  |                  |                             |\n") ;
    for(i = 0 ; i <  size_prot[0] ; i++)
     {
           if(step4[i].pa >= step4[i].pb && step4[i].pa > step4[i].pc) step4[i].stru = 'H' ;
      else if(step4[i].pb >  step4[i].pa && step4[i].pb > step4[i].pc) step4[i].stru = 'E' ;
      else if(step4[i].pc >= step4[i].pa && step4[i].pc > step4[i].pb) step4[i].stru = 'C' ;
      else                                                             step4[i].stru = 'C' ;
     fprintf(fp,"|%c  |  %d    %d    %d     |  %d    %d    %d     |  %d    %d    %d     |  %d    %d    %d     |  %6.3f  %6.3f  %6.3f  %c  |\n",
     res[i], voix[i].step1_a, voix[i].step1_b, voix[i].step1_c, 
             voix[i].step2_a, voix[i].step2_b, voix[i].step2_c, 
             voix[i].step3_a, voix[i].step3_b, voix[i].step3_c, 
             voix[i].step4_a, voix[i].step4_b, voix[i].step4_c, 
             step4[i].pa, step4[i].pb, step4[i].pc, step4[i].stru) ;
     }
   fprintf(fp,"|___|__________________|__________________|__________________|__________________|_____________________________|\n") ;
  }
 }
else
 {
  fprintf(fp,"MODEL\n") ;
  for(i = 0 ; i <  size_prot[0] ; i++)
   {
         if(step4[i].pa >= step4[i].pb && step4[i].pa > step4[i].pc) {step4[i].stru = 'H' ; pconf = step4[i].pa ; }
    else if(step4[i].pb >  step4[i].pa && step4[i].pb > step4[i].pc) {step4[i].stru = 'E' ; pconf = step4[i].pb ; }
    else if(step4[i].pc >= step4[i].pa && step4[i].pc > step4[i].pb) {step4[i].stru = 'C' ; pconf = step4[i].pc ; }
    else                                                             {step4[i].stru = 'C' ; pconf = step4[i].pc ; }
    fprintf(fp , "%c   %c   %6.3f\n", res[i], step4[i].stru, pconf) ;
   }
  fprintf(fp, "END\n")  ;
 }
fclose(fp) ;



if(check_pred) free(voix) ;
free(netInput)            ;
free(netOutput)           ;
free(res)                 ;
free(step4)               ;
for(i = 0; i < 18 ; i++) free(attrib[i]) ; free(attrib) ;

if(verbose == 1) printf("final steps are completed ...\n") ;

return ;

}
