/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<ctype.h>
#include "Prof.h"

void read_align(void)
{
int i , k , flag1 ;
char *chaine      ;
char *blank       ;
char *prot_name   ;
char *seq_bid     ;
char *seqline     ;

FILE *fp ;

MLLC(chaine   , char , MAX_FIC)      ;
MLLC(prot_name, char , MAX_FIC)      ;
MLLC(blank    , char , MAX_FIC)      ;
MLLC(seqline  , char , MAX_FIC)      ;
MLLC(seq_bid  , char , MAX_SEQ)      ;

strncpy(chaine   , ""   , MAX_FIC)      ; /* SAMIA */
strncpy(prot_name, ""   , MAX_FIC)      ; /* SAMIA */
strncpy(blank    , ""   , MAX_FIC)      ; /* SAMIA */
strncpy(seqline  , ""   , MAX_FIC)      ; /* SAMIA */
strncpy(seq_bid  , ""   , MAX_SEQ)      ; /* SAMIA */

if(mode == 1)
 {
  MLLC(output_clustal, char, MAX_FIC)     ;
  strcpy(output_clustal, file_clu)        ;
 }
if ((fp=fopen(output_clustal, "r")) == NULL)
       {
       printf("Unable to open file containing the multiple alignement (.aln) in function read_align ... \n");
       exit(1);
       }

i=0; flag1 = 0 ; k = 0 ;
nb_ali_seq = 0 ;

/**************************************************************/
/* ... Pass 1 to allocate just the right amount of memory ... */
/**************************************************************/
fgets(chaine, MAX_FIC, fp);
fgets(chaine,2, fp);
fgets(chaine,2, fp);
while(fgets(chaine, MAX_FIC , fp) != NULL)
 {
 if(chaine[0] != '\0' && chaine[0] != '\n' && chaine[0] != ' ')
  {
  sscanf(chaine,"%s %s\n", prot_name, seqline) ;
  if(i == 0) strcat(seq_bid, seqline)   ;
  i++ ;
  }
 else {if( flag1 == 0) {
                  nb_ali_seq = i ; i = 0 ; flag1 = 1 ;
                  sscanf(chaine,"%s", blank) ;
                  k++ ;
                  }
       else       {
                  i = 0 ;
                  sscanf(chaine,"%s", blank) ;
                  k++ ;
                  }
        }
 }
fclose(fp);

length_query = strlen(seq_bid) ;

free(seq_bid)     ;

seq = (char **) malloc (nb_ali_seq*sizeof (char *)) ;
for(i = 0 ; i < nb_ali_seq ; i++) seq[i] = malloc(length_query+1) ;

for(i = 0 ; i < nb_ali_seq ; i++) strncpy(seq[i], "", length_query) ;

/***************************************************/
/* ... Pass 2 to read the homologous sequences ... */
/***************************************************/
i=0; flag1 = 0 ; k = 0 ;
fp=fopen(output_clustal, "r") ;
fgets(chaine, MAX_FIC, fp);
fgets(chaine,2, fp);
fgets(chaine,2, fp);
while(fgets(chaine, MAX_FIC , fp) != NULL)
 {
 if(chaine[0] != '\0' && chaine[0] != '\n' && chaine[0] != ' ')
  {
  sscanf(chaine,"%s %s\n", prot_name, seqline) ;
  strcat(seq[i], seqline)   ;
  i++ ;
  }
 else {if( flag1 == 0) {
                  i = 0 ; flag1 = 1 ;
                  sscanf(chaine,"%s", blank) ;
                  k++ ;
                  }
       else       {
                  i = 0 ;
                  sscanf(chaine,"%s", blank) ;
                  k++ ;
                  }
        }
 }
fclose(fp) ;

free(blank)       ;
free(chaine)      ;
free(prot_name)   ;
free(seqline)     ;

/*
for(i = 0 ; i < nb_ali_seq ; i++)
{
printf("%s\n", seq[i]) ;
printf("++++++++++++++\n") ;
}
*/

return ;
}
