/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "Prof.h"

void read_seq(void)
{
int c , i, n,  flag_fasta ;
char *title ;
FILE *fp ;

 MLLC(title, char, MAX_TITLES) ;
 MLLC(seq_query, char, MAX_SEQ) ;
 flag_fasta = 0 ; n = 0 ; i = 0 ;
 if((fp = fopen(file_seq, "r")) == NULL)
       {
       printf("Unbale to open file of sequence in function read_seq ... \n");
       exit(1);
       }
 while( (c= fgetc(fp) ) != EOF )
  {
    if(c == '\0' || c == '\n') flag_fasta = 1 ;
    if(flag_fasta == 0) { title[n] = c ; n++ ; }
    else  if(c != '\n' && c != ' ') {seq_query[i] = c ; i++ ;}
  }
 fclose(fp)   ;
 free(title) ;
if(verbose == 1) printf("%s\n", seq_query) ;
return ;

}
