/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include "Prof.h"

void translate_align(void)
{
 int i , j , k ;

 MLLC(size_prot, int, nb_ali_seq) ;
 if( (i_seq =  (int **) malloc (nb_ali_seq*sizeof (int *)) ) )
  {
  for(i = 0 ; i < nb_ali_seq ; i++)  
   {
    if( !(i_seq[i] = (int *) malloc((length_query+1)*sizeof(int)) ) ) 
     {
      printf ("Error in malloc 2 for i_seq in function translate_align ... \n") ;
      exit(1) ;
     }
   }
  }
 else
  {
   printf ("Error in malloc 1 for i_seq in function translate_align ... \n") ;
   exit(1) ;
  }

 for(i = 0 ; i < nb_ali_seq ; i++)
  {
   k = 0 ;
   for(j = 0 ; j < length_query ; j++)
     {
       if(seq[i][j] == '-' || seq[i][j] == '.') 
        {
         continue ;
        }
       else
        {
         switch(seq[i][j]) {
         case 'A' : i_seq[i][k] =  0 ; break;
         case 'C' : i_seq[i][k] =  1 ; break;
         case 'D' : i_seq[i][k] =  2 ; break;
         case 'E' : i_seq[i][k] =  3 ; break;
         case 'F' : i_seq[i][k] =  4 ; break;
         case 'G' : i_seq[i][k] =  5 ; break;
         case 'H' : i_seq[i][k] =  6 ; break;
         case 'I' : i_seq[i][k] =  7 ; break;
         case 'K' : i_seq[i][k] =  8 ; break;
         case 'L' : i_seq[i][k] =  9 ; break;
         case 'M' : i_seq[i][k] = 10 ; break;
         case 'N' : i_seq[i][k] = 11 ; break;
         case 'P' : i_seq[i][k] = 12 ; break;
         case 'Q' : i_seq[i][k] = 13 ; break;
         case 'R' : i_seq[i][k] = 14 ; break;
         case 'S' : i_seq[i][k] = 15 ; break;
         case 'T' : i_seq[i][k] = 16 ; break;
         case 'V' : i_seq[i][k] = 17 ; break;
         case 'W' : i_seq[i][k] = 18 ; break;
         case 'Y' : i_seq[i][k] = 19 ; break;
         case 'X' : i_seq[i][k] = 20 ; break;
         case 'B' : i_seq[i][k] = 20 ; break;
         case 'Z' : i_seq[i][k] = 20 ; break;
         case '-' : i_seq[i][k] = 20 ; break;
         default  : i_seq[i][k] = 20 ; break;
                           }
         k++ ;
        }
     }
   size_prot[i] = k ;
  }

/*
for(i = 0 ; i < nb_ali_seq ; i++)
 {
 for(j = 0 ; j < size_prot[i] ; j++)
  {
   printf("%d ", i_seq[i][j]) ; 
  }
  printf("\n+++++++++++++++++++++++\n") ;
 }
*/

 return ;
}
