/* new trimmer program */
/* Legerement  modifie */
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <math.h>
#include <stdlib.h>

#define VIEW_MATRICES 0

#define MAXSEQLEN  40000
#define DEBUG 0

typedef struct
  {
    char ident[280];
    int *seq;
    int len;
    int begin;
    int ending;
    float seqid;
    float cover;
    float cover2;
  }
Entry;

/* Blosum62 substitution matrix */
int blosum62[24][24] = {
 4,-1,-2,-2,0,-1,-1, 0,-2,-1,-1,-1,-1,-2,-1 ,1 ,0,-3,-2, 0,-2,-1, 0,-4,
-1, 5, 0,-2,-3, 1,0,-2,0,-3,-2,2,-1,-3,-2,-1,-1,-3,-2,-3,-1,0,-1,-4,
-2,0,6,1,-3,0,0,0,1,-3,-3,0,-2,-3,-2,1,0,-4,-2,-3,3,0,-1,-4,
-2,-2,1,6,-3,0,2,-1,-1,-3,-4,-1,-3,-3,-1,0,-1,-4,-3,-3,4,1,-1,-4,
 0,-3,-3,-3,9,-3,-4,-3,-3,-1,-1,-3,-1,-2,-3,-1,-1,-2,-2,-1,-3,-3,-2,-4,
-1,1,0,0,-3,5,2,-2,0,-3,-2,1,0,-3,-1,0,-1,-2,-1,-2,0,3,-1,-4,
-1,0,0,2,-4,2,5,-2,0,-3,-3,1,-2,-3,-1,0,-1,-3,-2,-2,1,4,-1,-4,
 0,-2,0,-1,-3,-2,-2,6,-2,-4,-4,-2,-3,-3,-2,0,-2,-2,-3,-3,-1,-2,-1,-4,
-2,0,1,-1,-3,0,0,-2,8,-3,-3,-1,-2,-1,-2,-1,-2,-2,2,-3,0,0,-1,-4,
-1,-3,-3,-3,-1,-3,-3,-4,-3,4,2,-3,1,0,-3,-2,-1,-3,-1,3,-3,-3,-1,-4,
-1,-2,-3,-4,-1,-2,-3,-4,-3,2,4,-2,2,0,-3,-2,-1,-2,-1,1,-4,-3,-1,-4,
-1,2,0,-1,-3,1,1,-2,-1,-3,-2,5,-1,-3,-1,0,-1,-3,-2,-2,0,1,-1,-4,
-1,-1,-2,-3,-1,0,-2,-3,-2,1,2,-1,5,0,-2,-1,-1,-1,-1,1,-3,-1,-1,-4,
-2,-3,-3,-3,-2,-3,-3,-3,-1,0,0,-3,0,6,-4,-2,-2,1,3,-1,-3,-3,-1,-4,
-1,-2,-2,-1,-3,-1,-1,-2,-2,-3,-3,-1,-2,-4,7,-1,-1,-4,-3,-2,-2,-1,-2,-4,
 1,-1,1,0,-1,0,0,0,-1,-2,-2,0,-1,-2,-1,4,1,-3,-2,-2,0,0,0,-4,
 0,-1,0,-1,-1,-1,-1,-2,-2,-1,-1,-1,-1,-2,-1,1,5,-2,-2,0,-1,-1,0,-4,
-3,-3,-4,-4,-2,-2,-3,-2,-2,-3,-2,-3,-1,1,-4,-3,-2,11,2,-3,-4,-3,-2,-4,
-2,-2,-2,-3,-2,-1,-2,-3,2,-1,-1,-2,-1,3,-3,-2,-2,2,7,-1,-3,-2,-1,-4,
 0,-3,-3,-3,-1,-2,-2,-3,-3,3,1,-2,1,-1,-2,-2,0,-3,-1,4,-3,-2,-1,-4,
-2,-1,3,4,-3,0,1,-1,0,-3,-4,0,-3,-3,-2,0,-1,-4,-3,-3,4,1,-1,-4,
-1,0,0,1,-3,3,4,-2,0,-3,-3,1,-1,-3,-1,0,-1,-3,-2,-2,1,4,-1,-4,
 0,-1,-1,-1,-2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-2,0,0,-2,-1,-1,-1,-1,-1,-4,
 -4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,1
};


int Blosum=1,  Identity=0;

Entry **DB; 
int *picked;
int Seq[MAXSEQLEN];
int seq_1[MAXSEQLEN], seq_2[MAXSEQLEN];
char Ident[280];
int ender = 0, SeqLen, SeqCount;
char database[80];
char *AminoIndex = "ARNDCQEGHILKMFPSTWYVBZX-+";
int gap, extend, verbose=0, nhits=100;
float thresh=0.97, mincover=0.70 , maxcover = 1.5 ;
float thresh2=0.24  ;
int top2=0;

int compteur ;

int **DMat;
char **PMat;
int PAM[24][24];
int rows, cols;


int 
GetAminoIndex (int *pc)
/*                            012345678901234567890123   */
/* static char *AminoIndex = "ARNDCQEGHILKMFPSTWYVBZX*"; */
{
  int i;
  int c;

  c = *pc;
  for (i = 0; i < 23; i++)
    if (AminoIndex[i] == c)
      return i;

  /* Cannot find residue */
  return 23;
}


int 
ReadSequenceEntry (FILE * fp)
{
  int i;
  char *ptr;
  char *dst;
  int ch;

  ender = 1;
  for (i = 0; i < 280; i++)
    Ident[i] = '_';
  if (fgets (Ident, 280, fp) == NULL)
    {
      ender = 1;
      return (ender);
    }
  else
    ender = 0;

  i=0;
  Seq[0]=24;
  i++;
  while ((ch = fgetc (fp)) != '>' && ch != EOF)
    {
      if (ch != '\n' && ch != ' ')
        {
          Seq[i] = GetAminoIndex(&ch);
          i++;
        }
    }

  SeqLen = i;
  ungetc (ch, fp);

  if (verbose) fprintf (stderr, "...Seq Len is %d\n", SeqLen);
  if (SeqLen > MAXSEQLEN)
    {
    fprintf(stderr, "Sequence %s too long %d residues \n",
                     Ident, SeqLen);
    exit(1);
    }

  for(i=0; i<strlen(Ident); i++)if(Ident[i]=='\n')Ident[i]=' ';
  
#if 0
  fprintf(stdout, "%s %d\n", Ident, SeqLen);
  for(i=0; i<SeqLen; i++)
    {
      fprintf(stdout, "%c", AminoIndex[Seq[i]]);
      if ( (i%60==0) && i != 0) fprintf(stdout, "\n");
    }
  fprintf(stdout, "\n");
#endif

  return (ender);
}

void 
InsertSequenceEntry ()
{
  int i;
  int *dst, *src;
  Entry *entry;
  char ident2[13];
int b, c, l = 0 , m ;
  char *tt ;
  tt = malloc(13) ;

/* few Changes Ouali Mohammed */
/* This is to avoid problems which can occur when twice the same name of protein appears in the database */
m = SeqCount ;
do {tt[l++]=m%10 + 48 ; } while (m/=10) ; tt[l] = '\0' ;
for(b=0, c =l-1; b<c; b++, c--) {m=tt[b]; tt[b] = tt[c] ; tt[c] = m;}


  if (verbose) fprintf(stdout,"In InsertSequenceEntry - SeqCount %d\n", SeqCount);
  if (verbose) fprintf(stdout, "%s\n", Ident);
  /* Copy the 12 chars after > as the identifier */
  /*strncpy (DB[SeqCount]->ident, Ident + 1, 12); */
  strcpy(DB[SeqCount]->ident, Ident + 1);

/* few Changes Ouali Mohammed */
  if(SeqCount != 0) { 
                     strncpy(DB[SeqCount]->ident,"", 12) ;
                     strcat(DB[SeqCount]->ident,"P")      ;
                     strcat(DB[SeqCount]->ident,tt) ;
                    }

  if(verbose) fprintf(stdout, "%s\n", DB[SeqCount]->ident);
    
  /* for(i=0; i<12; i++) if (DB[SeqCount]->ident[i]=='\n') DB[SeqCount]->ident[i] = ' '; */
  for(i=0; i< strlen(DB[SeqCount]->ident); i++) if (DB[SeqCount]->ident[i]=='\n') DB[SeqCount]->ident[i] = ' ';
  DB[SeqCount]->len = SeqLen;

  /* Allocate memory for the sequence string */
  dst = (int *) malloc (SeqLen * sizeof (int));
  src = Seq;
  DB[SeqCount]->seq = dst;
  for (i = 0; i < SeqLen; i++)
    {
      *dst = *src;
      *dst++;
      *src++;
    }

}

void 
WriteSequenceEntries ()
{
  int i, j;
  Entry *entry;

  for (i = 0; i < SeqCount; i++)
    {
      fprintf (stdout, ">%s, %d, %d\n",
               DB[i]->ident, DB[i]->len, i);

      for (j = 0; j < DB[i]->len; j++)
        {
        if (j%60==0 && j!=0) fprintf(stdout, "\n");
        fprintf (stdout, "%c", AminoIndex[DB[i]->seq[j]]);
        }
      fprintf(stdout, "\n");
    }
}


void 
WriteEntries (int *val)
{
  int i, j, k;
  Entry *entry;

  i=*val;

      fprintf (stdout, ">%s Len:%d Begin:%d End:%d i:%d SeqID:%f Cover:%f Cover2:%f\n",
               DB[i]->ident, DB[i]->len, DB[i]->begin, DB[i]->ending, i, DB[i]->seqid, DB[i]->cover, DB[i]->cover2);
      k=0;
      for (j = DB[i]->begin; j < DB[i]->ending; j++)
        {
             if(k%60==0 && k!=0) fprintf(stdout, "\n");
             fprintf (stdout, "%c", AminoIndex[DB[i]->seq[j]]);
             k++;
        }
      fprintf(stdout, "\n");
    
}

void 
AllocationError ()
{
  fprintf (stderr, "Error: Memory allocation failed!\n");
  fputc (0x07, stderr);
  exit (1);
}

void 
DisplayUsage ()
{
  fputs ("trimmer - Mansoor Saqi\n", stderr);
  fputs ("usage: trimmer [-top2][-gap <value>][-extend <value>[-hits <value>] [-cover2<%coverage eg: 150]\n", stderr);
  fputs ("       [-thresh <%value eg 97>] [-thresh2 <%value eg 25] [-cover <%coverage eg: 80>] <database> > <trimmed_file>\n", stderr);
  fputs ("NB: Input sequence database must be in fasta format!\n", stderr);
  exit (1);
}

void 
ProcessCommandLine (argc, argv)
     int argc;
     char *argv[];
{
  register int i, j;

  gap = -8;
  extend = -2;

  j = 0;
  for (i = 1; i < argc; i++)
    if (argv[i][0] == '-')
      {                         /* All options take arguments! */
        if (i == argc - 1)
          DisplayUsage ();

        if (!strcmp (argv[i], "-gap"))
          {
            sscanf (argv[++i], "%d", &gap);
          }
        else if (!strcmp (argv[i], "-extend"))
          {
            sscanf (argv[++i], "%d", &extend);
          }
        else if (!strcmp (argv[i], "-hits"))
          {
            sscanf (argv[++i], "%d", &nhits);
          }
        else if (!strcmp (argv[i], "-thresh"))
          {
            sscanf (argv[++i], "%f", &thresh);
            thresh /= 100.0;
          }
        else if (!strcmp (argv[i], "-thresh2"))
          {
            sscanf (argv[++i], "%f", &thresh2);
            thresh2 /= 100.0;
          }
          else if (!strcmp (argv[i], "-blosum"))
          {
            Blosum=1;
          }
          else if (!strcmp (argv[i], "-top2"))
          {
            top2=1;
          }
          else if (!strcmp (argv[i], "-identity"))
          {
            Identity=1;
          }
          else if (!strcmp (argv[i], "-cover"))
          {
            /* Input as a percentage eg 97.5 */
            sscanf (argv[++i], "%f", &mincover);
            mincover = mincover/100.0;
          }
          else if (!strcmp (argv[i], "-cover2"))
          {
            /* Input as a percentage eg 150 */
            sscanf (argv[++i], "%f", &maxcover);
            maxcover = maxcover/100.0;
          }
        else if (!strcmp (argv[i], "-verbose"))
          {
            verbose=1;
          }
        else
          DisplayUsage ();

      }
    else
      switch (j++)
        {
        case (0):
          strcpy (database, argv[i]);
          break;
        default:
          DisplayUsage ();
        }
    if (j < 1) DisplayUsage();

}


int 
read_db (dbname, fpin)
     FILE *fpin;
     char dbname[80];
{
  int counter, i;
  char buf[280];

  if (verbose) fprintf (stdout, "DataBase is %s\n", dbname);
  if ((fpin = fopen (dbname, "r")) == NULL)
    {
    fprintf (stderr, "Cannot Open DB\n");
    exit(1);
    }

  /* How many entries */
  counter=0;
  while( fgets(buf, 280, fpin) != NULL) 
    {
      if(buf[0]=='>') counter++;
    }
  if(verbose) fprintf(stdout, "Number of entries in database %d\n", counter);

  DB = (Entry **) malloc(counter*sizeof(Entry*));

  for(i=0; i<counter; i++) 
    {
       DB[i] = (Entry*) malloc(sizeof(Entry));
       if (!DB[i]) AllocationError();
       else 
           {
           if(verbose) fprintf(stdout, "Allocated DB[%3d]\n", i);
           }
    }
  rewind(fpin);

  SeqCount = 0;
  while (!ender)
    {
      ReadSequenceEntry (fpin);
      if (!ender)
        {
                  InsertSequenceEntry ();
        }
      SeqCount++;
    }
  SeqCount -= 1;
  if (verbose) fprintf (stdout, "Number of sequences read in %d\n", SeqCount);

  return SeqCount;

}

void FreeSequenceEntries(int *nseq)
{
int i;

for(i=0; i<*nseq; i++)
  free(DB[i]);
free(DB);
if(verbose) fprintf (stdout, "\nFreed DB\n");

}

void FreeMatrices()
{
int i;

  for (i = 0; i < rows; i++)
    free (DMat[i]);
  free (DMat);
  for (i = 0; i < rows; i++)
    free (PMat[i]);
  free (PMat);
}


void 
AllocateMatrices ()

{
  int i;

  /* printf("rows %d cols %d\n", rows, cols); */
  /* Allocate Distance Matrix */
  DMat = (int **) malloc (rows * sizeof (int *));
  if (!DMat)
    AllocationError ();
  for (i = 0; i < rows; i++)
    {
      DMat[i] = (int *) malloc (cols * sizeof (int));
      if (!DMat[i])
        AllocationError ();
    }

  /* Allocate Path Matrix */
  PMat = (char **) malloc (rows * sizeof (char *));
  if (!PMat)
    AllocationError ();
  for (i = 0; i < rows; i++)
    {
      PMat[i] = (char *) malloc (cols * sizeof (int));
      if (!PMat[i])
        AllocationError ();
    }
}

void 
IdentityMatrix ()
{
  register int i, j;

  for (i = 0; i < 24; i++)
    {
      for (j = 0; j < 24; j++)
        PAM[i][j] = 0.0;
      PAM[i][i] = 1.0;
    }
  if (verbose)fprintf(stdout, "Identity Matrix Allocated\n");
}

void 
DisplayMatrix ()
{
  int i, j;

  for (i = 0; i < 23; i++)
    {
      for (j = 0; j < 23; j++)
        printf ("%3d", PAM[i][j]);
      putchar ('\n');
    }
}

void 
AlignmentScoreII (int *hi, int *hj, int *scor)

{
  float gapweight;
  int g1, g2, g4, w1, w2, w4;
  int ai, aj, bi, bj, fi, fj;
  int i, j, k, ssj, high, highi, highj, score;


  PMat[0][0] = 0;
  DMat[0][0] = 0;

/*  Want the best alignment of the Query (rows) in the Template (cols) */

/*  Find which is shorter query or template */
/*  This will affect the initialization conditions */

/* The first sequence is always the probe */
  if (rows < cols)
    {
      DMat[1][0] = gap;
      PMat[1][0] = 2;
      for (i = 2; i < rows; i++)
        {
          DMat[i][0] = DMat[i - 1][0] + extend;
          PMat[i][0] = 2;
        }

      DMat[0][1] = 0;
      PMat[0][1] = 4;
      for (j = 2; j < cols; j++)
        {
          /* For Type 2 let all D(0,j)=0 */
          /* DMat[0][j] = DMat[0][j-1] + extend; */
          DMat[0][j] = 0;
          PMat[0][j] = 4;
        }
    }
  else
    {
      /* Penalize all overhangs */

      DMat[1][0] = gap;
      PMat[1][0] = 2;
      for (i = 2; i < rows; i++)
        {
          DMat[i][0] = DMat[i - 1][0] + extend;
          PMat[i][0] = 2;
        }

      DMat[0][1] = gap;
      PMat[0][1] = 4;
      for (j = 2; j < cols; j++)
        {
          DMat[0][j] = DMat[0][j - 1] + extend;
          PMat[0][j] = 4;
        }

    }

  for (i = 1; i < rows; i++)
    {
      for (j = 1; j < cols; j++)
        {

          ai = seq_1[i];
          aj = seq_2[j];
          /*if(verbose)fprintf(stdout, "seq_1[%3d] %2d seq_2[%3d] %2d\n", i, ai, j, aj); */

          g1 = 0;
          /* previously PMat[i-1][j] == 2    */
          /* This fixes the affine path bug! */
          g2 = (PMat[i - 1][j] & 2) ? extend : gap;
          g4 = (PMat[i][j - 1] & 4) ? extend : gap;

          /*
             g2 = (PMat[i-1][j]==2)? extend : gap;
             g4 = (PMat[i][j-1]==4)? extend : gap;  
           */

          w1 = DMat[i - 1][j - 1] + g1 + PAM[ai][aj];
          w2 = DMat[i - 1][j] + g2;
          w4 = DMat[i][j - 1] + g4;


          if (w2 > w4)
            if (w1 > w2)
              {
                DMat[i][j] = w1;
                PMat[i][j] = 1;
              }
            else if (w1 == w2)
              {
                DMat[i][j] = w1;
                PMat[i][j] = 3;
              }
            else if (w1 < w2)
              {
                DMat[i][j] = w2;
                PMat[i][j] = 2;
              }
            else
              fprintf (stderr, "......... Something wrong \n");
          else if (w2 == w4)
            if (w1 > w2)
              {
                DMat[i][j] = w1;
                PMat[i][j] = 1;
              }
            else if (w1 == w2)
              {
                DMat[i][j] = w1;
                PMat[i][j] = 7;
              }
            else if (w1 < w2)
              {
                DMat[i][j] = w2;
                PMat[i][j] = 6;
              }
            else
              fprintf (stderr, "......... Something wrong \n");
          else if (w2 < w4)
            if (w1 > w4)
              {
                DMat[i][j] = w1;
                PMat[i][j] = 1;
              }
            else if (w1 == w4)
              {
                DMat[i][j] = w1;
                PMat[i][j] = 5;
              }
            else if (w1 < w4)
              {
                DMat[i][j] = w4;
                PMat[i][j] = 4;
              }
            else
              fprintf (stderr, "......... Something wrong \n");
          else
            {
              fprintf (stderr, "..........something  wrong \n");
            }

        }
    }


/* This will depend on whether query_len < template_len */
  highi = rows - 1;
  highj = cols - 1;

  if (rows < cols)
    {
      /* Find the highest score along row (rows-1) */
      high = DMat[rows - 1][0];
      highj = 0;
      for (j = 0; j < cols; j++)
        if (DMat[rows - 1][j] > high)
          {
            high = DMat[rows - 1][j];
            highj = j;
          }
      if (verbose) fprintf(stdout,"Rows<Cols - Highest Score at j = %3d with %4d\n", 
         highj, DMat[rows-1][highj]); 
      *scor = DMat[rows - 1][highj];
    }
  else
    {
      /* Find the highest score along col (cols-1) */
      high = DMat[0][cols - 1];
      highi = 0;
      for (i = 0; i < rows; i++)
        if (DMat[i][cols - 1] > high)
          {
            high = DMat[i][cols - 1];
            highi = i;
          }
      if (verbose) fprintf(stdout,"Rows>Cols - Highest Score at i = %3d with %4d\n", 
         highj, DMat[highi][cols-1]); 
      *scor = DMat[highi][cols - 1];
    }

  *hi = highi;
  *hj = highj;

}

int 
MakeTableII (int *highj, int *lowj)
{
  int temp, targ, ip, jp;
  int k = 0, i, j, len, tmp;
  int count, ids = 0;

  if (verbose) fprintf (stdout, "In MakeTableII \n");

  i = rows - 1;
  j = *highj;

  len = 0;

  while (i > 0)
    {
      if (verbose) fprintf(stdout, "i is %d -- j is %d len %d\n", i, j, len);
      tmp = PMat[i][j];
      if (tmp & 1)
        {
          i--;
              if(i==0)break;
          j--;
          len++;
        }
      else if (tmp & 2)
        {
          i--;
          len++;
        }
      else if (tmp & 4)
        {
        j--;
        len++; 
        }
    }

    *lowj = j+1;

    if (verbose) fprintf(stdout, "Alignment length %d,  rows %d,  cols %d\n",
                   len,  rows,  cols);
    
  /* Determine alignment */
  k = len+1;
  i = rows-1;                   
  j = *highj;

  count = 0;
  while (k > 0)
    {
      tmp = PMat[i][j];
      if (tmp & 1)
        {
          ip = seq_1[i];
          jp = seq_2[j];
          if (ip == jp)
            ids++;
          i--;
          j--;
          if (verbose)fprintf(stdout, "%c%c\n", AminoIndex[ip], AminoIndex[jp]);
        }
      else if (tmp & 2)
        {
          ip = seq_1[i];
          jp = 23;
          i--;
          if (verbose)fprintf(stdout, "%c%c\n", AminoIndex[ip], AminoIndex[jp]);
        }
      else if (tmp & 4)
        {
          ip = 23;
          jp = seq_2[j];
          j--;
          if (verbose)fprintf(stdout, "%c%c\n", AminoIndex[ip], AminoIndex[jp]);
        }
    k--;
    }

  return ids;

}

void ChooseMatrix()
{
int i,  j;

      if ( Blosum )
        {
        /*printf("Using Blosum62 .....\n");*/
          for(i=0; i<24; i++){
          for(j=0; j<24; j++){
          PAM[i][j] = blosum62[i][j];
          }
          }
        }
      else if( Identity ) 
        {
        /*printf("Using Identity Matrix.....\n");*/
        IdentityMatrix();
        } 
}


int 
main (argc, argv)
     int argc;
     char *argv[];
{
  double x;
  float sid, coverage, coverage2;
  int ID, kk, k, highi, highj, lowj, good_ones,max_good_ones, len1;
  int i, j, I, J, probe, templat, Nseq, index, score, choose, chosen;
  FILE *fpin;

  ProcessCommandLine (argc, argv);

  /* Open the database of sequences */
  if ((fpin = fopen (database, "r")) == NULL)
    {
      printf ("Cannot get database %s\n", database);
      exit (1);
    }

  /* read the db into memory ! */
  Nseq = read_db (database, fpin);
  if(verbose) fprintf(stdout, "Nseq = %d\n", Nseq);
  fclose (fpin);  
  if(verbose)WriteSequenceEntries();
  
  picked = (int*) malloc(Nseq*sizeof(int));

  /* Compare seqs 1, 2, .. to seq 0 */
  rows = DB[0]->len;
  for(i=0; i<rows; i++) seq_1[i]=DB[0]->seq[i];

  ChooseMatrix();
  if (verbose)DisplayMatrix();

  for(j=1; j<Nseq; j++)
    {
       cols = DB[j]->len;
       for(k=0; k<cols; k++) seq_2[k]=DB[j]->seq[k];
       AllocateMatrices();
       AlignmentScoreII(&highi, &highj, &score);
       ID=MakeTableII(&highj, &lowj);
       sid = (float)ID/(float)DB[0]->len;
       if (verbose) fprintf(stdout, "%s %s %f\n", DB[0]->ident, DB[j]->ident, sid);
       DB[j]->seqid=sid;
       DB[j]->begin=lowj;
       DB[j]->ending=highj;
       FreeMatrices();
    }

  /* Output all suitable seqs from lowj to highj */
  /* --- if the coverage is at least 0.8  of query */
  j=0;
  compteur = 0 ;
  DB[0]->begin=1; 
  DB[0]->ending=DB[0]->len;
  DB[0]->seqid=-1;
  WriteEntries(&j);
  good_ones=0;
  for(j=1; j<Nseq; j++) 
     {
     len1=DB[j]->ending-DB[j]->begin;
     if(len1 < DB[0]->len) 
       { 
        coverage  = (float)len1/(float)DB[0]->len;
        coverage2 = (float) DB[0]->len / (float) len1 ;
       }
     else
       {
        coverage2 = (float)len1/(float)DB[0]->len;
        coverage  = (float) DB[0]->len / (float) len1 ;
       }
     DB[j]->cover =coverage;
     DB[j]->cover2=coverage2;
     if((DB[j]->seqid < thresh) && (DB[j]->cover > mincover) && (DB[j]->seqid > thresh2) && (DB[j]->cover2 < maxcover)) 
             {
             max_good_ones = j ;
             good_ones++;
             }
     }
  if(verbose) fprintf(stdout, "Good Ones %d\n", good_ones);

  if (good_ones  < 1 && compteur < 1) {
     fprintf(stdout, ">DUP") ;
     j = 0 ;
     WriteEntries(&j)        ;
     fprintf(stderr, "Good Ones %d\n", good_ones);  
    exit(99) ;
  }


  if (good_ones <= nhits)
    {
       for(j=1; j<Nseq; j++) 
         {
         if((DB[j]->seqid < thresh) && (DB[j]->cover > mincover) && (DB[j]->seqid > thresh2) && (DB[j]->cover2 < maxcover)) 
         WriteEntries(&j);
         }
    }  
  else if (good_ones > nhits)
    {
      if (top2) {
          choose=1;
          WriteEntries(&choose);
      }
      for(i=0; i<Nseq; i++)picked[i]=0;
      chosen=0;
      while(chosen<nhits)
        {
          x=drand48();
          if (!top2) choose=1 + (int) (x*(max_good_ones+1));
          else choose=2 + (int) (x*(max_good_ones+1));
          /* Make sure you dont choose same one again */
          if(picked[choose]!=1)
            {
         if((DB[choose]->seqid < thresh) && (DB[choose]->cover > mincover) && (DB[choose]->seqid > thresh2) && (DB[choose]->cover2 < maxcover)) 
             {
             WriteEntries(&choose);
             chosen++;
             }
            }
          picked[choose]=1;    
        }
    }

  FreeSequenceEntries(&Nseq);
  free(picked);
  
}





/*---------------------------------------------------------------*/
/*Dr. Mansoor Saqi                      Email mass15599@ggr.co.uk*/
/*Group Leader, Protein Bioinformatics  Phone +44 (0)1438 763231 */
/*Glaxo Medicines Research Centre,                 (Direct Line) */
/*Gunnels Wood Road, Stevenage,                                  */
/*Herts, SG1 2NY, UK.                                            */
/*---------------------------------------------------------------*/
