/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include "Prof.h"
#include "gor.h"

void write_all_gor(void)
{
int i , j , k , consensus ;
char v[7]                 ;

FILE *fp ;

MLLC(name_all_gor, char, MAX_FIC)                     ;
if(check_pred == 1) voix = (struct consen *) malloc( (size_prot[0])*sizeof (struct consen) )  ;

strncpy(name_all_gor    , "" , MAX_FIC)               ;
if(mode == 0) truncate_name(file_seq , name_all_gor)  ;
else          truncate_name(file_clu , name_all_gor)  ;
strcat(name_all_gor, ".all_gor")                      ;

if ((fp=fopen(name_all_gor, "w")) == NULL)
       {
       printf("Unable to open file for all gor decisions ... \n");
       exit(1);
       }

j = 0 ;
for(i=0 ; i < length_query ; i++)
 {
  for(k=0 ; k < 7 ; k++) v[k] = 'x' ;
  if(seq[0][i] == '-' || seq[0][i] == '.') continue ;
  else
   {
         if(gor1[i].info_a > gor1[i].info_b && gor1[i].info_a > gor1[i].info_c) v[0] = 'a' ;
    else if(gor1[i].info_b > gor1[i].info_a && gor1[i].info_b > gor1[i].info_c) v[0] = 'b' ;
    else if(gor1[i].info_c > gor1[i].info_a && gor1[i].info_c > gor1[i].info_b) v[0] = 'c' ;

         if(gor1[i].p_a > gor1[i].p_b && gor1[i].p_a > gor1[i].p_c) v[1] = 'a' ;
    else if(gor1[i].p_b > gor1[i].p_a && gor1[i].p_b > gor1[i].p_c) v[1] = 'b' ;
    else if(gor1[i].p_c > gor1[i].p_a && gor1[i].p_c > gor1[i].p_b) v[1] = 'c' ;


         if(gor3[i].info_a > gor3[i].info_b && gor3[i].info_a > gor3[i].info_c) v[2] = 'a' ;
    else if(gor3[i].info_b > gor3[i].info_a && gor3[i].info_b > gor3[i].info_c) v[2] = 'b' ;
    else if(gor3[i].info_c > gor3[i].info_a && gor3[i].info_c > gor3[i].info_b) v[2] = 'c' ;

         if(gor3[i].p_a > gor3[i].p_b && gor3[i].p_a > gor3[i].p_c) v[3] = 'a' ;
    else if(gor3[i].p_b > gor3[i].p_a && gor3[i].p_b > gor3[i].p_c) v[3] = 'b' ;
    else if(gor3[i].p_c > gor3[i].p_a && gor3[i].p_c > gor3[i].p_b) v[3] = 'c' ;

         if(gor4[i].p_a > gor4[i].p_b && gor4[i].p_a > gor4[i].p_c) v[4] = 'a' ;
    else if(gor4[i].p_b > gor4[i].p_a && gor4[i].p_b > gor4[i].p_c) v[4] = 'b' ;
    else if(gor4[i].p_c > gor4[i].p_a && gor4[i].p_c > gor4[i].p_b) v[4] = 'c' ;

         if(pa_l[i] > pb_l[i] && pa_l[i] > pc_l[i]) v[5] = 'a' ;
    else if(pb_l[i] > pa_l[i] && pb_l[i] > pc_l[i]) v[5] = 'b' ;
    else if(pc_l[i] > pa_l[i] && pc_l[i] > pb_l[i]) v[5] = 'c' ;

         if(pa_q[i] > pb_q[i] && pa_q[i] > pc_q[i]) v[6] = 'a' ;
    else if(pb_q[i] > pa_q[i] && pb_q[i] > pc_q[i]) v[6] = 'b' ;
    else if(pc_q[i] > pa_q[i] && pc_q[i] > pb_q[i]) v[6] = 'c' ;
    if(check_pred == 1)
     {
      voix[j].step1_a = voix[j].step1_b = voix[j].step1_c = 0 ;
      for(k=0 ; k < 7 ; k++)
       {
        if(v[k] == 'a') voix[j].step1_a++ ;
        if(v[k] == 'b') voix[j].step1_b++ ;
        if(v[k] == 'c') voix[j].step1_c++ ;
       }
       j++ ;
     }

    if(v[0] == v[1] && v[1] == v[2] && v[2] == v[3] && v[3] == v[4] && v[4] == v[5] && v[5] == v[6])
     {
      consensus = 1 ;
     }
    else
     {
      consensus = 0 ;
     }
    fprintf(fp, "%c %d %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f\n", 
                  seq[0][i], consensus, gor1[i].info_a, gor1[i].info_b, gor1[i].info_c,
                                        gor1[i].p_a, gor1[i].p_b, gor1[i].p_c,
                                        gor3[i].info_a, gor3[i].info_b, gor3[i].info_c,
                                        gor3[i].p_a, gor3[i].p_b, gor3[i].p_c,
                                        gor4[i].p_a, gor4[i].p_b, gor4[i].p_c,
                                        pa_l[i], pb_l[i], pc_l[i],
                                        pa_q[i], pb_q[i], pc_q[i]) ;
   }
 }

fclose(fp) ;


free(gor1) ;
free(gor3) ;
free(gor4) ;
free(pa_l) ; free(pb_l) ; free(pc_l) ;
free(pa_q) ; free(pb_q) ; free(pc_q) ;

return ;
}
