/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include "Prof.h"
#include "All_net.h"


void write_step2(void)
{
int i , k ;
char v[8] ;
FILE *fp  ;

MLLC(name_step2, char, MAX_FIC)                    ;
strncpy(name_step2,"", MAX_FIC)                    ;
if(mode == 0) truncate_name(file_seq , name_step2) ;
else          truncate_name(file_clu , name_step2) ;
strcat(name_step2, ".all_step2")                   ;

if ((fp=fopen(name_step2, "w")) == NULL)
       {
       printf("Unable to open file for writing in function write_step2 ... \n") ;
       exit(1);
       }

for(i = 0 ; i < size_prot[0] ; i++)
 {
  fprintf(fp, "%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f\n",
             step2[i].nngorb_a  , step2[i].nngorb_b  , step2[i].nngorb_c  , 
             step2[i].nngoru_a  , step2[i].nngoru_b  , step2[i].nngoru_c  ,
             step2[i].nn_profb_a, step2[i].nn_profb_b, step2[i].nn_profb_c, 
             step2[i].nn_profu_a, step2[i].nn_profu_b, step2[i].nn_profu_c,
             step2[i].nn_phdb_a , step2[i].nn_phdb_b , step2[i].nn_phdb_c , 
             step2[i].nn_phdu_a , step2[i].nn_phdu_b , step2[i].nn_phdu_c ,
             step2[i].nn_psib_a , step2[i].nn_psib_b , step2[i].nn_psib_c ,
             step2[i].nn_psiu_a , step2[i].nn_psiu_b , step2[i].nn_psiu_c  ) ;
 }

fclose(fp) ;

if(check_pred == 1)
 {
  for(i = 0 ; i < size_prot[0] ; i++)
   {
    voix[i].step2_a = voix[i].step2_b = voix[i].step2_c = 0 ;
    v[0] = vote(step2[i].nngorb_a  , step2[i].nngorb_b  , step2[i].nngorb_c)    ;
    v[1] = vote(step2[i].nngoru_a  , step2[i].nngoru_b  , step2[i].nngoru_c)    ;
    v[2] = vote(step2[i].nn_profb_a, step2[i].nn_profb_b, step2[i].nn_profb_c)  ;
    v[3] = vote(step2[i].nn_profu_a, step2[i].nn_profu_b, step2[i].nn_profu_c)  ;
    v[4] = vote(step2[i].nn_phdb_a , step2[i].nn_phdb_b , step2[i].nn_phdb_c)   ;
    v[5] = vote(step2[i].nn_phdu_a , step2[i].nn_phdu_b , step2[i].nn_phdu_c)   ;
    v[6] = vote(step2[i].nn_psib_a , step2[i].nn_psib_b , step2[i].nn_psib_c)   ;
    v[7] = vote(step2[i].nn_psiu_a , step2[i].nn_psiu_b , step2[i].nn_psiu_c)   ;
    for(k=0 ; k < 8 ; k++)
     {
      if(v[k] == 'a') voix[i].step2_a++ ;
      if(v[k] == 'b') voix[i].step2_b++ ;
      if(v[k] == 'c') voix[i].step2_c++ ;
     }
   }
 }


free(step2) ;

return ;
}
