/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  net_phd.c
  --------------------------------------------------------
  generated at Fri Jun 25 17:47:14 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[307];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, 
Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, 
Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, 

Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, 
Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, 
Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, 

Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, 
Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, 
Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, 


  };

  /* Weigths definition section */
  static float Weights[] =  {
-0.229580, -0.296930, -0.065020, -0.124350, 0.014900, 0.804970, -0.197520, -0.363420, 0.167330, -0.674320, 
-0.002660, -0.013820, 0.214260, -0.198440, -0.490780, 0.100840, 0.032030, -0.453790, -0.470060, -0.011010, 
0.486410, -0.379690, 0.016610, -0.266400, 0.010790, -0.039890, 0.260150, -0.263620, -0.156380, -0.108120, 
-0.346160, 0.102860, -0.147160, 0.312810, -0.335740, -0.404000, -0.169610, 0.008750, -0.002540, -0.250220, 
0.131480, 0.252340, -0.630880, -0.158260, -0.360860, -0.071110, 0.107760, 0.568530, -0.105780, 0.011860, 
-0.096260, -0.015300, 0.094020, -0.168170, 0.091270, -0.462530, -0.582910, 0.175610, -0.166900, 0.344970, 
-0.440210, 0.038430, 0.055980, -0.771020, -0.129860, -0.091830, -0.352590, 0.204250, 0.558790, 0.135170, 
-0.183710, -0.425750, -0.044950, -0.087890, -0.174030, 0.057380, -0.417460, -0.641870, 0.554160, 0.438010, 
0.462300, -0.464810, -0.294220, -0.129470, -0.667610, -0.291680, 0.150230, 0.074030, 0.209040, 0.479400, 
-0.236940, -0.318330, -0.593290, -0.391920, 0.050260, -0.212350, 0.420020, -0.427550, -0.372920, 0.542120, 
0.475190, 0.258910, -0.210620, -0.508040, -0.218630, 0.002670, -0.364270, 0.553760, 0.664930, -0.382070, 
0.313270, -0.193880, -0.417200, -0.604410, -0.643380, -0.156640, -0.383220, 0.818150, -0.174050, -0.378710, 
0.391970, 0.394070, -0.476310, -0.174270, -0.143030, -0.452470, -0.016330, -0.257140, 0.299720, 0.441820, 
-0.134330, -0.009340, -0.131560, -0.134390, -0.124770, -0.477920, 0.090690, -0.943420, 0.805340, 0.237630, 
-0.302440, -0.397880, -0.426230, -0.118990, -0.165410, -0.037310, 0.005630, 0.546960, 0.023820, -0.226120, 
0.522940, 0.317070, -0.420820, -0.339990, 0.724240, -0.384830, 0.148300, 0.523460, -0.837340, -1.312290, 
0.161350, -0.334160, -0.513380, -0.320320, 0.274180, 0.213690, -0.255990, -0.270220, 0.530340, 0.054340, 
-0.274330, 0.017200, 0.120100, -0.917280, -0.590010, 0.405420, 0.042930, 0.319230, 0.447620, -0.491010, 
-2.006500, 0.654790, 0.056690, -0.016300, -0.117600, 0.381900, -0.028650, -0.213880, -0.192410, 0.669070, 
-0.002940, -0.235690, 0.597720, -0.090360, -0.348860, -0.204910, -0.634850, 0.460920, -0.398500, 0.223710, 
-0.127310, -1.665290, 0.884570, 0.423800, -0.143330, -0.126200, -0.709940, 0.025240, -0.132020, -0.187900, 
0.421060, -0.283220, -0.601720, 0.388640, -0.209870, -0.075550, 0.272360, -0.138960, -0.035800, 0.058200, 
0.473360, -0.299850, -1.438500, 0.319440, 0.234880, -0.365680, -0.043860, -0.327550, 0.037710, 0.135540, 
-0.349010, 0.519740, -0.375820, -0.659910, -0.109130, -0.085710, -0.304030, 0.000750, 0.566400, -0.179980, 
1.081450, 0.669260, -0.578420, -1.303480, 0.222130, -0.129650, -0.370200, -0.562430, -0.079810, 0.287640, 
0.090860, -0.454160, 0.412660, -0.116660, -0.532060, 0.309970, 0.063920, -0.097290, -0.085050, 0.199390, 
0.081690, 0.202810, 0.445230, -0.190450, -1.108930, 0.253670, -0.102890, -0.139290, -0.354760, 0.036150, 
-0.192680, -0.162700, -0.659580, 
0.602350, 0.044920, -0.763280, -0.154910, 0.003750, -0.513450, -0.354080, 0.411250, 0.093470, 0.138160, 
-0.284870, -0.149670, -0.381620, 0.526610, -0.381690, 0.180590, -0.168300, -0.394740, 0.246140, 0.207210, 
-0.525570, 0.464710, 0.284100, -1.041860, 0.534770, 0.086150, -0.861540, -0.448960, 0.043450, 0.337270, 
1.004500, -0.044470, -0.311570, -0.376940, -0.326110, -0.190800, -0.032080, -0.775050, -0.479440, 0.028810, 
0.522400, 0.016120, 0.490790, -0.057170, 0.272260, 0.601880, -0.480400, -1.513330, -0.036280, 0.017360, 
0.289220, 0.622740, -0.200700, 0.096470, -0.579330, 0.127640, 0.152060, -0.119780, -0.655150, -0.836400, 
0.027160, 0.098150, 0.060370, 0.874000, -0.488530, -0.221030, 0.506570, 0.113780, -1.242340, -0.051170, 
-0.532650, 0.735160, -0.151980, -0.301590, 0.129410, -0.172560, 0.179240, 0.238780, 0.583260, -0.035980, 
-1.101500, -0.609780, -0.065260, 0.068000, 0.036070, -0.323730, -0.125110, 0.743910, 0.179810, -0.803300, 
-0.100670, -1.380140, 0.731360, -0.163170, -0.108260, 0.390900, 0.452170, 0.088950, -0.204260, 0.407200, 
-0.055740, -0.954340, -0.794840, 0.168650, 0.193760, -0.080070, -0.512830, 0.758660, 0.342360, 0.152130, 
1.541740, -0.102520, -1.685070, 0.637920, -1.210200, -0.447220, 0.769240, 0.528230, 0.052190, -1.044390, 
0.521230, -0.261890, -1.310270, -0.773180, -0.525340, 1.079690, -0.218300, -0.163480, 0.169330, -0.316820, 
0.103650, 0.899920, -0.135840, -0.837440, 0.120390, 0.379590, -0.127550, 0.735850, 0.776350, -0.014040, 
-0.478210, -0.096310, -0.760880, -0.049440, -0.732740, -0.873970, -0.006910, -1.677970, -0.713460, 0.674070, 
-0.717690, 0.079540, 0.512240, -0.339090, -0.707290, 0.285790, 0.070200, -0.484840, 0.728170, 1.254830, 
-0.371710, 0.227880, 0.515170, 0.222140, -0.899650, -0.627040, -0.876290, 1.233920, -0.474220, -0.474460, 
-0.329230, -0.283010, -0.187800, -0.942930, -0.247320, -0.313350, 0.011580, 0.770300, -0.101120, 0.143010, 
0.710630, 0.026710, -0.316500, 0.167720, -0.230550, 0.102710, 0.075360, -0.062010, 0.340120, 0.060330, 
-0.019850, -0.431070, 0.183720, -0.460990, -0.614990, -0.296270, 0.154080, 0.142760, -0.371080, -0.436250, 
0.017320, 0.619680, -0.628470, 0.024890, 0.274320, -0.049910, 0.200320, -0.459540, 0.562810, -0.076810, 
-0.434640, 0.211330, 0.134520, 1.292760, -0.194930, -0.274350, -0.112620, 0.327420, -0.192860, -0.424500, 
0.029940, -0.926420, -0.049780, 0.103590, -0.732480, 0.104120, -0.373260, -0.000080, -0.191490, 0.146980, 
-0.032920, -0.378450, -0.144840, -0.217110, 0.637190, 0.168040, 0.270660, -0.088880, 0.595660, -1.376910, 
0.004610, 0.060250, -0.915590, -0.161250, 0.124960, 0.030610, -0.278990, -0.017950, 0.335210, -0.248930, 
0.232300, -0.212530, -0.633400, -0.367340, -0.722260, 0.389550, 0.704340, 0.169770, 0.215650, 0.628440, 
-1.198810, 0.575940, -0.020270, -0.216020, -0.295560, -0.108940, 0.285680, -0.092200, -0.486310, 0.121550, 
-0.421290, -0.016350, -0.118000, 
-0.063750, -0.051140, -0.089970, -0.124580, -0.020180, -0.126230, -0.038340, -0.013530, -0.142390, -0.086560, 
0.028020, -0.051110, -0.121650, -0.112480, -0.093000, -0.136460, -0.068490, -0.058110, 0.020210, 0.027480, 
0.001710, 0.015150, -0.074330, -0.099960, -0.151210, -0.092290, -0.056630, -0.057230, -0.014680, -0.149290, 
-0.054960, 0.002330, -0.038440, -0.091460, -0.079890, -0.093170, -0.134340, -0.008170, -0.034100, -0.020040, 
-0.019620, -0.003180, 0.021310, -0.003130, -0.073990, -0.071830, -0.097040, -0.040320, -0.056800, -0.082750, 
-0.199760, -0.029190, 0.009790, -0.110420, -0.105880, -0.108470, -0.119220, -0.080210, -0.026000, -0.068780, 
-0.036310, -0.020180, -0.029660, -0.029540, 0.018300, -0.080660, -0.138590, -0.053370, -0.078600, -0.046700, 
-0.054370, -0.211600, 0.019150, 0.013120, -0.025550, -0.084650, -0.096260, -0.130840, -0.103850, -0.020380, 
-0.153330, 0.043810, -0.020180, -0.062650, 0.002670, -0.046770, -0.008850, -0.074170, -0.048850, -0.092850, 
-0.047900, -0.079180, -0.162560, -0.038520, 0.041790, -0.088140, -0.058550, -0.093460, -0.060120, -0.045660, 
-0.141280, -0.089610, 0.036040, -0.101990, -0.107250, 0.005010, -0.040560, 0.087090, 0.089220, -0.136220, 
-0.095020, -0.057990, -0.148250, -0.113000, -0.127120, 0.016100, -0.056850, -0.048460, -0.009000, 0.006470, 
-0.046940, -0.142900, -0.240880, 0.064880, -0.078100, -0.195570, 0.061870, 0.005290, -0.045470, 0.010170, 
-0.033970, -0.114050, -0.081600, -0.038880, -0.114970, -0.080860, 0.001620, -0.145390, -0.086170, 0.011380, 
-0.095670, -0.171850, -0.232010, -0.187480, 0.071710, -0.003500, -0.008110, 0.135890, 0.054290, -0.023540, 
0.052840, 0.007720, -0.081360, -0.067920, -0.010990, -0.106820, 0.034140, 0.133080, -0.119330, -0.526940, 
0.073420, -0.077350, -0.160400, -0.190310, -0.173460, 0.014390, -0.048990, -0.186290, 0.097010, 0.022570, 
-0.067450, -0.096400, 0.042650, -0.145980, -0.043700, -0.055920, -0.023470, 0.024040, 0.104720, -0.079260, 
-0.357850, 0.086520, -0.058910, -0.175100, -0.149760, -0.184650, -0.039450, -0.049570, -0.113980, 0.096410, 
-0.029060, -0.156640, -0.152230, 0.012340, -0.091230, -0.050140, 0.005440, -0.020910, 0.022190, 0.114550, 
-0.131230, -0.282390, 0.137080, -0.033280, -0.231230, -0.210060, -0.154760, -0.017600, -0.090280, -0.038550, 
0.038570, -0.139690, -0.215760, -0.105520, 0.044960, -0.103540, 0.009250, 0.002470, -0.019840, 0.142120, 
0.028730, -0.087160, -0.195980, -0.007200, -0.079190, -0.239710, -0.128700, -0.095620, -0.062850, -0.071380, 
-0.000100, 0.076120, -0.150300, -0.132690, -0.067430, -0.011690, -0.119140, -0.062670, 0.007730, -0.011480, 
0.056070, 0.011580, -0.128200, -0.121600, 0.023210, -0.072170, -0.154010, -0.189340, -0.147490, -0.003850, 
-0.055310, -0.012640, 0.066690, -0.039660, -0.127450, -0.045050, -0.036270, -0.128200, -0.114900, -0.059410, 
-0.007320, -0.032370, 0.056010, -0.099510, -0.100520, -0.040380, -0.093500, -0.146590, -0.119410, -0.096630, 
-0.033280, -0.066070, -0.048950, 
-0.325170, -0.213170, -0.219760, -0.237560, 0.254340, 0.332780, -0.315510, -0.004500, -0.894190, 0.046340, 
0.296100, -0.096580, -0.222940, -0.175040, -0.193190, 0.028270, -0.153410, 0.218550, 0.186860, -0.069650, 
-0.518370, 0.313420, -0.144900, -0.751270, -0.763190, 0.428570, 0.878130, 0.105780, -0.083480, -1.082060, 
0.189280, 0.149830, -0.189630, -0.617930, -0.294140, -0.744790, 0.162260, 0.355830, 0.289920, 0.018940, 
-0.015940, -0.518630, 0.321610, -0.209200, -1.362390, -1.236530, 0.465350, 0.674680, -0.414070, 0.475250, 
-0.975280, 0.865760, 0.328930, -0.324730, -0.295710, -0.418680, -1.007560, 0.377770, -0.060200, 0.694180, 
0.366040, 0.010990, -0.558040, -0.068280, -0.118740, -0.425480, -0.596480, 0.075630, 0.483000, -0.218370, 
-0.162530, -0.594260, 0.449880, 0.094840, 0.497770, -0.238730, -0.584200, -0.484960, 0.345160, 0.116270, 
-0.193350, -0.034130, -0.210750, -0.421930, 0.229820, -0.676410, 0.132970, 0.167700, -0.262590, 0.481230, 
-0.215580, -0.326980, -0.326120, 0.276320, 0.217970, 0.129630, -0.281850, -0.320690, -0.427490, 0.139490, 
-0.116920, -0.209920, -0.394180, -0.308190, -0.178840, 0.776440, -0.435550, -0.513650, -0.356850, 0.030230, 
-0.362700, 0.031160, 0.237940, -1.128870, 0.985510, 0.529310, -0.156750, -0.206930, -0.534780, -0.974980, 
-0.239630, -0.080260, 0.872050, 0.025730, -0.546140, -0.224090, 0.482990, -0.277450, -0.771700, 0.102080, 
0.016360, -0.252460, -0.468430, -0.076490, -0.602680, 0.943650, 0.531630, -0.614460, -0.562090, -0.022530, 
-0.571410, -0.175470, 0.199680, 0.538370, -0.259580, -0.468500, -0.000710, 0.747760, -0.410980, -0.599440, 
0.444730, -0.533410, -0.171120, -0.246890, -0.044090, -0.132380, 0.818490, 0.046750, -0.417410, -1.001610, 
0.653140, 0.528100, 0.078450, -0.306440, -0.537990, -0.203030, -0.733640, -0.310240, 0.758230, -0.134260, 
-0.803010, 0.284720, -0.737050, -0.368270, -0.193560, 0.122270, -0.535150, 0.938230, 0.124470, -0.676520, 
-1.327660, 0.656820, 0.271860, -0.249530, -0.212910, 0.061340, 0.123020, -0.190990, -0.220490, 1.072590, 
0.157430, -1.461450, -0.398160, -0.136820, -0.398890, -0.256910, 0.484940, -0.440410, 1.463960, 0.865550, 
-0.996920, -1.394490, 0.265740, -0.245130, -0.357210, -0.494380, 0.062910, 0.250190, -0.046630, -0.283060, 
0.798490, -0.188980, -0.826960, -0.090030, -0.863760, -0.005370, 0.055300, 0.126150, -0.326790, 1.324350, 
0.563800, -0.502070, -1.291980, 0.444460, -0.220600, -0.171600, -0.570830, -0.124060, 0.195390, -0.220060, 
-0.362010, 0.832710, -0.381300, -0.584630, 0.056860, -0.689370, 0.068930, -0.099670, 0.008050, -0.079570, 
0.783940, 0.313530, -0.506040, -0.987220, 0.632570, 0.316370, -0.556080, -0.247290, -0.318540, -0.052130, 
-0.400000, -0.389230, 0.538130, -0.313620, -0.771580, -0.139080, 0.028870, -0.247650, -0.116500, 0.687770, 
-0.084520, 0.928950, -0.036550, -0.386020, -0.704350, 0.214610, 0.097590, -0.849510, -0.039430, -0.331420, 
-0.156510, 0.034010, -0.624860, 
-0.370200, 0.151200, 0.782590, 0.196080, 0.188820, 0.609090, -0.260620, -0.251190, 0.719370, -0.665620, 
-0.218660, 0.439360, -0.036130, 0.484580, 0.160830, 0.466130, -0.336010, 0.187040, -0.128660, -0.156900, 
0.717240, -0.334890, 0.563770, -0.165080, -0.282990, 0.817210, 0.651280, 0.337050, 0.237350, -0.796030, 
0.608540, -0.297720, -0.299010, 0.635870, -0.904610, -0.233400, 0.094010, 0.406030, 0.934400, 0.128220, 
0.494770, 0.097160, -0.617410, 0.945400, -0.519890, -1.210110, 0.937360, 1.164230, 0.092070, 0.227280, 
-0.122360, 0.532390, 0.064940, -0.421760, 0.268560, -0.382990, -0.031680, -0.024960, 0.372650, 0.529190, 
-0.042270, 0.477510, 0.426350, -0.591630, 0.010140, 0.706980, 0.746280, -0.606910, 1.614350, -0.018380, 
-0.700040, 1.003420, -1.106580, -0.809300, 0.958610, 0.804770, 0.524420, 0.664920, 0.333170, -0.176700, 
-0.356520, -0.463390, -0.357940, 0.496920, -0.680690, -0.300630, 0.654900, -0.011710, 0.284040, 1.772600, 
0.906660, -0.283500, -0.089670, -0.631770, -0.425440, 1.430570, 0.621800, -0.529400, -0.409350, 0.576810, 
0.194470, 0.131250, -0.899790, -0.133010, 0.557550, -0.929950, 2.378170, -0.778120, -1.906910, 1.597590, 
1.101870, 0.111630, 1.606840, -1.524430, 1.197410, 0.590740, -0.816420, 0.520490, -1.665100, -1.379740, 
-0.310810, 0.422650, 1.438670, 0.432620, 0.079850, 0.465660, -1.021860, 0.736740, -0.047010, -0.609480, 
0.026840, 1.844640, -0.201240, -0.139870, -0.365530, -0.053840, -0.661690, 0.355780, 2.065450, -0.356660, 
0.200230, 0.362140, 0.678510, 0.135570, -0.049610, -0.218150, -0.004050, -0.973020, -1.234210, 2.838930, 
1.201780, -1.586300, 2.026690, -0.102030, -1.625370, 1.077530, -1.861090, -1.307330, 1.129450, 3.937450, 
-0.339980, 0.066690, 1.678160, 0.441670, -1.481710, -1.089080, -0.948870, 0.800580, -0.521900, 0.607080, 
0.714880, -0.403600, 0.425560, 0.117260, 0.772820, 0.134570, -1.053300, -0.108200, 0.295170, -0.003910, 
0.958700, -0.679240, -0.593590, 0.273400, 0.437650, 0.381270, -0.255890, 0.283400, 0.874670, -0.509380, 
1.363870, -0.514160, -1.789880, 1.048850, 0.042210, -0.222470, 1.090540, -1.058830, 1.416880, 0.534130, 
-0.714920, 1.453160, -0.992900, -1.473200, -0.421540, 0.005820, 1.234680, 0.799900, 0.359620, 1.053660, 
-0.401640, 0.020640, 0.530620, 0.402150, -0.272050, 0.642270, 0.025830, -0.391560, 0.080880, -0.425370, 
-0.516610, 0.275710, 1.333180, 0.395660, -0.120480, 0.400750, 1.057250, 0.225520, -0.169480, -0.677400, 
0.225310, -0.088770, -0.140490, 0.763040, 1.262240, -0.229760, 0.059470, 0.145440, -0.721210, 0.335860, 
-0.897920, -0.778020, 0.564540, 0.393500, 1.131360, 0.272380, 0.331610, 0.793000, -0.304780, -0.053010, 
-0.253010, 0.076430, 0.545140, 0.637880, -0.315060, -0.615660, 0.169850, 0.303280, 0.392330, 0.371000, 
-0.402050, 0.489480, 0.215650, -0.189640, 0.365030, -0.345920, -0.520840, 0.115930, 0.529390, 0.016580, 
0.060850, 0.786320, 0.080360, 
0.388380, -0.286560, -0.940860, 0.279670, -0.226020, 0.119650, -0.757860, -0.104590, 0.413240, 0.180900, 
-0.195590, -0.243310, 0.058580, -0.162630, -0.341820, 0.223370, 0.001190, 0.198840, -0.006210, -0.079980, 
-0.458180, 0.726600, 0.018280, -0.448670, -0.448630, -0.170830, -0.724690, -0.470720, 0.719660, 0.049400, 
-0.081610, 0.024920, -0.258070, -0.491230, -1.040050, -0.177420, 0.078050, -0.109890, 0.164330, 0.506550, 
0.003300, 0.134820, 0.651530, -0.124370, -0.013500, 0.416260, -0.058950, -0.962110, -0.146830, 0.441430, 
-0.190020, 0.591340, -0.548870, -0.135500, -0.365250, -0.824530, -0.390520, -0.061830, -0.421330, -0.035670, 
0.013530, 0.001370, 0.162000, 0.229260, -0.235350, 0.010580, 0.340750, -0.083530, -0.716490, -0.169870, 
-0.024540, 0.312950, 0.007100, -0.141350, -0.314950, -0.246020, -0.158430, 0.091220, -0.270880, -0.349110, 
0.192080, -0.705470, 0.015140, 0.258230, 0.564800, -0.636270, 0.564710, 0.286090, -0.272390, 0.076530, 
-0.038560, -0.424250, 0.310000, -1.034610, -0.064790, 0.103450, -0.608290, 0.335670, -0.433420, 0.188850, 
0.278740, -0.490090, -0.610390, -0.366670, 0.319890, 0.456850, -0.087620, -0.380320, 0.266700, -0.122190, 
-0.121710, -0.147640, -1.032320, 0.069360, 0.035140, -0.105180, 0.069330, -0.281200, 0.043260, -0.703760, 
0.128010, -0.042710, -0.474160, -0.625690, 0.075080, 1.028000, -0.854460, -0.565390, 1.207410, -0.083450, 
-0.623290, 1.187060, 0.240890, -1.375040, 0.516680, -1.723060, -0.086630, 1.080610, 0.708490, -0.247650, 
0.018540, 0.852560, 0.014200, -0.564700, -0.920130, -0.764860, 0.008710, -0.135380, -0.858550, -0.335710, 
0.271470, 0.002870, -0.204660, -0.283740, -0.020760, 0.147370, 0.016970, -0.713790, -0.517590, 1.029990, 
-0.104350, -0.290550, 0.161630, -0.790960, 0.248400, -0.221990, -0.345010, 1.024300, -0.696250, -0.483150, 
-0.193770, 0.301970, -0.172400, -0.369810, -0.540220, 0.139510, 0.079410, -0.478440, -0.376710, -0.028390, 
0.735680, -0.096770, -0.131160, 0.699050, 0.078880, 0.158690, -0.539300, -0.481330, 0.411060, -0.021080, 
0.105740, -0.348700, 0.802950, 0.293360, -1.837840, 0.026900, 0.109090, -0.166850, 0.283500, -0.015490, 
-0.429820, 0.318450, -0.479920, -0.442930, -0.588660, 0.158060, 0.222830, 0.173170, -0.123310, -0.031610, 
-0.228590, 0.437070, -1.526650, -0.187750, 0.291340, -1.102170, 0.021540, 1.321830, -0.753670, 0.983090, 
0.200270, -0.773120, -0.718170, -0.268260, 0.520340, -0.388450, 0.215030, 0.417670, 0.048760, -0.077910, 
-0.392060, -1.111550, -0.012910, 0.149170, 0.155890, -0.296890, 0.184870, -0.005710, 0.896130, -0.574460, 
0.296820, 0.904860, -0.474730, -0.641540, -0.150480, 0.376580, 0.561580, -0.117360, -0.566630, -0.451400, 
-0.456920, -0.680160, -1.021080, 0.445920, 0.696300, -0.060810, -0.000060, 0.199930, 0.066830, 0.426800, 
-1.204070, 0.135690, 0.009980, -0.379690, 0.072510, -0.092310, 0.030220, 0.136550, -0.007750, 0.099160, 
-0.188550, -0.634810, -0.708760, 
-0.128810, -0.037630, -0.112090, -0.292100, -0.055060, -0.271730, -0.000410, 0.062090, -0.009420, 0.040350, 
-0.066900, -0.027560, -0.101200, -0.132060, 0.050620, -0.168220, -0.120560, -0.033410, 0.018680, 0.076260, 
0.031780, -0.107870, -0.125880, -0.054870, -0.288160, -0.131010, -0.141520, -0.065450, -0.008840, 0.001310, 
-0.038270, -0.094030, 0.016120, 0.024370, -0.000210, 0.009310, -0.189780, 0.051060, -0.025340, -0.112460, 
0.032580, 0.013370, -0.088700, -0.038900, -0.145950, -0.080150, -0.178560, -0.014860, -0.069030, -0.127930, 
-0.213530, -0.070930, -0.042310, 0.016390, -0.046710, -0.091510, -0.025810, -0.009170, 0.109670, 0.019080, 
-0.137130, -0.004770, -0.020090, -0.125590, 0.023120, -0.250870, -0.148350, -0.087780, 0.065180, -0.128050, 
-0.077800, -0.159300, 0.076080, -0.055610, 0.052220, -0.117410, -0.138630, -0.283910, -0.017010, 0.062250, 
0.113010, 0.015570, -0.005950, -0.038260, -0.237840, -0.004460, -0.141440, -0.247190, -0.097950, 0.202660, 
0.067740, 0.076790, -0.220160, 0.046110, -0.080380, -0.084260, -0.115760, -0.158560, -0.113620, -0.091110, 
-0.160590, 0.178190, 0.038870, -0.028420, -0.105370, -0.294600, 0.102890, -0.065010, -0.170440, -0.115530, 
0.094830, 0.035690, 0.114590, -0.070620, -0.271550, -0.146820, -0.022120, 0.030410, -0.110720, 0.107760, 
-0.227210, -0.165720, 0.014450, 0.043120, -0.015020, -0.096810, -0.267120, 0.171340, 0.065350, -0.234750, 
-0.130240, 0.006480, -0.024300, 0.161570, -0.092600, -0.411030, -0.263740, -0.094010, 0.150520, -0.101050, 
-0.083340, -0.167410, -0.071100, 0.039090, -0.033720, 0.108660, -0.007670, -0.166530, 0.101100, 0.039380, 
-0.309370, -0.017250, 0.035200, -0.092950, 0.033610, -0.225230, -0.221610, -0.092260, -0.125550, 0.178710, 
-0.228420, -0.239860, -0.259620, 0.055140, 0.312880, -0.066780, 0.089170, -0.058490, -0.158930, 0.103140, 
-0.036110, -0.369450, 0.099890, -0.059510, -0.033830, -0.013240, -0.183070, -0.159630, -0.127120, -0.087670, 
0.254540, -0.246440, -0.189890, -0.160690, 0.075840, 0.157280, -0.074310, 0.014680, -0.046730, -0.254150, 
0.012860, 0.017340, -0.194420, -0.010960, -0.014710, -0.015090, 0.003350, -0.137530, -0.295060, -0.116580, 
-0.016140, 0.037740, -0.021120, -0.158080, -0.015070, -0.063980, 0.018740, 0.013120, -0.071190, 0.037470, 
-0.169870, -0.144140, -0.045620, -0.070330, 0.132410, -0.026670, -0.028250, -0.110340, -0.058310, -0.130810, 
-0.188310, 0.021600, -0.087340, -0.092680, -0.125000, -0.082990, 0.065780, 0.060850, -0.090850, -0.091540, 
0.011680, -0.127000, -0.079580, -0.023430, -0.071340, 0.139880, -0.062200, -0.098060, -0.017260, -0.113990, 
-0.056690, -0.159740, -0.143120, -0.009070, -0.120920, -0.142950, -0.032850, 0.069440, -0.031210, 0.009550, 
-0.078870, -0.069860, -0.110880, -0.048420, 0.091330, -0.139810, 0.100130, 0.105410, -0.115860, -0.127660, 
-0.009440, -0.132530, -0.048370, -0.064790, -0.055260, -0.233200, -0.134650, -0.032170, 0.027180, -0.037020, 
-0.077950, -0.033660, -0.136160, 
0.233980, -0.243670, 0.051910, 0.556240, -0.362190, -0.421910, -0.361230, -0.129460, -0.336510, 0.186130, 
0.005350, -0.040120, -0.190110, -0.172130, -0.340710, -0.084890, 0.050410, -0.393930, -0.116680, -0.039220, 
-0.243660, 0.275410, -0.242690, -0.662500, -0.422720, 0.089220, -0.739300, 0.200000, 0.311510, -0.754810, 
1.055020, 0.131450, -0.568600, -0.326460, -0.501980, -0.041970, -0.452830, 0.192950, -0.194890, 0.174320, 
0.291460, -0.223310, 0.306910, -0.552780, 0.329550, 0.563810, -0.475310, -0.927500, -0.262190, -0.110760, 
0.710420, -0.443940, 0.127880, 0.167990, -0.284530, 0.694120, 0.420830, -0.461350, -0.420610, -0.817800, 
0.066910, -0.599000, -0.409730, 0.740490, -1.410430, 0.646460, 1.457250, -1.412570, -1.422930, -0.259080, 
-0.518000, 0.616030, -0.877190, -0.161460, 0.190470, -0.345520, 0.769880, 0.855950, 0.177710, -0.321760, 
-0.542800, -0.192730, -0.256320, -0.112850, 0.770190, 0.246220, -0.388870, -0.447380, 0.394830, -1.835580, 
0.195020, 0.857510, -1.060490, 0.730000, 0.618680, -0.525850, -0.965690, -0.683150, -0.750610, -0.258760, 
-0.015040, 0.056300, 0.365930, 0.195460, 0.039440, 0.597960, 0.631550, -1.393080, -0.658370, 0.609170, 
-1.794200, -0.709830, 1.004670, -0.235710, 0.993330, 0.843700, -1.032330, -0.475610, -0.053270, -0.012570, 
-0.927320, -0.602240, 0.432390, 1.023620, 0.071230, -0.727810, 0.778510, -1.963580, 1.048980, 1.773060, 
-1.776760, -1.117290, -0.759560, -1.077500, 1.612780, -1.130120, -0.707960, 0.688990, -0.187570, 1.228650, 
1.123900, 0.434590, -1.006230, -1.095290, -0.088690, -0.198090, 0.004530, 0.912330, -1.254940, 0.443880, 
1.491460, -0.805520, -1.610830, 0.338530, -0.841830, 0.854400, -0.722830, 0.242530, 0.195610, -1.575310, 
0.877020, 0.261110, 0.338920, -0.250090, -0.655770, -0.508770, 0.233750, -0.462800, 0.652850, 0.819140, 
-2.393000, -1.076370, 1.201930, -0.621340, 0.123450, 1.199950, -1.122430, 1.423190, 1.484300, -0.895570, 
-2.798140, -0.497870, -0.798150, -1.325190, -0.618010, 1.190390, 0.805740, 0.852620, -0.006440, 0.645100, 
-0.161130, -0.993790, -0.027040, 0.221910, -0.129430, -0.346420, 0.444250, 0.597400, 0.572370, 0.183790, 
-0.139270, -1.118900, 0.073610, 0.268920, -0.903280, -0.981900, 0.127010, 0.632030, -0.344720, -1.065270, 
0.449940, -1.053740, 0.568880, 1.587620, -1.069520, -0.092190, 0.099730, -0.962810, 1.221990, -1.439330, 
-0.541100, 0.540640, -0.720730, 1.151950, 1.226980, 0.063790, -0.127780, -1.070920, -0.745460, -0.524430, 
-0.948120, -0.079690, -0.319230, -0.400200, 0.164280, 0.108680, -0.534100, 0.201020, -0.003380, 0.031050, 
0.049730, 0.685990, -0.206380, -1.157470, -0.176540, 0.631600, -0.361900, -0.591140, -0.676230, -0.198610, 
0.485230, -0.084640, -0.006530, 0.344180, -0.851730, -1.074860, 0.407470, -0.325750, -0.146790, 0.684620, 
-0.250780, 1.106080, 0.394460, -0.651760, -0.644840, -0.735680, -0.635980, -0.331860, -0.899080, 0.505980, 
0.405180, 0.029990, 0.270320, 
0.368120, -0.632780, 0.377270, 0.826560, -1.306360, -0.775060, -0.479960, -0.621170, 0.639440, -0.524300, 
0.045550, 0.518130, -0.392360, 1.070140, 0.627200, 0.155440, -0.453230, -0.865580, -0.360330, -0.444840, 
-0.278400, 0.344210, -0.587510, 0.552980, 0.818620, -0.588450, -1.009850, -0.051330, -0.307430, 0.134010, 
-0.151520, 0.175040, 0.045450, -0.436510, 0.052300, -0.035130, -0.151130, -0.274100, -0.380550, -0.381320, 
-0.011420, -0.326310, 0.388290, 0.217330, -0.493360, -0.490160, 0.214820, -1.395230, 0.355020, 0.567200, 
-0.936670, 1.030520, -0.390320, -0.683970, -0.528860, -0.511890, -0.344970, -0.552210, 0.212000, 0.118140, 
0.568280, 0.322810, -0.219340, 0.579210, -0.014830, 0.227690, 0.489040, -0.505320, -1.470120, -0.865900, 
-0.289820, 0.549630, -0.156960, 0.028760, -0.972600, -0.433390, 0.604730, 0.619720, -0.496820, -0.275820, 
-0.218590, 0.532590, -0.054640, -0.388320, 0.777580, -1.986720, 0.914420, 1.853990, -1.550740, -1.200050, 
-0.444250, -1.632380, 1.216620, -1.152480, -0.344440, 0.695530, -0.295800, 1.583220, 1.176060, -0.101940, 
-0.499100, -1.022660, -0.493780, 0.079080, -0.056120, 1.044210, -0.066240, -0.391520, 0.383600, 0.402070, 
-1.950680, -0.026370, 0.474980, -0.112140, 0.495200, 0.686330, -0.810060, -1.617240, -0.032500, -0.063740, 
-0.543790, -0.277890, -0.121990, 0.036000, 0.534130, -0.548510, 0.550490, 0.629850, -2.284540, -0.983210, 
0.978280, -1.420480, -0.332300, 1.196460, -0.421200, 1.164410, 0.936000, -0.766570, -1.880090, -0.029870, 
-0.072000, -1.402350, -0.638740, 0.822810, 0.999610, 0.455900, 0.005680, 0.442270, -1.064330, -0.056450, 
0.940130, -0.840150, -0.434430, -0.393990, -0.797430, 1.256380, -0.614140, -0.684370, 0.515050, -1.212020, 
0.610700, 1.007310, 0.140030, -0.217150, -0.387610, 0.214930, -0.175030, -0.748280, 0.487200, -1.006320, 
0.631500, 1.218920, -1.025910, -0.593640, 0.013650, -1.042030, 1.159490, -1.400330, -0.338090, 0.737590, 
-1.929450, 1.074190, 0.667230, 0.812230, 0.008690, -1.299110, -0.614510, 0.224050, -0.290020, 0.243750, 
0.273700, -0.495960, -0.778520, 0.587550, -0.502810, 0.364140, 0.535640, -0.344520, 0.274780, 0.778120, 
-0.156870, -1.651600, -0.987280, -0.486570, -0.601260, -0.526320, -0.026360, 0.124000, 0.751360, 0.069530, 
-0.232130, -0.125060, -0.344790, -0.860580, 0.148570, 0.102330, -0.329090, 0.427600, 0.120120, 0.393260, 
0.817910, -0.283990, -0.241290, -0.816690, -0.455350, -0.389390, -0.680390, 0.621810, 0.009740, 0.016490, 
-0.396830, -0.169380, -0.687340, 0.390020, 0.776280, -0.469940, -0.146010, -0.469800, -0.679810, 0.640380, 
-1.016130, -0.051320, 0.674310, -0.014500, 0.041190, 0.590810, 0.169300, -0.387690, -0.321710, -0.432710, 
-0.728650, -0.192100, -0.314140, -0.471740, 0.241810, -0.069070, -0.020600, -0.260530, -0.148020, -0.680140, 
0.256400, -0.864680, 0.220890, 0.192580, -0.318800, 0.475560, 0.449330, -0.074800, -0.352460, -0.497170, 
-0.441260, -0.175480, 0.297190, 
-0.062910, 0.011860, -0.054080, -0.198300, 0.067410, -0.129770, -0.068580, 0.068120, -0.172910, -0.029740, 
-0.055880, -0.058300, -0.102230, -0.114570, 0.090650, -0.209350, -0.229760, 0.073770, 0.134730, -0.031210, 
-0.044100, -0.090790, -0.070360, 0.045180, -0.093500, -0.037980, -0.016200, -0.057560, -0.066250, -0.172410, 
-0.187120, 0.015600, -0.020110, -0.004810, 0.065290, 0.012090, -0.112350, -0.109680, -0.087000, -0.016770, 
-0.109910, -0.033770, -0.062370, 0.043490, -0.009410, -0.080020, -0.039370, 0.095140, -0.082960, -0.192900, 
-0.300270, -0.051940, 0.086070, -0.091190, 0.048400, -0.096270, -0.082380, -0.007520, -0.020360, -0.168900, 
-0.033930, -0.031980, -0.108590, -0.023660, 0.127220, -0.028970, -0.211940, -0.037440, 0.228330, -0.061820, 
-0.080680, -0.315930, 0.113590, 0.014320, 0.002950, 0.084700, -0.171090, -0.267410, -0.075000, -0.111280, 
-0.210840, 0.022230, -0.103040, -0.063600, -0.118840, 0.110200, -0.020670, -0.079350, -0.193150, 0.162930, 
-0.008260, -0.117020, -0.127790, -0.063570, -0.052140, 0.020320, 0.163220, -0.112720, -0.140080, -0.002200, 
-0.168970, -0.349200, 0.021110, -0.055100, -0.011790, -0.062930, 0.056790, 0.250410, 0.107950, -0.314010, 
0.057350, 0.029830, -0.361790, -0.077730, -0.250160, -0.119800, 0.240370, 0.309440, -0.037460, -0.019490, 
0.037530, -0.268710, -0.571130, -0.054960, -0.260840, 0.170120, 0.038560, -0.008190, 0.228600, 0.147390, 
-0.129980, 0.020690, -0.013260, -0.403740, -0.109100, -0.234480, -0.095350, 0.202230, 0.406060, -0.006360, 
-0.150060, 0.001890, -0.231700, -0.520520, -0.107550, -0.164460, 0.003240, 0.050640, 0.009640, 0.088700, 
0.082420, -0.129970, 0.290150, -0.081400, -0.336510, -0.126520, -0.058920, -0.080300, 0.066440, 0.127220, 
-0.011870, -0.103900, -0.197630, -0.184770, -0.366090, -0.130100, -0.162900, 0.112720, 0.027830, 0.083000, 
0.018090, -0.089740, -0.072140, 0.002620, -0.007250, -0.153100, -0.097890, -0.069060, -0.033960, 0.008710, 
0.110080, 0.037280, 0.004910, -0.339220, -0.080060, -0.249000, -0.157160, -0.128590, 0.054540, 0.046190, 
0.026800, -0.062540, -0.262840, -0.052660, 0.046020, -0.028160, -0.124830, -0.112970, -0.019860, -0.010130, 
-0.001080, 0.109600, 0.038130, -0.067720, -0.133950, -0.127780, -0.316460, -0.041730, -0.106840, 0.046250, 
0.152450, -0.116400, -0.124850, -0.177220, -0.072030, -0.015320, -0.100470, -0.090500, -0.085900, 0.052550, 
-0.089740, 0.012630, 0.093690, -0.036200, -0.128830, -0.157580, -0.091190, -0.054660, -0.042450, -0.102610, 
0.045300, 0.210090, -0.035990, -0.096290, -0.114630, -0.085100, -0.144530, -0.120060, -0.074120, -0.050230, 
-0.008550, -0.143460, -0.054850, 0.080940, -0.018440, -0.122100, -0.132250, -0.090320, -0.081900, 0.026420, 
-0.162440, 0.061120, 0.235180, -0.125330, 0.036640, -0.120610, -0.077420, -0.231570, -0.099320, -0.008020, 
-0.014120, 0.021010, 0.006960, -0.043570, -0.091920, -0.015480, -0.064250, -0.226620, -0.167470, -0.130720, 
-0.065530, 0.041350, -0.030020, 
-0.451100, 0.199040, 0.405200, -0.156580, -0.345690, 0.641720, 0.406280, -0.640400, 0.700600, -0.740850, 
-0.996080, 0.141370, -0.305420, -0.192560, 0.010610, 0.401100, -0.255400, -0.455940, -0.427760, -0.331760, 
0.081010, -0.869630, 0.127270, 0.138680, -0.161150, -0.299960, 0.334240, -0.144880, 0.010570, 0.201210, 
-0.048530, -0.471910, 0.068620, 0.274020, 0.081680, -0.318400, -0.145160, -0.486610, 0.218260, -0.085330, 
-0.254810, -0.500330, -0.916450, -0.123980, 0.220750, -0.422520, -0.113000, -0.009880, 0.183960, 0.262650, 
0.404660, -0.374360, -0.097900, -0.046020, -0.038790, -0.657820, -0.126750, 0.009940, 0.299390, 0.070330, 
-0.375980, 0.031220, -0.507160, 0.411170, -0.103310, -0.833690, -0.770060, 0.272800, -0.558570, -0.132640, 
0.909020, -0.526630, 0.113950, 0.438530, -1.292710, -0.225820, -0.487990, 0.209550, -0.727360, -0.494000, 
1.204080, 0.400540, 0.563600, -0.710530, -0.212880, -0.366760, -1.237250, 0.685080, 0.049710, -1.179090, 
0.100690, 0.762550, 0.225080, -0.254500, -0.202220, -1.163400, -0.813270, -0.089980, 0.040740, 0.033580, 
0.763400, 0.730100, -0.264480, 0.544030, -0.479510, 0.590850, 0.610010, -2.004990, -0.784660, 1.436100, 
-0.696070, -0.569040, 1.852230, -1.082730, 1.178730, 0.776530, -1.804150, -2.060070, -0.739740, -0.955200, 
-0.587960, -0.469380, 2.002150, 0.640130, 0.866880, -0.547580, -1.026560, 0.018760, -0.055740, 1.289530, 
0.031510, -1.772530, -0.025330, 0.512750, 0.018910, -0.786600, -0.132500, -0.636020, -1.555930, 0.249090, 
-0.049610, 0.417530, 0.484830, 0.437540, 0.285910, -0.023550, -0.004900, 0.113770, 0.624060, 0.217360, 
-1.181280, 0.702650, -0.352790, -0.702490, 0.920460, -1.321860, 0.936540, 0.413290, -0.576720, -0.237190, 
-0.647640, -0.826870, -0.093030, -0.639740, 1.026880, -0.072920, -0.037710, -0.563120, -0.381370, -0.402370, 
0.594120, 0.837810, -1.042840, -0.317820, -0.030090, -0.864610, 0.088490, -0.753260, -0.199390, 0.262930, 
0.359280, -0.081490, -0.107910, 0.371970, 0.313250, -0.228400, -0.226540, 0.081510, -0.553800, 0.089030, 
-0.789950, 0.547040, -0.765100, 0.086350, 0.326240, -0.090600, -0.453870, -0.528130, -0.311710, -0.154600, 
0.302840, 0.287430, -0.365480, -0.442880, 0.463350, -0.065290, -0.157550, -0.164240, -0.096370, -0.029940, 
0.092380, -0.110490, 0.631060, -0.630860, -1.134060, 1.038130, -0.069980, -1.036160, 0.470550, -0.898500, 
-0.281500, 0.678370, -0.066180, -0.398920, -0.340800, 0.534170, 0.267740, -0.666480, 0.013640, -0.460970, 
0.041670, -0.656170, 0.023160, 0.047270, 0.007890, -0.537880, 0.629040, 0.170290, -0.695610, 0.222060, 
-1.148020, -0.379500, 0.456850, -0.327160, -0.321440, -0.180430, 0.180230, 0.536110, -0.088370, -0.223470, 
-0.215470, 0.136830, -0.052850, -0.268870, -0.152880, -0.082100, -0.836070, 0.198580, -0.326110, -0.351230, 
-0.247680, 0.121300, 0.082900, -0.104980, -0.102460, 0.061640, 0.107740, 0.093630, 0.232280, -0.113890, 
0.101640, -0.497620, -0.208610, 
1.083750, -0.003580, -0.220570, -0.230540, 0.730850, -0.562380, 0.010850, 0.594890, -0.093140, -0.036090, 
-0.119500, 0.312870, -0.134200, -0.229090, 0.141980, -0.140830, -0.182120, -0.012430, 0.340510, -0.199730, 
-0.329440, 0.408020, 0.205220, -0.136700, 0.254730, 0.348610, -0.057560, -0.171430, 0.565510, -0.310310, 
0.592670, -0.097430, -0.064870, -0.351800, -0.816840, 0.160620, -0.310690, -0.023740, 0.205140, 0.084370, 
0.127020, 0.079240, 0.716790, 0.140500, 0.470790, 0.269540, 0.227540, -0.666050, 0.261580, 0.418960, 
-0.775770, 0.958080, 0.176450, 0.102670, -0.474580, -0.735270, -0.390000, -0.242290, -0.232090, -0.102150, 
0.222970, 0.314830, 0.045640, 0.571780, 0.253750, 0.176720, 0.217580, 0.393400, -0.513480, 0.302260, 
0.309460, -0.411070, 0.515350, 0.007050, 0.179920, -0.579890, -0.471070, 0.148170, -0.125000, -0.761280, 
-0.219800, 0.329400, 0.513490, -0.164100, 1.430300, 0.078390, 0.461440, 0.592640, 0.494920, -0.682100, 
0.092040, -0.329610, -0.229110, -0.121560, 0.574870, 0.045910, -0.189800, 0.086580, -0.457830, -0.318380, 
-0.936490, -0.163000, 0.038320, 0.361940, -0.167450, 1.085730, 0.088750, 1.723570, 1.121290, 0.091950, 
0.083760, -0.224040, -1.372640, 0.419360, -0.436160, -0.095340, 0.680190, 0.185920, -0.100070, -0.970350, 
1.233060, -0.773820, -1.335100, -0.342810, -0.333130, -0.054430, 1.434920, -0.221410, 1.098040, 1.234060, 
0.359700, 0.262430, 0.529290, -0.785070, -0.386590, -0.419700, 0.241220, 0.896360, -1.151680, -0.128710, 
-0.741260, 0.563370, -0.287290, -1.059510, -0.234930, -0.531100, -0.003440, -0.161230, -0.399200, 1.621710, 
1.635340, 0.638860, 0.441390, 0.064840, -0.879950, -0.146250, 0.045410, -0.150270, 0.500940, -0.969580, 
0.178220, 0.060100, 0.493920, -0.356360, -1.564920, -0.155540, -0.053000, -0.156970, -0.271920, 0.065900, 
0.055610, 0.180870, 1.309150, 0.005170, -0.323130, -0.589080, -0.379930, 1.448210, 0.865290, 0.181540, 
-0.351310, 0.803620, -0.315140, -0.391240, -0.573280, -0.877680, -0.076560, 0.057700, -0.085790, 0.941310, 
-0.022120, -0.108220, -0.081580, 0.390600, -0.939870, 0.153930, -0.183350, 0.312700, 0.322710, 0.141140, 
0.500680, 0.045700, 0.351690, -0.340130, 0.314720, -0.312200, -0.998480, -0.109830, 0.374680, -0.076090, 
1.890390, 0.228690, -0.073000, -0.563880, 0.571570, -0.079780, 0.370720, 0.560100, -0.274480, 0.230500, 
0.317220, 0.083410, -0.367780, -0.106810, -0.296600, -0.728060, -0.252220, -0.387610, -0.127430, -0.409320, 
0.076890, 1.175300, -0.294300, -0.440940, -0.570220, 0.325240, 0.063610, 0.018970, 0.872510, 0.092340, 
0.072260, 0.001180, -0.592820, -0.164370, 0.813310, -0.019390, -0.028510, 0.157270, -0.589260, -0.021570, 
-0.048630, -0.151300, 0.538000, -0.274700, -0.099610, 0.339110, 0.134910, 0.151270, -0.169150, 0.719940, 
-0.342140, 0.789530, 0.576180, -0.088520, -0.030530, 0.513360, 0.638450, -0.642600, -0.592190, -0.666060, 
-0.540300, -0.082880, -0.226410, 
-0.662460, -0.106650, -0.578250, 0.135570, 0.051110, 0.322170, 0.106320, 0.249210, -0.382170, -0.384750, 
0.139060, -0.158100, 0.444740, -0.280820, 0.057860, -0.082150, -0.129030, 0.219400, -0.151800, -0.192710, 
-0.234150, -0.374310, -0.317660, -0.022270, -0.180070, -0.080630, 0.114470, 0.092860, 0.272440, -0.627940, 
-0.178540, 0.254600, -0.510060, 0.086250, -0.578760, -0.026260, -0.294530, 0.464780, 0.599590, 0.030060, 
-0.163180, -0.177210, -0.200260, -0.489290, -0.456520, -0.518410, 0.333950, -0.042310, -0.136880, 0.700560, 
-0.557920, 0.136480, -0.258980, -0.148600, -0.340880, -0.701950, -0.184800, -0.261110, 0.239660, 1.058170, 
0.281540, -0.008540, -0.053320, -0.398830, -0.290510, -0.617110, -0.051040, 0.385820, -0.191980, -0.067240, 
0.665260, -0.709350, 0.233910, -0.264650, -0.666490, -0.376130, -0.411280, -0.064510, -0.029940, -0.114570, 
1.211480, -0.064360, -0.015350, 0.191170, 0.082490, -0.190180, -0.214500, -0.271110, 0.374080, -0.505610, 
-0.110010, 0.627400, -0.498360, -0.023460, 0.100760, -0.206700, -0.595990, -0.058660, -0.436750, -0.372450, 
-0.249510, 1.030500, -0.167870, -0.148380, 0.187800, -0.097860, -0.038410, 0.226350, -0.599280, -0.022620, 
-0.575080, -0.157570, 0.090000, -0.365070, 0.193640, -0.197890, -0.039650, 0.317070, -0.416250, -0.754850, 
0.084200, -0.043910, 0.538990, -0.194340, -0.095490, 0.514520, -0.494640, 0.113860, 1.193140, -1.276700, 
-0.498320, 0.623680, 0.250200, -0.796460, -0.467510, -0.584620, -0.609140, 0.701540, 0.579160, -0.600700, 
-0.251300, 0.795910, 0.585590, -0.242440, -0.265590, -0.411650, 0.000750, -0.000860, -0.746840, 0.845900, 
0.128660, -0.733390, 0.243110, -0.060480, -1.485410, -0.120560, -0.782830, -0.877170, 0.446970, 1.564080, 
-0.056860, -0.105150, 0.359130, 0.160170, -0.522640, -0.234570, -0.287090, 0.688720, 0.104260, -0.540010, 
0.624530, 0.918880, -0.407340, 1.208640, -0.217230, -1.518840, -0.090110, -0.955110, -0.888360, 0.305340, 
0.469830, 0.131570, -0.114740, 0.542920, 0.035370, -1.067110, -0.313460, -0.229140, 0.353300, 0.183910, 
-0.506970, 0.476530, 1.105200, -0.196300, 0.111270, 0.041830, -1.444270, 0.249710, -1.096400, -0.347400, 
0.358250, -0.038400, 0.307180, -0.116440, 0.595380, 0.117630, -1.262130, 0.075710, -0.305560, 0.077170, 
0.852400, -0.183840, -0.315840, 0.033790, -0.010190, -0.644360, -0.242600, -0.317820, -0.297420, -0.137660, 
0.130360, 0.156830, -0.507750, 0.395720, 0.192200, 0.222330, -0.022980, -0.637540, -0.034900, -0.031910, 
-0.235880, 0.328030, -0.038170, -0.116990, 0.253710, 0.413020, -0.751930, -0.316140, -0.264990, 0.259160, 
0.087670, 0.186350, -0.417480, -0.378660, 0.139550, 0.179230, -0.163580, 0.151520, -0.538600, -0.082310, 
-0.133250, -0.434060, 0.027080, 0.258060, 0.146950, 0.587180, 0.168550, -0.608960, -0.303690, -0.028090, 
0.231210, -0.359780, 0.026050, -0.353650, -0.349950, 0.179730, 0.130890, 0.040160, -0.164980, -0.322420, 
-0.150850, -0.075620, -0.677290, 
-0.068810, -0.013430, -0.068920, -0.150770, 0.043840, -0.154730, -0.061170, 0.050800, -0.164890, -0.060870, 
-0.029900, -0.042830, -0.099640, -0.119180, 0.055620, -0.208720, -0.193560, 0.040260, 0.128240, -0.020660, 
-0.049690, -0.050740, -0.060550, 0.004180, -0.104690, -0.056750, -0.035020, -0.070840, -0.044070, -0.154090, 
-0.130880, 0.008220, -0.038720, -0.036240, 0.020020, -0.029880, -0.126850, -0.071640, -0.060570, -0.022980, 
-0.075850, -0.025120, -0.032830, 0.018360, -0.057940, -0.070800, -0.048640, 0.051640, -0.082250, -0.154550, 
-0.257660, -0.029260, 0.067550, -0.114120, -0.001470, -0.079390, -0.085420, -0.037250, -0.005000, -0.148570, 
-0.045900, -0.030770, -0.089220, -0.038270, 0.096490, -0.046310, -0.169550, -0.033620, 0.130240, -0.067930, 
-0.075190, -0.274070, 0.076410, 0.014220, 0.006720, 0.021640, -0.145640, -0.217290, -0.072760, -0.106570, 
-0.207730, 0.045620, -0.069500, -0.051560, -0.080480, 0.057690, -0.012190, -0.071170, -0.158760, 0.067850, 
-0.009150, -0.103550, -0.133130, -0.053200, -0.020300, -0.007300, 0.105970, -0.101360, -0.129390, -0.009200, 
-0.181520, -0.291200, 0.030300, -0.085040, -0.016530, -0.046100, 0.027180, 0.200310, 0.100450, -0.265720, 
0.030260, -0.010500, -0.283980, -0.089710, -0.228960, -0.079500, 0.160990, 0.234730, -0.030390, -0.014670, 
0.008480, -0.241620, -0.480060, -0.021880, -0.222660, 0.075250, 0.020060, 0.006320, 0.167360, 0.085440, 
-0.091840, -0.005330, -0.039200, -0.306610, -0.111330, -0.182300, -0.080590, 0.126780, 0.304550, -0.010790, 
-0.145470, -0.040800, -0.232630, -0.427180, -0.069360, -0.122670, -0.004460, 0.047950, 0.006070, 0.067810, 
0.063780, -0.093400, 0.188310, -0.072000, -0.237410, -0.112330, -0.044150, -0.030460, 0.023440, -0.022570, 
0.002300, -0.092270, -0.173660, -0.181530, -0.313050, -0.094920, -0.138920, 0.045620, 0.043020, 0.054480, 
0.014060, -0.079580, -0.052360, -0.043140, -0.015390, -0.131750, -0.076360, -0.067200, -0.014600, -0.015480, 
0.021710, 0.050040, -0.018630, -0.288700, -0.107910, -0.224840, -0.123920, -0.125690, 0.004070, 0.074530, 
0.013020, -0.084880, -0.233910, -0.024590, -0.005950, -0.042200, -0.092240, -0.100810, -0.024720, 0.022220, 
-0.038590, 0.025570, 0.068610, -0.064280, -0.158540, -0.168380, -0.265250, -0.036710, -0.110820, 0.040010, 
0.120180, -0.112440, -0.151920, -0.155760, -0.030690, -0.057180, -0.058980, -0.057540, -0.067830, 0.097470, 
-0.051040, -0.016640, 0.024530, -0.043110, -0.138330, -0.186250, -0.094550, -0.071570, -0.055900, -0.099600, 
0.033050, 0.180450, -0.064410, -0.122590, -0.080880, -0.058790, -0.145400, -0.096960, -0.043990, -0.036680, 
0.009070, -0.091910, -0.097980, 0.001400, 0.005570, -0.091850, -0.131620, -0.107710, -0.100100, 0.006380, 
-0.144050, 0.051980, 0.185570, -0.082570, -0.006290, -0.089340, -0.062410, -0.208580, -0.115100, -0.031240, 
0.003460, -0.008310, 0.029030, -0.066700, -0.107620, -0.002330, -0.051840, -0.198450, -0.136220, -0.117670, 
-0.056920, 0.003710, -0.038230, 
-0.146000, -0.008490, 0.089210, -0.311520, 0.215920, -0.113600, -0.037780, 0.058870, -0.348330, -0.075060, 
-0.104230, -0.117000, 0.036960, -0.189860, 0.134150, -0.116120, -0.271850, 0.196880, 0.060530, -0.182950, 
-0.019530, -0.369730, -0.042250, 0.457580, -0.008530, -0.010160, 0.171890, 0.079760, -0.246690, -0.439130, 
-0.479010, -0.069420, 0.035000, 0.160460, 0.134170, 0.076590, -0.060120, -0.192570, -0.154880, -0.042950, 
-0.226580, -0.000300, -0.302340, 0.017830, -0.041110, -0.170890, 0.050930, 0.629710, -0.086540, -0.391990, 
-0.420830, -0.342360, 0.107660, -0.031780, 0.270180, -0.115970, -0.044880, 0.002970, -0.020040, -0.180010, 
-0.035970, 0.006480, -0.134670, -0.124060, 0.176180, 0.095390, -0.381220, -0.046560, 0.974710, 0.065750, 
-0.180760, -0.485710, -0.034490, -0.028150, -0.096560, 0.230670, -0.323820, -0.383500, -0.144940, -0.178570, 
-0.133250, -0.028230, -0.170500, -0.069930, -0.221810, 0.297390, -0.011610, -0.213880, -0.251290, 0.465860, 
0.068540, -0.145620, -0.149370, -0.203840, -0.109110, 0.028540, 0.322830, -0.214740, -0.215120, -0.030240, 
-0.043900, -0.529350, -0.014830, -0.048070, 0.041710, -0.039770, 0.099910, 0.295390, 0.088310, -0.350860, 
0.087520, 0.125880, -0.645420, -0.174620, -0.336370, -0.179130, 0.318700, 0.507890, -0.152640, -0.129790, 
0.191380, -0.153940, -0.763220, -0.108070, -0.370670, 0.459160, 0.184470, -0.139210, 0.130510, 0.239240, 
-0.073790, 0.222820, 0.060220, -0.831300, -0.233240, -0.298170, -0.032420, 0.225410, 0.479180, -0.020600, 
-0.179160, 0.105900, -0.232990, -0.527790, -0.210090, -0.172050, 0.009820, 0.006850, -0.023540, -0.162020, 
0.044280, -0.091010, 0.480690, -0.078100, -0.562220, -0.195910, 0.014260, -0.183280, 0.046950, 0.549560, 
-0.162100, -0.168010, -0.226020, -0.106630, -0.381320, -0.210210, -0.178170, 0.338660, -0.080420, 0.118430, 
-0.008840, 0.044510, -0.264920, 0.258360, 0.075280, -0.394250, -0.218230, -0.275650, -0.085750, 0.069000, 
0.429420, -0.066490, 0.085840, -0.452490, 0.140030, -0.479130, -0.165170, -0.146190, 0.162510, -0.080910, 
-0.026460, -0.058120, -0.232480, -0.224110, 0.264820, 0.021010, -0.334660, -0.068050, -0.014280, -0.154670, 
0.138950, 0.360790, -0.129140, -0.041920, -0.049930, 0.083280, -0.537520, -0.086060, -0.109140, 0.055410, 
0.228050, 0.002290, -0.111010, -0.330480, -0.295410, 0.183360, -0.178930, -0.251030, -0.216540, -0.137600, 
-0.203170, 0.162000, 0.366660, -0.035740, -0.112690, -0.034540, 0.016570, -0.219700, 0.016150, -0.111670, 
0.035230, 0.263810, 0.211190, 0.012430, -0.235750, -0.372510, -0.211890, -0.091990, -0.255540, -0.161660, 
-0.146620, -0.264570, 0.342790, 0.250690, -0.076940, -0.209140, -0.131490, 0.024890, -0.173860, 0.105390, 
-0.196150, 0.028900, 0.239780, -0.167400, 0.011670, -0.233730, -0.325070, -0.369760, 0.055650, -0.045960, 
-0.049840, 0.191000, -0.126980, 0.159390, 0.019350, 0.108110, -0.099760, -0.242600, -0.230540, -0.245460, 
-0.023430, 0.165800, -0.037480, 
-0.306280, -0.025090, 0.058770, -0.277800, -0.181950, 0.040190, -0.019450, -0.100510, 0.131070, 0.136850, 
-0.214910, -0.129260, -0.123560, -0.178070, -0.199710, 0.081860, 0.088880, -0.118260, -0.104670, 0.015280, 
0.083230, -0.268410, -0.201730, 0.005110, -0.334070, -0.163180, 0.033560, -0.179430, 0.045590, 0.155180, 
-0.212350, -0.195980, 0.005700, 0.123930, -0.149150, 0.014380, -0.070370, 0.230150, -0.118560, -0.177930, 
0.043680, 0.057070, -0.233650, -0.089630, -0.253990, -0.154310, -0.228100, 0.090700, -0.105930, 0.112270, 
-0.052290, -0.318190, -0.073020, -0.129770, 0.059300, -0.230410, 0.046690, 0.041520, 0.189250, 0.082060, 
-0.187380, -0.013820, 0.074850, -0.454000, -0.066010, -0.212950, -0.125650, -0.053440, -0.013140, -0.165750, 
0.294190, -0.027380, -0.129940, 0.023000, -0.090640, -0.217130, -0.300260, -0.120580, 0.037010, 0.016380, 
0.320830, 0.007910, -0.016130, -0.076010, -0.250600, -0.023420, -0.332300, -0.440620, 0.158880, 0.488970, 
-0.022610, 0.296080, -0.273770, 0.076600, -0.022530, -0.298750, -0.293800, -0.349210, -0.171900, -0.054410, 
-0.105190, 0.652440, 0.050950, -0.149190, -0.307610, -0.359580, 0.157040, -0.619810, -0.435090, 0.197480, 
0.154030, -0.040530, 0.452110, -0.148790, 0.023840, -0.102690, -0.658630, -0.592540, -0.288490, 0.145760, 
-0.091330, 0.159280, 0.614960, 0.242790, 0.244280, -0.391960, -0.316320, 0.414290, -0.383760, -0.596450, 
0.213750, -0.057110, -0.104860, 0.589170, -0.351530, -0.091130, -0.330510, -0.517980, -0.705020, -0.229940, 
-0.161750, -0.005340, 0.280900, 0.565220, 0.146280, 0.253180, -0.005330, -0.206060, 0.277860, -0.339620, 
-0.603410, 0.291120, -0.199310, -0.121860, 0.524410, -0.505130, 0.047440, -0.067300, -0.505570, 0.071750, 
-0.436390, -0.481970, -0.177650, 0.338130, 0.638650, 0.085380, 0.350740, -0.323820, -0.267520, 0.130260, 
-0.232600, -0.537310, 0.456760, -0.245850, -0.068700, 0.236820, -0.382580, 0.010800, -0.006960, -0.278400, 
0.066210, -0.514920, -0.489460, 0.117660, 0.197720, 0.348050, -0.010320, 0.288930, -0.170480, -0.279260, 
-0.121310, 0.094660, -0.121740, 0.112900, -0.110700, -0.080240, 0.018160, -0.324940, -0.130210, -0.192220, 
-0.048970, -0.240030, -0.118960, -0.326720, 0.129960, 0.132170, 0.202190, 0.008670, -0.016340, 0.035900, 
-0.328040, -0.138810, -0.077430, -0.056800, 0.099220, 0.076560, -0.071730, -0.310670, -0.132120, -0.179590, 
-0.184270, 0.073190, -0.319020, -0.133470, -0.157960, 0.102170, 0.216270, 0.145460, -0.029920, -0.053010, 
0.060390, -0.467770, -0.121350, -0.025910, 0.143660, 0.023530, 0.066800, -0.132160, -0.128160, -0.172040, 
-0.151790, -0.171800, -0.120510, -0.101140, -0.145690, -0.201030, 0.169100, 0.197510, 0.066840, 0.002080, 
0.023020, -0.110890, -0.490960, 0.018990, -0.062520, -0.080570, 0.014640, 0.373150, -0.104780, -0.193650, 
-0.064560, -0.160880, -0.114410, -0.224030, 0.026690, -0.350940, -0.201330, 0.194770, 0.293930, 0.104480, 
-0.106240, -0.083610, -0.177840, 
-0.073640, -0.015960, -0.023420, 0.021440, 0.013300, -0.328560, -0.063470, -0.126880, -0.104160, -0.180790, 
-0.023360, 0.022120, 0.074300, 0.004890, 0.074830, -0.180210, -0.127280, -0.076380, 0.037290, -0.111460, 
0.027150, -0.102550, 0.018130, -0.134660, 0.105690, -0.038650, -0.200090, 0.049630, -0.185240, -0.200530, 
-0.153320, -0.005180, -0.053930, 0.020600, 0.011470, -0.036340, -0.104140, -0.098340, -0.045380, 0.037680, 
-0.104270, 0.061530, -0.187730, -0.029850, -0.112470, -0.015660, -0.074480, -0.049320, -0.013050, -0.276910, 
-0.029780, -0.172140, -0.043080, 0.018280, 0.076900, 0.012960, 0.013810, -0.074040, -0.121650, -0.097170, 
-0.004600, -0.012400, 0.016240, -0.109740, -0.016050, 0.095260, -0.024480, -0.199790, 0.116200, 0.038430, 
-0.415540, 0.003870, -0.090340, -0.189750, -0.018500, 0.043250, 0.045290, -0.058200, 0.025860, -0.137520, 
-0.160710, -0.142900, -0.080610, 0.136830, -0.161910, -0.042370, 0.193130, 0.008040, -0.320380, -0.051220, 
0.009070, -0.390910, 0.078560, -0.315860, -0.154970, 0.118460, 0.200280, 0.005760, 0.015100, -0.056240, 
-0.021850, -0.314940, -0.114320, -0.031300, 0.197890, -0.210380, -0.178700, 0.220420, -0.054750, -0.274380, 
0.043270, 0.023480, -0.160460, -0.015000, -0.353460, -0.184740, 0.266230, 0.423020, -0.085330, -0.132150, 
-0.201400, -0.213640, -0.199300, -0.321850, -0.132470, 0.601430, -0.196540, -0.181460, 0.228550, -0.178970, 
-0.295930, 0.311810, -0.014350, -0.211160, 0.052690, -0.420700, -0.159540, 0.272980, 0.731290, -0.156070, 
0.016340, -0.068960, -0.123950, -0.289890, -0.347650, -0.160390, -0.005570, -0.289650, -0.244280, 0.154280, 
-0.193680, -0.394210, 0.215460, 0.032450, -0.393400, 0.078570, -0.546260, -0.281070, 0.149280, 0.880730, 
-0.084620, -0.018310, -0.010810, -0.011950, -0.162920, -0.249540, -0.309010, 0.483430, -0.231200, -0.202130, 
0.143130, -0.099940, -0.328990, 0.134020, 0.004420, -0.283930, -0.004630, -0.500910, -0.264900, 0.101320, 
0.681370, -0.072410, 0.080660, -0.053350, 0.010830, -0.100930, -0.161720, -0.254090, 0.232730, -0.338800, 
-0.063330, 0.149120, -0.070840, -0.153590, 0.082100, -0.020250, -0.221420, -0.129640, -0.191150, -0.223980, 
-0.049210, 0.508770, -0.171530, -0.024520, 0.023000, 0.050830, -0.132570, -0.141050, -0.091260, 0.046870, 
-0.183600, 0.079520, 0.078630, -0.109670, -0.067770, -0.101480, -0.061340, -0.078220, -0.125740, -0.318720, 
-0.170160, -0.054720, 0.235900, -0.083080, 0.038530, 0.037000, 0.034070, -0.065480, -0.086850, -0.080250, 
-0.057980, -0.018440, 0.101170, 0.023570, -0.190700, 0.003460, -0.167240, 0.032060, -0.163910, -0.053560, 
-0.189060, -0.155180, -0.043240, 0.029090, -0.096770, -0.080260, -0.003150, -0.035020, -0.029590, -0.010200, 
-0.061430, -0.066830, -0.052810, -0.028460, 0.108210, -0.034060, -0.090450, -0.201270, 0.085480, -0.156610, 
-0.066830, -0.286480, -0.132370, 0.015490, 0.003790, 0.052190, -0.106600, -0.029320, -0.040610, -0.114570, 
0.025610, -0.012020, -0.092490, 
-0.108580, -0.009940, -0.020390, -0.106300, 0.029370, -0.118160, -0.074720, -0.016310, -0.141230, -0.116030, 
-0.026180, -0.040130, -0.072510, -0.057490, 0.026730, -0.135930, -0.168210, -0.015540, 0.082610, -0.075350, 
-0.047840, -0.148360, -0.017860, 0.030000, -0.033750, -0.007540, -0.038850, -0.035700, -0.095640, -0.141600, 
-0.192110, -0.002980, -0.062920, -0.050020, -0.001220, -0.064270, -0.088000, -0.117200, -0.111160, 0.006060, 
-0.087810, -0.027400, -0.146770, 0.028610, -0.030010, -0.116860, -0.035190, 0.048840, -0.045290, -0.143220, 
-0.169140, -0.145140, 0.043850, -0.099610, 0.026850, -0.072730, -0.075330, -0.033150, -0.078410, -0.141520, 
0.003440, -0.034050, -0.054050, -0.115050, 0.077780, 0.042850, -0.180490, -0.060950, 0.174100, -0.037860, 
-0.119360, -0.182830, -0.036860, -0.007490, -0.018770, 0.060920, -0.139140, -0.141340, -0.045350, -0.169360, 
-0.233550, -0.008650, -0.085920, -0.030140, -0.128650, 0.056490, -0.002500, -0.103920, -0.167830, 0.102990, 
-0.024550, -0.164380, -0.112940, -0.137020, -0.033740, -0.007810, 0.152490, -0.081140, -0.089730, -0.058080, 
-0.125900, -0.317160, -0.003220, -0.044260, 0.036690, -0.081430, -0.000240, 0.109990, 0.028750, -0.212120, 
-0.007620, -0.004280, -0.269720, -0.131120, -0.157980, -0.077220, 0.122390, 0.229210, -0.090950, -0.110590, 
-0.003390, -0.182670, -0.407410, -0.069910, -0.194230, 0.198200, -0.031390, -0.059500, 0.065670, 0.053530, 
-0.071200, 0.009820, -0.000560, -0.320070, -0.120960, -0.138370, -0.026440, 0.103510, 0.265780, -0.060610, 
-0.120720, -0.009960, -0.135330, -0.415850, -0.106500, -0.153590, -0.002230, -0.039120, -0.035920, -0.004850, 
0.025770, -0.099730, 0.207730, -0.030560, -0.295490, -0.102020, -0.138460, -0.076190, 0.039120, 0.149590, 
-0.026270, -0.079950, -0.108290, -0.136750, -0.381810, -0.109180, -0.184100, 0.125640, -0.056020, 0.026350, 
-0.011670, -0.070780, -0.109430, 0.014550, 0.007710, -0.162710, -0.102730, -0.141350, -0.032290, -0.001560, 
0.130820, 0.026990, -0.003960, -0.253050, -0.096950, -0.224770, -0.128720, -0.147120, 0.053110, -0.021990, 
-0.000550, -0.048680, -0.221590, -0.034580, 0.030860, -0.022610, -0.139220, -0.124310, -0.023770, -0.020420, 
-0.037410, 0.134850, -0.036510, -0.083880, -0.119170, -0.079740, -0.251550, -0.060910, -0.104300, 0.026460, 
0.060030, -0.044240, -0.101170, -0.176630, -0.106420, -0.055930, -0.061140, -0.111020, -0.123120, -0.036740, 
-0.049030, 0.003710, 0.120740, -0.065630, -0.090570, -0.116640, -0.083290, -0.098960, -0.041920, -0.082190, 
0.010530, 0.105620, 0.006600, -0.110520, -0.129250, -0.122970, -0.132200, -0.075380, -0.135700, -0.074880, 
-0.099090, -0.100820, -0.041620, 0.069450, -0.043420, -0.111790, -0.104370, -0.085370, -0.069440, 0.003280, 
-0.134870, 0.044880, 0.081420, -0.069460, -0.033010, -0.074320, -0.106380, -0.229480, -0.039710, -0.079980, 
-0.070490, -0.060230, -0.024260, -0.015890, -0.065870, 0.040620, -0.074000, -0.161120, -0.099190, -0.146010, 
-0.029350, 0.014760, -0.008930, 
-0.379930, 0.204390, 0.395620, -0.025390, 0.103740, 0.664640, 0.324050, -0.457060, -0.334180, -0.207900, 
-0.226180, -0.455720, 0.407640, -0.288500, -0.259540, -0.216750, 0.053280, 0.266570, -0.123200, -0.485760, 
0.183910, -0.854040, 0.035790, 0.612700, 0.412680, -0.038200, 0.463360, 0.544530, -0.944530, -0.132090, 
-0.928560, -0.177080, 0.041760, 0.405480, 0.193470, -0.156550, 0.215790, -0.190550, 0.043010, 0.027850, 
-0.451100, 0.015640, -0.745490, 0.141710, 0.672580, -0.077570, 0.159040, 0.146800, 0.205520, -0.595560, 
0.261890, -0.773050, 0.038160, 0.183900, 0.826650, -0.076710, -0.012230, -0.127370, -0.291110, -0.253660, 
-0.356690, -0.049210, -0.110210, -0.543200, 0.264210, 1.012260, -0.588320, -0.104470, -0.098010, 0.342190, 
-0.135870, -0.065540, -0.619420, -0.213070, 0.123580, 1.278200, -0.170750, 0.031930, -0.446730, -0.357450, 
-0.279690, -0.183250, -0.174980, 0.018340, -0.668790, 0.376580, 0.889290, -0.205240, -0.570090, -0.297690, 
0.074280, -0.639250, 0.103990, -0.728260, -0.308130, 0.565100, 1.270100, -0.161400, 0.245380, 0.132430, 
0.263090, -0.809560, -0.410600, 0.007930, 0.039730, -0.489900, -0.322720, 0.961430, 0.029540, -1.031930, 
-0.069930, 0.221850, -1.644040, -0.026520, -0.742950, -0.492950, 0.859810, 1.486500, -0.158710, 0.373530, 
0.365080, 0.482330, -0.936800, -0.711570, -0.237480, 1.196720, -0.174610, -0.783590, 0.756720, 0.453330, 
-0.728310, 0.345360, -0.027560, -1.309690, 0.333170, -0.703590, 0.023000, 0.724290, 1.299410, -0.047270, 
0.430300, 0.042040, 0.308460, -0.754050, -0.617080, -0.415140, -0.005010, -0.358500, -0.247080, 0.802920, 
0.157720, -0.473940, 0.361500, 0.261080, -0.725720, -0.081030, -0.779020, 0.023800, 0.167860, 1.425310, 
-0.054890, -0.057760, -0.060280, -0.044350, -1.159040, -0.438890, -0.492690, 0.928380, -0.633970, -0.096560, 
0.739440, 0.214500, -0.421060, 0.754290, 0.525810, -0.719760, 0.021240, -0.791590, -0.139420, 0.221920, 
0.968030, -0.008540, 0.208800, -0.211650, -0.052750, -0.967210, -0.313410, -0.606040, 0.401080, -0.829660, 
-0.058970, 0.236380, -0.171150, 0.050700, 0.941020, 0.154080, -0.176780, 0.055890, -0.547960, -0.386060, 
0.264000, 1.064250, -0.346190, 0.188820, -0.547010, 0.227460, -0.182040, -0.499980, -0.389330, 0.087090, 
-0.552040, 0.305540, 0.199760, -0.514890, -0.288070, 0.224510, -0.173140, -0.271800, -0.118650, -0.749330, 
-0.467180, 0.204990, 1.363930, -0.010460, -0.062220, -0.210730, -0.038580, 0.000780, 0.242570, -0.137430, 
0.154170, -0.110360, 0.339280, 0.295350, -0.302780, -0.551420, -0.015030, 0.265690, -0.598260, 0.188710, 
-0.889690, -0.511800, 0.656470, 1.083810, 0.000100, -0.523280, -0.189630, 0.073590, -0.378360, 0.195890, 
-0.049460, 0.153470, 0.320730, 0.144280, -0.125170, -0.122250, -0.695010, -0.052080, 0.151990, -0.454740, 
0.099270, -0.559480, -0.146080, 0.358650, 0.617610, 0.367250, -0.551550, -0.219980, -0.396810, -0.279620, 
0.224420, 0.220670, 0.214890, 
-0.007940, -0.006080, -0.096390, -0.044650, -0.023390, -0.323100, -0.059340, -0.016070, -0.084180, -0.054170, 
-0.019950, -0.035900, 0.009320, -0.052740, 0.155540, -0.200720, -0.193700, -0.049390, 0.109030, -0.054360, 
-0.023420, -0.026330, -0.034970, -0.097060, 0.068950, -0.036560, -0.183320, 0.013770, -0.134930, -0.103780, 
-0.117120, -0.025160, -0.014330, 0.007400, 0.058150, 0.005500, -0.163550, -0.132950, -0.045570, 0.002400, 
-0.081920, 0.000840, -0.092880, 0.002720, -0.118880, 0.011940, -0.080680, -0.107970, -0.018090, -0.231240, 
-0.068980, -0.062600, -0.029880, 0.030780, 0.056490, 0.001360, -0.012620, -0.023120, -0.101240, -0.096690, 
-0.047980, -0.015810, -0.037230, -0.055980, 0.052200, -0.021090, -0.032460, -0.176630, 0.076570, -0.021150, 
-0.330950, -0.076440, 0.049870, -0.141670, 0.000750, 0.055590, 0.044680, -0.136370, -0.009560, -0.082250, 
-0.183810, -0.101330, -0.056230, 0.063850, -0.184450, -0.004560, 0.136520, 0.012600, -0.340150, 0.014220, 
0.048350, -0.310980, 0.044110, -0.228750, -0.166860, 0.139500, 0.152310, -0.000950, 0.001130, -0.031310, 
-0.096040, -0.288050, -0.054540, -0.028580, 0.130480, -0.218850, -0.089930, 0.264200, -0.004800, -0.321800, 
0.078390, 0.060390, -0.234800, 0.001170, -0.395430, -0.227310, 0.332900, 0.460270, -0.043000, -0.017610, 
-0.168050, -0.208310, -0.290720, -0.253770, -0.202910, 0.471070, -0.180140, -0.089590, 0.338170, -0.076600, 
-0.302280, 0.242880, -0.002090, -0.253740, 0.031520, -0.501220, -0.224140, 0.327990, 0.769350, -0.095510, 
0.015000, -0.068130, -0.166430, -0.365450, -0.299110, -0.118760, 0.009380, -0.202180, -0.173370, 0.255000, 
-0.122390, -0.347710, 0.302860, -0.015040, -0.411740, 0.058900, -0.583400, -0.251700, 0.157780, 0.773450, 
-0.087920, -0.018830, -0.074480, -0.028450, -0.204140, -0.239180, -0.244490, 0.382100, -0.170100, -0.126110, 
0.127150, -0.141830, -0.243890, 0.153960, -0.007340, -0.262100, -0.015020, -0.442120, -0.227560, 0.098710, 
0.596240, -0.072140, 0.054600, -0.158800, 0.002560, -0.063770, -0.153370, -0.174620, 0.179010, -0.268590, 
-0.020810, 0.086520, -0.151460, -0.091650, 0.086240, -0.031440, -0.167250, -0.104560, -0.207910, -0.156200, 
0.015690, 0.412780, -0.134000, -0.062770, -0.020740, -0.025880, -0.091950, -0.117350, -0.052810, 0.059660, 
-0.129320, -0.032300, 0.052680, -0.130810, 0.003730, -0.040060, -0.090940, -0.064660, -0.097820, -0.237060, 
-0.178270, -0.002760, 0.176570, -0.070290, -0.057600, -0.017780, 0.038670, -0.026070, -0.082630, -0.052150, 
-0.027860, 0.038830, 0.049920, 0.007870, -0.143060, 0.027360, -0.147670, -0.018770, -0.067600, 0.005080, 
-0.162870, -0.189330, -0.072530, 0.076490, -0.078440, -0.069100, -0.054090, -0.015210, -0.092080, 0.010500, 
-0.114520, -0.049670, 0.092240, -0.054970, 0.085490, -0.107940, -0.010420, -0.189840, 0.026980, -0.098510, 
-0.017910, -0.233790, -0.079050, 0.011750, 0.016710, -0.033990, -0.082500, -0.068290, -0.102140, -0.088310, 
-0.031570, 0.002140, -0.088720, 
0.451320, -0.186030, 0.031590, 0.902720, 0.035140, -0.639530, -0.362240, -0.535670, 0.293020, -0.102250, 
0.068120, -0.038680, -0.183770, 0.267790, -0.411610, 0.132840, -0.020130, -0.543920, 0.051320, -0.148910, 
-0.268270, 0.449440, 0.162520, -0.650770, 0.221840, 0.181130, -1.050090, -0.237200, 0.114350, 0.263870, 
0.607430, 0.208410, -0.483270, -0.181790, -0.294000, -0.214130, 0.144220, -0.753060, -0.102110, 0.514940, 
-0.104830, 0.006780, 0.298430, -0.193590, 0.119900, 0.423940, -0.396370, -0.844260, 0.079120, -0.299220, 
0.878400, -0.180910, -0.044560, 0.118150, -0.415550, 0.244820, 0.220980, -0.019620, -0.536600, -0.831270, 
0.046300, -0.048660, 0.157250, 0.637440, -0.340200, 0.458710, 0.431020, -0.565530, -0.763700, 0.084790, 
-0.646790, 0.842980, -0.480690, -0.343400, 0.018610, -0.169980, 0.637080, 0.796220, -0.001680, -0.404230, 
-1.302560, -0.407950, 0.016310, 0.364000, 0.523240, -0.583490, 0.358460, 0.252170, -0.331540, 0.189540, 
0.042830, -1.122680, 0.399890, -0.109390, -0.049740, 0.381620, 0.147950, 0.030060, -0.031780, -0.082350, 
-0.293240, -0.316760, -0.484080, -0.452910, 0.376180, -0.190120, -0.548750, -0.172870, -0.211140, 0.210130, 
0.213100, -0.296880, 0.024820, 0.065090, 0.421870, -0.097700, 0.095180, 0.223990, -0.096820, -0.538360, 
-0.400780, 0.036870, -0.068420, -0.786170, -0.291790, 1.254790, -0.362300, -0.738430, 0.517190, -0.197490, 
-0.402770, 0.888760, 0.027170, -0.417700, 0.054230, -0.170110, -0.245290, 0.744900, 1.183640, -0.298660, 
-0.224710, 0.622800, 0.507590, -1.014330, -0.791670, -0.833180, 0.006530, -0.421940, -0.803220, 0.351630, 
-0.208920, -0.544990, -0.168980, -0.037680, -0.230330, 0.307650, -0.525600, -0.364430, 0.130190, 1.338610, 
0.115310, 0.067390, 0.477510, -0.183040, -0.534240, -0.375880, -0.782730, 1.199570, -0.176330, -0.822520, 
0.755830, 0.438150, -0.290360, -0.290360, -0.395240, -0.341150, 0.258030, -0.401570, -0.408430, 0.051190, 
1.363170, -0.128100, -0.071730, 0.503310, -0.192990, -0.266750, -0.506510, -0.753350, 0.512890, -0.247200, 
-0.347210, 0.695040, 0.541870, -0.699640, -0.527750, -0.037420, -0.497320, -0.312350, -0.014180, -0.291890, 
-0.249220, 0.700060, 0.036520, 0.048140, -0.156500, -0.176120, 0.642890, -0.325240, -0.072390, 0.124220, 
-0.289480, 0.354450, 0.513960, 0.050650, -0.083750, -0.737990, 0.026280, -0.117660, -0.172770, -0.403660, 
0.026520, -0.879490, 0.249790, -0.267640, 0.251210, 0.075930, -0.003290, -0.065100, -0.309730, 0.487050, 
0.106250, -0.055440, -0.044200, -0.144880, -0.307900, -0.085550, -0.189170, 0.177890, -0.027270, 0.176730, 
-0.027440, 0.196560, -0.445720, -0.033500, -0.137700, -0.082510, 0.128210, -0.237240, 0.150740, -0.227980, 
0.157530, -0.069230, -0.378000, -0.038270, -0.227820, 0.242010, -0.304350, -0.505640, 0.289460, -0.184600, 
-0.011040, -0.791080, -0.225840, 0.111710, -0.092830, 0.538550, 0.038260, 0.372070, 0.561170, -0.058480, 
-0.036790, -0.541860, 0.078170, 
-0.120380, -0.030710, -0.047600, -0.091770, 0.017380, -0.198610, -0.050220, -0.055280, -0.166350, -0.169340, 
-0.021400, -0.039110, 0.012640, -0.030750, 0.055620, -0.154400, -0.107780, -0.030980, 0.029240, -0.084830, 
0.013580, -0.187370, 0.017740, -0.017770, 0.014680, -0.015630, -0.101640, 0.027900, -0.160630, -0.166200, 
-0.185100, -0.026250, -0.036820, 0.002620, 0.033240, -0.073440, -0.133670, -0.102860, -0.091580, 0.022250, 
-0.085570, 0.048660, -0.232510, 0.004820, -0.058970, -0.091620, -0.085420, 0.035560, -0.007930, -0.260330, 
-0.101510, -0.229500, -0.017620, -0.011110, 0.043790, -0.017970, 0.018460, -0.036360, -0.067620, -0.094130, 
-0.015990, -0.035140, -0.001430, -0.134370, 0.050570, 0.042060, -0.132700, -0.137190, 0.235440, 0.015940, 
-0.301470, -0.106090, -0.076220, -0.119020, -0.006030, 0.043270, -0.078740, -0.119780, -0.004610, -0.131140, 
-0.177700, -0.102950, -0.103090, 0.057460, -0.191590, 0.039430, 0.067630, -0.094030, -0.263270, 0.076120, 
0.010810, -0.229310, -0.050940, -0.217910, -0.121740, 0.028660, 0.162810, -0.050390, -0.049440, -0.086450, 
-0.061250, -0.254270, -0.049360, -0.035280, 0.126640, -0.171010, -0.063120, 0.109140, -0.022150, -0.239980, 
0.043180, 0.029420, -0.223350, -0.079560, -0.257260, -0.136690, 0.176540, 0.339800, -0.113160, -0.123370, 
-0.118460, -0.185520, -0.242920, -0.203690, -0.143020, 0.405600, -0.179730, -0.081600, 0.103650, -0.076450, 
-0.207720, 0.177390, 0.014260, -0.224150, -0.025890, -0.306530, -0.077100, 0.147470, 0.466240, -0.121920, 
-0.052050, -0.036340, -0.118300, -0.301310, -0.250440, -0.119300, -0.004610, -0.194150, -0.110510, 0.017890, 
-0.113340, -0.226450, 0.196070, 0.012090, -0.304320, -0.057190, -0.374110, -0.176770, 0.077240, 0.564720, 
-0.111750, -0.079600, -0.089110, -0.051390, -0.152790, -0.188580, -0.228190, 0.316160, -0.199250, -0.052350, 
0.038320, -0.114880, -0.204260, 0.106680, -0.003910, -0.202270, -0.064560, -0.328650, -0.176620, 0.045990, 
0.447210, -0.037230, 0.044890, -0.149000, -0.010200, -0.150500, -0.147710, -0.219060, 0.142760, -0.249680, 
-0.001230, 0.049470, -0.149020, -0.126040, 0.104790, 0.020720, -0.186170, -0.125080, -0.212520, -0.145410, 
-0.016300, 0.345750, -0.124370, -0.043000, -0.027390, 0.020910, -0.186510, -0.099550, -0.100570, 0.017390, 
-0.100810, 0.035460, 0.012010, -0.160290, -0.116250, -0.031650, -0.048150, -0.135520, -0.146890, -0.233380, 
-0.138570, -0.013880, 0.186440, -0.075830, -0.037290, 0.010100, -0.002940, -0.093780, -0.066510, -0.084200, 
-0.027630, -0.035100, 0.103320, -0.001980, -0.166360, -0.059930, -0.132610, -0.021730, -0.168410, -0.106100, 
-0.168470, -0.155530, 0.003680, 0.086970, -0.105550, -0.108240, -0.047460, -0.044940, -0.042530, 0.013970, 
-0.089070, -0.012520, -0.017710, -0.052280, 0.054700, -0.088200, -0.109260, -0.216350, 0.043040, -0.142070, 
-0.091900, -0.192930, -0.102590, 0.035540, -0.019430, 0.023920, -0.083960, -0.047530, -0.048620, -0.158060, 
0.024520, -0.011550, -0.056300, 
-0.460800, -0.560690, -0.374170, -0.139530, 0.249830, 0.502400, -0.290620, -0.359300, -0.425240, -0.225460, 
-0.031720, -0.193970, 0.064140, 0.021640, -0.577740, 0.317120, -0.283900, 0.341210, -0.380380, 0.167360, 
0.342630, -0.490250, -0.205140, -0.102020, -0.411160, -0.108430, 0.240610, -0.239550, -0.276150, 0.100840, 
-0.084530, 0.209100, 0.204120, 0.357760, -0.320850, -0.415430, 0.179860, -0.189850, -0.200210, -0.665040, 
0.042390, 0.063080, -0.600960, -0.081220, 0.091270, 0.112020, 0.192550, 0.199800, -0.122550, -0.796460, 
-0.576300, 0.039030, -0.154940, 0.272500, 0.174980, -0.340190, -0.586820, 0.206850, 0.195720, 0.179360, 
-0.311700, -0.217830, -0.154310, -0.399170, -0.082380, -0.226290, -0.050620, 0.059630, 0.067530, 0.038480, 
-0.448400, -0.035710, -0.190490, -0.319090, -0.156530, 0.487960, -0.218190, -0.269240, -0.103620, -0.208750, 
0.234670, -0.398850, -0.015850, -0.106470, -0.244920, -0.862310, 0.014090, 0.373570, -0.101440, -0.150380, 
-0.276350, -0.061910, -0.288120, -0.262980, 0.194810, -0.354730, 0.074410, -0.264500, -0.361230, -0.009890, 
0.547950, 0.406950, -0.390150, -0.412990, 0.154770, -0.238960, -0.574700, 0.073840, 0.077010, 0.345630, 
0.216940, -0.107460, -0.334590, -0.922990, -0.468520, -0.317640, 0.315670, 0.145830, -0.379080, -0.577960, 
0.877250, 0.853140, -0.042330, -0.378690, -0.509710, -0.378160, 0.155370, 0.188020, -0.732360, -0.009210, 
0.221890, -0.499740, -0.384840, 0.359110, -0.647330, 0.648330, 0.421120, -1.220840, 0.568670, -0.352490, 
-0.386130, -0.829750, -0.351310, 0.659100, -0.126770, 0.017500, 0.003770, 0.617160, -0.608590, 0.693840, 
0.717060, -0.634240, -0.834590, -0.434850, -0.274670, 0.448710, -0.225520, 0.088520, -0.470430, -0.720590, 
0.931100, 0.033460, -0.146960, -0.565160, -0.343270, -0.066080, -0.195990, -0.311760, 0.667120, -0.585580, 
0.662700, 1.414660, -0.937570, -0.632950, -0.415130, -0.486400, 0.124930, -0.309820, -0.016560, -0.412480, 
-1.964920, 0.895990, 0.113390, 0.071150, -0.000910, 0.069630, -0.084850, -0.241440, -0.267990, 1.053000, 
0.388280, -1.842780, -0.695650, 0.690490, -0.806380, -0.391900, 0.860040, -0.269220, 0.947410, 0.753260, 
-0.987390, -2.198630, -0.024560, 0.365150, -0.729630, -0.339770, 0.987510, 0.458530, -0.266650, -0.296070, 
0.577410, 0.110730, -0.914490, 0.156940, -0.318180, -0.768500, -0.250710, 0.273290, 0.023990, 0.811800, 
0.550840, -0.341790, -1.455320, 0.219790, 0.122900, -0.279020, -0.509430, -0.057560, 0.245490, 0.008510, 
-0.481930, 0.480830, -0.564030, 0.368820, 0.877140, -1.079860, 0.286030, 0.068940, -0.427510, 0.575050, 
-0.475120, 0.290880, 0.195070, -1.401410, 0.789810, 0.735150, -0.096760, -0.350540, -1.296810, -0.315840, 
-0.395210, -0.571270, 0.497220, -0.325850, -0.819920, 0.397760, 0.107150, -0.359070, -0.058870, 0.345250, 
-0.089790, 0.170170, 0.702160, -0.318510, -1.842710, 0.377160, 0.264880, -0.195250, -0.139630, -0.382230, 
-0.144970, 0.129180, -0.634810, 
-0.099640, -0.048740, -0.088650, -0.199480, -0.021560, -0.177710, -0.011190, 0.017410, -0.096850, -0.033560, 
-0.029950, -0.049530, -0.131270, -0.146320, -0.088490, -0.115420, -0.054110, -0.032870, 0.007230, 0.053090, 
0.007490, -0.063320, -0.081950, -0.083590, -0.189500, -0.096140, -0.105360, -0.058340, -0.017780, -0.087600, 
-0.048440, -0.046550, -0.027240, -0.052760, -0.071830, -0.086270, -0.122030, 0.019870, -0.043900, -0.047850, 
0.007950, -0.013310, -0.028560, -0.023230, -0.097390, -0.076530, -0.128410, -0.050440, -0.055970, -0.068270, 
-0.184830, -0.069050, -0.006060, -0.084020, -0.087540, -0.121250, -0.083790, -0.046500, 0.020460, -0.048000, 
-0.071310, -0.026660, -0.015720, -0.093430, 0.017670, -0.129590, -0.179110, -0.033860, -0.023070, -0.060690, 
-0.032980, -0.185010, 0.023450, 0.004340, -0.018560, -0.121610, -0.144590, -0.180150, -0.073760, -0.008620, 
-0.047740, 0.039520, -0.023840, -0.076910, -0.068330, -0.031220, -0.082270, -0.196640, -0.012990, 0.031410, 
-0.022350, 0.005930, -0.212560, -0.002850, 0.019140, -0.110410, -0.114800, -0.126420, -0.084980, -0.066090, 
-0.158910, 0.037280, 0.046880, -0.070750, -0.139680, -0.092690, 0.015310, -0.025390, -0.007850, -0.099450, 
-0.013720, -0.045450, -0.042120, -0.092080, -0.164920, -0.032510, -0.125280, -0.122790, -0.059160, 0.033010, 
-0.111760, -0.140330, -0.108150, 0.079860, -0.019740, -0.217930, -0.059230, 0.087620, -0.041580, -0.093330, 
-0.027310, -0.074110, -0.050320, 0.037790, -0.116470, -0.180120, -0.071430, -0.164110, -0.157990, -0.052960, 
-0.112490, -0.153710, -0.141620, -0.087510, 0.051850, 0.063530, 0.000000, 0.001080, 0.125240, -0.076130, 
-0.121460, 0.068400, -0.065180, -0.060650, 0.061350, -0.185310, 0.024620, 0.082920, -0.169510, -0.368580, 
-0.071410, -0.178720, -0.196560, -0.082410, 0.033590, 0.015560, 0.048350, -0.179320, -0.021250, 0.055780, 
-0.092080, -0.215880, 0.132490, -0.124350, -0.048120, -0.011470, -0.111520, 0.003640, 0.050860, -0.105360, 
-0.163400, -0.054810, -0.116230, -0.184210, -0.075440, -0.071360, -0.033560, -0.000980, -0.111730, -0.043910, 
-0.019390, -0.077060, -0.139130, 0.018460, -0.070520, -0.037480, -0.025090, -0.054360, -0.106130, 0.017990, 
-0.090200, -0.189710, 0.081870, -0.096750, -0.130520, -0.124930, -0.128190, -0.020680, -0.082040, -0.014410, 
-0.059010, -0.119750, -0.169250, -0.113390, 0.062470, -0.093110, 0.012720, -0.051280, -0.055650, 0.028300, 
-0.042590, -0.051270, -0.154470, -0.022840, -0.087840, -0.185530, -0.054330, -0.066970, -0.061860, -0.053510, 
-0.003430, -0.040730, -0.105800, -0.125270, -0.103990, 0.036830, -0.108100, -0.058610, -0.005290, -0.081700, 
0.049940, -0.034900, -0.134980, -0.080290, -0.039150, -0.123430, -0.099810, -0.095260, -0.069260, -0.003880, 
-0.035710, -0.036820, -0.039220, -0.031200, -0.056600, -0.070380, -0.021540, -0.029550, -0.098640, -0.081490, 
-0.015130, -0.075510, 0.006710, -0.098420, -0.066230, -0.122910, -0.111300, -0.091950, -0.056610, -0.070750, 
-0.043220, -0.055680, -0.086350, 
-0.074040, -0.020070, -0.090130, -0.194750, -0.002720, -0.210880, -0.027780, 0.041920, -0.092250, -0.038490, 
-0.033790, -0.063260, -0.068310, -0.096530, 0.029370, -0.187700, -0.165110, 0.002300, 0.067320, 0.007180, 
-0.011600, -0.103290, -0.056690, -0.050970, -0.135780, -0.077660, -0.110680, -0.038810, -0.049140, -0.087730, 
-0.098050, -0.036350, -0.031410, -0.039470, 0.003940, -0.042400, -0.158120, -0.062630, -0.035190, -0.038250, 
-0.047520, 0.003570, -0.092690, 0.001920, -0.061720, -0.077750, -0.103240, 0.001160, -0.058450, -0.146500, 
-0.194220, -0.088950, -0.013770, -0.037320, -0.034880, -0.058390, -0.055400, -0.034060, -0.004690, -0.088130, 
-0.068490, -0.037270, -0.046150, -0.065830, 0.067170, -0.116230, -0.168610, -0.072880, 0.065580, -0.048870, 
-0.137040, -0.200370, 0.045270, -0.044340, 0.021400, 0.000000, -0.129570, -0.188280, -0.045010, -0.045180, 
-0.091180, -0.000870, -0.040750, -0.020010, -0.160390, 0.032770, -0.027600, -0.128780, -0.160040, 0.108430, 
0.019840, -0.093510, -0.134340, -0.070590, -0.060110, -0.020970, 0.046270, -0.105000, -0.095540, -0.056010, 
-0.143690, -0.139090, 0.000760, -0.031000, -0.015340, -0.159870, 0.021650, 0.096680, -0.008970, -0.202820, 
0.062450, 0.029920, -0.173230, -0.061330, -0.273420, -0.108660, 0.105950, 0.182820, -0.063110, -0.012430, 
-0.093750, -0.207500, -0.260020, -0.057010, -0.130530, 0.077610, -0.141300, 0.040820, 0.122170, -0.039330, 
-0.146170, 0.051180, -0.023190, -0.132020, -0.070320, -0.308790, -0.120620, 0.068840, 0.274540, -0.072850, 
-0.090440, -0.094510, -0.154640, -0.240860, -0.091720, -0.052280, -0.007810, -0.083760, 0.015180, 0.066690, 
-0.093250, -0.092940, 0.140250, -0.052360, -0.153910, -0.120530, -0.206450, -0.072530, -0.014650, 0.143760, 
-0.096450, -0.130950, -0.183680, -0.081250, -0.086390, -0.096270, -0.087670, 0.060250, -0.082170, 0.036610, 
-0.003430, -0.190730, -0.038300, 0.002280, -0.026680, -0.104900, -0.095480, -0.157730, -0.073170, -0.019780, 
0.194220, -0.048990, -0.061460, -0.215980, -0.044280, -0.081810, -0.095360, -0.099170, 0.023630, -0.110020, 
0.012850, -0.024390, -0.176700, -0.032710, 0.010130, -0.028950, -0.092700, -0.091290, -0.193500, -0.059670, 
-0.039550, 0.113250, -0.009700, -0.085890, -0.086870, -0.090160, -0.154900, -0.043180, -0.090260, 0.025450, 
-0.040610, -0.076730, -0.083740, -0.119760, 0.005070, -0.071710, -0.037770, -0.051290, -0.081410, -0.072400, 
-0.104640, -0.006510, 0.008150, -0.073150, -0.110750, -0.089280, -0.025110, -0.047470, -0.059160, -0.095180, 
0.000160, 0.017450, -0.041050, -0.073640, -0.114290, 0.024240, -0.135100, -0.069210, -0.057740, -0.077240, 
-0.046180, -0.108830, -0.101620, 0.000650, -0.064970, -0.118950, -0.080390, -0.048100, -0.059120, 0.002390, 
-0.103230, -0.007340, 0.021420, -0.055610, 0.022670, -0.107890, 0.003430, -0.103140, -0.080090, -0.093070, 
-0.027220, -0.095460, -0.021060, -0.056240, -0.058340, -0.082750, -0.076800, -0.118660, -0.071560, -0.097710, 
-0.046290, -0.029910, -0.083790, 
-0.105670, -0.001460, -0.045300, -0.131480, 0.045640, -0.224490, -0.064890, -0.003760, -0.145050, -0.099150, 
-0.037610, -0.032970, -0.022150, -0.088580, 0.081200, -0.146820, -0.185000, 0.012660, 0.090270, -0.072210, 
-0.033450, -0.167890, -0.002670, 0.091900, 0.013470, -0.019570, -0.104770, 0.001720, -0.126420, -0.178430, 
-0.217300, -0.007930, -0.029390, 0.003030, 0.061750, -0.015640, -0.114670, -0.132490, -0.106800, -0.008700, 
-0.106680, 0.008570, -0.160160, 0.029540, -0.059850, -0.075060, -0.026690, 0.070100, -0.054590, -0.228060, 
-0.179850, -0.169460, 0.024580, -0.052510, 0.081170, -0.044770, -0.024840, -0.015930, -0.067810, -0.152580, 
-0.034230, -0.024140, -0.069360, -0.106190, 0.097160, 0.042370, -0.169820, -0.107100, 0.272260, -0.018440, 
-0.217220, -0.190950, -0.005770, -0.069190, -0.001630, 0.076920, -0.105810, -0.169990, -0.054110, -0.135400, 
-0.205750, -0.047390, -0.086650, 0.003750, -0.181400, 0.075170, 0.043150, -0.094480, -0.249680, 0.094480, 
0.000190, -0.203400, -0.075780, -0.159830, -0.097800, 0.055080, 0.195210, -0.067960, -0.089400, -0.047000, 
-0.090220, -0.333580, -0.020940, -0.051140, 0.078000, -0.121660, 0.001840, 0.196430, 0.036710, -0.274860, 
0.024120, 0.048040, -0.318090, -0.082560, -0.286690, -0.144420, 0.206410, 0.357740, -0.078320, -0.055200, 
-0.035390, -0.204510, -0.437480, -0.139910, -0.231430, 0.326300, -0.065040, -0.059610, 0.163040, 0.028980, 
-0.168290, 0.115530, 0.009980, -0.362750, -0.086510, -0.311300, -0.107930, 0.187760, 0.470410, -0.076990, 
-0.092940, -0.016050, -0.139720, -0.406700, -0.188920, -0.125400, 0.009920, -0.101090, -0.060530, 0.055810, 
-0.049370, -0.178300, 0.281790, -0.021850, -0.371600, -0.082140, -0.283200, -0.151410, 0.088630, 0.439160, 
-0.077220, -0.076650, -0.125500, -0.091190, -0.314440, -0.178460, -0.190010, 0.257550, -0.116410, 0.013440, 
0.041550, -0.105140, -0.154090, 0.091900, 0.012370, -0.206190, -0.089520, -0.257940, -0.120540, 0.032600, 
0.349970, -0.038380, 0.018820, -0.248290, -0.042410, -0.208600, -0.146930, -0.168390, 0.123600, -0.137300, 
-0.007910, -0.026050, -0.230180, -0.086920, 0.114250, -0.016470, -0.166650, -0.114750, -0.131070, -0.088650, 
-0.000090, 0.288140, -0.073680, -0.068170, -0.072420, -0.033000, -0.238530, -0.072970, -0.087180, 0.041580, 
-0.006180, -0.019130, -0.051940, -0.197640, -0.092900, 0.018070, -0.084720, -0.153290, -0.126070, -0.148200, 
-0.125160, 0.015170, 0.198900, -0.086110, -0.091540, -0.060770, -0.009520, -0.088690, -0.053910, -0.074740, 
0.006910, 0.089420, 0.064430, -0.048040, -0.152580, -0.088130, -0.139460, -0.061520, -0.144340, -0.060150, 
-0.140010, -0.155480, 0.006520, 0.114140, -0.078510, -0.113400, -0.065170, -0.040300, -0.094240, 0.026470, 
-0.143200, 0.016050, 0.112220, -0.081440, 0.014660, -0.104240, -0.113620, -0.236440, 0.002610, -0.092460, 
-0.049140, -0.107440, -0.065540, 0.037610, -0.011930, 0.014960, -0.083890, -0.119260, -0.113940, -0.137670, 
-0.012700, 0.018730, -0.036730, 
0.404360, -0.453660, 0.105620, 0.439970, 0.229880, -0.126900, -0.230970, -0.498120, -0.375630, -0.055590, 
0.145710, 0.046070, 0.052550, -0.258010, -0.701350, -0.017500, 0.443060, -0.495990, -0.694220, -0.070380, 
0.190310, 0.123360, -0.145070, 0.019400, 0.455810, -0.067290, 0.035280, 0.163700, -0.996450, -0.060320, 
-0.256110, -0.044670, -0.008830, -0.295990, 0.043990, -0.493940, 0.414540, 0.157670, -0.585010, -0.408130, 
-0.151370, 0.172600, -0.137500, -0.456830, 0.076590, 0.206860, -0.403650, 0.423030, -0.232760, -0.490580, 
0.286510, -0.458590, -0.463780, 0.467640, -0.060520, -0.342490, -0.350550, 0.212620, 0.150920, -0.414010, 
-0.113570, -0.268360, 0.417680, -0.432980, -0.495830, 0.785480, 0.078810, -0.335280, 0.484580, -0.034130, 
-0.786240, 0.685610, -0.604870, -0.622820, 0.458220, 0.164440, 0.100200, -0.052150, 0.099060, 0.125380, 
-0.384090, -0.785240, -0.241240, -0.150870, -0.271740, -0.295880, 0.768390, -0.259850, -0.483060, 0.563820, 
-0.466380, -0.346270, 0.584910, -0.951690, -0.102630, 0.599980, 0.181160, -0.216620, 0.309940, -0.095030, 
0.449770, -0.496480, -0.106460, -0.454860, -0.806680, 0.416590, -0.251010, -0.021440, -0.382660, -0.113700, 
-0.661350, -0.217430, -0.206840, 0.095080, 0.029860, 0.076090, 0.010780, -0.259960, 0.007260, 0.000920, 
-0.679030, 0.653740, 0.367840, 0.192840, 0.261080, -1.267850, 0.595030, 0.029690, -1.648310, 0.223930, 
-0.172420, -1.043390, 0.191750, 0.612330, 0.402340, 0.470990, 0.352660, -1.506710, -3.066000, 0.000360, 
0.132180, -0.303750, 0.792740, 1.225290, -0.027600, 0.769690, 0.000120, 0.440570, 0.358100, -2.098670, 
-0.254370, 1.088000, -1.194870, -0.067440, 1.213280, -0.494000, 1.078440, 0.721940, -1.067340, -2.815120, 
-0.284600, -0.411730, -0.146110, -0.253920, 1.576220, 0.536200, 0.926540, -0.783730, -0.277340, -0.222580, 
-1.942530, 0.435640, 0.562030, -0.940140, -0.093950, 0.739080, 0.144870, 0.589970, 0.686210, -0.457490, 
-2.694790, 0.317870, 0.303110, -0.115290, 0.081130, 0.881440, 0.563010, 0.314460, -0.807710, -0.213890, 
0.682560, -1.397980, -0.319150, 0.574220, -0.544890, -0.199530, 1.049180, -0.039150, 0.960180, 0.483840, 
-0.621750, -1.465940, -0.303960, -0.232440, -0.898360, 0.024960, 1.096510, -0.024020, 0.106050, -0.669100, 
-0.294840, 0.175640, -0.528980, -0.280420, 0.327250, -0.929330, -0.425280, 0.356340, -0.077040, 0.119170, 
-0.020520, -0.612290, -0.311500, 0.048840, 0.351250, -0.327600, -0.053040, 0.531870, 0.184200, 0.342270, 
-0.500540, -0.093970, 0.234730, -0.123020, -0.597980, -0.012700, -0.473060, 0.104730, 0.180080, -0.244200, 
0.062550, 0.116550, -0.269780, -0.034670, -0.119400, -0.121060, 0.023450, 0.180280, 0.034140, -0.160430, 
-0.204130, -0.363990, -0.672410, -0.016700, 0.047980, 0.184410, -0.040730, 0.065600, 0.284960, -0.009350, 
0.043330, -0.541660, -0.329590, 0.197490, 0.177870, 0.010110, -0.140790, -0.044880, 0.039910, -0.434380, 
-0.401010, -0.121150, -0.224140, 
-0.073570, -0.034480, -0.407490, 0.027700, -0.562130, 0.290830, -0.185180, -0.568930, 0.144650, -0.519890, 
-0.569660, 0.084930, 0.008790, 0.612450, -0.044370, 0.077520, -0.172540, -0.019800, -0.762670, -0.379900, 
0.313980, -0.385840, -0.265770, 0.203900, 0.097040, -0.614750, 0.493710, 0.256960, -0.298280, 0.703440, 
-0.772430, -0.918790, 0.220310, 0.019570, -0.369400, -0.290510, 0.028380, -0.246330, -0.112210, -0.551280, 
-0.030950, 0.093350, -0.050600, -0.233450, 0.329230, -0.249960, -0.395050, -0.100920, -0.093370, -0.231970, 
0.241980, -0.011710, -0.209530, -0.046260, 0.163960, 0.070910, -0.394310, -0.314080, -0.725620, 0.238350, 
-0.283540, 0.022310, -0.429660, -0.958690, -0.421790, 0.157970, -0.246250, -0.335590, 0.045830, 0.224640, 
0.191420, 0.314660, -0.591830, -0.581390, 0.054990, 0.104480, -0.424240, 0.262670, -0.227140, 0.831880, 
0.116420, -0.270070, -0.063140, -0.858340, 0.747970, -0.467220, -0.348660, -1.072750, 0.760090, -0.678030, 
-0.457960, 0.883780, -0.964360, 0.815900, 0.571450, -1.311400, -0.489730, 0.133490, 0.019660, -1.484630, 
-0.646420, 1.290300, 0.488630, 0.696000, -1.204690, -0.407820, -0.518360, -0.797390, 1.074940, -0.230780, 
-1.359040, -0.196510, 0.456040, 0.275540, -0.408470, -0.020430, -1.108660, -0.704750, -0.127240, 0.242520, 
0.633170, 0.718060, 0.538240, -0.318990, 0.267290, -0.673470, 1.229260, 0.615910, -3.611980, -0.202920, 
2.016510, -0.359900, -0.675900, 2.471110, -1.826590, 1.589870, 1.411730, -2.564670, -2.080070, -1.605300, 
-0.865970, -1.130440, -1.250520, 2.285480, 0.732880, 1.101870, -0.005770, -1.241170, -0.325150, -0.524020, 
1.523390, -0.347030, -1.208580, 0.107620, 0.731410, 0.493830, -0.612990, -0.126790, -0.779760, -1.412650, 
0.258000, 0.256120, 0.221980, 0.418350, 0.150210, -0.107820, 0.243410, -0.424420, -0.173810, 0.906250, 
0.094700, -1.758970, 0.868220, 0.035660, -0.918910, 1.525410, -1.258070, 0.946520, 0.518560, -1.473550, 
-0.219310, -0.292990, -0.800120, -0.317520, -1.078460, 1.110520, -0.140420, 0.038740, -0.313330, 0.038560, 
-0.305690, 0.381450, 0.613280, -0.784480, -0.035200, 0.102980, -0.667560, 0.191430, -0.643430, -0.771000, 
-0.121280, 0.029860, -0.514580, 0.246590, 0.226110, 0.297960, -0.132860, -0.192510, -0.043230, -0.645220, 
-0.040560, 0.411550, 0.189420, -0.600220, -0.451380, 0.442490, 0.271450, -0.141290, -0.359440, -0.305130, 
0.091670, -0.215390, 0.236160, -0.526400, -0.752610, 0.155280, -0.423620, 0.022010, -0.613810, -0.281700, 
0.208980, 0.005670, -0.031480, 0.505350, -0.639040, -0.944320, 0.842090, 0.050510, -0.671470, 0.309390, 
-0.854920, -0.065090, 0.350250, 0.206990, -0.471390, -0.104960, 0.240660, -0.355610, -0.565770, -0.323320, 
0.208520, -0.451590, -0.515280, 0.089770, 0.031450, -0.429210, -0.549210, 0.339520, 0.269940, -0.842500, 
-0.127390, -0.720960, -0.493570, 0.405540, 0.246810, 0.005400, -0.266340, 0.096650, 0.172390, -0.358720, 
-0.195430, -0.120640, 0.237520, 
-0.106900, -0.050700, -0.355850, 0.292150, -0.031120, -0.259100, -0.183830, -0.019120, -0.141890, -0.181740, 
0.066660, -0.093570, 0.187120, 0.025370, -0.050820, -0.112140, -0.043210, -0.008960, 0.017210, -0.099530, 
-0.212340, 0.083280, -0.001700, -0.346190, -0.006500, -0.095040, -0.283830, -0.042790, 0.053340, -0.347600, 
0.024040, 0.039350, -0.272310, -0.051590, -0.243000, -0.056210, -0.123510, 0.046640, 0.252420, 0.134940, 
-0.049050, -0.066530, -0.041520, -0.147730, -0.297520, -0.133630, 0.049530, -0.195860, -0.095940, -0.017600, 
-0.140820, 0.123850, -0.152640, -0.035700, -0.132570, -0.154440, 0.012200, -0.089500, -0.091390, 0.187180, 
0.029330, -0.007750, -0.018390, -0.049870, -0.138180, -0.092470, 0.136490, -0.052390, -0.161510, -0.032050, 
-0.303810, 0.090480, 0.003550, -0.255110, -0.201200, -0.187360, 0.025490, 0.053370, 0.025070, -0.199900, 
0.117160, -0.239410, -0.088010, 0.150830, 0.102630, -0.245110, 0.238790, 0.044500, -0.213380, -0.187910, 
0.011410, -0.356360, 0.189870, -0.456080, -0.159160, 0.108690, -0.094290, 0.111350, -0.030650, -0.014550, 
-0.141810, -0.165950, -0.265860, -0.105770, 0.272590, -0.044680, -0.281530, 0.162800, -0.295910, -0.216640, 
0.126510, -0.097140, -0.278700, 0.031290, -0.373710, -0.216430, 0.226680, 0.394270, -0.036600, -0.301290, 
-0.219710, -0.119220, -0.050780, -0.438370, -0.072140, 0.685890, -0.273490, -0.187380, 0.501330, -0.545990, 
-0.404290, 0.849330, 0.015880, -0.458030, 0.006730, -0.678130, -0.365870, 0.516530, 0.856710, -0.252760, 
-0.029180, 0.051730, -0.044010, -0.196650, -0.389410, -0.314020, -0.007070, -0.399690, -0.511070, 0.189890, 
-0.329220, -0.530830, 0.152700, -0.017700, -0.478650, 0.221910, -0.700730, -0.482930, 0.126040, 1.166310, 
-0.108840, -0.009900, 0.137480, -0.064530, 0.135400, -0.237620, -0.284590, 0.677550, -0.226090, -0.391060, 
0.116010, 0.145370, -0.442000, 0.198730, -0.111540, -0.427040, 0.112570, -0.598770, -0.488410, 0.019680, 
0.719880, -0.101710, 0.045600, 0.284500, 0.074860, -0.137530, -0.156080, -0.262850, 0.301480, -0.281560, 
-0.149150, 0.085440, 0.345160, -0.152400, -0.327240, -0.068300, -0.283710, -0.104030, -0.121060, -0.275190, 
-0.194400, 0.372920, -0.161600, -0.006150, 0.094140, 0.072910, -0.077520, -0.073870, -0.136330, 0.031060, 
-0.102470, 0.115140, -0.082180, 0.075050, 0.037150, -0.484440, -0.078280, 0.170060, -0.262500, -0.175160, 
-0.047500, -0.292480, -0.138940, -0.025710, 0.121090, 0.068560, 0.125930, -0.039440, -0.115180, -0.007210, 
-0.179280, -0.053740, 0.039680, 0.026520, 0.042240, 0.103120, -0.333430, -0.042370, 0.104150, -0.182230, 
0.038430, 0.078760, -0.342960, -0.255420, -0.070120, 0.048530, -0.011640, -0.094840, -0.090380, -0.084260, 
0.026250, -0.302830, -0.301130, 0.035280, 0.198840, 0.133780, 0.044220, -0.208830, 0.059450, -0.014710, 
-0.167910, -0.295070, -0.094320, -0.171860, -0.046040, -0.033800, -0.046630, 0.071950, 0.023070, 0.008000, 
-0.074370, -0.053620, -0.371390, 
-0.028540, 0.048210, -0.262380, 0.199480, -0.011400, 0.090200, 0.154840, -0.213680, -0.163450, 0.007160, 
0.034120, -0.113210, -0.354140, -0.350430, -0.097740, 0.583860, 0.114800, 0.270660, -0.245200, -0.022520, 
-0.946220, 0.211830, 0.102910, -0.446760, -0.240080, -0.171490, -0.422310, 0.077950, 0.465290, -0.482760, 
0.015330, -0.163710, -0.255520, -0.703770, -0.404060, 0.205890, 0.475020, 0.150050, 0.276060, 0.516220, 
0.037080, -0.598440, 0.504450, -0.149920, -0.186580, -0.153730, -0.278110, -0.238510, -0.185210, 0.544710, 
0.171360, -0.068270, -0.098490, -0.463520, -0.604620, -0.120120, -0.005290, -0.249240, -0.050330, 0.323760, 
0.127720, 0.176400, -0.384830, 0.702470, -0.294520, -0.254380, -0.292830, 0.318220, -0.358230, -0.115570, 
0.444880, -0.115900, 0.224650, 0.047940, -0.232500, -0.806350, -0.022750, 0.166430, -0.410140, 0.004620, 
0.363450, -0.029280, 0.047200, -0.685070, 0.771090, -0.042500, -1.188480, -0.760580, 1.063060, -0.890470, 
-0.338900, 0.891290, -0.210320, 0.611500, 0.507100, -0.490080, -1.196750, 0.002550, -0.275840, -0.308330, 
-0.168380, 0.523900, 0.471980, 0.475940, -0.796540, 0.525280, 0.322040, -1.853720, -0.540980, 0.620710, 
-1.006800, -0.307180, 1.137470, 0.322520, 1.244140, 0.614990, -1.368970, -2.222670, -0.231400, -0.238170, 
-0.506250, -0.023380, 1.346780, 0.803260, 0.707520, -0.700670, -0.163930, 0.081810, -1.529690, -0.867650, 
0.455140, -0.895140, 0.062790, 1.050710, 0.106750, 1.134400, 0.571870, -0.129770, -2.824590, -0.403630, 
0.044330, 0.203570, 0.447540, 0.589320, 0.521470, 0.183030, -0.008590, 0.039180, 0.051230, -1.475840, 
-0.690080, 0.284030, -0.347370, 0.185790, 0.680520, -0.001600, 0.978020, 0.309780, -0.009490, -1.175350, 
-0.573140, -0.023660, 0.120150, 0.144340, 0.653440, 0.192970, 0.276390, -0.931790, -0.386300, -0.145610, 
-0.728530, -0.683430, -0.145720, 0.861320, 0.431440, 0.245660, -0.247420, 0.396430, 0.103100, 0.077200, 
-0.056580, -0.639230, -0.114110, 0.229990, -0.072870, 0.139180, 0.113180, 0.047840, -0.761110, -0.485400, 
-0.531850, 0.034440, -0.272250, -0.140450, 0.584930, 0.204650, -0.096900, -0.318930, 0.411950, -0.063330, 
-0.325750, 0.452040, -0.474630, -0.505040, 0.372440, 0.322260, -0.053610, -0.175280, -0.020640, -0.232850, 
-0.690370, 0.137340, -0.151610, -0.505150, -0.052430, 0.041740, -0.155170, 0.339400, -0.569530, 0.177230, 
-0.249180, -0.174330, 0.483980, -0.061420, -0.002500, 0.284440, 0.027380, -0.269690, -0.095860, -0.042280, 
0.175100, -0.982190, 0.194120, -0.199990, -0.144310, 0.311160, 0.376690, 0.042130, -0.395100, -0.278490, 
0.062440, -0.492010, 0.151330, 0.566440, -0.064430, -0.492560, 0.150910, 0.103010, 0.278580, -0.461580, 
0.059000, -0.093950, -0.617140, 0.075150, 0.501430, 0.139880, -0.132920, -0.058210, 0.219540, -0.166730, 
-0.400430, -0.227820, -0.796060, -0.124900, 0.384170, -0.299870, -0.285450, 0.150000, 0.241790, 0.205920, 
-0.030790, -0.092560, -0.031170, 
2.698930, -2.533980, -0.253700, 2.174970, -4.149190, -3.002010, -0.190370, 4.086160, 4.461980, -0.510720, 
-3.050400, 2.028470, -3.529690, -0.444990, -0.474180, -0.011950, -0.081690, -0.226070, 0.281570, -0.316440, 
-0.139540, 0.005580, 3.233140, -0.087740, -0.148700, -0.287620, -1.678380, -4.074640, -0.643980, 2.251520, 

-0.939380, -1.330230, -0.395390, -3.527150, 3.973800, -0.593200, -1.127300, -3.759560, -4.189680, -1.174320, 
3.470740, -1.023120, 0.287910, -0.965080, -1.467810, -1.150160, -1.159960, -0.739150, -2.899140, -1.303350, 
-2.703990, -0.813100, -1.361810, -0.524300, -0.812420, -0.975830, 3.130890, 3.916840, -1.116100, -0.139890, 

-1.819580, 1.663620, -0.559020, -0.686110, 2.404010, 2.362740, -0.324590, -2.847480, -2.506500, -0.192890, 
-2.132720, -0.554890, 1.674840, -0.301080, 1.000840, -1.687270, 0.157520, 0.088990, 0.895570, -0.244570, 
1.279370, 0.278830, -2.523150, -0.375950, -0.157020, 0.093120, -1.964470, -1.772760, 0.242820, -2.087930, 


  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[307] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.010000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, 0.009980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.009170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.002710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.008150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, -0.000540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.000910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, 0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, -0.006630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.008630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, -0.001360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, -0.001120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, 0.008980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, 0.009620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.004950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, -0.007520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.000630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, -0.008410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, -0.000310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, -0.006210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, 0.006230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.001410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, 0.008460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, -0.006310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, -0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, 0.007630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.007880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, -0.005690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, 0.002430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, -0.003580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.003620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, -0.005050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.009880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, -0.002490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.007470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.002350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.005420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, 0.006270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, 0.000070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, -0.000190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, 0.003680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, -0.004030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, 0.002660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, -0.007530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, 0.002580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, 0.001440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, -0.000850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, -0.003360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, 0.006580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, -0.006620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.007240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, -0.005380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.008950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, -0.009330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, 0.003310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.008360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, 0.004590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.008510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.003520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.006200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.000720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.001380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.000240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, -0.004780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, -0.007430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, -0.001560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, 0.003330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, 0.002140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, 0.006460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.007760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.007050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.006220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, -0.009100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.008090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.003720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.007460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, 0.009920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, 0.009990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, 0.006140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, -0.001740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, 0.002500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, 0.009460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.000700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, -0.005710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.001160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.004240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.007070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.000520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, 0.004670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, -0.005670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, 0.000640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.006060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.001060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.005140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.000680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, -0.007380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, 0.007320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, -0.006920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.009640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, -0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, -0.003400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, -0.006000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.007140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, -0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.005490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.002680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.008890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, -0.007700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.001100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.006740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.001500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.000400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, 0.009380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, -0.002170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, -0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.006350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.000500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, -0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, 0.003820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, -0.008850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.002240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, -0.008610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.008230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, 0.003250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, -0.000660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.005360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, -0.005040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.008180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.007080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, 0.006510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, 0.001620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, 0.004070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, 0.002440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, 0.001630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, 0.002380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, 0.004000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, 0.009580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, 0.009260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.005580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, 0.000110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, -0.007650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 165 (Old: 165) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 166 (Old: 166) */
      0.0, 0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 167 (Old: 167) */
      0.0, 0.007600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 168 (Old: 168) */
      0.0, -0.000960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 169 (Old: 169) */
      0.0, 0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 170 (Old: 170) */
      0.0, 0.000860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 171 (Old: 171) */
      0.0, -0.001760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 172 (Old: 172) */
      0.0, -0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 173 (Old: 173) */
      0.0, 0.008600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 174 (Old: 174) */
      0.0, -0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 175 (Old: 175) */
      0.0, 0.001940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 176 (Old: 176) */
      0.0, -0.001710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 177 (Old: 177) */
      0.0, 0.006180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 178 (Old: 178) */
      0.0, -0.007850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 179 (Old: 179) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 180 (Old: 180) */
      0.0, 0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 181 (Old: 181) */
      0.0, 0.007690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 182 (Old: 182) */
      0.0, 0.006820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 183 (Old: 183) */
      0.0, -0.009850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 184 (Old: 184) */
      0.0, -0.003630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 185 (Old: 185) */
      0.0, -0.006240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 186 (Old: 186) */
      0.0, -0.002840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 187 (Old: 187) */
      0.0, 0.003410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 188 (Old: 188) */
      0.0, -0.004750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 189 (Old: 189) */
      0.0, -0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 190 (Old: 190) */
      0.0, -0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 191 (Old: 191) */
      0.0, -0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 192 (Old: 192) */
      0.0, 0.002820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 193 (Old: 193) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 194 (Old: 194) */
      0.0, 0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 195 (Old: 195) */
      0.0, -0.006300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 196 (Old: 196) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 197 (Old: 197) */
      0.0, 0.004510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 198 (Old: 198) */
      0.0, 0.009110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 199 (Old: 199) */
      0.0, -0.002020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 200 (Old: 200) */
      0.0, -0.000280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 201 (Old: 201) */
      0.0, -0.002600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 202 (Old: 202) */
      0.0, 0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 203 (Old: 203) */
      0.0, 0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 204 (Old: 204) */
      0.0, 0.000950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 205 (Old: 205) */
      0.0, -0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 206 (Old: 206) */
      0.0, -0.004860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 207 (Old: 207) */
      0.0, 0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 208 (Old: 208) */
      0.0, -0.002360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 209 (Old: 209) */
      0.0, -0.002370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 210 (Old: 210) */
      0.0, -0.007090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 211 (Old: 211) */
      0.0, 0.006370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 212 (Old: 212) */
      0.0, 0.003840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 213 (Old: 213) */
      0.0, 0.009530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 214 (Old: 214) */
      0.0, 0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 215 (Old: 215) */
      0.0, -0.009030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 216 (Old: 216) */
      0.0, -0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 217 (Old: 217) */
      0.0, 0.005900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 218 (Old: 218) */
      0.0, -0.002080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 219 (Old: 219) */
      0.0, -0.008710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 220 (Old: 220) */
      0.0, -0.001190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 221 (Old: 221) */
      0.0, -0.000940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 222 (Old: 222) */
      0.0, 0.001220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 223 (Old: 223) */
      0.0, 0.001000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 224 (Old: 224) */
      0.0, 0.003860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 225 (Old: 225) */
      0.0, 0.005980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 226 (Old: 226) */
      0.0, 0.005680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 227 (Old: 227) */
      0.0, 0.009000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 228 (Old: 228) */
      0.0, 0.005810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 229 (Old: 229) */
      0.0, -0.001490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 230 (Old: 230) */
      0.0, -0.008300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 231 (Old: 231) */
      0.0, 0.001690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 232 (Old: 232) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 233 (Old: 233) */
      0.0, 0.002890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 234 (Old: 234) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 235 (Old: 235) */
      0.0, 0.002160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 236 (Old: 236) */
      0.0, 0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 237 (Old: 237) */
      0.0, 0.004290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 238 (Old: 238) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 239 (Old: 239) */
      0.0, 0.001110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 240 (Old: 240) */
      0.0, -0.008520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 241 (Old: 241) */
      0.0, -0.008430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 242 (Old: 242) */
      0.0, -0.002120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 243 (Old: 243) */
      0.0, -0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 244 (Old: 244) */
      0.0, 0.009710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 245 (Old: 245) */
      0.0, -0.003730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 246 (Old: 246) */
      0.0, -0.006890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 247 (Old: 247) */
      0.0, 0.007410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 248 (Old: 248) */
      0.0, 0.008810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 249 (Old: 249) */
      0.0, 0.009740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 250 (Old: 250) */
      0.0, 0.002180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 251 (Old: 251) */
      0.0, -0.007310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 252 (Old: 252) */
      0.0, 0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 253 (Old: 253) */
      0.0, -0.008490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 254 (Old: 254) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 255 (Old: 255) */
      0.0, -0.003240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 256 (Old: 256) */
      0.0, -0.003100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 257 (Old: 257) */
      0.0, 0.008470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 258 (Old: 258) */
      0.0, 0.008140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 259 (Old: 259) */
      0.0, 0.009930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 260 (Old: 260) */
      0.0, -0.000530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 261 (Old: 261) */
      0.0, -0.005800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 262 (Old: 262) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 263 (Old: 263) */
      0.0, -0.000920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 264 (Old: 264) */
      0.0, -0.005970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 265 (Old: 265) */
      0.0, -0.004540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 266 (Old: 266) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 267 (Old: 267) */
      0.0, 0.004900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 268 (Old: 268) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 269 (Old: 269) */
      0.0, 0.000340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 270 (Old: 270) */
      0.0, 0.000650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 271 (Old: 271) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 272 (Old: 272) */
      0.0, -0.000080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 273 (Old: 273) */
      0.0, -0.007170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 274 (Old: 274) */
      0.0, -1.770990, 273,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 275 (Old: 275) */
      0.0, -1.613070, 273,
       &Sources[273] , 
       &Weights[273] , 
      },
    { /* unit 276 (Old: 276) */
      0.0, -1.284440, 273,
       &Sources[546] , 
       &Weights[546] , 
      },
    { /* unit 277 (Old: 277) */
      0.0, -2.278790, 273,
       &Sources[819] , 
       &Weights[819] , 
      },
    { /* unit 278 (Old: 278) */
      0.0, 2.670180, 273,
       &Sources[1092] , 
       &Weights[1092] , 
      },
    { /* unit 279 (Old: 279) */
      0.0, -1.961430, 273,
       &Sources[1365] , 
       &Weights[1365] , 
      },
    { /* unit 280 (Old: 280) */
      0.0, -1.262330, 273,
       &Sources[1638] , 
       &Weights[1638] , 
      },
    { /* unit 281 (Old: 281) */
      0.0, -2.397960, 273,
       &Sources[1911] , 
       &Weights[1911] , 
      },
    { /* unit 282 (Old: 282) */
      0.0, -2.488930, 273,
       &Sources[2184] , 
       &Weights[2184] , 
      },
    { /* unit 283 (Old: 283) */
      0.0, -1.146810, 273,
       &Sources[2457] , 
       &Weights[2457] , 
      },
    { /* unit 284 (Old: 284) */
      0.0, -2.345050, 273,
       &Sources[2730] , 
       &Weights[2730] , 
      },
    { /* unit 285 (Old: 285) */
      0.0, 0.681490, 273,
       &Sources[3003] , 
       &Weights[3003] , 
      },
    { /* unit 286 (Old: 286) */
      0.0, -1.631500, 273,
       &Sources[3276] , 
       &Weights[3276] , 
      },
    { /* unit 287 (Old: 287) */
      0.0, -1.178420, 273,
       &Sources[3549] , 
       &Weights[3549] , 
      },
    { /* unit 288 (Old: 288) */
      0.0, -1.240810, 273,
       &Sources[3822] , 
       &Weights[3822] , 
      },
    { /* unit 289 (Old: 289) */
      0.0, -1.349390, 273,
       &Sources[4095] , 
       &Weights[4095] , 
      },
    { /* unit 290 (Old: 290) */
      0.0, -1.163130, 273,
       &Sources[4368] , 
       &Weights[4368] , 
      },
    { /* unit 291 (Old: 291) */
      0.0, -1.279560, 273,
       &Sources[4641] , 
       &Weights[4641] , 
      },
    { /* unit 292 (Old: 292) */
      0.0, -0.873180, 273,
       &Sources[4914] , 
       &Weights[4914] , 
      },
    { /* unit 293 (Old: 293) */
      0.0, -1.041890, 273,
       &Sources[5187] , 
       &Weights[5187] , 
      },
    { /* unit 294 (Old: 294) */
      0.0, -1.161310, 273,
       &Sources[5460] , 
       &Weights[5460] , 
      },
    { /* unit 295 (Old: 295) */
      0.0, -1.256790, 273,
       &Sources[5733] , 
       &Weights[5733] , 
      },
    { /* unit 296 (Old: 296) */
      0.0, -2.288010, 273,
       &Sources[6006] , 
       &Weights[6006] , 
      },
    { /* unit 297 (Old: 297) */
      0.0, -1.337940, 273,
       &Sources[6279] , 
       &Weights[6279] , 
      },
    { /* unit 298 (Old: 298) */
      0.0, -1.238100, 273,
       &Sources[6552] , 
       &Weights[6552] , 
      },
    { /* unit 299 (Old: 299) */
      0.0, -1.224600, 273,
       &Sources[6825] , 
       &Weights[6825] , 
      },
    { /* unit 300 (Old: 300) */
      0.0, -1.934590, 273,
       &Sources[7098] , 
       &Weights[7098] , 
      },
    { /* unit 301 (Old: 301) */
      0.0, -2.718330, 273,
       &Sources[7371] , 
       &Weights[7371] , 
      },
    { /* unit 302 (Old: 302) */
      0.0, -1.361150, 273,
       &Sources[7644] , 
       &Weights[7644] , 
      },
    { /* unit 303 (Old: 303) */
      0.0, -1.337460, 273,
       &Sources[7917] , 
       &Weights[7917] , 
      },
    { /* unit 304 (Old: 304) */
      0.0, 1.578490, 30,
       &Sources[8190] , 
       &Weights[8190] , 
      },
    { /* unit 305 (Old: 305) */
      0.0, -1.687200, 30,
       &Sources[8220] , 
       &Weights[8220] , 
      },
    { /* unit 306 (Old: 306) */
      0.0, -1.129350, 30,
       &Sources[8250] , 
       &Weights[8250] , 
      }

  };



int net_phd(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[273] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, Units + 271, Units + 272, Units + 273}; /* members */

  static pUnit Hidden1[30] = {Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303}; /* members */

  static pUnit Output1[3] = {Units + 304, Units + 305, Units + 306}; /* members */

  static int Output[3] = {304, 305, 306};

  for(member = 0; member < 273; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 30; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
