/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  net_phd111.c
  --------------------------------------------------------
  generated at Fri Jun 25 17:47:39 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[307];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, 
Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, 
Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, 

Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, 
Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, 
Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, 

Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, 
Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, 
Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, 


  };

  /* Weigths definition section */
  static float Weights[] =  {
-0.077400, -0.069760, -0.103310, -0.156570, 0.004060, 0.000890, -0.014100, -0.046460, -0.161890, -0.170710, 
0.023500, -0.021510, -0.130270, -0.079500, -0.104660, -0.053860, -0.087370, -0.001090, -0.031260, 0.049910, 
-0.040910, -0.039770, -0.052090, -0.047670, -0.179540, -0.037840, 0.060080, -0.063590, -0.074860, -0.116190, 
-0.110390, -0.054860, 0.024500, -0.103040, -0.085850, -0.125780, -0.063410, -0.094730, -0.013430, -0.050930, 
-0.041270, -0.001810, -0.085610, 0.003240, -0.107470, -0.177750, -0.005990, 0.117510, 0.000060, -0.017320, 
-0.278190, -0.055670, 0.003390, -0.121320, -0.119250, -0.181860, -0.151810, -0.031020, 0.008710, 0.008940, 
-0.061790, 0.001440, -0.017330, -0.099360, 0.029840, -0.124160, -0.389760, 0.041820, 0.192920, -0.025480, 
-0.001740, -0.297100, 0.036340, 0.055060, -0.078750, -0.082660, -0.246990, -0.144640, -0.069720, 0.001890, 
0.002150, 0.032100, -0.002500, -0.126820, -0.029090, -0.088140, -0.079090, -0.123960, -0.078560, 0.164360, 
-0.056500, -0.061360, -0.170320, -0.092320, 0.061670, -0.132370, -0.004890, -0.119830, -0.110080, -0.037510, 
-0.121820, -0.041730, 0.067740, -0.044360, -0.191770, 0.097160, -0.028430, -0.013650, 0.120110, -0.081370, 
0.083340, -0.074060, -0.048180, -0.183430, -0.100200, 0.051880, -0.163600, -0.172600, -0.058000, -0.148060, 
-0.007320, -0.144090, -0.176080, 0.094690, -0.029410, -0.320680, 0.070840, 0.046500, -0.308230, 0.020420, 
0.186720, -0.152050, -0.097580, 0.223560, -0.314980, 0.171030, 0.146140, -0.358700, -0.404510, -0.140930, 
-0.253410, -0.216450, -0.175090, 0.079590, 0.124430, 0.053520, 0.005630, 0.149880, 0.110260, -0.164660, 
0.043960, 0.158960, -0.135850, -0.093700, 0.169790, -0.188760, 0.318410, 0.191690, -0.249490, -0.767300, 
-0.000990, -0.100470, -0.193700, -0.143410, -0.076920, 0.023450, 0.002390, -0.309320, 0.159700, 0.058330, 
-0.058810, -0.048420, 0.021590, -0.202820, -0.051610, -0.032730, -0.051790, 0.055340, 0.095040, -0.124570, 
-0.456320, 0.143220, -0.011070, -0.152130, -0.140690, -0.170830, -0.040440, -0.085700, -0.219020, 0.206890, 
0.007990, -0.177710, -0.197360, 0.078920, -0.108890, -0.009090, 0.003020, -0.088400, 0.162710, 0.092120, 
-0.232620, -0.367550, 0.086640, -0.084790, -0.185770, -0.129700, -0.128520, 0.000990, -0.055160, -0.092680, 
0.143170, -0.079340, -0.270530, -0.271060, 0.022030, -0.103390, -0.001500, 0.012100, -0.126080, 0.301080, 
0.103000, -0.133990, -0.212590, -0.076200, -0.153380, -0.208350, -0.168110, -0.002050, -0.014820, -0.048100, 
-0.034130, 0.160330, -0.111450, -0.170560, -0.102490, -0.119320, 0.020120, -0.063690, -0.055730, 0.021280, 
0.130210, 0.018960, -0.124000, -0.150750, 0.019510, -0.077910, -0.169170, -0.190100, -0.103890, -0.049540, 
-0.094730, -0.037160, 0.137430, -0.068400, -0.115130, 0.006710, -0.072170, -0.055200, -0.071630, -0.119350, 
0.004320, -0.017250, 0.064450, -0.093470, -0.217880, 0.055750, -0.052730, -0.147230, -0.109090, -0.134800, 
-0.075780, -0.085210, -0.071260, 
0.643510, 0.087240, -0.603510, 0.428700, 0.190790, -0.654870, -0.444110, -0.199160, 0.323870, 0.300650, 
-0.077210, -0.257100, -0.339300, 0.314680, -0.337920, -0.028990, -0.169930, -0.202220, 0.284230, -0.087090, 
-0.543630, 0.584610, 0.166390, -0.678840, 0.393930, 0.196160, -1.016150, -0.449910, 0.268910, 0.179390, 
0.579400, 0.142490, -0.438510, -0.349180, -0.257920, -0.188760, -0.115120, -0.745110, -0.014180, 0.595600, 
0.029720, -0.205060, 0.635740, -0.187980, 0.199800, 0.604830, -0.251520, -1.163620, -0.000940, 0.055630, 
0.537710, 0.458280, -0.073990, 0.124610, -0.439390, 0.043360, -0.094120, -0.393810, -0.715030, -0.598610, 
0.109790, -0.078300, -0.151250, 0.759470, -0.445860, 0.078860, 0.499750, -0.201230, -1.003660, 0.155690, 
-0.441880, 0.703720, 0.128830, -0.310210, -0.030210, -0.181370, 0.427900, 0.407940, 0.058900, -0.393370, 
-1.067430, -0.533400, -0.066150, 0.153790, 0.318590, -0.414410, 0.352710, 0.612760, -0.310480, -0.034180, 
-0.054160, -1.271500, 0.605630, -0.121810, -0.276020, 0.349690, 0.207650, 0.168470, 0.046800, -0.051110, 
-0.177820, -0.837300, -0.661980, -0.185650, 0.361380, 0.085840, -0.577050, 0.587010, 0.118810, -0.280760, 
0.957210, -0.136960, -1.153890, 0.225770, -0.485420, -0.431480, 0.769520, 0.707910, -0.120470, -0.665030, 
0.152890, -0.347850, -0.740270, -0.979330, -0.595140, 1.584270, -0.645440, -0.811680, 1.216970, -0.201680, 
-0.619380, 1.360330, 0.021830, -1.325950, 0.525480, -0.479340, -0.270090, 1.444520, 1.721310, -0.225740, 
-0.212630, 0.447610, -0.090460, -1.143290, -1.157760, -0.929100, -0.006910, -1.016790, -0.899290, 0.703730, 
-0.204630, -0.600660, 1.069090, -0.106490, -0.890990, 0.446970, -0.892410, -0.686030, 0.341250, 2.115750, 
-0.087600, 0.145000, 0.415880, -0.301530, -0.993860, -0.598230, -0.916140, 1.588520, -0.390690, -0.806710, 
0.381980, 0.218150, -0.708380, -0.243510, -0.276530, -0.628810, 0.314140, -0.201830, -0.509320, 0.013410, 
1.550820, -0.090120, 0.241180, 0.332720, -0.025450, 0.032230, -0.430970, -0.831200, 0.689530, -0.349620, 
-0.430020, 0.409310, 0.542220, -0.428920, -0.792380, -0.127040, -0.449700, -0.231360, -0.156590, -0.331850, 
0.023290, 1.102470, -0.220070, -0.037510, 0.049890, 0.204520, 0.064450, -0.377890, 0.061210, 0.115310, 
-0.008550, 0.254110, 0.152100, 0.542830, -0.205120, -0.840420, -0.092760, 0.229490, -0.430760, -0.207740, 
-0.092270, -0.904200, 0.135040, -0.137880, -0.081620, 0.273570, -0.158860, 0.112150, -0.193820, 0.393920, 
-0.084120, -0.288520, 0.045510, -0.232990, 0.102580, 0.064260, -0.337480, 0.018130, 0.198930, -0.329120, 
0.161680, 0.092510, -0.646900, -0.191240, 0.005330, 0.208490, 0.320280, -0.101190, 0.224210, -0.380410, 
0.207130, -0.477320, -0.477250, -0.293980, -0.078430, 0.149130, 0.172870, -0.452940, 0.268120, 0.523560, 
-0.608130, 0.196680, -0.168870, -0.067510, -0.329620, 0.233570, 0.290440, 0.219460, -0.268530, 0.233940, 
-0.083530, -0.465700, -0.353350, 
-0.058070, -0.040450, -0.059950, -0.104380, -0.044840, -0.105580, -0.013250, -0.065020, -0.081280, -0.106840, 
-0.003720, -0.022050, -0.107930, -0.070840, -0.077600, -0.065110, -0.071820, -0.035870, -0.038870, -0.009070, 
-0.019650, -0.039230, -0.045620, -0.054240, -0.135790, -0.050720, -0.042390, -0.027380, -0.069070, -0.064580, 
-0.086220, -0.047860, -0.000500, -0.087370, -0.063430, -0.066660, -0.070780, -0.057990, -0.057560, -0.036170, 
-0.026600, -0.006940, -0.050160, 0.004930, -0.071360, -0.113480, -0.058610, -0.020650, -0.013530, -0.046480, 
-0.133770, -0.111980, -0.028390, -0.085980, -0.096990, -0.117130, -0.073890, -0.061430, -0.027040, -0.039990, 
-0.042640, -0.006860, -0.014900, -0.058660, -0.008290, -0.060290, -0.202910, -0.031180, 0.008390, -0.011260, 
-0.011750, -0.160480, -0.069440, 0.006820, -0.047870, -0.083110, -0.147180, -0.063830, -0.091510, -0.040570, 
-0.053990, 0.017000, 0.010050, -0.078180, -0.036630, -0.046770, -0.108430, -0.147160, -0.011410, 0.019890, 
-0.027220, -0.018010, -0.118500, -0.053500, 0.013570, -0.092230, -0.084380, -0.113240, -0.072730, -0.069500, 
-0.103310, -0.003620, 0.042150, -0.019060, -0.136730, 0.008420, 0.017810, -0.084220, -0.012080, -0.025530, 
-0.055180, -0.048150, 0.017130, -0.089230, -0.060820, 0.030860, -0.170410, -0.186920, -0.062150, -0.055820, 
-0.053840, -0.122080, -0.038890, 0.091500, -0.006760, -0.243150, 0.001220, 0.050320, -0.219800, -0.034560, 
0.069160, -0.126100, -0.061260, 0.130530, -0.179210, 0.003210, 0.043510, -0.220660, -0.367740, -0.101760, 
-0.123660, -0.117220, -0.095860, 0.047560, 0.093870, 0.057410, -0.008110, 0.004680, 0.080030, -0.084500, 
-0.017120, 0.079990, -0.084600, -0.047870, 0.085310, -0.154500, 0.078470, 0.094010, -0.127210, -0.454430, 
-0.047110, -0.112890, -0.111970, -0.078020, -0.046790, 0.009420, 0.024150, -0.238160, -0.029660, 0.065740, 
-0.093430, -0.156850, 0.084830, -0.113100, -0.027590, 0.039800, -0.104510, 0.038290, 0.070010, -0.096400, 
-0.236120, -0.019090, -0.110600, -0.141650, -0.084280, -0.073680, -0.006020, 0.000230, -0.150970, -0.011610, 
-0.016110, -0.081660, -0.173280, 0.052430, -0.069670, -0.015330, 0.016140, -0.081630, 0.023800, 0.029440, 
-0.141480, -0.171620, -0.020740, -0.116570, -0.132310, -0.086280, -0.082220, -0.019290, -0.019560, -0.065070, 
-0.024860, -0.070030, -0.115200, -0.168030, 0.011720, -0.053890, -0.013620, -0.039130, -0.073970, 0.017830, 
0.001780, -0.061530, -0.086760, -0.062670, -0.103210, -0.112750, -0.069760, -0.040060, -0.040710, -0.061770, 
-0.000490, -0.025210, -0.074790, -0.083720, -0.100220, -0.066730, -0.011310, -0.038650, -0.077070, -0.008740, 
-0.059400, -0.031160, -0.079180, -0.040830, -0.038040, -0.086040, -0.091800, -0.081990, -0.073350, -0.027480, 
-0.043740, -0.007010, -0.025890, -0.032230, -0.075090, -0.063390, -0.058300, -0.049670, -0.033170, -0.101420, 
-0.036120, -0.062490, 0.000450, -0.072140, -0.073620, -0.054150, -0.097160, -0.085200, -0.043680, -0.088340, 
-0.046720, -0.063670, -0.032640, 
-0.155170, -0.190700, -0.398310, -0.192310, 0.061790, 0.590200, -0.228100, -0.146260, -0.231660, -0.194110, 
0.066740, -0.032440, -0.185250, -0.045420, -0.330170, -0.011910, -0.171720, -0.086410, -0.121930, -0.068300, 
0.186270, -0.059360, -0.161270, -0.374630, -0.384320, 0.077870, 0.519980, -0.208790, -0.106150, -0.384990, 
-0.027810, 0.064650, -0.022810, 0.014070, -0.312040, -0.336530, -0.137660, 0.060440, 0.030150, -0.180560, 
-0.050680, 0.056990, -0.211100, -0.111110, -0.398300, -0.300190, 0.203150, 0.674940, -0.209560, -0.180150, 
-0.570220, -0.049560, 0.049190, -0.065760, -0.032620, -0.194930, -0.347760, 0.165580, 0.011880, 0.005650, 
-0.075240, -0.194470, -0.057840, -0.252960, -0.124010, -0.254940, -0.326540, -0.074450, 0.511320, -0.067540, 
-0.191080, -0.287040, -0.047930, 0.121150, 0.057000, 0.031110, -0.270030, -0.435440, -0.052190, -0.004160, 
0.082600, -0.057910, -0.115340, -0.137630, -0.160380, -0.261730, -0.026460, 0.053280, -0.210710, 0.373600, 
-0.083130, -0.070420, -0.311470, -0.166520, 0.148780, -0.109720, 0.047310, -0.289390, -0.400470, 0.192890, 
0.181800, -0.117090, -0.138520, -0.365420, -0.165510, 0.139560, -0.223970, 0.059670, 0.084430, -0.092710, 
0.073060, -0.217570, -0.007800, -0.724210, 0.028820, 0.114050, -0.087700, 0.259320, -0.097680, -0.501570, 
0.264320, 0.088950, -0.204270, -0.046450, -0.396940, -0.391840, 0.299430, -0.446940, -0.229930, 0.699800, 
-0.188540, -0.223670, -0.450020, -0.095740, -0.293490, 0.385770, 0.232130, -0.655640, 0.481480, 0.122440, 
-0.261550, -0.389510, -0.632290, 0.103000, -0.019440, -0.352730, -0.000710, 0.656360, -0.395540, 0.182790, 
0.916850, -0.410620, -0.498460, -0.220420, -0.011940, -0.015220, 0.304360, 0.259900, -0.523470, -1.230440, 
0.464230, 0.076640, -0.013590, -0.436780, -0.408700, 0.002930, -0.347860, -0.288860, 0.754130, 0.001390, 
-0.242660, 0.423940, -0.237460, -0.809300, -0.231060, 0.391840, -0.244800, 0.443860, 0.339080, -0.606720, 
-1.586990, 0.682180, -0.047510, -0.255400, -0.292830, 0.160210, 0.074460, -0.378440, -0.249710, 1.029640, 
0.109740, -1.075110, -0.351030, 0.159000, -0.670090, -0.282510, 0.312480, -0.020860, 0.947740, 0.474880, 
-0.670520, -1.360710, 0.448100, 0.071040, -0.468540, -0.486230, 0.262200, 0.299210, -0.294770, -0.325700, 
0.809270, -0.314310, -0.350340, 0.332070, -0.549430, -0.243590, 0.028080, -0.250210, 0.230990, 0.592140, 
0.316750, -0.181270, -1.015700, 0.348570, 0.075650, -0.212060, -0.401380, -0.545580, 0.033000, -0.200370, 
-0.364480, 0.818880, -0.482880, -0.396290, 0.288670, -0.416790, -0.088950, -0.019400, -0.033580, 0.287850, 
0.441690, 0.304470, -0.326610, -1.065870, 0.411500, 0.324990, -0.355470, -0.542920, -0.518070, -0.032390, 
-0.150610, -0.331110, 0.767510, -0.340700, -0.760180, -0.036300, 0.146030, -0.215870, -0.200200, 0.277030, 
-0.084860, 0.720390, 0.433400, -0.416140, -1.137280, 0.211810, 0.064830, -0.427610, -0.364240, -0.057030, 
-0.026780, -0.026670, -0.405140, 
-0.537860, 0.448390, 0.124390, -0.415020, 0.724760, 1.138730, 0.338980, 0.112220, -0.428530, -0.157590, 
-0.106630, -0.094780, 0.293610, -0.432230, -0.600540, 0.490680, 0.040240, 0.509630, -0.209510, 0.326300, 
0.599790, -0.545330, 0.499660, -0.701700, -1.364120, 1.124410, 1.560670, 0.706610, 0.476760, -0.803220, 
0.434680, -0.187450, -0.561920, 0.457240, -0.559780, -0.721040, 0.132450, 0.635650, 0.749550, 0.098810, 
0.482010, 0.265230, -1.110540, 0.252420, -0.211650, -0.622880, 0.047870, 1.804770, 0.168860, -0.192240, 
0.178080, -0.506790, -0.095020, 0.566390, 0.580300, -0.082170, 0.350960, 0.623460, 0.171020, 0.189380, 
-0.500800, 0.046240, 0.494060, -0.822500, -0.025030, 0.716510, 0.466220, -0.079530, 2.052950, 0.617580, 
-0.858900, 0.138640, -0.881080, -0.888140, 1.681800, 0.719590, -0.470940, -0.138440, 0.722760, 0.477460, 
-0.390250, -1.240340, -0.100820, 0.468410, -0.818630, 0.971640, -0.463330, -1.182340, 1.273100, 1.829340, 
0.556630, 1.004790, -1.210150, 0.639870, 0.220730, -0.275050, 0.594940, -1.668200, -1.393700, -0.145320, 
0.805980, 1.256700, -0.193750, 0.211690, 0.205930, -0.949520, 1.286500, -0.737430, -1.430920, 0.828210, 
1.509630, 0.190610, 0.784150, -0.977480, 0.611190, -0.016410, -0.264200, 0.832070, -0.941110, -1.145240, 
0.244590, 0.925080, 1.232980, 0.356580, -0.177280, -0.047270, -0.953780, 0.437330, 1.107190, 0.072830, 
-0.777010, 1.907200, -0.236610, -0.801160, 0.358970, -0.926220, -1.072920, 0.667220, 1.634810, -0.060610, 
0.168230, 1.208800, 0.629650, -0.178000, -0.604930, -0.413170, -0.004050, -0.366800, 0.236600, 1.055920, 
0.104580, -0.243910, 0.744230, 0.236370, -0.269200, -0.211540, -0.770820, -0.702290, 0.055350, 2.292690, 
-0.123690, -0.333530, 0.652650, 0.441560, -0.261670, -0.445370, -0.351630, 0.399380, -0.459920, 1.038820, 
-0.578560, -1.252650, 1.061270, -0.151200, 0.146960, 1.175600, -1.365150, 1.486300, 0.261150, -0.970630, 
0.586780, -1.133100, -0.873820, -0.542770, 0.245620, 1.739620, 0.779490, 0.558730, 0.389660, -0.131840, 
0.536590, -0.269640, -0.157350, 0.000250, -0.057000, 0.178750, 0.280220, -0.305990, 0.564340, -0.380120, 
-0.340900, 0.703460, -0.130220, -0.171450, 0.062520, 0.315850, 1.223270, 0.296790, -0.381370, 0.353240, 
0.053070, 0.025180, 0.277190, 0.892780, -0.607410, 0.163140, 0.415270, -0.578200, 0.152550, -0.500320, 
-0.748260, 0.062320, 0.374610, 1.044390, 0.485340, 0.431620, 0.632170, -0.164780, -0.134360, -0.425170, 
0.268200, 0.381700, 0.650640, -0.002740, 0.106110, 0.025680, 0.140850, 0.355180, -0.041600, -0.303330, 
0.184580, -0.071680, -0.066350, -0.431300, 0.795210, -0.349250, -0.006960, 0.793480, -0.398120, 0.163250, 
0.377410, -0.160350, 0.233690, 0.706240, -0.569570, -0.145040, 0.236820, 0.681120, 0.161930, 0.463850, 
-0.569500, 1.128380, 0.157320, -0.110290, -0.173890, -0.296810, -0.646990, -0.152210, 0.056950, 0.187670, 
0.352670, 0.719260, -0.235920, 
-0.091130, -0.042590, -0.208190, 0.069930, 0.023950, -0.179680, -0.107430, 0.031450, -0.190160, -0.034300, 
-0.023790, -0.133420, 0.124800, 0.012600, -0.010280, -0.066700, -0.166820, -0.033730, 0.061090, -0.077840, 
-0.096750, 0.009520, 0.022350, -0.112120, 0.033150, -0.079480, -0.168450, -0.079490, -0.031630, -0.210320, 
-0.040310, 0.004810, -0.153080, -0.000470, -0.109040, -0.065910, -0.114020, -0.093200, 0.029980, 0.086950, 
-0.083050, -0.044280, -0.118090, -0.093550, -0.092710, 0.019420, -0.030880, -0.160520, -0.069750, -0.139560, 
-0.006860, 0.034700, -0.054280, 0.033880, 0.005780, -0.100040, -0.044300, -0.081970, -0.101540, -0.099790, 
-0.006790, -0.073760, -0.022990, -0.048220, -0.113040, 0.030420, 0.143640, -0.116170, -0.129440, -0.021360, 
-0.239170, 0.057920, -0.036750, -0.211060, -0.098660, 0.000740, 0.025380, -0.041030, 0.037540, -0.130880, 
-0.094180, -0.187390, -0.148480, 0.158440, 0.050290, -0.109380, 0.211960, 0.084250, -0.180930, -0.217560, 
0.009420, -0.333460, 0.141700, -0.306510, -0.173250, 0.134770, 0.027780, 0.051580, -0.047320, -0.049740, 
-0.113870, -0.307110, -0.242420, -0.066250, 0.282830, -0.112500, -0.147410, 0.174560, -0.142720, -0.289830, 
0.068510, -0.006260, -0.415430, -0.016750, -0.283090, -0.253760, 0.292120, 0.447920, -0.066800, -0.152900, 
-0.153670, -0.076160, -0.223340, -0.439670, -0.168980, 0.810220, -0.251980, -0.139590, 0.553060, -0.311660, 
-0.332720, 0.521620, 0.027420, -0.581620, 0.011260, -0.423340, -0.309590, 0.551540, 0.761530, -0.166080, 
-0.024370, 0.097500, -0.008460, -0.421870, -0.426100, -0.313760, 0.008710, -0.286850, -0.358770, 0.070050, 
-0.303420, -0.374400, 0.229080, -0.022640, -0.501610, 0.080420, -0.435730, -0.383250, 0.092720, 1.113420, 
-0.104020, 0.010530, 0.053030, -0.043170, -0.218870, -0.217670, -0.273860, 0.747500, -0.223920, -0.275190, 
0.086650, 0.129020, -0.352620, 0.129680, -0.060710, -0.407320, -0.002440, -0.524440, -0.381900, 0.093180, 
0.689130, -0.045330, 0.070090, 0.128200, 0.054050, -0.280520, -0.184530, -0.192020, 0.363960, -0.185670, 
-0.113790, 0.033950, 0.134770, -0.144890, -0.034150, -0.047790, -0.294340, -0.131740, -0.153980, -0.206170, 
0.018880, 0.432740, -0.186580, -0.000310, -0.018510, 0.017640, -0.184120, -0.115850, -0.116040, 0.101980, 
-0.075250, 0.070140, -0.036370, -0.027430, -0.029430, -0.145490, -0.121760, -0.022190, -0.218440, -0.098470, 
-0.099860, -0.148810, 0.122550, -0.079190, -0.009800, -0.026870, 0.006890, -0.074980, -0.074850, -0.026860, 
-0.048200, -0.138840, 0.048070, 0.007680, -0.025720, -0.000680, -0.146390, -0.041470, 0.000960, -0.207310, 
0.011550, -0.041060, -0.095080, 0.001740, -0.022820, -0.068990, -0.062910, -0.075750, -0.122910, -0.009070, 
-0.072130, -0.159990, -0.117690, -0.003090, 0.022710, 0.017560, -0.044590, -0.096270, 0.040650, -0.048770, 
-0.089870, -0.150700, -0.159430, -0.112640, 0.053200, 0.037840, -0.050440, -0.108850, -0.025900, -0.131460, 
0.013980, -0.054060, -0.170930, 
-0.168910, -0.029130, 0.038070, -0.185900, -0.192800, -0.026200, 0.052440, -0.092880, 0.089660, -0.027640, 
-0.121280, 0.018750, -0.161700, -0.130470, -0.035470, 0.017180, -0.020960, -0.048900, -0.096270, -0.085670, 
-0.016740, -0.141890, -0.079860, -0.119930, -0.220540, -0.139430, -0.065040, -0.070150, 0.001980, 0.139210, 
-0.131240, -0.181890, -0.000180, -0.024120, -0.105030, 0.095560, -0.006420, 0.094150, -0.089010, -0.095940, 
0.025730, -0.069960, -0.092350, -0.048410, -0.205460, -0.194010, -0.092970, -0.044140, 0.000470, 0.131120, 
-0.051230, -0.190700, -0.066630, -0.228070, -0.041760, -0.149590, 0.081980, -0.057940, 0.069050, 0.099530, 
-0.082190, -0.005910, -0.040700, -0.155360, -0.090750, -0.155000, -0.080860, 0.009650, -0.112750, -0.104550, 
0.210400, -0.030620, -0.120050, 0.005400, -0.127590, -0.186360, -0.246690, -0.035240, -0.057260, -0.017310, 
0.213660, 0.002680, 0.055040, -0.152870, -0.077160, -0.000660, -0.421940, -0.314660, 0.231360, 0.051030, 
-0.020600, 0.268890, -0.197640, 0.101850, -0.018780, -0.207550, -0.322850, -0.271510, -0.208480, 0.042110, 
-0.054620, 0.396500, 0.023580, 0.015220, -0.241160, -0.080080, 0.224250, -0.517420, -0.290610, 0.243660, 
-0.114390, -0.074810, 0.452570, -0.093630, 0.124890, 0.003520, -0.591900, -0.646510, -0.207140, -0.004990, 
-0.006790, 0.011960, 0.480730, 0.225820, 0.132740, -0.450830, -0.099620, 0.209760, -0.443870, -0.328180, 
0.171480, -0.098950, -0.015780, 0.417360, -0.289670, -0.031130, -0.125410, -0.375550, -0.848450, -0.200170, 
-0.101480, 0.074990, 0.136010, 0.403700, 0.162040, 0.163030, -0.007670, -0.197070, 0.191900, -0.124260, 
-0.299650, 0.187120, -0.159690, -0.082110, 0.341390, -0.367180, 0.111210, -0.012630, -0.176930, -0.213060, 
-0.334270, -0.334270, -0.002760, 0.177370, 0.298050, 0.013720, 0.173510, -0.397280, -0.240630, 0.157150, 
-0.060680, -0.425350, 0.276640, -0.190500, -0.007950, 0.270090, -0.301170, 0.104490, 0.021620, -0.136490, 
0.032500, -0.403860, -0.393410, -0.077000, 0.029510, 0.136270, 0.007870, 0.221210, -0.208700, -0.247070, 
-0.063380, 0.034350, -0.200120, 0.090600, -0.005540, -0.061600, 0.041440, -0.176150, -0.030860, -0.109120, 
-0.079300, -0.054660, -0.216730, -0.314350, 0.155150, 0.048050, 0.040500, -0.028710, 0.025810, -0.038590, 
-0.258850, -0.095680, 0.009560, -0.077910, -0.038240, 0.122080, -0.091590, -0.193480, -0.064360, -0.213510, 
-0.125380, 0.041140, -0.043320, -0.129500, -0.148730, 0.012320, 0.137600, 0.021470, -0.015810, -0.071750, 
0.024330, -0.375660, -0.091700, 0.013310, 0.042650, -0.015260, 0.128460, -0.071580, -0.150870, -0.088840, 
-0.308790, -0.164100, -0.024220, 0.049750, -0.117450, -0.132200, 0.076650, 0.164550, 0.068700, -0.066910, 
-0.048820, -0.054950, -0.260650, 0.019790, 0.003580, -0.082710, -0.095560, 0.124140, -0.060360, -0.172940, 
0.003560, -0.189460, -0.100800, -0.111540, 0.033920, -0.285770, -0.163640, 0.059900, 0.203830, 0.070350, 
-0.076150, -0.024670, -0.057730, 
0.412230, -0.016730, -0.452720, -0.182580, 0.365600, -0.548890, 0.278710, 0.091910, -0.582820, 0.545370, 
0.145960, -0.601150, -0.348090, -0.800210, -0.322050, -0.282990, 0.230080, 0.059800, 0.177340, -0.079100, 
-0.544720, 0.430360, -0.094220, -0.528350, -0.322280, 0.130090, -0.901580, -0.075580, 0.515610, -0.141100, 
0.249140, 0.061740, -0.447600, -0.288170, 0.022670, -0.088130, -0.519840, 0.142200, -0.275490, -0.056840, 
-0.072490, -0.211550, 0.138650, -0.938370, 0.673410, 1.183030, -1.160090, -0.919500, -0.553400, -0.738720, 
0.958610, -1.027800, -0.133150, 0.603710, -0.335030, 0.975040, 0.740340, -0.001570, -0.190740, -0.828290, 
-0.143220, -0.532660, -0.201900, 0.541010, -0.626610, 0.225300, 0.655930, -0.005520, -1.059960, 0.045900, 
0.192320, -0.181780, 0.366580, -0.025210, 0.024750, -0.859660, -0.153160, -0.305700, -0.303970, -0.260190, 
-0.254500, 0.125490, -0.043350, -0.535870, 0.653100, 0.939150, -1.405450, -1.830940, 1.045970, -1.652500, 
-0.133390, 1.315270, -1.309670, 1.494410, 0.946220, -1.620370, -0.745240, -0.631930, -0.547290, -0.717160, 
-0.018050, 0.846980, 1.100860, 0.351310, -0.597350, 0.419220, -0.308900, -0.553430, 0.579810, -0.365030, 
-1.020090, -0.998170, 0.029600, 0.578220, 0.242870, -0.080950, -0.521250, -0.682420, 0.857100, 0.841110, 
-0.441420, -0.412810, -0.348770, 0.323470, -0.209090, -0.397800, 0.779680, -1.599220, 0.570940, 1.492060, 
-1.340390, -0.827810, 0.096870, -1.176700, 1.268380, -1.092800, -0.366920, 0.569140, -1.152400, 0.931440, 
0.858870, 0.488340, -0.313510, -1.212100, -0.463020, 0.017200, 0.004530, 0.517700, 0.615150, -1.161450, 
-0.371280, 0.942570, -1.721160, 0.403580, 0.907890, -0.609070, 1.026250, 0.986230, -0.830330, -2.395360, 
-0.110160, -0.550270, -0.928740, -0.355690, 0.669440, 0.400440, 0.555250, -0.536880, 0.261480, 0.609880, 
-1.910010, -1.270260, 1.008930, -0.257970, -0.174550, 0.882480, -0.369280, 1.085530, 1.169900, -0.701430, 
-0.937050, -0.632100, -0.540770, -1.118680, -0.522880, 0.712430, 0.508930, 0.357670, -0.617370, 0.136430, 
-0.727530, 0.256930, 0.785740, -0.895700, 0.285880, -0.296040, -0.910400, 0.827610, -0.780430, -0.695500, 
0.497370, -0.252130, 0.623680, 0.648510, 0.167680, -0.098360, -0.620200, 0.002930, -0.696470, -0.760910, 
0.002390, -0.484610, 0.310810, 0.493040, -0.201750, -0.113900, 0.241660, -0.628360, 0.711300, -1.122690, 
-0.260280, 0.336370, -0.475560, 0.351780, 0.585820, 0.097670, -0.277130, -1.047470, -0.564210, -0.047160, 
-0.344520, 0.019940, -0.007670, -0.891150, -1.318290, 0.409480, -0.079700, 0.058900, 0.642720, -0.597680, 
0.684470, 0.109130, -0.368380, -0.475150, -0.810190, -0.488120, -0.169870, -0.226930, 0.168060, 0.286050, 
0.539650, 0.031640, -0.267310, -0.172880, -0.043170, -0.306620, -0.174170, 0.067280, -0.265320, 0.227280, 
0.056160, 0.367480, -0.010850, -0.367340, 0.063160, -0.437940, -0.104120, -0.265430, -0.676830, 0.267400, 
0.028140, -0.431680, -0.011950, 
-0.025710, -0.381610, -0.019270, 0.102790, -0.100560, 0.232810, -0.241420, -0.622300, -0.312390, 0.095790, 
-0.019180, -0.083030, 0.199230, -0.057860, -0.387420, 0.198950, -0.058510, -0.490770, -0.314640, 0.126810, 
0.182650, -0.190020, -0.342080, -0.094710, 0.005940, -0.121200, 0.144870, -0.150890, -0.539390, -0.517540, 
0.162440, 0.226350, 0.152110, 0.189840, -0.209280, -0.336000, -0.074570, 0.072900, -0.173720, -0.282510, 
0.119170, -0.077670, -0.001470, -0.383430, -0.008900, 0.221120, -0.049740, -0.027210, -0.296910, -0.415770, 
-0.330270, 0.041180, 0.073960, 0.222620, 0.147250, -0.063280, -0.408920, -0.090800, -0.053620, -0.051210, 
-0.239580, -0.072400, -0.228150, -0.033040, -0.405850, -0.066550, 0.332600, -0.248300, -0.356920, -0.196190, 
-0.359570, -0.160270, -0.193280, 0.048220, -0.011430, -0.006810, 0.121550, -0.500940, 0.095140, 0.367800, 
0.119080, -0.166030, -0.148130, -0.205510, 0.036290, -0.365210, 0.217760, 0.337220, -0.130280, -0.557670, 
-0.190660, -0.245160, -0.498170, -0.015830, 0.125620, 0.003270, -0.098450, -0.073970, -0.304970, 0.334860, 
0.372210, -0.157440, -0.152630, -0.361260, -0.222870, 0.385910, -0.460400, 0.202590, 0.530200, -0.252140, 
-1.202890, -0.271770, -0.120740, -0.670410, 0.062300, 0.260900, -0.034250, 0.219450, 0.030530, -0.082670, 
0.039040, 0.126780, 0.027240, 0.063800, -0.176090, -0.642890, 0.857680, -0.814580, 0.199350, 1.244050, 
-0.738860, -1.113080, -0.575140, -0.161590, 0.227640, -0.193040, 0.316430, -0.550830, 0.239370, 0.582090, 
0.122200, -0.562930, -0.824340, 0.074550, -0.013060, -0.274210, 0.005680, 1.044480, -0.609740, -0.019670, 
1.200490, -0.420100, -1.282220, -0.272010, 0.252250, 0.059440, -0.014130, 0.590840, -0.540680, -1.853260, 
0.754560, 0.082800, -0.332380, -0.449780, 0.227860, 0.181240, -0.162510, -0.392460, 0.948890, -0.035000, 
-0.938790, 0.122710, 0.021170, -0.928230, -0.317340, 0.663060, -0.240000, 0.597600, 0.713400, -0.667980, 
-2.408580, 0.568070, 0.245440, -0.555290, -0.377960, 0.728520, 0.384640, -0.131230, -0.354610, 0.984170, 
-0.114210, -0.989050, 0.301410, -0.362910, -0.695780, -0.275380, 0.083970, 0.441070, 0.433010, 0.337110, 
-0.295240, -1.952680, 0.728860, 0.745830, -0.464040, -0.663700, 0.044050, 0.322450, -0.133380, -0.498870, 
0.715390, -0.698390, -0.202770, 0.703050, -0.664080, -0.246370, 0.099100, -0.583690, 0.690030, -0.183550, 
0.244220, -0.012290, -1.575500, 0.677240, 0.642220, -0.058180, -0.083930, -0.693920, -0.052090, -0.079240, 
-0.596940, 0.440920, -0.696780, -0.551500, 0.174110, -0.156940, -0.277850, 0.109570, 0.283360, 0.234250, 
0.740920, 0.594580, -0.345760, -1.541330, 0.254120, 0.533720, -0.523970, -0.544380, -0.591230, 0.049160, 
0.328120, -0.466760, 0.560280, -0.340850, -1.036050, -0.209050, 0.364920, -0.213880, -0.167530, 0.592400, 
0.050240, 0.731910, 0.592490, -0.325480, -1.082440, 0.112460, -0.030930, -0.522310, -0.517900, -0.256440, 
-0.031990, 0.132260, -0.419270, 
-0.083370, -0.004330, -0.119860, -0.199360, 0.042390, 0.055770, -0.060600, 0.038850, -0.166250, -0.123920, 
-0.037320, -0.055780, -0.106620, -0.090520, -0.036290, -0.092520, -0.148250, 0.053690, 0.050590, 0.009230, 
-0.071580, -0.071910, -0.029400, 0.007340, -0.246200, -0.006970, 0.160720, -0.085220, -0.053570, -0.176990, 
-0.137110, -0.029120, 0.060560, -0.074810, -0.028380, -0.090970, -0.103770, -0.084470, -0.006520, -0.023530, 
-0.106510, -0.053350, -0.153470, 0.055500, -0.063340, -0.227160, 0.005360, 0.266870, -0.009280, -0.077850, 
-0.307790, -0.056130, 0.028330, -0.129930, -0.053220, -0.178890, -0.140750, -0.005400, -0.008940, -0.016170, 
-0.040400, -0.034680, -0.071610, -0.096310, 0.102510, -0.092490, -0.437940, 0.009160, 0.300580, -0.018570, 
-0.003300, -0.343580, 0.061920, 0.061880, -0.056670, 0.018320, -0.248960, -0.215100, -0.035570, -0.055680, 
-0.040600, 0.040720, -0.057390, -0.093320, -0.121330, 0.025210, -0.072880, -0.144250, -0.183810, 0.351460, 
0.045880, -0.087330, -0.182850, -0.104410, -0.027770, -0.059270, 0.153560, -0.146920, -0.183560, -0.013560, 
-0.134940, -0.164850, 0.007560, -0.023580, -0.106650, 0.035860, 0.019080, 0.064950, 0.064820, -0.202160, 
0.257120, 0.011470, -0.168130, -0.229330, -0.097710, 0.005900, 0.057940, 0.092700, -0.119730, -0.184340, 
0.009160, -0.251890, -0.317520, -0.042500, -0.142680, -0.034170, -0.015310, -0.024100, 0.003630, 0.155660, 
0.037090, 0.028190, -0.070410, -0.060180, -0.293770, 0.057650, 0.079480, -0.087460, -0.011480, -0.175510, 
-0.262560, -0.062010, -0.168600, -0.171940, -0.008430, -0.111010, 0.003240, 0.130390, 0.049900, -0.019300, 
0.089600, 0.028080, 0.105400, -0.101380, -0.077090, -0.228160, 0.222880, 0.053710, -0.120500, -0.283090, 
-0.025090, -0.089070, -0.141450, -0.132030, -0.302360, -0.084570, -0.168410, -0.081960, 0.141790, 0.102610, 
-0.027220, -0.057150, -0.055220, -0.103410, -0.059920, -0.048940, -0.114770, 0.047700, -0.000380, -0.074500, 
-0.112980, 0.123140, 0.033550, -0.219450, -0.130990, -0.256090, -0.091610, -0.180620, -0.076950, 0.239150, 
0.040740, -0.109210, -0.246180, 0.017650, -0.057280, -0.022240, -0.027450, -0.124040, 0.091350, 0.004380, 
-0.151170, -0.095220, 0.032260, -0.097280, -0.161970, -0.112020, -0.219890, -0.011740, -0.136590, -0.041020, 
0.226460, -0.072760, -0.158560, -0.224290, -0.111660, -0.028350, -0.035550, -0.080580, -0.103360, 0.217510, 
0.035990, -0.046900, -0.052440, -0.085490, -0.167980, -0.143880, -0.134980, -0.071790, -0.013300, -0.115730, 
0.006740, 0.288340, -0.070590, -0.175080, -0.121620, -0.143970, -0.018540, -0.093010, -0.067360, -0.003580, 
0.142970, -0.023000, -0.149840, -0.121770, -0.039780, -0.111930, -0.188620, -0.142470, -0.034220, 0.003300, 
-0.136270, 0.019210, 0.241730, -0.092380, -0.133260, -0.108190, -0.062820, -0.063630, -0.105110, -0.020320, 
-0.050430, 0.108450, 0.050880, -0.114580, -0.210360, 0.045360, -0.057030, -0.217950, -0.149990, -0.087470, 
-0.067200, -0.028140, -0.079680, 
-0.115750, -0.174820, 0.224340, 0.124870, 0.126020, 0.091600, 0.024980, -0.717360, 0.297580, -0.533340, 
-0.440360, -0.186230, -0.095620, -0.072890, -0.273080, 0.342950, -0.010400, -0.478750, -0.346880, -0.144030, 
0.240940, -0.041290, 0.046470, 0.164500, 0.233120, -0.279660, 0.125460, -0.400610, -0.541770, 0.046780, 
-0.200510, -0.206870, 0.030800, 0.072970, -0.018380, -0.188150, 0.126280, -0.171540, -0.197480, -0.320600, 
-0.291960, -0.120330, -0.677630, -0.192320, 0.243640, 0.063020, -0.161060, 0.402670, -0.158550, -0.440720, 
0.587130, -1.033290, -0.323650, 0.374510, 0.049070, -0.315770, -0.141190, 0.227640, 0.289730, -0.434650, 
-0.394530, -0.087960, -0.009820, -0.066460, -0.410480, 0.189910, -0.430090, -0.042590, 0.046110, -0.325530, 
-0.158550, -0.018900, -0.056670, -0.009290, -0.252490, 0.099970, 0.238740, 0.049090, -0.360720, -0.518620, 
0.115500, 0.149370, -0.066080, -0.318490, -0.851130, -0.245390, 0.209210, 0.255890, -0.562660, -0.092280, 
-0.097120, -0.166410, 0.526880, -0.624260, -0.378930, 0.013770, 0.418330, -0.179000, 0.427230, 0.012300, 
0.752020, -0.555150, -0.333120, -0.216400, -0.448620, 0.563380, 0.329440, -0.945410, -1.392040, 0.661240, 
0.175210, -0.294010, 0.774650, -0.754970, 0.636090, 0.618790, -0.923250, -0.973200, -0.375610, -0.067600, 
-1.252630, -0.101790, 1.117580, 0.411910, 0.550350, -0.913480, -0.778390, -0.022160, -0.740710, 1.632490, 
-0.749430, -1.948330, -0.114390, 0.019950, 0.877630, -0.846230, -0.188360, -0.491860, -1.718550, 0.191990, 
0.694150, 0.450310, 0.993700, 0.436740, -0.012880, 0.191670, -0.004900, 0.381610, 0.851680, -2.242990, 
-1.377410, 1.429850, -0.145680, -0.430140, 1.530140, -1.307990, 1.406690, 0.842520, -1.406010, -1.092900, 
-0.855040, -0.861360, -0.716790, -0.502200, 1.724020, 0.404260, 0.809040, -0.546020, -0.937330, -0.362810, 
-0.606180, 1.294320, -0.849270, -1.284100, 0.181600, 0.228170, 0.421430, -0.741330, 0.021830, -0.409880, 
-1.154350, 0.412280, 0.569170, 0.198520, 0.693920, 0.516910, -0.011860, 0.336180, -0.603530, -0.343970, 
0.581660, -0.605190, -1.096060, 0.721430, -0.091510, -0.371140, 0.958370, -1.041560, 0.892290, 0.596120, 
-0.582430, -0.110820, -0.687450, -0.759600, -0.486100, 0.015010, 0.753890, 0.027870, -0.123530, -0.365000, 
-0.552760, -0.337880, 0.282170, 0.039940, -0.316770, -0.270560, -0.248730, -0.627020, 0.070370, -0.509320, 
-0.330400, 0.287130, 0.150020, -0.517890, 0.159070, 0.344950, 0.244860, 0.238120, 0.045710, 0.165330, 
-0.450140, -0.201690, 0.266280, 0.130710, -0.596060, -0.090550, -0.247310, 0.174310, -0.126720, -0.302800, 
-0.418520, -0.317690, -0.142610, -0.098630, -0.428130, -0.269430, 0.277970, 0.204150, 0.496190, -0.302530, 
-0.195610, 0.022430, -0.598140, -0.069160, 0.377330, 0.006400, -0.817720, 0.533830, -0.162520, -0.640020, 
0.075670, -0.369050, -0.405350, 0.144370, 0.189870, -0.365360, -0.149500, 0.240840, 0.167490, 0.019890, 
0.064410, -0.359190, -0.029610, 
0.661440, 0.052980, 0.021380, 0.487290, 0.048670, 0.031020, -0.152430, -0.399070, 0.203980, -0.067350, 
0.038220, -0.071430, -0.153240, 0.301720, -0.230560, 0.047310, -0.269420, -0.110770, 0.066780, -0.128390, 
-0.338090, 0.436230, 0.083720, 0.001120, 0.375310, 0.149390, -0.054090, -0.265600, -0.144090, 0.047120, 
0.007040, 0.235970, 0.054170, -0.178650, -0.003130, -0.136880, 0.007530, -0.429230, -0.067470, 0.232570, 
-0.190100, -0.149460, 0.255400, 0.092390, 0.410010, 0.275250, 0.063050, -0.252860, 0.059730, -0.170730, 
0.079800, 0.246880, 0.144050, -0.161720, -0.153180, 0.111150, -0.050580, -0.229480, -0.298730, -0.422000, 
0.170470, 0.066950, -0.208040, 0.550560, -0.020950, 0.261560, -0.091230, -0.088350, -0.376090, 0.035340, 
-0.033300, -0.010750, 0.288800, 0.178800, -0.160290, 0.163700, 0.198200, 0.331960, -0.176510, -0.447170, 
-0.482220, 0.033530, 0.010270, -0.170420, 0.516710, -0.044560, 0.443900, 0.400350, -0.155980, -0.433460, 
-0.095880, -0.510920, 0.243180, 0.019300, 0.043340, -0.118550, 0.287080, 0.217520, -0.000090, -0.125230, 
-0.108870, -0.793100, 0.066620, 0.097440, 0.036110, 0.839660, -0.370800, 0.597400, 0.554300, -0.334190, 
-0.080630, -0.133940, -0.598780, -0.202450, 0.153470, 0.107140, 0.271850, 0.407620, -0.037940, -0.349600, 
0.158430, -0.291170, -0.586910, -0.307450, -0.321390, 0.525880, 0.405590, -0.501340, 0.638400, 1.076320, 
-0.117000, -0.001740, -0.081750, -0.465710, -0.169930, 0.340190, 0.504640, 0.340580, 0.271080, -0.195460, 
-0.298300, 0.154570, -0.407290, -0.727570, -0.201880, -0.564990, -0.003440, 0.384720, -0.235610, 0.020500, 
0.712630, -0.137750, 0.343600, 0.071970, -0.167050, 0.072040, 0.297940, 0.151930, -0.179030, -0.362400, 
0.393260, 0.233650, 0.056570, -0.502450, -0.993910, -0.054330, -0.471820, 0.380370, 0.353590, -0.084220, 
0.029260, 0.535380, -0.453930, -0.325580, -0.110570, -0.038720, 0.155800, 0.236920, 0.288700, -0.074790, 
-0.291260, 0.730480, 0.527950, -0.229560, -0.232190, -0.414830, -0.150550, -0.505110, 0.117160, 0.845350, 
-0.109200, 0.046710, 0.043330, -0.067620, -0.220210, -0.027970, -0.369150, -0.127230, 0.546940, 0.114160, 
-0.109830, 0.090160, -0.022170, 0.317570, -0.265700, -0.180940, -0.239450, -0.050120, -0.073520, -0.140340, 
1.006480, 0.158020, 0.033860, -0.042280, -0.488660, -0.114970, 0.009470, -0.066090, -0.014400, -0.003000, 
0.287990, -0.116170, 0.171710, -0.147010, 0.002310, 0.026540, -0.342020, -0.337970, -0.009230, 0.036030, 
-0.064770, 0.705070, 0.029560, -0.367730, -0.332280, -0.386420, -0.020130, 0.145880, -0.082680, 0.168370, 
0.235950, 0.164670, -0.072070, -0.197230, 0.185700, 0.176050, -0.102070, -0.222420, -0.064880, -0.044530, 
0.068080, 0.008260, 0.458820, -0.178060, -0.204470, 0.166770, -0.113420, -0.232600, 0.016790, 0.096010, 
-0.115230, 0.398770, 0.089410, -0.241140, -0.379970, 0.690100, 0.309710, -0.241130, -0.296730, -0.155960, 
0.056620, -0.119370, -0.038930, 
-0.190040, -0.026610, -0.034500, -0.215430, -0.062650, -0.241930, 0.043460, 0.073100, -0.095760, -0.072560, 
-0.050260, -0.037610, 0.089750, -0.165460, 0.146890, -0.179120, -0.104960, -0.025350, 0.096600, 0.016880, 
0.008430, -0.163130, -0.083980, 0.029440, -0.204130, -0.078070, 0.007510, -0.001700, -0.043250, -0.059510, 
-0.142100, -0.131100, -0.041380, 0.052230, 0.033480, 0.065280, -0.164260, -0.002360, 0.012810, -0.076990, 
-0.007720, -0.029370, -0.257090, -0.072850, -0.122370, -0.106590, -0.080060, 0.064730, -0.045010, -0.094910, 
-0.124170, -0.070870, -0.070980, -0.032060, 0.010480, -0.047540, -0.042340, 0.048140, 0.050810, 0.131540, 
-0.101980, -0.050030, -0.005990, -0.201040, -0.031000, -0.135200, -0.027790, -0.063000, 0.073760, -0.102490, 
-0.083640, -0.099420, -0.012120, -0.142700, -0.017420, -0.009380, -0.126480, -0.222980, 0.075180, -0.028270, 
0.118110, -0.025960, -0.049160, 0.055170, -0.290630, -0.025880, -0.114590, -0.126190, -0.094680, 0.089230, 
0.059630, 0.094890, -0.120490, -0.042390, -0.147620, 0.033450, -0.032190, -0.127900, -0.144500, -0.049800, 
-0.165660, 0.159160, -0.059090, 0.016200, 0.030180, -0.345490, 0.097870, -0.063230, -0.308960, -0.108930, 
0.128350, 0.052800, 0.162410, -0.097070, -0.216940, -0.198310, 0.118780, 0.174910, -0.170210, 0.044440, 
-0.214660, -0.179180, 0.087280, -0.051880, -0.090990, 0.130870, -0.354910, 0.143640, 0.124650, -0.403360, 
-0.126160, 0.136390, -0.024390, 0.059180, -0.117300, -0.328640, -0.364030, 0.117320, 0.268910, -0.125420, 
-0.000370, -0.090460, 0.055300, 0.068800, -0.091900, -0.017830, 0.000750, -0.138940, -0.013870, 0.149350, 
-0.404770, -0.149390, 0.078790, -0.087680, -0.121040, -0.201320, -0.293930, -0.250530, 0.069600, 0.602780, 
-0.233340, -0.152800, -0.131090, 0.192550, 0.115310, -0.146810, -0.003620, 0.129480, -0.176630, -0.016930, 
0.126240, -0.276590, -0.019130, 0.095170, -0.004100, -0.096950, -0.224610, -0.263540, -0.293820, 0.021380, 
0.476460, -0.267530, -0.182620, -0.112860, 0.094890, -0.010980, -0.084230, 0.093700, 0.063510, -0.208440, 
-0.017030, 0.075720, -0.170820, -0.053860, 0.162790, -0.058040, -0.012400, -0.148270, -0.328550, -0.175680, 
0.078980, 0.197410, -0.162670, -0.169250, 0.075220, -0.004870, -0.060520, -0.047440, -0.069270, 0.068550, 
-0.184620, -0.133140, 0.063530, -0.081500, 0.070780, 0.138640, -0.083070, -0.161170, -0.101620, -0.214970, 
-0.227570, 0.059880, 0.057910, -0.131290, -0.142410, -0.028650, 0.097650, 0.106800, -0.055260, -0.117820, 
0.015200, -0.034490, -0.068110, 0.054070, 0.013690, 0.063950, 0.045670, -0.125920, -0.073440, -0.112570, 
-0.255820, -0.214260, -0.080770, 0.074190, -0.146970, -0.165040, -0.042070, 0.113210, -0.003180, 0.072540, 
-0.131440, -0.037030, -0.008690, -0.013110, 0.055030, -0.150730, 0.082160, 0.093960, -0.088340, -0.135090, 
0.010760, -0.262060, -0.094750, -0.048020, 0.093610, -0.228230, -0.111530, -0.109940, 0.028210, -0.051700, 
-0.069780, 0.073180, -0.076250, 
-0.104650, -0.026680, -0.061070, -0.092270, 0.026020, -0.051590, -0.047650, -0.020600, -0.119970, -0.133450, 
-0.068850, -0.054810, -0.000320, -0.055460, 0.008470, -0.125470, -0.146260, -0.010290, 0.059890, -0.051850, 
-0.028580, -0.143360, 0.017060, 0.040670, -0.092670, -0.024960, 0.027130, -0.044160, -0.109520, -0.124820, 
-0.149250, -0.034260, -0.004640, 0.007310, 0.000580, -0.059780, -0.091040, -0.098260, -0.074910, -0.005950, 
-0.113930, -0.000330, -0.195420, 0.022220, 0.003030, -0.112000, -0.027500, 0.107270, -0.008460, -0.189100, 
-0.112760, -0.143920, -0.008240, -0.049700, 0.031600, -0.059430, -0.056490, -0.043620, -0.041470, -0.152140, 
-0.046900, -0.035910, -0.030990, -0.106020, 0.059060, 0.049370, -0.193810, -0.076530, 0.139000, 0.007620, 
-0.142070, -0.173000, -0.095020, -0.038350, -0.007280, 0.094270, -0.094240, -0.097060, -0.039140, -0.124560, 
-0.177320, -0.029300, -0.068170, 0.012380, -0.160950, 0.043280, 0.056400, -0.077710, -0.195640, 0.061960, 
0.059190, -0.153240, -0.093420, -0.144710, -0.085790, 0.002410, 0.193890, -0.079780, -0.118490, -0.057980, 
-0.093560, -0.247950, -0.055150, -0.024560, 0.054710, -0.088540, -0.019830, 0.111940, -0.010300, -0.228090, 
0.106330, 0.034850, -0.244520, -0.143910, -0.166200, -0.087550, 0.153360, 0.271990, -0.113490, -0.109890, 
-0.026050, -0.180370, -0.309010, -0.177470, -0.158190, 0.292030, -0.084710, -0.061930, 0.176860, 0.110550, 
-0.108650, 0.081020, -0.029140, -0.285050, -0.128760, -0.149280, -0.048090, 0.131810, 0.298850, -0.136670, 
-0.108870, 0.004620, -0.083330, -0.328840, -0.165570, -0.155410, -0.004460, -0.061340, -0.055000, 0.073720, 
0.004290, -0.108740, 0.166220, -0.037630, -0.278080, -0.132920, -0.139250, -0.100290, 0.009660, 0.284650, 
-0.045800, -0.055700, -0.060830, -0.093830, -0.338270, -0.144390, -0.191830, 0.229240, -0.071560, 0.005280, 
0.049940, -0.054250, -0.112360, 0.007530, -0.015290, -0.141760, -0.103670, -0.161030, -0.117080, 0.005800, 
0.261660, 0.013580, 0.011550, -0.154890, -0.086020, -0.253470, -0.103310, -0.171960, 0.078160, -0.000880, 
0.002310, 0.007460, -0.184720, -0.056140, 0.008830, -0.004620, -0.105560, -0.111240, -0.132120, -0.091440, 
-0.008490, 0.210320, -0.073210, -0.058410, -0.104950, -0.059540, -0.189180, -0.073460, -0.125660, 0.027280, 
0.049110, 0.007370, -0.039880, -0.162350, -0.121900, 0.017650, -0.033820, -0.150940, -0.086890, -0.079630, 
-0.038350, 0.008210, 0.158620, -0.106980, -0.118390, -0.078840, -0.038990, -0.128780, -0.040370, -0.121210, 
0.017130, 0.109750, 0.028630, -0.074070, -0.123720, -0.128720, -0.052350, -0.034980, -0.109230, -0.031070, 
-0.067390, -0.071080, -0.045450, 0.016050, -0.062210, -0.124830, -0.103500, -0.044030, -0.079890, 0.004870, 
-0.102860, 0.021120, 0.088340, -0.043900, -0.076920, -0.108300, -0.085010, -0.074080, -0.042300, -0.068910, 
-0.047530, -0.053230, -0.030570, -0.042750, -0.039440, 0.043410, -0.055350, -0.140530, -0.082240, -0.145300, 
-0.006420, -0.012000, -0.050540, 
-0.539260, 0.004270, 0.166740, -0.438800, 0.224520, 0.631980, -0.011960, -0.131730, -0.143340, -0.411760, 
-0.349850, -0.158220, 0.311970, -0.185530, -0.156550, -0.118180, -0.053480, 0.240000, -0.140650, -0.134080, 
0.413970, -0.750050, 0.145050, 0.750460, -0.384570, 0.009720, 0.849380, 0.124030, -0.442560, -0.148000, 
-0.931540, -0.252670, 0.351770, 0.364560, -0.000760, -0.164690, 0.147220, -0.093560, -0.090650, -0.281030, 
-0.387480, 0.229640, -0.697060, 0.233380, 0.436570, -0.563250, 0.158650, 0.772070, 0.091670, -0.356610, 
-0.038700, -0.774450, -0.100930, 0.043130, 0.849080, -0.373460, -0.095580, -0.055250, -0.047950, 0.004680, 
-0.475610, -0.016320, 0.042960, -0.627930, 0.443410, 0.419870, -1.013390, 0.201290, 0.603820, 0.298520, 
-0.012500, -0.427860, -0.290050, -0.099730, 0.192530, 1.060650, -0.630220, -0.198210, -0.383170, 0.002420, 
-0.103440, -0.280520, -0.179470, 0.028390, -0.760570, 0.416470, 0.443510, -0.340830, -0.374910, 0.387020, 
0.180200, -0.329480, -0.170540, -0.547690, -0.314100, 0.267230, 1.174040, -0.417090, -0.103240, 0.010220, 
0.342300, -0.445660, -0.409220, 0.006990, 0.081370, -0.232870, -0.001630, 0.767170, 0.288210, -0.715510, 
0.242660, 0.320850, -1.424960, -0.210970, -0.606140, -0.306710, 0.617380, 1.093090, -0.438760, -0.187070, 
0.380750, 0.252690, -0.754600, -0.631380, -0.344050, 0.937120, 0.066940, -0.262450, 0.866730, 0.823510, 
-0.276420, 0.133160, 0.092460, -1.160160, 0.072180, -0.406550, 0.031790, 0.341810, 0.714540, -0.281220, 
-0.211730, 0.222430, -0.047930, -0.674330, -0.551130, -0.523370, 0.009820, -0.111130, 0.104500, 0.690810, 
0.497940, -0.100170, 0.360660, -0.146550, -0.665060, -0.332810, -0.109260, -0.193460, -0.018890, 0.833960, 
0.004630, -0.105990, -0.026800, -0.334940, -1.093980, -0.357670, -0.572550, 0.702220, -0.331230, 0.262070, 
0.434980, 0.420550, -0.432790, 0.539460, 0.188590, -0.312630, -0.093140, -0.498470, -0.276080, 0.136820, 
0.672200, 0.206620, 0.338580, -0.431190, -0.195140, -0.873550, -0.285880, -0.724650, 0.272160, -0.125630, 
0.303120, 0.099980, -0.244130, -0.022350, 0.414630, 0.111400, -0.088540, -0.024820, -0.271960, -0.339570, 
0.032780, 0.722090, -0.036010, 0.010520, -0.384890, 0.032950, -0.429520, -0.260480, -0.432960, -0.019490, 
0.060480, 0.254580, 0.110430, -0.408900, -0.521340, 0.190550, 0.023890, -0.282980, -0.058630, -0.135330, 
-0.096900, 0.270770, 0.842810, 0.071600, -0.346120, -0.148850, -0.058360, -0.534180, 0.092480, -0.319770, 
0.038780, 0.369360, 0.288550, 0.100950, -0.188470, -0.548860, -0.015530, 0.060370, -0.419980, 0.070850, 
-0.281970, -0.147260, 0.308160, 0.334350, 0.004150, -0.402990, -0.210310, -0.003920, -0.300920, 0.119050, 
-0.176570, 0.027580, 0.463210, 0.114660, -0.083630, -0.110830, -0.499160, -0.226510, -0.132380, -0.147250, 
-0.032350, 0.114820, -0.064280, 0.047670, 0.081050, 0.224080, -0.229830, -0.429290, -0.068830, -0.271160, 
0.212770, 0.102120, -0.037880, 
-0.670700, 0.213950, 0.356570, -0.135360, -0.515580, 0.855810, 0.098160, -0.396300, 0.580900, -0.570400, 
-0.542360, 0.085770, -0.152250, -0.140640, 0.066900, 0.202620, -0.267230, -0.081060, -0.379180, -0.387020, 
-0.080130, -1.053050, 0.194010, -0.099110, -0.376500, -0.165230, 0.198860, -0.123150, 0.362760, 0.328240, 
-0.352930, -0.283880, 0.048280, 0.202770, -0.109660, -0.083000, -0.077270, 0.017750, 0.037860, 0.087220, 
-0.041260, -0.582550, -0.714960, 0.077840, 0.008950, -0.636860, 0.000130, -0.006710, 0.092720, 0.553860, 
0.137840, -0.051520, -0.121830, -0.732130, -0.210670, -0.211760, 0.091210, -0.269730, 0.008970, 0.522940, 
0.085810, 0.081590, -0.596210, 0.128580, -0.110460, -0.933560, -0.439160, 0.004920, -0.480840, -0.010540, 
0.862460, -0.575540, 0.143160, 0.284190, -0.985110, -0.163070, -0.101880, 0.093260, -0.763410, 0.195290, 
1.054820, 0.171540, 0.386690, -0.646880, 0.087910, 0.116750, -1.668130, 0.026430, 0.811550, -1.327230, 
-0.086530, 1.444990, -0.559480, 0.584620, 0.364980, -1.547490, -0.887600, -0.238450, -0.276940, -0.607610, 
0.124320, 1.156600, 0.277380, 0.778630, -0.463220, 0.212400, 0.373720, -1.849280, 0.527080, 0.827800, 
-1.137460, -0.222340, 1.385410, -0.521400, 0.782120, 0.573250, -1.707390, -1.860600, -0.256280, -0.548960, 
-0.088880, -0.062270, 1.442750, 0.363410, 0.508380, -0.598270, -0.474770, -0.015260, 0.024800, 0.484880, 
0.410840, -1.065290, -0.362520, 0.855100, -0.416740, 0.119420, 0.118500, -0.865270, -1.097730, 0.011320, 
-0.370830, -0.054510, -0.321880, 0.715050, 0.336430, 0.066430, -0.005330, -0.318350, 0.169810, 0.619700, 
-0.173730, -0.168890, -0.296370, -0.396750, 0.299520, -0.020130, 0.001800, 0.020500, 0.157100, 0.062370, 
-0.028500, -0.476310, 0.499640, -0.430530, -0.085300, -0.241930, -0.423760, -0.623860, -0.030450, -0.065760, 
0.912700, 0.191790, -0.716710, 0.471940, -0.285220, -0.900620, 0.158200, -0.912480, -0.197450, 0.471860, 
0.724810, -0.220830, -0.511500, 0.363320, -0.068520, -0.397140, -0.194850, -0.328520, -0.328850, 0.184390, 
-0.711170, 0.831040, -0.344340, -0.324890, 0.761970, -0.137930, -1.246030, 0.154160, -1.047140, -0.177190, 
0.529400, 0.572450, -0.239560, -0.261420, 0.634180, 0.070980, -0.800040, -0.126920, -0.216370, 0.006690, 
0.187420, -0.079720, 0.442290, -0.172110, -0.895290, 1.022150, 0.035440, -0.865470, 0.455640, -1.124590, 
-0.124900, 0.627980, 0.046210, -0.172160, -0.342670, 0.468350, 0.086140, -1.087840, -0.048620, -0.530070, 
0.158320, -0.430800, -0.186120, -0.192240, 0.147710, -0.427580, 0.449760, 0.057270, -0.795720, 0.225110, 
-0.744430, 0.025490, 0.272200, -0.203480, -0.270590, -0.067400, 0.088120, 0.501470, -0.245040, -0.193940, 
-0.035230, 0.154290, 0.079850, -0.223940, -0.458130, -0.003680, -0.397090, -0.295800, -0.174890, -0.157300, 
0.069610, 0.104440, 0.029700, -0.254260, -0.511860, -0.058690, -0.039230, 0.124260, 0.178230, -0.125810, 
0.229410, -0.056030, 0.033660, 
-0.143450, -0.021010, -0.092270, -0.091540, -0.015880, -0.161800, -0.016780, -0.005470, -0.112040, -0.118460, 
-0.037930, -0.054690, 0.062420, -0.053790, 0.042280, -0.112490, -0.114470, -0.048830, 0.039420, -0.030810, 
-0.038000, -0.123810, -0.015000, -0.048670, -0.088610, -0.088060, -0.059770, 0.002860, -0.091400, -0.127400, 
-0.102000, -0.048000, -0.044060, 0.037150, -0.004030, -0.020770, -0.112740, -0.041740, -0.028810, -0.016080, 
-0.072360, -0.031160, -0.201980, -0.065570, -0.079500, -0.064010, -0.059270, -0.025010, -0.032610, -0.149410, 
-0.073100, -0.075380, -0.050250, 0.011730, 0.015480, -0.043880, -0.039060, -0.035400, -0.035380, -0.030020, 
-0.030570, -0.061490, -0.018030, -0.141470, -0.037700, -0.060900, -0.028020, -0.106300, 0.010840, -0.023510, 
-0.155470, -0.058030, -0.069840, -0.124890, -0.032350, 0.022510, -0.048300, -0.122750, 0.024610, -0.055420, 
-0.006910, -0.080210, -0.084410, 0.073010, -0.189420, -0.039210, 0.023500, -0.029410, -0.132600, -0.071080, 
0.024850, -0.100060, -0.015890, -0.165300, -0.122290, 0.031760, 0.038740, -0.045450, -0.077090, -0.053140, 
-0.095720, -0.085840, -0.110290, -0.016510, 0.113980, -0.231270, -0.044990, 0.026150, -0.198630, -0.157220, 
0.060880, 0.039450, -0.089850, -0.077030, -0.211790, -0.171010, 0.166740, 0.244140, -0.103940, -0.045450, 
-0.168520, -0.136060, -0.083940, -0.184030, -0.100690, 0.360590, -0.246460, 0.010530, 0.185120, -0.262670, 
-0.184750, 0.169830, -0.011100, -0.195070, -0.043120, -0.311170, -0.239630, 0.187800, 0.419510, -0.128310, 
-0.019330, -0.061720, -0.007950, -0.118230, -0.179180, -0.121040, -0.005570, -0.188560, -0.122570, 0.047860, 
-0.285280, -0.223990, 0.084320, -0.041380, -0.261060, -0.091040, -0.304810, -0.245590, 0.032290, 0.647340, 
-0.132700, -0.062400, -0.081770, 0.033830, -0.034500, -0.133850, -0.124830, 0.328180, -0.170560, -0.104840, 
0.066670, -0.081210, -0.186230, 0.077240, -0.004680, -0.219600, -0.104010, -0.338670, -0.262630, 0.027370, 
0.428460, -0.129800, -0.038200, -0.028030, 0.029900, -0.103730, -0.093670, -0.069510, 0.170560, -0.191440, 
-0.031130, 0.057930, -0.057690, -0.119110, 0.060050, -0.041870, -0.134500, -0.125320, -0.232200, -0.178210, 
0.007980, 0.252570, -0.130080, -0.053210, 0.003250, -0.002180, -0.102520, -0.067020, -0.104510, 0.061400, 
-0.154650, -0.001820, 0.027650, -0.047350, -0.016570, 0.018390, -0.056560, -0.116450, -0.126810, -0.164960, 
-0.143260, -0.026060, 0.074550, -0.104420, -0.071510, -0.027500, 0.014070, -0.028130, -0.053640, -0.081910, 
-0.021410, -0.049880, 0.015650, 0.004090, -0.052440, -0.018330, -0.060580, -0.060330, -0.070780, -0.126400, 
-0.124100, -0.098030, -0.072190, 0.018660, -0.097290, -0.120700, -0.059290, -0.002300, -0.049320, 0.026620, 
-0.077930, -0.066310, -0.073360, -0.004710, 0.014080, -0.068710, -0.002610, -0.002410, -0.022050, -0.096970, 
-0.052510, -0.178740, -0.118120, -0.047760, 0.052320, -0.066460, -0.066510, -0.111320, -0.035890, -0.113050, 
-0.009700, -0.017400, -0.098590, 
-0.056470, -0.029430, -0.069310, -0.082880, -0.023120, -0.021310, -0.037690, -0.044050, -0.107330, -0.152220, 
-0.010210, -0.039240, -0.076750, -0.049500, -0.054780, -0.080550, -0.103140, -0.042640, 0.020260, -0.015620, 
-0.021790, -0.061320, -0.023670, -0.035150, -0.128800, -0.009400, 0.018950, -0.051590, -0.069860, -0.116220, 
-0.103650, -0.032840, -0.004270, -0.072300, -0.068940, -0.094820, -0.082320, -0.091800, -0.058780, -0.021650, 
-0.053290, -0.013550, -0.110790, 0.022640, -0.035720, -0.126190, -0.023800, 0.058020, -0.005090, -0.069710, 
-0.173790, -0.110860, -0.003890, -0.075490, -0.064850, -0.096020, -0.100790, -0.058290, -0.047100, -0.068940, 
-0.022120, -0.025020, -0.017750, -0.074140, 0.045140, -0.026860, -0.227340, -0.032390, 0.074360, -0.023000, 
-0.051170, -0.193770, -0.057810, 0.028460, -0.055030, -0.000300, -0.135720, -0.087940, -0.065430, -0.078740, 
-0.112360, 0.026710, -0.024560, -0.071880, -0.066290, -0.024800, -0.027200, -0.100350, -0.108300, 0.078370, 
-0.002180, -0.088370, -0.142110, -0.108350, 0.013900, -0.078170, 0.053960, -0.080090, -0.090460, -0.057590, 
-0.103140, -0.141550, 0.035130, -0.025840, -0.077500, 0.001490, -0.023490, 0.022450, 0.046360, -0.113470, 
0.034010, -0.034640, -0.110750, -0.157220, -0.100220, 0.014610, -0.041930, -0.000140, -0.065720, -0.109600, 
-0.023840, -0.147870, -0.226210, 0.001570, -0.073110, -0.092200, 0.009960, -0.039280, -0.074750, 0.090390, 
0.021050, -0.082120, -0.054560, -0.016340, -0.183810, 0.012660, 0.075110, -0.126280, -0.103990, -0.082710, 
-0.144830, -0.116400, -0.159590, -0.149120, 0.024290, -0.059220, -0.002230, 0.068060, 0.012180, -0.024260, 
0.088890, 0.018480, -0.007140, -0.044450, -0.058770, -0.122760, 0.041430, 0.066730, -0.109000, -0.355100, 
0.022030, -0.060390, -0.112470, -0.139030, -0.223850, -0.030110, -0.093980, -0.123840, 0.052160, 0.049630, 
-0.054920, -0.064420, -0.010710, -0.119920, -0.024900, -0.023190, -0.085030, -0.003660, 0.065150, -0.076270, 
-0.199270, 0.079540, -0.026130, -0.184540, -0.129130, -0.172730, -0.041830, -0.098520, -0.101060, 0.118050, 
0.001240, -0.109450, -0.179930, 0.028250, -0.079590, -0.020500, -0.020460, -0.071280, 0.034490, 0.043570, 
-0.124890, -0.139170, 0.021700, -0.077590, -0.159470, -0.105460, -0.136070, -0.015700, -0.081550, -0.051250, 
0.100500, -0.073880, -0.122330, -0.149740, -0.044150, -0.065560, -0.011430, -0.047290, -0.077900, 0.062130, 
0.048670, -0.054890, -0.063380, -0.058580, -0.092510, -0.133880, -0.113710, -0.097100, -0.034430, -0.071420, 
-0.035480, 0.119080, -0.088140, -0.113280, -0.103030, -0.097230, -0.046500, -0.042520, -0.080670, -0.003570, 
-0.012390, -0.000730, -0.098010, -0.088300, -0.019910, -0.072750, -0.131000, -0.130840, -0.087350, -0.028340, 
-0.088660, -0.014150, 0.093920, -0.048730, -0.116120, -0.070090, -0.058030, -0.084330, -0.067520, -0.062800, 
-0.053660, -0.003620, 0.045160, -0.064740, -0.135870, 0.027440, -0.066140, -0.131390, -0.106050, -0.109980, 
-0.035120, -0.041470, -0.048230, 
-0.306650, -0.079910, 0.183330, -0.038090, 0.048840, 0.237590, -0.051090, -0.246070, -0.010450, -0.328530, 
-0.194820, -0.112750, 0.219740, 0.018790, -0.126140, -0.040880, -0.062930, -0.124960, -0.028800, -0.156130, 
0.196270, -0.375560, 0.125610, 0.268670, 0.064280, 0.007500, -0.022630, 0.000650, -0.308980, -0.076960, 
-0.437410, -0.080460, -0.012150, 0.326550, 0.025330, -0.087550, 0.111450, -0.155900, -0.253070, -0.013610, 
-0.255070, 0.136010, -0.415760, 0.110650, 0.189350, -0.135910, -0.002800, 0.125130, 0.122860, -0.377910, 
0.171210, -0.495260, -0.031120, 0.072160, 0.409570, -0.046380, 0.058260, -0.110490, -0.067130, -0.454610, 
-0.177630, 0.019760, 0.049530, -0.284430, 0.126650, 0.521960, -0.184020, -0.205440, 0.202850, 0.156650, 
-0.261070, -0.031950, -0.432510, -0.133590, 0.124000, 0.498200, -0.063920, 0.078640, -0.129230, -0.197020, 
-0.492260, -0.282960, -0.196780, 0.124970, -0.323200, 0.119210, 0.437220, -0.061530, -0.334930, -0.156950, 
0.041480, -0.417730, -0.037960, -0.269190, -0.130690, 0.197290, 0.622520, -0.128400, -0.027610, -0.035660, 
0.112270, -0.442160, -0.285800, -0.065570, 0.203380, -0.267060, -0.127840, 0.379630, 0.076330, -0.377650, 
-0.058710, 0.087990, -0.680810, -0.128800, -0.163430, -0.214870, 0.286920, 0.620510, -0.187210, -0.062790, 
0.072060, 0.080380, -0.557420, -0.573290, -0.173040, 0.926400, -0.022830, -0.251610, 0.530060, 0.455140, 
-0.371500, 0.103690, -0.000610, -0.785630, 0.029720, -0.341820, -0.046910, 0.395590, 0.742240, -0.100640, 
0.036310, 0.170470, 0.134810, -0.792460, -0.503210, -0.374860, -0.005010, -0.186840, -0.134760, 0.346250, 
0.215580, -0.302370, 0.158130, 0.017400, -0.710100, -0.108470, -0.435230, -0.216000, 0.085870, 0.954840, 
0.028850, 0.020590, 0.103900, -0.177030, -0.777090, -0.302230, -0.333250, 0.760660, -0.289510, -0.028510, 
0.325980, 0.090990, -0.240200, 0.223830, 0.133320, -0.337830, -0.076490, -0.401110, -0.233610, 0.131300, 
0.714980, -0.004480, 0.080140, -0.081390, -0.176820, -0.610250, -0.231550, -0.374590, 0.331610, -0.265080, 
0.093900, 0.197150, -0.164020, -0.222590, 0.332860, 0.101890, -0.283720, -0.121180, -0.347470, -0.249460, 
0.144240, 0.667970, -0.134320, 0.054460, -0.187160, -0.098390, -0.194030, -0.217980, -0.209570, 0.088550, 
-0.136660, 0.185860, 0.081450, -0.329640, -0.230110, 0.153800, -0.001960, -0.376230, -0.107160, -0.377820, 
-0.040180, 0.135580, 0.686160, -0.066540, -0.038930, -0.155760, 0.034370, -0.335390, -0.038890, -0.185150, 
0.092930, -0.070590, 0.252550, -0.069670, -0.301870, -0.311880, 0.008820, 0.081790, -0.329280, -0.010450, 
-0.301000, -0.104880, 0.245220, 0.417170, -0.011730, -0.309390, -0.124280, 0.062630, -0.212900, 0.033040, 
-0.055580, 0.093410, -0.002890, 0.047400, -0.095770, -0.104080, -0.389740, 0.014970, -0.006400, -0.265460, 
-0.019430, -0.294160, -0.140390, 0.116480, 0.255340, 0.206410, -0.178270, -0.052670, 0.021710, -0.363090, 
0.176810, -0.080600, 0.118050, 
-0.088480, -0.016800, -0.068010, -0.133830, 0.029810, -0.038510, -0.050980, 0.005920, -0.122710, -0.119330, 
-0.065430, -0.080740, -0.024310, -0.065790, -0.004780, -0.110980, -0.161510, -0.001170, 0.075930, -0.026320, 
-0.033990, -0.137890, 0.013650, 0.057840, -0.114940, -0.007940, 0.032990, -0.036980, -0.108310, -0.125910, 
-0.156530, -0.049620, 0.025950, 0.006020, 0.007880, -0.063900, -0.101560, -0.114640, -0.061260, -0.011370, 
-0.105040, -0.020090, -0.201870, 0.045930, 0.022400, -0.122280, -0.029280, 0.126870, 0.010470, -0.185520, 
-0.112250, -0.148030, -0.017760, -0.043050, 0.040660, -0.084000, -0.051620, -0.021210, -0.053220, -0.144830, 
-0.054650, -0.021300, -0.029330, -0.093930, 0.079150, 0.051010, -0.253340, -0.093290, 0.193200, 0.012850, 
-0.126760, -0.209290, -0.060660, -0.030430, -0.019220, 0.131060, -0.123650, -0.114730, -0.033810, -0.110990, 
-0.183430, -0.051690, -0.071030, -0.003980, -0.195880, 0.057710, 0.047420, -0.105210, -0.217920, 0.131400, 
0.072110, -0.153080, -0.094510, -0.146090, -0.087840, 0.027280, 0.224890, -0.102380, -0.124410, -0.063870, 
-0.102000, -0.237850, -0.046700, -0.006800, 0.036830, -0.103390, -0.015590, 0.145340, -0.002440, -0.240210, 
0.152710, 0.070440, -0.275860, -0.135240, -0.171130, -0.114960, 0.202610, 0.302660, -0.119900, -0.116230, 
-0.018980, -0.184840, -0.363730, -0.189270, -0.179130, 0.316940, -0.093180, -0.060690, 0.212850, 0.142150, 
-0.132710, 0.107520, -0.023450, -0.296230, -0.147620, -0.191570, -0.053000, 0.152110, 0.336340, -0.146410, 
-0.103870, 0.021830, -0.072410, -0.361280, -0.181370, -0.158250, 0.009380, -0.041240, -0.042850, 0.124480, 
0.016640, -0.106990, 0.201520, -0.044890, -0.307970, -0.148280, -0.144120, -0.102480, 0.017030, 0.293140, 
-0.057080, -0.062110, -0.063210, -0.088770, -0.397530, -0.162000, -0.215250, 0.226230, -0.072550, 0.019940, 
0.062900, -0.065870, -0.118000, 0.041770, -0.015960, -0.156670, -0.111220, -0.148500, -0.115710, 0.028150, 
0.307720, 0.012280, 0.014560, -0.198500, -0.089790, -0.280870, -0.108080, -0.166620, 0.083870, 0.009560, 
0.022800, 0.014080, -0.205500, -0.043570, 0.047670, -0.011250, -0.101350, -0.103390, -0.124500, -0.101790, 
-0.005010, 0.239090, -0.079140, -0.071750, -0.113480, -0.062910, -0.190110, -0.077450, -0.141500, 0.024100, 
0.058480, -0.018420, -0.018350, -0.182570, -0.111630, 0.030600, -0.056430, -0.153670, -0.104180, -0.078040, 
-0.052170, 0.024580, 0.178130, -0.110110, -0.134210, -0.085440, -0.029090, -0.120530, -0.041030, -0.121440, 
0.027570, 0.142430, 0.034890, -0.070740, -0.153920, -0.129240, -0.061950, -0.053840, -0.099770, -0.022470, 
-0.058000, -0.078390, -0.048030, 0.052980, -0.078710, -0.146030, -0.132620, -0.043630, -0.077110, 0.028510, 
-0.117970, 0.024130, 0.128490, -0.051390, -0.093430, -0.121730, -0.091520, -0.054360, -0.046230, -0.063430, 
-0.050210, -0.044700, -0.035760, -0.026240, -0.015610, 0.030220, -0.068000, -0.164610, -0.116610, -0.139950, 
-0.010580, -0.013610, -0.033830, 
-0.087990, -0.163090, -0.345880, 0.483780, -0.033620, -0.157690, -0.377880, -0.170350, 0.042380, 0.062610, 
-0.075640, -0.124660, 0.050500, 0.177580, -0.258060, 0.140610, -0.076800, -0.182810, -0.088700, -0.190820, 
-0.101290, 0.295730, 0.151440, -0.301150, -0.064990, -0.073550, -0.476470, -0.289320, 0.247760, -0.244110, 
0.168530, 0.077590, -0.287670, 0.010130, -0.365930, -0.240190, -0.116860, -0.241730, 0.068130, 0.337200, 
-0.137840, 0.014320, 0.022260, -0.156990, -0.145540, 0.090710, -0.069330, -0.422730, -0.059210, -0.085570, 
0.164900, 0.097010, -0.039540, 0.111290, -0.034870, -0.182100, -0.046200, -0.107260, -0.228060, -0.423080, 
0.065030, -0.110450, 0.063150, 0.150480, -0.214260, 0.214180, 0.287090, -0.180580, -0.468800, 0.008590, 
-0.291000, 0.429990, -0.410690, -0.309240, -0.168450, -0.081460, 0.124880, 0.307610, -0.022900, -0.091570, 
-0.468950, -0.406860, -0.161640, 0.342670, 0.478920, -0.350640, 0.664270, 0.154320, -0.250660, -0.245100, 
0.025460, -0.853560, 0.204310, -0.520740, -0.172070, 0.295410, 0.000270, 0.062270, -0.066690, -0.006610, 
-0.057480, -0.521790, -0.509670, -0.256760, 0.497590, 0.176200, -0.295510, -0.067030, -0.178750, -0.147730, 
-0.111860, -0.155520, -0.661170, -0.088580, 0.076350, -0.185540, 0.036820, 0.274240, -0.099970, -0.420160, 
-0.243880, 0.200930, -0.145880, -0.785000, 0.008260, 1.387790, -0.459200, -0.422840, 0.888420, -0.301010, 
-0.455450, 1.112260, 0.148270, -0.993080, -0.154030, -0.476660, -0.231050, 0.856250, 1.036180, -0.388670, 
-0.249500, 0.490540, 0.289710, -0.743000, -0.710060, -0.658610, 0.006530, -0.389140, -0.666180, -0.090590, 
-0.126830, -0.473080, -0.084700, -0.013990, -0.437140, 0.173470, -0.085120, -0.442750, -0.172590, 1.486350, 
-0.046650, -0.115330, 0.358290, -0.358910, -0.444980, -0.323450, -0.520410, 1.307640, -0.224710, -0.604930, 
0.191950, 0.665240, -0.598570, -0.028520, -0.162990, -0.535810, 0.200070, -0.797060, -0.462550, 0.149250, 
1.162030, -0.022090, 0.001630, 0.656990, 0.009710, -0.585070, -0.384240, -0.658440, 0.594750, -0.096570, 
-0.198830, 0.217270, 0.738940, -0.323060, -0.463460, -0.118210, -0.537030, -0.179750, 0.003650, -0.311870, 
-0.095020, 0.644700, -0.020770, -0.018570, -0.238050, -0.082460, -0.154060, -0.161810, -0.208060, 0.165920, 
-0.086490, 0.316710, -0.161510, 0.045390, -0.043340, -0.717340, -0.131250, 0.103190, -0.285060, 0.027490, 
-0.023790, -0.502820, 0.146970, -0.026920, 0.230360, -0.149880, 0.170680, -0.261390, -0.119020, 0.089650, 
-0.082310, -0.417110, 0.040230, 0.035840, -0.034060, -0.169350, -0.254860, 0.126610, 0.078200, -0.140130, 
0.308850, 0.188660, -0.114820, -0.051140, 0.027590, 0.006320, 0.004880, -0.132440, -0.379360, -0.193220, 
-0.010300, -0.319760, -0.455540, 0.042940, 0.029800, 0.260110, -0.362830, -0.329820, 0.111370, -0.126510, 
0.018960, -0.243230, -0.279290, -0.164140, 0.114470, 0.320610, -0.004390, 0.152010, 0.301130, -0.158600, 
0.106060, -0.470540, -0.298900, 
-0.119250, -0.032660, -0.097180, -0.066540, -0.027710, -0.110990, -0.031540, -0.036770, -0.105600, -0.123800, 
-0.035040, -0.069990, 0.029070, -0.023160, 0.013090, -0.083620, -0.097520, -0.068430, 0.017030, -0.040390, 
-0.047210, -0.125270, 0.004340, -0.048400, -0.069150, -0.052210, -0.056880, -0.017140, -0.090210, -0.098510, 
-0.092540, -0.045450, -0.042700, 0.019100, -0.000770, -0.048790, -0.112460, -0.077570, -0.064830, 0.006040, 
-0.068840, -0.023090, -0.188250, -0.038120, -0.041120, -0.075550, -0.064570, -0.039680, -0.009630, -0.162140, 
-0.052090, -0.110700, -0.039110, 0.007140, -0.000200, -0.030040, -0.016560, -0.050730, -0.049930, -0.084190, 
-0.024310, -0.066550, -0.014170, -0.124010, -0.004100, -0.034480, -0.058260, -0.104150, -0.000410, -0.009510, 
-0.167890, -0.063780, -0.089550, -0.096290, -0.025120, 0.020040, -0.040910, -0.086280, -0.008100, -0.074020, 
-0.087680, -0.080210, -0.087530, 0.048280, -0.160100, -0.011740, 0.029010, -0.045170, -0.137940, -0.069560, 
0.024550, -0.116780, -0.038610, -0.161730, -0.115070, 0.008330, 0.045570, -0.030650, -0.063260, -0.067180, 
-0.085300, -0.124100, -0.085170, -0.031480, 0.105720, -0.162700, -0.050690, 0.004060, -0.128890, -0.145790, 
0.040590, 0.024210, -0.143440, -0.099790, -0.158350, -0.135250, 0.112130, 0.211210, -0.099330, -0.081970, 
-0.128940, -0.105690, -0.114120, -0.181850, -0.086740, 0.324640, -0.207420, -0.019940, 0.142710, -0.132900, 
-0.164260, 0.116200, -0.004940, -0.188480, -0.066770, -0.232780, -0.143440, 0.131070, 0.329970, -0.117860, 
-0.051650, -0.035540, -0.032370, -0.177810, -0.179600, -0.120350, -0.004610, -0.155100, -0.102020, -0.003100, 
-0.173170, -0.180480, 0.055570, -0.020620, -0.221440, -0.095810, -0.257880, -0.175330, -0.002780, 0.502770, 
-0.113010, -0.071540, -0.073550, -0.031660, -0.079950, -0.119880, -0.132980, 0.291970, -0.156070, -0.072750, 
0.036300, -0.062360, -0.162730, 0.018700, -0.020190, -0.180580, -0.076990, -0.256550, -0.202990, 0.001480, 
0.332410, -0.069050, -0.010890, -0.030140, -0.009090, -0.138080, -0.091430, -0.104680, 0.135110, -0.145050, 
-0.022980, 0.045220, -0.070800, -0.107140, 0.004270, -0.014190, -0.140670, -0.119490, -0.198380, -0.134270, 
0.009830, 0.203900, -0.095370, -0.044880, -0.039350, -0.022630, -0.095710, -0.062160, -0.100130, 0.029370, 
-0.100900, 0.012700, 0.005490, -0.082060, -0.066490, -0.000820, -0.036470, -0.140830, -0.128020, -0.142780, 
-0.099690, -0.042410, 0.073390, -0.082010, -0.069840, -0.028170, -0.010630, -0.078650, -0.053100, -0.068290, 
-0.017880, -0.071580, 0.040840, -0.024850, -0.081070, -0.055190, -0.062080, -0.036330, -0.090800, -0.110590, 
-0.101200, -0.080320, -0.051900, 0.015230, -0.084630, -0.094790, -0.077180, -0.027150, -0.069550, 0.016790, 
-0.058310, -0.041050, -0.053090, -0.022530, -0.027190, -0.077870, -0.038660, -0.040110, -0.022190, -0.091600, 
-0.069390, -0.156060, -0.093110, -0.040930, 0.016340, -0.026060, -0.047040, -0.070450, -0.026200, -0.139530, 
0.000140, -0.045590, -0.073580, 
0.295990, -0.372020, 0.494730, 0.940880, -0.465150, -0.653230, -0.605420, -0.386570, 0.291900, -0.421170, 
-0.019350, 0.178000, -0.714310, 0.308970, 0.252370, 0.399050, -0.504260, -0.504750, -0.083970, -0.330740, 
-0.418430, 0.266380, -0.204060, -0.351320, -0.224680, 0.442360, -0.613040, 0.130280, 0.041620, -0.548610, 
0.914760, 0.207220, -0.688830, -0.576390, -0.831010, -0.523900, -0.300110, 0.155580, 0.181450, 0.388930, 
0.187980, -0.390300, 0.192700, 0.152130, -0.495880, -0.595450, 0.167640, -0.949770, -0.056160, 0.354300, 
-0.065750, 0.468380, 0.228610, -0.958290, -0.227510, 0.001610, -0.011790, -0.475910, -0.066910, -0.035410, 
0.261630, 0.064250, -0.256300, 0.076410, -0.817400, 0.881860, 1.346390, -1.061620, -0.793390, -0.739440, 
-1.159880, 0.981550, -1.129640, -0.376860, 0.896560, -0.455860, 1.084580, 0.974440, 0.052690, -0.505380, 
-1.072780, -0.185490, -0.269200, -0.089830, 0.862830, -0.821320, 0.332070, 0.605910, -0.230890, -1.083840, 
0.005490, -0.148460, 0.106230, 0.098460, -0.008630, 0.016810, -0.726460, 0.090870, 0.244850, -0.588470, 
-0.497300, -0.223790, -0.339320, 0.199050, -0.193040, 0.597000, 0.641090, -1.457890, -1.634840, 1.421370, 
-1.701160, -0.082270, 1.490260, -1.597140, 1.750510, 0.935630, -1.355320, -0.838670, -0.714300, -0.770840, 
-1.057960, 0.073210, 1.197290, 1.018860, 0.306470, -0.566450, 0.404030, 0.013930, -0.906880, 0.450360, 
-0.079460, -0.970970, -0.778210, 0.098510, 0.571210, 0.611130, 0.304740, -0.725520, -1.457860, 0.252490, 
0.683360, -0.540540, -0.354240, -0.026950, 0.120310, 0.004400, 0.003770, 0.731490, -1.412170, 0.717160, 
1.596840, -1.742240, -0.297300, 0.284960, -1.487320, 1.462000, -1.422600, -0.934590, 0.825580, -0.774260, 
1.296450, 0.984120, 1.122910, -0.362310, -1.556650, -0.592350, -0.409190, -0.354600, 0.356450, 0.185510, 
-0.348310, -0.043700, 0.119180, -0.576600, 0.020420, 0.219360, -0.380450, 0.493470, 0.564010, -0.311890, 
-1.733210, 0.018770, -0.505130, -0.293580, -0.130890, -0.385210, 0.133050, 0.372130, -0.133010, 0.095690, 
0.499160, -1.263030, -1.637430, 1.097570, -0.227990, -0.208140, 1.145630, -0.529340, 1.468820, 1.141390, 
-0.548270, -0.863820, -1.049850, -1.017450, -1.044720, -0.688090, 0.802770, 0.411430, 0.350110, -0.296240, 
-0.149240, -0.323190, 0.253650, 0.171020, -0.618480, 0.065270, -0.383380, -0.371650, 0.682690, -0.407610, 
-0.161110, 0.248580, 0.022690, 0.194260, 0.214550, 0.072830, -0.561180, -0.094050, -0.172480, -0.557040, 
-0.412200, -0.034260, -0.369710, 0.440730, 0.316620, -0.285890, -0.273400, -0.048990, -0.745190, 0.686980, 
-1.030130, -0.182200, 0.288110, -0.257880, 0.522860, 0.479670, 0.138280, 0.138350, -0.685390, -0.794020, 
-0.417500, -0.215170, -0.018500, -0.024350, -0.404070, -0.869730, 0.084410, -0.441290, -0.058860, 0.012090, 
-0.303300, 0.254340, 0.175890, -0.117190, -0.114330, -0.398900, -0.223840, -0.099620, -0.234590, 0.020020, 
0.022860, 0.235290, 0.156390, 
-0.049740, -0.083300, -0.089700, -0.178920, -0.027980, -0.102980, 0.026120, -0.063740, -0.164580, -0.098690, 
0.028490, 0.009400, -0.205220, -0.112610, -0.168000, 0.015260, 0.027860, 0.045170, -0.099370, 0.087020, 
-0.115470, 0.001630, -0.086900, -0.071430, -0.178360, -0.089030, -0.005170, -0.052260, -0.108960, -0.070080, 
-0.092400, -0.108200, 0.030960, -0.137580, -0.083050, -0.113020, 0.040150, -0.016320, -0.009020, -0.064120, 
0.006210, -0.090870, 0.029130, -0.053850, -0.124360, -0.187530, -0.063150, -0.025740, 0.001540, 0.053980, 
-0.281380, -0.055180, -0.008370, -0.162650, -0.163080, -0.235250, -0.081960, 0.003670, 0.075720, 0.056300, 
-0.065010, 0.009920, -0.057260, -0.058820, -0.004460, -0.128700, -0.387180, 0.083250, 0.129440, -0.020410, 
0.060340, -0.282850, 0.026040, 0.038870, -0.085810, -0.225980, -0.299710, -0.081210, -0.066710, 0.030310, 
0.088160, 0.025740, 0.038650, -0.209560, 0.108250, -0.119360, -0.182750, -0.239860, 0.111060, 0.073430, 
-0.107380, 0.053610, -0.202010, 0.042960, 0.095900, -0.194850, -0.250300, -0.157390, -0.087840, -0.074130, 
-0.159920, 0.150040, 0.113140, 0.001500, -0.317210, 0.190980, 0.011850, -0.240420, 0.032380, 0.054390, 
-0.082510, -0.128440, 0.179310, -0.086060, 0.060840, 0.077340, -0.427390, -0.565570, -0.065690, -0.113670, 
-0.083380, -0.124720, 0.142230, 0.238550, 0.100750, -0.547520, 0.130850, 0.187800, -0.580580, -0.207020, 
0.305000, -0.227350, -0.073030, 0.463890, -0.350450, 0.260350, 0.156380, -0.544370, -1.019290, -0.195270, 
-0.275960, -0.145200, -0.041240, 0.343610, 0.236160, 0.249100, 0.000000, 0.069700, 0.230700, -0.420780, 
-0.200370, 0.321690, -0.208500, -0.069960, 0.375210, -0.262200, 0.500990, 0.256440, -0.329450, -1.003450, 
-0.146580, -0.203380, -0.188090, -0.048360, 0.220480, 0.104520, 0.213730, -0.489550, 0.044070, 0.085830, 
-0.192760, -0.222040, 0.190770, -0.144120, -0.021980, 0.046110, -0.114390, 0.198790, 0.132800, -0.163560, 
-0.501540, -0.002670, -0.093220, -0.124540, -0.095230, -0.059400, 0.006840, 0.070510, -0.321610, 0.021840, 
-0.037520, -0.113010, -0.187670, 0.131480, -0.030650, 0.037260, 0.000520, -0.152740, 0.214480, 0.060690, 
-0.250970, -0.429240, 0.015990, -0.206100, -0.131630, -0.051610, -0.086240, -0.040430, 0.023360, -0.101530, 
-0.006290, -0.064380, -0.304000, -0.375330, 0.096920, -0.024890, -0.001660, 0.000800, -0.190580, 0.308280, 
0.080040, -0.153140, -0.175020, -0.066960, -0.150300, -0.168240, -0.109670, 0.041280, -0.038790, -0.025920, 
0.003230, -0.060010, -0.089450, -0.169540, -0.161410, -0.101090, 0.106380, -0.047140, -0.089240, -0.037470, 
0.122860, -0.036030, -0.105010, -0.034070, 0.004690, -0.157100, -0.081870, -0.109660, -0.039710, -0.096790, 
-0.067730, -0.029060, -0.058050, -0.060450, -0.050850, 0.041010, -0.134250, 0.062150, -0.006440, -0.198550, 
0.005530, -0.122060, -0.037880, -0.096710, -0.063010, -0.026620, -0.079970, -0.057880, 0.015250, -0.141700, 
-0.089600, -0.138880, -0.058890, 
-0.058190, -0.038270, -0.055170, -0.152410, -0.023330, -0.128090, 0.001470, -0.007550, -0.068710, -0.066970, 
-0.033470, -0.044690, -0.079710, -0.083840, -0.020020, -0.100190, -0.110560, -0.015090, 0.021100, 0.003110, 
-0.050910, -0.070660, -0.046000, -0.028430, -0.165130, -0.038890, -0.033630, -0.042430, -0.054240, -0.058770, 
-0.083310, -0.073020, -0.003850, -0.074410, -0.035970, -0.053660, -0.097740, -0.071040, -0.039920, -0.045380, 
-0.031520, -0.027580, -0.100680, -0.003170, -0.059060, -0.130430, -0.050530, 0.019730, -0.012800, -0.063840, 
-0.161050, -0.098970, -0.026470, -0.081070, -0.070020, -0.091520, -0.057130, -0.028920, -0.013400, -0.041080, 
-0.061970, -0.020860, -0.028610, -0.080610, 0.024210, -0.078590, -0.221550, -0.020490, 0.045400, -0.024070, 
-0.037160, -0.175300, -0.032500, -0.007010, -0.026010, -0.033280, -0.157130, -0.105080, -0.043810, -0.063610, 
-0.034550, 0.024740, -0.001290, -0.050560, -0.092470, -0.010490, -0.087960, -0.155180, -0.063430, 0.104750, 
0.016860, -0.008320, -0.140280, -0.049610, -0.026270, -0.069750, -0.017250, -0.119820, -0.120840, -0.042730, 
-0.147570, -0.009620, 0.021470, -0.000410, -0.097960, -0.047060, 0.041560, -0.056650, -0.058120, -0.064040, 
0.066140, -0.013450, -0.003580, -0.108900, -0.097970, -0.021850, -0.070290, -0.060580, -0.092530, -0.060230, 
-0.068770, -0.170870, -0.085890, 0.029030, -0.044900, -0.129850, -0.080080, 0.055180, -0.078330, -0.040950, 
0.020530, -0.025650, -0.054960, 0.063700, -0.192590, -0.079040, -0.026440, -0.098970, -0.157730, -0.130200, 
-0.126580, -0.077600, -0.083630, -0.034360, 0.026500, 0.017150, -0.007810, -0.017220, 0.056440, -0.012690, 
-0.068890, 0.051280, 0.008140, -0.059870, 0.003020, -0.176410, 0.018440, 0.016370, -0.097040, -0.182600, 
-0.104270, -0.136530, -0.125640, -0.034800, -0.091550, -0.035920, 0.003310, -0.122920, -0.032750, 0.065660, 
-0.024170, -0.195930, 0.066130, -0.080920, -0.029360, 0.013760, -0.136190, 0.007440, 0.000870, -0.078750, 
-0.009150, -0.058860, -0.113050, -0.174840, -0.077700, -0.099650, -0.026160, 0.000180, -0.081340, -0.007840, 
-0.003520, -0.046290, -0.187190, 0.041460, -0.043260, -0.028420, -0.011520, -0.097530, -0.045410, -0.028100, 
-0.090640, -0.026430, -0.038350, -0.138470, -0.104920, -0.080950, -0.095730, -0.031990, -0.044060, -0.021730, 
-0.000810, -0.063840, -0.085230, -0.170590, -0.012110, -0.010200, -0.022160, -0.084190, -0.089860, -0.017520, 
-0.038610, -0.016150, -0.029360, -0.099010, -0.116010, -0.087280, -0.031460, -0.032200, -0.039270, -0.080120, 
0.009760, 0.018540, -0.066000, -0.081480, -0.105010, -0.051770, -0.011270, -0.055550, -0.082610, -0.028570, 
-0.056500, -0.061210, -0.093360, -0.028250, -0.065500, -0.111240, -0.104570, -0.049660, -0.036560, -0.011730, 
-0.070770, 0.008150, 0.020930, -0.036570, -0.074750, -0.106940, -0.033530, -0.000740, -0.067290, -0.085980, 
-0.026400, -0.062790, -0.001920, -0.074380, -0.040430, -0.069380, -0.079230, -0.120450, -0.048720, -0.080820, 
-0.062540, -0.041340, -0.047700, 
-0.138020, -0.031800, -0.021980, -0.083020, 0.047030, -0.033410, -0.066490, -0.053100, -0.100090, -0.165090, 
-0.095970, -0.075120, 0.065970, -0.029860, -0.008930, -0.093840, -0.142090, -0.026790, 0.063280, -0.066440, 
-0.001220, -0.195120, 0.069050, 0.123230, -0.023590, -0.001700, -0.024550, -0.023260, -0.151570, -0.132530, 
-0.199900, -0.038320, -0.005230, 0.085040, 0.015750, -0.060750, -0.059370, -0.136470, -0.121020, -0.001810, 
-0.148470, 0.025150, -0.246760, 0.047090, 0.062690, -0.097160, -0.000400, 0.082840, 0.001770, -0.254930, 
-0.029910, -0.230550, -0.022190, -0.004640, 0.126220, -0.042310, -0.005740, -0.047090, -0.071010, -0.237620, 
-0.065150, -0.021590, -0.024920, -0.119430, 0.082900, 0.187400, -0.168320, -0.138640, 0.159760, 0.046430, 
-0.229550, -0.124550, -0.155940, -0.087050, 0.016830, 0.208050, -0.062260, -0.048940, -0.043420, -0.133270, 
-0.270790, -0.115960, -0.105110, 0.057010, -0.206650, 0.056120, 0.175650, -0.060710, -0.255730, -0.016680, 
0.059830, -0.251930, -0.051240, -0.195840, -0.124090, 0.084700, 0.318150, -0.064720, -0.088490, -0.059220, 
-0.033770, -0.330080, -0.123230, -0.034830, 0.136010, -0.127310, -0.055400, 0.215680, 0.006070, -0.286850, 
0.062360, 0.083950, -0.414280, -0.125420, -0.187780, -0.150280, 0.237620, 0.418300, -0.131660, -0.093330, 
-0.014280, -0.126980, -0.406960, -0.322450, -0.188910, 0.550150, -0.080110, -0.118450, 0.321300, 0.188200, 
-0.227980, 0.133510, -0.000380, -0.465540, -0.084900, -0.263330, -0.092160, 0.256400, 0.502830, -0.135250, 
-0.056400, 0.071500, -0.004570, -0.495580, -0.293770, -0.233120, 0.009920, -0.107070, -0.107810, 0.159810, 
0.028640, -0.192820, 0.229530, -0.015850, -0.460630, -0.106640, -0.286040, -0.186480, 0.062040, 0.606810, 
-0.035920, -0.027710, -0.011100, -0.113060, -0.487310, -0.215520, -0.262970, 0.455030, -0.152580, -0.025010, 
0.139690, -0.005280, -0.175750, 0.110730, 0.005410, -0.242850, -0.082710, -0.266820, -0.189580, 0.062250, 
0.483550, -0.001550, 0.047750, -0.141450, -0.094380, -0.367280, -0.143230, -0.228400, 0.203700, -0.082030, 
0.002420, 0.053390, -0.177570, -0.116720, 0.109850, 0.007750, -0.161950, -0.104480, -0.213950, -0.157480, 
0.052600, 0.407470, -0.098820, -0.036710, -0.112790, -0.033560, -0.192200, -0.105340, -0.153120, 0.059050, 
0.000730, 0.052310, 0.010860, -0.196020, -0.150350, 0.085290, -0.043880, -0.237480, -0.116830, -0.185360, 
-0.061150, 0.027170, 0.326380, -0.110430, -0.099310, -0.074330, 0.006880, -0.184250, -0.049930, -0.119670, 
0.042110, 0.075130, 0.102840, -0.046540, -0.174230, -0.163050, -0.063970, -0.013970, -0.173420, -0.028540, 
-0.127200, -0.084820, 0.041840, 0.133280, -0.074600, -0.167400, -0.091910, -0.011230, -0.131280, 0.027300, 
-0.108010, 0.027020, 0.076320, -0.035530, -0.087370, -0.102900, -0.153930, -0.072210, -0.012440, -0.099220, 
-0.048460, -0.114150, -0.081240, 0.022310, 0.065800, 0.078870, -0.084110, -0.118860, -0.068650, -0.190210, 
0.047700, -0.025710, -0.007330, 
0.046240, -0.182920, -0.198870, 0.003860, -0.034920, 0.110410, 0.052800, -0.194900, -0.540520, -0.274840, 
0.196230, 0.002060, -0.054640, 0.105890, -0.565960, 0.140230, 0.047320, -0.213570, -0.469370, 0.146430, 
-0.109410, -0.233680, 0.020640, 0.088870, 0.096550, -0.375300, 0.050410, -0.189580, -0.384920, 0.079640, 
-0.496350, -0.150210, -0.038160, -0.099870, 0.283570, -0.270460, 0.375290, -0.286000, -0.182030, -0.376470, 
0.021510, 0.075590, -0.403740, -0.312990, -0.104800, -0.151100, -0.031960, 0.053220, 0.079880, -0.177440, 
-0.463190, 0.207420, -0.135280, 0.330760, -0.143750, -0.497520, -0.550480, 0.126840, 0.208730, -0.034410, 
-0.105760, 0.047890, 0.043520, -0.379820, 0.254120, -0.041540, -0.718840, 0.416930, -0.117550, 0.042570, 
-0.173100, -0.608930, 0.415720, -0.047540, -0.101940, -0.024590, -0.554100, -0.098380, -0.163970, 0.233330, 
0.253110, -0.312510, 0.069180, -0.354980, -0.057670, -0.467050, 0.111880, 0.479680, -0.117220, -0.219030, 
-0.592950, -0.114910, 0.262260, -0.181460, 0.205980, -0.635090, -0.068330, 0.203320, 0.209360, -0.612700, 
0.099080, 0.217600, 0.043580, -0.103950, -0.621800, 0.595030, -0.611870, 0.054200, 0.720100, -0.064380, 
-0.499230, -0.066070, -0.349250, 0.035300, -0.554390, -0.156690, -0.228520, -0.771800, 0.125000, -0.320070, 
0.101460, 0.517580, 0.028110, 0.211180, 0.209040, -0.992810, 0.586670, 0.596130, -1.461950, -0.472560, 
1.107660, -1.103790, 0.043580, 1.024120, -0.939950, 1.048940, 0.750900, -1.502740, -2.076940, -0.189450, 
-0.756020, -0.770690, 0.035690, 0.983050, 0.545490, 0.509570, 0.000120, 0.447660, 0.631440, -1.129050, 
-0.408200, 0.696650, -1.059350, -0.129160, 1.006610, -0.168290, 0.998050, 0.581570, -0.849290, -2.284690, 
0.064400, -0.025460, -0.663530, -0.547320, 0.761710, 0.501880, 0.329550, -0.759460, 0.332930, -0.310310, 
-0.120760, 0.880020, -0.726010, -0.647190, -0.191760, -0.614020, 0.852790, -0.239790, -0.124600, 0.161320, 
-1.683870, 0.929800, 0.583310, 0.334700, -0.042550, -0.423530, -0.133540, -0.156220, -0.664800, 0.292440, 
-0.222780, -0.541990, 0.075960, -0.035130, -0.685200, 0.307120, -0.044790, 0.106270, 0.269270, 0.235520, 
-0.308360, -1.411110, 0.147350, 0.100600, -0.295930, 0.119930, 0.239880, -0.049090, 0.123900, -0.443510, 
0.269150, 0.366090, -1.231550, -1.177060, 0.461470, -0.433340, 0.052400, 0.694750, -0.522460, 1.114010, 
0.730600, -0.576750, -1.011870, -0.364280, -0.330930, -0.379100, -0.455950, 0.660900, 0.197350, 0.321080, 
-0.374580, 0.359820, 0.097750, -0.224080, -0.251290, -0.432220, 0.080510, 0.101450, -0.207760, 0.237960, 
0.357270, 0.166440, 0.054830, -0.389950, 0.063340, -0.125750, -0.341400, -0.346440, -0.294710, -0.270730, 
-0.123700, -0.461390, -0.036840, -0.392160, 0.102980, 0.624360, -0.257660, 0.205120, 0.081870, -0.597440, 
0.258850, -0.669980, -0.087230, 0.300930, -0.484150, 0.452280, 0.491870, 0.109400, -0.010440, -0.937800, 
-0.334860, -0.387340, -0.425510, 
0.151270, -0.369420, 0.005250, 0.233040, -0.429510, 0.092550, -0.486860, -0.502800, 0.223110, -0.230520, 
-0.428430, 0.061900, -0.016220, 0.307120, -0.221500, 0.150700, 0.121620, -0.336040, -0.639800, -0.231890, 
0.324690, 0.069510, -0.144240, 0.091130, 0.376030, -0.201390, 0.300490, 0.142870, -0.820720, 0.664140, 
-0.724540, -0.652780, -0.034540, -0.189230, -0.245230, -0.368460, 0.206680, 0.078690, -0.133860, -0.629820, 
-0.286110, 0.280810, -0.102360, -0.118210, 0.417430, 0.055130, -0.435710, 0.395650, -0.410480, -0.717610, 
0.554160, -0.385160, -0.416130, 0.137190, 0.330040, 0.251000, -0.271470, -0.122620, -0.256820, -0.307960, 
-0.361550, -0.321390, -0.097760, -0.975640, -0.472080, 0.723740, -0.118890, -0.646120, 0.587900, 0.051890, 
-0.331010, 0.695960, -0.753770, -0.781720, 0.669220, 0.337490, 0.151240, 0.259230, -0.247350, 0.397150, 
-0.507670, -0.435800, -0.241440, -0.520160, 0.247510, -0.206050, 0.028110, -1.133230, 0.177320, 0.149910, 
-0.590760, 0.468790, -0.430480, 0.140500, 0.041120, -0.556060, -0.225540, 0.252750, 0.409040, -1.244460, 
-0.506710, 0.561930, 0.481510, 0.448940, -0.723020, -0.370750, -0.489200, -0.099160, 0.582580, -0.498440, 
-1.232780, -0.127070, 0.212600, 0.252930, -0.296940, -0.362320, -0.587240, -0.069940, -0.056150, 0.571000, 
-0.081170, 0.896460, 0.248860, 0.092180, 0.254820, -0.997240, 1.359140, 0.496440, -4.222190, -0.217040, 
1.377440, -0.398280, -0.089610, 1.760540, -1.267450, 1.551290, 1.392010, -2.726230, -1.957490, -1.579260, 
-0.277360, -1.277740, -0.050340, 2.126530, 0.677390, 1.112550, -0.005770, -0.402660, 0.105030, -1.229830, 
1.325060, -0.270240, -1.567420, 0.214470, 1.113060, 0.145900, -0.437480, 0.225300, -1.298480, -2.062600, 
0.268710, 0.379730, -0.147670, 0.385150, 0.668990, 0.218850, 0.707720, -0.534640, 0.116630, 1.112060, 
-1.341940, -1.905080, 1.059680, -0.348850, -0.677570, 1.923670, -1.254020, 1.359330, 1.249680, -1.833480, 
-0.894320, -0.484920, -0.628690, -0.837230, -0.467650, 1.417800, 0.429950, 0.286990, -0.473080, -0.134460, 
0.180760, -0.279240, 0.114710, -0.438180, -0.431630, 0.045150, 0.298720, -0.127930, 0.037490, -0.338190, 
-0.681580, -0.051570, -0.276580, 0.163530, -0.252640, 0.182380, 0.681030, -0.110350, 0.035900, -0.832110, 
-0.356340, 0.452810, 0.261880, -0.831890, 0.037480, -0.004470, 0.053070, 0.339950, -0.223560, -0.148930, 
-0.078720, -0.307280, 0.437860, -0.373060, -0.580560, 0.155800, -0.335260, 0.153090, -0.471150, -0.053490, 
-0.299020, -0.236270, -0.066840, 0.492790, -0.717320, -0.691820, 0.400800, -0.181730, -0.860030, 0.316460, 
-0.388670, -0.422720, 0.430820, 0.608240, -0.671180, -0.116590, 0.444760, 0.242050, -0.270530, -0.217770, 
-0.053850, -0.283300, -0.502480, 0.080340, 0.296490, -0.470220, -0.094360, 0.366710, 0.205540, -0.685570, 
-0.061260, -0.591790, -0.363330, -0.056360, 0.169950, -0.241950, -0.123350, 0.255780, -0.087740, -0.190860, 
-0.377500, -0.058080, 0.322520, 
-0.425100, 0.009950, -0.221750, -0.053560, -0.106660, -0.014430, 0.031020, 0.163170, -0.209810, -0.218820, 
0.024550, -0.078740, 0.279970, -0.138210, 0.067890, -0.167850, 0.007560, 0.038780, 0.070900, -0.044170, 
-0.014160, -0.234100, -0.086500, -0.062340, -0.082500, -0.155490, 0.128820, 0.029410, 0.066400, -0.208660, 
-0.175200, -0.028400, -0.202690, 0.034780, -0.059950, 0.025000, -0.118300, 0.155990, 0.164900, 0.001850, 
-0.086000, -0.097410, -0.341160, -0.152370, -0.268430, -0.125150, -0.007850, 0.014840, -0.096840, 0.103760, 
-0.142360, 0.078820, -0.093120, -0.083660, 0.034560, -0.091150, -0.048710, 0.011310, 0.023350, 0.394730, 
-0.028820, -0.132550, -0.038480, -0.330240, -0.116220, -0.286270, 0.126270, 0.003380, -0.123990, -0.120830, 
0.090040, -0.023040, 0.145570, -0.186620, -0.137270, -0.072410, -0.117390, -0.177000, 0.052330, 0.014310, 
0.372330, -0.094380, -0.176880, 0.120830, -0.278800, -0.052070, -0.072140, -0.017250, -0.042140, -0.143280, 
-0.059140, 0.134700, -0.032970, -0.086980, -0.127920, 0.042240, -0.065360, -0.057880, -0.091390, -0.070540, 
-0.124910, 0.232190, -0.186550, -0.090910, 0.195300, -0.484660, 0.002890, -0.017500, -0.386200, -0.142890, 
-0.039780, -0.013110, 0.021430, -0.066900, -0.250170, -0.210420, 0.243820, 0.411460, -0.104490, 0.040690, 
-0.222260, -0.069050, 0.156020, -0.165290, -0.176110, 0.418110, -0.398750, 0.133310, 0.408050, -0.808020, 
-0.273080, 0.425320, 0.026360, -0.285820, -0.030250, -0.355680, -0.521960, 0.429260, 0.644750, -0.107530, 
0.069310, 0.009120, 0.076320, -0.014040, -0.194750, -0.211460, -0.007070, -0.177040, -0.173230, 0.090780, 
-0.566510, -0.414310, 0.214790, -0.081880, -0.404120, -0.039890, -0.573170, -0.434070, 0.154590, 1.071790, 
-0.153920, 0.014420, -0.044520, 0.240620, 0.119490, -0.170270, -0.134840, 0.473430, -0.177450, -0.171320, 
0.125150, 0.102320, -0.305450, 0.424340, -0.011560, -0.439640, -0.110100, -0.659900, -0.474160, 0.094720, 
0.517450, -0.189770, -0.055320, 0.255140, 0.188310, -0.148890, -0.166710, -0.020640, 0.261670, -0.158110, 
-0.098240, 0.028880, 0.221730, -0.222650, 0.296430, -0.107810, -0.354240, -0.081570, -0.483700, -0.186960, 
0.087850, 0.164870, -0.150210, 0.046100, 0.211930, 0.027600, -0.220440, -0.040850, -0.161280, 0.131980, 
-0.138300, -0.074470, 0.016200, 0.131130, 0.033890, -0.060090, -0.129440, -0.065600, -0.126080, -0.184370, 
-0.180310, 0.010480, -0.081600, 0.015150, -0.051520, 0.036820, -0.000200, 0.011470, -0.034820, -0.054890, 
-0.030780, -0.016340, -0.021160, 0.115520, 0.257790, 0.134400, -0.135040, -0.165280, -0.052360, -0.278920, 
-0.186630, -0.109290, -0.111910, -0.049220, -0.116070, -0.091350, -0.031140, 0.036070, -0.048670, 0.106620, 
-0.134260, -0.097960, -0.144730, 0.037210, 0.167270, 0.093340, 0.107600, -0.165860, -0.084520, -0.105630, 
0.000280, -0.356030, -0.124830, -0.110290, 0.057390, -0.139940, -0.018060, -0.053560, -0.022680, 0.011710, 
-0.060280, 0.110650, -0.142000, 
0.092400, -0.060250, -0.035510, 0.002040, -0.209700, -0.166620, 0.082550, -0.170780, -0.110760, -0.031250, 
0.037880, 0.030970, -0.296500, -0.030810, -0.181530, 0.202990, 0.201360, 0.082100, -0.238870, 0.040790, 
-0.371320, 0.092070, -0.091600, -0.164700, -0.082360, -0.245130, -0.184670, 0.032040, 0.016610, -0.143700, 
-0.050750, -0.195720, 0.038890, -0.277170, -0.147800, 0.006570, 0.267830, 0.105350, 0.052760, 0.000420, 
0.092340, -0.299790, 0.398320, -0.096970, -0.120600, -0.215530, -0.090350, -0.177260, 0.035710, 0.204020, 
-0.190230, -0.065150, -0.077560, -0.266400, -0.188150, -0.280330, 0.041540, -0.089950, 0.140690, 0.074620, 
-0.096400, 0.081650, -0.234470, 0.257800, -0.054660, -0.059660, -0.192260, 0.137230, -0.178080, -0.008510, 
0.195990, -0.266550, -0.054920, 0.025250, -0.167220, -0.410860, -0.311940, 0.174060, -0.184840, 0.058290, 
0.203220, 0.010760, 0.122980, -0.421070, 0.451790, -0.077110, -0.492900, -0.366450, 0.491260, -0.252300, 
-0.199390, 0.288680, -0.105270, 0.341330, 0.181810, -0.268460, -0.657910, -0.221940, -0.152590, -0.110100, 
-0.175020, 0.282240, 0.218090, 0.175870, -0.522170, 0.440090, 0.135690, -0.774510, -0.196430, 0.342660, 
-0.772550, -0.183090, 0.606950, 0.139760, 0.622290, 0.185380, -0.890320, -1.289240, -0.141450, -0.115390, 
-0.125640, -0.082700, 0.711620, 0.467220, 0.455010, -0.714890, 0.240600, 0.340670, -1.063610, -0.479080, 
0.403610, -0.681810, -0.061120, 0.795710, -0.285060, 0.510870, 0.190970, -0.590260, -1.922580, -0.279470, 
-0.258370, 0.207370, 0.246110, 0.665510, 0.433090, 0.401580, -0.008590, -0.094060, 0.247800, -0.928700, 
-0.393690, 0.432980, -0.231250, 0.052520, 0.560520, -0.205390, 0.608590, 0.239620, -0.121120, -1.181950, 
-0.362290, -0.223290, -0.085430, 0.064700, 0.547690, 0.224680, 0.438140, -0.726120, -0.300010, 0.124760, 
-0.502440, -0.544860, 0.364360, 0.162700, 0.123610, 0.251470, -0.190820, 0.411300, 0.198820, -0.123200, 
-0.506550, -0.274100, -0.169050, -0.024980, -0.082870, 0.116650, 0.092690, 0.212060, -0.498740, -0.372610, 
-0.131220, 0.025510, -0.190990, 0.156600, 0.160460, 0.162110, -0.030830, -0.258680, 0.379760, -0.054790, 
-0.257100, -0.180060, -0.203270, -0.360190, 0.050360, 0.182730, -0.019390, -0.127460, 0.103200, -0.171760, 
-0.306320, -0.027030, -0.169160, -0.433540, 0.092620, 0.087520, -0.017860, -0.024380, -0.261130, 0.108490, 
0.012480, -0.103360, 0.048490, 0.003080, -0.160030, 0.085250, 0.053230, -0.060370, -0.084630, -0.099270, 
0.076670, -0.547060, -0.015040, -0.155100, -0.207590, -0.006900, 0.270000, 0.009440, -0.210010, -0.065710, 
0.063130, -0.209610, 0.050930, 0.309010, -0.015750, -0.253650, 0.100010, 0.038280, 0.028780, -0.263240, 
-0.024160, -0.030300, -0.458670, -0.050290, 0.102950, 0.081760, -0.154850, 0.144940, 0.089240, -0.269520, 
-0.097390, -0.169840, -0.279150, -0.104960, 0.265660, -0.182440, -0.124310, 0.138520, 0.318010, -0.142400, 
-0.062640, -0.214880, -0.000880, 
0.355990, -1.867540, 0.185060, 2.025080, -3.366410, -0.794930, 0.093070, 4.790620, 2.289810, 0.240110, 
-3.400780, 0.735260, -0.613270, -0.004590, 0.939350, -2.936870, -0.320670, 0.136850, 0.195160, -0.017160, 
-1.150660, -0.099710, 4.666270, 0.516740, 0.083360, -0.060970, 2.997580, -4.307950, -1.478410, 1.226280, 

-0.647460, -2.231670, -0.262450, -1.888620, 3.797480, -0.726890, -0.387710, -4.197990, -1.285530, -0.989520, 
3.653170, -0.538380, -0.994370, -0.748580, -2.567060, 3.414910, -0.592740, -0.435940, -1.811710, -0.881970, 
-1.274610, -0.461560, -4.222900, -0.625080, -0.522320, -1.043460, -1.249880, 3.942920, -0.402580, -0.270170, 

-0.493560, 0.959710, -0.405130, -1.379930, 1.154730, 0.213130, -1.300270, -2.040720, -3.103600, -0.153310, 
-1.766370, 0.567670, -0.422010, -0.021520, 0.902810, -1.715430, 0.059450, -0.233320, 0.501040, -0.083290, 
1.578270, 0.136960, -1.735040, -0.982330, -0.333390, 0.067490, -2.906620, -1.471440, 0.214450, -2.121750, 


  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[307] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.010000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, 0.009980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.009170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.002710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.008150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, -0.000540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.000910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, 0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, -0.006630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.008630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, -0.001360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, -0.001120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, 0.008980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, 0.009620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.004950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, -0.007520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.000630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, -0.008410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, -0.000310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, -0.006210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, 0.006230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.001410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, 0.008460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, -0.006310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, -0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, 0.007630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.007880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, -0.005690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, 0.002430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, -0.003580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.003620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, -0.005050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.009880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, -0.002490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.007470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.002350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.005420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, 0.006270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, 0.000070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, -0.000190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, 0.003680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, -0.004030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, 0.002660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, -0.007530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, 0.002580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, 0.001440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, -0.000850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, -0.003360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, 0.006580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, -0.006620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.007240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, -0.005380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.008950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, -0.009330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, 0.003310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.008360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, 0.004590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.008510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.003520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.006200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.000720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.001380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.000240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, -0.004780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, -0.007430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, -0.001560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, 0.003330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, 0.002140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, 0.006460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.007760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.007050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.006220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, -0.009100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.008090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.003720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.007460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, 0.009920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, 0.009990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, 0.006140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, -0.001740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, 0.002500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, 0.009460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.000700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, -0.005710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.001160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.004240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.007070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.000520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, 0.004670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, -0.005670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, 0.000640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.006060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.001060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.005140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.000680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, -0.007380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, 0.007320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, -0.006920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.009640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, -0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, -0.003400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, -0.006000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.007140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, -0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.005490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.002680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.008890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, -0.007700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.001100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.006740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.001500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.000400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, 0.009380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, -0.002170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, -0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.006350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.000500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, -0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, 0.003820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, -0.008850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.002240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, -0.008610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.008230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, 0.003250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, -0.000660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.005360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, -0.005040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.008180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.007080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, 0.006510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, 0.001620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, 0.004070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, 0.002440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, 0.001630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, 0.002380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, 0.004000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, 0.009580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, 0.009260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.005580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, 0.000110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, -0.007650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 165 (Old: 165) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 166 (Old: 166) */
      0.0, 0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 167 (Old: 167) */
      0.0, 0.007600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 168 (Old: 168) */
      0.0, -0.000960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 169 (Old: 169) */
      0.0, 0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 170 (Old: 170) */
      0.0, 0.000860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 171 (Old: 171) */
      0.0, -0.001760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 172 (Old: 172) */
      0.0, -0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 173 (Old: 173) */
      0.0, 0.008600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 174 (Old: 174) */
      0.0, -0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 175 (Old: 175) */
      0.0, 0.001940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 176 (Old: 176) */
      0.0, -0.001710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 177 (Old: 177) */
      0.0, 0.006180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 178 (Old: 178) */
      0.0, -0.007850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 179 (Old: 179) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 180 (Old: 180) */
      0.0, 0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 181 (Old: 181) */
      0.0, 0.007690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 182 (Old: 182) */
      0.0, 0.006820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 183 (Old: 183) */
      0.0, -0.009850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 184 (Old: 184) */
      0.0, -0.003630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 185 (Old: 185) */
      0.0, -0.006240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 186 (Old: 186) */
      0.0, -0.002840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 187 (Old: 187) */
      0.0, 0.003410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 188 (Old: 188) */
      0.0, -0.004750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 189 (Old: 189) */
      0.0, -0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 190 (Old: 190) */
      0.0, -0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 191 (Old: 191) */
      0.0, -0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 192 (Old: 192) */
      0.0, 0.002820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 193 (Old: 193) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 194 (Old: 194) */
      0.0, 0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 195 (Old: 195) */
      0.0, -0.006300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 196 (Old: 196) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 197 (Old: 197) */
      0.0, 0.004510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 198 (Old: 198) */
      0.0, 0.009110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 199 (Old: 199) */
      0.0, -0.002020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 200 (Old: 200) */
      0.0, -0.000280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 201 (Old: 201) */
      0.0, -0.002600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 202 (Old: 202) */
      0.0, 0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 203 (Old: 203) */
      0.0, 0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 204 (Old: 204) */
      0.0, 0.000950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 205 (Old: 205) */
      0.0, -0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 206 (Old: 206) */
      0.0, -0.004860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 207 (Old: 207) */
      0.0, 0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 208 (Old: 208) */
      0.0, -0.002360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 209 (Old: 209) */
      0.0, -0.002370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 210 (Old: 210) */
      0.0, -0.007090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 211 (Old: 211) */
      0.0, 0.006370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 212 (Old: 212) */
      0.0, 0.003840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 213 (Old: 213) */
      0.0, 0.009530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 214 (Old: 214) */
      0.0, 0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 215 (Old: 215) */
      0.0, -0.009030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 216 (Old: 216) */
      0.0, -0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 217 (Old: 217) */
      0.0, 0.005900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 218 (Old: 218) */
      0.0, -0.002080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 219 (Old: 219) */
      0.0, -0.008710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 220 (Old: 220) */
      0.0, -0.001190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 221 (Old: 221) */
      0.0, -0.000940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 222 (Old: 222) */
      0.0, 0.001220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 223 (Old: 223) */
      0.0, 0.001000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 224 (Old: 224) */
      0.0, 0.003860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 225 (Old: 225) */
      0.0, 0.005980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 226 (Old: 226) */
      0.0, 0.005680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 227 (Old: 227) */
      0.0, 0.009000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 228 (Old: 228) */
      0.0, 0.005810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 229 (Old: 229) */
      0.0, -0.001490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 230 (Old: 230) */
      0.0, -0.008300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 231 (Old: 231) */
      0.0, 0.001690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 232 (Old: 232) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 233 (Old: 233) */
      0.0, 0.002890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 234 (Old: 234) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 235 (Old: 235) */
      0.0, 0.002160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 236 (Old: 236) */
      0.0, 0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 237 (Old: 237) */
      0.0, 0.004290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 238 (Old: 238) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 239 (Old: 239) */
      0.0, 0.001110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 240 (Old: 240) */
      0.0, -0.008520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 241 (Old: 241) */
      0.0, -0.008430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 242 (Old: 242) */
      0.0, -0.002120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 243 (Old: 243) */
      0.0, -0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 244 (Old: 244) */
      0.0, 0.009710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 245 (Old: 245) */
      0.0, -0.003730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 246 (Old: 246) */
      0.0, -0.006890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 247 (Old: 247) */
      0.0, 0.007410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 248 (Old: 248) */
      0.0, 0.008810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 249 (Old: 249) */
      0.0, 0.009740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 250 (Old: 250) */
      0.0, 0.002180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 251 (Old: 251) */
      0.0, -0.007310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 252 (Old: 252) */
      0.0, 0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 253 (Old: 253) */
      0.0, -0.008490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 254 (Old: 254) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 255 (Old: 255) */
      0.0, -0.003240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 256 (Old: 256) */
      0.0, -0.003100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 257 (Old: 257) */
      0.0, 0.008470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 258 (Old: 258) */
      0.0, 0.008140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 259 (Old: 259) */
      0.0, 0.009930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 260 (Old: 260) */
      0.0, -0.000530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 261 (Old: 261) */
      0.0, -0.005800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 262 (Old: 262) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 263 (Old: 263) */
      0.0, -0.000920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 264 (Old: 264) */
      0.0, -0.005970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 265 (Old: 265) */
      0.0, -0.004540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 266 (Old: 266) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 267 (Old: 267) */
      0.0, 0.004900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 268 (Old: 268) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 269 (Old: 269) */
      0.0, 0.000340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 270 (Old: 270) */
      0.0, 0.000650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 271 (Old: 271) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 272 (Old: 272) */
      0.0, -0.000080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 273 (Old: 273) */
      0.0, -0.007170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 274 (Old: 274) */
      0.0, -1.275560, 273,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 275 (Old: 275) */
      0.0, -1.365470, 273,
       &Sources[273] , 
       &Weights[273] , 
      },
    { /* unit 276 (Old: 276) */
      0.0, -1.166540, 273,
       &Sources[546] , 
       &Weights[546] , 
      },
    { /* unit 277 (Old: 277) */
      0.0, -1.889200, 273,
       &Sources[819] , 
       &Weights[819] , 
      },
    { /* unit 278 (Old: 278) */
      0.0, 2.157540, 273,
       &Sources[1092] , 
       &Weights[1092] , 
      },
    { /* unit 279 (Old: 279) */
      0.0, -1.161580, 273,
       &Sources[1365] , 
       &Weights[1365] , 
      },
    { /* unit 280 (Old: 280) */
      0.0, -1.212350, 273,
       &Sources[1638] , 
       &Weights[1638] , 
      },
    { /* unit 281 (Old: 281) */
      0.0, -2.455240, 273,
       &Sources[1911] , 
       &Weights[1911] , 
      },
    { /* unit 282 (Old: 282) */
      0.0, -1.953050, 273,
       &Sources[2184] , 
       &Weights[2184] , 
      },
    { /* unit 283 (Old: 283) */
      0.0, -1.177180, 273,
       &Sources[2457] , 
       &Weights[2457] , 
      },
    { /* unit 284 (Old: 284) */
      0.0, -2.149390, 273,
       &Sources[2730] , 
       &Weights[2730] , 
      },
    { /* unit 285 (Old: 285) */
      0.0, 0.002080, 273,
       &Sources[3003] , 
       &Weights[3003] , 
      },
    { /* unit 286 (Old: 286) */
      0.0, -1.042240, 273,
       &Sources[3276] , 
       &Weights[3276] , 
      },
    { /* unit 287 (Old: 287) */
      0.0, -1.094720, 273,
       &Sources[3549] , 
       &Weights[3549] , 
      },
    { /* unit 288 (Old: 288) */
      0.0, -0.966100, 273,
       &Sources[3822] , 
       &Weights[3822] , 
      },
    { /* unit 289 (Old: 289) */
      0.0, -1.871330, 273,
       &Sources[4095] , 
       &Weights[4095] , 
      },
    { /* unit 290 (Old: 290) */
      0.0, -1.130380, 273,
       &Sources[4368] , 
       &Weights[4368] , 
      },
    { /* unit 291 (Old: 291) */
      0.0, -1.165450, 273,
       &Sources[4641] , 
       &Weights[4641] , 
      },
    { /* unit 292 (Old: 292) */
      0.0, -1.025220, 273,
       &Sources[4914] , 
       &Weights[4914] , 
      },
    { /* unit 293 (Old: 293) */
      0.0, -1.071530, 273,
       &Sources[5187] , 
       &Weights[5187] , 
      },
    { /* unit 294 (Old: 294) */
      0.0, -1.433360, 273,
       &Sources[5460] , 
       &Weights[5460] , 
      },
    { /* unit 295 (Old: 295) */
      0.0, -1.145170, 273,
       &Sources[5733] , 
       &Weights[5733] , 
      },
    { /* unit 296 (Old: 296) */
      0.0, -2.307520, 273,
       &Sources[6006] , 
       &Weights[6006] , 
      },
    { /* unit 297 (Old: 297) */
      0.0, -1.318340, 273,
       &Sources[6279] , 
       &Weights[6279] , 
      },
    { /* unit 298 (Old: 298) */
      0.0, -1.121080, 273,
       &Sources[6552] , 
       &Weights[6552] , 
      },
    { /* unit 299 (Old: 299) */
      0.0, -1.070390, 273,
       &Sources[6825] , 
       &Weights[6825] , 
      },
    { /* unit 300 (Old: 300) */
      0.0, -2.000100, 273,
       &Sources[7098] , 
       &Weights[7098] , 
      },
    { /* unit 301 (Old: 301) */
      0.0, -2.204140, 273,
       &Sources[7371] , 
       &Weights[7371] , 
      },
    { /* unit 302 (Old: 302) */
      0.0, -1.001170, 273,
       &Sources[7644] , 
       &Weights[7644] , 
      },
    { /* unit 303 (Old: 303) */
      0.0, -1.164040, 273,
       &Sources[7917] , 
       &Weights[7917] , 
      },
    { /* unit 304 (Old: 304) */
      0.0, 1.437950, 30,
       &Sources[8190] , 
       &Weights[8190] , 
      },
    { /* unit 305 (Old: 305) */
      0.0, -1.622420, 30,
       &Sources[8220] , 
       &Weights[8220] , 
      },
    { /* unit 306 (Old: 306) */
      0.0, -0.314730, 30,
       &Sources[8250] , 
       &Weights[8250] , 
      }

  };



int net_phd111(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[273] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, Units + 271, Units + 272, Units + 273}; /* members */

  static pUnit Hidden1[30] = {Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303}; /* members */

  static pUnit Output1[3] = {Units + 304, Units + 305, Units + 306}; /* members */

  static int Output[3] = {304, 305, 306};

  for(member = 0; member < 273; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 30; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
