/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  net_profil.c
  --------------------------------------------------------
  generated at Fri Jun 25 16:19:38 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[307];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, 
Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, 
Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, 

Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, 
Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, 
Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, 

Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, 
Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, 
Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, 


  };

  /* Weigths definition section */
  static float Weights[] =  {
0.002120, 0.030760, -0.051910, -0.066480, 0.150350, 0.133720, 0.021300, 0.100170, -0.193380, -0.003580, 
0.139240, 0.015530, -0.055290, 0.006930, 0.052930, -0.007550, -0.056380, 0.103510, 0.178690, 0.112620, 
-0.051490, 0.047370, 0.030150, -0.021430, -0.052390, 0.058800, 0.165590, 0.038980, 0.024990, -0.235330, 
0.027970, 0.132410, 0.003920, -0.066240, -0.009690, -0.066480, -0.014480, 0.005490, 0.070660, 0.110490, 
0.069720, -0.038320, 0.059410, 0.081690, -0.084120, -0.077100, 0.025410, 0.198490, 0.020280, -0.007580, 
-0.275870, 0.098300, 0.148940, -0.075900, -0.069370, -0.064380, -0.065240, 0.022880, 0.034260, 0.002370, 
0.087310, 0.055900, -0.060930, 0.084790, 0.109580, -0.043800, -0.188810, 0.015460, 0.167960, -0.035990, 
-0.033660, -0.254880, 0.131370, 0.116620, 0.057930, -0.004470, -0.103070, -0.112780, 0.004650, -0.034690, 
-0.150510, 0.076260, -0.018290, -0.073610, 0.037650, -0.017940, 0.001120, 0.001730, -0.066490, 0.070350, 
-0.087260, -0.108310, -0.143970, 0.006400, 0.133740, -0.001240, 0.085330, -0.049050, -0.104640, -0.012880, 
-0.133220, -0.184790, 0.068640, -0.039800, -0.091720, 0.145250, -0.049050, 0.098630, 0.109220, -0.140380, 
-0.016590, -0.081380, -0.188830, -0.222840, 0.065850, 0.042810, 0.047670, 0.063370, -0.038960, -0.133910, 
0.027400, -0.198150, -0.306940, 0.027550, -0.186920, -0.067390, 0.174940, -0.072090, -0.110820, 0.046220, 
-0.020010, -0.074480, -0.108550, -0.183160, -0.217640, 0.112790, 0.085180, -0.091710, 0.029210, -0.002520, 
-0.171720, -0.185350, -0.274820, -0.286200, -0.008550, -0.191520, -0.135750, 0.279640, -0.005690, -0.064330, 
0.125290, -0.039030, 0.032310, -0.064080, -0.135710, -0.046380, 0.227920, 0.158900, -0.037030, -0.495670, 
0.163810, 0.011840, -0.180640, -0.204780, -0.324660, -0.021660, -0.198120, -0.030420, 0.327520, 0.040720, 
-0.087010, 0.024300, -0.041080, -0.115440, 0.018110, -0.098560, 0.023420, 0.154840, 0.183590, -0.044330, 
-0.348760, 0.253820, 0.095650, -0.214630, -0.164240, -0.253680, -0.063380, -0.178690, -0.021020, 0.372560, 
0.024950, -0.186890, -0.142830, 0.066580, -0.017420, 0.036820, 0.017670, -0.018270, 0.290850, 0.212200, 
-0.111890, -0.259880, 0.224240, 0.057550, -0.208090, -0.183220, -0.201900, 0.014690, -0.074520, -0.023090, 
0.342850, -0.077390, -0.248560, -0.091580, 0.008980, -0.069080, 0.044370, 0.054420, 0.004080, 0.402280, 
0.155050, -0.049390, -0.166530, 0.091540, 0.012010, -0.175960, -0.211300, -0.116610, 0.018740, -0.045010, 
-0.003800, 0.328190, -0.084200, -0.158930, 0.008300, -0.013240, -0.052360, -0.025500, 0.020150, 0.042830, 
0.261430, 0.084010, -0.064530, -0.147500, 0.171130, 0.013540, -0.160580, -0.244010, -0.103130, 0.024560, 
-0.066980, 0.033860, 0.240860, -0.025720, -0.134570, 0.048260, 0.024840, -0.181480, -0.034350, 0.039730, 
0.017470, 0.204920, 0.148610, -0.073650, -0.222380, 0.137520, 0.021460, -0.218970, -0.182240, -0.083540, 
0.011440, 0.030420, 0.114130, 
0.745010, 0.170840, -0.517670, 0.198340, 0.185500, -0.359180, -0.328580, 0.136620, 0.180720, 0.423290, 
-0.019770, -0.176670, -0.115410, 0.333330, -0.316570, 0.215350, 0.087600, -0.128360, 0.222730, 0.086240, 
-0.732260, 0.624540, 0.198360, -0.731600, 0.280130, 0.167080, -0.726380, -0.241030, 0.227420, 0.340520, 
0.741000, 0.034090, -0.348670, -0.268100, -0.404340, -0.209170, 0.048130, -0.551200, -0.072770, 0.265040, 
0.159370, -0.478550, 0.556010, -0.268980, 0.161130, 0.371410, -0.327250, -1.358380, -0.190890, 0.079310, 
0.325800, 0.405710, -0.192960, -0.055320, -0.407090, -0.128910, 0.028560, -0.104250, -0.606340, -0.409100, 
-0.004340, 0.028620, -0.546290, 0.449530, -0.577030, 0.007290, 0.369070, -0.080530, -1.208450, -0.196230, 
-0.540290, 0.359050, 0.036910, -0.415070, -0.192360, -0.402620, -0.058650, 0.114910, 0.040150, -0.330150, 
-0.773060, -0.597250, -0.097070, -0.431780, 0.056710, -0.615500, -0.102180, 0.325020, -0.194590, -0.617260, 
-0.272330, -1.302660, 0.247330, -0.289590, -0.310270, 0.033820, -0.107370, -0.079090, -0.229720, -0.041850, 
-0.292000, -0.799810, -0.734230, -0.290210, -0.246850, -0.033680, -0.616430, 0.302630, 0.094540, -0.388700, 
0.754740, -0.308820, -1.579970, 0.143110, -0.895300, -0.502000, 0.480570, 0.233530, -0.025250, -0.887600, 
0.147790, -0.228380, -0.857420, -0.992560, -0.586940, -0.152240, -0.289200, -0.499690, 0.659810, -0.248790, 
-0.261520, 1.025530, -0.061990, -0.812670, 0.290120, -0.140140, -0.177710, 0.945860, 0.870000, -0.049010, 
-0.339490, 0.086260, -0.510680, -0.508150, -0.770310, -0.775020, 0.971700, -1.175230, -0.954940, 0.367280, 
-0.568850, -0.623120, 0.463380, -0.311390, -0.853050, 0.126090, -0.729790, -0.802930, 0.299290, 1.147700, 
-0.403880, -0.053220, 0.289910, -0.356720, -0.832620, -0.654120, -1.047220, 0.333520, -0.688040, -0.741240, 
-0.249910, -0.401280, -0.551990, -0.801180, -0.479330, -0.553510, -0.216850, 0.070150, -0.620440, -0.135800, 
0.570440, -0.393390, -0.272820, 0.069500, -0.369170, -0.110250, -0.460780, -0.534630, 0.165720, -0.307170, 
-0.240500, -0.516360, 0.019700, -0.469350, -0.982340, -0.301640, -0.263640, -0.330800, -0.113220, -0.364600, 
-0.219750, 0.398910, -0.666060, -0.154930, -0.250870, -0.076240, 0.129160, -0.513110, 0.042600, 0.140300, 
-0.435470, 0.176710, -0.290880, 0.504800, -0.396530, -0.739400, -0.204760, 0.297730, -0.441970, -0.210670, 
-0.055960, -0.742340, -0.139850, -0.111270, -0.268650, -0.052390, -0.100390, 0.045910, -0.177680, 0.136590, 
0.124150, -0.645830, -0.017970, -0.135490, 0.110980, 0.009860, -0.091910, -0.052190, 0.573240, -0.616980, 
0.369230, 0.203910, -0.546100, -0.350180, 0.066380, -0.107510, -0.062180, 0.024250, 0.196000, -0.278660, 
0.091870, 0.134280, -0.733710, -0.139380, -0.066480, 0.167730, 0.261010, -0.047250, 0.232930, 0.502900, 
-0.637240, 0.484810, 0.117240, -0.136840, -0.244620, -0.018570, -0.110380, 0.325510, -0.010850, 0.280730, 
-0.169750, -0.143100, 0.144170, 
-0.031370, -0.011010, -0.068480, -0.065910, 0.041640, -0.010240, 0.020550, -0.037100, -0.101460, -0.023390, 
0.065150, 0.005100, -0.062950, -0.037330, -0.068570, 0.021920, 0.001070, -0.027620, -0.004880, 0.044450, 
-0.043780, -0.011000, -0.004000, -0.067410, -0.068570, -0.002710, 0.036300, 0.051000, -0.005430, -0.131040, 
0.010430, 0.055520, -0.001520, -0.058260, -0.035610, -0.092940, 0.015230, 0.007700, 0.004030, 0.033080, 
0.050390, -0.098020, 0.000810, 0.025530, -0.058690, -0.054230, -0.004450, 0.075670, 0.017510, -0.011010, 
-0.138970, 0.002260, 0.065340, -0.026600, -0.075720, -0.064810, -0.077050, 0.017540, 0.025570, 0.001120, 
0.046020, 0.065320, -0.098520, 0.031850, 0.026620, -0.025080, -0.110160, 0.034150, 0.047610, 0.019980, 
-0.033970, -0.145350, 0.027610, 0.069200, 0.017680, -0.049300, -0.027410, -0.039560, -0.011480, 0.035160, 
-0.037070, 0.071580, 0.066620, -0.043600, 0.056400, -0.030890, -0.008520, -0.009380, 0.056040, -0.003930, 
-0.053170, -0.050110, -0.102240, -0.021400, 0.118050, -0.040630, -0.019540, -0.003430, -0.020480, -0.018080, 
-0.004410, -0.001990, 0.102630, 0.018560, -0.072610, 0.093560, -0.019670, -0.028180, 0.071520, 0.023380, 
-0.104420, -0.068390, -0.039050, -0.095920, 0.024510, 0.107810, -0.112660, -0.149040, 0.008450, -0.072920, 
-0.024450, -0.031040, -0.041910, 0.133000, 0.001630, -0.066880, 0.075640, -0.026840, -0.221030, -0.009220, 
0.043430, -0.185450, -0.096090, 0.029870, -0.133500, 0.014720, 0.094050, -0.241990, -0.366780, -0.004440, 
-0.096470, -0.210950, -0.147500, -0.032800, 0.067400, 0.002990, -0.237840, 0.164170, 0.067170, -0.138010, 
0.027710, 0.107710, -0.165720, -0.014890, 0.086320, -0.044050, 0.161430, 0.222550, -0.095320, -0.581050, 
0.105160, -0.019730, -0.099970, -0.094410, 0.001480, 0.082540, -0.014980, -0.061870, 0.156400, 0.065070, 
-0.113980, -0.011440, 0.064780, -0.104540, 0.041690, 0.006920, 0.037710, 0.108560, 0.207920, -0.028280, 
-0.372340, 0.158030, 0.058730, -0.058060, -0.050160, -0.061540, 0.060730, -0.015800, -0.032610, 0.140430, 
0.023290, -0.131570, -0.087570, 0.081000, -0.047910, 0.048000, 0.071250, 0.011860, 0.195670, 0.185870, 
-0.091270, -0.268090, 0.123640, 0.055730, -0.140220, -0.088950, -0.011920, 0.029610, 0.020880, -0.040980, 
0.088040, -0.025010, -0.192810, -0.108300, 0.048410, -0.083810, 0.043730, 0.076670, 0.011900, 0.234820, 
0.120800, -0.065740, -0.176500, 0.070430, 0.038010, -0.117960, -0.074120, -0.019860, 0.007480, 0.003110, 
-0.013280, 0.069190, -0.048050, -0.091260, -0.056240, -0.006650, -0.067660, 0.001690, 0.017640, 0.002980, 
0.138620, 0.063010, -0.052090, -0.122430, 0.085700, -0.008960, -0.109430, -0.125070, -0.057560, 0.003610, 
0.008350, -0.002230, 0.011640, -0.020160, -0.107460, 0.019080, -0.021980, -0.114850, 0.002890, -0.038390, 
-0.007200, 0.048040, 0.057200, -0.055080, -0.122500, 0.038420, -0.033740, -0.079910, -0.103260, -0.106400, 
-0.008610, -0.027440, 0.062820, 
0.401630, -0.306040, 0.340010, 1.100210, -0.648560, -0.491640, -0.491090, -0.502410, 0.530880, -0.367140, 
0.364770, 0.386880, -0.189930, 0.725100, 0.431830, 0.328290, -0.400530, -0.432360, 0.257440, -0.201220, 
0.083830, 0.577320, -0.160510, 0.102780, 0.440270, 0.124950, -0.531100, 0.029740, -0.128030, -0.219100, 
0.441330, 0.281650, 0.029070, -0.482890, -0.018750, -0.215280, -0.118880, 0.119620, -0.043130, 0.046630, 
0.242800, -0.074240, 0.522690, 0.261270, -0.614580, -0.545140, 0.611360, -0.911420, 0.014850, 0.542530, 
-0.671080, 1.318110, 0.231230, -0.562900, -0.267950, -0.268440, -0.348800, -0.238830, 0.116370, 0.454300, 
0.442250, 0.211010, -0.134580, 0.398090, -0.083960, 0.263670, 0.824470, -0.284700, -0.962380, -0.461950, 
-0.521880, 0.894380, -0.221140, -0.037600, -0.176720, -0.223160, 0.656000, 0.668010, 0.032960, -0.325100, 
-0.532220, 0.133620, -0.228390, -0.078570, 0.726470, -0.967310, 0.742240, 1.392490, -0.979780, -0.875830, 
-0.238510, -1.018050, 0.881780, -0.645850, -0.049080, 0.611650, -0.437420, 0.774660, 0.793980, 0.102490, 
-0.162190, -0.901940, -0.338850, -0.302330, 0.082480, 0.724440, -0.199100, -0.515030, -0.502670, 0.684870, 
-1.458560, -0.034830, 0.841710, -1.052290, 1.158960, 0.590740, -0.409800, -0.606960, -0.520050, -0.658900, 
-0.216950, -0.041540, 0.617110, 0.215760, 0.156330, 0.138360, 0.512450, 0.043590, -1.559180, -0.484840, 
0.683110, -1.083630, -0.689920, 0.763670, -0.460180, 1.357570, 0.641350, -0.918460, -0.378020, -0.156950, 
-0.158640, -1.323080, -0.737750, 0.602020, 0.330600, 0.086590, -0.105730, 0.512190, -0.925300, 0.510720, 
1.220010, -1.342770, -0.050050, -0.266490, -1.221220, 1.577860, -0.894390, -0.430710, 0.744360, -0.736590, 
1.093140, 1.209710, 0.553800, -0.451700, -1.342620, -0.222280, -0.635700, 0.200240, 0.597130, -0.480910, 
0.478520, 1.127470, -1.075570, -0.484200, 0.132960, -0.784800, 0.567180, -0.641900, 0.131730, 0.353230, 
-1.476060, 0.983650, 0.397370, 0.451430, -0.051780, -1.014470, -0.175860, 0.011830, 0.653200, 0.681230, 
0.391880, -1.244170, -1.082430, 0.930140, -0.444820, 0.127390, 1.086440, -0.502230, 1.441880, 0.917250, 
-0.489160, -1.384020, -0.456370, -0.437370, -0.858830, -0.574920, 0.687730, 0.416770, 0.739840, 0.119850, 
0.126210, -0.134710, -0.294280, -0.258980, -0.082770, -0.029380, -0.142330, 0.439990, 0.337670, 0.904380, 
0.665410, -0.115430, -0.380950, -0.082340, -0.071470, -0.338160, -0.528140, 0.229890, 0.115630, -0.174360, 
-0.021470, 0.047880, -0.551170, 0.353650, 0.965140, -0.638740, 0.033820, -0.195620, -0.579520, 0.891330, 
-1.007530, -0.045710, 0.394290, -0.264270, 0.843970, 0.893970, 0.149310, -0.484920, -0.673520, -0.258860, 
-0.608660, 0.441800, 0.121090, -0.150650, -0.083070, -0.163280, 0.060240, -0.441370, -0.033650, -0.029920, 
0.106720, -0.254600, 0.254860, 0.009650, -0.468850, 0.246500, 0.297120, -0.225310, -0.117210, -0.218150, 
-0.107330, 0.318020, 0.236220, 
-0.853720, 0.157620, 0.416550, -0.252350, -0.049140, 0.560080, -0.315660, -0.342940, 0.204390, -0.822820, 
-0.652490, 0.031130, -0.278450, -0.118700, -0.045280, 0.159410, -0.508430, -0.024600, -0.469500, -0.477140, 
-0.299550, -0.818940, 0.348410, -0.422340, -0.665400, 0.681960, 0.643600, 0.337340, -0.074020, -1.095780, 
0.337780, -0.618490, -0.465150, 0.342580, -1.104890, -0.647070, -0.194750, 0.259950, 0.472760, -0.203410, 
0.012930, -0.029500, -1.074490, 0.543510, -0.779600, -1.311810, 0.336640, 1.081490, -0.134190, 0.028060, 
-0.267990, -0.093020, 0.063490, -0.485910, 0.175320, -0.738050, -0.263630, -0.136740, 0.233330, 0.032160, 
-0.346660, 0.211140, 0.152290, -1.143870, -0.223160, 0.585960, 0.469070, -0.821200, 1.691900, -0.006920, 
-0.939140, 0.815050, -1.357140, -0.876240, 0.855410, 0.627390, -0.024700, 0.163040, 0.150040, -0.435630, 
-0.601330, -0.969320, -0.398170, 0.249800, -1.161950, 0.002310, 0.304550, -0.334810, 0.107450, 1.823520, 
0.656410, -0.155340, -0.483740, -0.749680, -0.605170, 0.855700, 0.531710, -0.842310, -0.601600, 0.163140, 
0.305460, 0.080660, -0.859810, -0.078370, -0.023660, -0.907310, 1.891390, -0.938990, -2.119930, 1.555660, 
1.367540, 0.128390, 1.556570, -1.652300, 1.018400, 0.150320, -0.857560, 0.497630, -1.736410, -1.536040, 
-0.090240, 0.546530, 1.591900, 0.218290, -0.029340, -0.334740, -0.873510, 0.855740, 0.156530, -0.422120, 
0.123900, 2.138440, -0.037610, -0.210890, 0.027450, -0.167270, -0.521460, 0.489870, 1.570440, -0.274950, 
0.329230, 0.558580, 0.903420, 0.473680, -0.348970, 0.008230, -0.390610, -1.003980, -0.720060, 2.401070, 
0.935410, -1.528760, 1.728830, -0.076860, -1.652770, 0.358510, -2.004190, -1.318130, 0.728020, 3.589210, 
-0.359700, -0.119190, 1.325260, 0.580040, -1.364160, -1.151330, -0.932340, -0.245850, -0.707400, 0.633800, 
0.229380, -0.589130, 0.507020, -0.288680, 0.373860, 0.234760, -1.431800, -0.212860, -0.113590, -0.443690, 
0.815860, -0.963400, -0.955950, -0.140880, 0.293410, 0.488390, -0.077120, 0.158290, -0.364370, -0.630210, 
0.714130, -0.829670, -1.745730, 0.809840, -0.068350, -0.387580, 0.978150, -1.226710, 1.195820, -0.218510, 
-0.710750, 1.270560, -1.039590, -1.418900, -0.389420, 0.149580, 1.336350, 0.236250, 0.022980, -1.042250, 
-0.394370, -0.201100, 0.559410, 0.565430, -0.626480, 0.408890, -0.209960, -0.850950, -0.059410, -0.708900, 
-0.718860, 0.149440, 0.742420, 0.471670, -0.108810, 0.244400, 0.654030, 0.002140, -0.342420, -0.749790, 
-0.575300, -0.039110, 0.093400, 0.430410, 0.860780, -0.394820, 0.107680, -0.010750, -0.854080, 0.107700, 
-1.044690, -0.754670, 0.093910, 0.063840, 0.981810, 0.151460, 0.300430, 0.730510, -0.566370, 0.048780, 
-0.270000, 0.157340, 0.317920, 0.668550, -0.235390, -0.687130, 0.147770, 0.347130, 0.437430, 0.342870, 
-0.615740, 0.791620, 0.074980, -0.280310, 0.044760, -0.390420, -0.514580, 0.135890, 0.415820, 0.106560, 
-0.083090, 0.755780, -0.020070, 
0.294220, 0.031900, -0.484020, 0.278800, -0.021330, -0.139750, -0.370350, -0.007850, 0.116160, 0.148560, 
-0.016570, -0.221830, 0.021470, 0.045480, -0.278740, 0.211650, 0.072650, -0.080410, 0.038330, -0.009720, 
-0.522590, 0.349360, 0.051510, -0.477120, -0.078930, -0.042180, -0.621250, -0.222300, 0.301030, -0.027440, 
0.091900, 0.012560, -0.361240, -0.193500, -0.488580, -0.174520, 0.032400, -0.196090, 0.164220, 0.152600, 
0.090510, -0.302900, 0.384000, -0.177840, -0.182560, 0.033500, -0.092910, -0.889140, -0.257110, 0.147120, 
-0.022130, 0.428620, -0.251880, -0.204770, -0.380330, -0.352890, -0.223180, -0.180200, -0.465560, -0.137790, 
-0.035880, -0.005680, -0.382400, 0.067120, -0.373410, -0.202900, 0.208440, -0.087380, -0.965110, -0.273210, 
-0.290190, 0.165120, 0.008020, -0.324260, -0.470870, -0.426270, -0.104660, -0.000230, -0.151550, -0.391700, 
-0.183590, -0.456710, -0.170760, -0.349610, 0.135710, -0.626190, 0.108380, 0.098920, -0.265060, -0.432860, 
-0.342150, -0.795750, 0.097330, -0.803130, -0.294060, -0.057910, -0.353270, 0.057320, -0.339970, -0.043700, 
-0.225360, -0.507100, -0.587020, -0.411610, -0.116300, 0.062830, -0.361640, -0.114510, -0.123440, -0.363580, 
0.109970, -0.331250, -0.959200, -0.071790, -0.403050, -0.354620, 0.069800, -0.068820, -0.058990, -0.703370, 
-0.122590, -0.154400, -0.503490, -0.730660, -0.356200, -0.049210, -0.472710, -0.448960, 0.972120, -0.218680, 
-0.567540, 1.098290, 0.060190, -0.951480, 0.310390, -0.906480, -0.236060, 0.922580, 0.723420, -0.048610, 
-0.158080, 0.365060, -0.209790, -0.612560, -0.653250, -0.673960, 0.957910, -0.681190, -0.816850, -0.082910, 
-0.391870, -0.544540, -0.041460, -0.260340, -0.527640, 0.076490, -0.295980, -0.759680, -0.157700, 0.951260, 
-0.359500, -0.153240, -0.076420, -0.551020, -0.326270, -0.423970, -0.768950, 0.227140, -0.655110, -0.563440, 
-0.176520, -0.098630, -0.626580, -0.583830, -0.458940, -0.370060, -0.180650, -0.394190, -0.570430, -0.132300, 
0.358410, -0.359270, -0.300520, 0.184210, -0.250330, -0.177290, -0.491410, -0.621010, 0.024660, -0.398600, 
-0.202220, -0.462640, 0.160770, -0.202380, -1.197090, -0.164790, -0.180470, -0.383420, 0.188970, -0.262880, 
-0.334940, 0.071130, -0.527770, -0.322660, -0.329100, -0.050890, -0.027400, -0.298810, -0.181610, 0.012300, 
-0.288110, 0.182910, -0.814850, -0.114420, -0.162620, -0.942550, -0.250190, 0.590020, -0.567770, 0.453580, 
-0.029200, -0.696660, -0.353490, -0.235780, 0.011910, -0.242190, -0.069080, 0.169300, -0.107750, 0.002690, 
0.131000, -0.732230, 0.011470, 0.018240, 0.030800, -0.173400, -0.109460, -0.074220, 0.401060, -0.368670, 
0.129340, 0.303650, -0.424560, -0.435010, -0.058500, 0.027080, 0.132530, -0.078200, -0.164930, -0.275680, 
-0.100480, 0.176520, -0.678800, 0.076320, 0.290300, 0.085400, -0.003140, -0.061800, 0.075630, 0.280600, 
-0.616150, 0.131100, -0.000790, -0.223940, -0.090320, -0.047350, -0.130490, 0.061050, 0.109220, 0.095730, 
-0.132710, -0.221200, 0.311850, 
-0.184140, -0.031830, -0.035480, -0.240680, -0.048040, -0.200700, 0.067350, 0.033030, 0.010380, 0.090380, 
-0.051430, -0.084200, -0.046720, -0.144640, -0.040880, 0.013570, 0.011790, -0.026860, -0.107380, 0.077430, 
-0.057100, -0.158000, -0.073220, -0.006620, -0.173740, -0.076880, -0.125620, 0.012620, 0.027000, -0.075320, 
0.012390, -0.090230, -0.020790, 0.053840, -0.036340, 0.018210, 0.056510, 0.099910, -0.004680, -0.099120, 
0.024050, -0.120440, -0.030930, -0.070760, -0.084670, -0.110800, -0.091500, 0.016200, 0.011710, 0.019160, 
-0.123470, -0.072020, -0.020370, 0.009680, -0.011050, -0.123140, 0.013810, 0.071680, 0.137160, 0.062200, 
-0.101930, 0.009080, -0.093210, -0.029700, 0.003750, -0.087180, -0.067280, 0.002270, 0.100740, -0.063070, 
-0.005170, -0.032410, 0.018380, 0.000110, 0.049460, -0.083690, -0.141650, -0.139000, -0.019480, 0.118430, 
0.126780, -0.004260, 0.012800, -0.039170, -0.087800, 0.016900, -0.109620, -0.125770, 0.087970, 0.157690, 
0.014910, 0.116960, -0.125150, 0.117170, -0.010470, -0.095600, -0.114630, -0.111750, -0.055390, -0.026190, 
-0.045510, 0.246850, 0.033130, -0.022770, -0.080830, -0.180890, 0.104120, -0.139300, -0.185310, 0.068250, 
0.069030, -0.018900, 0.220160, -0.030900, 0.011990, -0.047450, -0.181840, -0.210080, -0.125300, 0.059310, 
-0.146890, 0.025480, 0.257880, 0.142290, 0.086730, -0.146660, -0.120670, 0.141640, -0.105210, -0.327280, 
-0.010390, -0.020890, -0.020430, 0.135410, -0.073080, -0.245540, -0.204680, -0.201620, -0.221460, -0.066800, 
-0.020480, -0.153870, 0.049840, 0.144620, 0.066060, 0.151340, -0.359570, -0.132940, 0.216220, -0.067710, 
-0.370690, 0.159560, -0.026460, -0.034110, 0.153270, -0.210010, -0.048970, 0.003170, -0.075000, 0.094650, 
-0.194960, -0.255820, -0.124360, 0.177820, 0.316640, 0.029870, 0.181770, -0.147730, -0.151440, 0.094610, 
-0.067560, -0.291240, 0.195070, 0.046240, 0.060490, 0.045310, -0.094190, -0.040120, -0.039540, 0.020240, 
0.242800, -0.209600, -0.156840, 0.032870, 0.135670, 0.104650, -0.000410, 0.138250, -0.131400, -0.274940, 
0.008260, 0.055110, -0.111390, 0.028190, 0.149310, 0.054820, 0.118680, -0.074460, -0.096010, -0.039740, 
0.053830, 0.023580, -0.001810, -0.086660, 0.074600, 0.053440, 0.133870, -0.025090, -0.014080, -0.130940, 
-0.272680, -0.026720, -0.078630, -0.042830, 0.187970, 0.117050, -0.014130, -0.034230, -0.031080, -0.015090, 
-0.084300, 0.050050, -0.011710, 0.034100, -0.042630, 0.002860, 0.151090, 0.077380, -0.013160, 0.040020, 
-0.129530, -0.196330, -0.028140, -0.005570, -0.002380, 0.172690, 0.037260, -0.010590, 0.041300, -0.111030, 
0.043230, -0.073570, -0.019570, 0.057330, -0.032470, -0.120720, 0.036120, 0.133350, 0.079250, 0.028720, 
0.034290, -0.090230, -0.167230, 0.018640, 0.071040, -0.015470, 0.104950, 0.124150, -0.021270, -0.026890, 
0.044710, -0.063860, -0.039690, -0.006930, 0.133910, -0.212300, -0.076340, 0.076590, 0.129850, -0.034430, 
-0.020510, 0.016780, -0.043560, 
0.431420, -0.173610, 0.089880, 0.339410, 0.203180, -0.070630, -0.046830, -0.036080, -0.208090, 0.413560, 
0.020530, -0.026620, 0.076060, -0.102470, -0.323710, 0.272860, 0.287470, -0.163500, -0.204960, 0.164230, 
-0.049770, 0.499840, -0.110280, -0.610960, -0.535030, 0.276380, -0.307970, 0.297220, 0.442700, -0.739780, 
1.313810, 0.282640, -0.342000, -0.080670, -0.585550, -0.196370, -0.262300, 0.331540, 0.058060, 0.295100, 
0.419750, 0.144100, 0.377530, -0.350470, 0.266890, 0.675060, -0.408480, -0.465480, -0.312410, -0.335300, 
0.955470, -0.405850, 0.364340, 0.383930, -0.187240, 0.704670, 0.523380, -0.114100, -0.474570, -0.543680, 
0.257430, -0.341930, 0.208760, 0.538570, -0.788710, 0.533690, 1.366010, -0.915530, -0.722390, 0.200440, 
-0.509630, 0.385400, -0.570440, -0.101260, 0.569170, -0.149160, 0.626730, 0.443540, 0.471130, 0.015910, 
-0.313810, -0.015790, -0.131780, -0.140480, 0.828280, 0.219900, -0.442940, -0.735980, 0.881790, -1.362670, 
0.136670, 1.046260, -1.326360, 1.350590, 0.673060, -0.504460, -0.430510, -0.707250, -0.785730, -0.015850, 
0.108750, 0.673790, 0.631600, 0.384940, -0.216400, 0.589640, 0.271020, -0.999500, -0.279890, 0.435240, 
-1.363150, -0.770690, 1.000120, -0.319900, 1.116810, 0.764010, -0.945880, -0.011860, 0.046720, 0.010280, 
-0.658350, -0.201000, 0.669220, 0.795660, 0.069470, -0.010940, 0.623160, -1.659790, 0.944540, 1.692740, 
-1.904630, -0.926390, -0.818040, -1.310770, 1.354340, -1.337490, -0.641900, 0.803320, -0.034770, 1.118000, 
1.137820, 0.558160, -0.886890, -1.492450, -0.409250, -0.751870, 0.184600, 0.938810, -0.898090, 0.174490, 
1.328410, -0.609030, -1.530730, 0.502730, -0.280270, 0.511470, -0.355190, 0.489760, -0.036010, -1.355810, 
0.886610, 0.083610, 0.279590, -0.169030, -0.563770, -0.184360, 0.228630, 0.561980, 0.956070, 0.779910, 
-2.463140, -1.116560, 1.389290, -0.319730, 0.303170, 1.629990, -1.061950, 1.994280, 1.512310, -0.946520, 
-2.590020, -0.239620, -0.675800, -1.288060, -0.329050, 1.554730, 0.989800, 0.766240, 0.099490, 0.795330, 
-0.039460, -0.554930, 0.349840, -0.136040, 0.004930, -0.405900, 0.066180, 0.848550, 0.838570, 0.532650, 
-0.110140, -0.695330, 0.628380, 0.805730, -0.542080, -0.680360, 0.191380, 0.543000, -0.456290, 0.061660, 
0.540580, -0.781190, 0.527390, 1.682780, -1.123670, -0.061490, 0.316240, -0.970750, 1.174100, -1.186060, 
-0.210270, 0.466100, -0.601650, 1.160820, 1.387690, 0.274850, -0.082870, -1.137410, -0.329300, -0.434720, 
0.903110, 0.126580, -0.131350, -0.445360, -0.189170, 0.247200, -0.454370, 0.436140, 0.259010, -0.068770, 
0.556620, 0.457950, -0.240370, -0.980660, 0.011260, 0.449450, -0.327730, -0.395240, -0.483150, 0.083460, 
0.615870, 0.321840, 0.118080, 0.201170, -0.936630, -1.029640, 0.398170, -0.177340, -0.031990, 0.904930, 
-0.048050, 1.160820, 0.462970, -0.489580, -0.353650, -0.398180, -0.612440, -0.531690, -0.643630, 0.615660, 
0.294230, 0.034260, -0.048210, 
-0.295580, -0.130710, -0.228040, -0.235210, 0.043780, 0.676420, -0.109720, -0.211280, -0.307110, -0.217700, 
0.190670, 0.125740, 0.138890, 0.114370, -0.369130, 0.122370, -0.136330, -0.090440, -0.079330, 0.101310, 
0.240220, -0.383950, -0.014260, -0.027430, -0.123620, -0.041280, 0.601080, -0.034800, -0.194900, -0.103960, 
-0.179930, 0.127140, 0.065840, 0.175510, -0.113580, -0.518610, 0.034960, -0.031560, 0.003250, -0.131870, 
0.083800, 0.117680, -0.467070, -0.002640, -0.153570, -0.287900, 0.166990, 0.618530, 0.129570, -0.110580, 
-0.528380, 0.163570, 0.132700, 0.065320, 0.047460, -0.351350, -0.571370, 0.335850, 0.309610, 0.091790, 
-0.077630, 0.132640, 0.035080, -0.363780, 0.077970, -0.243370, -0.368850, 0.085540, 0.485700, -0.004320, 
-0.246540, -0.312150, 0.140080, -0.048720, 0.012460, 0.464010, -0.125350, -0.359370, 0.157070, 0.197880, 
0.341580, -0.079030, 0.074760, 0.164340, -0.228190, -0.498680, 0.413020, 0.472260, -0.299720, 0.577770, 
-0.161680, -0.396490, -0.196930, -0.431920, 0.124900, 0.069350, 0.490370, -0.012400, -0.204320, 0.405030, 
0.320530, -0.081300, -0.108980, -0.289310, 0.095610, 0.080500, -0.378620, 0.480050, 0.430720, -0.101050, 
0.292160, 0.003790, -0.425300, -0.724180, -0.555490, 0.114040, 0.244810, 0.392280, -0.152540, -0.556310, 
0.573280, 0.542490, -0.313770, -0.035160, -0.181200, 0.080240, 0.241180, -0.083360, -0.614220, 0.092620, 
0.260110, -0.012930, -0.293530, 0.292040, -0.768150, 0.223820, 0.491830, -0.992400, 0.327410, -0.097500, 
-0.607810, -0.887590, -0.410710, 0.376850, 0.026570, -0.024970, -0.207920, 0.698550, -0.135570, 0.130940, 
0.611440, -0.192690, -0.483020, -0.307420, 0.171670, 0.126820, 0.111940, 0.450310, -0.439290, -1.077970, 
0.517840, 0.156800, -0.211570, -0.217750, 0.065430, 0.085940, -0.324210, 0.041230, 1.032630, -0.164390, 
0.260360, 0.834640, -0.546240, -0.784970, -0.105210, -0.297630, 0.385620, -0.078490, 0.305260, -0.051210, 
-1.395660, 0.864230, 0.454460, 0.259480, -0.043570, -0.092940, -0.047940, -0.342260, 0.095670, 1.156780, 
0.219000, -0.872930, -0.192170, 0.239450, -0.641110, 0.065470, 0.209870, 0.064810, 0.688870, 0.569710, 
-0.443140, -1.371120, 0.428370, 0.463020, -0.397790, -0.197980, 0.348130, 0.247890, 0.031710, -0.020730, 
0.994770, 0.067560, -0.892580, 0.020710, 0.013160, -0.162980, -0.009930, 0.325120, 0.089640, 1.096880, 
0.586880, -0.371280, -1.095350, 0.115270, 0.084210, -0.395840, -0.359190, 0.175450, 0.149840, 0.000450, 
-0.005010, 0.833540, -0.212460, -0.188300, 0.459850, -0.464210, 0.079820, 0.008230, -0.034490, 0.324490, 
0.493480, 0.261170, -0.115940, -0.948060, 0.636800, 0.310510, -0.403600, -0.395330, -0.484050, -0.079010, 
-0.165020, 0.196930, 0.604170, -0.117880, -0.559450, 0.381710, 0.057210, -0.113640, -0.034760, 0.128470, 
0.082290, 0.221970, 0.369900, -0.165950, -1.126140, 0.578850, 0.111920, -0.202350, -0.252880, -0.401850, 
-0.122540, -0.017450, 0.317600, 
-0.025590, 0.068250, -0.020880, -0.087850, 0.112220, -0.016160, 0.006950, 0.085980, -0.187580, -0.015620, 
0.045620, -0.015820, 0.006600, 0.022240, 0.145680, -0.152750, -0.115680, 0.162310, 0.144290, 0.048110, 
-0.045500, -0.117730, 0.006150, 0.064330, 0.018560, -0.005210, 0.092040, 0.002400, -0.105320, -0.182320, 
-0.136050, 0.053980, 0.025590, -0.016560, 0.081750, 0.066390, -0.082750, -0.093990, -0.004020, 0.071100, 
-0.058720, 0.014540, -0.123120, 0.074730, -0.012430, -0.074420, -0.080170, 0.152350, -0.009960, -0.179890, 
-0.225550, -0.075150, 0.034890, -0.028830, 0.003010, -0.077450, -0.023970, -0.006550, -0.069950, -0.152200, 
0.041540, -0.041010, 0.012300, -0.074210, 0.101810, -0.021240, -0.231660, -0.122860, 0.226730, -0.027360, 
-0.158660, -0.229360, -0.021490, -0.045140, 0.055510, 0.015490, -0.143980, -0.165250, -0.051850, -0.136780, 
-0.276710, -0.062210, -0.130550, -0.071220, -0.209740, 0.072720, -0.023910, -0.139760, -0.235940, 0.098770, 
-0.012060, -0.191690, -0.099690, -0.134230, -0.093740, 0.029680, 0.102570, -0.139080, -0.131090, -0.137390, 
-0.161970, -0.364170, -0.100440, -0.059890, -0.122060, -0.089580, -0.028640, 0.096010, -0.061820, -0.329120, 
0.080160, 0.019140, -0.319790, -0.123420, -0.200600, -0.160330, 0.185990, 0.278180, -0.128010, -0.086150, 
-0.039040, -0.250350, -0.400690, -0.170920, -0.263400, -0.126720, -0.008950, -0.014960, 0.073000, -0.084450, 
-0.115230, 0.153110, 0.025770, -0.355590, -0.114840, -0.082200, -0.059960, 0.175880, 0.431960, -0.103150, 
-0.120920, -0.008420, -0.101960, -0.350390, -0.114790, -0.201020, 0.004570, -0.082130, -0.114390, -0.001200, 
-0.102500, -0.199690, 0.290730, -0.071920, -0.421300, -0.111440, -0.179040, -0.165150, 0.076100, 0.289170, 
-0.081810, -0.070740, -0.174000, -0.112320, -0.350790, -0.153340, -0.248880, -0.099180, -0.050360, -0.076070, 
-0.063280, -0.155650, -0.117260, 0.072180, -0.046700, -0.248430, -0.070390, -0.174320, -0.116930, -0.023860, 
0.187770, -0.006600, -0.031860, -0.291530, -0.106090, -0.285030, -0.190120, -0.203000, -0.114960, -0.064840, 
-0.070020, -0.020590, -0.193740, -0.071590, 0.124690, -0.011850, -0.170150, -0.095980, -0.145240, -0.067710, 
-0.013730, 0.166240, -0.047680, -0.105750, -0.151150, -0.073330, -0.323300, -0.082760, -0.067610, -0.144320, 
0.103030, -0.057030, -0.032650, -0.124400, -0.054040, 0.046820, -0.066350, -0.145780, -0.066270, -0.074650, 
-0.049930, 0.019570, 0.150950, -0.040360, -0.062150, -0.079010, -0.146380, -0.154510, -0.033490, -0.083970, 
-0.112350, 0.205720, -0.006530, -0.038620, -0.059720, -0.014540, -0.066150, -0.050660, -0.099450, 0.000000, 
-0.079340, -0.089960, 0.018940, 0.090790, -0.004160, -0.079740, -0.083150, -0.152860, -0.086150, 0.023600, 
-0.108660, -0.070880, 0.198870, -0.046240, -0.020730, -0.068220, 0.009370, -0.133110, 0.030480, -0.009780, 
-0.045940, -0.018530, 0.007540, 0.008600, -0.008040, 0.056250, 0.004880, -0.168530, -0.138550, -0.078830, 
0.018670, 0.064390, -0.090150, 
-0.403590, -0.077980, 0.126810, -0.229800, -0.280250, 0.309000, 0.053870, -0.404260, 0.362150, -0.290480, 
-0.457270, -0.019250, -0.221410, -0.155770, -0.327630, 0.158800, -0.041810, -0.384000, -0.495480, -0.251680, 
0.400720, -0.409240, 0.002720, -0.048520, -0.041430, -0.243040, 0.076730, -0.071730, -0.131220, 0.267640, 
-0.317460, -0.361530, -0.035940, 0.151650, -0.068050, -0.064600, 0.020580, 0.071170, -0.185690, -0.314540, 
-0.218630, 0.091730, -0.480810, -0.094230, -0.058710, -0.124780, -0.010080, 0.120620, -0.094970, 0.088310, 
0.431910, -0.459500, -0.189850, -0.081820, 0.133330, -0.224490, -0.112820, -0.030590, 0.185180, 0.162270, 
-0.278030, 0.064320, 0.003420, -0.228150, -0.292250, -0.117260, -0.131680, 0.143350, -0.103940, -0.072900, 
0.523260, 0.190630, -0.190210, 0.046750, -0.282550, 0.065880, -0.202420, 0.022220, -0.124950, -0.073400, 
0.677140, -0.074250, 0.203430, 0.046810, -0.200590, -0.010250, -0.428170, -0.015890, 0.203550, 0.113440, 
0.027100, 0.542510, 0.139480, -0.198710, -0.069470, -0.435300, -0.247620, -0.190460, 0.080740, 0.016400, 
0.552630, 0.577340, -0.030340, 0.178040, -0.012380, 0.071410, 0.250300, -0.870180, -0.540760, 0.751560, 
-0.284110, -0.129000, 1.034300, -0.365360, 0.539220, 0.218220, -0.898250, -1.001240, -0.405630, -0.159340, 
-0.190210, 0.157810, 1.315220, 0.288870, 0.518530, -0.147500, -0.347930, 0.278920, -0.738820, 0.303370, 
0.195670, -0.811360, -0.046610, 0.515530, -0.047310, -0.451230, -0.148840, -0.800630, -1.329570, -0.261520, 
0.075380, 0.156500, 0.441730, 0.625780, 0.172010, 0.484580, -0.627460, -0.156380, 0.600260, -0.710360, 
-0.490130, 0.654430, -0.168580, -0.149410, 1.148380, -0.805070, 0.633070, 0.078350, -0.697860, -0.251570, 
-0.553250, -0.530120, 0.002750, 0.095090, 1.267840, 0.148410, 0.369900, -0.300970, -0.465990, 0.197720, 
0.018490, 0.256080, -0.039340, -0.330360, 0.004920, 0.268500, -0.261460, -0.319550, 0.086520, -0.264210, 
0.244500, -0.261270, -0.128060, 0.393730, 0.438420, 0.469820, 0.174710, 0.444360, -0.201560, -0.229140, 
0.023840, 0.104450, -0.358670, 0.231240, 0.083970, -0.140760, 0.365710, -0.491350, 0.112610, -0.053860, 
-0.127320, 0.251380, -0.444820, -0.360710, 0.443050, 0.339860, 0.530240, 0.067790, 0.009410, -0.144830, 
-0.462550, 0.030510, 0.387510, -0.123070, -0.333350, 0.337820, -0.230180, -0.255790, -0.005450, -0.542160, 
-0.150350, 0.224820, 0.097050, -0.193140, -0.274150, 0.427250, 0.499730, 0.158220, 0.095750, -0.033580, 
-0.047810, -0.589160, 0.058130, 0.344410, 0.046120, -0.362630, 0.345960, -0.016770, -0.201630, -0.031830, 
-0.559520, -0.168540, 0.110780, -0.015480, -0.301870, -0.293080, 0.365660, 0.576900, 0.252790, -0.105040, 
-0.122240, -0.003640, -0.504290, -0.060390, 0.211440, -0.087410, -0.377110, 0.579550, -0.191380, -0.218470, 
0.007460, -0.279680, -0.203970, -0.006210, 0.174930, -0.271500, -0.234580, 0.183160, 0.440960, 0.142090, 
-0.096080, -0.106390, 0.065340, 
1.069180, 0.261170, -0.087260, 0.172010, 0.530300, -0.312490, 0.256950, 0.659890, -0.004890, 0.615760, 
0.275960, 0.384260, -0.127150, 0.232720, 0.580260, 0.000430, 0.089700, 0.421740, 0.596900, 0.242210, 
-0.693310, 0.734850, 0.253420, 0.084950, 0.419490, 0.365810, -0.085170, 0.206650, 0.573330, -0.071340, 
0.649510, 0.207480, 0.050910, 0.069680, -0.349370, 0.301290, 0.028010, 0.054160, 0.315190, 0.374780, 
0.237990, -0.550390, 1.122880, 0.321820, 0.159450, 0.218330, 0.355140, -0.614930, 0.279740, 0.540860, 
-0.402950, 0.915650, 0.360560, 0.028340, -0.075390, -0.338590, 0.112400, 0.006700, -0.117250, 0.023520, 
0.274270, 0.422570, -0.339420, 0.651580, 0.410850, 0.240320, 0.374620, 0.442100, -0.304440, 0.052340, 
0.056160, -0.016980, 0.390750, 0.271140, 0.149620, -0.167730, -0.187770, 0.146520, 0.070660, -0.374070, 
-0.126210, 0.229520, 0.389510, -0.109020, 1.198100, 0.251580, 0.510580, 0.036230, 0.592800, -0.278260, 
0.034940, -0.175310, -0.042170, -0.016940, 0.346670, 0.143120, -0.056980, 0.189690, -0.166460, -0.044580, 
-0.851470, -0.101890, 0.085400, 0.355570, -0.045240, 0.778660, 0.112420, 1.725600, 0.904310, -0.288370, 
0.561110, 0.047150, -1.133740, 0.626880, -0.695910, -0.210390, 0.487470, 0.281680, 0.140060, -0.359540, 
0.864320, -0.418940, -1.346220, -0.254150, -0.400110, 0.021520, 1.072880, -0.144480, 0.851540, 0.000530, 
0.166760, 0.657720, 0.135690, -0.518090, -0.558090, 0.095480, -0.006150, 0.813470, -0.457500, 0.014920, 
-0.541640, 0.164300, -0.614030, -0.653130, -0.194550, -0.605030, 0.304200, -0.036170, -0.213990, 1.504750, 
0.711620, -0.023400, 0.822940, 0.413770, -0.805830, -0.027800, -0.280820, -0.119900, 0.651340, -0.461230, 
0.210850, 0.208540, 0.300010, -0.290620, -1.284080, -0.205260, -0.140190, 0.644320, 0.235500, 0.093750, 
0.026450, -0.272970, 1.044590, 0.223250, 0.162580, -0.124860, -0.362280, 1.403050, 0.444110, 0.174880, 
0.012360, 0.481560, -0.342740, -0.455690, -0.496520, -0.661170, -0.104720, 0.269470, 0.453560, 0.578650, 
-0.126160, 0.036350, -0.057850, 0.417800, -0.622910, 0.410840, 0.108000, 0.230400, 0.107810, 0.263720, 
0.272750, 0.261920, 0.440890, -0.113790, 0.254670, 0.029820, -0.661040, 0.103450, 0.551990, 0.226550, 
1.493850, 0.151100, -0.430540, -0.422870, 0.680850, -0.220730, 0.266450, 0.660020, -0.334620, 0.631790, 
0.467210, 0.025420, -0.118700, -0.108790, -0.013120, -0.483960, 0.012480, 0.073310, 0.158150, 0.037090, 
0.090190, 0.767640, -0.203470, -0.563660, 0.026080, 0.486230, -0.201330, -0.022050, 0.849720, -0.020760, 
0.734450, 0.217390, -0.315560, -0.006740, 0.719160, -0.001930, -0.154970, 0.020380, -0.127000, 0.115210, 
0.182710, -0.126650, 0.545210, -0.136760, -0.000750, 0.148300, 0.405700, -0.043530, -0.048270, 0.487720, 
-0.248920, 0.672710, 0.603600, 0.009060, 0.071640, 0.249140, 0.164880, -0.302760, 0.056140, -0.249660, 
-0.411720, 0.037550, 0.153830, 
-0.562380, -0.104930, -0.272920, 0.349740, -0.122010, 0.141880, -0.001600, 0.172260, -0.348580, -0.302840, 
0.158360, -0.124210, 0.287140, -0.222860, -0.030690, -0.153230, 0.078780, 0.211170, -0.007510, -0.060700, 
-0.250370, -0.319710, -0.180980, 0.144750, -0.090400, -0.287780, -0.032270, -0.045070, 0.104230, -0.407550, 
-0.079970, 0.001110, -0.244040, -0.086310, -0.239270, -0.085710, -0.238210, 0.242940, 0.508670, 0.062430, 
-0.077600, -0.171450, -0.140690, -0.187910, -0.299680, -0.344290, 0.078250, 0.004560, -0.209140, 0.235750, 
-0.398490, 0.374600, -0.325110, -0.142680, -0.314840, -0.486010, -0.182210, -0.171570, 0.074270, 0.671590, 
-0.020640, -0.231850, -0.277720, -0.234760, -0.196180, -0.493480, 0.039720, -0.058300, -0.189130, -0.167520, 
0.149830, -0.232840, 0.036440, -0.420410, -0.304790, -0.316150, -0.388550, -0.103140, -0.015970, -0.106880, 
0.679460, -0.343120, -0.169720, -0.540420, -0.125810, -0.236890, -0.072390, -0.152830, -0.123230, -0.276790, 
-0.206040, 0.172280, -0.191730, -0.446730, -0.220950, -0.045750, -0.380710, -0.201260, -0.285860, -0.312220, 
-0.165870, 0.431400, -0.349780, -0.206920, -0.482470, -0.227450, -0.169220, -0.178680, -0.568820, -0.193980, 
-0.180250, -0.182410, 0.139510, -0.242190, -0.100790, -0.181430, 0.036310, 0.331860, -0.297190, -0.399260, 
-0.318740, -0.133350, 0.221090, -0.296680, -0.188800, -0.462490, -0.481550, -0.016270, 0.939620, -0.991580, 
-0.510350, 0.681040, 0.038670, -0.583460, 0.159680, -0.599890, -0.402740, 0.626050, 0.781170, -0.252730, 
-0.102830, 0.529090, 0.258280, -0.189290, -0.167260, -0.376320, 0.103960, -0.074060, -0.672000, 0.291680, 
-0.408930, -0.704600, -0.005690, -0.266310, -0.938820, 0.088520, -0.798950, -0.676070, 0.187300, 1.083520, 
-0.150460, -0.148680, 0.172540, 0.073500, -0.189910, -0.228720, -0.288080, -0.266180, -0.064350, -0.568290, 
0.225170, 0.684250, -0.597030, 0.606520, -0.354040, -1.106040, 0.152670, -1.116070, -0.780210, 0.028350, 
0.224460, -0.018800, -0.265880, 0.228840, -0.066600, -0.699090, -0.279370, -0.263650, -0.395150, -0.282490, 
-0.416900, 0.174250, 0.780100, -0.234110, -0.058670, -0.136410, -0.838820, 0.127120, -0.987810, -0.405880, 
-0.144060, -0.117750, 0.108140, -0.199120, 0.198120, 0.070000, -0.673460, -0.014170, -0.272240, -0.333580, 
0.238330, -0.170030, -0.111620, 0.097550, 0.135480, -0.495130, -0.252990, -0.036350, -0.212530, -0.233420, 
-0.083700, -0.245010, -0.412300, 0.167110, 0.115040, 0.075440, -0.188390, -0.307130, -0.113980, -0.074930, 
-0.313280, 0.087330, -0.090860, 0.052650, 0.402910, 0.292650, -0.587080, -0.169060, -0.126800, 0.121290, 
-0.085660, 0.063810, -0.264410, -0.281020, 0.013680, 0.307750, -0.087450, -0.052540, -0.428410, -0.115960, 
-0.057190, -0.354440, 0.074050, 0.142180, 0.218980, 0.409360, 0.264770, -0.675610, -0.027770, -0.006610, 
0.044550, -0.331590, -0.119500, -0.130780, -0.112750, 0.128540, 0.208690, -0.069950, 0.000280, -0.027790, 
0.001540, -0.052830, -0.445970, 
0.002330, 0.038680, -0.039550, -0.090670, 0.124590, -0.065880, 0.032000, 0.114200, -0.176860, 0.054820, 
0.080270, -0.006950, -0.020830, -0.023120, 0.132040, -0.102580, -0.076240, 0.156760, 0.151910, 0.107300, 
-0.082970, -0.006310, -0.004410, 0.033670, -0.036680, 0.008400, 0.050170, 0.013880, -0.018460, -0.198660, 
0.014940, 0.068830, 0.020740, -0.013590, 0.051470, 0.031000, -0.039590, -0.011320, 0.056590, 0.054970, 
0.030710, -0.055600, 0.021620, 0.043890, -0.057110, -0.038960, -0.046990, 0.107520, 0.006120, -0.094030, 
-0.254200, 0.051570, 0.082530, -0.012470, -0.045690, -0.061330, 0.003500, 0.023230, 0.039170, -0.070670, 
0.034920, 0.006730, -0.049620, 0.063340, 0.111260, -0.050850, -0.159260, -0.038350, 0.169880, -0.040760, 
-0.092140, -0.220540, 0.071620, 0.026240, 0.093250, -0.051500, -0.108990, -0.137460, -0.012920, -0.048820, 
-0.176540, 0.037130, -0.046980, -0.062450, -0.041300, 0.034830, -0.006430, -0.065460, -0.107480, 0.053470, 
-0.024550, -0.089790, -0.110490, 0.002390, 0.021840, 0.010710, 0.032170, -0.085360, -0.109760, -0.080680, 
-0.169530, -0.189740, 0.015740, -0.049650, -0.093320, 0.017460, -0.008000, 0.097190, 0.003410, -0.204170, 
0.049530, -0.039990, -0.164760, -0.118050, -0.077090, -0.068950, 0.111000, 0.145220, -0.061510, -0.040910, 
-0.050790, -0.216220, -0.284730, -0.020920, -0.215410, -0.104550, 0.080050, -0.003780, 0.020900, -0.083500, 
-0.072950, 0.062450, -0.043530, -0.237150, -0.127160, -0.055590, -0.049330, 0.043790, 0.213540, -0.020970, 
-0.113780, -0.117370, -0.188060, -0.282280, -0.032920, -0.133960, -0.110400, 0.070800, -0.033270, -0.004020, 
-0.069560, -0.069930, 0.161800, -0.060280, -0.237280, -0.084210, 0.014280, 0.004950, 0.042350, -0.074070, 
0.010890, -0.065790, -0.184710, -0.115000, -0.213820, -0.061270, -0.139990, -0.043880, 0.113550, -0.002240, 
-0.077020, -0.125620, 0.005330, 0.020640, 0.002970, -0.135130, -0.013700, 0.003100, 0.018940, -0.008260, 
-0.015440, 0.082090, -0.006840, -0.249930, -0.106270, -0.192340, -0.101280, -0.134520, -0.055730, 0.098860, 
-0.028150, -0.068850, -0.166060, 0.019020, 0.071930, 0.023460, -0.030110, -0.037320, 0.014060, 0.065540, 
-0.015660, -0.021390, 0.095930, -0.020340, -0.164910, -0.140980, -0.208610, -0.035180, -0.042810, -0.055050, 
0.168000, -0.080340, -0.137500, -0.079260, 0.064820, 0.025080, 0.009480, -0.031910, -0.011280, 0.171570, 
0.027640, 0.015010, -0.008960, 0.037470, -0.015340, -0.120870, -0.130090, -0.120820, -0.022170, -0.044700, 
-0.048870, 0.224090, -0.056580, -0.096910, -0.002800, 0.065980, -0.053170, -0.019300, 0.006600, 0.008960, 
0.109310, -0.002420, -0.037450, -0.019780, 0.081430, -0.031180, -0.100320, -0.140470, -0.078080, 0.028350, 
-0.058400, -0.013210, 0.183350, -0.019250, -0.042110, -0.018920, 0.075760, -0.113010, -0.008450, 0.023800, 
0.010110, 0.098530, 0.079160, -0.018770, -0.070970, 0.048340, 0.037320, -0.148070, -0.117650, -0.075300, 
0.012410, 0.041880, -0.004060, 
-0.090140, 0.080450, 0.116430, -0.045180, 0.151020, 0.054560, 0.036490, 0.016790, -0.236420, -0.109840, 
0.040700, -0.030380, 0.147900, 0.005120, 0.087610, -0.145540, -0.114020, 0.171490, 0.124890, -0.069430, 
0.067960, -0.299950, 0.057300, 0.220270, 0.134390, 0.017150, 0.234520, 0.049740, -0.248390, -0.233940, 
-0.380900, 0.010990, 0.033390, 0.066930, 0.080150, 0.021360, -0.040160, -0.179980, -0.059730, 0.082750, 
-0.159350, 0.208730, -0.313920, 0.063790, 0.085880, -0.093960, -0.082300, 0.307680, 0.007850, -0.319100, 
-0.186840, -0.362540, 0.006920, -0.047300, 0.178060, -0.087890, -0.070300, -0.045800, -0.176650, -0.286090, 
0.012620, -0.060330, 0.222950, -0.294530, 0.096040, 0.129030, -0.344430, -0.201060, 0.372250, 0.083600, 
-0.281900, -0.290460, -0.242360, -0.132360, -0.006240, 0.219150, -0.201400, -0.195780, -0.159960, -0.271270, 
-0.432350, -0.196340, -0.182570, 0.049660, -0.404930, 0.114120, 0.086000, -0.236540, -0.385450, 0.078230, 
0.045240, -0.411040, -0.144670, -0.336670, -0.189580, 0.059020, 0.312870, -0.205950, -0.153070, -0.185580, 
-0.122600, -0.651320, -0.230650, -0.117040, -0.051670, -0.225830, -0.115990, 0.160010, -0.086160, -0.524520, 
0.028710, 0.091940, -0.717130, -0.139060, -0.374720, -0.224300, 0.271550, 0.577070, -0.234230, -0.111410, 
0.023580, -0.140170, -0.598980, -0.346630, -0.316260, -0.132670, -0.046570, -0.103260, 0.130170, -0.072250, 
-0.147590, 0.292260, 0.092320, -0.646450, -0.081560, -0.105810, -0.023150, 0.330640, 0.707240, -0.168970, 
-0.100360, 0.092550, -0.002980, -0.469910, -0.252060, -0.222380, 0.109040, -0.237450, -0.209160, -0.013060, 
-0.110100, -0.289490, 0.312300, -0.062990, -0.645770, -0.139110, -0.374520, -0.288130, 0.078920, 0.703330, 
-0.161840, -0.091790, -0.159660, -0.105370, -0.543000, -0.266480, -0.391730, -0.223780, -0.245500, -0.153380, 
0.026330, -0.104690, -0.312900, 0.227100, -0.026320, -0.504100, -0.117630, -0.472400, -0.240030, -0.040830, 
0.466200, -0.127550, -0.018800, -0.328620, -0.102530, -0.576390, -0.283050, -0.329330, -0.265300, -0.281160, 
-0.122250, 0.048810, -0.185880, -0.208890, 0.296260, -0.034670, -0.385740, -0.119330, -0.310580, -0.224050, 
0.008410, 0.421600, -0.188270, -0.161970, -0.244980, 0.028630, -0.435170, -0.192730, -0.131280, -0.267300, 
-0.022870, 0.040660, 0.084110, -0.258420, -0.190270, 0.081810, -0.106650, -0.264550, -0.145320, -0.364370, 
-0.130340, 0.033520, 0.463520, -0.102710, -0.142380, -0.110920, -0.076070, -0.214240, -0.054670, -0.100800, 
-0.218320, 0.170850, 0.111120, 0.078160, -0.172690, -0.203100, -0.090550, -0.035420, -0.243020, 0.010620, 
-0.354140, -0.180250, 0.178390, 0.294950, -0.042510, -0.160990, -0.115520, -0.140880, -0.140890, 0.047670, 
-0.128860, -0.131090, 0.238110, 0.004000, -0.028190, -0.093940, -0.228600, -0.151960, 0.086900, -0.081940, 
-0.038990, -0.182630, -0.075850, 0.102780, 0.180390, 0.180610, -0.090610, -0.182470, -0.176190, -0.102050, 
0.043700, 0.079440, -0.143320, 
-0.268560, -0.040870, 0.010490, -0.248740, -0.150540, -0.085990, 0.052650, -0.061560, 0.097990, 0.015250, 
-0.134960, -0.093470, -0.081370, -0.165550, -0.137690, 0.083500, 0.015340, -0.133130, -0.213370, -0.029470, 
-0.061790, -0.241200, -0.076290, -0.021960, -0.178040, -0.099890, -0.099090, -0.002210, 0.027660, 0.017050, 
-0.089330, -0.169180, -0.045400, 0.064030, -0.079880, -0.022970, 0.063520, 0.113520, -0.081880, -0.163740, 
-0.038710, -0.162300, -0.135840, -0.094300, -0.097360, -0.140180, -0.066630, 0.007030, -0.042050, 0.075330, 
0.006840, -0.151050, -0.066870, -0.067320, 0.036460, -0.130540, -0.041110, 0.044310, 0.144120, 0.100420, 
-0.150180, -0.011050, -0.182500, -0.130450, -0.073110, -0.083870, -0.005490, 0.028670, 0.026870, -0.064390, 
0.096010, 0.020830, -0.069970, -0.009400, -0.077390, -0.051880, -0.146330, -0.119660, -0.063220, 0.105510, 
0.249620, -0.020470, 0.042720, -0.140190, -0.106210, -0.006020, -0.194570, -0.106950, 0.151880, 0.151490, 
0.004000, 0.199330, -0.096970, 0.096590, -0.017220, -0.184400, -0.152000, -0.138610, -0.049840, -0.003290, 
0.064480, 0.321900, 0.020450, -0.012220, -0.174310, -0.199250, 0.121660, -0.294120, -0.242550, 0.231970, 
-0.015080, -0.004020, 0.335990, -0.054560, 0.097030, -0.006120, -0.360730, -0.397590, -0.160150, 0.001990, 
-0.083480, 0.095040, 0.439190, 0.164260, 0.193090, -0.249560, -0.217900, 0.180500, -0.201920, -0.285940, 
0.094600, -0.182270, -0.017540, 0.266370, -0.089660, -0.231690, -0.212630, -0.342770, -0.476620, -0.102280, 
-0.023820, -0.100570, 0.154390, 0.287040, 0.091860, 0.234160, -0.541260, -0.175680, 0.285840, -0.105130, 
-0.357180, 0.230230, -0.139570, -0.030270, 0.330790, -0.295200, -0.026900, -0.018540, -0.175610, 0.082970, 
-0.249800, -0.279810, -0.032960, 0.210440, 0.425150, 0.053170, 0.231250, -0.323030, -0.245110, 0.132260, 
-0.070850, -0.205740, 0.158390, -0.033790, 0.047460, 0.113280, -0.191300, -0.099850, -0.014440, -0.018720, 
0.234120, -0.278210, -0.191320, 0.175360, 0.214840, 0.180820, 0.049680, 0.234000, -0.293830, -0.297340, 
0.015550, 0.044160, -0.099050, -0.001700, 0.120360, -0.009500, 0.145960, -0.158560, -0.112180, -0.087120, 
0.046910, 0.029250, -0.112390, -0.141970, 0.234590, 0.167050, 0.217180, -0.025520, -0.016030, -0.254370, 
-0.369640, -0.013670, -0.008980, -0.064390, 0.042180, 0.176800, -0.064360, -0.063790, -0.061040, -0.162600, 
-0.118380, 0.083920, -0.004090, -0.002780, -0.119790, 0.103300, 0.253320, 0.123820, 0.016390, 0.025760, 
-0.254040, -0.314790, -0.006950, 0.033790, 0.029450, 0.004520, 0.122510, -0.042290, -0.004040, -0.123580, 
-0.099490, -0.106450, 0.019410, 0.044300, -0.088320, -0.163880, 0.109980, 0.243200, 0.118240, 0.008320, 
-0.001520, -0.204550, -0.263710, 0.011710, 0.095050, -0.030660, -0.029770, 0.198320, -0.044950, -0.068580, 
0.030730, -0.109300, -0.087640, -0.062460, 0.144450, -0.247760, -0.152480, 0.115800, 0.231050, -0.032670, 
-0.027530, -0.023420, -0.143080, 
-0.113180, 0.006390, -0.021460, 0.025080, 0.030510, -0.165010, -0.063180, -0.081160, -0.153720, -0.176030, 
0.019840, -0.018710, 0.037730, 0.036310, 0.039600, -0.121060, -0.118500, -0.030730, 0.039120, -0.049820, 
-0.079050, -0.211990, -0.009330, -0.051160, 0.069720, -0.082380, -0.139530, -0.030720, -0.182400, -0.148860, 
-0.171490, -0.019120, -0.051360, -0.013550, 0.015740, -0.005390, -0.126500, -0.143510, -0.028840, 0.025100, 
-0.108080, 0.027970, -0.247990, -0.034230, -0.063620, -0.098190, -0.099610, -0.045200, -0.046850, -0.264040, 
-0.092440, -0.179890, -0.100790, -0.012020, -0.013410, -0.044000, -0.031270, -0.116560, -0.217600, -0.218640, 
-0.015210, -0.092450, 0.022130, -0.228320, -0.079060, -0.056830, -0.121070, -0.222140, 0.035410, -0.028920, 
-0.335430, -0.059040, -0.204260, -0.201950, -0.086390, -0.049870, -0.091370, -0.082550, -0.041010, -0.245650, 
-0.241130, -0.201800, -0.169030, -0.131800, -0.229650, -0.071590, -0.011650, -0.139600, -0.301270, -0.132120, 
-0.073550, -0.360280, -0.039440, -0.349910, -0.207990, -0.005110, 0.044170, -0.145560, -0.137290, -0.167410, 
-0.149370, -0.362050, -0.226590, -0.108400, -0.167370, -0.265190, -0.167300, 0.045160, -0.194990, -0.327980, 
0.022130, -0.031460, -0.269440, -0.076710, -0.352600, -0.220090, 0.117820, 0.297410, -0.143270, -0.143440, 
-0.171380, -0.181460, -0.335070, -0.324400, -0.236310, -0.173380, -0.117450, -0.084900, 0.083010, -0.306580, 
-0.169760, 0.266440, 0.017560, -0.239900, -0.042230, -0.143020, -0.092940, 0.226940, 0.554370, -0.154210, 
-0.071070, 0.012970, -0.031490, -0.189460, -0.193870, -0.172810, 0.146130, -0.349170, -0.337560, -0.068340, 
-0.316230, -0.370530, 0.072890, -0.052040, -0.470810, -0.051020, -0.459180, -0.332550, 0.036760, 0.637120, 
-0.171150, -0.057150, -0.065460, -0.064100, -0.228540, -0.199410, -0.270220, -0.208200, -0.254590, -0.278660, 
-0.072890, -0.141520, -0.338060, -0.042830, -0.105240, -0.380220, -0.111260, -0.404030, -0.333620, -0.082450, 
0.298010, -0.158930, -0.098580, -0.145770, -0.112870, -0.279590, -0.175280, -0.205970, -0.243990, -0.370380, 
-0.173660, 0.003030, -0.087440, -0.230950, 0.022630, -0.103130, -0.377020, -0.144580, -0.289760, -0.263400, 
-0.101360, 0.235720, -0.212720, -0.132010, -0.070610, -0.023850, -0.277640, -0.145570, -0.099840, -0.241610, 
-0.142170, 0.010940, 0.096210, -0.095700, -0.116250, -0.080800, -0.124050, -0.214080, -0.132320, -0.354130, 
-0.149630, -0.122160, 0.125560, -0.136910, -0.031950, -0.025550, -0.101500, -0.226240, -0.120340, -0.103800, 
-0.232830, 0.031260, 0.033160, -0.041770, -0.090450, -0.020220, -0.193430, -0.041990, -0.176950, -0.057840, 
-0.271420, -0.122400, -0.042140, 0.043530, -0.078850, -0.054120, -0.064530, -0.139780, -0.150520, -0.044680, 
-0.067700, -0.176900, 0.007770, -0.001860, -0.029130, -0.018530, -0.028690, -0.155460, 0.068920, -0.115260, 
-0.107600, -0.283260, -0.124980, 0.015650, 0.014890, 0.077260, -0.012690, -0.090300, -0.095600, -0.133860, 
0.018840, -0.019190, -0.226470, 
-0.040110, 0.029010, -0.031730, -0.068830, 0.042530, -0.072580, -0.003140, 0.041110, -0.127910, -0.028860, 
0.041720, -0.015200, -0.026560, 0.004900, 0.099110, -0.110700, -0.094900, 0.060830, 0.096820, 0.036740, 
-0.086140, -0.082470, -0.008740, 0.007910, -0.023900, -0.013700, -0.012220, -0.008450, -0.067030, -0.122750, 
-0.062880, 0.010410, -0.004060, -0.034040, 0.024400, 0.017160, -0.081120, -0.072190, -0.005640, 0.027340, 
-0.018130, -0.065420, -0.092550, 0.030570, -0.049390, -0.087010, -0.062310, 0.031090, -0.003140, -0.106150, 
-0.157880, -0.050520, -0.001270, -0.014000, -0.031340, -0.048710, -0.017480, -0.029490, -0.053870, -0.086360, 
0.027110, -0.034960, -0.047410, -0.061950, 0.065960, -0.055650, -0.140840, -0.087140, 0.094080, -0.045950, 
-0.121960, -0.142440, -0.033090, -0.034280, 0.026270, -0.032600, -0.110680, -0.111570, -0.027720, -0.105340, 
-0.177580, -0.025120, -0.077290, -0.108150, -0.123190, 0.018790, -0.037970, -0.110290, -0.139950, 0.018560, 
-0.021590, -0.125820, -0.092430, -0.108080, -0.048600, -0.011150, 0.002750, -0.096440, -0.094090, -0.115610, 
-0.134810, -0.208710, -0.044040, -0.037400, -0.118520, -0.098430, -0.021150, 0.029710, -0.080330, -0.191780, 
0.017140, -0.021210, -0.157800, -0.112070, -0.150960, -0.116610, 0.072520, 0.137150, -0.098490, -0.073810, 
-0.084600, -0.167140, -0.257810, -0.086730, -0.175190, -0.124670, -0.025690, -0.005990, 0.010230, -0.126690, 
-0.074580, 0.056760, 0.001970, -0.183560, -0.109000, -0.087900, -0.063020, 0.058420, 0.223230, -0.059740, 
-0.090920, -0.077740, -0.093130, -0.239510, -0.049730, -0.126830, -0.063140, -0.071050, -0.089920, -0.019260, 
-0.110460, -0.118420, 0.149150, -0.053470, -0.276440, -0.080540, -0.175380, -0.102700, 0.028220, 0.130030, 
-0.058740, -0.076090, -0.143890, -0.091970, -0.210020, -0.086200, -0.142110, -0.104850, -0.032770, -0.060010, 
-0.070230, -0.144350, -0.064270, 0.011500, -0.024910, -0.168160, -0.063350, -0.134830, -0.067110, -0.029430, 
0.076740, -0.008050, -0.053790, -0.222280, -0.100200, -0.174900, -0.111840, -0.117230, -0.107050, -0.049030, 
-0.055490, -0.043780, -0.165920, -0.028550, 0.045750, -0.021490, -0.099990, -0.067120, -0.103870, -0.034090, 
-0.026360, 0.061910, -0.026130, -0.084690, -0.124900, -0.083780, -0.194510, -0.043710, -0.050620, -0.105850, 
0.047470, -0.066420, -0.055790, -0.082870, 0.001200, 0.003830, -0.031940, -0.095310, -0.068260, -0.020800, 
-0.030390, -0.007580, 0.044080, -0.037040, -0.044340, -0.079460, -0.110630, -0.134670, -0.041540, -0.055630, 
-0.106130, 0.112130, -0.033540, -0.087990, -0.045880, 0.012550, -0.091760, -0.035350, -0.065630, -0.023670, 
-0.061740, -0.045260, -0.029180, 0.019200, -0.009940, -0.047920, -0.071440, -0.110830, -0.079700, 0.000490, 
-0.087020, -0.078430, 0.095500, -0.017460, -0.056190, -0.062460, 0.039860, -0.105850, 0.004190, -0.037860, 
-0.055950, -0.039350, 0.010340, 0.000440, -0.032280, 0.017930, 0.002380, -0.110510, -0.084060, -0.083190, 
0.009970, 0.012660, -0.080530, 
-0.305830, 0.145580, 0.471110, 0.062650, 0.117820, 0.336920, 0.160380, -0.152450, -0.096930, -0.219740, 
0.020250, 0.008170, 0.444470, -0.017330, -0.156680, -0.098640, -0.026420, 0.110070, 0.021730, -0.221500, 
0.330130, -0.583780, 0.117860, 0.564570, 0.313450, 0.106160, 0.155210, 0.113150, -0.496920, -0.185760, 
-0.724230, -0.003290, 0.094270, 0.282360, 0.087770, -0.097340, 0.212910, -0.227900, -0.122810, 0.065270, 
-0.265940, 0.597210, -0.555370, 0.080700, 0.432970, -0.119870, -0.057150, 0.087250, 0.202900, -0.398130, 
-0.110940, -0.774430, 0.039140, 0.008040, 0.552610, -0.140270, -0.109650, -0.122270, -0.269340, -0.526180, 
-0.097520, -0.052960, 0.633440, -0.651820, 0.155410, 0.586100, -0.494260, -0.225750, 0.177810, 0.329720, 
-0.323580, -0.315160, -0.734860, -0.216610, -0.054580, 0.722990, -0.168930, -0.186160, -0.360320, -0.471690, 
-0.748460, -0.373050, -0.209190, 0.365110, -0.683880, 0.091550, 0.403830, -0.315830, -0.581670, -0.171030, 
0.125410, -0.802490, -0.190730, -0.624600, -0.271660, 0.191510, 0.791190, -0.244530, -0.092490, -0.193610, 
-0.057120, -1.085960, -0.441250, -0.182930, 0.176590, -0.528840, -0.305020, 0.371130, -0.096160, -0.753450, 
-0.101740, 0.198160, -1.316590, -0.071530, -0.581690, -0.301310, 0.366300, 0.989450, -0.303010, -0.037340, 
0.101990, 0.079380, -0.867440, -0.627040, -0.271690, -0.066160, -0.110460, -0.347420, 0.367970, 0.027850, 
-0.252270, 0.399830, 0.104920, -0.882400, 0.143300, -0.320850, 0.125390, 0.568060, 1.150740, -0.228810, 
0.089820, 0.129950, 0.228290, -0.756550, -0.416200, -0.278490, 0.088140, -0.469590, -0.314380, 0.275440, 
0.058640, -0.437640, 0.139830, 0.041110, -0.906040, -0.085240, -0.821940, -0.265280, 0.118470, 1.156930, 
-0.142420, -0.038920, -0.171820, -0.120360, -0.929670, -0.383160, -0.526700, -0.408540, -0.561010, -0.185120, 
0.400480, -0.057130, -0.532730, 0.410370, 0.135680, -0.767050, -0.152080, -0.894250, -0.358480, -0.047920, 
0.819960, -0.234410, 0.088000, -0.295790, -0.217320, -0.961680, -0.406450, -0.527230, -0.470990, -0.621520, 
-0.123920, 0.218960, -0.210270, -0.346890, 0.598970, 0.042830, -0.550460, -0.120740, -0.629070, -0.312690, 
-0.027370, 0.848140, -0.359870, -0.122610, -0.468010, 0.118620, -0.389240, -0.416970, -0.241130, -0.414630, 
-0.382700, 0.149300, 0.315620, -0.427270, -0.203930, 0.087130, -0.121680, -0.372690, -0.189570, -0.781630, 
-0.152970, 0.060100, 0.992750, -0.180450, -0.210730, -0.237300, 0.038980, -0.067920, -0.044560, -0.113660, 
-0.430860, 0.000420, 0.250110, 0.212520, -0.338710, -0.334430, -0.021270, 0.039080, -0.408300, 0.185870, 
-0.774270, -0.336370, 0.345400, 0.800080, -0.016610, -0.351380, -0.212820, -0.145570, -0.101070, 0.100590, 
0.003020, -0.250320, 0.313260, 0.137260, 0.030930, -0.048110, -0.560410, 0.071140, 0.177330, -0.280540, 
0.001940, -0.559570, -0.107790, 0.256430, 0.526780, 0.328040, -0.300310, -0.145820, -0.191330, -0.240040, 
0.130140, 0.123750, -0.283140, 
-0.083460, -0.007400, -0.114060, 0.086720, 0.008790, -0.208510, -0.117080, -0.040330, -0.151690, -0.110690, 
0.047610, -0.076420, 0.023600, 0.029660, 0.030320, -0.062270, -0.095960, -0.030010, 0.060230, -0.030970, 
-0.136470, -0.139210, -0.014800, -0.105710, 0.093340, -0.080080, -0.225190, -0.058920, -0.143460, -0.149300, 
-0.088630, -0.029630, -0.090690, -0.025150, -0.048740, -0.042630, -0.147330, -0.178640, 0.056170, 0.057730, 
-0.073160, -0.017950, -0.187130, -0.053370, -0.085580, -0.078810, -0.117880, -0.187160, -0.054740, -0.243450, 
-0.051200, -0.100590, -0.148090, -0.005230, -0.085530, -0.091930, -0.024990, -0.092500, -0.249560, -0.188600, 
-0.019590, -0.101310, -0.004170, -0.170550, -0.110390, -0.109910, -0.079060, -0.241600, -0.074460, -0.061670, 
-0.371380, -0.022870, -0.149550, -0.258330, -0.133630, -0.111880, -0.074890, -0.067550, -0.041230, -0.240830, 
-0.247000, -0.276550, -0.183070, -0.171970, -0.185180, -0.135640, 0.004870, -0.101460, -0.341720, -0.131620, 
-0.090050, -0.463600, 0.011470, -0.436960, -0.252440, 0.030900, -0.027790, -0.134220, -0.136660, -0.181160, 
-0.200240, -0.334900, -0.286840, -0.165970, -0.174790, -0.256840, -0.222210, 0.054140, -0.209410, -0.365800, 
0.069660, -0.074710, -0.340020, -0.041660, -0.420730, -0.271000, 0.149980, 0.296540, -0.130650, -0.214510, 
-0.182080, -0.128940, -0.317240, -0.403280, -0.274060, -0.172000, -0.180040, -0.123170, 0.226020, -0.326020, 
-0.242010, 0.439200, 0.024670, -0.317800, -0.011460, -0.268020, -0.142450, 0.331720, 0.701340, -0.177870, 
-0.052360, 0.058030, -0.073040, -0.235440, -0.269720, -0.207970, 0.256750, -0.432760, -0.433440, -0.011600, 
-0.390460, -0.445640, 0.101460, -0.075080, -0.554740, 0.026740, -0.585560, -0.399940, 0.050690, 0.776700, 
-0.203260, -0.031850, -0.012170, -0.088960, -0.253080, -0.247750, -0.349760, -0.179170, -0.304540, -0.371580, 
-0.114130, -0.151280, -0.373220, -0.025120, -0.171240, -0.429580, -0.097050, -0.426700, -0.409120, -0.091970, 
0.377360, -0.173680, -0.122800, -0.128950, -0.142710, -0.253530, -0.203830, -0.234930, -0.267970, -0.409340, 
-0.206280, -0.030920, -0.039700, -0.253190, -0.062100, -0.124370, -0.407960, -0.142550, -0.297210, -0.287560, 
-0.099930, 0.249550, -0.245620, -0.155380, -0.085180, -0.038110, -0.248540, -0.180870, -0.095900, -0.261240, 
-0.181800, 0.007110, 0.078150, -0.064420, -0.112570, -0.189440, -0.159700, -0.150890, -0.182700, -0.355020, 
-0.127070, -0.188100, 0.060310, -0.106680, -0.038080, -0.015580, -0.080260, -0.239880, -0.145060, -0.048640, 
-0.250910, -0.034760, 0.056130, -0.041610, -0.090410, 0.039860, -0.188800, -0.055520, -0.073140, -0.094670, 
-0.172500, -0.111010, -0.104740, 0.003890, -0.085750, -0.021780, -0.084150, -0.142840, -0.183700, -0.062520, 
-0.072890, -0.200510, -0.018610, 0.011710, -0.012860, 0.001220, 0.022400, -0.194050, 0.100480, -0.086580, 
-0.108000, -0.312670, -0.117650, 0.030350, 0.021610, 0.047230, 0.025650, -0.044130, -0.088850, -0.126750, 
-0.004160, -0.048490, -0.245470, 
0.493330, 0.045920, -0.391040, 0.443700, 0.024560, -0.131010, -0.387920, -0.121560, 0.232700, 0.273590, 
0.025430, -0.128720, -0.027060, 0.208310, -0.337730, 0.331240, 0.083450, -0.320930, 0.062160, -0.041140, 
-0.598470, 0.582650, 0.129510, -0.383790, -0.061960, 0.129590, -0.835450, -0.223150, 0.190050, 0.234670, 
0.349780, 0.127950, -0.322470, -0.097970, -0.418180, -0.212320, 0.138860, -0.572700, -0.102500, 0.241670, 
0.035420, -0.324320, 0.391870, -0.230400, 0.231720, 0.257140, -0.238630, -0.873740, -0.161080, -0.127800, 
0.197970, 0.131620, -0.200030, -0.041080, -0.397870, -0.214670, -0.089450, -0.017030, -0.609010, -0.590960, 
-0.061060, 0.051470, -0.463310, 0.280990, -0.441400, 0.070830, 0.150430, -0.178450, -0.926770, -0.179430, 
-0.511950, 0.287810, -0.411260, -0.340910, -0.365270, -0.237330, -0.028600, 0.235440, -0.118990, -0.353140, 
-0.790500, -0.540350, -0.066880, -0.396680, 0.129940, -0.723380, 0.143650, 0.008210, -0.278800, -0.093490, 
-0.211680, -1.213880, 0.061680, -0.623460, -0.261640, 0.094560, -0.079270, -0.115620, -0.427600, -0.081650, 
-0.285240, -0.693590, -0.672570, -0.494300, -0.162720, -0.051560, -0.489360, -0.192530, -0.289400, -0.208620, 
0.130970, -0.341330, -1.023310, -0.115650, 0.179650, -0.286500, 0.090500, 0.044870, -0.147560, -0.831110, 
-0.100000, -0.147320, -0.550060, -0.869020, -0.403960, -0.275800, -0.489630, -0.595610, 0.835410, -0.275920, 
-0.387460, 1.052820, 0.039070, -1.044550, 0.036020, -0.436820, -0.239420, 1.051250, 0.890010, -0.155550, 
-0.274750, 0.770880, 0.186060, -0.824430, -0.709700, -0.802990, 0.864460, -0.721710, -0.964610, 0.042490, 
-0.091410, -0.524440, -0.228810, -0.318750, -0.623550, -0.113830, -0.279750, -0.790000, -0.182410, 1.075170, 
-0.314550, -0.284090, 0.220920, -0.486220, -0.662420, -0.494450, -0.821250, 0.129610, -0.477300, -0.702150, 
0.168880, 0.223320, -0.612960, -0.496200, -0.533870, -0.721310, -0.295340, -0.288080, -0.631930, -0.207450, 
0.647680, -0.443080, -0.464460, 0.356740, -0.403810, -0.656250, -0.584270, -0.806390, 0.033590, -0.297790, 
-0.252700, -0.015690, 0.551040, -0.617360, -1.118290, -0.217490, -0.658300, -0.393940, -0.261210, -0.374520, 
-0.245500, 0.158310, -0.187560, -0.223480, -0.353360, -0.092850, -0.237620, -0.409450, -0.220780, 0.097920, 
-0.349470, 0.245310, -0.451610, 0.174060, -0.273950, -1.003700, -0.220250, 0.244930, -0.437710, 0.059470, 
-0.053090, -0.821760, -0.156960, -0.186280, 0.006150, -0.224560, -0.052020, -0.187390, -0.138950, 0.227380, 
0.092920, -0.465990, -0.039520, -0.064680, -0.032220, -0.322830, -0.081520, -0.067840, 0.197160, -0.216930, 
0.111790, 0.266250, -0.304870, -0.235270, 0.066870, -0.110290, 0.111310, -0.042010, -0.275250, -0.290860, 
-0.023380, 0.194930, -0.536590, -0.003010, 0.000160, 0.345440, -0.126890, -0.296180, 0.139110, 0.099670, 
-0.340500, -0.128150, -0.030730, -0.003010, 0.010840, 0.310600, -0.099550, 0.295210, 0.189300, -0.107640, 
-0.158510, -0.375310, 0.274270, 
-0.104090, -0.006240, -0.035470, 0.010760, 0.014200, -0.107630, -0.054580, -0.062570, -0.181580, -0.170360, 
0.028180, -0.047370, 0.032380, 0.040440, 0.055470, -0.124390, -0.108570, -0.023050, 0.041870, -0.049490, 
-0.077700, -0.207370, -0.004410, -0.034300, 0.062880, -0.050800, -0.091760, -0.034510, -0.174060, -0.115550, 
-0.166370, -0.024500, -0.047140, -0.021440, 0.039670, -0.011980, -0.155920, -0.144060, -0.066770, 0.035540, 
-0.099050, 0.024710, -0.258620, -0.015990, -0.044650, -0.103120, -0.108810, -0.028540, -0.035610, -0.258960, 
-0.086990, -0.210380, -0.090780, -0.013090, -0.019660, -0.025010, -0.008310, -0.093930, -0.194350, -0.203140, 
-0.015090, -0.103180, 0.022200, -0.227760, -0.038680, -0.062020, -0.123880, -0.207880, 0.055100, -0.027900, 
-0.320400, -0.071460, -0.184120, -0.179480, -0.061660, -0.037990, -0.102060, -0.083810, -0.048350, -0.240130, 
-0.279710, -0.187240, -0.174970, -0.124090, -0.230230, -0.036050, -0.017140, -0.152610, -0.296430, -0.099780, 
-0.052940, -0.295450, -0.070540, -0.316590, -0.210020, -0.009450, 0.026140, -0.131750, -0.128640, -0.171900, 
-0.166620, -0.338290, -0.189490, -0.105960, -0.146570, -0.238110, -0.131220, 0.004510, -0.159990, -0.308780, 
0.011230, -0.026750, -0.275220, -0.101940, -0.286400, -0.203840, 0.098200, 0.294880, -0.153680, -0.132160, 
-0.154860, -0.177810, -0.301710, -0.299720, -0.226280, -0.176530, -0.133990, -0.061680, 0.059780, -0.252390, 
-0.155780, 0.208550, 0.030320, -0.206980, -0.064010, -0.094380, -0.073960, 0.195380, 0.479460, -0.138910, 
-0.073480, 0.028790, -0.023440, -0.227090, -0.191430, -0.154900, 0.112900, -0.287760, -0.294380, -0.092300, 
-0.233560, -0.330440, 0.072560, -0.041540, -0.423730, -0.074410, -0.447380, -0.292200, 0.031140, 0.566300, 
-0.169750, -0.073160, -0.089110, -0.076450, -0.208600, -0.188060, -0.250970, -0.199830, -0.236340, -0.226910, 
-0.072030, -0.137090, -0.280100, -0.044480, -0.108310, -0.338950, -0.094880, -0.348790, -0.299810, -0.090850, 
0.257160, -0.115010, -0.076760, -0.147570, -0.119020, -0.299530, -0.179010, -0.203850, -0.236420, -0.329260, 
-0.149380, -0.006130, -0.113020, -0.196940, 0.016110, -0.068010, -0.347090, -0.145480, -0.303260, -0.220590, 
-0.064430, 0.199570, -0.177650, -0.132760, -0.089320, -0.031530, -0.256790, -0.125990, -0.089920, -0.235810, 
-0.100200, -0.006320, 0.079400, -0.123670, -0.141140, -0.046640, -0.104020, -0.240270, -0.141310, -0.308880, 
-0.132850, -0.105530, 0.116440, -0.122000, -0.054440, -0.025180, -0.106700, -0.220050, -0.113640, -0.090780, 
-0.211140, -0.001810, 0.042510, -0.035520, -0.076370, -0.037950, -0.168940, -0.046160, -0.187570, -0.060140, 
-0.276480, -0.132180, -0.012290, 0.067050, -0.083900, -0.035750, -0.078780, -0.152220, -0.144980, -0.027270, 
-0.081500, -0.149340, 0.053910, -0.020790, -0.049740, -0.053730, -0.046930, -0.178170, 0.055490, -0.116240, 
-0.103000, -0.289140, -0.104840, 0.016210, 0.009370, 0.069490, -0.004580, -0.064740, -0.080290, -0.151720, 
0.022790, -0.027150, -0.198160, 
-0.034870, 0.032070, -0.164700, -0.125460, 0.193170, 0.434080, -0.011490, 0.121030, -0.328130, -0.048420, 
0.214000, 0.046650, -0.040810, 0.054770, 0.002400, 0.073160, -0.062690, 0.162720, 0.251500, 0.123720, 
0.027090, 0.126880, 0.034330, -0.076260, -0.139510, 0.079540, 0.490480, 0.034660, 0.032010, -0.402600, 
0.003270, 0.196690, 0.040970, -0.082750, -0.062460, -0.168340, 0.020710, 0.099870, 0.144150, 0.129160, 
0.065450, -0.006550, 0.088180, 0.086450, -0.234760, -0.222770, 0.088050, 0.483990, 0.011920, 0.043050, 
-0.461640, 0.237110, 0.237830, -0.140210, -0.106920, -0.163530, -0.144840, 0.122480, 0.143050, 0.154230, 
0.136430, 0.051210, -0.071470, 0.096040, 0.155030, -0.159600, -0.306810, 0.041520, 0.386830, -0.046980, 
-0.038060, -0.374120, 0.281040, 0.142140, 0.087830, 0.057490, -0.184840, -0.213720, 0.077210, 0.013830, 
-0.038390, 0.049930, -0.047430, -0.072230, 0.059040, -0.112620, 0.042260, 0.093200, -0.112680, 0.281630, 
-0.128110, -0.192430, -0.179080, 0.021550, 0.185080, 0.035950, 0.148310, -0.072960, -0.173350, 0.121900, 
-0.072050, -0.255580, 0.034830, -0.123360, -0.084980, 0.318080, -0.138590, 0.204330, 0.197850, -0.184540, 
0.076780, -0.101180, -0.267180, -0.449560, 0.166080, 0.113150, 0.094910, 0.117450, -0.083150, -0.349550, 
0.146860, -0.169420, -0.290960, 0.003720, -0.317780, -0.070900, 0.303530, -0.121160, -0.265550, 0.104880, 
-0.005690, -0.019760, -0.204790, -0.166930, -0.434800, 0.334620, 0.220970, -0.273800, 0.100780, -0.013110, 
-0.352440, -0.292410, -0.424800, -0.127140, -0.012150, -0.293480, -0.179580, 0.550970, -0.020940, -0.126320, 
0.317150, -0.167630, 0.018700, -0.141760, -0.112430, -0.067810, 0.509470, 0.260050, -0.144020, -0.755120, 
0.302340, 0.078590, -0.198460, -0.291500, -0.401540, -0.031540, -0.389510, -0.031090, 0.658710, 0.079490, 
-0.133380, 0.241190, -0.270710, -0.259060, 0.010160, -0.140410, 0.058990, 0.338750, 0.274620, -0.115470, 
-0.700290, 0.497940, 0.217660, -0.173840, -0.188440, -0.290980, -0.070960, -0.333910, -0.001730, 0.786650, 
0.066410, -0.438160, -0.161620, 0.066440, -0.095790, 0.020060, 0.034940, -0.049810, 0.659650, 0.353330, 
-0.251260, -0.584160, 0.394770, 0.121460, -0.268310, -0.275180, -0.183400, 0.056320, -0.124160, -0.026420, 
0.671720, -0.083880, -0.463610, -0.079970, -0.085350, -0.059600, 0.091030, 0.170790, 0.011080, 0.883950, 
0.308090, -0.145790, -0.432990, 0.208540, -0.023440, -0.247530, -0.325460, -0.127920, 0.064570, -0.074500, 
0.028110, 0.609500, -0.153100, -0.282410, 0.108850, -0.139930, 0.028880, -0.026920, 0.025840, 0.091010, 
0.552650, 0.148360, -0.127510, -0.395660, 0.340880, 0.086070, -0.269840, -0.331410, -0.165550, 0.040150, 
-0.151110, 0.129440, 0.461990, -0.059240, -0.300880, 0.131200, 0.004300, -0.185030, -0.075360, 0.146780, 
0.045240, 0.437090, 0.226620, -0.144670, -0.484840, 0.311770, 0.069020, -0.376460, -0.255360, -0.100570, 
-0.020230, 0.033540, 0.240640, 
-0.043100, -0.011680, -0.038970, -0.142490, 0.042290, -0.137920, 0.043580, 0.054540, -0.084090, 0.062200, 
0.024790, -0.031120, -0.045420, -0.083770, 0.007680, -0.024570, -0.014670, 0.044020, 0.025390, 0.100460, 
-0.088370, -0.047550, -0.033100, -0.019330, -0.083280, -0.014200, -0.065050, 0.034570, -0.000180, -0.134940, 
0.045640, 0.009630, -0.000110, 0.003010, -0.003990, -0.020640, 0.014460, 0.030840, 0.011880, 0.000860, 
0.066580, -0.123850, 0.018590, 0.002890, -0.058730, -0.042870, -0.042500, 0.027010, 0.012630, -0.032650, 
-0.178390, 0.013780, 0.051540, 0.007650, -0.051620, -0.084780, -0.002890, 0.042140, 0.060080, -0.022570, 
-0.004940, 0.026040, -0.089880, 0.050480, 0.063410, -0.055160, -0.101700, 0.007360, 0.089580, -0.023850, 
-0.076710, -0.122370, 0.040770, 0.034320, 0.060390, -0.068540, -0.084400, -0.113320, -0.008910, 0.031190, 
-0.041940, 0.043560, 0.007200, -0.063490, 0.005720, -0.000450, -0.018310, -0.074930, 0.018190, 0.044020, 
-0.025630, -0.013480, -0.116500, 0.028360, 0.046010, -0.021770, -0.053790, -0.041580, -0.046470, -0.030710, 
-0.090240, 0.010270, 0.053690, -0.007030, -0.089930, -0.036470, 0.021730, 0.008380, -0.030090, -0.042880, 
0.003910, -0.047460, -0.003290, -0.050870, -0.036750, -0.024810, -0.035770, -0.064610, -0.042090, -0.004150, 
-0.097120, -0.091280, -0.051140, 0.077270, -0.036380, -0.109490, 0.020150, 0.045010, -0.057590, -0.149960, 
-0.029620, -0.040120, -0.053700, -0.021550, -0.087060, -0.137190, -0.065460, -0.102020, -0.103490, -0.011340, 
-0.072860, -0.180440, -0.115330, -0.080680, 0.035930, 0.020650, -0.230480, 0.028180, 0.087850, -0.053460, 
-0.141310, 0.068100, -0.027700, -0.014710, -0.016660, -0.087020, 0.029230, 0.085150, -0.019830, -0.194430, 
-0.017110, -0.116350, -0.156870, -0.016900, 0.050330, 0.023090, 0.040390, -0.076490, 0.035850, 0.035850, 
-0.077400, -0.160990, 0.128750, 0.002660, 0.034140, -0.031380, -0.019980, 0.042260, 0.060140, 0.005700, 
-0.040570, 0.017760, -0.017180, -0.131290, -0.022270, -0.054580, -0.000350, 0.014870, -0.060610, -0.022050, 
0.010210, -0.042530, -0.113850, 0.053850, 0.051830, 0.040620, 0.056120, -0.004870, 0.020710, 0.068330, 
-0.009660, -0.098830, 0.084410, -0.006970, -0.080940, -0.070830, -0.025640, -0.014960, -0.007140, -0.067790, 
-0.017740, -0.045600, -0.134540, -0.078220, 0.123740, 0.002090, 0.031700, 0.016300, -0.018030, 0.130630, 
0.013550, 0.008380, -0.068680, 0.068320, 0.020250, -0.090670, -0.025750, -0.032310, -0.015430, 0.011440, 
-0.075650, 0.030740, -0.045540, -0.081140, -0.036800, 0.104150, -0.046240, 0.003920, 0.036880, -0.037050, 
0.122790, 0.009040, -0.036260, -0.020020, 0.052870, -0.053420, -0.063610, -0.047320, -0.024240, 0.026820, 
0.014590, -0.042750, 0.019390, -0.007080, -0.024200, -0.010320, 0.066960, -0.029680, -0.003950, 0.002590, 
0.012180, 0.032390, 0.035150, -0.020880, 0.001330, -0.069380, -0.021480, -0.048160, -0.037430, -0.069390, 
0.005560, 0.010380, -0.007260, 
-0.044050, 0.006320, -0.023170, -0.117090, 0.026310, -0.137800, 0.019910, 0.058850, -0.111110, 0.007930, 
0.020510, -0.049210, -0.010150, -0.035210, 0.094160, -0.121100, -0.095490, 0.067820, 0.065230, 0.062340, 
-0.097470, -0.093780, -0.037080, 0.003370, -0.052510, -0.045740, -0.056920, -0.001920, -0.041360, -0.134910, 
-0.021460, -0.013450, -0.008150, -0.022510, 0.024740, 0.030420, -0.078430, -0.042460, 0.028230, -0.000800, 
-0.007660, -0.077220, -0.067650, 0.005390, -0.064160, -0.079960, -0.064910, 0.024220, -0.010550, -0.097590, 
-0.184740, -0.021990, -0.016100, 0.011350, -0.049930, -0.062760, 0.003460, -0.009840, -0.002800, -0.064420, 
-0.016680, -0.030730, -0.066020, -0.010390, 0.063330, -0.092630, -0.119500, -0.075980, 0.096840, -0.042770, 
-0.138400, -0.139430, -0.004710, -0.051400, 0.059720, -0.058770, -0.119770, -0.118920, -0.022190, -0.042590, 
-0.113420, -0.020940, -0.062050, -0.084540, -0.105660, 0.030390, -0.028850, -0.090970, -0.115490, 0.045410, 
-0.018120, -0.088060, -0.078300, -0.064700, -0.059960, -0.005910, -0.026900, -0.098420, -0.094190, -0.090700, 
-0.138380, -0.123310, -0.045320, -0.036440, -0.123440, -0.113000, 0.001010, 0.027950, -0.094010, -0.151860, 
0.044150, -0.011720, -0.092460, -0.063350, -0.167800, -0.117660, 0.053640, 0.102610, -0.084840, -0.030240, 
-0.107260, -0.149210, -0.168280, -0.054310, -0.139780, -0.127880, -0.029600, 0.044420, 0.016970, -0.179990, 
-0.094260, 0.081160, -0.025310, -0.109080, -0.093260, -0.168700, -0.104380, 0.033340, 0.199380, -0.058080, 
-0.067420, -0.119930, -0.101580, -0.140350, -0.027460, -0.063460, -0.114920, -0.076750, -0.042880, 0.006790, 
-0.164160, -0.092700, 0.124810, -0.056650, -0.210270, -0.076570, -0.189800, -0.083230, 0.038150, 0.141140, 
-0.087400, -0.103620, -0.170840, -0.041950, -0.082610, -0.066590, -0.061110, -0.086540, -0.036180, -0.047900, 
-0.066650, -0.192050, -0.005080, 0.045860, -0.025980, -0.131250, -0.038730, -0.116380, -0.080980, -0.008680, 
0.126790, -0.030020, -0.081700, -0.190670, -0.058230, -0.112800, -0.078220, -0.054570, -0.090220, -0.087710, 
-0.051330, -0.040170, -0.149730, -0.010380, 0.066320, -0.013540, -0.052190, -0.044330, -0.136010, -0.034740, 
-0.014330, 0.057770, -0.019800, -0.069150, -0.096890, -0.090040, -0.118790, -0.037750, -0.023910, -0.115960, 
-0.006660, -0.058980, -0.068700, -0.071180, 0.069510, 0.029890, -0.024760, -0.066270, -0.045180, -0.023360, 
-0.050860, 0.007400, 0.007090, -0.027000, -0.029690, -0.052400, -0.069990, -0.093060, -0.036230, -0.046160, 
-0.111490, 0.069540, -0.036990, -0.074820, -0.029870, 0.093600, -0.063060, -0.024450, -0.030110, -0.028710, 
-0.018120, -0.047150, -0.030330, 0.011490, -0.008400, -0.056990, -0.061910, -0.071830, -0.063110, 0.011710, 
-0.049280, -0.083480, 0.062890, -0.016450, -0.028370, -0.070380, 0.101080, -0.050410, -0.005100, -0.022600, 
-0.019740, -0.032520, 0.007800, -0.005960, 0.013020, -0.051710, 0.016010, -0.081300, -0.056250, -0.067930, 
0.003530, -0.002570, -0.104810, 
-0.077980, 0.041370, 0.006700, -0.002160, 0.077900, -0.137690, -0.037350, -0.020190, -0.150670, -0.111000, 
0.039950, -0.011680, 0.062100, 0.031360, 0.079450, -0.093450, -0.124480, 0.033380, 0.096270, -0.037290, 
-0.045640, -0.202980, 0.028900, 0.082600, 0.138230, -0.010380, -0.090280, -0.017080, -0.175080, -0.136350, 
-0.209660, 0.007300, -0.024140, -0.002090, 0.065120, 0.031350, -0.104390, -0.183840, -0.060500, 0.044190, 
-0.098260, 0.074640, -0.232920, 0.023100, -0.006980, -0.064010, -0.076440, 0.013410, -0.028600, -0.259980, 
-0.113660, -0.216530, -0.055450, -0.013470, 0.032750, -0.029960, -0.017640, -0.069350, -0.204950, -0.264880, 
-0.006890, -0.062100, 0.058790, -0.214620, 0.009400, 0.030600, -0.173470, -0.211390, 0.136540, -0.003950, 
-0.322500, -0.124730, -0.176300, -0.162990, -0.032530, 0.017310, -0.092100, -0.097950, -0.079610, -0.248740, 
-0.347270, -0.178580, -0.159630, -0.073710, -0.266050, -0.004050, 0.009550, -0.160100, -0.326510, -0.067790, 
-0.036980, -0.364430, -0.076990, -0.293760, -0.192370, 0.031480, 0.124410, -0.138410, -0.144940, -0.176630, 
-0.146020, -0.436260, -0.193700, -0.119980, -0.114870, -0.207840, -0.114460, 0.091100, -0.121260, -0.365100, 
0.008150, 0.013900, -0.414280, -0.097590, -0.329600, -0.220830, 0.153080, 0.357630, -0.156090, -0.121250, 
-0.087190, -0.185100, -0.427470, -0.311200, -0.280300, -0.161820, -0.078440, -0.077430, 0.107530, -0.150880, 
-0.144620, 0.231830, 0.049440, -0.368960, -0.092290, -0.138670, -0.086390, 0.245400, 0.564550, -0.144660, 
-0.077040, 0.051720, -0.018620, -0.339630, -0.205600, -0.166360, 0.134940, -0.275340, -0.271280, -0.044350, 
-0.221790, -0.305570, 0.218890, -0.050310, -0.532400, -0.081740, -0.443030, -0.292760, 0.066370, 0.614180, 
-0.154090, -0.052100, -0.098580, -0.108270, -0.371060, -0.217930, -0.287690, -0.175120, -0.227160, -0.205710, 
-0.046510, -0.154500, -0.258590, 0.019400, -0.088870, -0.374030, -0.106980, -0.360170, -0.272740, -0.077410, 
0.330860, -0.135990, -0.062020, -0.226820, -0.135800, -0.350280, -0.210190, -0.223740, -0.207030, -0.293530, 
-0.153570, -0.025770, -0.187430, -0.187280, 0.110300, -0.073090, -0.337060, -0.129500, -0.289140, -0.203260, 
-0.037770, 0.294580, -0.170230, -0.146610, -0.138660, -0.019410, -0.307940, -0.146140, -0.070280, -0.216220, 
-0.064460, 0.002750, 0.057710, -0.162370, -0.138520, 0.035870, -0.115460, -0.269950, -0.122500, -0.327910, 
-0.115810, -0.063200, 0.238370, -0.129110, -0.078070, -0.051640, -0.079250, -0.228930, -0.097540, -0.067940, 
-0.194640, 0.088600, 0.065840, -0.039450, -0.110860, -0.062200, -0.127420, -0.041380, -0.188550, -0.009850, 
-0.274880, -0.139540, 0.051060, 0.136580, -0.061370, -0.078100, -0.050810, -0.136980, -0.166580, -0.009600, 
-0.109820, -0.134440, 0.127640, -0.020260, -0.062700, -0.052870, -0.072520, -0.164580, 0.087220, -0.097300, 
-0.084550, -0.230720, -0.083120, 0.078450, 0.066670, 0.097070, -0.017990, -0.087250, -0.118100, -0.133740, 
0.027580, 0.013140, -0.166810, 
0.048240, -0.128180, 0.032710, 0.442710, -0.230610, 0.335250, -0.081840, -0.669850, -0.046280, -0.590730, 
0.019620, 0.328900, -0.171000, 0.034640, -0.593020, 0.376020, 0.099880, -0.304500, -0.646300, -0.127370, 
0.445180, -0.029500, 0.088660, 0.117650, 0.349480, -0.104110, 0.163230, -0.007210, -0.410570, -0.082590, 
-0.346850, -0.172280, 0.005570, -0.126810, -0.062650, -0.185310, 0.348360, -0.158530, 0.104630, -0.016750, 
-0.097090, 0.141780, 0.074620, 0.077130, 0.417740, 0.000470, -0.143390, 0.000370, 0.104640, 0.212610, 
-0.080360, 0.114640, -0.175630, 0.390340, -0.285380, -0.384930, -0.166780, 0.026180, 0.139490, 0.233210, 
0.026570, 0.384280, 0.120060, 0.472430, -0.217640, 0.396350, 0.043540, 0.131280, 0.076000, 0.298540, 
0.232090, 0.237010, -0.098620, -0.003300, 0.038040, -0.197880, 0.097090, 0.632290, -0.076600, 0.235420, 
0.509380, -0.011770, 0.306250, 0.437480, 0.897730, -0.284490, 0.031020, 0.544250, 0.478870, -0.460320, 
-0.182800, 0.646150, 0.430980, -0.076010, 0.795760, -0.322160, -0.412930, 0.184630, 0.559850, -0.459560, 
0.556860, 0.492350, 0.264860, 0.685530, 0.290840, 0.855950, 0.059470, -0.905930, 0.364120, 0.769650, 
-1.183030, -0.254220, 0.967610, 0.144070, 1.151410, 0.782500, -1.194180, -1.372200, 0.157750, -0.301830, 
-0.103520, 0.669150, 1.466690, 0.568100, 0.601010, 0.459750, 0.412130, 0.159520, -1.939090, -0.099970, 
0.783780, -1.238550, -0.181610, 1.132610, -0.017750, 1.045020, 0.822420, -1.553840, -3.277690, -0.106780, 
-0.280010, -0.607050, -0.233600, 1.154350, 0.549950, 0.577490, 0.071240, 0.461360, 0.087280, -0.747430, 
0.261720, 0.536750, -0.576300, 0.005990, 1.088050, 0.581140, 0.955930, 0.708050, -0.179410, -2.581680, 
0.152500, 0.366190, 0.155250, -0.285290, 1.285610, 0.662390, 0.427840, 0.504740, 0.433960, 0.093800, 
-0.518830, 0.795950, 0.239160, -0.108950, 0.039140, 0.499140, 0.620220, 0.535800, 0.748690, -0.004660, 
-1.863690, 0.704940, 0.499720, 0.518750, 0.067680, 0.554580, 0.515750, 0.221700, 0.600720, 0.049900, 
0.163560, -0.336820, -0.023270, 0.548800, 0.276390, 0.345270, 0.435160, 0.289190, 0.764190, 0.688270, 
-0.285520, -0.737230, -0.149800, 0.032680, -0.207750, 0.406490, 0.470800, 0.226390, 0.552650, 0.261580, 
0.038320, 0.335340, -0.097360, -0.521560, 0.191840, 0.098730, -0.110450, 0.473120, 0.191360, 0.138540, 
0.388890, -0.184910, -0.024550, 0.056360, 0.198940, 0.070060, -0.364120, -0.044110, 0.097300, 0.082680, 
0.282040, -0.382570, -0.000350, 0.147040, -0.041800, -0.142500, 0.287240, 0.183900, -0.291580, 0.344370, 
-0.417440, 0.116380, 0.310300, -0.122210, 0.224850, -0.002190, 0.159940, -0.051400, -0.470330, -0.425090, 
-0.016750, 0.186750, -0.558480, -0.326260, 0.081830, 0.220400, -0.233470, -0.239050, 0.215400, -0.241020, 
-0.191710, -0.431080, -0.036270, 0.056060, -0.225570, 0.183380, -0.067210, -0.074590, -0.120090, -0.245620, 
-0.055980, -0.223830, 0.379730, 
-0.142910, -0.289510, -0.253890, -0.102780, -0.589350, -0.066150, -0.352900, -0.931380, 0.144510, -0.770500, 
-0.751710, 0.233640, -0.112220, 0.236590, -0.149060, -0.087690, -0.142270, -0.430910, -0.685790, -0.390620, 
0.669280, -0.401310, -0.187270, 0.009080, 0.119570, -0.274480, 0.523580, -0.134650, -0.607900, 0.567050, 
-0.908330, -0.834050, 0.128360, -0.072430, -0.228910, -0.299660, 0.031160, -0.312880, -0.305170, -0.559400, 
-0.105640, 0.310470, -0.381850, -0.190890, 0.453770, -0.143100, -0.527990, 0.230620, -0.134560, -0.378260, 
0.428200, -0.464610, -0.351630, 0.214990, 0.285270, 0.038330, -0.165450, -0.324490, -0.505460, -0.057730, 
-0.380470, -0.042150, 0.425970, -0.679880, -0.345370, 0.288350, -0.201450, -0.417100, 0.578310, 0.382840, 
0.101230, 0.273870, -0.695820, -0.372650, -0.073030, 0.096130, -0.189570, 0.347310, -0.334820, 0.471660, 
0.103860, -0.282030, 0.048070, 0.386890, 0.230700, -0.189530, -0.147130, -1.071700, 0.417830, -0.443620, 
-0.020690, 1.151280, -0.531170, 0.364720, 0.151360, -0.912070, -0.149770, -0.176920, 0.257080, -0.946320, 
-0.192000, 1.211340, 0.247130, 0.632660, 0.368500, -0.222980, -0.186730, -0.769030, 0.666120, 0.094940, 
-1.107240, 0.040930, 0.850010, 0.181190, -0.337180, 0.022960, -1.118960, -0.476280, -0.184390, 0.294910, 
-0.047790, 0.712710, 0.717210, 0.021790, 0.430280, 0.099650, 0.561670, 0.375990, -2.694940, 0.057430, 
1.558730, -1.217950, -0.563010, 2.444960, -1.219610, 1.387220, 0.864490, -1.995930, -1.811100, -1.242540, 
-0.660030, -0.948360, -0.485300, 2.398250, 0.383090, 0.537080, -0.607080, -0.829810, 0.216980, -0.392540, 
1.176000, 0.045050, -0.953930, -0.080290, 1.081370, 0.119770, -0.068540, 0.127590, -1.019730, -0.984630, 
-0.318420, 0.274420, -0.247790, 0.314720, 0.842360, 0.022140, 0.276240, -0.124480, -0.272490, 0.592540, 
-0.284470, -1.353430, 0.741720, 0.100020, -0.523470, 1.640170, -1.048620, 1.269660, 0.642390, -1.339590, 
0.057980, -0.356140, -0.637420, -0.514740, -0.619880, 1.636040, 0.080810, 0.173510, -0.091490, 0.017700, 
-0.051980, 0.313720, 0.072820, -0.282730, -0.004640, 0.003740, -0.075150, 0.124150, -0.377850, -0.202430, 
-0.297260, 0.278920, -0.581250, -0.020190, 0.060090, 0.086700, 0.112900, -0.032070, -0.032150, 0.220640, 
0.218860, 0.173310, 0.377980, -0.549450, -0.202380, 0.399280, 0.201770, -0.165560, -0.150830, -0.629510, 
-0.193190, -0.010690, 0.432110, -0.585630, -0.586150, 0.226790, -0.343360, 0.148590, -0.281520, -0.211690, 
0.244080, -0.031450, -0.032990, 0.336010, -0.550140, -0.843470, 0.777630, 0.171180, -0.648420, 0.185300, 
-1.032910, -0.295670, 0.358950, 0.532160, -0.702560, -0.115840, 0.438330, 0.017330, -0.324220, -0.301090, 
0.031320, 0.394510, -0.416490, -0.024140, 0.008790, -0.461080, -0.517760, 0.397420, 0.137350, -0.825260, 
-0.182450, -0.801730, -0.318890, 0.463900, 0.347300, -0.180820, -0.154100, 0.164070, 0.360030, -0.043500, 
-0.197280, -0.209260, 0.389450, 
-0.183320, -0.071840, -0.240200, 0.221780, -0.052100, -0.170960, -0.132890, -0.015300, -0.198560, -0.181170, 
0.081650, -0.084770, 0.068600, -0.005450, -0.019880, -0.123690, 0.016880, 0.029210, 0.017050, -0.028780, 
-0.269860, -0.131280, -0.047900, -0.177920, -0.007730, -0.188050, -0.208880, -0.072440, -0.071570, -0.238770, 
0.000380, -0.025690, -0.189650, -0.065390, -0.149380, -0.098670, -0.155850, -0.047040, 0.199580, 0.087000, 
-0.075550, -0.139310, -0.102590, -0.113140, -0.164730, -0.177320, -0.097140, -0.176300, -0.135870, -0.165520, 
-0.122670, 0.048260, -0.214820, -0.060620, -0.171810, -0.185390, -0.045500, -0.130510, -0.178400, -0.008270, 
-0.039980, -0.132610, -0.162020, -0.156570, -0.171280, -0.208580, -0.021730, -0.204810, -0.206170, -0.133360, 
-0.344700, 0.021270, -0.147870, -0.314670, -0.203330, -0.203990, -0.160270, -0.027910, -0.019610, -0.209760, 
-0.012970, -0.327450, -0.212170, -0.321050, -0.118740, -0.236390, 0.026280, -0.152970, -0.300500, -0.188330, 
-0.139000, -0.389900, 0.022660, -0.529420, -0.259340, -0.001510, -0.148360, -0.141540, -0.155700, -0.179710, 
-0.204640, -0.171170, -0.365560, -0.195330, -0.257460, -0.252490, -0.267960, -0.037030, -0.368540, -0.348720, 
0.082810, -0.155060, -0.270970, -0.085520, -0.388200, -0.240660, 0.118220, 0.309860, -0.156480, -0.260390, 
-0.258060, -0.129860, -0.203450, -0.436320, -0.247230, -0.258610, -0.257560, -0.147790, 0.350940, -0.580570, 
-0.349080, 0.635410, 0.022150, -0.389570, 0.105100, -0.396580, -0.242180, 0.433490, 0.715830, -0.178130, 
-0.078980, 0.126860, 0.042430, -0.169710, -0.260280, -0.280460, 0.285330, -0.457030, -0.549700, -0.014600, 
-0.469440, -0.564050, -0.017700, -0.129560, -0.581870, 0.079950, -0.597230, -0.505590, 0.020360, 0.866770, 
-0.209130, -0.049520, 0.055130, -0.061440, -0.089480, -0.258710, -0.361440, -0.170590, -0.298410, -0.460250, 
-0.051570, 0.052120, -0.487890, 0.000330, -0.239540, -0.566040, -0.020390, -0.586290, -0.546980, -0.108480, 
0.343760, -0.158840, -0.153570, 0.040250, -0.106510, -0.310270, -0.226450, -0.324490, -0.279530, -0.445060, 
-0.268720, 0.002670, 0.283830, -0.292820, -0.258200, -0.156170, -0.475520, -0.096540, -0.425020, -0.360120, 
-0.240460, 0.127860, -0.174710, -0.149130, -0.044120, -0.023990, -0.259490, -0.169200, -0.179530, -0.243920, 
-0.146140, 0.007900, 0.026590, 0.049290, -0.045530, -0.417920, -0.162950, -0.021970, -0.225630, -0.283980, 
-0.159910, -0.323080, -0.130360, -0.055900, 0.035110, -0.013330, -0.102500, -0.207870, -0.167050, -0.093100, 
-0.235580, -0.048010, -0.011880, 0.013610, 0.056220, 0.109650, -0.385390, -0.071410, -0.031940, -0.117110, 
-0.114410, -0.028140, -0.204580, -0.159730, -0.077620, 0.070990, -0.091030, -0.145330, -0.210340, -0.108560, 
-0.040820, -0.208050, -0.185330, 0.027390, 0.097400, 0.118120, 0.084770, -0.334950, 0.063490, -0.024290, 
-0.095990, -0.290860, -0.126560, -0.051770, -0.029000, 0.040370, 0.039880, -0.003640, -0.034840, -0.033830, 
-0.018010, -0.061870, -0.271560, 
-0.083440, -0.058420, 0.015880, 0.012630, -0.084080, 0.003670, 0.090090, -0.265220, 0.062000, -0.015490, 
-0.199680, 0.074080, -0.283070, -0.162470, -0.297260, 0.295250, 0.145560, -0.140880, -0.412130, -0.185400, 
0.228940, -0.114660, 0.059550, -0.309760, 0.054910, -0.202800, 0.051130, 0.166020, -0.073170, 0.077560, 
-0.218950, -0.233360, -0.051810, -0.053110, -0.158300, -0.005750, 0.376110, 0.185470, -0.098540, -0.048480, 
0.059300, -0.128330, -0.010530, -0.100340, -0.108770, -0.077390, 0.046300, 0.007600, 0.046680, 0.334270, 
0.369620, -0.247310, -0.086510, -0.105630, -0.050980, -0.119660, 0.023000, 0.087680, 0.161040, 0.090260, 
-0.060210, 0.214250, -0.168360, 0.003000, -0.151620, 0.122560, -0.070420, 0.453940, -0.038670, 0.120440, 
0.308790, -0.088180, 0.099300, 0.099090, -0.026770, -0.197620, -0.126650, 0.096410, 0.217940, 0.212380, 
0.519130, 0.012050, 0.312100, 0.001330, 0.331060, 0.176950, -0.528250, -0.168010, 0.783600, 0.149190, 
-0.125400, 0.461110, 0.029730, 0.231080, 0.355050, -0.179720, -0.495990, -0.029270, -0.037730, 0.145510, 
0.322530, 0.519140, 0.307360, 0.329710, -0.028120, 0.353090, 0.389600, -0.729600, -0.115200, 0.590160, 
-0.353940, -0.090500, 0.466140, 0.328430, 0.468090, 0.308850, -0.800090, -1.286490, -0.119560, -0.059170, 
-0.100560, 0.242900, 1.070380, 0.560070, 0.654270, -0.016780, -0.251840, 0.334380, -0.717520, -0.288590, 
0.253840, -0.996310, 0.125830, 0.337670, -0.096560, 0.119510, -0.036940, -0.597020, -2.079260, -0.182150, 
-0.196630, 0.304620, 0.563790, 0.602520, 0.317230, 0.414030, -0.450930, -0.086030, 0.634720, -0.893640, 
-0.615870, 0.846930, -0.589320, 0.237540, 0.920900, -0.250310, 0.834940, 0.295350, -0.209740, -1.153870, 
-0.364000, -0.241420, 0.233100, 0.203700, 1.001520, 0.483410, 0.595960, -0.034770, -0.426360, 0.246560, 
-0.384170, -0.163680, 0.412260, 0.181560, 0.221070, 0.369800, 0.072680, 0.384100, 0.357470, -0.051610, 
-0.257180, -0.220150, 0.084760, 0.355670, 0.280580, 0.455870, 0.394300, 0.417290, 0.041490, -0.518790, 
-0.025290, 0.302820, 0.076390, 0.285960, 0.072440, 0.156370, 0.013660, -0.067000, 0.306570, -0.028850, 
0.098570, 0.040950, -0.096100, -0.142030, 0.416560, 0.460060, 0.293340, 0.006170, 0.328620, 0.042090, 
-0.508220, 0.213710, 0.096260, -0.201590, -0.043340, 0.230080, -0.045800, 0.028520, -0.122590, -0.045620, 
0.022960, -0.074260, -0.134140, 0.038420, 0.041290, 0.369780, 0.444110, 0.144420, 0.056840, 0.141650, 
0.009470, -0.658520, 0.270030, -0.085110, -0.260480, -0.026940, 0.130630, 0.093120, -0.119080, -0.143310, 
0.197650, -0.084900, 0.004410, -0.010050, -0.087270, -0.201070, 0.141070, 0.330300, 0.400200, -0.157110, 
0.194540, 0.031620, -0.598020, -0.085240, 0.109920, 0.148300, -0.280070, 0.154450, 0.114530, -0.169960, 
-0.003630, -0.165270, -0.235930, -0.088310, 0.181230, -0.208300, -0.081110, 0.256540, 0.153060, -0.095880, 
-0.136400, -0.027360, 0.237460, 
-0.067370, -2.038000, 0.011770, 3.751340, -4.080610, -1.728800, -0.384390, 4.233100, 2.448830, -0.242340, 
-1.652800, 2.218660, -2.597890, -0.347840, -0.079870, -0.457950, -0.259880, -0.224570, 0.337320, -0.499890, 
-1.350000, -0.167840, 0.497470, -0.299740, -0.357960, -0.217560, 1.275080, -4.166000, -0.918010, 0.681050, 

-0.853610, -1.929130, -0.078650, -4.416940, 3.991480, -0.736800, -0.617200, -3.815460, -1.117540, -1.129820, 
0.629890, -1.069490, -0.268350, -0.889510, -1.759960, -0.168650, -1.020130, -0.684670, -3.166920, -1.164230, 
-1.693810, -0.936910, -1.695710, -0.470320, -0.690030, -1.222230, 1.494090, 2.866640, -0.992050, 0.410670, 

-0.294850, 1.262820, -0.184730, -1.921170, 2.446020, 1.805710, -0.666260, -2.705410, -1.975030, 0.110360, 
-2.128820, -0.840990, 1.122600, -0.261880, 0.574230, -0.813200, 0.729890, 0.111130, 1.071540, 0.616610, 
1.666340, 0.730070, -0.632790, -0.342610, -0.085250, 0.542230, -1.618570, -1.576410, 0.786330, -2.082660, 


  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[307] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.010000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, 0.009980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.009170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.002710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.008150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, -0.000540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.000910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, 0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, -0.006630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.008630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, -0.001360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, -0.001120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, 0.008980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, 0.009620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.004950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, -0.007520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.000630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, -0.008410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, -0.000310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, -0.006210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, 0.006230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.001410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, 0.008460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, -0.006310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, -0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, 0.007630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.007880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, -0.005690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, 0.002430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, -0.003580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.003620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, -0.005050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.009880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, -0.002490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.007470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.002350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.005420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, 0.006270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, 0.000070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, -0.000190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, 0.003680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, -0.004030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, 0.002660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, -0.007530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, 0.002580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, 0.001440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, -0.000850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, -0.003360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, 0.006580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, -0.006620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.007240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, -0.005380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.008950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, -0.009330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, 0.003310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.008360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, 0.004590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.008510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.003520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.006200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.000720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.001380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.000240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, -0.004780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, -0.007430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, -0.001560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, 0.003330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, 0.002140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, 0.006460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.007760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.007050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.006220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, -0.009100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.008090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.003720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.007460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, 0.009920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, 0.009990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, 0.006140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, -0.001740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, 0.002500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, 0.009460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.000700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, -0.005710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.001160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.004240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.007070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.000520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, 0.004670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, -0.005670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, 0.000640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.006060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.001060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.005140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.000680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, -0.007380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, 0.007320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, -0.006920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.009640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, -0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, -0.003400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, -0.006000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.007140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, -0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.005490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.002680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.008890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, -0.007700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.001100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.006740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.001500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.000400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, 0.009380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, -0.002170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, -0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.006350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.000500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, -0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, 0.003820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, -0.008850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.002240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, -0.008610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.008230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, 0.003250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, -0.000660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.005360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, -0.005040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.008180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.007080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, 0.006510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, 0.001620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, 0.004070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, 0.002440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, 0.001630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, 0.002380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, 0.004000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, 0.009580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, 0.009260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.005580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, 0.000110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, -0.007650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 165 (Old: 165) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 166 (Old: 166) */
      0.0, 0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 167 (Old: 167) */
      0.0, 0.007600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 168 (Old: 168) */
      0.0, -0.000960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 169 (Old: 169) */
      0.0, 0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 170 (Old: 170) */
      0.0, 0.000860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 171 (Old: 171) */
      0.0, -0.001760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 172 (Old: 172) */
      0.0, -0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 173 (Old: 173) */
      0.0, 0.008600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 174 (Old: 174) */
      0.0, -0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 175 (Old: 175) */
      0.0, 0.001940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 176 (Old: 176) */
      0.0, -0.001710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 177 (Old: 177) */
      0.0, 0.006180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 178 (Old: 178) */
      0.0, -0.007850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 179 (Old: 179) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 180 (Old: 180) */
      0.0, 0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 181 (Old: 181) */
      0.0, 0.007690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 182 (Old: 182) */
      0.0, 0.006820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 183 (Old: 183) */
      0.0, -0.009850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 184 (Old: 184) */
      0.0, -0.003630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 185 (Old: 185) */
      0.0, -0.006240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 186 (Old: 186) */
      0.0, -0.002840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 187 (Old: 187) */
      0.0, 0.003410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 188 (Old: 188) */
      0.0, -0.004750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 189 (Old: 189) */
      0.0, -0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 190 (Old: 190) */
      0.0, -0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 191 (Old: 191) */
      0.0, -0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 192 (Old: 192) */
      0.0, 0.002820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 193 (Old: 193) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 194 (Old: 194) */
      0.0, 0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 195 (Old: 195) */
      0.0, -0.006300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 196 (Old: 196) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 197 (Old: 197) */
      0.0, 0.004510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 198 (Old: 198) */
      0.0, 0.009110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 199 (Old: 199) */
      0.0, -0.002020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 200 (Old: 200) */
      0.0, -0.000280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 201 (Old: 201) */
      0.0, -0.002600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 202 (Old: 202) */
      0.0, 0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 203 (Old: 203) */
      0.0, 0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 204 (Old: 204) */
      0.0, 0.000950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 205 (Old: 205) */
      0.0, -0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 206 (Old: 206) */
      0.0, -0.004860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 207 (Old: 207) */
      0.0, 0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 208 (Old: 208) */
      0.0, -0.002360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 209 (Old: 209) */
      0.0, -0.002370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 210 (Old: 210) */
      0.0, -0.007090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 211 (Old: 211) */
      0.0, 0.006370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 212 (Old: 212) */
      0.0, 0.003840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 213 (Old: 213) */
      0.0, 0.009530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 214 (Old: 214) */
      0.0, 0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 215 (Old: 215) */
      0.0, -0.009030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 216 (Old: 216) */
      0.0, -0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 217 (Old: 217) */
      0.0, 0.005900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 218 (Old: 218) */
      0.0, -0.002080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 219 (Old: 219) */
      0.0, -0.008710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 220 (Old: 220) */
      0.0, -0.001190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 221 (Old: 221) */
      0.0, -0.000940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 222 (Old: 222) */
      0.0, 0.001220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 223 (Old: 223) */
      0.0, 0.001000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 224 (Old: 224) */
      0.0, 0.003860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 225 (Old: 225) */
      0.0, 0.005980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 226 (Old: 226) */
      0.0, 0.005680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 227 (Old: 227) */
      0.0, 0.009000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 228 (Old: 228) */
      0.0, 0.005810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 229 (Old: 229) */
      0.0, -0.001490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 230 (Old: 230) */
      0.0, -0.008300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 231 (Old: 231) */
      0.0, 0.001690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 232 (Old: 232) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 233 (Old: 233) */
      0.0, 0.002890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 234 (Old: 234) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 235 (Old: 235) */
      0.0, 0.002160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 236 (Old: 236) */
      0.0, 0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 237 (Old: 237) */
      0.0, 0.004290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 238 (Old: 238) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 239 (Old: 239) */
      0.0, 0.001110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 240 (Old: 240) */
      0.0, -0.008520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 241 (Old: 241) */
      0.0, -0.008430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 242 (Old: 242) */
      0.0, -0.002120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 243 (Old: 243) */
      0.0, -0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 244 (Old: 244) */
      0.0, 0.009710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 245 (Old: 245) */
      0.0, -0.003730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 246 (Old: 246) */
      0.0, -0.006890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 247 (Old: 247) */
      0.0, 0.007410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 248 (Old: 248) */
      0.0, 0.008810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 249 (Old: 249) */
      0.0, 0.009740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 250 (Old: 250) */
      0.0, 0.002180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 251 (Old: 251) */
      0.0, -0.007310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 252 (Old: 252) */
      0.0, 0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 253 (Old: 253) */
      0.0, -0.008490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 254 (Old: 254) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 255 (Old: 255) */
      0.0, -0.003240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 256 (Old: 256) */
      0.0, -0.003100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 257 (Old: 257) */
      0.0, 0.008470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 258 (Old: 258) */
      0.0, 0.008140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 259 (Old: 259) */
      0.0, 0.009930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 260 (Old: 260) */
      0.0, -0.000530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 261 (Old: 261) */
      0.0, -0.005800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 262 (Old: 262) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 263 (Old: 263) */
      0.0, -0.000920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 264 (Old: 264) */
      0.0, -0.005970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 265 (Old: 265) */
      0.0, -0.004540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 266 (Old: 266) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 267 (Old: 267) */
      0.0, 0.004900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 268 (Old: 268) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 269 (Old: 269) */
      0.0, 0.000340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 270 (Old: 270) */
      0.0, 0.000650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 271 (Old: 271) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 272 (Old: 272) */
      0.0, -0.000080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 273 (Old: 273) */
      0.0, -0.007170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 274 (Old: 274) */
      0.0, -1.677390, 273,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 275 (Old: 275) */
      0.0, -0.564600, 273,
       &Sources[273] , 
       &Weights[273] , 
      },
    { /* unit 276 (Old: 276) */
      0.0, -1.695570, 273,
       &Sources[546] , 
       &Weights[546] , 
      },
    { /* unit 277 (Old: 277) */
      0.0, -3.033980, 273,
       &Sources[819] , 
       &Weights[819] , 
      },
    { /* unit 278 (Old: 278) */
      0.0, 4.425320, 273,
       &Sources[1092] , 
       &Weights[1092] , 
      },
    { /* unit 279 (Old: 279) */
      0.0, -0.719850, 273,
       &Sources[1365] , 
       &Weights[1365] , 
      },
    { /* unit 280 (Old: 280) */
      0.0, -1.446700, 273,
       &Sources[1638] , 
       &Weights[1638] , 
      },
    { /* unit 281 (Old: 281) */
      0.0, -3.775940, 273,
       &Sources[1911] , 
       &Weights[1911] , 
      },
    { /* unit 282 (Old: 282) */
      0.0, -2.696010, 273,
       &Sources[2184] , 
       &Weights[2184] , 
      },
    { /* unit 283 (Old: 283) */
      0.0, -0.997330, 273,
       &Sources[2457] , 
       &Weights[2457] , 
      },
    { /* unit 284 (Old: 284) */
      0.0, -2.373300, 273,
       &Sources[2730] , 
       &Weights[2730] , 
      },
    { /* unit 285 (Old: 285) */
      0.0, -0.033790, 273,
       &Sources[3003] , 
       &Weights[3003] , 
      },
    { /* unit 286 (Old: 286) */
      0.0, -0.520080, 273,
       &Sources[3276] , 
       &Weights[3276] , 
      },
    { /* unit 287 (Old: 287) */
      0.0, -1.275490, 273,
       &Sources[3549] , 
       &Weights[3549] , 
      },
    { /* unit 288 (Old: 288) */
      0.0, -0.638740, 273,
       &Sources[3822] , 
       &Weights[3822] , 
      },
    { /* unit 289 (Old: 289) */
      0.0, -1.672460, 273,
       &Sources[4095] , 
       &Weights[4095] , 
      },
    { /* unit 290 (Old: 290) */
      0.0, -0.665780, 273,
       &Sources[4368] , 
       &Weights[4368] , 
      },
    { /* unit 291 (Old: 291) */
      0.0, -1.134400, 273,
       &Sources[4641] , 
       &Weights[4641] , 
      },
    { /* unit 292 (Old: 292) */
      0.0, -0.195510, 273,
       &Sources[4914] , 
       &Weights[4914] , 
      },
    { /* unit 293 (Old: 293) */
      0.0, -0.620700, 273,
       &Sources[5187] , 
       &Weights[5187] , 
      },
    { /* unit 294 (Old: 294) */
      0.0, -0.516370, 273,
       &Sources[5460] , 
       &Weights[5460] , 
      },
    { /* unit 295 (Old: 295) */
      0.0, -0.719110, 273,
       &Sources[5733] , 
       &Weights[5733] , 
      },
    { /* unit 296 (Old: 296) */
      0.0, -2.135680, 273,
       &Sources[6006] , 
       &Weights[6006] , 
      },
    { /* unit 297 (Old: 297) */
      0.0, -1.415290, 273,
       &Sources[6279] , 
       &Weights[6279] , 
      },
    { /* unit 298 (Old: 298) */
      0.0, -1.133710, 273,
       &Sources[6552] , 
       &Weights[6552] , 
      },
    { /* unit 299 (Old: 299) */
      0.0, -0.707150, 273,
       &Sources[6825] , 
       &Weights[6825] , 
      },
    { /* unit 300 (Old: 300) */
      0.0, -2.806350, 273,
       &Sources[7098] , 
       &Weights[7098] , 
      },
    { /* unit 301 (Old: 301) */
      0.0, -2.838550, 273,
       &Sources[7371] , 
       &Weights[7371] , 
      },
    { /* unit 302 (Old: 302) */
      0.0, -0.617640, 273,
       &Sources[7644] , 
       &Weights[7644] , 
      },
    { /* unit 303 (Old: 303) */
      0.0, -2.497370, 273,
       &Sources[7917] , 
       &Weights[7917] , 
      },
    { /* unit 304 (Old: 304) */
      0.0, 1.106180, 30,
       &Sources[8190] , 
       &Weights[8190] , 
      },
    { /* unit 305 (Old: 305) */
      0.0, -1.196780, 30,
       &Sources[8220] , 
       &Weights[8220] , 
      },
    { /* unit 306 (Old: 306) */
      0.0, -0.955840, 30,
       &Sources[8250] , 
       &Weights[8250] , 
      }

  };



int net_profil(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[273] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, Units + 271, Units + 272, Units + 273}; /* members */

  static pUnit Hidden1[30] = {Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303}; /* members */

  static pUnit Output1[3] = {Units + 304, Units + 305, Units + 306}; /* members */

  static int Output[3] = {304, 305, 306};

  for(member = 0; member < 273; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 30; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
