/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  net_profil111.c
  --------------------------------------------------------
  generated at Fri Jun 25 16:23:47 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[307];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, 
Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, 
Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, 
Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, 

Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, 
Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, 
Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, 

Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, 
Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, 
Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, 


  };

  /* Weigths definition section */
  static float Weights[] =  {
-0.007310, -0.011910, 0.035580, -0.059470, 0.009480, -0.019440, -0.001360, -0.028440, -0.108080, -0.055030, 
0.006920, -0.010900, -0.081430, -0.002150, -0.008910, -0.066170, -0.082070, -0.074060, 0.033600, 0.018700, 
-0.118020, -0.017260, -0.009390, -0.040700, -0.019560, 0.009850, -0.006900, 0.014750, -0.022820, -0.126780, 
-0.049720, 0.007220, -0.021760, -0.028920, 0.005000, -0.044550, -0.036410, -0.049920, -0.113270, -0.012450, 
0.027950, -0.104830, 0.054670, 0.018550, -0.045770, -0.048100, -0.009570, -0.010760, -0.001860, -0.060610, 
-0.130460, -0.049780, 0.052540, -0.039920, -0.001370, 0.007690, -0.066030, -0.065460, -0.024020, -0.140970, 
-0.004850, -0.003180, -0.124640, 0.013170, -0.000520, -0.039840, -0.029590, -0.039750, 0.028020, -0.027910, 
-0.094880, -0.100130, -0.090930, 0.054610, -0.040100, -0.016090, -0.006860, -0.054400, -0.015630, -0.037050, 
-0.172730, 0.036010, -0.021070, -0.154260, 0.048400, 0.003910, -0.068750, 0.003350, -0.038000, -0.022920, 
-0.071920, -0.041260, -0.062790, -0.106750, 0.026640, -0.029710, -0.053740, -0.006930, -0.067330, -0.056890, 
-0.118740, -0.122790, 0.042580, -0.025710, -0.173660, 0.031090, -0.015570, 0.028830, -0.008180, -0.074700, 
-0.152670, -0.083000, -0.062060, -0.064740, -0.095490, -0.027070, -0.034450, -0.102730, 0.006930, -0.035850, 
-0.047410, -0.123160, -0.112730, 0.030540, -0.062000, -0.159290, 0.052060, -0.010340, -0.163550, 0.011170, 
0.021700, -0.224340, -0.078470, 0.024880, -0.122270, 0.014140, -0.020390, -0.114600, -0.129480, 0.030330, 
-0.114770, -0.178550, -0.192840, -0.066300, 0.037570, -0.033050, -0.217490, 0.028270, -0.009790, -0.079980, 
0.056430, 0.004350, -0.171150, -0.020060, -0.051350, -0.052690, -0.031120, 0.035980, -0.038700, -0.249860, 
0.042550, -0.054770, -0.126390, -0.131520, -0.094520, -0.003830, 0.019370, -0.146190, 0.019390, -0.012070, 
-0.108810, -0.115790, 0.124870, -0.119190, -0.002770, -0.044550, -0.074260, 0.064570, 0.073160, -0.070590, 
-0.208930, 0.046830, -0.035840, -0.175140, -0.139020, -0.083520, 0.027050, 0.026310, -0.142350, 0.060830, 
-0.013070, -0.107700, -0.137700, 0.026310, -0.113450, 0.009520, -0.002410, -0.018400, 0.039980, 0.077270, 
-0.047490, -0.157270, 0.024460, 0.016610, -0.127480, -0.085740, -0.132870, 0.014470, 0.015720, -0.127240, 
0.068650, -0.057740, -0.124040, -0.097350, -0.003250, -0.034080, -0.016060, -0.065190, -0.033930, 0.048780, 
0.039850, 0.000840, -0.101780, -0.011840, -0.012550, -0.105660, -0.108310, -0.089680, 0.015670, -0.043320, 
-0.118140, 0.114470, -0.044790, -0.143010, -0.081090, -0.011450, -0.030790, -0.019480, -0.010930, 0.020880, 
-0.000510, 0.013820, -0.027970, -0.071650, 0.068930, -0.022560, -0.105340, -0.130180, -0.150740, 0.005190, 
-0.038500, -0.112920, 0.052690, -0.042590, -0.120290, -0.044740, -0.012380, -0.064520, -0.027130, 0.008620, 
-0.020460, 0.040810, 0.077390, -0.010050, -0.053090, -0.020880, -0.021410, -0.133800, -0.109040, -0.133090, 
-0.022600, -0.031960, -0.095690, 
0.879050, 0.301990, -0.183690, 0.238440, 0.167960, -0.831260, -0.857700, -0.164360, 0.775560, 0.669490, 
-0.273810, 0.242610, -0.716060, 0.827120, -0.513040, 0.375990, -0.404730, -0.427010, 0.278030, 0.325740, 
-0.581100, 0.520310, 0.458120, -0.994310, 0.392250, -0.009300, -0.844720, -0.718030, 0.530200, 0.668480, 
0.779000, -0.247020, -0.433590, -0.241440, -0.203820, -0.366490, -0.143470, -1.136830, -0.122420, 0.683410, 
-0.099980, -0.329910, 0.449160, -0.305230, -0.110190, 0.721410, -0.936990, -1.670000, 0.073970, -0.305240, 
0.828860, 0.392940, -0.435570, 0.160830, -0.385360, 0.069860, 0.272380, -0.118480, -0.647270, -1.376380, 
0.229890, -0.285650, -0.650800, 0.840200, -0.891750, 0.337830, 0.204930, -1.194310, -1.094380, -0.068470, 
-0.812130, 0.459650, 0.230600, -0.877340, -0.279430, -0.498540, 0.204650, 0.022340, -0.029780, -0.219510, 
-1.521550, -0.983210, -0.507040, -0.221090, 0.126500, -0.782390, -0.210800, 0.162800, -0.674360, -0.460280, 
-0.299400, -2.161960, 0.019780, 0.003700, -0.243310, -0.234900, -0.734930, 0.056380, -0.283730, -0.321040, 
-0.251330, -1.183880, -1.116700, -0.564420, 0.092670, -0.012200, -0.702680, -0.274990, 0.304640, -0.405230, 
0.546140, -0.755330, -1.529650, -0.061240, -1.199120, -0.421820, 0.052620, -0.526740, 0.326440, -1.299060, 
-0.240780, -0.206190, -1.383890, -1.606990, -0.643540, -0.106350, -0.447120, -1.191850, 0.642910, 0.518980, 
-0.217170, 1.427160, -0.146740, -0.329450, 0.332900, -0.736890, 0.482810, 0.717600, 1.431500, 0.003600, 
-0.702050, 0.096570, -0.780410, -0.754000, -1.577980, -0.553570, 1.405650, -1.232120, -1.142820, 0.317350, 
-0.773100, -0.366890, 0.498050, -0.484790, -0.055550, -0.216740, -1.434890, -0.622480, -0.591100, 0.865110, 
-0.403360, -0.200720, -0.290800, -0.993440, -0.963930, -1.139110, -1.364880, 0.181350, -0.945390, -0.989520, 
-0.497270, -0.812330, -0.835870, -1.462850, -0.918630, -0.076180, -0.290240, -1.061850, -0.826730, -0.539300, 
1.206840, -0.537170, -0.042380, -0.117860, -0.142250, 0.659410, -0.692480, -0.935440, 0.277950, -0.795590, 
-0.186900, -0.519220, -0.614350, -0.930910, -0.885390, -0.474530, -0.076660, -0.855980, 0.270390, -0.190790, 
-0.466060, 1.212050, -1.164600, 0.073010, -0.567440, -0.329360, 0.624620, -0.770730, 0.446820, -0.028380, 
-1.409160, 0.392970, -0.035880, -0.066980, -0.347500, -0.928450, -0.285590, 0.186430, -0.176570, -0.101910, 
0.089070, -1.275460, 0.967180, -0.194680, -0.445910, 0.125150, 0.567390, 0.075620, -0.489490, 0.678880, 
-0.481410, -0.937870, -0.065590, -0.117320, -0.428040, 0.258490, 0.068000, 0.496540, 0.936730, -0.361770, 
0.408490, 0.552680, -0.814210, 0.388790, -0.084540, -0.121590, 0.626400, 0.292840, 0.619090, -1.237070, 
-0.058460, -0.428470, -0.989600, -0.325020, -0.236580, -0.215410, 0.502860, 0.050060, 0.481310, -0.020870, 
-0.677810, 0.288160, 0.379450, -0.202220, -0.096530, 0.240840, -0.122890, 1.181600, 0.722390, 0.307700, 
0.268540, -0.666740, -0.072750, 
-0.043420, -0.077000, -0.018330, -0.075870, -0.069350, -0.089040, 0.040710, -0.096710, -0.092410, 0.012110, 
0.049810, 0.007740, -0.112530, -0.064530, -0.165830, 0.019400, 0.057490, -0.098640, -0.117460, 0.041970, 
-0.030180, 0.001860, -0.045110, -0.023080, -0.010980, -0.097170, -0.002030, 0.079530, -0.046000, -0.031740, 
-0.064180, 0.013230, -0.004400, -0.042950, -0.047270, -0.124550, 0.108780, 0.008150, -0.151030, -0.062670, 
0.134870, -0.123350, 0.143240, 0.011600, 0.063890, 0.046180, -0.056570, 0.029500, 0.045250, -0.033600, 
-0.121970, -0.103490, 0.062910, -0.010990, -0.012250, -0.056330, -0.089570, -0.005290, 0.045030, -0.156660, 
-0.034660, 0.102570, -0.096970, 0.058780, 0.020670, 0.154280, 0.055520, 0.008510, 0.102940, 0.072610, 
-0.057560, -0.098500, -0.155010, 0.084980, 0.029940, -0.033850, -0.014450, 0.040430, 0.017450, 0.076780, 
-0.132220, 0.058040, 0.115650, 0.007330, 0.238610, -0.011420, 0.070240, 0.034960, 0.130840, 0.004550, 
-0.082440, 0.057390, -0.073180, -0.066070, 0.168660, -0.057640, -0.099350, 0.020440, 0.081580, 0.007030, 
-0.013400, 0.096770, 0.183620, 0.029160, -0.051500, 0.211330, 0.072690, 0.059370, 0.148710, 0.063970, 
-0.312550, -0.081280, 0.035090, 0.075100, -0.045210, 0.090580, -0.206600, -0.336360, 0.067030, 0.081910, 
0.051160, 0.068160, 0.126340, 0.258410, 0.119820, -0.058150, 0.138980, 0.073570, -0.489380, -0.143440, 
0.156640, -0.401190, -0.107590, 0.288310, -0.118640, 0.113960, 0.037170, -0.413870, -0.661750, 0.015370, 
-0.161760, -0.242030, -0.163700, 0.194200, 0.140470, 0.165240, -0.377280, 0.088410, 0.214500, -0.147820, 
0.168270, 0.272350, -0.399360, 0.076270, 0.312670, -0.048030, 0.140060, 0.262790, -0.149920, -0.721400, 
0.087510, -0.036150, -0.035100, -0.050830, 0.189450, 0.172240, 0.249270, -0.065620, -0.030260, 0.195000, 
-0.099930, -0.083670, 0.442310, -0.086570, 0.129130, 0.160250, 0.010750, 0.273200, 0.287680, -0.014880, 
-0.469340, 0.042690, -0.004800, -0.045230, -0.089750, 0.095640, 0.167370, 0.161040, -0.038400, -0.061180, 
0.081730, -0.059660, 0.034060, 0.177980, -0.084220, 0.153470, 0.162640, 0.057830, 0.194500, 0.201140, 
-0.159630, -0.322920, 0.162660, 0.102580, -0.211930, -0.059350, 0.064990, 0.008560, 0.138310, -0.055630, 
-0.081660, -0.002430, -0.259330, -0.163170, 0.171890, -0.048170, 0.039820, 0.181300, 0.008360, 0.299260, 
0.143000, -0.115540, -0.181790, 0.109620, 0.069190, -0.154660, -0.018360, 0.081050, 0.019140, 0.005850, 
-0.063300, -0.092040, -0.060410, -0.072570, -0.068830, -0.015690, -0.003910, 0.036690, 0.043080, 0.058970, 
0.018460, 0.046270, -0.036270, -0.012140, 0.150420, -0.029490, -0.053760, -0.075920, -0.166450, -0.027800, 
0.087590, -0.029270, -0.114930, -0.017090, -0.043920, 0.094120, -0.095410, -0.055380, 0.018430, -0.052150, 
0.032040, -0.072620, 0.088660, 0.010970, -0.017180, -0.034350, -0.081800, -0.100980, -0.012300, -0.209990, 
0.004130, -0.026800, 0.041120, 
0.580740, 0.093470, 0.472750, 0.915120, 0.073860, -0.526910, 0.069190, 0.256780, 0.248380, 0.291980, 
0.154990, 0.048230, -0.368740, 0.005520, -0.339960, -0.164450, 0.147840, -0.070510, 0.323090, -0.015950, 
0.083780, 0.690370, -0.139570, -0.500200, -0.236860, 0.265010, -0.695500, 0.315360, 0.577130, -0.671990, 
1.397140, 0.239600, -0.941180, -0.180920, -0.354140, 0.001100, -0.498860, 0.414450, -0.203730, 0.993350, 
0.094340, 0.232820, 0.318590, -0.314120, 0.557310, 0.719290, -0.271670, -0.837600, -0.536340, -0.208620, 
1.178290, -0.697580, 0.314770, -0.137200, -0.403440, 0.854350, 0.731290, -0.146710, -0.043300, -0.636600, 
0.022610, -0.460640, 0.463530, 0.788650, -1.188140, 0.648940, 1.689430, -1.261060, -1.347780, 0.068920, 
-0.429720, 0.689460, -0.913690, -0.276770, 0.711610, -0.598730, 0.924350, 0.900970, 0.241150, -0.439550, 
-0.685730, 0.159040, 0.029620, 0.251500, 0.911120, 0.370170, -0.428630, -0.750620, 0.436020, -1.754910, 
0.356900, 1.138870, -0.859100, 0.973700, 1.037480, -0.706840, -0.749050, -0.701850, -0.575770, -0.349490, 
-0.279390, 0.027780, 0.458830, 0.331380, 0.170250, 0.670870, 0.715630, -1.818120, -0.762020, 0.641290, 
-1.873360, -0.808370, 1.107360, -0.349450, 1.265750, 1.129940, -1.578990, -0.803610, 0.148380, 0.300700, 
-1.272900, -0.407390, 0.864920, 1.243640, 0.118840, 0.010380, 0.555010, -1.501840, 0.742880, 1.831340, 
-1.626210, -1.278740, -0.812730, -1.432770, 1.465010, -1.038370, -0.646520, 0.604580, -0.745380, 1.053350, 
1.403740, 0.442070, -0.929950, -1.599470, 0.013670, -0.355110, 0.196960, 0.646390, -0.642990, 0.250990, 
1.045740, -0.627490, -1.101440, 0.787120, -0.612250, 0.704710, -0.676110, 0.163460, 0.098080, -1.852020, 
1.031110, 0.252330, 0.314990, -0.225490, -0.913380, -0.618250, 0.296810, 0.500860, 0.586620, 0.963310, 
-1.654880, -0.984880, 1.550780, -0.324810, 0.087720, 1.600840, -1.318060, 1.577570, 1.579570, -0.800470, 
-1.898650, -0.440290, -1.010440, -1.445910, -0.523070, 0.913510, 0.737070, 0.865130, 0.086320, 0.501970, 
0.015190, -0.508740, 0.126750, 0.455940, 0.017620, -0.406910, 0.429070, 0.698280, 0.695110, 0.498240, 
-0.080690, -0.064030, -0.089470, 0.315500, -0.436970, -0.483550, 0.075620, 0.767440, -0.368970, -0.209870, 
0.297570, -0.717790, 0.792910, 1.348000, -0.873840, 0.023900, -0.108100, -0.840170, 1.348610, -1.518420, 
-0.506360, 0.685220, 0.109990, 0.977670, 1.247390, 0.243590, -0.086090, -0.708050, -0.708690, -0.487050, 
0.868230, -0.170410, -0.024930, 0.013480, -0.363130, 0.371670, -0.356120, 0.172890, 0.003650, 0.163630, 
-0.037360, 0.025320, -0.006700, -0.653440, -0.015600, 0.453880, 0.028720, -0.442890, -0.222530, -0.064570, 
0.252430, 0.372330, 0.166030, 0.294380, -0.586410, -0.913140, 0.296400, -0.259650, -0.042320, 0.677740, 
-0.038470, 1.015510, 0.080600, -0.363490, -0.192860, -0.781130, -0.554890, -0.122420, -0.864720, 0.676050, 
0.612000, 0.135730, -0.140560, 
-0.625740, -0.657950, -0.026340, 0.021070, -1.016910, -0.457750, -0.425250, -0.380600, -0.085410, 0.025500, 
-0.148080, -0.507560, -0.326910, -0.023320, -0.732010, -0.055790, 0.112430, -0.087710, -0.850150, -0.546070, 
0.852230, -0.478660, -0.314790, 0.310610, -0.076970, -0.203660, -0.186720, -0.166890, -0.862450, 0.495950, 
-0.596510, -0.616210, -0.113560, 0.033850, -0.164500, -0.390430, 0.162280, 0.223380, -0.227690, -0.813950, 
-0.467580, 0.168600, -0.861420, -0.449620, -0.059100, 0.263450, -0.648330, 0.315500, -0.613570, -0.675450, 
1.077180, -0.487700, -0.851770, -0.006260, 0.106200, 0.327880, -0.025180, 0.067410, -0.028840, -0.394370, 
-0.370540, -0.419060, 0.444700, -1.108510, -0.691550, 0.464600, 0.120500, -0.738050, 0.544420, -0.094570, 
-0.172430, 0.781610, -0.818690, -1.078880, 0.745510, 0.237500, 0.016340, -0.015320, -0.157140, 0.996840, 
-0.179470, -0.279880, -0.765210, 0.286610, -1.071270, 0.259270, -0.022950, -1.303170, -0.513350, 0.685020, 
0.191530, 0.342940, -0.273420, 0.063510, -0.757070, -0.298900, 0.142120, 0.104640, 0.453640, -0.475570, 
0.431430, 0.388630, 0.450880, 0.239220, 0.259390, -1.579490, -0.835210, -0.421330, 0.485930, -0.880910, 
-0.517990, 0.074950, 0.396510, 0.425280, 0.196250, 0.041190, -0.156670, -0.156360, 0.322230, 1.050640, 
-0.550660, 1.113920, 0.324710, 0.084850, 0.342070, 0.272430, 0.763950, 0.436510, -3.887890, -0.432810, 
0.818300, 0.216690, -0.171830, 1.653710, -0.832740, 1.169920, 0.905640, -2.311770, -0.621180, -1.039450, 
0.405760, -1.323380, -0.064480, 1.925240, 0.396860, 1.387870, -0.756980, 0.072380, 0.404780, -1.832580, 
0.819140, -0.525900, -1.202340, 0.342390, 1.261360, 0.122050, -0.476810, 0.473040, -1.110470, -0.112970, 
0.429990, 0.586830, -0.534930, 0.861610, 0.492710, -0.258980, 0.427130, -0.723900, 1.036350, 1.208330, 
-1.512880, -1.033670, -0.015820, -0.454280, -0.320160, 1.540500, -0.506570, 0.672560, 0.643520, -1.297830, 
0.066410, -0.587170, -0.396610, -0.341180, 0.007720, 0.982470, 0.100830, 0.312390, -0.974550, -0.226240, 
0.386880, -0.773600, -0.510030, -0.816590, -0.035890, -0.257160, 0.511810, -0.119170, -0.530150, -0.279430, 
-0.372220, -0.037520, 0.007270, 0.258300, 0.815470, 0.189710, 1.196910, -0.071450, -0.496430, -0.556230, 
-1.604780, 0.561760, 0.423080, -0.138390, -0.128740, -0.262270, -0.263110, -0.076620, 0.165540, -0.415250, 
-0.214730, -0.124950, 0.502210, 0.073780, -0.748480, 0.168900, 0.001650, 0.023210, -0.183400, 0.075740, 
-0.474620, -1.338670, 0.061950, 0.347010, -0.074820, -0.818900, 0.211410, -0.500090, -0.984480, -0.069250, 
0.079970, -0.364970, 0.287570, 0.909890, -0.708110, -0.680970, 0.565360, 0.284520, 0.490540, -0.013340, 
-0.283760, -0.062440, -0.488580, 0.210200, 0.242920, -0.663180, 0.033770, 0.079690, 0.468480, -1.350640, 
0.343770, -0.501480, -0.997180, -0.278100, 0.299400, -0.584760, -0.871710, 0.291820, 0.330090, 0.385720, 
-0.034210, -0.139420, -0.070010, 
0.215310, 0.012550, -0.891200, 0.128000, -0.080050, 0.253940, -0.277310, 0.198880, 0.138550, 0.135410, 
-0.051630, -0.316810, 0.145280, -0.138610, -0.326100, -0.037860, 0.401450, 0.202540, -0.025900, -0.023160, 
-0.609130, 0.432510, 0.019510, 0.207270, -0.276180, -0.590210, -0.495940, -0.412160, 0.390520, -0.360310, 
-0.163880, 0.260360, -0.235020, -0.156890, -0.735400, -0.055550, -0.019630, 0.196810, 0.062460, 0.264900, 
-0.068000, -0.221760, 0.413610, -0.090610, 0.028890, -0.088250, 0.018140, -0.495950, -0.337130, 0.547900, 
-0.160250, 0.674920, -0.555640, -0.340600, -0.333910, -0.654230, -0.641050, -0.242760, -0.308990, 0.228790, 
-0.286420, -0.167060, -0.416340, -0.178390, -0.223840, -0.403880, 0.235270, 0.157800, -0.843620, -0.390690, 
-0.205110, 0.075070, -0.191150, -0.356250, -0.288730, -0.140650, -0.494510, 0.122710, -0.390760, -0.258720, 
0.285390, -0.699220, -0.271110, -0.446740, 0.052280, -0.770410, -0.033170, -0.176610, -0.263410, -0.223900, 
-0.344570, -0.390990, 0.137300, -1.340180, -0.227900, -0.080240, -0.835630, 0.223230, -0.341510, 0.051170, 
0.139380, -0.452570, -0.568360, -0.444700, -0.054680, -0.360730, -0.109960, -0.628820, -0.453510, -0.286250, 
-0.621540, -0.311390, -0.619760, -0.279550, -0.044310, -0.180430, -0.249090, -0.322220, -0.228090, -0.941840, 
-0.119850, -0.259150, 0.062650, -0.411420, -0.165370, -0.146930, -1.732570, -0.409990, 1.527900, -1.104520, 
-0.759110, 1.067460, 0.414200, -1.423700, 1.015990, -1.488950, -0.322260, 0.945350, 0.566250, -0.090650, 
0.394390, 0.837650, 0.413750, -0.578620, -0.528470, -0.853970, 1.242390, -0.233690, -1.033510, -0.972990, 
-0.068110, -0.491480, -0.342360, -0.411020, -0.455470, 0.090720, 0.134570, -0.967690, -0.743660, 0.424060, 
-0.205730, -0.348550, -0.686570, -0.732450, 0.354770, -0.150850, -0.726720, 0.145850, -0.469740, -0.756730, 
-0.364840, 0.329180, -0.901170, -0.476510, -0.693240, -0.745050, 0.114810, -0.415190, -0.474450, -0.244170, 
-0.158970, -0.131330, -0.008840, 0.213420, -0.295850, -0.165680, -0.690960, -0.877290, -0.103810, -0.044620, 
-0.261630, -0.401500, 0.620720, 0.230130, -1.943060, -0.136700, -0.103020, 0.043580, -0.300550, -0.055960, 
-0.577720, -0.474560, -0.158060, -0.420900, -0.532970, 0.111960, -0.176630, -0.034750, -0.530040, -0.150160, 
0.343720, 0.063820, -1.351930, -0.597870, 0.366100, -1.401740, -0.269040, 1.191280, -0.820280, 1.357040, 
0.169850, -0.692760, -0.982770, -0.514590, 0.235460, -0.440870, -0.459960, 0.720120, 0.174030, -0.285550, 
0.050410, -1.098630, -0.112340, 0.417470, 0.240360, -0.051010, -0.234230, 0.096460, 0.296030, -0.127120, 
0.312640, 0.763390, -0.417220, -0.677970, -0.194640, 0.547880, 0.274140, -0.141620, -0.274480, -0.455680, 
-0.376780, -0.048560, -0.383140, 0.409400, 0.842840, -0.013450, 0.192450, -0.375740, -0.214040, 0.657390, 
-0.485420, 0.621260, -0.075160, -0.789890, 0.019430, -0.414380, 0.110790, -0.251980, -0.164640, 0.409690, 
-0.116070, -0.263790, 0.056500, 
-0.050210, 0.105850, -0.272000, -0.176290, -0.566810, 0.036700, 0.182670, -0.097430, 0.101250, 0.200210, 
-0.032100, -0.170300, -0.305390, -0.054790, -0.315130, 0.474270, 0.130880, -0.397620, -0.314250, -0.300190, 
-0.214790, -0.198330, 0.155310, -0.263800, -0.042020, -0.141420, 0.030230, 0.022110, 0.046820, 0.429110, 
-0.185740, -0.133830, -0.163190, -0.178450, -0.114020, -0.096650, 0.325220, 0.168910, -0.554660, -0.117760, 
0.116680, -0.454300, -0.094810, -0.086500, -0.247270, 0.027170, 0.372650, -0.037280, -0.041030, 0.179820, 
0.222430, -0.426120, 0.018840, -0.514690, 0.294320, 0.079500, -0.061030, 0.101990, 0.025610, -0.115170, 
-0.087050, 0.073340, -0.480180, -0.255790, -0.168480, 0.152930, 0.420440, 0.576290, -0.062210, -0.086110, 
0.159650, 0.109300, -0.289970, -0.010730, -0.383470, 0.284890, -0.066710, 0.084910, 0.333020, -0.038790, 
0.091240, -0.033450, 0.030600, -0.496710, 0.302760, 0.169890, -0.043850, 0.188390, 0.484190, 0.106310, 
0.058900, -0.016030, -0.052490, 0.066360, 0.001060, -0.364660, -0.039520, 0.042120, -0.081390, 0.346070, 
0.101240, 0.280510, 0.133610, -0.030510, -0.530920, 0.326900, 0.507850, -0.303970, -0.083390, 0.742810, 
-0.056320, 0.316560, 0.177130, 0.038830, -0.167630, 0.090830, -0.959760, -0.880220, -0.152270, 0.092430, 
0.793780, 0.171880, 0.286380, 0.381510, 0.643370, -0.660320, -0.115160, 0.471870, -0.553560, -0.620690, 
0.467430, 0.258480, 0.466220, 0.224880, -0.371230, -0.014580, -0.232660, -0.340510, -1.307270, -0.276770, 
-0.206850, 0.416120, 0.132440, 0.311880, 0.049070, 0.420830, -1.177020, -0.646190, 0.540270, 0.336280, 
0.007960, 0.401240, -0.094850, 0.626560, 0.509570, -0.302040, -0.395210, -0.023010, -0.374550, 0.118500, 
-0.156080, -0.131120, 0.540920, 0.422150, 0.108480, 0.078900, 0.542680, -0.837050, -0.680150, 0.736190, 
0.235460, 0.024630, 0.413010, -0.269760, 0.283180, 0.396770, -0.426170, 0.246120, 0.205510, 0.028990, 
0.057590, -0.624850, -0.305610, 0.817050, 0.213610, 0.116310, 0.147530, 0.555060, -0.753270, -0.640960, 
-0.106760, 0.268730, 0.563490, 0.006880, 0.049250, 0.063400, -0.081150, -0.293690, 0.026310, -0.224400, 
0.086300, 0.000780, -0.177480, -0.055910, 0.643690, 0.804540, 0.111380, -0.094630, 0.105570, -0.614380, 
-0.629380, 0.031670, -0.014590, -0.010070, -0.324260, 0.196270, -0.292300, 0.290200, -0.187290, 0.074620, 
0.104230, -0.216350, -0.066530, 0.051660, -0.489180, 0.237630, 0.686060, 0.487120, 0.080640, 0.171360, 
-0.623010, -0.518870, -0.111380, 0.310430, 0.120030, -0.210120, 0.301880, -0.143690, 0.251030, -0.220920, 
-0.353090, -0.106550, -0.259640, -0.107880, 0.070860, -0.256520, 0.462600, 0.544510, 0.175080, -0.152220, 
0.013720, -0.535470, -0.396250, 0.007920, 0.194950, 0.204320, -0.205620, 0.470660, -0.027530, -0.206630, 
-0.059840, -0.286240, -0.101290, -0.277050, 0.027840, -0.237270, -0.388600, 0.300790, 0.425740, -0.225660, 
-0.038900, 0.227800, -0.398180, 
0.878880, 0.119650, -0.603290, -0.266750, 0.330560, -0.044030, 0.630900, 0.299940, -0.569880, 1.161030, 
0.409090, -0.524030, 0.106440, -0.022720, 0.023840, 0.077590, 0.594610, 0.198810, 0.167690, 0.485320, 
0.204830, 0.809160, -0.095990, 0.525980, 0.372370, -0.453930, -0.317950, -0.262200, -0.336140, 0.700050, 
-0.457310, 0.459400, 0.487260, -0.119140, 0.850890, 0.436560, -0.106320, -0.075000, -0.498040, 0.063720, 
-0.386970, 0.165940, 0.555830, -0.915670, 0.516580, 1.529280, -1.002340, -1.197540, 0.120180, -0.070310, 
0.491700, -0.426660, -0.006300, 0.853050, -0.172080, 0.732520, 0.715400, 0.216610, -0.049930, -0.260510, 
0.367080, -0.110140, -0.036970, 0.831680, -0.111780, -0.441390, -0.571370, 0.951640, -0.986890, 0.066920, 
1.051010, -0.760800, 1.299050, 0.825840, -0.680280, -0.682820, -0.442930, -0.538630, -0.324510, 0.548460, 
0.413580, 0.946390, 0.360020, -0.288090, 1.067730, 0.292590, -0.864570, -0.152310, 0.340260, -1.883160, 
-0.406540, 0.697160, -0.005890, 1.132270, 0.813090, -1.968680, -0.769020, 0.486330, 0.352200, -0.872170, 
0.002050, 0.559980, 0.910930, 0.465620, -0.240020, 0.749710, -1.618620, 0.642950, 1.782670, -1.289780, 
-1.108970, -0.344270, -1.360120, 1.412210, -1.027830, -0.569640, 0.602900, -0.859710, 1.837450, 1.262790, 
0.134700, -0.621900, -1.539560, -0.209420, -0.368900, 0.473690, 0.995370, -0.782030, -0.138240, 0.696640, 
-0.706600, -1.893220, 0.451710, -0.101690, 0.299280, -0.551540, 0.182390, -0.388570, -2.445530, 0.541480, 
0.001050, -0.394140, -0.707750, -0.389240, -0.303510, 0.042360, 0.756220, 1.165910, 1.028810, -2.917730, 
-1.487040, 1.855560, -2.590790, 0.055880, 1.851080, -1.413970, 2.173380, 1.794070, -1.276730, -3.615060, 
0.357980, -0.389320, -1.786350, -0.097940, 2.027890, 1.283060, 0.987770, 0.279970, 0.701460, -0.131640, 
-0.888530, 0.411210, -0.374900, -0.221320, -0.738730, 0.188500, 0.954410, 0.638360, 0.516560, -0.017110, 
-0.644160, 0.550910, 0.674120, -0.044730, -0.226560, -0.153470, 0.442130, 0.153480, -0.024270, 0.708660, 
-1.344630, 0.635740, 1.966090, -1.399790, 0.372150, 0.516650, -1.138070, 0.947280, -1.316920, -0.363860, 
1.011930, -0.991750, 1.255280, 1.733380, 0.577380, 0.066700, -0.872660, -0.586220, -0.237600, 1.342110, 
0.618650, 0.298760, -0.337210, -0.187460, 0.529810, -0.358660, 0.160940, 0.286060, 0.169380, 0.390000, 
0.168730, -0.045160, -1.304080, -0.064880, 0.457850, -0.298750, -0.538260, -0.325560, 0.474430, 0.698040, 
1.035880, 0.192630, -0.138970, -0.812500, -1.212580, 0.666770, 0.066380, 0.289050, 1.038380, -0.631090, 
1.277940, 1.169560, -0.309620, -0.496290, -1.070370, -0.282940, -0.327960, -0.498750, 0.651330, 0.407390, 
0.506940, -0.443220, -0.254160, -0.766330, 0.313560, 0.472330, 0.252030, 0.119960, -0.118330, -0.350780, 
0.886170, -0.429480, -0.162490, -0.198260, -0.186140, 0.544310, 0.692710, -0.251420, -0.648390, -0.047880, 
-0.022060, -0.942160, 0.412600, 
-0.501150, -0.207220, -0.591860, -0.499610, 0.424600, 1.035720, -0.483550, -0.305880, -0.323300, -0.316190, 
0.118160, -0.047690, 0.165550, -0.029610, -0.251360, 0.240570, -0.583460, -0.297080, -0.329790, 0.221380, 
0.536080, -0.256860, 0.001080, -0.901850, -0.724500, 0.276940, 1.102940, -0.261030, -0.334640, -0.722180, 
-0.315000, 0.333990, 0.270960, 0.256440, -0.452090, -0.485310, 0.090950, -0.054430, 0.002570, -0.292990, 
0.057180, 0.564310, -0.514070, -0.207490, -0.842590, -0.556720, 0.533580, 1.111270, -0.234180, -0.247980, 
-0.524410, 0.181650, -0.051230, 0.430470, 0.245010, -0.501050, -0.683830, 0.656800, -0.081730, 0.431880, 
0.068270, -0.187190, -0.133960, -0.559620, 0.091770, -0.287560, -0.740630, 0.361880, 1.023620, -0.133010, 
-0.116800, -0.502640, 0.050910, 0.185730, 0.387640, 0.404300, -0.606550, -1.043810, 0.396200, 0.419110, 
0.398790, -0.227940, 0.088750, -0.304290, -0.339770, -0.327840, 0.221870, -0.234030, 0.274740, 0.578410, 
-0.214350, -0.108630, -0.752790, -0.088230, 0.460310, 0.189240, 0.445500, -0.648690, -0.964050, 0.593320, 
0.825950, 0.201940, -0.284840, -0.390570, -0.340380, 0.160550, -0.508380, 0.346930, 0.371470, 0.063670, 
0.074740, -0.165530, -0.401460, -1.083540, -0.020940, 0.221680, 0.158430, 1.017050, -0.430030, -0.936050, 
0.976170, 0.443400, -0.184790, -0.349230, -0.387070, -0.306430, 0.469450, -0.928520, -0.116330, 1.049800, 
-0.060240, -0.328750, -0.779330, -0.297800, -0.741590, 0.255780, 0.408740, -0.997210, 0.917810, -0.048190, 
-0.587600, -0.306590, -0.329960, 0.022290, -0.336710, -0.502800, -0.131710, 0.936470, -0.435640, -0.078800, 
1.278070, -0.238520, -0.623070, -0.534670, 0.220810, -0.557730, 0.519330, 0.699750, -0.933400, -0.924990, 
0.761480, -0.182830, -0.202420, -0.485420, 0.018780, 0.178560, -0.744900, -0.028620, 1.183330, -0.156930, 
-0.440080, 1.055920, -0.531910, -1.216480, -0.435570, 0.817940, -0.121530, 0.867240, 0.849640, -0.932570, 
-2.665820, 1.256990, 0.213070, -0.150010, -0.093350, 0.659040, 0.243980, -0.641520, -0.215690, 1.726620, 
0.285910, -1.479760, 0.162270, 0.099170, -0.947160, -0.375940, 0.480360, 0.257200, 1.340580, 0.887690, 
-0.856820, -2.625210, 1.133260, 0.567880, -0.169440, -0.326670, 0.195490, 0.661410, -0.463940, -0.128800, 
1.417910, -0.312240, -0.705670, 0.598260, -1.033300, -0.322690, 0.441060, 0.051240, 0.321790, 1.234450, 
0.729280, -0.296890, -2.287740, 1.066370, 0.557220, -0.172510, -0.324490, -0.667660, 0.390220, 0.135640, 
0.216120, 1.240730, -0.524680, -0.630380, 0.272350, -0.826590, -0.223670, 0.367580, 0.522590, 0.308400, 
1.330690, 1.090560, -0.516260, -2.297160, 0.864460, 0.821380, -0.541860, -0.653650, -0.576630, 0.158970, 
-0.005450, 0.754730, 1.222310, -0.362360, -1.004850, 0.280950, 0.323880, -0.172180, -0.015180, 0.875260, 
-0.029680, 1.361170, 0.916670, -0.490090, -1.965590, 0.599430, 0.360800, -0.656340, -0.253560, -0.039140, 
-0.340810, 0.069160, 0.879440, 
0.053490, 0.032760, 0.018360, -0.003930, 0.152450, 0.044540, -0.041770, 0.035130, -0.201000, -0.081950, 
-0.069870, 0.028540, -0.065750, 0.082550, 0.094220, -0.165460, -0.201060, 0.027440, 0.091670, 0.013050, 
-0.096400, -0.085070, -0.003710, -0.049300, 0.025100, -0.036350, 0.095620, -0.029270, -0.061650, -0.184700, 
-0.130210, 0.009590, 0.117990, -0.036370, 0.128430, 0.067530, -0.068400, -0.065480, -0.120930, 0.021960, 
-0.080480, -0.057430, -0.056640, 0.055950, -0.036760, -0.075590, -0.102250, 0.273170, -0.062940, -0.166660, 
-0.194670, 0.017940, 0.056730, 0.011640, 0.041150, -0.057570, -0.078040, -0.113460, -0.076270, -0.173900, 
0.034700, -0.063060, -0.125350, -0.062230, 0.029590, -0.136620, -0.152720, -0.167620, 0.226640, -0.008550, 
-0.152680, -0.184240, -0.013190, -0.010080, -0.006320, 0.000170, -0.007450, -0.084680, -0.042710, -0.112360, 
-0.252740, 0.001540, -0.091460, -0.211210, -0.037080, 0.080860, -0.136830, -0.103150, -0.177370, 0.215740, 
-0.014170, -0.154740, -0.049060, -0.199250, -0.084840, 0.025840, 0.007890, -0.131510, -0.122310, -0.131690, 
-0.161360, -0.398220, -0.072700, -0.011400, -0.261130, 0.067170, -0.012900, 0.016250, -0.081130, -0.252090, 
-0.035830, -0.033070, -0.174510, -0.127170, -0.175900, -0.115950, 0.087510, 0.090160, -0.134410, -0.165670, 
-0.104910, -0.342240, -0.229360, -0.111940, -0.160030, -0.264130, 0.037510, 0.026810, 0.054650, 0.121770, 
-0.021780, -0.084240, -0.029940, -0.196780, -0.132580, -0.022060, -0.065230, 0.051200, 0.092090, -0.112000, 
-0.179940, -0.042370, -0.104060, -0.222110, -0.034060, -0.114420, -0.107770, 0.027200, -0.126190, -0.206400, 
-0.099320, -0.145520, 0.183910, -0.109540, -0.371060, -0.161410, 0.013310, -0.157730, -0.020680, 0.055120, 
-0.091750, -0.071930, -0.177230, -0.164160, -0.205140, -0.084050, -0.162510, -0.184790, -0.004610, -0.181640, 
-0.145940, -0.116080, -0.022880, -0.173350, -0.147700, -0.279910, -0.138920, 0.018620, -0.039270, -0.019240, 
-0.001820, 0.120290, 0.005090, -0.301520, -0.112180, -0.221420, -0.045130, -0.095490, -0.182820, 0.076160, 
-0.158230, -0.105930, -0.261980, -0.015500, -0.105860, -0.045760, -0.178920, -0.069790, 0.075430, -0.003560, 
0.033890, 0.008500, -0.130370, -0.113300, -0.021510, 0.023670, -0.259820, 0.015970, -0.083250, -0.223160, 
0.290000, -0.098840, -0.027570, -0.100870, -0.174200, 0.067770, -0.108430, -0.267220, -0.030830, -0.060860, 
-0.044110, 0.107460, 0.042550, -0.071340, 0.010890, 0.022680, -0.175630, -0.180350, -0.014110, -0.086260, 
-0.149570, 0.414790, 0.002170, -0.070000, -0.103470, -0.069240, -0.149240, -0.033660, -0.135220, 0.079160, 
0.019250, -0.085350, 0.090400, -0.063060, -0.027490, -0.049570, -0.079580, -0.238640, -0.073420, 0.019250, 
-0.124180, -0.147340, 0.272810, -0.157690, -0.093450, -0.092360, 0.026290, -0.081920, -0.007970, 0.080090, 
-0.022850, 0.121970, -0.003770, 0.028410, -0.058300, 0.019530, 0.072890, -0.241660, -0.214520, -0.105190, 
-0.044460, 0.072940, -0.193120, 
0.393450, -0.509680, -0.289240, -0.083210, 0.211320, -0.173950, -0.367460, -0.940600, 0.080070, -0.685770, 
-0.327660, -0.358650, 0.024850, -0.148660, -0.351120, 0.227040, 0.032630, -1.102820, -0.234080, -0.249610, 
-0.433250, 0.494310, -0.207490, 0.092640, -0.002040, -0.254750, 0.079940, -0.501460, -0.770370, -0.063260, 
-0.217080, -0.391370, 0.077860, -0.109230, 0.242530, -0.552500, 0.075200, -0.240980, -0.605480, -0.408540, 
-0.402210, 0.071370, -0.337980, -0.315500, -0.064350, 0.177450, 0.077340, 0.188390, -0.279070, -0.816650, 
0.402920, -1.173410, -0.233170, 0.599350, 0.392620, -0.215340, 0.221290, 0.192140, 0.215230, -0.712740, 
-0.700160, -0.330080, -0.001940, -0.006740, -0.324800, 0.306320, -0.367270, 0.051640, 0.289520, -0.286820, 
-0.445560, 0.337610, -0.265700, -0.090080, 0.005060, 0.237230, 0.446350, 0.114430, -0.159270, -0.344080, 
-0.082380, -0.168040, -0.123340, 0.517140, 0.104190, -0.416320, 0.832320, 0.146570, -0.331260, 0.495400, 
-0.056770, -0.809120, 0.653310, -0.448250, -0.320800, 0.698420, 0.542210, -0.200660, 0.577750, 0.485910, 
0.684150, -0.639760, -0.437270, -0.354870, 0.506750, 0.886670, 0.389790, 0.253200, -1.760040, 0.545650, 
0.933510, -0.269120, 0.513190, -0.766430, 0.045190, 0.075500, -0.231560, 0.028360, 0.210380, 0.212510, 
-0.779900, 0.223670, 0.774400, 0.140120, 0.423010, 0.352630, -0.280950, -0.030660, -1.166990, 1.375090, 
-0.764680, -1.141960, -0.147550, -0.090510, 0.506840, -0.455440, -0.559680, -0.125860, -1.757310, -0.387750, 
0.597600, 0.343910, 0.686700, 0.501470, -0.332080, 0.042240, 0.090950, 0.612840, 1.140110, -3.147710, 
-0.967730, 1.550410, 0.485470, -0.072030, 1.289110, -1.508400, 1.718780, 1.359060, -1.787460, -1.238450, 
-0.910350, -0.573110, -0.853580, -0.323710, 1.931950, 0.943860, 1.238480, 0.001110, -1.565640, -0.369850, 
-0.719800, 1.280020, -0.119260, -1.754480, 0.273100, 1.282700, 0.539850, -0.137430, 0.561030, -0.737890, 
-1.300100, 0.462190, 0.725890, 0.111230, 0.863860, 0.959610, 0.279740, 0.838950, 0.277250, -0.279100, 
1.331130, -0.693330, -0.765930, 1.184560, -0.203610, -0.340380, 1.573630, -1.206200, 1.592190, 1.156760, 
-0.896740, -0.163880, -0.721700, -0.938100, -1.398000, 0.163730, 0.861060, 0.217560, -0.107510, 0.158940, 
-0.523150, -0.166260, 0.054030, 0.511520, 0.079120, -0.275840, -0.209700, -0.251890, -0.313480, -0.062970, 
-0.591770, -0.225990, 0.272640, -0.544500, 0.483760, -0.011840, 0.248570, 0.650600, 0.075090, 0.448300, 
0.421000, 0.154250, 0.253780, 0.223790, -0.826730, 0.277330, -0.271950, 0.304860, 0.602850, -0.677850, 
-0.239280, -0.424880, -0.209940, -0.014490, -0.639850, -0.032190, 0.167080, 0.272400, 0.432560, -0.222340, 
-0.137810, 0.171370, -0.626630, 0.186840, 0.433620, 0.110430, -0.562360, 0.686610, -0.248780, -0.466620, 
-0.124530, -0.686700, -0.535810, 0.362360, 0.444430, -0.141040, 0.194210, 0.321560, -0.073020, 0.202040, 
-0.209010, -0.358060, 0.203590, 
-0.049880, 0.043560, 0.310370, 0.700590, -0.629190, -0.424310, -0.291930, -0.247270, 0.976730, -0.329470, 
-0.097720, 0.738740, 0.037800, 1.020680, 0.322660, -0.533730, -0.289040, -0.467260, 0.194140, -0.661480, 
0.459760, 0.371820, -0.346780, 0.841050, 1.228000, -1.091850, -0.976170, -0.594630, -0.310680, 0.737640, 
-0.568170, 0.091620, 0.479630, 0.015080, 0.591800, 0.696240, 0.319530, -0.529580, -0.597510, 0.086680, 
-0.648590, 0.208800, 0.724510, 0.123700, 0.476350, -0.141440, 0.450410, -0.912530, 0.023240, 0.404500, 
0.124730, 0.356270, 0.137260, -0.685860, -0.523340, -0.417410, -0.437160, -0.670120, 0.072160, 0.183050, 
0.463780, 0.032100, -0.152200, 0.468310, 0.359640, -0.606820, -0.398510, -0.005420, -1.458560, -0.079520, 
0.672120, 0.276040, 0.480610, 0.467570, -1.588380, -0.322440, 0.122660, 0.320840, -1.052240, -0.641920, 
0.498040, 0.851690, 0.080770, 0.083470, 0.321080, -0.935970, 0.886050, 1.065050, -1.381850, -0.913200, 
-0.666560, -1.386480, 1.316490, -1.383880, -0.752520, 0.769730, -0.059740, 1.715100, 1.151990, 0.381960, 
-0.525790, -1.728240, -0.421740, -0.573470, 0.160580, 0.427410, -0.708000, 0.984570, 0.840660, -0.971200, 
-1.265550, 0.051710, -0.810310, 0.557520, -0.780190, 0.001380, 0.131080, -0.390170, 0.410650, 0.575900, 
0.107080, -0.710260, -1.475020, -0.666860, 0.081460, 0.190370, 0.342450, -0.143950, -0.587930, -0.437950, 
1.131500, -1.569960, 0.192330, 0.730850, -0.778210, 1.029550, 0.942990, -0.677270, -0.833330, -0.678240, 
-0.257630, -1.303570, -0.427290, 0.213270, 0.504320, 0.322110, -0.134270, -0.010420, 0.081250, 0.004000, 
0.447580, 0.194750, -0.247460, -0.480560, 0.185310, 0.455620, 0.368060, -0.184520, -0.266210, -1.809570, 
0.053120, 0.253850, -0.113040, -0.842810, -0.454390, 0.084980, -0.144280, 0.032330, 0.165060, -0.982390, 
1.068580, 1.626290, -1.285830, -0.023160, -0.089900, -1.187090, 1.332700, -1.766840, -0.667430, 0.841080, 
-0.848700, 1.522940, 0.837580, 0.595850, -0.291820, -1.561480, -0.746640, -1.038420, 0.343160, 0.358190, 
0.289870, 0.174840, -0.218040, 0.428150, -0.595070, -0.181320, -0.186990, 0.168240, -0.221500, 0.371570, 
-0.405400, -0.297910, -0.188230, -0.339870, -0.214740, -0.122020, -0.895660, -0.112910, 0.351550, 0.291510, 
-0.034230, 0.444650, -0.285790, -0.898230, 0.277580, -0.226360, -0.293800, 0.848750, -0.171750, 0.639530, 
0.833820, -0.111370, 0.115390, -0.840200, -0.751930, -0.475160, -0.687760, 0.463160, 0.184650, 0.282300, 
-0.198100, -0.311440, -0.327530, 0.378810, 0.483440, -0.131890, -0.343580, -0.217150, -0.402110, 0.948420, 
-0.783770, -0.276160, 0.105980, 0.148410, -0.319080, 0.632540, -0.100620, -0.733220, 0.262400, -0.195250, 
-0.695850, -0.073180, 0.175230, -0.272430, 0.472690, 0.455410, -0.455070, -0.782880, -0.224360, -0.506760, 
0.500670, -0.984040, 0.002860, 0.145220, -0.338200, 0.358320, 0.327190, 0.086390, 0.044090, -0.374740, 
-0.310560, -0.470030, 0.039650, 
-0.201230, -0.022190, -0.040710, -0.031070, 0.017170, -0.120250, 0.008070, 0.015780, -0.048720, -0.213010, 
-0.153810, -0.080520, 0.179120, -0.067810, 0.192440, -0.404610, -0.127950, -0.099880, 0.055160, -0.049250, 
-0.053140, -0.197800, -0.097930, -0.041400, -0.077700, -0.135780, -0.058690, -0.026720, -0.051640, -0.121490, 
-0.069860, -0.147740, 0.002020, 0.165950, -0.032760, 0.094290, -0.226430, -0.071060, -0.021380, -0.108080, 
-0.031370, 0.025620, -0.190750, -0.053670, -0.129030, -0.011740, -0.189930, 0.051900, -0.070860, -0.100100, 
-0.112070, 0.013330, -0.080010, 0.020770, 0.041980, -0.152330, -0.181650, -0.082680, -0.077450, 0.148170, 
-0.225520, -0.032760, 0.024590, -0.247380, -0.033730, -0.248830, 0.032740, -0.087880, 0.001120, -0.099950, 
-0.136850, 0.073970, -0.170890, -0.178290, -0.076830, 0.036640, -0.137590, -0.193100, -0.028000, -0.077450, 
0.114020, -0.184350, -0.097370, -0.104170, -0.313120, -0.120930, 0.055520, -0.025820, -0.240870, 0.069700, 
0.030240, -0.033630, 0.089350, -0.442750, -0.268750, 0.179100, 0.058070, -0.183580, -0.165910, -0.122760, 
-0.178310, -0.058510, -0.212160, -0.005800, -0.120490, -0.429670, 0.015570, 0.201290, -0.393590, -0.236570, 
0.183710, 0.022310, 0.133580, -0.123290, -0.426110, -0.298340, 0.288860, 0.503730, -0.310240, -0.123890, 
-0.363240, -0.326840, 0.155310, -0.191730, -0.096490, -0.157250, -0.583850, 0.143350, 0.634740, -0.402700, 
-0.268410, 0.233110, -0.032180, -0.116680, 0.131490, -0.726360, -0.509710, 0.364700, 0.763020, -0.101640, 
-0.196150, 0.043000, 0.135250, 0.016480, -0.162770, -0.133420, -0.062660, -0.436460, -0.252150, 0.204530, 
-0.327180, -0.287800, 0.051460, -0.188470, -0.359090, -0.170650, -0.502330, -0.460050, 0.188780, 1.218750, 
-0.263440, -0.259720, -0.047900, 0.015970, 0.272120, -0.228540, -0.161890, -0.179310, -0.443120, -0.297020, 
0.289880, -0.072150, -0.163370, 0.004780, -0.148000, -0.461600, -0.210660, -0.430820, -0.436930, 0.132630, 
0.872550, -0.165200, -0.163220, -0.014310, -0.005590, -0.056640, -0.126380, -0.166250, -0.253810, -0.340320, 
-0.162890, 0.148610, 0.149420, -0.107650, -0.140030, -0.074060, -0.149490, -0.125490, -0.376200, -0.238240, 
0.059160, 0.259410, -0.189410, -0.300570, 0.125220, 0.172500, -0.049610, -0.029180, -0.204290, -0.275040, 
-0.077440, -0.201500, 0.148840, 0.103060, 0.091890, -0.032570, -0.155160, -0.125830, -0.111560, -0.332210, 
-0.262840, 0.128370, 0.057140, -0.111910, -0.041950, 0.110260, 0.003480, 0.096740, -0.036400, -0.140730, 
-0.267620, 0.119980, -0.016590, 0.144160, 0.101770, 0.143130, -0.037920, -0.014050, -0.106770, 0.025850, 
-0.221770, -0.194770, -0.053620, -0.096460, 0.015100, -0.011680, -0.030390, 0.034430, -0.104450, 0.085580, 
-0.057710, -0.199310, 0.062100, -0.018870, 0.207530, -0.012360, 0.150570, 0.109720, -0.056030, 0.105900, 
-0.010480, -0.148660, -0.040590, 0.098580, 0.059350, -0.145380, 0.074290, -0.183930, 0.020600, -0.002450, 
-0.075210, 0.020910, -0.251390, 
-0.010130, 0.005800, 0.014640, 0.019440, 0.080180, 0.001160, -0.040190, -0.021050, -0.167370, -0.116300, 
-0.042140, 0.026890, -0.066310, 0.044760, 0.057080, -0.131770, -0.163150, -0.014190, 0.064720, -0.015490, 
-0.122730, -0.095150, -0.001450, -0.031780, 0.029380, -0.035800, 0.037240, -0.039270, -0.067220, -0.171940, 
-0.090760, -0.004630, 0.034920, -0.044370, 0.073470, 0.009850, -0.071510, -0.065100, -0.105480, 0.004360, 
-0.062850, -0.080450, -0.043560, 0.008440, -0.083610, -0.079460, -0.059680, 0.114980, -0.068610, -0.120800, 
-0.154710, -0.003230, 0.023240, -0.024980, 0.001520, -0.018190, -0.077220, -0.117570, -0.073550, -0.154280, 
0.013130, -0.068950, -0.141100, -0.092340, -0.014520, -0.112620, -0.077230, -0.128690, 0.107680, -0.038660, 
-0.139110, -0.128450, -0.064750, -0.021230, -0.023140, -0.048890, 0.004250, -0.064030, -0.039780, -0.142220, 
-0.208250, -0.008110, -0.092390, -0.219260, -0.023630, 0.037550, -0.115090, -0.070940, -0.140030, 0.029340, 
-0.043770, -0.136960, -0.043360, -0.178280, -0.075530, -0.019370, -0.037570, -0.087890, -0.118310, -0.128020, 
-0.150260, -0.307290, -0.058540, -0.050200, -0.247180, 0.023360, -0.048090, -0.010630, -0.096870, -0.186730, 
-0.082000, -0.071830, -0.127600, -0.114980, -0.174200, -0.101150, 0.022270, 0.043680, -0.089890, -0.126180, 
-0.098690, -0.246180, -0.182350, -0.100640, -0.161740, -0.263500, 0.028570, -0.002380, -0.013570, 0.027660, 
-0.012550, -0.088560, -0.037740, -0.159560, -0.125980, 0.005360, -0.047660, 0.007020, 0.044030, -0.050450, 
-0.119730, -0.078440, -0.134550, -0.167910, -0.027350, -0.087570, -0.129320, -0.036370, -0.140740, -0.179350, 
-0.147980, -0.135150, 0.051820, -0.077730, -0.278650, -0.134970, -0.052940, -0.107900, -0.023690, 0.010230, 
-0.072300, -0.070890, -0.123910, -0.145330, -0.169250, -0.061790, -0.104600, -0.202410, -0.035820, -0.156490, 
-0.157310, -0.109670, -0.048040, -0.157320, -0.100780, -0.220100, -0.121030, -0.039010, -0.051740, -0.074440, 
-0.084050, 0.090620, -0.038600, -0.217170, -0.121860, -0.194370, -0.024410, -0.068840, -0.211540, 0.013070, 
-0.137160, -0.118880, -0.216600, -0.032910, -0.119630, -0.062120, -0.164410, -0.074000, -0.008010, -0.008750, 
-0.000950, -0.050220, -0.103300, -0.069400, -0.030650, -0.033970, -0.244800, -0.003750, -0.050530, -0.192730, 
0.176400, -0.070010, -0.059290, -0.092270, -0.137700, 0.038250, -0.085250, -0.223620, -0.033420, -0.087640, 
-0.022340, 0.035540, -0.028670, -0.081470, -0.012950, -0.019880, -0.146290, -0.193730, -0.024760, -0.075040, 
-0.152330, 0.294760, -0.006170, -0.143960, -0.058140, -0.052530, -0.120530, -0.042760, -0.103640, 0.029090, 
-0.047360, -0.052920, 0.001310, -0.085220, 0.002690, -0.012370, -0.090560, -0.185530, -0.130060, 0.000560, 
-0.106260, -0.147440, 0.152430, -0.099010, -0.129730, -0.061870, 0.024590, -0.078080, -0.011330, 0.022690, 
-0.023060, 0.031160, 0.003530, -0.020360, -0.067270, 0.019850, 0.068000, -0.179430, -0.171060, -0.133390, 
-0.047780, 0.000760, -0.198370, 
-0.467430, 0.074190, 0.547390, -0.526170, 0.305210, 0.925130, 0.382020, 0.092400, -0.281570, -0.258730, 
-0.429720, -0.657270, 0.639400, -0.549640, -0.777460, -0.092000, 0.588550, 0.222180, -0.709910, -0.482810, 
0.603470, -1.256940, 0.182510, 1.331110, -0.096880, 0.301360, 0.431860, 0.577480, -0.434070, -0.394800, 
-1.193040, -0.540600, -0.313470, 0.455470, -0.115720, -0.493910, 0.465080, 0.063600, -0.247960, -0.965820, 
-0.336880, 0.781880, -1.222270, 0.041940, 0.568190, -0.467360, 0.091510, 0.115390, 0.309670, -0.283410, 
-0.374200, -1.567520, -0.154830, 0.191830, 1.092740, -0.349020, -0.138040, -0.094100, -0.145460, -0.258880, 
-0.957170, 0.186500, 0.694860, -1.171110, -0.114220, 0.930310, -1.144680, 0.172560, 0.310210, 0.649540, 
-0.039500, -0.942850, -0.655420, -0.357420, 0.096890, 1.092750, -0.682720, -0.475930, -1.034520, -0.487930, 
-0.474880, -0.694590, -0.143280, 0.533330, -0.868120, 0.380760, 0.168980, -0.913150, -0.610530, -0.497050, 
0.077520, -0.445320, -0.811050, -0.481710, -0.303020, -0.240740, 1.186060, -0.719300, -0.353370, -0.424710, 
0.331850, -0.393570, -0.745540, -0.084510, -0.025270, -0.587070, -0.251490, 0.522410, 0.095540, -0.915620, 
-0.421990, 0.349290, -2.325170, -0.701050, -0.865190, -0.710270, 0.173880, 0.862880, -0.371640, 0.009300, 
0.358390, 0.502720, -0.500490, -1.136690, -0.481040, -0.270470, 0.494310, -0.480240, 0.704070, 1.037310, 
-0.581670, 0.051700, 0.148370, -1.656690, 0.604290, -0.850410, 0.174870, 0.522440, 0.273470, 0.228210, 
0.503750, 0.428490, 0.112190, -0.586180, -0.534840, -0.680190, -0.255830, -0.292990, -0.017410, 0.336070, 
0.265360, -0.466560, -0.108240, -0.150850, -1.471060, -0.431340, -0.710550, -0.143720, -0.310990, 0.950640, 
0.046040, -0.172120, -0.574150, -0.759380, -1.316750, -0.514530, -0.071540, -0.793120, -0.675630, 0.344350, 
0.202850, 0.072700, -0.358490, 0.393100, 0.318340, -0.751250, -0.366390, -0.842780, -0.406060, -0.330520, 
0.374620, -0.540580, 0.326060, -0.652480, -0.458750, -1.231320, -0.357550, -0.327650, -0.807600, -0.800720, 
0.184710, -0.418570, -0.096370, -0.121040, 0.810150, 0.213420, -0.112810, -0.107780, -0.438160, -0.295480, 
0.198970, 0.288670, -0.549080, 0.110570, -0.652590, 0.409640, -0.398240, -0.737730, -0.479300, -0.278730, 
-0.391110, 0.344820, 0.296950, -0.574620, -0.390640, 0.559720, 0.072150, -0.578680, -0.299380, -0.594690, 
-0.412480, 0.420870, 0.982240, 0.151640, -0.423440, -0.189570, 0.150640, -0.571100, 0.193600, -0.319420, 
-0.298980, -0.309130, 0.602510, 0.381880, -0.377440, -0.727360, 0.335110, 0.170090, -0.658460, -0.321060, 
-0.873570, -0.524630, 0.678070, 1.152980, 0.127730, -0.778360, -0.270040, 0.152050, -0.603420, 0.340540, 
0.163360, -0.036100, 0.136960, 0.314840, -0.198940, -0.047300, -1.070310, 0.095970, 0.183390, -0.368720, 
-0.202010, 0.156590, -0.350850, 0.287490, 0.857480, 0.160420, -0.842930, -0.267900, -0.080030, -0.642770, 
0.745860, 0.162610, -0.268840, 
-0.626730, 0.237280, 0.421950, -0.284530, -0.502060, 0.633600, 0.250080, -0.313940, 0.517670, -0.689760, 
-0.974380, -0.191580, -0.459800, -0.413910, -0.062800, 0.363650, -0.399580, -0.239050, -0.727390, -0.132930, 
1.085120, -1.294710, 0.390020, 0.034960, -0.317230, -0.021860, 0.161130, -0.138760, 0.460630, -0.071130, 
0.074470, -0.527640, 0.004920, 0.300810, 0.184500, -0.294350, -0.300220, -0.278930, 0.140030, 0.288120, 
-0.132150, 0.613040, -0.858690, 0.003290, 0.157170, -0.486540, 0.077900, 0.122780, 0.071050, 0.243510, 
0.119950, -0.231470, -0.167600, -0.415030, -0.228250, -0.108610, 0.051400, 0.118000, 0.072520, 0.284260, 
0.194500, 0.379640, 0.140290, 0.834840, -0.027300, -0.814970, -0.538630, 0.621620, -0.543090, 0.323320, 
0.976240, -0.947200, 0.372440, 0.437640, -1.501220, -0.128190, 0.115740, -0.075930, -0.900040, -0.201460, 
1.177830, 0.894160, 0.494820, -0.147830, -0.078410, 0.080890, -1.421930, 0.865960, 0.224120, -1.154760, 
0.311740, 1.031030, -0.070520, 0.071510, 0.073540, -1.297590, -0.630490, 0.463750, -0.138030, 0.283190, 
0.807560, 0.851410, -0.009300, 0.720690, -0.392220, 0.524640, 0.662440, -1.603060, -0.166400, 1.504450, 
-0.739260, 0.185990, 1.851960, -0.696700, 1.241910, 0.965770, -1.761450, -2.394160, 0.078440, -0.868250, 
-0.576170, -0.555460, 1.720690, 0.756090, 0.907280, -0.516730, -1.968540, -0.202440, 0.558300, 1.511940, 
-0.126770, -2.426020, -0.017390, 0.217260, 0.216800, -0.764060, -0.297080, -0.415290, -0.856880, 0.623670, 
0.330450, 0.322310, 0.529770, 0.018390, 0.289740, 0.113510, -0.541660, 0.496580, 0.798590, 0.169960, 
-1.063480, 0.645260, -0.175060, 0.057560, 0.662290, -0.745770, 1.077040, 0.215010, -0.254360, 0.515800, 
0.082240, -0.532300, 0.293350, -0.660100, 0.486110, -0.088300, 0.027630, -0.547370, 0.333900, -0.091370, 
1.245910, 1.190880, -1.532010, 0.260980, 0.173010, -0.981010, -0.119620, -1.316330, -0.496650, 0.587500, 
0.696200, 0.419420, 0.400050, 0.690980, 0.509170, -0.802740, -0.008820, 0.056630, 0.150130, 0.107220, 
-1.058960, 0.693140, -0.521760, -0.149490, 0.726010, 0.290480, -0.679230, 0.023660, -0.651690, -0.383280, 
0.650110, 0.455480, -0.404500, -0.513790, 0.621060, 0.055960, -0.517890, -0.008200, -0.144220, 0.005360, 
-0.119720, -0.134110, 0.796500, -0.584350, -1.221300, 1.036760, 0.258530, -1.230490, 0.731610, -1.301420, 
-0.121730, 0.775690, -0.159410, -0.041660, -0.606570, 0.314230, 0.103210, -1.108500, 0.038460, -0.501410, 
0.316050, -0.754060, 0.162410, -0.186480, 0.034670, -0.803300, 0.540370, 0.214440, -0.882820, 0.253400, 
-0.911040, -0.283720, 0.253330, -0.319660, -0.344090, -0.418560, -0.011540, 0.702550, -0.300140, -0.134160, 
0.059720, -0.009210, 0.088450, -0.380030, -0.317510, -0.062100, -0.946630, 0.201670, -0.386340, -0.622100, 
0.105740, 0.023430, -0.244870, -0.588540, -0.231390, -0.080920, -0.068720, -0.049640, 0.469830, -0.363230, 
0.441670, -0.136700, 0.146370, 
-0.356280, -0.050060, 0.036360, 0.187450, -0.017980, 0.089880, -0.033250, -0.004680, -0.188880, -0.521180, 
-0.024200, 0.032180, -0.041240, 0.011560, -0.050740, -0.193090, -0.137510, 0.024130, -0.063420, -0.044040, 
-0.233140, -0.355040, -0.042520, -0.081210, -0.013410, -0.260750, 0.088620, -0.013020, -0.064800, -0.428200, 
0.035560, -0.095950, -0.062610, -0.046310, -0.080640, -0.150960, -0.088240, 0.020240, 0.221950, -0.007600, 
-0.134580, -0.160170, -0.009380, -0.077150, -0.265860, -0.261040, -0.039560, -0.039640, -0.181060, 0.113830, 
-0.220720, 0.183420, -0.170010, -0.085380, -0.107730, -0.232860, -0.168750, -0.248860, 0.002620, 0.248090, 
-0.035090, -0.201060, -0.287180, -0.244590, -0.154050, -0.324240, -0.022180, -0.195910, -0.136970, -0.122180, 
0.062310, -0.057250, -0.017900, -0.218580, -0.139400, -0.185700, -0.118500, -0.074980, -0.041960, -0.093210, 
0.316110, -0.178530, -0.241310, -0.517460, -0.197020, -0.127770, -0.059030, -0.018250, -0.147190, -0.148160, 
-0.145280, -0.010150, 0.042600, -0.470970, -0.227440, -0.026430, -0.200930, -0.170740, -0.151410, -0.180110, 
-0.067420, 0.064040, -0.264520, -0.091540, -0.526830, -0.279070, -0.155430, -0.012700, -0.444100, -0.157730, 
-0.036100, -0.161440, 0.075970, -0.074090, -0.291380, -0.192820, 0.034670, -0.013210, -0.151440, -0.159910, 
-0.245720, -0.212310, 0.130400, -0.250280, -0.088780, -0.495370, -0.083690, 0.102490, 0.054280, -0.397180, 
-0.135790, 0.239860, 0.001680, -0.160050, 0.089920, -0.246590, -0.152360, 0.031370, 0.280890, -0.081580, 
-0.052960, -0.123220, 0.013380, 0.081530, -0.016800, -0.089250, -0.128030, -0.365130, -0.319950, -0.116390, 
-0.526410, -0.342130, -0.027060, -0.160390, -0.369200, -0.127210, -0.223980, -0.294850, -0.035060, 0.229940, 
-0.142330, -0.128670, -0.073820, -0.079670, 0.097920, -0.070590, -0.127990, -0.466950, -0.230140, -0.402120, 
-0.131280, 0.162200, -0.433420, 0.196300, -0.177560, -0.530960, -0.100940, -0.582530, -0.364040, -0.153770, 
-0.091220, 0.169020, -0.146010, 0.002860, -0.065040, -0.252920, -0.027610, -0.146810, -0.487520, -0.288240, 
-0.263920, -0.101670, 0.104580, -0.257050, -0.066460, -0.191410, -0.448070, 0.001770, -0.276700, -0.239790, 
-0.262130, -0.021720, -0.040290, -0.112280, 0.265630, 0.051700, -0.394100, 0.034460, -0.181640, -0.422340, 
-0.037940, -0.061930, 0.009950, -0.021750, -0.060820, 0.003730, -0.201620, -0.193310, -0.133030, -0.217870, 
-0.108410, -0.168410, -0.200040, -0.023980, 0.032890, 0.089870, -0.213560, -0.249230, -0.040230, -0.169360, 
-0.391470, 0.337570, 0.019700, -0.179530, 0.161520, 0.134580, -0.315550, -0.135980, -0.160410, -0.057450, 
-0.145090, -0.033950, -0.162780, -0.207740, 0.008050, 0.121600, -0.201270, -0.202140, -0.213280, 0.024380, 
-0.119310, -0.412030, -0.110630, 0.030940, -0.079370, 0.216220, 0.163490, -0.061730, 0.001530, -0.085920, 
-0.032660, -0.041960, -0.182110, -0.124230, -0.109770, -0.005590, 0.264180, -0.224820, -0.240780, -0.090200, 
-0.022750, -0.144430, -0.519560, 
0.014080, 0.007440, 0.020720, -0.043380, 0.023470, -0.029930, -0.012380, -0.011640, -0.114150, -0.043180, 
-0.016330, 0.001450, -0.068650, 0.014830, 0.030180, -0.091130, -0.097510, -0.051950, 0.064480, 0.031400, 
-0.103760, -0.008500, -0.016070, -0.039780, -0.032230, -0.004860, 0.008350, -0.000150, -0.029530, -0.122230, 
-0.056750, -0.010700, 0.013190, 0.003070, 0.020360, -0.017350, -0.034000, -0.040590, -0.115100, -0.025490, 
0.015930, -0.111910, 0.025080, 0.016340, -0.023200, -0.047220, -0.049370, 0.032770, 0.002380, -0.082900, 
-0.151250, -0.048120, 0.047640, -0.006540, 0.030190, -0.017170, -0.063490, -0.064220, -0.014310, -0.130450, 
0.000230, -0.019440, -0.114620, 0.003110, 0.033310, -0.056410, -0.062060, -0.056390, 0.059190, -0.027840, 
-0.100990, -0.107820, -0.077560, 0.042170, -0.025460, -0.000380, -0.020410, -0.065460, -0.012200, -0.053830, 
-0.170820, 0.032160, -0.011380, -0.147890, 0.043050, 0.016590, -0.069470, -0.026320, -0.051910, 0.040580, 
-0.042480, -0.053980, -0.061450, -0.114820, 0.006260, -0.019250, -0.050920, -0.035260, -0.076840, -0.082400, 
-0.137660, -0.162440, 0.028890, -0.008310, -0.162930, 0.047310, -0.007760, 0.043630, -0.024950, -0.114380, 
-0.123190, -0.072060, -0.063860, -0.082840, -0.108570, -0.053170, 0.005380, -0.047730, -0.041600, -0.071470, 
-0.081660, -0.166280, -0.115730, 0.018650, -0.077490, -0.175890, 0.035940, 0.005830, -0.086400, 0.012260, 
0.004680, -0.210650, -0.062460, -0.001590, -0.123310, -0.015730, -0.046360, -0.077460, -0.075700, 0.017850, 
-0.142740, -0.154660, -0.163110, -0.103700, 0.041630, -0.043670, -0.210050, 0.033730, -0.032520, -0.081990, 
0.019570, 0.002670, -0.103320, -0.055430, -0.118400, -0.093000, -0.009070, -0.007830, -0.039690, -0.151440, 
-0.003100, -0.090580, -0.133440, -0.143970, -0.078380, -0.010320, -0.011330, -0.151270, -0.002810, -0.031080, 
-0.103400, -0.138850, 0.117860, -0.107390, -0.015490, -0.095460, -0.089000, 0.063760, 0.056330, -0.042510, 
-0.118250, 0.057750, -0.043430, -0.218590, -0.130780, -0.088530, 0.007800, 0.009050, -0.140000, 0.074840, 
-0.031960, -0.093920, -0.176740, 0.044330, -0.097750, -0.005140, -0.020230, -0.038560, 0.058060, 0.057110, 
-0.007920, -0.105590, -0.002500, -0.047310, -0.133090, -0.059140, -0.137980, 0.008390, -0.006940, -0.130180, 
0.114340, -0.090030, -0.104210, -0.091030, 0.006680, 0.004520, -0.026980, -0.083340, -0.047650, 0.059750, 
0.017420, 0.041740, -0.056940, -0.019530, -0.003400, -0.087900, -0.098500, -0.096890, -0.003650, -0.039730, 
-0.125670, 0.172540, -0.055590, -0.134350, -0.094460, -0.014600, -0.045670, -0.014210, -0.033310, 0.030270, 
0.003270, -0.008080, -0.010520, -0.060450, 0.050280, -0.037000, -0.102930, -0.125780, -0.117440, 0.008070, 
-0.062690, -0.109190, 0.084230, -0.054670, -0.107310, -0.060990, -0.002330, -0.028130, -0.039470, 0.036140, 
-0.028000, 0.052990, 0.067790, 0.033780, -0.033580, -0.010100, 0.006180, -0.152920, -0.103110, -0.134170, 
-0.034960, -0.017870, -0.102230, 
-0.457420, -0.026730, 0.141130, -0.025540, 0.072160, -0.189930, 0.098720, -0.186870, -0.172780, -0.137550, 
-0.079580, -0.131780, 0.187010, 0.137110, -0.190680, 0.114420, -0.181090, -0.253260, -0.102840, -0.275900, 
0.487620, -0.495470, -0.055080, 0.161930, 0.295420, 0.052700, -0.454250, 0.040860, -0.425090, -0.068000, 
-0.528810, -0.036220, -0.077170, 0.204120, 0.119490, -0.172340, 0.173910, -0.204610, -0.480770, -0.171260, 
-0.264280, 0.532750, -0.445020, -0.214130, 0.133150, -0.039270, -0.022310, -0.217570, -0.075540, -0.368490, 
0.011870, -0.572040, 0.036310, -0.079390, 0.255290, -0.023580, -0.086390, -0.202090, -0.382970, -0.599290, 
-0.180110, -0.070430, 0.432440, -0.473520, -0.365340, 0.032040, 0.060850, -0.150560, -0.159510, 0.047710, 
-0.410830, -0.132060, -0.435000, -0.171690, -0.334480, 0.154700, 0.066380, -0.248110, -0.284400, -0.494730, 
-0.553430, -0.320270, -0.227820, 0.247020, -0.333120, -0.119300, -0.018710, -0.059350, -0.172940, -0.638480, 
-0.236750, -0.474090, -0.252760, -0.167100, -0.182600, -0.275100, 0.245080, -0.095980, -0.152030, -0.507070, 
-0.324460, -0.741920, -0.326650, -0.234110, 0.137130, -0.210140, -0.278070, 0.137970, -0.078960, -0.362480, 
-0.478760, -0.117140, -0.814410, -0.367000, -0.295620, -0.249000, -0.160640, 0.363360, -0.144810, -0.228870, 
-0.138640, -0.358420, -0.506320, -0.570490, -0.426800, -0.067810, 0.139800, -0.163730, 0.131350, 0.281830, 
-0.123790, -0.304690, -0.026250, -0.618370, -0.196000, -0.077060, 0.095000, 0.160070, 0.329910, -0.015650, 
0.222350, 0.111180, -0.015590, -0.528660, -0.342130, -0.135890, 0.332600, -0.491020, -0.287090, -0.160890, 
-0.410950, -0.332450, -0.241880, 0.007810, -0.750980, -0.449540, -0.705960, -0.298790, -0.190030, 0.631770, 
-0.154070, -0.079540, 0.103830, -0.301800, -0.776260, -0.272200, -0.278170, -0.292820, -0.604910, -0.194740, 
-0.137240, -0.193520, -0.476710, -0.244260, 0.009160, -0.556730, -0.513400, -0.251010, -0.293870, -0.384080, 
0.202970, -0.350470, -0.134920, 0.104040, -0.444630, -0.560990, -0.250770, -0.353640, -0.218270, -0.474740, 
-0.194310, -0.204030, -0.332870, -0.398070, 0.221430, -0.098300, -0.535870, -0.333460, -0.163820, -0.300290, 
-0.005310, 0.140660, -0.441120, -0.150240, 0.082000, -0.111250, -0.411120, -0.345270, -0.228380, -0.043830, 
-0.189280, 0.166110, -0.002060, -0.419690, -0.572970, 0.077840, -0.181310, -0.607090, -0.259110, -0.545920, 
-0.040920, 0.081410, 0.346290, -0.100800, -0.128780, -0.136550, -0.229740, -0.219360, -0.139920, -0.212730, 
0.059210, -0.234300, 0.279700, -0.380680, -0.349110, -0.390160, -0.092170, -0.020460, -0.395320, -0.328310, 
-0.462900, -0.228930, 0.201860, 0.116690, 0.103190, -0.235280, -0.235050, -0.072510, -0.186860, 0.021200, 
0.036150, 0.341610, 0.056990, -0.162590, -0.120980, -0.052090, -0.368850, 0.156360, 0.050090, -0.277370, 
-0.202710, -0.391220, -0.286730, 0.057760, 0.005500, 0.179020, -0.254400, -0.244190, -0.085210, -0.592510, 
0.117080, -0.000820, 0.281430, 
-0.130830, -0.061130, -0.056760, 0.144840, 0.135810, -0.016210, -0.100760, -0.005210, -0.218320, -0.274240, 
-0.042580, 0.014790, -0.048080, 0.092360, 0.087350, -0.124340, -0.218850, -0.001960, 0.005270, -0.056370, 
-0.128120, -0.243960, 0.004720, -0.123180, 0.151560, -0.199130, 0.014430, -0.044450, -0.197950, -0.269890, 
-0.092980, -0.070040, 0.147200, -0.033090, 0.042040, -0.013200, -0.141830, -0.141970, -0.074730, 0.017860, 
-0.070850, -0.027700, -0.116000, -0.035880, -0.138100, -0.142040, -0.196440, 0.233580, -0.143540, -0.212640, 
-0.114180, 0.070530, -0.062600, 0.034240, -0.031370, -0.098090, -0.075600, -0.230920, -0.212210, -0.167430, 
-0.006810, -0.122670, -0.105100, -0.233000, -0.113480, -0.261940, -0.096260, -0.334430, 0.224400, -0.003660, 
-0.278800, -0.085020, -0.053260, -0.188920, -0.112940, -0.083210, 0.013450, -0.038500, -0.063610, -0.195360, 
-0.217040, -0.209470, -0.212380, -0.321060, -0.124890, -0.054930, -0.104390, -0.149290, -0.302410, 0.030220, 
-0.042410, -0.343600, 0.075740, -0.510190, -0.230590, 0.068220, -0.026440, -0.186620, -0.091810, -0.136020, 
-0.198060, -0.500540, -0.256430, -0.080940, -0.362720, -0.099300, -0.188050, 0.019890, -0.269190, -0.339700, 
0.023230, -0.083200, -0.257100, -0.092710, -0.428740, -0.264280, 0.093480, 0.244080, -0.188740, -0.218250, 
-0.209110, -0.350040, -0.212410, -0.365070, -0.171710, -0.372930, -0.073200, -0.010900, 0.145190, -0.152950, 
-0.068340, 0.245230, -0.000620, -0.274930, -0.013310, -0.143050, -0.110990, 0.146030, 0.418340, -0.223270, 
-0.078170, -0.065670, -0.096480, -0.094240, -0.177320, -0.073100, 0.072710, -0.387990, -0.387930, -0.289610, 
-0.536770, -0.371510, 0.216210, -0.103250, -0.566300, -0.143780, -0.228580, -0.364450, -0.043450, 0.465850, 
-0.249840, -0.059590, -0.124370, -0.095360, -0.076100, -0.124700, -0.278500, -0.362680, -0.292070, -0.475390, 
-0.177030, -0.103270, -0.378370, -0.177580, -0.220700, -0.530220, -0.236670, -0.236990, -0.285520, -0.057460, 
0.169730, 0.075920, -0.022130, -0.228840, -0.064390, -0.277830, -0.041990, -0.176900, -0.378970, -0.243100, 
-0.352990, -0.087770, -0.165280, -0.202650, -0.103320, -0.171580, -0.429320, -0.076140, -0.041670, -0.217530, 
-0.055170, 0.164780, -0.255810, -0.161250, 0.181240, 0.071570, -0.324050, -0.068410, -0.181300, -0.368170, 
0.110170, -0.050980, 0.181940, -0.044120, -0.271560, 0.059250, -0.213830, -0.408990, -0.080280, -0.352540, 
-0.120620, -0.011490, 0.022420, -0.099560, 0.048690, 0.116400, -0.188760, -0.349760, -0.133660, -0.105500, 
-0.300010, 0.370540, 0.109310, -0.017910, -0.009230, -0.015810, -0.327870, -0.059010, -0.196570, -0.007410, 
-0.102850, -0.145520, 0.037070, -0.071410, -0.044490, 0.028120, -0.170400, -0.315660, -0.167350, -0.000060, 
-0.133140, -0.268820, 0.193310, -0.125880, -0.069530, 0.021600, 0.060270, -0.077650, 0.074580, -0.019480, 
-0.005720, -0.091290, -0.197630, 0.043700, -0.046840, 0.047440, 0.168010, -0.324630, -0.279970, -0.158760, 
-0.009550, 0.038250, -0.349420, 
-0.319510, -0.411620, -0.330500, 0.689300, -0.143450, -0.220610, -0.409870, -0.168000, -0.119780, 0.352680, 
0.005360, 0.169000, 0.003070, 0.211360, -0.397240, 0.366140, 0.221090, -0.223760, -0.105190, -0.360670, 
-0.337870, 0.312540, -0.038140, -0.156770, -0.449250, 0.162140, -0.583730, -0.388620, -0.037850, -0.224000, 
0.221460, 0.233670, -0.156520, 0.176420, -0.281140, -0.235590, -0.217870, -0.287570, -0.282150, 0.214430, 
-0.061030, -0.218230, -0.163160, -0.402130, -0.243150, -0.213510, -0.280700, 0.099860, -0.242120, -0.298750, 
-0.025930, -0.312540, -0.105490, 0.081430, -0.008790, -0.149970, -0.214130, 0.087780, -0.270120, -0.464960, 
-0.099980, -0.092280, -0.439380, -0.162010, -0.432860, -0.241040, 0.033050, -0.149410, -0.254240, -0.082340, 
-0.440530, 0.140840, -1.284100, -0.338480, -0.371390, -0.141340, -0.094790, 0.367480, -0.245150, -0.091850, 
-0.681380, -0.645660, -0.041020, -0.653210, 0.092880, -0.863650, 0.469160, -0.382080, -0.461170, -0.123450, 
-0.181100, -1.083730, -0.226550, -0.689890, -0.162390, 0.171990, 0.211910, -0.209010, -0.273170, -0.185930, 
-0.510090, -0.770870, -0.740420, -0.684700, -0.386930, 0.000880, -0.397850, -0.436850, -0.962240, -0.069840, 
-0.563020, -0.469280, -0.245480, -0.627170, 0.601500, 0.106770, -0.481400, 0.053670, -0.376730, -0.912120, 
-0.665270, -0.049550, -0.051650, -0.665350, -0.506750, -0.666120, -0.565120, -0.409240, 0.564750, -0.689190, 
0.027410, 0.314090, 0.169890, -0.995020, -0.849000, 0.533700, -0.237960, 0.542930, 0.660540, -0.492140, 
-0.322210, 0.996470, 1.004230, -0.315010, -0.348320, -0.471540, 0.593460, -0.403940, -1.121690, -0.507470, 
0.110530, -0.757020, -1.054560, -0.230710, -0.811400, -0.639580, -0.207930, -0.739520, -0.485550, 0.740690, 
-0.080840, -0.514270, 0.714630, -0.077730, -0.615470, -0.271990, -0.952640, -0.380700, -0.236000, -0.906820, 
0.428130, 1.299480, -0.943890, -0.180270, -0.392920, -1.315480, -0.507690, -0.714860, -0.906510, -0.277540, 
0.559160, -0.127590, -0.805090, 0.729370, -0.418880, -1.481580, -0.565710, -1.283770, -0.135210, -0.139830, 
-0.262380, 0.691140, 1.287080, -1.112660, -0.453360, -0.450550, -1.102520, -0.223910, -0.517330, -0.600600, 
-0.144770, -0.284950, 0.554390, -0.366280, -0.307070, -0.586690, -1.002430, -0.275230, -0.839280, 0.289820, 
-0.170890, 0.256820, 0.255130, 0.266850, -0.475520, -1.264880, -0.176560, -0.200600, -0.455730, -0.293320, 
-0.111000, -0.474710, -0.253110, 0.051630, 0.361930, -0.441970, 0.011080, -0.546120, -0.148110, 0.028000, 
0.138100, -0.244910, -0.181240, -0.171740, -0.144580, -0.633910, -0.217310, 0.127830, 0.008620, -0.126430, 
0.128300, 0.109670, -0.005680, -0.190480, 0.282600, 0.122000, -0.356760, -0.159440, -0.533030, -0.195220, 
0.164940, 0.474080, -0.305470, 0.141370, -0.010590, 0.531270, -0.584860, -0.461420, -0.024260, -0.490910, 
0.627940, -0.858780, -0.457630, 0.192420, 0.082790, 0.583700, 0.135050, 0.248960, 0.460710, -0.569380, 
-0.039330, -0.533420, 0.517830, 
-0.306220, -0.065100, -0.047320, 0.173920, -0.043120, 0.069490, -0.066730, -0.021540, -0.214690, -0.412890, 
0.002610, -0.006250, -0.083490, 0.034420, -0.054260, -0.125080, -0.121690, 0.006030, -0.053520, -0.030690, 
-0.225950, -0.311430, -0.030480, -0.113610, 0.002430, -0.207160, 0.045970, -0.042250, -0.090570, -0.337070, 
0.052630, -0.069440, -0.075800, -0.067420, -0.018600, -0.143450, -0.155970, -0.036110, 0.092640, 0.026850, 
-0.101580, -0.148100, -0.057780, -0.074370, -0.197680, -0.221610, -0.098620, -0.053350, -0.181290, 0.042610, 
-0.143710, 0.069060, -0.150500, -0.066940, -0.106330, -0.145700, -0.106910, -0.198680, -0.017200, 0.109940, 
-0.025510, -0.248640, -0.257160, -0.230390, -0.141020, -0.322070, -0.032080, -0.205780, -0.117150, -0.113100, 
-0.044160, -0.021160, -0.030390, -0.193390, -0.109360, -0.178110, -0.095380, -0.060890, -0.033550, -0.102650, 
0.132350, -0.196130, -0.249980, -0.478870, -0.182150, -0.107540, -0.103020, -0.073150, -0.156710, -0.130910, 
-0.130920, -0.048870, 0.019720, -0.435760, -0.230860, -0.030820, -0.211270, -0.140070, -0.110360, -0.193380, 
-0.091620, -0.013730, -0.237770, -0.109340, -0.471930, -0.220750, -0.165950, -0.114390, -0.387450, -0.146560, 
-0.060690, -0.166950, 0.039580, -0.101680, -0.200960, -0.168630, -0.020240, 0.000920, -0.141480, -0.186210, 
-0.258670, -0.184840, 0.097370, -0.265020, -0.118900, -0.471450, -0.175550, 0.045830, 0.023040, -0.361710, 
-0.104700, 0.165970, 0.010510, -0.127220, 0.049480, -0.006880, -0.087410, 0.009670, 0.206880, -0.085600, 
-0.035960, -0.058900, -0.020120, 0.023180, -0.048410, -0.067270, -0.097870, -0.270220, -0.336850, -0.237320, 
-0.466440, -0.358520, -0.118870, -0.114510, -0.336360, -0.134670, -0.241220, -0.261060, -0.050820, 0.151110, 
-0.141960, -0.113980, -0.048630, -0.045300, 0.075260, -0.051940, -0.148050, -0.457400, -0.208960, -0.361800, 
-0.160780, 0.133730, -0.407250, 0.016880, -0.194180, -0.473920, -0.082660, -0.467680, -0.336830, -0.196520, 
-0.136630, 0.171620, -0.105880, 0.021010, -0.086010, -0.275390, -0.050520, -0.161680, -0.466930, -0.277290, 
-0.250450, -0.063630, 0.068720, -0.249880, -0.072410, -0.152970, -0.445640, -0.049820, -0.293830, -0.228350, 
-0.209850, -0.101180, -0.014980, -0.103930, 0.190590, -0.006580, -0.346700, 0.018490, -0.173110, -0.397180, 
-0.004170, -0.047330, 0.067150, 0.010240, -0.183850, -0.050590, -0.172900, -0.272490, -0.143870, -0.255620, 
-0.104420, -0.189260, -0.210340, -0.001060, 0.021760, 0.086370, -0.222220, -0.298010, -0.075540, -0.125620, 
-0.352450, 0.186450, 0.040750, -0.152860, 0.134010, 0.097880, -0.296910, -0.129830, -0.165690, -0.101590, 
-0.161770, -0.066220, -0.154450, -0.175890, -0.037780, 0.172480, -0.207700, -0.253250, -0.181070, 0.007210, 
-0.126210, -0.361280, -0.014270, -0.012980, -0.132100, 0.158460, 0.127800, -0.175340, -0.011740, -0.088200, 
-0.023060, -0.169890, -0.175430, -0.140470, -0.136850, 0.007570, 0.223050, -0.139260, -0.214380, -0.125180, 
-0.017140, -0.121980, -0.461350, 
0.748960, -0.611770, 0.748510, 0.819930, -0.819770, -0.211740, -0.444530, -0.598760, -0.159100, -0.274700, 
0.185060, 0.686910, -0.412030, 0.858850, 0.703310, 0.663670, -0.229450, -0.181230, -0.074090, -0.158750, 
0.141070, 0.637730, -0.230860, 0.270970, 0.334450, 0.373550, -0.332410, 0.330830, -0.197070, -0.419640, 
0.483660, 0.153820, 0.207060, -0.620950, -0.195320, -0.741970, -0.364250, 0.399180, 0.142200, 0.215480, 
0.526640, -0.202570, 0.405500, 0.267050, -1.082540, -0.485050, 0.439440, -0.943250, 0.244590, 0.409540, 
-0.730810, 1.408540, 0.191460, -0.697100, -0.183010, -0.174210, -0.230000, -0.456960, 0.605080, 0.423860, 
0.779980, 0.498590, -0.329500, 0.390060, -0.573550, 0.551710, 0.824770, -0.224030, -0.659310, -0.764120, 
-0.824820, 0.664400, -0.422590, -0.393290, 0.181090, -0.154160, 1.114400, 0.885380, 0.312770, -0.080270, 
-0.828000, 0.013150, -0.398520, -0.267440, 1.010510, -1.504390, 0.957460, 1.604800, -1.152320, -1.298050, 
0.183090, -0.955200, 0.459700, -0.589420, -0.414300, 0.273060, -0.634020, 0.842000, 0.879280, -0.422770, 
-0.341020, -0.139830, -0.864920, 0.173640, 0.447680, 0.995790, 0.000310, -1.004080, -0.558850, 1.282490, 
-1.741930, 0.149580, 1.303150, -1.351620, 1.114220, 0.957590, -1.063930, -1.644870, -0.494270, -0.912070, 
-1.007330, 0.122330, 1.001340, 0.345700, -0.004420, 0.346740, 0.819200, 0.363560, -2.039930, -0.562020, 
-0.093690, -1.347140, -0.575440, 0.839910, -0.389940, 1.264970, 0.616500, -1.025980, -2.019210, 0.140660, 
0.180580, -1.387050, -0.403800, 1.146730, 0.578970, 0.260790, -0.160150, 0.916920, -1.439430, -0.158960, 
0.954440, -1.602270, -0.585160, -0.181320, -1.492050, 1.569900, -0.847020, -0.596150, 0.738510, -0.910710, 
1.622220, 1.496740, 0.428120, -0.545470, -0.708190, 0.071050, -0.144360, 0.202550, 0.884170, -0.837510, 
0.060380, 0.891570, -1.461750, -0.791770, 0.191480, -1.041630, 0.563640, -0.534600, 0.247860, 0.288110, 
-2.104380, 0.887720, 0.743410, 0.391030, -0.001780, -0.991380, -0.104780, 0.779110, 1.375100, 0.948340, 
0.478240, -1.383120, -0.856170, 0.776380, -0.501100, 0.333440, 1.199460, -0.490650, 1.521000, 1.435750, 
-0.083190, -2.607310, -0.889640, -0.308940, -1.145120, -0.766750, 0.840190, 0.450190, 1.054140, 0.206900, 
0.438740, -0.318410, -0.286220, -0.255080, 0.000230, 0.176190, -0.058190, 0.095560, 0.480320, 0.955180, 
0.851210, -0.239850, -0.614030, -0.123250, 0.184840, -0.460330, -0.460090, 0.382810, 0.276420, -0.030550, 
-0.103250, 0.140550, -0.612090, 0.289240, 0.856420, -0.456560, 0.091350, -0.289810, -0.599350, 0.618100, 
-0.913380, 0.006680, 0.671660, -0.453360, 0.763450, 1.103120, 0.069990, -0.153870, -0.755960, -0.773590, 
-0.525600, 0.421540, -0.089950, 0.099350, -0.103040, -0.713830, 0.176820, -0.081820, -0.070440, -0.184420, 
0.293140, -0.329130, -0.254360, -0.163020, -0.068990, 0.405350, 0.675210, -0.224130, -0.562250, -0.472960, 
-0.080620, 0.161820, -0.053540, 
-0.081120, -0.048610, -0.072040, -0.114860, 0.035290, -0.124700, 0.103410, -0.055950, -0.169870, 0.037130, 
0.029000, 0.028660, -0.118300, -0.092310, -0.200050, 0.070880, 0.119800, 0.049670, -0.003160, 0.191780, 
-0.030170, -0.001700, -0.035710, -0.033770, -0.088270, -0.139680, -0.032520, 0.099720, -0.006240, -0.089450, 
-0.025600, -0.012030, -0.012100, 0.033380, -0.047600, -0.099020, 0.174900, 0.120340, -0.010170, -0.000960, 
0.164300, -0.161690, 0.100180, 0.016240, 0.117240, -0.000270, -0.149680, 0.106520, 0.108120, -0.012570, 
-0.223070, -0.026620, 0.163180, 0.002120, 0.030560, -0.173950, -0.009120, 0.046560, 0.124880, -0.075220, 
-0.029770, 0.141180, -0.107590, 0.087960, 0.101520, 0.064870, -0.159000, 0.060330, 0.072470, 0.065800, 
0.009320, -0.217720, 0.053750, 0.153590, 0.054870, -0.053350, -0.124840, 0.057660, 0.030190, 0.111390, 
0.028880, 0.105830, 0.197450, 0.057860, 0.296100, 0.013700, 0.040940, -0.072420, 0.239950, 0.031530, 
-0.116140, 0.168720, -0.230570, 0.168080, 0.270680, -0.139420, -0.133500, -0.039640, -0.000210, -0.052080, 
-0.101010, 0.224080, 0.237460, 0.115370, 0.002290, 0.382380, 0.129490, -0.145540, 0.132160, 0.065820, 
-0.288880, -0.123170, 0.181860, -0.016430, 0.250790, 0.140400, -0.311840, -0.465440, -0.081300, -0.053900, 
-0.105680, -0.031990, 0.388180, 0.368370, 0.148220, -0.061940, 0.139300, 0.207690, -0.553280, -0.220520, 
0.273730, -0.503010, -0.137580, 0.347870, -0.281870, 0.297460, 0.072920, -0.420620, -0.929820, -0.110580, 
-0.309100, -0.203360, -0.046970, 0.212160, 0.198960, 0.125600, -0.398890, 0.227090, 0.344770, -0.336920, 
-0.066750, 0.405370, -0.357610, 0.023230, 0.358740, -0.146700, 0.577820, 0.326250, -0.288890, -0.800430, 
-0.030780, -0.115760, -0.086100, -0.055640, 0.345300, 0.203530, 0.252010, -0.022950, 0.034380, 0.196690, 
-0.096620, -0.136170, 0.458830, -0.009410, 0.187930, 0.022350, 0.020830, 0.380330, 0.297150, 0.001900, 
-0.255470, 0.064010, 0.061080, -0.081720, -0.126630, 0.017350, 0.128270, 0.161470, 0.009330, 0.081310, 
0.134410, -0.036170, -0.086750, 0.314290, 0.147710, 0.233310, 0.134080, -0.009420, 0.360760, 0.252990, 
-0.191750, -0.271860, 0.123440, -0.058610, -0.208820, -0.030010, -0.005300, 0.012240, 0.083950, -0.035340, 
0.028380, 0.016570, -0.308260, -0.294800, 0.272150, 0.078200, 0.080610, 0.210900, -0.083610, 0.407480, 
0.141940, -0.045800, -0.093260, 0.051050, 0.071480, -0.118680, -0.027030, 0.107360, 0.031710, 0.000130, 
-0.073830, -0.040330, -0.016660, 0.003630, -0.152330, -0.038740, 0.078950, 0.095820, -0.043230, 0.053130, 
0.141490, 0.000020, 0.019960, 0.085800, 0.124310, -0.140220, 0.018010, -0.078610, -0.056820, -0.054370, 
0.112370, 0.013450, -0.164280, -0.018290, 0.091160, 0.169590, -0.170040, 0.084810, 0.032960, -0.114070, 
0.075760, -0.155850, 0.061700, 0.091670, 0.120630, 0.002600, -0.060760, -0.077530, 0.084570, -0.237240, 
-0.024670, -0.030460, 0.148610, 
-0.053530, -0.026270, -0.018800, -0.131150, -0.019830, -0.087160, 0.019910, -0.028620, -0.073620, -0.024950, 
-0.041030, -0.034210, -0.075840, -0.051880, -0.029660, -0.066970, -0.066090, -0.059990, -0.003740, 0.024750, 
-0.101730, -0.056320, -0.038750, -0.061230, -0.080960, -0.048460, -0.047910, 0.004930, -0.030780, -0.068430, 
-0.063380, -0.043590, -0.027760, -0.005600, -0.025530, -0.030820, -0.014230, -0.003960, -0.097300, -0.069780, 
0.017100, -0.134890, -0.004060, -0.008600, -0.048450, -0.051580, -0.055930, -0.015880, 0.003870, -0.058840, 
-0.135470, -0.076280, 0.026200, -0.038970, 0.017910, -0.061050, -0.055150, -0.039020, 0.017840, -0.082770, 
-0.061770, 0.002950, -0.136520, -0.008400, 0.023790, -0.062840, -0.073400, -0.008470, 0.033660, -0.015060, 
-0.068240, -0.098380, -0.084570, 0.024850, -0.020590, -0.016570, -0.074560, -0.061770, -0.018580, -0.014650, 
-0.072140, 0.025510, 0.025390, -0.109560, 0.024660, 0.017670, -0.062740, -0.049720, 0.017090, 0.040510, 
-0.035880, 0.022530, -0.086230, -0.068280, 0.014860, -0.056490, -0.067470, -0.057540, -0.079860, -0.037030, 
-0.119380, -0.004230, 0.034920, 0.010300, -0.149130, 0.036750, 0.054310, -0.014020, -0.042760, -0.011770, 
-0.102720, -0.049500, 0.020620, -0.050870, -0.075140, -0.022290, -0.085240, -0.147050, -0.053400, -0.048920, 
-0.069450, -0.130250, 0.031370, 0.087440, -0.002490, -0.166680, -0.034570, 0.084210, -0.132750, -0.078710, 
0.031990, -0.196300, -0.071780, 0.093280, -0.128090, -0.094950, -0.075610, -0.129060, -0.212440, -0.020780, 
-0.141370, -0.119730, -0.106690, 0.017180, 0.065770, 0.031460, -0.296440, -0.042060, 0.080400, -0.050190, 
-0.035550, 0.094340, -0.135730, -0.051880, 0.030800, -0.131020, 0.013640, 0.028590, -0.066920, -0.122850, 
-0.067820, -0.150280, -0.121540, -0.075340, 0.051970, 0.026580, 0.086350, -0.146320, -0.100810, 0.048020, 
-0.056840, -0.157770, 0.167500, -0.079230, 0.011250, -0.026670, -0.099110, 0.081560, 0.051650, -0.031820, 
-0.006420, -0.030560, -0.090210, -0.112870, -0.080300, -0.024620, 0.036720, 0.072330, -0.131130, -0.033270, 
0.013990, -0.060880, -0.121420, 0.068410, -0.071250, 0.020230, 0.035020, -0.061260, 0.023200, 0.032910, 
-0.025080, -0.064090, -0.005970, -0.082030, -0.094680, -0.046690, -0.052950, -0.005800, 0.008170, -0.138670, 
-0.034780, -0.043800, -0.120390, -0.142300, 0.043530, 0.011660, -0.011390, -0.030250, -0.057410, 0.038790, 
-0.000750, 0.038970, -0.053780, -0.016400, -0.028430, -0.065690, -0.009290, -0.015770, 0.007940, -0.045470, 
-0.130690, -0.014200, -0.044940, -0.082730, -0.081190, 0.002010, 0.017100, -0.006860, -0.025270, -0.008320, 
-0.025050, -0.019940, -0.020640, -0.034560, 0.032740, -0.079100, -0.063770, -0.044030, -0.079030, 0.007650, 
-0.020640, -0.095310, -0.064250, -0.028860, -0.039410, -0.059870, -0.019590, 0.035800, -0.047940, 0.001770, 
-0.006850, -0.027010, 0.043870, 0.018170, 0.017290, -0.075920, -0.027660, -0.118070, -0.014460, -0.123330, 
-0.036950, -0.030200, -0.082420, 
-0.218310, -0.058970, -0.013840, 0.078100, 0.206660, -0.118550, -0.067000, -0.042100, -0.246770, -0.183560, 
-0.055150, -0.004360, 0.050290, 0.124970, 0.013460, -0.030320, -0.201510, -0.032140, -0.031400, -0.140670, 
-0.019240, -0.380720, 0.042620, 0.000760, 0.248590, -0.132190, -0.140740, -0.030880, -0.296330, -0.217420, 
-0.212900, -0.050040, 0.101610, 0.018900, 0.090400, -0.024940, -0.031240, -0.174480, -0.226940, -0.014040, 
-0.152580, 0.105280, -0.225190, -0.070760, -0.092730, -0.111970, -0.171700, 0.250380, -0.151010, -0.316190, 
-0.083920, -0.132460, -0.011770, 0.054530, 0.039100, -0.020840, -0.040780, -0.284040, -0.351660, -0.415360, 
-0.047980, -0.047260, -0.016430, -0.321360, -0.154980, -0.156540, -0.104000, -0.330900, 0.256820, 0.059940, 
-0.415740, -0.103850, -0.153610, -0.216100, -0.186530, -0.008280, 0.032520, -0.063640, -0.171650, -0.281020, 
-0.411450, -0.282880, -0.208310, -0.215620, -0.205310, -0.082240, -0.031470, -0.230520, -0.336130, -0.132110, 
-0.076600, -0.464750, -0.060760, -0.451510, -0.240020, 0.014100, 0.127000, -0.186920, -0.109890, -0.156770, 
-0.185850, -0.688180, -0.328530, -0.178680, -0.290440, -0.105640, -0.220230, 0.109840, -0.196620, -0.398200, 
-0.088870, -0.074640, -0.581780, -0.200550, -0.442810, -0.263680, 0.018420, 0.391690, -0.209040, -0.206410, 
-0.149600, -0.391150, -0.373730, -0.536620, -0.280170, -0.385190, 0.006850, -0.139430, 0.232840, -0.005410, 
-0.067830, 0.166120, 0.012070, -0.477100, -0.072640, -0.174460, -0.054990, 0.200510, 0.449380, -0.192560, 
-0.024390, 0.085150, 0.038530, -0.290790, -0.308620, -0.131160, 0.199960, -0.438900, -0.435290, -0.351880, 
-0.514350, -0.418680, 0.263770, -0.084110, -0.727010, -0.238070, -0.326990, -0.412340, -0.080860, 0.685350, 
-0.263710, -0.102170, -0.049750, -0.203300, -0.344490, -0.203910, -0.339450, -0.381780, -0.408070, -0.465750, 
-0.109680, -0.079880, -0.476220, -0.268180, -0.185410, -0.617930, -0.334110, -0.225950, -0.326590, -0.133150, 
0.275170, -0.091930, -0.031290, -0.146140, -0.144400, -0.487160, -0.114070, -0.299420, -0.339380, -0.317860, 
-0.385840, -0.101840, -0.193470, -0.363450, -0.059080, -0.165980, -0.504760, -0.131880, -0.087680, -0.274870, 
-0.031930, 0.262170, -0.307870, -0.148610, 0.128440, 0.076580, -0.350090, -0.167780, -0.224210, -0.312030, 
0.087360, 0.074040, 0.112240, -0.172160, -0.429520, 0.159950, -0.212870, -0.584830, -0.118980, -0.412840, 
-0.138580, -0.019540, 0.232300, -0.087920, 0.040330, 0.020180, -0.163290, -0.421240, -0.162370, -0.109080, 
-0.251080, 0.226660, 0.222700, -0.048390, -0.062850, -0.195930, -0.357840, 0.000190, -0.336920, -0.026510, 
-0.244610, -0.182960, 0.197810, 0.013880, -0.011490, -0.055540, -0.116440, -0.253480, -0.235430, -0.012680, 
-0.116780, -0.122600, 0.186860, -0.131710, -0.094500, 0.014970, -0.164780, -0.131960, 0.134640, -0.029340, 
-0.023100, -0.120960, -0.256400, 0.092790, -0.040210, 0.181650, -0.015930, -0.283400, -0.203920, -0.236190, 
0.060500, 0.040950, -0.194110, 
-0.208690, -0.532570, 0.503160, 0.259300, -0.070500, 0.046440, -0.325450, -0.333340, -0.573130, 0.194730, 
-0.397120, 0.268380, -0.004380, 0.185950, -1.272090, -0.151540, 0.149400, -0.152930, -1.161340, 0.032800, 
0.220980, -0.426040, 0.161410, 0.701430, 0.270860, -0.475750, -0.454360, 0.017100, -0.111940, -0.433930, 
0.039280, -0.316350, 0.021500, 0.290450, 0.054150, -0.228850, 0.419270, 0.206370, -0.500930, -0.653730, 
-0.073800, 0.089090, 0.358310, -0.367930, 0.581900, 0.081300, -0.798330, 0.170610, 0.169680, 0.185610, 
-0.182570, 0.572260, -0.551430, 0.609290, 0.369950, -0.205580, -0.735130, -0.208140, 0.272880, 0.188670, 
-0.160390, 0.135720, 0.192750, 0.091820, -0.400470, 0.695470, 0.724570, -0.424460, 0.295600, 0.645970, 
-0.057300, 0.555150, -0.098910, -0.310120, 0.477970, 0.250530, 0.292880, 0.296590, -0.223550, 0.794090, 
0.152690, -0.400000, -0.113920, 0.422200, 0.638470, -0.062130, 0.281540, -0.086690, 0.466400, 0.122150, 
-0.090330, 0.759930, 0.367980, 0.623350, 0.814750, 0.304000, -0.157920, 0.350020, 0.471670, -0.742630, 
0.796240, 0.389750, 0.470710, 0.135290, 0.141160, 0.564730, -0.379720, -0.338440, 1.216630, 0.188810, 
-2.135910, -0.084670, 0.568840, 0.696280, 0.935130, 0.946620, -0.071040, -0.835860, 1.170720, 0.202410, 
-0.587290, 1.031710, 1.611920, 0.528730, 0.858000, 0.590760, 0.654700, -0.234100, -0.627260, -0.136300, 
0.368860, -2.191270, -0.523830, 0.984730, 0.410680, 0.474420, 0.890140, -1.872470, -2.298260, 0.473610, 
-0.173760, -1.023210, -0.143910, 1.371180, 0.370100, 0.579410, 0.201000, 1.237540, -0.176710, -1.138100, 
1.192000, 0.528830, -1.782560, 0.085590, 1.577860, 0.736370, 1.093060, 1.089470, -0.000790, -3.430170, 
0.850410, 0.767860, 0.193940, -0.168580, 1.711250, 1.035710, 0.805730, 0.676290, 0.849750, 0.015570, 
-1.248190, 0.937950, 0.851410, 0.036440, 0.074590, 0.536080, 0.435850, 0.506380, 0.735810, -0.139160, 
-2.634110, 1.244050, 1.105670, 0.481040, 0.154640, 1.463080, 1.077310, 0.391980, 0.429250, 0.406030, 
0.509320, -1.150280, 0.135580, 0.118140, -0.403350, 0.121570, 0.386520, 0.797600, 0.824780, 0.814520, 
0.079230, -1.205820, 0.671670, 0.925950, -0.089780, 0.191320, 0.820390, 0.362980, 0.317800, -0.006980, 
-0.186780, 0.153280, -0.189180, -0.159420, 0.262930, -0.575690, -0.139740, 0.481720, 0.107640, 0.568510, 
0.652170, 0.103360, -0.420520, 0.544290, 0.688220, 0.124800, -0.303090, -0.305440, 0.177550, 0.110130, 
0.144090, -0.306890, 0.016990, -0.111410, 0.007350, -0.221620, -0.074790, 0.291950, -0.045240, 0.195640, 
0.478520, 0.514180, 0.630540, -0.193110, 0.540510, -0.003420, -0.123970, -0.307780, -0.592490, -0.640210, 
-0.154510, 0.051820, -0.877010, -0.502290, -0.379180, 0.207580, 0.192480, -0.483030, 0.142710, -0.005220, 
0.288370, 0.265790, -0.108490, 0.159780, -0.111970, -0.081780, -0.378090, 0.152480, 0.269200, -0.507430, 
0.309970, -0.668930, 0.143860, 
-0.402270, -0.025270, -0.984350, -0.332750, -0.755590, 0.185270, -0.371640, -1.221540, -0.093230, -1.242660, 
-0.992420, 0.332790, 0.241030, 0.467060, 0.085650, -0.167630, -0.381360, -0.281270, -0.704820, -0.743730, 
0.825000, -0.458560, -0.358730, -0.082970, -0.477980, -0.604560, 0.502600, -0.036860, -0.381110, 0.268550, 
-0.948350, -0.343200, 0.115010, 0.260120, -0.729690, 0.067550, -0.192120, -0.196150, -0.148070, -0.548210, 
0.191070, 0.017220, -0.425330, 0.210560, 0.035740, -0.700070, -0.262040, -0.355870, 0.056490, 0.118960, 
-0.033100, -0.592360, -0.004310, -0.074310, 0.314950, -0.070760, 0.326370, -0.622140, -0.218800, 0.473140, 
-0.050360, -0.081630, 0.517380, -0.437070, 0.048140, -0.323750, -1.043560, -0.311190, 0.344770, 0.291870, 
0.740980, 0.020040, -0.334920, 0.112550, -0.330380, -0.257010, -0.048440, 0.527620, -0.293060, 0.420830, 
0.458720, -0.090010, 0.835060, 0.368480, 1.293720, 0.029470, -0.921520, -0.869230, 1.027950, -0.963160, 
-0.271350, 1.369860, -0.678270, 0.519910, 1.345150, -1.508540, -0.827020, 0.008770, 0.334510, -1.192370, 
-0.262400, 1.242290, 0.107250, 1.117230, 0.738860, 0.474660, 0.673900, -1.177690, 1.224390, 0.202430, 
-0.921830, 0.270960, 0.900250, -0.189230, -0.060260, 0.082450, -1.633750, -0.932310, -0.280060, 0.227570, 
0.983860, 0.802170, 0.934780, -0.638370, -0.037910, 0.578140, 1.337980, 0.420320, -3.066240, -0.172190, 
1.815340, -0.363460, -0.500720, 1.737720, -1.202410, 0.914360, 0.956010, -1.939340, -2.086260, -1.349900, 
-0.956010, -0.463960, -0.510620, 1.775010, 0.920190, -0.246750, -0.269030, -1.200170, -0.447070, 0.475040, 
0.483900, 0.179080, -0.882510, -0.065880, 0.740030, 0.561430, -0.236070, -0.730470, -0.473640, -1.258980, 
0.532480, 0.572430, 0.563800, 0.279390, 0.840110, 0.519340, 0.141410, 0.669440, -1.070790, 0.296830, 
0.860450, -1.907260, 0.957310, 0.203430, -0.535260, 0.903640, -0.124630, 1.077630, 0.871320, -0.878690, 
0.641580, -0.369260, -0.729380, -0.308440, -0.569420, 1.326640, 0.452960, -0.460190, 0.286560, -0.013550, 
-1.189970, 0.909910, 0.712560, -0.514950, 0.472260, -0.113740, -0.906550, 0.120120, -0.328280, -0.600270, 
-0.038410, 0.157890, -0.599970, 0.265060, -0.059300, 0.087340, -0.413200, 0.024270, 0.677800, 0.712080, 
0.628580, -0.031710, 0.148610, -0.564310, -0.564060, 0.875530, 0.601890, -0.501140, -0.026350, -0.373970, 
-0.267970, -0.356990, 0.170660, -1.211400, -0.055120, 0.270200, -0.461720, -0.241540, -0.569230, -0.288230, 
0.404680, 0.079500, -0.154060, 0.175770, -0.533860, -0.753660, 0.697110, 0.391740, -0.693970, 0.348010, 
-1.411290, 0.001230, 0.217950, 0.476250, -0.425700, 0.345030, 0.148900, -0.193260, -0.671590, -0.508960, 
0.410120, 0.558320, -0.117690, 0.285870, -0.339870, -0.650780, -0.410110, 0.099370, 0.004260, -0.164580, 
-0.422930, -1.058000, -0.014110, 0.358940, -0.041290, -0.066790, 0.107370, -0.011590, -0.514370, 0.029150, 
-0.104010, -0.342210, 0.715690, 
-0.736130, 0.191500, -0.215790, -0.001390, 0.077670, 0.232230, 0.211430, 0.344840, -0.530280, -0.217480, 
0.024380, 0.030020, 0.315450, -0.152360, -0.084870, -0.103740, -0.180180, 0.133140, 0.161350, 0.008190, 
0.100480, -0.289150, -0.193380, -0.104370, 0.239560, -0.051930, 0.116630, 0.062010, 0.367430, -0.458320, 
-0.117440, -0.060780, -0.366000, -0.021600, 0.010370, 0.071420, 0.072370, 0.269230, 0.111420, 0.093980, 
-0.198800, 0.121940, 0.223640, -0.211780, -0.454670, -0.436470, 0.379130, -0.135420, -0.122540, 0.864740, 
-0.593750, 0.031790, -0.084200, -0.325880, 0.043450, -0.355160, -0.102750, -0.113060, 0.045320, 0.476540, 
0.007820, -0.275270, -0.100410, -0.314180, -0.058340, -0.495270, 0.138460, 0.392300, -0.322650, -0.143550, 
0.369340, -0.343170, 0.038650, -0.049540, -0.372830, -0.043330, -0.554760, -0.204590, 0.101740, -0.108490, 
0.616510, -0.279930, -0.182180, -0.439160, -0.300800, 0.047080, -0.377950, 0.110550, 0.211910, -0.387240, 
-0.358470, 0.228070, 0.109270, 0.257960, -0.032690, -0.008410, -0.044850, -0.350620, -0.346470, -0.210400, 
-0.219690, 0.454770, -0.420140, -0.626050, -0.387210, -0.501970, 0.000370, 0.199020, -0.398620, 0.006620, 
-0.183980, -0.205670, -0.326550, 0.019640, -0.382180, -0.214730, 0.073160, 0.532130, -0.171670, -0.279500, 
0.221220, -0.116480, 0.096920, -0.188880, -0.452840, -0.449720, -0.074480, 0.090650, 0.784760, -1.224630, 
-0.338900, 0.431160, 0.067560, -0.628740, -0.239580, -0.219710, -0.521480, 0.427420, 0.911040, 0.030860, 
-0.040570, 0.237960, 0.064590, -0.057330, -0.181460, -0.515380, -0.009810, -0.691560, -0.340390, 0.887860, 
-0.793510, -0.667590, 0.465080, -0.514840, -1.157840, -0.155050, -0.852050, -0.627110, 0.872210, 1.652640, 
-0.347490, -0.341480, 0.362120, 0.116400, -0.312410, -0.443350, -0.353940, 0.002760, -0.469630, -0.333040, 
0.064820, 0.146010, -0.102180, 1.017420, -0.063440, -1.429320, 0.010050, -1.029390, -0.830660, 0.456350, 
0.315720, -0.154210, -0.383140, 0.568810, -0.031950, -0.788530, -0.498900, 0.061270, -0.097580, -0.295930, 
-0.446400, -0.142280, 0.727510, -0.430400, 0.329610, -0.150820, -1.503080, 0.153580, -1.103300, -0.259220, 
0.468920, -0.106760, -0.012800, 0.095520, 0.425540, 0.110370, -0.999300, -0.129920, -0.016450, 0.029110, 
0.296290, -0.243340, -0.384570, 0.362160, -0.346180, -0.121650, -0.432430, -0.525100, -0.387620, -0.379510, 
0.125510, 0.227550, -0.425800, 0.242980, -0.123120, 0.116980, -0.137900, -0.299480, 0.234230, 0.051640, 
0.099880, 0.151000, 0.014530, -0.514810, 0.750010, 0.385340, -0.427270, -0.447970, 0.067150, -0.341860, 
-0.325110, 0.143920, 0.248350, -0.545770, 0.322390, 0.456520, -0.398050, -0.027010, -0.366300, 0.235460, 
-0.121960, 0.101610, -0.302180, 0.146900, -0.221030, 0.739050, 0.435880, -0.562620, -0.179110, 0.174670, 
0.067550, -0.127440, 0.266550, 0.056970, -0.121830, 0.118420, 0.091820, 0.125750, -0.377720, 0.017940, 
-0.109230, -0.011480, -0.095280, 
0.040160, 0.081090, -0.444810, -0.221340, 0.020430, -0.041880, 0.170150, -0.009880, -0.200780, -0.033490, 
0.137200, -0.044280, -0.191660, -0.223240, -0.336820, 0.383130, 0.159680, 0.222640, -0.077520, 0.001570, 
-0.032150, 0.204040, 0.099450, -0.251480, -0.297050, -0.007360, -0.093060, -0.065660, 0.125680, -0.250860, 
-0.025470, -0.084860, -0.139500, -0.301330, -0.175620, -0.055800, 0.370640, 0.243470, 0.231000, 0.151820, 
0.110050, -0.353730, 0.283520, -0.034440, -0.158590, -0.399610, -0.029850, 0.151250, -0.007370, 0.289080, 
-0.084950, 0.026510, 0.180560, -0.197230, -0.203240, -0.334210, 0.133140, 0.335970, 0.078010, -0.008530, 
0.013620, 0.095240, -0.200160, 0.313070, 0.074850, -0.141970, -0.402190, 0.440670, 0.109870, -0.089830, 
0.364290, -0.373450, 0.350890, 0.204530, 0.120140, -0.284110, -0.443940, 0.302030, -0.048730, 0.065460, 
0.318250, 0.083090, 0.174760, 0.067140, 0.331630, 0.199230, -0.318920, -0.252120, 0.675460, 0.167700, 
-0.115810, 0.170470, -0.259350, 0.520260, 0.383300, -0.398010, -0.267060, -0.126750, -0.092750, 0.069170, 
-0.041890, 0.594080, 0.240540, 0.184630, 0.079590, 0.398200, 0.424680, -0.996490, -0.247350, 0.477610, 
0.179750, -0.119080, 0.529430, 0.108630, 1.081340, 0.308100, -1.050510, -1.011590, -0.316500, -0.242470, 
-0.209450, -0.022170, 1.094950, 0.697330, 0.326740, 0.054540, -0.143320, 0.371950, -1.055170, -0.853740, 
0.478120, 0.209730, 0.091860, 0.490010, -0.558020, 0.733210, 0.032530, -0.482630, -2.024090, -0.446170, 
-0.379230, 0.304560, 0.642470, 0.318750, 0.168870, 0.067750, -0.383470, -0.095630, 0.706810, -0.820260, 
-0.750810, 0.543860, 0.371160, 0.263370, 0.533280, -0.450660, 1.046380, 0.280270, -0.525830, -0.388460, 
-0.426350, -0.285430, 0.228840, 0.503670, 0.505060, 0.203800, 0.343470, -0.048190, -0.266510, 0.514590, 
-0.294890, -0.475080, 0.166540, 0.456030, 0.515820, 0.285830, -0.168840, 0.638210, 0.307710, -0.210980, 
0.368350, -0.422640, -0.127950, 0.379030, 0.056490, 0.037750, 0.047580, 0.323640, 0.068910, -0.391310, 
-0.038340, 0.309900, -0.088790, 0.252710, 0.493580, 0.310710, -0.013070, -0.400530, 0.573200, 0.109530, 
-0.329160, 0.518310, -0.210160, -0.449790, 0.226520, 0.307570, -0.006090, -0.037340, 0.177030, 0.041460, 
-0.185460, 0.216200, -0.075640, -0.614180, 0.278990, 0.239350, 0.050050, 0.315590, -0.524000, 0.412820, 
0.105620, -0.314470, 0.306340, -0.182710, -0.175320, 0.068880, 0.174920, 0.282950, -0.006090, -0.001990, 
-0.062580, -0.528510, 0.219040, -0.039440, -0.298420, 0.059600, 0.148310, 0.123760, -0.234570, -0.340870, 
0.170520, -0.185740, -0.292070, 0.555330, 0.071230, -0.469340, 0.272230, 0.308100, 0.398420, -0.183740, 
0.009800, 0.100790, -0.557250, 0.226750, 0.276850, 0.156480, -0.294210, 0.202330, 0.254110, -0.444750, 
-0.136420, -0.255380, -0.346400, -0.226460, 0.402200, 0.058360, -0.181250, 0.148170, 0.454780, -0.099240, 
-0.188500, -0.207660, 0.407050, 
-0.463500, -1.740860, -0.400530, 4.571980, -3.551090, -3.510190, -0.088510, 4.676880, 3.760440, -0.644390, 
-3.485150, 3.611290, -1.081210, -0.521970, 1.029060, -3.346300, -0.676200, -0.520410, 0.337670, -0.773260, 
-1.962800, -0.494480, 4.252060, -0.175630, -0.291620, -0.815390, 0.625150, -2.998030, -3.197670, 2.062700, 

-0.099330, -3.326820, 0.132870, -4.485110, 1.984300, 0.282470, 1.970580, -4.817000, -3.178650, -0.852340, 
3.847130, -3.826090, -1.636270, -0.434500, -3.810490, 3.915420, -0.151620, -0.326710, -0.867990, -0.958260, 
-2.038940, -0.042770, -4.362040, -0.808460, -0.229280, -1.220970, 1.816310, 3.917700, 0.839510, -0.742870, 

-0.021960, 2.405940, -0.572050, -2.015120, -0.175360, 2.156130, -1.652530, -1.973350, -2.049080, 0.286510, 
-1.364850, -1.043750, -0.761450, 0.321580, 1.628930, -1.850290, 1.338290, -0.040780, 2.137370, 0.831430, 
2.907900, 1.296740, -1.771590, -0.891060, -0.072840, 0.902330, -1.752100, -1.993020, 0.134470, -1.810600, 


  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[307] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.010000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, 0.009980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.009170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.002710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.008150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, -0.000540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.000910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, 0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, -0.006630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.008630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, -0.001360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, -0.001120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, 0.008980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, 0.009620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.004950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, -0.007520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.000630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, -0.008410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, -0.000310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, -0.006210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, 0.006230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.001410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, 0.008460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, -0.006310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, -0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, 0.007630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.007880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, -0.005690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, 0.002430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, -0.003580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.003620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, -0.005050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.009880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, -0.002490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.007470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.002350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.005420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, 0.006270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, 0.000070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, -0.000190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, 0.003680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, -0.004030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, 0.002660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, -0.007530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, 0.002580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, 0.001440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, -0.000850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, -0.003360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, 0.006580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, -0.006620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.007240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, -0.005380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.008950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, -0.009330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, 0.003310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.008360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, 0.004590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.008510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.003520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.006200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.000720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.001380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.000240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, -0.004780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, -0.007430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, -0.001560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, 0.003330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, 0.002140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, 0.006460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.007760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.007050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.006220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, -0.009100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.008090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.003720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.007460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, 0.009920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, 0.009990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, 0.006140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, -0.001740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, 0.002500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, 0.009460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.000700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, -0.005710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.001160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.004240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.007070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.000520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, 0.004670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, -0.005670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, 0.000640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.006060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.001060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.005140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.000680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, -0.007380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, 0.007320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, -0.006920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.009640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, -0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, -0.003400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, -0.006000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.007140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, -0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.005490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.002680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.008890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, -0.007700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.001100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.006740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.001500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.000400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, 0.009380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, -0.002170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, -0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.006350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.000500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, -0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, 0.003820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, -0.008850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.002240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, -0.008610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.008230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, 0.003250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, -0.000660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.005360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, -0.005040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.008180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.007080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, 0.006510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, 0.001620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, 0.004070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, 0.002440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, 0.001630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, 0.002380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, 0.004000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, 0.009580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, 0.009260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.005580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, 0.000110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, -0.007650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 165 (Old: 165) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 166 (Old: 166) */
      0.0, 0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 167 (Old: 167) */
      0.0, 0.007600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 168 (Old: 168) */
      0.0, -0.000960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 169 (Old: 169) */
      0.0, 0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 170 (Old: 170) */
      0.0, 0.000860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 171 (Old: 171) */
      0.0, -0.001760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 172 (Old: 172) */
      0.0, -0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 173 (Old: 173) */
      0.0, 0.008600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 174 (Old: 174) */
      0.0, -0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 175 (Old: 175) */
      0.0, 0.001940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 176 (Old: 176) */
      0.0, -0.001710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 177 (Old: 177) */
      0.0, 0.006180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 178 (Old: 178) */
      0.0, -0.007850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 179 (Old: 179) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 180 (Old: 180) */
      0.0, 0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 181 (Old: 181) */
      0.0, 0.007690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 182 (Old: 182) */
      0.0, 0.006820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 183 (Old: 183) */
      0.0, -0.009850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 184 (Old: 184) */
      0.0, -0.003630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 185 (Old: 185) */
      0.0, -0.006240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 186 (Old: 186) */
      0.0, -0.002840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 187 (Old: 187) */
      0.0, 0.003410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 188 (Old: 188) */
      0.0, -0.004750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 189 (Old: 189) */
      0.0, -0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 190 (Old: 190) */
      0.0, -0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 191 (Old: 191) */
      0.0, -0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 192 (Old: 192) */
      0.0, 0.002820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 193 (Old: 193) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 194 (Old: 194) */
      0.0, 0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 195 (Old: 195) */
      0.0, -0.006300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 196 (Old: 196) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 197 (Old: 197) */
      0.0, 0.004510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 198 (Old: 198) */
      0.0, 0.009110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 199 (Old: 199) */
      0.0, -0.002020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 200 (Old: 200) */
      0.0, -0.000280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 201 (Old: 201) */
      0.0, -0.002600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 202 (Old: 202) */
      0.0, 0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 203 (Old: 203) */
      0.0, 0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 204 (Old: 204) */
      0.0, 0.000950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 205 (Old: 205) */
      0.0, -0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 206 (Old: 206) */
      0.0, -0.004860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 207 (Old: 207) */
      0.0, 0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 208 (Old: 208) */
      0.0, -0.002360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 209 (Old: 209) */
      0.0, -0.002370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 210 (Old: 210) */
      0.0, -0.007090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 211 (Old: 211) */
      0.0, 0.006370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 212 (Old: 212) */
      0.0, 0.003840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 213 (Old: 213) */
      0.0, 0.009530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 214 (Old: 214) */
      0.0, 0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 215 (Old: 215) */
      0.0, -0.009030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 216 (Old: 216) */
      0.0, -0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 217 (Old: 217) */
      0.0, 0.005900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 218 (Old: 218) */
      0.0, -0.002080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 219 (Old: 219) */
      0.0, -0.008710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 220 (Old: 220) */
      0.0, -0.001190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 221 (Old: 221) */
      0.0, -0.000940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 222 (Old: 222) */
      0.0, 0.001220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 223 (Old: 223) */
      0.0, 0.001000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 224 (Old: 224) */
      0.0, 0.003860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 225 (Old: 225) */
      0.0, 0.005980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 226 (Old: 226) */
      0.0, 0.005680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 227 (Old: 227) */
      0.0, 0.009000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 228 (Old: 228) */
      0.0, 0.005810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 229 (Old: 229) */
      0.0, -0.001490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 230 (Old: 230) */
      0.0, -0.008300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 231 (Old: 231) */
      0.0, 0.001690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 232 (Old: 232) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 233 (Old: 233) */
      0.0, 0.002890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 234 (Old: 234) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 235 (Old: 235) */
      0.0, 0.002160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 236 (Old: 236) */
      0.0, 0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 237 (Old: 237) */
      0.0, 0.004290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 238 (Old: 238) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 239 (Old: 239) */
      0.0, 0.001110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 240 (Old: 240) */
      0.0, -0.008520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 241 (Old: 241) */
      0.0, -0.008430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 242 (Old: 242) */
      0.0, -0.002120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 243 (Old: 243) */
      0.0, -0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 244 (Old: 244) */
      0.0, 0.009710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 245 (Old: 245) */
      0.0, -0.003730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 246 (Old: 246) */
      0.0, -0.006890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 247 (Old: 247) */
      0.0, 0.007410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 248 (Old: 248) */
      0.0, 0.008810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 249 (Old: 249) */
      0.0, 0.009740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 250 (Old: 250) */
      0.0, 0.002180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 251 (Old: 251) */
      0.0, -0.007310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 252 (Old: 252) */
      0.0, 0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 253 (Old: 253) */
      0.0, -0.008490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 254 (Old: 254) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 255 (Old: 255) */
      0.0, -0.003240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 256 (Old: 256) */
      0.0, -0.003100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 257 (Old: 257) */
      0.0, 0.008470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 258 (Old: 258) */
      0.0, 0.008140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 259 (Old: 259) */
      0.0, 0.009930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 260 (Old: 260) */
      0.0, -0.000530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 261 (Old: 261) */
      0.0, -0.005800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 262 (Old: 262) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 263 (Old: 263) */
      0.0, -0.000920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 264 (Old: 264) */
      0.0, -0.005970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 265 (Old: 265) */
      0.0, -0.004540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 266 (Old: 266) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 267 (Old: 267) */
      0.0, 0.004900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 268 (Old: 268) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 269 (Old: 269) */
      0.0, 0.000340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 270 (Old: 270) */
      0.0, 0.000650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 271 (Old: 271) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 272 (Old: 272) */
      0.0, -0.000080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 273 (Old: 273) */
      0.0, -0.007170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 274 (Old: 274) */
      0.0, -1.461720, 273,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 275 (Old: 275) */
      0.0, -0.352800, 273,
       &Sources[273] , 
       &Weights[273] , 
      },
    { /* unit 276 (Old: 276) */
      0.0, -1.966700, 273,
       &Sources[546] , 
       &Weights[546] , 
      },
    { /* unit 277 (Old: 277) */
      0.0, -3.657250, 273,
       &Sources[819] , 
       &Weights[819] , 
      },
    { /* unit 278 (Old: 278) */
      0.0, -1.321100, 273,
       &Sources[1092] , 
       &Weights[1092] , 
      },
    { /* unit 279 (Old: 279) */
      0.0, -0.836420, 273,
       &Sources[1365] , 
       &Weights[1365] , 
      },
    { /* unit 280 (Old: 280) */
      0.0, -1.975180, 273,
       &Sources[1638] , 
       &Weights[1638] , 
      },
    { /* unit 281 (Old: 281) */
      0.0, -4.851380, 273,
       &Sources[1911] , 
       &Weights[1911] , 
      },
    { /* unit 282 (Old: 282) */
      0.0, -3.403820, 273,
       &Sources[2184] , 
       &Weights[2184] , 
      },
    { /* unit 283 (Old: 283) */
      0.0, -1.110620, 273,
       &Sources[2457] , 
       &Weights[2457] , 
      },
    { /* unit 284 (Old: 284) */
      0.0, -3.095530, 273,
       &Sources[2730] , 
       &Weights[2730] , 
      },
    { /* unit 285 (Old: 285) */
      0.0, -2.435860, 273,
       &Sources[3003] , 
       &Weights[3003] , 
      },
    { /* unit 286 (Old: 286) */
      0.0, -0.798000, 273,
       &Sources[3276] , 
       &Weights[3276] , 
      },
    { /* unit 287 (Old: 287) */
      0.0, -1.192950, 273,
       &Sources[3549] , 
       &Weights[3549] , 
      },
    { /* unit 288 (Old: 288) */
      0.0, -0.296090, 273,
       &Sources[3822] , 
       &Weights[3822] , 
      },
    { /* unit 289 (Old: 289) */
      0.0, -2.829320, 273,
       &Sources[4095] , 
       &Weights[4095] , 
      },
    { /* unit 290 (Old: 290) */
      0.0, -0.734900, 273,
       &Sources[4368] , 
       &Weights[4368] , 
      },
    { /* unit 291 (Old: 291) */
      0.0, -1.407180, 273,
       &Sources[4641] , 
       &Weights[4641] , 
      },
    { /* unit 292 (Old: 292) */
      0.0, -0.770900, 273,
       &Sources[4914] , 
       &Weights[4914] , 
      },
    { /* unit 293 (Old: 293) */
      0.0, -0.662800, 273,
       &Sources[5187] , 
       &Weights[5187] , 
      },
    { /* unit 294 (Old: 294) */
      0.0, -0.296810, 273,
       &Sources[5460] , 
       &Weights[5460] , 
      },
    { /* unit 295 (Old: 295) */
      0.0, -0.724090, 273,
       &Sources[5733] , 
       &Weights[5733] , 
      },
    { /* unit 296 (Old: 296) */
      0.0, -3.817120, 273,
       &Sources[6006] , 
       &Weights[6006] , 
      },
    { /* unit 297 (Old: 297) */
      0.0, -2.237970, 273,
       &Sources[6279] , 
       &Weights[6279] , 
      },
    { /* unit 298 (Old: 298) */
      0.0, -1.526270, 273,
       &Sources[6552] , 
       &Weights[6552] , 
      },
    { /* unit 299 (Old: 299) */
      0.0, -0.552100, 273,
       &Sources[6825] , 
       &Weights[6825] , 
      },
    { /* unit 300 (Old: 300) */
      0.0, -2.419540, 273,
       &Sources[7098] , 
       &Weights[7098] , 
      },
    { /* unit 301 (Old: 301) */
      0.0, -3.198720, 273,
       &Sources[7371] , 
       &Weights[7371] , 
      },
    { /* unit 302 (Old: 302) */
      0.0, -1.007600, 273,
       &Sources[7644] , 
       &Weights[7644] , 
      },
    { /* unit 303 (Old: 303) */
      0.0, -2.394640, 273,
       &Sources[7917] , 
       &Weights[7917] , 
      },
    { /* unit 304 (Old: 304) */
      0.0, -0.211370, 30,
       &Sources[8190] , 
       &Weights[8190] , 
      },
    { /* unit 305 (Old: 305) */
      0.0, 0.082720, 30,
       &Sources[8220] , 
       &Weights[8220] , 
      },
    { /* unit 306 (Old: 306) */
      0.0, 0.245480, 30,
       &Sources[8250] , 
       &Weights[8250] , 
      }

  };



int net_profil111(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[273] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, Units + 271, Units + 272, Units + 273}; /* members */

  static pUnit Hidden1[30] = {Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303}; /* members */

  static pUnit Output1[3] = {Units + 304, Units + 305, Units + 306}; /* members */

  static int Output[3] = {304, 305, 306};

  for(member = 0; member < 273; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 30; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
