/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  net_psi.c
  --------------------------------------------------------
  generated at Fri Jun 25 18:31:01 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[436];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 358, Units + 359, Units + 360, Units + 361, Units + 362, Units + 363, Units + 364, Units + 365, Units + 366, Units + 367, 
Units + 368, Units + 369, Units + 370, Units + 371, Units + 372, Units + 373, Units + 374, Units + 375, Units + 376, Units + 377, 
Units + 378, Units + 379, Units + 380, Units + 381, Units + 382, Units + 383, Units + 384, Units + 385, Units + 386, Units + 387, 
Units + 388, Units + 389, Units + 390, Units + 391, Units + 392, Units + 393, Units + 394, Units + 395, Units + 396, Units + 397, 
Units + 398, Units + 399, Units + 400, Units + 401, Units + 402, Units + 403, Units + 404, Units + 405, Units + 406, Units + 407, 
Units + 408, Units + 409, Units + 410, Units + 411, Units + 412, Units + 413, Units + 414, Units + 415, Units + 416, Units + 417, 
Units + 418, Units + 419, Units + 420, Units + 421, Units + 422, Units + 423, Units + 424, Units + 425, Units + 426, Units + 427, 
Units + 428, Units + 429, Units + 430, Units + 431, Units + 432, 
Units + 358, Units + 359, Units + 360, Units + 361, Units + 362, Units + 363, Units + 364, Units + 365, Units + 366, Units + 367, 
Units + 368, Units + 369, Units + 370, Units + 371, Units + 372, Units + 373, Units + 374, Units + 375, Units + 376, Units + 377, 
Units + 378, Units + 379, Units + 380, Units + 381, Units + 382, Units + 383, Units + 384, Units + 385, Units + 386, Units + 387, 
Units + 388, Units + 389, Units + 390, Units + 391, Units + 392, Units + 393, Units + 394, Units + 395, Units + 396, Units + 397, 
Units + 398, Units + 399, Units + 400, Units + 401, Units + 402, Units + 403, Units + 404, Units + 405, Units + 406, Units + 407, 
Units + 408, Units + 409, Units + 410, Units + 411, Units + 412, Units + 413, Units + 414, Units + 415, Units + 416, Units + 417, 
Units + 418, Units + 419, Units + 420, Units + 421, Units + 422, Units + 423, Units + 424, Units + 425, Units + 426, Units + 427, 
Units + 428, Units + 429, Units + 430, Units + 431, Units + 432, 
Units + 358, Units + 359, Units + 360, Units + 361, Units + 362, Units + 363, Units + 364, Units + 365, Units + 366, Units + 367, 
Units + 368, Units + 369, Units + 370, Units + 371, Units + 372, Units + 373, Units + 374, Units + 375, Units + 376, Units + 377, 
Units + 378, Units + 379, Units + 380, Units + 381, Units + 382, Units + 383, Units + 384, Units + 385, Units + 386, Units + 387, 
Units + 388, Units + 389, Units + 390, Units + 391, Units + 392, Units + 393, Units + 394, Units + 395, Units + 396, Units + 397, 
Units + 398, Units + 399, Units + 400, Units + 401, Units + 402, Units + 403, Units + 404, Units + 405, Units + 406, Units + 407, 
Units + 408, Units + 409, Units + 410, Units + 411, Units + 412, Units + 413, Units + 414, Units + 415, Units + 416, Units + 417, 
Units + 418, Units + 419, Units + 420, Units + 421, Units + 422, Units + 423, Units + 424, Units + 425, Units + 426, Units + 427, 
Units + 428, Units + 429, Units + 430, Units + 431, Units + 432, 

  };

  /* Weigths definition section */
  static float Weights[] =  {
0.017430, -0.082570, -0.052030, 0.106000, 0.389970, 0.395660, 0.018890, 0.171420, 0.228510, 0.299060, 
0.425190, 0.113020, 0.221320, 0.511360, 0.718800, 0.237240, -0.039070, 0.931580, 0.173970, 0.214470, 
0.455030, -0.101860, -0.029170, 0.022530, 0.057700, 0.296730, 0.306620, 0.097260, 0.757390, 0.447660, 
0.138380, 0.435220, 0.170300, 0.213570, 0.536120, 0.916730, 0.416280, 0.012980, 0.926740, 0.076780, 
-0.156370, 0.454370, 0.014870, 0.493020, 0.374350, 0.064990, 0.140910, 0.337960, 0.031160, 0.212830, 
0.109350, 0.282810, 0.504080, 0.095790, 0.506360, 0.229030, 0.184070, 0.413990, 0.323120, 0.749830, 
-0.010240, 0.205260, 0.412240, 0.322800, 0.524510, 0.310300, 0.542420, 0.136650, 0.213940, 0.064370, 
0.524970, 0.543500, 0.250100, 0.137300, 0.208420, 0.056710, 0.297530, 0.126080, 0.276700, 0.033500, 
0.433410, 0.187250, 0.196220, 0.426870, 0.045200, 0.138210, -0.026480, 0.339470, 0.574880, -0.128040, 
0.451190, 0.149240, 0.282220, 0.372290, -0.105240, -0.190840, 0.028920, 0.554900, 0.414550, 0.177160, 
0.403330, 0.665570, 0.464720, 0.383050, 0.375500, -0.094650, -0.231390, 0.264680, 0.143900, 0.393710, 
-0.348390, -0.000030, -0.249690, -0.269900, 0.559600, 0.318820, -0.466890, 0.248130, 0.108540, 0.758860, 
-0.118920, 0.090530, -0.059830, -0.040030, 0.544830, 0.307060, 0.593010, -0.022270, 0.138100, 0.426520, 
0.427090, -0.264190, 0.044210, 0.216580, 0.444830, 0.505270, 0.145430, -0.093250, -0.235810, 0.321950, 
0.545170, 0.453250, -0.055480, 0.418400, 0.641610, 0.274040, 0.287250, 0.217380, -0.106350, 0.192850, 
-0.148330, 0.269750, 0.344370, 0.443010, 0.260940, -0.317660, 0.814190, 0.498830, -0.002400, 0.813410, 
0.304480, 0.738560, 0.422890, 0.054830, 0.993310, 0.611800, 0.540690, 0.316660, -0.251930, 0.000360, 
0.026720, 0.301910, 0.352180, 0.271330, -0.014130, -0.911950, 0.369900, 0.209920, 0.402230, 0.391270, 
0.160130, 0.025530, 0.606230, 0.476290, -0.464180, -0.277560, -0.099590, 0.306720, 0.004830, -0.518040, 
0.008280, 0.086910, -0.093460, -0.418730, 0.165140, -0.397700, -0.465070, -0.040860, 0.074280, 0.492210, 
0.156330, 0.184540, -0.356600, 0.316280, 0.147080, 0.814460, -0.306270, -0.527810, 0.026330, 0.003990, 
-0.702350, 0.077180, 0.163870, -0.062870, -0.316900, 0.206560, -0.041950, -0.595890, 0.027280, -0.189770, 
0.651780, 0.331480, 0.329430, -0.062060, 1.212190, 0.065050, 0.040980, -0.562670, -0.400510, -0.444640, 
0.023630, 0.021510, 0.368940, 0.469180, 0.222500, 0.048080, 0.058260, 0.308010, 0.702470, -0.079750, 
-0.021720, -0.208900, -0.252300, -0.260150, 0.125330, -0.409840, -0.325570, -0.039380, 0.344070, 0.125390, 
0.307910, 0.015400, 0.388890, 0.015600, 0.078210, 0.000840, 0.244860, 0.348740, 0.018380, 0.456060, 
-0.242940, -0.149590, -0.396340, -0.007670, -0.299530, -0.278550, 0.286180, 0.109330, -0.147430, 0.192970, 
-0.163540, -0.066230, 0.025310, -0.160590, -0.055740, 0.088180, 0.481140, -0.432170, 0.101670, 0.355950, 
0.044970, -0.049710, -0.626060, -0.434000, 0.024000, -0.305550, -0.102150, 0.774080, -0.325390, -0.338270, 
0.112810, -0.291420, -0.046870, 0.009220, 0.123950, -0.158170, 0.124450, 0.519290, -0.209270, -0.395230, 
-0.083780, -0.310430, -0.303100, -0.214100, -0.366270, 0.012580, -0.230900, -0.246520, -0.165290, -0.164590, 
0.004640, -0.732150, -0.349070, -0.302900, 0.016140, -0.041950, 0.127780, -0.133850, 0.259420, 0.190670, 
0.600980, 0.049220, -0.246900, 0.097210, -0.293880, -0.319840, 0.095120, 0.252640, -0.132720, -0.612230, 
0.328400, -0.216290, -0.489130, -0.358210, -0.593270, 0.003360, -0.261500, -0.067150, -0.134200, 0.278960, 
0.024290, 0.145900, -0.237970, 0.298490, 0.382320, -0.131620, -0.313670, -0.532490, -0.392660, -0.124610, 
-0.535430, -0.246280, -0.431750, -0.788270, -0.127470, -0.176500, 0.018840, 
-0.030180, -0.122320, -0.072020, 0.239730, 0.445840, -0.115730, -0.200260, -0.327780, -0.085380, 0.407210, 
0.244610, -0.128880, 0.428560, 0.461770, -0.516380, 0.220390, 0.025850, -0.231630, 0.280010, 0.508950, 
-0.101090, 0.350910, -0.475050, 0.014350, 0.162760, 0.407050, -0.178960, -0.244940, -0.092830, -0.027720, 
-0.093760, 0.337120, 0.140410, 0.483470, 0.059260, -0.309310, -0.043330, -0.011220, -0.001950, 0.032800, 
-0.125910, -0.108720, 0.157560, 0.152530, -0.008170, 0.113410, -0.459820, 0.187300, 0.320520, 0.397440, 
-0.491130, -0.035320, -0.167240, 0.048240, -0.077050, -0.150580, -0.054330, 0.407710, 0.279430, 0.305260, 
0.092830, 0.148200, -0.090020, 0.161170, -0.226820, 0.019830, -0.187870, -0.140080, -0.221850, 0.109720, 
0.187180, 0.228320, 0.084250, 0.312090, -0.241680, 0.322870, 0.005270, -0.050990, 0.119950, 0.263220, 
0.494500, 0.045390, -0.099840, -0.053700, -0.167650, -0.097750, -0.330990, -0.225880, 0.196940, 0.230380, 
-0.374130, -0.025920, -0.302360, 0.175070, 0.441900, -0.215750, 0.065770, 0.339810, -0.440310, 0.309670, 
-0.185110, 0.577520, 0.089560, -0.042300, -0.065260, 0.215360, 0.050270, 0.495130, 0.107960, 0.327780, 
-0.092220, 0.293240, 0.463760, -0.321700, -0.005980, 0.062440, -0.335000, 0.101510, -0.165280, 0.257780, 
0.194180, -0.341330, 0.206340, -0.121090, 0.051040, -0.072330, 0.380390, -0.353430, 0.135200, 0.087880, 
-0.073320, -0.233440, -0.565800, -0.300240, -0.661050, 0.091640, 0.146790, -0.385550, 0.433480, -0.143780, 
0.031210, 0.368870, 0.062400, 0.035890, -0.497840, -0.138290, -0.054840, -0.323940, -0.556690, -0.457870, 
-0.017030, 0.497330, -0.523330, -0.259280, -0.559970, -0.133950, 0.105370, 0.190660, -0.712190, -0.130410, 
-0.150550, -0.248480, 0.113250, 0.239340, 0.111630, -0.096120, -0.394360, -0.042460, 1.362330, 0.576030, 
0.445120, 0.797940, 0.471600, 0.759100, 0.499620, 0.030630, 0.085190, 0.083680, 0.579270, 0.130890, 
0.026390, 0.001720, 0.769110, 0.262960, -0.328460, 0.231090, -0.034730, -0.247350, 0.006850, 1.731640, 
-0.269350, -0.431360, 0.624360, -0.157460, 0.502660, 0.846400, -0.300110, -0.243640, 0.612820, 0.707270, 
0.442170, 0.033390, 0.067940, -0.277030, 0.127900, -0.047770, 0.230770, 0.382010, 0.171580, -0.083400, 
1.529790, -0.638980, -0.560230, -0.530320, 0.677690, -0.230460, -0.628910, -0.180380, 0.236240, 0.559430, 
1.259150, -0.586950, -0.160270, 0.267040, -0.727290, 0.187910, 0.293330, 0.343090, -0.069660, -0.088230, 
-0.088130, 1.265840, 0.136380, 0.281610, -0.414050, 0.538020, 0.775200, -0.098850, -0.427800, -0.044930, 
0.782020, 0.925210, 0.283730, 0.360150, 0.557630, -0.956940, -0.063730, -0.496940, 0.329580, -0.004220, 
0.300560, -0.122570, 1.451430, 1.356690, 0.121180, 0.120920, 0.174270, 0.809140, 0.686420, 0.378150, 
0.447980, -0.041380, 0.376260, 0.681260, 0.378840, -0.109060, -0.516980, 0.216510, 0.144460, 0.426770, 
-0.100320, -0.536380, -0.211080, 0.898910, 0.391280, 0.219710, -0.232520, 0.438840, 0.378460, 0.339120, 
-0.580860, 0.519390, 0.520400, 1.183390, 0.186580, 0.392320, 0.172960, -1.235340, 0.057200, -0.289140, 
0.247600, 0.384220, -0.245220, -0.154350, 1.283550, -0.316600, -0.231360, -0.609190, 0.650790, -0.001210, 
-0.668340, 0.047020, 0.124350, 0.017180, 1.230250, -0.275940, 0.546830, 0.304620, -0.444060, -0.132030, 
-0.011490, 0.467400, 0.341420, -0.365750, -0.168030, 0.727320, 0.294750, 0.236800, -0.008520, 0.800150, 
0.343430, 0.028070, 0.220410, 0.573910, -0.087870, 0.147710, 0.812410, 0.221520, 0.463870, -0.467270, 
-0.075570, -0.283630, -0.096060, 0.348360, -0.577730, -0.210660, 1.042810, -0.093540, -0.064080, -0.347170, 
0.763890, 0.387850, 0.332670, 0.138130, 0.449140, -0.245790, 0.122080, 0.027120, 0.216680, 0.165920, 
-0.124570, 0.171780, 0.059010, 0.316140, -0.018610, -0.336360, -0.174920, 
-0.171100, -0.231310, -0.085350, 0.004390, 0.079940, -0.146530, -0.124040, -0.100200, 0.034900, -0.265400, 
0.056580, -0.094880, 0.264430, 0.089260, -0.096770, 0.162610, -0.024680, -0.104560, -0.231500, 0.101490, 
0.003920, -0.016300, -0.018520, 0.219050, -0.060150, 0.019770, -0.201150, -0.425990, 0.084670, 0.029240, 
-0.174440, 0.025520, 0.075330, 0.187900, 0.154260, -0.182350, -0.014180, 0.082860, -0.072570, 0.445280, 
-0.031670, 0.004790, -0.028820, 0.176020, -0.543270, -0.178970, -0.093850, -0.210900, -0.227260, -0.068520, 
-0.105980, 0.252310, 0.028690, 0.114760, -0.559890, 0.263470, -0.464800, 0.314810, 0.224030, -0.077560, 
-0.243940, 0.154370, 0.022040, -0.256930, -0.041730, -0.031420, 0.005340, -0.201810, -0.258730, 0.071620, 
0.026480, 0.023220, 0.064270, 0.050640, -0.320830, -0.334970, -0.128420, 0.165470, 0.044660, -0.373240, 
-0.128430, -0.185110, 0.292910, 0.011470, -0.054260, -0.038900, 0.444240, -0.268440, 0.315270, -0.271650, 
0.017210, -0.144110, -0.176920, 0.092220, 0.097770, -0.121050, -0.412220, -0.298360, -0.046330, 0.255100, 
-0.069620, 0.339930, 0.285470, 0.053060, 0.006310, 0.073070, 0.072110, -0.106670, -0.219840, 0.077150, 
-0.007740, 0.077430, 0.130420, -0.068390, 0.356090, 0.221260, 0.286950, 0.084740, -0.015210, -0.111340, 
0.390860, -0.155100, -0.127810, -0.220500, 0.257890, 0.003890, 0.281070, -0.131430, -0.053380, 0.059260, 
-0.161660, -0.188610, -0.145630, 0.391800, -0.285490, -0.038550, 0.040720, 0.071900, 0.256070, 0.044190, 
0.212190, 0.157140, -0.152150, -0.161240, 0.126060, 0.310450, 0.007420, 0.039710, -0.085400, 0.039340, 
-0.299460, 0.156220, -0.217720, -0.186860, -0.100870, -0.367110, -0.368060, -0.284940, -0.267760, -0.170560, 
0.281340, 0.111940, 0.090750, -0.346220, -0.005000, 0.107440, 0.263880, 0.003020, -0.110320, -0.576510, 
0.007160, 0.028210, -0.027140, 0.173990, -0.209710, -0.334520, 0.039900, -0.049070, -0.077720, -0.188660, 
0.005400, 0.260320, 0.539880, -0.126320, -0.250060, 0.265480, 0.257480, 0.159950, 0.006860, -0.298730, 
0.013660, -0.105260, 0.214470, 0.604000, 0.122200, 0.099750, 0.320930, 0.519490, 0.434110, 0.390040, 
0.128050, 0.159580, 0.680050, 0.239270, -0.074720, -0.120530, 0.413490, 0.548910, 0.450860, 0.279720, 
0.031230, 0.212780, 0.093810, 0.268920, 0.649090, -0.058710, 0.207740, 0.263770, -0.010540, 0.446260, 
0.428300, 0.107040, -0.081170, 0.493610, 0.510180, 0.053250, 0.225760, 0.344140, 0.554130, 0.529890, 
0.247030, 0.305320, 0.326090, 0.192970, -0.022710, 0.719990, 0.090250, 0.126650, 0.552850, 0.074110, 
0.020040, 0.084980, 0.432780, 0.072120, -0.062840, 0.455180, -0.041390, 0.241250, 0.305660, 0.085070, 
0.200640, 0.185710, 0.140580, 0.178380, 0.069460, 0.112590, 0.114980, 0.108500, 0.093400, 0.371140, 
0.054870, 0.087620, 0.063590, 0.351060, 0.113770, 0.340330, 0.459500, 0.095340, 0.060280, 0.274690, 
0.140640, 0.056850, 0.188340, 0.056450, 0.081470, -0.002120, 0.256040, 0.162950, 0.184770, 0.329370, 
0.264570, 0.156590, 0.188780, 0.063390, 0.281680, 0.145020, 0.241410, 0.299720, 0.133860, 0.200420, 
0.299170, -0.077940, 0.217020, 0.197720, -0.007880, 0.016770, -0.017940, 0.453670, 0.042220, -0.016930, 
0.162950, 0.274470, 0.464700, 0.204850, 0.155370, -0.118950, 0.010430, 0.240080, 0.199640, 0.010230, 
0.140880, 0.322640, -0.047560, 0.177010, 0.165130, 0.087680, -0.054810, -0.108920, 0.315900, -0.012390, 
0.004040, 0.145040, 0.152660, 0.093960, 0.144300, 0.175850, 0.047840, 0.038570, 0.182270, 0.239690, 
-0.012370, 0.204760, 0.482010, 0.132110, 0.226370, 0.139800, 0.102160, 0.145550, 0.129340, 0.131500, 
0.288660, 0.054840, 0.159810, 0.425840, 0.068530, 0.019320, 0.037600, 0.154050, -0.041020, 0.110460, 
0.299210, -0.035830, 0.137160, 0.271830, -0.096840, 0.013130, 0.147750, 
0.356710, 0.018360, -0.224650, -0.048480, 0.637130, 0.020590, -0.419740, 0.107790, -0.229310, -0.184690, 
0.010740, 0.088120, 0.750720, -0.030450, 0.014210, -0.105780, 0.080520, -0.112120, -0.087320, 0.004400, 
-0.066630, -0.066160, 0.202900, 0.370180, -0.501720, 0.285390, 0.327950, 0.042910, -0.140350, -0.063980, 
0.261960, 0.322080, -0.347060, 0.669470, -0.090980, -0.701220, 0.022610, 0.015270, 0.137250, -0.289300, 
0.254320, -0.068630, -0.103210, -0.527980, -0.121200, -0.648790, 0.426300, -0.309380, -0.523190, 0.086830, 
-0.048020, 0.077160, 0.217790, -1.110830, 0.501420, 0.184490, -0.651620, 0.003390, 0.413920, 0.773800, 
0.051800, 0.231200, -0.099470, 0.348400, -0.096280, 0.485720, -0.535270, 0.288460, -0.145590, -0.842040, 
0.317930, 0.014730, 0.335990, 0.396920, -0.632790, 0.053360, 0.249500, -0.565930, 0.396620, 0.329310, 
0.194190, -0.100670, 0.037770, -0.081710, 0.482190, 0.072980, -0.051370, -0.009410, 0.012090, -0.285690, 
-0.040170, -0.045910, -0.552150, -0.239500, 0.347490, -0.290590, 0.428930, -0.046750, -0.664860, 0.088940, 
-0.084870, -0.140290, -0.492300, -0.524960, -0.086390, 0.822650, -0.147530, -0.275000, -0.024200, 0.087740, 
-0.257560, 0.233010, -0.300690, 0.082410, -0.164350, 0.730240, -0.463100, -0.137800, -0.286120, -0.578480, 
-0.007410, -0.214820, 0.551990, 0.122340, -0.731600, -0.071140, 0.926400, -0.371410, -0.108360, -0.265180, 
0.275790, -0.218760, -0.273350, -0.496070, -0.178290, -0.005750, 1.019310, -0.911510, -0.013130, -0.010660, 
-0.316430, 0.424090, -0.397190, 0.627770, 0.160920, -0.592490, -0.047670, 0.699340, 0.277880, 0.015910, 
0.048990, 0.273730, -0.019730, -0.228400, -0.937930, -0.679600, 0.156780, 1.333780, -0.169290, 0.076210, 
0.022010, -0.198460, 0.152380, 0.148090, 0.539950, -0.079640, -0.679300, -0.055080, 1.689230, 0.627090, 
-0.615420, -0.126790, -0.165880, 0.041790, 0.125810, -0.387300, -0.133800, 0.501150, 0.924080, 0.067910, 
0.390620, 0.071020, -0.106140, -0.097100, -0.626750, 0.448450, -0.167030, -0.595100, -0.006530, 1.577140, 
0.573960, -0.117960, -0.457310, 0.036630, 0.387200, 0.242820, -0.777870, 0.061160, 0.443460, 1.462410, 
-0.074250, 0.175960, 0.284490, -0.349460, 0.137740, 0.092930, 1.226210, 0.449580, -0.671230, -0.027260, 
1.259110, -0.399690, 0.189370, -0.708130, 0.083890, 0.569630, -0.116440, 0.566660, -0.216800, -0.116800, 
0.732470, -0.044180, 0.525160, 0.125080, -0.895610, -0.136530, -0.431040, 0.256780, -0.131030, -0.634030, 
-0.063500, 1.600180, -0.159700, -0.052400, -0.587600, -0.096810, 0.150070, -0.049210, 0.362500, 0.141260, 
0.211040, 0.886550, -0.258320, 0.288680, -0.567730, -1.328650, -0.289440, -0.262440, 0.088270, -0.425880, 
-0.202450, -0.121170, 0.930370, -0.252640, 0.405660, -0.365000, 0.388670, 0.188760, 0.087960, 0.140850, 
0.043370, 0.470350, 1.010340, 0.015160, 0.669640, -0.026690, -0.503660, -0.335740, -0.072210, 0.139890, 
0.092830, 0.119000, -0.186920, 0.670380, 0.164690, -0.168540, -0.244870, 0.228440, 0.429580, -0.273080, 
0.096530, 0.410920, 0.019790, 0.912600, -0.039610, -0.003700, -0.101700, -0.011860, -0.172520, -0.974030, 
0.042630, -0.136080, -0.697090, -0.184000, 1.150950, -0.012270, -0.308670, -0.113930, -0.029650, 0.245710, 
0.227560, 0.179130, -0.158950, 0.236260, 0.662680, 0.091700, 0.216890, -0.178880, -0.227060, -0.024010, 
-0.728670, 0.011250, 0.124750, 0.133680, -0.209060, 0.450520, 0.379640, -0.568130, -0.327870, 0.347070, 
0.146410, -0.148660, -0.049330, 0.087930, 0.026530, 0.317610, 0.149160, 0.365280, -0.123060, -0.116750, 
-0.303760, -1.185010, 0.099340, 0.345690, -0.304510, -0.211740, 0.186780, -0.152030, -0.317340, 0.067450, 
0.168410, -0.008010, -0.096470, -0.168700, 0.372730, 0.462800, 0.475420, 0.098960, 0.020190, 0.180270, 
0.076140, -0.423730, -0.560730, -0.381790, 0.335180, 0.083180, -0.226500, 
0.079750, 0.291360, -0.044450, 0.130850, 0.106300, 0.212450, 0.140720, 0.652920, 0.349110, 0.142860, 
0.322650, 0.163360, -0.029580, -0.126000, 0.055840, 0.011150, -0.217790, -0.258090, -0.333520, 0.284250, 
0.002880, -0.445470, -0.149570, -0.276610, 0.304530, -0.234660, 0.258280, 0.141460, 0.076270, -0.147660, 
0.400120, -0.000100, -0.228460, 0.512850, -0.054750, 0.226710, -0.126240, -0.233580, -0.579370, -0.261070, 
0.349090, -0.004120, -0.404540, 0.048350, -0.447420, 0.090560, 0.183870, -0.076160, -0.242610, 0.256340, 
-0.432990, 0.027120, -0.143040, -0.102340, -0.238500, -0.457240, -0.103320, -0.148350, 0.164580, -0.026630, 
-0.286710, -0.166050, -0.017670, -0.103960, -0.202380, 0.146080, 0.017850, 0.399080, 0.339990, -0.257180, 
-0.201480, 0.000120, -0.081130, -0.173120, -0.348330, 0.183070, -0.178550, 0.065520, -0.418630, 0.076140, 
-0.244700, -0.058570, 0.266050, 0.002840, -0.130120, 0.389830, 0.265100, -0.336920, 0.325590, -0.136000, 
0.078670, 0.049060, 0.270060, -0.585940, -0.288940, -0.478390, 0.006780, 0.206210, -0.276340, 0.315450, 
0.200370, 0.074060, 0.294300, -0.473680, 0.019360, -0.395220, -0.437980, -0.129470, -0.360590, 0.065790, 
-0.092380, -0.450820, -0.328380, 0.140960, 0.396070, -0.261750, 0.087540, -0.125500, 0.074790, -0.263790, 
-0.413620, -0.644840, -0.275960, -0.094790, 0.032070, 0.023310, -0.580410, -0.184140, 0.273360, -0.002810, 
0.096970, 0.010850, 0.031110, -0.023940, -0.066990, -0.084570, -0.438580, -0.227380, 0.337220, -0.234690, 
0.503340, -0.177440, 0.086420, 0.312780, 0.143110, 0.017510, 0.018910, -0.202120, -0.475090, -0.740930, 
-0.621610, 0.485770, -0.614990, -0.159310, -0.560680, -0.663370, 0.279490, 0.449600, -0.394960, -0.235630, 
0.427960, -0.427100, -0.373290, -0.021070, -0.157590, -0.079390, 0.663740, 0.015580, -1.051110, 0.191230, 
0.263630, 0.962450, -0.214670, -0.313940, -0.279620, 0.262280, -0.091730, -0.815240, -0.489850, 0.171870, 
-0.204980, -0.142640, 1.330950, 0.504260, 0.461830, -0.201840, 0.020890, -0.765200, 0.006350, 0.070960, 
-0.123610, -0.533030, -0.164080, 0.389430, -0.055690, 0.059880, -0.098570, -0.258690, 0.429660, 0.561060, 
0.440650, 0.237370, 0.376180, 1.126130, -0.164340, -0.121200, -0.017090, -0.355170, 0.304270, 0.075340, 
0.011010, 0.372700, 0.224830, 1.100040, -0.083410, 0.019290, 0.413840, 0.620390, 0.561950, 0.308640, 
-0.476830, 0.866800, -0.219700, 0.038640, 0.500950, 0.734560, 0.874880, 0.266100, 0.001050, 0.454200, 
0.049880, 0.042440, 0.081700, 0.164090, 0.799940, -0.124780, 0.266810, 0.879570, 0.455080, 0.139500, 
0.238490, 0.077870, 0.405330, -0.107940, 0.210940, -0.280600, -0.298170, 0.184930, 0.334720, -0.096340, 
0.327340, 0.103560, 0.352680, -0.167270, 0.004130, 0.414500, -0.123140, -0.105150, 0.423380, 0.355840, 
-0.188130, 0.316430, 0.447660, 0.053250, -0.316100, 0.321510, 0.078300, 0.346020, -0.182220, 0.364810, 
-0.123400, -0.009830, 0.080920, 0.075180, 0.160850, -0.173570, 0.594560, -0.293510, -0.220990, 0.465470, 
0.347020, 0.439760, -0.025890, 0.000950, 0.096910, -0.208910, 0.002980, 0.073110, 0.104540, 0.262080, 
0.348030, -0.113240, 0.047900, 0.080800, 0.231170, 0.329160, -0.121660, 0.117440, 0.051790, 0.398630, 
0.228330, 0.705930, -0.026470, 0.385520, 0.358430, 0.385540, 0.752010, -0.374930, -0.000200, 0.038840, 
0.010970, 0.399740, 0.272690, -0.123950, 0.086840, 0.589500, 0.327920, 0.059470, -0.057430, 0.159130, 
0.123150, 0.356450, 0.048130, 0.307140, 0.122790, -0.213280, -0.118210, -0.260410, 0.151180, -0.135570, 
0.245220, -0.121930, 0.188910, 0.065490, 0.137080, 0.066340, -0.092650, 0.585860, -0.209560, 0.070940, 
0.005880, -0.040830, 0.123080, 0.440040, -0.595880, 0.562160, -0.026610, -0.063410, 0.341660, -0.020820, 
-0.162390, -0.238340, -0.064150, 0.577060, -0.143180, 0.279060, 0.031430, 
0.219770, -0.070300, -0.346140, 0.263540, 0.785250, -0.101370, 0.011750, 0.256590, -0.168800, 0.017450, 
-0.279650, 0.165780, -0.326430, -0.063190, -0.120650, 0.326790, 0.095810, 0.245010, 0.446060, 0.094230, 
-0.010850, 0.489520, -0.583460, 0.083470, 0.024170, 0.146850, -0.184730, -0.070250, 0.267160, -0.093740, 
0.190570, 0.137360, -0.537290, 0.228510, 0.548590, 0.466880, 0.310330, 0.192280, -0.430050, 0.276410, 
0.041710, 0.011420, 0.293650, 0.099320, 0.016140, 0.245860, 0.278090, -0.409820, -0.152920, 0.164580, 
-0.117940, 0.086210, 0.195130, 0.116220, -0.423710, 0.328830, -0.297280, -0.046410, -0.106790, -0.118710, 
0.396220, 0.374350, 0.034520, 0.950140, 0.053950, 0.243060, -0.433720, 0.279730, -0.318580, 0.313060, 
-0.198220, -0.337660, 1.039590, 0.270560, 0.684720, 0.065480, -0.079180, -0.397410, 0.308770, -0.055260, 
0.120730, 0.082080, 1.362330, 0.077700, 0.424910, 0.132610, 0.214990, 0.294180, 0.132250, -0.147010, 
-0.265970, -0.071280, 0.376070, 0.646350, 0.351710, 0.103900, -0.427250, 0.231740, -0.180920, -0.104350, 
0.111320, 0.149440, 0.072850, 0.468640, 0.114350, 0.152140, 0.040160, 0.289160, 0.412990, 0.102050, 
0.340430, 0.236810, -0.476690, 0.326670, 0.176660, 0.415850, 0.514250, -0.107850, 0.316370, 0.494680, 
0.024310, 0.368170, -0.491150, 0.621670, 0.371720, 0.094220, 0.169530, 0.002410, 1.007910, 0.672400, 
0.391580, 0.364740, 0.077070, 0.355970, -0.119700, 0.504320, 0.149910, 0.820290, 0.167990, 0.548860, 
0.080880, 0.717640, -0.081050, 0.898180, 0.772210, 0.100920, 0.094600, -0.084820, 0.395420, 0.255680, 
0.550340, 0.501630, -0.408800, -0.166000, 0.616150, 0.172110, 0.243240, 0.237790, 0.195040, -0.267130, 
-0.258400, 1.019450, -0.203270, -0.234500, 0.476220, -0.557490, 0.349310, 0.159760, 0.125020, 0.797180, 
0.900360, 1.424090, 0.107280, 0.323290, -0.251350, 1.154420, 0.154120, -0.184210, 0.067700, 0.743050, 
0.259040, 0.010910, 0.337080, 0.089920, 0.087130, 0.373780, 0.470840, 0.171160, -0.000470, -0.374130, 
0.156560, 0.098710, -0.037830, -0.187150, 0.070570, -0.491480, 0.725190, 0.894300, 0.239200, 0.063840, 
0.451750, -0.096190, 0.001490, -0.472870, 0.010800, 0.254270, 0.349760, 0.235550, 0.445500, 0.013990, 
-0.235570, 0.358190, -0.453670, -0.549590, 0.852010, -0.043710, -0.018600, -0.216480, -0.645220, 0.496200, 
0.431110, 0.735480, -0.213230, -0.111480, -0.453080, 0.057790, -0.307130, -0.141280, -0.620990, 0.395700, 
0.020740, -0.335990, 0.040600, -0.097080, -0.201470, 0.505080, -0.626110, -0.608470, -0.517160, 0.205700, 
0.385730, 0.260360, -0.017740, -0.133610, 0.540290, 0.162320, 0.111240, 0.084320, 0.178220, 0.944120, 
0.557440, 0.017690, -0.195300, -0.135190, -0.180600, -0.092990, 0.671620, -0.542080, -0.327630, -0.063530, 
-0.435080, 0.752940, 0.282190, -0.326710, 0.288030, 0.492310, -0.391950, -0.115860, 0.088480, -0.297140, 
-0.152750, 0.682680, 0.003100, -0.391010, -0.087820, -0.130440, -0.004770, -0.131020, -0.386630, 0.307060, 
0.213870, 0.240910, 0.258460, -0.553690, -0.224530, 0.162110, 0.475170, -0.421370, 0.399350, -0.173180, 
-0.550260, 0.498250, 0.060940, -0.007620, -0.483350, 0.126100, -0.033270, -0.474210, 0.123320, -0.070700, 
-0.771440, -0.096030, -0.176330, 0.102610, -0.124660, -0.078990, -0.123700, 0.361150, -0.671060, 0.355070, 
0.029310, -0.312760, 0.323950, -0.110410, -0.029870, 0.159920, -0.705360, -0.346890, -0.272420, 0.512870, 
0.322820, -0.322610, 0.419080, -0.249540, -0.042640, -0.441860, -0.564620, -0.068260, -0.307930, 0.503030, 
-0.304870, 0.126600, -1.085740, -0.055640, 0.308330, -0.058430, -0.246090, 0.268540, 0.054290, -0.193890, 
0.019570, -0.239770, -0.146550, -0.297900, -0.061120, 0.114470, 0.211590, -0.269340, -0.404400, -0.073910, 
0.423650, -0.277160, -0.256620, 0.512040, 0.227630, 0.049040, -0.087120, 
0.133920, 0.000020, -0.372370, -0.158990, -0.063450, -0.219620, -0.050720, -0.342420, -0.390610, -0.054960, 
-0.362890, 0.128640, -0.100690, -0.001820, 0.403240, -0.318750, -0.347900, -0.024430, 0.397040, -0.005330, 
0.024960, 0.440060, -0.301100, -0.235260, 0.099380, 0.254250, 0.106340, -0.092990, -0.422550, 0.550210, 
0.019880, -0.072590, -0.393630, -0.159840, -0.144860, -0.322660, 0.596220, 0.331570, 0.020300, 0.344080, 
0.107860, 0.024710, 0.192340, -0.080240, -0.176060, 0.204420, 0.790010, -0.203040, 0.291600, -0.007270, 
-0.223460, -0.075100, -0.214020, 0.181400, 0.023830, -0.113980, 0.541610, 0.105270, 0.212830, 0.382480, 
-0.232010, 0.160050, 0.062050, 0.283270, 0.196960, 0.488830, 0.214100, 0.141120, -0.071330, -0.513400, 
0.154950, -0.111690, 0.327780, 0.237860, 0.340590, 0.170730, 0.410890, 0.186770, 0.524750, -0.060030, 
0.384190, -0.072610, 0.165870, 0.072350, 0.246160, -0.096760, 0.186370, 0.093330, 0.344830, 0.058630, 
0.259320, 0.019320, 0.368500, 0.212430, 0.113900, 0.059670, -0.282620, 0.128730, 0.431680, 0.005620, 
-0.145410, -0.260190, 0.422800, -0.114040, 0.055590, 0.221320, 0.214590, 0.248690, 0.042910, 0.076320, 
-0.127560, -0.209740, 0.201270, -0.110070, -0.142810, 0.446790, 0.162030, -0.220200, 0.180590, 0.303920, 
-0.163550, 0.006890, 0.445240, 0.047320, 0.055460, 0.027370, -0.062520, 0.242110, 0.298300, 0.683720, 
-0.111430, 0.363250, 0.248380, 0.889440, 0.461310, 0.149810, 0.423290, 0.700830, 0.173730, 0.612790, 
-0.083290, 0.135080, 0.396950, -0.089680, 0.361900, -0.210990, 0.046020, -0.283120, 0.489310, 0.435750, 
-0.032800, 0.525110, 0.665810, 0.047470, 1.067030, 0.457990, -0.230710, -0.161590, 0.177580, 0.417590, 
-0.091030, 0.255760, 0.088670, 0.238650, 0.098480, -0.082510, 0.237470, 0.040820, -0.541170, 0.363380, 
-0.164370, -0.223260, 0.061510, 0.553520, -0.344550, 0.962260, 0.376330, -0.500710, -0.700910, 0.146870, 
0.017000, -0.042950, 0.162000, 0.165430, 0.392310, 0.315670, 0.220490, -0.087590, 0.009640, 0.016550, 
0.142950, -0.781290, -0.895600, -0.122880, 0.305120, -0.032840, 0.236970, 0.458180, 0.769910, -0.114560, 
-0.148820, 0.608380, 0.241610, -0.724430, -0.302120, 0.032740, 0.246610, -0.464000, 0.821350, 0.007300, 
-0.760070, 1.061270, -0.180590, -0.323290, 0.363970, -0.359520, -0.119660, -0.603930, 0.282330, 0.595450, 
-0.175290, -0.092120, 0.047400, -0.009600, 0.205040, 0.522000, 0.843700, 0.156660, 0.279120, 0.225150, 
0.023050, -0.284050, -0.633810, -0.805490, -1.124330, 0.806060, -0.559480, -0.737920, -0.036210, -0.734700, 
0.528440, 0.125120, -0.812550, 0.443800, -0.536940, -0.027350, -1.012200, -0.645230, 0.160320, -0.579460, 
1.294480, 0.035460, -0.867310, 0.300740, 0.060930, -0.134070, -0.093160, 0.241860, 0.315100, -0.460110, 
0.583740, 0.275460, -0.327850, -0.192130, 0.144810, 0.256820, -0.547770, 0.165730, 0.391260, 0.121970, 
0.234550, 0.357440, 0.020920, -0.934360, -0.311880, -0.668250, -0.254920, 0.410310, -0.410540, -0.613780, 
-0.528790, -0.187840, 0.296900, -0.145650, -0.137240, 0.063520, -0.165720, -0.039280, -0.116620, -0.286790, 
-0.227710, -0.112660, 0.249850, 0.000900, -0.782760, -0.953800, 0.314050, 0.374750, 0.077150, -0.367690, 
-0.579900, 0.106630, -0.183740, -0.296700, -0.578750, -0.634480, -0.587110, -0.427620, 0.544830, -0.195520, 
0.364390, 0.053740, 0.229610, 0.479720, 0.000820, -0.460470, -0.054340, -0.111260, 0.336740, 0.191100, 
-0.366670, 0.123040, 0.645370, -0.513340, 0.037610, -0.029650, -0.108870, 0.056640, 0.057030, 0.153320, 
0.501740, 0.279150, 0.342650, -0.148950, 0.009030, 0.022700, -0.259070, -0.073610, 0.121170, 0.562530, 
-0.075710, -0.276180, -0.292700, 0.553540, 0.158760, -0.197800, -0.162420, -0.054450, -0.328930, 0.234980, 
0.499220, 0.432820, 0.142100, -0.242560, 0.380640, -0.086830, 0.052720, 
0.395790, 0.502350, -0.213210, -0.132380, -0.190370, 0.403590, -0.086610, -0.027760, -0.237000, 0.396510, 
0.323440, 0.145850, -0.081780, 0.008160, -0.517280, 0.540310, 0.409670, 0.581390, 0.127960, 0.263580, 
-0.096230, 0.001760, -0.213320, -0.257410, 0.068720, 0.103130, 0.256200, -0.007430, 1.084480, -0.025360, 
-0.107040, -0.373560, 0.170960, -0.138610, 0.094480, -0.139350, 0.167910, -0.046030, -0.112000, 0.206620, 
0.199460, -0.134150, 0.034910, 0.379260, 0.390130, -0.132660, -0.038960, 0.229170, 0.419330, 0.397560, 
0.044510, 0.214210, 0.631360, 0.710510, -0.039130, 0.074120, -0.617690, 0.311630, 0.151850, -0.040000, 
-0.553500, 0.420870, -0.150890, -0.592730, 0.313850, 0.262740, 0.058880, -0.168760, -0.137610, -0.645750, 
1.170210, 0.404890, 0.196700, -0.280840, 0.677500, -0.031430, 0.159630, 0.554640, 0.152440, 0.446530, 
-0.003180, 0.389030, -0.278260, -0.121810, -0.585610, -0.441590, -0.062370, 0.675970, 0.284830, -0.143200, 
-0.368290, 1.172680, 0.187660, 0.063070, -0.343430, 0.405730, -0.316660, -0.365980, -0.198520, -0.118710, 
-0.133330, 0.460720, 0.045690, 0.184720, -0.143170, -1.184910, 0.017410, 0.236090, -0.188600, -0.457410, 
0.018200, -0.199370, 0.752150, -0.056630, 0.402890, -0.843970, 0.305090, -0.386600, -0.313370, -0.208600, 
-0.084560, 0.783650, 0.392910, -0.085020, 0.240710, -0.156770, -0.127350, 0.337770, 0.080200, -0.656000, 
0.160740, 0.155970, -0.753110, -0.042160, -0.245120, 0.814650, -0.305760, -0.205350, 0.224710, 0.262090, 
-0.327740, -0.079650, 0.326130, 0.124830, 0.128740, 0.872290, -0.103220, -0.872520, 0.594640, -0.243820, 
-0.435820, 0.324160, 0.559800, 0.661150, -0.346230, 0.540940, 0.295350, -0.641760, 0.074010, 0.142210, 
-0.042740, -0.409760, 0.753880, 1.375830, 0.510110, 0.191100, 1.084410, -0.075830, -0.204820, -0.447560, 
-0.991280, -0.383830, 0.415280, -1.251080, -0.785620, 0.503670, -0.587890, 0.901640, -0.393500, -0.980860, 
-0.478430, 0.757910, -0.247330, -0.367440, -0.124910, 0.901530, 0.630790, 1.460320, -0.007080, -1.133350, 
0.423920, -0.191660, 0.113640, -0.322000, 0.471890, 0.817210, -0.792340, 0.367390, 0.653160, -0.333660, 
0.417370, -0.144590, -0.164040, -1.065530, 0.014630, 0.633970, 0.258790, 0.872020, 1.218660, -0.056330, 
-0.816060, -0.117570, -0.528070, -0.242060, 0.338610, -0.496470, -0.706530, 0.217250, -0.550910, 0.342110, 
0.047730, -0.316350, 0.244750, 0.204820, 1.128330, -0.307900, -0.160010, -0.276100, -0.410390, 0.233960, 
-0.055170, -0.525270, -0.028940, 0.184430, 0.297660, 0.227940, 0.174520, 0.014570, 0.549530, 0.416100, 
0.083400, -0.199580, -0.360340, -0.577260, -0.299370, 0.251140, 0.949190, 0.394170, -0.482220, 0.048450, 
0.463670, -0.066670, -0.363430, -0.338990, -0.574570, 0.632920, 0.350950, -0.219840, -0.550240, 1.341240, 
-0.263560, -0.337620, -0.869000, -0.795030, -0.499540, 0.060100, -0.064310, 0.227110, -0.410370, 0.576630, 
-0.735090, 0.276980, -0.040240, -0.712990, -0.449610, 0.036380, 0.489470, 0.286530, -0.100810, -0.129970, 
0.610070, 0.115480, -0.577080, -0.115280, 0.114550, -0.145960, -0.201110, 0.545110, 0.865110, 0.472560, 
-0.050640, 0.008440, -0.186850, -0.065630, -0.197660, 0.219280, 0.250080, 0.077810, 0.512600, -0.324560, 
0.002390, 0.740390, -0.505990, 0.022050, -0.191210, -0.226750, 0.234050, 0.433790, 0.163950, 0.544260, 
0.020550, 0.141090, -0.069750, 0.073680, -0.070620, -0.815340, 0.212190, 0.127090, 0.178690, 0.573030, 
-0.104430, 0.507330, 0.208400, -0.162830, -0.182640, -0.704870, 0.110600, -0.023180, -0.108340, -0.573060, 
0.244800, -0.195370, 0.055300, 0.187390, 0.313690, -0.106060, -0.401630, 0.561220, -0.074500, -0.320220, 
0.291540, 0.209410, -0.182050, 0.406710, 0.200150, 0.094830, 0.299310, 0.457830, 0.394950, 0.530550, 
0.026030, 0.285120, 0.269520, 0.281970, 0.208010, 0.418320, -0.078600, 
0.103350, -0.044990, -0.039670, 0.461370, -0.041860, 0.327320, 0.087340, 0.145920, -0.116250, 0.268840, 
-0.078470, -0.038680, 0.046450, 0.606990, 0.851100, 0.038300, 0.883930, 0.238970, 0.214600, -0.083760, 
-0.109020, 0.106620, 0.474130, -0.381180, 0.570880, -0.072860, -0.544860, 0.489910, -0.601610, 0.673600, 
-0.329150, -0.341300, -0.054570, 0.173390, 0.658360, -0.129160, 0.100830, 0.055300, 0.932190, -0.379720, 
0.074640, -0.105020, 0.494080, 0.316920, -0.115300, 0.443270, 0.161170, -0.171710, 0.122880, -0.087280, 
-0.015270, 0.381800, 0.199370, 0.041210, 0.130490, -0.081760, 0.016800, -0.223850, -0.523530, -0.186310, 
-0.482790, -0.439440, -0.066890, 0.478880, 0.896870, -0.028620, 0.016530, -0.002270, 0.016230, 0.471080, 
-0.158360, -0.160870, -0.209060, 0.152140, 0.691250, -0.009790, -0.312500, 0.402260, -0.139540, -0.411370, 
0.194130, 0.385280, -0.493680, -0.064960, 0.169870, -0.488180, 0.111620, -0.272920, -0.055130, -0.096840, 
-0.201860, -0.651720, -0.105130, -0.184680, -0.123300, 0.081340, 0.001970, 0.434910, -0.009760, 0.386000, 
-0.219080, 0.535860, 0.048740, -0.746580, -0.052210, -0.183230, 0.234380, -0.195990, -0.449090, 0.112700, 
-0.222260, -0.490480, -0.694760, -0.072930, 0.592920, 0.274180, 0.212600, 0.339210, 0.011330, -0.503020, 
-0.112660, 0.344450, -0.005600, 0.135820, 0.404530, -0.016690, 1.014020, 0.757760, 0.837280, 1.064950, 
0.342720, 0.398800, 1.051980, 0.307000, -0.605530, 0.228010, 0.071260, 1.060350, -0.037060, -0.240220, 
0.952210, -0.203350, -0.283790, 0.024980, 0.063870, 0.091020, -0.036660, 1.351780, 0.088990, 0.104180, 
0.862620, 0.295800, 0.433980, 0.732050, -0.576510, 0.425550, 0.118120, 0.591080, -0.051850, -0.916050, 
-0.046700, -0.201690, 0.426230, -0.067870, 0.478450, 0.207120, -0.201750, -0.040880, 0.906510, -0.383010, 
-0.393820, -0.974740, 0.143470, -0.253690, -0.690880, -0.051580, -0.130210, 0.426850, 1.250100, -0.843070, 
0.899400, 0.197320, -0.181180, -0.427250, -0.746690, 0.687300, 0.089910, -0.537520, -0.000110, 0.492940, 
0.947470, 0.430830, -0.438450, 0.756040, 0.487770, -0.269260, -0.119540, -0.122260, 0.485140, 1.061670, 
0.619660, 0.570540, 0.211190, -0.947080, -0.182430, -0.591690, 0.761910, -0.039110, -0.406460, -0.078190, 
1.833700, 0.988450, 1.350000, 1.054050, -0.551470, 1.657110, 1.721280, 1.089070, 0.171780, 0.336530, 
0.365600, 1.902370, 0.424680, -0.136740, -0.589340, 0.598670, 0.342900, 0.215110, -0.069000, -0.179710, 
-0.037440, 0.836700, 0.206240, 0.475970, -0.120460, 0.173320, 0.681900, 0.637400, -0.670190, 0.462790, 
0.258380, 1.021840, 0.564810, 0.809150, 0.450000, -1.214790, 0.001350, -0.101920, 0.309540, 1.323410, 
-0.344820, -0.091590, 0.247420, 0.392300, -0.002250, -0.694520, 0.590590, -0.145940, -0.347950, 0.016650, 
0.561040, 0.032820, 0.845030, -0.155580, 0.859760, -0.606980, -0.268580, -0.174000, -0.348660, 0.287280, 
-0.192600, -0.554350, -0.125570, 0.074250, 0.507000, 0.751870, 0.510850, -0.037870, -0.089960, -0.081730, 
-0.173390, 0.053780, 0.294050, 0.312670, 0.986030, -0.387260, -0.024810, -0.617810, -0.355630, -0.268260, 
0.658030, -0.335590, -0.350990, -0.145240, 0.640610, 0.449990, -0.296420, 0.132820, 0.028260, 0.313490, 
0.113100, 0.385120, 0.022510, 0.199470, 0.327070, 0.503030, -0.009450, 0.425140, 0.249160, -0.089890, 
-0.249310, 0.236430, -0.227700, -0.432130, -0.164110, 0.167070, -0.317480, 0.383750, -0.270210, 0.073160, 
-0.322030, -0.207630, -0.353040, 0.279890, 0.156270, 0.183180, -0.240490, 0.296860, -0.167050, -0.057060, 
-0.110830, -0.146980, 0.562530, 0.663720, -0.185710, -0.166330, -0.106380, -0.266390, -0.085790, 0.111270, 
-0.680800, -0.376180, -0.070990, -0.116710, 0.127020, 0.157490, 0.340120, -0.141000, 0.202720, 0.192360, 
0.754100, -0.196750, -0.099620, -0.441450, 0.159270, 0.044410, -0.199690, 
0.238070, -0.020800, -0.299040, 0.120300, 0.280460, 0.016580, -0.097310, -0.400420, -0.266100, 0.438610, 
0.268700, -0.251330, 0.200980, 0.224500, -0.683700, -0.375630, -0.056690, -0.492270, -0.781640, 0.239570, 
0.018170, -0.093290, -0.271600, -0.116740, -0.280010, -0.044280, -0.580110, -0.105890, -0.726860, -0.313580, 
-0.064210, -0.310710, -0.019770, -0.164030, -0.130240, -0.211800, -0.474290, -0.131160, 0.475100, -0.476760, 
-0.052130, 0.034580, 0.198700, -0.128820, -0.251430, -0.080220, 0.226010, -0.130910, 0.074540, 0.205270, 
-0.285470, -0.075220, -0.490260, -0.163040, -0.128540, -0.124780, -0.301010, -0.142370, -0.116460, 0.296290, 
-0.308910, -0.098260, 0.018910, 0.198470, 0.400500, 0.138190, 0.329290, 0.841340, 0.435730, -0.034370, 
-0.297590, 0.260170, 0.124690, -0.185970, 0.112710, 0.528700, -0.122550, -0.217180, 0.121290, -0.403850, 
-0.115030, -0.412130, -0.149820, 0.028280, 0.278740, 0.021050, 0.030310, -0.112050, 0.425740, -0.087380, 
-0.065470, -0.553430, 0.307220, 0.098540, -0.085200, 0.020400, 0.172020, 0.024290, 0.549780, 0.238000, 
-0.161320, -0.272180, -0.390200, 0.093030, 0.047240, -0.244400, -0.294600, 0.086220, -0.355830, 0.274310, 
-0.131520, -0.084650, -0.162100, 0.561510, 0.019840, 0.364880, -0.179040, -0.118740, 0.164350, 0.001600, 
-0.358810, 0.100070, 0.063900, 0.381100, 0.110410, 0.036080, -0.164180, 0.203290, 0.476960, 0.188650, 
0.055540, -0.137390, -0.043180, 0.827900, 0.204910, -0.495440, -0.214050, 0.387150, -0.052420, -0.673030, 
1.298310, -0.167180, -0.345970, -0.233280, -0.861100, -0.453390, 0.033160, -0.321820, -0.138410, 0.197700, 
-0.146800, 0.472230, -0.184810, -0.230770, 0.047070, 0.365070, -0.211360, 0.205060, 0.493230, 0.027160, 
-0.147040, 0.886840, -0.483730, -0.227210, -0.123240, 0.064820, -0.413950, 0.034600, -0.160100, 0.127150, 
0.671660, 0.783200, 0.339080, -0.333070, -0.614970, 0.443020, 0.265180, -0.633910, -0.017490, -0.254320, 
-0.093420, 0.277370, 0.905140, 0.350550, 0.325420, -0.417390, 0.270330, -0.689110, 0.000020, -0.624390, 
0.222080, 0.480570, 0.567850, 0.048820, 0.553300, -0.111360, 1.422930, -0.036490, -0.141870, -0.292340, 
0.598160, -0.053330, -0.533840, 0.726760, 0.337540, 0.241240, -0.424850, -0.704860, -0.225300, 0.065930, 
-0.455640, -0.335710, -0.478890, -0.285560, 0.558990, -0.507950, -0.269310, -0.152000, -0.102960, -0.076670, 
0.066320, 0.131570, -0.360070, -0.266580, 0.045850, -0.204820, 0.084470, 0.723960, 0.379740, -0.099230, 
0.056990, -0.307960, 0.181580, -0.001070, 0.865290, 0.145790, 0.093080, 0.220370, -0.540050, 0.891400, 
0.039270, -0.154770, -0.081060, 0.223110, -0.036370, 0.256620, 0.167800, 0.135100, 0.467560, 0.050090, 
0.125050, 0.043250, -0.234760, 0.424170, -0.232170, -0.001650, 0.016030, -0.073250, 0.225950, -0.446140, 
0.283440, -0.186710, 0.094660, -0.130280, 0.068750, 0.068810, 0.311950, -0.064520, 0.446760, 0.108170, 
-0.211440, -0.199900, 0.037200, 0.216820, 0.139290, -0.109060, 0.087660, 0.422200, -0.376880, 0.197250, 
0.415600, -0.603980, -0.122940, -0.177250, 0.090750, 0.007680, 0.005500, -0.236760, 0.160880, -0.436440, 
-0.087010, -0.295870, -0.181590, 0.046970, -0.032670, -0.148050, 0.154070, -0.031710, 0.099250, 0.162700, 
0.091920, 0.205660, 0.301660, -0.389380, -0.250640, 0.159940, 0.000980, 0.059310, 0.262000, 0.281340, 
0.045720, 0.051300, -0.197710, -0.477140, 0.028040, 0.150630, -0.415350, -0.101210, 0.672750, -0.097190, 
-0.024190, -0.008550, -0.139550, -0.403170, 0.144900, 0.349450, -0.189270, 0.165720, -0.163900, 0.655060, 
-0.284880, -0.056710, 0.136790, -0.071380, -0.152820, 0.018750, 0.067600, 0.326240, 0.035830, 0.234030, 
-0.061630, -0.264720, 0.166260, 0.537560, -0.098700, -0.259630, -0.223580, 0.036060, 0.059580, 0.475490, 
0.283160, -0.059670, -0.308290, 0.928040, 0.434440, 0.018910, 0.017640, 
-0.042830, 0.505080, 0.090690, 0.028600, 0.110300, 0.225540, 0.036340, -0.399510, 0.238980, 0.530900, 
0.208020, -0.095970, -0.205600, 0.070250, 0.347180, 0.565090, 0.386800, -0.263090, -0.246670, -0.166100, 
-0.176900, 0.098550, 0.019230, 0.233980, 0.770170, -0.182340, 0.257940, 0.006270, 0.034540, 0.265360, 
0.401050, 0.272900, 0.404900, -0.373030, -0.302300, 0.170730, -0.118220, 0.224170, -0.090310, -0.439260, 
0.014350, -0.183700, -0.402890, -0.338340, 0.232500, 0.327840, 0.519310, 0.016220, -0.329350, 0.476120, 
-0.225590, 0.627860, 0.216400, -0.051870, -0.047730, -0.066730, -0.307840, -0.187960, -0.191310, -0.472130, 
-0.301590, 0.293890, -0.203590, -0.620870, 0.311860, 0.685170, 0.592470, 0.122260, 0.235300, 0.341210, 
0.839170, 0.897050, -0.316170, -0.249340, 0.960550, -0.420040, -0.390090, 0.438680, 0.173570, 0.389990, 
0.485640, 0.197340, -0.106680, -0.207220, -0.659600, -0.225350, 0.349550, 0.200540, 0.842950, -0.344050, 
-0.610460, 0.258750, -0.076220, 0.542130, -0.149040, -0.069580, 0.216440, 0.309950, -0.488040, -0.249710, 
-0.013930, -0.312200, 0.393430, 0.411080, -0.216280, -0.466040, 0.478790, 0.296790, -0.212540, -0.122180, 
-0.106410, -0.295270, 0.319730, 0.825890, 0.239560, -0.478060, 0.082380, -0.326640, -0.344080, -0.280320, 
-0.169260, 0.437010, -0.452380, 0.072180, 0.518620, -0.182090, -0.379850, -0.321960, -0.881880, -1.052870, 
0.262400, -0.250360, -0.697000, -0.198490, -0.013750, 0.306990, -0.061430, -0.710990, -0.191490, 0.447430, 
-0.186120, -0.457810, 0.396730, 0.333900, 0.121180, 0.623880, -0.163460, -0.714840, 0.370090, -0.814830, 
-0.602550, 0.320490, 0.049520, 0.414110, -1.017770, 0.071630, 1.182340, -0.672560, 0.337820, -0.267290, 
0.603970, -1.145960, 0.022350, 0.335160, 0.042200, 1.004820, 1.555300, -0.135810, -0.435160, 0.239840, 
-0.773840, -0.236880, 0.455880, -0.125710, 0.302190, -0.122590, -0.173950, 0.602200, -0.238670, -0.329140, 
0.054350, 0.158670, -0.521120, -0.092430, -0.423050, 0.687220, -0.332160, 1.206590, -0.001840, -0.608370, 
0.142940, -0.315040, 0.080680, 0.661090, 0.149040, 0.164700, -0.294110, -0.209580, 0.913440, 0.170200, 
0.176290, 0.562430, -0.152410, -0.388020, 0.332960, -0.119660, -0.309560, -0.218210, 1.053790, -0.091840, 
-0.366120, -0.048790, 0.073010, -0.058610, 0.346820, -0.437150, 0.142920, 0.778200, -0.438970, 0.330040, 
0.198190, -0.248850, 0.264810, 0.163560, -0.027100, 0.036030, -0.135680, 0.033790, -0.047290, 0.685500, 
-0.091140, -0.123110, 0.226580, 0.080290, 0.554470, 0.420020, 0.118890, -0.016620, 0.173180, 0.216770, 
-0.028570, -0.301400, -0.418220, 0.560080, 0.269560, -0.064040, 0.877520, 0.462660, -0.278330, -0.051090, 
0.095050, -0.092650, -1.037630, -0.184760, 0.245130, 0.271950, 0.005150, 0.260030, -0.311100, 0.293730, 
0.083140, 0.287960, -0.031060, -0.007760, 0.810880, 0.160320, -0.008360, -0.263460, -0.078660, 1.036960, 
0.109890, -0.081270, -0.062370, -0.531500, -0.018470, 0.307260, 0.176020, 0.142490, -0.211470, -0.316790, 
0.641960, 0.176730, 0.303030, -0.298230, -0.193300, 0.116110, 0.233290, -0.056530, 0.055490, 0.209530, 
-0.000440, 0.249780, 0.308250, -0.083050, -0.342880, 0.343040, -0.198150, 0.108420, -0.102200, -0.046740, 
0.226820, 0.040450, -0.082640, 0.396970, 0.059650, 0.561690, 0.007530, 0.395270, 0.131520, 0.099680, 
0.702010, 0.231620, -0.171910, 0.791930, -0.093970, -0.145800, 0.263830, -0.255490, -0.638380, 0.358720, 
-0.293510, 0.033700, 0.621040, -0.155340, 0.034520, -0.158350, 0.366290, 0.068180, 0.066810, -0.217000, 
-0.005660, 0.193850, -0.286310, -0.017510, 0.276940, -0.110060, -0.475050, -0.101960, 0.353170, 0.000630, 
-0.321950, 0.017710, -0.118360, -0.212270, 0.752720, 0.310950, 0.000500, -0.168110, 0.062570, -0.057060, 
0.190190, -0.252870, -0.064320, 0.464580, 0.225740, 0.502340, -0.085320, 
0.004930, -0.002570, -0.162070, -0.116270, 0.539280, -0.163470, 0.259440, -0.515200, 0.042440, 0.297580, 
0.324100, 0.012450, 0.041640, 0.257260, -0.590300, -0.590130, -0.021980, 0.426300, -0.354840, -0.246790, 
0.040390, -0.047460, 0.387390, -0.431560, 0.137640, -0.112410, 0.112100, 0.152090, -0.729850, 0.303230, 
0.537090, 0.260680, -0.205480, 0.459970, 0.468520, 0.177250, -0.048850, 0.235650, 0.097620, 0.218770, 
0.245340, 0.039210, 0.337090, 0.348820, -0.196380, -0.331900, 0.090640, 0.320180, 0.633140, -0.067110, 
-0.034790, 0.095110, 0.409260, -0.187220, -0.015310, 0.158470, -0.048590, -0.371020, -0.070910, 0.822640, 
-0.168840, -0.099290, 0.045890, 0.561070, 0.300650, -0.006250, -0.077170, 0.443310, 0.439090, 0.415730, 
-0.082910, 0.213230, 0.230290, -0.158500, 0.347880, -0.022900, -0.444920, -0.201620, 0.183770, -0.156270, 
-0.450890, 0.323400, -0.074320, 0.072130, 1.274130, 0.423030, -0.091310, -0.277810, 0.307710, 0.256940, 
-0.450610, -0.145960, -0.454530, 0.022010, 0.518200, 0.209790, 0.350110, 0.256540, -0.556260, 0.598220, 
-0.171820, -0.511140, -0.105780, -0.370710, 0.039260, 0.748740, 0.857650, -0.026970, -0.180150, -0.182000, 
0.267590, 0.414160, -0.605120, 0.037050, -0.008950, 0.252350, 0.765540, 0.312450, 0.422320, -0.250530, 
0.094230, -0.184390, 0.110520, 0.380330, -0.240980, 0.069110, -0.036980, 0.579850, 0.904780, 0.609970, 
0.057680, 0.217180, 0.487790, -0.004520, 0.429500, -0.020340, 0.115450, 0.806400, 0.275850, 0.255710, 
0.182460, 0.015590, 0.366510, -0.338220, 0.072510, -0.118240, 0.081680, 0.030080, 0.030770, 0.548140, 
0.702000, -0.117360, -0.239130, 0.177270, 1.897330, 0.187210, -0.158410, 0.766330, 0.591950, 0.084290, 
0.069210, 0.237980, -0.206010, -0.305180, 0.351880, 0.145440, -0.314690, 0.121330, -0.348530, 0.132710, 
0.950500, 0.468680, 0.302400, -0.168660, -0.558550, 0.404150, 0.407120, 0.004430, 0.488220, 0.262600, 
0.255150, 0.305000, -0.217830, -0.101340, -0.113770, -0.383320, -0.310150, -0.063030, -0.006140, -0.282150, 
-0.220410, -0.182070, 0.234600, -0.533790, 0.037830, -0.519270, -0.487930, -0.333310, 0.329920, 0.379380, 
0.023350, 0.105310, -0.085230, 2.165310, -0.212040, 0.079320, -0.234740, -0.105680, 0.425100, 0.027250, 
-0.661390, 0.029220, 0.183540, 0.521020, -0.080570, -0.255410, -0.016750, 0.302980, 0.277160, -0.149170, 
-0.214010, -0.260140, -0.215080, 0.444000, 0.359380, 0.282870, 0.351500, 0.258050, 0.653010, 0.154390, 
0.042050, 0.113880, -0.469230, -0.531340, -0.077370, 0.359110, -0.463130, -0.167770, -0.406470, 0.036020, 
0.162190, 0.364750, -0.042360, -0.042500, 0.016780, 0.754560, 0.550400, -0.105480, -0.384790, -0.451670, 
0.259930, 0.021000, -0.185060, -0.365920, -0.200670, 0.065080, 0.080500, 0.333680, -0.123510, 0.150530, 
-0.152180, -0.116090, -0.538330, -0.145580, 0.300140, -0.070160, 0.425170, 0.430350, -0.114290, -0.127370, 
-0.186150, 0.092650, 0.010060, 0.190600, -0.105340, -0.308840, -0.152720, 0.345090, 0.059170, 0.085900, 
-0.343390, 0.421740, 0.161410, 0.313210, 0.031320, 0.139360, 0.214530, -0.106700, -0.040370, -0.224420, 
-0.035610, -0.061770, -0.057420, 0.017350, 0.247250, -0.105940, -0.126130, 0.077760, -0.063750, 0.000050, 
0.127030, 0.585120, 0.034650, 0.381610, -0.125450, -0.044930, 0.108080, 0.225820, -0.530100, -0.013820, 
0.445460, 0.267700, -0.342670, 0.335070, 0.027450, 0.505310, 0.176680, -0.112710, 0.099290, -0.150260, 
0.292000, -0.001440, 0.543720, -0.242460, -0.232230, -0.234090, -0.453810, 0.283520, -0.285910, 0.434100, 
-0.198410, 0.145870, 0.284670, 0.045880, -0.067670, 0.028460, -0.548880, 0.653040, -0.155210, -0.230490, 
1.002130, -0.170380, -0.704450, 0.130860, 0.546400, -0.519690, -0.014120, -0.289160, -0.468380, 0.213210, 
-0.119230, -0.356330, -0.449500, -0.246240, 0.232070, -0.250880, 0.017500, 
0.566160, -0.032650, -0.332490, -0.324630, 0.331820, -0.405940, -0.263300, 0.000180, 0.190330, -0.278730, 
-0.161490, -0.024170, -0.275510, 0.183170, -0.233260, -0.086700, -0.131200, 0.269590, -0.344970, 0.237450, 
-0.061180, 0.726410, 0.258460, 0.017390, 0.366040, -0.325130, 0.053430, 0.178060, 0.177710, -0.100710, 
0.205390, 0.390290, 0.560270, -0.023100, 0.040510, -0.142760, 0.509800, 0.508840, 0.175760, 0.211160, 
0.790110, -0.058550, 0.054570, 0.352510, -0.295250, 0.206740, 0.040020, -0.401440, 0.149540, 0.495570, 
-0.157420, -0.191650, 0.172940, 0.215300, 0.003580, 0.235620, -0.317230, 0.017150, -0.276960, -0.092680, 
0.289610, -0.487680, -0.101990, 0.141620, 0.439670, 0.170910, 0.087440, 0.108750, 0.118870, 0.254290, 
1.063270, 0.205470, 0.391230, 0.145390, 0.652400, -0.198760, 0.094630, -0.390980, 0.640850, 0.009510, 
0.097070, 0.080940, 0.044780, -0.116990, -0.223450, 0.279000, 0.006300, 0.321190, 0.452250, 0.297770, 
-0.194690, 0.857570, -0.212000, -0.184520, 0.112710, 0.473260, -0.361800, 0.674700, 0.071680, 0.124860, 
0.646230, -0.313500, -0.206950, -0.373950, -0.115730, -0.259250, 0.251160, 0.579530, 0.430880, 0.102100, 
0.301910, -0.440260, 1.017750, 0.443810, 0.074090, -0.052180, 0.689170, 0.246660, 0.477310, 0.490730, 
-0.019440, 0.336650, -0.184820, -0.179460, -0.084270, -0.110070, -0.870530, -0.090260, 0.570240, 0.350320, 
0.084560, -0.535600, -0.358920, 1.682440, -0.069410, -0.161580, -0.958360, 0.164110, -0.467930, -0.051790, 
0.462040, 0.289720, 0.027380, 0.404170, 0.493790, 0.014880, -0.053510, -0.539450, 0.531750, -0.359630, 
-0.506560, 0.062610, 0.061540, -0.814560, -0.195860, 0.363010, 0.651480, -0.559180, 0.048600, -0.085920, 
0.278160, -0.640680, -0.629070, 0.360520, -0.101590, -0.185980, 1.349600, -0.054420, -0.613740, 0.530800, 
-0.515660, -0.577590, 0.196000, 0.372300, 0.880470, -0.113320, 0.325400, 0.605350, -0.115760, 0.100500, 
-0.162290, -0.051760, -0.133650, 0.701240, 0.618020, 0.365890, 0.244900, 0.886400, -0.004090, 0.061550, 
-0.493420, -1.216730, -0.773130, 0.281120, -0.303700, -0.354010, 0.278140, -0.425940, 1.058300, 0.163790, 
-0.652710, 0.463330, 0.423100, -0.010920, -0.548410, -0.437350, -0.677800, 0.444080, 2.074280, -0.009340, 
-0.473450, 0.217950, 0.266230, 0.194000, -0.293230, 0.014630, 0.899420, -0.329300, 0.153890, 0.370810, 
-0.364260, 0.203520, -0.130440, 0.013750, -0.135030, 0.537560, 0.946220, 0.463080, 0.855350, 0.367780, 
-0.035450, -0.291300, -0.098380, -0.024240, -0.382130, 0.496820, -0.560480, -0.577610, 0.501000, 0.078210, 
-0.109000, 0.289990, -0.892150, 0.177130, -0.056000, -0.439310, -0.626600, -0.118490, 0.001600, -0.137270, 
0.799230, -0.038630, -0.584670, 0.675120, 0.346240, 0.200590, -0.020770, 0.089700, -0.464750, -0.147290, 
-0.122470, -0.191900, 0.025660, -0.133000, -0.281680, 0.111610, 0.582470, 0.358950, 0.601210, -0.235270, 
-0.087320, 0.537880, -0.021290, -0.809000, -0.084520, 0.039200, 0.464600, 0.982350, -0.071980, 0.126090, 
0.779010, -0.047280, -0.049850, -0.323790, -0.327660, -0.380530, -0.030750, 0.195130, -0.021770, 0.207560, 
0.050470, -0.066700, 0.411070, -0.017130, -0.462960, 0.105210, 0.060790, 0.032610, -0.326310, -0.016190, 
-0.237000, 0.896730, 0.065770, 0.017580, -0.401110, 0.004280, -0.408240, 0.323460, -0.216750, 0.221590, 
0.602680, 0.192500, -0.123290, 0.611320, -0.000430, -0.403760, 0.204220, 0.088440, 0.310760, 0.065870, 
-0.340200, 0.072570, 0.410340, -0.385000, -0.065490, 0.155950, 0.691500, -0.264710, 0.487930, 0.014190, 
0.121060, -0.183010, 0.143610, 0.138300, -0.021120, 0.011330, 0.097160, -0.046110, -0.403230, 0.500370, 
0.139840, 0.107950, 0.347210, 0.410180, 0.244300, 0.142380, 0.216080, 0.194120, 0.211940, -0.402980, 
0.671570, 0.338100, -0.225360, -0.352100, -0.447990, 0.393470, 0.036790, 
0.129430, -0.383970, -0.295930, -0.064040, 0.026870, -0.047510, 0.548330, -0.599600, 0.067200, -0.350190, 
-0.156660, 0.058230, -0.155360, -0.289240, 0.385570, 0.190960, -0.071990, 0.027880, -0.304610, -0.245390, 
0.020060, -0.005520, 0.096800, 0.162860, -0.380480, -0.056950, -0.265420, -0.421530, -0.459500, 0.484800, 
-0.181360, -0.003410, 0.254730, 0.563700, -0.151220, -0.120860, 0.152120, -0.203310, -0.330560, 0.249210, 
-0.026870, 0.028600, -0.242930, 0.201780, -0.159470, 0.154880, -0.213720, 0.054710, 0.064960, -0.091600, 
-0.088870, -0.123280, -0.088440, -0.081070, -0.168440, 0.248700, -0.524210, -0.135070, 0.323380, -0.141260, 
0.168900, -0.141340, 0.028040, -0.099360, 0.026860, 0.138430, -0.076460, -0.355030, 0.141030, 0.067650, 
0.128230, 0.195620, 0.350380, 0.439970, -0.068820, 0.006960, 0.057180, -0.215470, -0.118030, 0.064760, 
0.148890, -0.302880, 0.253740, 0.014870, 0.181490, 0.174000, -0.006600, 0.265420, 0.235270, 0.033220, 
0.117770, 0.033460, -0.279650, -0.198860, 0.109010, 0.277220, -0.209820, -0.297580, 0.036180, 0.051330, 
-0.224720, -0.000550, -0.196630, -0.086870, 0.015910, 0.079350, 0.122300, 0.067440, 0.328990, 0.033170, 
0.351240, 0.374990, -0.112200, 0.330150, -0.062990, -0.076460, 0.063190, 0.195560, 0.112610, 0.247190, 
0.183370, -0.507120, 0.024430, -0.007490, 0.073420, 0.024970, 0.318150, -0.254950, -0.381550, -0.113640, 
0.366760, 0.113180, 0.207440, -0.269880, -0.415910, -0.123180, -0.093240, 0.280700, 0.033070, 0.043620, 
0.362270, 0.237980, -0.420220, 0.218380, 0.144410, 0.003810, 0.018980, 0.185350, -0.465260, -0.185210, 
-0.368090, 0.519760, -0.113720, 0.000330, -0.443380, -0.197410, -0.365490, -0.021600, -0.312020, -0.300450, 
0.100000, 0.227370, 0.142000, -0.052790, -0.055650, -0.060920, -0.068770, 0.014940, 0.362970, -0.411930, 
-0.001840, 0.153580, 0.112110, 0.411200, -0.002580, -0.282960, -0.614740, 0.106950, 0.196810, -0.245640, 
0.393900, -0.050890, 0.118320, -0.077160, -0.388700, -0.051040, -0.200710, 0.311630, 0.007070, -0.173520, 
-0.224030, 0.033590, 0.225360, 0.250340, -0.186040, 0.170720, 0.164160, 0.112130, 0.126020, 0.161280, 
0.105230, -0.200390, 0.326210, 0.166130, 0.097450, 0.315890, 0.524690, 0.132320, 0.349870, 0.239490, 
-0.067920, 0.247980, -0.034300, -0.072780, 0.698330, -0.050650, 0.082990, 0.011230, -0.148060, 0.278840, 
0.093240, 0.178710, 0.236580, 0.252170, 0.419590, 0.024920, 0.257980, 0.319530, 0.614110, 0.142560, 
0.259230, -0.058100, 0.337980, 0.300640, 0.100880, 0.571710, -0.060570, 0.037290, 0.179800, 0.213810, 
0.377730, 0.281020, 0.198290, 0.392520, 0.973380, 0.430910, 0.153610, 0.283600, 0.642550, 0.746700, 
0.298880, 0.310790, 0.176790, 0.465400, 0.170990, 0.252610, 0.476530, 0.416090, 0.226020, 0.237670, 
0.080430, -0.027470, 0.147470, 0.310150, 0.111450, 0.183210, 0.236860, 0.168770, 0.212350, 0.178020, 
0.161440, -0.077320, 0.297040, 0.546470, 0.012590, -0.065030, -0.056070, 0.144080, 0.343110, 0.116810, 
0.560090, 0.025380, -0.053890, -0.096420, 0.086480, 0.052130, -0.034720, 0.499630, 0.012070, -0.073950, 
0.131640, -0.035220, -0.131610, 0.269110, 0.360300, 0.316090, 0.096720, 0.223880, 0.183030, 0.161740, 
0.311040, 0.730910, 0.038980, 0.094210, 0.024820, -0.186440, 0.108310, 0.254490, 0.047070, 0.078090, 
0.031510, 0.234050, 0.211810, 0.101130, 0.249700, 0.109770, 0.167550, 0.074240, 0.219180, 0.557690, 
0.183060, 0.296630, 0.304310, 0.085130, 0.110810, 0.129660, 0.192350, 0.248680, 0.141270, 0.010380, 
0.098200, 0.049230, 0.332820, 0.454340, 0.233570, 0.274650, 0.101250, 0.213410, 0.031770, 0.133840, 
0.334250, 0.083000, 0.253500, 0.359860, 0.176920, -0.037820, 0.004700, -0.057330, 0.004780, 0.110620, 
0.081420, 0.048080, 0.013420, 0.176350, 0.409290, -0.178830, 0.284980, 
0.008320, -0.077160, -0.071790, 0.255830, -0.097610, -0.478840, 0.122760, -0.104520, -0.262460, -0.349120, 
0.257690, 0.014800, 0.162300, -0.447460, 0.100050, 0.025240, 0.400420, -0.105180, 0.217240, 0.079900, 
-0.107780, 0.085280, -0.546470, -0.006440, 0.106350, -0.324510, -0.218580, 0.187000, 0.309550, -0.004780, 
0.197220, -0.116550, -0.514470, -0.140680, -0.188970, -0.317450, 0.066900, 0.673000, 0.762720, 0.262520, 
0.048360, -0.095410, -0.009840, -0.125090, 0.023970, -0.361130, -0.081530, -0.102190, -0.514430, 0.208420, 
-0.107920, 0.285130, -0.265970, -0.252350, 0.127190, 0.062160, -0.068540, -0.069260, 0.080930, 0.046810, 
-0.441340, -0.201450, -0.054010, 0.371380, 0.073020, -0.035760, 0.144210, 0.219120, -0.133930, -0.314460, 
0.024070, -0.008600, 0.012130, 0.239060, -0.276850, 0.225610, 0.553380, 0.313310, -0.073060, 0.634390, 
0.061570, 0.157770, -0.306180, -0.023930, 0.748230, -0.001920, 0.491870, -0.171030, 0.132330, 0.252320, 
0.189760, 0.591600, 0.313410, -0.459690, 0.322960, 0.038700, 0.419520, -0.027270, -0.113210, 0.278580, 
-0.118630, 0.327080, 0.231740, -0.032330, -0.026390, 0.536950, -1.317070, -0.004910, -0.589690, -0.162110, 
-0.168180, -0.517150, -0.161010, -0.367680, 0.320660, 0.580030, -0.835710, 0.717510, -0.143020, -0.393380, 
0.618250, 0.380960, -0.445940, 0.232100, -0.152340, 0.001380, 0.251110, -0.166580, 0.354110, -0.267180, 
-0.053910, -0.242910, -0.824260, -0.358310, -0.085090, 0.224640, 0.453980, -0.137600, 0.648380, 0.266290, 
-0.734000, 0.234020, -0.005180, -0.197390, 0.287250, -0.461190, -0.002350, 1.099330, 0.629210, 0.530410, 
0.045320, 0.387590, 0.506870, 0.405710, 0.035920, -0.428630, -0.056030, 0.747120, -0.119230, 0.115450, 
-0.089260, 0.772990, 0.392740, -0.102840, 0.933780, 0.098450, -0.497050, 0.013030, 2.056620, 0.124860, 
-0.184670, 0.377260, -0.066630, 0.047480, 0.512060, 0.026500, -0.444460, 0.230990, 0.740240, 0.113320, 
0.176970, -0.244860, -0.468680, 0.262100, 0.018450, 0.740190, 0.547840, -0.245090, -0.002020, 1.409290, 
-0.656000, -0.558360, -0.880180, 0.429690, -0.768610, -1.111570, 0.188750, -0.208650, 1.049900, 1.048270, 
-1.190660, 0.575950, 0.546730, -0.021990, -0.211970, -0.278650, 0.413620, -0.012600, -0.152190, -0.028670, 
1.150230, 0.123020, -0.320720, -0.750110, 0.302910, 0.106760, -0.476610, -0.113130, -0.137270, 0.953560, 
1.166890, 0.727170, 0.154290, 0.190930, -0.216780, -0.340430, -0.642480, 0.129790, -0.528010, -0.097490, 
-0.006130, 1.602310, 1.171680, 0.503830, 0.525690, 0.240770, 0.664450, 0.868650, 0.587730, 0.561160, 
0.248600, 1.162880, 0.587740, 0.963610, 0.262130, -0.533460, 0.241760, 0.022870, 0.631910, -0.027690, 
-0.177310, -0.064520, 1.324890, 0.463150, -0.302510, -0.428250, 0.367010, 0.633500, 0.571050, -0.175110, 
0.513440, 0.201300, 1.110730, 0.178690, 0.100980, 0.173410, -0.634470, 0.095400, -0.036850, 0.278640, 
0.774440, 0.017130, -0.086250, 0.867540, -0.087970, -0.048980, -0.632610, 0.312330, 0.148500, -0.562250, 
0.702910, 0.060460, 0.461820, 1.228540, -0.448650, 0.495000, 0.235000, -0.550290, 0.281510, -0.192040, 
-0.099560, -0.203540, -0.012240, -0.121460, 0.858860, 0.138240, -0.448410, -0.197850, 0.360710, 0.524970, 
0.068900, 0.480100, -0.281660, -0.591310, 0.738080, 0.312730, 0.401380, -0.059980, -0.389420, 0.126080, 
0.336770, 0.249180, -0.347230, -0.040570, -0.138220, 0.726220, 0.394440, 0.355230, 0.064730, 0.526290, 
0.651030, 0.027540, -0.074270, 0.248430, 0.098080, 0.091860, 0.334800, 0.754830, 0.006360, -0.104650, 
0.090110, -0.241040, 0.213440, 0.194050, -0.268770, -0.160740, 0.519080, -0.063360, 0.103390, -0.385500, 
0.533630, 0.158280, 0.087970, 0.133440, 0.048480, 0.404120, 0.327390, -0.128730, 0.402410, 0.138750, 
-0.240670, 0.131360, -0.086080, 0.226750, 0.636310, 0.138780, -0.185490, 
-0.163420, 0.572650, 0.443440, -0.043810, -0.248330, 0.118350, -0.492860, 0.072740, 0.066860, 0.446230, 
0.365760, -0.105760, -0.310360, 0.220650, -0.065350, 0.105040, -0.123170, -0.823130, -0.586570, -0.195710, 
-0.119520, -0.236090, 0.193040, 0.487900, -0.046760, 0.190090, 0.022210, 0.171940, 0.105500, 0.777140, 
0.252670, -0.042460, 0.630860, 0.610610, -0.160970, -0.276670, -0.348730, -0.616010, -0.134100, 0.107770, 
0.056500, -0.129300, 0.358610, 0.186840, -0.326700, 0.555010, 0.206960, 0.282880, 0.566940, -0.491200, 
0.254030, -0.257750, 0.143930, 0.088930, -0.087820, 0.085650, -0.103560, -0.142500, 0.079110, 0.318980, 
-0.059410, -0.102260, -0.109910, 0.324760, -0.102580, 0.714040, -0.062890, -0.339000, -0.333610, 0.146180, 
-0.460510, 0.309690, 0.052310, -0.417490, -0.106280, -0.569340, 0.568490, 0.074940, 0.516890, 0.110260, 
0.130180, -0.393430, 0.136270, -0.143310, 0.024250, 0.180250, -0.030830, -0.171810, -0.086110, -0.337340, 
-0.506650, -0.150510, 0.883470, 0.303360, 0.467940, 0.013700, -0.037280, -0.540240, 0.132400, 0.020310, 
0.519720, -0.148130, -0.091640, 0.540900, -0.102800, 0.798320, 0.613930, -0.291100, 0.880320, 0.298820, 
0.165970, 0.682140, 0.322650, -0.439050, -0.181940, 0.127520, 0.832770, -0.339240, 0.624350, 0.597950, 
-0.133460, 0.007080, 0.604160, 0.027480, -0.140780, -0.103920, 1.118580, -0.501050, 0.458050, 0.495130, 
0.448020, 0.091860, 0.620100, 0.018840, -0.362630, -0.414740, -0.175780, 0.271800, 0.409770, -0.008920, 
-0.103770, -0.454030, 0.084590, 0.713850, 0.496830, -0.060400, -0.091780, 0.486770, -0.174900, 0.702030, 
-0.146750, -0.107620, -0.669880, -1.106540, -0.773600, 0.413570, 0.097240, 0.290910, -1.183010, 0.172200, 
0.413500, 0.296350, 0.623530, 0.091140, -0.685290, -0.767910, -0.228190, -0.073970, 0.487250, 0.456900, 
-0.275490, -0.421200, -0.119980, -0.088380, 0.000970, -0.346100, 0.061050, 0.740970, 0.540780, 0.071170, 
-0.012260, 0.023950, 1.211420, -0.730020, -0.614640, 0.713550, 0.052860, 0.099550, 0.007160, 1.740320, 
0.656890, 0.944640, 1.281470, 0.219140, 1.191580, 1.814190, 0.128510, -0.352330, 0.462530, 0.159270, 
1.092060, -0.404630, -0.061260, 0.113580, 0.485970, -0.030730, 0.848370, -0.130460, -0.244370, -0.076330, 
1.587070, -0.294430, 0.489060, 0.559040, 0.116740, 1.299250, 0.197600, -0.681240, -0.022960, 0.192970, 
0.953810, -0.245450, 0.588430, -0.524930, -1.084430, 0.055320, 0.123910, 0.581880, -0.113120, 0.436590, 
-0.114930, 0.364430, -0.091150, -0.116000, -1.010590, -0.078620, -0.460980, -0.632520, -0.762850, -0.102990, 
0.511020, 0.876020, -0.324830, 0.344820, -0.186280, -0.879490, -0.367840, -0.418350, 0.100270, -0.151950, 
-0.151610, -0.129650, 0.684490, 0.513770, -0.110390, 0.118470, 0.459470, 0.690870, -0.044850, 0.001270, 
0.220140, 0.292930, 0.039500, 1.170890, -0.086050, -0.465280, -0.239740, 0.080900, -0.464330, 0.366570, 
-0.011060, -0.326040, -0.213390, 0.840980, 1.175170, 0.478680, 0.071950, 0.725680, 0.932240, 0.723830, 
0.385010, 0.262190, 0.291560, 0.312950, 1.051560, 0.403470, -0.428090, -0.006660, 0.232510, 0.415010, 
0.409630, -0.059190, -0.036100, -0.229820, 0.973880, 0.696570, 0.003570, -0.213090, -0.167430, -0.310740, 
0.056240, -0.189500, -0.512780, 0.230880, 0.284400, 0.066870, -0.200360, 0.130180, -0.697020, -0.547860, 
0.155290, 0.494880, -0.085240, -0.041150, -0.220140, 0.277060, -0.083940, -0.364500, -0.347050, 0.264650, 
-0.361210, -0.627280, 0.064440, 0.113930, 0.471610, 0.557250, 0.385580, -0.082390, 0.320860, -0.991800, 
-0.778710, -0.505960, -0.163230, -0.231790, -0.130130, -0.206400, 0.550030, 0.571560, 0.389060, 0.142100, 
0.181010, 0.546790, 0.176990, 1.049190, 0.037070, 0.121070, -0.089890, 0.170680, -0.052050, 0.071020, 
-0.008470, 0.109430, 0.157600, 0.265160, 0.185010, -0.158950, -0.194530, 
0.134060, -0.105510, -0.443210, -0.645210, -0.076340, 0.074420, -0.455910, 0.172230, 0.024790, 0.365750, 
0.094160, -0.569070, 0.137020, 0.067320, -0.038980, -0.151930, 0.248650, -0.144290, 0.399960, 0.343070, 
-0.057790, -0.120010, -0.061190, -0.011920, 0.266430, -0.040500, 0.147240, 0.039260, -0.653280, 0.562990, 
0.058270, -0.314470, -0.005880, -0.244370, 0.234800, 0.435050, 0.016240, 0.340110, 0.263200, -0.464670, 
0.088600, -0.068640, 0.379180, 0.029460, -0.182190, 0.141580, -0.178950, -0.118190, 0.121130, -0.354410, 
-0.493100, 0.643270, 0.437850, -0.067180, 0.394840, 0.165240, -0.083700, -0.004380, 0.165460, 0.486060, 
-0.110620, 0.127730, -0.034790, 0.122440, -0.210870, -0.577380, -0.245350, 0.003390, -0.145880, 0.219410, 
-0.882240, 0.247900, 0.402970, 0.263300, -0.106270, -0.494940, 0.277910, -0.483360, 0.112030, 0.197850, 
0.346100, 0.384380, 0.235400, -0.003860, -0.017030, -0.072180, -0.100080, 0.026840, 0.112110, 0.231280, 
0.048760, -0.180190, -0.315230, 0.314140, 0.436730, 0.078890, -0.062750, -0.169070, -0.569710, 0.060120, 
-0.515000, -0.297790, 0.208150, -0.057270, -0.014610, -0.219060, 0.538710, -0.154480, 0.159590, 0.443360, 
-0.254620, 0.215090, -0.385870, -0.496500, 0.248960, 0.482830, 0.325790, 0.160920, -0.019280, -0.722350, 
-0.208780, 0.375890, 0.005310, -0.418590, 0.073620, 0.006640, -0.004970, 0.252640, 0.003680, 0.060280, 
0.818330, 0.111110, -0.037070, -0.550020, 0.017470, 0.731790, 0.405890, 0.273400, 0.250270, -0.184230, 
-0.759760, 0.056180, 0.531340, -0.193780, -0.249080, 0.594340, -0.008480, -0.250380, 0.170460, 0.100530, 
0.439300, 0.384690, 0.109690, 0.151800, 0.793050, 0.158160, -0.867030, -0.702650, 0.189550, -0.456170, 
-0.679450, 1.116200, -0.177390, 0.105830, -0.157670, -0.066410, -0.583930, 0.025530, 0.152960, 0.537190, 
0.967510, 0.327440, 0.243000, 0.446830, -0.665150, 1.952840, 0.454920, -0.870140, -0.270180, 0.502140, 
0.298800, 0.288940, -1.061440, 0.081210, -0.101800, 0.219570, -0.121950, -0.324850, -0.009720, -0.114610, 
0.015210, -0.275380, -0.009700, -0.100660, -0.422800, -0.750480, 1.572910, 0.002530, -0.011390, -0.172940, 
-0.057860, -0.148650, -0.181520, 0.476340, -0.146760, 0.149940, 0.671820, -0.034550, 0.154260, 0.076980, 
0.034780, 0.270570, -0.316620, -0.184730, 0.781570, -0.207170, -0.091700, -0.311490, -0.549920, 0.389240, 
-0.164000, -0.040810, 0.286550, -0.245340, 0.384920, 0.160060, 0.642100, 0.814860, -0.089230, 0.501500, 
0.065270, -0.099750, 0.211560, -0.034560, -0.136010, 0.337130, 0.063710, -0.163440, -0.472660, 0.467090, 
-0.013590, 0.040090, 0.412160, 0.303290, 0.535230, 0.435560, 0.262690, 0.500800, 0.262390, 0.329530, 
0.379290, 0.047900, 0.081950, -0.002390, -0.356350, -0.469790, -0.009880, 0.122400, -0.404790, 0.554410, 
-0.082070, -0.146040, -0.282550, -0.066960, 0.140660, 0.113070, 0.132820, 0.653750, 0.017450, 0.296590, 
0.179340, -0.026500, 0.050460, -0.051260, 0.068330, 0.005340, -0.032900, 0.038820, 0.411100, 0.320250, 
0.183000, 0.254530, -0.550890, -0.591910, -0.389770, 0.108810, 0.241930, 0.575560, 0.258990, 0.352320, 
0.188000, -0.057570, -0.079480, 0.006060, -0.130320, -0.297910, -0.269180, 0.024430, 0.153440, -0.356990, 
-0.464420, 0.364150, 0.386560, 0.068540, -0.244420, -0.690010, -0.211260, 0.138030, 0.064210, -0.341770, 
-0.059420, 0.008560, -0.293930, -0.117390, 0.026670, 0.000440, 0.147790, -0.111170, 0.042990, 0.074450, 
-0.019240, -0.047180, 0.600600, -0.260030, -0.742280, -0.537280, -0.109780, -0.361680, -0.578560, 0.154720, 
-0.163920, -0.038690, 0.192410, -0.140650, -0.182060, 0.009660, 0.325180, -0.265500, 0.214570, 0.611230, 
0.216990, 0.091010, 0.383190, 0.467690, -0.339890, -0.115250, -0.293400, -0.147820, 0.098400, 0.455400, 
0.434420, 0.116890, -0.336250, 0.265730, 0.150530, -0.592070, 0.009400, 
0.290990, -0.086290, -0.017880, 0.046780, -0.041730, -0.280240, 0.467020, 0.166850, -0.349700, -0.092060, 
-0.365740, -0.283140, -0.141460, 0.101770, -0.472790, -0.019490, -0.119300, -0.113910, 0.038300, -0.151860, 
-0.020440, 0.416910, -0.106690, 0.221410, -0.380160, -0.437840, -0.492780, 0.001140, 0.733420, 0.402160, 
0.015770, -0.032130, 0.228940, -0.170760, -0.428680, 0.268440, 0.112660, 0.388290, -0.284330, -0.251720, 
0.312430, -0.012270, -0.381640, -0.126670, 0.328920, -0.005300, -0.786430, 0.008370, 0.233390, -0.162310, 
-0.111150, -0.137690, -0.643700, -0.334690, -0.369460, 0.080520, 0.164170, 0.199410, -0.050010, -0.215390, 
0.064760, 0.007890, 0.014170, 0.644540, 0.140010, 0.515240, 0.093320, -0.108200, 0.322900, 0.334460, 
0.282410, 0.166060, -0.218210, -0.302270, 0.179750, 0.422730, -0.217010, 0.118870, 0.132970, 0.348340, 
0.046980, 0.013620, -0.261900, 0.015000, 0.048050, 0.152180, 0.024750, 0.329170, -0.380370, -0.440510, 
-0.350150, 0.441150, 0.400760, -0.254490, -0.601870, -0.124610, -0.212010, -0.232500, 0.731460, 0.112400, 
0.138830, -0.194880, 0.172070, -0.342370, 0.017020, 0.102980, 0.335550, 0.573640, -0.303070, -0.247820, 
0.119080, -0.450310, 0.873080, -0.085420, -0.219700, 0.290130, -0.357540, 0.297700, 0.306370, 0.639120, 
0.043600, -0.053400, 0.046170, -0.327920, 0.151160, 0.016340, -0.068690, -0.193680, 0.377900, -0.174520, 
0.498830, 0.049160, -0.035460, 0.121760, -0.267730, -0.566190, 0.420210, 0.292080, 0.019050, 0.761130, 
-0.448240, 0.364300, 0.098400, 0.653710, 0.131520, -0.498360, 0.015040, -0.176530, -0.122290, 0.267250, 
-0.239940, -0.415640, 0.239540, -0.419020, -0.025060, 0.440080, -0.422600, 0.055940, 0.148380, -0.250150, 
-0.040040, 1.274850, -0.038160, -0.074190, -0.314420, -0.174230, -0.380680, 0.010440, 0.072600, -0.499710, 
0.321200, 0.021430, 0.129100, -0.313950, -0.494980, 0.478710, 0.379520, 0.186360, 0.323120, -0.403950, 
-0.234730, 0.270390, 0.271820, 0.179380, 0.446630, -0.129130, 0.298570, -0.524730, 0.002440, 0.141580, 
-0.476540, -0.117010, 0.728530, -0.452390, 0.054580, 0.352960, -0.400380, 0.229470, 0.367860, 0.117540, 
0.198610, 0.204590, 0.051970, 2.159980, 0.010030, -0.214150, 0.416860, 0.010520, -0.101970, 0.086660, 
-0.460360, 0.337180, 0.158530, 0.453750, -0.233810, -0.248510, 0.228620, -0.284600, 0.596430, -0.456480, 
-0.134940, 0.134520, -0.068150, 0.364370, 0.461220, 0.024400, 0.238370, 0.294500, 0.145290, -0.358570, 
0.096040, -0.102200, -0.265220, -0.359600, 0.123230, 0.006360, 0.232220, 0.342680, -0.241920, -0.642790, 
-0.490870, 0.047250, -0.088280, -0.267560, -0.411270, 0.764750, -0.450900, -0.378530, 0.325160, 0.035540, 
-0.421460, 0.074040, 0.094660, 0.546000, 0.472480, 0.183300, -0.237980, -0.333230, -0.404020, 0.274160, 
0.710780, -0.192430, -0.190420, 0.198400, -0.465750, -0.234000, 0.415900, -0.527380, -0.124160, -0.324330, 
0.184720, -0.293560, 0.069420, 0.374980, -0.090190, 0.433200, 0.007020, -0.008050, -0.000630, 0.263080, 
-0.856950, 0.563610, 0.222000, 0.268750, 0.210730, -0.105740, -0.015150, 0.012940, -0.161780, 0.052820, 
0.365440, 0.294540, -0.092090, 0.079460, 0.573840, 0.211700, -0.259140, 0.042220, -0.183980, 0.469210, 
0.241290, 0.361850, -0.171270, 0.091230, 0.153490, 0.176580, 0.092680, 0.110820, -0.399410, 0.171910, 
-0.373680, 0.162330, 0.415090, -0.311780, 0.093610, 0.437480, 0.074650, 0.201340, 0.081320, -0.505910, 
0.127190, 0.159490, -0.323130, 0.349860, 0.180440, 1.033690, 0.354610, 0.581890, 0.201350, 0.166910, 
0.041650, 0.241910, 0.169090, 0.201070, 0.195770, 0.056700, 0.232600, 0.068570, 0.053670, 0.258700, 
0.192240, 0.355780, 0.130280, -0.252900, 0.115420, 0.523760, 0.289960, 0.221680, 0.005150, 0.742930, 
-0.192890, -0.041580, 0.217630, 0.146170, 0.275930, 0.460490, 0.049870, 
-0.338610, 0.023470, -0.130510, 0.231250, 0.040430, 0.080930, 0.190250, 0.525160, 0.294260, 0.087300, 
0.270830, 0.136570, 0.164570, 0.406150, -0.163840, -0.164620, -0.357410, 0.390880, -0.081020, 0.588080, 
0.126640, -0.196940, 0.111030, -0.334260, -0.084030, 0.139380, 0.051850, 0.207750, 0.160600, 0.202410, 
0.404620, -0.080030, 0.179880, 0.147190, -0.191010, -0.344280, -0.482940, -0.117300, -0.055830, 0.203310, 
0.371240, 0.092730, -0.139400, 0.011670, -0.418180, 0.252930, -0.029090, 0.016090, 0.249740, 0.365720, 
0.033410, -0.027500, -0.016170, -0.001110, -0.315970, -0.295620, 0.422770, -0.093810, -0.100640, 0.369710, 
-0.172640, -0.141130, 0.112770, 0.317270, 0.290330, 0.124410, -0.000710, 0.583810, -0.035540, -0.194360, 
0.231270, -0.360270, -0.245480, 0.067270, 0.121410, 0.174530, -0.332470, 0.543750, 0.166340, 0.531270, 
0.623600, -0.215940, 0.114680, 0.099820, 0.177490, -0.273410, -0.140230, 0.031290, -0.591690, -0.497750, 
-0.474730, 0.330050, -0.485540, 0.203100, -0.126730, -0.187470, -0.227390, 0.570750, -0.273900, -0.037630, 
0.039520, -0.149630, -0.185320, 0.005180, 0.105710, 0.119960, -0.067590, -0.187920, -0.220150, 0.195470, 
0.248150, -0.134570, 0.475730, 0.021170, 0.453800, -0.207510, -0.355120, 0.331920, -0.179300, 0.345360, 
-0.174070, -0.478190, 0.170380, 0.367200, 0.648990, 0.103730, 0.182290, -0.096910, -0.088610, 0.206650, 
0.179980, 0.165590, -0.064180, -0.468560, -0.127490, 0.502540, -0.193230, -0.375080, 0.052980, 0.293220, 
-0.393740, 0.048450, -0.186630, 0.252890, 0.209880, 0.307680, 0.026770, -0.494600, -0.392340, -0.203350, 
0.029440, -0.082110, -0.375460, -0.204880, -0.390560, 0.022350, 0.006810, 0.226250, -0.346050, 0.048260, 
0.107880, 0.302330, -0.007960, 0.174840, -0.168070, 0.371900, 0.587290, 0.019680, -0.614390, 0.417850, 
0.376770, 1.196780, 0.079630, -0.270830, -0.743190, 0.984460, -0.109860, -0.836170, -0.753900, 0.213850, 
-0.313390, -0.019760, 0.435040, 0.378780, 0.863900, 0.350290, -0.167220, -0.743350, 0.002470, -0.138430, 
0.217770, -0.349100, 0.018440, -0.007060, 0.323530, 0.258900, 0.659290, 0.302430, 0.151220, 0.055400, 
0.158690, 0.206460, 0.168040, 1.007240, 0.028550, -0.287930, 0.283460, 0.069140, 0.009400, 0.055890, 
0.092210, 0.141980, 0.080680, 1.201620, 0.132420, 0.061520, 0.563630, 0.996830, -0.038200, -0.148780, 
-0.432230, 0.413610, -0.041110, 0.032840, -0.469660, 0.133850, -0.246180, 0.255750, 0.001210, 0.039420, 
0.058910, -0.245560, 0.402570, 0.184130, 0.583690, 0.442720, 0.395230, 0.444030, 0.238390, 0.729360, 
-0.327610, -0.149480, 0.015370, -0.431180, -0.083100, -0.106090, 0.039410, 0.151410, 0.134520, -0.041020, 
-0.364150, 0.077540, 0.187300, 0.192750, -0.055790, -0.258080, 0.334470, 0.175250, 0.020250, -0.432960, 
-0.201320, 0.245210, 0.426340, -0.130920, 0.193030, 0.278440, -0.275570, 0.047180, -0.306440, 0.850270, 
0.300080, -0.246160, 0.073550, 0.374760, 0.126220, -0.091640, -0.101650, 0.130900, -0.039110, 0.261940, 
-0.017560, -0.232390, -0.222350, 0.009280, 0.693640, 0.061120, -0.293130, 0.108170, -0.229530, -0.039710, 
0.130300, 0.014510, 0.234050, 0.037800, 0.251050, -0.106020, -0.391730, -0.498470, 0.577930, -0.456610, 
-0.416840, 0.326780, -0.212700, -0.354970, -0.206350, -0.144630, 0.010530, -0.109740, -0.343930, -0.061490, 
-0.297670, -0.085910, -0.113720, -0.583620, 0.057310, -0.239130, 0.116060, -0.102150, -0.019710, -0.189630, 
-0.243690, -0.259930, -0.416280, 0.025700, 0.017900, -0.125650, -0.240080, -0.549070, 0.460150, -0.217150, 
-0.300640, -0.186280, 0.015330, 0.430760, -0.156560, 0.034140, 0.093140, -0.079800, 0.053710, 0.116240, 
0.157630, -0.096970, 0.331930, 0.252440, 0.083260, 0.030270, 0.020340, -0.062940, 0.201260, 0.527340, 
-0.315550, -0.084010, 0.237690, 0.628310, 0.302260, 0.390650, 0.036330, 
-0.285710, 0.218540, -0.155030, 0.476100, -0.263510, 0.508490, 0.502430, -0.352490, 0.437920, -0.208890, 
0.002350, 0.179590, 0.059210, 0.136470, 0.636850, -0.312100, 0.114940, -0.189170, 0.275040, -0.149650, 
0.044270, 0.156730, 0.152710, -0.084420, 0.129200, 0.153170, -0.173450, 0.139060, -0.065320, 0.018910, 
0.191410, -0.077460, -0.322730, 0.298870, -0.207050, 0.198710, 0.006380, 0.228180, 0.664950, -0.134570, 
0.051840, 0.037180, 0.002780, -0.114560, -0.360060, 0.226550, 0.232030, 0.017350, 0.249220, -0.301510, 
-0.073820, 0.005330, -0.225320, -0.173840, -0.222840, 0.037320, -0.081230, -0.279750, -0.193940, 0.013320, 
-0.043040, 0.312970, 0.029750, 0.542000, 0.305710, 0.076270, 0.244950, 0.067450, 0.443830, 0.541460, 
0.038220, -0.073670, -0.294150, -0.271060, 0.407310, 0.143840, -0.548370, 0.392650, 0.234090, 0.455680, 
0.912290, -0.231810, -0.292110, 0.041710, 0.408610, -0.062040, -0.358650, -0.564590, -0.079420, -0.188850, 
0.029580, 0.023170, 0.084640, 0.047160, -0.153890, 0.663580, -0.431200, 0.587800, -0.406490, 0.181350, 
0.139170, 0.609520, -0.175700, -0.002550, 0.063980, 0.080300, 0.064480, 0.022960, -0.285850, 0.609190, 
0.368380, -0.274820, 0.081580, 0.111160, 0.150580, 0.250630, 0.256990, 0.266760, -0.033970, -0.365070, 
0.142860, -0.106310, -0.035280, -0.098750, 0.320460, 0.059050, -0.199070, 0.577740, 0.247950, 0.009740, 
-0.010760, 0.543970, 0.134350, 0.848680, 0.022410, -0.108330, -0.268740, 0.096420, 0.280700, 0.213890, 
0.283130, -0.276380, -0.180300, 0.297340, 0.419950, -0.099200, 0.070160, -0.034880, -0.497470, 0.216920, 
0.290120, 0.676460, 0.199590, -0.213830, -0.387340, -0.314760, 0.290940, 0.086470, 0.055190, 0.176000, 
0.359560, -0.046900, 0.408430, 0.814150, -0.353370, 0.345660, 0.415340, 0.052510, -0.567130, 0.397970, 
0.219640, 0.615890, 0.015960, 0.116710, -0.311950, 0.820260, 0.591240, -0.806590, -0.200290, 0.414970, 
-0.003400, -0.129550, 0.802430, 0.463430, -0.448550, 0.480550, 0.024530, -0.802600, -0.001630, -0.267520, 
0.337340, -0.380600, -0.119040, 0.425770, 0.396360, -0.230910, 0.271850, -0.075940, -0.284830, -0.069260, 
0.689520, 0.144200, -0.225430, 0.613140, 0.265430, -0.186860, 0.158810, -0.361130, 0.256920, 0.054890, 
0.127160, -0.401290, -0.380480, 0.186560, -0.136440, -0.429310, -0.257220, 0.833750, -0.065620, -0.046640, 
-0.863530, -0.488260, -0.229560, -0.006370, 0.330200, -0.122660, -0.178720, -0.125250, 0.101570, 0.122760, 
0.054190, -0.076750, -0.080250, -0.180910, -0.478380, -0.175870, -0.287200, 0.331730, -0.209250, 0.635220, 
-0.037320, -0.241690, 0.008070, -0.339300, 0.573040, 0.218170, 0.191280, 0.111820, 0.448560, 0.208500, 
0.422170, 0.060150, 0.009540, 0.398120, -0.805500, -0.882250, 0.345170, 0.059530, -0.669920, -0.715610, 
-0.156840, 0.151610, 0.062680, -0.063630, -0.082980, 0.136440, -0.455420, -0.283240, -0.210280, -0.071630, 
-0.096490, 0.950100, 0.066260, -0.232540, 0.072190, -0.243330, -0.840950, -0.541620, 0.140400, 0.166180, 
-0.197850, 0.147610, 0.366550, -0.167180, -0.362740, -0.255410, 0.121820, -1.016880, -0.355250, -0.105090, 
0.037280, 0.030460, 0.105820, 0.032280, -0.234340, 0.032750, 0.173580, 0.152190, -0.339090, 0.219040, 
0.350680, -0.521170, 0.342320, -0.222460, -0.024090, -0.034570, 0.515310, 0.223270, 0.042650, 0.067040, 
-0.134740, -0.215800, -0.187060, 0.077140, 0.042000, -0.132970, -0.032890, -0.162910, -0.179060, -0.219720, 
-0.498240, -0.303280, -0.355010, 0.568910, -0.040660, -0.701550, -0.147140, -0.268250, -0.059730, 0.244010, 
-0.232890, 0.163250, 0.065930, 0.157820, 0.353610, 0.021650, 0.094150, 0.096470, 0.110720, 0.412000, 
-0.004120, 0.476530, 0.271680, 0.436970, 0.106060, -0.289260, -0.473780, 0.233930, -0.079820, 0.142010, 
0.122090, 0.305150, -0.068150, 0.147550, -0.206440, 0.296520, -0.025660, 
-0.072690, -0.222350, -0.047470, 0.124600, 0.310610, -0.540220, -0.063120, 0.061240, -0.240760, -0.323200, 
0.232270, 0.107090, 0.466170, 0.314850, -0.283160, 0.074250, 0.136730, 0.261910, -0.067010, -0.451770, 
-0.019320, -0.513080, -0.040010, 0.125470, -0.391120, -0.176120, -0.587060, -0.829280, 0.060880, 0.082500, 
0.065890, -0.210430, -0.526100, 0.622560, 0.388790, 0.391730, -0.081980, -0.559920, 0.250440, 0.189340, 
-0.002860, -0.016720, 0.002110, 0.239940, 0.231100, 0.015460, 0.349130, 0.215040, -0.739260, 0.438290, 
0.223290, 0.302430, 0.074510, 0.120840, 0.175410, 0.278800, -0.112610, 0.189740, -0.002580, 0.017220, 
0.114410, -0.213980, -0.006780, 0.520920, -0.101050, 0.786440, 0.106990, 0.653240, 0.004250, 0.070710, 
-0.059970, -0.539370, -0.459510, 0.392950, -0.358750, 0.417190, -0.251390, -0.043830, 0.479300, -0.260660, 
0.026210, -0.175340, 0.195880, -0.035730, 0.750100, -0.789170, 0.015350, -0.622470, -0.090890, -0.311720, 
-0.571870, -0.267550, 0.152660, 0.163710, 0.284840, -1.221930, -0.042520, 0.252870, -0.032620, 0.736380, 
-0.074870, -0.565190, 0.035300, -0.510600, -0.002020, 0.754230, -0.369350, -0.372810, 0.058980, 0.158270, 
-0.112400, -0.664980, -0.211240, -0.213090, 0.178420, 0.197050, -0.709980, -0.614520, 0.114080, -0.153440, 
0.197780, -0.349280, -0.371760, -0.458590, -0.204150, 0.025740, 0.480530, 0.367200, 0.599560, 0.340300, 
0.227830, 0.255730, 0.421220, 0.363520, -0.032110, 0.047910, 0.504310, 0.374740, 0.309800, -0.331240, 
0.353840, 0.058070, 0.014160, 0.298930, 0.527990, -0.165190, 0.002710, 1.127110, -0.397070, 0.219570, 
1.037530, -0.179010, -0.096570, 0.200130, -0.485300, 0.331980, -0.039650, 0.422660, -0.350470, -0.447040, 
0.343420, 0.154970, 0.255950, -0.175900, 0.112220, 0.278980, -0.561220, -0.015110, 1.095890, -1.188300, 
-0.342350, -0.891050, 0.298120, -0.523780, -1.238250, -0.037240, -0.502880, 0.379560, 1.186470, -1.576480, 
0.578320, 0.531140, 0.709160, -0.208710, 0.176060, 0.456450, 0.138330, -0.321400, 0.001570, 0.824360, 
0.104020, 0.176430, -0.252120, 0.035560, 0.249840, -0.089490, 0.282330, -0.343790, -0.045260, 0.789140, 
0.679580, 0.204440, 0.045550, -0.153760, -0.314600, -0.174270, -0.072570, -0.350610, -0.753110, -0.015060, 
1.348640, 0.599010, 0.501190, 0.894850, 0.489550, 0.663440, 0.876850, -0.145360, -0.401310, 0.358580, 
0.346390, 0.975580, 0.431680, -0.262860, -0.534440, -0.063120, -0.027660, 0.257440, -0.060340, 0.007370, 
-0.023640, 1.072710, 0.046810, 0.176950, -0.536860, 0.524650, 0.127310, 0.083740, -0.284640, 0.316860, 
0.086060, 1.417350, -0.103590, 0.683660, 0.202960, -0.144040, -0.107630, 0.403570, -0.159010, 0.331860, 
-0.286540, -0.078410, 0.777350, -0.354890, 0.038810, -0.593470, -0.067130, -0.190280, -0.706310, -0.116500, 
-0.122070, -0.042960, 1.134820, -0.026300, 0.338830, 0.698280, -0.107410, -0.105990, -0.665320, -0.386440, 
0.006230, -0.277090, -0.129640, 1.134990, 0.062960, -0.112240, -0.508840, 0.117340, 0.520770, -0.569630, 
0.147010, 0.346070, 0.267690, 1.021870, 0.146110, 0.411600, -0.049960, -0.575470, 0.125520, -0.119400, 
0.053630, 0.315260, -0.072610, -0.128210, 0.572090, 0.177370, 0.175390, 0.343980, 0.394000, 0.385550, 
-0.053910, -0.036630, 0.255930, -0.031700, 0.511540, -0.057790, 0.463780, -0.120240, -0.028230, -0.170290, 
-0.191660, 0.206000, 0.311960, -0.394180, -0.127820, 1.031770, -0.285470, -0.019790, 0.285570, 0.192110, 
0.054720, 0.057400, 0.479620, -0.470920, -0.150460, 0.431180, -0.124330, 0.254240, -0.009520, -0.190050, 
-0.037910, -0.305330, -0.204430, 0.233910, -0.416310, -0.094220, 0.143170, 0.555340, 0.067940, -0.317370, 
0.021870, 0.155920, -0.175130, 0.343670, 0.527670, -0.006440, 0.596420, 0.155200, 0.563420, 0.267640, 
-0.694140, -0.289840, -0.561290, 0.337300, 0.155370, -0.254560, -0.109380, 
-0.251230, 0.260140, 0.199480, -0.033960, -0.001110, 0.392720, 0.137710, 0.136800, 0.039250, -0.105090, 
0.061920, 0.249380, 0.181620, -0.106600, -0.345580, 0.059130, 0.421250, 0.161630, -0.288080, 0.224460, 
0.004910, -0.419360, 0.159570, -0.039560, -0.244890, 0.042370, 0.238730, -0.093320, -0.098720, 0.176710, 
-0.016220, 0.001310, -0.235870, 0.049550, 0.376780, 0.020510, -0.273630, 0.050890, -0.264290, 0.385740, 
0.004640, -0.018290, -0.650740, -0.463780, -0.779810, -0.579640, -0.087750, -0.394280, -0.187000, -0.685430, 
-0.127650, 0.326970, -0.299970, -0.254520, -0.075240, -0.306130, 0.295500, -0.425240, 0.273260, -0.361310, 
0.035960, 0.286390, -0.004470, -0.602200, -0.533620, -0.830160, -0.465270, 0.120070, -0.359940, -0.418080, 
-0.272680, -0.265310, 0.244150, -0.690520, -0.965340, -0.606370, 0.286190, -0.191120, -0.177210, -0.345150, 
-0.095690, 0.055290, 0.445580, -0.018210, -0.279310, 0.045100, -0.277960, -0.233560, 0.020170, -0.155580, 
-0.189070, -0.202780, -0.659370, 0.247190, -0.305440, -0.070860, -0.156010, -0.017600, 0.418610, -0.089260, 
0.088130, -0.266730, -0.068590, 0.513360, -0.004910, -0.034620, -0.121730, -0.517720, -0.344810, 0.033560, 
-0.083480, 0.057260, -0.701150, -0.104100, 0.307550, 0.071310, -0.351910, 0.019650, -0.455420, -0.016150, 
-0.153180, 0.274990, -0.598520, 0.038950, 0.289170, -0.012900, -0.302660, -0.262790, -0.329960, -0.253670, 
0.039350, -0.145370, -0.387980, 0.095010, 0.034560, 0.112730, -0.183600, -0.247640, 0.063540, 0.233620, 
-0.173380, -0.428470, -0.248460, 0.006610, -0.072140, 0.095690, 0.007220, -0.430040, -0.247910, 0.311740, 
-0.148850, 0.077030, 0.124050, -0.085780, -0.064710, -0.004410, 0.391300, -0.295070, -0.164050, 0.086670, 
0.176020, 0.325250, -0.131060, 0.381830, -0.029220, -0.019150, 0.492780, 0.015170, -0.740120, -0.294150, 
0.631770, 0.659450, 0.257950, -0.132700, -0.281270, 0.115990, -0.390620, -0.289830, 0.175340, -0.021710, 
-0.254130, -0.253040, -0.420500, 0.442120, 0.957600, 0.166680, 0.057390, 0.044480, -0.006300, -0.609640, 
0.253830, 0.324060, 0.579680, -0.049310, -0.164780, -0.019180, 0.780740, -0.339760, -0.848680, -0.550490, 
0.709850, -0.024150, -0.118320, 1.726280, 0.664500, 0.187410, 0.006020, 0.004370, -0.304230, 0.064340, 
-0.139840, 0.100270, 0.776510, 0.839130, -0.499430, 0.371940, 0.735090, 0.445030, 0.237160, 0.017580, 
0.099750, 1.136770, 0.244630, -0.090720, 0.279250, 0.556030, 0.367750, 0.632820, -0.082680, -0.307470, 
0.100170, 0.119550, -0.054290, 0.051960, 0.175380, -0.032370, 0.649730, 0.640970, 0.779630, 0.205840, 
0.219300, 0.054300, 0.400550, 0.151580, 0.046930, 0.360620, 0.763610, 0.330540, 0.963290, 0.231420, 
0.310060, 0.134040, 0.446960, 0.627510, 0.050890, 0.478800, -0.018270, 0.648470, 0.767930, -0.260770, 
0.140280, -0.290240, -0.127690, 0.240170, 0.347260, -0.023790, -0.378070, -0.268060, 0.457350, 0.223830, 
0.245580, 0.056820, 0.134550, 0.222760, 0.378540, -0.254390, 0.522930, 0.212140, 0.028680, 0.025240, 
-0.037420, -0.045650, 0.550950, 0.217600, 0.087170, 0.204110, -0.107470, -0.162580, -0.206380, -0.179120, 
-0.005700, -0.061750, -0.068980, 0.138360, 0.382360, 0.276540, -0.002120, 0.040800, 0.230040, -0.150960, 
0.099050, 0.702180, 0.133900, 0.269810, 0.255000, 0.184920, 0.248610, 0.338890, 0.040250, 0.202270, 
0.151330, 0.238780, 0.175220, 0.142750, 0.091200, 0.437560, 0.599440, 0.142470, 0.074410, 0.118530, 
0.135810, 0.509670, 0.288060, -0.249540, 0.229040, 0.106540, 0.225100, 0.035730, 0.074800, -0.431720, 
0.140680, 0.269500, 0.002300, -0.288370, 0.144670, 0.071370, 0.426570, 0.291030, -0.176820, -0.113590, 
-0.271240, 0.151120, 0.080160, 0.573170, -0.386010, 0.551660, 0.170650, -0.059090, 0.131760, 0.344430, 
0.286820, 0.015830, 0.286280, -0.067090, 0.470410, 0.354610, 0.075280, 
0.339130, 0.065800, -0.094040, -0.132380, -0.283260, 0.169180, 0.246370, 0.432540, -0.104880, -0.007110, 
-0.048740, 0.029690, 0.144810, 0.021700, -0.277470, 0.164240, -0.263100, 0.021070, 0.138610, 0.123490, 
0.015540, 0.302190, -0.185240, -0.175380, -0.004580, -0.225880, 0.277210, 0.077070, 0.492780, -0.177320, 
-0.619630, -0.338180, 0.337850, -0.106170, 0.290950, 0.234320, 0.180300, -0.072480, 0.052250, 0.055880, 
-0.103810, 0.018490, -0.300310, 0.292010, 0.301640, -0.170380, 0.206800, 0.109810, 0.108260, -0.356810, 
-0.142680, -0.027170, -0.138450, 0.410130, -0.162670, -0.068010, -0.438880, 0.118890, 0.118410, 0.184690, 
-0.109520, -0.163410, 0.029020, 0.144220, -0.561860, -0.740650, -0.329880, 0.378860, -0.051820, 0.093410, 
0.020270, -0.342370, 0.034040, -0.077470, 0.086620, -0.252240, 0.255430, -0.346610, 0.097480, 0.128020, 
-0.216670, -0.240600, 0.019740, 0.010650, 0.308520, 0.139790, -0.432390, -0.053150, 0.134310, -0.129280, 
0.414580, -0.388940, 0.058190, 0.323220, -0.064940, 0.387060, -0.208660, -0.007290, -0.313400, 0.067550, 
-0.370200, 0.127340, 0.538460, 0.095000, 0.009580, -0.279740, -0.162980, 0.018160, 0.505030, 0.346620, 
-0.132000, 0.134660, -0.396370, 0.076590, 0.086800, 0.273120, -0.146120, -0.045010, -0.411330, -0.107310, 
0.105380, -0.138180, -0.333400, 0.126760, -0.074850, 0.036100, 0.230620, 0.060460, -0.074070, 0.066940, 
0.087390, 0.029700, 0.096940, -0.365050, -0.167840, 0.034840, 0.712460, 0.054920, -0.136970, -0.143220, 
0.482550, 0.361250, 0.364490, 0.172360, -0.014810, 0.359440, 0.011690, -0.064350, 0.276830, 0.797580, 
0.603330, -0.201630, 0.135980, 0.066620, 0.809380, -0.016060, 0.000960, 0.025960, 0.577120, 0.090260, 
0.101590, -0.403480, -0.165440, 0.316580, 0.097670, 0.184700, 0.083860, 0.021800, 0.287600, 0.067330, 
-0.411670, -0.317600, 0.201600, 0.139730, -0.166140, 0.458130, 0.037560, -0.104350, 0.202600, 0.248830, 
-0.163240, -0.405090, 0.000470, -0.322550, -0.119850, -0.290280, -0.268840, 0.018800, -0.000160, -0.519600, 
0.707340, 0.437630, 0.452390, 0.130620, 0.206750, -0.020210, 1.217920, -0.174620, -0.203210, -0.133120, 
0.661220, 0.185480, 0.300220, 0.062390, 0.017210, 0.401170, 0.325690, 0.247210, -0.066340, 0.109000, 
-0.530840, 0.327470, 0.047170, -0.421260, 0.108220, 0.318590, 0.056830, -0.418770, -0.020290, 0.359150, 
0.862610, 0.426640, 0.569090, -0.024460, -0.241060, 0.035470, -0.205380, -0.501190, -0.086040, 0.532970, 
0.096710, -0.244620, 0.159310, -0.127200, -0.124990, 0.706040, -0.466480, -0.084890, 0.122470, -0.429670, 
-0.074950, -0.114010, -0.088110, -0.106410, -0.151730, 0.827950, 0.059010, 0.308370, 0.114290, -0.624730, 
0.175260, 0.105240, 0.094790, 0.509000, -0.328670, 0.050460, -0.634770, 0.029100, 0.028350, 0.185750, 
0.077840, 0.312200, 0.230640, 0.438210, 0.304680, -0.201120, 0.031590, -0.011980, 0.123290, -0.199120, 
-0.136880, 0.311500, 0.122110, -0.168900, 0.098720, -0.077010, 0.190250, 0.156700, -0.005680, 0.038000, 
-0.117770, -0.223700, 0.441580, 0.128270, -0.178150, 0.148720, 0.371200, -0.040730, -0.019080, 0.450350, 
0.201110, 0.372290, 0.225290, 0.134660, -0.274180, -0.110870, -0.130560, 0.109660, -0.336070, -0.065210, 
0.140340, -0.116920, 0.314150, 0.006210, -0.136810, -0.083540, -0.522590, 0.108780, 0.053750, 0.297160, 
-0.253810, 0.220240, 0.126550, 0.023510, 0.096550, -0.101360, 0.163130, -0.092060, 0.036180, 0.120630, 
0.221140, 0.190490, 0.194460, 0.148880, 0.138250, 0.049750, 0.204370, 0.245920, 0.381870, -0.266570, 
-0.016730, 0.067400, 0.599470, 0.367310, 0.024120, 0.075650, 0.041930, 0.247690, 0.370480, 0.214280, 
-0.239820, -0.335310, -0.234720, 0.198820, -0.149920, 0.422370, -0.130510, 0.694570, -0.398000, 0.107050, 
-0.267930, 0.023960, 0.138930, -0.033920, -0.039620, 0.373100, 0.084670, 
-0.270040, -0.225520, 0.006000, 0.177990, -0.252000, -0.061170, -0.316940, -0.281630, -0.353880, 0.381550, 
-0.051290, -0.330750, -0.228310, 0.139840, 0.419040, -0.579240, 0.083820, -0.438580, 0.057950, 0.216310, 
0.043330, 0.100760, 0.127860, 0.166010, -0.367520, -0.101600, -0.261140, -0.104360, 0.149910, -0.214360, 
0.254910, -0.132180, -0.030780, -0.071060, 0.045310, 0.069280, -0.009270, -0.485660, -0.131560, 0.212560, 
0.153190, 0.079970, 0.004180, -0.046480, 0.447610, 0.319920, 0.218100, 0.415500, 0.530160, 0.184110, 
0.079910, -0.415660, -0.463650, -0.141660, 0.080330, -0.135880, -0.034650, -0.275650, -0.414620, -0.366020, 
-0.308110, 0.245040, 0.100470, 0.766940, 0.158250, 0.082900, -0.139910, 0.152270, -0.094820, 0.105300, 
0.089310, 0.189420, 0.101800, 0.202780, 0.264030, 0.133520, -0.315770, 0.320850, 0.271570, -0.132670, 
-0.566950, -0.411720, 0.323860, 0.078910, 0.214230, -0.228250, 0.326040, 0.264750, -0.479190, -0.225920, 
0.155160, -0.137680, 0.251180, 0.028680, 0.092600, -0.756650, -0.265100, -0.084620, 0.071700, -0.470140, 
-0.089060, -0.430920, -0.177230, -0.293870, 0.070230, -0.016880, 0.376330, 0.508320, -0.039360, 0.283950, 
-0.205400, -0.172040, -0.364530, 0.190380, 0.103980, 0.067300, 0.027430, -0.151240, 0.118090, 0.927750, 
0.375040, -0.401060, -0.004050, -0.531690, -0.331570, 0.071900, -0.226330, 0.145600, 0.674950, 0.522440, 
0.060490, -0.078990, 0.086810, 0.045610, 0.158720, -0.338190, -0.176160, 0.180660, -0.575460, -0.230390, 
1.272090, 0.119090, -0.045340, 0.404320, -0.273460, -0.562660, 0.069920, 0.321750, -0.394940, 0.852250, 
0.921390, -0.294320, 0.246570, 0.284510, 0.848670, 0.246260, -0.822970, -0.215690, -0.541200, -0.448330, 
-0.410000, 1.583700, 0.255180, -0.273430, -0.781670, -0.531270, -0.764080, 0.049230, -0.063250, -0.086830, 
0.917520, 0.938360, -0.138210, 0.061480, -0.340360, 0.804270, 0.241430, -0.247670, 0.223890, -0.245790, 
-0.057180, -0.151460, 1.211000, -0.075150, -0.111530, -0.382060, -0.565230, -0.596840, -0.006450, -0.848830, 
0.101380, 0.549000, 0.380200, 0.312580, 0.031890, -0.570250, 0.213410, -0.117630, 0.047920, 0.144310, 
-0.080330, -0.017680, -0.324290, 1.069640, -0.035300, -0.186690, 0.140370, -0.540540, -0.445030, 0.025120, 
-0.195950, 0.661630, 0.634230, 0.146180, -0.343990, 0.485420, 0.287920, -0.242870, 0.276220, -0.290340, 
0.011250, 0.299830, -0.221090, -0.468770, 0.749020, 0.131990, 0.510120, -0.149750, -0.401590, -0.878610, 
0.020060, -0.253750, 0.184630, 0.222480, 0.332760, -0.629240, 0.212770, 0.333590, -0.279470, 0.447290, 
-0.006090, 0.040400, -0.065230, -0.094480, 0.128340, 0.245100, -0.137420, 0.221280, 0.072720, -0.063960, 
-0.102580, 0.012340, -0.112860, -0.457990, 0.002610, 0.198080, -0.251750, 0.098810, 0.042460, -0.122140, 
-0.022960, -0.111270, -0.389380, -0.341720, -0.294180, -0.299630, 0.432370, -0.325290, -0.186700, 0.139940, 
0.102960, -0.410560, 0.043010, 0.097450, 0.101820, -0.236490, 0.057300, -0.066100, -0.315870, 0.090050, 
-0.480340, -0.436960, 0.053190, -0.187040, -0.066650, -0.278790, 0.185110, 0.193850, -0.227040, 0.052870, 
0.017780, -0.336600, -0.505540, 0.062860, 0.222270, 0.030180, 0.064650, 0.266810, -0.088730, 0.190280, 
-0.054470, 0.370440, 0.382960, -0.221520, -0.161910, -0.110070, -0.692880, -0.023900, 0.706990, -0.230340, 
-0.216470, 0.290860, -0.329060, -0.232800, 0.096070, 0.418960, 0.061000, 0.171700, 0.542140, -0.059290, 
0.220110, 0.333110, -0.105380, 0.230670, -0.169170, 0.230770, 0.209430, -0.188180, -0.006330, -0.631780, 
-0.058040, 0.245980, 0.508500, 0.449430, -0.391550, 0.124130, 0.570030, 0.205430, -0.336810, -0.231790, 
0.070150, -0.166270, 0.099350, 0.284440, -0.417950, 0.352460, 0.460290, -0.077710, 0.006200, -0.474400, 
-0.181600, 0.038810, -0.235190, -0.197310, -0.170540, 0.093070, 0.114370, 
-0.177070, 0.566750, 0.052120, 0.245680, 0.859620, 0.137220, 0.120630, 0.110040, 0.062850, 0.121590, 
0.197040, 0.217590, -0.103770, -0.135290, 0.611140, 0.178080, 0.300820, 0.227330, -0.239850, -0.021330, 
0.172160, -0.063270, 0.554320, -0.058720, 0.351430, 0.511610, 0.369980, 0.245300, 0.181320, 0.007800, 
0.086040, 0.038610, 0.057730, 0.220440, -0.323190, 0.324920, 0.065500, -0.565540, -0.297140, -0.520000, 
0.037970, 0.129060, 0.155610, 0.417120, 0.283630, 0.222610, -0.171380, 0.743830, 0.705150, 0.162890, 
0.377940, -0.032830, 0.185350, 0.312550, 0.563080, 0.222430, 0.578510, 0.092300, -0.074750, 0.031090, 
0.007670, 0.226830, 0.156020, -0.198500, -0.105240, 0.117040, 0.111080, -0.142750, 0.277390, 0.143300, 
-0.037410, -0.108580, 0.088570, 0.095900, -0.278150, 0.331420, 0.205610, -0.026450, 0.030620, 0.064550, 
0.619040, 0.282550, 0.374330, 0.148470, 0.530790, 0.008270, -0.185010, 0.009040, 0.343730, -0.176840, 
0.035700, 0.283110, 0.311000, 0.118180, 0.054790, -0.541380, -0.239030, -0.063350, -0.349980, -0.285110, 
-0.437670, 0.633170, 0.584670, -0.008360, 0.139530, 0.072570, 0.305300, 0.401040, 0.452120, 0.253490, 
0.254730, 0.118490, -0.179210, 0.287170, 0.310380, 0.006830, 0.471670, 0.563420, 0.196830, 0.243250, 
0.382050, 0.378180, 0.555520, 0.400670, 0.311130, 0.138280, -0.016550, -0.389440, 0.078730, 0.495340, 
0.759290, 0.017410, 0.015280, -0.338590, -0.211320, 0.394370, 0.463650, -0.125820, -0.156640, 0.019230, 
0.030120, -0.018310, 0.422830, -0.126120, 0.017980, 0.080820, 0.121470, -0.127730, 0.084310, 0.121730, 
0.440350, 0.444210, 0.317890, -0.144540, 0.395710, 0.180810, -0.029610, -0.134440, 0.140860, 0.100530, 
-0.024970, 0.850100, -0.130970, -0.181850, -0.197020, 0.165810, 0.154130, 0.109300, -0.330670, -0.582540, 
0.849720, 0.251610, 0.417300, -0.184520, -0.680000, 0.723900, -0.086930, -0.532050, -0.364510, -0.016250, 
-0.092720, -0.014750, 0.999610, -0.030000, 0.300950, 0.096390, -0.103160, -0.128950, -0.001160, -0.306940, 
-0.133940, 0.118440, -0.114020, 0.390340, -0.344590, -0.738640, 0.299800, 0.162090, -0.162440, -0.242390, 
-0.202020, -0.288280, 0.143170, 0.728220, -0.123530, -0.379880, 0.419750, 0.558520, 0.048090, 0.029460, 
-0.507870, 0.314640, 0.454680, -0.323370, 0.017990, 0.200140, -0.079720, 0.152820, 0.431130, -0.308320, 
0.145070, 0.254900, 0.127250, 0.034090, 0.733290, -0.008950, 0.274990, -0.009530, 0.540280, 0.012290, 
0.026340, -0.132230, 0.044640, -0.204500, -0.371160, 0.171600, -0.071180, -0.202200, 0.422350, -0.026970, 
-0.175610, 0.097190, -0.263900, -0.229190, -0.179700, 0.616570, 0.386240, 0.236150, -0.413250, -0.234320, 
0.010910, 0.022730, 0.067400, -0.196000, -0.316600, -0.331530, 0.437980, -0.214250, -0.345390, 0.008380, 
0.189610, -0.198050, -0.369080, -0.577290, -0.157480, -0.625070, 0.583980, 0.111100, -0.191740, -0.478030, 
-0.264100, -0.085250, 0.015400, 0.120680, 0.107060, 0.179220, -0.336920, 0.233440, 0.085460, -0.217850, 
-0.236670, 0.036190, 0.080890, -0.119730, -0.176050, 0.463040, -0.288010, -0.551610, 0.227660, 0.310470, 
-0.367060, -0.316180, 0.101160, -0.002450, 0.007260, -0.574200, -0.560700, -0.285190, 0.229090, -0.490820, 
-0.160950, 0.074690, 0.213500, 0.202430, 0.135360, -0.278680, -0.439850, -0.072850, -0.114740, -0.165940, 
-0.418510, -0.039940, -0.250580, 0.333250, 0.001480, 0.088170, 0.177200, 0.061420, -0.156410, -0.015430, 
0.265030, 0.070220, -0.261620, 0.037860, -0.067850, 0.104830, 0.308810, 0.047970, -0.432250, 0.025240, 
0.324030, -0.081600, -0.009140, 0.143710, -0.198060, 0.009680, 0.467370, 0.202350, -0.601310, 0.089070, 
0.490860, -0.200880, 0.131160, -0.736490, -0.218900, 0.318670, 0.137450, 0.078190, 0.278170, -0.145650, 
-0.088960, -0.153760, -0.002200, -0.148990, -0.104170, 0.049750, -0.012500, 
-0.032090, 0.464140, -0.095030, -0.858010, 0.069960, -0.276610, -0.298480, 0.630740, -0.013060, 0.545380, 
0.124810, -0.116790, 0.627030, 0.193090, 0.131620, -0.740880, -0.303930, -0.022240, 0.339590, 0.029120, 
-0.068410, -0.077870, -0.481880, 0.044600, 0.019900, 0.391870, -0.268820, -0.409860, 0.421470, -0.314270, 
0.655900, 0.581780, -0.318830, 0.271980, 0.126170, 0.416780, -0.218710, -0.309030, 0.349710, -0.250730, 
0.526680, -0.093470, 0.134050, -0.182470, 0.242040, -0.231580, 0.324710, 0.217690, 0.265640, 0.172880, 
-0.003310, 0.001970, 0.051040, 0.258150, 0.174550, -0.081920, 0.581660, 0.312540, 0.460720, 0.094510, 
0.362100, 0.100290, -0.091700, 0.076510, -0.385240, 0.140940, 0.346850, -0.002610, 0.097620, -0.176520, 
0.519460, 0.307260, -0.199340, -0.087330, -0.541910, 0.423660, 0.239360, -0.031200, 0.078290, 0.153900, 
0.482650, -0.173260, -0.085730, -0.067970, -0.033570, 0.203520, 0.108580, 0.067380, -0.122320, -0.192190, 
-0.363730, -0.103330, 0.188850, 0.135330, 0.003410, -0.177270, 0.243430, -0.045430, 0.197280, -0.224320, 
0.124340, -0.333240, -0.439130, 0.277320, -0.061730, 0.012330, 0.378300, 0.126740, 0.343300, -0.014680, 
-0.199360, 0.127980, -0.287220, -0.088740, 0.082500, -0.217630, 0.012780, -0.242810, -0.255200, 0.112660, 
-0.217900, 0.190850, -0.005360, -0.138350, 0.065540, -0.066670, 0.048730, -0.356230, 0.592610, 0.726820, 
-0.627370, -0.243150, -0.227490, -0.609170, -0.116410, 0.288630, -0.121550, -0.348270, -0.075570, 0.019310, 
-0.005780, -0.001610, 0.304430, 0.062100, 0.079510, 0.011310, -0.090560, -0.003490, -0.378070, 0.424140, 
0.072910, 0.056890, -0.146450, -0.257380, -0.515390, 0.118920, 0.297410, -0.032220, -0.767640, -0.320570, 
-0.378220, 0.032020, 0.928870, 0.681960, -0.068550, -0.353680, -0.229610, -0.091800, 1.335050, 0.277850, 
-0.041490, -0.669770, -0.270280, 0.286790, -0.041210, 0.030700, 0.134950, 0.644110, 0.400880, 0.344150, 
0.031100, -0.140700, 0.470250, -0.297980, -0.028050, 0.262860, -0.122440, 0.075940, -0.004080, 1.533620, 
0.361880, -0.110710, 0.216570, 0.160320, 0.584360, 1.180210, -1.004730, -0.172240, 0.288350, 0.191840, 
0.444840, 0.000640, -0.318320, -0.945450, -0.173620, -0.185960, 0.274450, -0.078350, 0.263270, -0.114700, 
1.561760, 0.123990, -0.478800, 0.103550, 0.646670, 0.273360, 0.488810, -0.844830, -0.486100, 1.074610, 
0.854860, 0.000230, 0.945880, 0.747050, -1.535340, -0.046710, 0.043590, -0.185600, 0.322560, 0.647410, 
-0.103070, 0.538960, 0.484720, 0.506030, -0.638980, -0.007970, 0.531080, 0.175340, -0.336170, 0.558650, 
0.279540, 0.358560, 0.377910, 0.200300, 0.594300, -1.566690, -0.773960, -1.093850, 0.277660, 0.712860, 
0.136520, -0.099510, 1.043540, 0.243200, -0.472770, -0.988310, 0.425130, 0.183260, -0.584200, 0.542460, 
-0.440840, 0.326710, 0.647580, 0.014410, 0.426340, 0.399670, -0.777610, -0.448910, -0.291790, 0.662830, 
-0.210120, -0.101520, -0.142630, 0.710090, 0.179010, 0.395660, -0.134190, 0.484760, -0.130870, -0.120050, 
0.502930, 0.018840, 0.102070, 0.424210, 0.236590, 0.050370, -0.261990, -0.506170, -0.201800, -0.053570, 
-0.416160, -0.162470, -0.178660, -0.139990, 0.227530, 0.394060, 0.337050, -0.194970, 0.127730, -0.204350, 
-0.358890, -0.026450, 0.249850, -0.007250, 0.894320, 0.133850, 0.710560, 0.107020, -0.296780, -0.589480, 
-0.317250, 0.002750, 0.239920, -0.230290, -0.150030, 0.054360, 0.086920, 0.424080, 0.178620, 0.285380, 
0.332800, 0.621640, -0.046960, 0.844610, -0.012900, 0.329020, 0.145630, 0.098370, -0.002220, 0.128530, 
0.137560, -0.261710, 0.343640, -0.033530, -0.102720, -0.151060, 0.327700, -0.182630, 0.284810, 0.506610, 
0.365300, -0.054460, 0.185680, 0.315360, -0.040680, -0.010080, 0.429200, 0.404860, 0.160150, 0.311150, 
-0.173530, -0.500300, -0.299100, 0.012530, 0.164550, 0.143600, -0.186260, 
0.232980, 0.007440, 0.157610, -0.337670, 0.196910, -0.415610, -0.550170, -0.026180, 0.400760, 0.203700, 
-0.149640, -0.427800, -0.119380, -0.046620, -0.300450, -0.057650, 0.319350, 0.390370, 0.058830, 0.220280, 
-0.122810, 0.002790, 0.127610, -0.424460, -0.326830, -0.019670, 0.188970, 0.139950, -0.420620, 0.074250, 
0.084310, 0.114370, 0.239980, 0.414190, 0.439800, 0.062460, -0.473470, 0.066140, 0.263400, 0.227650, 
0.460020, -0.113510, -0.408200, -0.171540, -0.079320, -0.183480, 0.220170, 0.170560, 0.266580, -0.176500, 
0.165990, 0.255060, 0.256610, -0.055540, 0.771630, 0.273970, 0.022590, -0.244620, 0.061010, 0.097960, 
0.593670, 0.098160, -0.120360, 0.088200, 0.508080, 0.346060, 0.214220, -0.020920, 0.184930, 0.613410, 
-0.071420, -0.246280, 0.439750, -0.322970, 0.666150, 0.221920, 0.044600, 0.415960, 0.066230, 0.006080, 
0.013550, 0.374030, 0.151660, -0.139310, -0.083980, 0.436320, 0.562450, 0.424440, 0.185480, 0.181630, 
0.210720, 1.493870, -0.207990, 0.007980, 0.062670, 0.406340, -0.319090, -0.433830, 0.383460, -0.110990, 
0.188110, -0.019920, -0.129870, -0.198800, -0.108550, -0.417200, 0.470300, 0.723130, 0.983510, 0.119810, 
0.173040, 0.141500, 1.408660, 0.319980, -0.449220, -0.095140, 0.354960, -0.038450, -0.249220, 0.052170, 
0.076260, 0.418540, 0.265720, -0.189150, -0.268280, -0.086510, -0.276360, 0.692220, 0.229330, -0.111320, 
-0.182140, 0.140180, -0.424250, 0.635280, -0.166400, 0.130100, -0.180650, 0.725410, 0.191140, -0.192250, 
-0.057330, -0.225870, -0.253810, -0.236560, -0.094620, 0.080400, -0.090970, -0.725200, 0.620400, 0.314770, 
0.237960, 0.518050, 0.163470, -0.082380, -0.864070, 0.784350, 0.204240, -0.252710, 0.324330, 0.319070, 
0.142480, 0.113980, -0.324880, 0.621960, 0.344390, -0.035410, 0.565970, -0.092330, -0.199870, 0.506130, 
-0.416270, -0.724990, 0.880540, -0.555280, 0.135870, 0.473800, -0.222070, 0.485110, 0.302050, 0.115930, 
-0.131940, 0.494610, -0.674810, 0.128780, 0.275810, 0.126400, 0.238070, 1.087370, 0.004340, 0.371230, 
0.305390, -0.430380, -0.790410, 0.245080, -0.329260, -0.017780, 0.777800, 0.395490, 0.855320, 0.141700, 
-0.228430, 0.358550, 0.129400, -0.900220, -0.126100, -0.345910, 0.485770, 0.549220, 1.043940, 0.003520, 
-0.099970, 0.527040, -0.210640, -0.850150, 0.086890, 0.049810, -0.064480, 0.132670, 0.279560, 0.170310, 
0.213150, -0.169790, 0.275140, -0.103150, -0.517290, 0.292490, 0.571860, 0.521110, 0.135800, 0.323990, 
-0.015940, -0.700080, 0.671720, -0.481380, -0.741940, 0.465830, 0.182200, -0.212850, -0.212840, -0.275440, 
0.340390, -0.109000, 0.053970, 0.235370, 0.492060, -0.097470, -0.584970, 0.136310, 0.245750, 0.530210, 
0.603730, -0.024860, -0.418090, 1.016050, -0.558710, -0.367920, 0.696610, 0.295330, -0.012330, -1.130380, 
-0.114790, 0.479740, 0.379930, 0.260990, 0.296150, 0.266630, 0.170070, -0.335200, -0.128560, -0.067140, 
0.017060, 0.495500, -0.017830, -0.358950, 0.162030, -0.727600, 0.134800, 0.455640, -0.264210, -0.265400, 
0.071160, -0.014150, 0.292370, -0.124230, 0.143740, 0.261300, -0.179840, -0.108020, -0.303840, -0.160620, 
0.296880, 0.087130, 0.631680, -0.017210, -0.576390, 0.603600, 0.091650, -0.375750, 0.275260, -0.305230, 
-0.441400, -0.446390, 0.216680, 0.189630, 0.159160, 0.751120, 0.386870, 0.449810, 0.239500, 0.222140, 
0.535970, 0.226970, 0.163680, 0.742270, -0.010350, -0.469130, 0.041990, 0.317240, 0.620170, 0.338050, 
-0.551420, -0.016190, 0.312990, 0.048660, 0.515080, -0.220540, 0.227720, -0.103550, -0.171870, 0.898970, 
0.029460, 0.528150, -0.036350, -0.678110, 0.513960, 0.011090, -0.069590, 0.699550, 0.400150, 0.346250, 
0.771680, -0.327970, -0.363160, 0.618680, -0.155650, 0.054510, -0.152260, 1.022400, 0.040040, 0.094670, 
0.301970, 0.210810, 0.333640, 0.331990, -0.323200, 0.126420, 0.008140, 
-0.084030, 0.039230, 0.707990, -0.408480, 0.152590, 0.056000, 0.271430, -0.516980, 0.121790, 0.348820, 
0.044970, 0.381040, 0.107810, -0.541920, 0.309490, 0.253460, 0.084290, -0.029630, 0.000600, 0.714740, 
0.050460, -0.065150, 0.346830, -0.048890, -0.283900, 0.004090, 0.448680, 0.617160, -0.101770, 0.703590, 
0.034270, 0.428520, 0.401650, 0.155340, -0.560850, 0.100500, -0.205780, -0.258740, -0.524640, -0.171890, 
0.202780, 0.043970, 0.532140, -0.094990, -0.138440, -0.377220, -0.290970, 0.316220, 0.160460, 0.068190, 
-0.037740, 0.636620, 0.154940, -0.423130, -0.024050, 0.589040, -0.630900, 0.579880, 0.176660, -0.204660, 
-0.361440, 0.707200, 0.048680, 0.106960, 0.055110, -0.015960, -0.343380, 0.194070, -0.179490, -0.107430, 
0.069450, 0.257460, 0.097720, -0.063610, -0.243490, 0.120320, 0.209330, -0.091180, -0.185850, -0.285800, 
0.345250, 0.237990, 0.151520, 0.057020, 0.128920, 0.161470, -0.311150, 0.048650, -0.263420, -0.168670, 
0.204560, 0.027160, -0.753240, 0.225300, 0.184300, 0.224260, 0.002710, 0.200610, -0.159010, 0.181540, 
0.113900, 0.089880, 0.014480, 0.046650, 0.072610, -0.095830, 0.272790, 0.288080, 0.203040, -0.139780, 
0.173720, -0.127470, 0.453330, -0.065210, -0.234710, 0.067880, 0.582390, 0.364310, -0.208920, 0.171280, 
0.470870, 0.247670, 0.101670, 0.016950, -0.227680, 0.041830, 0.250620, -0.159630, 0.576490, -0.090490, 
0.240850, -0.124560, 0.014540, 0.995780, 0.323970, 0.084410, 0.211590, 0.325170, 0.282110, -0.301570, 
-0.226920, 0.272340, 0.666720, 0.653190, 0.005080, -0.071580, 0.022850, 0.105430, 0.043090, 0.345010, 
-0.233410, 0.181730, -0.370730, -0.545050, -0.364710, 0.015820, -0.440740, 0.956840, 0.319150, 0.449220, 
0.448390, 0.093630, 0.587200, 0.349660, 0.051170, 0.101270, -0.077200, 0.054590, -0.518100, -0.380750, 
0.327130, 0.482800, 0.245280, -0.242070, -0.933950, 1.760820, 0.297230, -0.534050, -0.231950, -0.489900, 
-0.760080, 0.405700, 0.860100, 0.592110, 0.289310, -0.189600, -0.422110, -0.432780, 0.004760, -0.232750, 
0.175000, -0.022640, 0.024980, 0.181090, 0.227960, 0.337760, -0.104820, -0.569270, 0.247160, 0.679410, 
0.011170, 0.043870, 0.104620, 0.045530, -0.000990, 0.596050, 0.800990, -0.185910, 0.144990, 0.040280, 
0.409110, 0.046350, -0.086820, 0.622490, 0.132340, 0.152600, 0.155330, 0.607640, 0.128130, -0.214860, 
-0.670500, 0.278210, -0.449040, -0.088360, 0.783470, 0.338850, 0.502270, -0.094380, -0.129990, -0.032130, 
0.041850, -0.088360, 0.303240, -0.120310, 0.077700, 0.060070, 0.156760, 0.978940, -0.047240, 0.193050, 
-0.322050, 0.280440, 0.104550, -0.020100, 0.182900, 0.000570, -0.012150, -0.155900, 0.835490, 0.084410, 
-0.140220, 0.067600, 0.467680, 0.310040, -0.030770, -0.198210, 0.139990, 0.127230, 0.231500, 0.036720, 
0.201430, -0.019800, 0.199400, 0.100250, 0.170630, 0.302560, -0.009410, 0.359190, 0.004130, 0.572930, 
0.198700, 0.130450, 0.060520, -0.435330, 0.060150, 0.077200, 0.373080, -0.047830, 0.137180, -0.138020, 
0.124740, -0.213380, -0.092150, 0.081780, -0.118140, 0.138030, 0.262040, -0.683660, -0.328720, -0.192030, 
0.900810, 0.077690, -0.509730, 0.042780, 0.405650, -0.053500, 0.642450, 0.291170, 0.315320, -0.043230, 
-0.138890, -0.058860, 0.013550, 0.025730, 0.169110, 0.090900, 0.042530, -0.124580, 0.049380, 0.093670, 
0.207400, 0.317770, 0.210710, -0.087000, 0.047550, 0.117740, 0.440360, -0.061730, -0.244120, -0.157100, 
-0.163400, 0.013570, -0.428380, 0.273040, 0.192770, 0.025580, 0.503700, 0.117030, 0.296740, 0.678990, 
-0.039760, -0.113560, 0.939570, 0.320170, 0.353450, 0.011460, -0.015080, -0.095920, -0.381910, 0.363610, 
0.434900, -0.172770, 0.087150, 0.199140, 0.149760, 0.055790, -0.202440, -0.237620, -0.195030, -0.405670, 
0.285920, 0.042370, -0.306620, -0.036580, -0.062960, 0.310710, 0.006470, 
-0.250080, -0.056570, -0.144980, -0.179320, 0.546660, -0.180300, -0.252280, -0.206310, 0.028830, -0.042660, 
-0.039410, 0.061440, 0.203700, -0.271730, -0.340300, -0.321730, 0.094330, -0.261100, 0.071530, 0.113460, 
0.003760, 0.423120, 0.056470, 0.329130, 0.242390, 0.570580, 0.013660, 0.522120, -0.385510, 0.059690, 
0.359600, 0.095430, 0.031550, 0.049290, 0.040540, 0.071840, -0.044210, -0.309680, 0.134240, 0.669350, 
0.758740, 0.015130, 0.054290, 0.246410, -0.163630, 0.207440, 0.211430, 0.285060, 0.873520, 0.023530, 
-0.134950, -0.516520, -0.011060, 0.353590, -0.082110, 0.069620, 0.239610, 0.552200, 0.018590, -0.148710, 
-0.183750, -0.395830, 0.028990, 0.062390, -0.379650, 0.155300, -0.057010, 1.023960, -0.271080, -0.608940, 
-0.024110, -0.377940, 0.134300, 0.203700, -0.617050, -0.113340, 0.136780, 0.275800, -0.101030, -0.650490, 
-0.389810, -0.385660, 0.414850, 0.038690, -0.435960, 0.455450, -0.420950, -0.139600, 0.212270, -0.103480, 
0.075060, -0.045830, 0.106670, 0.143040, -0.240190, 0.052010, 0.203380, -0.283480, -0.255270, -0.227880, 
-0.754220, -0.210160, 0.309580, -0.167320, 0.037990, 0.105840, -0.006360, -0.039350, -0.371050, 0.490510, 
0.530730, 0.120960, -0.142930, -0.397730, 0.368320, -0.140670, 0.158900, 0.239530, -0.319070, 0.755250, 
-0.016950, 0.142600, -0.153530, -0.190330, 0.140250, 0.024700, 0.276010, -0.284670, 0.345930, 0.415320, 
0.732210, 0.106470, 0.097400, 0.173930, 0.072670, -0.449430, 0.041540, -0.032130, -0.092500, -0.497620, 
-0.305520, 0.245430, 0.960340, -0.303950, -0.272640, -0.238560, -0.002580, -0.119400, 0.213940, 0.557170, 
-0.070560, -0.463480, 0.119190, -0.212810, -0.769020, 0.825270, -0.738950, 0.222590, 0.229220, 0.347640, 
-0.493020, 1.041590, -0.147260, 0.204940, 0.268420, 0.058030, -0.492280, 0.003410, -0.518800, 0.241390, 
0.051870, -0.083340, -0.307140, -0.246940, -0.658610, 1.555490, -0.291800, -0.279250, -0.199080, 0.110570, 
-0.369100, 0.131580, 1.103340, -0.389950, -0.189550, 0.062830, -0.254630, -0.158570, 0.003650, -0.247660, 
0.193810, 0.210640, 0.313820, 0.902490, 0.437150, -0.135460, -0.381750, 0.324470, 0.309450, 0.174500, 
-0.047620, 0.524270, 0.466400, -0.926490, -0.083090, 0.353100, 0.578140, 0.713340, 0.729840, 0.103110, 
0.170080, -0.056620, -0.390010, -0.053530, 0.145400, -0.087310, 0.003530, 0.930020, -0.058480, -0.068910, 
-0.155290, -0.131000, -0.064740, -0.484780, 2.569080, -0.157930, 0.426460, -0.674060, -0.213800, 0.670090, 
0.087200, -0.423900, -0.396540, -0.047100, 0.437530, -0.250740, -0.050680, 0.079440, -0.034350, 0.481930, 
-0.146660, -0.035220, -0.493580, 0.255380, 0.444690, 0.688810, -0.100240, 0.205120, 0.388590, -0.046940, 
-0.091100, 0.100070, -0.276710, 0.003610, 0.161990, 0.584720, -0.058080, 0.398250, -0.073030, -0.268610, 
0.758310, 0.359440, 0.153540, 0.290040, 0.373920, 0.390160, 0.386300, 0.306360, 0.224250, -0.108760, 
0.789970, 0.238600, 0.115870, 0.622290, 0.395230, 0.238660, -0.252860, 0.571410, 0.351060, 0.049840, 
0.772320, 0.639940, -0.002140, -0.014380, 0.366380, 0.464060, 0.070300, -0.234220, 0.195530, 0.491370, 
-0.185860, -0.239610, 0.041380, 0.086290, 0.200730, -0.267420, 0.552840, 0.008600, -0.379570, -0.029060, 
-0.196240, 0.059900, -0.123500, -0.239270, 0.127920, 0.045370, -0.137430, -0.496130, -0.557160, 0.514040, 
0.668950, 0.183610, 0.061290, 0.101580, 0.105430, 0.726360, 0.522140, -0.425280, 0.070820, 0.085220, 
0.113490, 0.342370, 0.383590, 0.039010, -0.152200, -0.008250, 0.665040, -0.443020, 0.230850, -0.116920, 
-0.243750, 0.034500, 0.392460, -0.031200, 0.263290, 0.085790, 0.258920, 0.105790, -0.080660, -0.184450, 
0.172780, 0.196770, 0.055740, -0.249000, 0.675620, 0.079030, 0.622620, 0.408450, 0.263110, -0.270570, 
-0.055720, -0.103980, -0.217050, -0.182830, -0.111200, 0.260990, 0.066420, 
-0.360590, -0.431430, -0.440110, 0.015370, -1.043700, 0.546280, -0.099890, -0.137300, -0.037620, 0.008630, 
0.433510, -0.003640, -0.119380, 0.464370, -0.098580, -0.097290, -0.185660, 0.186110, -0.097910, -0.168180, 
-0.083320, -0.050740, 0.322740, -0.185430, 0.215360, -0.697740, 0.597490, 0.482760, -0.008220, -0.137260, 
-0.054820, -0.383180, 0.204730, -0.517580, -0.147140, 0.125180, -0.139930, 0.203280, 0.008520, 0.122650, 
-0.241280, -0.100200, -0.349110, 0.277260, 0.846320, -0.209160, -0.023820, -0.154570, -0.039180, 0.912110, 
0.516330, -0.203320, 0.072430, -0.388850, 0.204800, 0.542580, -0.513450, -0.006350, 0.446700, 0.861350, 
0.589180, -0.314730, -0.100260, -0.006220, -0.165940, -0.213720, -0.381930, 0.090760, -0.041710, -0.455510, 
0.151450, -0.431370, 0.067370, -0.024500, -0.025210, -0.006430, 0.373600, 0.555360, 0.015690, 0.033000, 
-0.303480, 0.040610, 0.148620, -0.082680, -0.318510, 0.229970, -0.272100, -0.463960, -0.458650, -0.024610, 
-0.027960, 0.054330, -0.039260, 0.381210, -0.400890, 0.216880, -0.028140, 0.450570, -0.059490, 0.084780, 
0.432370, 0.657530, 0.469200, 0.375650, -0.076420, -0.206650, 0.103270, 0.296260, -0.232370, -0.200220, 
0.787320, 0.313010, -0.214940, 0.425010, 0.051710, -0.609960, 0.233080, -0.107540, -0.343490, -0.135540, 
-0.199140, 0.577740, -0.256680, -0.158850, 0.436560, -0.069140, 0.754440, 0.434400, -0.200100, -0.464760, 
-0.307450, 0.415960, 0.142680, -0.572320, -0.257060, 0.001950, 0.006790, -0.016580, 0.053960, 0.581950, 
-0.561080, -0.131410, -0.149850, 0.082660, 0.108570, 0.452740, -0.037100, 0.329340, -0.228280, -0.854530, 
-0.896530, -0.285250, 0.187140, 0.329630, -0.505240, -0.261260, 0.551180, 0.046790, -0.167640, 0.416250, 
0.269050, -0.835830, -0.153470, -0.024310, 0.532460, -0.052580, 0.846870, -0.083550, 0.468760, 0.401670, 
-0.617940, -0.701070, 0.187770, 0.114820, 0.318880, -0.744910, 0.504640, 0.269520, -0.341470, -0.084240, 
-0.050130, 0.496000, -1.646830, 0.075280, 0.710710, -0.088320, -0.086690, 0.983060, 0.004940, 0.173070, 
0.302320, -0.178650, -1.257930, 0.301200, -0.039840, -0.404780, -0.882590, 0.129290, 0.917730, 0.529590, 
-0.089270, 0.413110, 0.371740, -1.050090, -0.153420, -0.018880, 0.391210, 0.581010, 0.693840, -0.057860, 
-0.277650, 0.253960, 0.187340, 0.323550, 0.086860, -0.229250, 0.396230, -0.360930, 0.871980, -0.362860, 
0.191220, 0.278280, -0.232960, 0.232920, -0.935780, 0.142560, 0.233020, 0.345320, 0.672870, -0.463110, 
-0.050030, -0.315050, 0.312220, 0.219180, 0.161150, -0.121770, 0.380230, 0.336850, -0.435980, 0.211860, 
0.128060, 0.497590, 0.194900, 0.434910, -0.360930, -0.351860, -0.318490, 0.166950, -0.154390, -0.527010, 
0.330440, -0.039150, -0.367630, -0.320960, -0.055920, -0.517990, 0.431890, -0.052630, -0.051270, -0.418790, 
0.342640, 0.546300, 0.137020, 0.384380, 0.512920, -0.006330, -0.285450, -0.665150, -0.072370, -0.134900, 
0.215570, 0.669330, -0.042930, -0.037590, 0.328290, -0.015860, -0.279520, 0.969080, 0.269490, -0.229110, 
-0.614230, 0.458050, 0.412510, 0.435890, 0.550320, 0.610420, -0.369750, 0.027840, 0.004490, -0.229840, 
-0.499910, -0.407680, -0.085820, -0.056430, -0.674200, 0.336210, 0.458340, 0.891260, -0.195820, 0.643830, 
0.517110, 0.068430, 0.140930, -0.178590, -0.376040, 0.729520, -0.088460, -0.848390, 0.335900, 0.061780, 
0.158520, -0.234330, -0.869620, -0.318530, -0.095370, -0.034240, 0.352710, 0.386490, 0.370420, -0.575920, 
0.041920, 0.410940, 0.255050, -0.107180, -0.235440, 0.096980, 0.533580, 0.571080, 0.537880, -0.546110, 
0.233990, 0.368750, 0.493860, -0.002280, -0.470700, -0.088180, -0.126920, 0.175200, 0.058060, -0.001680, 
-0.353560, -0.134380, -0.287120, -0.323320, -0.482440, 0.055140, 0.249000, 0.269390, 0.309990, 0.422850, 
-0.008160, -0.244480, -0.008780, -0.381830, -0.204270, 0.013430, -0.113960, 
-0.193600, 0.525290, 0.434390, -0.230110, 0.235370, 0.039850, 0.053890, 0.043460, 0.276700, -0.210330, 
-0.331710, 0.113070, -0.008820, -0.398960, -0.145410, 0.016880, -0.105950, -0.019520, 0.509800, 0.117020, 
-0.007680, -0.288390, -0.110890, -0.549460, -0.489350, 0.123320, 0.261050, -0.206550, -0.135350, -0.290030, 
-0.154680, -0.014040, 0.374060, -0.345960, -0.118400, 0.311860, -0.540600, 0.018590, 0.068320, 0.099140, 
0.133280, -0.000920, -0.631520, -0.010750, -0.495270, -0.524610, 0.103550, -0.172190, 0.016000, -0.384990, 
0.255260, -0.257620, -0.017020, 0.261020, 0.129290, 0.133190, 0.026800, -0.238150, 0.111610, 0.248690, 
-0.104140, -0.016150, -0.030160, -0.446010, 0.199920, -0.129840, -0.495340, -0.280130, -0.071900, -0.016970, 
-0.396850, -0.139080, 0.438670, 0.015600, 0.396430, -0.033360, 0.198670, -0.385970, -0.118830, -0.125470, 
0.099230, 0.186590, 0.367390, -0.004590, -0.347090, 0.096120, -0.172150, 0.106130, 0.613040, 0.165930, 
0.002300, -0.300370, 0.116290, 0.139410, -0.186220, 0.009750, 0.227820, -0.014640, 0.241990, -0.477720, 
-0.040360, -0.109070, -0.173290, -0.054230, 0.016510, 0.042720, 0.159630, -0.023040, -0.182300, 0.015030, 
0.183360, 0.114940, 0.232550, 0.364160, -0.349390, 0.017430, 0.245700, 0.424930, 0.175370, 0.188200, 
0.105850, -0.155980, -0.275190, 0.038500, 0.328850, 0.026990, -0.628490, 0.087500, -0.503930, -0.348450, 
0.539390, -0.277760, -0.498780, -0.281200, -0.192260, 0.389250, 0.383630, -0.304340, 0.398220, 0.226060, 
-0.434830, -0.324500, 0.160640, -0.463910, 0.068300, 0.351360, 0.053300, -0.109000, 0.592270, 0.264220, 
0.467330, 0.262520, 0.385290, 0.173000, 0.418890, 0.160280, -0.754820, -0.509570, 0.279480, -0.048060, 
-0.240440, 0.614620, 0.537700, 0.340570, 0.165230, -0.007980, -0.366170, 0.049100, -1.038450, 0.173110, 
0.051050, -0.081840, 0.201730, -0.494980, -0.469420, 0.503910, -0.019800, -0.232420, -0.191310, 0.086040, 
-0.153870, -0.122600, 0.402750, 0.167840, 0.549070, 0.093500, 0.031040, -0.090990, -0.008460, -0.570250, 
-0.003520, -0.360870, -0.081570, 0.149430, -0.341980, -0.637250, 0.769460, -0.188740, -0.286820, -0.294570, 
0.024330, -0.140080, -0.349760, 0.842030, 0.050900, -0.005030, 0.401770, 0.170110, -0.194510, 0.056080, 
-0.141050, 0.525040, 0.484440, 0.933410, 0.186180, 0.022880, 0.471080, 0.712410, 0.486980, -0.406350, 
-0.494990, 0.537890, -0.368520, -0.220730, 0.578120, 0.976390, 0.397980, -0.543050, 0.027030, -0.165940, 
0.052690, -0.292750, -0.463700, -0.515830, -0.199220, 0.340150, -0.102450, 0.016050, -0.041370, -0.204030, 
0.366470, 0.018890, -0.686560, -0.240820, -0.108130, 0.737310, 0.138270, 0.115780, -0.175410, 0.169910, 
0.653900, 0.064020, -0.464150, -0.162880, -0.056960, 0.470100, -0.596300, -0.045230, 0.004800, 0.255790, 
0.340400, -0.045820, -0.275050, -0.292030, -0.133190, -0.141220, 0.190730, 0.194710, 0.356840, -0.147930, 
0.070930, 0.031130, 0.084060, 0.076220, 0.189480, -0.172670, -0.119110, 0.000310, -0.038160, 0.193900, 
-0.040790, -0.042560, 0.081070, 0.291450, -0.344710, -0.010120, 0.506430, -0.572490, -0.109030, -0.011690, 
0.061230, 0.243260, 0.220200, 0.088690, 0.191080, 0.132880, -0.464350, -0.113410, 0.193400, 0.107260, 
-0.054230, -0.833350, 0.148210, 0.320540, 0.240960, -0.387180, 0.280720, 0.075840, 0.524770, -0.383440, 
0.115350, -0.108250, 0.187530, 0.478640, 0.082050, -0.091830, 0.373230, -0.068640, 0.029240, 0.586740, 
0.158500, 0.133330, 0.035090, -0.033670, 0.005270, 0.009860, 0.048370, 0.186240, -0.181600, -0.402390, 
-0.027860, 0.300820, 0.189170, -0.368830, 0.191230, 0.106330, 0.135180, -0.247740, 0.288520, 0.089810, 
0.039460, 0.175840, 0.211890, 0.266050, 0.201180, 0.293820, 0.034260, -0.200550, -0.272080, -0.070170, 
-0.022320, 0.177110, 0.000540, -0.554800, -0.079970, 0.086410, 0.113820, 
0.364260, 0.381030, -0.066990, -0.578740, 0.250600, -0.059080, 0.302050, -0.202830, 0.439800, -0.045770, 
-0.152390, -0.151500, -0.127340, 0.473670, -0.300220, 0.216130, -0.191300, 0.065670, -0.003490, -0.415120, 
-0.167310, 0.365080, 0.006190, -0.127670, 0.138610, 0.168510, -0.495040, -0.781280, 0.809080, 0.086780, 
0.166540, -0.027720, 0.213440, 0.188880, 0.217360, -0.034760, 0.020800, -0.176430, 0.133230, 0.316510, 
-0.234160, -0.157220, 0.661730, 0.307340, 0.307900, 0.146960, 0.477610, -0.152650, 0.318700, 0.268360, 
-0.040580, 0.258720, 0.204940, 0.357960, -0.176560, -0.515730, -0.177850, -0.211660, -0.537460, 0.092270, 
-0.246700, -0.051460, -0.121770, 0.777180, -0.115740, 0.031680, -0.169210, 0.094070, -0.243270, 0.181560, 
-0.523760, 0.283460, -0.108950, 0.079310, -0.223390, -0.066490, 0.143940, -0.470390, 0.112820, -0.013310, 
0.183570, -0.152260, -0.066780, -0.133980, 0.201030, -0.233900, -0.821020, -0.112930, -0.277670, -0.317470, 
-0.089350, -0.270940, 0.403700, -0.041950, 0.331450, -0.385010, -0.350960, -0.016090, -0.062130, -0.131060, 
-0.242580, 0.149450, -0.020560, -0.286080, -0.082260, 0.568300, 0.825250, -0.312070, -0.085720, 0.243630, 
0.022480, 0.229490, -0.137820, 0.160630, 0.126640, -0.036540, 0.042940, -0.073850, 0.013420, 0.156670, 
-0.298650, -0.010050, 0.401450, 0.097470, -0.428380, -0.090940, 0.614840, 0.576310, 0.658090, 0.814030, 
-0.319520, 0.156460, 1.304860, -0.427190, 0.344300, -0.232830, 0.461300, 0.564050, 0.363730, -0.258230, 
0.593320, -0.229070, -0.450310, 0.178710, 0.306950, -0.055970, -0.077140, 1.228770, -0.428870, -0.296000, 
-0.141830, -0.117990, 0.037230, -0.179970, -0.305590, 0.372950, 0.115240, 0.701280, -0.400150, 0.182330, 
-0.075320, 0.028590, 0.277350, 0.151110, 0.205050, -0.232620, -0.225040, -0.057350, 1.255440, 0.530310, 
-0.277120, -1.220650, 0.105350, -0.146030, 0.018470, -0.080790, -0.494080, 0.322280, 0.758890, 0.173650, 
0.324090, -0.191240, -0.121840, -0.664830, -0.591780, -0.346920, -0.366240, -0.287510, -0.005890, 1.270800, 
0.907050, 0.977160, 0.326200, 0.265540, 1.243670, 1.353180, 0.063850, -0.003090, 0.026170, 0.204360, 
0.787420, 0.359840, -0.365950, -0.573020, 0.083720, -0.563140, 0.251020, -0.112160, 0.026250, -0.055020, 
1.276350, 0.736840, 0.706210, 0.490890, -0.246280, 0.863660, 1.454240, -0.328050, 0.489370, 0.345170, 
0.929050, 0.735270, 0.984850, -0.288480, -0.968590, 0.035820, -0.310350, 0.135110, 0.407830, -0.358670, 
-0.057900, 1.519700, -0.834020, 0.042170, -0.985800, 0.873040, -0.463650, -0.449630, -0.158260, 0.235690, 
-0.024090, 1.180010, -0.445890, -0.246430, -0.159750, -0.740390, -0.098750, -0.383970, 0.097450, 0.331290, 
-0.437150, -0.059090, 0.627410, 0.116250, -0.674000, -0.344330, 0.401660, 0.284650, -0.129580, -0.254470, 
-0.229090, 0.126530, 1.287810, -0.233080, 0.590290, -0.014570, -0.245360, -0.523140, -0.501720, 0.326370, 
-0.377600, 0.344370, -0.119340, 0.400510, 1.141630, 0.664210, 0.459670, 0.104190, 0.693300, 0.570500, 
0.644830, 0.323220, 0.454810, 0.303130, 0.839490, -0.143960, -0.078220, -0.496070, -0.231140, -0.233040, 
0.172010, -0.204540, -0.153190, -0.086570, 1.557550, 0.734140, 0.095210, 0.015660, 0.230230, 0.080800, 
0.061390, 0.295380, 0.714250, 0.051410, 0.524820, 0.194140, 0.461200, 0.242460, 0.161040, -0.081690, 
-0.326840, 0.328470, 0.447620, 0.029030, -0.085820, 0.846370, -0.010550, -0.391750, -0.719280, 0.026770, 
-0.068480, -0.036800, -0.086030, -0.070070, 0.263490, 1.016950, 0.340590, 0.425890, 0.539440, -0.122470, 
-0.344520, -0.275260, -0.076070, 0.403570, 0.053310, -0.100260, 0.771570, -0.125430, -0.394210, -0.226750, 
0.497110, 0.576230, 0.406910, 0.253500, -0.330740, 0.263000, 0.206440, 0.267280, 0.055830, 0.505150, 
-0.392920, -0.574090, -0.259780, -0.110170, 0.097990, 0.168650, -0.129130, 
0.384070, 0.323680, -0.168870, 0.284230, -0.330530, -0.109350, 0.418670, 0.410310, -0.240140, -0.352240, 
0.050410, 0.100160, 0.155880, -0.045950, 0.206300, -0.120730, 0.029670, -0.176810, -0.275140, -0.435680, 
-0.138740, 0.325170, 0.223300, -0.472420, 0.417950, 0.080400, -0.090420, 0.494490, -0.496240, -0.127950, 
-0.008440, 0.317530, -0.167930, -0.170950, -0.236390, 0.590970, -0.213480, 0.139310, 0.042320, -0.090050, 
-0.061790, -0.146720, 0.779750, 0.783030, -1.087770, 0.392680, -0.170220, 0.499190, -0.020940, -0.366150, 
0.165060, -0.370490, 0.319510, 0.022480, -0.073530, 0.042640, -0.229590, -0.365160, -0.207760, -0.427160, 
-0.518000, -0.084130, -0.114020, 0.276210, 0.579560, -0.351850, 0.095250, -0.126060, 0.652310, 0.021150, 
-0.385290, 0.066430, 0.068790, -0.009790, 0.174110, 0.272500, -0.218650, -0.297310, -0.316570, -0.316100, 
-0.572000, -0.341810, -0.756680, -0.130480, 1.450100, 0.231000, -0.314760, 0.487640, 0.038170, 0.499400, 
0.141010, -0.446420, -0.293110, 0.082350, 0.258970, -0.208030, 0.394320, -0.203230, -0.264330, 0.322130, 
-0.434510, 0.214260, -0.391770, -0.255330, -0.146320, 0.758670, 0.605920, 0.224660, 0.471620, -0.224630, 
0.209360, 0.115740, -1.291410, 0.036450, -0.045200, 0.250310, 0.211440, 0.219750, 0.046460, 0.400080, 
-0.374060, -0.595100, -0.280500, -0.082970, -0.469760, -0.140510, 1.380200, 0.444730, -0.851360, 0.821740, 
0.631290, 0.394420, 0.866820, -1.301210, 0.274250, 0.582920, 0.490750, 0.389340, 0.380750, -0.489780, 
-0.144860, -0.241620, -0.542730, 0.609700, -0.570280, -0.662120, -0.103430, 1.700420, 0.695810, 0.105060, 
1.173650, 0.229830, 0.913570, 0.838230, -0.935080, 0.616870, 0.035260, 0.598670, 0.114210, 0.044710, 
-0.093360, -0.137630, -0.046660, -0.557650, 0.447650, -0.538950, -0.682430, -0.068720, 1.695200, 0.856240, 
-0.126220, 0.410840, 0.110520, 0.857770, 1.329100, -0.682050, 0.769620, -0.249410, 0.645560, 0.046470, 
0.806010, 0.168910, -0.271750, -1.014940, -1.025810, 0.517070, 0.393240, -0.481920, -0.006270, 1.478510, 
0.406690, 0.012120, 0.184510, -0.405400, 0.773540, 1.013990, -0.198090, 0.307860, -0.484920, 0.243900, 
0.610930, 0.073830, 0.011020, -1.840250, -0.733440, -1.181110, 0.430220, 0.015520, -0.907370, -0.092480, 
1.328510, 0.668980, 0.372060, -0.263040, 0.079080, 0.976330, 0.352070, -0.171940, 0.152610, 0.187930, 
0.228910, 1.328000, 0.551720, -0.529640, -1.541490, -0.817760, -0.623940, 0.155010, 0.580980, -1.032600, 
-0.125300, 0.612990, 0.351370, 0.255670, -0.075770, 0.152530, 0.538780, -0.102250, 0.282980, -0.110090, 
-0.233200, -0.013990, 0.689490, 0.077520, 0.011910, -0.923140, -0.884730, -0.696380, 0.501530, 0.239860, 
-0.748990, -0.165580, 1.027060, 0.610510, 0.259360, -0.003690, 0.345210, 0.310740, 0.287000, 0.187710, 
0.314780, -0.157260, 0.306070, 0.536300, 0.388300, 0.127480, -0.664930, -0.988570, -0.679940, -0.099450, 
0.740440, -0.618130, -0.227070, 1.029160, 0.023560, 0.219400, 0.252540, -0.099080, -0.121310, 0.281100, 
0.117560, 0.029950, 0.141590, 0.233250, 0.130480, -0.028240, -0.550120, -0.331190, -0.514520, 0.021100, 
0.207930, 0.759730, -0.224530, -0.199830, 0.246050, 0.589500, 0.913860, -0.019210, 0.120470, -0.331510, 
-0.475470, 0.147500, 0.080830, 0.271990, 0.020260, 0.270780, 0.030080, -0.137050, -0.386710, -1.013440, 
-0.197250, 0.156220, 0.060400, -0.003550, -0.179380, 0.129870, 0.733860, 0.542420, 0.003920, 0.036660, 
0.068870, -0.352030, -0.292470, -0.318020, 0.337450, -0.023300, 0.268750, 0.091540, 0.370660, -0.613180, 
-0.670930, -0.012650, 0.012400, -0.032060, 0.219740, -0.157000, 0.229440, 0.235860, 0.586170, 0.292350, 
-0.248900, -0.004670, 0.122440, -0.111200, 0.354810, 0.170540, -0.127420, 0.249540, -0.008230, -0.732100, 
0.287980, -0.492970, -0.062270, -0.472540, 0.422760, 0.131250, -0.159980, 
-0.063790, 0.414090, -0.102780, -0.130770, 0.036040, -0.426700, -0.017690, -0.284660, 0.261120, 0.189450, 
-0.241970, -0.055850, 0.255590, -0.228020, 0.198280, -0.012880, 0.609850, 0.484510, -0.015910, -0.345590, 
-0.058370, 0.940730, 0.194700, 0.083550, 0.171110, 0.113810, 0.265880, 0.021140, 0.159540, 0.341910, 
0.445000, -0.122370, 0.116500, 0.112520, -0.073650, 0.299640, 0.393050, 0.059760, 0.015060, -0.236960, 
-0.237510, -0.015440, 0.769160, 0.120060, -0.062600, 0.131610, 0.278200, 0.319430, 0.925810, -0.339950, 
-0.012420, -0.270940, -0.091970, 0.366600, 0.167350, -0.227800, 0.504430, -0.123700, -0.279860, -0.122060, 
-0.125770, -0.269330, -0.040750, 0.632490, -0.168880, 0.334770, 0.184340, -0.448660, -0.174490, 0.199000, 
-0.570660, -0.311310, -0.233820, 0.557510, -0.622630, 0.268000, 0.279270, -0.554910, 0.268060, 0.337780, 
0.125770, -0.053770, -0.383540, 0.018130, 0.673100, 0.268950, -0.484460, -0.020150, 0.106730, 0.109740, 
-0.098380, -0.355420, -0.344500, 0.368030, 0.415400, 0.175830, 0.570420, 0.289460, -0.059450, 0.044370, 
0.011500, 0.739720, -0.248540, -0.244500, 0.025290, 0.925760, 1.385360, 0.791420, 1.005460, 0.105210, 
1.189580, 0.828670, 0.032720, -0.175480, 0.120880, 0.759940, 0.850280, 0.335510, -0.053970, 0.636230, 
0.108600, -0.248150, 0.030960, 0.333140, -0.011380, 0.002430, 1.449630, 0.077690, 0.202570, 0.766360, 
0.182110, 0.368600, 0.558660, -0.392420, 0.032460, -0.153130, 1.082870, -0.338030, -0.046620, 0.281110, 
-0.269110, 0.027970, -0.269230, 0.101750, 0.747700, -0.407450, -0.002830, 1.286800, -0.657490, -0.716330, 
-0.585620, 0.836110, -0.081580, -0.766250, -0.417480, -0.539630, 0.451740, 1.438100, -0.978200, 0.714260, 
0.569960, -0.328550, -0.307220, 0.045230, 0.971320, -0.070470, -0.103980, -0.026620, 1.221990, 0.282490, 
0.433100, -0.370050, 0.387590, 0.120310, 0.368840, -0.017770, 0.153980, 0.564800, 1.305230, 0.706150, 
0.660450, -0.132250, -1.016190, -0.133190, -0.444290, 0.248470, -0.477570, -0.432200, 0.008070, 2.167400, 
0.928630, 1.235570, 0.707130, -0.048880, 0.661970, 0.983210, 0.961510, 0.628210, 0.103080, 0.498720, 
1.616010, 0.182880, -0.117970, -0.479280, 0.642970, -0.229730, 0.842330, 0.328390, -0.280410, -0.041930, 
1.203660, 0.069560, 0.136430, 0.259620, 0.381940, 0.320040, 0.318690, 0.086530, 0.877070, -0.145760, 
0.998900, -0.337290, 0.543830, -0.000770, -0.720510, 0.196980, -0.167400, 0.551190, 0.890880, -0.047410, 
-0.038000, -0.388360, 0.004400, -0.289600, -0.461110, -0.345450, -0.142330, -0.739500, 0.227890, 0.325600, 
0.098190, 0.416640, 0.072290, 0.366550, 0.199320, -0.207430, -0.748800, -0.656060, 0.131120, -0.549040, 
0.121920, -0.076720, -0.216750, 0.042380, -0.144630, 0.098800, -0.490440, -0.136000, -0.278700, 0.462360, 
0.365620, 0.271620, 0.369320, 0.033010, -0.589120, 0.029940, -0.202950, -0.448740, -0.259210, 0.135720, 
0.385120, -0.004410, -0.135750, 0.257740, 0.316830, -0.254110, 0.285900, -0.344220, -0.072640, 0.358240, 
-0.015220, -0.586510, 0.002670, -0.089310, 0.761340, 0.376590, 0.188450, 0.369750, -0.435520, -0.560820, 
0.276950, -0.423060, -0.211460, -0.149910, 0.232490, -0.074710, 0.008190, 0.032080, -0.203540, -0.010080, 
-0.314570, -0.168170, -0.241980, -0.160980, -0.097200, 0.330420, 0.187060, -0.175930, 0.039030, -0.314730, 
-0.105800, -0.093810, 0.113230, -0.145920, -0.129650, -0.112580, -0.282720, 0.478260, -0.158900, -0.312260, 
-0.089860, 0.128970, 0.538160, 0.274410, -0.138100, -0.028470, -0.315740, -0.454190, 0.029720, 0.163770, 
-0.600380, -0.055880, -0.576750, -0.107030, 0.383320, -0.136830, -0.260120, -0.300260, 0.299380, 0.162030, 
0.141650, 0.153070, 0.422080, -0.252130, -0.508290, 0.884750, -0.231060, -0.364330, 0.278900, -0.020600, 
0.332720, -0.571950, 0.276670, 0.140400, 0.034680, 0.270720, -0.104810, 
-0.203200, 0.170390, 0.243430, 0.054880, 0.272560, -0.175620, -0.159950, 0.133960, -0.070780, 0.219370, 
0.126650, -0.313390, -0.144370, 0.007400, -0.589610, 0.339750, -0.138720, -0.737970, 0.058690, 0.047670, 
0.105390, -0.029540, 0.158520, -0.002450, 0.468350, 0.605680, 0.144260, 0.606600, -0.265900, -0.121480, 
0.059920, 0.179440, 0.148590, 0.346820, -0.381350, -0.071980, -0.328270, -0.015820, 0.327500, -0.530070, 
0.107930, 0.133220, 0.461910, -0.062960, -0.020070, 0.144860, 0.354040, 0.534410, 0.241430, -0.158340, 
0.129200, 0.404980, 0.233860, 0.356840, 0.553150, -0.059300, -0.134800, 0.169180, -0.000260, -0.056760, 
0.126140, 0.167360, 0.134240, 0.460400, -0.293820, -0.113030, -0.442230, 0.322970, -0.183370, -0.136280, 
0.073850, 0.247630, 0.171170, 0.168680, -0.757420, 0.176330, 0.075180, -0.221870, 0.206740, 0.020450, 
0.177110, 0.249310, 0.390060, 0.129360, 0.029500, -0.348190, 0.337390, 0.952280, 0.047880, 0.014040, 
0.571430, 0.237310, 0.228580, -0.477140, 0.458270, -0.282540, -0.082960, -0.126590, 0.190220, 0.290910, 
-0.218630, 0.532940, 0.515550, -0.457880, 0.121480, 0.700130, 1.015400, -0.063990, 0.617210, 0.362080, 
0.553740, 0.752280, 0.172430, -0.251790, 0.047200, -0.079380, 0.866040, 0.106870, 0.099500, -0.063090, 
0.363080, 0.255550, 0.731550, 0.299840, -0.241110, 0.138980, 0.562260, -0.032720, 0.357660, 0.118420, 
-0.053860, 0.119290, 0.272270, 0.570350, 0.984600, 0.372600, 0.370530, 0.424550, 0.803160, 0.174720, 
0.069820, 0.060950, 0.345660, 0.152080, -0.152050, 0.017790, 0.151920, 0.247610, 0.141480, 0.420700, 
-0.274300, -0.052740, -0.169360, -0.277870, 0.527070, 0.767910, -0.123880, 0.755050, 0.091930, 0.257480, 
-0.012560, 0.514420, -0.124600, 0.048310, 0.038500, -0.050730, -0.061940, 0.163320, -0.818790, -0.142040, 
0.808930, 0.352640, -0.181790, 0.132750, -0.544870, 1.568980, -0.135630, -0.273810, -0.101260, -0.258280, 
0.116550, -0.036570, 0.207170, 0.474140, -0.222340, 0.070470, -0.414390, -0.264110, -0.007770, -0.035480, 
-0.202010, 0.181620, -0.031280, -0.190620, 0.331440, 0.223320, -0.138520, 0.516330, 0.582710, 0.610630, 
-0.229830, 0.174350, -0.115780, -0.397460, -0.163240, -0.348830, -0.112590, 0.186940, 0.506270, 0.007270, 
0.008740, -0.286090, -0.218680, 0.795790, -0.049040, 0.116280, 0.053900, -0.475050, -0.503380, 0.307080, 
-0.051650, 0.008530, -0.143780, 0.110540, 0.601440, 0.249740, -0.100380, -0.312140, 0.228590, 0.428790, 
0.000690, -0.269580, -0.075540, 0.431320, 0.728800, -0.279520, 0.114770, 0.029880, -0.619310, -0.126730, 
-0.050360, 0.136570, 0.002390, 0.254370, -0.176050, 0.452200, -0.042280, -0.029460, -0.464970, -0.309190, 
0.027980, 0.023530, -0.221320, 0.081610, -0.080880, -0.219200, -0.256510, 0.026160, 0.140670, 0.181450, 
0.083210, 0.187320, 0.461860, 0.313990, 0.059750, 0.241140, -0.304160, 0.244180, 0.229560, -0.718660, 
-0.200110, -0.319890, 0.035420, -0.016390, -0.286670, 0.229910, 0.240150, -0.202290, 0.050730, 0.324850, 
-0.041160, 0.170990, 0.060680, 0.210850, -0.008320, 0.071110, -0.475420, -0.248640, 0.332010, 0.289530, 
-0.048610, 0.104380, 0.069620, 0.028310, 0.057500, 0.079930, 0.367360, 0.169260, -0.052220, 0.297140, 
0.232130, 0.006910, 0.044880, -0.227720, -0.018990, 0.200260, -0.286790, -0.249730, 0.500420, 0.343430, 
0.224070, 0.167460, 0.127660, -0.207720, 0.043630, 0.160580, -0.031310, 0.322800, 0.137820, 0.716120, 
-0.246230, 0.523910, -0.082300, -0.182510, 0.066770, 0.201180, 0.708620, -0.636560, 0.157550, -0.092240, 
-0.054720, -0.305270, -0.092650, -0.051980, -0.159400, 0.040900, 0.497970, 0.179750, 0.245780, -0.168850, 
0.251380, 0.441560, 0.097470, 0.017350, 0.051800, 0.367830, 0.576600, 0.503250, 0.623560, -0.421990, 
0.339550, 0.350060, 0.116210, -0.153820, 0.046240, 0.027670, -0.017620, 
0.013030, 0.225530, 0.130480, 0.077210, 0.101940, 0.332600, 0.095560, -0.009180, 0.288660, -0.047100, 
-0.105230, -0.203610, -0.050640, 0.101470, -0.069240, 0.107040, 0.013570, -0.028960, 0.058450, -0.096260, 
0.007640, 0.204000, -0.156530, -0.031660, -0.105980, 0.420720, 0.179860, 0.175550, -0.284810, 0.033050, 
0.229840, 0.191480, -0.148430, 0.258460, -0.095010, 0.326010, 0.078180, -0.000420, -0.095840, -0.267390, 
0.262070, 0.014940, 0.022750, -0.076190, -0.153130, 0.093630, 0.069380, -0.160780, 0.264070, 0.088370, 
-0.095660, -0.070830, -0.159640, -0.194200, -0.052630, 0.154380, -0.028080, -0.054960, -0.203000, -0.051440, 
-0.256520, -0.080540, 0.019510, 0.090770, 0.198720, -0.204430, -0.021930, 0.212880, -0.082490, 0.158670, 
-0.069090, -0.061420, 0.282520, 0.118260, 0.165300, -0.049070, 0.257020, -0.144310, -0.094080, 0.059530, 
0.279790, 0.288280, 0.304360, 0.039230, 0.217380, -0.155050, -0.039070, 0.275930, 0.148990, -0.039510, 
0.098050, 0.095110, -0.113050, 0.060820, 0.013050, 0.079890, 0.173360, 0.086590, 0.605940, 0.422430, 
0.150550, 0.360890, -0.049910, -0.108470, 0.031310, -0.287620, 0.098280, 0.091670, 0.220580, -0.004250, 
0.256130, 0.291720, -0.232190, 0.204660, 0.060430, 0.192940, 0.248200, -0.023390, 0.035950, 0.251550, 
-0.000790, -0.101020, 0.327690, -0.180370, -0.313360, 0.044250, -0.055180, 0.120100, -0.009860, 0.228530, 
-0.247760, -0.068470, 0.061490, 0.706840, 0.423880, 0.219600, 0.142570, 0.103500, 0.096660, 0.342720, 
0.017380, 0.194370, 0.130550, 0.106640, 0.294780, -0.034880, 0.058720, -0.022800, 0.513090, 0.141950, 
0.030550, 0.336400, 0.179940, 0.023570, 0.054200, 0.131790, 0.035530, 0.296420, 0.485880, 0.136430, 
0.461860, 0.093270, -0.209320, 0.236970, 0.511630, 0.342080, 0.163510, 0.054770, 0.044860, 0.192130, 
-0.143380, 0.056450, 0.263590, -0.047800, -0.217460, 0.039390, -0.175880, -0.182780, 0.180740, 0.162470, 
0.132290, -0.084930, 0.587880, 0.002060, 0.073880, -0.050550, 0.052780, 0.107530, -0.004060, -0.212340, 
0.132560, 0.185120, 0.264860, 0.060960, 0.148080, -0.180040, 0.442690, 0.506090, -0.107200, -0.160380, 
0.176520, 0.185920, -0.035950, 0.494340, 0.116020, -0.016350, 0.012200, -0.088220, -0.127410, 0.020850, 
0.171350, -0.015410, -0.218770, -0.157530, 0.226770, -0.225630, -0.138070, 0.507190, -0.096700, 0.387730, 
-0.036010, -0.044340, 0.079870, 0.141980, 0.130130, 0.182610, 0.251150, 0.633400, 0.304480, 0.400860, 
0.023360, 0.138840, 0.094330, -0.200330, 0.133550, 0.115160, -0.032320, 0.023720, -0.173980, 0.204210, 
-0.010560, -0.137800, -0.007920, 0.082710, 0.104790, 0.103890, 0.243750, 0.238480, -0.010740, 0.299700, 
0.067740, 0.031300, 0.066400, 0.251340, -0.063810, 0.045320, -0.290470, 0.518220, 0.478730, -0.259150, 
0.396060, 0.017140, 0.043200, 0.122520, 0.194570, 0.215710, -0.060810, 0.408290, 0.253750, 0.005530, 
0.344540, 0.112400, 0.023150, 0.248120, 0.283550, -0.040050, -0.267480, 0.155570, -0.322150, -0.248050, 
-0.202820, -0.072660, 0.365090, 0.181280, -0.054080, -0.127250, -0.425910, -0.109130, 0.116720, -0.028230, 
-0.133410, -0.260490, 0.252260, 0.010880, -0.092720, -0.093050, 0.346700, 0.178580, 0.331970, -0.168500, 
0.075850, 0.203190, 0.049200, -0.236830, -0.234960, -0.066930, -0.131260, 0.048930, 0.253970, 0.196900, 
0.121930, 0.292480, 0.026590, -0.207110, 0.005400, -0.081150, -0.000610, -0.071260, 0.304550, 0.050560, 
-0.010780, 0.009570, -0.144250, 0.011790, 0.000440, 0.041110, -0.041120, 0.092340, -0.495150, 0.095220, 
0.064990, 0.202290, -0.126240, -0.226260, 0.047500, 0.003650, 0.028270, 0.039680, -0.019810, 0.495060, 
0.064670, 0.259920, 0.220160, -0.004540, 0.118700, -0.274190, -0.231920, 0.035950, -0.224240, 0.175680, 
0.131880, 0.112230, 0.142100, 0.000200, 0.329770, -0.058760, 0.008960, 
0.271870, -0.199690, -0.452420, 0.534140, -0.105680, 0.227410, 0.581780, 0.061220, 0.002200, 0.013180, 
0.194740, 0.208490, 0.034940, 0.320830, -0.364560, 0.071300, -0.054070, 0.345710, 0.148860, 0.316840, 
-0.003390, 0.203560, 0.020560, 0.392070, -0.121160, 0.046390, 0.163960, 0.590810, -0.109440, -0.110570, 
0.091270, 0.454020, 0.245680, -0.011290, 0.171990, 0.227020, 0.035490, 0.495260, 0.260440, -0.039190, 
0.325110, 0.033980, 0.056810, 0.188100, 0.071630, -0.465710, -0.090350, -0.054880, -0.331070, 0.151420, 
-0.075770, 0.324890, 0.421940, -0.340470, 0.684380, 0.026530, 0.057050, 0.382040, 0.261310, -0.293320, 
-0.334930, -0.004900, 0.038440, -0.196380, -0.011440, -0.329800, -0.282110, 0.178910, 0.297070, 0.317420, 
0.209040, -0.197340, 0.065060, 0.283760, 0.088980, 0.583640, -0.071640, -0.041400, 0.027760, -0.146880, 
-0.120170, -0.207270, 0.010940, 0.036260, -0.127040, 0.720350, 0.302790, 0.228560, -0.402580, 0.607980, 
0.447890, -0.077930, -0.087700, 0.189660, -0.236370, 0.297120, 0.392900, -0.253790, 0.569460, -0.021770, 
-0.056820, 0.370860, -0.032290, 0.028920, -0.005890, -0.081760, 0.211090, 0.308730, -0.163300, -0.360990, 
-0.109340, -0.329050, 0.476510, 0.146970, -0.220380, 0.226380, -0.289180, -0.121380, 0.309010, -0.113240, 
-0.155920, 0.115800, 0.101150, 0.039080, -0.188190, 0.032070, -0.094470, 0.394750, 0.702300, 0.136680, 
0.077880, 0.354020, 0.023120, 0.249110, 0.406450, -0.220870, 0.354820, 0.502810, 0.122210, 0.336690, 
0.698110, 0.347520, 0.336820, -0.181020, 0.588430, -0.305760, 0.060260, -0.303400, 0.194790, 0.885740, 
0.296820, 0.203830, 0.624520, -0.305750, 1.190500, -0.186070, 0.137980, -0.039090, 0.386190, 0.096450, 
-0.066560, 0.204290, 0.355350, 0.111670, 0.401860, -0.422530, -0.020970, 0.069530, 0.119220, -0.468240, 
-0.511310, -0.694490, 0.420860, -0.328340, -0.584700, -0.239150, -0.357910, 0.331560, 0.497710, -0.539580, 
0.376850, 0.347230, -0.745630, -0.434220, -0.002250, -0.024490, -0.111760, 0.254780, -0.003760, 0.024940, 
0.563260, 0.449900, 0.863590, 0.317420, 0.185080, -0.371490, 0.037940, 0.213740, -0.432390, -0.313210, 
0.061320, -0.274140, 0.006110, 0.747110, 0.780760, 0.709980, 0.588180, 0.123010, -0.338530, 0.084960, 
-0.453170, -0.730170, -0.157250, -0.390140, 0.199370, 0.219770, -0.045070, 0.103700, 0.126390, -0.350050, 
0.479300, -0.236820, -0.114330, 0.085300, 0.138610, 0.214710, -0.062880, 0.452340, -0.240340, -0.560860, 
0.086300, -0.144020, 0.452670, 0.520400, -0.350850, -0.269190, -0.134190, 0.011630, 0.595800, 0.089770, 
-0.406740, -0.198370, 0.371390, -0.202260, 0.271110, -0.070670, 0.347430, 0.379790, -0.230390, 0.539810, 
-0.106350, 0.031310, -0.035180, 0.180510, -0.441860, 0.365020, 0.241410, 0.498060, 0.803250, 0.135170, 
0.065270, -0.462450, -0.427630, 0.212340, -0.204940, -0.114040, -0.487510, -0.255210, -0.165170, 0.143610, 
-0.037060, -0.384460, 0.075860, -0.167890, 0.218480, -0.045400, -0.217020, 0.709610, -0.043350, -0.191650, 
-0.314990, -0.286570, 0.726800, 0.297390, -0.281960, 0.082110, 0.269930, 0.458600, -0.203780, 0.296120, 
-0.118020, -0.096170, 0.546030, 0.062130, -0.321680, -0.254140, -0.174810, -0.105340, 0.554460, -0.109010, 
-0.030530, -0.146240, -0.347000, -0.059870, 0.238790, -0.086790, 0.206870, 0.598790, -0.766460, -0.191430, 
0.088990, 0.291360, -0.048140, -0.267620, 0.024830, -0.276130, 0.264400, 0.264990, 0.669300, 0.366570, 
0.550850, 0.331350, -0.506140, -0.013380, 0.530960, 0.000830, 0.080680, 0.351560, -0.059120, -0.444040, 
0.368070, 0.378910, -0.015270, 0.244800, 0.488330, 0.050040, 0.470010, 0.039910, -0.112120, -0.172370, 
-0.206860, -0.197650, -0.271040, -0.236960, 0.237230, 0.127980, -0.001530, 0.107120, -0.343450, 0.094860, 
0.293850, -0.110690, -0.125340, -0.134110, -0.298880, 0.416250, 0.048570, 
-0.177430, -0.044550, 0.083170, -0.167400, 0.233520, 0.268660, -0.039240, -0.249770, 0.204610, 0.134860, 
0.225790, -0.067840, 0.195930, 0.101890, 0.268670, -0.287910, 0.055990, 0.407550, 0.192680, 0.365870, 
0.036520, 0.027730, 0.117910, 0.042830, -0.359010, 0.372450, -0.246950, -0.371830, 0.220270, 0.102750, 
0.289000, -0.206960, 0.111360, -0.379180, -0.100240, 0.315590, -0.062070, 0.178120, -0.225720, -0.018480, 
0.328360, 0.061810, 0.027680, -0.038880, 0.012170, -0.353160, 0.378140, -0.141990, -0.236770, 0.194750, 
0.175940, 0.224220, -0.041730, -0.139900, 0.264040, 0.039720, 0.139820, -0.259960, 0.039840, 0.395600, 
0.176520, 0.171270, 0.066320, 0.246800, -0.075230, 0.163830, -0.047020, 0.501580, 0.080500, -0.086400, 
0.165410, 0.076340, 0.027490, 0.546960, -0.081930, 0.460790, -0.008990, 0.271070, -0.321920, -0.104490, 
-0.010530, -0.139420, 0.223300, 0.080120, 0.398210, -0.160810, -0.153050, -0.035070, 0.341960, -0.054690, 
0.228250, 0.207860, 0.368150, 0.062730, 0.136230, 0.112400, -0.135450, 0.144230, 0.035610, 0.002450, 
0.203570, 0.090320, -0.182980, 0.088870, 0.076020, 0.101580, 0.013150, 0.307720, 0.176830, 0.456610, 
0.018680, 0.066750, 0.002820, 0.334370, 0.072250, 0.176500, 0.081610, -0.079280, 0.273290, 0.200780, 
-0.123080, -0.213800, 0.101290, 0.285770, -0.228300, 0.066740, -0.225050, 0.084440, 0.497680, 0.156460, 
0.308400, -0.235690, -0.022270, 0.404910, 0.168370, -0.054030, -0.035570, 0.005180, -0.214430, -0.099710, 
0.506410, 0.259280, -0.041460, -0.166570, 0.094340, 0.032230, 0.027960, -0.317470, -0.223110, 0.320100, 
0.430490, 0.587710, -0.287270, -0.187590, 0.588900, -0.046840, -0.010220, 0.026600, -0.270180, -0.028050, 
-0.174310, 0.378840, 0.232730, -0.074440, -0.276390, -0.333810, -0.165410, 0.030300, -0.373290, -0.062410, 
0.387320, 0.184610, 0.582000, -0.103440, -0.275880, 0.844700, -0.151190, -0.277010, -0.004300, -0.314340, 
-0.195910, -0.035580, 0.468010, 0.397580, 0.340170, -0.341330, -0.325550, -0.369580, 0.000370, -0.291000, 
0.091000, 0.324150, -0.113570, 0.609620, -0.128680, -0.423610, 0.601930, 0.213500, -0.065220, 0.017750, 
-0.375460, -0.105670, -0.005400, 0.774620, 0.021070, -0.021770, 0.141590, -0.016540, -0.164300, 0.039420, 
-0.170420, 0.129370, -0.050060, 0.152020, 0.390100, -0.156110, -0.078110, 0.082210, -0.137740, 0.301380, 
0.267210, 0.333850, -0.134730, -0.009320, 0.744490, 0.043290, 0.295850, -0.087640, -0.292330, 0.263540, 
0.067480, 0.001290, 0.127460, 0.243340, 0.101300, 0.087740, -0.003690, -0.103260, -0.081670, 0.173610, 
0.070510, 0.060260, 0.049170, -0.421690, 0.210250, 0.750530, 0.032780, 0.294070, 0.205510, 0.361050, 
0.042530, 0.064750, -0.089900, 0.060600, -0.041300, -0.112610, -0.071360, -0.030530, -0.122150, 0.297640, 
0.122360, -0.038580, 0.013000, 0.181550, -0.305220, -0.044490, 0.066580, 0.013110, -0.030300, -0.031590, 
0.193560, 0.318520, 0.048060, 0.171890, -0.273420, -0.067040, 0.075670, 0.099480, 0.060780, 0.133020, 
0.122060, -0.128340, 0.191830, -0.177190, -0.034630, -0.147670, 0.308180, 0.228790, 0.210720, 0.230480, 
-0.062350, -0.191700, 0.417630, 0.048720, 0.212770, -0.173110, 0.089890, 0.109830, 0.445270, 0.334110, 
0.111060, 0.070100, 0.000060, -0.039220, 0.184450, 0.038820, -0.054220, 0.269450, 0.250750, 0.076650, 
0.227890, 0.102430, 0.251390, 0.016710, 0.052870, -0.104220, 0.242740, -0.019020, 0.177820, 0.043850, 
0.038780, -0.011600, 0.013150, 0.410060, -0.043710, 0.177510, 0.505410, 0.073590, 0.341310, -0.026970, 
0.077770, 0.290250, 0.159450, 0.201530, 0.040270, 0.063160, 0.111790, -0.271030, 0.296800, 0.134160, 
0.134500, -0.011550, -0.099790, 0.142610, 0.114480, 0.305980, 0.033770, -0.028010, -0.121070, 0.207120, 
0.245080, 0.228870, 0.219590, 0.015970, 0.051280, 0.100730, 0.080920, 
-0.577270, 0.426130, -0.252770, -0.005900, -0.057980, -0.282820, -0.140100, -0.137070, 0.439260, -0.180770, 
-0.056740, 0.310650, 0.601080, -0.121960, 0.041480, 0.139190, -0.043300, 0.260820, -0.203400, 0.042830, 
0.088680, -0.392680, 0.155670, 0.318960, 0.118700, -0.164130, 0.021120, 0.099310, 0.047550, 0.449910, 
0.544190, 0.009760, 0.338350, 0.355490, 0.457960, 0.312520, -0.151190, 0.141400, 0.582090, 0.626030, 
0.272230, 0.086940, 0.009390, 0.010830, -0.069360, -0.360230, -0.185420, -0.096990, -0.619580, 0.006620, 
0.190550, -0.035970, -0.374370, 0.220160, -0.463290, -0.089290, 0.311600, 0.090190, -0.051520, 0.503340, 
0.009820, 0.114160, 0.052540, -0.163770, -0.415300, 0.185950, 0.169460, -0.028530, -0.394350, -0.537100, 
-0.049190, -0.249630, -0.246920, 0.104930, -0.071480, 0.163100, -0.049040, 0.393100, 0.359590, 0.432070, 
-0.052920, -0.075210, -0.203410, 0.039120, 0.411670, -0.246450, -0.059880, 0.355830, 0.040970, 0.552770, 
0.295850, 0.206580, -0.141010, -0.196140, -0.323230, 0.201060, 0.436120, -0.189710, -0.091670, 0.532150, 
0.268090, -0.579450, 0.381160, -0.040910, 0.032270, 0.316320, -0.364230, -0.111930, -0.072390, -0.123740, 
-0.118220, 0.455440, 0.302770, -0.066470, 0.019740, 0.285760, 0.204910, 0.516390, -0.162200, 0.000300, 
0.058620, -0.208730, -0.218390, -0.363790, -0.243760, 0.023130, 0.004100, -0.232420, -0.036780, 0.479430, 
0.168710, -0.183910, 0.359430, 0.519870, 0.079320, -0.194580, -0.017060, 0.134670, -0.684450, 0.218210, 
0.203760, -0.109820, -0.214870, -0.447880, 0.635290, 0.114700, 0.016280, -0.413110, -0.161820, 0.378720, 
-0.440230, 0.810100, -0.115610, 0.121810, 0.434370, -0.081980, -0.798550, -0.399840, -0.067750, -0.090700, 
0.373280, 0.070270, 0.198460, -0.056990, 0.212880, 0.758420, -0.528800, 0.028110, -0.022410, -0.334190, 
0.156300, -0.305910, -0.449150, -0.195720, -0.033280, 0.578940, -0.180090, 0.145320, -0.003740, -0.508220, 
0.378220, -0.085910, 1.463030, -0.145650, -0.052610, 0.368700, 0.174320, -0.017850, -0.000480, -0.127820, 
-0.207270, 0.095910, -0.031970, 0.901170, -0.111770, 0.037330, -0.472840, -0.253500, 0.145190, -0.025920, 
0.045290, 0.308420, 0.834680, -0.995810, -0.113200, -0.194780, -0.240120, 0.076390, 0.035720, 0.087560, 
0.025460, -0.028370, 0.372810, 0.423670, 0.036770, 0.172190, 0.182880, 0.426250, -0.132500, 0.076190, 
-0.184240, 0.127340, 0.123550, 0.158140, 0.566970, 0.257330, 0.224470, -0.141410, 0.532520, -0.049970, 
0.072130, -0.187240, -0.094230, 0.438230, 0.232380, 0.232020, -0.134100, 0.165100, -0.055500, 0.889240, 
-0.068840, 0.188930, 0.134040, -0.217050, 0.101970, 0.192430, 0.079730, 0.168280, -0.106040, 0.074100, 
-0.379050, 0.086580, 0.089700, -0.213590, 0.042930, 0.271160, 0.322420, -0.582030, 0.335920, 0.485010, 
-0.169440, -0.015550, 0.196060, 0.122280, 0.362120, 0.036080, 1.025870, 0.323740, 0.250420, -0.095100, 
0.020250, -0.029350, 0.083450, 0.173690, 0.081700, 0.406530, 0.132660, -0.358410, -0.241920, -0.196950, 
0.514090, 0.278550, 0.400960, 0.108340, -0.166200, -0.100760, 0.075770, 0.572080, 0.220290, 0.443590, 
0.340220, 0.114210, 0.269910, 0.082690, 0.054550, 0.289670, 0.462370, 0.042020, 0.046550, 0.154180, 
-0.228830, 0.204090, 0.633690, 0.825910, 0.681080, -0.012150, 0.099190, 0.175580, -0.633120, 0.247700, 
-0.113560, 0.350800, 0.129290, 0.216450, 0.123230, 0.044520, 0.194570, -0.179660, 0.169590, 0.674020, 
-0.059030, -0.308280, 0.102660, 0.451020, -0.097720, 0.194310, 0.145060, 0.231220, 0.475570, 0.081400, 
0.083930, 0.152420, 0.023900, 0.067810, -0.187160, 0.076510, -0.014760, -0.489840, 0.044610, 0.406320, 
-0.324650, -0.297150, -0.127360, -0.290300, 0.173670, 0.016130, -0.135080, 0.238190, -0.206560, -0.064960, 
0.287880, -0.298870, 0.074550, 0.480980, 0.115980, 0.156720, 0.060740, 
0.093560, 0.194870, 0.241430, 0.078560, 0.310300, 0.145980, 0.475090, 0.751240, 0.065710, 0.507410, 
0.395870, 0.326560, 0.160370, 0.061020, 0.607460, 0.265510, -0.036200, 0.031810, 0.267960, 0.307490, 
0.202870, 0.182740, 0.427580, -0.034440, 0.269170, -0.153520, 0.574320, 0.452420, 0.115180, 0.120900, 
-0.130390, 0.446130, 0.788570, 0.297590, 0.595310, 0.197450, -0.228910, 0.131270, 0.445320, 0.157690, 
0.019550, 0.156540, 0.098870, 0.146890, 0.017180, -0.299460, -0.076300, 0.812000, 0.095200, 0.084530, 
0.283230, 0.330700, 0.463940, 0.164460, 0.039170, 0.405820, 0.396270, -0.100810, -0.068140, 0.515320, 
-0.032800, 0.169130, 0.220220, 0.506260, 0.194940, -0.253180, -0.533810, 0.722730, -0.109150, -0.126430, 
0.504920, 0.443280, 0.007490, 0.589800, -0.324170, 0.013250, 0.516320, 0.033980, -0.439330, -0.458170, 
-0.011970, 0.310150, -0.284230, 0.269660, 0.731450, 0.810230, 0.376160, -0.169260, 0.343080, 0.722110, 
-0.004130, 0.154230, 0.529430, 0.436140, 0.321930, 1.179260, 0.456110, 0.291360, 0.041250, 0.141400, 
0.025610, 0.306610, 0.068860, 0.464830, 0.222490, 0.426850, 0.609170, 0.560140, 0.665810, 0.452880, 
0.268890, 0.441530, -0.128600, 0.528650, 0.205300, 0.356660, 0.776830, -0.048080, 0.413480, 0.060370, 
0.266790, 0.543010, 0.355930, 0.297180, 0.113300, 0.277510, -0.035750, 0.104290, 0.625860, 0.129010, 
-0.135570, 0.193620, -0.026130, 0.008150, 1.315920, 0.278220, 1.284110, 0.448380, -0.085160, 0.308110, 
0.360890, 0.023310, -0.251490, 0.490120, 0.386720, -0.096310, 0.177780, -0.231960, 0.085240, 0.745020, 
0.491380, 0.132460, 0.388720, -0.111470, 2.134300, -0.006120, 0.081150, -0.096080, 0.779100, -0.121140, 
-0.090790, 0.445200, -0.168300, -0.816920, 0.398200, -0.133670, 0.412210, 0.268950, -0.028890, -0.718630, 
-0.025350, -0.317120, 0.230620, -0.587840, -0.913230, -0.069110, 0.363860, 0.445290, 0.985510, -0.151800, 
0.512680, 0.551470, -0.446050, 0.231440, 0.015440, -0.078660, -0.195830, -0.048020, -0.002400, -0.187120, 
-0.072510, 0.110160, 0.557200, -0.141020, 0.242540, -0.158930, -0.330040, 0.502140, 0.045150, -0.206560, 
0.226900, -0.039040, 0.060770, 1.405770, 0.413590, 0.017420, -0.473040, 0.009850, 0.634240, 0.010230, 
-0.383930, -0.603880, 0.643960, 0.222100, -0.412090, -0.184190, 0.082960, 0.062780, 0.465490, 0.314250, 
0.307190, -0.220430, -0.317750, 0.381700, 0.505380, 0.051840, -0.047300, -0.105170, 0.145610, 0.427330, 
0.010340, -0.391820, 0.172820, 0.585550, -0.311910, 0.253980, 0.201770, 0.459200, -0.093120, 0.153870, 
-0.041990, 0.449320, 0.180420, -0.243070, 0.057070, 0.425630, 0.231720, 0.327280, -0.457410, 0.125800, 
0.477060, 0.010040, -0.516790, -0.167020, 0.045040, 0.390010, -0.089550, 0.275360, -0.127710, -0.385350, 
0.433000, 0.430170, -0.194920, 0.331040, 0.076900, 0.106340, -0.094660, -0.388790, 0.065010, 0.414720, 
0.560160, 0.225690, 0.014500, -0.399040, 0.038160, -0.367720, 0.040250, -0.737520, -0.041560, 0.194280, 
-0.412000, -0.122650, 0.143070, 0.527640, -0.268680, -0.037450, 0.452900, -0.385370, 0.045250, -0.116320, 
-0.324760, -0.036400, 0.017380, 0.017590, -0.186280, 0.120930, -0.477630, 0.078830, 0.306240, -0.269430, 
-0.268140, -0.462260, 0.059350, -0.124340, -0.392020, -0.178940, -0.195580, 0.015650, 0.458650, 0.404540, 
0.452680, 0.204170, -0.326180, -0.209960, 0.026920, -0.225930, 0.146590, -0.000310, 0.039660, 0.068210, 
0.123140, -0.094360, 0.016140, -0.200390, 0.122410, -0.103910, -0.298620, 0.435980, -0.444700, 0.041400, 
-0.101780, -0.126680, -0.604820, -0.050340, -0.128440, 0.019050, -0.176170, -0.403410, 0.050890, -0.030980, 
0.338580, -0.392850, -0.645110, 0.121900, -0.144360, 0.175220, 0.053110, 0.124530, -0.314230, -0.337450, 
0.551910, 0.069270, 0.197810, -0.449850, -0.519270, 0.472740, 0.032620, 
0.471290, 0.400660, 0.205680, 0.151900, 0.781710, -0.778020, -0.652880, 0.276740, 0.496620, -0.444770, 
-0.453450, 0.390950, -0.233430, -0.249180, -0.205360, -0.142940, 0.124920, 0.013920, 0.261790, -0.382500, 
-0.193710, 0.399330, 0.394080, -0.335890, 0.183890, 0.445280, 0.409510, 0.679390, -0.147190, 0.495450, 
0.399220, 0.684250, -0.045710, 0.254710, 0.172800, -0.438520, -0.376920, -0.179690, -0.139560, 0.302850, 
0.212050, -0.177310, 0.431120, 0.017410, 0.348700, 0.232340, 0.043470, -0.068450, -0.016520, -0.168700, 
0.041150, -0.151950, 0.109300, 0.314180, -0.142830, 0.517370, 0.190050, 0.631080, 0.236160, -0.164180, 
0.124250, -0.200300, -0.186440, 0.829670, 0.645840, -0.018790, -0.703070, 0.202070, -0.762620, -0.966570, 
-0.531730, 0.417370, -0.427460, 0.421890, -0.712890, -0.098090, 0.150020, -0.234020, 0.062630, -0.100020, 
-0.844450, -0.317890, -0.165180, -0.158250, 0.003730, 0.892920, 0.479780, 0.337480, 0.245960, 0.662040, 
0.063190, -0.438650, 0.247370, -0.081580, -0.519360, 0.212720, 0.165720, 0.282390, -0.142520, -0.742400, 
-0.437950, 0.049440, 0.091630, -0.072500, -0.179220, 0.668440, 0.609280, 0.826410, 0.935950, -0.097120, 
0.133180, 0.496050, -0.064770, -0.146580, -0.010700, -0.011740, 0.170100, -0.639820, 0.314670, 0.426640, 
-0.260300, 0.110190, 0.315070, -0.284650, -0.107430, -0.197700, 0.296270, -0.251330, 0.096780, 0.345010, 
-0.312590, -0.221650, -0.671980, -0.715550, 0.209630, 0.071660, 0.576550, -0.680980, -0.427310, 0.107810, 
-0.356450, -0.050870, -0.078140, -0.322230, -0.136420, -0.190940, -0.110370, 0.471420, 0.429100, -0.410620, 
-0.575890, 0.485790, -0.000380, 0.066110, -0.478360, 0.061800, 0.604000, 0.609090, -0.167700, 0.634640, 
-0.138090, 1.121000, -0.443840, -0.314450, 0.947210, 0.508510, 0.367920, -0.064400, 1.230740, 0.899290, 
0.791830, 1.869430, 0.463800, 1.152410, 2.538250, 0.014990, -0.060630, 0.137810, 0.591960, 1.428610, 
-0.224380, -0.094480, 0.314290, 0.061940, -0.619720, 0.184140, -0.216000, 0.108560, -0.006420, 1.815800, 
0.211670, 0.668940, 1.110800, -0.182350, 1.513530, 1.203140, -0.991150, 0.475880, -0.234830, 0.746970, 
0.931490, 0.696890, -0.136040, -0.971660, 0.171280, -0.064090, 0.080820, 0.246600, -0.009030, -0.060710, 
0.269720, -0.345100, -0.279880, -1.080380, 0.478760, -0.622490, -0.770040, -0.804760, 0.715800, 0.130370, 
0.763280, -1.082730, -0.048030, -0.197810, -0.833090, -0.752010, -0.778770, 0.060800, -0.046960, -0.182500, 
-0.061020, 0.161250, 0.351830, 0.272810, -0.687640, 0.368080, 1.431490, -0.298360, 0.239110, 0.097650, 
-0.120210, 0.755760, 1.239760, 0.935130, -0.271390, -0.405530, -0.475130, -0.732850, -0.191820, -0.495200, 
-0.393940, -0.154670, 0.988260, 1.390410, 0.818170, 0.241090, 0.234620, 0.554650, 0.586380, 0.320170, 
-0.169600, 0.739540, 0.448640, 1.020620, 0.307970, -0.833840, 0.098270, -0.279500, 0.378730, -0.341570, 
-0.426300, 0.073860, -0.219610, 0.801470, 0.264460, 0.241550, 0.023050, 0.017110, -0.392890, -0.024980, 
-0.180170, -0.200460, 0.430980, 0.399000, 0.097140, 0.745800, 0.145210, -0.218280, -0.320080, -0.356810, 
0.217610, 0.235110, -0.147270, -0.164530, 0.243810, -0.189160, -0.031800, -0.517760, -0.044550, -0.110180, 
-0.680360, -0.002910, -0.012320, 0.350650, 0.176460, 0.097380, 0.202670, -0.276680, -0.208450, -0.730190, 
-0.384310, 0.228880, 0.316180, -0.030050, -0.139130, 0.345980, 0.095160, 0.380820, 0.040570, 0.324870, 
0.756580, 0.097490, 0.455860, -0.120230, -0.027320, -0.104810, 0.115690, -0.025570, -0.239430, 0.510300, 
0.106810, -0.064410, 0.505010, 0.259060, -0.356980, -0.125080, 0.233760, 0.893330, 0.071360, 0.428220, 
0.048810, 0.323340, 0.088670, -0.135860, 0.296660, 0.404160, 0.347610, 0.061800, 0.532400, 0.178460, 
0.141350, 0.023600, -0.272930, 0.662920, 0.213730, 0.074610, -0.068530, 
-0.217940, 0.191250, 0.093030, 0.269260, 0.525670, -0.195720, 0.311580, 0.188600, 0.045520, -0.112870, 
-0.174730, 0.231520, 0.357190, 0.032010, 0.353300, -0.166070, -0.507190, 0.606280, 0.133650, 0.074800, 
0.127600, -0.356370, -0.097380, 0.207480, 0.401130, -0.096020, 0.036100, 0.083350, -0.157410, -0.360320, 
-0.201840, 0.041540, 0.322080, 0.131500, -0.254230, 0.325650, -0.033980, -0.266400, -0.004860, -0.012110, 
0.278980, 0.130420, -0.065770, 0.079760, 0.536610, -0.240750, 0.247770, 0.403430, 0.126700, 0.180860, 
-0.171070, -0.616020, -0.116990, -0.146050, 0.062500, -0.027750, 0.322810, 0.154820, 0.007260, -0.229660, 
0.108940, 0.003370, 0.145140, -0.067270, -0.056140, -0.001780, 0.096420, -0.342480, 0.231400, 0.149460, 
0.141090, -0.123480, -0.250260, -0.198780, 0.275810, 0.360530, 0.315270, 0.711000, 0.146090, 0.130980, 
-0.090160, 0.017950, -0.225120, 0.115220, -0.154600, 0.236270, 0.408910, -0.029310, -0.397680, 0.018340, 
0.190640, 0.363030, -0.048630, -0.140310, -0.353460, 0.125870, 0.317060, 0.360670, 0.851430, -0.428240, 
-0.167470, 0.019910, 0.113980, -0.055460, 0.117090, -0.591520, 0.216400, 0.294030, 0.044950, 0.329950, 
-0.260800, -0.026660, 0.763430, 0.157120, -0.459720, -0.475200, -0.222740, -0.473830, 0.088690, 0.152210, 
-0.236560, -0.523000, 0.452970, 0.153470, -0.504670, 0.093980, -0.785450, -0.704130, -0.417670, 0.093630, 
0.477780, -0.163130, -0.288510, -0.745820, -0.183920, -0.144700, -0.156110, -0.815530, 0.008500, -0.187200, 
0.905430, 0.188180, 0.095280, 0.217110, -0.180910, -0.504660, 0.037400, -0.442340, -0.359100, -0.455260, 
-0.209450, -0.077870, -0.337800, -0.577170, -0.406240, 0.482240, 0.258670, -0.217140, -0.145230, 0.099830, 
0.000390, 1.736350, -0.413410, -0.700570, -0.639750, 0.010920, -0.218380, 0.032670, 0.003130, -0.149570, 
0.262930, 0.169950, 0.572660, -0.077600, -0.334240, -0.272780, -0.052030, 0.448930, -0.140340, 0.230330, 
-0.102880, 0.235600, -0.002910, 0.173990, -0.030260, 0.221340, 0.389490, -0.108630, 0.009470, 0.308930, 
0.315930, -0.334350, -0.005180, 0.572830, -0.161990, 0.005190, -0.122730, 0.266620, -0.484960, -0.068120, 
0.242680, 0.261890, 0.245210, 1.931080, 0.269170, -0.094870, 0.248020, 0.306570, -0.297420, 0.097350, 
-0.152510, -0.069430, 0.127620, 0.011740, 0.033590, -0.371230, -0.005370, 0.204640, 0.418290, -0.141380, 
0.087370, 0.207120, 0.366670, 0.109350, 1.187080, -0.032710, 0.307780, -0.061410, -0.016060, -0.180650, 
0.138230, -0.153590, -0.177790, -0.122140, -0.366720, 0.447450, -0.043160, 0.054840, 0.282150, 0.094630, 
-0.488760, -0.025650, -0.210960, -0.213940, -0.360140, 0.416670, -0.076490, -0.195290, 0.362360, -0.052990, 
-0.281830, 0.117080, 0.149130, 0.005860, 0.459830, 0.056500, 0.242920, -0.399700, -0.411140, -0.106420, 
0.060010, -0.142810, -0.656320, -0.339900, -0.730010, 0.033330, 0.000080, -0.207450, 0.310760, -0.009570, 
-0.297410, 0.084660, 0.108000, 0.557600, -0.007140, 0.586650, 0.035140, 0.373480, 0.157210, 0.433620, 
-0.096370, 0.053230, -0.016640, -0.187420, -0.298690, -0.045820, 0.203950, -0.269870, 0.110060, -0.211090, 
0.308790, 0.300140, -0.231730, 0.146490, 0.398440, 0.216450, 0.311130, 0.084800, 0.057470, 0.647240, 
-0.005330, 0.321600, 0.021160, 0.382370, -0.260200, 0.119470, -0.054740, -0.101870, -0.272970, -0.138950, 
-0.331190, 0.120740, 0.294220, -0.153260, 0.141390, 0.610920, 0.460340, 0.465820, -0.054480, -0.235060, 
0.053040, 0.268780, 0.538770, -0.096600, -0.203580, 0.049340, 0.240640, -0.324520, -0.442450, -0.239810, 
0.003940, -0.050510, -0.053740, -0.225300, -0.055990, 0.154970, 0.285990, -0.086400, 0.286900, 0.065760, 
0.027790, -0.032440, -0.130470, -0.139940, 0.153770, -0.087680, 0.136340, 0.393310, -0.060590, 0.283940, 
0.058750, -0.095570, 0.033700, -0.077970, 0.173440, 0.076180, 0.191440, 
0.224990, -0.093430, -0.358690, -0.205260, 0.334110, -0.108050, 0.061760, 0.303300, -0.902020, -0.153810, 
-0.015350, -0.105240, 0.024430, -0.229310, 0.201320, -0.097730, -0.078910, 0.053940, -0.408260, 0.047340, 
-0.003230, 0.159190, -0.082350, 0.278300, 0.019800, -0.386930, 0.079030, 0.093400, -0.474500, -0.294320, 
0.576120, 0.131930, -0.092870, 0.294860, 0.261790, 0.144870, -0.106390, -0.215140, 0.318200, 0.155450, 
0.256490, -0.019000, 0.063550, 0.405690, -0.230160, -0.206490, -0.563500, 0.086950, 0.374180, -0.234990, 
0.023720, 0.008770, -0.005490, 0.467990, -0.069010, 0.550430, 0.114570, -0.184810, 0.004740, -0.314980, 
0.350320, 0.107120, 0.008100, -0.072480, 0.241780, -0.411250, -0.066070, -0.189710, -0.510640, -0.158500, 
0.532780, 0.271440, -0.170310, 0.000660, 0.409610, -0.306610, 0.333050, 0.091630, -0.315830, -0.271080, 
0.346420, 0.185650, -0.056100, -0.001790, -0.287610, 0.188110, -0.162750, 0.192770, -0.021130, -0.293280, 
-0.384860, 0.276600, -0.139020, 0.103470, -0.177950, 0.032710, 0.206690, 0.037230, 0.352240, 0.058520, 
-0.120880, -0.327900, -0.018820, -0.257640, 0.031830, 0.361660, 0.209650, 0.057320, 0.137540, 0.210980, 
-0.068060, 0.459250, -0.131580, 0.009450, 0.361710, 0.553170, 0.138270, 0.334860, 0.126060, 0.505540, 
0.137080, 0.280650, -0.183190, 0.109090, 0.108250, 0.038210, 0.267230, 0.276680, 0.125640, 0.224800, 
0.102890, 0.504330, 0.606040, 0.335990, 0.011620, -0.213260, 0.031340, 0.406830, -0.463600, -0.101040, 
1.096630, 0.266170, 0.109090, -0.466140, 0.151390, 0.162400, 0.034500, 0.043310, 0.332030, 1.044890, 
0.702160, 0.389190, 0.242580, -0.205560, 1.250620, 0.087030, -0.160290, 0.307990, 0.683360, 0.274330, 
-0.361580, -0.459050, 0.429980, 0.810780, -0.015960, -0.275180, -0.286690, 0.041180, -0.435330, 0.160760, 
0.537030, 0.577100, 0.024820, -0.431580, -0.491070, 1.107420, 0.034470, -0.633020, -0.235270, -0.275170, 
-0.360820, -0.288010, 1.142120, -0.325910, -0.180130, 0.502450, -0.123600, -0.273990, 0.009840, -0.762660, 
0.398450, -0.334190, -0.535990, 0.265750, -0.011620, -0.447850, 0.095670, 0.254120, -0.074410, 0.154280, 
0.287750, -0.216040, -0.659390, 0.672950, -0.095910, -0.275320, -0.405770, 0.127780, -0.494070, 0.044000, 
-0.911420, 0.410600, -0.291550, 0.068540, -0.028140, -0.655860, -0.281670, -0.183790, 0.192950, 0.170350, 
-0.136710, 0.021020, 0.115200, -0.476170, 0.946580, -0.103070, -0.235650, -0.191440, -0.242040, 0.237700, 
0.054530, -0.461760, -0.125740, 0.022550, 0.304170, 0.356960, -0.293520, -0.180930, 0.036950, 0.263850, 
0.066090, 0.119330, -0.117920, 0.366210, 0.298990, 0.072670, -0.027190, 0.200770, -0.064710, 0.019340, 
0.427160, 0.052130, -0.115030, 0.065510, -0.073650, -0.058480, 0.545910, 0.318430, -0.184910, -0.249700, 
0.105770, -0.130580, -0.273810, -0.170470, 0.168570, -0.111670, 0.365130, 0.259550, 0.114130, 0.333730, 
0.247910, 0.344150, 0.054860, -0.090030, -0.017610, -0.301560, -0.274320, 1.383440, 0.155930, -0.484210, 
-0.527110, 0.619980, 0.035390, -0.110150, 0.070170, 0.182950, 0.034800, 0.330980, -0.029920, -0.103840, 
-0.222270, 0.057810, -0.232770, 0.070230, -0.135590, -0.367640, -0.040090, -0.286340, 0.247550, -0.391620, 
-0.043150, -0.586420, -0.063200, 0.553180, 0.183160, -0.504610, -0.097780, -0.122250, 0.200190, 0.131040, 
0.130070, -0.166560, -0.220410, 0.038380, 0.111850, -0.077900, -0.234520, 0.129360, 0.346800, 0.214430, 
-0.106270, -0.025820, -0.556900, 0.325260, 0.771780, 0.341530, -0.078080, 0.312640, 0.136220, 0.254220, 
-0.127730, 0.666860, 0.025830, -0.127340, 0.808780, 0.116230, 0.202360, -0.018450, 0.436750, 0.443100, 
0.324950, -0.093650, 0.086650, -0.029340, 0.146680, 0.318170, 0.212430, -0.718560, -0.219510, 0.186900, 
0.003520, 0.303110, 0.522830, -0.367620, 0.042060, 0.080450, 0.101830, 
0.291350, 0.505460, 0.233250, -0.315090, -0.030760, 0.247980, -0.153230, -0.140430, 0.226050, -0.207020, 
-0.094470, 0.077600, 0.190260, -0.320810, -0.563750, 0.315950, -0.206150, -0.349290, -0.137250, -0.040760, 
-0.024030, -0.107210, -0.383470, -0.603710, 0.379210, -0.365260, -0.062730, 0.301730, -0.987980, -0.198420, 
0.215250, -0.252680, 0.239500, -0.144960, -0.198720, 0.235190, 0.164080, 0.103030, 0.337890, -0.137420, 
-0.056260, -0.001010, -0.371800, -0.064350, -0.128740, -0.306030, -0.086610, 0.172360, -0.088630, -0.620780, 
0.213830, 0.301190, 0.015160, -0.797720, 0.055330, -0.027530, -0.063870, 0.007600, -0.123460, 0.579020, 
0.545400, -0.019510, -0.013360, -0.299620, -0.494830, -0.273470, -0.314390, -0.017080, -0.099990, 0.002540, 
0.144690, 0.081090, -0.011290, 0.209120, -0.405180, 0.195530, 0.214460, -0.751040, 0.049810, -0.589590, 
0.009460, 0.197530, -0.564560, -0.005330, -0.270930, 0.185870, -0.015900, 0.292930, 0.257210, 0.519470, 
0.285820, -0.044780, 0.917670, 0.039070, 0.117680, 0.124610, 0.267750, -0.270040, -0.281140, 0.010770, 
-0.057520, -0.321970, 0.034440, -0.051780, -0.003130, 0.279690, 0.493980, -0.311670, 0.282780, 0.014530, 
0.406180, 0.665440, 0.248170, 0.407840, 0.101480, 0.172660, 0.499180, 0.208270, -0.232840, -0.111320, 
0.645470, -0.529950, 0.237190, 0.193660, -0.017880, -0.008850, 0.521830, -0.170480, -0.065460, -0.369130, 
0.160930, -0.113240, -0.395670, -0.271460, -0.084440, -0.311440, 0.216250, 0.060100, -0.145570, -0.142210, 
0.983840, 0.093520, -0.123590, -0.289110, -0.226100, -0.232970, 0.007920, -0.262980, -0.204520, 0.019940, 
-0.363550, 0.088910, 0.256630, -0.206650, 0.363870, -0.035880, -0.488380, -0.010920, -0.121240, 0.023750, 
-0.189460, 0.745780, -0.260640, -0.009580, 0.370870, -0.215880, -0.164430, 0.004040, -0.249740, 0.167680, 
-0.080120, 0.072880, 0.241160, -0.053590, 0.174790, -0.556060, 0.161930, -0.145510, 0.602620, 0.072950, 
0.393950, 0.064750, -0.082080, -0.076770, 0.024950, -0.200630, 0.027510, -0.109560, 0.000940, -0.094450, 
-0.226710, -0.101950, 0.210500, 0.324350, -0.003560, 0.460430, 0.945360, 0.089630, -0.233240, -0.179150, 
-0.180410, 0.010070, -0.055350, 2.106680, 0.221430, 0.389010, 0.128240, -0.431080, 0.086710, 0.157920, 
-0.293470, 0.187140, -0.169870, -0.106790, 0.243450, 0.309670, 0.466340, 0.527210, -0.538650, 0.533740, 
-0.004940, 0.716890, 0.250080, 0.563520, -0.342590, -0.100960, 0.201390, 0.042130, 0.148820, 0.381900, 
0.142060, 0.147890, 0.157420, 0.067660, 0.516770, 0.423320, 0.055710, 0.395100, -0.102250, 0.082370, 
0.664550, 0.429480, 0.123450, -0.059430, 0.181700, 0.775250, 0.430020, 0.450090, 0.481470, 0.101600, 
0.431780, 0.145810, 0.390250, 0.474350, -0.234940, 0.177030, 0.127850, 0.312900, 0.243830, 0.745000, 
-0.075100, 0.108480, 0.688670, 0.202200, -0.223780, -0.331630, -0.525530, -0.051820, -0.007560, 0.223550, 
0.327810, 0.346780, 0.151560, 0.127880, -0.021780, 0.307490, 0.442280, -0.220070, -0.188890, -0.176740, 
0.147440, -0.241910, 0.163010, -0.123240, -0.253510, -0.380470, -0.206600, -0.230140, 0.225290, 0.022740, 
0.514600, 0.017520, -0.189560, 0.115990, 0.214670, 0.222570, -0.101490, 0.590640, 0.248160, -0.038860, 
0.185260, 0.595220, 0.567970, 0.340110, -0.007210, 0.117530, -0.376750, -0.159190, -0.007210, 0.111650, 
-0.200810, 0.286080, -0.316240, 0.021260, 0.131650, 0.814330, -0.165380, -0.094330, 0.219710, 0.231690, 
-0.129210, 0.310510, 0.412830, -0.090860, 0.214840, 0.144450, 0.302140, -0.229780, 0.212410, 0.509340, 
-0.135740, -0.174960, 0.554020, 0.128490, 0.410920, 0.096250, -0.094380, 0.000190, 0.496180, 0.071340, 
-0.026670, 0.000510, 0.087100, 0.015110, 0.657070, 0.085270, 0.414600, -0.165800, 0.129010, 0.219530, 
0.382260, -0.402270, 0.150140, 0.267620, 0.433150, -0.067060, 0.110140, 
-0.133990, -0.310410, -0.566980, -0.042270, -0.216880, -0.650470, -0.093880, -0.417440, -0.156870, -0.219610, 
-0.090010, 0.009360, 0.028430, -0.159260, 0.107760, -0.408470, 0.111420, -0.136820, -0.516740, -0.262980, 
0.024290, 0.320400, 0.156710, -0.310910, -0.513410, -0.353230, 0.246860, 0.193100, -0.444110, -0.054290, 
0.147570, -0.006440, -0.049750, 0.518600, -0.235320, 0.017320, -0.420530, -0.138780, 0.164650, 0.055070, 
0.285570, 0.027270, 0.137070, -0.141070, -0.511340, -0.676860, -0.395980, -0.071010, -0.663700, -0.534650, 
-0.299190, 0.210760, 0.135700, -0.696180, 0.533120, 0.264440, -0.569890, -0.269770, -0.236330, 0.293040, 
0.258620, 0.162940, 0.061420, 0.722360, -0.411000, -0.504120, -0.134990, -0.158320, 0.285780, -0.171820, 
-0.423190, 0.171740, -0.091930, 0.065800, -0.275870, 0.387340, 0.023270, 0.239060, 0.004560, -0.252820, 
0.137780, 0.263490, -0.266630, 0.075140, 0.270050, -0.469030, -0.282730, -0.516650, 0.473020, -0.323350, 
0.109960, -0.585050, -0.490930, -0.146600, 0.078950, -0.469150, 0.085280, 0.089800, -0.388370, -0.614640, 
-0.654360, 0.128680, 0.030320, -0.114820, 0.084740, 0.567140, -0.130400, 0.377790, 0.314440, -0.171480, 
0.021930, 0.260870, -0.555610, -0.267100, 0.054670, 0.437350, -0.119900, -0.130690, -0.091470, -0.007050, 
-0.202290, -0.198020, -0.396430, 0.113390, -0.416150, 0.048060, 0.354390, -0.385720, -0.264690, -0.252370, 
-0.298730, 0.260060, -0.247160, 0.204970, -0.394740, -0.296610, 0.103260, -0.166610, 0.364450, 0.002660, 
0.328510, -0.304480, -0.440620, -0.052250, 0.356890, -0.809260, 0.043300, 0.612860, 0.312800, 0.653520, 
0.769210, -0.349750, 0.402820, 0.901350, -0.777160, 0.165220, -0.345060, 0.848240, 0.520840, 0.064860, 
-0.297800, 0.025350, 0.039230, -0.208170, -0.314110, -0.193420, -1.002480, 0.047820, 0.540530, -0.452860, 
0.857560, 0.977600, -0.166270, -0.082560, -0.778130, 0.429720, 0.235160, -0.667070, 0.833050, 0.104820, 
-0.155850, -0.364850, 0.535200, -0.694830, -0.519310, 0.167890, -0.066830, -1.415580, -0.003850, 0.758970, 
0.343330, 1.045560, 1.267680, -0.069950, 0.586140, -0.128470, -0.139450, -0.077860, -0.191820, 0.969900, 
0.901300, 0.538150, -0.351270, 0.078190, -0.359840, -0.405340, -0.334180, -0.755230, -0.752370, 0.056450, 
0.744880, -0.336460, 0.324030, 0.086010, -0.159280, -0.198330, -0.507840, 0.788660, 0.268420, -0.691380, 
0.384870, 0.037930, -0.214220, 0.084490, 0.396070, -0.631310, -0.988690, 0.294590, -0.779670, -0.951390, 
0.039630, 0.252530, 0.276560, 0.723340, 0.174240, -0.060370, 0.437280, 0.113190, 0.242570, 0.190430, 
-0.447000, 0.376900, 0.472420, -0.015070, 0.283880, -0.646970, -0.161080, -0.720720, -0.354100, -0.287540, 
-0.500880, 0.015700, 0.633390, -0.092630, -0.156190, -0.351560, 0.146580, -0.195010, -0.374520, -0.075190, 
-0.240070, -0.457380, 0.656740, 0.236710, 0.560030, -0.559180, -0.572850, -0.593240, -0.471860, 0.384650, 
-0.304340, -0.923970, -0.005110, 0.822530, 0.116330, -0.402230, -0.483410, -0.574080, -0.159920, 0.254370, 
-0.466820, -0.009520, 0.174390, 0.044280, 0.125290, 0.035000, -0.083890, -0.149860, -0.398370, -0.257470, 
-0.517450, -0.045950, -0.263430, -0.004760, 0.538750, 0.007300, -0.347140, -0.593170, 0.134760, -0.221080, 
-0.153080, -0.606870, -0.076110, 0.060890, 0.427640, -0.040050, 0.179300, 0.194840, -0.365470, -0.549250, 
-0.507210, 0.399550, 0.041660, -0.359090, 0.000270, 0.639510, 0.006220, -0.309630, -0.110390, 0.374170, 
-0.000560, 0.092830, -0.508570, -0.320650, 0.357160, 0.263530, 0.156140, 0.012660, -0.037160, -0.290930, 
-0.640050, 0.012150, -0.274540, -0.308090, 0.043090, 0.009820, 0.547640, 0.132770, -0.273110, -0.421160, 
-0.310980, 0.131520, -0.187160, -0.691080, 0.143680, 0.090140, 0.615600, 0.003200, 0.518020, 0.296270, 
0.079640, -0.266690, -0.849590, -0.190350, 0.168160, -0.025510, -0.000210, 
0.102680, 0.371070, -0.048150, -0.096970, -0.188260, 0.525810, 0.108100, 0.853360, 0.274630, -0.389660, 
-0.281950, 0.511990, -0.151590, -0.314730, 0.312440, -0.258980, 0.208690, -0.058850, -0.420730, -0.224600, 
-0.025010, -0.075180, -0.096880, -0.791930, -0.441240, 0.067370, -0.191630, -0.277050, 0.049930, 0.176310, 
0.241640, 0.213390, -0.151250, 0.105080, 0.106890, -0.089920, -0.265530, -0.175370, -0.006590, -0.063850, 
0.190310, -0.026470, -0.094150, 0.056510, 0.154230, -0.097330, 0.345130, 0.020910, -0.000980, 0.251580, 
-0.445500, 0.168430, -0.310650, 0.034980, -0.469060, -0.028900, -0.107840, 0.130180, 0.603720, 0.125210, 
0.014360, 0.142880, -0.000710, 0.335060, -0.544930, -0.447140, 0.148610, 0.151920, 0.103750, -0.117500, 
-0.092950, -0.313910, -0.078740, -0.482500, -0.246460, -0.386760, 0.362740, -0.412350, 0.030680, -0.324280, 
0.514220, 0.459480, 0.138020, 0.011720, 0.379590, -0.104390, -0.909120, -0.234360, 0.483670, -0.250090, 
0.039990, 0.120820, -0.279100, 0.407740, 0.310060, -0.123170, -0.254850, -0.152840, -0.130210, 0.273200, 
0.048380, -0.496690, 0.083660, 0.544720, 0.012590, 0.186010, 0.006830, -0.316010, -0.341130, -0.599530, 
-0.180350, -0.342840, -0.779070, -0.098980, 0.843630, 0.645470, -0.270420, 0.328390, 0.567470, -0.198420, 
-0.057720, -0.193140, -0.185060, -0.334760, 0.260540, 0.012880, 0.197790, 0.314430, -0.400070, 0.113890, 
0.520840, 0.300640, 0.312210, -0.542190, -0.156690, 0.204850, 0.101420, 0.196660, 0.004630, -0.078600, 
-0.140540, 0.125770, 0.550460, -0.426410, 0.576390, 0.449470, 0.013960, 0.736980, -0.142240, 0.798430, 
0.572010, 0.507330, 0.457200, 0.001840, 0.389740, -0.052230, -0.251740, -0.074780, 0.394440, -0.128330, 
-0.282930, -0.063420, 0.524010, 0.895410, 0.066730, -0.000250, -0.278770, 0.011100, -0.151700, 0.062530, 
0.503790, 0.795690, 0.220920, 0.016330, -0.179810, 0.932850, 0.317880, -0.714360, -0.138800, 0.079470, 
0.313690, 0.095720, -0.539720, 0.038760, 0.239410, 0.361570, -0.583520, -0.410370, -0.004550, 0.067040, 
0.410320, 0.148270, -0.050120, -0.075020, 0.341200, -0.191440, 0.675780, 0.257620, 0.083130, 0.021140, 
0.534880, 0.082810, -0.122940, 1.402720, 0.081230, -0.556210, 0.158020, -0.380570, 0.074790, 0.082440, 
-0.226800, 0.792800, 0.504600, -0.118190, 0.179120, -0.078400, 0.089350, 0.048650, 0.362560, -0.018720, 
0.317690, 0.173410, 0.696940, 1.041900, 0.714280, 0.144950, 0.359590, 0.856620, 1.009200, -0.024240, 
0.121840, -0.183030, -0.339960, -0.511320, -0.333700, -0.291890, -0.027870, -0.459270, 0.390000, 0.017650, 
0.299420, 0.173080, -0.038810, -0.083960, -0.284850, -0.093160, 0.190670, 0.080060, 0.414020, -0.083550, 
0.796770, 0.129010, 0.125320, 0.749230, 0.063750, 0.046830, -0.177490, 0.467180, -0.170760, -0.415940, 
0.354420, 0.099000, -0.068820, -0.128080, 0.429200, 0.028330, 0.424810, 0.031390, 0.448300, 0.436970, 
0.085940, 0.158330, 0.142880, -0.431350, 0.071620, -0.266520, 0.195030, -0.263520, 0.204040, 0.169620, 
-0.255330, 0.159180, 0.441490, 0.278880, 0.088280, 0.578410, 0.288270, 0.508790, 0.007520, 0.236530, 
0.381640, -0.011090, 0.161890, 0.127910, 0.184090, 0.410240, -0.368650, 0.274850, 0.109150, 0.006880, 
0.233100, 0.052390, -0.019540, 0.390060, -0.065070, 0.286260, 0.033710, -0.371730, -0.138300, 0.123080, 
0.188150, 0.135910, -0.284360, 0.410340, 0.117000, -0.239940, 0.014460, 0.065930, 0.328660, -0.059550, 
-0.414340, -0.154960, 0.506670, 0.122720, -0.267940, -0.078150, -0.256760, 0.177650, -0.399840, -0.388440, 
-0.009480, 0.473300, 0.246520, -0.041530, -0.114320, 0.087080, 0.311320, 0.290340, 0.086800, 0.280220, 
0.274640, 0.064760, -0.170720, 0.270620, -0.048410, -0.152860, -0.082180, -0.175350, 0.316880, -0.251620, 
0.335640, -0.214570, -0.076850, -0.275010, -0.035770, 0.269560, 0.073130, 
0.068090, -0.178020, -0.529900, -0.077550, -0.394740, 0.178640, -0.035760, -0.635040, -0.034160, 0.336610, 
-0.251380, 0.355820, -0.017510, 0.127220, -0.793030, -0.029930, 0.143500, -0.671590, 0.187140, 0.295690, 
0.037310, -0.059080, -0.309230, -0.450920, -0.112660, -0.273730, -0.441010, -0.104350, -0.477790, 0.440350, 
-0.330800, -0.465930, -0.228950, 0.120290, 0.232250, -0.046790, -0.271890, -0.081880, -0.645160, -0.224290, 
0.034690, 0.061630, -0.036870, -0.262150, -0.721650, 0.050210, 0.291890, -0.476780, -0.042670, -0.992780, 
-0.290000, -0.166990, -0.280810, -0.643660, -0.333490, -0.179310, -0.261030, 0.225300, -0.076010, 0.137940, 
0.036520, -0.126370, 0.121490, 0.881450, -0.320680, -0.400370, -0.056360, 0.144000, 0.098330, 0.103440, 
-0.079430, -0.003700, -0.177430, 0.273460, -0.213860, -0.674670, 0.112020, -0.394390, -0.326090, -0.912320, 
0.305620, 0.149700, -0.249460, 0.128740, 0.002010, 0.456130, 0.711530, 0.159560, -0.151830, -0.125160, 
0.673200, -0.570840, -0.417000, -0.180920, 0.173730, 0.087910, -0.115770, -0.253390, -0.281540, 0.349530, 
0.341970, 0.602780, 0.207550, -0.764780, 0.103760, 0.275170, -0.154650, 0.011450, 0.211070, 0.210490, 
-0.908130, -0.126090, -0.187360, 0.031850, -0.099790, 0.165740, -0.478140, -0.124940, -0.308350, 0.223700, 
-0.207960, -0.218100, -0.569700, -0.169100, -0.690580, 0.084610, 0.364690, 0.031130, 0.397180, 0.697890, 
0.073540, 0.726600, 0.647310, -0.124610, -0.496840, -0.966590, 0.042910, 0.435830, 0.443600, -0.334150, 
0.052360, 0.034450, -0.158990, -0.101310, -0.013540, -0.656380, 0.083790, 0.259410, -0.548950, 0.231100, 
0.247490, 0.151940, -0.636810, -0.338950, 0.486290, -0.063280, -0.354700, 0.476840, 0.253260, 0.279230, 
-0.109920, 0.193470, 0.318240, -0.330240, -0.154590, 0.055170, -1.002360, 0.068080, 0.206830, -0.288220, 
0.702460, 0.615610, -0.640340, -0.445140, -0.247530, 0.435470, 0.488590, -0.161500, 0.056090, -0.549730, 
-0.249800, -0.181080, 0.342330, -0.553670, -0.415750, 0.144200, -0.118630, -0.502140, 0.009740, -0.394980, 
0.096840, 0.422560, 0.945090, -0.775050, 0.480270, 0.399090, 0.239910, 0.264620, -0.741080, 0.422910, 
0.258270, -0.065320, -0.145910, 0.017800, -0.160080, -1.097260, -0.481370, 0.382720, -1.775280, 0.070800, 
0.958440, -0.710690, 0.056440, -0.138130, 0.161110, 0.020290, -0.451490, 0.438270, 0.014450, -0.134700, 
0.170420, -0.751650, 0.072070, -0.088260, 0.199100, -0.230950, -0.634550, 0.175760, -0.157310, -0.379480, 
0.097890, 0.111300, -0.089160, 0.466420, 0.474140, -0.547140, 0.317650, 0.453580, 0.032130, 0.268640, 
-0.662890, -0.512130, 0.445010, -0.545840, -0.486250, 0.016100, 0.118770, -0.354200, 0.123000, 0.140680, 
-0.838250, 0.037950, 0.373910, -0.061140, -0.181360, -0.504550, 0.280160, 0.202350, -0.073170, 0.112630, 
-0.132160, 0.258910, -0.088760, 0.151470, 0.276720, -0.170510, -0.563800, -0.036210, -0.666400, -0.048850, 
-0.320160, -0.045820, 0.020310, 0.149930, 0.073420, 0.455970, -0.302650, 0.067770, 0.389040, -0.151230, 
-0.964140, -0.309810, 0.162160, 0.239370, 0.092820, 0.030590, 0.495890, -0.817150, -0.347880, 0.093800, 
-0.339040, -0.075560, 0.016230, 0.011640, 0.413730, -0.220010, -0.173950, -0.526000, 0.487260, -0.105700, 
-0.231150, -0.829350, -0.342380, -0.051530, 0.216760, -0.006050, 0.036850, 0.371370, 0.199730, -0.470760, 
-0.723370, -0.437600, 0.403200, -0.077090, -0.003200, 0.292880, -0.276120, -0.217240, 0.365500, -0.187570, 
-0.209280, -0.094440, 0.047580, -0.395020, 0.057450, -0.361150, -0.529420, -0.154230, 0.133080, -0.553390, 
-0.196290, -0.126310, 0.593930, 0.142600, 0.085580, 0.001690, 0.041920, -0.075890, -0.010990, -0.379750, 
-0.004820, -0.085510, -0.008540, -0.033710, -0.540260, -0.444440, 0.266680, 0.305550, -0.027910, -0.125370, 
-0.115900, 0.172860, -0.239920, 0.128740, -0.391430, -0.999460, 0.001810, 
0.113120, 0.508040, 0.124350, -0.400870, -0.089120, 0.299660, -0.229770, 0.039150, -0.017790, 0.710490, 
0.360450, 0.157700, -0.000530, -0.069820, -0.934370, 0.082480, -0.000460, 0.253640, -0.019580, 0.151050, 
-0.175870, 0.126300, -0.442210, 0.484470, -0.130550, -0.073340, 0.503980, 0.180780, -0.248260, 0.352090, 
0.169220, -0.000980, -0.244140, 0.318320, 0.319830, -0.508560, -0.003160, -0.024570, 0.531230, -0.020380, 
-0.477580, -0.196710, -0.197070, 0.291890, -0.334080, 0.327780, -0.073810, 0.126240, 0.153740, 0.171010, 
0.108340, 0.377860, -0.149710, 0.330830, -0.025290, 0.109480, 0.035090, 0.185610, 0.036920, 0.207320, 
-0.129420, 0.159110, -0.205490, -0.393250, -0.261290, 0.355550, -0.062240, 0.094510, -0.252540, -0.500260, 
0.437850, -0.361090, 0.220720, -0.329430, 0.164710, -0.024510, 0.362530, -0.239440, 0.062180, 0.622470, 
0.594710, 0.056900, 0.246230, -0.192450, -0.484370, 0.118700, -0.421010, 0.021480, -0.429310, -0.262230, 
-0.116720, -0.121970, -0.128020, 0.509610, 0.114810, -0.147570, -0.308650, 0.164650, -0.641510, -0.536260, 
-0.099600, 0.417180, 0.441850, 0.150160, -0.172670, 0.023130, 0.150370, -0.237890, -0.937940, -0.117630, 
-0.348020, -0.604100, -0.086980, -0.387140, 0.494130, -0.594330, -0.048500, 0.389430, 0.302370, -0.312280, 
-0.236350, -0.002090, 0.625770, -0.096480, 0.306280, -0.141740, 0.506180, 0.361580, -0.261890, -0.217290, 
0.243900, 0.172740, -0.267630, -0.551690, 0.171850, 0.290530, 0.003810, 0.036250, -0.159450, 0.558800, 
-0.603770, 0.234000, 0.945080, 0.048190, 0.303490, 0.462260, -0.107030, 0.418580, 0.422460, -1.200750, 
-0.925380, -0.300500, -0.293300, -0.077290, -0.813870, -1.049710, 1.045360, 0.431350, 0.132940, 0.411200, 
0.744070, -0.726540, -0.586460, -0.331680, 0.653370, 0.592300, 0.531470, -0.080990, 0.640180, 0.123350, 
-0.694280, -0.522190, 0.127970, 0.223380, 0.758560, -1.302170, -0.096950, 0.656470, 0.130460, 0.093160, 
-0.570100, 0.198810, -1.570620, 0.070990, 0.178710, 0.169830, 0.531900, 1.040770, 0.008780, 0.638740, 
0.176050, -0.447400, -0.863070, 0.078090, 0.118210, 0.299620, -0.845330, -0.476190, 0.421670, 0.599240, 
-0.185310, 0.633340, 0.022550, -1.068610, -0.002840, -0.337110, 0.072170, 0.177140, 0.686190, -0.092070, 
0.017560, -0.149190, -0.456710, -1.071680, 0.826050, -0.505810, -0.904640, -1.082070, 0.344790, 0.709260, 
0.730250, -0.237470, 0.164890, 0.037000, -1.230330, -0.244260, 0.012730, -0.007130, 0.390210, 0.617320, 
-0.078860, 0.256900, -0.329450, 0.240080, 0.488420, 0.508560, 0.243560, 0.412430, 0.549410, 0.468890, 
-0.128680, 0.124830, 0.235790, 0.178710, -0.056420, -0.388070, -0.291940, -0.408270, 0.462280, 0.247460, 
-0.269700, -0.085950, 0.152080, 0.144960, 0.017260, -0.138640, 0.620520, 0.429720, -0.161880, 0.331820, 
0.616470, -0.102280, -0.078620, 0.016130, 0.141220, -0.140830, -0.674360, 0.201190, -0.189950, -0.121180, 
-0.560280, -0.122840, -0.138210, -0.065300, 0.194680, -0.129870, -0.308930, 0.068470, 0.223130, -0.303670, 
-0.178180, 0.236160, 0.113680, 0.397060, 0.207480, 0.837830, 0.483100, -0.282260, -0.379880, 0.567530, 
0.109870, -0.140510, 0.311120, -0.134400, -0.327500, 0.041580, 0.189150, -0.085360, -0.491260, -0.707910, 
-0.187160, 0.247970, 0.354640, -0.247820, 0.207210, -0.544980, -0.277610, 0.582330, -0.243870, -0.212220, 
-0.405890, 0.713180, -0.267490, -0.055240, -0.144350, -0.458110, 0.099810, 0.348590, -0.318220, 0.536010, 
-0.339010, -0.480690, 0.063750, 0.019320, 0.222730, -0.036390, 0.142160, 0.173020, 0.340300, -0.352530, 
-0.295670, 0.112120, 0.184040, -0.438700, 0.204070, -0.120960, 0.271780, -0.203670, 0.161930, 0.601260, 
-0.000920, 0.634840, 0.139640, -0.000490, 0.267600, -0.376900, -0.264600, -0.091750, -0.282970, -0.036170, 
-0.449910, -0.089860, 0.352940, 0.004310, 0.152230, -0.142000, -0.158610, 
0.792990, 0.466940, 0.349810, -0.142940, -0.150770, 0.239360, -0.010270, 0.121320, 0.615480, 0.444640, 
0.803340, 0.337910, -0.004850, -0.617280, -0.271550, -0.195720, -0.063540, -0.484900, 0.130030, 0.106660, 
-0.227920, 0.174350, 0.786480, 0.198000, -0.437880, 0.074270, 0.036650, 0.148890, -0.121850, 0.441220, 
0.077930, -0.071500, 0.382000, -0.296880, 0.183760, -0.217480, 0.439770, 0.360870, 0.234030, -0.209630, 
-0.490410, -0.205230, 0.521120, 0.369920, 0.350100, 0.020920, -0.294330, -0.050900, -0.231220, -0.373620, 
-0.176100, 0.119510, 0.365750, -0.289330, 0.443700, 0.395150, 0.148000, 0.044230, 0.011950, 0.033230, 
-0.545570, -0.090690, -0.202880, -0.408230, 0.593090, 0.210260, 0.115150, -0.323880, 0.653950, 0.122690, 
-0.449640, -0.342230, 0.119630, -0.471240, 0.226610, -0.399320, -0.292310, 0.380230, -0.787220, -0.572370, 
0.244050, 0.229310, -0.039080, -0.183640, 0.723230, 0.742760, 0.213990, 0.345260, -0.379640, 0.721220, 
0.862650, -0.351720, -0.180130, -0.042670, 0.062680, 0.466670, -0.199100, -0.079620, 0.112160, 0.034370, 
-0.066580, -0.037390, -0.088390, -0.185550, -0.189480, 0.061510, -0.290960, 0.339380, 0.476830, -0.345180, 
0.120880, -0.201590, -0.768990, -0.149760, 0.081820, 0.081990, -0.463900, -0.141070, 0.547260, 0.105670, 
0.194300, 0.219110, -0.065640, -0.595180, -0.133550, -0.161940, -0.143140, 0.607160, -0.392340, -0.385500, 
0.121620, 0.376470, -0.091640, -1.240850, -0.201880, 0.067970, 0.527190, 0.266410, 0.223370, -0.481640, 
0.278020, -0.379560, -0.010720, 1.278720, 0.368860, -0.236910, -0.086940, 1.519220, 0.961050, 0.435780, 
1.548700, 0.271610, 0.792370, 1.331770, 0.251710, 0.190900, 0.079660, -0.188070, 1.179440, -0.428380, 
-0.687240, 0.209480, 0.157910, -0.371520, 0.008700, -0.347700, 0.201990, -0.068890, 1.066510, 0.247650, 
0.060160, 1.228460, -0.057610, 0.900590, 1.209190, -0.257370, -0.438420, -0.116430, 0.426830, 0.560070, 
-0.096020, 0.229800, -0.813550, -0.114180, -0.242170, 0.032400, -0.214150, 0.360670, 0.003140, 0.567320, 
-0.002270, -0.597650, -0.719730, 0.046470, 0.073230, -0.930620, -0.967270, 0.621300, 0.049630, 1.019850, 
-0.693510, 0.096610, 0.709800, -0.628680, -0.759360, -0.573130, 0.142950, 0.104570, -0.291340, -0.080740, 
0.285810, 0.435380, 0.189700, -0.215980, 0.352270, 0.617520, -0.288360, 0.081440, -0.775920, 0.366250, 
0.432150, 0.273430, 0.375860, 0.212820, 0.369760, -0.302160, -0.486000, 0.536370, -0.372590, -0.066870, 
-0.135990, 0.830380, 1.566890, 0.622900, -0.024600, -0.694860, 0.772820, 0.826590, 0.572130, 0.125720, 
0.246110, 0.168680, 1.130080, 0.218540, -0.197700, 0.150930, 0.511540, 0.332610, 0.464070, -0.262980, 
-0.397020, -0.175350, 0.681510, 0.393660, 0.752380, -0.369350, -0.092060, 0.072110, 0.456960, -0.135160, 
-0.442120, 0.421200, 0.702480, 0.249650, 0.372220, 0.045470, -0.821700, -0.050880, -0.355880, 0.698350, 
0.466630, -0.200980, -0.194060, 0.094340, 0.127650, -0.323750, -1.016840, -0.171870, -0.013400, -0.487210, 
0.159040, 0.190220, 0.478900, 1.125570, 0.666290, 0.219220, 0.210420, -0.467970, -0.615950, -0.621300, 
-0.091520, 0.077260, 0.037300, -0.169490, 0.165550, 0.568910, 0.557330, 0.358730, 0.245920, 0.703680, 
0.254090, 0.784680, 0.234890, -0.127760, 0.068450, 0.858830, 0.260220, -0.472720, 0.460470, 0.168680, 
-0.126040, 0.426410, -0.570310, -0.005280, -0.189110, 0.565260, 0.266730, -0.169980, -0.059710, 0.335170, 
0.815800, 0.520930, 0.194340, -0.070610, 0.429560, 0.348760, 0.614850, 0.552570, -0.369370, -0.156740, 
0.243310, 0.279170, 1.034900, -0.036010, 0.047150, -0.140110, -0.005440, 0.627680, 0.236640, -0.030130, 
-0.041920, 0.635560, -0.381840, 0.697990, 0.055560, 0.012490, 0.398620, 0.232330, 0.468140, -0.199000, 
0.338580, -0.029370, 0.162110, 0.133080, 0.531330, 0.194130, -0.162750, 
-0.182970, -0.318930, 0.483740, 0.475810, 0.468160, 0.113490, 0.199580, 0.168670, 0.756550, 0.086160, 
-0.120460, 0.144550, -0.033050, 0.377350, 0.061940, 0.068590, -0.062540, 0.382320, 0.144530, -0.010750, 
0.042890, 0.073040, 0.048120, -0.264880, -0.184710, 0.284900, 0.117590, -0.058960, 0.369730, 0.272190, 
-0.005220, 0.515530, 0.297050, 0.252850, 0.136320, 0.082010, -0.009220, -0.050740, 0.090560, 0.259810, 
-0.051660, 0.071300, 0.182460, -0.002300, 0.271430, -0.046060, 0.471150, 0.174480, -0.046530, 0.032550, 
0.121870, -0.151050, -0.141570, 0.120120, -0.044600, -0.218210, 0.095280, 0.383970, 0.170960, 0.415730, 
0.154190, -0.014650, 0.067880, 0.252180, 0.140680, 0.649750, 0.258780, 0.049430, 0.289820, 0.188560, 
0.263460, 0.592910, -0.058100, 0.402370, 0.017960, 0.067590, 0.035390, -0.235540, -0.422060, -0.266810, 
0.385160, 0.336620, -0.001930, 0.045790, -0.167920, 0.254540, -0.031050, -0.201210, 0.173640, 0.130080, 
-0.071680, -0.182830, 0.166400, 0.005000, 0.602020, 0.080090, 0.182380, -0.002140, 0.326080, -0.267550, 
-0.262580, 0.495680, -0.273070, -0.182710, 0.054770, -0.125630, 0.040480, 0.825570, 0.748150, 0.510960, 
0.243060, 0.002240, 0.318300, 0.174120, -0.148710, 0.195270, 0.070800, 0.042350, -0.164500, 0.309580, 
0.157920, 0.369300, 0.117500, -0.509790, -0.058860, 0.019830, -0.145910, -0.193880, 0.423140, 0.472300, 
0.259540, -0.046060, 0.201650, 0.185140, 0.296460, -0.159930, 0.248050, -0.074540, 0.040070, 0.022460, 
1.079870, -0.060440, 0.114260, -0.337670, 0.197840, -0.203520, 0.053850, -0.616590, -0.592830, 0.799660, 
0.981040, 0.702050, -0.262010, 0.385600, -0.169250, 0.385250, 0.044410, 0.170090, -0.198720, 0.025560, 
0.042710, 1.148810, 0.098250, 0.352860, -0.250400, -0.530580, -0.053950, -0.000270, -0.346640, -0.365800, 
0.168690, 0.763250, 0.274640, 0.455460, 0.363260, 0.140570, 0.198870, -0.396540, -0.162570, -0.422680, 
-0.196950, 0.030420, 1.245310, -0.198000, -0.453140, -0.152190, 0.330730, -0.549310, 0.007880, -0.150270, 
0.088880, 0.241990, 0.291060, 0.142620, 0.512900, 0.627470, 0.064340, -0.407560, -0.181390, -0.113940, 
0.227830, -0.095930, -0.608950, 0.688410, -0.170990, 0.050790, 0.233130, -0.202730, -0.018840, 0.027650, 
-0.451630, 0.196080, 0.481970, 0.473580, -0.103710, 0.232970, 0.252930, -0.331220, 0.476040, 0.082550, 
0.013280, -0.135210, 0.027530, -0.510380, 0.156950, -0.477400, -0.293710, 0.488320, -0.297110, 0.132830, 
0.054170, -0.009100, 0.212560, 0.235550, -0.248830, 0.775680, 0.175360, 0.304700, 0.163950, 0.291730, 
0.015420, -0.000090, 0.690580, 0.107370, -0.426960, 0.049460, -0.326800, -0.394500, -0.132680, -0.107070, 
-0.177070, 0.044790, 0.401970, 0.228180, 0.405100, -0.208690, -0.327820, -0.253320, 0.176230, -0.567170, 
0.288030, 0.276090, 0.181240, 0.384170, -0.140960, 0.035570, 0.113780, -0.014150, -0.069960, 0.297500, 
0.445610, -0.143640, 0.039180, -0.151360, 0.206820, 0.275440, -0.152360, 0.305490, 0.184000, -0.053550, 
-0.301070, 0.474160, -0.013350, 0.209700, 0.355400, 0.380110, 0.093790, 0.537030, -0.136790, -0.222280, 
-0.321640, -0.175300, 0.126570, 0.042440, 0.116730, -0.277500, -0.114610, -0.029450, 0.091330, -0.213790, 
-0.148230, 0.466910, 0.530380, 0.230170, 0.012580, 0.038190, -0.275030, 0.265550, 0.109940, 0.012070, 
-0.176620, -0.200600, 0.380130, 0.081650, 0.018360, 0.121500, -0.213660, -0.031200, -0.207640, 0.320810, 
-0.071990, -0.156080, 0.495170, -0.253850, -0.231710, 0.114100, 0.466750, -0.245080, 0.112470, -0.057250, 
-0.032690, -0.325220, 0.216680, 0.080530, -0.224550, 0.049580, -0.389550, 0.379820, 0.143050, 0.213590, 
0.237730, -0.133710, -0.168210, -0.394000, 0.601370, -0.027450, -0.003900, -0.029930, 0.078790, 0.085440, 
-0.204390, -0.032930, -0.427200, -0.280250, -0.046700, -0.652170, 0.082880, 
-0.592650, 0.390360, 0.059720, -0.146560, -0.026010, -0.121090, -0.194300, 0.138320, 0.575140, -0.024970, 
-0.253840, 0.267880, -0.071570, 0.048330, 0.407430, -0.232460, -0.073580, -0.084540, 0.339730, -0.259520, 
0.067040, -0.133790, 0.190520, 0.318030, -0.151640, 0.256680, 0.031800, 0.264710, 0.149040, 0.172820, 
-0.168010, 0.171100, 0.343770, 0.272650, 0.277550, -0.466750, 0.037070, -0.211090, 0.201850, 0.036730, 
0.222520, 0.053030, 0.012710, -0.019110, -0.402320, -0.639500, 0.023730, 0.103160, 0.317380, -0.573040, 
0.245940, -0.210870, -0.057530, 0.265350, -0.009260, -0.163510, 0.110960, 0.100780, 0.177840, 0.022270, 
0.032850, 0.055630, 0.077710, -0.645070, -0.358440, -0.262230, -0.066730, -0.446500, -0.532080, 0.059390, 
-0.398200, 0.078640, 0.178690, -0.126780, -0.133490, -0.231060, -0.055890, 0.195040, -0.349130, 0.059630, 
0.099830, 0.311900, 0.344230, 0.069300, -0.027270, -0.126370, -0.293580, -0.522680, 0.005950, -0.060600, 
-0.317960, -0.016470, -0.611370, -0.019240, 0.331880, 0.031070, 0.320320, 0.384830, -0.818740, -0.424080, 
-0.166270, 0.347720, -0.023920, 0.094250, 0.078630, 0.228020, 0.807840, 0.185400, 0.064710, 0.624800, 
0.367920, 0.494440, -0.248090, -0.442020, 0.053340, -0.172350, 0.507960, 0.390910, -0.698260, 0.677070, 
0.012280, 0.056050, -0.530090, -0.189650, 0.076990, 0.096430, -0.673920, 0.088570, 0.092880, -0.505540, 
-0.096870, 0.234220, -0.175980, 0.380340, 0.259970, -0.218160, 0.071580, 0.037230, 0.198820, -0.261150, 
-0.504520, 0.023230, 0.371020, -0.028600, -0.041320, 0.171540, 0.049550, -0.366200, -0.711950, 0.033750, 
0.286900, 0.711000, -0.358020, -0.617740, 0.292200, -0.217970, 0.577050, 0.283730, -0.530470, 0.649540, 
0.455000, 0.525640, -0.150000, 0.026400, -0.308350, 0.253700, 0.505940, 0.064290, -0.604800, 0.339610, 
0.339800, -0.204300, 0.634590, -0.011670, -0.342180, 0.454900, 0.162250, -0.869770, -0.397040, -0.030280, 
0.102660, -0.415600, 0.431950, 0.533570, 0.220840, -0.258480, -0.233550, -0.401040, -0.002480, -0.647490, 
0.186510, 0.251950, 0.281200, 0.133810, -0.197600, -0.418960, 0.621330, 0.619300, -0.456310, -0.595460, 
0.135880, 0.327160, 0.094700, 0.842960, 0.457410, 0.745290, -0.167660, -0.205280, -0.044310, 0.074890, 
-0.565930, -0.370980, -0.229480, 0.442000, 0.359840, -0.196090, -0.239990, 0.178180, 0.804980, -0.190570, 
-0.781880, -0.200330, -0.437250, -0.258150, 1.437280, 0.380590, 0.316670, 0.145520, -0.262190, -0.062830, 
0.077460, -0.188030, 0.211180, 0.293140, 0.722320, -0.386860, -0.008480, 0.720570, 0.651950, 0.778360, 
-0.443320, -0.669000, 0.030380, -0.421260, -0.658430, 0.657120, 0.853780, 0.337340, -0.219690, -0.216340, 
-0.018820, 0.095200, -0.207280, -0.467860, -0.070270, -0.253180, -0.156140, -0.094740, -0.279460, -0.364470, 
-0.235430, -0.072380, -0.071400, -0.648460, 0.235850, 0.057190, 0.155480, -0.210040, 0.063620, -0.149420, 
0.206530, 0.111410, 0.103240, -0.324790, -0.291190, 0.036190, 0.830530, -0.039400, -0.082820, 0.380280, 
-0.466140, 0.155280, 0.260730, -0.270000, -0.043660, -0.133550, -0.744200, 0.212210, 0.205510, 0.476410, 
-0.194810, -0.225700, 0.036600, 0.082460, -0.042190, 0.108740, -0.358950, -0.154860, -0.022700, -0.199930, 
0.057820, -0.865340, -0.165140, 0.215070, -0.305770, 0.415760, 0.179030, -0.047590, 0.231160, -0.077940, 
0.304570, -0.007210, 0.089190, 0.129380, 0.094160, -0.007890, -0.184410, -0.375870, 0.178350, -0.234090, 
-0.127050, 0.125230, 0.029020, -0.059000, -0.060770, 0.045450, -0.334740, -0.001290, -0.067920, 0.014490, 
-0.165380, -0.131400, -0.170230, -0.246090, 0.492820, 0.073670, -0.018890, 0.287860, 0.230010, 0.434160, 
-0.543730, 0.183910, 0.460530, 0.432770, 0.173740, -0.277000, -0.273550, 0.220260, -0.067690, -0.281300, 
-0.248970, -0.009160, 0.064980, -0.313500, -0.526990, -0.018020, 0.048640, 
-0.060050, -0.265900, -0.198540, -0.102890, -0.020450, -0.089060, 0.140550, 0.091190, -0.061860, -0.172330, 
-0.493250, 0.192530, 0.276660, -0.222250, 0.495020, -0.018150, 0.146940, 0.095940, 0.034650, -0.333100, 
0.017150, -0.006280, 0.143250, -0.211200, -0.265800, -0.486850, -0.422270, 0.202310, -0.183060, -0.511850, 
0.377980, 0.126170, -0.195730, -0.059710, -0.308960, 0.095620, -0.077850, -0.263600, 0.215160, -0.141990, 
0.026240, -0.010470, 0.630820, 0.122030, 0.060150, 0.178680, -0.255250, -0.114260, 0.442150, -0.435970, 
-0.031680, 0.364060, 0.135540, 0.213470, -0.002010, 0.112320, -0.545450, -0.038250, -0.222030, 0.071870, 
0.175740, 0.501950, 0.020970, 0.271540, -0.261420, -0.350580, -0.236530, 0.470120, 0.216330, 0.809380, 
-0.223740, 0.311040, -0.016110, -0.074580, 0.328310, -0.083300, -0.063320, -0.406430, 0.248050, 0.046560, 
0.046040, 0.422930, -0.183560, 0.024390, -0.244030, 0.280970, 0.000030, -0.282870, -0.292120, 0.351100, 
0.672450, -0.383900, 0.144240, 0.095690, 0.559260, 0.297510, 0.654710, -0.032170, -0.014590, 0.009640, 
0.052860, -0.002260, 0.025520, -0.585270, -0.008450, 0.080760, 0.207130, 0.472900, 0.575750, -0.292010, 
0.040420, 0.296550, 0.703960, 0.054960, 0.328940, 0.242140, 0.283140, 0.198100, -0.026860, -0.302700, 
0.248310, 0.336750, 0.306950, 0.235350, 0.289460, 0.007070, -0.133760, 0.661460, 0.623880, 0.672720, 
-0.173770, 0.113760, 0.333790, 1.236060, 0.531860, -0.388650, -0.359160, 0.517660, -0.087240, -0.140830, 
0.326290, -0.246140, 0.384840, -0.072810, -0.012250, -0.016090, 0.014310, -0.749340, 0.688210, 0.467150, 
0.634470, -0.043440, 0.595610, -0.064310, 1.474220, 0.762120, -0.956640, -0.775200, 0.658920, -0.201000, 
-0.361730, -0.509050, 0.393580, 0.687160, 0.191890, -0.346140, -0.990190, 0.015660, 0.129890, 0.124500, 
-0.245590, -1.121530, -0.022980, 0.126270, -0.111570, 0.432420, 0.504510, 0.040060, -0.253870, -0.099030, 
0.173600, 0.302260, 0.093470, -0.518190, -0.196210, -0.104370, 0.090090, 0.513580, 0.003630, -0.593070, 
0.918790, 0.221920, 0.186930, 0.059440, 0.166920, 0.507190, -0.394560, 0.088790, 0.175940, 0.015130, 
-0.109750, 0.181950, -0.017620, -0.481300, 0.266430, 0.813050, 0.160120, 0.011310, 0.545270, 0.048570, 
-0.195160, -0.714920, -0.839190, -0.753690, 0.658880, -0.670320, -0.586380, -0.276380, -0.164080, 0.515200, 
0.008430, -0.623160, 0.407970, 0.100070, 0.170350, -0.496780, -0.267880, -0.109880, -0.543330, 1.279810, 
0.064670, -0.746430, 0.711280, -0.073960, -0.429140, -0.286220, 0.088600, -0.070670, -0.408430, 0.006250, 
0.083590, -0.162160, 0.356690, 0.320670, -0.015820, 0.261590, -0.108000, 0.081930, 0.082950, 0.190140, 
0.747570, 0.098650, -0.289420, -0.264980, -0.425190, -0.145500, 0.289070, -0.337890, -0.191100, 0.099660, 
-0.396330, 0.580940, -0.167930, -0.369420, -0.084790, -0.010400, 0.097290, 0.072300, -0.148820, -0.419710, 
-0.079660, 0.710330, 0.170020, -0.412920, 0.063030, 0.036490, 0.124890, 0.893350, 0.222100, -0.056300, 
0.341760, 0.385610, 0.275630, -0.289550, 0.020820, -0.219020, -0.081170, 0.623990, 0.372570, 0.111020, 
0.019890, 0.130550, 0.736640, 0.170580, -0.122020, 0.023650, 0.072950, -0.252080, 0.152610, 0.178080, 
0.077640, 0.420520, 0.213340, 0.065510, -0.005140, -0.087150, 0.090490, -0.156000, 0.794350, 0.071380, 
-0.248850, 0.108580, -0.266490, 0.272110, 0.171320, -0.403310, 0.043690, 0.303530, 0.747840, -0.325980, 
-0.088530, 0.134060, 0.275530, 0.044680, 0.126020, 0.027250, -0.046550, 0.047810, 0.480820, 0.781860, 
0.057540, 0.503220, 0.505440, 0.659690, 0.365510, 0.173130, -0.197360, -0.039630, 0.080830, 0.277140, 
0.159400, -0.165730, 0.302460, 0.215360, -0.324110, 0.278980, -0.278300, 0.378710, 0.223300, 0.515880, 
0.361040, 0.084060, 0.236310, 0.089820, 0.456090, 0.566600, 0.150450, 
-0.014450, -0.004430, 0.071590, 0.210690, 0.030880, -0.469970, -1.059990, 0.543670, -0.330270, 0.016130, 
-0.308640, -0.636600, -0.488310, 0.150470, 0.731700, 0.375880, 0.319900, -0.019930, -0.600380, -0.070010, 
0.188670, -0.317900, -0.047720, -0.069860, -0.923420, -0.030940, 0.032130, -0.372950, 0.646610, 0.499680, 
0.243880, -0.014210, 0.216450, 0.189280, -0.307920, 0.048150, 0.044880, -0.104140, 0.183160, -0.130420, 
0.135150, 0.139210, -0.493900, 0.049460, 0.487660, 0.193320, -0.181460, -0.098530, 0.142360, -0.078080, 
0.146550, 0.116970, -0.251560, -0.051180, -0.306360, -0.398060, -0.029850, -0.170130, -0.082430, -0.596690, 
0.503910, 0.081380, 0.119410, -0.613230, 0.061540, 0.039430, -0.276970, -0.410110, -0.185490, 0.426900, 
-0.400470, -0.097250, -0.521010, -0.003940, 0.112640, -0.355370, -0.153010, -0.266660, 0.113720, 0.105940, 
-0.216660, -0.181110, -0.160990, 0.106610, -0.189140, -0.882750, -0.946730, -0.665430, -0.534090, 0.089100, 
-0.496230, 0.234710, 0.144510, -0.088780, 0.079850, -0.393840, 0.180640, 0.029090, 0.036030, 0.245060, 
0.324450, 0.085770, 0.023960, -0.005390, 0.097750, -0.726650, 0.280890, -0.058190, -0.049680, -0.740660, 
0.078910, 0.256180, 0.517110, -0.469080, 0.180810, -0.643170, -0.064340, -0.292880, -0.125390, 0.311800, 
0.193130, 0.322110, 0.208060, -0.307020, 0.644220, 0.076910, -0.891980, 0.406910, 0.607120, -0.104930, 
-0.193290, 0.152580, 0.293780, 0.571550, 0.111180, -0.406920, -0.810660, 0.490880, -0.020730, -0.823860, 
-0.599480, -0.262470, -0.096590, -0.221640, 0.692760, -0.027580, 0.012680, -0.360150, -0.478140, -0.750200, 
-0.481830, -0.151770, -0.555420, -1.440990, 0.594600, 0.170340, -0.214250, -0.428210, -1.335980, -0.488480, 
-0.031930, -0.757640, -0.048970, 1.026480, -0.131160, 0.256500, 0.340260, 0.019590, -1.503280, -0.173300, 
-0.695220, -1.522710, 0.011740, -0.766660, -1.855450, 0.133040, -0.740480, 0.154260, -0.815170, -0.808030, 
-0.067350, 0.540550, -0.147420, 0.009570, 0.769950, -0.168890, -0.133650, -0.036990, -0.005120, -1.368270, 
0.301490, -0.014360, 0.111500, -0.778950, -0.374250, -0.215810, 0.421790, -0.200250, 0.196950, -0.800670, 
0.287120, -0.468330, 0.404100, 0.744160, 0.658640, 0.326820, -0.023050, 0.046730, 0.184180, 0.052000, 
-0.373400, -0.115390, 0.504340, 0.756600, 0.155680, -0.273290, 0.703820, -0.392670, 0.295260, 0.126580, 
-0.672680, 0.096210, -0.097130, -0.767910, 0.549960, 0.732270, 0.887740, 0.249180, 0.377270, 0.207290, 
0.103630, -0.485040, -0.766040, -0.178200, -0.184520, 0.583980, -0.553410, -0.780030, -0.349330, -0.245000, 
0.342740, 0.284180, -0.941770, 0.304020, 0.255750, 0.151350, 0.473930, 0.501100, -0.683260, 0.232430, 
0.404780, 0.205350, -0.922570, -0.421070, -0.289530, -0.515990, -0.144910, -0.031730, -0.450130, -0.539720, 
-0.227070, -0.102450, 0.088020, -0.284260, 0.022180, -0.586860, 0.169110, 0.532580, 0.613120, -0.088300, 
0.212860, 0.378930, 0.219400, -0.424940, 0.409550, -0.242060, 0.262100, -0.519060, 0.259490, 0.289410, 
0.528670, -0.141550, 0.199020, -0.442360, 0.290440, -0.152280, -0.146230, 1.098000, 0.244390, 0.556650, 
-0.241840, -0.725510, 0.181720, 0.231640, -0.301720, 0.326720, 0.195020, 0.280440, 0.278300, 0.289730, 
-0.309570, 0.223090, 0.213200, 0.174020, -0.259310, -0.308550, 0.562790, -0.387670, -0.185120, 0.240220, 
0.378660, 0.390030, -0.084040, -0.033980, 0.224150, -0.294860, -0.099910, -0.036490, -0.810490, -0.204130, 
-0.043420, -0.672140, -0.672150, 0.213860, -0.239280, 0.207610, -0.528360, 0.105680, 0.355810, -0.039340, 
0.249270, 0.363640, 0.283060, 0.075880, 0.015760, 0.190040, -0.258480, 0.134040, -0.485690, 0.080200, 
-0.142540, 0.304310, -0.557590, -0.216280, 0.542800, -0.295640, -0.247210, -0.399520, -0.105880, -0.244570, 
-0.452770, 0.204790, 0.322350, 0.420920, 0.118130, -0.495680, 0.143910, 
0.134970, 0.306410, 0.393000, 0.442260, 0.251120, 0.321840, 0.228900, 0.294650, 0.256030, 0.363260, 
-0.129500, 0.067870, 0.152510, -0.048690, -0.008560, -0.260080, 0.235200, 0.429710, -0.096170, 0.266020, 
0.176210, 0.027610, 0.101280, 0.546110, 0.110440, -0.209040, 0.330380, -0.096140, 0.552150, 0.297810, 
-0.061650, 0.200760, 0.291890, -0.451670, 0.301210, 0.332070, 0.049520, 0.197160, 0.343450, 0.204100, 
0.023700, 0.141590, -0.119790, -0.094690, -0.068840, -0.292070, -0.084520, -0.015870, 0.432790, -0.018040, 
-0.100760, 0.021620, 0.059720, -0.614680, 0.308860, 0.241180, 0.717660, 0.029780, -0.134300, -0.248100, 
-0.134260, 0.230820, 0.139210, -0.152690, -0.122420, 0.378700, 0.512930, 0.119230, 0.089960, 0.293440, 
-0.333800, 0.476190, 0.233110, 0.271710, -0.124440, 0.428820, -0.069930, 0.003170, -0.373100, -0.169520, 
-0.364390, -0.210000, 0.260630, 0.143250, 0.067750, -0.516300, -0.072690, 0.405370, -0.345110, 0.358700, 
0.349150, 0.373290, 0.057370, 0.516060, 0.002100, 0.094970, 0.088790, -0.138550, -0.263270, -0.395500, 
-0.238320, 0.885630, -0.121430, 0.033180, 0.122360, 0.277990, 0.037370, 0.476630, 0.388130, 0.013550, 
0.090860, 0.302450, 0.398750, 0.156890, 0.488590, 0.186940, 0.232390, 0.286680, 0.111180, 0.466460, 
0.345990, 0.629870, 0.690620, 0.133200, 0.194950, 0.150570, 0.032480, 0.348530, 1.107040, 0.352210, 
0.412480, -0.421430, -0.543140, 0.401180, 0.439970, -0.325430, -0.193000, 0.231880, -0.011840, 0.362660, 
0.442780, 0.193160, 0.423560, 0.544850, 0.291470, -0.438260, 0.145340, -0.109480, -0.035720, 0.716250, 
-0.517660, -0.086710, -0.640550, -0.734770, 0.561540, -0.044580, 0.024030, 0.313000, -0.491130, -0.380070, 
-0.205040, 0.851340, -0.079990, -0.561570, 0.329410, -0.578320, -0.041230, 0.140880, -0.206300, -0.217330, 
-0.275970, -0.613290, -0.561880, -0.148460, -0.217610, -0.243980, 0.257490, 0.351810, 1.083530, 0.054350, 
0.234730, 0.229730, 0.414880, -0.266710, 0.292850, 0.452830, -0.337760, 0.510530, 0.007660, -0.221470, 
-0.011740, 0.693300, 0.278810, -0.412360, -0.152110, -0.371760, 0.146330, -0.382810, -0.067000, 0.194030, 
-0.457200, -0.144810, 0.076650, 0.374390, 0.344350, 0.593560, 0.187450, -0.143100, -0.443450, 0.041050, 
-0.139770, -0.624940, 0.252890, 0.259450, -0.182890, -0.075670, -0.173630, 0.025040, -0.210080, -0.296590, 
0.223400, -0.062370, -0.144160, -0.380930, 1.207400, 0.261580, 0.832140, 0.272510, -0.357490, -0.498290, 
0.064510, 0.093690, -0.252900, -0.195520, 0.602170, -0.109130, 0.047030, 0.968020, -0.415620, 0.010070, 
-0.235390, 0.391900, 0.058900, -0.032950, 0.005540, 0.389070, 0.080800, 0.589170, -0.287880, -0.236620, 
0.104760, 0.078190, 0.211310, 0.316560, 0.596200, 0.759270, 0.192580, 0.105480, 0.537450, -0.160060, 
0.303740, 0.388370, 0.086690, 0.093840, -0.165150, -0.541970, -0.286520, -0.001690, 0.444350, -0.240610, 
-0.185870, 0.013560, 0.056040, 0.713590, 0.937030, 0.379760, 0.466120, -0.079080, 0.286960, 0.082110, 
-0.297480, -0.082050, 0.145110, -0.098870, -0.430750, -0.092070, 0.140480, -0.243420, -0.100830, 0.313750, 
0.428790, -0.277050, -0.017230, 0.054490, 0.739530, 0.130440, -0.210050, -0.166670, 0.259300, -0.267070, 
-0.215030, 0.008960, -0.137800, 0.269470, 0.317060, -0.004290, -0.073900, -0.089240, 0.502300, -0.303280, 
-0.086150, 0.153040, -0.454190, 0.403940, 0.036030, 0.430010, -0.157820, 0.247040, 0.372340, -0.543470, 
0.754990, 0.358940, 0.192280, 0.412030, -0.214610, -0.260540, 0.658100, 0.073400, 0.363870, 0.238200, 
0.205210, -0.333790, -0.115470, 0.571210, -0.138370, 0.026010, 0.282510, -0.108360, -0.095810, 0.323740, 
-0.291640, 0.102450, 0.217690, -0.764410, -0.475060, -0.055010, 0.669320, -0.257400, 0.134380, -0.436430, 
0.501170, -0.299530, 0.236520, -0.397070, -0.522670, 0.264950, 0.056470, 
0.029530, -0.129710, 0.158990, 0.157280, -0.038800, 0.135310, 0.204150, -0.253550, 0.384150, -0.078790, 
0.324900, -0.235590, -0.134260, -0.197700, -0.289940, 0.199400, 0.417450, 0.078060, 0.124300, -0.201550, 
-0.099430, 0.113970, -0.046710, -0.441620, 0.044700, 0.077310, 0.010050, -0.122250, -0.560180, 0.135300, 
0.495400, 0.142620, -0.495400, 0.390580, -0.302110, -0.187780, -0.045310, 0.493070, -0.297320, -0.459670, 
0.242190, -0.084350, -0.027250, 0.878040, 0.054120, -0.146770, 0.281700, 0.210780, -0.407500, -0.348500, 
-0.114760, 0.225440, 0.003180, 0.460880, 0.236880, -0.432290, 0.381600, -0.062470, -0.076600, -0.207440, 
0.025800, -0.094670, -0.031840, 0.958810, 0.398350, -0.061580, 0.581170, 0.256790, 0.608510, 1.382360, 
-0.207740, -0.116750, -0.281050, 0.010620, 0.905910, 0.030250, -0.265720, 0.049560, 0.109060, -0.211790, 
0.319880, 0.266870, -0.350210, 0.003610, 0.911810, -0.056770, -0.376550, 0.300340, -0.381930, 0.354740, 
0.429650, -0.523120, -0.260640, 0.474490, 0.686050, 0.025330, 0.051440, -0.007200, -0.270230, 0.099950, 
0.037200, 0.029520, -0.072340, -0.104820, 0.018590, 0.755760, -0.292640, -0.307130, -0.756110, -0.019450, 
-0.649620, -0.600390, -0.376130, -0.005020, 0.608530, 1.201280, -0.602820, 0.275530, 0.312660, -0.342620, 
0.272830, 0.317020, 0.481740, -0.259380, 0.077960, 0.051740, 0.341730, 0.935020, 0.654930, 0.258480, 
0.871880, 1.073870, 0.689900, 0.071370, -0.023870, 0.154080, 0.503030, 0.924560, 0.362150, 0.223610, 
0.003810, -0.227340, -0.515510, 1.058280, 0.805280, -0.296750, 0.056250, 1.155420, 1.204140, 0.740540, 
0.991130, 0.084780, 0.733300, 1.046390, -0.397870, 0.396210, 0.032460, 0.913620, 1.004960, 0.359350, 
0.118610, -0.349230, -0.031800, -0.389870, -0.053360, 0.561580, 0.061320, -0.014590, 0.950540, -0.472640, 
-0.577990, -0.574780, 0.212630, 0.331890, 0.163140, -0.172660, 0.072510, 0.314540, 1.129550, -0.657290, 
0.058310, 0.316430, -0.849610, -0.223340, 0.123750, 0.704540, 0.292060, -0.545420, -0.008320, 0.671650, 
0.057500, 0.125860, -0.760350, 0.753630, -0.522610, -1.016360, 0.269370, 0.262790, 0.550080, 0.620580, 
-0.062090, 0.467010, 0.845580, -0.714190, -0.202440, 0.109690, 0.274550, 0.009850, 0.359110, -0.020610, 
0.193140, 0.920340, 0.935740, 0.195400, -0.045530, 0.718910, 0.745520, 0.501480, -0.096050, 0.018030, 
-0.107710, 0.899670, 0.082440, -0.296920, 0.578260, 0.323020, 0.074950, 1.164620, 0.189500, -0.243590, 
-0.073230, 0.893170, 0.152910, 0.189790, 0.268060, 0.365820, 0.065490, 0.595410, 0.387330, -0.153610, 
0.051690, 0.244130, 0.619070, -0.178860, -0.103230, -0.142050, -0.431150, -0.106000, 0.082730, 0.674110, 
-0.397170, -0.121030, 0.174150, -0.460130, -0.104950, -0.847130, 0.463270, -0.493820, -0.863790, -0.282710, 
-0.226890, 0.665450, 0.883120, -0.382380, 0.099270, 0.238240, -0.396390, -0.293620, -0.650140, -0.374710, 
-0.102500, -0.068980, -0.101260, -0.830370, -0.132850, 0.265210, -0.104380, -0.381010, 0.107420, -0.467750, 
-0.035530, 0.457410, -0.382360, 0.473390, 0.277650, -0.162070, -0.403540, 0.138480, -0.219270, -0.385580, 
0.006960, -0.060660, -0.092980, -0.137040, -0.444690, 0.551090, 0.414470, 0.100570, -0.380460, 0.136760, 
0.216560, 0.050660, -0.057980, 0.470430, 0.097930, 0.058160, 0.621830, 0.052660, -0.361010, -0.012090, 
0.331630, 0.075360, -0.325960, 0.110750, -0.119020, 0.434280, -0.205480, 0.457780, 0.392670, 0.548360, 
-0.154930, -0.327300, -0.178290, -0.470670, 0.630050, 0.450630, 0.444690, 0.042220, 0.091720, 0.445340, 
-0.128360, -0.220370, -0.444610, 0.168700, 0.237410, -0.090840, 0.265390, -0.450980, -0.258100, 0.132250, 
0.371550, 0.140820, -0.289570, 0.359740, 0.007260, 0.260600, 0.201100, -0.202220, -0.065910, 0.146940, 
-0.227980, -0.092680, -0.078640, -0.037590, 0.171280, -0.149180, -0.121060, 
-0.316250, 0.164010, 0.095030, -0.251260, -0.100760, 0.238510, -0.157760, 0.082370, 0.147620, 0.185090, 
-0.005620, -0.174650, 0.207770, -0.124670, 0.023770, -0.343410, -0.329540, 0.316110, 0.168030, 0.084320, 
0.035340, -0.090680, -0.377290, 0.212520, 0.266140, 0.201270, 0.176140, 0.171190, 0.316780, 0.438630, 
-0.102710, -0.401880, -0.269270, -0.014250, 0.038640, -0.427700, 0.072570, -0.102430, -0.327330, -0.010410, 
-0.108010, 0.011070, 0.223850, -0.129090, -0.222550, -0.160690, 0.325210, -0.135450, 0.042050, -0.159930, 
-0.301790, 0.358140, 0.319440, -0.318210, 0.081980, 0.491470, -0.099650, -0.019600, 0.094930, 0.114410, 
-0.388700, 0.240040, 0.040590, 0.201530, -0.148660, -0.051380, -0.000970, 0.130940, -0.148690, -0.043170, 
0.235150, 0.115780, -0.144580, 0.070030, -0.048870, -0.150370, 0.111030, 0.006350, -0.155870, -0.342250, 
0.114960, 0.094800, 0.143140, 0.068550, -0.031300, -0.137820, 0.109570, 0.665720, -0.033670, 0.299900, 
0.302750, 0.153150, 0.216670, -0.084310, 0.014600, -0.047750, -0.196480, 0.344370, -0.124600, 0.136450, 
-0.429310, -0.266940, -0.059440, -0.225630, 0.067200, 0.225740, 0.371080, 0.072420, 0.254930, 0.300620, 
-0.159520, -0.088460, -0.372460, 0.009180, 0.165440, -0.033670, -0.021790, 0.063210, 0.253210, 0.216140, 
0.036420, -0.155710, -0.101900, 0.011880, -0.052550, 0.071360, -0.287480, 0.224730, 0.142230, -0.009230, 
-0.171660, -0.239360, 0.021880, -0.186810, 0.525110, 0.097870, 0.554390, 0.092860, 0.125150, 0.509350, 
-0.363380, -0.090310, 0.088510, 0.175390, 0.649980, -0.077210, 0.059740, -0.112460, 0.024840, 0.499150, 
0.261370, -0.146450, 0.165800, -0.112490, 0.697250, 0.207610, -0.320270, -0.216550, 0.424480, 0.060690, 
-0.429130, 0.994530, 0.138860, -0.045110, 0.205170, 0.155920, -0.155680, 0.077080, -0.669380, 0.058010, 
0.533530, 0.048510, 0.163830, -0.167050, -0.422440, 0.723820, 0.275100, -0.059920, -0.002320, 0.002390, 
0.236780, 0.092600, 0.121320, -0.040670, -0.162310, 0.336020, 0.029100, -0.249600, 0.009430, -0.157690, 
0.071950, -0.160800, -0.023530, -0.248350, -0.070730, -0.292240, -0.010840, -0.316990, 0.107030, 0.189510, 
0.145640, 0.299900, 0.482780, 0.687880, -0.052820, -0.078130, 0.118680, 0.327600, 0.304560, 0.027980, 
-0.225850, 0.097680, 0.071800, -0.187380, 0.287080, -0.175420, -0.454390, -0.014000, 0.255700, -0.086000, 
0.002840, -0.139360, 0.057370, 0.416300, 0.462310, 0.138080, 0.265940, 0.178890, 0.251100, -0.066080, 
0.028860, -0.403010, 0.107940, -0.083660, -0.274630, -0.119510, -0.221590, -0.077530, 0.730990, -0.140500, 
-0.465290, -0.345070, 0.189160, -0.422880, -0.096870, 0.245180, 0.206640, 0.077370, -0.023360, -0.178910, 
-0.244420, 0.032980, -0.026920, -0.171010, -0.271330, -0.058080, 0.352240, -0.162890, -0.200200, 0.272460, 
-0.166310, -0.227490, -0.086440, -0.037270, -0.119690, -0.501870, 0.436780, -0.082920, 0.107090, -0.060280, 
-0.306680, -0.018450, 0.019110, -0.235770, -0.310120, 0.189910, 0.131720, 0.158330, 0.016890, 0.059940, 
0.059310, 0.279660, -0.070060, -0.211570, -0.320150, 0.093040, -0.040100, 0.101210, -0.023360, -0.063410, 
-0.194340, -0.186550, -0.035960, 0.012770, 0.134400, 0.048790, -0.158980, -0.429940, 0.010670, 0.066480, 
-0.203540, 0.042510, 0.325840, -0.050860, -0.233430, 0.028110, -0.080610, -0.302790, 0.641000, 0.049510, 
-0.093780, -0.021850, -0.157660, -0.029230, 0.013790, 0.114610, -0.405000, 0.415230, 0.420080, -0.048760, 
-0.248300, -0.056390, 0.110490, -0.074990, -0.042190, 0.149190, -0.353060, -0.063350, -0.083900, -0.398730, 
-0.041260, 0.304630, 0.094230, -0.092110, -0.080710, 0.008040, -0.259670, 0.646720, 0.190420, -0.145960, 
-0.259240, 0.067740, 0.144690, -0.212330, 0.048450, 0.073190, 0.021640, 0.236910, -0.019520, -0.017320, 
-0.065050, -0.155560, 0.088250, -0.195630, -0.123540, -0.067190, -0.002850, 
-0.147200, -0.310450, 0.166380, 0.728690, 0.110470, 0.142020, 0.448130, -0.438480, -0.114700, 0.031530, 
0.292600, -0.565680, 0.035720, 0.335350, -0.048240, -0.025280, -0.380590, -0.017050, -0.088450, -0.037790, 
0.106560, -0.069900, -0.079640, 0.384170, 0.167240, 0.069070, 0.674570, 0.179310, 0.642210, -0.038850, 
0.360630, -0.196650, -0.312120, 0.102770, 0.219280, 0.199470, -0.018440, -0.265110, 0.446780, 0.044870, 
0.232960, 0.112560, 0.606020, 0.246040, 0.231050, 0.261960, 0.251050, 0.433580, 0.676960, 0.413930, 
0.215120, 0.237010, 0.207890, 0.065180, 0.203080, 0.101430, -0.071080, 0.197650, -0.120640, -0.018860, 
0.209430, 0.120910, 0.127470, 0.719020, -0.042970, 0.047310, -0.069400, 0.103980, -0.044490, 0.187760, 
0.297040, 0.046320, 0.297260, 0.026610, -0.231180, -0.315140, 0.098090, 0.156580, -0.023670, -0.269870, 
0.193430, -0.304920, 0.135980, 0.128690, 0.731000, -0.108290, -0.129480, -0.384810, 0.586380, -0.202480, 
0.086510, 0.297820, 0.053320, -0.069980, 1.029780, -0.013360, 0.183690, 0.205770, 0.350860, 0.257700, 
0.000640, 0.611410, -0.139090, -0.237690, 0.183590, 0.360590, 0.197010, 0.146750, 0.500720, 0.114770, 
-0.089930, 0.578250, 0.273700, 0.198160, 0.044950, 0.325070, 0.591510, 0.091610, 0.407730, -0.471740, 
-0.089310, 0.058950, 0.029500, 0.515110, 0.003340, 0.148930, 0.409180, 0.232610, -0.160620, 0.454190, 
0.028750, 0.625460, 0.750940, -0.005020, 0.286160, 0.981550, 0.342500, 0.755190, 0.365700, 0.308920, 
0.216880, 0.138790, 0.260720, -0.118950, 0.326640, 0.341470, 0.174040, 0.680180, -0.224600, -0.193950, 
0.079680, 0.607510, 0.037760, 0.354170, 0.108440, 0.358600, 0.446840, 0.690490, 0.436710, 0.247550, 
0.512910, 0.516250, -0.362260, -0.250310, 0.338840, 0.599080, 0.636160, 0.163230, -0.089080, -0.340550, 
-0.405580, 0.115570, -0.001780, 0.015940, -0.537700, 0.572440, -0.135080, -0.112740, 0.044470, -0.075020, 
-0.168210, -0.421030, 2.498100, -0.366630, -0.083910, -0.087230, -0.749910, 0.076310, -0.001830, -0.766760, 
-0.532560, 0.294770, 0.182000, 0.160090, -0.098980, -0.125730, 0.309950, 0.579930, 0.176530, 0.042710, 
-0.112900, -0.047250, 0.263350, 0.601830, -0.315000, -0.191600, 0.119760, -0.255830, 0.129450, 0.010010, 
-0.343700, 0.166240, 0.040140, -0.233500, -0.068950, -0.402530, -0.318210, -0.142150, -0.155940, 0.112410, 
-0.112660, 0.107750, -0.352790, 0.405700, 0.896150, -0.410270, -0.059560, -0.085650, 0.246690, 0.538670, 
0.010200, -0.382690, -0.052570, -0.141540, -0.206640, -0.020050, -0.195180, -0.252870, 0.343980, 0.036930, 
0.405060, 0.135520, -0.274590, -0.153320, 0.133390, 0.195480, -0.216240, 0.201090, -0.359870, -0.050780, 
0.290520, 0.009970, -0.256140, 0.373600, 0.064040, -0.378470, -0.198020, -0.053670, 0.136920, 0.212220, 
-0.174060, 0.274400, 0.229130, 0.089090, 0.308360, 0.035120, -0.355110, 0.353990, 0.329660, -0.010890, 
-0.128240, 0.456500, 0.016450, -0.288810, -0.422330, -0.579350, 0.001090, -0.113150, -0.325680, -0.439110, 
-0.225670, -0.004160, -0.147930, -0.113200, -0.178400, -0.166660, -0.587280, -0.736110, -0.515870, -0.391180, 
-0.498350, -0.488720, 0.023000, 0.005830, -0.324980, -0.168770, -0.147890, 0.386400, -0.427190, 0.157500, 
0.304060, -0.052900, -0.334870, 0.243250, 0.200760, -0.146220, -0.015680, 0.035580, -0.052980, 0.367980, 
0.321950, 0.045050, 0.127880, 0.389670, 0.018220, -0.216680, 0.186770, -0.390090, -0.074340, 0.470640, 
-0.019200, 0.006550, -0.416540, -0.441890, 0.475710, -0.206800, 0.156910, -0.623370, -0.471070, -0.245060, 
-0.158080, -0.142630, -0.168060, -0.064650, 0.519220, 0.015130, 0.218270, 0.006490, -0.224060, 0.216200, 
0.535890, 0.135130, -0.283830, -0.240300, -0.274030, 0.320890, 0.162950, -0.246370, -0.122560, -0.069320, 
-0.247770, 0.028360, -0.402850, 0.125810, 0.492020, 0.105930, 0.033410, 
-0.062610, 0.011400, 0.087890, 0.128610, 0.178230, 0.183970, -0.025510, 0.112910, 0.120490, -0.609500, 
-0.440780, -0.007920, 0.088000, -0.305150, -0.093210, -0.065030, -0.585360, 0.167410, -0.003020, -0.314650, 
-0.019350, 0.105200, -0.179370, -0.115060, 0.105420, 0.000750, -0.109440, 0.192910, 0.167210, 0.049520, 
0.067960, -0.455150, -0.117250, 0.140000, 0.086620, -0.210780, -0.593910, -0.104400, 0.211170, -0.381720, 
-0.259640, -0.012630, -0.144780, -0.355080, -0.243730, 0.095130, 0.210730, -0.233820, -0.169790, -0.047780, 
-0.351640, 0.061540, -0.112850, -0.062060, 0.569170, -0.198470, -0.041060, -0.120930, -0.103730, 1.003600, 
-0.569620, -0.086860, 0.019700, -0.131600, 0.335540, 0.353320, 0.285740, -0.227630, 0.225890, 0.163200, 
-0.190480, 0.294330, -0.059390, -0.274840, 0.086870, 0.128060, 0.543910, 0.014390, -0.145770, -0.118600, 
0.102950, -0.005980, -0.235870, 0.024430, -0.296020, 0.449970, 0.381430, 0.500770, -0.168920, 0.070730, 
0.507040, -0.067150, 0.378190, 0.120280, -0.295790, 0.247870, -0.092600, -0.189460, 0.341400, -0.147950, 
-0.176420, -0.115190, 0.002630, -0.305880, 0.017870, -0.288240, 0.090660, -0.160930, 0.267570, 0.547390, 
-0.210470, -0.152020, 0.020240, -0.265330, -0.443410, -0.111780, -0.060480, -0.214070, 0.354780, 0.449360, 
0.103500, 0.484610, 0.743420, -0.057420, -0.377240, 0.022800, -0.318150, -0.116990, 0.560270, 1.109030, 
0.437560, -0.384060, 0.176750, 0.546600, 0.418150, 0.089880, 0.287350, 0.094680, -0.064990, -0.076580, 
0.921670, -0.001000, -0.044350, -0.684550, 0.313090, -0.247170, 0.035060, -0.434120, 0.456220, 0.051350, 
0.143610, 0.181590, -0.103810, -0.597280, 0.016580, -0.074640, -0.141660, 0.898040, -0.074580, -0.126570, 
0.293240, 0.240840, -0.368930, -0.009380, -0.128670, -0.099670, -0.401300, 0.056010, -0.223200, -0.291460, 
0.524420, 0.945250, -0.071050, -0.177470, -0.356840, 0.898840, 0.360720, -0.473970, -0.040870, -0.111920, 
0.245810, -0.107080, 1.661450, 0.300110, 0.216310, -0.576800, -0.150470, -0.669760, -0.002420, -0.574520, 
0.456440, -0.118310, -0.229510, 0.031320, 0.113750, -0.462340, 0.089610, 0.503340, 0.072430, 0.144370, 
0.263930, 0.181190, -0.393520, 1.972080, -0.378650, -0.211420, -0.213560, -0.041640, -0.294830, 0.045880, 
-0.226950, 0.272090, 0.008910, 0.106740, 0.580290, -0.611530, -0.279960, 0.575850, -0.447020, 0.069050, 
-0.088970, -0.186190, -0.268660, -0.258550, 0.540260, -0.335140, -0.549790, -0.058760, -0.367050, -0.058590, 
0.039540, -0.687090, 0.510320, 0.133420, 0.633260, 0.568730, 0.091360, 0.275050, -0.452990, -0.205660, 
0.007410, 0.276280, 0.041840, 0.278900, -0.212270, -0.181090, -0.194310, 0.029900, 0.224850, -0.015500, 
0.226850, 0.032920, -0.104550, -0.540100, -0.030720, 0.376060, 0.130950, -0.283680, -0.006900, 0.018260, 
0.076430, 0.176170, -0.298650, -0.942900, -0.456310, -0.052020, 0.364260, -0.270050, -0.072440, -0.205940, 
-0.039550, -0.034430, 0.049460, -0.039230, 0.093950, 0.160790, -0.113410, 0.616250, 0.199670, 0.058190, 
-0.259690, 0.377680, 0.233510, 0.114100, -0.284280, -0.310700, -0.645920, -0.096600, -0.346250, -0.568190, 
-0.449800, -0.086760, -0.160740, 0.044400, 0.003280, -0.067650, 0.727220, -0.101430, 0.315740, 0.388670, 
0.156860, -0.108580, 0.218180, -0.111210, 0.199910, 0.039580, 0.256520, -0.320020, 0.827530, -0.004920, 
-0.232970, -0.284020, -0.449400, -0.380140, 0.034730, 0.041540, 0.413690, 0.470240, 0.213200, 0.399210, 
0.258100, -0.295930, -0.283150, 0.445350, 0.020170, 0.516170, 0.478010, -0.238390, 0.157270, -0.660180, 
0.092780, -0.219990, -0.003740, 0.645060, -0.202060, 0.028500, 0.040940, 0.029010, 0.301130, 0.186380, 
-0.053180, -0.074100, 0.262460, -0.064170, 0.008120, -0.255300, -0.101850, -0.145600, -0.286200, -0.064280, 
0.178710, -0.179950, -0.065180, -0.493160, 0.120350, -0.182810, 0.028560, 
-0.520920, 0.132890, -0.084890, 0.286940, 0.119830, 0.672820, -0.008890, -0.125940, -0.250960, -0.161340, 
0.325470, 0.144890, 0.003860, 0.230900, -0.152420, 0.233560, -0.004940, 0.527700, 0.417300, -0.190840, 
-0.103740, -0.225580, -0.102750, 0.439470, 0.587720, -0.337130, 0.124720, -0.137230, 0.517130, 0.372230, 
0.311970, -0.079470, 0.408160, 0.304620, 0.642140, 0.164090, 0.286500, 0.141310, 0.647050, 0.151200, 
0.392200, -0.123300, -0.593630, -0.317060, -0.115550, 0.214680, 0.536180, 0.002750, 0.157550, 0.832470, 
0.008640, 0.082910, 0.093090, -0.157780, -0.080480, -0.251410, -0.045680, -0.272460, 0.086020, 0.502120, 
-0.165960, 0.234430, -0.149060, -0.574690, -0.237940, -0.169430, 0.165640, 0.252530, 0.321020, -0.248450, 
0.228550, -0.157310, -0.140590, -0.541940, -0.404850, -0.563110, 0.239470, 0.505160, -0.094010, 0.178110, 
0.184400, -0.476590, -0.206240, -0.161940, -0.117110, -0.211350, -0.040310, 0.172350, 0.831820, -0.048610, 
-0.373140, -0.283500, -0.259210, -0.091330, -0.053350, -0.215420, -0.182580, 0.211860, 0.476730, 0.055960, 
0.352240, -0.261350, -0.641730, 0.509440, -0.152440, -1.060400, 0.097630, 0.291410, -0.093810, -0.178690, 
0.360020, -0.181830, -0.265200, -0.309840, -0.053030, -0.776070, 0.055480, -0.598660, -0.100210, 0.211860, 
0.134060, 0.772760, 0.071010, -0.008230, -0.077870, -0.072950, 0.744710, -1.044060, -0.652920, -0.802550, 
1.083230, -0.759220, -0.861860, 0.441750, -0.287330, 0.690420, -0.162700, -0.894970, 0.516450, 0.788400, 
-0.500190, -0.548130, -0.051830, 0.732280, -0.127970, 1.045950, -0.043670, -0.504600, 0.571590, -0.485470, 
-0.565830, -0.074740, 0.600260, 1.671270, -0.751480, 0.248900, 0.581440, -0.210020, 0.662160, 0.311250, 
-0.128430, -0.741310, 0.562140, 1.135780, 0.714870, 0.059710, 0.614320, -0.024290, 0.071140, -0.499570, 
-0.615550, -0.720550, 0.167780, -0.248880, -0.565130, 0.115980, -0.430180, 1.299900, 0.183320, -0.747720, 
0.244450, 0.578280, -0.376720, -0.417710, -0.516970, -0.392700, 0.015250, 1.626380, 0.006180, -0.875780, 
0.639460, 0.524450, 0.905420, 0.546670, 0.095100, 0.493270, 0.027140, 0.604610, 0.056470, -0.310490, 
1.054520, 0.058530, -0.043270, -0.178710, 0.432430, 0.452860, -0.516200, 0.477220, 0.038690, -0.013590, 
-0.143900, -0.102840, 0.105490, 0.261910, 0.189380, -0.218560, -0.060200, 0.667560, 0.052100, 0.254020, 
-0.215520, 0.391460, -0.386170, 0.263480, 0.619670, -0.014560, -0.349070, 0.365040, 0.329150, 0.325810, 
0.026180, -0.618010, 0.466150, -0.042540, 0.603660, -0.106820, 0.270190, 0.213220, 0.786100, -0.209630, 
0.114840, -0.352920, 0.554230, 0.409600, 0.112080, 0.132860, 0.649910, 0.782240, 0.220860, -0.365210, 
0.098580, 0.064660, -0.172230, -0.067660, 0.182450, 0.313900, 0.261880, -0.194650, 0.215490, 0.414340, 
0.373730, 0.020510, -0.198710, 0.078040, -0.137860, 0.267780, 0.310010, 0.802840, 0.085750, 0.146990, 
-0.105100, -0.040780, 0.110910, -0.030670, 0.161060, 0.044090, 0.264950, -0.078080, -0.262950, -0.135740, 
0.315010, 0.141220, 0.051760, -0.011820, 0.191690, 0.460670, -0.334890, -0.063540, -0.525150, -0.180680, 
0.397090, 0.198270, 0.438350, 0.081620, 0.259650, 0.209180, 0.678600, -0.005920, -0.044020, 0.091270, 
0.040980, 0.251600, 0.218160, 0.057880, -0.316900, 0.738330, 0.216550, 0.174550, -0.373400, -0.084470, 
0.450500, 0.213560, 0.364490, 0.262170, 0.077470, -0.096620, 0.468650, -0.000660, -0.143780, -0.033140, 
0.101040, -0.042740, 0.079910, -0.670810, -0.018080, -0.064060, -0.024120, -0.040540, 0.056300, -0.050420, 
-0.193620, 0.183440, 0.451650, -0.412110, -0.114920, 0.044820, 0.018560, 0.387820, -0.464380, 0.019950, 
0.202630, 0.246230, 0.155260, 0.241910, 0.111490, 0.346360, 0.138380, -0.197690, 0.109530, 0.371290, 
0.786530, -0.068310, -0.159970, 0.511380, 0.042620, 0.001270, 0.046770, 
-0.015920, -0.279140, 0.169290, -0.151100, 0.321830, 0.278800, -0.054710, 0.730950, 0.173670, 0.514440, 
-0.093310, 0.134050, 0.413570, -0.000440, 0.303300, 0.034990, 0.032360, 0.410480, -0.217290, 0.431550, 
0.075450, -0.180930, 0.077610, 0.365920, 0.102700, 0.447730, 0.198170, 0.039120, 0.515780, -0.075020, 
-0.182260, 0.354360, 0.017640, -0.246230, 0.256470, -0.212160, -0.126290, -0.079840, -0.766510, -0.648580, 
-0.083950, 0.068640, 0.238230, 0.481450, -0.117160, -0.674950, 1.007400, -0.064220, -0.168280, 0.401720, 
0.112540, 0.239020, -0.307860, -0.253490, -0.145850, -0.280810, 0.025820, 0.206980, -0.141510, 0.688570, 
0.122400, 0.475420, 0.105650, -0.417030, -0.063140, -0.682170, 0.002770, -0.352040, 0.304800, 0.533460, 
-0.013430, 0.173780, 0.018540, -0.048610, 0.330520, -0.413020, 0.475050, 0.669730, -0.094970, -0.085290, 
-0.284000, -0.110240, -0.031800, 0.085860, -0.174320, 0.293910, 0.269390, -0.116820, -0.135960, 0.024590, 
0.113230, -0.438060, -0.414210, 0.376080, 0.190320, -0.128750, 0.332810, 0.164470, -0.197960, -0.084430, 
-0.512540, -0.065560, -0.386580, 0.114790, 0.092650, 0.165810, -0.122570, -0.132460, 0.358530, -0.201780, 
0.183880, 0.057240, -0.327580, -0.126800, 0.055870, 0.581440, -0.020240, 0.161470, 0.007230, 0.357170, 
0.012310, -0.262720, 0.550900, -0.017350, -0.040600, 0.090870, 0.095800, 0.447590, 0.009800, 0.349050, 
0.189210, 0.253390, -0.622270, -0.598370, -0.313040, 0.138840, 0.937450, 0.461130, 0.367210, 0.561310, 
0.715630, -0.179000, 0.112530, 0.813900, 0.792710, -0.080910, 0.143420, -0.255990, 0.113350, 1.263750, 
1.515200, 0.232190, 0.339560, 0.181880, 1.776070, 0.381290, -0.028960, -0.043170, 0.120210, 0.147920, 
0.228410, -0.385150, 0.049080, 0.109930, 0.530750, -0.279120, -0.336590, 0.136990, 0.169280, 0.198360, 
-0.130390, -0.033120, -0.008730, 0.079280, 0.001590, -0.367460, 0.342450, 0.001040, 0.281120, -0.203830, 
0.272220, 0.314720, 0.048790, -0.066490, 0.136330, 0.322100, -0.259390, 0.106140, -0.009080, -0.765010, 
0.763690, 0.481670, 0.860630, 0.493780, -0.255580, -0.486400, 0.962670, 0.235750, -0.409630, -0.375680, 
0.410950, -0.223930, -0.136620, 0.863130, 0.040850, 0.709280, -0.415370, -0.135160, -0.349010, 0.032200, 
-0.213240, 0.412390, 0.289410, -0.636920, -0.150060, 0.076410, -0.081480, 0.753760, 0.370580, -0.024530, 
0.518710, 0.389450, 0.108310, -0.093360, 0.042590, -0.104040, -0.629040, -0.100610, 0.240370, 0.322920, 
0.038920, -0.728430, -0.023160, 0.237420, -0.575490, 0.213000, -0.341080, -0.362320, 0.245000, -0.432550, 
-0.183770, -0.027550, 0.652840, -0.063350, 0.504940, 0.458510, 0.163290, 0.313250, 0.203380, 0.501230, 
0.417420, -0.002200, 0.001980, -0.209760, -0.416590, -0.011300, -0.090440, -0.249240, -0.003170, -0.436100, 
-0.317400, 0.042670, -0.352770, 0.056390, 0.196110, -0.190680, -0.515730, 0.200250, 0.137680, 0.157670, 
0.220850, 0.295050, 0.026340, -0.245590, 0.810140, 0.157790, -0.709570, 0.062380, -0.003740, 0.127980, 
-0.102520, -0.607980, 0.324630, 0.408920, 0.005880, 0.145470, 0.376030, -0.132260, 0.299780, 0.747160, 
0.007170, -0.437800, 0.457690, 0.018330, -0.438480, -0.028210, -0.453240, -0.278160, -0.287080, -0.040280, 
-0.023660, -0.195210, 0.242260, 0.478140, -0.338690, -0.177520, -0.473460, -0.084480, 0.205600, -0.237550, 
-0.163450, 0.219870, -0.229660, 0.376680, 0.008320, -0.930590, 0.645060, 0.423470, 0.207960, 0.147470, 
0.409370, -0.327770, 0.299140, -0.495750, -0.134570, 0.066470, 0.141410, -0.380320, -0.129480, -0.290770, 
-0.427870, 0.026540, 0.030430, -0.016310, -0.530820, 0.004680, -0.278000, -0.085480, -0.413310, 0.069550, 
0.025530, -0.661770, -0.388920, 0.098260, -0.607360, 0.110640, -0.122500, 0.190820, -0.506540, 0.176170, 
-0.349390, -0.330860, -0.201520, 0.035340, -0.165700, -0.054300, 0.008700, 
0.315860, -0.010850, 0.291160, 0.157230, 0.244180, 0.615650, 0.475530, 0.105210, 0.376810, -0.402700, 
-0.257970, -0.436480, 0.135250, -0.100210, 0.531850, 0.090950, -0.052380, 0.455930, -0.112630, -0.512960, 
0.135590, 0.030750, -0.071510, 0.261700, -0.121620, 0.093000, -0.183980, 0.050640, -0.239660, -0.201400, 
0.089970, 0.290800, 0.016710, 0.273460, 0.578040, -0.231770, -0.168190, -0.260290, 0.477660, 0.415550, 
0.099920, 0.168330, 0.288430, 0.187540, 0.091440, 0.317440, 0.653900, 0.319360, 0.175750, 0.543750, 
0.409890, -0.093620, 0.126620, 0.007400, -0.063080, -0.081330, -0.251900, -0.167540, 0.279390, 0.416410, 
0.326170, -0.152090, 0.182850, 0.305410, 0.528580, -0.186210, 0.597090, 0.217750, 0.074860, 0.215320, 
-0.056020, -0.072130, -0.527130, -0.079670, 0.324790, -0.195940, -0.250490, 0.246470, 0.084480, -0.103780, 
0.166280, -0.198210, 0.064640, 0.167330, 0.405560, -0.104880, 0.319350, 0.466880, -0.189430, -0.076370, 
0.456330, -0.060550, 0.258510, 0.114100, -0.091860, -0.028180, 0.074650, 0.062310, 0.622100, 0.252410, 
-0.006240, 0.142320, -0.157720, -0.017040, 0.105740, 0.164310, -0.130230, -0.011660, -0.302970, 0.184350, 
-0.341890, -0.196510, -0.199600, 0.094480, 0.283510, 0.366350, -0.112670, -0.094330, 0.282440, 0.683460, 
-0.294850, -0.566710, 0.047190, -0.052410, -0.026990, 0.100390, 0.068510, -0.288350, 0.295480, 0.148070, 
0.870370, -0.147530, -0.085600, 0.042690, -0.103890, -0.174520, -0.074180, 0.145880, -0.088270, 0.112370, 
0.215110, 0.193790, 0.003500, 0.074160, 0.030890, 0.022790, 0.128410, 0.170330, 0.197490, 0.469440, 
0.365120, 0.136330, 0.037490, 0.007390, 0.658420, 0.499000, 0.267450, 0.241480, 0.290840, 0.089540, 
-0.230540, 0.554630, -0.001740, -0.130990, 0.311510, -0.058160, -0.328260, 0.116530, -0.441580, -0.199690, 
0.267100, 0.085180, -0.214850, -0.373870, -0.510300, 0.324040, 0.085110, 0.071370, 0.051870, -0.107950, 
0.357120, 0.151920, 1.271040, -0.539200, -0.739480, 0.234320, 0.213920, -0.358040, -0.000070, -0.257400, 
-0.377970, 0.170180, 0.201990, -0.163470, -0.406140, -0.430990, 0.322980, 0.143130, 0.123190, 0.294270, 
-0.268830, 0.425510, 0.230100, 0.257960, 0.003510, 0.047930, 0.244560, -0.086130, 0.155550, 0.020830, 
-0.384740, 0.024600, 0.278520, 0.724000, -0.395620, -0.160240, 0.104570, 0.270850, 0.045830, 0.387610, 
0.016480, -0.115490, 0.116290, 0.184250, -0.603640, 0.043430, -0.072740, -0.124120, 0.122790, 0.246910, 
0.037470, -0.064030, -0.243230, 0.047690, -0.247780, 0.072970, -0.372340, 0.305110, 0.527140, 0.246650, 
-0.238010, 0.023310, 0.063040, -0.239250, 0.047860, 0.948750, -0.018900, 0.562920, -0.375610, -0.269050, 
0.030830, 0.021350, -0.076180, 0.081680, 0.697740, 0.407710, -0.077120, 0.149350, 0.466130, -0.359490, 
-0.030540, -0.058000, -0.245930, -0.066020, -0.236520, -0.225340, 0.471790, -0.274180, 0.033170, 0.281490, 
0.051600, -0.183680, 0.026650, 0.133270, 0.162930, 0.244400, 0.168380, -0.160650, 0.290560, 0.256830, 
-0.072500, 0.447710, 0.174190, -0.115460, -0.335310, -0.360330, -0.248030, 0.617250, 0.144670, -0.011210, 
-0.531480, 0.175210, -0.071630, 0.034150, 0.161930, 0.299840, -0.563080, -0.010940, -0.199890, 0.166760, 
-0.024810, -0.297940, -0.032130, -0.017050, 0.452350, 0.051830, -0.025920, -0.113160, -0.051230, 0.043410, 
0.142880, -0.145460, 0.348080, -0.194560, 0.034930, -0.199330, 0.116940, 0.034880, 0.706770, -0.424560, 
0.438570, 0.017960, 0.076350, -0.086460, 0.088440, 0.026550, 0.135660, 0.240020, 0.071760, 0.076880, 
-0.106720, 0.066370, -0.424720, -0.143310, -0.241920, 0.021770, -0.147910, 0.451770, 0.538130, 0.229160, 
-0.060430, 0.323990, 0.476320, -0.487680, 0.471400, -0.304600, -0.163010, 0.218040, 0.040970, 0.133010, 
0.076790, -0.200420, 0.115110, -0.417220, 0.639680, -0.487660, 0.050150, 
0.334070, 0.034540, 0.158820, 0.065420, -0.175340, 0.575220, 0.406680, 0.525640, 0.437800, -0.148350, 
0.599130, -0.215400, 0.457820, 0.008270, 0.105860, 0.279660, 0.069840, -0.004080, 0.379580, 0.160230, 
0.050670, 0.299990, -0.154500, 0.147620, 0.029670, -0.334050, -0.080790, 0.263500, 0.059420, -0.127260, 
-0.791680, -0.308740, -0.186780, 0.165430, -0.352970, 0.409240, -0.030010, 0.071550, 0.241130, 0.176320, 
-0.332450, 0.033930, 0.831670, -0.172940, -0.311620, -0.057630, 0.979680, -0.048230, -0.423920, 0.215100, 
0.013660, -0.233940, 0.058850, -0.121890, -0.177560, -0.240570, -0.054240, 0.212870, 0.030050, -0.329670, 
-0.460580, -0.098690, 0.037630, 0.447540, 0.376230, 0.572090, 0.542020, -0.031740, -0.210090, 0.107510, 
0.407990, 0.548260, -0.377060, 0.191810, 0.350040, -0.003690, -0.137320, -0.073980, 0.058730, 0.184960, 
0.413420, 0.307810, 0.057750, 0.053060, 0.382730, 0.382650, 0.674220, 0.182240, 0.419450, 0.296560, 
0.440860, 0.619630, 0.501950, -0.410950, -0.081890, 0.590920, -0.303090, -0.020270, -0.155020, 0.333250, 
0.997810, 0.371140, 0.176700, -0.051780, 0.051020, 0.283930, 0.000150, 0.114080, 0.543520, -0.120360, 
0.188840, 0.498570, 0.942000, 0.348010, -0.063980, 0.012630, 0.017770, 0.422520, 0.386250, 0.939430, 
0.071660, -0.410280, 0.290320, 0.128040, 0.076790, 0.056020, -0.243850, 0.385500, 0.565010, 0.983670, 
-0.359030, 0.173520, 0.085960, 1.279330, -0.274270, 0.408850, 0.471240, 0.111350, 0.014330, 0.291440, 
0.098500, 0.165170, -0.320400, 1.078960, -0.026650, 0.079910, 0.056300, -0.021570, -0.162870, -0.278210, 
-0.414060, -0.026660, -0.416980, -0.092880, 0.040000, -0.204090, 0.755200, 0.860920, 0.122550, -0.054490, 
0.087860, 0.494830, -0.483820, -0.079040, -0.571170, 0.157260, 0.666510, 0.106680, -0.444260, 0.197050, 
0.351710, 1.822510, 0.088780, -0.260140, -0.078940, -0.480450, -0.222900, 0.405390, -0.189400, 0.272290, 
-0.289980, -0.053490, 1.318020, 0.646840, 0.768970, -0.169400, 0.130350, 0.080690, -0.007590, -0.453870, 
0.099460, -0.025770, -0.367220, 0.604830, -0.147780, -0.006260, 0.310440, 0.147200, 0.036520, 0.505820, 
-0.050900, -0.706390, 0.432120, -0.021230, -0.046810, -0.195560, 0.696150, -0.298290, -0.363130, 0.017070, 
0.330750, -0.349090, -0.306910, 0.395270, 0.132970, -0.058070, 0.349310, -0.252470, -0.003410, 0.333620, 
0.232020, 0.380780, -0.055630, 0.181100, 0.146460, 0.274130, 0.156300, -0.175890, -0.302290, 0.435260, 
0.029570, -0.283550, 0.517810, -0.364790, 0.450790, -0.419170, -0.062020, 0.594450, -0.734350, 0.915480, 
0.500150, 0.178440, 0.631070, -0.006070, -0.202280, -0.320620, 0.300400, 0.525600, -0.022680, 0.181170, 
0.462540, 0.028880, 0.141230, 0.195970, -0.477620, -0.344000, 0.220240, -0.131290, -0.273830, -0.950600, 
-0.260730, 0.467930, 0.063570, -0.093500, -0.300920, 0.837120, -0.678150, -0.344680, -0.522420, 0.102830, 
-0.061910, 0.334520, 0.011040, -0.055350, 0.027030, -0.266290, 0.169910, -0.233220, -0.361710, -0.017190, 
-0.245160, -0.091220, 0.160450, 0.151530, 0.418420, 0.608650, 0.156290, -0.616990, -0.220790, -0.358700, 
-0.566380, -0.079470, 0.443900, 0.000500, 0.300200, -0.086620, -0.485770, -0.071220, 0.626260, -0.122060, 
-0.147740, -0.115360, 0.292910, 0.557440, -0.275810, 0.154170, 0.206230, 0.659840, -0.019520, 0.164200, 
-0.553020, -0.070990, 0.056930, 0.483180, 0.002070, -0.102310, 0.024040, -0.407140, 0.466380, 0.492630, 
-0.063580, -0.060870, -0.325370, -0.242230, 0.358960, 0.087330, -0.155980, 0.270510, -0.254780, -0.292550, 
0.039650, -0.133330, -0.195470, -0.247240, 0.498550, -0.010200, 0.555130, -0.221040, -0.072560, 0.286050, 
0.126680, 0.132500, 0.142160, -0.077360, 0.272260, 0.361880, -0.053030, -0.277900, -0.266480, 0.137400, 
-0.018650, 0.317560, 0.306990, 0.162800, -0.346470, 0.373270, -0.032130, 
-0.083350, 0.120430, 0.312030, 0.526480, 0.711710, 0.171140, -0.120620, 1.117200, 0.422240, 0.020430, 
0.449930, 0.050020, -0.304020, -0.020850, -0.049370, 0.106410, -0.358510, 0.204630, 0.222780, -0.375500, 
0.005340, -0.301800, 0.887740, 0.237110, 0.630220, 0.370900, 0.427560, 0.610450, 1.062690, 0.403060, 
-0.182030, 0.313660, 0.342560, -0.105720, -0.184150, 0.296420, 0.303690, 0.373310, 0.027330, -0.194930, 
0.083900, -0.040000, -0.576180, -0.071060, 0.131120, -0.085590, 0.482070, 0.027850, -0.092620, 0.850940, 
0.251470, 0.051860, 0.104130, 0.508110, -0.389090, -0.055140, 0.205190, 0.262970, 0.935440, -0.029940, 
0.036110, 0.462000, -0.098700, -0.861600, -0.203360, 0.088240, -0.199960, 0.440370, -0.031980, -0.411480, 
0.769420, 0.512230, 0.525640, 0.195900, 0.705250, -0.267000, -0.417890, 0.590050, -0.210260, 0.265570, 
-0.330290, 0.043450, 0.668740, -0.100520, -0.624660, 0.294300, -0.065570, -0.409230, -0.036850, -0.408410, 
-0.462090, 0.484020, 0.311880, 0.637470, -0.237660, 0.241920, -0.177950, -0.359420, -0.234340, -0.106520, 
0.065630, -0.127430, -0.053570, 0.967570, -0.087080, -0.463750, 0.054160, -0.765160, -0.902760, 0.218760, 
-0.248390, -0.128070, 0.330270, -0.338950, 0.821360, -0.410300, -0.093110, -0.308250, 0.193320, 0.149840, 
-0.495780, -0.314260, -0.727960, 0.205630, 1.053050, -0.116200, -0.442890, 0.187750, -0.488540, -0.307610, 
-0.426950, 0.290050, 0.456580, 0.070680, 0.021470, 1.164050, -0.227410, -0.059540, -0.319550, -0.204230, 
-0.451790, 0.207560, 0.801870, -0.059440, -0.072790, 1.264620, -0.088490, -0.281980, 0.588230, -0.834790, 
-0.795310, -0.409350, -0.168050, 0.119870, 0.471600, -0.315150, 0.764740, -0.452600, -0.251830, -0.239890, 
0.213080, -0.757840, 0.203520, 0.125120, -0.166820, 0.132620, 1.706380, -0.059170, -0.523720, 0.128010, 
-0.645890, -0.439380, -0.118800, -0.229990, 0.214930, -0.020610, 0.147310, 0.597800, -0.657660, 0.166670, 
-0.132030, 0.222520, -0.094280, 0.061060, 0.040460, 0.039100, -0.221790, 1.235900, 0.006660, -0.520210, 
-0.106410, -0.178590, -0.228740, 0.550110, -0.152400, -0.102060, -0.045400, -0.031980, -0.028090, -0.650210, 
0.392400, -0.023890, 0.124290, 0.276400, 0.202700, -0.059120, -0.001080, 0.413870, 0.558340, -0.023970, 
-0.452980, -0.192820, -0.179930, -0.102300, 0.522720, -0.019240, -0.124620, -0.025480, -0.305850, 0.176810, 
-0.682710, -0.448690, -0.249880, -0.020090, 0.473720, 0.110110, 0.478370, 0.191210, -0.144580, 0.482170, 
-0.007470, -0.314050, -0.323860, -0.135620, 0.699100, 0.420280, -0.012150, 0.078380, 1.082130, -0.065970, 
-0.425440, -0.835630, 0.574300, -0.593370, -0.181930, 0.164370, 0.484760, 0.551560, 0.153140, 0.320630, 
0.200300, 0.021880, -0.297610, 0.073860, 0.135140, 0.492330, 0.170380, -0.146390, -0.097220, 0.986010, 
-0.165760, 0.182130, -0.403910, 0.333970, -0.036400, -0.433960, 0.175610, 0.383570, 0.422430, 0.443230, 
-0.546660, 0.660050, 0.067850, -0.349380, -0.397900, 0.550960, 0.387730, 0.058900, 0.247300, 0.283000, 
1.007230, 0.044140, 0.149000, -0.483970, 0.152160, -0.121660, 0.176260, 0.478910, 0.568910, 0.657620, 
0.377410, -0.336460, 0.379560, 0.045600, -0.173580, -0.115730, 0.009220, 0.214560, -0.328480, 0.130320, 
0.470570, 0.515150, 0.000490, 0.020830, 0.065100, 0.541320, -0.157790, 0.312190, -0.497550, -0.187740, 
-0.395180, 0.543690, 0.361210, 0.012080, 0.021670, -0.298490, 0.152840, 0.101490, -0.019590, -0.039090, 
0.159040, 0.271620, 0.274010, 0.190120, -0.163500, -0.481090, 0.598670, -0.062030, 0.213920, -0.411960, 
0.262280, 0.537420, 0.111140, -0.032130, 0.056310, 0.030440, -0.465440, -0.202640, -0.181860, 0.215660, 
0.040690, 0.241590, 0.689290, 0.021310, -0.063710, 0.185420, -0.243120, 0.002840, -0.083590, 0.027140, 
-0.398180, -0.012290, 0.521960, -0.329380, -0.084350, 0.544270, 0.020620, 
0.423240, -0.090290, -0.070630, 0.287150, 0.284990, 0.208890, 0.195330, 0.354750, 0.168910, -0.468280, 
-0.047690, -0.245440, -0.661310, 0.117990, 0.256790, 0.172500, -0.363930, -0.063410, 0.239750, 0.076460, 
-0.026230, 0.294360, 0.401100, -0.180350, 0.294220, -0.003800, 0.326960, 0.165800, -0.124110, 0.090000, 
0.185300, 0.366210, 0.158180, 0.134420, 0.037800, 0.235130, -0.141550, 0.163040, 0.001970, 0.413620, 
0.221360, -0.022010, -0.199780, 0.322100, 0.003000, 0.310730, 0.005720, 0.297370, -0.207630, 0.287280, 
-0.123230, 0.121530, 0.618290, 0.226120, 0.000560, -0.205070, -0.780220, 0.162940, 0.237120, 0.029020, 
0.068690, 0.141070, -0.055380, -0.526050, 0.039880, -0.031800, -0.201310, 0.154620, 0.210230, 0.177150, 
0.449530, 0.303830, 0.213500, -0.162120, 0.424350, -0.001630, 0.269270, 0.279320, 0.183500, 0.360070, 
0.565470, 0.365560, -0.169180, -0.059540, 0.100720, -0.130640, 0.274610, 0.106570, 0.604840, 0.044760, 
0.220650, -0.079820, -0.150290, 0.110820, -0.061490, -0.155810, 0.102030, 0.256220, -0.096500, 0.348200, 
0.787580, -0.108730, -0.136520, -0.062880, -0.069800, -0.227450, 0.340940, 0.295630, -0.000340, -0.071400, 
0.227030, 0.032890, 0.352120, 0.417460, -0.084230, -0.196960, -0.145660, -0.272250, -0.391470, -0.314310, 
0.504370, 0.424890, -0.394920, -0.141610, -0.144950, -0.066670, 0.240410, 0.127430, -0.388940, -0.221450, 
0.466150, -0.131620, 0.345600, -0.998700, 0.018810, 0.044980, -0.104860, 0.203930, 0.065700, 0.066960, 
-0.065720, 0.131470, -0.071040, 0.586360, 0.418140, 0.271780, -0.079410, 0.548030, 0.215160, -0.612880, 
-0.816280, -0.096630, 0.190220, 0.188640, -0.485460, -0.240930, 0.978880, 0.344700, 0.208900, 0.077460, 
0.109450, -1.633260, 0.323090, 0.035800, 0.096750, 0.101040, 0.287850, -0.065040, 0.560560, -0.092480, 
-0.465470, -0.334320, 0.321060, -0.025330, 0.388730, -0.285240, -0.110100, 0.469700, -0.228520, -0.058820, 
-0.170860, 0.106140, -1.919100, -0.124330, -0.087690, 0.363550, -0.063770, 0.320120, -0.009440, 0.793550, 
-0.114770, -0.006680, -0.845500, 0.417330, 0.072970, 0.083670, -0.772530, 0.493400, 0.637280, 0.577790, 
-0.410090, 0.530590, -0.024410, -1.601690, -0.126620, -0.472990, 0.173220, 0.167910, -0.086660, -0.074610, 
0.381020, 0.357060, 0.211380, -0.110510, 0.078180, 0.318160, 0.399920, 0.105820, 0.222750, -0.182800, 
0.057530, 0.254710, 0.042270, -0.391330, -0.972380, -0.002820, 0.136450, -0.595720, -0.379170, -0.069610, 
-0.027840, 0.339280, 0.120370, 0.069960, 0.276460, -0.066750, 0.167700, -0.164500, 0.032650, -0.027420, 
0.351660, 0.364630, 0.222280, -0.062340, -0.307470, -0.529570, 0.380410, 0.128580, 0.122290, -0.784230, 
0.086520, -0.055410, -0.136610, -0.226740, 0.193710, -0.326650, -0.093830, -0.249680, -0.561310, 0.465630, 
-0.210800, -0.052660, 0.048050, -0.114640, 0.110120, 0.219190, 0.054220, -0.087160, -0.269050, 0.387840, 
-0.028420, -0.205950, -0.063590, 0.377500, 0.031400, 0.116820, 0.141690, 0.289950, -0.060800, -0.345870, 
0.779420, -0.164300, -0.215440, -0.314720, 0.058970, -0.045940, -0.361790, -0.296330, 0.090190, 0.414810, 
-0.712020, -0.506700, -0.007350, -0.081640, -0.444490, 0.034950, 0.746940, 0.534930, 0.063160, 0.133770, 
0.103430, 0.750070, 0.092350, -0.814020, -0.688650, -0.113830, -0.573990, 0.381980, 0.065410, 0.341590, 
-0.003080, 0.483520, 0.202770, -0.431570, -0.065760, -0.537560, -0.348030, 0.466630, 0.219790, -0.240960, 
0.228390, 0.085570, 0.019350, -0.415150, 0.201530, 0.105650, -0.262690, 0.191360, 0.155980, -0.437780, 
0.215830, 0.109630, -0.109250, -0.049270, 0.338760, -0.061320, -0.400720, -0.203480, 0.458460, -0.103260, 
0.689600, -0.114170, -0.479480, -0.215330, -0.089210, -0.118460, -0.103660, -0.714820, -0.064270, -0.128970, 
0.178680, -0.067230, 0.031360, -0.181530, -0.384530, -0.318750, -0.068260, 
0.028480, 0.092560, -0.135970, -0.147580, 0.029400, 0.297630, -0.107430, 0.131130, -0.055350, 0.215880, 
0.030220, 0.405010, 0.142270, 0.331270, 0.527840, 0.253840, 0.205600, 0.137990, 0.434130, 0.484730, 
0.136280, -0.262550, 0.212110, -0.261060, -0.324980, 0.185770, 0.047110, -0.051070, 0.189130, 0.316320, 
-0.364760, 0.011470, 0.227600, 0.131230, -0.018370, 0.450890, 0.109780, 0.164830, -0.452220, -0.185670, 
0.007970, 0.109110, -0.290910, -0.182020, -0.305710, -0.087970, -0.042030, 0.079900, -0.235500, 0.103980, 
0.642210, 0.246280, -0.133750, -0.186940, 0.280420, 0.002470, 0.499330, -0.069010, -0.068910, -0.111340, 
-0.496570, 0.261630, 0.094010, -0.449210, 0.180720, -0.210960, -0.112430, -0.004650, -0.123220, -0.001950, 
0.348960, -0.102360, 0.051660, -0.323780, -0.007030, -0.327610, -0.545180, 0.472890, -0.075800, 0.017180, 
-0.075260, -0.459500, 0.080340, 0.086830, -0.259110, 0.428900, 0.253700, -0.403640, 0.270450, -0.186300, 
0.000230, 0.265900, -0.262560, 0.429450, -0.426440, -0.146400, 0.152800, -0.206770, 0.399090, 0.187210, 
0.152870, 0.361250, -0.292280, 0.418760, 0.077680, -0.251820, 0.084750, -0.341340, -0.393700, 0.316230, 
-0.802340, -0.184760, 0.353250, -0.219520, -0.077700, -0.235720, -0.222390, 0.080880, 0.064730, -0.092160, 
0.013730, 0.201010, 0.289130, 0.015380, 0.198720, 0.113270, -0.047660, -0.134600, 0.073630, -0.455990, 
0.642970, -0.064450, -0.277210, 0.065190, 0.210250, 0.411750, -0.315000, -0.373600, 0.291790, 0.045980, 
0.482910, -0.035240, 0.438950, 0.046220, 0.594560, 0.721380, 0.076920, -0.415110, 0.100480, -0.189960, 
-0.342980, 0.375630, -0.182010, -0.161580, -0.016910, -0.144370, 0.459130, -0.049990, 0.002540, 0.103860, 
0.282170, 0.261530, 0.125650, 0.250040, 0.206070, 0.062740, 0.272010, 0.070500, -0.205390, 0.170030, 
0.020510, 0.211870, 0.636360, -0.267950, -0.438120, -0.168360, -0.386470, -0.017250, -0.243980, -0.219540, 
0.228680, -0.440370, 0.339780, 0.469200, 0.835020, -0.141730, -0.189010, 0.334900, -0.006560, -0.905290, 
0.239490, 0.244910, 0.741220, 0.315850, 0.011300, -0.161460, 0.852460, -0.115330, -0.840350, -0.545540, 
0.393400, -0.228560, -0.296800, 1.378940, 0.714030, 0.954530, -0.056310, 0.027950, -0.326940, 0.049230, 
-0.168560, -0.125980, 0.188550, 0.079080, -0.372360, -0.183890, -0.005560, 0.728650, 0.336740, -0.353180, 
-0.461650, 0.079510, -0.462240, -0.116270, 0.908800, 0.374420, 0.182270, -0.235320, -0.177070, -0.115070, 
0.066100, -0.365190, 0.159040, 0.054200, 0.803700, -0.269130, -0.170030, 0.475980, 0.846390, 0.482200, 
-0.877610, -0.634670, 0.024350, -0.443390, -0.471840, 0.616160, 0.482770, 0.211380, 0.292130, 0.088590, 
-0.378140, 0.085310, -0.122080, -0.307840, -0.327360, 0.038510, 0.311460, 0.404290, 0.356620, -0.543140, 
0.376790, -0.403540, -0.080790, -0.275090, 0.039760, -0.110500, 0.370890, 0.062330, 0.028920, 0.113240, 
0.090860, -0.383230, 0.103860, -0.057060, 0.272140, 0.127800, -0.243660, -0.215770, 0.200150, -0.175030, 
0.098360, 0.056290, -0.141620, 0.101820, 0.075420, 0.090840, 0.294920, -0.593790, -0.074960, 0.100190, 
0.068240, 0.211200, -0.119700, 0.072880, 0.013720, 0.135950, -0.233000, -0.120010, -0.040960, 0.506690, 
0.305900, -0.306120, 0.268630, -0.057330, -0.050590, 0.566030, 0.272440, -0.356380, -0.164560, -0.045730, 
0.268860, -0.576760, -0.287470, -0.076030, 0.064550, 0.103790, -0.322720, -0.508660, -0.383940, 0.326940, 
0.015600, -0.112350, -0.443380, -0.182470, -0.025610, 0.045380, -0.587460, 0.609450, -0.324110, 0.099990, 
0.163990, 0.039570, -0.025110, -0.411360, -0.337890, 0.047940, -0.257290, -0.124510, -0.125030, -0.452180, 
0.612580, 0.268520, -0.252120, -0.030420, 0.054740, 0.125700, -0.055500, 0.049390, 0.065290, -0.163790, 
0.060060, 0.084950, 0.145460, -0.175420, 0.261130, 0.395350, 0.044210, 
0.125160, -0.277990, -0.140240, -0.420410, -0.231540, -0.181850, -0.137070, 0.104120, -0.059890, -0.253670, 
-0.252070, -0.042900, 0.074210, -0.016520, 0.323520, -0.055660, -0.122270, -0.290300, 0.126260, 0.492360, 
0.009810, -0.148080, 0.164140, 0.069090, 0.081620, 0.280400, -0.001390, -0.050900, -0.259380, 0.319160, 
-0.396130, -0.509720, -0.225770, -0.001420, -0.504370, 0.172970, 0.172300, -0.058800, 0.100830, 0.165340, 
-0.439680, -0.003180, -0.131790, 0.222610, -0.337250, 0.060280, -0.355280, 0.044810, -0.186720, -0.111830, 
0.230980, -0.016960, 0.139100, 0.136980, -0.208350, -0.362110, 0.210990, 0.090570, 0.041530, -0.026030, 
-0.186760, -0.157170, 0.012910, -0.413570, 0.267250, 0.301200, 0.259130, -0.102510, 0.060230, 0.197140, 
0.112320, 0.468170, -0.025560, 0.114580, -0.060980, -0.068470, 0.340940, 0.016930, 0.011050, -0.002680, 
0.045690, 0.152280, -0.036520, 0.015190, 0.196970, 0.035210, -0.177970, -0.174340, 0.180880, 0.070280, 
-0.036810, 0.102600, -0.350340, 0.311420, -0.008150, -0.089820, -0.042800, 0.008640, -0.007420, -0.018020, 
-0.121440, -0.183740, 0.201240, 0.044200, 0.011410, 0.208370, 0.190840, -0.243090, 0.222820, -0.020790, 
-0.083280, 0.271930, 0.508450, -0.156550, 0.030240, 0.033280, 0.256280, -0.072200, -0.200850, 0.067820, 
0.447700, -0.197730, -0.423920, -0.211990, 0.014550, 0.025190, -0.170720, -0.207740, -0.185350, -0.016960, 
0.045920, -0.122410, 0.178250, 0.052380, -0.218830, 0.066020, 0.176390, -0.030020, -0.013180, 0.142470, 
0.149750, 0.224110, -0.131350, 0.104000, -0.302740, 0.014270, 0.020370, 0.134160, -0.009570, -0.448800, 
-0.294830, -0.193110, 0.118240, 0.132290, 0.037440, -0.349650, -0.347940, -0.080430, 0.064740, -0.018460, 
-0.012070, 0.166820, 0.291100, 0.010850, -0.311170, 0.044880, 0.297780, 0.004680, 0.218170, 0.266070, 
-0.171450, -0.227910, 0.520540, 0.439490, -0.054980, -0.027470, -0.004320, -0.104510, -0.000850, -0.237640, 
0.309030, 0.063470, 0.318210, 0.008130, -0.003010, -0.222340, -0.299450, -0.216900, -0.002880, -0.050880, 
0.158040, 0.054280, 0.356670, 1.035560, -0.249270, 0.654460, -0.163060, 0.152570, 0.098970, 0.221640, 
0.301960, 0.014070, -0.156260, -0.027040, -0.345180, 0.158350, 0.135070, 0.063330, 0.244590, 0.197020, 
0.082180, 0.650570, 0.226360, 0.065530, 0.144530, 0.217580, 0.220190, 0.010830, 0.091980, 0.261820, 
0.210950, 0.299950, 0.051420, -0.335600, 0.426060, -0.043860, 0.309460, 0.169150, 0.208680, 0.020180, 
0.288330, 0.033190, 0.793840, 0.074070, 0.097910, 0.414550, 0.238300, 0.297580, -0.123930, 0.265410, 
0.072530, 0.473040, 0.071290, 0.374190, 0.439760, 0.350250, 0.066770, 0.121900, 0.128470, 0.265080, 
-0.183000, 0.271320, 0.560060, 0.332630, 0.346150, 0.366970, 0.408610, 0.311250, 0.033750, 0.454680, 
0.370290, 0.267310, 0.176720, 0.055460, 0.108660, 0.276780, 0.188800, 0.263740, 0.184830, 0.123710, 
0.176040, 0.161340, 0.303120, 0.296800, 0.167960, 0.052280, 0.387330, 0.575940, 0.145160, 0.097630, 
0.260330, 0.015910, 0.131270, 0.119640, 0.108190, 0.053720, 0.190410, 0.217200, 0.180160, 0.138850, 
0.252590, 0.327840, 0.083100, 0.301580, 0.177350, 0.408660, 0.083840, 0.154690, 0.463430, 0.093800, 
0.119390, 0.245180, 0.443360, 0.377050, 0.245800, -0.006580, 0.204160, 0.315410, 0.221320, 0.092550, 
-0.022680, 0.548830, 0.183610, 0.102700, 0.280830, -0.032480, 0.352240, 0.162030, 0.234860, 0.083460, 
0.133590, 0.314500, 0.203530, 0.477520, 0.354570, 0.235420, 0.175760, 0.176200, 0.588230, -0.149360, 
-0.058240, 0.045330, 0.449900, 0.415270, -0.018000, 0.250670, 0.236080, 0.085510, -0.003150, 0.076190, 
0.043530, 0.471020, 0.143350, 0.228070, 0.046710, 0.240330, 0.433250, 0.179980, 0.247280, 0.031600, 
0.038360, -0.043710, -0.002380, 0.149550, 0.268200, 0.222830, 0.238970, 
0.154850, -0.116950, -0.167410, -0.592150, -0.223710, 0.221810, -0.182010, -0.337370, 0.226430, -0.029440, 
0.319950, 0.092740, 0.527850, -0.386120, 0.327010, 0.093530, 0.145240, -0.047380, -0.018600, 0.332690, 
0.005020, -0.084800, -0.087210, -0.357390, -0.079350, 0.101950, -0.115780, 0.193870, -0.354800, -0.699770, 
-0.113010, -0.315930, -0.000880, 0.038430, -0.199640, 0.327070, -0.347370, 0.285460, -0.060130, -0.190210, 
0.624500, 0.012750, -0.350340, 0.122190, -0.230880, 0.337110, 0.258040, 0.219350, -0.032000, -0.262190, 
-0.187340, -0.259030, 0.147340, 0.429350, -0.362730, 0.047760, -0.363760, -0.082840, 0.468500, -0.226810, 
-0.312900, -0.280490, 0.013020, -0.179240, 0.334100, 0.188080, 0.425430, -0.121130, 0.572160, 0.317050, 
0.023150, 0.234110, 0.094510, -0.116060, 0.157690, -0.529170, -0.029120, 0.299410, 0.247540, 0.347760, 
0.124630, 0.122220, 0.269610, 0.027900, -0.167380, 0.064390, 0.107020, -0.378310, 0.105120, 0.222410, 
-0.171370, 0.026190, -0.145210, 0.175450, 0.512020, 0.022650, -0.095320, -0.099240, 0.028990, 0.131120, 
-0.217170, -0.104610, 0.063640, -0.248800, 0.032110, -0.180010, 0.074850, -0.738490, -0.457200, 0.727380, 
-0.140390, -0.207270, -0.291260, -0.238350, -0.799640, 0.041170, 0.237520, -0.095190, -0.159190, 0.381900, 
-0.163250, -0.199010, 0.428500, -0.444310, -0.233430, 0.015660, 0.047730, -0.196200, 0.013460, -0.041110, 
0.324820, 0.332070, 0.376620, -0.148720, -0.277900, 0.294380, 0.263380, 0.485300, 0.225110, -0.122180, 
0.060000, 0.079420, -0.022160, -0.179260, -0.023550, 0.412570, 0.009690, -0.230790, -0.571460, -0.232510, 
-0.226060, 0.458990, 0.054010, 0.040670, 0.218100, -0.343440, -0.439080, 0.040250, -0.008060, -0.058300, 
-0.081710, 0.275070, -0.155260, -0.641330, -0.143580, -0.182670, -0.424350, 0.009050, 0.238910, 0.078190, 
-0.009710, -0.173240, 0.372140, 0.557620, -0.019190, 0.117660, 0.058440, -0.065760, 0.066600, 0.012640, 
0.341830, 0.250770, -0.071310, 0.057880, 0.005570, 0.003780, 0.038100, 0.236350, 0.001410, 0.166490, 
-0.101180, -0.194110, -0.139330, 0.418240, -0.224660, 0.294980, 0.673310, 0.006250, 0.061300, 0.273320, 
0.323900, -0.122330, -0.017840, 0.305150, -0.120170, 0.287870, 0.510930, 0.024130, 0.295380, 0.202130, 
-0.317770, -0.311230, -0.323500, -0.419610, 0.682350, -0.410520, -0.447160, -0.209150, -0.350640, 0.051070, 
0.666390, 0.131080, 0.063110, 0.238880, -0.013400, -0.249390, -0.175400, 0.407710, 0.584050, 0.058600, 
0.148170, 0.182720, -0.155790, -0.033780, 0.192280, -0.057610, 0.097470, 0.134880, 0.080280, -0.080810, 
0.226780, 0.223530, 0.138330, 0.283710, 0.046940, 0.505210, 0.171650, 0.145330, 0.067160, 0.009170, 
0.008370, 0.091970, -0.031580, -0.098170, 0.119860, -0.176490, 0.601380, 0.408040, 0.125210, 0.239560, 
0.027430, 0.249690, 0.333960, -0.065410, 0.083970, 0.197280, -0.173090, -0.042240, 0.178240, 0.255810, 
0.363600, 0.147760, 0.211510, 0.361950, 0.229870, 0.586060, 0.228310, 0.336490, 0.409600, 0.134020, 
0.355220, 0.371070, -0.157880, -0.180510, 0.696890, 0.130280, 0.178950, 0.514500, 0.301630, 0.067350, 
0.188670, 0.022960, -0.239660, 0.230650, 0.031520, 0.371220, 0.135100, 0.248950, 0.244490, 0.004520, 
0.406350, 0.376000, 0.233370, 0.314930, 0.221430, 0.339990, -0.039980, 0.502700, 0.131810, -0.051960, 
-0.106840, 0.445540, 0.367430, 0.136000, 0.210600, 0.232990, 0.135610, 0.642890, 0.054990, 0.035050, 
0.190500, 0.041040, 0.364360, 0.115910, 0.252940, 0.327320, -0.114000, 0.260650, 0.162390, 0.035770, 
0.013430, 0.037290, 0.390350, -0.002040, 0.135850, 0.259290, 0.270950, 0.330750, 0.530600, 0.022910, 
0.568300, -0.018840, -0.067840, 0.031580, 0.077170, 0.357830, 0.365640, 0.376480, -0.045100, 0.434540, 
0.407710, 0.060120, -0.165230, 0.637510, 0.350160, 0.088640, 0.237170, 
0.175610, 0.289510, 0.052610, -0.130300, 0.010650, -0.159690, 0.186010, -0.083620, -0.130800, -0.051680, 
-0.256520, 0.379520, -0.177020, 0.131450, 0.044140, 0.093270, 0.447130, 0.531690, -0.011940, 0.296990, 
0.049890, 0.158910, -0.244290, -0.027670, -0.319990, -0.381460, -0.007940, 0.430520, -0.496100, -0.124380, 
0.013760, 0.342250, 0.122860, 0.231590, 0.131640, 0.017290, 0.188580, -0.118880, 0.671220, 0.513820, 
0.269880, 0.061490, -0.183500, 0.279300, 0.148070, -0.566230, -0.711350, 0.306890, 0.256220, -0.081820, 
-0.282120, -0.034560, 0.473000, -0.119690, 0.338980, 0.259670, -0.240160, 0.521930, 0.176400, -0.177430, 
0.181150, 0.194980, 0.036340, -0.049350, 0.303460, 0.276090, 0.150070, -0.856830, 0.164450, 0.447230, 
0.007140, 0.072610, -0.173150, 0.233530, 0.017060, 0.673910, -0.032070, 0.252920, -0.539060, -0.394100, 
0.979910, -0.024390, -0.354100, 0.013480, -0.014520, 0.097300, 0.239370, 0.113970, 0.050860, 0.277680, 
-0.014940, 0.547290, 0.061860, -0.248030, 0.282380, 0.227070, 0.588300, -0.271170, 0.037640, 0.246160, 
0.440690, 0.341200, 0.122140, -0.442510, 0.031030, 0.095000, 0.102030, 0.492960, 0.160180, -0.117710, 
-0.253320, 0.277980, 1.369260, 0.461830, -0.378230, -0.406840, -0.251050, -0.222430, -0.055120, 0.223370, 
0.496340, 0.320140, 0.210960, 0.105610, -0.467650, 0.068100, 0.250610, 0.391360, 0.382770, 0.572610, 
-0.187070, 0.174420, 0.338530, 1.004920, 0.022280, -0.400840, 0.078160, -0.386380, 0.877600, -0.471510, 
0.220260, 0.276970, -0.130420, 0.073550, -0.370420, -0.436320, 0.052230, -0.021510, 0.014630, -0.432220, 
-0.414990, 0.768550, 0.028150, -0.217770, -0.148110, 0.008450, 0.021570, 0.044450, -0.290270, 0.078960, 
0.328790, -0.460540, -0.018260, 0.018620, -0.130640, -0.081280, -0.508230, 0.035730, -0.431710, -0.243210, 
-0.198450, 0.059990, -0.244640, 0.071470, -0.095480, -0.794530, -0.455830, -0.129990, 0.344430, -0.336460, 
0.230980, 0.170650, 0.922600, 0.030730, 0.171410, 0.411090, -0.103550, -0.122380, 0.007560, -0.502700, 
-0.766950, 0.377040, 0.625060, 0.097440, -0.194950, -0.208010, -0.116560, 0.019260, -0.194110, 0.473050, 
-0.557370, -0.172440, -0.032090, 1.432260, 0.520500, 0.411440, 0.061590, -0.272740, -0.317450, 0.080060, 
0.210940, -0.290120, -0.277650, 0.735370, 0.152990, -0.541930, 0.505610, -0.146330, -0.191860, 0.359150, 
0.302070, 0.014660, -0.234740, -0.169630, 1.256650, 0.138210, 0.261700, -0.087260, 0.253710, 0.290710, 
0.054140, 0.436910, 0.621900, -0.605730, 0.721270, -0.300070, 0.265840, 0.729130, -0.416590, 0.043070, 
-0.541120, -0.064050, 0.729270, -0.196790, -0.267240, 0.581880, 0.149120, 0.144150, 0.455600, 0.261890, 
-0.182690, 0.019660, 0.518430, 0.144280, -0.060630, 0.521010, 0.066330, 0.071280, 0.777660, -0.111000, 
0.137570, -0.360690, 0.237080, 0.714540, -0.292700, 0.215390, 0.244870, -0.014120, 0.503370, 0.042430, 
-0.101530, -0.298960, 0.040390, 0.561150, 0.275970, 0.224580, -0.369950, -0.207000, 0.015000, -0.115270, 
0.272320, -0.044080, 0.140880, 0.621450, 0.697980, 0.327590, -0.308590, 0.322200, -0.150890, -0.353680, 
-0.004340, -0.691090, -0.445510, 0.030220, 0.333390, 0.147030, 0.302040, 0.560190, 0.226770, 0.367370, 
0.113830, -0.521080, 0.025300, -0.272410, 0.045420, 0.460430, 0.371770, -0.026510, 0.332920, 0.168230, 
0.263800, 0.051030, -0.074540, -0.040330, 0.025270, 0.502150, 0.002180, -0.379150, -0.197470, -0.149580, 
0.417120, 0.188840, -0.526630, 0.244960, 0.122070, 0.552990, 0.328140, -0.001410, 0.533820, -0.159110, 
0.107110, -0.042640, -0.136740, 0.131450, 0.168760, 0.037220, 0.127130, 0.070280, -0.014530, -0.223730, 
-0.289860, 0.157210, -0.025410, -0.501200, 0.494340, 0.335900, 0.280460, -0.123800, 0.096700, 0.608230, 
-0.669540, -0.135760, -0.201460, 0.200960, 0.367040, 0.302900, 0.038070, 
-0.090510, 0.324470, 0.137120, -0.166420, 0.016710, -0.119490, 0.029960, -0.011770, 0.430740, -0.197150, 
0.086590, 0.535100, -0.174730, 0.626940, -0.234650, 0.341980, 0.132610, 0.758930, 0.719860, -0.283810, 
0.054330, 0.095030, 0.513940, -0.332760, 0.069540, 0.125100, 0.185060, -0.192880, 0.026640, -0.202250, 
0.076530, 0.041060, -0.080590, 0.310320, 0.094150, -0.071710, -0.315420, -0.090060, 0.456980, 0.137310, 
-0.187770, 0.038150, -0.008380, 0.052030, 0.088900, 0.293800, -0.040370, -0.223540, 0.149940, 0.284510, 
0.004500, 0.096210, -0.443240, -0.087720, -0.320840, -0.116940, 0.044430, -0.024050, -0.565000, -0.059340, 
-0.111790, -0.203810, 0.045010, 0.263260, 0.229660, 0.101650, 0.098710, -0.389220, 0.039810, 0.239830, 
-0.524910, 0.150350, 0.405270, -0.472590, -0.335000, -0.099450, -0.058600, -0.396370, -0.272130, -0.677350, 
0.162730, 0.279310, 0.422220, 0.048260, 0.239970, -0.556730, -0.544680, -0.463680, 0.463790, -0.504510, 
-0.087950, -0.533050, -0.112270, 0.107080, 0.782280, -0.192850, -0.292130, 0.475860, 0.381960, -0.107700, 
0.146870, 0.307030, 0.454950, -0.214430, 0.059850, 0.158950, 0.061450, 0.383810, 0.451010, 0.144240, 
0.214420, -0.164170, 0.347920, -0.482400, 0.001360, 0.297040, 0.251610, 0.332180, 0.028050, 0.301410, 
-0.020230, -0.592050, 0.399690, 0.102300, -0.260040, 0.074400, -0.570900, 0.020160, 0.251300, 0.515260, 
-0.800870, -0.045050, -0.111700, 0.048480, -0.124250, 0.148100, -0.003490, 0.296190, 0.100150, 0.342890, 
0.552930, -0.169570, -0.237640, -0.546880, 0.230960, -0.140840, 0.076650, -0.081910, -0.255470, 0.011040, 
0.213300, 0.650130, -0.149610, -0.245730, 0.023810, -0.101870, 0.137340, 0.393730, 0.062930, 0.249750, 
0.654960, 0.141340, -0.033070, -0.570000, 0.468490, 0.220370, -0.050950, 0.077170, 0.114560, 0.062790, 
0.375290, 0.514310, 0.463920, -0.342370, -0.427890, 0.963040, 0.277520, -0.876030, -0.365760, -0.113130, 
-0.440120, -0.110660, 0.828050, 0.438640, 0.168430, -0.735910, 0.212160, -0.268970, 0.006700, -0.040120, 
0.289630, 0.211100, 1.021550, 0.323460, -0.267370, 0.139480, 1.749930, -0.034230, -0.568270, -0.531380, 
0.327090, -0.222450, -0.378410, 1.671010, -0.070620, -0.445110, 0.310450, -0.192520, -0.351350, 0.049050, 
-0.749320, -0.086270, 0.173300, 0.310140, 0.343000, -0.240300, -0.022610, 0.354870, 0.655090, -0.275590, 
0.109880, 0.109880, -0.480800, -0.056090, 0.607890, -0.084800, -0.363680, 0.042230, -0.147920, -0.553820, 
0.038830, -0.389790, -0.097160, 0.005340, -0.033520, 0.678740, 0.002580, -0.396140, -0.201380, -0.120090, 
0.390290, 0.066330, -0.169360, -0.162820, -0.572570, 0.842160, -0.061710, 0.032510, -0.237940, -0.308940, 
0.354320, 0.022820, 0.268930, -0.157550, -0.224810, 0.123310, 0.155650, -0.419410, -0.321130, -0.501930, 
0.389140, 0.206570, 0.100860, -0.565170, -0.533620, -0.039410, 0.020240, 0.067720, -0.259950, -0.408520, 
-0.014670, 0.245680, 0.039990, 0.025510, 0.360280, -0.599840, -0.205190, 0.549270, 0.175980, -0.116440, 
-0.339180, -0.328060, 0.123870, 0.176900, -0.119120, 0.036090, 0.308960, 0.244580, -0.167600, -0.324770, 
0.183370, 0.473090, 0.019780, 0.055450, -0.693350, 0.005550, 0.104170, 0.550060, 0.638150, 0.033330, 
-0.230810, -0.409830, 0.071200, 0.013480, 0.025680, -0.203420, 0.253240, 0.463690, -0.429800, -0.429550, 
-0.317090, -0.319470, 0.155320, -0.172220, 0.028390, -0.109680, -0.580220, -0.044550, 0.057390, 0.561600, 
-0.066360, -0.248430, 0.316670, 0.167290, 0.375240, 0.103430, -0.550590, -0.076440, -0.180230, -0.251620, 
-0.031140, -0.101100, 0.115240, 0.159520, 0.347280, 0.039710, 0.203230, -0.176180, -0.275880, 0.522190, 
0.168450, -0.068010, 0.113680, -0.395350, -0.139650, 0.265550, 0.065470, -0.525260, -0.031510, 0.024820, 
-0.123790, -0.133050, -0.043530, -0.085650, 0.249980, 0.128320, 0.032170, 
0.239810, 0.014520, -0.070100, 0.128000, -0.100420, 0.040960, 0.202100, 0.294160, 0.203610, 0.423960, 
-0.057840, -0.197900, 0.322030, 0.101120, -0.091590, -0.257920, 0.323780, -0.129150, -0.332280, 0.604910, 
-0.065280, -0.376320, 0.046370, -0.129630, 0.192100, 0.166210, 0.051780, -0.007460, 0.567500, 0.778550, 
0.590740, 0.121810, -0.225650, -0.147770, 0.593630, -0.075060, -0.451450, -0.293160, 0.528370, 0.426320, 
-0.004810, -0.116550, 0.086990, -0.092120, 0.312700, 0.683560, -0.048770, 0.124520, -0.354520, 0.213150, 
-0.137210, -0.039770, -0.178060, 0.150240, -0.113250, 0.600350, 0.486820, 0.140850, 0.187680, 0.241940, 
-0.096340, -0.143990, -0.129880, -0.080570, 0.140290, -0.068170, 0.256370, 0.566710, 0.272180, -0.087410, 
0.535270, 0.123770, -0.115210, -0.096900, 0.036380, 0.170660, 0.107690, 0.528390, -0.000320, -0.368110, 
-0.059040, 0.116880, -0.000710, -0.103210, -1.157930, 0.167750, 0.879920, 0.406620, -0.169240, 0.494570, 
0.134690, 1.217320, 0.046720, -0.521450, -0.112550, 0.945600, 0.160720, -0.090690, 0.385130, 0.255310, 
0.159520, 0.957440, 0.266400, -0.147670, -0.084460, -0.504660, 0.185190, -0.406320, 0.035030, 0.204100, 
-0.267250, -0.822030, 0.308360, -0.318810, 0.443650, -0.417060, 0.090060, 0.024850, 0.540090, -0.046270, 
-0.069320, 0.097390, -0.067560, 0.186170, 0.577020, -0.101260, -0.492660, 1.193520, 0.386380, 0.062380, 
-0.005520, 0.866750, 0.507940, -0.018270, 0.833710, 0.044240, -0.599980, 0.802250, -0.099970, 0.137890, 
0.362260, 0.399020, 0.350750, -0.123240, 0.261810, 0.359550, -0.059090, -0.235940, -0.221660, -0.520320, 
-1.088780, 0.774320, -0.959680, -0.963980, 0.336080, -0.234280, 0.786300, -0.225060, -0.862350, -0.186210, 
0.093470, 0.117610, -0.413000, 0.376950, -0.107170, -0.384590, 1.255420, -0.078340, -0.362100, 0.370510, 
-0.222150, -0.537100, 0.575860, 0.367220, 0.196060, -0.242870, 0.538540, 0.829290, -0.724190, 0.480190, 
0.200750, 0.340100, -0.886270, 0.312590, 0.943580, -0.222790, 0.256810, 1.884360, 0.009650, -0.693410, 
0.580450, -0.722090, -1.077070, -0.172070, -0.407880, 0.511120, -0.342750, -0.466730, 0.520340, -0.133910, 
-0.203180, -0.310350, 0.255890, -0.330760, -0.531540, -0.074100, 0.628310, -0.245800, 1.212970, -0.043840, 
-0.072870, 0.113090, -0.305860, -0.493180, 0.135360, -0.164240, 0.222860, -0.096130, -0.185990, 0.891310, 
-0.230630, -0.220560, 0.612120, -0.142730, -0.364190, 0.111410, 0.462830, 0.530710, 0.010750, 1.053480, 
-0.043650, -0.358340, 0.755220, -0.360560, 0.137790, 0.059910, 0.250030, 0.580820, -0.312380, 0.169220, 
-0.070390, -0.415380, 0.499300, -0.673300, 0.218460, 0.535360, -0.336490, 0.139540, 0.499720, 0.085160, 
-0.151330, 0.000780, -0.195020, -0.028200, -0.250140, 0.206920, 0.106310, -0.476760, -0.548750, 0.271640, 
-0.083320, 0.139720, -0.075160, -0.073360, 0.059940, -0.211480, -0.151430, 0.134590, 0.086920, -0.145700, 
-0.145480, 0.799000, -0.020130, -0.595630, 0.191830, 0.197020, 0.760180, -0.090140, 0.221290, -0.351700, 
0.438220, 1.073790, -0.058110, -0.427650, 0.262610, -0.240460, 0.431170, 0.388310, 0.273410, 0.682480, 
0.113060, -0.121610, 0.359310, -0.041100, 0.091400, -0.322640, -0.520890, 0.480200, 0.582620, -0.234020, 
-0.370550, 0.801890, -0.488420, -0.186840, -0.269160, -0.544470, 0.158400, 0.002250, 0.325910, 0.992370, 
0.135980, 0.346220, 0.021770, 0.319450, -0.055330, 0.054150, 0.264020, 0.441180, 0.436560, 0.294820, 
-0.146760, 0.071830, 0.557250, 0.462820, -0.309350, -0.190310, 0.599080, -0.099060, 0.233490, -0.304130, 
0.580470, 0.648900, 0.103230, 0.081000, -0.392290, -0.056520, -0.180720, 0.280780, -0.158570, -0.009220, 
0.133710, 0.102970, -0.178680, 0.597870, -0.096190, -0.160110, 0.130800, -0.013620, -0.099060, 0.024400, 
-0.391860, 0.341930, 0.260460, -0.194530, 0.233920, -0.068790, -0.039980, 
-0.332350, -0.065380, 0.544140, 0.773890, -0.434700, 0.644350, 0.543130, 0.788610, 0.050360, 0.067140, 
0.493530, 0.872180, -0.211140, 0.330360, 0.083750, 0.347400, -0.209060, -0.368950, -0.269460, -0.133310, 
-0.203710, -0.014930, -0.270290, 0.163630, 0.228690, 0.531790, -0.137040, -0.029140, 0.544740, 0.285380, 
-0.362980, 0.365660, 0.214190, -0.458680, -0.110130, 0.030610, 0.535480, -0.105180, -0.027430, 0.275710, 
0.080110, -0.222410, -0.388860, 0.178900, 0.006280, 0.491800, 0.334050, -0.287710, -0.164420, 1.630180, 
0.242720, -0.499370, -0.336380, 0.472730, -0.419400, 0.479590, 0.472460, 0.536990, 0.022620, 0.319450, 
0.299940, -0.460690, -0.170520, -0.535660, -0.502740, -0.229480, 0.202080, 0.154140, -0.280530, -0.362900, 
0.179460, -0.148570, 0.158570, -0.336480, 0.268650, -0.098450, 0.126290, -0.164110, 0.416360, 0.712960, 
0.036850, 0.089750, 0.840900, -0.171080, -1.238620, 0.151190, 0.106290, -0.117190, -0.031390, -0.024510, 
-0.130510, -0.206030, 0.407840, 0.712150, -0.403430, 0.413440, -0.485390, 0.168360, 0.167770, 0.069770, 
0.585050, -0.141270, 0.053790, 0.384260, -0.155240, -0.381930, -0.450710, -0.845580, -0.596850, 0.979550, 
0.085620, -0.467650, -0.466930, 0.204000, 0.270420, -0.704200, -0.257200, 0.195810, 0.140280, 0.046490, 
0.010540, 0.849370, 0.556780, 0.457790, 1.263740, -0.115580, -0.124060, 0.376600, -0.301760, -0.493600, 
-1.256720, 0.409380, 0.615530, -0.301130, 0.029890, 1.065810, 0.026070, 0.220380, 0.042120, 0.181090, 
-0.966060, 0.672070, 0.829340, 1.491800, 0.150770, 0.542440, -0.073570, 0.078090, -0.150700, -0.910840, 
-0.821670, 0.528150, -0.183860, -0.481990, 0.535040, -0.024570, 0.979390, -0.140460, -0.662520, 0.017650, 
0.745870, -0.611000, 0.186330, 0.087290, 0.286600, 0.272900, 1.034120, -0.054900, -1.325520, 0.828530, 
-0.286450, 0.272520, -0.433330, 0.671180, 0.546990, -0.655380, -0.072140, 0.545300, -0.471520, 0.365350, 
-0.524950, 0.439170, -0.219050, 0.228090, 0.058240, -0.194190, 0.651470, 0.768170, 0.005850, -0.580970, 
-0.537250, 0.066530, 0.571800, 0.065820, -0.576610, -0.555440, -0.171300, -0.571870, 0.518650, -0.176520, 
-0.741130, -0.372350, -0.261170, -0.531170, -0.413100, -0.290050, -0.123820, -0.895240, 0.554840, -0.067930, 
-0.856710, 0.214780, 0.324510, 0.440970, 0.732140, -0.070770, 0.263030, 0.941640, -0.086830, -0.486080, 
-0.530540, -0.149490, -0.324390, -0.242080, 0.261140, 0.501610, 0.668320, 0.184660, 0.186490, -0.283100, 
-0.078030, -0.395990, 0.047080, 0.372310, 0.799900, -0.113360, 0.440350, -0.549710, 0.893530, 0.405150, 
-0.141800, 0.049050, -0.014340, 0.594510, 0.705650, 0.506770, 0.694630, 0.084090, 0.121630, -0.091960, 
-0.374090, 0.003550, -0.452280, -0.011420, 0.695310, 0.585440, 0.346000, 0.526430, -0.083120, 1.270480, 
0.053640, -0.084440, -0.308660, 0.274810, -0.091080, -0.143560, -0.195990, 0.738880, 0.469380, -0.071800, 
-0.186520, -0.111670, 0.031840, -0.332310, -0.380510, 0.796230, -0.135620, 0.444370, 0.269850, 0.143520, 
0.924370, 0.053550, 0.229130, -0.405680, 0.396550, -0.376020, 0.207820, -0.264340, 0.723820, 0.346750, 
0.017110, 0.389860, 0.274010, 0.032260, -0.007220, 0.015290, 0.080740, -0.089390, 0.427790, -0.034670, 
-0.073100, 0.210420, -0.339930, 0.596620, -0.046840, 0.083920, 0.373620, -0.052570, -0.094300, 0.012970, 
0.499980, 0.034400, 0.290450, 0.723900, 0.043310, -0.426000, -0.331240, -0.257530, -0.504250, 0.361450, 
-0.111320, 0.145310, -0.349990, 0.095170, 0.237550, 0.303610, 0.024970, 0.486920, 0.491450, 0.389970, 
0.102500, 0.726770, -0.307180, 0.484960, 0.731220, 0.051650, -0.208580, -0.101790, -1.083790, -0.284700, 
0.129600, 0.204720, 0.218980, 0.628910, 0.001190, 0.475480, 0.069840, -0.618740, -0.086180, 0.219450, 
0.168480, 0.037480, -0.061760, 0.512140, 0.835050, 0.144050, 0.034890, 
-0.027120, -0.180580, 0.287550, 0.226740, 0.249380, 0.157570, 0.561350, 0.497970, -0.239010, -0.016190, 
0.333790, 0.283860, 0.669160, 0.016460, -0.012190, 0.516680, 0.771090, 0.449830, -0.514390, 0.394630, 
0.016540, 0.305670, 0.237020, 0.289180, 0.241280, 0.113240, -0.733870, -0.567920, 0.423240, 0.064150, 
0.344650, 0.109350, -0.028970, -0.379950, 0.107220, -0.404680, -0.032540, 0.077980, 0.342210, 0.119070, 
0.101870, 0.020710, -0.122600, 0.316730, 0.187060, 0.217900, 0.112860, 0.421380, 0.129120, 0.262320, 
-0.393440, 0.314760, 0.235800, 0.776420, -0.008310, -0.208620, -0.060870, 0.273500, 0.560040, 0.014430, 
0.402670, -0.252630, -0.045140, 0.216710, 0.259330, -0.077240, 0.402120, 0.808040, -0.195020, -0.206490, 
0.352870, 0.301690, 0.357100, 0.191570, 0.137870, 0.028250, -0.002330, 0.066540, 0.023400, -0.149080, 
-0.278110, -0.138660, 0.199920, -0.017440, -0.111420, 0.528090, 0.536770, 0.097000, -0.120700, 0.353080, 
-0.135070, 0.808450, 0.608040, 0.346110, 0.350260, 0.352340, 0.158490, -0.554960, 0.983260, -0.226080, 
0.089360, 0.478180, -0.066780, 0.237320, -0.031810, -0.637090, 0.405640, -0.029040, 0.470380, 0.258890, 
-0.322000, -0.280700, 0.641050, 0.455750, 0.290740, 0.015620, 0.390980, -0.038350, 0.133930, 0.411640, 
0.205590, 0.653550, -0.293940, 0.253010, 0.287640, -0.017510, -0.355540, 0.125350, -0.166240, 0.154360, 
0.584130, -0.092140, -0.693740, 0.725240, -0.139190, 0.131800, -0.635060, 0.169090, -0.071550, 0.097680, 
0.440010, -0.478700, 0.042230, -0.242000, 0.321400, 0.264570, -0.033370, -0.151220, 0.269430, 0.051360, 
0.452650, 0.650280, 0.150070, -0.276910, 0.028240, 0.103200, 0.254670, -0.579420, 0.112350, -0.194970, 
0.061280, 0.790290, 0.572400, 0.645790, 0.361530, 0.539000, -0.079730, -0.005700, 0.334730, -0.199920, 
-0.680760, -1.495120, 0.181270, -0.847050, -0.812740, 1.530410, 0.395590, 0.736870, -0.876930, -1.110980, 
0.131870, 0.485000, -0.779080, -0.300150, -0.166890, -0.397930, -0.049210, 1.659260, -0.009730, -0.353680, 
0.443990, 0.180200, -0.177460, -0.048870, 0.346390, 0.528480, -0.643190, 0.163480, 0.626310, -0.044610, 
0.109060, -0.523620, 0.453970, 0.247930, 0.798970, 1.286660, -0.003920, 0.270650, 0.801180, -0.009990, 
0.189090, -0.795370, -1.076240, -1.225460, 0.204000, -0.843390, -0.634940, 0.729950, -0.587800, 0.858160, 
0.216560, -0.886510, 0.588700, 0.656330, -0.255730, -0.677790, -0.422880, 0.018880, -0.342820, 1.332140, 
0.010600, -1.017220, 0.369440, 0.049240, -0.088920, 0.077330, 0.273250, 0.541380, -0.697690, 0.038910, 
0.622140, -0.157940, 0.417900, -0.296300, 0.322200, -0.266510, 0.612360, 1.289670, 0.178160, 0.614070, 
0.791410, 0.042170, -0.560790, 0.378970, -0.318940, 0.469350, 0.531970, -0.293020, 0.038780, 0.212350, 
-0.209970, -0.104850, 0.399150, -0.380970, -0.161710, 0.210020, 0.091090, -0.202510, 0.045490, 0.036390, 
0.615840, 0.539140, 0.095290, -0.835430, 0.307490, 0.495230, -0.009340, -0.254860, 0.385830, 0.210680, 
-0.235580, -0.139110, 0.190230, -0.298590, 0.378200, -0.395030, -0.023270, 0.231840, -0.047530, 0.126800, 
0.347520, -0.081770, 0.576110, 0.052950, -0.025660, -0.004130, -0.163100, 0.158090, 0.698990, -0.532320, 
-0.432660, 0.305030, 0.658270, -0.240110, -0.318180, -0.416490, -0.378960, 0.020710, 0.552360, 0.167470, 
-0.172220, -0.339940, -0.383760, -0.008920, 0.084840, -0.471120, -0.320550, 0.048890, 0.323490, -0.038870, 
-0.125010, 0.339000, 0.062770, -0.276000, -0.199560, -0.568920, 0.052540, -0.152020, 0.296920, 0.655000, 
-0.220000, 0.413870, 0.045890, -0.075330, 0.386820, 0.037770, -0.235560, 0.129710, 0.198380, 0.235370, 
0.478960, -0.405330, -0.103080, 0.646420, 0.183000, 0.219250, 0.174680, 0.238230, -0.262600, 0.005190, 
-0.056340, 0.030230, 0.236630, 0.038540, -0.071260, 0.597130, 0.060650, 
-0.015790, 0.061270, 0.145390, -0.126550, -0.152590, 0.184530, -0.299640, -0.589780, -0.174930, 0.357800, 
0.171980, 0.033640, 0.404970, 0.578530, -0.421220, -0.134560, 0.454370, 0.223000, -0.152980, 0.268330, 
-0.003760, -0.270760, 0.308460, -0.075320, -0.289900, -0.371430, -0.139780, 0.109920, -0.317230, -0.128000, 
0.226100, -0.016430, 0.038530, 0.098580, 0.379840, -0.179310, 0.138200, -0.394400, -0.214310, -0.310990, 
-0.117530, 0.028640, -0.027600, -0.022970, 0.231570, 0.083260, -0.281530, -0.065690, 0.508120, 0.058960, 
-0.023910, -0.125270, -0.106210, 0.009030, -0.010830, 0.089410, -0.407080, 0.108530, -0.223860, 0.414510, 
0.024360, 0.013460, 0.049060, 0.025420, -0.331180, 0.328950, 0.071910, 0.212020, 0.163560, -0.534730, 
-0.138390, 0.381190, 0.376320, -0.077470, -0.143360, 0.248650, -0.074990, -0.236820, 0.261120, -0.479820, 
0.071020, 0.368560, 0.090880, 0.057610, -0.318280, -0.002500, -0.191390, -0.300870, 0.389300, -0.192350, 
-0.443000, -0.254170, 0.171910, -0.171950, 0.216910, -0.459060, 0.117780, 0.671370, -0.004670, 0.010680, 
-0.063450, -0.118560, 0.218900, -0.135990, 0.060050, -0.322110, 0.210430, 1.163900, 0.301670, 0.457790, 
0.104170, 0.243450, 0.031410, 0.849710, -0.143780, -0.094610, 0.218270, 0.005700, 0.065210, 0.153720, 
0.306200, 0.124600, -0.550250, 0.733760, -0.200480, 0.068210, -0.143180, 0.500980, 0.198470, 0.325060, 
0.493440, 0.135880, 0.123360, -0.254220, 0.139450, 0.020530, 0.216710, 0.316610, 0.107890, -0.412400, 
0.429590, 0.006240, 0.300820, -0.281490, 0.068980, -0.059940, 0.057690, -0.188360, -0.298640, 0.313120, 
0.341950, 0.272890, -0.414650, -0.502380, 0.011580, 0.775290, 0.050210, 0.326710, 0.068720, -0.077460, 
0.285940, -0.058140, -0.200860, -0.386360, 0.112830, 0.154910, -0.056600, 0.054740, -0.213150, 0.421990, 
0.298480, 0.316660, -0.075460, -0.156610, -0.158940, 0.077880, 0.139670, -0.304980, -0.213120, -0.074140, 
0.489920, 0.190060, 1.167640, 0.050270, 0.308190, 0.396850, -0.046730, -0.074950, 0.002670, -0.747960, 
-0.083240, 1.019820, 0.270760, -0.065970, -0.174740, -0.071920, 0.793950, -0.150480, -0.440000, -0.587900, 
-0.093300, -0.043240, 0.006630, 1.036710, 0.278530, 0.601120, 0.211410, 0.163900, -0.422670, 0.073770, 
-0.314660, -0.184760, -0.232410, -0.454730, 0.309200, -0.256560, -0.300370, 0.345480, -0.431320, 0.437820, 
0.421450, -0.047590, -0.012390, 0.151410, 0.191140, 0.115850, -0.059040, 0.623610, -0.133230, 0.056030, 
0.056050, -0.304610, 0.469430, 0.365770, -0.078400, 0.184680, -0.025560, -0.298990, -0.041230, 0.042110, 
0.289320, 0.036900, 0.215110, 0.314370, 0.044770, 0.099460, 0.072900, 0.048050, 0.064570, -0.235680, 
0.009190, 0.049450, -0.210960, 0.477020, 0.585020, -0.183660, -0.534120, 0.134400, 0.210410, -0.112290, 
0.208100, -0.122500, 0.018790, 0.176900, -0.005270, -0.211800, 0.344420, 0.263270, 0.035400, 0.070570, 
-0.108290, -0.203260, 0.057220, 0.589000, -0.391130, -0.054480, 0.287950, 0.607090, -0.400070, 0.065880, 
0.370340, -0.206170, -0.242350, -0.527330, -0.301990, -0.129030, -0.072520, 0.726700, 0.405280, 0.311210, 
-0.250430, -0.146510, -0.402970, 0.052590, -0.345190, 0.073850, 0.296390, -0.054680, -0.321720, -0.028960, 
-0.061770, 0.310980, -0.033500, -0.039400, -0.137580, -0.283310, 0.307260, -0.079870, -0.256000, -0.256020, 
-0.059750, 0.086600, 0.027970, -0.366630, 0.044230, 0.087250, 0.104350, 0.347010, -0.254770, 0.380100, 
0.023630, -0.456240, 0.307970, 0.110910, -0.369540, -0.258020, -0.259360, -0.187110, 0.542660, 0.009630, 
0.289930, -0.257130, -0.025300, 0.140690, -0.380310, 0.046530, 0.349790, -0.188210, 0.036930, 0.278370, 
0.441470, 0.138510, 0.292130, 0.001730, 0.225960, 0.311320, 0.157240, 0.199130, 0.217810, -0.005180, 
-0.141990, -0.042500, -0.058210, -0.078460, -0.083860, 0.008280, 0.055690, 
0.145530, 0.435590, -0.173310, 0.057130, 0.324680, -0.256300, -0.321900, 0.021770, 0.264680, 0.229570, 
-0.186530, 0.131390, 0.154470, 0.174040, 0.482250, -0.456130, -0.521220, 0.701090, 0.785250, 0.298670, 
0.084040, 0.483080, 0.387530, 0.124740, 0.170730, 0.105220, 0.266490, 0.131720, 0.471880, -0.054390, 
-0.098980, -0.036790, 0.069630, -0.264780, -0.038270, 0.115420, 0.077430, 0.068530, -0.307100, -0.061410, 
-0.205510, 0.073050, 0.333340, 0.010480, 0.021880, 0.250870, 0.200380, 0.028900, 0.190730, -0.344860, 
-0.137050, -0.159150, -0.321290, -0.131350, 0.066230, -0.081520, 0.224950, -0.124480, -0.289120, -0.125530, 
-0.380210, -0.121290, 0.091510, 0.037420, -0.212890, -0.634430, 0.170630, -0.275030, -0.069840, 0.009610, 
-0.304360, -0.360390, -0.242010, 0.338820, -0.333980, 0.393460, 0.004010, 0.501880, -0.716070, -0.482960, 
0.172650, -0.167640, -0.344240, 0.108100, 0.137110, 0.055400, 0.118450, -0.284760, 0.324140, 0.410750, 
0.026720, -0.498870, 0.213730, -0.184460, -0.077090, 0.230710, -0.261000, -0.022140, 0.091160, -0.336760, 
-0.443320, 0.440970, 0.059430, 0.081090, 0.077560, -0.121960, -0.056140, 0.347430, 1.200830, -0.261790, 
0.042680, 0.338410, 0.011940, -0.247620, -0.232980, -0.488580, -0.281740, -0.330350, -0.381130, 0.724640, 
-0.169840, -0.575410, -0.195410, 0.061280, -0.390740, 0.081860, -0.652280, 0.208500, 0.406230, -0.039120, 
0.188340, -0.221170, -0.356180, -0.722590, 1.003340, -0.108740, 0.360980, 0.209750, 0.141050, 0.117520, 
0.748670, -0.606730, -0.475490, -0.125260, 0.377750, -0.296290, 0.078150, -0.321970, -0.314910, 0.848250, 
0.071500, 0.039890, -0.418940, -0.545720, 0.304680, 0.377250, -0.513840, 0.070610, -0.250480, 0.173070, 
-0.288480, 0.696230, -0.303260, -0.190800, -0.392610, 0.052160, -0.687410, 0.051510, 0.172540, 0.096410, 
0.757010, 0.468490, -0.046150, -0.190640, -0.454310, 0.786200, -0.288400, -0.577080, -0.160620, 0.554440, 
-0.344020, -0.194360, 1.190180, 0.055330, -0.286210, -0.712240, -0.602540, -0.785430, 0.003760, 0.102690, 
0.225410, 0.322270, 0.589000, -0.233310, 0.100150, -0.263880, 1.084920, -0.077570, -0.580040, -0.251710, 
0.038560, 0.093290, 0.269850, 0.839490, 0.204040, -0.304290, -0.067430, 0.012430, -0.471320, 0.046770, 
-0.384020, -0.125540, 0.499010, 0.823100, -0.066550, -0.043480, -0.183280, 0.493800, -0.471740, -0.307900, 
-0.257190, 0.115100, -0.020930, 0.083200, 0.632340, -0.114450, -0.137740, -0.420860, -0.068050, -0.502510, 
0.061730, -0.421560, -0.261030, 0.384580, 0.078760, -0.082410, 0.087060, 0.129780, 0.035560, -0.295200, 
-0.190840, 0.222680, -0.115860, 0.157600, 0.266930, 0.336120, -0.096880, -0.247060, -0.469200, -0.433850, 
-0.068630, 0.053210, 0.164400, 0.425280, -0.127110, 0.013340, -0.050240, -0.166120, -0.028560, -0.205750, 
0.111930, 0.257690, 0.436180, 0.146770, -0.204280, -0.003820, 0.114620, -0.217930, 0.052710, 0.153690, 
0.110810, 0.364360, 0.033050, 0.271840, 0.298530, 0.360770, 0.095240, 0.215110, -0.201700, -0.582270, 
0.596880, 0.075040, -0.083930, -0.309240, -0.006440, -0.152970, -0.265870, 0.550020, -0.103610, -0.074290, 
-0.330270, -0.209200, -0.225510, 0.046330, 0.100950, -0.117790, 0.481800, 0.153150, 0.490490, 0.159600, 
0.282110, -0.155320, -0.083110, 0.001500, 0.107780, 0.158490, 0.108990, -0.311130, -0.210490, -0.222760, 
-0.169470, -0.202330, -0.591970, 0.111040, 0.060960, 0.204620, -0.104630, -0.155090, -0.058450, -0.282900, 
0.285750, 0.523200, -0.439230, -0.134340, 0.414000, 0.176040, 0.243690, -0.146270, 0.145140, 0.527030, 
-0.390960, -0.150560, -0.180390, 0.145810, 0.023480, 0.046100, 0.545060, -0.108430, 0.012450, 0.309220, 
0.017370, 0.025230, 0.140430, -0.120670, -0.088810, 0.368300, 0.335340, 0.075660, 0.045500, 0.465390, 
0.147180, -0.210830, -0.092310, 0.008480, -0.469290, -0.094530, 0.069640, 
0.492570, 0.367420, 0.523270, 0.064390, 0.413550, 0.106320, -0.267530, 0.303740, 0.627250, 0.182590, 
-0.390660, -0.071630, -0.030880, -0.180700, -0.092310, 0.346340, -0.005630, 0.492930, 0.502780, 0.324840, 
-0.117540, 0.274310, -0.511520, 0.020950, 0.217990, 0.386410, -0.334160, 0.238030, -0.630450, -0.057190, 
-0.467890, 0.092430, -0.514830, -0.493520, -0.137810, 0.467980, 0.200520, -0.007770, -0.205410, 0.181650, 
-0.022430, -0.081390, 0.336210, -0.128300, 0.218110, -0.169690, 0.000680, 0.089640, -0.097660, -0.011380, 
-0.150460, -0.038370, 0.217490, -0.509600, -0.038100, 0.202870, 0.145510, -0.092960, -0.023070, 0.469250, 
0.288330, -0.377440, -0.078040, 0.839120, 0.864960, -0.734810, -0.288920, -0.220960, -0.228630, -0.539630, 
-0.462900, -0.277600, 0.202780, 0.177510, -0.094700, 0.424510, -0.402190, -0.003280, -0.171320, -0.427260, 
0.421660, -0.142790, 0.099220, -0.039840, 0.747080, 0.409240, 0.404230, 0.499000, 0.215560, 0.097070, 
-0.036170, 0.406250, -0.452160, -0.282850, 0.486160, -0.000320, 0.252590, 0.097200, 0.125070, 0.056460, 
0.125630, -0.585830, -0.178620, -0.240520, -0.051890, 1.248900, 0.426940, -0.208840, -0.235690, 0.029500, 
-0.014040, 0.007140, -0.084670, 0.172040, 0.057390, 0.715430, 0.267480, 0.542490, 0.052020, -0.350960, 
-0.328370, -0.282390, 0.189830, 0.212010, -0.054880, -0.096810, 0.650820, -0.669500, -0.181670, -0.498620, 
0.453580, -0.381190, -0.890430, -0.203190, -0.461440, 0.484150, 0.637090, -0.680850, 0.840650, 0.192720, 
-0.213470, 0.220750, 0.051530, -0.151560, -0.409780, -0.003410, -0.085710, 0.617990, -0.125930, 0.523820, 
-0.004440, -0.294260, -0.050200, -0.497660, -0.198310, 0.250120, 0.019740, 0.163300, 0.327990, -0.063360, 
-0.087750, -0.611840, 0.289900, -0.602710, 0.631810, -0.221120, -0.301240, -0.031790, 1.188980, 1.283370, 
0.792640, 0.273510, 0.008680, -0.024610, 0.328080, -0.036460, 0.090690, -0.272530, 0.638490, 0.790450, 
-0.051810, 0.110900, 0.703310, 0.165740, -0.660410, 0.601870, 0.022020, -0.332720, -0.009630, 1.979210, 
-0.300680, -0.214530, 0.702050, 0.105160, 0.797440, 0.868900, -0.259730, 0.126220, -0.107240, 0.583570, 
0.367560, 0.173880, 0.093750, -0.527070, -0.138870, -0.665220, 0.556940, 0.635500, -0.448060, -0.035340, 
0.789190, -1.141530, -0.583990, -0.685430, 0.038600, -0.295960, -0.304130, -0.419580, -0.167070, -0.234440, 
1.188800, -0.773090, 0.595030, 0.695600, -1.004150, -0.397070, -0.281250, -0.111750, -0.012670, -0.915790, 
-0.047330, 1.146570, -0.316930, -0.290590, -0.589300, 0.292940, 0.207570, -0.656780, 0.108040, -0.417330, 
0.601580, 0.677820, -0.144130, 0.354640, 0.079300, -0.637510, -0.532080, -0.008610, 0.028780, -0.277540, 
0.186450, -0.106270, 0.713680, 0.677780, 0.642700, 1.052170, 0.210050, 0.589050, 0.760150, 0.456310, 
-0.240510, 0.140460, -0.018170, 0.683520, 0.009120, -0.254380, 0.192040, -0.071840, 0.070560, -0.119380, 
-0.377350, -0.181520, -0.164480, 0.193950, 0.269100, 0.731010, -0.264270, 0.273110, 0.547540, 0.038330, 
0.046240, 0.829310, 0.078610, 0.760950, 0.604080, -0.014340, 0.067450, -0.201720, -0.155030, -0.010360, 
-0.199490, 0.381750, -0.308430, -0.136610, 0.575160, -0.505870, -0.133990, -0.707160, -0.163670, -0.549560, 
-0.704930, 0.135940, -0.001150, 0.938350, 0.912020, -0.256330, 0.351520, 0.011460, -0.558630, -0.054150, 
-0.144750, -0.199330, -0.146180, 0.151730, -0.120690, -0.119170, -0.106980, -0.034540, 0.406250, -0.095090, 
-0.019160, 0.113820, -0.262140, -0.149900, 0.441120, 1.080560, -0.109390, 0.015370, -0.214460, 0.157750, 
-0.230230, 0.145910, 0.176410, 0.209120, 0.485500, -0.119560, 0.677840, 0.044860, 0.017810, 0.434920, 
0.291570, -0.019000, -0.066240, 0.569320, -0.116330, -0.113020, -0.018430, 0.410050, 0.145060, 0.079950, 
-0.101090, 0.208170, -0.056980, -0.191540, -0.272740, -0.014790, -0.111270, 
-0.977420, 0.947240, -1.523600, 0.735350, -0.895600, -0.925230, -1.033480, -0.816250, 1.295760, -0.257200, 
-0.578610, -0.946860, -1.056820, -1.119350, 1.009020, 1.183630, -0.536200, -0.429340, -0.835390, -0.674830, 
0.921390, -0.658040, -0.607450, -0.062630, -0.598270, 0.609720, -0.833500, -0.845670, -0.782530, 0.227120, 
-0.469760, 0.917450, 0.647830, 1.337560, -0.504840, -0.848190, -0.912230, 1.035690, -0.671660, -1.119840, 
1.108550, -0.535130, -0.473660, -1.131280, 0.693680, -0.838180, 0.610390, 0.283730, 1.074770, 1.137310, 
-0.496090, -0.915170, -0.852750, -0.569460, 1.036580, -0.032800, -0.987490, -0.109890, -1.169940, -0.677100, 
-0.096160, -1.064430, -0.602930, 0.427380, -0.528750, -1.381490, -0.947260, -0.859420, -0.120620, -0.838150, 
-0.704660, -1.198920, -0.349630, -0.033410, 0.978880, 
-2.204840, -0.557650, -1.137230, -0.983200, 0.283700, -0.637470, 0.459570, 0.718890, -0.917930, -0.498590, 
0.636760, -0.782630, 0.974060, -1.073970, -0.966650, -0.917540, -0.260690, -0.430830, -0.040520, 0.137890, 
-0.749600, 0.008320, -0.190660, -0.643950, -0.325680, 0.000510, 1.366630, -0.720070, -0.480030, 0.505510, 
0.277140, -0.868980, -0.415910, -1.204940, -0.696200, -0.457090, 0.022330, -0.495110, -1.019010, -1.640630, 
-0.926360, -0.310540, -0.588980, -0.694850, -0.524180, -0.153960, -0.788150, 0.393520, -0.896910, -0.690880, 
-0.039800, 0.596400, 0.799240, -0.930170, -1.098680, -0.519790, -1.071920, -0.375620, 1.115580, -0.299690, 
-0.948460, -0.248930, 0.653900, 0.132260, 0.199560, -0.164440, -1.030910, -0.195360, -0.575900, 0.952850, 
0.937740, 1.020810, -0.423490, -0.614120, -0.623760, 
1.728330, -0.630950, 2.075760, -0.230320, 0.382910, 0.773820, 0.394550, -0.352070, -0.813690, 0.470880, 
-0.581920, 0.811800, -0.371000, 1.174730, -0.489630, -0.873520, 0.464930, 0.459600, 0.462650, 0.394680, 
-0.358480, 0.384140, 0.664380, 0.304740, 0.424830, -0.429800, -0.814610, 0.854640, 0.728900, -0.498130, 
0.195010, -0.670210, -0.497080, -0.584960, 0.597600, 0.768350, 0.532840, -1.429760, 1.006270, 1.356290, 
-0.855180, 0.444270, 0.562290, 1.011590, 0.302860, 0.574630, 0.342550, -0.445430, -0.612490, -1.078070, 
0.417910, 0.305600, 0.366640, 0.807230, -0.280360, 0.425580, 0.900320, 0.320890, -0.556740, 0.604600, 
0.541820, 0.750620, -0.321750, -0.320180, 0.239900, 1.121400, 1.305560, 0.519040, 0.329650, -0.546250, 
-0.620280, -0.467010, 0.408410, 0.425040, -0.504370, 

  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[436] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.010000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, 0.009980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.009170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.002710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.008150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, -0.000540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.000910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, 0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, -0.006630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.008630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, -0.001360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, -0.001120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, 0.008980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, 0.009620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.004950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, -0.007520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.000630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, -0.008410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, -0.000310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, -0.006210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, 0.006230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.001410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, 0.008460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, -0.006310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, -0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, 0.007630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.007880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, -0.005690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, 0.002430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, -0.003580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.003620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, -0.005050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.009880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, -0.002490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.007470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.002350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.005420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, 0.006270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, 0.000070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, -0.000190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, 0.003680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, -0.004030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, 0.002660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, -0.007530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, 0.002580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, 0.001440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, -0.000850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, -0.003360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, 0.006580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, -0.006620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.007240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, -0.005380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.008950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, -0.009330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, 0.003310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.008360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, 0.004590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.008510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.003520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.006200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.000720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.001380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.000240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, -0.004780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, -0.007430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, -0.001560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, 0.003330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, 0.002140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, 0.006460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.007760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.007050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.006220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, -0.009100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.008090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.003720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.007460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, 0.009920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, 0.009990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, 0.006140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, -0.001740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, 0.002500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, 0.009460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.000700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, -0.005710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.001160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.004240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.007070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.000520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, 0.004670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, -0.005670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, 0.000640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.006060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.001060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.005140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.000680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, -0.007380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, 0.007320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, -0.006920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.009640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, -0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, -0.003400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, -0.006000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.007140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, -0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.005490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.002680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.008890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, -0.007700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.001100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.006740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.001500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.000400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, 0.009380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, -0.002170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, -0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.006350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.000500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, -0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, 0.003820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, -0.008850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.002240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, -0.008610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.008230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, 0.003250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, -0.000660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.005360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, -0.005040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.008180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.007080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, 0.006510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, 0.001620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, 0.004070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, 0.002440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, 0.001630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, 0.002380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, 0.004000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, 0.009580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, 0.009260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.005580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, 0.000110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, -0.007650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 165 (Old: 165) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 166 (Old: 166) */
      0.0, 0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 167 (Old: 167) */
      0.0, 0.007600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 168 (Old: 168) */
      0.0, -0.000960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 169 (Old: 169) */
      0.0, 0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 170 (Old: 170) */
      0.0, 0.000860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 171 (Old: 171) */
      0.0, -0.001760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 172 (Old: 172) */
      0.0, -0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 173 (Old: 173) */
      0.0, 0.008600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 174 (Old: 174) */
      0.0, -0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 175 (Old: 175) */
      0.0, 0.001940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 176 (Old: 176) */
      0.0, -0.001710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 177 (Old: 177) */
      0.0, 0.006180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 178 (Old: 178) */
      0.0, -0.007850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 179 (Old: 179) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 180 (Old: 180) */
      0.0, 0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 181 (Old: 181) */
      0.0, 0.007690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 182 (Old: 182) */
      0.0, 0.006820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 183 (Old: 183) */
      0.0, -0.009850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 184 (Old: 184) */
      0.0, -0.003630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 185 (Old: 185) */
      0.0, -0.006240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 186 (Old: 186) */
      0.0, -0.002840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 187 (Old: 187) */
      0.0, 0.003410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 188 (Old: 188) */
      0.0, -0.004750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 189 (Old: 189) */
      0.0, -0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 190 (Old: 190) */
      0.0, -0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 191 (Old: 191) */
      0.0, -0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 192 (Old: 192) */
      0.0, 0.002820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 193 (Old: 193) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 194 (Old: 194) */
      0.0, 0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 195 (Old: 195) */
      0.0, -0.006300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 196 (Old: 196) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 197 (Old: 197) */
      0.0, 0.004510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 198 (Old: 198) */
      0.0, 0.009110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 199 (Old: 199) */
      0.0, -0.002020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 200 (Old: 200) */
      0.0, -0.000280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 201 (Old: 201) */
      0.0, -0.002600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 202 (Old: 202) */
      0.0, 0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 203 (Old: 203) */
      0.0, 0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 204 (Old: 204) */
      0.0, 0.000950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 205 (Old: 205) */
      0.0, -0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 206 (Old: 206) */
      0.0, -0.004860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 207 (Old: 207) */
      0.0, 0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 208 (Old: 208) */
      0.0, -0.002360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 209 (Old: 209) */
      0.0, -0.002370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 210 (Old: 210) */
      0.0, -0.007090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 211 (Old: 211) */
      0.0, 0.006370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 212 (Old: 212) */
      0.0, 0.003840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 213 (Old: 213) */
      0.0, 0.009530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 214 (Old: 214) */
      0.0, 0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 215 (Old: 215) */
      0.0, -0.009030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 216 (Old: 216) */
      0.0, -0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 217 (Old: 217) */
      0.0, 0.005900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 218 (Old: 218) */
      0.0, -0.002080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 219 (Old: 219) */
      0.0, -0.008710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 220 (Old: 220) */
      0.0, -0.001190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 221 (Old: 221) */
      0.0, -0.000940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 222 (Old: 222) */
      0.0, 0.001220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 223 (Old: 223) */
      0.0, 0.001000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 224 (Old: 224) */
      0.0, 0.003860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 225 (Old: 225) */
      0.0, 0.005980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 226 (Old: 226) */
      0.0, 0.005680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 227 (Old: 227) */
      0.0, 0.009000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 228 (Old: 228) */
      0.0, 0.005810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 229 (Old: 229) */
      0.0, -0.001490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 230 (Old: 230) */
      0.0, -0.008300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 231 (Old: 231) */
      0.0, 0.001690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 232 (Old: 232) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 233 (Old: 233) */
      0.0, 0.002890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 234 (Old: 234) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 235 (Old: 235) */
      0.0, 0.002160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 236 (Old: 236) */
      0.0, 0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 237 (Old: 237) */
      0.0, 0.004290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 238 (Old: 238) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 239 (Old: 239) */
      0.0, 0.001110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 240 (Old: 240) */
      0.0, -0.008520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 241 (Old: 241) */
      0.0, -0.008430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 242 (Old: 242) */
      0.0, -0.002120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 243 (Old: 243) */
      0.0, -0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 244 (Old: 244) */
      0.0, 0.009710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 245 (Old: 245) */
      0.0, -0.003730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 246 (Old: 246) */
      0.0, -0.006890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 247 (Old: 247) */
      0.0, 0.007410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 248 (Old: 248) */
      0.0, 0.008810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 249 (Old: 249) */
      0.0, 0.009740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 250 (Old: 250) */
      0.0, 0.002180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 251 (Old: 251) */
      0.0, -0.007310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 252 (Old: 252) */
      0.0, 0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 253 (Old: 253) */
      0.0, -0.008490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 254 (Old: 254) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 255 (Old: 255) */
      0.0, -0.003240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 256 (Old: 256) */
      0.0, -0.003100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 257 (Old: 257) */
      0.0, 0.008470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 258 (Old: 258) */
      0.0, 0.008140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 259 (Old: 259) */
      0.0, 0.009930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 260 (Old: 260) */
      0.0, -0.000530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 261 (Old: 261) */
      0.0, -0.005800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 262 (Old: 262) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 263 (Old: 263) */
      0.0, -0.000920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 264 (Old: 264) */
      0.0, -0.005970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 265 (Old: 265) */
      0.0, -0.004540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 266 (Old: 266) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 267 (Old: 267) */
      0.0, 0.004900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 268 (Old: 268) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 269 (Old: 269) */
      0.0, 0.000340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 270 (Old: 270) */
      0.0, 0.000650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 271 (Old: 271) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 272 (Old: 272) */
      0.0, -0.000080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 273 (Old: 273) */
      0.0, -0.007170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 274 (Old: 274) */
      0.0, 0.009800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 275 (Old: 275) */
      0.0, -0.006430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 276 (Old: 276) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 277 (Old: 277) */
      0.0, 0.009610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 278 (Old: 278) */
      0.0, -0.008590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 279 (Old: 279) */
      0.0, 0.008740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 280 (Old: 280) */
      0.0, 0.009240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 281 (Old: 281) */
      0.0, 0.006190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 282 (Old: 282) */
      0.0, 0.004470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 283 (Old: 283) */
      0.0, 0.001050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 284 (Old: 284) */
      0.0, -0.002990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 285 (Old: 285) */
      0.0, 0.006980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 286 (Old: 286) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 287 (Old: 287) */
      0.0, -0.002990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 288 (Old: 288) */
      0.0, -0.000690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 289 (Old: 289) */
      0.0, 0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 290 (Old: 290) */
      0.0, 0.002120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 291 (Old: 291) */
      0.0, -0.004440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 292 (Old: 292) */
      0.0, -0.004490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 293 (Old: 293) */
      0.0, 0.003880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 294 (Old: 294) */
      0.0, 0.007870, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 295 (Old: 295) */
      0.0, -0.008220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 296 (Old: 296) */
      0.0, -0.004820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 297 (Old: 297) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 298 (Old: 298) */
      0.0, -0.003030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 299 (Old: 299) */
      0.0, 0.002630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 300 (Old: 300) */
      0.0, 0.009480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 301 (Old: 301) */
      0.0, -0.006990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 302 (Old: 302) */
      0.0, 0.009160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 303 (Old: 303) */
      0.0, 0.008880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 304 (Old: 304) */
      0.0, 0.001480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 305 (Old: 305) */
      0.0, 0.000410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 306 (Old: 306) */
      0.0, -0.000030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 307 (Old: 307) */
      0.0, -0.009610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 308 (Old: 308) */
      0.0, -0.002150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 309 (Old: 309) */
      0.0, -0.008250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 310 (Old: 310) */
      0.0, -0.005010, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 311 (Old: 311) */
      0.0, -0.004280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 312 (Old: 312) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 313 (Old: 313) */
      0.0, 0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 314 (Old: 314) */
      0.0, 0.004710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 315 (Old: 315) */
      0.0, 0.009630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 316 (Old: 316) */
      0.0, 0.008390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 317 (Old: 317) */
      0.0, 0.006910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 318 (Old: 318) */
      0.0, 0.007710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 319 (Old: 319) */
      0.0, -0.005130, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 320 (Old: 320) */
      0.0, -0.008760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 321 (Old: 321) */
      0.0, 0.007420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 322 (Old: 322) */
      0.0, -0.001850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 323 (Old: 323) */
      0.0, 0.007550, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 324 (Old: 324) */
      0.0, -0.001980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 325 (Old: 325) */
      0.0, 0.008680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 326 (Old: 326) */
      0.0, 0.004880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 327 (Old: 327) */
      0.0, 0.001750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 328 (Old: 328) */
      0.0, -0.008970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 329 (Old: 329) */
      0.0, 0.002930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 330 (Old: 330) */
      0.0, 0.009660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 331 (Old: 331) */
      0.0, -0.009470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 332 (Old: 332) */
      0.0, -0.005250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 333 (Old: 333) */
      0.0, -0.007240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 334 (Old: 334) */
      0.0, 0.001900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 335 (Old: 335) */
      0.0, -0.007360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 336 (Old: 336) */
      0.0, 0.009260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 337 (Old: 337) */
      0.0, 0.005830, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 338 (Old: 338) */
      0.0, 0.001530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 339 (Old: 339) */
      0.0, -0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 340 (Old: 340) */
      0.0, -0.001290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 341 (Old: 341) */
      0.0, -0.001530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 342 (Old: 342) */
      0.0, 0.000640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 343 (Old: 343) */
      0.0, 0.000720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 344 (Old: 344) */
      0.0, -0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 345 (Old: 345) */
      0.0, 0.003960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 346 (Old: 346) */
      0.0, 0.001650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 347 (Old: 347) */
      0.0, 0.008030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 348 (Old: 348) */
      0.0, 0.007260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 349 (Old: 349) */
      0.0, -0.003960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 350 (Old: 350) */
      0.0, 0.006390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 351 (Old: 351) */
      0.0, -0.007860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 352 (Old: 352) */
      0.0, -0.004620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 353 (Old: 353) */
      0.0, 0.003950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 354 (Old: 354) */
      0.0, 0.007180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 355 (Old: 355) */
      0.0, -0.006480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 356 (Old: 356) */
      0.0, 0.001160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 357 (Old: 357) */
      0.0, -0.001800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 358 (Old: 358) */
      0.0, 0.171540, 357,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 359 (Old: 359) */
      0.0, -0.373620, 357,
       &Sources[357] , 
       &Weights[357] , 
      },
    { /* unit 360 (Old: 360) */
      0.0, 0.023080, 357,
       &Sources[714] , 
       &Weights[714] , 
      },
    { /* unit 361 (Old: 361) */
      0.0, -0.583540, 357,
       &Sources[1071] , 
       &Weights[1071] , 
      },
    { /* unit 362 (Old: 362) */
      0.0, -0.095350, 357,
       &Sources[1428] , 
       &Weights[1428] , 
      },
    { /* unit 363 (Old: 363) */
      0.0, -0.174340, 357,
       &Sources[1785] , 
       &Weights[1785] , 
      },
    { /* unit 364 (Old: 364) */
      0.0, -0.044440, 357,
       &Sources[2142] , 
       &Weights[2142] , 
      },
    { /* unit 365 (Old: 365) */
      0.0, -0.230000, 357,
       &Sources[2499] , 
       &Weights[2499] , 
      },
    { /* unit 366 (Old: 366) */
      0.0, -0.305910, 357,
       &Sources[2856] , 
       &Weights[2856] , 
      },
    { /* unit 367 (Old: 367) */
      0.0, -0.153280, 357,
       &Sources[3213] , 
       &Weights[3213] , 
      },
    { /* unit 368 (Old: 368) */
      0.0, -0.308300, 357,
       &Sources[3570] , 
       &Weights[3570] , 
      },
    { /* unit 369 (Old: 369) */
      0.0, -0.169800, 357,
       &Sources[3927] , 
       &Weights[3927] , 
      },
    { /* unit 370 (Old: 370) */
      0.0, -0.197520, 357,
       &Sources[4284] , 
       &Weights[4284] , 
      },
    { /* unit 371 (Old: 371) */
      0.0, 0.075300, 357,
       &Sources[4641] , 
       &Weights[4641] , 
      },
    { /* unit 372 (Old: 372) */
      0.0, -0.381350, 357,
       &Sources[4998] , 
       &Weights[4998] , 
      },
    { /* unit 373 (Old: 373) */
      0.0, -0.498430, 357,
       &Sources[5355] , 
       &Weights[5355] , 
      },
    { /* unit 374 (Old: 374) */
      0.0, -0.199290, 357,
       &Sources[5712] , 
       &Weights[5712] , 
      },
    { /* unit 375 (Old: 375) */
      0.0, -0.124380, 357,
       &Sources[6069] , 
       &Weights[6069] , 
      },
    { /* unit 376 (Old: 376) */
      0.0, -0.078670, 357,
       &Sources[6426] , 
       &Weights[6426] , 
      },
    { /* unit 377 (Old: 377) */
      0.0, -0.082000, 357,
       &Sources[6783] , 
       &Weights[6783] , 
      },
    { /* unit 378 (Old: 378) */
      0.0, -0.394130, 357,
       &Sources[7140] , 
       &Weights[7140] , 
      },
    { /* unit 379 (Old: 379) */
      0.0, -0.090090, 357,
       &Sources[7497] , 
       &Weights[7497] , 
      },
    { /* unit 380 (Old: 380) */
      0.0, -0.042210, 357,
       &Sources[7854] , 
       &Weights[7854] , 
      },
    { /* unit 381 (Old: 381) */
      0.0, -0.056580, 357,
       &Sources[8211] , 
       &Weights[8211] , 
      },
    { /* unit 382 (Old: 382) */
      0.0, -0.045550, 357,
       &Sources[8568] , 
       &Weights[8568] , 
      },
    { /* unit 383 (Old: 383) */
      0.0, -0.241310, 357,
       &Sources[8925] , 
       &Weights[8925] , 
      },
    { /* unit 384 (Old: 384) */
      0.0, -0.147320, 357,
       &Sources[9282] , 
       &Weights[9282] , 
      },
    { /* unit 385 (Old: 385) */
      0.0, -0.157390, 357,
       &Sources[9639] , 
       &Weights[9639] , 
      },
    { /* unit 386 (Old: 386) */
      0.0, -0.150240, 357,
       &Sources[9996] , 
       &Weights[9996] , 
      },
    { /* unit 387 (Old: 387) */
      0.0, -0.065200, 357,
       &Sources[10353] , 
       &Weights[10353] , 
      },
    { /* unit 388 (Old: 388) */
      0.0, 0.083940, 357,
       &Sources[10710] , 
       &Weights[10710] , 
      },
    { /* unit 389 (Old: 389) */
      0.0, -0.440220, 357,
       &Sources[11067] , 
       &Weights[11067] , 
      },
    { /* unit 390 (Old: 390) */
      0.0, -0.448520, 357,
       &Sources[11424] , 
       &Weights[11424] , 
      },
    { /* unit 391 (Old: 391) */
      0.0, -0.324400, 357,
       &Sources[11781] , 
       &Weights[11781] , 
      },
    { /* unit 392 (Old: 392) */
      0.0, -0.122030, 357,
       &Sources[12138] , 
       &Weights[12138] , 
      },
    { /* unit 393 (Old: 393) */
      0.0, -0.091430, 357,
       &Sources[12495] , 
       &Weights[12495] , 
      },
    { /* unit 394 (Old: 394) */
      0.0, -0.033740, 357,
       &Sources[12852] , 
       &Weights[12852] , 
      },
    { /* unit 395 (Old: 395) */
      0.0, 0.045070, 357,
       &Sources[13209] , 
       &Weights[13209] , 
      },
    { /* unit 396 (Old: 396) */
      0.0, -0.114730, 357,
       &Sources[13566] , 
       &Weights[13566] , 
      },
    { /* unit 397 (Old: 397) */
      0.0, -0.108020, 357,
       &Sources[13923] , 
       &Weights[13923] , 
      },
    { /* unit 398 (Old: 398) */
      0.0, -0.397020, 357,
       &Sources[14280] , 
       &Weights[14280] , 
      },
    { /* unit 399 (Old: 399) */
      0.0, -0.025710, 357,
       &Sources[14637] , 
       &Weights[14637] , 
      },
    { /* unit 400 (Old: 400) */
      0.0, -0.144410, 357,
       &Sources[14994] , 
       &Weights[14994] , 
      },
    { /* unit 401 (Old: 401) */
      0.0, -0.112770, 357,
       &Sources[15351] , 
       &Weights[15351] , 
      },
    { /* unit 402 (Old: 402) */
      0.0, 0.026980, 357,
       &Sources[15708] , 
       &Weights[15708] , 
      },
    { /* unit 403 (Old: 403) */
      0.0, -0.110970, 357,
       &Sources[16065] , 
       &Weights[16065] , 
      },
    { /* unit 404 (Old: 404) */
      0.0, 0.094580, 357,
       &Sources[16422] , 
       &Weights[16422] , 
      },
    { /* unit 405 (Old: 405) */
      0.0, -0.129430, 357,
       &Sources[16779] , 
       &Weights[16779] , 
      },
    { /* unit 406 (Old: 406) */
      0.0, -0.405730, 357,
       &Sources[17136] , 
       &Weights[17136] , 
      },
    { /* unit 407 (Old: 407) */
      0.0, 0.014490, 357,
       &Sources[17493] , 
       &Weights[17493] , 
      },
    { /* unit 408 (Old: 408) */
      0.0, 0.121510, 357,
       &Sources[17850] , 
       &Weights[17850] , 
      },
    { /* unit 409 (Old: 409) */
      0.0, 0.075180, 357,
       &Sources[18207] , 
       &Weights[18207] , 
      },
    { /* unit 410 (Old: 410) */
      0.0, 0.402990, 357,
       &Sources[18564] , 
       &Weights[18564] , 
      },
    { /* unit 411 (Old: 411) */
      0.0, -0.032860, 357,
       &Sources[18921] , 
       &Weights[18921] , 
      },
    { /* unit 412 (Old: 412) */
      0.0, -0.347430, 357,
       &Sources[19278] , 
       &Weights[19278] , 
      },
    { /* unit 413 (Old: 413) */
      0.0, -0.090940, 357,
       &Sources[19635] , 
       &Weights[19635] , 
      },
    { /* unit 414 (Old: 414) */
      0.0, -0.130170, 357,
       &Sources[19992] , 
       &Weights[19992] , 
      },
    { /* unit 415 (Old: 415) */
      0.0, -0.242290, 357,
       &Sources[20349] , 
       &Weights[20349] , 
      },
    { /* unit 416 (Old: 416) */
      0.0, -0.165830, 357,
       &Sources[20706] , 
       &Weights[20706] , 
      },
    { /* unit 417 (Old: 417) */
      0.0, -0.117320, 357,
       &Sources[21063] , 
       &Weights[21063] , 
      },
    { /* unit 418 (Old: 418) */
      0.0, -0.009560, 357,
       &Sources[21420] , 
       &Weights[21420] , 
      },
    { /* unit 419 (Old: 419) */
      0.0, -0.226530, 357,
       &Sources[21777] , 
       &Weights[21777] , 
      },
    { /* unit 420 (Old: 420) */
      0.0, -0.223590, 357,
       &Sources[22134] , 
       &Weights[22134] , 
      },
    { /* unit 421 (Old: 421) */
      0.0, -0.036490, 357,
       &Sources[22491] , 
       &Weights[22491] , 
      },
    { /* unit 422 (Old: 422) */
      0.0, 0.104550, 357,
       &Sources[22848] , 
       &Weights[22848] , 
      },
    { /* unit 423 (Old: 423) */
      0.0, 0.012310, 357,
       &Sources[23205] , 
       &Weights[23205] , 
      },
    { /* unit 424 (Old: 424) */
      0.0, 0.009340, 357,
       &Sources[23562] , 
       &Weights[23562] , 
      },
    { /* unit 425 (Old: 425) */
      0.0, -0.093210, 357,
       &Sources[23919] , 
       &Weights[23919] , 
      },
    { /* unit 426 (Old: 426) */
      0.0, -0.114030, 357,
       &Sources[24276] , 
       &Weights[24276] , 
      },
    { /* unit 427 (Old: 427) */
      0.0, -0.161600, 357,
       &Sources[24633] , 
       &Weights[24633] , 
      },
    { /* unit 428 (Old: 428) */
      0.0, -0.255720, 357,
       &Sources[24990] , 
       &Weights[24990] , 
      },
    { /* unit 429 (Old: 429) */
      0.0, -0.158940, 357,
       &Sources[25347] , 
       &Weights[25347] , 
      },
    { /* unit 430 (Old: 430) */
      0.0, -0.078240, 357,
       &Sources[25704] , 
       &Weights[25704] , 
      },
    { /* unit 431 (Old: 431) */
      0.0, -0.107810, 357,
       &Sources[26061] , 
       &Weights[26061] , 
      },
    { /* unit 432 (Old: 432) */
      0.0, -0.327290, 357,
       &Sources[26418] , 
       &Weights[26418] , 
      },
    { /* unit 433 (Old: 433) */
      0.0, -0.703440, 75,
       &Sources[26775] , 
       &Weights[26775] , 
      },
    { /* unit 434 (Old: 434) */
      0.0, -0.137640, 75,
       &Sources[26850] , 
       &Weights[26850] , 
      },
    { /* unit 435 (Old: 435) */
      0.0, -1.768330, 75,
       &Sources[26925] , 
       &Weights[26925] , 
      }

  };



int net_psi(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[357] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357}; /* members */

  static pUnit Hidden1[75] = {Units + 358, Units + 359, Units + 360, Units + 361, Units + 362, Units + 363, Units + 364, Units + 365, Units + 366, Units + 367, Units + 368, Units + 369, Units + 370, Units + 371, Units + 372, Units + 373, Units + 374, Units + 375, Units + 376, Units + 377, Units + 378, Units + 379, Units + 380, Units + 381, Units + 382, Units + 383, Units + 384, Units + 385, Units + 386, Units + 387, Units + 388, Units + 389, Units + 390, Units + 391, Units + 392, Units + 393, Units + 394, Units + 395, Units + 396, Units + 397, Units + 398, Units + 399, Units + 400, Units + 401, Units + 402, Units + 403, Units + 404, Units + 405, Units + 406, Units + 407, Units + 408, Units + 409, Units + 410, Units + 411, Units + 412, Units + 413, Units + 414, Units + 415, Units + 416, Units + 417, Units + 418, Units + 419, Units + 420, Units + 421, Units + 422, Units + 423, Units + 424, Units + 425, Units + 426, Units + 427, Units + 428, Units + 429, Units + 430, Units + 431, Units + 432}; /* members */

  static pUnit Output1[3] = {Units + 433, Units + 434, Units + 435}; /* members */

  static int Output[3] = {433, 434, 435};

  for(member = 0; member < 357; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 75; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
