/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  net_psi111.c
  --------------------------------------------------------
  generated at Fri Jun 25 18:31:39 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[436];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, 
Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, 
Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, 
Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, 
Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357, 
Units + 358, Units + 359, Units + 360, Units + 361, Units + 362, Units + 363, Units + 364, Units + 365, Units + 366, Units + 367, 
Units + 368, Units + 369, Units + 370, Units + 371, Units + 372, Units + 373, Units + 374, Units + 375, Units + 376, Units + 377, 
Units + 378, Units + 379, Units + 380, Units + 381, Units + 382, Units + 383, Units + 384, Units + 385, Units + 386, Units + 387, 
Units + 388, Units + 389, Units + 390, Units + 391, Units + 392, Units + 393, Units + 394, Units + 395, Units + 396, Units + 397, 
Units + 398, Units + 399, Units + 400, Units + 401, Units + 402, Units + 403, Units + 404, Units + 405, Units + 406, Units + 407, 
Units + 408, Units + 409, Units + 410, Units + 411, Units + 412, Units + 413, Units + 414, Units + 415, Units + 416, Units + 417, 
Units + 418, Units + 419, Units + 420, Units + 421, Units + 422, Units + 423, Units + 424, Units + 425, Units + 426, Units + 427, 
Units + 428, Units + 429, Units + 430, Units + 431, Units + 432, 
Units + 358, Units + 359, Units + 360, Units + 361, Units + 362, Units + 363, Units + 364, Units + 365, Units + 366, Units + 367, 
Units + 368, Units + 369, Units + 370, Units + 371, Units + 372, Units + 373, Units + 374, Units + 375, Units + 376, Units + 377, 
Units + 378, Units + 379, Units + 380, Units + 381, Units + 382, Units + 383, Units + 384, Units + 385, Units + 386, Units + 387, 
Units + 388, Units + 389, Units + 390, Units + 391, Units + 392, Units + 393, Units + 394, Units + 395, Units + 396, Units + 397, 
Units + 398, Units + 399, Units + 400, Units + 401, Units + 402, Units + 403, Units + 404, Units + 405, Units + 406, Units + 407, 
Units + 408, Units + 409, Units + 410, Units + 411, Units + 412, Units + 413, Units + 414, Units + 415, Units + 416, Units + 417, 
Units + 418, Units + 419, Units + 420, Units + 421, Units + 422, Units + 423, Units + 424, Units + 425, Units + 426, Units + 427, 
Units + 428, Units + 429, Units + 430, Units + 431, Units + 432, 
Units + 358, Units + 359, Units + 360, Units + 361, Units + 362, Units + 363, Units + 364, Units + 365, Units + 366, Units + 367, 
Units + 368, Units + 369, Units + 370, Units + 371, Units + 372, Units + 373, Units + 374, Units + 375, Units + 376, Units + 377, 
Units + 378, Units + 379, Units + 380, Units + 381, Units + 382, Units + 383, Units + 384, Units + 385, Units + 386, Units + 387, 
Units + 388, Units + 389, Units + 390, Units + 391, Units + 392, Units + 393, Units + 394, Units + 395, Units + 396, Units + 397, 
Units + 398, Units + 399, Units + 400, Units + 401, Units + 402, Units + 403, Units + 404, Units + 405, Units + 406, Units + 407, 
Units + 408, Units + 409, Units + 410, Units + 411, Units + 412, Units + 413, Units + 414, Units + 415, Units + 416, Units + 417, 
Units + 418, Units + 419, Units + 420, Units + 421, Units + 422, Units + 423, Units + 424, Units + 425, Units + 426, Units + 427, 
Units + 428, Units + 429, Units + 430, Units + 431, Units + 432, 

  };

  /* Weigths definition section */
  static float Weights[] =  {
-0.019700, 0.058860, 0.167210, 0.041880, 0.253260, -0.073400, 0.025920, 0.008630, 0.083280, 0.266640, 
0.293710, -0.155300, 0.213040, 0.103420, 0.622150, 0.064650, 0.105090, 0.337850, -0.128890, 0.098410, 
0.259740, 0.153660, 0.054110, 0.194230, 0.293660, 0.244790, 0.208110, 0.177370, 0.291430, 0.282000, 
0.030430, 0.134620, 0.111870, 0.220850, 0.059660, 0.526350, 0.253720, 0.225960, 0.280390, -0.146750, 
0.093440, 0.288290, 0.114630, 0.235130, 0.175180, 0.171510, 0.058820, 0.357420, 0.273690, 0.089960, 
0.326000, -0.009240, 0.348310, 0.094870, 0.178830, 0.556250, 0.323090, 0.106580, 0.133630, 0.088250, 
0.180380, -0.051920, 0.280660, 0.148190, 0.143760, 0.087450, 0.234120, 0.342760, 0.256270, 0.211220, 
0.317740, 0.127550, 0.247780, 0.245290, 0.032350, 0.364420, 0.100800, 0.181020, 0.195850, 0.201770, 
0.113430, 0.044810, 0.180620, 0.267700, 0.016850, 0.139600, 0.351440, 0.118390, 0.058520, 0.054770, 
0.247390, 0.317070, 0.437030, -0.206660, -0.151540, 0.154600, -0.031920, 0.079360, 0.132790, 0.129200, 
0.092770, 0.407450, 0.101930, -0.106550, 0.189900, 0.238400, 0.253650, 0.472920, 0.249580, -0.025250, 
-0.033930, 0.052410, 0.301660, 0.067710, 0.197460, 0.180260, 0.057250, 0.042510, 0.260860, 0.131630, 
0.192340, 0.157590, 0.537460, 0.093980, 0.140260, 0.235700, 0.158310, 0.197990, 0.242750, 0.119510, 
-0.032140, -0.070650, -0.092760, 0.012220, 0.092710, 0.152860, 0.230370, 0.161050, 0.017130, 0.042660, 
0.369020, 0.165000, 0.116870, -0.127700, -0.213910, 0.228840, 0.193980, 0.131110, 0.032350, 0.169730, 
0.423020, 0.094210, 0.064990, 0.052850, 0.196430, 0.158540, 0.064730, 0.041470, 0.036120, 0.143120, 
0.080500, 0.163830, 0.037260, -0.081990, 0.157510, 0.328170, 0.027060, 0.168790, -0.119470, 0.047930, 
0.094190, -0.130170, 0.363220, 0.073510, -0.273560, -0.572640, -0.097470, 0.056620, 0.236670, 0.060130, 
0.708570, 0.157230, 0.027400, 0.041740, -0.011240, -0.273290, 0.112840, 0.074240, 0.004830, -0.188600, 
-0.097710, 0.036750, -0.129150, 0.058700, 0.048300, -0.069110, -0.022010, 0.001490, -0.042950, 0.034970, 
-0.075020, 0.108150, -0.172320, 0.504080, -0.029050, -0.002560, 0.138680, -0.322660, 0.296900, 0.009960, 
-0.088110, 0.281340, 0.417780, -0.094140, -0.105240, 0.219500, 0.027310, 0.038830, 0.413380, 0.011010, 
0.259360, 0.195190, 0.378070, -0.052580, 0.498430, 0.127230, -0.057250, 0.032620, 0.118980, 0.011260, 
0.033390, -0.123840, -0.218950, 0.274900, 0.133080, 0.370440, 0.042250, 0.121090, -0.196410, -0.030500, 
-0.097260, 0.056350, -0.124080, -0.011260, -0.156460, 0.374120, -0.048400, 0.097760, -0.296970, -0.225190, 
-0.325030, 0.025120, 0.000570, 0.215540, 0.614830, 0.198000, 0.057040, 0.238250, 0.170240, 0.196130, 
0.241200, -0.019830, -0.033600, 0.147720, -0.005930, -0.086930, -0.133360, -0.058520, 0.342200, 0.309670, 
-0.116860, 0.040820, 0.036720, -0.023540, 0.237000, 0.019600, 0.114600, 0.078460, 0.132630, 0.127310, 
-0.337320, -0.105710, -0.359940, -0.067500, 0.079310, -0.055220, -0.125100, 0.079050, -0.107880, -0.159470, 
-0.173210, -0.392540, -0.146650, 0.019860, 0.120340, 0.088530, -0.108020, 0.236270, 0.076390, 0.022080, 
0.189370, -0.188630, -0.232050, -0.187050, -0.128710, -0.112950, -0.093330, -0.289590, 0.170510, 0.112560, 
-0.003820, -0.182400, -0.304780, -0.221160, 0.029210, 0.010840, 0.042620, 0.080730, 0.040750, -0.070000, 
0.050680, -0.140400, 0.133810, -0.064330, 0.007920, -0.219370, 0.026980, 0.022710, -0.094420, 0.428950, 
0.061010, -0.001600, -0.494430, -0.158000, -0.045880, 0.018620, 0.055250, -0.022670, 0.268690, 0.115800, 
0.074910, 0.143370, 0.045580, -0.180910, 0.204110, -0.368050, -0.130070, -0.214520, -0.185000, -0.087510, 
-0.126290, -0.211370, -0.214970, -0.130380, -0.132690, -0.120970, 0.035710, 
0.314390, -0.327470, -0.249940, -0.086580, -0.312280, -0.145810, 0.351620, 0.283140, 0.007720, -0.026120, 
0.254110, -0.313280, 0.104490, 0.234350, -0.279140, -0.172250, 0.081980, 0.363080, 0.287210, -0.013650, 
-0.179180, 0.476820, 0.083040, -0.357220, -0.157800, -0.124240, -0.074180, 0.087770, -0.184350, -0.201920, 
-0.014600, 0.190430, -0.095220, 0.023370, -0.068890, -0.026410, 0.048510, -0.074810, 0.119000, -0.371560, 
-0.460640, -0.159600, 0.453570, 0.034070, 0.061230, -0.181430, 0.370260, 0.004430, -0.330650, 0.379580, 
0.077040, 0.351930, 0.238130, -0.060710, 0.076440, 0.081890, 0.076440, 0.059310, 0.137020, 0.248500, 
-0.114980, 0.026450, -0.129540, 0.285620, 0.564410, 0.122450, 0.310710, 0.098400, 0.210530, 0.360540, 
-0.160660, -0.152370, 0.025360, 0.266080, 0.210760, 0.003210, 0.060340, -0.052800, -0.091580, -0.515240, 
0.109480, 0.000190, -0.154930, -0.115900, 0.637510, 0.037730, 0.086470, 0.186760, -0.016610, 0.172430, 
0.655540, -0.247920, -0.048210, -0.038760, -0.010220, -0.141000, 0.102710, 0.191550, -0.470990, -0.211250, 
-0.109810, 0.193260, 0.206030, -0.155440, -0.121780, 0.438160, -0.157290, -0.354360, -0.454950, 0.132720, 
-0.091620, -0.564580, -0.490490, -0.242560, 0.295670, 0.354590, -0.214170, 0.407880, 0.241320, -0.654580, 
-0.020550, 0.063580, 0.076390, -0.333590, -0.056210, -0.105050, 0.673530, 0.206450, -0.332730, -0.384450, 
0.249170, 0.373900, 0.111790, 0.129900, -0.056870, 0.212950, 0.630970, 0.170150, 0.094340, 0.239660, 
0.039750, -0.050770, -0.100500, 0.290920, 0.296860, -0.241970, -0.062430, 0.829440, 0.772790, 0.468380, 
0.442340, 0.263580, 0.596900, 0.995440, -0.053830, 0.126990, 0.343570, 0.472960, 0.668650, -0.094860, 
-0.024000, 0.187680, 0.094020, 0.004190, 0.469960, 0.433160, -0.005060, -0.050310, 1.270320, 0.527380, 
-0.117380, -0.047470, 0.369700, 0.451460, 0.703010, -0.231850, -0.002090, 0.553660, 0.727560, -0.049470, 
0.095210, 0.035260, -0.427550, -0.038210, -0.058660, 0.480620, -0.422400, 0.101750, 0.006850, 1.088270, 
-0.138990, -0.161770, -0.475410, 0.366100, -0.210400, -0.180490, -0.378120, 0.230520, 0.447200, 0.969910, 
-0.465590, 0.276560, 0.174290, -0.620120, -0.263360, -0.001930, -0.096860, 0.002180, 0.441500, -0.088830, 
0.655350, 0.266660, -0.112080, -0.056130, 0.241050, 0.278430, 0.224180, 0.412570, -0.259460, 0.245260, 
0.248190, 0.313830, -0.011700, 0.007200, -0.298340, -0.310820, -0.511880, 0.400270, -0.092040, -0.000670, 
-0.163520, 1.038060, 0.730970, 0.211180, 0.500960, -0.000980, 0.754380, 0.635300, 0.108140, 0.304790, 
0.053960, 0.256520, 0.475750, 0.409240, -0.191720, -0.512420, -0.026730, 0.102880, 0.450860, 0.306410, 
-0.554270, -0.225370, 0.588490, 0.222040, 0.005830, -0.385660, 0.004950, -0.083490, 0.046930, 0.352360, 
0.124400, -0.041490, 0.351700, 0.097330, 0.148830, 0.103990, -0.129600, -0.238650, -0.512720, 0.223740, 
0.083360, -0.375930, -0.240550, 0.514940, -0.130760, -0.047730, -0.434000, -0.087480, -0.175970, -0.391190, 
0.044730, 0.403960, 0.333020, 0.672520, -0.145170, 0.098320, 0.099340, -0.437800, -0.112000, -0.546250, 
-0.159380, -0.023520, -0.087940, -0.240270, 0.226170, 0.097420, 0.277210, 0.107240, 0.045640, 0.144490, 
-0.017180, 0.486910, -0.313600, 0.238670, 0.288090, 0.522080, 0.173340, -0.025180, 0.071850, 0.023860, 
0.012960, 0.021210, -0.165210, 0.125830, -0.262990, -0.006680, 0.170480, 0.232070, 0.028400, 0.342350, 
0.239220, 0.008610, -0.019560, 0.236820, -0.007950, 0.329120, 0.448680, 0.499420, -0.038860, 0.008740, 
-0.045630, -0.195100, -0.074510, -0.027020, -0.352260, -0.256160, 0.449540, -0.131400, -0.049700, -0.261290, 
0.349460, -0.125920, -0.091380, 0.162750, -0.186100, -0.146350, 0.204350, -0.006700, -0.262900, 0.077280, 
-0.087760, 0.000960, -0.202930, -0.302550, -0.156870, 0.185850, -0.236390, 
-0.034650, 0.284860, 0.160600, 0.025470, 0.332610, 0.411040, 0.244910, 0.095490, 0.274960, -0.186610, 
-0.169770, 0.307380, 0.102200, -0.268330, -0.132950, 0.136970, -0.088960, -0.020540, 0.014370, 0.167500, 
0.074410, -0.200080, 0.170400, 0.377560, 0.055690, -0.139840, 0.139780, -0.027240, 0.070740, 0.138040, 
-0.060880, -0.209400, -0.086370, 0.012020, 0.028960, 0.257260, -0.227910, -0.267230, -0.210430, 0.126020, 
-0.061340, 0.051670, -0.237440, 0.119840, 0.016860, -0.077480, 0.095120, 0.441620, 0.058950, 0.007830, 
-0.427900, 0.025030, -0.165650, 0.192940, -0.124320, -0.151540, 0.223990, 0.075310, 0.278770, 0.094190, 
-0.338240, -0.012910, 0.065450, 0.031210, -0.326400, -0.140400, 0.001110, 0.119000, 0.010710, 0.092240, 
-0.269730, -0.368110, 0.337900, -0.047410, -0.176070, 0.068240, -0.176690, 0.259540, -0.046550, -0.216960, 
0.021620, -0.314820, 0.230040, 0.065210, -0.195250, -0.116360, -0.124600, -0.287790, 0.028540, -0.271870, 
-0.207060, 0.101440, -0.090000, 0.209200, -0.145240, -0.214080, -0.116770, 0.038130, -0.046770, -0.123350, 
0.198190, -0.058290, 0.023370, 0.273950, 0.041410, -0.203780, 0.014770, -0.426630, -0.403150, 0.473730, 
-0.483120, -0.346370, -0.380510, -0.223280, 0.613150, 0.234180, -0.017640, 0.289630, -0.225040, 0.036350, 
-0.149200, -0.208810, -0.355150, -0.026400, 0.292620, 0.030680, -0.193580, -0.203620, -0.372020, 0.222350, 
0.525150, -0.095040, -0.219070, -0.558210, -0.224180, 0.296090, 0.117660, -0.192840, 0.186230, -0.137920, 
0.363930, -0.295090, 0.138570, -0.026480, -0.144810, 0.122720, 0.030220, -0.107340, -0.320870, 0.005850, 
-0.016820, 0.267800, -0.297860, -0.260100, -0.398870, -0.560900, -0.025380, -0.009740, -0.107770, -0.005550, 
0.009840, 0.600130, -0.228680, 0.255220, -0.062840, -0.132610, 0.252100, 0.019160, -0.598150, -0.068670, 
0.407090, 0.218610, 0.025300, -0.186900, -0.721240, 0.941270, -0.054130, -0.651530, -0.507610, 0.140300, 
-0.153330, -0.384920, 0.894030, 0.142240, 0.185330, -0.129580, -0.235080, -0.438200, 0.006860, -0.218650, 
0.238480, -0.229410, -0.069860, 0.294770, -0.131580, -0.406120, 0.610390, -0.188740, -0.210590, -0.038660, 
0.463780, 0.107810, 0.007400, 1.021200, -0.111840, -0.164380, 0.297250, 0.222080, 0.063200, 0.113660, 
-0.022820, 0.543170, 0.137990, 0.244220, 0.265040, -0.028400, 0.098140, 0.286740, 0.407750, -0.371360, 
-0.278790, 0.574520, 0.205710, -0.017980, 0.535880, 0.406200, 0.380610, 0.322770, -0.088980, -0.049140, 
0.136280, -0.269170, -0.000950, -0.029200, 0.012690, 0.356290, 0.041220, 0.125080, 0.052270, 0.502040, 
-0.178120, -0.059490, -0.054790, -0.052350, -0.147620, 0.000910, 0.131820, 0.105940, 0.273480, -0.006310, 
0.090180, 0.164040, 0.449080, 0.483330, -0.109430, -0.039820, 0.212440, 0.130580, -0.046320, -0.037640, 
0.487870, 0.135760, 0.072140, 0.165990, 0.091290, 0.038260, 0.365640, 0.282420, 0.275620, 0.364220, 
0.257530, 0.219100, 0.159220, -0.114360, 0.201580, -0.291070, 0.117490, 0.107140, 0.104990, 0.138890, 
-0.185180, 0.185930, -0.256800, -0.081510, -0.167000, 0.130330, -0.208300, -0.154660, -0.059780, -0.061150, 
0.016840, -0.029890, -0.210140, 0.148540, 0.186340, 0.155260, 0.104320, 0.289860, 0.041010, 0.076630, 
0.101690, 0.080240, 0.280290, -0.058770, -0.206030, 0.166740, 0.050340, -0.118840, 0.400060, 0.199660, 
0.173730, -0.003070, -0.290660, -0.142570, 0.133830, 0.191100, 0.274540, -0.085270, 0.052780, 0.357080, 
-0.068530, 0.177360, 0.044130, 0.210290, -0.025560, -0.095770, -0.052480, -0.293750, 0.068500, -0.078280, 
-0.157580, -0.015430, 0.240440, 0.000910, 0.186990, 0.101810, 0.437280, 0.265090, 0.176130, 0.145010, 
0.481230, -0.026860, 0.134990, 0.222710, -0.220740, 0.098260, -0.139650, 0.011790, 0.001700, -0.280690, 
0.031770, -0.220360, 0.113760, -0.002390, -0.373830, 0.410270, 0.117530, 
0.288850, 0.314310, 0.010570, -0.027900, -0.019200, 0.162680, -0.306790, -0.117870, 0.128310, -0.033200, 
0.219390, 0.212810, 0.190340, -0.050730, -0.278650, -0.127860, -0.088630, 0.001220, 0.280090, 0.077730, 
-0.167490, 0.194320, 0.173870, 0.370770, 0.289060, 0.004770, -0.188130, 0.161460, -0.090030, 0.034380, 
0.001050, 0.025560, 0.061980, 0.134920, -0.016030, -0.127260, 0.050420, 0.031660, -0.242950, 0.039520, 
-0.105580, -0.142620, 0.223010, 0.141930, 0.202350, -0.263940, -0.112800, 0.430950, 0.094140, -0.140610, 
0.351430, -0.123830, 0.011010, -0.230950, -0.015270, -0.213720, 0.169280, -0.217620, -0.106270, 0.189580, 
-0.125590, -0.087420, -0.136720, 0.136080, 0.052790, -0.095350, 0.211370, -0.170520, 0.046260, 0.279040, 
-0.473020, -0.201130, 0.054900, 0.226010, -0.512010, -0.055430, -0.178000, -0.256110, -0.210630, -0.069990, 
-0.146020, -0.335860, -0.072070, -0.132200, 0.534040, 0.339450, 0.064980, 0.507860, -0.303830, 0.456850, 
0.359540, -0.246210, -0.561740, -0.159790, 0.384590, 0.086390, -0.036930, -0.101240, -0.028770, 0.098740, 
0.132530, 0.059100, -0.509730, -0.127760, -0.103150, 1.001580, 0.343120, -0.038350, 0.286620, 0.032310, 
0.252390, 0.388760, -0.493640, 0.430280, -0.065080, 0.158030, -0.160730, -0.185080, 0.221700, 0.307090, 
-0.264350, -0.301150, 0.455370, 0.346660, -0.042190, -0.091360, 1.116520, 0.265380, 0.057730, 0.307450, 
0.108660, 0.242430, 0.014940, -0.502800, 0.012120, 0.065720, 0.631190, 0.020740, 0.264240, -0.093420, 
-0.565530, 0.106860, -0.126750, -0.091890, 0.135110, -0.326450, -0.081730, 0.924180, 0.474810, 0.172720, 
0.576750, -0.135340, 0.049800, 0.411780, -0.951700, -0.279010, 0.233290, 0.820220, -0.071600, -0.188310, 
-0.135080, -0.073520, -0.207280, -0.053630, 0.216820, -0.158110, -0.266080, -0.066300, 1.752330, 0.699070, 
-0.194640, 0.101830, -0.132180, 0.500960, 0.675900, -0.638900, -0.093230, 0.074000, 0.967300, 0.786780, 
0.474030, -0.188400, 0.039270, -0.238210, -0.745590, 0.547600, 0.078840, -0.245630, -0.006530, 1.965770, 
0.248510, 0.165750, 0.325030, 0.143320, 0.849110, 0.884100, -0.808980, 0.291020, 0.035060, 0.927780, 
0.394250, 0.082900, 0.247780, -1.141780, -0.285750, -0.574310, 0.453900, 0.156820, -0.651670, -0.108510, 
1.316520, 0.433820, 0.120910, -0.486180, -0.100220, 0.860820, 0.388970, -0.072510, 0.449240, -0.183090, 
0.385640, 0.241560, 0.215210, -0.050880, -1.337760, -0.354560, -0.510130, -0.172720, 0.378680, -0.162460, 
-0.156890, 0.983200, 0.336710, 0.423140, -0.605950, 0.301290, 0.162740, -0.287150, 0.260010, 0.214270, 
0.021520, 0.747850, 0.258580, 0.633610, -0.051710, -1.224170, -0.533500, -0.665290, 0.040370, -0.086920, 
-0.371930, -0.211060, 0.613400, 0.188980, 0.281130, 0.301070, -0.213160, 0.331230, -0.044180, 0.092690, 
0.045470, 0.177440, 0.333910, 0.487060, 0.252360, -0.116350, -0.179800, -0.525170, -0.411340, 0.456470, 
-0.168590, -0.404070, -0.239940, 0.411920, -0.048890, 0.037480, -0.227830, -0.206300, -0.019340, 0.002860, 
0.150690, -0.129610, -0.081970, 0.113150, 0.286930, -0.137950, -0.158170, -0.053850, -0.390900, -0.334890, 
0.018740, 0.369880, -0.385030, -0.224620, 0.403920, 0.043410, 0.022520, -0.249540, -0.149480, -0.269860, 
0.143210, -0.303600, 0.241410, -0.147330, 0.252660, 0.031320, -0.087200, -0.152060, -0.008440, -0.287330, 
-0.380870, 0.220940, 0.471450, -0.422220, -0.214410, -0.012760, 0.400270, 0.020290, 0.362370, -0.497070, 
0.026060, 0.264830, -0.208770, 0.095290, -0.059810, -0.003300, 0.211920, -0.395200, 0.013250, 0.069130, 
-0.291800, -0.273200, -0.140390, 0.062710, -0.089810, -0.213060, -0.023000, 0.461040, -0.054720, 0.259890, 
0.209220, 0.315470, 0.468720, -0.288530, 0.235500, 0.304470, 0.162560, 0.083670, 0.068840, 0.079960, 
0.132400, -0.279780, -0.321360, 0.165040, 0.434270, -0.008670, -0.225300, 
0.259580, -0.017330, 0.111640, 0.188900, -0.042390, 0.297300, 0.317490, 0.169990, -0.022480, -0.017920, 
0.288390, 0.042800, 0.146560, -0.451580, -0.184180, -0.158160, 0.017540, -0.153510, -0.156580, -0.026780, 
-0.027700, 0.032380, -0.067460, 0.290040, 0.124160, 0.222510, 0.175090, 0.485090, -0.233970, 0.140860, 
0.000830, -0.029420, -0.234350, -0.119150, -0.109290, -0.101110, 0.324470, 0.520300, 0.212070, -0.043270, 
-0.336370, -0.018330, 0.118210, 0.180210, -0.314610, 0.198510, -0.400710, -0.293990, -0.181370, -0.212980, 
0.176640, 0.254720, 0.343410, -0.181970, 0.073940, 0.297790, 0.306210, 0.131440, 0.021730, 0.150320, 
-0.359310, 0.033290, -0.006490, 0.251640, 0.631410, -0.106810, 0.019830, 0.304290, 0.357050, 0.256470, 
0.243740, -0.020790, -0.123240, 0.017900, 0.135050, -0.039920, 0.181720, 0.309900, -0.221790, -0.377750, 
0.239250, 0.238190, -0.376790, -0.001490, 0.482990, 0.671450, 0.300030, 0.267660, -0.022810, 0.220860, 
0.906230, -0.184670, 0.022580, -0.091430, 0.251400, 0.492900, 0.128290, 0.020150, 0.120170, 0.098570, 
0.131310, 0.368050, 0.308710, -0.037030, -0.015040, 0.501670, -0.337560, 0.342640, -0.032280, -0.351690, 
0.114760, -0.235970, -0.236890, 0.246850, 0.108860, 0.139510, -0.280110, 0.148070, 0.602120, 0.124630, 
-0.170470, -0.085670, -0.159810, 0.205200, -0.400440, -0.000100, 0.409230, -0.050260, -0.378530, -0.554770, 
0.083970, -0.252590, -0.531210, -0.362540, -0.072560, 0.591320, 0.550420, -0.188480, 0.207340, 0.446030, 
-0.059280, -0.188050, -0.180510, 0.047270, 0.145320, 0.134100, 0.003690, 0.485450, 0.664300, 0.472980, 
0.365520, 0.589680, 0.585160, 0.538370, 0.454500, -0.393970, 0.102800, 0.166810, 0.811300, 0.288070, 
-0.086380, 0.022830, 0.161150, -0.474680, 0.664260, 0.276690, -0.145140, -0.002170, 0.900420, 0.351100, 
0.126840, 0.389300, -0.226030, 0.169380, 0.732800, 0.041760, 0.363370, 0.084050, 0.264930, 0.568990, 
-0.045620, 0.257370, -0.340720, -0.109120, -0.033730, 0.307790, 0.357550, 0.076650, 0.006350, 0.267650, 
-0.505590, -0.304810, -0.429940, 0.359470, -0.255820, -0.411260, -0.278820, 0.571000, 0.526530, 0.409790, 
-0.708250, 0.324780, 0.540060, -0.354970, -0.550690, -0.298180, 0.450380, 0.635800, 0.346110, -0.030340, 
0.031090, 0.461010, -0.355130, -0.516520, -0.288670, 0.172650, -0.474950, 0.012090, -0.170440, 0.394380, 
0.580760, 0.228900, 0.435440, 0.027470, 0.002700, -0.385660, -0.059450, -0.096990, -0.371480, -0.021310, 
-0.078680, 0.709550, 0.822080, 0.689530, 0.438860, -0.056600, 0.450810, 0.498860, 0.741190, 0.180120, 
-0.172340, -0.122840, 0.534790, 0.001990, -0.154510, 0.234380, 0.156500, 0.068600, 0.361160, -0.148600, 
-0.411260, -0.112270, 0.760300, 0.192480, 0.132560, 0.311400, -0.139380, 0.257460, 0.427240, 0.105880, 
0.126730, 0.211750, 0.411850, 0.269680, 0.041960, 0.296530, -0.589180, 0.145800, 0.074910, 0.199320, 
0.370440, 0.083600, -0.118590, -0.171080, -0.042740, 0.196360, -0.350790, -0.162660, 0.056380, -0.273850, 
-0.027060, 0.313040, 0.212840, 0.526760, 0.015590, 0.332030, 0.179730, -0.082390, -0.149810, 0.017420, 
-0.281950, 0.342000, -0.043270, -0.106790, -0.082450, 0.008260, 0.118780, -0.029620, 0.181590, 0.208730, 
-0.223490, -0.030560, -0.169010, -0.019750, 0.120670, 0.622490, -0.088390, 0.105120, 0.198110, -0.047060, 
-0.187030, 0.521170, 0.164620, 0.110480, -0.126490, 0.481500, 0.437670, 0.175700, 0.079270, 0.100570, 
0.099070, 0.145700, 0.133110, -0.084160, 0.203930, 0.258620, 0.276180, 0.236160, 0.170550, -0.191290, 
-0.006410, -0.270550, 0.012590, -0.297690, -0.193270, -0.131590, 0.009860, 0.103720, 0.060280, 0.084680, 
0.048160, 0.162540, 0.128450, -0.693510, 0.097680, 0.182140, 0.037590, -0.020230, 0.291860, -0.055060, 
0.073580, -0.125330, -0.069090, -0.219770, 0.448020, 0.297690, -0.145700, 
0.092470, 0.453540, 0.040480, -0.131410, 0.084950, 0.150660, -0.029240, 0.141730, 0.212790, 0.246430, 
0.175500, 0.007810, 0.070420, 0.160340, -0.028800, -0.044750, -0.021930, 0.049680, 0.136080, 0.132500, 
0.050210, 0.181650, -0.217590, 0.026300, 0.339490, -0.007260, 0.018500, 0.238190, 0.162380, -0.327320, 
0.061140, 0.345160, -0.160190, -0.088450, 0.119600, 0.228820, 0.153100, 0.105240, -0.140170, -0.241930, 
0.182810, 0.071760, -0.017470, -0.125110, -0.179730, -0.170190, 0.121530, 0.018860, 0.092630, 0.226030, 
0.137060, 0.415040, 0.348220, 0.016200, -0.250960, 0.012610, -0.111060, -0.292510, -0.252050, 0.413900, 
0.157300, 0.399610, 0.080730, 0.267310, 0.070250, -0.065640, -0.020570, -0.017390, -0.061200, 0.430830, 
0.209600, 0.120000, 0.177670, 0.313330, 0.290540, 0.173330, 0.079440, 0.103090, 0.014660, -0.277440, 
0.194170, 0.208130, -0.008430, 0.095070, 0.430370, 0.203130, -0.140640, -0.120530, 0.164500, 0.083080, 
-0.223130, -0.001770, -0.131530, 0.247460, 0.526460, 0.476990, 0.108900, -0.098390, 0.261910, 0.124160, 
0.138180, -0.178130, -0.369130, 0.178830, 0.108270, -0.013380, 0.106840, 0.037210, 0.532100, 0.036070, 
0.346280, 0.386980, 0.213100, -0.050450, 0.046830, 0.378930, 0.199740, -0.015750, 0.205600, 0.336870, 
0.223230, 0.118270, 0.537640, 0.496560, -0.054730, 0.117640, 0.183360, 0.602660, 0.326140, 0.360880, 
-0.085470, 0.421180, 0.296800, 0.144010, 0.347180, 0.366880, 0.656080, 0.436380, 0.324860, 0.374130, 
0.584710, 0.327500, 0.467070, 0.450050, 0.464080, 0.334050, 0.120230, -0.009440, -0.202310, 0.656880, 
0.701240, 0.480960, 0.060690, -0.157070, 1.376490, 0.190990, 0.211100, 0.112080, 0.224360, -0.045470, 
0.110370, -0.198950, 0.150070, 0.066240, 0.370860, -0.131580, -0.062160, 0.113860, -0.197220, -0.003920, 
0.309570, 0.606310, 0.192230, 0.066800, -0.182890, 0.134710, 0.291400, 0.157980, 0.080760, -0.077160, 
0.227610, 0.106700, -0.119510, -0.012080, -0.050390, 0.473470, 0.088000, 0.062990, -0.000470, -0.420100, 
0.404120, 0.238340, 0.082710, 0.149170, 0.264890, -0.231920, -0.110760, 0.204280, 0.077050, 0.038380, 
0.356800, 0.069540, -0.201100, 0.998210, 0.127980, 0.109920, 0.000050, -0.083330, 0.064080, 0.011980, 
-0.457970, 0.007130, 0.018430, -0.036800, -0.185290, -0.309750, -0.443720, -0.011760, 0.084240, 0.162260, 
0.246160, -0.166630, -0.056180, 0.383090, 0.063560, -0.251750, -0.225560, -0.074200, 0.119790, 0.274360, 
0.022470, -0.147410, 0.233290, -0.239880, -0.221630, 0.605700, -0.203290, -0.179290, -0.103460, -0.213590, 
0.245130, 0.301290, 0.035580, 0.209230, 0.299350, -0.194870, -0.015810, 0.208070, -0.466370, -0.000020, 
0.341500, 0.012770, -0.172690, -0.153010, -0.380530, -0.228320, 0.280750, -0.341840, -0.123010, -0.341710, 
0.088460, 0.415070, -0.282970, -0.262670, -0.002090, 0.187030, -0.124750, 0.149830, 0.466430, -0.073050, 
0.100030, 0.345080, 0.010520, -0.465610, 0.135390, -0.128570, -0.008320, 0.145450, -0.176090, -0.130620, 
-0.203760, -0.260510, 0.008420, 0.108320, -0.065540, 0.003180, 0.058250, -0.430490, -0.181300, -0.017800, 
-0.006460, -0.090280, -0.171380, 0.002230, -0.343410, -0.011870, 0.156840, 0.207380, -0.255680, -0.048400, 
0.157990, -0.126960, 0.145360, 0.171810, -0.253550, 0.261900, -0.094020, -0.148880, -0.252200, 0.248820, 
0.057720, -0.097440, -0.094080, 0.202840, 0.006270, -0.154720, 0.055800, 0.143360, -0.112190, 0.227610, 
-0.102390, -0.406740, 0.417040, 0.018540, -0.043530, 0.247590, -0.233070, 0.021450, -0.080350, -0.186700, 
0.192260, -0.129940, -0.223600, 0.070920, -0.069590, 0.000830, 0.026330, -0.070010, -0.241110, -0.038720, 
0.130830, -0.014430, -0.246520, 0.018010, -0.066130, -0.168320, -0.166420, -0.402890, -0.208240, -0.129500, 
0.360440, 0.013150, -0.172260, -0.141690, -0.298560, -0.055960, -0.019990, 
-0.046050, -0.209840, -0.000570, -0.008540, 0.313990, -0.309280, 0.020050, -0.400820, -0.118700, 0.156300, 
0.028890, -0.298440, 0.068730, 0.193900, -0.082980, 0.054650, 0.172420, 0.239420, -0.116920, 0.111530, 
-0.113280, -0.069570, -0.040790, -0.021730, 0.200020, 0.143450, -0.225440, -0.369810, -0.078060, 0.417890, 
-0.075540, -0.201360, -0.235760, 0.119590, 0.063700, -0.065420, 0.344030, 0.412040, -0.037230, -0.145890, 
-0.121270, -0.092950, 0.226340, 0.093510, -0.028510, 0.049940, 0.091680, -0.038100, -0.004650, 0.032060, 
0.091520, -0.176340, -0.312190, 0.019220, 0.146430, 0.064540, -0.269210, 0.234820, -0.210160, 0.201020, 
-0.040530, -0.203640, -0.063970, 0.439360, -0.118940, 0.102850, 0.224890, -0.263180, -0.079050, 0.486120, 
0.052600, -0.439550, -0.087830, 0.167890, -0.062690, 0.141730, 0.271780, -0.251310, 0.094740, -0.163830, 
0.266320, 0.223790, -0.106280, -0.041550, 0.532230, -0.762380, -0.174920, -0.141050, -0.327670, -0.067300, 
-0.385630, -0.032390, -0.184730, 0.371570, 0.407310, -0.384720, 0.216150, 0.365070, -0.267440, 0.189170, 
-0.158710, 0.252430, -0.027170, -0.168240, -0.021560, 0.598540, -0.108940, -0.366190, -0.519690, 0.511900, 
0.025130, -0.065670, 0.239480, -0.442060, -0.098540, 0.456180, -0.100500, 0.197090, 0.045090, -0.356890, 
0.110020, 0.216850, 0.297260, 0.002520, -0.258030, 0.008480, 0.333790, 0.342830, 0.408650, 0.053150, 
0.082810, 0.089500, 0.141320, 0.305710, -0.003290, 0.038540, 0.481300, 0.013420, 0.172290, 0.124940, 
0.025800, -0.042540, -0.171740, 0.317010, 0.528360, -0.247460, 0.003330, 1.017210, -0.122260, 0.056950, 
0.045900, -0.121080, -0.027670, 0.159210, 0.105340, -0.288230, 0.336800, 0.866960, -0.020520, 0.282160, 
0.488860, -0.236360, 0.330350, 0.066560, 0.296640, 0.483380, 0.029880, -0.000810, 0.420970, -0.501540, 
-0.316370, -0.902840, -0.026110, -0.277890, -0.879980, 0.075530, 0.266080, 0.286360, 1.018050, -0.557550, 
0.325720, 0.338620, -0.271510, -0.261590, -0.310500, 0.379000, 0.423710, 0.096120, 0.009640, 0.611250, 
0.132990, 0.041850, -0.404590, 0.222740, -0.021050, -0.233900, 0.074540, -0.436360, 0.323170, 0.795660, 
-0.184130, 0.305620, 0.311010, -0.345940, -0.059970, 0.067580, -0.090580, -0.220250, -0.076900, -0.012500, 
0.601320, 0.555640, 0.627640, 0.141910, 0.049830, 0.497290, 0.549220, 0.186180, 0.304620, 0.339290, 
0.545700, 0.641700, 0.321030, 0.309560, -0.200240, 0.068130, 0.404410, 0.388110, 0.224520, 0.144120, 
-0.021980, 0.872470, -0.177710, 0.460680, 0.119940, 0.441930, 0.255830, 0.002370, 0.076870, 0.383790, 
0.031940, 0.548180, 0.053790, 0.296050, 0.486460, -0.088520, 0.097720, 0.424390, -0.177110, 0.387780, 
-0.063640, -0.023890, 0.532820, -0.273350, -0.178870, -0.329380, 0.300500, 0.069200, -0.228000, 0.039000, 
0.170760, 0.268960, 0.733410, -0.334090, 0.132790, 0.262860, -0.037280, 0.083520, 0.180340, -0.106000, 
0.178500, 0.389460, -0.062170, 0.527320, -0.010640, 0.258810, -0.270190, -0.113980, 0.125970, -0.205050, 
0.018740, 0.034910, 0.294890, 0.410150, 0.062350, 0.055020, -0.059610, -0.155030, 0.240190, 0.024350, 
-0.162200, -0.040670, 0.334750, -0.080400, 0.318420, -0.028080, -0.368810, 0.074600, 0.148860, 0.226750, 
-0.038410, -0.133550, 0.215470, -0.107120, 0.326080, 0.001800, 0.335750, -0.055040, 0.331290, -0.000380, 
-0.226540, 0.445480, 0.175710, -0.045830, -0.104560, 0.176740, -0.264290, -0.092730, 0.062400, 0.492260, 
-0.248580, 0.011320, 0.144770, 0.208250, 0.081600, 0.268200, -0.109720, 0.339430, 0.156560, -0.263030, 
0.068730, -0.272150, 0.053230, 0.221210, -0.005570, -0.104590, -0.128020, 0.023830, -0.064290, -0.300330, 
0.004800, -0.019660, -0.174670, -0.115240, 0.204980, 0.350770, 0.469010, -0.125880, 0.419900, 0.215570, 
-0.165700, -0.192690, -0.194620, -0.037550, 0.035650, 0.051630, -0.115300, 
-0.139470, 0.071630, -0.138910, -0.237660, 0.102180, 0.138690, -0.214790, 0.235990, 0.069860, 0.183610, 
-0.270520, 0.188640, -0.158290, 0.073250, 0.315370, -0.114730, -0.252420, 0.493250, 0.205860, 0.038470, 
-0.058080, -0.189490, 0.279580, -0.114690, -0.164120, -0.185060, 0.392880, 0.074920, 0.149490, 0.116970, 
0.053270, 0.170780, 0.137960, 0.072440, 0.088720, 0.155150, 0.115680, 0.028400, 0.639520, 0.099870, 
0.025710, -0.087700, -0.013840, 0.112260, -0.179500, 0.087290, -0.154430, -0.337160, -0.491150, 0.116970, 
0.058290, 0.274860, -0.025410, 0.066770, 0.175290, 0.310260, 0.119410, -0.237080, 0.340220, 0.399050, 
0.211700, 0.280310, -0.113640, -0.255380, 0.384120, 0.040930, -0.365260, 0.157950, -0.185520, 0.038130, 
0.250500, -0.063120, 0.330420, 0.337180, 0.138850, -0.177620, -0.138180, 0.171150, -0.058340, -0.001630, 
0.264460, -0.230290, 0.352480, -0.106940, -0.272690, 0.111450, -0.035680, 0.098410, 0.289040, 0.043640, 
-0.225580, 0.047970, 0.106380, 0.089060, 0.054650, 0.143080, -0.076960, -0.133850, 0.481550, 0.069380, 
0.243030, -0.066610, 0.072070, 0.148300, -0.118420, -0.184560, 0.134740, -0.200540, -0.052610, 0.251420, 
-0.316710, -0.133170, 0.103300, 0.208270, 0.053440, 0.016790, -0.077480, 0.253760, 0.434900, 0.017150, 
-0.104700, -0.272520, -0.249490, -0.047330, -0.013480, -0.103290, -0.450050, 0.532710, -0.222510, -0.029150, 
-0.088860, 0.179550, 0.157310, 0.217980, 0.341730, -0.124020, -0.226960, 0.380230, 0.015970, 0.053050, 
0.311230, 0.485950, 0.276070, 0.120210, -0.304260, -0.363480, -0.098330, -0.075870, -0.249570, -0.350630, 
-0.286620, 0.260900, -0.070960, -0.578860, 0.346130, 0.095740, 0.288790, -0.441530, -0.022280, 0.075530, 
0.053340, -0.468430, -0.397290, 0.159050, -0.171680, -0.301180, 0.730790, -0.053540, -0.282160, 0.760640, 
0.321100, -0.086510, 0.149820, 0.330610, 0.872050, -0.324600, 0.600180, 0.289180, 0.013520, 0.784640, 
0.125610, 0.130900, -0.546670, 0.776770, 0.651860, -0.042470, 0.266000, 0.655850, -0.007080, 0.133440, 
-0.439390, -0.762280, -0.663370, 0.010790, -0.321640, -0.262220, 0.307510, -0.198790, 0.508580, -0.022050, 
-0.203980, 0.098860, 0.464090, -0.321880, -0.317110, -0.487330, 0.782070, 0.049630, 0.609970, -0.034660, 
-0.367880, 0.376070, 0.041410, 0.080660, 0.184360, 0.199500, 0.452400, -0.549560, 0.093460, 0.314700, 
-0.087640, 0.258890, 0.367450, 0.182140, -0.181040, 0.771560, 0.879060, 0.445150, 0.705810, 0.417920, 
-0.057480, -0.102990, -0.231470, -0.409880, -0.538560, 0.739840, -0.584080, -0.357660, 0.373200, -0.299130, 
0.216260, -0.013540, -0.211710, 0.502210, 0.082150, 0.189450, -0.325110, -0.217650, 0.168440, -0.250030, 
0.519510, -0.040210, -0.500710, 0.614970, 0.050090, 0.181470, 0.083400, 0.329820, 0.283970, -0.538850, 
0.280980, 0.141560, 0.079050, 0.496620, 0.386820, -0.233470, 0.097190, 0.126540, 0.420700, -0.122930, 
0.178080, 0.342090, -0.053980, -0.136470, -0.010370, -0.212530, -0.175850, 0.189220, -0.234500, -0.279880, 
0.526360, 0.156470, 0.068600, 0.086820, -0.163310, 0.299070, -0.027900, 0.332530, -0.041980, -0.043140, 
0.192750, -0.042980, 0.403020, -0.055250, -0.248000, 0.113560, 0.302020, 0.269550, -0.097920, 0.264350, 
0.272970, 0.521710, 0.007260, -0.325440, -0.153440, -0.170860, -0.110490, -0.070440, 0.232930, -0.127670, 
0.293850, 0.298850, -0.354500, 0.099210, -0.065660, -0.257950, -0.131880, -0.029840, 0.243770, 0.151090, 
-0.157480, 0.059980, 0.339550, 0.084900, 0.045360, -0.094580, -0.116030, -0.026610, 0.134890, 0.080080, 
0.022040, -0.181860, -0.330170, -0.241360, 0.012640, -0.069770, -0.197030, 0.232940, -0.074270, 0.373690, 
0.195570, 0.165320, 0.182450, -0.091210, 0.177030, -0.097130, 0.071510, 0.168830, 0.040800, -0.051870, 
0.452990, -0.008370, 0.278900, -0.109010, -0.185250, -0.063360, -0.049280, 
0.037630, -0.212110, -0.010240, -0.149930, 0.054020, -0.249250, -0.190900, -0.631020, -0.022370, 0.191870, 
0.293140, -0.230360, 0.070000, 0.191870, -0.309660, 0.114010, -0.125060, 0.253290, 0.059240, 0.358970, 
0.082850, 0.304500, 0.202550, -0.136670, -0.127990, -0.066480, 0.024480, -0.115970, -0.354590, -0.081250, 
-0.283540, -0.023110, -0.030420, 0.103150, -0.141680, 0.252320, -0.040090, 0.018060, 0.002790, -0.151710, 
-0.071430, 0.079430, 0.518530, -0.242980, -0.106840, -0.062050, 0.034840, -0.016820, -0.005750, 0.059250, 
-0.342630, -0.079210, -0.126490, -0.135190, -0.431640, -0.229470, -0.051260, 0.150680, -0.222070, -0.010050, 
-0.248310, -0.109440, 0.105520, 0.149750, 0.061210, 0.202670, 0.350000, -0.006100, -0.132370, 0.049970, 
0.116920, 0.032120, -0.421920, 0.002300, 0.095730, -0.308010, -0.398760, 0.214160, 0.078910, -0.124450, 
-0.448170, -0.347680, -0.464920, 0.112990, 0.143340, -0.101710, 0.280900, 0.255580, 0.053620, 0.080840, 
-0.170780, 0.247330, 0.010340, -0.300650, 0.018570, 0.045470, -0.089590, 0.108960, -0.100830, -0.053990, 
-0.225530, 0.201940, -0.355790, -0.511530, 0.099470, -0.196260, 0.031210, 0.344210, 0.378950, -0.122370, 
0.228170, 0.139980, -0.398760, -0.086270, -0.260350, 0.102170, 0.191910, -0.087670, -0.149850, 0.158410, 
0.149020, -0.258350, -0.084850, 0.473070, -0.276900, 0.086580, -0.068520, -0.151790, 0.300230, 0.197440, 
0.138080, -0.366700, -0.587240, -0.033370, -0.531460, -0.160680, 0.087420, -0.229760, 0.270330, -0.320930, 
0.227900, -0.320910, -0.160170, -0.198290, -0.135630, -0.393580, 0.042370, -0.068890, -0.078220, 0.282980, 
0.189280, -0.437920, -0.094340, -0.061690, -0.520060, 0.194770, -0.212230, 0.176400, -0.032060, -0.182310, 
-0.419400, 0.433810, 0.059240, 0.311510, -0.823950, -0.148800, -0.255480, 0.022690, 0.230130, -0.188850, 
0.134660, 0.015610, -0.222180, -0.451080, -0.266680, 0.259840, -0.347910, -0.176640, 0.313600, -0.371260, 
-0.139390, 0.184450, 0.006190, -0.091770, -0.302360, -0.413430, -0.256210, -0.301890, -0.000110, 0.438670, 
-0.296690, -0.077910, -0.718490, 0.081780, -0.245910, -0.328200, 0.376050, 0.045570, -0.027160, 0.081740, 
-0.124290, -0.280220, 0.100100, -0.140170, 0.235260, -0.137150, 0.221680, 0.104220, -0.162900, 0.057680, 
-0.048010, 0.329030, -0.175930, -0.583650, 0.136540, 0.098090, -0.035100, -0.102710, 0.189300, -0.205560, 
0.039830, 0.042360, 0.011120, -0.180600, -0.469390, -0.136650, -0.317600, 0.215380, -0.156350, -0.375380, 
0.066990, 0.032470, -0.132910, -0.300180, -0.645050, 0.294800, -0.071940, -0.406320, -0.667770, -0.011550, 
0.339070, 0.266210, -0.638510, 0.100230, 0.229750, -0.022820, -0.449400, -0.119890, 0.265360, 0.160330, 
0.074090, 0.042980, 0.059390, -0.077170, -0.323700, -0.033160, -0.071560, -0.013900, 0.461540, -0.480330, 
-0.039480, 0.014160, -0.045490, -0.068270, -0.244520, 0.186010, 0.375840, 0.073340, -0.245240, 0.117330, 
-0.202580, -0.355120, 0.043340, 0.095610, -0.189980, -0.385560, 0.084420, -0.060350, -0.068560, -0.166100, 
-0.418130, -0.240360, -0.078020, 0.102360, -0.249430, -0.090930, 0.024460, -0.086050, -0.290690, -0.282900, 
-0.111210, 0.038750, 0.039610, 0.063000, -0.037280, -0.190580, 0.379840, 0.243210, -0.332870, 0.255240, 
0.091650, 0.275720, 0.151140, -0.301240, -0.255410, 0.363290, -0.380020, -0.143040, 0.100700, 0.057640, 
-0.334000, -0.271160, -0.117150, -0.343270, 0.053480, -0.128450, 0.263050, 0.254990, 0.200560, 0.126670, 
-0.086870, -0.108450, 0.272220, 0.046980, 0.089940, 0.452780, 0.095450, 0.062080, -0.427120, -0.029780, 
0.055360, -0.316760, -0.469560, -0.393770, -0.043450, 0.052490, 0.308600, 0.013500, -0.076980, 0.145150, 
-0.007140, -0.175450, -0.034190, -0.014200, -0.065180, -0.217870, 0.186920, -0.028250, -0.013360, 0.231680, 
-0.132510, 0.074790, -0.183300, -0.362980, 0.198770, -0.234390, 0.043410, 
-0.132810, 0.158300, 0.066050, -0.151770, 0.214090, -0.002350, -0.168580, 0.130580, -0.275140, 0.253410, 
0.160330, -0.068240, 0.011310, 0.296470, -0.037840, -0.133780, -0.170280, 0.394610, 0.021520, 0.275120, 
0.105410, 0.026830, 0.216160, 0.128680, 0.025890, 0.187050, 0.099390, 0.213770, 0.300290, 0.146040, 
0.134720, -0.000080, 0.194800, 0.039590, 0.069480, 0.003650, 0.076950, -0.002770, 0.035240, 0.159490, 
0.050050, 0.111300, 0.169390, -0.345260, -0.114210, -0.181920, 0.240850, -0.185710, -0.050870, -0.108150, 
0.314830, -0.099780, -0.210130, -0.118630, -0.121450, 0.096080, 0.204500, -0.033350, 0.144260, 0.098240, 
0.300530, -0.015960, 0.100940, 0.178890, -0.225500, -0.196960, 0.241320, 0.241520, -0.195920, 0.029060, 
0.172180, 0.184840, -0.086350, -0.237090, -0.316440, -0.040250, -0.045460, 0.099820, 0.022290, -0.189110, 
0.422550, -0.108480, -0.057430, 0.109160, 0.178300, 0.042090, 0.058710, -0.095960, 0.285640, -0.095510, 
-0.018750, 0.091620, 0.062290, 0.053390, -0.156370, -0.056980, -0.075000, 0.124870, 0.127920, 0.293750, 
0.006980, -0.074430, 0.088020, -0.047710, 0.089340, 0.158030, 0.117890, 0.285290, 0.303420, 0.020490, 
-0.189610, -0.115920, 0.434170, -0.008880, 0.152350, -0.149500, 0.030140, -0.066850, 0.110490, 0.335740, 
-0.023590, -0.047390, -0.195590, -0.090440, 0.076710, 0.091700, -0.123830, 0.121430, 0.235830, 0.005120, 
0.348510, -0.151770, -0.377260, -0.133150, 0.143180, 0.215160, 0.385510, -0.096710, 0.057500, 0.084280, 
0.360300, -0.002320, 0.057190, -0.153950, -0.005730, -0.166140, 0.089130, -0.166400, -0.195360, 0.507960, 
0.392390, 0.000530, -0.025010, -0.022530, 0.482120, 0.077460, -0.158510, -0.027570, 0.163330, 0.016420, 
-0.104190, 0.824680, 0.161080, 0.109980, 0.001050, 0.112500, -0.285130, 0.068650, -0.256660, -0.006590, 
0.755530, 0.575380, -0.049060, -0.138010, -0.314600, 0.827690, 0.194610, -0.370360, -0.080740, -0.132370, 
-0.373390, -0.133530, 0.711990, 0.342890, 0.416960, -0.051530, -0.019740, -0.342950, 0.000020, -0.512300, 
-0.154770, 0.036890, 0.361770, -0.018690, -0.026160, -0.381090, 0.187340, 0.084590, -0.176600, -0.036570, 
-0.018660, -0.025570, -0.218820, 1.258060, -0.052690, 0.193540, -0.184450, -0.237370, -0.204580, 0.043680, 
-0.256340, 0.218270, -0.044290, 0.178460, 0.094050, -0.195090, -0.153930, 0.210770, -0.165720, -0.225440, 
-0.039390, -0.022630, -0.076020, -0.160330, 1.028590, 0.244900, 0.350910, 0.171590, -0.273980, -0.021790, 
0.055320, -0.329080, -0.085210, 0.202130, 0.366200, -0.127340, -0.230880, 0.065240, 0.168600, 0.198660, 
-0.145620, -0.119680, -0.252180, -0.263570, -0.072980, 0.007400, 0.008620, 0.134340, -0.195440, -0.275210, 
0.001310, 0.045220, -0.031950, -0.307730, -0.042340, 0.065800, -0.013180, -0.097860, -0.219570, -0.255540, 
-0.053660, 0.105410, -0.185730, -0.353130, -0.155370, 0.144260, 0.391630, 0.219450, 0.182050, -0.230230, 
0.169450, 0.176740, 0.038880, -0.006120, -0.071840, -0.070280, -0.192470, 0.173140, 0.026180, 0.019430, 
-0.085620, -0.091160, -0.302990, -0.086240, -0.147250, -0.212590, -0.202040, 0.075010, -0.058290, 0.011890, 
0.112940, -0.089090, -0.151080, 0.035210, 0.182050, -0.096500, -0.092210, -0.227820, 0.218210, -0.032640, 
-0.028380, -0.238250, -0.002420, 0.117340, 0.055000, 0.074390, -0.173170, 0.050810, -0.053400, -0.052630, 
-0.095040, -0.035590, -0.126040, 0.038860, 0.023730, -0.010500, -0.174410, 0.122130, 0.090540, -0.273350, 
-0.010590, -0.086920, 0.107380, -0.218300, -0.000970, 0.004470, -0.028120, -0.206860, -0.195590, 0.019750, 
-0.082020, -0.064640, -0.058250, 0.050460, -0.019040, 0.020250, 0.214490, 0.076760, 0.422310, 0.266560, 
-0.154890, 0.020820, -0.048920, 0.098710, 0.163610, -0.180810, -0.025110, -0.060440, -0.135320, -0.119570, 
-0.246240, 0.017230, 0.107410, -0.193470, -0.134860, -0.170530, 0.025370, 
0.115190, -0.011780, 0.158060, 0.140750, -0.094070, -0.000320, 0.129250, 0.245510, 0.292420, 0.126690, 
0.218600, 0.104660, 0.192540, -0.058980, 0.270490, 0.165540, 0.025330, -0.147620, 0.085740, 0.170950, 
-0.117790, -0.029250, -0.237080, 0.084720, 0.191170, 0.572120, 0.030420, -0.215430, -0.074600, -0.160090, 
0.196820, 0.020960, -0.051870, -0.164850, 0.165690, -0.242750, 0.171580, 0.347420, 0.241420, 0.024460, 
0.134880, -0.139300, -0.280480, -0.256540, 0.135560, -0.195850, 0.381640, -0.073360, -0.070790, 0.398710, 
-0.324590, 0.135820, 0.452680, 0.047360, -0.039730, -0.208500, -0.045070, 0.168180, -0.197400, 0.077110, 
-0.245140, 0.192160, -0.156170, -0.374270, 0.511630, 0.030070, 0.388930, -0.095360, 0.254240, 0.154330, 
0.463980, -0.028760, -0.108470, -0.143970, 0.557400, -0.268660, 0.062150, 0.235640, 0.378530, 0.459530, 
-0.025850, -0.093150, -0.120330, -0.155580, -0.307060, -0.261120, 0.011280, 0.286230, 0.419610, -0.121750, 
-0.277150, 0.385580, -0.138910, 0.602410, 0.153090, -0.169930, -0.111970, -0.125930, -0.047790, -0.141420, 
0.209050, -0.270730, -0.198680, 0.446730, -0.149880, -0.473440, 0.783410, 0.468290, 0.357150, -0.456690, 
0.325570, 0.540640, 0.772800, 0.501000, -0.315640, -0.414220, 0.816800, -0.082180, -0.212500, -0.165450, 
0.296990, 0.230900, 0.098860, 0.075890, -0.121230, -0.128210, -0.283620, 0.162500, 0.029070, -0.221250, 
-0.141550, -0.220870, -0.214590, 0.358860, 0.142780, 0.191890, -0.170480, -0.076190, -0.212900, 0.504350, 
-0.246120, 0.175910, 0.302670, 0.095430, 0.074370, 0.285220, -0.098200, -0.600060, 0.313020, -0.259870, 
-0.223580, -0.088550, 0.057050, 0.216680, -0.252250, 0.048520, 0.500870, -0.284810, 0.021460, 0.079390, 
0.326150, -0.339860, 0.035990, 0.674380, 0.234570, 0.163670, 0.842030, -0.094360, -0.224600, 0.320870, 
-0.263680, -0.266030, 0.047470, -0.197290, 0.072740, 0.376400, 0.050110, 0.447890, 0.032340, 0.145420, 
-0.160030, 0.095690, -0.169250, 0.114680, 0.240600, -0.122110, 0.000850, 0.763240, -0.001840, -0.162850, 
-0.177130, -0.331570, -0.287030, 0.017760, -0.242130, 0.003460, -0.164160, 0.614140, 0.663610, 0.096500, 
-0.171970, -0.000520, 0.229860, -0.125610, 0.090980, 0.103880, -0.057090, 0.402700, 0.732600, -0.063020, 
0.011220, -0.038940, 0.083030, 0.041460, 0.133740, -0.184500, 0.181770, 0.443010, -0.187720, 0.208100, 
-0.281400, -0.105860, -0.327490, 0.043170, -0.135450, 0.352630, 0.225890, -0.049570, -0.338770, 0.214030, 
-0.062220, -0.087030, -0.129020, -0.324500, -0.003910, 0.520450, -0.244700, -0.126590, 0.437090, -0.094420, 
0.219670, -0.316780, -0.128100, -0.009510, -0.404140, 0.302490, 0.411580, 0.508010, 0.047150, -0.227920, 
0.070830, -0.076160, -0.419220, -0.032220, 0.196430, 0.236620, 0.167360, -0.005970, -0.346930, 0.197120, 
0.173970, 0.269570, 0.063060, -0.084270, -0.210000, -0.025160, 0.135550, 0.152940, 0.244960, 0.182890, 
-0.102890, -0.031340, -0.045000, 0.066670, -0.090340, 0.228700, 0.021930, -0.058220, -0.284740, -0.293430, 
0.906090, -0.134110, -0.326330, -0.347360, -0.023640, -0.113560, 0.096010, 0.060670, 0.652440, 0.619840, 
0.144870, -0.124490, 0.086510, -0.057470, -0.357990, -0.127060, -0.018420, 0.235560, 0.152470, -0.143430, 
0.338330, 0.046920, 0.231170, 0.085130, -0.097020, 0.115240, -0.057020, 0.188120, 0.247030, 0.113730, 
0.311940, -0.016960, 0.040130, 0.024220, -0.076400, -0.281490, 0.245850, 0.104880, 0.153030, 0.272910, 
0.170800, 0.091410, 0.825160, -0.093100, -0.154340, -0.206360, 0.032640, -0.042460, 0.012220, -0.285520, 
0.245710, 0.224280, 0.300110, -0.149080, 0.060160, -0.090590, -0.221700, 0.107520, -0.074150, -0.112860, 
-0.123860, 0.341850, 0.226700, -0.008480, -0.191880, -0.051690, -0.095820, -0.009510, -0.032260, 0.109670, 
0.251910, 0.098760, 0.336490, -0.048490, 0.124680, 0.070090, -0.087630, 
-0.048880, 0.045240, 0.037340, 0.239940, 0.218580, 0.057510, 0.204500, 0.213730, 0.169560, 0.192520, 
0.138120, 0.103030, 0.173690, 0.165850, 0.350590, 0.006840, -0.053490, 0.422780, 0.305150, 0.150310, 
0.193430, 0.098210, -0.095050, -0.016380, 0.047930, 0.136780, 0.036400, 0.016800, 0.252730, -0.021490, 
0.133300, 0.209070, -0.026700, 0.256930, 0.243010, 0.055430, 0.037070, -0.066200, 0.534120, 0.228040, 
-0.008400, 0.154400, -0.050500, 0.047860, 0.143070, 0.151250, 0.304190, 0.195150, 0.050780, -0.046960, 
0.167710, 0.182700, 0.031500, -0.015790, 0.032990, 0.429140, 0.141840, 0.168280, 0.164070, 0.016450, 
0.281320, 0.035790, 0.175610, 0.090900, 0.023420, 0.163350, 0.128300, 0.251440, 0.159540, 0.365600, 
0.003350, 0.148150, 0.097290, 0.096640, 0.158990, 0.219500, 0.111680, 0.279080, 0.072520, 0.119890, 
0.248270, 0.194790, -0.047950, 0.214370, 0.004330, 0.349100, 0.226520, 0.107640, -0.014250, 0.159440, 
0.147670, 0.297840, 0.268350, -0.035320, -0.049830, 0.360140, 0.081980, 0.186430, 0.149140, 0.140330, 
0.009180, 0.261710, 0.185380, -0.071680, 0.202160, 0.109700, 0.219760, 0.577740, 0.339720, -0.039830, 
0.148560, 0.160490, 0.089130, 0.633790, 0.093810, 0.105570, 0.304930, 0.153170, 0.084500, 0.371520, 
0.329470, 0.139350, 0.295150, 0.133810, -0.000420, 0.200780, 0.100370, 0.137090, 0.114030, 0.051770, 
0.044510, -0.037890, 0.043570, 0.207210, 0.278180, 0.236790, 0.278890, 0.007630, 0.306820, 0.407470, 
0.183030, 0.286440, 0.060850, 0.378280, 0.311390, 0.194990, 0.164620, 0.160820, -0.226120, 0.013960, 
0.239830, 0.137200, -0.046790, 0.005510, 0.714900, -0.090120, 0.035990, 0.046330, -0.039790, 0.148780, 
0.348910, 0.336480, 0.080880, -0.259570, 0.261060, 0.134350, -0.094750, 0.164890, -0.155980, -0.089820, 
0.020020, 0.025780, -0.358470, 0.032520, -0.116410, 0.048520, -0.080540, 0.155620, 0.192380, 0.150260, 
0.288470, 0.234210, 0.064870, 0.021330, -0.276610, 0.278780, -0.119860, -0.025630, -0.006140, -0.119460, 
-0.187230, 0.056910, -0.023690, -0.350380, -0.129030, -0.287160, -0.028260, 0.160180, -0.023570, 0.204640, 
0.094750, 0.042860, 0.012830, 0.508330, -0.103380, 0.171060, -0.060890, 0.130790, 0.171700, 0.009590, 
-0.161030, -0.035560, 0.184840, 0.123330, -0.037770, -0.032170, -0.207940, 0.135500, 0.045890, -0.151150, 
0.069270, -0.153350, 0.072670, 0.365930, 0.157710, 0.127020, 0.230780, -0.058500, 0.154410, -0.282120, 
0.018820, 0.013650, -0.025750, 0.250930, -0.089320, -0.034740, 0.090800, 0.002230, -0.080960, 0.186470, 
-0.059480, 0.038400, 0.005820, 0.028950, 0.074830, 0.099330, 0.171770, 0.254250, -0.079410, 0.330450, 
0.054600, 0.014550, -0.068340, -0.244260, 0.052690, 0.089180, -0.100180, -0.055970, -0.091880, -0.059750, 
-0.084450, -0.229940, -0.214680, 0.140950, -0.007960, 0.088360, 0.153660, 0.048640, -0.015560, 0.171040, 
0.165270, -0.221200, 0.018930, -0.259160, -0.006400, -0.017740, 0.090830, -0.421780, -0.104980, 0.041060, 
-0.212480, 0.061670, -0.118070, -0.048650, -0.054890, -0.252220, -0.034480, 0.100640, -0.057580, -0.241830, 
-0.035510, -0.117390, -0.253710, 0.020560, 0.134290, -0.154390, -0.231600, 0.136490, -0.069620, 0.159250, 
0.131660, -0.299820, -0.115430, 0.010130, -0.041160, 0.028950, -0.125050, 0.014580, 0.142190, 0.123180, 
0.037410, 0.183690, -0.111060, -0.049850, 0.007660, 0.007430, 0.130280, -0.008690, -0.173500, -0.033840, 
0.098120, 0.004070, -0.169560, -0.067180, 0.049370, 0.178800, -0.060760, 0.068390, -0.141010, -0.099910, 
0.140820, 0.156650, -0.387760, -0.024980, 0.121800, 0.020210, 0.204280, -0.050830, -0.120000, -0.015220, 
-0.080190, 0.222570, -0.051240, -0.250930, -0.223340, -0.005520, 0.200900, 0.073930, 0.005690, -0.050290, 
0.270780, -0.126120, -0.223530, -0.206520, -0.290480, 0.044840, 0.014540, 
-0.249190, 0.232300, -0.112840, -0.081030, -0.110080, 0.067600, 0.058370, 0.273660, 0.203790, -0.133060, 
0.123320, -0.021950, 0.012280, 0.148720, -0.354610, 0.075880, -0.046220, 0.182560, 0.146510, -0.428280, 
-0.165160, -0.029790, 0.116710, 0.008920, -0.062910, -0.092770, 0.322310, 0.099450, -0.037600, 0.308150, 
0.111310, 0.174630, 0.063330, -0.060690, 0.237570, -0.146940, 0.057640, 0.094300, 0.182580, 0.291280, 
0.082510, -0.143380, -0.193230, 0.262600, 0.107980, -0.062230, 0.037230, 0.156650, -0.163910, -0.027640, 
0.068820, 0.086210, 0.088670, 0.364470, -0.172620, -0.140450, 0.126470, 0.191880, 0.205930, 0.104990, 
0.011860, -0.126290, -0.172840, -0.071250, 0.009420, -0.162270, -0.092480, 0.258000, -0.142480, -0.221510, 
0.408710, 0.014690, 0.280920, 0.233780, -0.061630, 0.326690, 0.214010, 0.221960, 0.107570, 0.153280, 
-0.202590, -0.081810, -0.044460, -0.157010, -0.207020, -0.340130, -0.202100, -0.128100, 0.000370, -0.095650, 
-0.099970, -0.025000, 0.300240, 0.413620, -0.011640, -0.217940, 0.161910, 0.369230, 0.214030, 0.005460, 
0.175040, 0.018910, 0.427620, 0.365420, -0.139250, 0.107270, 0.162950, -0.076470, -0.200830, 0.153020, 
0.159740, 0.065410, 0.081190, 0.089310, 0.131470, -0.269390, 0.126060, -0.094980, -0.216920, -0.296200, 
0.101020, 0.477460, -0.056740, -0.101510, 0.281050, -0.150970, 0.240080, 0.253380, -0.202520, -0.406680, 
-0.109000, 0.286340, 0.142650, -0.190110, 0.044140, -0.032700, -0.087420, -0.174150, -0.267980, 0.184220, 
-0.482740, -0.153770, -0.061200, 0.504110, 0.352560, 0.036810, -0.119120, 0.079970, 0.147900, -0.865310, 
-0.548590, -0.181730, 0.103740, 0.118930, -0.584260, -0.295870, 0.768160, 0.351680, -0.222530, 0.274230, 
0.287660, -0.782380, -0.219240, 0.137280, 0.341890, 0.229560, 0.487030, -0.098180, 0.365830, 0.332300, 
-0.403750, -0.575260, 0.716790, 0.050310, 0.362070, -0.548460, -0.059680, 0.690040, 0.446610, 0.229720, 
-0.026670, 0.270570, -1.151890, -0.215700, -0.160800, 0.224000, 0.142780, 0.951640, -0.004090, 0.201350, 
0.265550, -0.387460, -0.127060, 0.152090, 0.258160, 0.506160, -0.697870, 0.015220, 0.424610, 0.273680, 
0.368970, 0.120250, 0.245830, -0.738970, -0.099770, -0.014320, -0.082820, 0.260060, 0.519500, -0.098310, 
0.417810, -0.045340, -0.221740, -0.640620, 0.364320, -0.332280, -0.352970, -0.068730, 0.165550, -0.031770, 
0.235820, -0.082520, 0.303760, 0.231030, -0.943040, -0.019520, 0.029630, 0.418360, 0.435800, 0.148010, 
-0.134810, -0.147110, 0.019060, 0.047730, 0.453140, 0.141850, 0.137090, -0.097210, -0.015680, 0.175630, 
-0.000440, -0.066960, -0.117370, 0.000700, 0.033910, -0.442270, -0.019480, -0.221080, 0.142950, 0.017420, 
-0.201690, -0.165390, 0.037950, 0.053780, -0.025050, 0.154710, 0.286200, 0.073970, -0.206230, -0.004980, 
0.250240, 0.183170, 0.110360, 0.072040, 0.236570, -0.170950, -0.022950, -0.013360, 0.003960, -0.116170, 
-0.037580, 0.149780, -0.175840, -0.164170, 0.054550, 0.217770, -0.309360, -0.061770, 0.126230, -0.057140, 
0.146710, -0.109560, -0.102910, 0.040960, 0.163060, 0.261180, -0.010170, -0.111220, -0.070190, 0.046760, 
-0.085190, -0.080180, 0.091960, -0.175770, -0.091270, 0.053700, -0.126330, -0.201490, 0.159230, 0.194310, 
0.187860, 0.083820, 0.078530, -0.111210, 0.003360, 0.391230, -0.075420, -0.154560, -0.062030, 0.007440, 
0.134060, 0.142940, -0.279300, -0.009220, -0.154440, -0.443130, 0.013770, 0.174530, -0.101400, 0.066290, 
-0.079230, -0.104310, -0.366600, 0.049030, -0.085760, -0.106520, 0.106860, 0.036370, 0.361620, -0.021890, 
0.178410, 0.178050, -0.079760, -0.098130, -0.033490, -0.166850, -0.205780, -0.219660, -0.034300, 0.287330, 
-0.163010, 0.198530, 0.190890, -0.171980, -0.031720, 0.306820, 0.019250, -0.026150, 0.123340, 0.237880, 
0.299540, -0.039510, 0.302650, -0.126700, -0.014130, 0.557800, -0.159540, 
-0.324070, 0.100790, 0.416820, 0.288180, 0.032760, 0.203750, 0.032380, 0.272760, 0.087510, -0.220210, 
-0.332200, 0.076360, 0.040490, -0.005780, 0.029680, 0.134850, 0.023230, 0.336430, -0.001270, -0.025510, 
0.095040, -0.081460, 0.338130, 0.199740, 0.020620, -0.184100, -0.081290, 0.192290, 0.275780, -0.074620, 
-0.351330, -0.215460, 0.117770, -0.302650, -0.002850, 0.198510, -0.084200, -0.214280, 0.168490, -0.031510, 
-0.112030, 0.106660, 0.210630, -0.087260, -0.310730, 0.296850, 0.137370, 0.131530, 0.158160, 0.053910, 
-0.176660, 0.140090, 0.150050, -0.042340, -0.215410, -0.069690, 0.140260, -0.010590, -0.023850, -0.207520, 
-0.137130, 0.260950, 0.119050, -0.088260, -0.262590, 0.086320, 0.318540, -0.049430, -0.087680, 0.072420, 
0.059610, 0.127260, 0.063240, 0.003980, -0.189320, 0.161090, 0.130520, 0.171880, -0.133320, 0.095250, 
-0.145180, -0.077430, 0.046910, 0.105200, -0.115870, -0.095790, 0.110030, 0.667270, 0.114780, 0.195270, 
0.317520, 0.080080, 0.129830, 0.075150, -0.039010, -0.004520, 0.207680, 0.061830, 0.031530, -0.004470, 
-0.191250, 0.515240, 0.118910, -0.053370, 0.097880, 0.520250, 0.100040, 0.133410, 0.094580, -0.101850, 
-0.200190, 0.178200, 0.438640, -0.207270, 0.174010, 0.092840, 0.054250, -0.015750, -0.070740, 0.638820, 
0.366860, 0.201220, 0.222840, -0.239130, -0.145540, 0.131570, -0.054740, 0.180500, 0.233180, 0.166640, 
0.119460, -0.055780, 0.011960, 0.693560, 0.070510, 0.202800, 0.257190, 0.283830, 0.000000, 0.065580, 
0.249650, 0.085990, 0.200220, 0.461890, 0.296590, -0.127490, 0.139120, 0.000790, 0.031310, 0.242900, 
-0.131460, 0.069410, -0.097920, -0.054740, 0.669510, -0.019060, -0.080220, 0.169480, 0.086370, -0.014520, 
-0.257230, 1.137430, -0.276020, 0.128320, 0.291660, -0.425700, 0.018190, 0.122860, -0.180940, -0.149130, 
0.076110, -0.042490, -0.093660, -0.181060, -0.426060, 0.253120, 0.096630, -0.055910, 0.363520, 0.097490, 
0.110580, 0.453470, 0.697590, -0.134340, -0.125750, 0.270710, 0.059900, -0.166730, 0.007070, -0.369510, 
-0.431260, -0.026900, 0.356340, -0.036970, -0.523670, -0.339820, 0.236540, 0.049930, 0.056870, -0.087450, 
-0.329610, -0.237000, 0.325020, -0.318100, 0.286050, 0.212630, 0.444110, 0.114110, -0.049280, 0.027140, 
-0.241280, 0.121440, -0.263890, 0.493800, -0.334650, 0.051320, 0.113830, -0.140640, -0.306230, 0.075340, 
0.019440, 0.163740, -0.219650, -0.068690, 0.836240, -0.120130, 0.237470, -0.215880, -0.232840, -0.225800, 
0.033360, 0.197660, 0.351320, -0.041140, -0.004000, -0.111770, 0.091310, 0.498720, 0.102280, 0.057630, 
0.015290, 0.083990, -0.059590, 0.050760, -0.062170, 0.697340, 0.016150, 0.195520, -0.177210, -0.041100, 
0.091280, 0.035940, 0.139590, -0.050370, 0.254930, 0.260650, 0.071490, 0.103740, 0.461460, -0.042770, 
-0.373250, -0.034770, -0.104760, 0.100430, -0.209090, -0.768900, 0.180960, -0.147560, 0.094570, -0.370240, 
-0.526460, -0.071350, 0.051110, 0.121590, 0.148810, 0.449070, 0.190710, -0.047990, -0.068200, 0.050780, 
-0.487690, 0.267620, 0.122400, -0.030870, -0.105120, -0.330980, 0.232450, -0.257580, -0.033860, 0.125970, 
0.182160, -0.035200, 0.053060, 0.032990, 0.198750, 0.181910, 0.028100, -0.125020, 0.030160, -0.002980, 
-0.085660, -0.014880, 0.041350, 0.223910, 0.177490, 0.032980, -0.253530, 0.083560, -0.197460, 0.046660, 
0.100250, 0.149260, 0.174990, 0.116770, 0.021260, -0.078950, 0.160280, 0.271550, 0.426070, 0.032040, 
0.248900, 0.551430, -0.011690, 0.308770, -0.263170, 0.010840, 0.323510, 0.065610, 0.147590, -0.269960, 
0.259180, 0.085360, 0.022570, 0.041400, -0.180150, 0.031860, 0.066180, 0.456370, 0.003440, -0.010230, 
-0.262170, 0.272090, 0.043530, -0.456230, -0.101370, 0.352060, 0.390530, 0.178780, 0.320860, 0.177700, 
-0.234070, -0.066520, 0.073050, -0.322720, -0.019320, 0.429790, 0.040100, 
-0.066010, 0.216970, 0.015110, 0.117220, 0.262760, 0.231670, 0.163030, -0.295100, 0.094360, -0.287370, 
0.136000, -0.137440, 0.118790, 0.214020, 0.072060, 0.091910, -0.018040, 0.334020, 0.262890, -0.260410, 
-0.139310, 0.225190, 0.094790, -0.008570, 0.163900, -0.016090, -0.015290, -0.202600, -0.026250, -0.020690, 
0.197940, -0.083840, -0.108880, 0.000390, 0.240020, 0.203750, 0.116880, 0.152340, 0.205540, 0.003900, 
-0.104670, -0.134180, 0.004470, 0.460690, -0.205630, 0.085980, -0.182380, 0.075850, 0.015020, 0.050490, 
0.113350, 0.169070, 0.252240, 0.328290, 0.123320, -0.250520, 0.056090, -0.249970, -0.011410, -0.278290, 
-0.206350, -0.132820, -0.099410, 0.506760, 0.379380, 0.053850, 0.055960, 0.004280, 0.086600, 0.529340, 
0.035190, 0.066290, -0.099620, -0.005420, 0.439650, -0.175220, -0.132910, -0.122000, 0.191700, 0.060760, 
0.390770, 0.007640, -0.050940, -0.085960, 0.158830, -0.199390, -0.298810, -0.202780, -0.422830, 0.065670, 
0.049610, -0.283800, -0.095130, 0.001960, 0.048300, -0.251580, -0.115730, -0.087900, 0.168960, -0.322940, 
0.190960, -0.252690, -0.019720, -0.065960, -0.080340, -0.047770, 0.151520, -0.043830, -0.255240, 0.006740, 
-0.097350, -0.332030, -0.415680, 0.189380, 0.225140, 0.194730, 0.134270, 0.173360, 0.172950, 0.287320, 
0.071760, 0.126510, 0.070720, -0.073600, -0.097980, -0.055130, 0.359840, 0.709290, 0.659490, 0.883740, 
0.139000, 0.439200, 0.707010, -0.128410, 0.196500, 0.175790, -0.079840, 0.578970, -0.100340, -0.137610, 
0.242100, -0.267430, -0.201490, 0.390950, 0.138440, 0.137880, -0.048450, 0.808460, 0.052570, 0.283050, 
0.731040, -0.045170, 0.479460, 0.598420, -0.193650, -0.185300, -0.029490, 0.346360, 0.046840, -0.216730, 
0.028930, -0.511750, -0.050230, -0.033840, 0.302790, 0.320570, 0.113730, -0.033980, 0.677960, -0.107210, 
-0.182500, -0.294100, 0.249770, -0.207480, -0.402860, -0.097260, -0.038450, 0.365580, 0.646630, -0.449750, 
0.111010, 0.140410, -0.125210, -0.439510, -0.256600, 0.436680, -0.165910, 0.113520, -0.002020, 0.158530, 
0.301710, -0.112280, -0.323190, 0.066960, 0.173290, -0.153160, -0.028930, -0.049980, 0.172390, 0.387590, 
0.485690, 0.123060, 0.575780, -0.938180, -0.390620, -0.501820, 0.335290, 0.052830, -0.132090, -0.069800, 
0.733500, 1.070620, 0.856650, 0.437360, -0.182060, 0.981200, 1.125240, 0.392810, 0.233480, 0.213060, 
0.316950, 1.328990, 0.649980, -0.038210, 0.103620, 0.166290, 0.292090, 0.186940, 0.109180, -0.108730, 
-0.075290, 1.084880, 0.250570, 0.507260, 0.236250, 0.266500, 0.659720, 0.381040, 0.117500, 0.110600, 
0.127390, 0.205100, 0.368160, 0.417080, 0.356310, -0.510550, 0.328110, 0.123520, 0.196960, 0.477550, 
-0.142260, -0.111730, 0.244480, -0.141680, -0.079050, -0.568590, 0.257990, 0.054600, -0.520520, 0.131980, 
0.155730, 0.180970, 0.878860, 0.276020, 0.621740, 0.019220, -0.266330, -0.394810, -0.795740, -0.062550, 
-0.010890, 0.214690, -0.110450, 0.038470, 0.141990, 0.062190, 0.103390, 0.109300, -0.024160, 0.121080, 
0.102350, 0.243500, 0.021080, 0.319960, 0.481820, -0.287050, 0.083090, -0.035740, -0.053130, -0.368240, 
-0.184870, 0.158280, -0.066680, -0.151880, 0.398820, 0.803970, 0.156620, 0.305470, 0.059020, 0.532080, 
0.263790, 0.238930, 0.153790, 0.144740, 0.173050, 0.555170, 0.170530, 0.312870, -0.034710, 0.206940, 
-0.125570, 0.101780, -0.059530, -0.104690, -0.148630, 0.175480, -0.071380, 0.139730, 0.180590, 0.018320, 
-0.168660, 0.231300, 0.041870, -0.009470, -0.077070, 0.336380, 0.047760, 0.018700, -0.078280, 0.020030, 
0.120400, -0.158750, -0.060740, 0.194680, -0.074120, -0.136190, -0.167100, -0.338690, -0.203740, -0.295410, 
0.245460, 0.019860, -0.142810, 0.199920, 0.079780, 0.075860, 0.322370, 0.064820, 0.229180, -0.131420, 
-0.076810, -0.209920, -0.201810, 0.043930, -0.285560, 0.084520, -0.137720, 
0.402520, -0.057610, 0.001660, 0.290940, 0.326860, 0.100380, 0.206500, 0.030240, -0.161840, 0.220340, 
0.227590, -0.064200, 0.301960, 0.124030, 0.090330, 0.191270, 0.021280, -0.051840, -0.193620, 0.136430, 
-0.099860, -0.134770, 0.326140, -0.057590, 0.180270, 0.081610, 0.095090, -0.001570, 0.196360, 0.028090, 
0.227400, 0.155310, -0.094670, 0.353230, -0.030690, -0.108930, -0.167090, 0.102720, 0.128440, -0.078800, 
0.228970, -0.110370, 0.026160, -0.040450, 0.227240, 0.427360, 0.122540, 0.127740, -0.010470, 0.244980, 
-0.156280, 0.113720, -0.063230, 0.035260, 0.121950, -0.085850, 0.169250, -0.256860, -0.173460, -0.017930, 
-0.042770, 0.112050, -0.103100, -0.029280, -0.039350, 0.125510, 0.486540, 0.386340, -0.026860, -0.094880, 
0.127700, -0.163320, 0.026850, -0.074080, -0.372550, 0.040140, -0.314890, 0.149010, -0.195750, 0.009670, 
0.001690, -0.072570, -0.083130, -0.107020, 0.185220, -0.222430, -0.112620, 0.215610, 0.277000, 0.073370, 
-0.018170, -0.167650, -0.124150, -0.101960, -0.077410, -0.160200, 0.020730, 0.137810, -0.281370, 0.019630, 
-0.007670, 0.314430, -0.146400, 0.063730, -0.099380, -0.051970, 0.152720, 0.079980, 0.080550, -0.210660, 
-0.016140, 0.056680, 0.064860, 0.082220, 0.117110, -0.224690, 0.108770, -0.123020, 0.146890, -0.412230, 
0.073910, 0.107160, 0.037840, 0.087890, -0.273480, -0.088720, 0.496410, 0.327140, -0.151300, 0.153510, 
-0.072670, -0.017070, -0.121700, -0.075970, -0.133960, 0.012140, 0.036230, 0.095100, 0.176510, -0.086980, 
-0.243740, -0.044270, -0.070680, 0.311820, -0.211270, -0.147370, -0.072150, 0.539630, -0.152640, 0.022430, 
0.477080, 0.012820, 0.107020, 0.528490, -0.623650, 0.451000, -0.134960, -0.014320, -0.008150, -0.228810, 
0.051530, -0.335120, 0.130900, 0.089010, 0.042450, 0.060660, -0.362510, -0.067440, 0.863790, 0.031600, 
-0.330170, 0.184240, -0.256600, 0.420760, 1.230260, -0.429560, -0.217000, 0.077570, 0.413780, 0.198660, 
-0.015450, -0.013160, -0.392020, -0.410220, -0.477280, 0.498110, -0.013080, 0.094750, 0.007160, 0.807370, 
0.474590, -0.081500, -0.115840, -0.004320, 0.344100, 0.526050, -0.662090, 0.160660, 0.191270, 0.724700, 
0.180970, 0.236890, -0.057680, -1.071150, -0.437140, -0.674890, 0.284120, 0.190750, -0.198600, -0.111870, 
0.740010, 0.244340, 0.202170, -0.383980, -0.088710, 0.565780, 0.177630, -0.414390, -0.173740, 0.142680, 
0.550950, 0.300120, 0.632130, 0.029330, -1.200900, -0.353500, -0.399070, -0.032630, -0.061590, -0.155780, 
-0.159060, 0.670350, 0.582580, -0.100070, -0.554080, 0.038810, 0.239160, -0.029520, -0.480910, -0.351120, 
0.381680, 0.758880, 0.455060, 0.405710, 0.222560, -1.339090, -0.431740, -0.184300, 0.018870, -0.055950, 
-0.263090, -0.179950, 0.391570, 0.808130, 0.222240, -0.340830, 0.029410, 0.397730, 0.033570, 0.055390, 
0.180680, -0.024550, 0.393990, 0.903830, 0.325980, 0.287010, -0.512610, -0.350860, -0.364990, 0.253940, 
0.010660, -0.356760, -0.195050, 0.537310, 0.315680, 0.148120, -0.019330, 0.214830, 0.166100, -0.267150, 
0.316390, 0.103710, -0.187860, 0.272290, 0.118580, 0.064040, -0.117700, -0.347920, -0.041330, -0.399040, 
0.027720, 0.013790, -0.279470, -0.191870, 0.344030, 0.127840, 0.235970, -0.144130, 0.127670, -0.112520, 
0.015420, 0.287790, 0.097490, -0.010760, 0.295080, 0.547300, 0.309920, 0.067740, -0.105710, 0.201020, 
-0.224280, 0.326670, -0.061370, -0.425450, -0.179510, 0.093080, 0.296670, 0.052150, 0.058900, -0.095930, 
0.326670, 0.106830, 0.098350, 0.624780, 0.211090, 0.194470, 0.130880, 0.233970, -0.002660, -0.537200, 
-0.319400, -0.038380, 0.486300, 0.292800, -0.147830, -0.178700, 0.213640, 0.028620, -0.085170, 0.047420, 
0.186230, 0.110330, -0.098850, 0.124150, 0.137250, 0.128440, 0.273970, 0.361440, 0.025970, -0.195940, 
-0.509760, -0.139310, 0.011780, 0.191240, 0.198400, 0.067120, -0.174670, 
0.264500, 0.045370, -0.009530, -0.077630, 0.821700, 0.112780, -0.111470, 0.443770, -0.527940, 0.180440, 
0.227780, 0.281880, 0.182100, 0.042960, 0.113980, 0.156610, 0.236010, 0.118370, -0.383030, 0.356810, 
0.022690, 0.059210, 0.136370, -0.066500, 0.021180, -0.033280, -0.081800, -0.048290, 0.438530, 0.009190, 
0.383970, 0.086270, 0.009520, -0.078410, 0.082190, 0.231140, 0.001920, -0.103470, 0.092880, -0.150430, 
0.245240, -0.006300, -0.079750, -0.007900, 0.561390, 0.246930, 0.218490, 0.220510, -0.134130, 0.405580, 
0.252840, 0.142820, -0.011560, 0.442380, -0.073060, -0.009800, -0.018560, 0.323530, 0.312160, -0.022550, 
-0.145820, 0.332090, -0.042150, -0.282940, 0.412710, 0.380610, 0.450050, 0.405850, 0.087490, -0.192390, 
0.692630, 0.191150, -0.170630, -0.063980, 0.518440, 0.130240, 0.060220, 0.135390, 0.161240, 0.036140, 
-0.091920, 0.330320, -0.203540, -0.047160, -0.360390, 0.219450, 0.458290, 0.405580, -0.237870, -0.006700, 
0.315310, 0.467720, 0.087050, 0.074610, -0.022850, 0.505200, -0.055540, -0.148240, 0.520030, -0.066080, 
0.349170, 0.189040, 0.038780, 0.309960, -0.075460, -0.438920, 0.156320, 0.088050, 0.105960, 0.077600, 
-0.115320, -0.421310, 0.591390, 0.126680, 0.153450, -0.111650, -0.015300, -0.159070, 0.287610, 0.028350, 
-0.037660, 0.227460, 0.051260, -0.141900, 0.078890, -0.045720, -0.239660, 0.585280, 0.206500, -0.083720, 
-0.168340, 0.194480, -0.080950, 0.438860, -0.047430, 0.138950, -0.018850, 0.085810, 0.062780, -0.085390, 
0.154270, -0.020120, 0.299020, 0.138640, 0.009890, 0.440580, -0.052680, -0.208530, 0.157810, 0.125110, 
-0.150040, 0.578700, -0.209900, -0.086910, 0.122580, -0.276140, 0.280680, -0.035360, -0.382020, -0.076880, 
-0.345590, 0.237740, 0.652210, 0.950830, 0.325850, 0.017710, 0.410410, -0.040080, 0.166980, -0.050390, 
-0.502770, -0.953090, -0.036660, -0.268720, -0.938760, 0.779580, 0.114990, 0.548150, -0.193440, -0.704690, 
-0.111590, 0.453700, -0.743610, -0.300300, 0.218290, 0.158520, 0.147740, 0.872550, -0.009720, -0.562460, 
0.531540, -0.306030, -0.183410, 0.151000, 0.205930, 0.409650, -0.751440, -0.420750, 0.267850, -0.093160, 
0.141660, -0.077450, -0.034940, 0.312480, 0.576460, 0.871300, 0.158540, -0.006690, 0.111330, -0.017330, 
0.332070, -0.472550, -0.563010, -0.693450, 0.805510, -0.516490, -0.666560, 0.323450, -0.520860, 0.639600, 
0.017130, -0.669000, 0.145480, 0.193220, -0.050220, -0.179030, 0.254330, -0.215190, -0.336320, 1.022670, 
-0.053110, -0.363500, 0.020060, 0.059570, -0.124810, -0.333920, 0.015690, 0.187200, 0.144900, 0.408510, 
0.108300, -0.165500, 0.011050, -0.392060, -0.090820, 0.271370, 0.730530, 0.385360, 0.149840, 0.129710, 
0.079190, -0.039500, -0.021720, -0.392250, -0.322630, 0.278550, 0.203550, -0.146310, -0.128100, 0.224640, 
-0.351630, -0.244870, -0.038170, -0.485510, -0.164680, 0.099600, 0.188200, 0.019400, -0.018790, -0.116530, 
-0.431590, 0.305330, -0.022860, -0.567250, 0.188360, 0.489280, 0.505650, -0.336390, -0.080070, -0.143390, 
0.255760, 0.193200, 0.172310, 0.003390, -0.218810, -0.421910, -0.067480, 0.101160, 0.428610, 0.312020, 
0.278130, -0.079380, 0.199840, -0.031490, -0.432100, 0.099440, 0.193250, -0.121610, -0.108590, -0.140520, 
0.177560, 0.646400, -0.043830, -0.131500, 0.019860, -0.125630, 0.012570, 0.163730, 0.019210, 0.169140, 
-0.204190, -0.325280, -0.042770, 0.078160, -0.027320, -0.384990, 0.010290, 0.084420, -0.171500, 0.459460, 
-0.002540, 0.232120, 0.087760, 0.236350, -0.075950, -0.345650, -0.055650, -0.215070, -0.277700, 0.222700, 
-0.176310, 0.244590, 0.082320, -0.015080, 0.041070, -0.030640, -0.312370, -0.133200, 0.065550, -0.026550, 
-0.024650, -0.090290, -0.004170, 0.595650, -0.213650, -0.026570, -0.345100, -0.139890, -0.204950, -0.091470, 
0.010590, 0.324060, -0.167420, -0.277610, 0.147450, 0.097850, -0.013230, 
0.090840, -0.055500, -0.020640, -0.020570, 0.084990, 0.040650, 0.203290, -0.026230, 0.489690, 0.040780, 
-0.210370, 0.198400, 0.131590, 0.215260, -0.154150, 0.068660, -0.033410, -0.060460, 0.121640, 0.013740, 
0.029860, -0.035770, 0.145540, -0.041270, 0.161240, -0.539150, 0.124870, 0.585390, -0.021340, 0.017070, 
-0.092260, -0.420240, 0.255650, 0.039530, -0.247900, -0.213970, 0.025360, 0.029510, 0.146450, -0.103240, 
0.004700, 0.027580, -0.294600, -0.006520, -0.365330, -0.141820, -0.126080, -0.030020, -0.238260, -0.026520, 
-0.522750, -0.064210, -0.269610, 0.103760, -0.231950, 0.061190, -0.056770, -0.078200, 0.002010, 0.542910, 
0.067440, -0.215400, 0.026230, -0.283060, -0.194220, -0.086340, 0.038300, -0.083620, 0.082910, 0.251920, 
0.146950, 0.059030, -0.143290, 0.132630, 0.077990, 0.061200, -0.183960, -0.354310, -0.251360, -0.306310, 
-0.074480, -0.051880, -0.007680, 0.030050, 0.369670, 0.180640, 0.105250, -0.055860, 0.342190, -0.479430, 
-0.031030, 0.052110, -0.051530, 0.190290, 0.016940, -0.039820, -0.083490, 0.022820, -0.310490, 0.148950, 
0.231590, 0.030880, 0.056500, -0.043310, 0.027270, 0.134770, -0.109060, -0.175230, 0.497330, 0.187470, 
0.186270, 0.259380, -0.071480, 0.094330, 0.089520, -0.099990, 0.191380, 0.125360, -0.247560, 0.100120, 
-0.072300, -0.252110, -0.408250, 0.075780, 0.038480, 0.027610, -0.043710, -0.095350, -0.056830, -0.400730, 
0.412890, -0.196800, -0.158810, -0.434230, -0.243290, -0.312970, -0.043930, 0.074460, 0.116490, -0.109100, 
-0.059220, -0.023350, -0.037770, -0.032530, 0.274810, -0.257680, 0.021580, -0.220580, -0.379810, -0.036220, 
-0.115740, -0.063070, -0.365530, -0.328690, 0.795520, -0.316660, -0.461170, -0.080860, -0.391090, -0.378310, 
-0.186150, 0.651920, 0.090970, -0.390240, -0.414590, -0.405760, -0.179080, 0.008250, -0.069450, -0.288800, 
-0.056720, -0.093090, 0.566420, -0.253060, -0.295270, -0.158640, -0.126990, -0.006570, 0.422150, -0.084620, 
0.218120, -0.107030, -0.126160, -0.038510, 0.131880, -0.150950, -0.083710, -0.205960, 0.002440, -0.066940, 
0.003570, 0.141940, 0.699070, 0.032950, 0.087930, 0.002400, 0.465420, 0.154770, 0.071190, 0.208510, 
0.236210, 0.103450, 0.373730, 1.179440, 0.411260, 0.531450, 0.462950, 0.290790, 0.069190, 0.221220, 
-0.467720, 0.212910, 0.172560, 0.137200, 0.716680, 0.158600, 0.105220, 0.503060, -0.134080, -0.066790, 
0.058490, 0.123870, -0.038320, 0.172820, -0.099540, -0.054330, 0.098380, 0.240320, 0.319360, -0.061010, 
0.234890, -0.134450, -0.071420, 0.371770, 0.295150, 0.682680, -0.036520, 0.204260, 0.358390, -0.017370, 
0.122600, -0.041230, -0.107780, 0.028140, 0.057660, 0.786550, 0.317920, 0.570000, 0.096400, -0.085140, 
0.097710, 0.220790, 0.077600, 0.294530, 0.172100, -0.151520, -0.118990, 0.109650, -0.065260, 0.592930, 
0.279690, 0.022250, 0.203920, 0.065450, 0.110060, 0.179840, 0.361580, -0.132420, 0.091950, 0.527840, 
0.357270, -0.056680, 0.200990, -0.085270, 0.172170, 0.155500, -0.076340, 0.522050, -0.163590, -0.086460, 
-0.114470, 0.019470, 0.078040, -0.006870, -0.014470, -0.011770, 0.272670, 0.215100, -0.113670, 0.035030, 
0.292800, 0.052580, -0.092020, 0.191050, 0.096440, 0.055160, -0.009160, 0.181200, 0.052830, -0.202320, 
0.217740, 0.352250, -0.139660, 0.320110, 0.155660, -0.025690, -0.087950, 0.281530, 0.096180, -0.031790, 
-0.231850, 0.332540, 0.197770, -0.116510, 0.201280, 0.033900, 0.225570, 0.363370, 0.681970, 0.303000, 
0.201030, 0.475880, -0.089660, 0.374530, -0.134470, 0.015500, 0.249110, -0.093460, -0.022670, 0.373760, 
-0.120610, 0.230490, 0.061210, 0.233090, -0.094960, 0.171150, 0.066160, 0.105290, -0.114780, -0.051020, 
0.000670, 0.081700, 0.179190, 0.169160, -0.103610, 0.065250, -0.043130, 0.277620, -0.114400, 0.234350, 
0.754830, -0.118390, -0.064130, 0.394280, 0.392440, 0.054650, 0.192720, 
0.037250, 0.024680, 0.011230, -0.290950, -0.051310, -0.027450, 0.087860, 0.132740, -0.343710, 0.210880, 
0.135650, -0.013550, 0.076490, 0.013320, -0.276300, -0.090730, 0.143350, -0.106820, -0.275740, 0.136810, 
0.031780, 0.070970, 0.012780, 0.062300, -0.101340, -0.286600, 0.113180, 0.082930, 0.145350, 0.137430, 
-0.001890, -0.166470, 0.007310, -0.026460, -0.106160, -0.224870, -0.007470, 0.038500, -0.099640, 0.212670, 
0.245210, 0.024580, 0.060980, 0.219140, -0.129630, -0.170950, -0.161290, 0.057060, 0.115840, -0.106570, 
-0.207040, 0.023470, -0.204730, 0.161070, 0.067460, 0.114560, 0.093200, -0.062830, 0.080750, 0.230390, 
0.120360, 0.201470, 0.034610, 0.046480, -0.078210, -0.127810, -0.043430, 0.196290, -0.172930, 0.003210, 
-0.119000, -0.189240, 0.343760, -0.096990, 0.020670, -0.038410, -0.194300, 0.084800, 0.005040, -0.022450, 
-0.350140, 0.067240, 0.217680, 0.025940, 0.188050, -0.101780, -0.202310, 0.019460, 0.224830, -0.260420, 
0.159020, -0.086860, 0.059310, -0.151580, 0.055830, 0.030260, -0.201950, 0.274650, -0.112510, 0.003650, 
-0.088620, 0.048440, 0.248920, -0.119610, 0.025950, -0.106210, 0.131570, -0.245400, 0.035590, 0.039070, 
0.084730, 0.254410, -0.050850, -0.069220, -0.208520, -0.026890, 0.395830, -0.134870, 0.022160, 0.346120, 
0.127640, -0.165680, -0.088400, 0.017350, -0.048300, 0.036370, -0.007240, 0.015460, -0.100860, 0.399010, 
0.147940, 0.061550, 0.248290, -0.038550, -0.264040, -0.097220, -0.020870, 0.151240, 0.052670, 0.059060, 
-0.152150, -0.058470, 0.156370, 0.101840, -0.159260, -0.033220, 0.010510, -0.055720, -0.043900, 0.150960, 
-0.046040, 0.291800, 0.060580, -0.132270, 0.212030, -0.033870, -0.163310, 0.172850, 0.030460, 0.133670, 
0.205340, -0.190570, 0.141380, 0.391480, 0.087200, 0.245920, -0.039560, 0.014470, -0.466000, 0.167380, 
0.659980, 0.596810, -0.015230, 0.036630, -0.185870, 0.548810, -0.055650, -0.335590, -0.290600, 0.256340, 
-0.315070, 0.013370, -0.155520, 0.393800, 0.489220, 0.140810, -0.299830, -0.182100, 0.002470, -0.159690, 
-0.023780, -0.294980, 0.143620, 0.038580, -0.176930, 0.081460, 0.336530, -0.100180, 0.075500, 0.352240, 
-0.010030, -0.032960, 0.104230, 0.950710, -0.193860, -0.154990, -0.108940, -0.093660, 0.056000, 0.095820, 
-0.032070, 0.341440, 0.137310, 0.457290, 0.037680, 0.136150, 0.382620, 0.059750, 0.230570, 0.067120, 
-0.033920, 0.446150, 0.017480, 0.070650, 0.062420, 0.370980, 0.206670, 0.080460, 0.110230, 0.174190, 
0.114650, -0.195630, -0.047730, -0.293150, 0.627110, -0.054710, 0.144930, 0.582710, -0.083970, 0.080290, 
0.165670, -0.122830, 0.023720, -0.064060, -0.008040, 0.398230, 0.287010, 0.283780, 0.001840, 0.178800, 
0.289690, 0.127160, 0.281510, 0.134010, -0.398820, -0.141910, 0.286780, -0.001610, 0.116120, -0.059830, 
-0.091370, 0.451060, 0.234510, -0.082590, 0.133750, 0.233500, -0.039810, 0.078560, -0.137440, -0.194490, 
0.281180, 0.468720, 0.127220, -0.020370, 0.156540, 0.039580, 0.210690, -0.203050, 0.137230, 0.213550, 
-0.058610, 0.157540, -0.096840, 0.072400, 0.066760, 0.139130, 0.450750, -0.213880, -0.039290, 0.122540, 
-0.026090, 0.179100, 0.139990, 0.093690, 0.113920, 0.064330, -0.326500, -0.117840, -0.064780, -0.112160, 
0.020780, 0.035920, -0.287270, 0.578190, 0.228440, 0.095910, 0.124960, 0.471950, -0.537930, -0.177550, 
-0.066780, -0.108300, -0.110930, 0.649580, 0.101110, -0.010700, 0.373920, -0.073710, 0.104350, 0.085350, 
0.164790, 0.045200, -0.193330, 0.294460, -0.135060, 0.009330, 0.291450, -0.098760, -0.206730, -0.367080, 
0.289710, 0.148500, 0.152100, -0.053310, 0.095230, 0.074150, -0.167790, -0.025120, 0.062440, 0.228440, 
-0.072390, -0.105620, -0.020400, 0.106820, -0.212800, -0.002720, -0.119070, -0.189900, 0.087650, 0.023890, 
0.009230, -0.079730, 0.152090, 0.242550, -0.202440, -0.095370, 0.068600, 
-0.134900, 0.130390, -0.023210, -0.233120, -0.069040, 0.258930, 0.047020, -0.211700, 0.106550, 0.080880, 
-0.117430, 0.157280, -0.035000, -0.155050, 0.282270, -0.075650, -0.124480, -0.111040, -0.032020, 0.030630, 
0.013120, -0.030680, -0.171780, 0.077940, 0.001580, -0.226850, 0.053920, 0.065140, 0.028850, 0.159070, 
-0.042650, -0.217090, -0.189570, 0.106660, 0.036620, 0.164640, 0.036070, -0.049030, -0.145950, 0.034630, 
-0.127010, 0.003280, 0.146510, -0.226410, -0.347450, -0.236440, 0.006760, -0.053230, -0.072180, -0.385200, 
-0.094780, 0.394680, 0.187220, -0.116870, -0.017310, 0.244910, -0.317160, -0.112780, 0.053220, 0.047030, 
-0.121030, 0.444740, 0.003620, 0.286140, 0.013350, -0.452450, -0.403660, 0.214180, -0.144350, -0.004260, 
-0.219830, 0.023810, 0.327310, 0.084980, 0.106480, -0.179770, -0.168470, -0.398300, -0.023880, 0.037830, 
0.130020, 0.103470, 0.097920, 0.029640, 0.110840, 0.245560, -0.163860, 0.147970, 0.069360, -0.047480, 
-0.047100, 0.007940, 0.069680, 0.143580, 0.034770, 0.095740, 0.088370, -0.164230, -0.507030, 0.003370, 
-0.175400, -0.075450, 0.191340, 0.115980, 0.019900, 0.185320, 0.289660, -0.040210, 0.267160, -0.206610, 
0.278310, 0.470280, -0.402990, -0.208390, 0.105410, 0.345250, 0.408910, -0.141650, -0.231970, -0.231380, 
0.003210, 0.161780, -0.293930, -0.095180, 0.146210, 0.024190, 0.105520, 0.342260, 0.077730, 0.025820, 
-0.223100, 0.162130, 0.245100, 0.180280, -0.308130, 0.136400, 0.138390, 0.476100, 0.184350, 0.022080, 
0.026100, 0.068640, 0.202340, -0.269470, 0.012100, 0.229590, 0.031190, -0.175560, -0.168510, 0.640920, 
0.005550, 0.406140, 0.049930, -0.202760, 0.860500, 0.210190, -0.343600, -0.080410, -0.154970, -0.001240, 
0.125190, -0.197580, -0.019510, 0.158850, 0.046720, 0.028300, -0.188420, 0.011770, -0.292540, 0.210310, 
0.443060, -0.018480, 0.018910, -0.073640, -0.412260, 0.836470, 0.270840, -0.586420, -0.281500, 0.168600, 
-0.205940, -0.309740, 0.445960, -0.030980, 0.007780, 0.058740, -0.116320, -0.368330, -0.001630, -0.614050, 
0.334890, 0.215560, 0.135470, 0.288000, -0.178640, -0.563990, 0.810700, -0.023940, 0.080090, -0.140350, 
0.011580, 0.098490, 0.089370, -0.134000, -0.122040, -0.056360, 0.527260, 0.048090, -0.036670, 0.110950, 
-0.209250, 0.197610, -0.025120, -0.204980, 0.141400, -0.196980, -0.078350, -0.223890, 0.292440, 0.233790, 
0.257310, -0.117080, 0.149130, 0.084340, 0.491920, -0.166690, 0.060810, 0.175670, 0.068540, 0.629020, 
0.130050, -0.108070, -0.015790, -0.047730, 0.292140, 0.275120, -0.484110, -0.084810, 0.081070, 0.118030, 
0.098910, -0.069010, -0.118010, 0.030200, -0.051160, 0.703140, 0.396450, 0.422700, -0.102050, -0.357010, 
0.278640, 0.154180, -0.240480, -0.045400, -0.424310, -0.193100, 0.080370, -0.029010, -0.186980, 0.083530, 
-0.056950, -0.061850, 0.013270, -0.257900, 0.257460, 0.163560, 0.269450, 0.019270, -0.031340, 0.214030, 
0.122830, 0.170020, 0.147400, -0.221740, 0.050280, -0.192970, 0.221460, 0.093580, -0.096750, 0.126870, 
-0.195110, 0.017100, 0.251520, -0.182960, -0.388390, 0.133930, 0.147030, -0.176900, -0.010970, 0.232580, 
0.175080, 0.001230, 0.251380, 0.112310, -0.159010, -0.048330, -0.170490, 0.210420, 0.275040, -0.075870, 
0.219540, 0.157610, 0.334200, 0.202280, -0.156690, -0.055750, -0.048940, 0.062440, -0.109120, -0.159040, 
-0.249530, 0.325190, 0.043620, -0.018640, 0.111010, 0.079580, -0.159050, -0.118320, 0.078340, 0.072330, 
-0.290300, 0.022490, 0.407950, -0.035210, 0.171110, 0.045320, -0.251440, 0.027640, 0.046370, 0.059670, 
-0.069690, 0.080520, 0.189770, -0.040350, 0.316070, 0.123360, 0.040380, 0.140160, 0.241030, 0.407340, 
-0.194430, -0.112120, 0.095810, 0.310540, 0.124920, -0.133210, -0.195040, -0.271720, -0.017580, 0.370830, 
0.430400, 0.203300, 0.038210, 0.443680, 0.222160, -0.145110, 0.108790, 
-0.057870, 0.023050, 0.057150, -0.145170, 0.090240, 0.247740, -0.050450, 0.144400, 0.079300, 0.016850, 
-0.082560, -0.174600, 0.164770, 0.038000, -0.116180, 0.068340, -0.098250, 0.130910, 0.030570, 0.084300, 
0.045690, -0.104580, 0.236630, -0.119130, 0.047570, 0.024110, -0.150900, 0.174380, 0.199980, -0.178240, 
-0.077790, -0.355780, -0.066760, -0.334230, -0.131890, 0.223540, -0.055530, 0.149530, -0.167900, -0.427470, 
-0.236580, 0.029150, -0.106320, -0.036110, -0.109900, -0.136140, 0.155600, -0.120970, -0.045850, 0.123310, 
-0.224730, 0.256730, 0.087780, -0.182910, 0.159830, -0.097140, -0.127230, -0.077620, -0.045770, -0.122370, 
-0.253880, 0.322070, 0.049600, 0.079380, 0.079020, 0.131510, -0.001260, 0.154990, 0.169910, 0.149470, 
0.107150, 0.192970, -0.090130, -0.278180, 0.081440, -0.088170, -0.008810, 0.034580, -0.014000, -0.141430, 
0.061780, 0.234050, -0.085070, 0.039240, 0.168350, 0.026470, -0.013430, 0.174650, 0.184330, -0.045710, 
0.183210, 0.033740, 0.065010, -0.056410, -0.121860, 0.032380, -0.117660, 0.237980, -0.057890, -0.025210, 
-0.234450, 0.133610, 0.108820, -0.079580, 0.069090, -0.209740, 0.225100, 0.421320, 0.030920, 0.095030, 
0.096540, 0.194220, 0.026830, -0.099090, -0.156020, 0.105310, 0.196530, 0.166550, -0.088010, 0.218680, 
0.120640, 0.256030, 0.075340, 0.017140, -0.103710, 0.070100, -0.118320, -0.051700, 0.237440, 0.260290, 
0.029510, -0.029940, -0.178250, 0.845390, -0.021180, 0.083670, -0.157070, -0.029870, 0.124030, 0.025410, 
0.069700, 0.103710, 0.194680, 0.415600, 0.062470, 0.199360, 0.065690, -0.453590, 0.092870, 0.210990, 
0.196620, 0.435620, -0.125300, -0.216950, 0.351150, 0.346300, -0.228650, -0.071410, 0.048350, -0.005900, 
-0.201870, 0.523020, 0.109220, 0.060730, 0.073250, -0.015460, -0.265070, 0.057040, -0.428350, 0.224030, 
0.656840, 0.487790, 0.151930, -0.115550, -0.510230, 1.175430, -0.007560, -0.433550, -0.465260, 0.093450, 
-0.204010, -0.541720, 0.743130, 0.204350, 0.375960, -0.032030, -0.397290, -0.292900, 0.001570, -0.475910, 
0.037440, -0.144960, 0.179560, 0.246960, -0.280570, -0.272080, 0.648200, 0.137110, -0.024000, -0.216210, 
-0.007560, -0.100450, 0.109810, 0.574360, 0.059980, -0.064290, 0.038810, -0.200940, -0.087880, 0.019840, 
-0.452100, -0.127670, -0.178340, 0.186260, -0.043880, -0.418390, 0.018170, 0.447970, -0.131230, -0.239140, 
-0.230490, 0.057210, -0.139470, -0.106820, 0.498130, 0.144890, 0.212750, -0.069540, -0.265140, -0.039260, 
0.029100, -0.329060, -0.245460, -0.146700, 0.185700, 0.136420, -0.198340, 0.091880, 0.087320, -0.011080, 
-0.290450, -0.378690, -0.468260, -0.188050, 0.067090, 0.586810, 0.289480, 0.214200, 0.094780, 0.103490, 
0.051570, 0.021140, -0.241080, -0.071880, -0.543230, -0.295770, 0.065470, -0.085430, -0.027740, -0.307670, 
-0.322980, -0.017850, -0.152030, -0.181060, 0.164260, -0.082180, 0.056200, -0.078620, 0.009480, 0.126120, 
-0.254280, 0.178970, 0.025510, -0.111690, -0.048540, -0.048570, 0.157760, -0.083910, 0.159340, -0.025680, 
0.116380, -0.044900, -0.220560, -0.325990, -0.106300, -0.196290, -0.389810, 0.154270, -0.045860, 0.125760, 
-0.324730, -0.396200, -0.131160, 0.010490, 0.101700, -0.336320, -0.064600, 0.021310, -0.074180, -0.215200, 
0.088180, 0.032000, 0.140490, 0.028620, -0.371430, -0.214210, -0.043130, -0.246430, -0.094130, 0.071790, 
-0.162370, -0.215570, 0.089290, 0.124870, -0.002380, 0.037030, -0.207640, 0.175660, 0.117140, -0.024460, 
-0.138600, -0.059160, 0.106140, -0.281140, -0.465480, -0.470220, -0.213430, -0.271600, -0.238650, -0.079380, 
0.206820, 0.219010, -0.124470, -0.217770, -0.186730, 0.001730, -0.071370, 0.077480, 0.000050, 0.095940, 
-0.449400, 0.003420, 0.181500, -0.049410, -0.021940, -0.169770, -0.106260, -0.168720, -0.010140, -0.199780, 
0.151580, 0.041110, 0.022990, -0.205950, 0.007940, -0.177160, -0.001010, 
0.172850, -0.266180, 0.299170, 0.271010, 0.159030, -0.017850, -0.005180, 0.390130, 0.207990, -0.156380, 
-0.041360, -0.281460, -0.056600, 0.226710, 0.041070, 0.214540, -0.142230, 0.496420, -0.061760, 0.042900, 
-0.039220, 0.142160, 0.148450, 0.051760, 0.120790, 0.193150, 0.050140, 0.035750, 0.152030, 0.057500, 
0.105230, 0.067710, -0.079370, -0.107020, -0.374720, -0.027660, 0.145660, 0.194530, -0.179880, -0.150180, 
-0.001960, -0.058240, 0.026260, -0.100430, 0.143110, 0.447940, 0.052890, 0.239260, 0.105340, 0.205620, 
0.005960, 0.086490, 0.016130, 0.377380, 0.126810, -0.189610, 0.025280, 0.181510, 0.367730, -0.130800, 
0.061730, 0.147640, -0.056480, -0.059280, -0.069920, -0.026400, -0.047520, -0.021210, -0.335520, -0.189220, 
0.624900, -0.128890, -0.095960, -0.165550, -0.030420, -0.227680, -0.045690, 0.251920, 0.195720, 0.056770, 
-0.140480, -0.057320, 0.040260, -0.075020, -0.064040, 0.244630, 0.311550, 0.220830, 0.066840, 0.095720, 
0.139350, 0.233210, -0.073450, 0.087640, -0.264500, 0.003240, -0.190890, -0.077280, -0.273910, 0.262290, 
0.267120, -0.039580, -0.091470, 0.243270, -0.065650, 0.206110, 0.208610, 0.052510, 0.033940, -0.070500, 
0.347970, -0.022350, 0.058490, 0.099300, 0.116650, -0.200180, 0.284740, -0.127000, 0.016200, -0.070780, 
0.028420, 0.300190, 0.130090, 0.049670, 0.272750, -0.068490, 0.233850, 0.053730, -0.131540, -0.248970, 
0.080720, 0.248610, 0.113690, -0.330020, 0.037380, -0.009690, -0.058760, -0.069400, -0.090460, 0.124530, 
-0.253940, 0.234220, 0.306240, 0.655840, 0.268380, 0.150360, -0.050480, 0.377200, 0.288700, -0.475460, 
-0.335070, -0.119450, 0.401080, 0.494400, -0.575480, -0.318960, 0.461970, -0.096840, 0.074640, 0.088570, 
0.038740, -0.412040, 0.173100, 0.181540, 0.567430, 0.108370, 0.407900, -0.044130, 0.414370, 0.143870, 
-0.613160, -0.403500, -0.071150, 0.063460, 0.546220, -0.773550, -0.147180, 0.399790, 0.152200, 0.039220, 
0.153740, -0.076810, -0.749530, -0.102910, -0.050720, -0.057190, 0.043620, 0.615490, -0.006300, 0.995670, 
0.013780, -0.353480, -0.532610, 0.287430, 0.152410, 0.511490, -0.479620, -0.440140, 0.195660, 0.119360, 
0.008970, 0.361780, -0.097690, -1.226800, 0.251180, 0.073570, -0.006920, 0.037470, 0.197780, -0.093360, 
0.397920, 0.111420, -0.244210, -0.147990, -0.050760, 0.289590, 0.163900, -0.186210, -0.092420, 0.151280, 
0.119970, -0.023640, 0.260740, 0.031590, -0.572180, -0.023850, 0.093350, 0.196520, -0.033110, 0.254110, 
-0.130770, 0.544070, -0.002220, 0.152400, -0.232250, -0.003610, 0.170540, -0.039980, 0.210510, -0.228990, 
0.109090, -0.024830, 0.061610, -0.064410, 0.160390, -0.638030, 0.117150, 0.008320, -0.307010, -0.011120, 
0.044770, -0.126940, -0.024630, -0.073580, -0.021910, -0.239650, 0.061270, 0.234200, -0.177850, 0.141120, 
-0.377890, -0.110840, 0.319350, 0.255060, 0.105410, -0.074530, -0.029520, 0.011600, 0.037930, 0.039700, 
-0.266780, 0.105060, -0.149130, -0.067020, 0.200100, -0.079010, -0.155500, -0.320600, 0.099960, -0.078630, 
0.183760, -0.148140, -0.174610, 0.083720, 0.199590, 0.211660, 0.067830, -0.466050, -0.148580, -0.175640, 
-0.075020, 0.079060, -0.096220, -0.152740, -0.056170, 0.354950, 0.365210, 0.083760, -0.351610, 0.018020, 
-0.163010, 0.359460, -0.134530, -0.108380, 0.119410, 0.315750, -0.010100, 0.163320, -0.212930, 0.109920, 
0.254220, 0.056960, 0.019440, -0.087770, -0.165000, 0.120980, -0.152860, -0.155700, -0.041500, 0.023740, 
0.043090, 0.028830, -0.209350, -0.344600, 0.221150, 0.188380, 0.119820, -0.104490, -0.166470, 0.011670, 
0.110400, 0.315420, -0.543010, -0.067910, 0.207020, -0.157610, -0.119850, -0.326560, -0.159610, -0.474800, 
0.118660, -0.137190, -0.426920, 0.177460, -0.261640, -0.103430, -0.186130, -0.210120, 0.016340, 0.148440, 
0.000210, -0.054250, -0.101630, 0.341200, 0.256170, 0.076960, -0.159720, 
0.344330, 0.188620, -0.136470, -0.349060, -0.054610, -0.164150, -0.220920, 0.258090, 0.066080, 0.276730, 
-0.067520, -0.245650, -0.081510, -0.221350, -0.300830, -0.006380, 0.117140, 0.160370, -0.132830, 0.136250, 
-0.046480, 0.227130, 0.135260, -0.443770, -0.115290, -0.034300, 0.105880, -0.165990, -0.014120, 0.189700, 
-0.218790, -0.166580, -0.058940, -0.388400, 0.260160, -0.260220, -0.084990, 0.044550, 0.351720, 0.111930, 
0.004840, -0.051330, 0.034830, 0.030590, -0.110050, 0.270660, 0.242060, 0.092050, 0.198770, -0.197150, 
-0.144730, 0.087200, 0.328700, 0.211400, 0.363460, -0.110410, 0.073080, 0.092780, 0.070420, 0.084370, 
0.143460, 0.138050, -0.047260, 0.325340, 0.311290, 0.261520, 0.016300, 0.179470, 0.123280, 0.082180, 
0.260100, 0.240810, 0.166810, 0.039720, 0.018890, -0.019540, 0.218680, -0.054870, -0.002570, 0.078560, 
0.199970, 0.331060, 0.087860, -0.047350, -0.132140, 0.048230, 0.194380, 0.313480, -0.204090, 0.073170, 
0.108290, 0.494330, 0.171830, 0.092930, 0.149420, 0.259690, 0.083700, -0.103200, 0.312520, 0.051850, 
-0.081810, 0.184970, -0.056390, 0.122090, -0.082710, -0.149680, 0.532920, 0.304800, 0.501610, -0.044090, 
0.227250, -0.003490, 0.894620, 0.302350, -0.169770, -0.085760, 0.570280, 0.095320, -0.182160, 0.253750, 
0.083470, 0.025980, 0.122330, -0.004480, -0.236860, -0.047770, -0.163330, 0.350380, 0.181380, 0.594870, 
0.335070, 0.118230, -0.127820, 0.505010, -0.011460, -0.100560, -0.222180, 0.555310, 0.253850, -0.000170, 
-0.008680, -0.170280, -0.157840, -0.602860, -0.449770, -0.402010, -0.078170, -0.595320, 0.565150, 0.666120, 
0.397840, 0.212310, 0.370550, -0.018300, 0.284750, 0.201000, -0.597770, -0.595360, 0.463290, -0.147810, 
0.099890, 0.518810, 0.078070, 0.178120, -0.139260, 0.040580, -0.355000, -0.059680, -0.149180, 0.329430, 
-0.297460, -0.449670, 0.776900, 0.092000, -0.040820, 0.194350, 0.347660, 0.319640, -0.437160, 0.062160, 
0.236230, 0.150780, -0.454270, 0.046360, 0.214280, 0.315900, 0.119150, 0.672660, -0.000160, 0.162910, 
0.131070, -0.492270, -0.878710, 0.274860, -0.151600, -0.000230, -0.296750, 0.193440, 0.581730, 0.201220, 
-0.224950, 0.505160, 0.628220, -0.776240, -0.150070, 0.169130, 0.337320, 0.594330, 0.976680, -0.011030, 
-0.284750, 0.233350, -0.516950, -0.523950, 0.228300, -0.449350, -0.229530, -0.104540, 0.403520, 0.443050, 
0.227380, -0.199170, 0.447700, 0.235450, -0.539210, -0.113980, 0.082250, 0.062940, 0.132820, 0.641910, 
-0.020360, 0.140610, -0.002590, -0.341210, -0.538870, 0.508910, 0.019960, -0.061310, -0.265940, -0.097350, 
0.265780, -0.241440, -0.026290, 0.435920, 0.012450, 0.087580, -0.047360, 0.180720, -0.092610, 0.257870, 
0.619790, -0.012210, -0.404010, 0.165090, 0.040940, 0.122360, 0.199920, -0.224060, -0.161930, -0.632950, 
-0.105330, 0.064360, -0.143960, 0.077170, -0.403540, 0.007120, 0.036920, -0.115200, 0.148860, -0.171200, 
-0.234580, 0.242870, -0.024960, -0.309420, 0.128900, -0.200840, 0.296610, 0.186620, -0.221370, -0.334110, 
0.487650, -0.110500, -0.075620, -0.355790, 0.162950, -0.076090, -0.381690, -0.206210, -0.243890, -0.049120, 
-0.097920, 0.026880, 0.333890, -0.021190, -0.421210, 0.157220, 0.257680, 0.385780, 0.261720, 0.047260, 
0.062070, 0.071200, -0.038280, -0.128820, -0.130930, 0.064090, 0.160010, -0.180130, 0.250710, 0.211090, 
0.269890, -0.058440, 0.054220, 0.321130, -0.037940, -0.217600, -0.277580, -0.029570, -0.002530, -0.181640, 
-0.554680, -0.255510, 0.008020, -0.136480, 0.153720, -0.128970, 0.038860, 0.037490, 0.209820, 0.038460, 
-0.170580, 0.171480, -0.175120, -0.069020, 0.335320, -0.053150, -0.153540, -0.270640, 0.099730, 0.274780, 
-0.353250, -0.402290, -0.166080, 0.219920, 0.151320, 0.103950, -0.059720, 0.303480, -0.327950, 0.067990, 
0.307830, -0.088430, -0.100530, 0.591230, 0.114980, 0.224360, -0.046110, 
-0.074520, 0.091110, 0.129960, -0.079180, 0.074930, -0.117420, 0.026410, -0.096650, -0.295540, 0.019320, 
-0.021750, -0.137710, 0.434570, 0.088940, -0.194810, 0.153230, 0.225210, 0.021110, -0.367810, 0.010450, 
0.038790, 0.304600, 0.240950, -0.017980, -0.208100, 0.267990, -0.036330, -0.090100, -0.192130, -0.069660, 
-0.020360, 0.021540, -0.183670, 0.050680, -0.134810, 0.040960, -0.034270, 0.021520, -0.059660, -0.134960, 
-0.099430, 0.063340, 0.402210, 0.041350, -0.019280, 0.045290, 0.059250, -0.075180, 0.082110, -0.212370, 
-0.052350, -0.205990, 0.221960, -0.438740, 0.086200, 0.236660, 0.000250, -0.023190, -0.208810, -0.025880, 
-0.168000, -0.257150, 0.087990, 0.566450, 0.150490, 0.011000, -0.134540, -0.057610, -0.094440, 0.046500, 
-0.619620, 0.037770, 0.394680, 0.229480, -0.037990, 0.331170, 0.226510, -0.176870, 0.104310, -0.148700, 
0.058070, 0.234420, 0.077580, 0.080120, 0.572730, 0.326830, -0.135100, 0.152110, 0.133400, -0.056450, 
0.284150, -0.608470, 0.064820, 0.130660, 0.408440, 0.193740, 0.316380, -0.009660, 0.236250, 0.041870, 
-0.291210, -0.135330, -0.064540, -0.317700, 0.059000, 0.537860, 0.108570, 0.308380, 0.649410, -0.325380, 
0.115740, 0.404280, -0.184890, 0.168290, -0.199640, 0.256610, 0.054350, -0.121420, -0.194530, 0.169900, 
0.020190, -0.321780, -0.038530, 0.129580, -0.569030, 0.063470, 0.409240, -0.106650, 0.486640, 0.607660, 
0.125730, -0.106590, -0.200810, 0.503950, -0.139970, -0.230930, 0.210750, -0.065090, 0.164240, -0.259520, 
0.099430, -0.044620, -0.607300, -0.362930, -0.171650, -0.599130, 0.049050, 0.287220, 0.161350, 0.566980, 
0.296560, -0.147020, 0.104950, 0.059780, 0.038120, 0.113770, -0.481980, 0.323320, 0.288920, 0.108090, 
-0.310160, 0.615310, 0.178630, -0.215920, -0.456040, -0.238830, -1.077670, 0.036850, 0.632720, -0.050230, 
0.535220, -0.023240, -0.065540, 0.188260, -0.067440, 0.306780, 0.264350, -0.305340, 0.404320, 0.261570, 
0.174010, 0.080720, -0.003600, -0.233960, -0.462950, -0.025010, -0.088290, -0.643960, -0.006450, 0.627050, 
0.165640, 0.128600, -0.000460, 0.054720, 0.084590, 0.111600, 0.022870, 0.235250, 0.000740, 0.520280, 
0.124600, 0.133620, 0.212060, -0.506120, -0.312410, -0.190090, -0.082290, 0.358440, -0.557840, 0.006530, 
0.550190, -0.092200, -0.249430, -0.303190, -0.046980, -0.191610, -0.178840, -0.500150, -0.086050, 0.149250, 
0.276430, -0.236220, 0.028000, 0.301410, -0.372730, -0.396840, -0.652420, 0.014010, 0.047440, -0.184850, 
-0.004190, 0.362290, 0.019680, -0.259150, -0.555130, 0.288380, 0.278590, 0.035270, -0.838240, 0.034790, 
0.238420, 0.374210, -0.013880, 0.291280, -0.241610, -0.078980, -0.546970, -0.247330, 0.070530, -0.044230, 
-0.118230, -0.050660, -0.005560, -0.302730, -0.120770, -0.228870, 0.015510, -0.389960, -0.148380, -0.460900, 
0.013220, 0.250960, -0.095260, -0.229270, -0.223380, -0.066980, -0.098290, -0.403290, -0.207160, -0.283990, 
0.152080, -0.010880, -0.057720, 0.117060, 0.104930, 0.207040, 0.176930, 0.203830, 0.208710, -0.140060, 
-0.336190, 0.062800, 0.000520, 0.125400, 0.036960, -0.185080, -0.294760, -0.001940, -0.156690, -0.019650, 
-0.379400, -0.344640, -0.219130, -0.056340, -0.105840, -0.129890, -0.086020, -0.366670, 0.261470, -0.182980, 
-0.424950, -0.359400, 0.237320, -0.047440, -0.075810, -0.325330, 0.092680, -0.087120, -0.077770, -0.405370, 
-0.312830, 0.019170, -0.156050, -0.134430, -0.064090, 0.057220, -0.147160, 0.281730, -0.021320, 0.290720, 
0.018260, -0.159990, -0.268890, 0.260830, 0.115800, 0.049560, 0.104220, 0.028000, 0.048660, -0.519550, 
-0.020240, -0.255690, -0.320350, -0.243290, -0.058970, -0.037220, 0.247830, -0.043680, 0.176270, 0.174140, 
0.270350, -0.071270, 0.096920, -0.411200, 0.071310, 0.194180, 0.103750, 0.156280, -0.080200, -0.259510, 
-0.184010, 0.028420, 0.115370, -0.080490, -0.162760, -0.129930, -0.051660, 
0.002920, 0.390920, 0.202820, 0.298010, -0.046440, 0.103040, -0.074520, 0.184100, 0.326670, -0.311330, 
-0.159840, -0.198490, -0.065670, -0.053620, 0.020940, -0.189350, 0.014300, 0.164800, 0.174930, -0.300880, 
0.084300, 0.206470, 0.277850, 0.128730, -0.020530, -0.088670, 0.146140, 0.224230, -0.120260, 0.227730, 
-0.168600, 0.046080, 0.063370, 0.227440, 0.102600, -0.190900, -0.116080, 0.008860, 0.183470, 0.092110, 
-0.221430, 0.081090, 0.384830, 0.223570, -0.200860, 0.163610, 0.287510, -0.025810, 0.288390, -0.002520, 
-0.313850, -0.420460, -0.246550, 0.028330, -0.291590, -0.043120, 0.139810, -0.080930, -0.329800, 0.069730, 
-0.305990, -0.133200, 0.094880, 0.318460, -0.160400, 0.203110, 0.044490, 0.265940, -0.409030, -0.080730, 
-0.010750, -0.223540, 0.070400, -0.156730, -0.119480, -0.108740, -0.018470, 0.110820, 0.038990, 0.035670, 
-0.393750, -0.012480, 0.053790, 0.107480, 0.046390, -0.171160, 0.234940, 0.360670, 0.125380, -0.026710, 
-0.053450, -0.226480, 0.260050, -0.222830, -0.146120, -0.069570, -0.198600, 0.217630, 0.055660, 0.291330, 
-0.049460, -0.222440, -0.228450, -0.504850, 0.090960, -0.288560, 0.331940, 0.408790, 0.089280, -0.154090, 
-0.067980, 0.046170, -0.446660, -0.012850, -0.174560, -0.010450, -0.026220, -0.076200, -0.010740, 0.365000, 
0.072970, -0.408720, -0.026950, 0.125730, -0.449870, 0.074360, -0.186640, -0.073760, 0.380160, 0.203220, 
0.117170, -0.334590, -0.542210, 0.310900, 0.227360, -0.439790, -0.097670, -0.284450, -0.324660, -0.284580, 
0.556580, 0.106910, -0.369580, -0.310610, -0.071840, -0.564170, 0.072830, -0.212760, -0.105300, 0.865380, 
0.368390, 0.231780, -0.338570, -0.207890, 0.087300, 0.641370, -0.159850, 0.364940, 0.019420, 0.030300, 
-0.035550, 0.751390, 0.370670, 0.382440, -0.594360, -0.054600, -0.418360, 0.065430, 0.040400, 0.109710, 
0.592240, 0.332110, -0.492900, -0.204630, -0.270230, 1.116030, 0.182690, -0.533470, 0.196170, 0.125640, 
0.048550, -0.186330, 1.228510, 0.327170, 0.211570, -0.324820, -0.147460, -0.462730, -0.001160, -0.454340, 
-0.118950, 0.217070, 0.205790, -0.322320, -0.212220, -0.515200, 0.635130, 0.109430, -0.279990, -0.009880, 
-0.066090, 0.056560, -0.096590, 1.179830, -0.007500, -0.164250, -0.039930, -0.128860, -0.379510, 0.082820, 
-0.128410, -0.082050, 0.155490, -0.017990, 0.066280, -0.056560, -0.400630, 0.449850, -0.108930, -0.190380, 
-0.314140, -0.034170, -0.379380, 0.007210, 0.620950, 0.250390, 0.265150, -0.402410, -0.156460, -0.112290, 
0.103250, -0.354290, 0.128700, 0.102770, 0.210710, 0.358290, -0.048230, 0.015480, -0.209940, -0.000360, 
-0.113620, -0.113900, 0.197490, -0.359550, -0.235360, 0.532000, 0.062140, 0.425630, -0.094600, -0.305250, 
0.148160, 0.103710, -0.091060, 0.026980, 0.195960, 0.343160, -0.210450, -0.170360, -0.057460, -0.337650, 
-0.230480, -0.273180, -0.138310, 0.058030, -0.297560, -0.072900, 0.869300, 0.275700, 0.252040, -0.256620, 
0.052820, -0.260320, 0.101350, 0.139680, -0.088580, -0.192560, 0.075080, 0.203640, -0.141530, -0.170660, 
-0.042280, -0.099890, 0.143730, -0.130820, 0.075070, -0.288090, 0.097870, 0.502640, 0.243110, 0.146480, 
-0.011110, 0.081030, -0.101460, 0.103100, -0.077970, -0.395140, 0.238160, -0.279340, -0.008250, 0.162840, 
0.049760, -0.054720, 0.328770, -0.064770, -0.112000, 0.130310, 0.019260, 0.051630, 0.089790, 0.233030, 
0.163590, 0.082110, 0.137670, -0.054880, 0.112710, 0.125370, -0.130970, 0.083730, 0.330090, 0.045330, 
0.023630, -0.203670, -0.049080, -0.176430, -0.060180, 0.082160, -0.196030, -0.094290, -0.166700, 0.029450, 
0.201350, 0.410680, -0.009650, -0.196310, -0.029880, 0.131040, 0.084690, 0.019690, 0.083990, 0.282680, 
-0.091230, 0.324920, 0.270790, -0.094960, -0.113960, -0.385090, -0.181990, 0.421390, -0.378040, -0.222460, 
0.154970, 0.175720, 0.133040, -0.066070, -0.139070, -0.252200, 0.114740, 
0.176440, -0.056090, -0.390100, -0.052560, -0.337920, 0.149210, 0.003770, 0.209830, 0.430780, 0.292900, 
0.230690, -0.022340, 0.207650, 0.560320, -0.179370, 0.091950, 0.247920, 0.288950, 0.188790, 0.158660, 
-0.094860, -0.059500, 0.199580, 0.096540, -0.240280, 0.174440, 0.259090, -0.028200, -0.048270, 0.390240, 
0.038560, -0.205160, -0.037260, 0.070680, 0.251890, -0.190000, 0.154460, -0.068270, 0.348640, 0.254120, 
-0.015550, -0.091390, -0.127770, -0.091640, 0.101390, -0.251900, 0.236480, -0.042680, -0.110730, 0.566020, 
-0.211260, 0.129630, 0.143120, -0.054500, -0.084540, 0.038500, 0.125250, -0.162620, 0.211010, -0.230090, 
0.012450, 0.156380, -0.098400, -0.158160, 0.424550, 0.156900, -0.077370, 0.100310, 0.251010, -0.039910, 
0.352730, 0.134900, 0.076560, -0.160990, 0.160660, -0.116800, 0.184550, 0.036780, 0.093340, 0.185750, 
0.199660, 0.164270, -0.070220, -0.118240, -0.072620, -0.057980, 0.023020, 0.193810, -0.007510, -0.101720, 
-0.163380, 0.518370, -0.094160, -0.003400, -0.121970, -0.416210, -0.157270, 0.200790, 0.081660, 0.227050, 
0.255290, 0.499090, -0.226440, -0.094420, -0.105880, -0.330950, -0.163240, 0.187630, 0.084800, -0.116910, 
-0.024180, -0.104940, 0.126750, 0.154830, -0.105570, -0.443030, 0.004260, -0.344630, -0.369430, -0.154740, 
0.131190, 0.290250, -0.032310, -0.059520, 0.115240, -0.117330, 0.534430, -0.066480, -0.277070, -0.188970, 
-0.002690, 0.072710, -0.237450, 0.075950, -0.462800, 0.146430, -0.083550, -0.242060, 0.307960, -0.129630, 
-0.052240, -0.085760, 0.016130, 0.019380, -0.119240, 0.217580, -0.103120, 0.475270, 0.091010, -0.101160, 
0.325680, 0.038550, 0.107210, 0.614160, -0.165870, -0.115090, -0.001430, -0.332510, -0.078550, -0.288590, 
-0.122240, -0.533120, 0.130810, 0.524320, 0.065870, -0.166710, 0.423650, -0.098350, 0.679620, 0.098160, 
-0.593780, -0.719280, -0.004140, 0.087660, 0.033670, -0.200470, -0.315880, 0.305970, -0.060190, -0.087460, 
-0.011050, 0.249300, -0.432280, -0.119280, 0.089720, 0.558320, 0.341230, 0.331910, -0.004080, 0.691910, 
-0.254600, -0.240770, -0.620790, 0.245650, -0.062340, -0.195750, -0.109800, -0.227590, 0.527680, 0.459880, 
-0.502760, 0.146910, 0.160470, -0.904570, -0.089850, -0.156630, 0.192700, -0.257580, 0.443710, -0.097800, 
0.359120, 0.360410, -0.043940, -0.077010, -0.215160, 0.546470, 0.599780, -0.268500, -0.290850, 0.021340, 
0.197550, 0.258760, 0.314410, 0.109490, -0.998600, 0.018630, -0.118100, -0.031180, -0.014310, -0.224360, 
-0.128050, 0.703200, 0.164230, -0.329830, -0.479190, 0.044940, 0.056490, -0.087840, -0.247730, -0.233190, 
0.390190, 0.344910, 0.037830, 0.367280, 0.010420, -0.692210, 0.055930, -0.013420, 0.071720, -0.254990, 
0.374310, -0.143670, 0.343100, 0.192270, 0.007030, -0.229230, 0.013320, 0.200910, 0.035990, -0.522350, 
-0.023480, 0.192190, 0.439220, -0.046090, 0.249830, 0.051070, -0.326170, -0.096700, -0.195070, 0.196130, 
0.043230, 0.119310, -0.154310, 0.355210, -0.141160, -0.064030, 0.379950, 0.401420, 0.045620, -0.183930, 
0.090740, -0.142860, 0.089240, 0.225260, -0.240260, 0.155910, -0.394580, -0.179770, -0.091760, -0.184080, 
-0.276900, -0.308130, 0.299850, -0.150240, 0.048260, -0.041000, 0.255070, 0.232900, 0.003660, 0.203000, 
0.244360, 0.132660, 0.094590, -0.000140, 0.260990, 0.339750, 0.133780, -0.196530, 0.042070, 0.026490, 
0.046620, -0.228340, -0.309760, 0.058980, -0.159610, 0.157720, -0.196430, -0.024290, -0.121340, 0.289180, 
0.009820, -0.056020, 0.095040, -0.127080, 0.135900, 0.003800, -0.239410, 0.103980, 0.022290, 0.467260, 
-0.062840, -0.019090, 0.159750, 0.120190, 0.339720, -0.151960, 0.312800, 0.038400, -0.004630, -0.144920, 
0.113290, -0.043420, -0.084700, 0.325400, 0.195200, 0.081070, 0.115100, 0.161870, 0.171330, 0.135790, 
-0.043020, 0.003560, -0.052070, -0.246690, -0.109910, 0.009030, -0.162980, 
0.009060, 0.188680, 0.148360, 0.111810, 0.345740, 0.083380, -0.022830, -0.175720, -0.165310, 0.313980, 
0.319520, 0.071280, 0.010470, -0.185350, -0.139110, 0.057330, 0.125730, 0.256280, 0.004600, 0.126400, 
-0.109790, -0.162460, 0.014330, -0.089660, 0.251570, -0.032970, 0.075480, -0.217480, 0.124560, -0.200000, 
-0.041160, -0.075860, -0.142280, 0.046770, -0.296230, 0.348500, -0.157230, -0.112850, -0.271680, 0.221670, 
-0.212560, -0.105280, -0.225200, -0.074950, -0.062400, 0.189580, -0.423890, -0.039900, -0.041790, -0.128730, 
0.244130, 0.336900, -0.019850, -0.229050, -0.191520, 0.515920, 0.250730, -0.129070, -0.066800, 0.482320, 
0.164170, 0.026290, -0.112180, -0.210560, 0.237000, 0.213310, -0.121880, 0.148230, 0.291580, -0.092640, 
0.176160, -0.208600, 0.248370, 0.178820, 0.038950, -0.046690, 0.131950, 0.217570, 0.110550, 0.185330, 
-0.093620, 0.212800, 0.005900, -0.122560, -0.277450, 0.122640, 0.098000, 0.162140, 0.299180, -0.041720, 
-0.131490, -0.011510, 0.121400, 0.057180, -0.282630, -0.063530, -0.113580, 0.173830, -0.167360, -0.209190, 
-0.018310, -0.010860, 0.259110, 0.070380, -0.106370, -0.145840, -0.044780, -0.148670, -0.007200, -0.068260, 
0.003870, 0.150000, -0.084840, -0.045890, 0.265030, -0.016020, -0.033270, -0.077760, 0.359620, -0.405140, 
-0.097100, 0.229890, 0.056350, 0.153000, 0.046080, -0.097970, 0.205700, -0.116900, -0.213870, -0.104700, 
-0.157420, 0.148420, 0.062200, -0.153210, -0.108670, 0.145110, -0.121350, -0.259720, -0.066010, -0.113000, 
-0.442540, 0.028290, 0.328150, 0.096640, 0.367400, 0.178280, -0.087470, 0.355250, 0.115400, -0.650880, 
-0.103190, -0.012850, 0.240590, 0.582830, -1.092050, 0.050590, 0.502150, -0.051970, -0.025070, 0.307590, 
0.136900, -0.334120, -0.149200, 0.325020, 0.026350, 0.258310, 0.520200, -0.090900, 0.414090, -0.020370, 
-0.244450, -0.144690, -0.108170, 0.278780, 0.848980, -0.957540, 0.398750, 0.522650, -0.137110, -0.028920, 
-0.119980, 0.113800, -0.892330, -0.367440, -0.401900, 0.269430, 0.150700, 0.435590, 0.004340, 0.554650, 
0.173210, -0.376650, 0.003510, 0.321040, 0.492330, 0.446660, -1.267240, -0.276260, 0.416710, 0.426560, 
0.399810, 0.376210, 0.035120, -1.332150, -0.175450, -0.180970, -0.436810, 0.181900, 0.514470, -0.124820, 
0.398960, 0.136560, -0.358340, -0.402650, -0.002060, 0.258860, 0.054950, -0.298010, -0.253110, 0.021380, 
0.417230, 0.123570, 0.369420, 0.022080, -1.163030, -0.444500, -0.567180, 0.285490, 0.092410, 0.013990, 
-0.149290, 0.211900, 0.231180, -0.026810, -0.142880, 0.509430, 0.158980, -0.076770, 0.051270, 0.191590, 
0.106640, 0.021200, 0.181910, 0.154480, -0.015050, -0.729570, -0.041340, -0.242280, 0.325660, 0.168930, 
-0.211670, -0.165130, 0.195230, 0.387220, 0.061290, -0.062360, 0.321530, -0.072050, -0.032860, -0.086480, 
0.364170, -0.173760, 0.234160, 0.370610, 0.310120, 0.145470, -0.675570, -0.059050, -0.182340, 0.070140, 
0.207640, -0.158260, -0.169970, 0.181980, 0.240670, 0.232030, -0.002370, -0.027530, 0.260130, 0.281170, 
-0.080950, 0.125300, -0.064130, 0.141040, 0.469930, -0.096770, -0.158000, -0.129710, 0.063320, 0.013180, 
0.174540, -0.116220, -0.100060, -0.163960, 0.049760, -0.096960, 0.024510, 0.027220, 0.338380, -0.137250, 
-0.156740, 0.222900, -0.139350, 0.025110, 0.388940, 0.104750, 0.206590, -0.345050, -0.220670, 0.085430, 
-0.149500, 0.002870, 0.061460, -0.016100, -0.184740, -0.114320, 0.036710, 0.393910, 0.188330, 0.144050, 
0.226930, -0.007730, 0.032950, 0.419200, -0.126240, -0.109430, 0.116530, 0.050210, 0.303460, -0.351130, 
0.141110, -0.176500, -0.050760, 0.014230, -0.256560, -0.174780, -0.156240, 0.218930, 0.336780, 0.097890, 
-0.261190, 0.363660, -0.058230, 0.548130, 0.350490, -0.095920, 0.086750, 0.153020, 0.074520, -0.167190, 
0.024990, 0.085400, -0.139580, -0.127030, 0.089200, -0.263930, -0.170790, 
0.265040, 0.045790, -0.189330, -0.051180, 0.208630, 0.093790, -0.115910, 0.019550, -0.131990, -0.006700, 
-0.218150, -0.018410, 0.012290, -0.007450, -0.165450, -0.039200, -0.354460, 0.039480, 0.099090, 0.053210, 
0.053740, 0.198920, 0.088190, 0.091380, 0.296790, 0.096260, 0.216920, 0.471950, -0.154960, 0.061460, 
0.112060, -0.159060, -0.070590, 0.203780, 0.098710, 0.040620, 0.179220, 0.158540, 0.181180, -0.053730, 
0.092710, 0.036230, 0.168300, 0.156640, -0.230460, 0.081330, -0.311260, 0.273120, 0.445910, -0.484440, 
-0.183270, 0.207930, 0.243410, 0.255080, -0.064070, -0.137420, -0.052820, -0.004990, -0.061080, -0.048090, 
0.019510, 0.145270, 0.043290, 0.333320, -0.087830, -0.112650, -0.420100, 0.244640, 0.009700, -0.194880, 
-0.243850, -0.217670, 0.331480, 0.541150, -0.077820, 0.041050, 0.018430, -0.075340, -0.144520, -0.201130, 
0.207630, -0.011290, 0.055810, 0.056520, 0.238010, 0.023300, 0.169050, 0.148340, 0.100180, 0.117020, 
0.199540, -0.383810, 0.283690, -0.072080, -0.058650, 0.201790, -0.148940, -0.129480, -0.314020, 0.186180, 
0.003700, -0.168280, 0.261040, -0.097640, 0.051650, 0.246470, 0.354070, 0.107000, 0.238990, 0.172950, 
0.424410, 0.368890, 0.238610, -0.050880, 0.213840, -0.017460, 0.658040, 0.124300, -0.352280, 0.182640, 
0.205640, -0.170500, -0.230120, 0.152830, -0.028920, 0.035980, 0.083740, -0.097560, 0.326540, 0.320250, 
0.128250, 0.362660, 0.536280, -0.059720, 0.245620, 0.266720, 0.175540, 0.380880, -0.000190, 0.227130, 
-0.122270, 0.164360, 0.221190, -0.135830, 0.384500, -0.040680, 0.045560, -0.042600, 0.131320, -0.027930, 
-0.193390, -0.404360, -0.392740, -0.240210, 0.362760, 0.061790, -0.182970, 0.043920, 0.061690, -0.239560, 
-0.036570, 0.511860, -0.241180, 0.020940, -0.166550, 0.295080, -0.079860, 0.043450, -0.354700, -0.073490, 
0.290410, 0.265760, -0.082050, -0.094240, -0.566090, 0.755540, -0.086920, -0.348710, 0.046150, 0.174690, 
-0.277890, -0.124460, 0.672890, -0.004100, -0.215760, -0.143900, -0.325010, -0.135460, 0.004760, -0.481070, 
-0.175460, -0.242480, 0.243570, 0.732100, -0.090630, -0.160260, -0.018320, 0.225320, 0.294360, 0.053430, 
0.017100, 0.105620, 0.178830, 0.559800, -0.287640, -0.169030, 0.505640, 0.545750, 0.285330, 0.139560, 
-0.373290, -0.051760, -0.162520, 0.404800, 0.137400, -0.016610, 0.011580, 0.017800, -0.051090, 0.370110, 
0.022660, -0.097660, -0.217830, -0.030490, 1.400950, -0.100930, 0.225380, -0.499890, -0.116840, 0.328330, 
0.151000, -0.369800, 0.174600, -0.098120, 0.317910, 0.243790, 0.048450, 0.232070, -0.540020, 0.182040, 
0.290300, 0.140440, -0.011010, 0.042970, 0.136500, 0.432510, -0.051490, 0.166090, -0.007690, 0.243310, 
0.385180, 0.180980, 0.067670, -0.051040, 0.000350, -0.189960, 0.638230, -0.152010, -0.338200, 0.240280, 
0.140060, 0.061070, 0.056400, -0.144440, 0.133860, 0.000280, -0.072350, 0.312710, -0.068120, -0.099640, 
-0.050160, 0.060380, 0.145520, -0.011220, -0.053830, 0.314950, 0.059680, 0.091930, -0.072110, -0.165640, 
0.352580, 0.326060, 0.053490, -0.315650, -0.284990, 0.133560, -0.065870, -0.196830, 0.149340, 0.040170, 
-0.065640, -0.100850, -0.088540, 0.141010, -0.055530, 0.065860, 0.103760, -0.040630, 0.321120, -0.026460, 
-0.238910, 0.175040, 0.200770, -0.153200, -0.250620, -0.126970, -0.059240, 0.186630, 0.011360, 0.225550, 
0.207840, 0.243520, -0.008480, 0.073770, 0.163920, 0.394230, -0.019020, -0.131460, -0.494670, 0.724620, 
-0.120650, -0.060650, -0.195700, -0.129990, 0.198860, 0.031650, -0.066690, -0.130610, 0.053000, 0.077720, 
0.149770, 0.263330, 0.232720, 0.024580, 0.272550, 0.161520, 0.154680, -0.096340, 0.012630, 0.149740, 
0.045940, -0.045150, 0.285400, 0.062700, 0.438260, 0.093560, 0.244040, -0.176450, 0.084350, 0.196990, 
0.090960, 0.023760, 0.066990, 0.139710, 0.113820, 0.106780, 0.133390, 
0.144970, 0.066260, -0.271510, -0.066030, 0.025460, 0.206910, 0.086540, 0.185470, 0.023200, 0.058790, 
-0.059730, 0.165730, -0.148710, -0.019470, -0.043690, -0.137780, -0.207520, 0.012280, 0.088990, 0.088550, 
0.043910, -0.119360, -0.001590, 0.050470, -0.188290, 0.210870, -0.159770, -0.106230, -0.126610, 0.041990, 
0.152360, 0.047420, -0.064690, 0.277120, 0.047360, 0.016980, -0.159450, -0.065010, 0.116830, 0.135700, 
0.050200, 0.027260, 0.094680, -0.052310, -0.150610, 0.157980, 0.364380, 0.046550, 0.070940, 0.014940, 
-0.030950, -0.155460, -0.128540, 0.009460, -0.171180, 0.061800, -0.010180, -0.013750, 0.189330, 0.045150, 
-0.219250, -0.169000, 0.031730, 0.281520, 0.308660, -0.188000, -0.070350, 0.125100, -0.105340, 0.023560, 
-0.321550, -0.114770, 0.290680, 0.076280, 0.029520, -0.041920, -0.051730, -0.057810, 0.004150, 0.094130, 
-0.145910, -0.040230, 0.318970, 0.046020, -0.001070, -0.135130, -0.243000, -0.268020, 0.215810, -0.410840, 
-0.089420, -0.357010, -0.202160, 0.461910, 0.400640, -0.077430, 0.077210, 0.056970, -0.117400, -0.032100, 
-0.091040, 0.269330, 0.044200, 0.156770, 0.035810, 0.129790, 0.073590, -0.434510, -0.176140, 0.066180, 
0.033790, 0.029520, -0.298490, -0.090630, 0.236340, 0.243350, 0.176960, 0.066720, 0.052160, -0.164680, 
-0.267520, -0.147980, 0.044670, 0.239280, 0.235560, 0.050830, -0.060690, 0.163650, 0.309910, 0.371420, 
-0.301720, 0.362240, 0.347380, 0.371340, 0.345680, -0.112530, -0.067250, 0.483170, -0.069580, 0.090840, 
-0.105810, 0.045860, -0.027580, -0.167870, 0.140750, -0.106110, 0.041960, -0.003710, -0.098710, 0.086770, 
0.290710, 0.005600, 0.094840, -0.132020, 0.550030, 0.170540, -0.048120, 0.150330, 0.096480, 0.217910, 
-0.073760, -0.084330, 0.000860, 0.090820, 0.016330, 0.002250, -0.017220, 0.036910, -0.293940, 0.347610, 
0.262440, 0.488870, 0.081870, 0.193230, -0.367480, 0.555390, 0.093950, -0.465480, -0.176610, 0.205020, 
0.070370, -0.238230, 0.755570, 0.099290, -0.024510, 0.079820, -0.107480, -0.308110, 0.003650, -0.252860, 
0.096740, 0.100090, -0.012920, 0.079310, 0.042960, -0.199350, 0.416520, 0.186580, -0.012000, 0.015150, 
0.090650, -0.075000, 0.018290, 0.478870, 0.022200, -0.028990, 0.235980, 0.154660, 0.006360, 0.050160, 
-0.098020, -0.237780, -0.224690, 0.136560, 0.301050, -0.267320, 0.036080, 0.118740, -0.082800, -0.036330, 
-0.146840, 0.020100, -0.052580, -0.150120, 0.395360, -0.011810, -0.033890, 0.133250, -0.027850, 0.216440, 
0.071060, -0.136870, -0.050710, -0.280420, 0.016420, -0.097570, -0.122730, -0.113800, -0.203490, -0.046410, 
0.332450, 0.334640, 0.144010, 0.274080, 0.060860, 0.217400, 0.023880, 0.218040, 0.159840, -0.050420, 
0.522870, 0.082040, -0.203090, 0.110500, -0.095580, -0.304490, -0.083050, 0.023660, -0.086950, -0.137600, 
0.019710, 0.366510, 0.104430, -0.162760, 0.140600, 0.336640, -0.014720, -0.005400, -0.022720, 0.123240, 
0.237450, 0.345170, 0.080310, 0.025400, 0.119110, -0.088150, -0.054940, 0.010550, -0.084620, -0.035410, 
-0.298100, -0.002780, 0.267530, -0.078650, 0.129840, 0.045820, 0.349310, 0.092780, 0.167640, 0.395150, 
-0.270040, -0.126850, 0.217080, 0.078020, -0.245170, -0.176490, -0.109980, 0.087590, 0.311710, -0.029720, 
-0.102890, -0.075870, -0.164700, 0.160840, -0.071470, -0.078850, 0.212430, 0.149810, -0.099210, -0.029970, 
0.000880, 0.066000, -0.139920, 0.243350, 0.062970, -0.028260, -0.012540, -0.086440, 0.052430, -0.013630, 
-0.073970, -0.033430, -0.195770, 0.113130, 0.040210, -0.043490, -0.154210, -0.091910, 0.082350, 0.282050, 
-0.005510, 0.033370, 0.089490, 0.051950, 0.206190, 0.056210, -0.060240, 0.063950, 0.081020, 0.157920, 
0.021930, 0.019470, -0.090240, 0.298520, 0.199130, -0.103730, -0.144520, -0.226290, -0.071140, 0.047040, 
0.182700, -0.130180, -0.230230, 0.251870, 0.102050, -0.105620, 0.050950, 
0.074850, 0.137710, 0.439670, 0.198860, -0.035250, 0.124060, 0.365940, 0.234460, -0.024590, 0.461560, 
0.354680, 0.253170, 0.037920, 0.324200, 0.010240, 0.242560, 0.338360, 0.065730, 0.172500, 0.207300, 
-0.058250, -0.195740, -0.025240, 0.418950, 0.664150, 0.649760, 0.151660, 0.206020, 0.981260, -0.007220, 
-0.290290, -0.130390, 0.459320, -0.104960, -0.209880, 0.074760, 0.241580, -0.362800, -0.079010, -0.010960, 
-0.396580, -0.088040, -0.256120, 0.304630, 0.319990, 0.230550, 0.128960, 0.530990, 0.271900, 0.931430, 
0.180410, -0.063990, 0.203200, 0.447940, -0.126600, -0.360920, 0.032470, 0.420690, 0.121640, 0.376370, 
0.073190, -0.086540, -0.131170, -0.599240, 0.076780, 0.347790, 0.222190, 0.154760, -0.023210, -0.124360, 
0.790490, -0.194370, -0.017710, -0.003510, 0.459070, -0.146350, -0.000330, 0.298760, 0.293430, 0.026420, 
0.069580, 0.002350, -0.243410, -0.113860, -0.522360, 0.119950, 0.194210, 0.173540, 0.330060, -0.015870, 
-0.542730, 0.772330, 0.266310, -0.224930, -0.526810, 0.375210, -0.225940, -0.213780, 0.435400, 0.258650, 
0.371410, 0.033100, -0.061130, 0.145060, -0.119240, -0.315640, -0.111630, -0.311540, -0.403990, 0.069940, 
-0.047660, -0.272780, 0.352460, -0.169400, 0.451510, -0.159890, -0.382120, -0.283760, -0.416280, -0.344900, 
0.116810, 0.377620, 0.355740, -0.132960, 0.692440, -0.093080, -0.386560, 0.677130, -0.259320, -0.590070, 
-0.280880, 0.293530, -0.296390, -0.543400, -0.126250, 0.501280, 0.063220, 0.130490, 0.260210, 0.115350, 
-0.339860, -0.191210, 0.332720, 0.334770, -0.075340, 0.830870, -0.075300, -0.255980, 0.271880, -0.657040, 
-0.483940, 0.184360, -0.238410, 0.159300, -0.271980, 0.035460, 0.639210, -0.076060, -0.052600, 0.154640, 
0.239660, -0.551150, 0.382690, 0.653010, 0.058980, 0.538710, 0.944850, -0.066070, -0.497940, -0.016260, 
-0.317460, -0.066460, -0.037540, -0.163920, 0.069920, -0.529460, -0.453200, 0.569310, -0.214000, -0.218690, 
0.030690, 0.520290, -0.351100, 0.198610, 0.249580, 0.219740, 0.281970, 0.953040, 0.004940, -0.395130, 
-0.289170, -0.279350, -0.368970, -0.078280, -0.142760, -0.137190, 0.328990, 0.051450, 0.309340, -0.272070, 
-0.531830, -0.082210, 0.082260, -0.147410, -0.027980, 0.071430, -0.240970, -0.100350, 0.296890, -0.064950, 
-0.319690, 0.083070, 0.011870, 0.238870, -0.006700, -0.035850, 0.115660, 0.121540, 0.074640, 0.145090, 
-0.367490, -0.284650, -0.091840, -0.217950, 0.565190, 0.300130, 0.596480, -0.437860, -0.399450, 0.386810, 
-0.093070, -0.353840, -0.180420, 0.215770, 0.316220, 0.209920, 0.169540, -0.003850, 0.314840, 0.071970, 
-0.102530, -0.171860, 0.000550, -0.303320, -0.221740, 0.045710, 0.412300, 0.443300, 0.195040, 0.096290, 
0.280730, -0.058090, -0.169620, -0.311120, 0.299470, 0.278660, 0.069770, -0.113530, 0.188250, 0.751000, 
-0.041240, -0.076040, -0.354590, -0.006770, -0.443830, 0.363430, 0.171530, 0.720590, 0.068370, 0.027680, 
-0.092380, 0.002650, -0.062370, -0.547610, -0.233860, 0.171600, 0.215160, 0.157860, -0.008720, 0.100530, 
0.430940, -0.325200, -0.134440, -0.259150, 0.197410, -0.349150, 0.047070, 0.376910, 0.327050, 0.439290, 
0.079660, 0.065690, -0.048160, -0.041710, -0.246590, -0.246140, 0.046340, 0.062840, 0.044570, 0.087680, 
0.182790, 0.350020, 0.035680, -0.067700, -0.393510, 0.075370, -0.199100, -0.109460, -0.268120, 0.371380, 
0.453910, 0.337240, -0.083090, 0.161970, -0.050260, -0.281680, 0.123740, -0.028700, -0.187340, 0.322560, 
0.052040, 0.222910, 0.070710, -0.123710, 0.217700, -0.019080, 0.139010, -0.077410, 0.167840, 0.157900, 
0.191790, 0.398120, -0.087970, -0.078380, 0.326360, -0.050300, 0.155770, 0.028090, -0.022610, -0.249610, 
-0.139090, 0.030810, 0.033290, 0.490150, -0.106040, 0.158530, 0.104470, 0.133510, -0.018100, 0.025910, 
0.422690, 0.135910, 0.338410, 0.424570, 0.133410, 0.367820, -0.051260, 
0.047280, -0.007680, 0.153220, -0.059420, -0.128570, 0.305030, -0.071500, 0.046050, -0.523230, -0.157410, 
0.073330, -0.018260, -0.115570, -0.142660, 0.140380, 0.361140, 0.255070, -0.008860, -0.387350, -0.218680, 
0.089640, -0.098430, 0.443860, -0.285200, -0.426900, -0.411290, 0.342780, -0.271920, -0.266510, -0.149170, 
-0.113600, -0.009550, 0.270380, -0.136030, -0.323800, 0.022220, -0.153640, 0.096400, 0.158640, -0.037590, 
-0.181040, 0.092800, -0.006010, 0.174950, -0.098950, 0.332530, 0.142280, 0.015480, 0.149120, 0.462440, 
0.191620, 0.140120, -0.199610, 0.434480, -0.068580, -0.241210, 0.230310, -0.199630, -0.001350, 0.106970, 
0.288340, 0.223390, 0.074790, -0.109690, -0.013480, 0.114530, 0.382290, -0.075180, -0.020670, 0.493980, 
-0.202170, -0.142190, 0.243130, 0.372800, 0.341910, 0.226610, 0.271410, -0.057300, -0.079370, -0.122050, 
-0.661340, -0.040130, 0.333660, 0.052810, -0.296880, -0.262800, -0.045170, -0.053790, -0.047680, -0.319880, 
-0.278690, -0.133000, -0.171810, -0.161470, 0.095530, 0.082160, -0.443020, 0.198660, -0.194450, 0.223840, 
0.366560, -0.143190, -0.086110, -0.038830, 0.054370, -0.251660, 0.483490, 0.083200, 0.197110, 0.015530, 
-0.079020, -0.000070, 0.072230, -0.163080, 0.276980, -0.149350, 0.492650, 0.050540, 0.052310, 0.348250, 
0.070760, -0.152020, -0.303020, -0.002830, 0.462900, 0.069120, -0.547290, 0.581620, 0.323520, 0.003570, 
0.217920, 0.454530, 0.522040, 0.573640, 0.245570, -0.088390, 0.253950, 0.787400, -0.161960, -0.284520, 
0.108730, -0.381840, -0.290300, -0.441580, 0.471510, 0.091490, 0.049810, -0.426300, -0.186400, 0.071280, 
0.607230, 0.065730, -0.067100, 0.136790, -0.092650, 0.143470, -0.117540, -0.321310, -0.056730, -0.224400, 
-0.149450, -0.012500, 0.015780, 0.220440, -0.569850, -0.408340, 0.147810, 0.034400, -1.224590, -0.067810, 
-0.733730, -0.873160, -0.506050, -0.053910, -1.423820, -0.027860, 0.325330, 0.083660, -0.440500, -0.400840, 
0.183880, -0.151140, 0.297510, -0.442040, 0.092710, -0.257980, -0.093350, 0.325860, -0.008460, -1.469020, 
0.215870, 0.252520, 0.278520, -0.160170, -0.267210, -0.110060, 0.601780, -0.110660, -0.223440, -0.938650, 
-0.097390, -0.251990, 0.170860, 0.709050, 0.170870, 0.103820, -0.620130, -0.054100, 0.180960, 0.049800, 
-0.646290, 0.322710, 0.073860, 0.923500, -0.167670, 0.272850, 0.992330, -0.336330, 0.202450, 0.308600, 
-0.790740, 0.375660, -0.394740, -0.348430, 0.781590, 0.258220, 0.077580, -0.503330, 0.255420, 0.303140, 
0.102890, -0.843320, -0.276690, -0.051000, 0.093530, -0.061760, -0.638190, -0.114400, 0.079830, 0.058340, 
-0.525370, -0.517390, -0.616870, -0.418560, -0.095710, 0.505440, 0.101580, 0.534420, -0.353250, -0.112720, 
0.104250, 0.142450, -0.891330, -0.596470, -0.188210, -0.206380, -0.332910, -0.308600, -0.042770, -0.542490, 
-0.144710, 0.016900, 0.030280, -0.367580, -0.245290, 0.116750, 0.592440, -0.179110, -0.182130, -0.194740, 
0.123510, 0.245630, 0.171340, -0.646400, 0.356550, 0.105820, 0.253960, -0.068570, 0.223300, 0.416580, 
0.224630, -0.120090, -0.283660, -0.929560, 0.240220, -0.284600, -0.090860, 0.529100, 0.061080, 0.137840, 
-0.381290, -0.537710, 0.150190, 0.120380, -0.647390, -0.175900, 0.022960, 0.467400, 0.179630, -0.058830, 
0.081710, -0.287620, -0.355150, -0.180500, -0.533860, 0.025980, -0.052760, -0.100210, 0.293640, 0.162890, 
0.384760, 0.042620, 0.145820, -0.346620, 0.130900, -0.442500, -0.427200, -0.041150, -0.003010, 0.014180, 
-0.626660, -0.039820, -0.348500, -0.260220, -0.086890, -0.280270, -0.274300, -0.384560, -0.166650, 0.234940, 
-0.156640, 0.203970, -0.351050, -0.066050, -0.142880, 0.140590, -0.286090, 0.202290, -0.134240, 0.193890, 
-0.568230, -0.083560, 0.129910, 0.180820, -0.063270, 0.042910, -0.437990, 0.211060, -0.505360, 0.076100, 
0.075050, -0.090470, 0.012720, -0.487440, 0.252880, 0.104800, 0.138140, 
0.050280, 0.368510, -0.109890, 0.121360, 0.471660, -0.109620, -0.266520, 0.302700, 0.285480, 0.109320, 
-0.122700, 0.032180, -0.002230, 0.388390, 0.293370, 0.149720, 0.242200, 0.261570, -0.095690, 0.001850, 
-0.070690, 0.160020, 0.184140, 0.133650, 0.234870, 0.491410, 0.018810, 0.119880, 0.219550, 0.032030, 
0.033880, 0.041700, -0.148770, 0.215160, 0.065480, 0.053530, 0.170540, 0.226440, 0.353250, 0.182500, 
0.263860, -0.070890, 0.048480, -0.151430, 0.123750, -0.076760, 0.194400, 0.079780, -0.176810, 0.354240, 
0.230110, 0.077580, 0.228480, 0.058200, 0.072440, -0.054200, 0.121880, -0.119770, -0.348550, 0.028090, 
-0.088430, 0.209260, -0.044310, 0.393760, -0.197110, -0.007910, 0.257510, 0.177160, 0.080690, 0.191240, 
0.195200, 0.020080, 0.044220, 0.030680, -0.150470, -0.045370, 0.386900, 0.300010, 0.080750, -0.109930, 
0.354140, -0.006460, -0.003850, -0.048470, 0.060310, -0.039130, 0.052150, -0.266090, 0.086750, -0.115000, 
-0.310290, 0.480160, 0.544480, -0.307840, 0.240950, -0.409840, -0.125230, -0.011760, 0.474600, 0.643610, 
0.283510, 0.287410, -0.339510, -0.379650, -0.030630, 0.305880, 0.376440, -0.100800, 0.117510, 0.448130, 
0.072820, 0.094020, 0.187090, 0.378230, 0.069990, 0.069450, 0.158420, 0.185830, 0.045690, 0.247720, 
0.041410, -0.163230, 0.075720, 0.254880, 0.133000, -0.032810, 0.416610, -0.068720, 0.232700, 0.417700, 
0.436020, 0.064600, 0.412640, 0.110580, 0.138280, 0.042350, -0.015620, 0.070780, 0.104220, -0.009460, 
0.384730, -0.155650, -0.138750, 0.112980, 0.111830, 0.169200, -0.042370, 0.604660, -0.464360, 0.233670, 
0.167520, 0.074420, 0.021770, 0.049260, -0.325320, -0.109050, -0.160920, 0.226610, -0.611200, -0.320010, 
-0.099100, 0.005840, 0.548610, 0.489110, -0.073990, -0.310550, -0.026000, -0.029510, 0.501040, 0.060220, 
-0.124530, -0.619240, -0.026240, -0.198690, -0.159630, -0.271570, -0.014870, 0.472590, 0.609460, -0.312320, 
-0.014400, 0.387410, 0.233740, -0.399590, -0.394740, 0.125480, -0.407510, -0.046300, -0.005890, 0.907660, 
0.573250, 0.531490, 0.500720, 0.295740, 0.640750, 0.625360, -0.233140, -0.006720, -0.011230, 0.445940, 
0.718130, -0.079840, 0.099390, -0.034710, -0.036030, -0.290340, 0.400290, -0.231910, -0.209680, -0.071900, 
1.231320, 0.404090, 0.115660, 0.682380, 0.309560, 0.811910, 0.665170, -0.024390, 0.053600, 0.040250, 
0.474440, 0.570260, 0.140010, -0.145300, -0.656480, 0.060560, 0.061480, 0.279130, 0.044090, 0.047000, 
-0.069390, 1.105270, -0.418100, -0.204690, -0.530400, 0.570030, -0.317720, -0.539110, -0.335170, -0.374700, 
0.629480, 1.019580, -0.506780, 0.456070, 0.320140, -0.642290, -0.212910, -0.297610, 0.417410, 0.206210, 
0.132370, -0.102020, 0.748360, 0.337200, -0.128820, -0.423770, 0.668510, 0.511400, -0.121270, -0.451120, 
-0.186880, 0.419000, 1.300510, 0.049690, 0.123140, -0.105700, -0.629790, -0.223960, -0.122660, -0.205250, 
0.131390, 0.305100, -0.141940, 0.655120, 1.125950, 0.909930, 0.580420, 0.357820, 0.603350, 0.258180, 
0.584580, 0.119180, -0.422540, 0.028180, 0.646490, 0.072880, -0.362000, -0.221040, 0.216770, 0.110110, 
0.122750, 0.065960, -0.349260, -0.152020, 0.658010, 0.810580, 0.090430, -0.011150, -0.012090, 0.342910, 
0.515970, 0.014770, 0.292400, 0.234440, 0.764880, 0.368780, 0.312950, -0.075280, -0.558050, 0.003440, 
-0.212830, 0.175290, 0.266830, 0.097420, -0.168120, 0.452010, 0.413390, -0.140550, -0.460370, 0.091050, 
-0.015400, -0.281110, -0.002810, 0.265300, 0.287450, 0.909800, -0.202350, 0.489380, 0.076190, -0.315020, 
-0.143120, -0.144230, 0.395950, 0.216690, -0.258080, -0.170370, 0.261180, 0.496780, -0.136770, -0.124890, 
-0.231530, 0.254850, -0.046900, 0.331460, -0.071750, 0.020630, 0.171070, 0.244050, -0.104120, 0.075400, 
-0.391680, 0.183980, 0.031650, 0.463800, -0.377050, -0.131460, -0.159590, 
0.117940, -0.207060, -0.180020, -0.100280, 0.024150, -0.352640, -0.567430, 0.655410, -0.071170, 0.202140, 
0.167160, -0.191610, -0.023300, 0.348860, -0.093720, 0.139000, -0.050570, 0.205600, -0.020280, -0.296130, 
-0.084040, 0.241410, -0.056650, 0.293140, 0.070200, -0.038570, -0.227680, -0.248900, 0.307330, 0.155800, 
-0.227260, -0.183350, -0.119630, 0.151410, -0.037040, 0.017320, 0.008800, 0.067710, -0.285200, -0.058550, 
-0.007490, -0.082910, 0.189830, 0.195890, 0.196810, 0.231560, -0.160410, 0.066560, 0.388240, 0.173070, 
0.345600, -0.167710, -0.155370, -0.125680, 0.134520, 0.178600, 0.185270, -0.040760, -0.017980, 0.379390, 
0.518490, -0.321450, -0.054230, 0.130710, -0.345690, 0.157570, -0.205710, -0.208610, -0.224910, -0.173590, 
0.114580, -0.162120, -0.313570, 0.472530, -0.207540, 0.276440, 0.074100, -0.141100, 0.429610, 0.002230, 
0.367910, 0.026140, -0.110000, -0.036300, 0.108330, 0.014780, -0.468790, -0.524230, 0.220670, -0.034160, 
-0.716420, -0.152380, 0.282110, 0.159470, 0.623570, -0.369480, 0.095110, 0.378230, 0.282900, 0.078080, 
0.083780, 0.108400, -0.014770, -0.054190, -0.011840, 0.461530, 0.467650, 0.444320, 0.508300, -0.032130, 
0.200180, 0.152640, 0.196690, -0.451490, -0.050820, 0.180160, 0.217250, 0.240670, 0.134730, 0.116810, 
0.276080, 0.059510, 0.825010, -0.175370, -0.166080, -0.009560, 0.768570, 0.053050, 0.357690, 0.377570, 
-0.150940, 0.190000, 0.090490, -0.016940, -0.177540, 0.213000, 0.897770, -0.154340, 0.615290, -0.278650, 
-0.189080, 0.203290, -0.020440, 0.139670, -0.116120, -0.022000, -0.000160, 0.632010, -0.406620, -0.250250, 
-0.151280, 0.261490, -0.391650, -0.760060, -0.403180, 0.234210, 0.105620, 0.763860, -0.817680, 0.308760, 
0.155540, -0.082360, 0.168680, 0.168460, -0.114070, -0.278180, -0.234790, -0.002200, 0.639010, 0.434590, 
-0.107760, -0.507030, -0.169350, 0.033030, -0.034530, -0.112840, -0.467870, 0.199280, 0.540480, 0.008950, 
0.524650, -0.001510, 0.079770, -0.128870, -0.027080, 0.084260, -0.100540, -0.047030, -0.006270, 1.505710, 
0.541900, 0.562790, 0.460360, 0.007600, 0.521310, 0.794410, 0.317300, 0.074120, 0.325260, 0.593240, 
0.423980, 0.337500, -0.040290, -0.177470, 0.502160, 0.247100, 0.374820, 0.091170, -0.046260, -0.035630, 
0.991670, -0.297390, 0.017900, 0.699320, 0.376050, 0.400040, 0.463460, -0.458600, 0.194650, 0.259810, 
0.933040, 0.066940, 0.196450, 0.151940, -0.630500, 0.104370, -0.230530, -0.080810, -0.032840, 0.000340, 
-0.067820, 1.010590, -0.302350, -0.191690, -0.907420, 0.240250, -0.147700, -0.647300, -0.384370, 0.198290, 
0.218860, 0.887830, -0.408840, 0.411230, -0.079910, -0.557520, -0.159800, -0.034080, -0.290840, 0.078370, 
-0.024330, -0.101600, 0.492670, 0.192900, 0.326900, -0.195090, 0.615570, 0.319110, 0.047460, 0.218990, 
0.256030, -0.097020, 0.511710, 0.198380, 0.360260, -0.187420, -0.320440, -0.111240, -0.260330, 0.186580, 
-0.135370, -0.151450, -0.130390, 0.452540, 0.379770, 0.239680, -0.093360, -0.049490, 0.250030, 0.184680, 
0.043740, 0.199590, -0.071610, 0.368830, 0.453930, 0.407850, -0.075420, -0.058560, -0.040950, -0.051840, 
-0.088290, 0.023660, -0.486220, -0.128340, 0.659290, 0.073500, -0.008360, -0.241120, 0.202570, 0.099470, 
-0.319990, -0.108020, 0.028800, 0.097270, 0.437140, -0.062260, -0.205590, 0.159170, -0.303930, 0.101950, 
-0.045890, 0.031680, 0.363310, -0.010520, -0.133050, 0.629800, -0.040500, -0.015160, -0.263750, 0.392320, 
-0.242950, -0.193430, 0.034340, 0.455690, 0.133820, 0.525390, -0.054870, -0.063730, 0.332420, -0.126800, 
-0.032620, -0.088340, -0.307480, -0.117780, 0.185530, -0.154670, 0.288120, -0.041770, -0.178760, 0.031220, 
0.162300, 0.285430, 0.116910, 0.054500, 0.044560, 0.071270, -0.002590, 0.019150, 0.299270, 0.163830, 
-0.190200, -0.217420, -0.272960, 0.188700, -0.007740, 0.078340, -0.159780, 
-0.074940, 0.124620, 0.147750, 0.263920, -0.141320, 0.008490, 0.140370, 0.045620, -0.292190, -0.002410, 
0.119410, 0.062850, 0.325080, -0.236540, -0.117020, -0.033860, 0.178750, -0.415240, -0.210360, 0.075770, 
0.031390, 0.030620, -0.119210, 0.035160, 0.153870, 0.136780, -0.164420, 0.052070, 0.045100, 0.018960, 
-0.441320, -0.217160, -0.475460, -0.149530, 0.150920, -0.127170, -0.131870, -0.000350, 0.003800, 0.143820, 
-0.346390, 0.060600, -0.046360, 0.134030, 0.013780, -0.278510, 0.115150, -0.035780, -0.280980, -0.318760, 
-0.091040, 0.082780, 0.399420, -0.262360, 0.064710, 0.057670, -0.422760, -0.037410, 0.067890, 0.055220, 
-0.215150, 0.055820, 0.073130, 0.251860, -0.015300, -0.246320, -0.303830, -0.138910, -0.022880, 0.043240, 
-0.016590, -0.043600, -0.107830, -0.166360, -0.253540, 0.207100, -0.097300, 0.032290, -0.208900, -0.415430, 
0.305230, 0.106650, -0.237800, 0.088480, 0.274410, -0.260500, -0.055970, -0.001890, 0.082370, -0.001410, 
0.065020, -0.690430, 0.009320, 0.370460, 0.453960, -0.141340, 0.440580, 0.237050, -0.269630, -0.054070, 
-0.095710, 0.294320, 0.196860, 0.031180, 0.078320, 0.545360, 0.169590, -0.282130, -0.132210, -0.064960, 
-0.031910, 0.077200, 0.054000, -0.059340, -0.051980, 0.315810, -0.036590, -0.006990, -0.006380, -0.336730, 
-0.012020, -0.248320, 0.114000, 0.161580, -0.405900, 0.064850, 0.597530, 0.130550, 0.155380, 0.170720, 
0.037410, 0.097510, 0.032460, -0.510050, -0.232430, -0.030560, 0.501250, 0.063410, 0.396910, 0.125300, 
0.247590, -0.020870, -0.082980, -0.215510, 0.163550, -0.176790, 0.058130, 0.410570, 0.009370, 0.542440, 
0.689660, -0.314200, -0.011800, 0.230320, 0.260370, -0.164220, -0.562890, 0.483970, 0.184350, -0.176410, 
-0.361950, 0.703930, 0.300050, -0.148480, -0.522970, -0.561540, -0.728820, 0.061770, 0.594470, -0.302820, 
0.300380, 0.077760, 0.244820, -0.051350, -0.531240, 0.694520, -0.089140, -0.514230, 0.238990, -0.354000, 
0.083560, 0.155620, 0.491970, -0.179960, -0.678530, 0.224510, 0.111500, -0.966610, 0.008070, 0.245170, 
0.358900, 0.363720, 0.258280, -0.262940, 0.433950, 0.336230, -0.031810, 0.200450, -0.235570, 0.163220, 
0.316260, 0.148930, 0.016670, 0.188760, 0.122360, -0.077640, -0.017750, 0.228090, -0.570920, 0.029030, 
0.149430, -0.196200, 0.164900, 0.065240, 0.015950, -0.025820, -0.136320, -0.224360, -0.174430, -0.311730, 
0.267530, -0.173220, -0.045020, 0.401320, -0.326870, -0.169420, -0.179750, 0.268230, 0.054710, -0.526430, 
0.045820, 0.323260, 0.072640, 0.084350, 0.107130, -0.295060, 0.188900, 0.434240, 0.027580, 0.072650, 
-0.119250, -0.011560, 0.299550, -0.259030, -0.011090, -0.334850, -0.054840, 0.011490, -0.147730, 0.043680, 
-0.035200, 0.027120, 0.487370, 0.018520, -0.174130, -0.143530, 0.142340, 0.004130, -0.133080, -0.297940, 
0.091790, 0.009800, 0.189820, -0.158430, -0.253870, 0.080410, 0.022800, -0.301280, -0.311740, -0.045750, 
-0.048070, -0.263870, 0.018080, 0.467470, 0.156900, 0.308110, 0.052300, -0.080240, 0.262440, 0.270390, 
0.481360, 0.003900, -0.441110, 0.070420, 0.058400, -0.075400, -0.457950, 0.220130, 0.166010, -0.046990, 
0.110690, -0.151650, -0.462110, 0.014560, 0.316000, -0.003660, 0.179690, 0.033680, 0.115560, 0.089240, 
-0.208650, 0.121850, 0.003940, 0.086860, 0.058950, -0.292440, -0.042690, -0.342600, -0.006630, -0.044940, 
-0.218870, -0.249650, -0.193500, -0.297470, 0.010740, 0.480130, -0.381730, 0.072280, 0.228870, 0.173370, 
0.021520, -0.018470, 0.066680, 0.175080, -0.248650, -0.298350, -0.052970, -0.315000, 0.025160, -0.090170, 
0.152980, -0.307000, 0.115780, 0.093220, -0.282450, 0.008170, 0.441350, -0.123320, -0.125880, -0.020130, 
0.371950, -0.334170, -0.053810, 0.095070, 0.080290, -0.153660, 0.052490, -0.021930, 0.038800, 0.240050, 
-0.104340, 0.014860, 0.075130, 0.164580, 0.283560, 0.062160, -0.002320, 
-0.189070, 0.111790, -0.041100, 0.063190, 0.464990, 0.101060, 0.095040, -0.013380, 0.396450, -0.155150, 
-0.156200, 0.131170, -0.236780, 0.001430, 0.361630, 0.111230, 0.064530, 0.242170, 0.208580, 0.041460, 
0.077160, 0.051390, -0.131510, -0.137180, -0.070240, 0.393280, -0.178960, -0.073990, -0.109470, -0.108720, 
0.213800, 0.066210, -0.068900, -0.002380, 0.053250, 0.061510, -0.156940, -0.085580, -0.241330, -0.128910, 
0.365410, 0.076660, 0.267740, 0.272170, -0.104920, 0.040330, 0.358540, -0.065800, 0.326540, -0.046700, 
-0.179480, 0.352460, -0.328370, -0.020350, -0.122650, -0.181270, 0.311650, -0.056320, -0.028390, -0.026170, 
-0.074930, 0.260090, 0.068130, 0.143350, -0.130330, -0.185960, 0.239440, -0.032130, -0.077880, 0.395330, 
-0.380710, 0.326400, 0.385090, -0.033920, 0.072870, -0.085140, 0.130630, 0.373310, -0.021890, -0.235980, 
0.052260, -0.051950, 0.405680, 0.084330, 0.127790, 0.013190, -0.156080, -0.029580, 0.107020, 0.017210, 
-0.055440, 0.166440, -0.093910, -0.015360, -0.077160, -0.039270, 0.166410, 0.089990, 0.320610, 0.038000, 
-0.150660, 0.143130, 0.162830, 0.072940, 0.078400, 0.238340, 0.369990, -0.075500, 0.081590, -0.115160, 
-0.055090, 0.014920, -0.124500, 0.047360, 0.074190, 0.316700, 0.229370, -0.062180, 0.044080, 0.097080, 
0.000990, -0.027500, 0.433820, 0.247650, 0.255900, 0.088650, 0.104850, 0.488770, 0.200660, 0.340380, 
0.418960, 0.214780, 0.048910, 0.032960, 0.204320, 0.167220, 0.081220, 0.258470, 0.131890, 0.275860, 
0.191330, -0.021410, 0.181840, 0.316220, 0.246030, -0.089920, 0.081580, -0.015640, 0.103290, 0.372910, 
0.486510, 0.180040, 0.090090, 0.173120, 0.794280, 0.017250, -0.114440, -0.082220, 0.249860, 0.005780, 
-0.129640, 0.910350, 0.172490, 0.287790, 0.042280, 0.176750, 0.027020, 0.073770, -0.456130, 0.151870, 
0.797070, 0.498140, 0.798530, -0.168540, -0.407910, 0.458670, 0.522950, -0.390480, -0.004800, -0.121000, 
0.036900, -0.045970, 0.272090, 0.193370, 0.229650, -0.194460, 0.044910, -0.159990, -0.007770, -0.139330, 
0.101780, 0.018580, -0.222200, -0.165740, -0.140810, -0.484050, 1.312240, 0.093720, -0.299920, -0.280740, 
0.117980, -0.164930, -0.239790, 1.433470, 0.372990, 0.249090, -0.199560, -0.216360, -0.201520, 0.019160, 
-0.378570, 0.126820, 0.051280, -0.181580, 0.329760, -0.027940, -0.024500, 0.466360, 0.407420, -0.261160, 
-0.214900, 0.030010, -0.151810, -0.007680, 0.468060, 0.157050, 0.164180, 0.317410, -0.210600, -0.139050, 
0.023740, -0.230390, -0.044640, -0.270680, -0.209040, 0.044330, -0.252620, 0.088420, 0.018040, 0.092380, 
-0.017020, -0.123570, -0.230360, -0.303700, 0.094750, 0.422670, 0.086750, 0.115740, -0.062180, 0.071560, 
0.323230, 0.029840, -0.120940, -0.001430, -0.362430, 0.028690, -0.073470, 0.115190, -0.121160, -0.398340, 
-0.214410, -0.118770, -0.179310, -0.274800, 0.094520, 0.000400, -0.132800, 0.086660, -0.164120, 0.049060, 
-0.157240, -0.035260, 0.027650, -0.422570, 0.050740, -0.358060, -0.336820, -0.213850, -0.207140, -0.150780, 
-0.459120, -0.106640, -0.046560, -0.349650, -0.514550, 0.012510, -0.218490, 0.157080, -0.220120, 0.008030, 
-0.235340, 0.150340, 0.009880, 0.005210, 0.071980, -0.048010, -0.148130, -0.166860, 0.073540, -0.102260, 
0.005100, -0.208050, -0.329070, 0.103870, -0.255840, 0.041730, -0.163490, -0.162590, -0.232480, 0.076320, 
0.104730, -0.340860, -0.454000, 0.176310, 0.003310, 0.039810, -0.106700, -0.009060, -0.157270, 0.173050, 
0.031410, -0.042300, -0.196930, 0.128100, -0.002500, -0.171220, -0.353420, -0.111740, -0.118500, -0.118430, 
-0.060420, -0.075880, -0.137390, 0.089460, 0.077050, 0.012460, 0.346010, 0.039850, -0.338710, -0.091400, 
0.030400, -0.159560, -0.232480, 0.053770, -0.036760, 0.165160, -0.191780, -0.186370, -0.266830, -0.100720, 
-0.331330, -0.154130, -0.045100, 0.064950, 0.282010, 0.210590, 0.005950, 
0.279780, -0.152240, -0.220190, -0.207580, -0.106830, 0.155660, 0.109930, 0.089800, 0.121000, -0.203660, 
-0.013370, 0.103650, 0.234940, 0.090930, 0.291710, 0.182590, 0.021470, -0.049330, -0.280800, 0.086580, 
0.025210, 0.021040, -0.106780, -0.239470, -0.042880, 0.344430, 0.013830, 0.011310, -0.124930, 0.051770, 
-0.262940, -0.041160, 0.111190, 0.090660, 0.085280, 0.171270, 0.078790, 0.149600, -0.086850, 0.105590, 
-0.086100, 0.026380, -0.186320, 0.013330, -0.176380, -0.061630, -0.402460, 0.167620, 0.091480, -0.401270, 
0.001080, 0.111890, -0.025230, 0.196090, -0.162640, 0.157250, 0.327650, 0.046430, 0.317470, -0.026400, 
0.143610, -0.083080, 0.021220, -0.204380, 0.066210, 0.267770, 0.101880, -0.392130, 0.294510, 0.185780, 
0.108600, 0.033020, -0.103030, 0.027630, 0.103320, -0.040540, 0.028680, 0.027470, 0.157590, 0.165530, 
-0.239680, -0.020140, -0.076710, 0.019350, -0.306730, -0.121750, 0.359850, 0.207160, 0.235180, 0.072750, 
0.145270, 0.061800, -0.136510, -0.041420, -0.099630, 0.020560, -0.122330, -0.115470, 0.030300, 0.162740, 
-0.123670, -0.131580, -0.106510, -0.059710, 0.015540, 0.097960, 0.252640, -0.164250, -0.215260, -0.017260, 
0.077980, 0.088280, 0.440700, -0.198920, -0.269360, -0.184030, 0.288600, -0.148790, 0.049730, -0.130920, 
0.067870, -0.388240, 0.071120, -0.062300, -0.152590, 0.012400, -0.000930, -0.127650, -0.076650, -0.011800, 
0.173020, 0.062520, 0.169670, 0.015190, -0.214060, 0.011950, -0.152040, 0.197710, -0.005410, 0.051770, 
0.056820, -0.011060, -0.008110, 0.027600, -0.153170, 0.084810, 0.009550, -0.048480, -0.348370, -0.129460, 
-0.224430, 0.383480, -0.009190, -0.259410, -0.196070, -0.140030, -0.196080, 0.129820, -0.157160, 0.040650, 
0.161000, 0.309540, 0.030480, 0.018860, 0.034870, -0.346440, -0.082060, 0.009620, -0.038780, 0.025390, 
0.192220, 0.044580, 0.026690, 0.180440, 0.059590, -0.181720, 0.171510, -0.071640, 0.345830, -0.052190, 
0.225920, 0.049390, -0.048720, 0.036890, -0.135990, -0.084470, -0.036880, 0.018700, -0.004060, 0.165960, 
-0.113650, -0.007170, 0.154600, 0.206800, -0.039220, 0.151470, 0.470150, -0.148260, 0.196410, 0.468720, 
-0.052700, 0.198550, 0.211610, 0.411370, 0.049180, 0.147060, 0.512900, 0.046880, 0.222610, 0.209430, 
-0.261920, 0.042050, -0.105490, 0.154810, 0.543150, 0.030600, 0.030020, -0.122990, -0.011250, 0.156440, 
0.326780, -0.162610, 0.152610, 0.327940, 0.457760, -0.106150, 0.150840, 0.450590, 0.403060, 0.065670, 
0.242360, 0.209040, 0.373690, 0.105430, 0.337940, 0.199430, 0.285470, 0.242620, 0.473620, 0.164210, 
0.178440, 0.235550, 0.394190, 0.134100, 0.217570, 0.142610, 0.219350, 0.322820, 0.373020, 0.222600, 
0.168020, 0.282500, 0.160590, 0.191540, 0.221370, 0.144950, 0.437610, 0.249890, 0.191980, 0.360910, 
0.097830, 0.214120, 0.168320, 0.160720, 0.242060, 0.211800, 0.362020, 0.115010, 0.220410, 0.290660, 
0.350710, 0.109790, 0.258910, 0.164670, 0.304130, 0.235620, 0.313940, 0.222070, 0.344510, 0.251680, 
0.339180, 0.266730, -0.122030, -0.031390, 0.317400, 0.073860, -0.006780, 0.256170, 0.180620, 0.052730, 
0.411740, -0.087730, -0.082320, 0.238530, 0.163420, 0.242890, 0.150800, 0.393640, 0.283140, 0.217540, 
0.224040, 0.308890, 0.160460, 0.238250, 0.198240, 0.111840, 0.113870, 0.306350, 0.057350, 0.203410, 
0.062230, 0.277710, 0.230830, 0.058820, 0.252180, 0.241200, 0.161750, 0.120150, 0.217120, 0.303620, 
0.194590, 0.170130, 0.310090, 0.105450, 0.059840, 0.102280, 0.149090, 0.140430, 0.211310, 0.377620, 
0.057240, 0.030160, 0.360770, 0.254000, 0.074830, 0.260230, 0.096990, 0.058700, 0.148550, 0.070200, 
0.188250, 0.105590, 0.122010, 0.361900, 0.114760, 0.049780, 0.077070, 0.032000, -0.026480, 0.310390, 
0.257410, 0.030260, 0.068890, 0.609280, 0.278540, -0.039190, 0.268290, 
-0.083740, 0.246870, 0.270730, 0.160560, -0.009080, 0.129540, 0.188160, -0.086010, 0.047600, 0.070640, 
0.173930, 0.027250, 0.090810, 0.312110, 0.023990, 0.098610, 0.165670, 0.078720, 0.143180, 0.144590, 
0.037470, -0.128850, 0.056740, 0.207490, 0.050910, -0.024130, -0.054050, 0.024230, 0.109000, 0.188860, 
-0.099990, 0.159790, -0.040350, 0.224110, 0.022580, -0.141900, 0.224120, 0.040820, 0.018190, -0.029710, 
-0.068590, 0.036810, -0.051220, -0.108090, -0.197220, -0.367350, 0.161900, -0.047470, 0.096750, -0.098800, 
-0.108810, 0.337480, 0.066080, -0.179220, -0.027280, 0.161570, -0.048100, 0.018070, -0.086610, 0.259360, 
0.070930, 0.223440, 0.038390, -0.181940, 0.299170, 0.113610, 0.095420, -0.150430, 0.287740, 0.307650, 
0.177710, 0.336330, -0.144800, -0.228110, 0.155940, 0.084450, -0.280840, 0.396820, 0.028180, -0.108840, 
-0.136620, -0.182750, -0.138380, 0.025080, -0.309740, 0.021790, 0.294780, 0.115030, 0.017180, 0.052530, 
-0.123740, 0.295210, 0.005750, 0.075140, -0.197400, -0.174650, 0.080290, 0.142670, -0.050040, -0.037340, 
0.237890, 0.485850, 0.209010, 0.027120, 0.038240, -0.220890, 0.090750, 0.131020, -0.093290, 0.009800, 
0.115380, 0.094640, 0.575420, 0.056970, -0.154430, -0.321830, 0.210280, -0.015810, 0.045140, 0.143860, 
0.120080, 0.193560, 0.153080, 0.022260, -0.073690, 0.059540, -0.318750, -0.014820, 0.256800, -0.007100, 
-0.146450, -0.106750, -0.129920, 0.588760, 0.125110, -0.062980, -0.056600, -0.046200, -0.028410, 0.245430, 
0.166400, 0.009880, 0.121380, 0.355430, 0.158640, -0.069070, 0.067100, -0.320780, -0.070220, -0.103730, 
-0.475170, 0.059400, -0.217920, -0.414910, 0.066630, 0.046390, 0.144990, 0.413020, -0.094220, 0.190430, 
0.549620, -0.083590, -0.087750, 0.287640, 0.124910, 0.087280, 0.117190, 0.058660, -0.456200, -0.003320, 
-0.070570, 0.105460, 0.098380, -0.150120, -0.209160, 0.108690, 0.044440, -0.072050, 0.114180, -0.082580, 
-0.265780, -0.064030, 0.689200, 0.276820, 0.555270, 0.318410, -0.015700, 0.011570, -0.003760, -0.677040, 
-0.078220, -0.045260, 0.436910, 0.018600, 0.014710, -0.022730, -0.047420, 0.200630, -0.139440, -0.004160, 
0.135430, -0.189040, 0.170570, 0.779730, 0.337180, 0.348510, 0.139420, 0.164560, -0.004980, 0.029120, 
-0.188620, -0.300440, 0.144620, 0.176090, 0.093980, -0.196990, -0.050800, 0.424280, 0.000900, 0.100760, 
-0.153780, 0.044640, -0.165560, -0.148320, 0.447290, 0.301420, 0.393420, -0.153460, -0.232730, 0.225500, 
0.030590, -0.182530, 0.423050, 0.381110, 0.488890, -0.337840, -0.032930, 0.532910, 0.525080, 0.350570, 
-0.526820, -0.544510, 0.319160, -0.425940, -0.369820, -0.025310, 0.402320, 0.106900, 0.118460, -0.030420, 
-0.288320, 0.009470, -0.217280, -0.082000, -0.206510, -0.051550, 0.120870, 0.094000, 0.099440, -0.298740, 
-0.125030, -0.099450, -0.111430, 0.041730, -0.140090, -0.219930, -0.029920, 0.063590, -0.013110, 0.035580, 
-0.136950, -0.187330, 0.008590, 0.039920, -0.042260, -0.036580, -0.105300, -0.138130, 0.078750, -0.056010, 
0.042580, 0.001130, -0.214140, 0.125890, 0.115520, -0.012130, 0.180400, -0.213090, 0.102170, 0.064970, 
0.094480, 0.240990, -0.105510, -0.003220, 0.006330, 0.088790, -0.172400, 0.137450, 0.035330, 0.300870, 
0.117590, -0.020520, -0.156970, -0.066980, 0.049000, -0.071120, 0.246750, -0.061560, 0.175500, 0.114800, 
0.189800, 0.011880, -0.118270, -0.036580, 0.009780, -0.059530, 0.106260, -0.347680, -0.274710, 0.317020, 
-0.069250, -0.091650, -0.484330, -0.083410, 0.091200, 0.328820, 0.042130, -0.001970, 0.020570, -0.190670, 
-0.098010, -0.128500, 0.032590, 0.116300, 0.388250, 0.011420, -0.239760, -0.139470, 0.025010, -0.045270, 
0.021840, -0.084550, -0.245050, -0.021820, 0.050970, 0.127750, 0.021590, 0.017780, 0.040410, 0.093930, 
-0.030530, -0.067340, -0.010640, -0.192460, -0.000790, 0.280820, -0.010490, 
-0.203880, 0.110330, -0.079850, -0.070030, -0.020890, -0.112850, -0.045640, -0.172180, 0.111640, 0.063690, 
0.060980, -0.109030, 0.067220, 0.018920, -0.080800, -0.171360, -0.174330, 0.078460, 0.257060, 0.181330, 
0.042290, -0.257820, -0.111320, -0.022200, 0.067440, -0.239710, -0.072940, 0.252460, -0.037310, -0.043310, 
0.120670, -0.088500, 0.012410, -0.017570, -0.058400, 0.094440, -0.067220, -0.039210, 0.105900, 0.015390, 
0.099680, 0.052410, -0.080060, 0.165840, -0.084910, -0.175880, 0.110340, 0.130700, 0.140200, -0.107300, 
0.165440, 0.125260, -0.007550, 0.080530, 0.197150, 0.135660, -0.202600, -0.115720, -0.137460, 0.106780, 
0.173230, 0.069160, 0.049180, 0.046370, 0.009500, -0.086910, -0.121360, 0.092230, 0.166470, 0.158290, 
0.029080, 0.158300, 0.122090, -0.042640, 0.083520, 0.147920, 0.180480, -0.185020, 0.013410, -0.063310, 
0.022510, 0.264310, 0.136580, 0.057420, -0.004450, 0.077730, 0.082840, 0.036500, 0.256220, -0.018220, 
0.007390, 0.169630, 0.114570, -0.145190, -0.131340, -0.097920, -0.089960, -0.064250, -0.042880, 0.179630, 
-0.103610, -0.153490, 0.059190, -0.123190, 0.063500, -0.147030, 0.443330, 0.136590, -0.019470, 0.206180, 
0.033510, 0.106160, 0.158810, 0.169370, -0.198130, -0.226140, 0.355790, 0.001690, -0.120830, 0.149790, 
0.136450, -0.003610, 0.310070, 0.082510, -0.161550, 0.052910, -0.157330, 0.009800, 0.152110, -0.058970, 
-0.146630, -0.019990, -0.084020, 0.424730, 0.077870, 0.137150, 0.073810, 0.102260, -0.125650, 0.276230, 
-0.099280, -0.125330, 0.014720, 0.218870, 0.471810, 0.033740, 0.047600, -0.460600, -0.040180, 0.307510, 
0.206140, 0.027170, 0.029280, -0.141330, 0.637560, 0.137090, -0.229050, -0.044910, 0.068240, 0.148310, 
0.012450, 0.380470, 0.050420, 0.254070, 0.190670, 0.081440, -0.156710, 0.045610, -0.519860, -0.085310, 
0.604430, 0.428220, -0.004340, -0.161950, -0.423700, 0.889940, 0.109670, -0.338510, -0.238130, 0.074130, 
-0.182020, 0.014830, 0.207120, 0.263410, 0.235260, -0.075160, -0.203870, -0.280540, 0.000370, -0.550850, 
-0.064740, -0.011220, 0.199170, 0.312860, -0.096530, -0.324590, 0.350540, 0.043170, 0.014200, -0.092260, 
-0.028600, 0.033200, -0.146250, 0.647680, -0.161860, 0.060560, 0.005290, -0.081420, 0.093700, 0.045120, 
-0.353630, 0.297530, 0.202950, 0.426520, -0.192410, -0.087100, 0.128540, 0.298000, -0.030900, -0.103790, 
-0.457770, 0.269240, -0.216980, -0.356660, 0.257240, 0.126280, 0.284720, 0.029680, -0.206750, -0.047950, 
0.069540, -0.350360, 0.213980, 0.015610, 0.442710, 0.090580, -0.070280, 0.487400, -0.084850, -0.076440, 
-0.030020, -0.122670, 0.061530, -0.214870, -0.001440, 0.099030, 0.223800, 0.119300, -0.010760, -0.052020, 
0.046420, 0.083000, -0.326500, -0.030350, -0.177170, 0.039100, -0.013920, -0.098640, -0.004720, 0.033290, 
-0.065230, 0.034930, -0.090460, -0.152620, 0.080650, 0.127830, 0.072460, -0.052520, -0.077070, 0.026760, 
-0.109910, 0.109890, 0.067560, -0.210420, 0.028140, 0.050110, 0.131100, 0.055980, 0.060150, 0.004510, 
-0.268720, 0.267890, 0.033170, -0.072540, 0.048580, 0.027440, 0.104360, -0.241190, 0.140890, 0.378890, 
0.170190, -0.100430, -0.039470, 0.065260, -0.160920, 0.095700, 0.122900, 0.012770, -0.146130, 0.005340, 
0.004800, -0.041300, 0.360210, -0.035570, -0.061500, -0.074240, -0.014660, 0.396270, -0.021450, 0.073580, 
-0.006050, -0.056420, 0.228030, -0.104840, 0.057950, 0.033410, -0.055620, -0.082040, 0.018820, 0.004180, 
-0.051870, -0.065900, -0.062890, -0.177870, -0.037460, -0.041060, -0.093020, -0.032500, 0.108300, -0.029760, 
0.030270, 0.175310, 0.024080, 0.073740, 0.010840, 0.039710, 0.108970, -0.003580, -0.218930, -0.050800, 
0.078810, 0.052690, 0.142250, -0.148580, -0.134640, 0.023900, -0.030990, 0.069000, -0.070390, -0.145170, 
0.010190, 0.070700, 0.056820, -0.160450, -0.080020, 0.061100, 0.040280, 
0.191210, -0.146840, 0.077170, -0.164030, 0.099820, 0.121330, 0.039830, -0.241390, 0.024450, 0.088740, 
0.026280, -0.019290, 0.192030, 0.193120, 0.059700, 0.305230, 0.193680, 0.230830, 0.107920, 0.279120, 
0.024070, 0.128500, 0.147330, -0.125310, -0.019990, -0.197270, 0.227810, 0.141260, 0.112090, -0.117220, 
0.016230, 0.180800, 0.071010, 0.201300, 0.133790, -0.014340, -0.041430, 0.075860, 0.207000, -0.258660, 
-0.010990, 0.022020, -0.098390, -0.073100, -0.224850, -0.196930, -0.068490, -0.026070, -0.008430, -0.128780, 
-0.240030, 0.318130, 0.321100, -0.153550, -0.022100, -0.013140, -0.108600, -0.063640, -0.047210, -0.040780, 
0.102260, 0.156640, 0.030590, 0.038860, -0.004370, -0.313270, -0.165270, -0.015940, 0.220440, 0.503830, 
0.000360, 0.307520, 0.060730, -0.042350, 0.080630, -0.005070, 0.069070, 0.049890, 0.036650, -0.151640, 
-0.137910, 0.211410, -0.039240, 0.027660, 0.168780, 0.213710, -0.049680, 0.038910, 0.194430, 0.219200, 
0.220970, -0.072780, -0.013500, -0.058700, 0.117870, 0.173880, 0.089080, -0.055410, -0.058000, 0.195750, 
-0.028580, -0.080920, -0.201440, 0.003290, 0.036840, 0.027770, -0.030120, -0.230330, 0.173410, 0.107170, 
-0.054260, -0.022460, 0.014430, 0.002810, 0.028360, 0.043200, -0.104030, -0.093430, 0.300980, -0.145500, 
0.014450, 0.198960, 0.267150, 0.068890, 0.005820, 0.037310, -0.038360, 0.190950, 0.198830, -0.023490, 
0.039470, 0.231480, 0.127010, -0.245800, 0.258480, -0.162060, 0.176650, 0.387100, 0.063780, 0.198490, 
0.040470, 0.109810, 0.177310, 0.263970, 0.175040, -0.086060, 0.027540, -0.092970, 0.063480, 0.414450, 
0.170690, 0.043810, 0.032100, -0.062700, 0.959900, 0.007920, -0.384540, -0.255480, 0.150580, -0.159820, 
-0.124650, 0.493340, 0.051470, -0.145400, -0.068540, -0.140610, -0.293020, 0.041980, -0.108410, -0.154100, 
-0.077530, -0.012530, 0.118300, -0.229860, -0.291930, 0.297300, 0.029310, -0.156470, 0.248820, -0.227350, 
0.147400, 0.196360, -0.388800, -0.029920, -0.191940, -0.114350, -0.164870, -0.179810, -0.000480, -0.142320, 
0.645110, 0.002270, 0.262820, 0.154090, 0.074460, 0.180900, -0.032470, 0.044070, -0.026470, 0.071600, 
0.421400, 0.160530, -0.077570, 0.615580, 0.167740, 0.374000, 0.062820, -0.109960, 0.151410, 0.095550, 
-0.159550, -0.053440, -0.014480, 0.001120, 0.365600, -0.053130, -0.145430, 0.050510, 0.108040, 0.174930, 
0.287080, -0.145690, 0.028750, 0.168180, 0.439630, 0.089580, -0.029360, 0.138950, 0.094120, 0.175630, 
0.122670, -0.088050, 0.146500, 0.100200, -0.103660, 0.383300, 0.014040, -0.068600, 0.251080, 0.181610, 
0.249390, 0.112360, 0.151070, 0.129640, 0.156600, 0.193500, 0.225000, 0.110920, 0.185680, 0.131850, 
0.081300, 0.123950, 0.010860, 0.072100, 0.088670, 0.238130, -0.021680, 0.137070, 0.302640, 0.216280, 
0.266550, -0.109330, -0.133880, 0.092360, 0.101200, -0.034870, -0.018590, 0.194430, 0.088420, 0.046450, 
0.039190, -0.119000, 0.116400, 0.114820, 0.097380, -0.212840, -0.085030, 0.111320, 0.113850, 0.038530, 
-0.154610, -0.013410, 0.219410, 0.192920, -0.187450, 0.106710, 0.196430, 0.229190, -0.007760, 0.116800, 
0.304510, 0.136590, 0.318240, 0.103720, -0.061770, 0.042820, 0.020410, 0.166660, 0.027700, 0.070510, 
0.207010, 0.051770, 0.299900, 0.233200, -0.036490, 0.031350, -0.034060, 0.073800, 0.103920, 0.029250, 
0.078450, 0.003230, -0.037330, 0.019150, 0.106680, 0.270060, 0.210670, 0.388860, 0.207770, 0.231450, 
0.114600, 0.196030, -0.078580, 0.184610, 0.093350, -0.018920, 0.079800, 0.111210, 0.096040, -0.209970, 
0.088820, 0.233770, 0.152860, -0.001630, 0.066540, 0.090920, -0.006720, -0.086910, 0.010770, 0.067770, 
0.191390, -0.237960, -0.041040, 0.067480, -0.146860, 0.290040, 0.165520, -0.074790, 0.011210, -0.049960, 
-0.095870, -0.062930, 0.111540, -0.062280, -0.161480, 0.374300, 0.090130, 
0.058250, 0.262600, -0.360140, -0.231120, 0.291730, 0.036790, 0.318310, -0.196320, -0.311950, 0.198650, 
-0.098710, 0.359980, -0.026130, -0.215770, -0.588730, -0.165640, 0.106500, 0.038190, -0.494550, 0.219700, 
0.051940, -0.107140, -0.220310, -0.347220, -0.304330, -0.036090, -0.191030, -0.030300, -0.147290, 0.006140, 
0.130700, -0.179070, -0.318050, 0.159650, -0.130980, -0.100920, -0.274250, -0.065560, 0.239660, -0.091050, 
0.060890, 0.042880, -0.261420, 0.052930, -0.027280, -0.076290, -0.429360, 0.074950, 0.140850, -0.096430, 
0.037530, -0.196020, -0.191880, -0.043820, 0.003230, 0.052590, 0.223560, -0.234160, -0.168330, -0.092040, 
-0.121230, -0.199010, 0.067940, 0.125700, 0.070230, 0.089960, -0.087130, 0.234620, 0.239540, -0.006600, 
0.060070, 0.030110, -0.357920, -0.258800, 0.191870, -0.203440, 0.026990, 0.157000, -0.009020, -0.073040, 
-0.195100, -0.222780, -0.290930, 0.046190, 0.160600, 0.222650, -0.047640, 0.154230, -0.027550, 0.085030, 
0.082040, -0.137000, 0.168470, -0.182300, -0.288360, 0.075870, -0.277920, -0.291920, 0.600210, -0.081780, 
-0.337810, -0.460080, -0.204710, -0.398940, 0.035070, 0.088690, 0.202570, 0.148860, 0.050890, -0.030480, 
0.126230, 0.142740, 0.178720, 0.511530, -0.169960, -0.213620, 0.260540, -0.115080, 0.156940, 0.015090, 
0.119700, -0.317730, -0.208800, 0.145730, -0.367400, 0.039630, 0.131100, -0.073400, 0.110690, 0.089560, 
0.294030, -0.133400, -0.222220, 0.522000, -0.104700, -0.232690, -0.184760, 0.055580, -0.079850, -0.169570, 
0.374640, 0.123650, -0.362710, -0.108270, -0.133810, -0.241670, 0.032410, -0.158530, -0.178160, 0.078410, 
-0.159330, -0.112260, -0.190730, -0.217400, 0.494600, -0.132870, -0.291270, -0.086620, -0.178010, -0.186690, 
-0.091800, 0.568490, -0.308210, -0.376160, -0.116040, -0.284710, -0.309100, 0.022190, -0.089280, 0.093920, 
0.369760, 0.163010, -0.020760, -0.077080, -0.283020, 0.170810, -0.137620, -0.315020, 0.072370, 0.177040, 
-0.001110, 0.266180, 0.606970, -0.022130, 0.078630, -0.126500, -0.058260, -0.333280, -0.002400, -0.503190, 
0.133370, 0.166620, 0.254140, -0.316790, 0.047640, -0.354840, 0.450480, 0.148150, -0.287870, -0.056790, 
-0.003630, -0.090170, 0.100530, 1.079370, -0.035540, -0.011220, 0.167690, 0.219270, -0.190230, 0.101150, 
-0.440630, 0.145480, 0.097350, 0.193420, 0.365080, 0.019840, 0.109300, -0.067780, 0.341040, -0.281850, 
-0.166940, 0.133180, -0.239530, 0.116760, 0.655370, -0.001990, 0.123110, 0.538250, 0.393150, -0.290840, 
0.129380, -0.372840, 0.147570, 0.195030, 0.225730, -0.110140, 0.031280, 0.232550, 0.099640, 0.024050, 
-0.272200, 0.055160, 0.282910, -0.081010, -0.086190, 0.696030, -0.030350, 0.198480, 0.307280, -0.119030, 
-0.277680, 0.128900, -0.010420, -0.004890, 0.123150, 0.101640, 0.245690, 0.009070, 0.124390, -0.176880, 
0.101300, 0.208550, -0.017350, -0.025240, -0.039980, 0.007220, 0.371260, -0.183160, 0.027580, 0.033410, 
-0.020650, 0.136760, 0.139130, 0.312680, 0.075110, -0.042310, 0.384990, -0.004990, 0.164870, 0.029500, 
0.371830, -0.009230, -0.241400, 0.029890, 0.067680, -0.078420, -0.311460, 0.570560, 0.119670, -0.139530, 
-0.079730, -0.243890, -0.285090, 0.137780, 0.314780, 0.066470, -0.010240, 0.025810, 0.125700, -0.080110, 
0.105920, -0.058720, 0.041750, 0.115010, 0.051000, -0.175480, 0.089830, -0.102610, 0.735650, 0.100620, 
0.388680, 0.348700, -0.284050, 0.008340, 0.139230, 0.015900, 0.262080, 0.128860, 0.323150, -0.046430, 
0.318310, 0.109510, 0.236560, 0.125450, -0.000950, -0.011200, 0.183330, 0.116810, -0.045670, 0.225310, 
-0.026360, 0.007540, 0.463780, 0.206440, -0.134720, 0.134030, 0.260530, 0.215250, 0.055270, 0.276780, 
0.242310, 0.310140, 0.475470, -0.005170, 0.177170, 0.044130, 0.241890, -0.104630, 0.083060, 0.435120, 
-0.064880, 0.135230, -0.019790, 0.361810, 0.395880, -0.105730, 0.136110, 
0.439410, -0.436850, 0.094940, 0.295140, 0.331270, -0.106240, 0.220660, 0.102590, 0.118860, 0.242200, 
0.240060, -0.017920, 0.052730, 0.125760, -0.376680, 0.247270, -0.227120, 0.026050, 0.203280, 0.085890, 
-0.152890, 0.262560, 0.022920, -0.224340, 0.109770, 0.505060, 0.025850, 0.075420, -0.171200, 0.139290, 
-0.182230, 0.375910, -0.036890, -0.133610, -0.366660, 0.025790, -0.106300, -0.145110, -0.012220, -0.228170, 
-0.281520, -0.114580, 0.006220, 0.169640, 0.124290, 0.277470, -0.077540, -0.142080, 0.174050, 0.069550, 
0.304330, -0.014220, 0.032330, -0.022530, -0.172120, 0.019540, 0.098100, 0.354320, 0.353470, 0.179230, 
-0.133500, -0.112370, -0.115590, -0.101450, 0.009820, 0.408870, -0.086520, -0.150940, -0.371850, -0.341710, 
-0.455200, 0.480880, 0.097780, 0.305660, -0.281160, -0.136770, -0.452970, 0.192490, -0.234970, 0.001030, 
0.123480, 0.004000, -0.062450, -0.109590, 0.084810, 0.167380, 0.032070, 0.550350, 0.443430, 0.085140, 
0.164040, 0.274700, 0.147130, 0.053380, -0.096590, 0.059250, -0.050720, 0.265770, 0.300760, -0.116670, 
0.067750, 0.120210, 0.207720, 0.007740, -0.082790, 0.133630, -0.084240, 0.100030, 0.320220, -0.130630, 
0.154210, 0.086530, -0.413200, -0.508560, -0.047450, -0.066480, -0.017130, 0.380390, 0.102070, 0.116950, 
-0.169180, 0.032900, 0.377050, -0.173190, -0.034790, -0.109460, 0.189350, 0.004470, -0.024880, -0.083390, 
-0.078050, -0.517720, -0.574720, -0.356070, 0.028210, -0.202130, 0.195820, -0.676820, -0.302710, -0.125130, 
0.471190, 0.092790, 0.329670, -0.424790, -0.773710, -0.274760, -0.069450, 0.353170, 0.383990, 0.046980, 
0.148720, 0.369360, -0.232620, 0.378860, -0.644240, 0.071140, 0.303440, 0.394810, 0.546480, 0.002770, 
0.112780, 1.089850, 0.061450, -0.153830, 0.403150, 0.224890, 0.167790, -0.043000, 0.988210, 0.576610, 
0.448850, 0.956670, 0.187890, 0.467850, 1.301250, 0.008540, -0.117680, 0.301380, 0.199550, 0.214830, 
-0.267360, -0.067900, 0.712420, 0.052970, -0.278430, -0.017970, 0.088520, 0.091750, -0.006420, 1.050660, 
-0.276520, -0.321340, 0.525540, -0.039790, 0.613190, 0.713660, -0.400790, -0.024620, 0.312350, 0.291640, 
-0.125420, 0.230690, 0.310320, -0.628640, -0.533980, -0.331480, 0.272980, 0.236330, 0.157940, -0.094830, 
0.831980, -0.341990, -0.511670, -0.333230, 0.165360, 0.044440, -0.188240, -0.357630, -0.194140, 0.533440, 
0.221380, -0.580840, 0.432260, 0.184690, -0.704560, -0.359890, -0.363410, 0.387270, -0.169850, 0.409800, 
-0.107830, 0.684030, 0.604160, 0.460560, 0.119440, 0.622520, 0.639130, 0.071120, -0.057010, -0.194750, 
0.299000, 0.446110, 0.557580, -0.200030, -0.423760, 0.113800, -0.153960, -0.155080, 0.375960, -0.041810, 
-0.113010, -0.144650, 0.890350, 0.800980, 0.323850, 0.230850, 0.195540, 0.831410, 0.956800, -0.008630, 
0.149980, 0.160320, 0.182130, 0.685510, 0.276390, -0.352910, -0.062950, -0.119990, 0.087920, 0.367720, 
0.201570, -0.115520, -0.181750, 0.618680, 0.361030, -0.085930, -0.393980, -0.058020, -0.540980, -0.072230, 
0.092660, -0.015110, 0.366450, 0.554020, -0.140520, 0.033610, 0.408200, -0.831900, -0.463620, -0.182050, 
0.288510, 0.302460, -0.178650, -0.191150, 0.151140, -0.203030, -0.135010, -0.332760, 0.201180, 0.037770, 
-0.268460, 0.203850, 0.163670, 0.160370, 0.618010, 0.009020, 0.242990, 0.236680, -0.219850, -0.394830, 
-0.466420, -0.027130, -0.144940, -0.170460, -0.178190, 0.267240, 0.568290, 0.363640, 0.043630, 0.257650, 
0.408460, 0.343900, 0.647520, 0.108920, 0.092650, -0.177050, 0.578640, -0.074260, -0.099920, 0.106110, 
-0.069800, -0.056710, 0.006890, -0.041590, 0.195170, -0.195720, 0.386060, 0.464260, 0.523780, 0.207160, 
0.312490, 0.605850, 0.212870, 0.427660, 0.464260, -0.059620, 0.094630, 0.494100, 0.090160, 0.089820, 
-0.252060, 0.216280, 0.054950, -0.106340, -0.010200, -0.313180, -0.169620, 
0.066680, 0.063780, 0.009470, 0.028490, 0.173520, -0.051990, 0.046380, 0.197200, -0.000880, -0.025170, 
-0.099970, -0.065870, -0.070230, -0.104370, 0.146900, -0.008490, -0.132930, -0.032160, -0.021760, -0.009010, 
0.045580, -0.039660, 0.111640, 0.057670, -0.084730, 0.129590, -0.025750, -0.004310, -0.130930, 0.092940, 
0.043200, 0.094160, 0.002020, 0.265650, 0.228310, -0.000570, -0.009060, 0.091620, 0.128300, 0.061230, 
0.000690, 0.059020, -0.029440, -0.215280, -0.266130, -0.066790, 0.238330, -0.146700, -0.086550, -0.103240, 
-0.041910, 0.141040, -0.007030, -0.115230, 0.072970, 0.072620, 0.277770, -0.091750, -0.090590, 0.197900, 
0.108850, 0.199640, 0.062680, -0.149330, -0.053280, 0.034840, 0.007660, 0.064940, -0.104920, 0.085310, 
-0.029070, 0.009140, 0.054120, -0.021600, -0.163070, -0.003130, 0.083350, 0.082340, -0.021880, -0.055990, 
0.241120, 0.039890, -0.007390, 0.050010, 0.119500, -0.007490, 0.114280, 0.110190, 0.294860, -0.007020, 
-0.083840, 0.185320, 0.146990, -0.117620, -0.142520, 0.085240, -0.192120, -0.053990, 0.003530, 0.057070, 
0.150670, 0.001640, 0.137270, -0.067560, 0.050610, -0.107080, 0.067040, 0.048750, -0.018960, 0.038270, 
-0.023480, -0.042920, -0.065860, -0.069410, 0.063290, 0.100720, 0.025710, 0.018760, -0.058210, 0.189380, 
-0.130440, -0.032130, 0.017550, -0.008760, 0.018670, 0.046470, -0.134940, 0.050520, 0.178540, 0.182550, 
0.351320, -0.094120, -0.129010, 0.210920, 0.069730, -0.011960, 0.001730, 0.002290, -0.074230, -0.091570, 
0.380090, -0.119450, -0.140510, -0.126440, -0.056950, -0.113520, 0.039220, -0.040160, -0.189820, 0.058730, 
0.018750, 0.265560, -0.088760, -0.171570, 0.142940, -0.084720, -0.141090, 0.114090, -0.129120, 0.075880, 
0.081760, 0.388720, 0.040450, 0.046250, 0.126510, 0.117510, -0.154290, 0.034990, -0.222420, 0.044000, 
0.300040, 0.217500, 0.029930, -0.095630, -0.214240, 0.364020, 0.171990, -0.317640, -0.136610, -0.089200, 
-0.065720, -0.002150, 0.660230, 0.066060, -0.053690, 0.080790, 0.019070, -0.300610, 0.009470, -0.210900, 
0.132630, -0.004520, 0.169620, 0.049910, 0.105610, -0.096120, 0.233230, -0.086210, -0.059870, 0.021530, 
0.018450, 0.001110, -0.123110, 0.797740, -0.026170, 0.055740, 0.150540, -0.091810, -0.092540, 0.061580, 
-0.051290, 0.121800, 0.089970, 0.251260, 0.123930, -0.082970, 0.129280, 0.417000, -0.026450, -0.048640, 
-0.131940, 0.031070, -0.096930, 0.056940, 0.400140, 0.009790, -0.034420, 0.264080, 0.050140, -0.045510, 
0.070810, -0.131940, 0.181800, 0.053770, 0.306270, 0.016050, 0.081590, 0.265120, 0.057990, 0.201370, 
-0.051210, 0.032460, 0.183460, -0.023740, -0.063390, 0.160400, -0.004980, 0.180040, -0.127920, 0.055370, 
0.100880, 0.059780, -0.063780, 0.059600, -0.032510, 0.137420, -0.035500, -0.038290, 0.054070, -0.129050, 
0.025380, 0.028820, 0.083900, -0.164420, 0.056920, 0.093860, 0.198370, 0.007340, -0.060680, 0.135730, 
0.078260, -0.045870, 0.057630, 0.029430, 0.172260, 0.037540, 0.119550, 0.278560, 0.089380, 0.032390, 
0.024730, 0.248920, -0.121150, 0.009370, -0.052320, -0.007390, 0.079460, 0.187790, 0.056580, -0.157690, 
0.003880, 0.018370, -0.205840, 0.060510, 0.105440, 0.052070, 0.045470, 0.041110, 0.145240, 0.018140, 
0.011380, -0.065650, 0.094990, -0.023690, 0.022950, 0.010810, 0.094900, 0.194680, 0.117100, 0.089040, 
0.141280, 0.003140, -0.083930, -0.087320, 0.052360, -0.015770, -0.060360, -0.029750, 0.043760, 0.139950, 
-0.067680, -0.106750, 0.199450, 0.042670, 0.112970, 0.076040, -0.097660, 0.118550, 0.149110, 0.039910, 
0.145860, 0.053330, 0.037120, 0.024420, 0.058940, 0.059060, -0.005480, -0.033410, 0.080100, 0.136950, 
0.141670, 0.132230, 0.012240, 0.203420, -0.073330, -0.052300, 0.073460, -0.028040, -0.004700, 0.035020, 
-0.014760, 0.043170, 0.061630, 0.142390, -0.085300, 0.023300, 0.054700, 
-0.276660, -0.327470, -0.183140, -0.253410, -0.024940, -0.048210, -0.287780, -0.102920, -0.156380, 0.157940, 
-0.066670, 0.025830, -0.057920, 0.166460, -0.301520, -0.222200, -0.096940, 0.109570, -0.280560, -0.048140, 
0.049830, -0.162270, 0.042520, 0.202680, -0.010510, 0.142290, -0.095050, -0.019560, -0.061390, -0.105520, 
-0.172370, -0.210930, 0.326180, -0.076870, -0.149880, -0.260870, 0.104140, 0.057400, -0.259800, -0.058220, 
0.105790, 0.032700, 0.046630, -0.191430, 0.135550, 0.253820, -0.204540, 0.071920, 0.533010, 0.173300, 
0.054380, -0.050000, -0.313420, 0.297360, -0.197830, -0.069010, 0.008310, 0.137690, 0.028530, -0.054470, 
-0.001030, 0.019280, 0.027850, -0.354450, -0.160150, -0.117050, -0.107600, -0.036560, -0.154670, 0.143850, 
0.247430, -0.173600, -0.015670, -0.251150, -0.013030, -0.159080, -0.119060, 0.004790, -0.168830, -0.056990, 
0.064350, -0.041920, 0.043630, 0.007490, -0.674350, -0.014310, -0.052290, -0.190590, 0.192550, -0.098820, 
-0.143870, 0.256140, 0.033050, 0.074000, -0.280720, 0.053990, -0.174650, 0.032590, 0.093910, -0.398110, 
-0.047150, -0.181460, 0.160250, 0.185000, 0.012480, -0.435340, 0.124210, -0.182820, -0.079590, 0.022810, 
-0.114620, -0.222310, 0.293530, -0.036470, 0.059380, -0.194840, 0.029710, -0.067400, -0.179840, 0.159940, 
-0.170740, 0.078170, 0.096120, 0.315540, 0.245690, 0.018330, -0.643390, 0.240130, 0.058060, -0.236980, 
-0.068240, -0.394260, -0.423220, 0.372430, -0.003350, 0.097200, -0.463380, 0.016500, -0.021020, -0.174030, 
-0.183390, 0.038180, 0.304080, -0.525500, -0.272090, 0.363210, 0.016540, -1.268400, -0.065830, -0.308740, 
-0.633590, -0.300670, -0.286740, -0.876970, 0.247060, -0.055100, -0.146930, -0.372110, -0.301070, -0.052480, 
0.270810, 0.345960, -0.117680, 0.137990, -0.264690, -0.018300, 0.040240, 0.006790, -1.160580, 0.111530, 
-0.149690, -0.231290, -0.027310, -0.094680, -0.239360, 0.218890, -0.035420, -0.224440, -0.624470, -0.016760, 
-0.186580, 0.190390, 0.655850, -0.082080, 0.272790, -0.016650, 0.139380, 0.232450, 0.009840, -0.790520, 
0.190170, -0.052870, 0.689200, -0.272870, 0.265690, 0.323720, 0.374950, 0.326640, -0.147720, -0.542140, 
0.126560, -0.223360, -0.262520, 0.690560, 0.156950, 0.282030, -0.144510, 0.244520, 0.153260, 0.050280, 
-0.681260, -0.722950, -0.452420, 0.223470, -0.080850, -0.507360, -0.122840, -0.213200, 0.066910, 0.124370, 
-0.348350, -0.701030, -0.231700, 0.390590, 0.360830, -0.066210, 0.419030, 0.058990, 0.233690, 0.454680, 
0.107960, -0.590040, -0.541920, -0.397070, 0.045550, 0.375850, -0.380870, -0.217660, -0.502350, -0.271900, 
0.391160, -0.252560, -0.670860, 0.046260, 0.230870, 0.130330, 0.246570, 0.243480, -0.268880, 0.060210, 
0.588890, 0.124600, -0.270680, 0.456210, 0.053420, 0.300600, 0.006710, 0.075110, 0.282730, 0.008250, 
0.003430, -0.263180, -0.391380, 0.315720, -0.055220, -0.072140, 0.377300, 0.160050, 0.364450, -0.117790, 
0.205080, 0.146980, 0.138100, -0.180680, 0.486200, -0.050940, 0.068880, 0.158900, 0.246030, 0.420780, 
-0.168840, 0.045780, -0.140000, -0.326330, 0.163220, -0.185710, 0.172950, 0.150970, 0.136380, 0.219380, 
0.096350, 0.353910, 0.012240, 0.141730, 0.000270, 0.143900, 0.088200, -0.018940, 0.049180, -0.108910, 
0.033300, 0.024960, 0.133420, 0.094990, 0.021270, -0.076500, 0.268910, 0.347920, -0.263910, 0.116210, 
0.032260, 0.098520, -0.173500, -0.226470, 0.151790, -0.320630, -0.155980, -0.066180, 0.179750, 0.015800, 
-0.172520, -0.013840, 0.004410, -0.120210, 0.250940, 0.099590, 0.057430, -0.173660, 0.208470, -0.372030, 
0.057450, 0.279680, -0.089430, 0.044390, 0.133760, 0.135880, 0.012700, 0.177610, 0.071260, 0.222090, 
-0.045550, 0.141860, 0.321490, 0.069590, 0.058330, -0.108300, -0.219430, 0.327860, -0.051560, -0.175240, 
-0.312240, 0.207350, 0.084750, 0.051670, -0.301170, -0.113870, 0.134520, 
-0.311360, 0.125650, 0.326010, 0.122080, -0.035740, 0.304040, -0.096030, 0.256140, 0.037390, 0.159320, 
0.336470, -0.025340, 0.153520, 0.178880, 0.135140, -0.115900, -0.150480, -0.055800, -0.003830, -0.039520, 
0.015130, -0.222160, 0.115660, 0.359620, 0.006720, -0.149170, 0.145730, -0.263370, 0.779240, 0.475270, 
0.217900, -0.085440, 0.180170, -0.029690, 0.252360, 0.511440, 0.059410, -0.049250, 0.218380, 0.377030, 
-0.041640, 0.010980, -0.717250, 0.144430, 0.405090, 0.255790, 0.002610, 0.294370, -0.086920, 0.573420, 
0.270620, -0.188640, -0.031870, 0.094840, 0.009740, -0.315440, 0.458930, -0.296590, 0.002190, -0.039490, 
-0.123940, 0.142070, -0.023970, -0.485570, -0.023340, 0.005570, -0.166000, -0.064220, 0.006060, -0.296950, 
0.068680, 0.183200, 0.309410, -0.041370, -0.263540, -0.170820, 0.278690, 0.170020, -0.084290, 0.238540, 
0.306620, 0.143680, 0.050480, -0.033920, -0.212170, -0.126180, -0.167300, -0.172940, 0.449770, 0.116200, 
-0.325960, -0.357570, 0.191980, -0.015850, -0.242390, 0.177560, -0.019320, -0.169410, 0.377930, -0.403700, 
0.058580, 0.199080, 0.213650, 0.359590, -0.046770, -0.249200, -0.168330, -0.427440, -0.572770, -0.073160, 
-0.069260, -0.347590, -0.096450, -0.343190, 0.211720, -0.214210, -0.378940, -0.150000, -0.157900, 0.119960, 
0.106730, 0.355330, 0.284380, -0.002510, 0.624120, -0.055900, 0.039130, -0.499380, -0.595870, -0.500350, 
0.496080, -0.360040, -0.721060, -0.465240, -0.541160, 0.621670, 0.186500, -0.702870, 0.228150, 0.643130, 
-0.593300, -0.414980, 0.250170, 0.395750, 0.150570, 0.705600, -0.033010, -0.426900, 0.375970, -0.013760, 
-0.057060, -0.056580, 0.134210, 0.553350, 0.049780, 0.196240, -0.111520, -0.531970, 0.261490, -0.000930, 
-0.387480, -0.187900, 0.113470, 0.320510, 0.100650, -0.084600, 0.445830, -0.018200, -0.335150, -0.458240, 
-0.434220, -0.145740, 0.367060, -0.126990, -0.266580, 0.245880, -0.457360, 0.548610, -0.184780, -0.641710, 
0.048430, -0.045190, -0.242030, -0.156720, -0.285580, 0.656340, -0.130810, 0.725420, 0.000940, -0.557120, 
0.322630, 0.466440, 0.533200, -0.063380, 0.317460, 0.100150, -0.041200, 0.113590, -0.258520, -0.283760, 
0.255960, 0.019580, -0.198650, -0.075490, 0.516290, 0.288230, 0.322230, -0.102240, -0.132660, 0.007360, 
-0.165490, 0.250220, -0.014140, -0.271260, -0.090160, 0.066820, -0.315630, 0.428660, 0.142950, -0.113650, 
-0.120000, 0.118550, -0.070290, 0.131780, 0.415790, 0.120890, -0.131250, 0.554950, 0.037720, -0.180140, 
0.020410, -0.006000, 0.172600, 0.181850, 0.318700, 0.254380, 0.364130, 0.000430, 0.249810, -0.045620, 
-0.238750, -0.234770, 0.188260, 0.193510, -0.040680, 0.019790, 0.672990, 0.382140, -0.128960, -0.062310, 
0.214000, 0.033580, -0.142860, -0.063250, 0.072710, -0.128200, 0.050080, 0.020870, 0.019040, 0.221970, 
0.423530, -0.177000, -0.107030, 0.395550, -0.112690, 0.473590, 0.254600, 0.084430, -0.076670, 0.038000, 
0.036810, -0.196810, 0.030880, -0.254290, 0.044050, 0.081550, 0.155030, 0.133020, 0.109060, 0.055110, 
0.276420, 0.075720, 0.062320, 0.209350, -0.007360, 0.192680, 0.000430, -0.075360, 0.228740, 0.229920, 
0.379400, 0.025390, 0.148550, 0.019540, 0.116040, -0.113460, -0.178980, -0.212340, 0.296980, 0.146610, 
-0.118990, -0.175150, 0.182530, 0.045240, -0.163220, 0.091600, 0.064440, -0.232660, 0.696050, -0.052700, 
0.076850, 0.012960, 0.439160, 0.057990, 0.036340, 0.054390, 0.074110, -0.135380, -0.281970, -0.137250, 
0.235730, 0.125290, 0.159000, 0.020070, -0.021840, -0.088220, -0.034220, 0.020460, 0.061570, -0.031410, 
-0.034620, -0.140990, 0.221370, -0.162640, 0.051430, 0.036880, 0.363880, -0.092710, -0.553740, -0.250050, 
0.341700, 0.066830, 0.120980, 0.183560, 0.039170, 0.131440, -0.043350, -0.347670, -0.159040, -0.098790, 
-0.011980, -0.072060, -0.149370, 0.099500, 0.093690, 0.123420, 0.050670, 
0.035420, 0.390490, 0.480760, 0.064840, -0.220830, -0.009730, 0.123170, 0.247030, 0.145460, -0.214550, 
-0.195000, 0.194850, -0.168830, -0.040340, 0.174190, -0.241290, -0.150140, 0.193640, 0.226000, 0.026850, 
-0.042130, -0.027540, 0.231900, 0.241970, 0.739840, 0.119170, 0.357270, 0.963190, -0.105920, -0.128530, 
-0.192190, 0.306170, 0.102680, -0.187500, -0.184390, -0.041320, 0.153160, -0.159420, 0.052470, 0.089960, 
-0.059000, -0.037950, 0.477380, -0.420080, -0.089720, 0.184710, 0.002700, -0.130260, 0.246120, -0.423320, 
-0.421160, -0.067830, 0.332440, -0.200290, -0.148160, 0.435310, 0.003320, -0.077110, -0.231720, 0.047070, 
-0.347500, -0.158240, -0.015030, 0.350420, 0.191230, -0.649100, -0.167360, -0.233060, -0.100680, -0.340150, 
-0.295130, -0.138920, 0.256910, 0.499800, -0.190340, 0.092950, 0.715020, -0.197230, -0.086320, 0.257870, 
0.210750, -0.076150, 0.153620, 0.002300, 0.149300, 0.869100, 0.398150, 0.657710, 0.208390, 0.690030, 
0.580250, 0.356140, 0.214410, 0.109280, 0.055480, 0.793430, 0.069410, -0.129890, 0.141860, 0.021420, 
-0.008460, 0.156870, 0.031680, 0.233120, 0.020700, 0.444490, 0.437160, 0.655420, 0.582970, 0.179530, 
0.231680, 0.583840, 0.008660, -0.106610, 0.034130, -0.133140, 0.650510, -0.208420, 0.116200, -0.094160, 
0.144350, 0.119000, 0.242140, 0.138330, -0.046250, -0.009880, 0.098370, -0.438890, -0.122650, -0.309590, 
0.065820, 0.123620, -0.547850, -0.463120, 0.297900, 0.054880, 0.663220, -0.576260, 0.587760, 0.438490, 
-0.354120, -0.194690, -0.309560, 0.213160, 0.285610, 0.027650, 0.003050, 0.238980, 0.329940, 0.098700, 
-0.371950, 0.184750, 0.130720, -0.189700, 0.271520, 0.051090, 0.517140, 0.562650, 0.088800, 0.294390, 
-0.016610, 0.258300, -0.011800, -0.330420, 0.670700, -0.061530, 0.288050, 0.024100, 0.867510, 0.856580, 
0.590340, 1.174300, 0.038620, 0.555630, 1.142370, 0.194120, 0.497610, 0.226210, 0.651750, 0.924350, 
0.010920, -0.195430, 0.428580, 0.285110, -0.233620, 0.299470, -0.192720, -0.126710, -0.003850, 1.017320, 
0.259890, 0.531190, 0.464460, -0.034930, 0.294180, 0.330900, -0.122910, 0.475400, -0.107820, 0.602950, 
0.281380, 0.438220, 0.004590, -0.080360, 0.165770, -0.097830, -0.057410, 0.163480, -0.143220, -0.008830, 
-0.096560, -0.375710, -0.148980, -0.581380, 0.013070, -0.530280, -0.407680, -0.228790, -0.149800, 0.165820, 
0.657280, -0.071100, 0.074190, 0.619150, -0.168680, -0.427540, -0.284490, -0.555420, -0.012230, -0.115920, 
-0.042810, 0.088320, 0.127580, 0.066860, 0.194950, -0.160170, 0.334790, -0.075760, -0.154930, -0.283620, 
0.020910, 0.228320, 0.155110, 0.104630, -0.047410, 0.111210, -0.408500, -0.557750, 0.106490, -0.701910, 
-0.088460, -0.081950, 0.658450, 0.496880, 0.060420, 0.352230, 0.197940, 0.309360, 0.305580, 0.020480, 
-0.336900, -0.003260, 0.001280, 0.370270, -0.149270, -0.074120, 0.371850, 0.097110, 0.145390, -0.002270, 
-0.049480, -0.132360, -0.114700, 0.487320, 0.196980, 0.171720, 0.138540, 0.154280, 0.012280, 0.004260, 
-0.234240, -0.269780, -0.036620, 0.403660, 0.354250, 0.182230, -0.029330, -0.103190, -0.041100, 0.167790, 
0.000010, 0.032100, -0.170150, -0.100810, 0.031080, -0.330950, 0.293910, -0.294080, -0.228120, -0.088590, 
-0.476840, 0.034000, -0.133010, 0.127640, 0.528270, -0.319260, -0.001500, 0.497270, -0.361330, -0.093070, 
-0.017370, -0.250050, -0.323930, -0.131720, -0.113800, 0.294200, 0.134300, -0.376340, -0.210060, -0.147770, 
0.185360, 0.087800, 0.095370, -0.097810, 0.330620, 0.156130, 0.110440, 0.245880, 0.308990, 0.192190, 
0.136000, -0.006570, 0.367230, -0.068950, 0.247930, -0.103380, 0.254670, 0.126610, 0.132280, 0.226560, 
0.019720, 0.312320, 0.144150, 0.068460, -0.293390, 0.112260, 0.323830, 0.131070, 0.308840, 0.156650, 
0.088850, -0.251890, -0.172670, -0.116260, -0.147340, -0.255020, -0.100770, 
-0.265770, -0.315350, -0.153080, -0.189930, -0.335940, -0.176780, -0.101160, 0.360090, -0.062150, 0.006590, 
-0.222340, -0.053790, -0.160160, 0.048700, -0.058000, 0.073500, 0.000680, -0.065130, -0.022520, 0.046600, 
0.015040, -0.049450, -0.164890, -0.112900, -0.253320, -0.227090, -0.060370, -0.161830, -0.448390, -0.079160, 
0.093750, 0.070080, -0.084260, -0.128280, -0.063020, 0.122760, -0.210620, 0.113250, -0.441510, -0.150410, 
0.236580, 0.010110, -0.264220, 0.166670, 0.011830, -0.362550, -0.138740, -0.010320, -0.187100, -0.168520, 
0.190850, -0.105790, -0.349430, 0.011510, -0.295960, -0.255260, -0.137670, -0.251620, 0.105170, -0.012880, 
-0.027910, -0.076880, 0.004770, -0.074840, 0.042320, -0.107340, -0.142930, -0.069730, -0.265170, -0.044090, 
-0.150740, -0.031840, 0.050330, -0.308540, -0.270350, -0.134490, -0.056670, -0.137410, -0.026440, -0.024400, 
0.154720, 0.240640, 0.049920, 0.014990, -0.142000, -0.265110, -0.152450, 0.035450, -0.038330, -0.242710, 
0.308350, -0.207720, -0.040160, 0.030380, -0.200570, -0.184590, -0.121640, -0.000560, 0.025740, 0.085830, 
0.157840, -0.181670, 0.008360, 0.152040, 0.006850, 0.073470, -0.157770, -0.215900, -0.191900, 0.010810, 
-0.189860, -0.100030, -0.126560, -0.174640, 0.186800, 0.099070, -0.015240, -0.000320, 0.312060, 0.049330, 
-0.111170, -0.200320, -0.199790, -0.052910, 0.314250, 0.012660, -0.112320, 0.049700, 0.190040, 0.146310, 
-0.227960, 0.184470, -0.046230, -0.123650, 0.093000, 0.262880, -0.097710, 0.225540, 0.053300, -0.129560, 
0.111380, -0.113330, 0.086920, -0.292780, 0.072410, 0.190280, 0.010840, -0.022560, 0.062890, 0.115100, 
-0.150470, 0.431070, 0.167950, -0.300160, -0.061710, -0.196900, -0.011540, 0.109840, 0.068280, 0.142370, 
0.332130, 0.236230, 0.007590, 0.246210, 0.285590, -0.067620, 0.088960, 0.009060, -0.514310, -0.038870, 
0.607590, 0.672520, 0.101430, -0.107470, -0.497220, 0.705210, 0.167910, -0.438070, -0.124080, 0.090620, 
-0.059810, 0.201840, -0.198980, 0.483540, 0.538870, 0.386290, -0.089050, -0.340640, -0.004550, -0.508320, 
0.197120, 0.035770, 0.359510, -0.201880, -0.038780, -0.066660, 0.419920, -0.183540, -0.301550, 0.132350, 
0.356990, -0.024350, -0.054980, 1.090340, 0.094790, 0.059100, 0.252020, -0.104660, -0.112230, 0.092170, 
-0.064090, 0.423550, 0.482130, 0.778030, 0.095870, 0.045810, 0.528150, 0.642630, 0.349480, -0.221700, 
0.036930, 0.570190, 0.000260, -0.248450, 0.082750, 0.620650, 0.289050, 0.205310, -0.026360, -0.139260, 
0.124890, -0.042280, 0.170660, -0.012920, 0.102710, -0.200110, -0.000670, 0.189440, 0.348720, 0.391630, 
-0.284760, -0.278400, 0.107640, -0.237390, 0.160300, -0.051520, 0.049410, 0.000780, 0.463880, 0.156550, 
0.020740, 0.137570, 0.168220, 0.322090, -0.040620, -0.104410, 0.477830, 0.082150, -0.024360, -0.074330, 
0.044490, 0.062320, 0.057320, 0.000190, 0.250980, -0.151430, -0.061120, 0.200020, 0.061350, 0.004980, 
-0.015920, 0.026490, 0.137720, 0.008140, 0.029170, -0.240050, -0.269010, 0.485420, -0.071660, 0.099550, 
-0.073950, -0.188150, 0.016030, 0.165890, 0.079770, 0.207640, 0.112010, -0.090090, -0.199030, -0.089150, 
0.120590, 0.077540, 0.129610, 0.135880, 0.087430, 0.236530, -0.281160, -0.137290, 0.006840, 0.034380, 
0.164730, -0.293910, 0.047260, 0.416820, 0.198430, 0.111280, 0.266780, 0.199700, -0.303320, -0.164820, 
0.021350, 0.335510, 0.083920, 0.289060, 0.110890, 0.019520, 0.176510, -0.061850, -0.110430, -0.054480, 
0.018940, -0.285320, -0.003450, -0.012470, 0.095240, 0.089390, -0.111300, 0.037680, 0.142370, -0.390720, 
0.042900, 0.107270, 0.171250, -0.115930, 0.045720, 0.098520, -0.181700, -0.029510, -0.201340, -0.093460, 
0.043040, -0.115530, -0.261220, -0.106470, -0.050480, 0.168950, -0.018700, -0.165160, 0.038770, 0.084790, 
-0.034130, -0.300360, -0.026110, 0.232480, 0.111230, 0.306570, 0.085140, 
0.240110, 0.173250, 0.141080, -0.429230, 0.122920, -0.378090, -0.393320, 0.240160, 0.087170, 0.097480, 
-0.004530, -0.074250, 0.170890, -0.090310, -0.011880, -0.124450, -0.023270, 0.118020, 0.150500, 0.018310, 
-0.102530, 0.122820, 0.076640, -0.205710, -0.608450, 0.212690, -0.110000, -0.238630, -0.050670, -0.009460, 
0.121450, 0.003320, -0.261600, 0.261540, -0.203090, 0.057980, -0.460770, -0.177600, 0.144330, -0.092200, 
0.109640, -0.092020, 0.503450, -0.419740, 0.144120, 0.122330, 0.025480, -0.135310, -0.158840, 0.470970, 
0.014570, 0.156400, 0.083160, -0.511750, 0.111520, -0.100500, -0.314420, 0.188950, 0.062380, -0.083600, 
-0.020170, 0.301860, -0.071610, 0.310990, -0.289970, 0.177810, -0.335560, -0.181420, -0.406280, -0.535290, 
-0.104820, -0.136070, 0.199840, 0.299610, -0.620320, 0.022960, 0.221080, -0.212110, 0.052240, 0.206390, 
0.229340, -0.182760, -0.038140, -0.054870, 0.309470, 0.008740, -0.078520, -0.218210, 0.125010, 0.134900, 
0.030990, -0.065090, -0.093700, -0.144540, 0.164570, -0.073040, -0.064750, 0.017900, -0.153780, -0.299090, 
0.022930, 0.497500, -0.193850, -0.238490, -0.058560, 0.632510, -0.028730, -0.050620, 0.532540, 0.067210, 
0.305670, 0.326590, 0.027090, -0.260580, -0.069610, 0.326160, 0.179100, 0.097740, -0.442980, 0.314370, 
0.074290, 0.050540, -0.000460, 0.049080, 0.113240, -0.038730, 0.575300, -0.454670, -0.090970, 0.249670, 
-0.046500, -0.517760, -0.304920, -0.258800, -0.130670, 0.209360, 0.245810, -0.695910, -0.051200, 0.511350, 
-0.214560, -0.063980, -0.456760, 0.007380, -0.171200, -0.385840, -0.070780, 0.252850, -0.615110, -0.360140, 
-0.573320, 0.251650, -0.792110, -0.878900, -0.409200, -0.236360, 0.120150, 0.668450, -0.642010, 0.096620, 
0.377400, 0.057500, 0.052320, 0.286010, 0.486090, -0.155720, -0.459260, -0.015990, 0.814150, 0.336680, 
0.241550, -0.226740, 0.110420, 0.433490, 0.473600, -0.033770, -0.219840, 0.337670, 0.513260, 0.282300, 
-0.024170, 0.176920, 0.716410, 0.179980, -0.222950, 0.078800, -0.185480, -0.378810, 0.009740, 1.534970, 
0.594010, 0.599220, 0.544580, -0.004840, 0.602000, 0.752450, 0.083650, 0.080570, 0.082780, 0.434470, 
0.453560, -0.050960, -0.090880, -0.271520, 0.223330, -0.145040, 0.374900, 0.353310, -0.410170, -0.015740, 
0.856310, -0.520260, -0.201300, -0.638430, 0.215970, -0.107350, -0.541300, -0.483140, 0.332840, 0.085980, 
0.958720, -0.312770, 0.160540, -0.022990, -0.581560, -0.315510, -0.231580, 0.106700, 0.453180, -0.508890, 
-0.043590, 0.588740, -0.072820, 0.135920, -0.236020, -0.035720, 0.159440, -0.672830, 0.370340, -0.169090, 
0.289220, 0.645220, -0.075160, 0.204570, -0.152040, -0.509680, -0.254070, -0.529680, -0.036670, -0.559240, 
-0.024420, -0.071210, 0.680970, 0.482870, -0.041310, -0.129160, 0.296680, 0.435600, 0.134340, 0.137520, 
0.224790, 0.136950, 0.422940, 0.618230, 0.242960, 0.088440, -0.445320, 0.005170, -0.315050, 0.604740, 
0.286230, 0.013510, -0.096150, 0.586110, 0.337160, 0.119110, 0.303070, 0.472370, 0.307920, -0.016610, 
0.105830, 0.319740, 0.000840, 0.212350, -0.001040, 0.164530, 0.151010, -0.487040, -0.053840, -0.068050, 
0.113870, 0.364480, -0.275820, -0.092220, 0.307570, -0.046580, -0.241090, -0.129470, 0.358380, -0.162170, 
-0.346900, -0.386170, 0.098040, 0.456940, 0.762150, -0.135090, 0.219140, -0.153680, -0.413580, -0.456520, 
-0.479520, 0.111840, 0.200490, 0.035470, -0.103770, 0.257020, 0.072410, -0.061950, 0.089460, 0.210020, 
0.161680, 0.102710, 0.446410, -0.075410, -0.263390, -0.035870, -0.178630, -0.169120, 0.012050, -0.092750, 
-0.320450, -0.715090, 0.035380, -0.071060, -0.515730, -0.136650, 0.310370, 0.269250, 0.038170, 0.232940, 
-0.129210, 0.201440, 0.583500, -0.341710, 0.167450, 0.218780, 0.242120, 0.365210, 0.225360, 0.230520, 
-0.025940, -0.041550, -0.149860, -0.093350, 0.088280, -0.130420, -0.128630, 
-0.111260, 0.448620, 0.040740, -0.083820, 0.170150, 0.295020, 0.347620, -0.036290, 0.032980, 0.240680, 
-0.113890, 0.240820, -0.013090, -0.054640, -0.068350, 0.102770, 0.215810, -0.178070, -0.249770, 0.292340, 
-0.061510, -0.147370, -0.252590, 0.261660, 0.144000, 0.009930, 0.071160, 0.053070, 0.112810, -0.005260, 
0.023090, -0.055130, 0.043370, -0.066440, 0.046200, -0.036910, 0.217340, 0.112640, 0.218150, 0.080430, 
0.285980, -0.094970, -0.374980, -0.179620, -0.090280, 0.182770, 0.030410, -0.212280, -0.019400, -0.021670, 
-0.062380, 0.261240, 0.090100, -0.011650, 0.353200, 0.208240, -0.364990, -0.040560, 0.149550, -0.190800, 
-0.089980, 0.190680, -0.100810, -0.689840, 0.110680, 0.143620, -0.582990, -0.070540, -0.129950, -0.331550, 
0.005570, -0.180080, 0.260090, 0.014270, 0.123070, 0.181490, 0.359340, 0.062080, -0.109150, 0.426120, 
0.236530, 0.035820, 0.270360, -0.096510, -0.259760, 0.049340, 0.189870, 0.261030, 0.253410, 0.090380, 
0.052520, 0.304150, 0.001400, 0.172510, -0.175060, -0.061000, -0.123780, -0.186800, 0.186430, 0.395610, 
0.457110, 0.060730, -0.220740, 0.164530, -0.100980, 0.070500, -0.081130, -0.201830, 0.132910, 0.005570, 
0.029090, 0.134080, -0.243600, 0.091090, 0.415460, 0.255960, 0.038310, 0.351440, 0.373290, -0.224670, 
-0.007360, 0.673310, -0.214570, -0.003690, 0.642830, -0.112300, 0.241580, -0.494750, -0.614720, -0.658480, 
-0.131180, -0.446710, -0.685950, 0.316680, -0.718670, 0.133090, 0.068780, -0.564910, 0.225990, 0.173000, 
-0.752960, -0.256600, 0.401670, -0.006020, -0.150600, 0.556750, -0.079530, -0.201390, 0.412990, -0.671520, 
-0.709400, -0.042710, 0.159640, 0.002970, 0.373870, -0.183070, 0.203350, -0.372480, -0.035140, 0.008820, 
-0.023840, -0.875680, -0.086610, 0.487460, 0.071480, -0.138060, 0.769530, -0.053350, -0.073140, 0.234720, 
-0.387390, -0.514490, -0.173140, 0.192250, -0.010330, 0.004060, 0.178240, 0.630180, -0.416800, -0.027620, 
-0.059550, 0.048390, -0.647410, 0.104760, 0.514030, 0.414400, 0.403910, 0.653980, 0.008780, 0.063830, 
-0.401840, -0.368220, -0.538010, 0.234690, -0.363580, -0.304230, -0.564980, 0.309740, 0.475090, 0.146590, 
-0.438150, -0.131290, 0.550120, -0.488010, 0.255780, 0.255790, 0.139660, 0.601960, 0.672350, -0.070000, 
-0.513630, -0.591130, -0.512200, -0.290000, -0.083280, -0.574070, -0.368430, -0.244970, -0.151130, 0.269990, 
0.077470, -0.569400, 0.040500, 0.453510, -0.009750, 0.061000, -0.159500, 0.041560, 0.179690, 0.266980, 
-0.082310, -0.117450, -0.152980, -0.160110, 0.155930, -0.059950, -0.059890, 0.114590, 0.270890, -0.221140, 
0.053300, -0.460990, -0.193340, 0.058220, 0.266360, -0.015890, 0.322100, 0.126330, 0.007720, -0.219480, 
0.153470, -0.074380, -0.057940, 0.162450, 0.153240, 0.110050, -0.448260, 0.083930, 0.577770, 0.431560, 
-0.325840, -0.171340, -0.307630, 0.572550, -0.043010, 0.069160, 0.200550, 0.496550, 0.237280, 0.098160, 
-0.221820, 0.187310, -0.090010, -0.348030, -0.246690, 0.046710, 0.481580, -0.038460, -0.097830, 0.027110, 
0.334180, 0.033620, -0.240770, -0.216940, -0.051800, -0.251910, -0.261390, -0.189200, 0.166880, 0.082110, 
-0.257060, -0.075990, 0.051370, -0.098810, -0.126720, -0.169370, -0.328770, -0.011980, -0.238010, -0.335570, 
-0.173040, 0.175530, -0.332630, -0.036750, -0.071840, -0.198040, -0.115440, 0.026120, 0.016850, 0.341030, 
0.204500, 0.121190, 0.105530, -0.026800, -0.112120, -0.318320, 0.307540, -0.088510, -0.282900, -0.407490, 
0.134640, -0.195430, 0.019200, -0.089380, -0.222300, -0.384830, -0.067810, -0.192230, -0.097440, 0.273640, 
0.139260, 0.313910, 0.019910, 0.093820, 0.046670, -0.108190, -0.632120, 0.160730, 0.023430, 0.133590, 
0.297520, -0.025980, 0.152570, -0.204070, -0.086360, -0.503290, -0.327890, 0.178070, 0.048190, -0.323940, 
0.194470, 0.067330, 0.276510, 0.452780, 0.022980, -0.223360, -0.128940, 
0.332380, 0.109990, 0.173680, 0.186680, 0.166390, -0.030600, 0.221250, 0.591340, -0.028820, -0.363260, 
-0.211700, 0.056820, -0.221250, -0.101100, 0.024090, 0.462560, 0.077010, -0.050020, -0.031890, -0.234940, 
-0.091740, 0.152070, -0.186310, 0.072250, 0.140440, -0.327940, 0.193700, 0.145020, 0.473230, -0.001950, 
-0.336450, -0.355000, -0.120650, -0.012940, -0.037340, -0.129850, 0.297790, -0.010560, -0.112030, -0.118760, 
-0.250910, -0.080200, -0.092450, 0.026370, -0.029490, -0.055980, -0.086390, 0.089570, 0.004670, -0.033520, 
0.006360, 0.260990, 0.100880, 0.167920, 0.069000, -0.323220, 0.005440, 0.212250, 0.080640, -0.338480, 
-0.126210, 0.066640, -0.104170, -0.126350, 0.336480, 0.373370, 0.330990, -0.085820, 0.536590, 0.285200, 
0.279080, 0.257260, 0.019030, -0.203540, 0.394860, -0.323010, -0.176660, -0.117950, 0.291970, 0.175100, 
-0.050130, 0.215260, -0.173990, -0.080040, 0.152850, 0.155820, 0.126320, -0.127920, 0.335370, 0.329150, 
0.186040, 0.448160, -0.081530, -0.238940, -0.299610, 0.180150, -0.259100, -0.208940, -0.243630, 0.177580, 
0.125840, 0.327830, -0.030510, -0.226960, -0.085210, -0.102490, 0.241300, -0.137650, -0.056960, 0.287960, 
0.189060, -0.074870, -0.291440, 0.281960, 0.220100, -0.119380, -0.013620, 0.086230, -0.207720, -0.017040, 
0.139270, 0.211370, -0.010250, -0.146550, 0.340580, -0.077550, 0.190820, -0.018360, -0.330170, -0.242150, 
-0.032240, -0.145900, 0.102080, -0.412050, -0.110080, 0.243880, 0.255460, 0.186430, 0.054760, 0.289850, 
-0.561810, 0.155210, 0.182260, -0.220890, 0.070670, 0.357130, -0.062930, 0.393120, 0.197080, -0.588910, 
-0.502500, 0.011620, 0.025110, 0.140990, -0.777970, -0.047010, 0.756700, 0.230480, 0.075990, 0.179620, 
0.088080, -0.752680, -0.128700, 0.212800, 0.432980, -0.226260, 0.680060, -0.062480, 0.434790, 0.362930, 
-0.327740, -0.230210, -0.140460, 0.219600, 0.873320, -0.639830, -0.023110, 0.379380, 0.165440, 0.351860, 
-0.043250, 0.147850, -0.828200, 0.075220, -0.047430, -0.087920, 0.066100, 0.542970, 0.003140, 0.600130, 
0.260510, -0.198890, -0.232350, -0.151410, 0.385760, 0.520680, -0.790700, -0.022180, 0.115470, 0.089450, 
0.246770, 0.106790, -0.173550, -0.591650, -0.074750, 0.052560, -0.081010, 0.067240, 0.211570, -0.080630, 
0.314240, -0.061930, 0.043350, 0.111050, -0.083690, 0.139190, 0.246520, -0.106210, -0.278240, 0.152710, 
0.127400, 0.032110, 0.225890, 0.065450, -0.718350, -0.016570, -0.203790, -0.403800, -0.079120, -0.070020, 
-0.101840, 0.393850, 0.064280, -0.245870, -0.144510, -0.177750, 0.189040, 0.103430, 0.212900, 0.054480, 
0.203080, 0.098490, 0.268330, 0.120230, 0.026320, -0.104570, 0.068350, -0.428930, -0.287880, -0.159110, 
-0.147260, -0.113120, 0.173280, -0.018420, 0.270150, -0.002090, 0.057830, 0.201960, -0.016360, 0.083610, 
-0.159660, -0.114340, 0.127450, 0.251150, 0.066470, 0.164380, -0.242800, -0.028390, -0.280510, -0.010210, 
-0.339340, -0.115160, -0.122090, -0.114570, 0.068690, 0.532020, 0.064810, -0.021670, 0.189850, 0.011240, 
0.167920, 0.218300, -0.027340, 0.188890, 0.272410, 0.014250, -0.076240, -0.273150, -0.010280, 0.107880, 
0.268200, 0.218770, -0.067700, -0.145770, -0.009390, 0.207470, 0.241840, 0.153940, 0.162650, -0.026940, 
0.128880, 0.034230, -0.228810, 0.057300, 0.261990, 0.067710, 0.044750, 0.018000, -0.268470, 0.011440, 
0.078380, -0.304570, -0.020530, -0.073520, -0.131330, 0.076260, 0.061890, 0.011690, -0.134860, 0.029810, 
-0.041360, -0.014300, 0.155920, -0.139400, 0.238450, 0.026420, -0.186710, -0.093130, -0.099190, 0.033440, 
0.248150, 0.186560, -0.524500, -0.647200, 0.053910, -0.137230, -0.274650, -0.078940, 0.438620, 0.205090, 
-0.291620, 0.185950, 0.130930, 0.239600, 0.093930, -0.122850, -0.253410, 0.034250, -0.209830, -0.388830, 
-0.053620, 0.203530, 0.085910, -0.609810, -0.105040, -0.137670, -0.129390, 
0.259330, 0.417500, 0.020680, -0.017090, 0.352810, 0.272100, 0.125040, 0.082750, 0.132180, -0.220280, 
0.128700, 0.177410, -0.142860, 0.120560, 0.089670, -0.123910, -0.162800, -0.026330, 0.165820, -0.104450, 
-0.004480, -0.088490, 0.005140, -0.115050, 0.174780, -0.293070, -0.217000, -0.043520, -0.417550, 0.087380, 
0.179520, 0.035350, -0.066790, -0.014550, 0.189660, -0.224630, 0.007090, -0.013400, 0.160190, 0.142910, 
0.040830, 0.019850, -0.045510, -0.003800, -0.021560, 0.325610, 0.125790, 0.045040, -0.102920, -0.364440, 
0.056910, 0.255980, -0.089260, -0.073220, -0.118620, 0.215380, 0.447060, -0.108370, 0.152020, 0.206890, 
0.205820, -0.156020, 0.043190, 0.519960, 0.310450, 0.077530, 0.212620, 0.195650, 0.015710, 0.189070, 
0.152390, -0.055510, 0.081080, 0.182760, 0.305950, 0.074270, -0.066100, 0.302350, 0.088980, -0.078770, 
-0.076550, -0.001860, -0.141530, 0.026050, 0.197450, -0.193840, 0.020240, 0.043380, -0.099580, -0.209410, 
-0.094190, -0.344570, 0.023890, -0.086350, 0.145600, -0.121670, 0.133310, 0.444880, 0.192630, -0.111390, 
-0.035250, 0.246990, 0.234550, -0.336430, 0.026480, -0.052170, -0.159070, -0.050170, -0.074370, -0.502290, 
-0.400820, -0.462510, -0.535820, -0.019580, 0.151740, 0.514840, -0.245900, 0.506800, -0.101970, -0.271430, 
-0.061890, -0.250230, 0.148740, -0.087090, -0.234490, 0.026900, -0.126400, 0.566600, 0.331380, 0.326690, 
-0.069960, 0.626380, 0.691500, -0.182710, -0.111500, 0.299090, 0.426090, 0.771480, 0.032240, 0.148390, 
0.609410, -0.125650, -0.300510, 0.546630, 0.186880, -0.282110, 0.047570, 0.553010, 0.465840, 0.635790, 
1.100810, -0.352710, 0.536310, 0.918430, -0.221270, 0.038000, -0.241620, 0.128450, 0.506270, -0.192000, 
0.225270, -0.036190, 0.485690, 0.127710, 0.449260, 0.535770, -0.243460, -0.001880, 0.575550, -0.178230, 
-0.114630, -0.138250, -0.073190, 0.058040, -0.037490, -0.600040, 0.039560, 0.310800, 0.819240, -0.015500, 
0.616410, 0.082580, -0.717060, -0.434050, -0.579850, 0.546590, 0.060130, 0.296220, 0.007880, 0.136920, 
0.079080, -0.132930, -0.598600, 0.038730, -0.147190, -0.628760, -0.356040, 0.147020, 0.394420, 0.742390, 
-0.422340, 0.649650, 0.404900, -0.561870, -0.422860, -0.533810, 0.483160, 0.072680, -0.063200, -0.044380, 
0.408350, 0.494870, 0.648000, 0.736000, -0.173170, 0.635890, 0.672500, 0.019320, -0.276100, -0.230000, 
0.239390, 0.711540, -0.072120, -0.117030, 0.084600, 0.133780, -0.130240, 0.442900, -0.382840, -0.505930, 
-0.048800, 0.265940, 0.178750, 0.317200, 0.327940, 0.143600, -0.091320, 0.596670, 0.120050, 0.121820, 
0.262470, 0.367460, 0.450270, 0.014740, -0.003230, -0.151190, -0.008420, -0.023060, 0.151340, 0.114950, 
-0.134700, -0.043370, -0.004230, -0.425840, 0.177740, -0.165230, -0.062660, -0.284060, -0.204280, -0.471180, 
-0.221180, 0.510370, 1.044650, -0.357640, 0.289460, 0.426070, -0.167820, -0.165160, -0.011890, 0.326500, 
0.545550, -0.029430, -0.042460, 0.077350, -0.054750, 0.279820, 0.042910, -0.327830, 0.194330, 0.036180, 
-0.271820, -0.222470, 0.274510, 0.506160, 0.220840, -0.112960, 0.116460, 0.371820, -0.454330, -0.400650, 
0.022200, -0.139770, -0.307940, -0.070400, 0.299590, 0.298690, 0.020010, 0.308070, 0.025300, -0.038070, 
0.285460, 0.286940, -0.249960, 0.011770, 0.062720, 0.226700, 0.265680, 0.156320, -0.318210, 0.009100, 
-0.253560, 0.290540, 0.259540, -0.114720, -0.068790, 0.159290, 0.115870, 0.180790, 0.277890, 0.077610, 
-0.071640, 0.156130, -0.025250, -0.199960, 0.194500, 0.274810, -0.038430, 0.086120, 0.061590, 0.137280, 
-0.113610, -0.305640, -0.068140, -0.109380, -0.035300, -0.059630, -0.033910, -0.346750, 0.355200, 0.198550, 
0.030510, -0.146380, 0.154160, -0.081430, -0.147620, 0.152400, 0.106170, 0.215340, 0.148350, 0.065860, 
0.574500, 0.033030, -0.054880, -0.147140, 0.143720, 0.007350, -0.060490, 
-0.273650, -0.149000, 0.327760, 0.286130, -0.117940, 0.227170, 0.149780, 0.585030, 0.325770, -0.017780, 
-0.133990, -0.029540, -0.288980, -0.243100, -0.168760, -0.073050, 0.168090, -0.271160, -0.279570, -0.086930, 
-0.126940, -0.310750, 0.167960, 0.259830, 0.337560, -0.091450, 0.086600, 0.138120, 0.223480, 0.044430, 
0.248490, 0.159570, 0.219170, 0.134890, 0.295700, -0.134620, -0.051490, -0.033900, -0.065230, 0.234580, 
0.057880, -0.124610, -0.241320, 0.028110, -0.058700, -0.049270, 0.571790, 0.040460, 0.267820, 0.599920, 
-0.132280, 0.305620, 0.374080, 0.232190, -0.241700, -0.177540, 0.085470, 0.010950, 0.411070, 0.526120, 
0.053170, 0.478180, -0.115600, -0.362200, 0.407290, 0.549140, 0.332640, 0.217030, 0.139910, 0.242280, 
0.644770, 0.142210, -0.176570, -0.311720, 0.446000, -0.064470, -0.103850, 0.334760, 0.283010, 0.408800, 
0.124310, 0.042850, -0.280120, -0.124220, -0.155040, -0.498410, -0.099330, -0.013670, 0.231010, -0.134420, 
-0.449140, 0.164170, -0.028370, 0.266010, -0.244290, -0.441150, 0.183150, 0.597760, -0.461920, -0.226450, 
-0.148190, 0.182110, 0.335040, 0.612730, -0.100940, -0.387000, 0.603600, 0.143160, -0.281600, -0.522160, 
0.516080, 0.150930, 0.605580, 0.223610, -0.071470, -0.056310, 0.574400, -0.177420, 0.167710, -0.220010, 
0.512470, 0.046030, 0.005830, 0.448860, 0.056400, -0.085140, 0.663080, -0.531420, -1.005520, -0.978620, 
0.760590, -0.526070, -0.595080, 0.473370, -0.332700, 0.560620, -0.122380, -0.691030, 0.089610, 0.335960, 
-0.349930, -0.527320, -0.357140, 0.226830, 0.132930, 1.256580, -0.080570, -0.028380, 0.318920, -0.261990, 
0.022140, 0.149750, 0.531110, 0.855250, -0.398400, 0.126330, 0.615840, 0.038190, 0.495460, 0.199640, 
0.089410, -0.608840, 0.477490, 0.660050, -0.182260, 0.058970, 0.983570, -0.039900, -0.465550, -0.330210, 
-0.850410, -0.279110, 0.656470, -0.681810, -0.561100, 0.595770, -0.614070, -0.110190, -0.335900, -0.685740, 
-0.030440, 0.093060, -0.234610, -0.259220, -0.666660, 0.110150, -0.307650, 0.062480, -0.002480, -0.749740, 
0.653990, 0.081600, -0.141660, 0.283170, 0.409810, -0.038960, -0.143590, -0.043220, 0.668220, -0.335790, 
0.077250, 0.355430, 0.003570, -0.537630, 0.283820, 0.435800, 0.383800, 0.366880, 0.766640, -0.034550, 
-0.081750, 0.373600, -0.123120, 0.391010, -0.105970, -0.129540, -0.184620, 0.554220, -0.185010, 0.171030, 
-0.106480, -0.052050, -0.294330, 0.030720, 0.380290, 0.062680, -0.154040, 0.091250, -0.172290, 0.142730, 
-0.033170, -0.293920, 0.269340, -0.179640, 0.726130, 0.305700, 0.160070, -0.131520, 0.213720, 0.077390, 
0.042850, 0.066630, -0.067300, 0.283250, 0.306380, 0.349150, 0.203680, 0.275650, 0.130010, 0.228100, 
0.293570, -0.031800, -0.270680, -0.000010, 0.284660, 0.461810, -0.463500, 0.022300, 0.206430, 0.477160, 
0.060040, 0.159950, -0.120500, 0.071930, -0.184900, 0.396470, 0.135920, 0.030480, 0.001880, 0.262020, 
-0.067140, 0.176950, -0.012080, -0.201580, -0.108010, 0.130600, 0.115340, -0.050920, -0.159880, 0.240040, 
0.206950, 0.102250, 0.096820, -0.063960, 0.087990, 0.301560, -0.017060, 0.083780, 0.137970, 0.245780, 
-0.094620, 0.129990, 0.230680, -0.019350, -0.197220, 0.234530, 0.399220, 0.165720, 0.086510, -0.303890, 
-0.281250, 0.303240, 0.051400, 0.021560, -0.191650, -0.157450, 0.044480, 0.193710, -0.039640, 0.022990, 
0.174970, 0.155900, 0.019650, 0.042860, -0.003730, -0.183370, 0.145520, 0.119310, -0.308710, 0.288960, 
0.175730, 0.020480, 0.353710, -0.205380, -0.334390, -0.034600, -0.199620, -0.114880, 0.246400, 0.214680, 
0.050340, 0.153070, 0.242790, 0.190410, -0.243390, -0.016530, 0.036830, 0.429990, -0.066130, 0.123030, 
0.005980, 0.333800, 0.068210, -0.254920, 0.187110, 0.180390, -0.131270, -0.045320, -0.075440, -0.045150, 
-0.051100, 0.189940, 0.266760, 0.423820, -0.056320, 0.129700, -0.031770, 
-0.194690, -0.189700, -0.156300, 0.042520, 0.031470, 0.058660, -0.086760, -0.134780, -0.059110, 0.070910, 
-0.040670, -0.116160, -0.004600, -0.174910, -0.148910, 0.060700, 0.041320, 0.476380, 0.453390, -0.149790, 
-0.014650, -0.389560, 0.211020, 0.001020, 0.221410, 0.166540, 0.035820, -0.118120, 0.059100, 0.160820, 
-0.074730, -0.044810, 0.253630, -0.349540, -0.031070, 0.099240, -0.017890, -0.135840, 0.268280, 0.537760, 
-0.127080, -0.029250, -0.728030, -0.157490, 0.297470, 0.007260, 0.161170, -0.242480, -0.061610, 0.303210, 
-0.069110, 0.139920, -0.206140, -0.024590, -0.284800, 0.142370, -0.103140, -0.206910, -0.034640, 0.560910, 
-0.072700, 0.109190, -0.034680, -0.173090, 0.151680, -0.022480, 0.001560, 0.155220, -0.142660, 0.015430, 
-0.013490, -0.356100, 0.277040, 0.029750, 0.261000, -0.022990, -0.070090, 0.242420, -0.218550, 0.007470, 
0.182940, -0.041500, 0.090830, -0.032980, -0.298360, 0.347500, -0.128060, 0.081720, 0.128860, 0.484250, 
0.216320, 0.314740, -0.278640, -0.095300, 0.078950, 0.424790, 0.305040, -0.279980, 0.315530, -0.251370, 
-0.108470, 0.310670, -0.296920, 0.133940, -0.045350, -0.664090, 0.037740, 0.556840, 0.442170, -0.339490, 
0.070380, 0.252170, 0.628610, 0.253860, 0.088560, -0.018280, 0.179240, 0.174670, -0.280130, -0.302040, 
0.484250, 0.911020, 0.677390, -0.009230, 0.166980, -0.019330, -0.267730, 0.189010, -0.109680, -0.067050, 
-0.204760, -0.230140, -0.329220, 0.369380, 0.080360, 0.155070, -0.281500, 0.021060, 0.306420, 0.215420, 
-0.529140, -0.390340, 0.011960, -0.417450, 0.017200, 0.281410, -0.030400, -0.921990, 0.844450, 0.027610, 
0.209100, -0.303920, 0.444430, 0.802780, -0.214470, 0.503380, -0.290340, -0.530420, 0.710220, 0.213990, 
-0.445260, 0.494670, 0.542710, 0.946380, 0.237250, 0.088180, 0.183570, -0.034980, 0.043050, -0.021170, 
-0.513120, -0.958580, 0.295180, -0.043900, -0.428060, -0.022750, 0.286770, 0.630300, -0.507020, -0.380610, 
0.060420, 0.109930, -0.422160, -0.369370, -0.062460, -0.143960, 0.338860, 1.124590, 0.003630, -0.459850, 
0.220880, 0.021520, -0.026520, -0.201140, 0.048160, 0.330190, -0.035600, 0.359460, -0.167320, -0.437650, 
0.362370, -0.117380, 0.073420, 0.013490, 0.488490, 0.793370, 0.096440, 0.461890, 0.302480, -0.007140, 
-0.402600, 0.238590, -0.158470, -0.769190, 0.221030, -0.572070, -0.131610, -0.112790, 0.084550, 0.263470, 
0.022090, -0.049540, -0.034990, 0.227450, -0.272380, -0.154500, -0.292150, -0.427690, 0.278360, 0.143500, 
0.003760, -0.225950, 0.482110, -0.122800, -0.049750, 0.198700, 0.046510, -0.139880, -0.513160, -0.110730, 
0.107780, -0.263670, 0.063510, 0.124620, -0.110510, 0.118320, 0.151710, 0.619120, -0.156770, 0.172410, 
0.665670, 0.004440, -0.324150, 0.178730, 0.114020, 0.137830, 0.292830, 0.058430, 0.134350, -0.182120, 
0.073320, -0.035890, -0.530520, -0.209480, -0.237350, -0.128160, 0.050310, 0.284200, 0.330600, 0.016480, 
0.271580, 0.280620, 0.007990, -0.322720, -0.118310, -0.329310, 0.249740, 0.082280, 0.017770, 0.158010, 
-0.339840, -0.001380, 0.311150, -0.163050, -0.095280, 0.223320, 0.136260, 0.288440, 0.109080, 0.573270, 
-0.121060, 0.281520, 0.526910, -0.000640, -0.357730, 0.091730, 0.077390, -0.239580, 0.325600, 0.194450, 
-0.142610, -0.173390, 0.001360, 0.159010, 0.009680, 0.473290, -0.235570, 0.144910, 0.409310, 0.248700, 
0.206990, -0.269800, -0.049800, 0.511740, 0.002880, -0.327890, -0.059550, -0.133610, 0.609200, -0.472160, 
0.084880, 0.478200, 0.182400, -0.004170, 0.031630, -0.212480, -0.109060, 0.077060, 0.108770, 0.464090, 
0.258290, 0.236600, -0.323140, -0.195000, 0.022110, 0.020980, -0.176060, 0.301340, 0.054260, 0.537420, 
0.019310, 0.036880, 0.072650, -0.450240, 0.411950, 0.271110, 0.258120, 0.291770, 0.348410, 0.091770, 
0.531920, 0.319430, 0.226690, 0.001660, 0.225610, 0.164640, 0.012510, 
0.192270, -0.190850, -0.461170, -0.052240, 0.327220, -0.073600, -0.024300, -0.197680, -0.397740, 0.337610, 
0.084690, -0.096040, 0.117620, -0.242400, 0.046960, 0.079900, 0.261050, 0.304880, -0.339780, 0.593750, 
-0.077720, 0.420910, 0.048560, -0.214290, 0.075230, 0.064330, -0.038050, 0.054510, 0.151740, 0.294970, 
0.157200, 0.093610, -0.028620, 0.048730, 0.212440, -0.244820, 0.174440, 0.154670, 0.156370, 0.228680, 
0.323380, -0.058940, 0.208520, 0.329150, 0.149820, -0.238480, 0.395270, 0.470710, 0.084440, -0.150420, 
-0.055950, 0.050980, 0.118800, 0.282130, 0.118620, -0.026150, -0.147410, -0.014680, -0.054640, 0.311880, 
0.136440, -0.042440, -0.075320, -0.190660, 0.053730, 0.058620, 0.461750, 0.113570, 0.032540, 0.125050, 
0.413860, 0.018040, -0.039450, -0.155440, 0.052590, -0.044490, 0.457710, 0.057340, 0.032000, -0.092350, 
0.072640, -0.015260, -0.073830, -0.075790, 0.161030, 0.144660, 0.312500, 0.484670, 0.058890, 0.420430, 
0.301150, 0.991030, 0.070840, -0.284790, 0.058580, 0.646350, 0.333020, -0.090770, 0.503760, 0.042850, 
0.086950, 0.377380, 0.143880, -0.232590, -0.090230, -0.130720, 0.141150, -0.138090, 0.523330, 0.017420, 
-0.148730, -0.264810, 1.229470, 0.216160, -0.281080, -0.230130, 0.197730, -0.163930, -0.233290, 0.145250, 
0.325750, 0.162700, 0.012890, -0.134980, -0.039590, -0.069080, -0.487530, 0.118820, 0.108940, 0.198440, 
0.031860, 0.241780, -0.528170, 0.417980, 0.389870, -0.073740, -0.360180, 0.309850, 0.176140, 0.229850, 
0.058660, -0.133570, -0.174840, 0.075610, -0.057550, 0.002390, -0.067760, -0.337680, 0.419680, -0.017610, 
0.282300, 0.572080, -0.007760, -0.054480, 0.096620, 0.213990, 0.301390, -0.094550, 0.402990, 0.201360, 
-0.046850, 0.427980, 0.213320, 0.421770, 0.309740, 0.240180, 0.334560, -0.051810, -0.061740, 0.373770, 
-0.591720, -0.804130, 0.296390, -0.023450, -0.036370, -0.067620, 0.356850, 0.562220, 0.192820, -0.112020, 
0.656910, 0.302690, -0.400150, -0.155860, 0.148990, -0.099410, 0.158960, 0.847770, -0.005120, -0.142150, 
0.396010, -0.102970, -0.243610, 0.054130, 0.078180, 0.239670, -0.122640, 0.036840, 0.225480, -0.150770, 
0.014830, 0.432580, -0.004460, -0.366520, 0.143560, 0.118790, -0.169400, 0.140670, 0.856540, -0.040560, 
-0.327410, 0.519890, -0.449400, -0.979750, -0.217900, -0.188780, -0.011370, -0.264670, 0.285610, 0.433760, 
0.106680, 0.042630, 0.255260, 0.061400, -0.155240, -0.078630, 0.023420, 0.066330, 0.261010, 0.615570, 
-0.049370, -0.495040, 0.149060, -0.492320, -0.419110, 0.043950, 0.142440, -0.217070, -0.271490, -0.090100, 
0.445340, 0.051150, -0.300460, 0.186100, 0.090830, -0.233000, -0.339300, -0.200740, 0.221280, 0.079450, 
0.662560, -0.030010, -0.337540, 0.417620, -0.391610, -0.361130, 0.369970, -0.453040, 0.016780, -0.140890, 
-0.372100, 0.283470, -0.102960, 0.029410, -0.137400, 0.134450, 0.262480, -0.190900, 0.045190, -0.049200, 
0.016920, 0.506070, -0.015340, -0.691150, -0.098240, -0.209720, -0.284070, 0.453140, -0.380230, -0.537040, 
-0.446490, -0.030760, 0.136580, 0.015640, -0.214430, 0.418830, -0.014480, 0.588690, -0.212400, 0.001140, 
0.177900, 0.237960, 0.551760, -0.008120, -0.546340, 0.028280, 0.016520, 0.042430, -0.067370, -0.316980, 
-0.066320, -0.039300, -0.143690, 0.162640, 0.041190, 0.197620, 0.126990, 0.158850, 0.391660, -0.119150, 
0.189780, -0.250060, 0.148660, 0.499570, -0.023670, -0.202680, -0.083510, 0.024100, 0.137530, -0.456800, 
-0.310080, 0.124080, 0.251570, 0.102000, -0.001120, -0.226500, -0.009890, 0.007250, 0.399770, 0.336000, 
-0.004790, 0.071340, 0.011830, -0.328240, 0.162230, 0.005420, -0.290170, 0.141560, 0.447670, 0.336980, 
0.425570, -0.268180, -0.395230, 0.441290, 0.345260, 0.034550, -0.197510, 0.568600, -0.092680, -0.002570, 
0.362280, 0.169690, 0.411820, 0.326840, -0.315780, -0.071400, 0.040320, 
0.415850, 0.273700, 0.187890, -0.055950, 0.104540, 0.310110, 0.026430, 0.386940, 0.192250, -0.055080, 
-0.116110, -0.132050, 0.295760, 0.085880, -0.091790, 0.461350, 0.220460, 0.128110, -0.046800, 0.143700, 
0.118030, 0.214640, 0.079290, -0.113510, -0.226670, 0.102900, -0.175970, 0.020240, 0.150870, -0.059060, 
0.115560, 0.092600, -0.080220, 0.229560, 0.324280, 0.228140, -0.162360, -0.075380, 0.459180, 0.045340, 
0.054750, 0.104630, 0.203500, -0.093320, -0.373720, 0.012530, 0.213770, -0.039100, 0.025470, 0.098140, 
-0.136860, 0.264890, 0.088050, -0.188430, 0.197220, 0.177380, -0.188530, 0.079550, 0.042080, -0.252700, 
-0.159420, 0.058560, 0.094560, 0.396280, 0.157660, 0.032250, -0.124410, 0.144870, -0.051170, -0.092030, 
0.483480, -0.147230, 0.068090, -0.218850, -0.030930, -0.015400, 0.239350, -0.203730, -0.053990, -0.253930, 
0.810080, 0.007330, 0.120510, 0.096340, -0.038330, 0.088570, 0.125160, 0.022650, -0.222420, 0.037820, 
-0.015180, 0.010610, -0.032820, 0.183210, 0.243760, 0.079190, 0.236780, 0.018390, 0.362320, 0.170790, 
0.474110, 0.035830, -0.041920, 0.313420, 0.090240, -0.026960, 0.150790, 0.046020, -0.265480, 0.131530, 
-0.168760, -0.180890, 0.226640, 0.245200, -0.029150, 0.182540, 0.130900, 0.152360, 0.116050, 0.294330, 
0.120880, 0.014810, 0.036850, 0.156590, 0.047230, 0.093130, -0.101720, 0.335460, 0.392190, 0.564420, 
-0.012760, 0.058020, 0.094450, 0.263910, 0.222510, 0.285710, -0.255560, -0.037460, 0.018020, 0.217570, 
0.207470, 0.282740, 0.262150, 0.065050, 0.097760, 0.040240, 0.082680, -0.068140, -0.259920, -0.109760, 
-0.217940, 0.340960, -0.352130, -0.305000, -0.408200, -0.190420, 0.621340, 0.705360, -0.051820, 0.467750, 
0.220630, 0.404980, -0.077110, 0.201070, -0.194550, -0.003350, 0.632320, 0.075160, -0.111730, -0.008430, 
0.261380, 0.396530, 0.128550, -0.147100, -0.451280, 0.051860, 0.144570, -0.448770, -0.186740, -0.000440, 
-0.093430, -0.203310, 1.431030, 0.237020, 0.481300, -0.238930, 0.154770, -0.466680, 0.007660, -0.304280, 
-0.000690, 0.214580, 0.144760, 0.020390, -0.062960, -0.215020, 0.304930, 0.165320, -0.054660, 0.162460, 
-0.045420, -0.173490, 0.306450, 0.718210, 0.229710, 0.015840, 0.130630, -0.195300, -0.122410, 0.043500, 
-0.020420, -0.235890, -0.305490, 0.229900, 0.022040, 0.054420, 0.257830, 0.263910, -0.447820, -0.019390, 
-0.032190, 0.311000, -0.039850, -0.170440, 0.715210, 0.015590, -0.000600, 0.258040, -0.385350, -0.025980, 
0.060220, -0.159610, 0.261290, -0.131750, 0.202640, -0.163200, 0.240720, 0.641550, 0.038440, 0.223870, 
-0.161370, -0.113930, 0.149370, 0.118330, -0.008280, -0.233800, -0.036260, 0.012720, 0.385910, 0.286560, 
0.195100, 0.069410, -0.315780, -0.001750, -0.141280, 0.068180, -0.186120, 0.140120, 0.095560, -0.565800, 
0.282210, 0.365870, 0.103970, -0.278060, 0.245480, 0.300330, -0.248670, -0.152330, -0.126510, 0.139760, 
0.245540, 0.147880, 0.073480, -0.047870, -0.043150, 0.031550, 0.001700, -0.161680, 0.036370, 0.330540, 
0.096520, -0.165790, 0.107670, -0.109080, 0.097760, -0.015290, -0.248470, -0.144220, 0.077030, -0.304120, 
-0.043790, -0.227940, 0.202110, 0.058540, -0.136340, 0.384690, 0.055770, 0.139360, 0.233100, 0.082830, 
0.125140, -0.036490, -0.112560, -0.072740, -0.021540, 0.163080, 0.205760, 0.107290, -0.186070, 0.082310, 
-0.160720, 0.025990, -0.200540, -0.233510, 0.043940, 0.038440, -0.414550, -0.466510, 0.100880, 0.473280, 
-0.150400, -0.238610, -0.081700, -0.377520, 0.213100, -0.224640, -0.366250, -0.126750, -0.165310, 0.166650, 
0.019520, -0.123210, -0.329010, -0.228940, 0.257290, 0.029590, 0.216070, 0.159800, 0.069190, -0.211960, 
0.143970, 0.193240, -0.145610, -0.044800, 0.071370, 0.028270, -0.028500, -0.355310, 0.241020, -0.096830, 
0.149820, -0.131550, 0.047850, 0.219440, -0.059250, 0.173100, 0.040560, 
0.259480, 0.125360, -0.015860, 0.147140, -0.109130, -0.271620, -0.157270, -0.320010, -0.090650, 0.290980, 
0.087950, -0.071400, -0.278430, 0.262390, -0.096110, 0.191120, 0.092230, 0.153690, -0.166070, -0.225990, 
-0.071490, 0.277710, 0.352460, -0.215010, 0.240620, 0.267450, -0.021060, 0.169700, -0.026370, 0.210360, 
0.032410, 0.194750, 0.319050, 0.025340, 0.170070, 0.175280, -0.218380, -0.276420, 0.179100, 0.293810, 
-0.127350, -0.061190, 0.374410, 0.656890, -0.278540, 0.296800, 0.014840, 0.294160, 0.792010, -0.044550, 
0.147180, -0.256180, 0.106510, 0.630310, 0.093380, -0.086070, 0.191470, 0.126540, -0.063260, -0.030980, 
-0.039870, -0.176370, -0.049250, 0.357750, -0.086690, 0.279890, 0.261640, -0.342160, -0.113880, 0.385680, 
-0.050100, 0.086590, -0.090100, -0.065580, -0.056660, 0.092350, 0.099830, 0.035720, 0.065060, 0.091640, 
0.007460, -0.128900, 0.074860, -0.033900, 0.106860, 0.057680, -0.461530, -0.491100, 0.070920, 0.008720, 
-0.174260, -0.477410, 0.578060, 0.703770, 0.472580, -0.137790, 0.123440, 0.024360, -0.103130, -0.257250, 
-0.177250, 0.454410, 0.530580, 0.280820, -0.031710, 0.429750, 0.751620, 0.357270, 0.777920, -0.133980, 
0.125910, 0.590920, -0.013070, -0.145950, 0.358430, 0.546980, 0.749980, -0.121210, 0.355610, 0.072630, 
-0.186970, -0.595600, 0.362490, 0.283330, 0.176400, -0.044810, 0.472510, 0.056690, 0.540700, 0.518480, 
-0.576780, 0.472750, 0.505270, -0.343670, 0.218960, -0.075500, 0.231870, 0.463820, 0.099200, 0.079650, 
-0.262460, -0.143610, -0.594440, 0.289490, 0.108150, -0.227760, -0.048810, 0.428810, -0.067610, -0.408680, 
-0.339980, -0.096030, -0.192730, -0.340460, -0.594390, 0.301820, 0.132340, 0.400610, -0.339120, 0.306980, 
0.409690, 0.306190, -0.035860, -0.211530, 0.328700, 0.095540, -0.240680, -0.005560, 0.724860, 0.568630, 
0.341470, -0.135020, -0.197710, 0.004100, 0.489730, -0.263770, -0.212740, 0.475700, 0.923460, 0.239200, 
0.883210, 0.274530, 0.132390, -0.233780, -0.497740, 0.768320, -0.082120, -0.209160, -0.008320, 1.114210, 
0.691070, 0.677330, 1.031710, -0.011500, 0.913540, 1.650450, 0.323760, 0.150520, 0.228350, 0.325530, 
1.197050, 0.212250, -0.030540, -0.176290, 0.119380, -0.001950, 0.432620, -0.023610, -0.195450, -0.055150, 
0.752070, 0.276200, 0.184640, 0.156400, 0.232410, 0.661370, 0.466910, -0.207490, 0.353140, -0.148660, 
0.411080, 0.315010, 0.338330, -0.305070, -0.908670, -0.344240, -0.465290, 0.140130, 0.131340, -0.257480, 
-0.077370, -0.186330, -0.328470, 0.047610, -0.586440, -0.240100, 0.100370, -0.467170, 0.008550, 0.076320, 
0.058220, 0.302070, -0.000800, 0.476450, 0.360960, -0.390150, -0.454610, -0.769990, 0.374930, -0.003510, 
-0.364730, -0.098450, -0.052520, 0.492270, 0.246910, 0.261510, -0.511510, 0.337740, 0.316380, 0.335320, 
0.021220, 0.255630, 0.235870, 0.547750, -0.156060, -0.318890, 0.403520, -0.253500, -0.473870, -0.260000, 
0.014100, -0.076610, -0.120080, 0.201190, 0.595280, 0.488630, 0.257260, -0.189830, 0.624760, 0.575420, 
0.172360, 0.043650, 0.174100, -0.142140, 0.682430, 0.072550, 0.158050, 0.490110, 0.005790, -0.350490, 
0.147760, -0.034080, -0.335810, -0.136190, 0.476040, 0.225300, -0.276760, -0.185800, 0.014520, -0.460540, 
-0.227420, 0.045550, -0.270760, 0.318870, 0.159200, 0.045690, -0.103140, 0.210390, -0.130020, -0.034860, 
-0.208760, -0.218700, 0.093100, 0.343120, -0.125600, -0.058270, -0.168840, 0.252440, -0.011560, 0.306210, 
-0.016540, -0.053400, 0.307930, -0.241190, -0.015530, -0.024320, 0.654650, -0.274720, -0.041220, -0.398350, 
-0.096070, -0.130500, 0.054840, -0.071200, 0.204200, -0.140580, 0.114850, 0.284230, -0.093810, 0.321070, 
-0.014000, 0.136510, 0.569060, 0.193370, -0.134870, 0.079430, -0.254300, 0.009730, -0.364650, -0.189810, 
0.194320, -0.222150, 0.127620, 0.138410, -0.189020, 0.157060, -0.125700, 
0.093770, 0.187940, -0.179150, -0.185000, 0.091150, 0.157940, 0.085300, 0.230480, 0.246770, 0.131330, 
0.034090, 0.199520, 0.109100, 0.057850, -0.097460, 0.023800, -0.045640, 0.250780, 0.147020, 0.083750, 
0.128120, 0.099490, -0.075400, 0.229160, 0.099060, 0.051270, -0.155200, -0.045880, -0.221320, 0.452800, 
-0.185260, -0.227810, -0.052970, -0.302690, 0.287040, 0.120750, 0.011660, 0.128230, 0.317260, 0.315310, 
0.024870, 0.121920, -0.062710, -0.098910, -0.015130, 0.096790, -0.127230, 0.182230, 0.344800, -0.425930, 
-0.094330, 0.160020, 0.186360, -0.193160, 0.306440, 0.057970, -0.049960, 0.017270, 0.248870, 0.224830, 
-0.004340, -0.212260, 0.136690, 0.124250, -0.196600, -0.092820, 0.260730, -0.343660, 0.061970, 0.251160, 
0.063750, 0.104760, -0.042120, -0.063540, -0.092070, -0.022810, -0.145690, -0.117850, -0.146110, -0.138190, 
0.174330, 0.136290, -0.061590, 0.130680, 0.131010, 0.155710, 0.064120, 0.051660, -0.167530, 0.057350, 
0.147110, 0.331810, -0.087300, -0.060950, -0.157510, 0.141730, 0.238570, -0.169260, 0.075710, -0.020410, 
-0.334190, 0.361310, -0.313720, 0.023970, 0.135870, -0.088910, 0.046560, 0.342390, 0.068030, 0.005610, 
-0.119350, 0.032710, 0.144560, 0.172910, 0.118660, 0.024800, 0.091740, 0.230770, 0.272150, 0.192130, 
-0.128740, -0.120850, 0.174900, 0.308400, 0.034370, 0.143160, -0.198400, -0.055120, 0.363250, 0.076470, 
0.093270, -0.389950, -0.347470, 0.262100, 0.095480, -0.172950, 0.092300, -0.072110, -0.053320, -0.174610, 
0.297850, -0.023280, -0.145690, -0.013710, 0.302030, -0.380920, 0.127720, 0.024670, -0.025860, 0.291170, 
0.109440, -0.019240, -0.032580, -0.157660, 0.454310, 0.076020, 0.059050, 0.261030, 0.042770, 0.254640, 
-0.023090, 0.184280, -0.015170, -0.366920, 0.347790, -0.031080, -0.083860, 0.113320, -0.225110, -0.263830, 
-0.201960, -0.351170, 0.026760, -0.205090, -0.369500, -0.507170, -0.016420, 0.201750, 0.777500, -0.144440, 
0.581470, 0.133300, 0.211380, -0.053410, 0.013030, 0.020350, -0.088190, -0.065930, 0.009430, -0.170700, 
-0.276910, -0.228720, 0.319840, -0.305670, -0.210310, -0.290890, -0.288580, -0.323890, 0.015950, 0.131600, 
-0.033580, -0.008660, -0.033410, 1.805060, 0.194530, 0.361790, -0.283630, -0.151770, -0.102640, 0.062460, 
-0.141010, -0.086730, -0.076770, 0.251130, 0.102200, -0.112720, 0.189180, 0.472470, 0.025490, -0.190700, 
0.072250, -0.057470, 0.055220, 0.102150, 0.437630, -0.181630, 0.008670, 0.482090, 0.048910, -0.247110, 
0.080320, -0.045680, -0.081250, 0.116610, 0.526260, 0.170860, 0.077490, 0.541300, -0.024070, -0.067860, 
-0.159500, -0.055030, -0.017540, -0.244410, -0.334650, 0.189920, -0.089250, -0.118380, -0.421720, -0.328010, 
0.022990, 0.080260, -0.034320, 0.108160, 0.312980, 0.460600, -0.139850, 0.237540, 0.284040, -0.201880, 
-0.046300, 0.173670, 0.133900, 0.118000, -0.047230, -0.332290, -0.106660, -0.097670, 0.239780, -0.337080, 
-0.247990, -0.071030, 0.075330, 0.180230, 0.052500, -0.032040, 0.182630, 0.128210, 0.042600, 0.172570, 
-0.034230, -0.132270, 0.234830, 0.298790, -0.379080, -0.051880, 0.155650, -0.326680, 0.058450, 0.130420, 
-0.182680, -0.141590, -0.075200, 0.094680, 0.136950, 0.243310, -0.085750, 0.185150, -0.017000, 0.227070, 
0.101960, 0.025870, 0.126820, 0.276150, 0.187360, 0.217270, -0.021050, 0.156230, -0.108040, 0.064330, 
-0.079080, 0.025930, 0.181020, 0.039940, 0.096600, 0.224170, 0.106690, 0.035420, 0.212340, 0.043250, 
0.071820, 0.229890, -0.151010, 0.218600, 0.112470, 0.189050, -0.062030, -0.148280, 0.167790, 0.047790, 
0.016140, -0.045050, -0.280340, 0.182480, 0.192800, 0.100190, 0.043060, -0.038720, 0.189830, 0.114900, 
-0.038840, 0.005070, 0.042600, -0.090830, 0.218650, 0.056450, 0.080870, 0.088100, -0.061410, 0.171370, 
-0.034470, -0.067480, 0.151490, 0.096580, 0.040450, 0.239610, 0.087740, 
0.020420, 0.074650, -0.067510, -0.033350, 0.235490, 0.006960, 0.161740, -0.144650, 0.111690, 0.308210, 
0.235660, 0.072040, 0.277530, 0.354160, 0.260890, 0.037720, 0.134590, 0.373640, 0.147070, 0.283100, 
0.221740, -0.010730, 0.023450, -0.007320, 0.013580, 0.064800, 0.225720, 0.282620, 0.029630, 0.068080, 
0.052600, 0.288080, 0.059130, 0.232190, 0.207620, 0.200310, 0.067600, -0.015440, 0.250570, -0.092730, 
0.085890, 0.214330, 0.077180, 0.214290, 0.012740, -0.012240, 0.481980, 0.128310, -0.006670, 0.282950, 
0.155560, 0.110980, 0.271860, 0.146110, 0.158990, 0.138090, 0.231400, 0.033900, 0.001110, 0.352590, 
-0.024670, 0.040640, 0.231930, 0.117170, 0.057830, 0.233290, 0.268680, 0.325600, 0.227610, 0.275640, 
0.016350, 0.345370, 0.042380, 0.071110, 0.016610, 0.030160, 0.128410, 0.500760, 0.020750, 0.218190, 
0.146540, -0.018470, -0.015210, 0.236590, 0.128620, 0.107860, 0.006960, 0.217870, 0.188940, 0.117610, 
0.021970, 0.111120, 0.276980, 0.034500, 0.193980, 0.050520, 0.418720, 0.275640, 0.314360, 0.138640, 
-0.041920, 0.290610, 0.178970, 0.011770, 0.224160, -0.005850, -0.074000, -0.019070, 0.364560, 0.162870, 
-0.243410, 0.025850, 0.302950, 0.183890, 0.039340, 0.205220, -0.094660, 0.047710, 0.192080, 0.297110, 
0.133930, -0.082580, 0.093510, 0.145970, 0.054410, 0.202660, 0.061020, 0.212320, -0.088270, 0.151390, 
0.114540, 0.179310, 0.150310, -0.114590, 0.180280, 0.474420, 0.466210, 0.148300, 0.355080, 0.341000, 
0.125250, 0.089720, -0.196370, 0.012830, 0.387270, 0.145650, 0.193290, 0.335020, 0.214850, 0.032490, 
0.050670, 0.311260, 0.201970, 0.140500, 0.452240, 0.132350, 0.454680, 0.491480, 0.271980, 0.383970, 
0.363310, 0.200920, 0.205790, -0.065690, 0.491750, 0.068340, 0.258510, 0.187720, -0.134680, -0.101680, 
0.042990, -0.067410, -0.278420, 0.160970, -0.158810, -0.353720, 0.093940, 0.098200, 0.301230, 0.127670, 
0.383300, -0.012970, 0.774480, 0.139280, -0.096740, -0.217710, -0.269490, 0.115810, -0.001830, -0.338940, 
0.076210, -0.136840, 0.140410, -0.468380, -0.062420, -0.171310, 0.109630, 0.122760, 0.054400, 0.026630, 
0.132460, 0.305640, 0.110570, 0.364480, -0.011700, 0.068250, 0.018960, -0.159330, -0.005290, 0.005980, 
-0.361600, -0.011890, 0.131590, 0.163490, 0.005570, -0.055140, -0.159540, 0.055530, 0.067320, 0.098900, 
0.165520, 0.059050, -0.023780, 0.034070, 0.311080, -0.092560, -0.042950, -0.088010, -0.047720, -0.059580, 
0.009570, -0.022410, -0.005860, 0.427120, 0.051700, 0.006710, 0.086980, 0.185810, -0.068240, 0.123470, 
-0.121630, 0.035490, 0.043950, -0.145110, 0.136380, 0.061400, 0.022160, 0.192920, -0.062960, -0.022150, 
-0.088730, 0.007270, -0.171320, 0.011240, -0.230080, -0.146710, -0.219650, -0.071580, 0.215480, -0.305490, 
-0.128940, 0.002580, -0.018250, 0.072860, -0.058940, -0.232550, 0.041160, -0.156300, 0.042510, -0.071020, 
-0.206130, -0.119300, 0.005150, -0.029220, -0.031740, 0.037460, 0.182670, -0.265520, 0.162850, 0.024090, 
-0.250180, 0.071960, 0.020190, -0.098230, -0.052160, -0.300960, 0.016570, 0.130510, 0.201000, 0.054860, 
-0.165760, 0.002030, -0.032530, 0.021740, 0.069290, 0.154200, -0.051020, 0.389360, -0.034110, 0.285570, 
0.249240, -0.198570, 0.182570, -0.254590, -0.147390, 0.045100, -0.084340, 0.097790, -0.190280, -0.020980, 
-0.125180, -0.304000, 0.059310, 0.031600, 0.022900, -0.007030, 0.057490, -0.216360, -0.086930, 0.197000, 
-0.038920, -0.034700, -0.086390, -0.263430, -0.135290, -0.016920, 0.011470, -0.071670, 0.146830, -0.148760, 
0.018820, -0.133080, -0.026300, -0.226050, -0.072790, 0.019420, 0.235230, -0.131760, -0.262840, -0.217570, 
-0.030900, 0.046020, -0.133710, -0.110210, 0.080730, 0.097070, 0.041900, -0.129820, -0.148430, 0.062550, 
0.250080, -0.044020, -0.180380, -0.134180, -0.086490, 0.256790, 0.019320, 
0.366790, -0.093300, -0.264950, 0.167940, 0.223080, 0.058510, -0.142880, 0.006670, -0.144840, 0.047470, 
0.160000, -0.179170, -0.231010, 0.413980, -0.014110, -0.252900, -0.337520, 0.687810, -0.170660, -0.105260, 
0.084780, 0.138370, 0.428290, 0.073050, -0.128340, 0.063850, 0.285320, 0.231870, -0.093410, -0.116130, 
-0.009150, -0.005510, 0.188970, 0.298690, -0.007740, -0.157050, 0.002080, -0.178610, 0.100720, 0.026440, 
0.020710, 0.095910, 0.278510, 0.368960, 0.417810, 0.266610, -0.168970, 0.087030, 0.185710, 0.162550, 
0.160690, -0.079470, -0.309680, 0.209340, -0.133060, 0.147560, 0.148470, -0.196820, -0.303920, 0.477790, 
0.158410, -0.076940, 0.121370, -0.058630, 0.272260, 0.231980, 0.021570, 0.153510, 0.012380, -0.154730, 
-0.234010, -0.017260, 0.085230, 0.148000, 0.200250, 0.021760, 0.008160, -0.127850, -0.248160, -0.213620, 
-0.026220, -0.184230, -0.135130, 0.111580, 0.177600, 0.254640, -0.019750, 0.198610, 0.255110, 0.162810, 
-0.032840, -0.254580, 0.021050, -0.084650, -0.059500, 0.260060, 0.034830, 0.192900, 0.075510, -0.121720, 
-0.329540, -0.186350, -0.002710, -0.169850, 0.097050, 0.076900, 0.225850, 0.196460, 0.020580, 0.131290, 
0.230120, 0.142550, -0.154200, 0.065880, 0.102590, 0.205540, 0.194990, 0.173010, 0.103590, 0.442950, 
-0.087240, -0.249350, -0.020080, 0.444670, -0.212200, 0.076440, 0.041730, 0.183170, 0.246740, 0.325990, 
0.305100, 0.105950, 0.107160, 0.006560, 0.230190, 0.026160, 0.123690, 0.257110, -0.227420, -0.147630, 
0.305300, 0.106660, 0.134590, -0.076230, 0.156770, -0.255560, 0.093820, -0.021470, -0.107890, 0.804360, 
0.747830, 0.143270, 0.266080, 0.300390, 0.485660, 0.832150, -0.181310, 0.200070, 0.505780, 0.155340, 
0.166640, 0.485640, -0.214550, 0.036090, -0.118920, 0.430040, -0.025820, 0.083560, -0.431550, -0.498470, 
0.436680, 0.446520, -0.308770, -0.495460, -0.527730, 0.785580, -0.117220, -0.291590, -0.034780, -0.008340, 
-0.241440, -0.096510, 1.328760, -0.182420, -0.066750, -0.106950, -0.303000, -0.424350, -0.002420, -0.469780, 
0.053960, 0.207980, 0.654200, -0.315350, -0.059340, -0.216370, 0.286560, 0.305690, -0.175560, -0.123580, 
0.144780, -0.200860, -0.231270, 1.295400, 0.077450, 0.176240, -0.188950, -0.176010, -0.233650, 0.058540, 
-0.475250, -0.267650, -0.168100, 0.021880, 0.091550, -0.525720, -0.358460, -0.319640, -0.053520, 0.223470, 
0.168270, -0.000410, 0.136840, 0.200720, 0.939390, -0.005090, 0.244040, -0.115570, 0.050390, 0.014770, 
0.054850, -0.624380, 0.102870, -0.263380, 0.078170, 0.000340, 0.010980, -0.144680, -0.700650, -0.100240, 
0.033710, -0.050760, 0.051830, 0.080560, -0.129880, 0.946680, -0.019610, -0.080050, -0.191350, 0.028270, 
0.223270, 0.057230, -0.143310, 0.037550, -0.148450, 0.295730, -0.246700, -0.084820, 0.255630, -0.038520, 
0.319200, -0.246680, -0.260980, -0.062370, -0.116480, -0.199470, 0.327230, -0.119250, -0.065370, -0.079650, 
-0.318900, -0.166890, 0.064780, 0.156950, -0.291980, -0.231800, -0.060050, 0.329650, 0.117790, -0.120830, 
-0.244370, -0.167230, 0.191010, 0.083980, -0.140820, 0.098540, -0.303510, -0.072390, -0.034580, -0.116100, 
-0.500930, -0.183700, 0.033600, 0.073740, 0.076720, -0.459740, -0.173200, 0.216440, 0.318250, 0.098630, 
0.121360, -0.105690, -0.134360, 0.216160, 0.091300, -0.244410, -0.086610, 0.124330, -0.332180, 0.068120, 
0.128120, 0.102100, -0.205960, 0.031090, 0.078170, 0.359230, 0.043430, -0.181270, 0.015100, 0.144570, 
0.137490, 0.279340, -0.399120, -0.230250, 0.058480, -0.022190, -0.095650, -0.161760, -0.114010, 0.109700, 
-0.039180, -0.112510, -0.178340, -0.087670, 0.032580, 0.061830, 0.214500, 0.105850, 0.163020, 0.352620, 
0.329950, 0.140310, 0.122520, -0.281640, 0.293710, -0.157480, -0.055090, 0.056720, -0.142840, 0.419680, 
-0.307960, -0.044710, -0.315330, -0.173430, 0.393130, -0.067060, 0.075160, 
0.001940, 0.024750, 0.204780, -0.087390, 0.237360, 0.208630, 0.178250, 0.038970, 0.088310, 0.237580, 
0.261630, 0.538910, -0.085660, 0.105190, 0.107160, 0.071150, 0.398300, 0.434300, 0.235510, 0.228480, 
-0.066330, 0.009580, 0.180470, -0.274090, 0.053920, 0.414290, -0.184390, 0.074340, 0.313100, 0.064080, 
0.063680, 0.257950, 0.136010, 0.085630, -0.075580, 0.238480, -0.106760, -0.099350, -0.092140, -0.191620, 
-0.009350, -0.087880, -0.190480, 0.093770, 0.178330, 0.264470, 0.037720, -0.275620, -0.331020, 0.840010, 
0.170820, -0.196810, -0.277850, -0.032270, -0.260520, -0.139610, 0.800960, 0.228890, 0.080870, 0.124830, 
0.103020, -0.561620, -0.125110, 0.200070, -0.191640, -0.322580, -0.192210, 0.622820, 0.146420, -0.154670, 
0.739380, -0.050320, 0.212530, -0.065230, -0.128310, -0.009070, 0.012160, -0.564780, -0.003490, 0.162290, 
-0.002370, -0.080300, 0.594010, -0.135030, -0.344410, 0.644150, 0.033450, -0.242200, 0.033230, 0.158410, 
0.064280, -0.034740, 0.459320, 0.074650, -0.297830, 0.601890, -0.084730, 0.045490, 0.219320, 0.284080, 
0.404000, 0.137970, 0.521200, 0.378480, -0.138240, -0.074230, -0.516850, -0.647620, -0.645620, 0.942740, 
-0.191640, -0.354840, -0.222560, -0.002700, 0.541700, -0.055320, -0.179600, -0.065200, 0.183960, -0.345240, 
-0.368620, 0.334030, 0.403470, 0.260420, 1.206810, -0.114060, -0.187810, 0.213140, 0.085540, -0.103760, 
-0.256630, 0.452010, 0.561070, -0.187200, 0.410490, 0.299860, -0.065170, 0.204430, -0.001340, 0.096910, 
-0.487650, 0.485560, 0.120540, 0.218230, 0.087290, 0.415550, -0.079880, -0.071220, -0.189920, -0.651730, 
-0.116050, -0.004980, -0.283370, -0.145270, 0.676140, -0.075640, 0.570790, -0.088680, -0.422660, -0.234090, 
0.477240, -0.302060, 0.030070, 0.044540, 0.272090, -0.158670, 0.693680, -0.056580, -0.408410, 0.233650, 
-0.406480, -0.019890, -0.210830, 0.524620, 0.887270, -0.550230, 0.143380, 0.935330, -0.218860, 0.409200, 
0.178590, 0.630770, -0.126090, -0.013720, 0.244950, -0.129050, 0.206790, 0.946550, 0.006180, -0.137510, 
0.144130, -0.192490, -0.170110, -0.111910, -0.241830, -0.053070, 0.361230, 0.166450, 0.261310, -0.097980, 
-0.109930, -0.193810, 0.088590, 0.216510, -0.079610, -0.132310, 0.149050, 0.225150, 0.448850, -0.058140, 
-0.321690, -0.177670, -0.133440, 0.199500, 0.117880, 0.048080, -0.019140, -0.022700, 0.154500, 0.448510, 
0.059010, -0.188070, 0.258360, 0.400970, 0.020500, 0.206550, 0.228290, 0.260200, 0.249340, 0.554230, 
-0.070450, -0.403840, 0.054190, 0.158440, 0.396890, -0.180410, -0.141630, 0.002710, 0.094640, 0.312460, 
0.261500, -0.146810, 0.189020, 0.029460, 0.127670, 0.099220, 0.340860, 0.030620, 0.309800, -0.159380, 
0.082490, -0.050760, -0.040130, -0.031450, 0.000690, 0.295790, 0.311980, -0.191420, 0.093510, 0.494390, 
-0.176450, -0.045800, -0.233490, -0.071270, 0.149010, 0.168070, 0.004460, 0.365090, 0.298070, 0.171520, 
-0.032340, 0.390030, -0.058620, -0.298040, 0.017970, 0.331400, 0.089180, 0.192700, 0.224920, 0.051700, 
0.145990, 0.007720, 0.007100, -0.270770, 0.039230, -0.085690, 0.095820, -0.174610, 0.278220, 0.234570, 
0.198380, 0.026790, 0.127800, -0.076780, -0.035320, 0.038860, 0.117450, 0.167870, 0.335710, -0.073740, 
0.068050, 0.314010, 0.045000, 0.162410, -0.028180, -0.044250, 0.087840, -0.158890, -0.014850, 0.213750, 
0.308560, 0.134980, -0.026360, 0.199630, -0.087360, 0.158900, 0.186620, -0.208980, -0.118610, -0.036180, 
-0.117360, 0.099040, 0.113510, -0.043250, 0.038420, -0.041560, 0.110710, 0.045860, -0.116190, -0.043540, 
0.069760, 0.231680, 0.189630, 0.055970, 0.101550, -0.078860, 0.120220, 0.112140, 0.038550, -0.282330, 
0.137260, 0.130940, 0.208400, 0.374530, 0.252020, -0.042470, -0.270960, 0.047520, -0.284060, -0.134820, 
-0.103340, 0.079530, 0.438060, -0.053990, -0.015620, -0.052620, -0.095100, 
-0.057800, 0.003110, 0.197960, -0.045440, 0.301480, 0.183430, 0.024400, 0.194660, -0.035440, 0.024220, 
0.147670, 0.100840, 0.180410, 0.104300, -0.088810, 0.150310, 0.094060, 0.166180, 0.063650, -0.094960, 
-0.011450, -0.093650, -0.187500, 0.071310, 0.063070, 0.093330, 0.212050, -0.065240, 0.235200, 0.176770, 
0.023940, -0.022670, 0.078840, 0.055290, 0.148060, 0.120480, 0.068340, 0.007510, -0.029680, 0.127570, 
0.111710, -0.034650, -0.225320, -0.236280, 0.245570, 0.017970, 0.164310, 0.079010, 0.003320, -0.250600, 
0.052100, 0.227260, 0.099000, 0.050900, 0.126300, -0.100890, 0.084420, 0.057570, 0.202750, -0.250270, 
-0.168590, 0.167400, -0.021860, -0.202220, -0.099190, -0.362880, -0.250680, 0.137310, -0.220360, -0.240080, 
-0.038600, -0.117530, 0.117730, -0.041500, -0.090150, -0.003750, 0.249850, 0.032430, -0.178490, -0.034280, 
-0.054690, 0.224380, 0.180950, -0.026040, -0.296590, -0.153690, 0.074870, -0.136820, 0.251880, 0.035120, 
-0.035260, 0.268470, -0.055880, 0.107730, 0.246440, 0.092620, 0.163480, 0.025440, -0.004380, 0.083600, 
0.100260, 0.061230, -0.025730, 0.260450, -0.037840, -0.232990, -0.003640, -0.101630, -0.022780, -0.127600, 
-0.030220, -0.002570, 0.174600, 0.098840, 0.033800, -0.105060, -0.012730, -0.068880, -0.028920, -0.126840, 
-0.062840, 0.274940, 0.064450, 0.144720, 0.152670, -0.022520, -0.055540, -0.095830, -0.098290, -0.181910, 
0.299480, -0.031560, -0.098720, -0.009690, 0.167890, 0.159890, -0.021220, -0.111500, 0.187540, 0.323480, 
0.041670, -0.184330, -0.085910, 0.007720, -0.002940, 0.208230, 0.002860, -0.337130, -0.050240, -0.149660, 
-0.039750, -0.122990, -0.056890, 0.259010, 0.016860, -0.238920, -0.033720, -0.372630, 0.048840, -0.181060, 
0.136100, 0.034160, 0.134160, 0.165590, 0.072520, 0.002620, 0.124450, -0.004490, -0.026320, -0.163830, 
-0.375200, -0.375060, 0.327630, -0.076630, -0.201260, -0.252960, -0.180200, 0.529960, 0.029390, -0.187550, 
0.162190, 0.112220, -0.360430, -0.378840, 0.060620, -0.051740, -0.040740, 0.990010, -0.009080, -0.482890, 
0.316630, 0.177840, 0.402390, 0.075010, 0.199140, 0.518160, -0.536210, -0.072070, 0.115000, -0.093020, 
0.414510, -0.060630, -0.103600, 0.300040, 0.426450, 0.478230, 0.058430, 0.167530, 0.141320, 0.012070, 
-0.076320, -0.302980, -0.224960, -0.089030, 0.119870, -0.194800, -0.241010, 0.135160, -0.159620, 0.272840, 
0.235440, 0.030220, 0.073570, 0.043350, 0.019240, -0.192340, -0.066590, 0.117580, -0.289130, 0.287970, 
0.039820, -0.260780, 0.199310, 0.324160, 0.287770, -0.232310, 0.033670, 0.088180, 0.487400, 0.154820, 
-0.102370, -0.245820, 0.180890, -0.217390, -0.108040, 0.327190, 0.296850, 0.164860, 0.248870, -0.020100, 
-0.021750, 0.035470, -0.078310, 0.117190, -0.099690, 0.263610, 0.013640, -0.046390, 0.114190, 0.414340, 
-0.085890, -0.005750, -0.138870, 0.061440, 0.065340, -0.075060, -0.081450, 0.123000, -0.128780, 0.288550, 
0.006520, 0.182070, 0.053460, -0.071050, 0.179690, 0.099320, -0.092510, 0.175420, 0.018360, 0.161950, 
0.577260, -0.089930, -0.172180, -0.055040, 0.108250, 0.047100, -0.198370, -0.134790, 0.131310, 0.102170, 
0.397770, -0.111180, -0.102580, 0.050000, -0.045360, 0.145530, -0.090010, -0.206820, 0.031010, 0.087430, 
0.287580, 0.096250, 0.129550, 0.176040, -0.040350, 0.229310, 0.090200, 0.095450, 0.045930, -0.044850, 
-0.039530, -0.141020, -0.080720, 0.169260, 0.026640, 0.092020, 0.304610, -0.074740, 0.039570, 0.126080, 
0.022110, 0.209420, 0.200780, 0.024000, 0.111410, -0.087150, 0.201800, 0.284380, -0.114250, 0.042330, 
0.096010, 0.138880, -0.112140, -0.201910, 0.097900, 0.045200, 0.182710, 0.187650, -0.066470, -0.072880, 
0.229990, 0.094200, -0.027380, 0.031150, 0.096990, 0.023620, 0.184650, 0.217290, 0.173290, 0.159340, 
-0.055040, -0.046020, -0.058210, 0.111080, 0.188800, 0.170860, 0.036350, 
0.024300, 0.013970, -0.069160, -0.190780, 0.100590, 0.029550, 0.081840, 0.017980, -0.099110, -0.005660, 
-0.078460, -0.144100, 0.010330, 0.030270, 0.075700, 0.111800, -0.110950, 0.101800, -0.019050, 0.001090, 
0.027710, 0.112940, 0.027900, 0.139590, 0.071400, -0.197940, -0.017890, 0.196490, -0.025280, 0.090210, 
0.034730, 0.085500, -0.061760, 0.209380, 0.030620, 0.113950, 0.060620, -0.060290, 0.026310, 0.175630, 
0.041170, 0.042270, 0.093030, -0.171160, -0.114790, -0.188330, -0.118790, 0.037250, 0.043420, -0.130530, 
0.078680, 0.300310, 0.291650, 0.006530, 0.200060, 0.026100, -0.190080, -0.007920, -0.022340, 0.194620, 
0.183640, 0.353560, 0.045310, -0.101470, -0.014800, 0.144590, 0.033940, 0.118440, -0.017710, 0.038090, 
0.063070, 0.098270, 0.030270, 0.015080, -0.070000, 0.045570, 0.026270, 0.000320, -0.130120, -0.193750, 
0.176650, 0.122100, -0.064300, 0.044340, -0.061300, 0.206900, 0.270640, 0.120330, -0.080010, 0.040820, 
0.017450, 0.226650, 0.054380, -0.164200, 0.028400, 0.196850, 0.017740, 0.033720, 0.305480, -0.054700, 
-0.074530, 0.276470, 0.069380, -0.293240, 0.043060, 0.033600, 0.144390, 0.377220, 0.321100, -0.106750, 
0.160270, 0.203340, 0.475700, 0.119660, -0.205760, -0.050420, 0.059830, -0.113750, 0.012380, 0.041240, 
0.113620, 0.093430, 0.060470, 0.116860, -0.275090, 0.046360, 0.021370, 0.130050, 0.300580, 0.183290, 
-0.194850, 0.218020, 0.129990, -0.029890, 0.357760, -0.190610, -0.053780, 0.370490, 0.129660, 0.062770, 
0.307860, -0.003170, 0.084570, 0.147070, 0.101240, -0.255640, 0.055840, -0.194750, 0.160560, 0.211110, 
-0.198890, 0.156860, -0.078360, -0.277950, 0.562890, 0.003980, -0.033910, 0.115480, 0.054840, 0.095260, 
0.116130, 0.126450, 0.045470, 0.009390, 0.135080, 0.125790, -0.047170, 0.050320, -0.270070, -0.235810, 
-0.048930, -0.225540, -0.059180, -0.205160, -0.247240, -0.022880, -0.102750, 0.163900, 0.433020, -0.051030, 
0.119230, 0.138820, 0.102980, -0.095330, 0.037300, 0.054670, 0.035960, 0.029800, -0.000070, -0.250900, 
0.012850, 0.235270, 0.346890, -0.013150, 0.012180, -0.058550, 0.042560, 0.117230, 0.023270, 0.180120, 
0.045950, -0.039270, 0.098270, 0.193600, 0.182940, 0.321320, 0.010270, 0.077840, -0.009370, 0.034650, 
-0.176490, 0.115590, -0.144270, 0.036490, -0.054590, -0.109970, -0.105070, 0.040620, 0.047750, 0.025100, 
0.207840, 0.082230, 0.005050, -0.058750, 0.450870, -0.046390, -0.039990, 0.086140, -0.036910, -0.018330, 
0.051120, 0.154920, 0.105350, 0.102200, 0.105720, -0.022280, -0.099190, 0.189750, 0.367630, -0.208720, 
-0.033880, 0.053160, 0.109530, -0.262130, 0.006350, 0.051380, 0.028930, -0.065200, -0.279380, -0.222570, 
-0.013610, 0.045560, -0.056920, 0.137690, 0.153370, 0.233730, -0.194400, 0.125050, 0.162120, 0.130140, 
0.023210, -0.213890, -0.100900, 0.066680, -0.158610, -0.203450, -0.141810, 0.146850, 0.155500, -0.003270, 
0.021660, -0.156020, 0.051100, -0.040300, -0.183390, -0.000100, -0.052170, 0.108220, -0.023090, -0.178560, 
-0.078890, -0.062560, 0.186590, 0.251840, -0.206420, -0.050700, 0.139220, -0.104500, -0.190410, -0.203680, 
-0.019190, 0.201350, 0.149580, 0.055010, 0.093940, -0.014790, -0.191900, -0.231150, 0.149250, -0.026100, 
-0.051430, -0.225310, 0.062740, 0.230650, 0.247840, 0.081240, 0.082770, 0.150270, 0.257810, -0.008080, 
-0.023090, -0.033480, 0.083050, 0.170960, 0.053830, -0.063130, -0.009380, 0.012040, 0.123920, 0.104500, 
0.173500, 0.135540, -0.219770, 0.021630, 0.063030, 0.079430, 0.050660, 0.012860, -0.027100, -0.071440, 
-0.014190, -0.022380, -0.194500, 0.129860, 0.148830, 0.045290, -0.074420, -0.122970, 0.214510, 0.075030, 
-0.178980, -0.042690, -0.088300, -0.064120, 0.009920, 0.419720, 0.245420, -0.145670, 0.106720, 0.022070, 
-0.075810, 0.005250, 0.163590, -0.056950, 0.039950, 0.315040, 0.055320, 
-0.119640, 0.060470, 0.107790, -0.097720, -0.232070, -0.315000, 0.025010, 0.084640, -0.065370, 0.107810, 
-0.018580, 0.064560, -0.178460, 0.251660, 0.238650, 0.279860, 0.017420, 0.198180, 0.384250, 0.168880, 
-0.026240, 0.243860, 0.032610, -0.055170, 0.145930, 0.673990, -0.173910, 0.019080, 0.271880, -0.089490, 
0.077910, 0.228990, -0.167070, -0.062870, -0.051550, -0.171850, 0.325300, 0.249020, 0.342340, -0.120310, 
0.312340, -0.063760, 0.094540, 0.165180, 0.293980, 0.206100, -0.346200, 0.136210, 0.477220, 0.456920, 
0.035980, -0.106120, -0.071830, 0.273300, 0.031570, 0.227380, 0.001800, 0.537410, 0.265500, -0.301650, 
-0.048700, 0.145110, -0.060220, -0.200170, 0.031620, 0.036880, 0.037270, -0.079510, -0.124460, 0.012890, 
0.365590, -0.162710, 0.193070, 0.248830, 0.223810, -0.253810, -0.309650, 0.012930, 0.255270, 0.192170, 
-0.068280, -0.206920, -0.077980, -0.053450, -0.273540, 0.369830, 0.335040, 0.226150, -0.007170, 0.012430, 
0.208750, 0.947860, 0.229660, 0.201060, 0.179360, 0.295380, -0.199890, 0.131190, -0.506120, 0.300010, 
0.356950, 0.447280, 0.106150, 0.032650, -0.049710, -0.304190, -0.066040, 0.385450, 0.073080, -0.147170, 
0.228290, 0.026140, 1.025480, 0.210110, -0.199140, -0.337600, 0.382460, -0.272820, -0.237450, 0.583070, 
0.118640, 0.416960, -0.098220, -0.131840, 0.265560, -0.067910, -0.247890, 0.510950, 0.280590, 0.044770, 
-0.193310, -0.086100, -0.073200, 0.871880, -0.108340, -0.189290, -0.596670, -0.080880, -0.004360, -0.403100, 
0.075520, 0.267720, 0.553190, -0.474950, -0.305780, 0.354230, -0.061370, -0.552110, -0.029650, 0.136080, 
-0.301420, -0.262330, 0.149590, -0.026110, 0.189260, 0.486560, -0.372550, -0.498470, 0.174790, -0.084970, 
-0.054410, -0.118820, 0.152890, 0.662370, -0.219110, 0.029870, 0.219090, -0.062050, -0.281180, 0.395930, 
-0.234900, -0.528630, 0.335180, -0.371870, -0.047230, 0.172330, 0.011720, 0.168980, -0.473330, 0.055190, 
-0.248030, 0.178130, -0.292230, 0.103010, 0.537340, 0.579380, 0.228810, 0.649880, -0.007590, -0.133110, 
-0.121430, -0.436770, -0.489750, 0.324560, -0.021550, 0.242130, -0.584880, -0.056770, 0.674220, 0.154380, 
-0.275500, 0.328880, 0.223160, -0.802150, 0.135260, 0.333700, -0.085150, 0.360590, 0.851300, -0.042410, 
-0.360850, 0.201450, -0.168760, -0.609370, 0.063900, -0.005110, 0.180610, -0.209630, 0.097620, 0.396260, 
-0.348310, 0.034410, 0.020270, -0.029400, -0.242350, -0.002170, 0.130400, 0.440870, 0.461930, 0.696450, 
-0.037530, -0.362550, 0.149450, -0.193040, -0.405760, 0.201390, -0.184710, 0.031410, 0.042530, -0.298930, 
0.277510, -0.204680, -0.139810, -0.006510, -0.011160, 0.025230, 0.176020, 0.112580, 0.384630, -0.062480, 
0.751710, -0.007170, -0.424700, -0.045310, -0.288930, -0.013360, 0.048710, -0.181350, -0.150280, 0.154690, 
-0.252670, -0.004110, -0.456740, -0.545880, 0.011060, -0.014280, 0.110900, -0.071250, -0.014090, 0.019150, 
0.114600, 0.436190, -0.001970, -0.597790, 0.436030, -0.027540, 0.332550, 0.112870, -0.026010, 0.397110, 
-0.089140, 0.357300, -0.079470, -0.385980, 0.206680, -0.190980, 0.000110, 0.411720, 0.405150, 0.203100, 
-0.123080, -0.071410, -0.134530, -0.008820, -0.462160, -0.549770, -0.192150, 0.294610, 0.601280, -0.406780, 
0.042930, 0.187010, -0.252480, 0.050500, -0.114900, -0.537420, -0.298940, -0.043270, -0.188880, 0.151990, 
0.246320, 0.188070, -0.125900, 0.419580, -0.017760, -0.388630, 0.322520, 0.437730, 0.391560, 0.034490, 
-0.045130, 0.370190, 0.359080, 0.191200, -0.067500, -0.375020, 0.401520, -0.099820, -0.211120, -0.084880, 
0.350680, 0.254600, -0.142550, -0.108740, -0.048040, -0.033170, -0.384030, -0.107450, 0.198140, 0.302920, 
0.171110, -0.479750, 0.123360, 0.444610, -0.308510, 0.268330, 0.161240, 0.293330, -0.015340, 0.499420, 
-0.050730, 0.147600, 0.265340, -0.111770, 0.043900, 0.334200, -0.042180, 
-0.014330, -0.135350, 0.171250, 0.367430, 0.103940, -0.174090, -0.025860, 0.482270, -0.090300, 0.301540, 
0.255910, 0.024070, -0.168410, -0.241300, -0.004680, -0.018670, 0.080850, -0.290390, -0.461290, 0.239200, 
-0.025560, -0.087940, -0.020580, 0.177080, 0.062600, 0.289400, -0.023760, 0.075270, 0.252270, 0.399940, 
-0.050210, 0.314960, -0.085240, 0.027750, -0.037050, -0.005220, 0.199560, 0.105750, -0.113980, 0.053050, 
0.025200, -0.046440, -0.456830, 0.260720, 0.270080, 0.164920, 0.413260, 0.280510, -0.016920, 0.446370, 
0.172110, -0.144730, 0.038800, 0.214800, -0.026110, 0.050810, 0.113090, 0.058260, 0.027250, 0.074890, 
0.262940, -0.208070, -0.045240, -0.322780, -0.219640, -0.038920, 0.014540, 0.338650, 0.063410, -0.073860, 
0.725870, 0.122010, 0.074870, 0.090640, 0.090990, -0.172660, -0.030770, 0.073210, -0.023920, 0.086460, 
0.041180, -0.158790, 0.034050, -0.061890, -0.565130, 0.016750, 0.024080, 0.249360, 0.421210, 0.176060, 
-0.147320, 0.038500, 0.119950, 0.252260, -0.279990, -0.118810, 0.080950, 0.016960, -0.227250, 0.239830, 
0.249780, 0.001880, 0.048040, 0.362230, -0.054460, -0.419910, -0.083340, -0.211950, -0.287570, 0.128160, 
-0.139500, -0.312440, 0.491920, 0.045690, 0.158180, -0.251600, 0.120240, 0.079200, 0.009050, -0.421880, 
-0.188990, 0.087250, 0.164890, 0.349610, 0.426020, -0.043620, -0.299290, 0.182490, -0.384200, -0.436380, 
0.060030, 0.179250, 0.052030, -0.592320, 0.167330, 0.435230, 0.151510, -0.005560, 0.231610, 0.189030, 
-0.041280, -0.124350, 0.324350, 0.177110, 0.162050, 0.782370, -0.033950, -0.164660, -0.182760, -0.554050, 
-0.222090, -0.046270, 0.067970, 0.468290, -0.392370, -0.003230, 0.909400, -0.158000, -0.123090, -0.147640, 
0.358470, -0.432260, -0.044960, 0.098950, 0.440110, 0.242800, 1.297660, -0.022870, -0.778130, 0.350480, 
-0.054570, 0.436320, -0.311870, 0.398120, 0.284260, -0.668370, 0.149220, 0.329180, -0.174480, 0.209580, 
-0.012600, -0.012520, 0.051600, 0.133470, 0.031950, -0.351940, 0.018040, 0.597980, 0.006660, -0.432320, 
-0.016150, 0.080890, -0.236110, 0.059500, -0.152660, -0.216460, -0.075110, 0.026280, 0.190220, -0.049320, 
-0.204270, -0.098080, -0.182900, -0.047740, 0.151350, 0.057960, -0.273440, -0.412420, 0.379930, -0.039990, 
-0.256310, -0.031360, 0.181600, 0.293500, -0.173040, -0.062830, 0.065860, 0.839310, 0.278150, -0.351220, 
-0.314730, -0.046870, -0.140550, 0.025550, 0.208790, 0.226950, 0.005670, 0.249000, -0.124280, -0.050500, 
-0.036290, -0.003540, 0.157860, -0.045120, 0.308440, 0.179100, 0.100250, -0.297390, 0.599440, 0.042150, 
0.082270, -0.059750, -0.127670, 0.186550, -0.012060, 0.130760, 0.426720, 0.325900, 0.103870, 0.083480, 
0.133160, -0.014870, -0.223960, -0.322290, 0.109570, -0.039820, 0.220380, -0.212850, -0.276560, 0.596160, 
0.503660, -0.067580, -0.035490, -0.227900, -0.008190, 0.242530, -0.189490, 0.354630, 0.088980, 0.363030, 
-0.228940, -0.203650, 0.006630, -0.069200, -0.042270, -0.122700, -0.023960, 0.029200, 0.165770, 0.154640, 
0.493610, 0.194730, 0.131480, 0.138100, -0.188220, 0.148270, 0.376580, -0.400820, -0.002880, 0.302690, 
0.145880, 0.282590, 0.270810, -0.005340, 0.264430, 0.222390, 0.312830, -0.023790, -0.160140, 0.023470, 
0.013880, 0.837460, -0.324180, 0.164740, 0.043820, 0.042390, -0.119020, 0.128420, -0.400880, 0.338560, 
0.299210, -0.001370, 0.130420, 0.144650, -0.009730, -0.171800, 0.162150, -0.259850, -0.272370, 0.060180, 
0.184170, -0.041100, 0.287060, -0.018790, -0.107670, 0.220260, 0.133660, 0.196000, 0.144170, -0.111480, 
0.031180, 0.130840, -0.123720, 0.246010, 0.140880, -0.019300, -0.276500, 0.230060, 0.027330, -0.054680, 
-0.263420, 0.187780, -0.042040, -0.000270, 0.216520, 0.229810, 0.084790, -0.088990, 0.171270, 0.420480, 
-0.108020, 0.155820, -0.106880, 0.027690, 0.212240, 0.191460, -0.041300, 
0.106860, -0.278560, 0.176540, -0.019440, -0.024370, -0.148870, 0.171990, 0.343830, -0.212180, 0.064080, 
-0.096880, -0.062630, -0.020360, -0.236260, -0.237570, 0.126250, 0.034070, 0.121470, -0.033860, -0.062600, 
-0.111510, 0.012210, -0.325650, -0.150270, -0.001370, 0.039900, -0.265950, -0.063410, -0.135700, 0.169180, 
0.287410, 0.200500, -0.440830, 0.538650, 0.083350, -0.024870, -0.022150, -0.116500, 0.020650, 0.066730, 
0.203200, -0.112670, -0.014050, -0.142520, -0.107460, -0.011540, 0.379690, -0.021420, -0.276740, 0.123950, 
-0.164670, 0.171640, 0.274370, -0.262550, 0.362010, 0.136010, -0.205880, 0.292350, 0.150100, 0.343590, 
-0.109160, 0.067840, -0.114750, 0.198500, 0.054740, -0.046510, -0.052400, -0.094510, -0.146500, -0.024270, 
-0.045740, -0.056460, 0.066000, 0.136880, -0.206680, 0.075270, -0.010250, -0.161650, -0.041000, 0.057480, 
0.098170, -0.099350, 0.038240, -0.104200, 0.455070, 0.013650, -0.201580, -0.172780, -0.130760, -0.042620, 
0.019790, -0.123930, -0.048930, 0.273500, 0.265100, -0.081800, 0.258680, -0.044560, 0.104560, 0.091510, 
0.044890, 0.402090, -0.024440, 0.057970, -0.097910, 0.164370, -0.026040, -0.206060, -0.249450, 0.244990, 
0.023730, -0.189020, -0.194160, -0.284060, 0.323780, 0.444230, -0.113360, 0.236300, 0.144400, -0.488180, 
-0.002090, 0.195100, 0.022630, 0.126500, 0.183140, -0.083210, 0.449760, 0.141930, 0.071540, -0.196030, 
-0.058060, 0.017240, -0.121330, 0.124040, -0.338210, 0.160920, 0.182080, -0.233660, 0.278560, -0.020960, 
-0.467960, -0.037450, 0.188710, 0.263780, -0.214420, 0.117380, -0.063060, 0.318620, 0.298110, -0.303440, 
-0.389300, -0.162970, 0.026500, 0.024240, -0.356410, -0.396880, 0.464030, 0.532000, -0.118840, 0.250810, 
0.232860, -0.356990, -0.172230, 0.059330, 0.570430, 0.103170, 0.344910, -0.029620, 0.325250, -0.151880, 
-0.201380, -0.067920, 0.114280, 0.034530, 0.072050, -0.333480, -0.065600, 0.594410, 0.736920, -0.142950, 
0.150650, 0.681440, -0.496940, -0.082390, 0.008300, 0.800500, 0.497740, 0.426120, -0.009440, 0.487780, 
-0.003650, 0.032090, -0.238770, 0.136140, 0.014050, 0.160990, -0.197210, 0.280930, 0.052630, 0.578660, 
-0.078650, 0.229180, 0.070210, -0.415830, -0.022790, -0.007330, 0.404830, 0.139100, -0.088240, -0.062780, 
0.493300, -0.215960, -0.239090, -0.338920, -0.250690, -0.111640, 0.002580, -0.031070, 0.013110, 0.029520, 
0.219360, -0.159490, 0.031760, 0.047390, -0.492670, -0.244230, -0.262270, 0.163100, 0.110890, -0.030090, 
-0.082710, 0.284460, -0.119790, -0.321820, -0.050270, 0.307920, 0.036790, 0.145820, -0.173400, -0.109250, 
0.088070, 0.363030, 0.079200, 0.360220, 0.225660, -0.325340, -0.158870, -0.168740, 0.399860, 0.186310, 
-0.086700, -0.111140, 0.223940, 0.065960, 0.439900, 0.073800, 0.008690, 0.401470, 0.178720, 0.127340, 
0.174340, 0.026080, 0.171790, 0.343970, 0.198010, 0.048470, -0.009380, -0.040750, -0.008450, 0.125140, 
0.075400, -0.251950, -0.135480, 0.319300, 0.190190, -0.050460, 0.004690, 0.131590, 0.249260, 0.110520, 
0.145630, 0.238980, -0.074480, -0.020800, 0.009800, 0.138650, -0.072710, 0.044880, 0.157790, -0.188500, 
0.257000, 0.090470, -0.018560, -0.129580, 0.213500, 0.030900, -0.296890, -0.270410, -0.102640, 0.113530, 
-0.086830, -0.055000, -0.092850, 0.116090, 0.175680, 0.043710, 0.104240, 0.149670, -0.087250, 0.032840, 
0.112320, 0.264530, 0.010360, 0.063770, -0.122780, -0.191380, 0.076790, 0.021860, -0.218430, 0.385850, 
-0.017830, -0.078100, -0.182170, 0.001710, 0.083100, 0.143500, 0.191280, 0.133390, 0.199070, 0.024460, 
-0.135880, -0.264050, 0.072140, 0.343600, -0.040830, -0.115230, -0.075400, 0.121110, 0.208140, 0.130620, 
0.130860, 0.150130, 0.168380, -0.055370, 0.183240, -0.132500, -0.024310, 0.099370, 0.154790, -0.137900, 
0.037430, -0.014080, -0.145440, 0.225460, 0.082100, -0.054880, -0.121280, 
-0.016600, 0.035200, 0.073650, -0.128140, 0.381480, 0.007230, 0.075800, 0.373570, 0.312180, -0.021690, 
0.011540, -0.034500, -0.189160, 0.286280, 0.344920, 0.141280, -0.221850, 0.114840, 0.093370, -0.067360, 
0.010200, 0.116750, -0.240070, 0.299900, 0.254490, 0.092770, 0.345740, 0.086900, 0.442630, -0.184950, 
0.174020, 0.344000, 0.254100, 0.063710, -0.058040, 0.226490, 0.166830, 0.411850, 0.113280, -0.282990, 
0.368680, -0.023590, -0.272120, 0.262360, -0.172140, -0.115040, -0.142250, 0.002740, 0.129590, 0.602390, 
0.003310, -0.121200, -0.122510, 0.412450, -0.348200, 0.087580, 0.118900, -0.173330, -0.277620, 0.090530, 
-0.080750, -0.026430, -0.046080, -0.283480, -0.165180, 0.436060, 0.118070, 0.214180, 0.165700, 0.283600, 
0.084020, 0.360030, 0.400640, 0.027460, -0.112340, 0.057380, -0.073450, -0.668090, 0.153290, 0.554760, 
0.195570, 0.194960, 0.373050, -0.025100, -0.465100, 0.184190, -0.010260, 0.352860, -0.196670, 0.173620, 
0.172960, 0.355880, 0.366170, -0.054510, -0.069790, 0.210000, 0.069820, 0.356820, 0.404330, 0.035440, 
-0.054830, 0.045920, 0.350940, -0.034000, -0.007380, -0.237670, 0.414450, 0.302150, 0.034150, -0.120750, 
0.536100, 0.373250, 0.218370, -0.204090, -0.168320, -0.219560, 0.611750, 0.290810, -0.002530, 0.304580, 
0.144220, 0.499390, 0.170320, -0.009080, 0.270590, -0.012430, -0.587560, 0.001660, 0.020490, -0.047380, 
-0.177820, -0.140090, -0.212550, 0.658440, 0.077840, -0.036950, -0.168830, -0.072190, 0.131380, 0.256870, 
-0.105600, 0.241750, 0.563920, 0.103300, -0.001320, 0.190600, -0.018140, -0.267790, 0.104390, -0.199310, 
-0.559120, 0.156420, 0.386300, -0.250290, 0.132060, 0.184750, 0.144680, -0.493690, -0.333320, 0.236990, 
0.351650, 0.095680, -0.379500, 0.123020, -0.071750, -0.026600, 0.726380, -0.010900, -0.512080, 0.352910, 
-0.263830, -0.174500, 0.366200, 0.188740, 0.344460, -0.499960, -0.280650, 0.089530, -0.365740, 0.476370, 
0.116820, 0.098360, 0.004290, 0.811290, 1.115310, 0.377760, 0.174360, 0.249930, -0.006560, 0.044110, 
-0.586840, -0.891820, -0.862290, 0.480250, -0.291340, -0.571230, 0.001090, -0.283710, 0.416780, -0.096760, 
-0.434360, 0.200680, 0.126600, -0.047100, -0.485340, -0.178930, 0.146010, 0.103680, 1.058260, -0.006780, 
-0.753710, 0.617450, 0.338980, 0.456670, -0.174370, -0.008210, 0.692750, -0.093520, 0.222180, -0.306290, 
-0.292350, 0.422930, -0.199690, -0.313870, -0.011200, 0.864480, 0.933580, 0.254010, -0.251450, -0.235900, 
0.012330, -0.494790, -0.315380, -0.316390, 0.073080, 0.321830, -0.268470, -0.149190, -0.133100, -0.529250, 
0.141960, 0.158420, -0.250150, 0.208170, -0.005170, 0.246720, -0.311590, -0.348990, 0.005060, -0.229580, 
0.245440, 0.024800, -0.449050, 0.090070, -0.123770, 0.237800, -0.237300, 0.239960, 0.264860, -0.066890, 
0.405330, -0.234470, -0.435600, 0.313270, -0.093120, 0.016030, 0.280660, 0.315940, 0.179250, -0.086560, 
0.118890, 0.062680, 0.022880, -0.177410, -0.063850, -0.392950, 0.221080, 0.026950, 0.344130, 0.208530, 
-0.066410, -0.075590, -0.074490, -0.227380, 0.210470, 0.165580, -0.137570, 0.202770, -0.290230, -0.490330, 
0.131200, -0.011040, 0.024150, 0.013880, -0.249690, -0.176130, -0.259670, 0.046940, -0.448080, 0.039080, 
-0.181300, 0.128780, 0.125580, -0.313080, 0.059690, 0.155530, -0.118680, 0.033940, 0.303040, -0.202350, 
0.013020, 0.231170, -0.032370, 0.068810, 0.004160, 0.246140, -0.188030, -0.434320, 0.106960, -0.078170, 
0.136350, 0.340690, 0.150280, 0.443470, 0.123850, -0.042180, 0.343820, 0.213770, -0.067190, 0.438340, 
0.327290, -0.019420, 0.107280, 0.568690, 0.079090, 0.020780, 0.067500, 0.236430, 0.262190, 0.193630, 
0.157770, 0.031150, 0.072200, 0.004240, 0.539560, -0.248160, 0.028960, 0.196730, 0.162590, 0.067360, 
-0.067630, 0.193180, -0.230140, -0.123120, -0.037620, -0.055640, 0.021030, 
-0.084430, 0.022910, 0.058740, -0.190210, -0.009680, -0.322310, 0.041970, -0.256160, 0.054350, 0.450580, 
0.120290, 0.089600, 0.129980, -0.072090, -0.250640, -0.030620, -0.050650, -0.219010, -0.200120, 0.214830, 
0.037460, 0.095020, 0.282000, 0.093760, 0.214390, -0.281620, 0.124350, 0.205260, -0.027630, 0.157620, 
-0.039000, -0.114810, 0.197110, 0.004470, -0.135160, 0.135550, 0.106400, -0.023040, -0.051250, -0.322220, 
0.069350, 0.022620, 0.289620, 0.144850, -0.196870, -0.317910, 0.077760, 0.033870, -0.058460, 0.000240, 
-0.150170, 0.056440, 0.036830, -0.041500, 0.003840, -0.021770, -0.285530, 0.158950, -0.005140, 0.681240, 
-0.211540, 0.030130, 0.026340, -0.126540, -0.080190, -0.554680, -0.386810, 0.014600, 0.065710, 0.034190, 
0.106620, -0.059470, -0.084780, -0.055010, -0.128020, -0.089190, -0.038050, -0.243100, -0.221150, -0.232190, 
-0.298360, -0.198330, 0.048240, 0.030980, -0.043840, 0.355800, 0.032400, -0.097120, -0.021440, 0.401180, 
0.337370, -0.145220, 0.072420, 0.035820, 0.005100, 0.375430, 0.450750, -0.055770, -0.470380, 0.025910, 
-0.405280, -0.382630, 0.046690, -0.043820, 0.022210, 0.242950, 0.061940, -0.066620, -0.016920, 0.418540, 
-0.094210, -0.018630, 0.087930, 0.217500, -0.289430, 0.053760, 0.074760, 0.028050, -0.048420, -0.100490, 
0.112360, -0.296700, -0.057490, 0.116850, -0.121570, 0.038370, -0.135000, 0.287940, 0.107610, -0.377480, 
0.138640, -0.067470, -0.008610, -0.529870, 0.024040, -0.098430, 0.238050, 0.333730, 0.166650, 0.156510, 
-0.192360, 0.134400, -0.008320, 0.072620, 0.165840, -0.291380, 0.029010, -0.256950, -0.060710, 0.453760, 
0.471830, -0.216860, 0.001730, 0.062120, 0.415500, -0.019920, -0.464070, -0.154470, 0.209210, -0.177010, 
-0.243970, 0.210610, -0.160550, -0.323150, -0.091470, -0.324250, -0.200150, 0.012400, -0.119070, -0.373270, 
0.051680, -0.307480, 0.572610, -0.257650, -0.304280, 0.035930, 0.038520, 0.095360, 0.332730, -0.157870, 
0.293690, 0.063630, -0.499470, -0.103550, -0.162470, -0.234540, 0.004930, -0.035040, -0.002880, 0.116130, 
0.066310, 0.113210, 0.182350, 0.214770, 0.051810, -0.087300, 0.505580, 0.005270, -0.018560, 0.073200, 
0.037940, 0.209650, -0.164200, 1.107200, 0.310130, 0.467340, 0.182520, -0.035630, 0.201650, 0.129000, 
-0.327230, 0.075310, 0.263520, -0.048870, 0.477780, 0.334580, 0.084420, 0.215990, -0.012340, 0.033470, 
0.184710, 0.093890, 0.295590, 0.382830, 0.092170, -0.103360, 0.005580, 0.199780, -0.014830, 0.180810, 
0.169180, -0.211340, -0.000830, 0.019690, 0.090240, 0.486340, -0.089050, 0.040100, 0.280980, -0.164960, 
0.112930, 0.173180, -0.260830, 0.037910, 0.286100, 0.228540, 0.007040, 0.094510, 0.103510, -0.048160, 
0.053290, 0.167770, -0.048810, 0.136910, -0.057130, 0.381180, 0.094110, 0.190980, 0.237490, 0.138430, 
0.067030, -0.067880, 0.340050, 0.160380, 0.239110, 0.168820, 0.274820, -0.090690, 0.207400, 0.024110, 
0.188400, -0.012550, 0.177640, -0.069220, 0.066540, 0.032420, 0.337780, 0.451490, -0.033640, 0.207150, 
-0.280220, 0.149330, -0.006980, -0.017730, -0.090380, 0.185440, 0.007770, 0.242390, 0.304330, 0.285330, 
0.120320, -0.047750, -0.132390, 0.155270, 0.134060, -0.076080, -0.313300, 0.172890, 0.125340, 0.027250, 
0.223790, 0.188720, 0.218320, 0.289880, 0.124550, -0.106850, -0.088040, 0.028460, 0.356830, -0.024260, 
0.032130, 0.074360, -0.000980, 0.092310, 0.136620, -0.060550, 0.057950, -0.010770, 0.211300, 0.227380, 
0.067050, 0.129490, 0.047170, 0.056070, 0.136160, 0.071740, 0.013250, 0.032390, 0.002140, 0.410270, 
-0.101060, -0.226400, 0.291090, -0.140410, 0.184010, 0.150140, 0.104610, 0.184810, 0.220510, 0.134500, 
-0.038620, -0.028170, -0.050100, 0.074210, 0.288710, 0.271560, 0.229310, 0.015310, 0.147220, 0.154680, 
0.412840, -0.060320, 0.055830, 0.127870, 0.036100, 0.025520, 0.159950, 
0.298010, 0.122110, -0.337810, 0.122790, -0.090500, 0.098490, 0.206760, 0.062900, -0.095710, -0.056750, 
-0.048230, 0.152070, 0.224680, -0.177480, -0.201310, -0.052600, -0.175360, 0.174800, 0.116680, 0.129440, 
0.022140, 0.170560, -0.072910, 0.098830, 0.159390, 0.165500, -0.251070, 0.010840, 0.092680, -0.240240, 
0.088370, -0.155420, -0.125600, -0.027510, -0.203040, -0.145720, 0.010580, 0.165220, 0.237200, -0.226390, 
0.210540, 0.023370, 0.181180, 0.090900, 0.134840, 0.285790, -0.079850, 0.042360, 0.080440, 0.173030, 
-0.069890, -0.048900, -0.265570, 0.213630, 0.031680, 0.108080, 0.380000, 0.295880, 0.285180, 0.050020, 
0.310990, -0.093340, -0.006510, 0.087790, 0.148470, 0.143460, 0.308610, -0.020940, 0.137890, 0.267920, 
0.221270, 0.191400, 0.150070, -0.066620, 0.355690, -0.294720, 0.012540, 0.186430, 0.196550, 0.123570, 
-0.037570, -0.107630, 0.041350, 0.015280, 0.241640, 0.235390, 0.256550, 0.189040, -0.038640, -0.111290, 
-0.120410, 0.728310, -0.036280, 0.030130, 0.023970, -0.016090, -0.308740, 0.068670, 0.007090, 0.084570, 
0.180550, 0.164450, -0.092170, 0.102970, 0.000480, 0.301920, 0.315750, 0.000860, 0.279500, 0.425050, 
0.004660, -0.055150, 0.643860, 0.235690, -0.083880, 0.176100, 0.140280, 0.234660, 0.073570, 0.206060, 
0.214960, 0.186280, 0.437140, 0.193640, -0.038250, -0.025590, -0.252090, 0.203620, 0.178810, 0.095550, 
-0.125510, 0.003170, -0.135410, 0.609810, 0.279520, 0.069020, -0.094380, 0.082650, 0.438760, 0.065390, 
-0.000720, 0.083080, -0.045580, 0.192570, 0.284460, 0.230510, -0.006390, -0.364250, 0.455990, 0.136500, 
0.176520, 0.116370, 0.145160, -0.328280, 0.280100, 0.201330, -0.077910, -0.384270, 0.283510, 0.083910, 
0.130340, -0.241460, -0.263060, 0.045940, 0.048140, 0.157400, 0.377970, -0.009180, -0.283360, 0.262530, 
-0.441920, -0.218980, -0.213520, 0.369750, 0.115440, 0.361150, 0.108330, 0.002070, -0.159870, 0.385960, 
0.124520, -0.111360, 0.203660, 0.002730, -0.135450, -0.075700, 0.068690, 0.453100, 0.001410, -0.169990, 
0.348660, -0.462000, -0.534810, 0.056590, 0.052460, 0.282870, -0.306490, 0.298230, 0.449080, -0.301430, 
-0.037400, 0.484900, -0.083720, 0.372180, -0.092690, -0.025490, -0.149780, 0.002310, 0.776460, -0.003480, 
-0.482080, -0.072840, -0.350470, -0.979570, -0.095370, -0.277270, -0.161730, -0.379190, -0.433510, 0.358730, 
0.020710, 0.004510, 0.168630, -0.021420, -0.051540, -0.549170, -0.160550, 0.419690, 0.057600, 0.526220, 
-0.009800, -0.568210, 0.095490, -0.250970, -0.529010, 0.004100, -0.037160, -0.076590, -0.349280, 0.143930, 
0.389900, -0.236770, -0.078200, 0.287910, 0.241060, -0.225910, -0.315980, 0.141580, -0.057700, 0.020570, 
0.553670, -0.001920, -0.453590, -0.106850, -0.709880, -0.597810, 0.126380, -0.410670, -0.377070, -0.476490, 
0.085740, 0.687400, -0.214800, -0.166920, 0.463270, 0.587610, 0.060160, -0.312360, 0.061640, 0.206940, 
0.398750, 0.790450, 0.027570, -0.645510, 0.066440, -0.018060, 0.096380, -0.046130, -0.279760, -0.258700, 
-0.365550, -0.190290, 0.254140, -0.323920, -0.094750, -0.105150, -0.154610, 0.447870, 0.012230, 0.125680, 
0.076700, -0.397730, 0.561920, 0.036870, -0.521000, -0.366400, 0.021530, 0.216900, -0.258850, -0.395240, 
-0.659590, 0.465530, 0.237930, -0.188150, -0.347730, -0.393640, -0.343870, 0.203590, 0.507100, 0.087400, 
0.053720, 0.210000, -0.194060, 0.168030, 0.042890, -0.260680, 0.180540, -0.021800, 0.441430, 0.217670, 
0.016550, -0.044980, 0.020280, 0.119780, -0.210720, -0.261470, 0.294050, -0.098220, 0.203900, 0.548000, 
-0.135570, 0.014170, 0.394240, 0.041650, -0.002200, 0.067100, -0.268500, -0.063180, -0.083740, 0.588290, 
0.263670, -0.241400, 0.072750, 0.291880, 0.182940, -0.129010, -0.218540, 0.281360, -0.362970, -0.017820, 
0.463220, 0.094200, 0.146680, -0.112130, 0.185020, -0.009140, 0.073470, 
0.035450, -0.111820, -0.205130, 0.188730, 0.598370, 0.084590, -0.031450, 0.338100, -0.073140, 0.086960, 
0.049580, 0.069180, -0.059740, -0.290200, 0.066440, 0.238280, 0.233560, -0.049880, -0.065920, 0.009350, 
-0.108070, -0.224750, 0.065550, -0.083040, 0.525790, -0.013720, 0.221570, 0.164620, 0.199100, 0.054700, 
-0.049460, -0.136250, 0.387430, -0.016960, 0.050540, 0.283620, -0.029020, -0.066990, -0.223730, -0.169130, 
-0.038300, -0.102830, -0.396610, -0.234830, 0.058670, -0.056300, -0.028230, -0.083870, -0.165200, 0.279290, 
0.054890, 0.058840, 0.043430, -0.291690, 0.063620, -0.065250, 0.223420, -0.161670, -0.046770, 0.158150, 
-0.418130, 0.227540, -0.109420, -0.049280, 0.387620, -0.265990, 0.163380, -0.183340, 0.057500, 0.052940, 
0.316030, 0.298240, -0.236250, -0.422130, 0.202830, -0.230090, 0.002040, 0.462880, -0.079770, 0.346240, 
0.167010, -0.102100, -0.197440, -0.127090, -0.249040, -0.063450, -0.444130, -0.288560, 0.170580, -0.156550, 
-0.257900, -0.220230, 0.273060, 0.455320, 0.129530, -0.245130, 0.267210, 0.013760, 0.003340, -0.546020, 
-0.109590, 0.053500, 0.131780, 0.573920, -0.128170, -0.211650, 0.032990, -0.173010, -0.066950, 0.077620, 
-0.090870, 0.093380, -0.329140, 0.169720, 0.419510, -0.135790, -0.100660, 0.024130, 0.034250, -0.028640, 
0.098580, 0.486680, -0.108940, 0.197150, 0.271320, -0.125030, 0.145330, -0.459550, -0.357220, -0.250450, 
-0.119030, -0.314300, -0.349200, 0.280770, 0.005960, 0.438400, -0.217560, -0.602320, -0.317160, 0.369240, 
-0.247370, -0.292920, -0.047680, -0.217480, -0.293800, 0.542200, -0.099760, -0.061670, 0.272760, -0.263270, 
-0.157620, 0.156720, 0.052140, 0.363570, -0.168880, -0.062960, 0.531890, -0.332020, -0.020180, -0.160070, 
0.403540, -0.297190, 0.532490, 0.848520, 0.078950, 0.414930, 0.549820, -0.074830, 0.337950, -0.139480, 
-0.442520, -0.474140, 0.121760, -0.198440, -0.210460, 0.185780, -0.181830, 0.777560, -0.053500, -0.216460, 
0.228910, 0.221480, -0.378150, -0.344720, -0.370850, -0.106590, -0.129040, 0.964030, 0.007560, -0.464150, 
0.218690, 0.362180, 0.485320, 0.395810, 0.171170, 0.610340, -0.528490, 0.020990, 0.101930, -0.281640, 
0.419840, 0.063490, 0.127270, -0.112570, 0.294880, -0.013310, 0.029540, 0.081500, 0.143970, -0.059760, 
-0.210980, -0.247860, -0.355650, 0.050650, 0.180710, -0.009220, -0.230220, -0.234500, -0.459610, 0.285200, 
0.040770, -0.024300, 0.174540, -0.053960, 0.199370, -0.154940, -0.183060, 0.314510, -0.198590, 0.642770, 
-0.059320, -0.182410, 0.129050, 0.313330, 0.392890, 0.002560, 0.203630, 0.251320, 0.388600, 0.157870, 
-0.021410, -0.242280, 0.647310, 0.309600, -0.155120, -0.215420, 0.390930, 0.070910, 0.270410, -0.176290, 
0.154660, -0.055340, -0.197330, 0.106430, -0.017990, 0.210590, 0.441280, 0.164490, 0.292370, 0.134040, 
-0.030340, 0.089360, -0.282310, 0.196980, 0.010300, -0.207590, 0.463220, 0.375310, 0.020750, 0.000020, 
-0.200590, 0.288920, -0.015410, -0.190490, -0.150870, 0.000400, 0.016470, 0.187290, -0.112760, -0.214370, 
0.566750, 0.123110, -0.119140, -0.029990, -0.107350, 0.099910, 0.090970, 0.281800, 0.215390, 0.174650, 
0.308360, 0.151460, 0.191270, -0.013600, -0.153480, 0.397600, 0.132200, -0.041310, -0.134830, -0.069910, 
0.234060, 0.271180, 0.165140, 0.077150, 0.067980, 0.363470, 0.399680, 0.479600, -0.014770, 0.337720, 
-0.131710, 0.129020, 0.081070, 0.015580, -0.017420, -0.115360, 0.024680, -0.022420, -0.009270, 0.399200, 
-0.176540, -0.250120, 0.354980, -0.015900, 0.187250, -0.027550, -0.298640, 0.041930, 0.409430, -0.219640, 
-0.148900, -0.066630, 0.115900, 0.128450, 0.208960, -0.003230, -0.232770, -0.025620, 0.114110, -0.257270, 
-0.143360, 0.121600, 0.181860, 0.245360, 0.337360, -0.049150, 0.033300, 0.097820, -0.117630, 0.173050, 
0.257460, 0.154970, 0.120540, 0.331700, 0.420000, -0.014420, -0.000750, 
0.167460, 0.283660, -0.126990, -0.273350, 0.233300, -0.103980, -0.299800, 0.273170, -0.238910, 0.087230, 
0.040770, 0.161580, 0.002920, -0.047090, 0.014010, 0.109030, 0.141510, 0.367110, -0.511320, 0.036520, 
0.024020, 0.176390, 0.211000, -0.075110, -0.108080, 0.016190, 0.125240, 0.208120, -0.264360, -0.297460, 
-0.081730, 0.018570, 0.099800, -0.008860, 0.132010, 0.014170, -0.006080, -0.067650, -0.136200, 0.007050, 
-0.035250, 0.026050, -0.072320, 0.183420, 0.098220, -0.243380, -0.184200, 0.167960, 0.098660, -0.250260, 
0.034080, -0.008650, -0.097010, -0.058340, 0.304280, -0.204940, 0.109010, -0.146520, -0.123790, 0.006910, 
0.028250, 0.057270, 0.039240, -0.016350, -0.391970, -0.245950, -0.266720, -0.059400, 0.067150, -0.024760, 
-0.131220, -0.232200, 0.314700, 0.039020, -0.042980, -0.328540, -0.047130, 0.118560, -0.184760, -0.273650, 
-0.078820, -0.077080, 0.212600, 0.035330, 0.188050, -0.131000, -0.398160, -0.354120, 0.384060, -0.304730, 
-0.338360, -0.185260, -0.287030, 0.297980, 0.282030, -0.274870, 0.043530, 0.120010, -0.301120, -0.097600, 
-0.352710, 0.331010, -0.031630, -0.062820, 0.031330, -0.245880, -0.163560, 0.008690, 0.041540, 0.425430, 
-0.097580, -0.048790, -0.152280, 0.056470, -0.028180, 0.151480, -0.173230, 0.122490, -0.049440, -0.260590, 
-0.156030, -0.016890, -0.171480, 0.326360, 0.025550, 0.046610, 0.052920, 0.084860, 0.085810, -0.071900, 
0.405060, 0.229240, -0.026330, -0.116250, -0.372230, -0.087340, 0.142630, 0.195210, -0.237950, -0.468360, 
0.546710, 0.205810, 0.163940, -0.457960, -0.351950, -0.215700, 0.045590, 0.107790, 0.022360, 0.633650, 
0.260260, 0.323810, 0.080770, 0.088870, 0.335150, 0.326000, -0.434520, -0.270140, 0.173700, 0.129740, 
-0.005990, -0.112320, -0.235190, 0.237490, 0.099990, -0.002900, -0.264290, 0.042380, -0.143500, -0.037720, 
0.300940, 0.221290, 0.139560, -0.201610, -0.208280, 0.419180, -0.040540, -0.476760, 0.186110, 0.148570, 
-0.129120, 0.075520, 0.164790, -0.420870, 0.023690, 0.444980, 0.045700, -0.144410, 0.006700, -0.362780, 
-0.217460, 0.309350, 0.418530, -0.016870, -0.062900, -0.275470, 0.931990, -0.008150, -0.156740, -0.191630, 
-0.080990, -0.066340, -0.107500, 1.225390, 0.113770, 0.016490, -0.174080, -0.079810, -0.293960, 0.092160, 
-0.452440, -0.077650, -0.187020, -0.212550, 0.114550, -0.109420, -0.083430, 0.252790, -0.127500, 0.071400, 
0.299380, -0.098390, 0.136950, 0.312290, 0.364590, -0.100270, -0.126240, 0.622380, 0.063670, 0.036230, 
0.113700, -0.277470, -0.321110, -0.264750, -0.117090, 0.162740, -0.175610, 0.074870, 0.274700, -0.177500, 
0.139610, 0.224950, -0.167720, 0.089720, 0.032700, 0.490900, -0.134630, 0.197500, 0.217860, -0.068080, 
0.123520, 0.128650, -0.168190, 0.303960, -0.108890, 0.416930, -0.138760, 0.286410, 0.450610, -0.068540, 
0.440280, -0.279690, -0.212290, 0.260080, -0.022230, 0.087340, 0.521460, 0.069940, 0.115960, 0.239840, 
0.115510, -0.068030, 0.146060, -0.103150, 0.039820, -0.283740, -0.144680, 0.259160, 0.307650, 0.114610, 
-0.153500, 0.104980, 0.010280, -0.092290, 0.007080, -0.021500, 0.009880, 0.168970, -0.228150, -0.157150, 
0.214400, -0.047890, -0.255900, 0.137110, -0.244020, 0.426080, -0.026280, -0.023240, -0.368200, 0.160180, 
0.071370, 0.268950, 0.102700, 0.036350, -0.002160, 0.101160, 0.018240, -0.032030, 0.175110, -0.013040, 
0.010810, 0.336740, 0.057810, -0.289210, 0.132830, 0.074600, 0.164250, -0.010290, 0.211430, -0.104400, 
0.240570, 0.095160, 0.441740, 0.101800, -0.311490, 0.112970, -0.080990, -0.010240, 0.124320, 0.108470, 
0.079580, -0.219690, 0.393270, 0.047730, -0.095430, 0.130030, 0.354510, -0.151320, -0.272440, 0.123850, 
0.216730, -0.029770, 0.100730, -0.027750, -0.244340, 0.118520, 0.221250, -0.160610, 0.155380, 0.340600, 
-0.097370, -0.268320, -0.263710, -0.145800, -0.059610, 0.205120, 0.134940, 
0.033710, 0.328860, 0.238800, 0.142530, -0.061800, 0.215080, -0.084430, 0.589310, -0.100580, 0.158020, 
0.256480, 0.035240, -0.279680, -0.115290, 0.017100, 0.220060, 0.280940, -0.035680, -0.398680, 0.205540, 
-0.059980, -0.244800, -0.042420, 0.011770, 0.343170, 0.050760, 0.113770, 0.274770, 0.151060, 0.220050, 
0.325390, 0.462450, 0.077440, 0.061350, 0.148350, -0.290200, 0.254530, 0.175680, -0.124970, 0.042460, 
0.213520, -0.099110, 0.254030, 0.236070, 0.038650, 0.358180, -0.123500, 0.068200, 0.234280, 0.741020, 
-0.075780, -0.074090, 0.198430, 0.432020, -0.202160, -0.213470, 0.366800, 0.407650, 0.270160, -0.058180, 
-0.277130, -0.121810, -0.131400, -0.285640, -0.234020, 0.217910, 0.105430, -0.006890, -0.207830, -0.237060, 
0.775540, 0.049990, -0.175430, -0.224180, -0.080880, -0.241400, -0.179640, 0.243680, 0.166720, 0.112210, 
0.021050, -0.062380, -0.042070, -0.110570, -0.351960, 0.157290, 0.033360, 0.139380, -0.305020, 0.184980, 
0.111080, 0.534930, -0.094510, -0.089910, -0.184800, 0.432940, 0.047040, 0.096590, 0.116990, 0.037800, 
0.188110, -0.032940, 0.200250, 0.143500, -0.121130, -0.336750, 0.249100, -0.312410, -0.172290, 0.244860, 
0.103840, -0.190100, 0.000820, 0.043410, 0.035980, -0.109290, 0.040300, -0.033960, 0.271410, -0.107460, 
-0.016500, 0.135120, -0.141530, 0.252800, 0.499370, -0.111460, -0.511410, 0.344770, -0.016640, -0.243390, 
-0.302910, -0.083800, -0.027980, 0.081100, 0.165350, 0.167420, -0.157860, 0.027540, -0.308510, 0.054630, 
0.332510, -0.021410, 0.337770, -0.248880, 0.334030, 0.537630, -0.098770, -0.144060, -0.155650, -0.486720, 
-0.260460, -0.071050, -0.213370, -0.156400, 0.312060, -0.102410, 0.037810, -0.283870, -0.461610, -0.241790, 
0.239370, -0.622710, 0.032170, 0.135830, 0.329330, -0.029660, 0.462940, -0.083090, -0.118300, 0.139760, 
-0.247770, -0.285350, 0.316770, 0.283540, 0.451870, -0.298110, 0.101470, 0.293700, -0.467290, -0.017540, 
-0.380590, 0.176720, -0.254850, 0.433050, 0.580600, 0.425140, 0.405500, 0.539010, 0.009650, -0.281850, 
-0.119170, -0.266930, -0.359540, 0.097000, -0.064240, -0.072660, -0.171530, 0.135310, 0.365460, -0.216440, 
-0.301300, -0.152460, 0.250520, -0.441390, -0.011450, 0.342810, 0.402840, 0.118110, 0.802260, -0.073130, 
-0.348780, 0.032520, -0.312320, -0.164290, 0.085060, 0.077820, 0.131000, -0.623690, -0.129310, 0.424850, 
-0.276770, -0.146460, 0.125720, 0.163870, -0.143400, 0.273480, 0.557240, -0.114050, 0.524000, 0.729710, 
-0.104760, -0.264720, -0.068490, 0.081560, 0.400090, -0.046590, -0.086200, 0.040150, 0.008240, -0.132490, 
0.227130, -0.206050, -0.515680, -0.018010, -0.069380, 0.248430, 0.330580, 0.280220, -0.148460, -0.063360, 
0.223640, -0.079780, -0.564670, -0.313170, 0.404300, 0.486180, 0.018840, -0.158090, -0.212340, 0.058070, 
-0.119020, 0.037050, -0.193790, -0.015710, -0.222440, -0.283730, 0.455610, 0.372400, 0.290440, 0.040910, 
-0.297150, 0.154550, -0.086410, -0.332070, -0.078720, -0.050680, 0.273970, -0.028540, 0.031120, -0.050150, 
0.234170, -0.111630, -0.087780, -0.152520, 0.307600, -0.351460, 0.027190, 0.599530, 0.397910, 0.260450, 
0.516350, 0.066460, 0.141110, -0.083740, -0.123500, -0.019980, 0.028230, 0.179430, -0.144090, 0.008480, 
0.127120, 0.617890, -0.178160, -0.125520, -0.161920, -0.097570, -0.079720, -0.234210, -0.011510, 0.388240, 
0.289990, -0.090450, -0.261160, -0.128640, -0.091500, -0.131360, 0.006780, 0.130660, 0.092880, 0.122030, 
-0.002740, 0.232340, 0.404700, 0.164510, -0.062900, -0.242970, 0.081470, -0.167370, 0.304410, -0.021380, 
0.551990, 0.363050, 0.204720, 0.344330, -0.033270, -0.100120, 0.077510, -0.225270, -0.318800, 0.012380, 
0.649000, -0.208310, -0.032360, 0.291120, -0.372300, 0.262520, 0.165350, -0.190370, 0.073800, -0.020530, 
-0.001300, 0.315200, 0.315450, -0.028190, 0.095650, 0.391980, -0.093920, 
-0.252980, 0.349250, 0.077860, 0.069160, -0.064500, 0.220680, 0.091780, 0.147670, 0.058810, 0.032380, 
0.123180, 0.261110, 0.070480, 0.338840, 0.000240, 0.095030, -0.073660, 0.374270, 0.043890, -0.000510, 
-0.043410, -0.326340, -0.079850, -0.033120, 0.365860, -0.202960, 0.243690, 0.066220, 0.223390, 0.221160, 
-0.105170, -0.047830, 0.212710, -0.216220, -0.107970, 0.382640, -0.023980, 0.181430, 0.245420, -0.048700, 
0.049870, -0.052200, -0.154110, 0.291820, 0.045410, -0.131710, 0.102220, 0.001460, -0.025450, 0.016250, 
0.450790, -0.008840, 0.074200, 0.439950, -0.111440, -0.015230, 0.289200, 0.252450, 0.210560, -0.102130, 
-0.074270, 0.074980, -0.076470, -0.323210, -0.113210, -0.113180, -0.308370, -0.193530, -0.221110, -0.208200, 
0.309100, 0.062860, 0.208540, 0.137420, -0.015110, -0.072800, 0.153350, 0.051320, -0.066750, 0.035030, 
0.040350, -0.169920, 0.159130, -0.058050, -0.369280, 0.161040, 0.147000, -0.207370, -0.071960, 0.069090, 
-0.192980, 0.599740, 0.095150, 0.247570, 0.180430, 0.267190, 0.176040, 0.165040, 0.040060, 0.027300, 
0.431200, -0.015210, 0.210270, 0.396850, -0.073170, -0.272590, -0.035120, 0.036390, 0.003610, 0.259190, 
-0.190750, -0.178030, 0.523440, -0.051010, 0.271760, -0.007230, -0.035850, 0.055530, 0.400580, 0.133900, 
-0.079870, 0.092190, 0.001020, 0.122020, 0.466870, -0.061350, -0.271410, 0.044800, 0.079580, 0.006910, 
0.198980, 0.021400, -0.098340, 0.455630, -0.056450, 0.280120, -0.207970, -0.042030, 0.001590, -0.219290, 
0.004570, 0.153080, 0.268750, -0.300100, -0.154970, 0.675490, -0.075380, -0.396550, -0.095860, -0.342660, 
-0.168760, -0.109190, -0.123930, -0.204200, -0.058840, -0.143510, 0.666370, -0.032830, -0.193260, 0.036530, 
0.069900, -0.438470, -0.097340, 0.075630, -0.154640, -0.144130, 0.767570, -0.047520, -0.231200, 0.223670, 
-0.310860, -0.454060, 0.251310, 0.145820, 0.305490, -0.405880, -0.081360, 0.620980, -0.492600, 0.243530, 
-0.252810, 0.169830, -0.451360, 0.331920, 0.621830, -0.237850, 0.146350, 1.004890, 0.005850, -0.391120, 
-0.411510, -0.671190, -0.814730, 0.169430, -0.414260, -0.083630, -0.206960, 0.064900, 0.154730, -0.461970, 
-0.416250, -0.075870, 0.438640, -0.271360, -0.177950, 0.173470, 0.321190, 0.398010, 0.622020, -0.060020, 
-0.188550, -0.036120, -0.146430, -0.099210, 0.271430, -0.194030, -0.067030, 0.077830, -0.438570, 0.077420, 
-0.413860, -0.166460, -0.134330, 0.088420, -0.441330, 0.273820, 0.173400, 0.350880, 0.039180, 0.335900, 
-0.080200, -0.221880, -0.092580, -0.087160, 0.280880, -0.204620, -0.240210, -0.149810, 0.267310, -0.411670, 
0.225770, -0.234730, -0.103260, -0.131760, -0.035670, 0.173480, 0.349780, 0.233780, 0.140350, -0.116670, 
0.534380, -0.057750, -0.316260, -0.003150, 0.101860, 0.244370, 0.252110, -0.009970, -0.044420, 0.156870, 
-0.065270, 0.108430, -0.325650, 0.004150, -0.170370, -0.054800, -0.033630, 0.215630, 0.124950, -0.027700, 
0.031030, 0.123500, -0.040880, -0.233550, -0.063470, 0.209140, 0.348260, -0.069960, 0.080020, 0.187320, 
0.413510, -0.017180, -0.087460, -0.251050, 0.084800, -0.223920, -0.058530, 0.039100, 0.254470, 0.125060, 
-0.272630, -0.189580, 0.174230, -0.028310, -0.262950, 0.444810, 0.177100, 0.117400, -0.436420, 0.011070, 
0.365540, 0.331630, 0.066980, -0.017580, -0.071350, 0.265390, -0.014660, -0.350950, 0.038450, 0.265690, 
0.546430, -0.027900, -0.134750, 0.154780, -0.038170, -0.377500, -0.000920, 0.225390, 0.294310, -0.071400, 
-0.132140, 0.012310, 0.579720, -0.104210, -0.262520, -0.365740, -0.076310, -0.016470, 0.017520, 0.054310, 
0.392860, 0.415620, 0.178410, -0.050000, -0.124850, -0.029440, -0.117550, -0.022610, -0.014320, 0.260900, 
0.128790, 0.133160, -0.023260, 0.363890, -0.164010, 0.038460, -0.085410, 0.125340, 0.061140, -0.008900, 
0.238630, 0.252340, 0.228720, 0.273900, 0.083440, 0.123700, -0.023690, 
0.332450, 0.285860, -0.093580, -0.019620, -0.281300, 0.362320, 0.086910, 0.460680, 0.249400, 0.032080, 
0.160070, 0.169280, -0.174210, -0.063500, 0.287540, -0.024050, -0.232980, -0.084610, -0.044070, -0.074400, 
-0.037820, -0.065660, 0.348630, -0.119590, -0.210270, -0.102450, 0.200590, 0.084680, -0.016010, -0.092160, 
0.104160, 0.159400, 0.304530, 0.141400, -0.002260, 0.057870, 0.126110, 0.244890, 0.148130, 0.081200, 
0.232810, -0.050430, -0.105190, -0.265780, 0.134770, 0.083560, 0.079650, 0.012520, -0.169840, 0.413660, 
0.019790, 0.012730, 0.049640, 0.060170, -0.334080, 0.014350, -0.353950, 0.043100, -0.147860, -0.074510, 
0.214480, 0.073430, -0.057690, -0.327420, 0.091420, -0.226630, -0.240820, 0.415570, 0.344710, 0.077480, 
0.412270, 0.015580, -0.000130, 0.004690, 0.162280, 0.119710, -0.299620, 0.028520, -0.348600, -0.305990, 
0.255360, 0.206970, -0.053000, -0.055480, -0.056800, 0.176860, 0.096710, -0.105110, -0.325080, 0.009020, 
-0.057640, 0.570170, -0.109870, -0.009190, -0.143580, -0.026560, 0.026750, 0.352220, -0.060850, 0.319130, 
0.347160, 0.196110, -0.167260, -0.074160, -0.045410, -0.144760, -0.297060, -0.204220, -0.142570, 0.187160, 
-0.121880, -0.536900, 0.055860, -0.110730, 0.074850, -0.177620, -0.183670, -0.069940, 0.057280, 0.327060, 
-0.415950, -0.422540, -0.046150, -0.114490, 0.290880, -0.045960, -0.322650, 0.120760, -0.116030, -0.052360, 
0.120290, 0.201770, 0.183800, 0.554990, 0.063230, -0.053220, -0.303040, -0.129450, -0.332590, -0.365100, 
-0.079070, 0.231170, 0.487160, 0.382390, 0.211950, 0.401070, -0.022370, 0.264120, -0.421280, -0.481540, 
-0.573000, 0.584290, -0.694430, -0.618620, 0.158460, -0.189420, 0.698750, 0.038870, -0.502160, 0.258660, 
0.342630, -0.066150, -0.507390, -0.270530, -0.061660, 0.051340, 1.022990, -0.012330, -0.555140, 0.149790, 
0.010030, 0.169040, -0.245530, 0.016670, 0.487150, -0.368910, 0.190270, 0.126290, 0.044010, -0.000640, 
0.219310, -0.097280, 0.301440, 0.172000, 0.506560, 0.426190, 0.214320, 0.340660, -0.009730, -0.269340, 
-0.160800, -0.440060, -0.199330, 0.228020, -0.421680, -0.164850, -0.364820, -0.322880, 0.398380, 0.002780, 
-0.204200, 0.076000, 0.316870, 0.286970, -0.348930, 0.020920, -0.058830, -0.035010, 0.554570, 0.013280, 
-0.338970, 0.168880, 0.088230, 0.263030, 0.078680, 0.146240, 0.351410, 0.247820, 0.256790, 0.117280, 
-0.360030, 0.351920, 0.054080, 0.058750, 0.248650, 0.070010, 0.214620, 0.005770, 0.303350, 0.368440, 
0.013480, -0.298430, 0.344470, 0.077060, 0.307170, -0.102470, 0.101550, 0.261420, 0.132300, 0.485340, 
0.167130, -0.134400, 0.250200, -0.097440, 0.109640, 0.402760, -0.003930, -0.086460, 0.208210, 0.264050, 
0.303980, 0.050520, -0.212600, -0.206530, -0.081380, 0.115920, -0.126250, -0.127190, 0.096490, 0.010010, 
-0.002440, 0.100770, 0.101800, 0.009380, 0.030260, 0.454210, 0.004950, -0.053320, 0.026130, 0.504810, 
0.075940, 0.290840, 0.050150, -0.213190, -0.047020, 0.523630, 0.224230, -0.103450, -0.040610, 0.072510, 
0.094490, 0.387630, 0.055060, -0.016180, 0.169750, 0.040290, 0.271730, 0.215450, 0.307310, 0.351910, 
-0.194390, 0.191530, -0.161010, 0.064790, -0.014400, -0.031470, -0.097810, 0.059910, 0.161210, 0.031090, 
0.265560, 0.561140, 0.091790, 0.053890, -0.026980, 0.175940, 0.042570, 0.044740, 0.139870, 0.092910, 
0.023300, 0.167800, 0.353680, 0.304620, 0.048540, 0.102620, 0.140080, 0.453760, 0.286980, 0.386060, 
0.191510, 0.258370, 0.105760, 0.137000, 0.063550, 0.000790, 0.164600, 0.054190, 0.238110, 0.325020, 
0.256500, 0.441170, -0.057700, 0.259120, 0.047230, 0.034700, 0.189690, 0.201060, -0.005910, 0.301950, 
0.104150, 0.187260, 0.078840, 0.188400, -0.081050, 0.102110, 0.005940, -0.059500, 0.067110, -0.050400, 
-0.090100, 0.262020, 0.000750, 0.220700, 0.085800, 0.084160, 0.026460, 
-0.095900, 0.162380, 0.005390, 0.123490, 0.268570, -0.240390, 0.079370, -0.406450, 0.082730, -0.078830, 
-0.241150, -0.088720, -0.194980, 0.009300, 0.159950, -0.160420, 0.312600, 0.040850, 0.042010, 0.266090, 
0.150170, 0.180270, 0.222510, -0.115930, -0.039170, 0.341360, 0.213160, 0.276530, -0.105930, -0.088120, 
0.349280, -0.023630, -0.030330, 0.194030, 0.011880, 0.093800, -0.346150, -0.124970, 0.222530, 0.180580, 
0.401500, 0.167460, 0.032840, -0.054330, 0.105420, 0.138450, 0.203490, 0.137190, 0.436470, 0.083970, 
-0.048620, -0.112710, 0.046590, -0.124710, 0.084190, 0.096780, 0.593740, -0.119570, 0.005230, 0.162520, 
-0.239000, 0.286900, 0.177750, 0.221620, 0.203770, 0.284040, 0.381180, -0.059450, 0.273540, 0.279250, 
0.007970, -0.010710, 0.035130, -0.197800, -0.117340, -0.144580, -0.097760, 0.261200, 0.127420, -0.101770, 
-0.107730, -0.170980, -0.042940, 0.177180, -0.275440, 0.073330, 0.068480, 0.048890, -0.188170, -0.009300, 
0.000380, 0.168420, -0.091210, 0.094530, -0.277270, 0.171340, 0.158910, 0.202490, 0.139190, -0.269220, 
-0.060220, 0.421370, 0.066940, -0.024410, 0.143720, -0.154040, 0.102610, 0.200540, -0.045090, 0.002910, 
-0.078340, -0.042470, 0.343180, 0.230340, 0.087180, -0.172120, -0.330470, -0.174030, -0.195990, 0.519110, 
-0.021500, 0.001570, 0.272400, 0.079640, -0.134760, 0.138790, 0.068460, -0.290180, 0.261330, 0.387950, 
0.017580, -0.228470, -0.182300, 0.528080, 0.047120, -0.125420, -0.122290, -0.168120, -0.139230, 0.127250, 
0.741210, -0.070780, -0.328830, -0.021990, -0.059760, -0.131620, 0.112800, -0.231590, -0.321790, -0.255610, 
-0.413230, 0.431900, -0.426240, -0.447500, -0.604870, -0.156020, 0.063650, 0.396300, -0.079040, -0.133540, 
0.410670, 0.424990, -0.005220, 0.014250, 0.317940, 0.586920, -0.209660, 0.081370, -0.261500, -0.292390, 
-0.057070, 0.553900, -0.408010, -0.277230, -0.402090, -0.120620, -0.582460, -0.270430, -0.216960, 0.143340, 
-0.023690, 0.148710, 1.910510, 0.164610, 0.096420, -0.273670, -0.133830, -0.296890, 0.002670, -0.404670, 
-0.207580, 0.088690, 0.283940, 0.498900, 0.111590, -0.216590, -0.264570, -0.039950, -0.222650, 0.115650, 
0.305280, 0.130650, -0.228560, 1.331990, 0.004630, 0.190230, -0.098630, -0.044020, -0.241100, 0.081410, 
-0.050190, -0.181100, -0.282880, 0.563170, -0.238650, -0.182050, 0.128260, 0.402430, -0.363760, -0.378160, 
-0.305330, 0.183000, -0.516870, -0.223490, 1.060740, 0.032190, 0.070420, -0.170160, -0.104110, -0.385840, 
0.083240, 0.172750, -0.068560, -0.035080, 0.391600, 0.040210, 0.213560, 0.551660, 0.267200, 0.242970, 
-0.220850, -0.146510, -0.069170, -0.170300, -0.139930, 0.089640, 0.249570, 0.487540, 0.030160, 0.172000, 
-0.008570, 0.132770, -0.034360, 0.278780, 0.067750, 0.195820, 0.200480, 0.071760, 0.071220, -0.245920, 
0.054270, -0.223620, -0.190060, 0.077700, -0.242760, -0.036720, -0.026880, 0.041890, -0.013220, -0.024060, 
0.349550, 0.014460, 0.132690, 0.083260, 0.560340, 0.050500, 0.165150, -0.259890, -0.115630, -0.121640, 
0.110890, 0.089760, -0.100890, 0.070850, 0.131060, -0.201390, -0.352850, 0.018110, -0.070170, -0.395930, 
0.282700, -0.149640, -0.329170, 0.114590, -0.086150, -0.053840, 0.730190, 0.524800, 0.324710, 0.262470, 
0.192110, 0.000460, -0.195040, -0.150000, 0.050180, 0.128950, 0.103640, -0.100360, 0.437460, 0.316120, 
0.318520, -0.234630, -0.136330, -0.101840, 0.108170, 0.087650, -0.004860, -0.204650, 0.087720, 0.282470, 
0.129530, 0.141200, -0.025670, -0.144460, 0.018330, 0.098840, -0.000970, 0.038240, 0.331870, 0.030620, 
-0.127790, -0.129280, -0.049090, 0.093150, 0.114830, 0.124980, 0.297520, 0.102830, -0.121290, 0.051560, 
0.505020, 0.100010, 0.153790, 0.202090, 0.136800, 0.212350, -0.094350, 0.241010, 0.000840, 0.179750, 
-0.132970, -0.184360, -0.312070, 0.272500, 0.309650, 0.506010, 0.111370, 
0.037950, -0.188010, 0.070770, 0.209560, 0.128100, -0.001860, -0.007860, 0.293480, -0.093080, -0.035340, 
-0.118080, -0.262240, -0.062160, 0.027300, -0.215840, -0.005530, -0.073810, -0.050240, -0.034440, -0.112540, 
0.069410, 0.216330, -0.382120, 0.409710, 0.014350, 0.356180, -0.431130, -0.210580, 0.349170, -0.031340, 
0.198400, 0.021840, -0.407240, 0.183380, 0.172530, 0.239080, 0.246000, 0.435850, 0.235740, -0.149030, 
0.155440, 0.075890, 0.014990, -0.092530, -0.231620, -0.269930, -0.074630, -0.003730, -0.466640, -0.089770, 
-0.172800, -0.075800, 0.034530, -0.129640, -0.211560, 0.010390, 0.410740, -0.038660, -0.161530, 0.066150, 
-0.143690, 0.021060, 0.086940, 0.152430, 0.583970, 0.110220, 0.360150, 0.200740, 0.216020, 0.290150, 
0.269970, 0.394400, -0.159800, 0.041460, 0.171670, -0.269390, -0.018150, 0.233490, 0.058140, -0.036280, 
0.142540, 0.033960, -0.197580, 0.101050, 0.135210, -0.044010, 0.279650, 0.237370, -0.105320, -0.037820, 
0.103270, 0.299880, 0.205630, -0.383830, -0.185510, -0.334540, -0.316320, -0.184300, 0.338270, 0.086110, 
-0.268480, -0.353630, -0.252170, -0.476400, 0.079320, 0.364290, -0.358720, -0.039410, -0.220360, 0.625260, 
-0.216740, -0.267310, -0.362870, -0.124530, 0.352160, 0.089920, -0.656880, 0.090950, 0.299740, 0.155240, 
-0.061060, 0.024680, -0.417570, -0.411290, -0.173280, 0.059550, 0.179290, -0.238160, 0.180350, 0.254880, 
0.572530, -0.017520, -0.174240, 0.022400, 0.266960, 0.028020, 0.311350, -0.155160, 0.013260, 0.081660, 
0.340220, 0.004190, -0.052420, 0.212720, 0.196450, -0.204010, 0.084640, 0.259020, 0.284950, 0.909600, 
1.198470, 0.091700, 0.373930, 0.450110, 0.065530, 0.170330, -0.192840, -0.195710, 0.202850, -0.173810, 
-0.246960, 0.955520, 0.211040, -0.127940, -0.018440, -0.335120, -0.737930, 0.048110, 0.321980, -0.016690, 
0.357980, 0.498340, 0.072730, 0.127930, 0.344400, 0.112910, 0.246520, -0.231770, 0.494500, -0.020930, 
-0.075030, -0.028700, 0.640020, -0.076800, -0.379220, 0.686030, 0.055860, -0.503640, 0.003760, 0.129730, 
-0.182060, -0.195330, 0.062720, 0.066500, 0.082470, -0.231040, -0.567250, -0.084430, 0.166950, 0.591610, 
-0.225070, 0.329900, 0.127980, 0.456530, -0.323950, -0.294150, -0.108390, -0.344700, -0.432340, 0.008420, 
0.397960, 0.147600, 0.138550, -0.025480, 0.100120, -0.035980, 0.047470, 0.068080, 0.084890, 0.049300, 
0.233660, 0.307150, 0.229570, 0.188700, -0.265720, -0.188440, -0.272760, -0.112550, -0.296940, -0.234300, 
0.000870, 0.512660, 0.238100, 0.242020, 0.019770, -0.011730, 0.386860, 0.255350, 0.619600, -0.152580, 
-0.122250, 0.071140, 0.149640, -0.062400, 0.059030, -0.207920, 0.217340, 0.085330, 0.281360, -0.051380, 
-0.474960, -0.032290, 0.705330, -0.144480, 0.179420, 0.162470, 0.053330, 0.055300, 0.058340, -0.143650, 
-0.025340, -0.049920, 0.272250, -0.084190, -0.131820, -0.283530, 0.571910, -0.046690, -0.423830, -0.203840, 
0.153590, -0.139260, -0.036110, 0.304880, 0.093170, 0.116790, -0.047250, -0.084020, 0.099120, -0.022830, 
0.140470, 0.560380, -0.085260, 0.264520, -0.069910, -0.012320, 0.031480, 0.024280, -0.067110, -0.250360, 
-0.114260, 0.382310, -0.178740, -0.033530, 0.248980, 0.077110, 0.069060, 0.049050, -0.123780, 0.259240, 
0.046160, 0.013250, 0.214380, 0.023280, 0.403990, -0.186460, 0.266080, -0.101820, -0.221350, -0.224320, 
-0.247600, -0.118270, -0.413710, -0.052550, -0.019010, 0.383820, 0.304370, -0.078780, 0.182270, -0.214850, 
0.385830, 0.267130, -0.286770, 0.203230, 0.107610, 0.258940, 0.306360, -0.100190, -0.086910, 0.032580, 
-0.388360, -0.093090, -0.225070, 0.064960, -0.214550, -0.041210, 0.321070, 0.064870, 0.093280, -0.132030, 
-0.399050, -0.071210, -0.105440, -0.313540, -0.218310, 0.119650, 0.340250, -0.094660, 0.155400, 0.068250, 
-0.055250, -0.272300, -0.291040, -0.482000, 0.112630, -0.127320, -0.034630, 
-0.141750, -0.141870, 0.049450, 0.062800, 0.341340, 0.020680, -0.063580, -0.034140, 0.050650, 0.226570, 
-0.085950, -0.201380, 0.085360, 0.227980, 0.078610, -0.088960, -0.026680, 0.233600, 0.251240, -0.103770, 
0.106040, 0.040050, 0.084100, 0.075540, 0.238740, 0.280030, 0.328630, 0.241180, -0.002140, 0.163290, 
0.183410, -0.032520, 0.067400, 0.063110, 0.061220, 0.059130, -0.155680, -0.323860, 0.257170, 0.148120, 
0.067630, 0.124490, 0.191620, 0.288980, -0.056710, -0.046470, -0.051190, 0.396440, 0.480280, -0.029600, 
0.040150, 0.062430, -0.111880, 0.484680, 0.303950, 0.093960, 0.070190, -0.094720, -0.041670, 0.221840, 
0.022090, 0.080090, 0.119210, 0.287320, -0.013080, 0.231470, -0.093490, 0.107560, 0.041770, 0.212370, 
0.048250, -0.005760, 0.189610, 0.071900, 0.067910, 0.026490, 0.063820, 0.076970, 0.155280, -0.038930, 
0.233370, 0.122190, -0.029470, 0.137120, 0.274790, -0.038740, -0.003860, 0.274460, 0.239000, -0.047310, 
0.148060, 0.429880, 0.192220, -0.005150, 0.201250, -0.048630, 0.309070, 0.375210, -0.275810, 0.142030, 
-0.330380, 0.008160, 0.171910, -0.114140, 0.120130, 0.301860, 0.318530, 0.448840, 0.307650, 0.444490, 
0.083160, 0.330960, -0.138100, 0.042700, 0.075600, 0.339940, 0.399340, 0.394180, 0.391810, -0.092510, 
0.230480, 0.331780, 0.529360, 0.309620, 0.035180, 0.122830, 0.065800, 0.259330, 0.492530, 0.657990, 
0.399510, 0.149850, 0.407930, 0.246200, 0.136070, 0.147830, 0.341060, 0.303200, 0.132300, 0.196000, 
-0.181650, 0.120820, 0.054530, 0.013360, 0.206360, 0.031260, 0.116280, -0.026240, 0.413440, 0.239840, 
0.183530, -0.026710, 0.118480, 0.251530, 0.222440, 0.508610, 0.128030, 0.715320, 0.603030, 0.152100, 
0.242330, 0.116410, 0.029820, 0.017380, 0.126850, 0.459790, 0.117550, 0.121620, -0.363930, -0.156150, 
0.417880, 0.159500, -0.179630, -0.160070, -0.393490, 1.160430, 0.115800, -0.058110, -0.015540, 0.324400, 
0.000980, -0.070250, 0.576660, -0.011800, -0.256390, 0.066240, -0.212040, 0.005740, -0.009630, -0.453180, 
-0.088360, -0.434760, -0.330600, 0.437790, -0.000550, -0.360800, -0.142230, 0.048460, 0.182400, 0.077360, 
0.105090, 0.161810, 0.354390, -0.299700, -0.119220, -0.234820, 0.078910, 0.159110, 0.204690, 0.009760, 
-0.235070, 0.146510, 0.172970, 0.201000, 0.348080, -0.027730, -0.236470, -0.101720, 0.287460, 0.100560, 
-0.047350, 0.074430, -0.083780, -0.155840, 0.741250, -0.021730, 0.037140, -0.340810, -0.023410, 0.022000, 
0.021670, -0.338470, -0.163360, -0.213940, -0.226920, -0.012000, -0.212490, -0.200920, -0.196190, 0.190330, 
-0.097650, -0.029340, -0.152310, -0.192220, 0.048220, 0.471580, -0.142770, -0.206430, -0.060910, -0.015930, 
-0.079510, 0.032240, 0.159780, -0.056560, 0.049330, -0.069510, 0.298180, -0.300740, -0.207570, -0.010410, 
-0.272350, -0.003410, 0.083870, 0.037550, -0.103900, -0.013610, 0.022440, 0.234630, -0.217670, -0.517360, 
-0.031930, -0.035880, 0.026260, -0.251060, 0.005330, -0.163750, -0.016520, -0.354620, 0.122970, -0.076060, 
0.071170, 0.097660, -0.113580, -0.171290, 0.037280, -0.112700, 0.224380, -0.413970, -0.054010, -0.115100, 
-0.106720, 0.143330, -0.063140, 0.026320, -0.326000, 0.128790, 0.046860, -0.034780, -0.161440, -0.128340, 
-0.173780, -0.634580, 0.028540, 0.053700, 0.061620, -0.232470, -0.049620, 0.181870, -0.080770, 0.088440, 
0.233940, -0.145990, -0.069000, 0.291650, 0.058260, -0.311810, -0.169230, 0.009570, 0.199000, 0.359950, 
0.052880, 0.068120, -0.095070, -0.078540, -0.201940, -0.010350, -0.064190, -0.130520, 0.327870, -0.185520, 
-0.039790, -0.149540, 0.260820, 0.109840, -0.114960, 0.044890, -0.244150, -0.117320, -0.164510, 0.014930, 
0.345330, -0.105590, -0.048610, -0.429920, -0.095790, 0.296050, 0.076250, -0.058900, 0.034460, -0.078960, 
0.407900, -0.028930, 0.092670, -0.185590, -0.204530, 0.347020, 0.037130, 
-0.312320, 0.723960, -0.677060, 0.536210, 1.062970, -0.752340, 0.827740, -0.810580, 0.307890, -0.149670, 
-0.482010, -0.443660, 0.216850, -0.380770, 1.056070, 0.376920, -0.693010, -0.672840, -0.348020, -0.594590, 
-0.320780, 0.303590, -0.752630, 0.447920, -0.092490, 0.380470, 0.061680, -0.412520, -0.472370, -0.580240, 
-0.709770, 1.293440, 0.894230, 0.334210, -0.476470, -1.268150, -0.598150, -0.370510, -0.758200, -0.385990, 
1.096820, -0.335990, -0.568540, -0.771630, 1.154090, -0.495720, 0.669360, -0.535450, 0.482940, 0.841910, 
-0.526200, -0.619110, -0.761330, -0.716720, 1.162950, -0.096320, -0.651720, -0.308160, -0.696220, -0.609710, 
-0.416790, -0.621540, -0.659090, 0.640430, -0.726020, -0.540140, -0.574010, -0.777480, -0.469510, -0.398760, 
-0.447250, -0.784210, -0.325890, 0.310000, -0.846980, 
-1.302990, -0.755220, 0.181810, -0.478790, -1.082110, -0.520690, -0.893490, 0.835430, -0.527490, -0.204530, 
0.471540, -0.860680, 0.191340, -0.532120, -0.926500, -0.205590, 0.659730, -0.987970, -0.104100, -0.068600, 
-0.093170, 0.157870, 0.641580, -0.475530, -0.309160, 0.049200, 0.289850, -0.509440, 0.128570, 0.584240, 
0.607780, -0.959800, -0.916000, -0.279380, -0.133070, -0.839710, 0.165280, -0.195700, -0.051930, -0.308220, 
-0.738400, -0.556660, 0.367370, 0.581180, -1.249260, 0.302270, -0.641980, 0.694700, 0.153610, -0.767250, 
0.697980, 0.675290, 0.735510, -0.466480, -1.050530, -0.375910, -1.119730, -0.693080, 0.921680, 0.312900, 
0.104570, 0.451390, 0.644380, -0.554780, 0.589560, -0.536600, 0.431030, 0.859310, -0.267820, 0.345030, 
0.421260, 0.463200, -0.676830, -0.485340, -0.729600, 
1.054850, -0.272260, 0.270250, -0.422700, -0.272550, 0.713310, -0.109080, -0.302410, 0.227330, 0.125430, 
-0.309950, 0.831920, -0.370230, 0.595370, -0.721920, -0.372440, -0.414460, 0.968450, 0.212640, 0.339440, 
0.287080, -0.328360, -0.133230, 0.115750, 0.210420, -0.310620, -0.283000, 0.554730, 0.169810, -0.543060, 
0.294480, -0.835490, -0.430870, 0.115670, 0.227660, 1.873360, 0.238520, 0.077670, 0.515800, 0.294310, 
-0.777470, -0.203930, 0.141430, 0.049030, -0.271070, 0.050300, -0.183480, -0.177480, -0.416600, -0.282890, 
-0.526180, -0.157930, -0.446500, 0.709610, -0.556800, 0.395100, 1.175200, 0.528080, -0.441240, 0.079600, 
0.051540, 0.005640, -0.338860, -0.112630, -0.073390, 0.656910, 0.022200, -0.516050, 0.465470, -0.196860, 
-0.368370, -0.120090, 0.600160, 0.220930, 1.034390, 

  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[436] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.010000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, 0.009980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.009170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.002710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.008150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, -0.000540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.000910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, 0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, -0.006630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.008630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, -0.001360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, -0.001120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, 0.008980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, 0.009620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.004950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, -0.007520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.000630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, -0.008410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, -0.000310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, -0.006210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, 0.006230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.001410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, 0.008460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, -0.006310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, -0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, 0.007630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.007880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, -0.005690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, 0.002430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, -0.003580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.003620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, -0.005050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.009880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, -0.002490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.007470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.002350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.005420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, 0.006270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, 0.000070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, -0.000190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, 0.003680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, -0.004030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, 0.002660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, -0.007530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, 0.002580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, 0.001440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, -0.000850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, -0.003360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, 0.006580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, -0.006620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.007240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, -0.005380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.008950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, -0.009330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, 0.003310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.008360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, 0.004590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.008510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.003520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.006200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.000720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.001380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.000240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, -0.004780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, -0.007430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, -0.001560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, 0.003330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, 0.002140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, 0.006460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.007760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.007050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.006220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, -0.009100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.008090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.003720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.007460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, 0.009920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, 0.009990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, 0.006140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, -0.001740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, 0.002500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, 0.009460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.000700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, -0.005710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.001160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.004240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.007070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.000520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, 0.004670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, -0.005670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, 0.000640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.006060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.001060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.005140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.000680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, -0.007380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, 0.007320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, -0.006920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.009640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, -0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, -0.003400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, -0.006000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.007140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, -0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.005490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.002680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.008890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, -0.007700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.001100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.006740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.001500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.000400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, 0.009380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, -0.002170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, -0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.006350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.000500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, -0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, 0.003820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, -0.008850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.002240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, -0.008610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.008230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, 0.003250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, -0.000660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.005360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, -0.005040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.008180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.007080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, 0.006510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, 0.001620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, 0.004070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, 0.002440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, 0.001630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, 0.002380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, 0.004000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, 0.009580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, 0.009260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.005580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, 0.000110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, -0.007650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 165 (Old: 165) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 166 (Old: 166) */
      0.0, 0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 167 (Old: 167) */
      0.0, 0.007600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 168 (Old: 168) */
      0.0, -0.000960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 169 (Old: 169) */
      0.0, 0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 170 (Old: 170) */
      0.0, 0.000860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 171 (Old: 171) */
      0.0, -0.001760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 172 (Old: 172) */
      0.0, -0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 173 (Old: 173) */
      0.0, 0.008600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 174 (Old: 174) */
      0.0, -0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 175 (Old: 175) */
      0.0, 0.001940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 176 (Old: 176) */
      0.0, -0.001710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 177 (Old: 177) */
      0.0, 0.006180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 178 (Old: 178) */
      0.0, -0.007850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 179 (Old: 179) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 180 (Old: 180) */
      0.0, 0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 181 (Old: 181) */
      0.0, 0.007690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 182 (Old: 182) */
      0.0, 0.006820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 183 (Old: 183) */
      0.0, -0.009850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 184 (Old: 184) */
      0.0, -0.003630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 185 (Old: 185) */
      0.0, -0.006240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 186 (Old: 186) */
      0.0, -0.002840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 187 (Old: 187) */
      0.0, 0.003410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 188 (Old: 188) */
      0.0, -0.004750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 189 (Old: 189) */
      0.0, -0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 190 (Old: 190) */
      0.0, -0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 191 (Old: 191) */
      0.0, -0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 192 (Old: 192) */
      0.0, 0.002820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 193 (Old: 193) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 194 (Old: 194) */
      0.0, 0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 195 (Old: 195) */
      0.0, -0.006300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 196 (Old: 196) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 197 (Old: 197) */
      0.0, 0.004510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 198 (Old: 198) */
      0.0, 0.009110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 199 (Old: 199) */
      0.0, -0.002020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 200 (Old: 200) */
      0.0, -0.000280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 201 (Old: 201) */
      0.0, -0.002600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 202 (Old: 202) */
      0.0, 0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 203 (Old: 203) */
      0.0, 0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 204 (Old: 204) */
      0.0, 0.000950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 205 (Old: 205) */
      0.0, -0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 206 (Old: 206) */
      0.0, -0.004860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 207 (Old: 207) */
      0.0, 0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 208 (Old: 208) */
      0.0, -0.002360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 209 (Old: 209) */
      0.0, -0.002370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 210 (Old: 210) */
      0.0, -0.007090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 211 (Old: 211) */
      0.0, 0.006370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 212 (Old: 212) */
      0.0, 0.003840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 213 (Old: 213) */
      0.0, 0.009530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 214 (Old: 214) */
      0.0, 0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 215 (Old: 215) */
      0.0, -0.009030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 216 (Old: 216) */
      0.0, -0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 217 (Old: 217) */
      0.0, 0.005900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 218 (Old: 218) */
      0.0, -0.002080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 219 (Old: 219) */
      0.0, -0.008710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 220 (Old: 220) */
      0.0, -0.001190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 221 (Old: 221) */
      0.0, -0.000940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 222 (Old: 222) */
      0.0, 0.001220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 223 (Old: 223) */
      0.0, 0.001000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 224 (Old: 224) */
      0.0, 0.003860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 225 (Old: 225) */
      0.0, 0.005980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 226 (Old: 226) */
      0.0, 0.005680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 227 (Old: 227) */
      0.0, 0.009000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 228 (Old: 228) */
      0.0, 0.005810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 229 (Old: 229) */
      0.0, -0.001490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 230 (Old: 230) */
      0.0, -0.008300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 231 (Old: 231) */
      0.0, 0.001690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 232 (Old: 232) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 233 (Old: 233) */
      0.0, 0.002890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 234 (Old: 234) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 235 (Old: 235) */
      0.0, 0.002160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 236 (Old: 236) */
      0.0, 0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 237 (Old: 237) */
      0.0, 0.004290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 238 (Old: 238) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 239 (Old: 239) */
      0.0, 0.001110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 240 (Old: 240) */
      0.0, -0.008520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 241 (Old: 241) */
      0.0, -0.008430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 242 (Old: 242) */
      0.0, -0.002120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 243 (Old: 243) */
      0.0, -0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 244 (Old: 244) */
      0.0, 0.009710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 245 (Old: 245) */
      0.0, -0.003730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 246 (Old: 246) */
      0.0, -0.006890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 247 (Old: 247) */
      0.0, 0.007410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 248 (Old: 248) */
      0.0, 0.008810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 249 (Old: 249) */
      0.0, 0.009740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 250 (Old: 250) */
      0.0, 0.002180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 251 (Old: 251) */
      0.0, -0.007310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 252 (Old: 252) */
      0.0, 0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 253 (Old: 253) */
      0.0, -0.008490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 254 (Old: 254) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 255 (Old: 255) */
      0.0, -0.003240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 256 (Old: 256) */
      0.0, -0.003100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 257 (Old: 257) */
      0.0, 0.008470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 258 (Old: 258) */
      0.0, 0.008140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 259 (Old: 259) */
      0.0, 0.009930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 260 (Old: 260) */
      0.0, -0.000530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 261 (Old: 261) */
      0.0, -0.005800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 262 (Old: 262) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 263 (Old: 263) */
      0.0, -0.000920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 264 (Old: 264) */
      0.0, -0.005970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 265 (Old: 265) */
      0.0, -0.004540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 266 (Old: 266) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 267 (Old: 267) */
      0.0, 0.004900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 268 (Old: 268) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 269 (Old: 269) */
      0.0, 0.000340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 270 (Old: 270) */
      0.0, 0.000650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 271 (Old: 271) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 272 (Old: 272) */
      0.0, -0.000080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 273 (Old: 273) */
      0.0, -0.007170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 274 (Old: 274) */
      0.0, 0.009800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 275 (Old: 275) */
      0.0, -0.006430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 276 (Old: 276) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 277 (Old: 277) */
      0.0, 0.009610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 278 (Old: 278) */
      0.0, -0.008590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 279 (Old: 279) */
      0.0, 0.008740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 280 (Old: 280) */
      0.0, 0.009240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 281 (Old: 281) */
      0.0, 0.006190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 282 (Old: 282) */
      0.0, 0.004470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 283 (Old: 283) */
      0.0, 0.001050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 284 (Old: 284) */
      0.0, -0.002990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 285 (Old: 285) */
      0.0, 0.006980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 286 (Old: 286) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 287 (Old: 287) */
      0.0, -0.002990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 288 (Old: 288) */
      0.0, -0.000690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 289 (Old: 289) */
      0.0, 0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 290 (Old: 290) */
      0.0, 0.002120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 291 (Old: 291) */
      0.0, -0.004440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 292 (Old: 292) */
      0.0, -0.004490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 293 (Old: 293) */
      0.0, 0.003880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 294 (Old: 294) */
      0.0, 0.007870, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 295 (Old: 295) */
      0.0, -0.008220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 296 (Old: 296) */
      0.0, -0.004820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 297 (Old: 297) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 298 (Old: 298) */
      0.0, -0.003030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 299 (Old: 299) */
      0.0, 0.002630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 300 (Old: 300) */
      0.0, 0.009480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 301 (Old: 301) */
      0.0, -0.006990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 302 (Old: 302) */
      0.0, 0.009160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 303 (Old: 303) */
      0.0, 0.008880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 304 (Old: 304) */
      0.0, 0.001480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 305 (Old: 305) */
      0.0, 0.000410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 306 (Old: 306) */
      0.0, -0.000030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 307 (Old: 307) */
      0.0, -0.009610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 308 (Old: 308) */
      0.0, -0.002150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 309 (Old: 309) */
      0.0, -0.008250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 310 (Old: 310) */
      0.0, -0.005010, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 311 (Old: 311) */
      0.0, -0.004280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 312 (Old: 312) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 313 (Old: 313) */
      0.0, 0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 314 (Old: 314) */
      0.0, 0.004710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 315 (Old: 315) */
      0.0, 0.009630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 316 (Old: 316) */
      0.0, 0.008390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 317 (Old: 317) */
      0.0, 0.006910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 318 (Old: 318) */
      0.0, 0.007710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 319 (Old: 319) */
      0.0, -0.005130, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 320 (Old: 320) */
      0.0, -0.008760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 321 (Old: 321) */
      0.0, 0.007420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 322 (Old: 322) */
      0.0, -0.001850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 323 (Old: 323) */
      0.0, 0.007550, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 324 (Old: 324) */
      0.0, -0.001980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 325 (Old: 325) */
      0.0, 0.008680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 326 (Old: 326) */
      0.0, 0.004880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 327 (Old: 327) */
      0.0, 0.001750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 328 (Old: 328) */
      0.0, -0.008970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 329 (Old: 329) */
      0.0, 0.002930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 330 (Old: 330) */
      0.0, 0.009660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 331 (Old: 331) */
      0.0, -0.009470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 332 (Old: 332) */
      0.0, -0.005250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 333 (Old: 333) */
      0.0, -0.007240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 334 (Old: 334) */
      0.0, 0.001900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 335 (Old: 335) */
      0.0, -0.007360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 336 (Old: 336) */
      0.0, 0.009260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 337 (Old: 337) */
      0.0, 0.005830, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 338 (Old: 338) */
      0.0, 0.001530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 339 (Old: 339) */
      0.0, -0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 340 (Old: 340) */
      0.0, -0.001290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 341 (Old: 341) */
      0.0, -0.001530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 342 (Old: 342) */
      0.0, 0.000640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 343 (Old: 343) */
      0.0, 0.000720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 344 (Old: 344) */
      0.0, -0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 345 (Old: 345) */
      0.0, 0.003960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 346 (Old: 346) */
      0.0, 0.001650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 347 (Old: 347) */
      0.0, 0.008030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 348 (Old: 348) */
      0.0, 0.007260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 349 (Old: 349) */
      0.0, -0.003960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 350 (Old: 350) */
      0.0, 0.006390, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 351 (Old: 351) */
      0.0, -0.007860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 352 (Old: 352) */
      0.0, -0.004620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 353 (Old: 353) */
      0.0, 0.003950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 354 (Old: 354) */
      0.0, 0.007180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 355 (Old: 355) */
      0.0, -0.006480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 356 (Old: 356) */
      0.0, 0.001160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 357 (Old: 357) */
      0.0, -0.001800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 358 (Old: 358) */
      0.0, 0.098890, 357,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 359 (Old: 359) */
      0.0, -0.441380, 357,
       &Sources[357] , 
       &Weights[357] , 
      },
    { /* unit 360 (Old: 360) */
      0.0, 0.027000, 357,
       &Sources[714] , 
       &Weights[714] , 
      },
    { /* unit 361 (Old: 361) */
      0.0, -0.451780, 357,
       &Sources[1071] , 
       &Weights[1071] , 
      },
    { /* unit 362 (Old: 362) */
      0.0, -0.263590, 357,
       &Sources[1428] , 
       &Weights[1428] , 
      },
    { /* unit 363 (Old: 363) */
      0.0, -0.064000, 357,
       &Sources[1785] , 
       &Weights[1785] , 
      },
    { /* unit 364 (Old: 364) */
      0.0, -0.244660, 357,
       &Sources[2142] , 
       &Weights[2142] , 
      },
    { /* unit 365 (Old: 365) */
      0.0, -0.121340, 357,
       &Sources[2499] , 
       &Weights[2499] , 
      },
    { /* unit 366 (Old: 366) */
      0.0, 0.046690, 357,
       &Sources[2856] , 
       &Weights[2856] , 
      },
    { /* unit 367 (Old: 367) */
      0.0, -0.014390, 357,
       &Sources[3213] , 
       &Weights[3213] , 
      },
    { /* unit 368 (Old: 368) */
      0.0, -0.212380, 357,
       &Sources[3570] , 
       &Weights[3570] , 
      },
    { /* unit 369 (Old: 369) */
      0.0, 0.056190, 357,
       &Sources[3927] , 
       &Weights[3927] , 
      },
    { /* unit 370 (Old: 370) */
      0.0, -0.214880, 357,
       &Sources[4284] , 
       &Weights[4284] , 
      },
    { /* unit 371 (Old: 371) */
      0.0, -0.033240, 357,
       &Sources[4641] , 
       &Weights[4641] , 
      },
    { /* unit 372 (Old: 372) */
      0.0, -0.281140, 357,
       &Sources[4998] , 
       &Weights[4998] , 
      },
    { /* unit 373 (Old: 373) */
      0.0, -0.333430, 357,
       &Sources[5355] , 
       &Weights[5355] , 
      },
    { /* unit 374 (Old: 374) */
      0.0, -0.131610, 357,
       &Sources[5712] , 
       &Weights[5712] , 
      },
    { /* unit 375 (Old: 375) */
      0.0, 0.033510, 357,
       &Sources[6069] , 
       &Weights[6069] , 
      },
    { /* unit 376 (Old: 376) */
      0.0, 0.015180, 357,
       &Sources[6426] , 
       &Weights[6426] , 
      },
    { /* unit 377 (Old: 377) */
      0.0, 0.007940, 357,
       &Sources[6783] , 
       &Weights[6783] , 
      },
    { /* unit 378 (Old: 378) */
      0.0, 0.031090, 357,
       &Sources[7140] , 
       &Weights[7140] , 
      },
    { /* unit 379 (Old: 379) */
      0.0, -0.144150, 357,
       &Sources[7497] , 
       &Weights[7497] , 
      },
    { /* unit 380 (Old: 380) */
      0.0, -0.010400, 357,
       &Sources[7854] , 
       &Weights[7854] , 
      },
    { /* unit 381 (Old: 381) */
      0.0, 0.016260, 357,
       &Sources[8211] , 
       &Weights[8211] , 
      },
    { /* unit 382 (Old: 382) */
      0.0, 0.032900, 357,
       &Sources[8568] , 
       &Weights[8568] , 
      },
    { /* unit 383 (Old: 383) */
      0.0, -0.225680, 357,
       &Sources[8925] , 
       &Weights[8925] , 
      },
    { /* unit 384 (Old: 384) */
      0.0, -0.177380, 357,
       &Sources[9282] , 
       &Weights[9282] , 
      },
    { /* unit 385 (Old: 385) */
      0.0, -0.034010, 357,
       &Sources[9639] , 
       &Weights[9639] , 
      },
    { /* unit 386 (Old: 386) */
      0.0, -0.022050, 357,
       &Sources[9996] , 
       &Weights[9996] , 
      },
    { /* unit 387 (Old: 387) */
      0.0, -0.126040, 357,
       &Sources[10353] , 
       &Weights[10353] , 
      },
    { /* unit 388 (Old: 388) */
      0.0, 0.330240, 357,
       &Sources[10710] , 
       &Weights[10710] , 
      },
    { /* unit 389 (Old: 389) */
      0.0, -0.402190, 357,
       &Sources[11067] , 
       &Weights[11067] , 
      },
    { /* unit 390 (Old: 390) */
      0.0, -0.297840, 357,
       &Sources[11424] , 
       &Weights[11424] , 
      },
    { /* unit 391 (Old: 391) */
      0.0, 0.021290, 357,
       &Sources[11781] , 
       &Weights[11781] , 
      },
    { /* unit 392 (Old: 392) */
      0.0, 0.003070, 357,
       &Sources[12138] , 
       &Weights[12138] , 
      },
    { /* unit 393 (Old: 393) */
      0.0, 0.077390, 357,
       &Sources[12495] , 
       &Weights[12495] , 
      },
    { /* unit 394 (Old: 394) */
      0.0, -0.003460, 357,
       &Sources[12852] , 
       &Weights[12852] , 
      },
    { /* unit 395 (Old: 395) */
      0.0, 0.006320, 357,
       &Sources[13209] , 
       &Weights[13209] , 
      },
    { /* unit 396 (Old: 396) */
      0.0, 0.015640, 357,
       &Sources[13566] , 
       &Weights[13566] , 
      },
    { /* unit 397 (Old: 397) */
      0.0, -0.022420, 357,
       &Sources[13923] , 
       &Weights[13923] , 
      },
    { /* unit 398 (Old: 398) */
      0.0, -0.373780, 357,
       &Sources[14280] , 
       &Weights[14280] , 
      },
    { /* unit 399 (Old: 399) */
      0.0, -0.016210, 357,
       &Sources[14637] , 
       &Weights[14637] , 
      },
    { /* unit 400 (Old: 400) */
      0.0, 0.284790, 357,
       &Sources[14994] , 
       &Weights[14994] , 
      },
    { /* unit 401 (Old: 401) */
      0.0, -0.061640, 357,
       &Sources[15351] , 
       &Weights[15351] , 
      },
    { /* unit 402 (Old: 402) */
      0.0, -0.256910, 357,
       &Sources[15708] , 
       &Weights[15708] , 
      },
    { /* unit 403 (Old: 403) */
      0.0, 0.004450, 357,
       &Sources[16065] , 
       &Weights[16065] , 
      },
    { /* unit 404 (Old: 404) */
      0.0, -0.336370, 357,
       &Sources[16422] , 
       &Weights[16422] , 
      },
    { /* unit 405 (Old: 405) */
      0.0, -0.016170, 357,
       &Sources[16779] , 
       &Weights[16779] , 
      },
    { /* unit 406 (Old: 406) */
      0.0, -0.118440, 357,
       &Sources[17136] , 
       &Weights[17136] , 
      },
    { /* unit 407 (Old: 407) */
      0.0, -0.166520, 357,
       &Sources[17493] , 
       &Weights[17493] , 
      },
    { /* unit 408 (Old: 408) */
      0.0, -0.164320, 357,
       &Sources[17850] , 
       &Weights[17850] , 
      },
    { /* unit 409 (Old: 409) */
      0.0, 0.051990, 357,
       &Sources[18207] , 
       &Weights[18207] , 
      },
    { /* unit 410 (Old: 410) */
      0.0, -0.094010, 357,
       &Sources[18564] , 
       &Weights[18564] , 
      },
    { /* unit 411 (Old: 411) */
      0.0, -0.053680, 357,
       &Sources[18921] , 
       &Weights[18921] , 
      },
    { /* unit 412 (Old: 412) */
      0.0, -0.343480, 357,
       &Sources[19278] , 
       &Weights[19278] , 
      },
    { /* unit 413 (Old: 413) */
      0.0, 0.008670, 357,
       &Sources[19635] , 
       &Weights[19635] , 
      },
    { /* unit 414 (Old: 414) */
      0.0, 0.113170, 357,
       &Sources[19992] , 
       &Weights[19992] , 
      },
    { /* unit 415 (Old: 415) */
      0.0, -0.045060, 357,
       &Sources[20349] , 
       &Weights[20349] , 
      },
    { /* unit 416 (Old: 416) */
      0.0, -0.145330, 357,
       &Sources[20706] , 
       &Weights[20706] , 
      },
    { /* unit 417 (Old: 417) */
      0.0, -0.020150, 357,
       &Sources[21063] , 
       &Weights[21063] , 
      },
    { /* unit 418 (Old: 418) */
      0.0, -0.009960, 357,
       &Sources[21420] , 
       &Weights[21420] , 
      },
    { /* unit 419 (Old: 419) */
      0.0, 0.031280, 357,
       &Sources[21777] , 
       &Weights[21777] , 
      },
    { /* unit 420 (Old: 420) */
      0.0, -0.077350, 357,
       &Sources[22134] , 
       &Weights[22134] , 
      },
    { /* unit 421 (Old: 421) */
      0.0, -0.199750, 357,
       &Sources[22491] , 
       &Weights[22491] , 
      },
    { /* unit 422 (Old: 422) */
      0.0, -0.019600, 357,
       &Sources[22848] , 
       &Weights[22848] , 
      },
    { /* unit 423 (Old: 423) */
      0.0, -0.001650, 357,
       &Sources[23205] , 
       &Weights[23205] , 
      },
    { /* unit 424 (Old: 424) */
      0.0, 0.005430, 357,
       &Sources[23562] , 
       &Weights[23562] , 
      },
    { /* unit 425 (Old: 425) */
      0.0, -0.161160, 357,
       &Sources[23919] , 
       &Weights[23919] , 
      },
    { /* unit 426 (Old: 426) */
      0.0, -0.015800, 357,
       &Sources[24276] , 
       &Weights[24276] , 
      },
    { /* unit 427 (Old: 427) */
      0.0, -0.144740, 357,
       &Sources[24633] , 
       &Weights[24633] , 
      },
    { /* unit 428 (Old: 428) */
      0.0, -0.089520, 357,
       &Sources[24990] , 
       &Weights[24990] , 
      },
    { /* unit 429 (Old: 429) */
      0.0, -0.078430, 357,
       &Sources[25347] , 
       &Weights[25347] , 
      },
    { /* unit 430 (Old: 430) */
      0.0, 0.012360, 357,
       &Sources[25704] , 
       &Weights[25704] , 
      },
    { /* unit 431 (Old: 431) */
      0.0, -0.132570, 357,
       &Sources[26061] , 
       &Weights[26061] , 
      },
    { /* unit 432 (Old: 432) */
      0.0, -0.005650, 357,
       &Sources[26418] , 
       &Weights[26418] , 
      },
    { /* unit 433 (Old: 433) */
      0.0, 0.100040, 75,
       &Sources[26775] , 
       &Weights[26775] , 
      },
    { /* unit 434 (Old: 434) */
      0.0, -1.112800, 75,
       &Sources[26850] , 
       &Weights[26850] , 
      },
    { /* unit 435 (Old: 435) */
      0.0, -1.169230, 75,
       &Sources[26925] , 
       &Weights[26925] , 
      }

  };



int net_psi111(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[357] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, Units + 311, Units + 312, Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, Units + 351, Units + 352, Units + 353, Units + 354, Units + 355, Units + 356, Units + 357}; /* members */

  static pUnit Hidden1[75] = {Units + 358, Units + 359, Units + 360, Units + 361, Units + 362, Units + 363, Units + 364, Units + 365, Units + 366, Units + 367, Units + 368, Units + 369, Units + 370, Units + 371, Units + 372, Units + 373, Units + 374, Units + 375, Units + 376, Units + 377, Units + 378, Units + 379, Units + 380, Units + 381, Units + 382, Units + 383, Units + 384, Units + 385, Units + 386, Units + 387, Units + 388, Units + 389, Units + 390, Units + 391, Units + 392, Units + 393, Units + 394, Units + 395, Units + 396, Units + 397, Units + 398, Units + 399, Units + 400, Units + 401, Units + 402, Units + 403, Units + 404, Units + 405, Units + 406, Units + 407, Units + 408, Units + 409, Units + 410, Units + 411, Units + 412, Units + 413, Units + 414, Units + 415, Units + 416, Units + 417, Units + 418, Units + 419, Units + 420, Units + 421, Units + 422, Units + 423, Units + 424, Units + 425, Units + 426, Units + 427, Units + 428, Units + 429, Units + 430, Units + 431, Units + 432}; /* members */

  static pUnit Output1[3] = {Units + 433, Units + 434, Units + 435}; /* members */

  static int Output[3] = {433, 434, 435};

  for(member = 0; member < 357; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 75; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
