/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  step3_net.c
  --------------------------------------------------------
  generated at Mon Jun 28 13:25:15 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[356];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, Units + 321, Units + 322, 
Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, Units + 331, Units + 332, 
Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, Units + 341, Units + 342, 
Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, Units + 351, Units + 352, 

Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, Units + 321, Units + 322, 
Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, Units + 331, Units + 332, 
Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, Units + 341, Units + 342, 
Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, Units + 351, Units + 352, 

Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, Units + 321, Units + 322, 
Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, Units + 331, Units + 332, 
Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, Units + 341, Units + 342, 
Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, Units + 351, Units + 352, 


  };

  /* Weigths definition section */
  static float Weights[] =  {
-0.356640, 0.274040, -0.118020, -0.156790, -0.012780, -0.096360, -0.157600, -0.109710, -0.107000, -0.292810, 
0.031340, -0.214320, -0.061730, 0.150190, -0.300950, -0.148990, 0.010290, -0.253560, -0.181470, 0.223640, 
-0.192810, -0.037860, 0.229110, -0.090850, -0.215900, -0.003330, -0.013250, -0.051040, -0.325670, 0.023910, 
0.048260, 0.004390, -0.213710, -0.337050, 0.055700, 0.004620, -0.118610, 0.309240, -0.127160, 0.057050, 
-0.063870, -0.143420, -0.105110, 0.011460, 0.074600, 0.113220, -0.146870, 0.046230, -0.225190, -0.035280, 
-0.100020, -0.247020, -0.189030, 0.068440, 0.004660, -0.084360, -0.128420, -0.115230, -0.339620, 0.133690, 
-0.250400, 0.245920, -0.123740, 0.065290, -0.377040, -0.032480, -0.339000, -0.093260, 0.153910, 0.059800, 
-0.254110, -0.140980, -0.163010, -0.195170, -0.067500, -0.126020, -0.390570, 0.118050, -0.054150, -0.427500, 
0.052880, -0.227140, -0.181030, -0.084450, -0.185090, 0.178320, -0.191290, 0.174360, -0.750350, 0.003640, 
-0.323420, 0.106400, -0.440920, -0.208680, -0.044590, -0.040200, -0.059770, -0.404160, 0.155490, -0.085210, 
-0.449870, 0.225580, -0.052570, -0.485780, 0.132690, -0.299700, -0.010530, -0.181350, -0.024700, -0.000470, 
-0.181150, 0.144890, -0.754170, 0.148520, -0.560800, 0.415650, -0.373800, -0.156160, 0.280590, -0.214520, 
-0.086560, -0.149200, 0.101630, -0.180030, -0.000320, 0.175870, -0.092190, -0.010900, 0.090020, -0.012310, 
0.032290, -0.152340, 0.071410, 0.369040, -0.107350, 0.073660, -0.539090, 0.209540, -0.494000, 0.688710, 
-0.204590, -0.167100, 0.787300, -0.484260, -0.321710, 0.168570, -0.105200, -0.320220, 0.383270, -0.233630, 
-0.121530, 0.103610, -0.266790, -0.326490, 0.393040, -0.272000, -0.297680, 0.676770, -0.275920, -0.292580, 
-0.235640, 0.101720, -0.326960, 1.103650, -0.555430, -0.137770, 1.200200, -1.102660, -0.092350, 0.065610, 
-0.111240, -0.237250, 0.306660, -0.183940, -0.015350, 0.188620, -0.120750, -0.164810, -0.070970, -0.144170, 
-0.247150, 0.316550, -0.075450, -0.134070, -0.505060, 0.229760, -0.368610, 0.594820, -0.244680, -0.251800, 
0.643040, -0.705210, 0.116650, -0.149120, 0.043320, 0.015300, 0.064870, -0.053010, 0.109380, 0.418930, 
-0.199520, -0.342590, 0.294020, -0.123160, 0.134480, 0.022890, -0.013750, -0.022240, -0.386650, 0.255020, 
-0.294650, 0.139510, 0.199070, -0.246240, 0.436560, -0.285060, 0.073740, -0.240580, 0.236650, 0.064580, 
-0.089500, 0.031310, 0.175090, 0.343200, -0.226960, -0.078220, 0.228720, -0.067540, 0.119090, 0.181630, 
-0.117440, -0.015480, -0.202430, 0.166250, -0.224840, 0.088240, 0.006400, 0.026360, 0.403140, -0.287520, 
0.042310, -0.330610, 0.317790, 0.077060, -0.299730, 0.291520, 0.207610, 0.122590, -0.185610, -0.002050, 
0.406460, -0.135840, 0.184680, 0.172350, -0.333840, 0.221990, -0.154090, 0.069670, -0.008880, 0.294790, 
0.168930, 0.114020, 0.017130, -0.027940, 0.010320, -0.167580, 0.408850, 0.022290, -0.143610, 0.301590, 
0.267400, -0.091400, -0.204950, 0.218560, 0.260000, -0.068370, 0.327520, -0.126280, -0.022510, 0.166860, 
-0.250240, 0.033650, -0.160770, 0.256880, 0.229600, 0.238870, 0.264280, -0.091010, -0.057740, 0.210360, 
0.229900, -0.002260, 0.299570, 0.080240, 0.171350, 0.141670, -0.089540, 0.228140, 0.079610, -0.125030, 
0.086360, 0.132770, 0.004200, -0.027310, 0.087060, 0.070560, 0.064370, 0.352210, 0.143110, -0.072290, 
0.682010, -0.246590, 
0.141760, -0.124470, -0.058020, 0.185370, 0.063090, -0.167590, -0.084600, 0.189330, -0.061020, -0.221700, 
0.082200, -0.118210, -0.154430, 0.078130, 0.079970, -0.103190, 0.071470, 0.035920, -0.201280, 0.293540, 
-0.086180, 0.008540, 0.201280, -0.191960, -0.013580, -0.085870, 0.003010, -0.008130, 0.031860, -0.049660, 
-0.212500, 0.004190, 0.041900, -0.124480, -0.057340, -0.052240, 0.004410, -0.203260, 0.032990, -0.109040, 
-0.120650, 0.118990, -0.040770, 0.472010, -0.281270, -0.114420, 0.428740, -0.220850, 0.006230, -0.125850, 
0.070170, -0.087820, 0.052000, 0.050520, -0.037050, 0.026630, -0.112960, 0.042560, -0.123410, -0.089220, 
0.193290, -0.166800, 0.035490, 0.062820, -0.268490, 0.081290, -0.024910, 0.474420, -0.310820, -0.097990, 
0.407770, -0.174620, 0.051280, -0.113330, 0.018850, -0.029990, -0.010980, 0.044970, 0.170450, -0.075260, 
-0.135080, 0.247190, -0.178040, -0.101800, 0.206830, -0.215000, -0.044210, 0.173300, -0.232240, 0.002550, 
-0.146390, 0.422620, -0.099340, 0.098210, 0.202360, -0.246330, -0.001030, -0.101460, -0.073940, -0.106900, 
-0.027890, 0.053860, 0.108340, -0.019310, -0.245500, 0.198010, -0.091620, -0.237200, 0.151710, -0.160400, 
-0.167910, 0.075230, -0.007070, -0.158360, -0.248960, 0.264280, 0.133320, -0.138300, 0.033500, -0.130490, 
-0.182450, -0.226270, -0.145140, -0.272360, -0.216300, -0.106960, 0.035620, -0.064870, -0.464870, -0.087890, 
-0.352620, -0.074680, -0.160780, -0.095010, -0.198110, 0.006500, 0.010190, -0.391560, -0.244160, -0.214020, 
0.085710, -0.271090, -0.320650, 0.252640, -0.411320, -0.304800, 0.343630, -0.296760, -0.525360, 0.508920, 
-0.004340, -0.074460, -0.049380, -0.009860, -0.528630, 0.347080, -0.012590, -0.255980, 0.075150, 0.179100, 
-0.359900, 0.093160, -0.438560, -0.274550, 0.422160, -0.381820, -0.407980, 0.604390, -0.150160, -0.182870, 
-0.157510, -0.116700, -0.276560, 0.019600, -0.082090, -0.227530, -0.188640, 0.222350, -0.388510, -0.125030, 
0.062710, -0.132600, -0.293650, 0.145610, -0.213590, -0.278310, -0.296500, -0.114060, 0.002870, -0.181510, 
-0.199960, 0.150790, -0.118480, -0.099030, 0.021770, -0.141380, -0.168100, 0.089850, -0.085570, -0.241580, 
0.012150, 0.158340, -0.134510, 0.052980, 0.049800, -0.049710, -0.068170, 0.059520, -0.059960, -0.096590, 
0.047580, 0.183220, -0.285260, -0.038550, 0.368010, -0.261490, -0.081940, -0.031800, 0.048240, -0.057260, 
-0.153520, 0.109130, -0.004680, -0.154160, -0.006270, 0.254480, -0.260960, -0.100910, -0.015680, -0.034150, 
0.143300, 0.111970, -0.137310, 0.042230, -0.025920, 0.488580, -0.300270, -0.122070, 0.441280, -0.279260, 
-0.012200, -0.102820, 0.078370, -0.153170, -0.003460, 0.066230, 0.063180, -0.135340, 0.069030, 0.238410, 
-0.098930, -0.145840, 0.055110, -0.080380, 0.170060, 0.163620, -0.171870, 0.092900, -0.193310, 0.419860, 
-0.126660, -0.105850, 0.428390, -0.216880, 0.091450, 0.010710, 0.004160, 0.086050, -0.023550, 0.028120, 
0.098960, -0.033390, 0.142920, 0.251020, -0.053820, -0.052970, 0.162820, 0.060340, -0.002050, 0.124150, 
-0.130250, 0.179830, -0.020990, 0.163860, 0.024470, -0.132980, 0.352270, -0.066480, 0.129110, 0.016700, 
0.058820, 0.241440, -0.097430, 0.030390, 0.134780, 0.054080, 0.085940, 0.031890, 0.025450, 0.018450, 
0.325830, -0.062820, -0.087430, 0.208850, -0.112340, 0.072830, 0.208670, 0.142300, -0.045990, -0.109250, 
0.397930, -0.027320, 
0.127490, -0.046080, 0.008870, 0.169040, -0.217830, 0.043120, -0.076070, -0.147320, 0.152530, 0.218310, 
-0.063730, -0.012800, -0.098390, 0.065790, 0.108370, 0.124320, 0.035840, 0.061160, 0.669350, 0.113070, 
-0.212030, 0.057870, 0.086900, 0.142270, 0.017820, -0.088750, 0.159530, -0.055990, -0.067640, 0.068900, 
0.017160, -0.027720, 0.061980, 0.041490, -0.092780, 0.006560, -0.091610, 0.104680, 0.162770, 0.320600, 
-0.254070, 0.090450, 0.262410, -0.035620, 0.204680, -0.019220, 0.010600, -0.058960, -0.021470, 0.005830, 
-0.057920, -0.175910, -0.023760, 0.115100, -0.086810, 0.046010, 0.007020, -0.049660, -0.042600, -0.054300, 
-0.338190, 0.199580, 0.122700, 0.082860, -0.253950, 0.052730, -0.008490, -0.133530, 0.115640, -0.174630, 
-0.350890, -0.109630, -0.196840, 0.111500, 0.091900, -0.140940, -0.213410, 0.280110, -0.152190, -0.270490, 
0.264730, -0.345270, 0.131150, -0.050680, -0.068640, -0.176060, 0.100870, -0.044460, -0.277840, 0.211350, 
-0.098320, -0.040290, -0.183690, -0.113010, -0.027150, -0.147430, -0.201640, 0.187230, -0.101480, -0.226940, 
0.074530, -0.032130, 0.105130, -0.257120, -0.052920, -0.519180, 0.240430, -0.334950, 0.100460, 0.047940, 
-0.192830, 0.032160, -0.190770, -0.093560, 0.013370, 0.065180, -0.318370, 0.068480, 0.135290, -0.116470, 
-0.086790, 0.269350, -0.459260, 0.069630, 0.119070, -0.368710, -0.060070, 0.058750, -0.218210, -0.335360, 
0.385830, -0.385300, -0.088070, 0.438470, -0.410020, -0.005180, -0.081450, -0.234730, 0.487960, 0.495150, 
-1.028900, 0.320470, 0.460600, -0.777190, -0.004440, 0.196490, -0.654640, 0.008770, 0.135310, -0.487700, 
-0.022270, 0.021390, -0.528380, -0.076880, 0.297780, -0.635190, 0.061290, 0.337560, -0.616810, -0.186590, 
-0.061170, -0.418450, 0.182080, 0.483560, -0.952530, 0.443960, 0.456160, -1.155100, -0.117720, -0.035110, 
-0.153880, -0.287450, 0.030310, -0.060860, -0.018210, -0.000350, -0.100110, -0.005530, 0.020120, -0.271980, 
-0.048810, -0.019210, -0.158910, -0.003900, -0.406420, 0.024650, -0.087490, 0.166190, -0.250140, 0.436700, 
-0.096720, -0.619970, -0.143790, -0.297640, 0.223950, -0.171900, -0.162340, 0.222920, 0.075770, -0.041620, 
0.022780, -0.256940, -0.181070, 0.274370, 0.038020, -0.273910, 0.219340, 0.112630, -0.521770, 0.268060, 
-0.149040, 0.149950, 0.401070, 0.114180, -0.244060, 0.232130, -0.076050, -0.339250, 0.227140, -0.064440, 
-0.055070, -0.030340, 0.195700, -0.029090, -0.042760, -0.027810, 0.001610, 0.094570, 0.000740, -0.020450, 
0.117120, 0.056270, -0.145080, 0.127240, -0.170910, 0.191110, 0.220100, 0.285990, -0.209280, 0.255290, 
-0.034390, -0.163970, 0.094490, 0.038830, 0.056060, -0.099990, 0.150930, -0.009760, 0.004420, -0.203000, 
0.326230, 0.033200, -0.109520, 0.142870, 0.067930, 0.046340, 0.082720, 0.054290, 0.235800, 0.060570, 
0.050120, 0.243040, -0.084650, 0.027580, -0.035830, -0.070050, 0.141000, -0.081950, 0.213220, 0.007130, 
0.044590, 0.085870, -0.002720, -0.272180, 0.187450, 0.197090, -0.101400, 0.038880, 0.247420, -0.202820, 
0.242590, -0.024760, 0.129010, 0.192400, 0.132280, 0.159210, 0.050380, 0.098340, 0.055640, 0.039320, 
0.030540, -0.106760, 0.356670, -0.094920, 0.046990, 0.309870, 0.000700, -0.058220, 0.317820, -0.098020, 
-0.253120, 0.502400, 0.134620, -0.234960, 0.489510, -0.023060, 0.314160, 0.289470, 0.054670, -0.017100, 
0.274200, -0.012670, 
-0.011030, -0.021940, -0.157320, -0.256820, 0.026640, -0.075350, -0.051960, -0.044220, -0.139360, 0.108610, 
0.074120, -0.046720, 0.036090, -0.202480, -0.059690, 0.064620, -0.010070, -0.081730, 0.563560, -0.052610, 
-0.427770, 0.039510, -0.275160, -0.013910, -0.073900, 0.018560, -0.086090, -0.240100, -0.002730, -0.049630, 
0.007660, -0.100930, -0.157880, -0.096630, -0.017450, -0.058450, 0.192340, -0.261930, -0.172550, 0.129180, 
0.002190, -0.187450, 0.515670, -0.231560, -0.248710, 0.187330, -0.452270, -0.027430, -0.056950, 0.017190, 
-0.119480, -0.077410, -0.063340, -0.144940, 0.097490, -0.092370, -0.257040, -0.160170, 0.184100, -0.153840, 
0.219200, -0.225270, -0.218560, -0.010770, 0.192460, -0.245220, 0.455000, -0.369740, -0.237910, 0.170450, 
-0.394380, -0.121600, -0.129200, 0.038850, -0.155140, 0.066910, -0.181660, -0.224870, 0.031170, -0.045230, 
-0.251800, -0.084100, 0.162920, -0.231810, 0.170830, -0.205140, -0.251130, -0.000440, 0.199330, -0.272120, 
0.153820, -0.197580, -0.180520, 0.157770, -0.290010, -0.197600, -0.272790, 0.134570, -0.181140, -0.001970, 
-0.179870, -0.246170, -0.024670, 0.080110, -0.285550, -0.171430, 0.167180, -0.213560, 0.026180, -0.049750, 
-0.236150, -0.145400, 0.199590, -0.237480, 0.125960, -0.009510, -0.325580, 0.022120, -0.178650, 0.020620, 
-0.184730, 0.033670, -0.200340, 0.101330, -0.276520, -0.237120, -0.085480, 0.159460, -0.216510, -0.016380, 
0.094990, -0.113410, 0.040640, 0.064810, -0.289490, -0.065940, 0.157470, -0.217120, 0.177060, 0.086260, 
-0.371990, 0.120650, -0.111270, -0.164490, 0.030490, -0.035910, -0.325600, 0.128480, -0.153850, -0.358540, 
-0.069260, 0.188650, -0.226220, 0.154760, 0.141180, -0.260930, 0.205190, -0.011940, -0.338390, -0.070670, 
0.120520, -0.309500, 0.195480, -0.005860, -0.299820, 0.411490, -0.184990, -0.405260, -0.071880, -0.095400, 
-0.061970, -0.189110, -0.156540, -0.021800, -0.185590, 0.089350, 0.048000, -0.039720, -0.021630, 0.100970, 
-0.100370, -0.062900, -0.001140, -0.026880, 0.058150, -0.034620, 0.084520, -0.145410, 0.051430, 0.197670, 
-0.237960, 0.090390, -0.105840, -0.173220, -0.050670, -0.116980, -0.166750, -0.040940, -0.327060, -0.022830, 
0.146070, -0.201640, -0.141550, 0.178810, -0.330500, -0.111480, 0.167500, -0.189270, -0.000530, 0.023800, 
-0.116890, -0.187340, 0.373880, 0.069750, -0.317860, 0.277830, 0.030930, -0.246700, 0.058980, 0.064280, 
-0.149300, -0.069570, -0.200910, 0.020560, 0.092730, -0.230650, -0.131770, 0.233550, -0.393380, -0.056210, 
0.250710, -0.218630, 0.098000, 0.025580, -0.226260, -0.104840, 0.363300, -0.080170, -0.057830, 0.145000, 
0.070530, -0.078900, -0.033250, 0.124980, 0.066080, -0.194640, -0.178130, 0.099710, 0.059530, -0.177590, 
-0.199270, 0.167020, -0.336700, 0.003770, 0.079840, -0.195730, 0.172570, -0.052980, -0.103030, 0.037220, 
0.064410, -0.287820, 0.143560, -0.064700, 0.113420, -0.058970, -0.122020, 0.096300, 0.061340, -0.161740, 
-0.032660, -0.030250, -0.048010, -0.108710, -0.248680, 0.088430, -0.159770, -0.102330, -0.013300, -0.104170, 
0.010120, -0.034400, -0.198870, 0.112800, -0.000700, -0.319010, 0.102120, -0.054560, 0.202560, -0.217380, 
-0.032630, 0.096840, -0.142590, 0.010890, 0.204260, -0.186060, -0.189180, 0.215950, -0.370430, -0.076960, 
0.089760, -0.192300, -0.075110, 0.140820, -0.148030, -0.080020, -0.060290, 0.059260, -0.135510, -0.109320, 
-0.104210, 0.142680, 
-0.016040, -0.155210, 0.076810, -0.179610, -0.095740, 0.106830, -0.328830, -0.107360, 0.408580, 0.187550, 
-0.031540, 0.164190, -0.353980, -0.143680, 0.404280, -0.060820, -0.025770, 0.262280, 0.070790, 0.023490, 
0.137300, -0.296120, -0.013920, 0.269010, 0.037370, -0.093450, -0.094680, -0.181410, -0.000780, -0.033070, 
-0.012450, -0.185160, 0.097290, 0.074730, -0.038840, 0.004040, -0.151970, -0.162610, 0.219840, 0.121800, 
-0.156050, -0.020460, 0.173540, -0.129130, 0.113580, -0.226080, 0.042200, 0.021510, 0.091740, -0.045490, 
-0.203030, -0.119820, -0.004820, -0.128160, -0.014830, -0.052680, -0.082210, 0.133390, 0.072320, -0.153830, 
-0.296020, -0.066690, 0.166270, -0.030740, -0.007570, -0.087380, 0.195690, -0.116790, -0.069170, -0.242140, 
0.081360, -0.223710, 0.172980, -0.034280, -0.316010, 0.048210, -0.118610, -0.239890, 0.089550, -0.084190, 
-0.129030, 0.040060, 0.177940, -0.271430, -0.080590, -0.075700, -0.026100, 0.041620, 0.071980, -0.190250, 
0.193000, 0.096460, -0.352110, -0.089140, 0.220170, -0.372170, 0.274270, -0.031190, -0.468680, 0.238990, 
-0.251780, -0.390250, 0.139140, -0.102570, -0.267180, -0.028090, 0.090230, -0.329960, 0.104360, -0.034580, 
-0.276970, 0.105540, -0.014970, -0.351240, -0.034630, 0.128760, -0.221560, 0.002800, 0.134640, -0.194670, 
0.244610, -0.020140, -0.512410, 0.361250, -0.271870, -0.354540, 0.088750, 0.020850, -0.297120, -0.017860, 
0.227970, -0.397050, -0.062670, 0.158000, -0.250040, 0.016070, 0.070540, -0.227900, 0.088590, 0.297100, 
-0.453670, 0.077240, 0.115010, -0.233610, 0.323620, -0.068590, -0.705400, 0.229850, -0.151200, -0.499180, 
0.146610, -0.017820, -0.437470, 0.052000, 0.219120, -0.479580, 0.136840, 0.126460, -0.509160, 0.037870, 
0.001030, -0.415280, 0.111100, 0.283750, -0.616830, 0.205030, 0.102440, -0.576820, 0.164440, -0.028250, 
-0.449930, -0.130600, -0.064540, -0.226270, 0.159680, 0.014960, -0.254970, 0.202840, 0.071580, -0.258180, 
0.122170, 0.038780, -0.330040, 0.046850, -0.024960, -0.175310, -0.059200, 0.190690, -0.336020, 0.172920, 
0.141950, -0.448250, 0.082230, -0.125060, -0.190170, -0.064210, -0.112420, -0.028350, 0.096650, 0.013080, 
-0.173050, 0.030830, -0.097040, -0.041150, 0.092600, -0.096600, -0.014180, 0.170560, -0.127510, -0.076710, 
-0.000640, 0.087050, 0.051900, -0.032200, -0.014710, 0.036500, 0.197800, -0.187380, -0.155390, 0.160290, 
-0.119860, -0.145720, 0.150990, 0.041580, -0.163180, 0.122520, -0.244060, 0.074700, -0.022810, -0.071160, 
0.156110, 0.141440, -0.090500, -0.038340, -0.155050, -0.097810, 0.329100, -0.089210, -0.176610, 0.287240, 
0.158210, -0.132260, -0.073140, 0.280870, -0.096120, -0.190960, 0.085650, 0.114140, -0.151870, -0.037880, 
0.003610, -0.036860, -0.179340, 0.039890, 0.103310, 0.096430, 0.138570, -0.102510, -0.033710, -0.188710, 
0.174220, -0.169600, -0.046520, 0.036500, 0.237810, -0.143110, -0.182690, 0.192470, -0.005800, -0.216950, 
0.000680, 0.122940, -0.139870, -0.013970, -0.054710, -0.051550, -0.318690, 0.029500, 0.150050, -0.050150, 
0.151390, -0.177400, 0.128890, -0.059220, -0.048450, -0.117740, 0.112980, -0.141760, 0.248030, -0.254450, 
-0.162720, 0.196260, -0.127760, -0.179330, -0.052630, 0.025630, -0.114470, 0.176310, -0.243070, -0.117420, 
-0.276700, 0.017400, 0.127870, -0.100560, 0.082560, -0.175690, -0.059210, 0.190800, -0.112010, -0.127750, 
0.119030, -0.172070, 
-0.236900, 0.043370, 0.069720, -0.465540, 0.181810, 0.062090, -0.063830, 0.177950, -0.138680, -0.051890, 
0.220800, 0.083510, -0.076230, 0.119380, 0.045630, 0.003130, 0.194870, -0.128040, 0.045590, 0.357130, 
-0.302640, -0.133010, -0.041730, 0.261870, -0.107490, -0.007740, -0.064230, -0.340180, 0.200330, -0.059850, 
-0.024590, 0.115410, -0.181400, -0.067530, 0.285250, -0.079770, 0.155370, -0.112570, 0.002350, -0.000650, 
0.169730, -0.211960, -0.007910, 0.187620, -0.093400, -0.217290, 0.186180, 0.039920, -0.075800, -0.102910, 
-0.017760, -0.089770, 0.053100, -0.184250, -0.020200, 0.017910, -0.166720, 0.035410, 0.147650, -0.310990, 
0.139160, -0.405290, 0.087310, -0.022370, 0.095560, -0.129580, 0.078520, -0.080230, -0.090060, -0.116230, 
0.130180, -0.041740, -0.026260, -0.210040, -0.054070, -0.166090, -0.034270, -0.194300, 0.117580, -0.219480, 
-0.104850, 0.136130, -0.102120, -0.256600, 0.209870, -0.545470, 0.171910, 0.148000, 0.043820, -0.250880, 
0.562130, -0.286980, -0.412770, 0.009110, -0.090760, -0.141020, -0.124080, -0.081770, -0.098040, -0.309320, 
-0.077690, -0.142290, -0.162190, -0.129250, -0.083450, -0.126790, -0.103160, -0.073080, 0.096710, -0.470600, 
0.074770, -0.049100, 0.094550, -0.220830, 0.494960, -0.146420, -0.261360, 0.076990, -0.180860, -0.060890, 
-0.238470, 0.056310, -0.122690, -0.329210, -0.103310, -0.008360, -0.328280, 0.071350, -0.031480, -0.310890, 
0.104880, 0.110180, -0.176370, -0.076760, -0.005340, -0.384850, 0.344680, -0.068120, 0.387730, -0.041750, 
-0.217270, -0.095310, -0.125370, 0.006430, 0.129540, 0.001260, -0.502860, -0.105130, -0.091140, -0.225610, 
-0.046250, 0.133190, -0.433440, 0.109600, 0.265270, -0.410220, 0.295050, 0.079700, -0.576260, -0.070820, 
0.337970, -0.452550, 1.040910, 0.221710, -1.075210, 0.318950, -0.011970, -0.461220, -0.287100, 0.011550, 
-0.134160, -0.152280, -0.173180, -0.143180, -0.124720, 0.138100, -0.360120, 0.011250, 0.207230, -0.277200, 
0.214380, -0.071320, -0.472990, -0.135310, 0.300600, -0.309550, 0.475290, 0.162350, -0.642940, 0.299720, 
0.064620, -0.353480, -0.222310, -0.044250, -0.163070, 0.021230, -0.210220, -0.196610, -0.060710, 0.253860, 
-0.573910, 0.281020, 0.106920, -0.363860, 0.088160, -0.068170, -0.481130, 0.075960, 0.358190, -0.540310, 
0.574810, 0.004570, -0.577440, 0.424230, 0.029320, -0.376560, -0.072680, -0.068250, -0.127280, 0.060590, 
-0.200320, -0.162500, -0.076170, 0.278200, -0.503600, 0.134910, 0.143680, -0.256870, 0.183360, -0.107850, 
-0.361210, 0.053720, 0.207580, -0.362780, 0.494930, 0.019840, -0.388890, 0.469080, -0.155510, -0.316950, 
-0.094530, -0.137490, 0.100870, -0.024070, -0.186500, -0.030090, 0.044500, 0.076840, -0.320020, 0.226220, 
-0.068080, -0.146860, 0.088140, -0.259020, -0.033000, -0.024950, 0.177960, -0.243580, 0.316130, -0.161590, 
-0.066730, 0.257680, -0.178690, -0.033160, -0.076520, -0.212930, 0.108690, -0.011540, -0.143780, -0.010120, 
-0.076350, -0.080050, -0.172680, -0.025370, -0.224450, 0.048120, -0.224820, -0.238770, 0.057400, -0.028150, 
0.156670, -0.277850, 0.138680, -0.281660, 0.233310, 0.322440, -0.296630, 0.073510, 0.024920, -0.181300, 
-0.038150, 0.025490, -0.065300, -0.092890, -0.080430, -0.062570, -0.035130, 0.168430, -0.378230, 0.151140, 
-0.161860, -0.200450, 0.137850, -0.131300, 0.199020, -0.202340, 0.119440, -0.198350, 0.225660, 0.235510, 
-0.423920, 0.146650, 
-0.252360, -0.034040, 0.037500, -0.276890, 0.070680, 0.013780, -0.170780, 0.094670, -0.038960, -0.157690, 
-0.142920, 0.142920, -0.311830, 0.099580, 0.131220, -0.188790, -0.037890, 0.061270, -0.303890, 0.320670, 
-0.034920, -0.221160, 0.259860, -0.083120, -0.246310, -0.104740, 0.169640, -0.235650, -0.060860, 0.152070, 
-0.174610, -0.080410, 0.123660, -0.074580, -0.048600, 0.140190, -0.173920, -0.057820, 0.151890, -0.229580, 
-0.010360, 0.115250, -0.175250, 0.231690, 0.017880, -0.252040, 0.312350, 0.003820, -0.196090, -0.118510, 
0.225230, -0.160540, -0.008540, 0.077910, -0.124510, -0.073470, 0.171850, 0.010710, -0.074960, 0.056960, 
-0.176060, -0.127550, 0.256970, -0.170930, 0.006570, 0.172080, -0.091450, 0.044000, 0.104780, -0.247280, 
0.183300, 0.178440, -0.142360, -0.116090, 0.084680, -0.128920, 0.051160, -0.102850, -0.023850, -0.075950, 
0.105460, 0.133310, -0.070350, -0.039680, -0.182860, -0.063610, 0.183980, -0.075770, 0.017530, 0.039630, 
-0.121930, 0.028210, 0.178950, -0.178820, 0.098650, 0.131270, -0.130550, -0.101120, -0.008300, -0.129990, 
0.005370, -0.133330, 0.041310, -0.072010, -0.031530, 0.184490, -0.105730, -0.125520, -0.106690, -0.165980, 
0.079000, -0.020480, 0.019450, -0.057900, 0.146880, -0.093910, 0.015250, 0.005570, -0.099930, 0.054720, 
-0.110990, -0.232060, -0.028070, -0.138070, -0.202470, -0.083000, -0.006990, -0.104050, -0.052070, 0.160150, 
-0.158770, -0.025370, -0.126080, -0.267730, 0.048790, -0.041360, -0.065490, -0.065070, 0.255590, -0.360350, 
-0.036750, 0.100200, -0.428410, 0.223520, 0.057200, -0.282520, -0.067140, -0.079190, -0.262520, 0.025770, 
-0.084570, 0.012120, -0.041690, 0.085220, -0.141400, 0.064380, 0.022970, -0.234600, -0.043270, 0.012270, 
-0.239670, 0.044550, 0.252350, -0.343530, -0.108370, 0.295280, -0.553270, 0.222560, -0.105070, -0.151020, 
-0.111720, -0.102870, -0.192090, -0.055600, -0.199260, -0.030940, -0.045330, -0.059560, -0.038390, -0.020940, 
-0.116870, -0.076700, -0.144150, 0.025250, -0.169030, -0.109890, 0.041480, -0.250410, -0.113870, 0.117790, 
-0.340140, 0.156930, -0.232620, -0.038460, 0.009510, -0.067980, -0.102370, -0.021530, -0.229980, -0.064340, 
0.010420, -0.065920, -0.154370, 0.032520, -0.205280, -0.006990, 0.004070, -0.041380, -0.009190, -0.117850, 
0.000090, -0.042350, -0.053020, -0.064410, 0.023080, 0.124930, -0.304340, 0.000950, 0.209610, -0.081900, 
-0.080940, 0.100570, -0.211380, 0.025760, 0.124610, 0.017460, -0.200260, 0.068800, -0.161960, 0.027910, 
0.126930, -0.048500, 0.055170, 0.056940, 0.043990, 0.136670, 0.027860, -0.123370, 0.050970, 0.189550, 
-0.242780, -0.050740, 0.231270, -0.067000, -0.028810, 0.027200, -0.171950, 0.024440, 0.174320, 0.073810, 
-0.074840, -0.013390, -0.111740, -0.007000, 0.207140, -0.142180, 0.062330, 0.110240, -0.034920, 0.096370, 
-0.045850, -0.010350, 0.058110, 0.080690, -0.155880, -0.152960, 0.152960, 0.051940, -0.208390, 0.011420, 
-0.072500, 0.035250, 0.089920, 0.011830, 0.031130, -0.101430, 0.027010, -0.013160, 0.037180, -0.062280, 
0.008210, 0.110290, 0.072650, -0.120560, 0.014900, -0.028390, 0.064050, -0.014540, 0.133040, -0.389460, 
0.020770, 0.259880, -0.413040, -0.077160, -0.027620, 0.077110, -0.025510, 0.107250, -0.082190, -0.039220, 
0.151140, -0.058830, -0.047320, 0.014970, -0.095030, 0.060860, 0.292600, -0.209270, -0.224160, 0.159430, 
-0.060280, -0.043290, 
-0.061190, 0.049670, -0.136350, -0.178790, 0.042380, -0.076160, -0.283140, 0.132020, 0.032070, -0.024270, 
0.160520, 0.003710, -0.219380, 0.039000, 0.044290, -0.105860, 0.130710, 0.034210, 0.267750, 0.047730, 
-0.179380, -0.035980, -0.037790, 0.011580, -0.011990, 0.055310, -0.135240, -0.169520, 0.071450, -0.088270, 
-0.096240, 0.022280, -0.023530, -0.122090, 0.094130, -0.025030, -0.048010, -0.071530, 0.017280, 0.075500, 
-0.021300, -0.067140, 0.245020, -0.045820, -0.095130, -0.059330, 0.016910, -0.076640, 0.025350, 0.022220, 
-0.121070, -0.051440, -0.011680, -0.087650, -0.006670, 0.032640, -0.113800, -0.039610, 0.135890, -0.105720, 
-0.135980, -0.049660, 0.011170, 0.016330, 0.033800, -0.098620, 0.279350, -0.106080, -0.165390, 0.023840, 
-0.063780, -0.195890, 0.031440, -0.059540, -0.095810, 0.045930, -0.147260, -0.087240, -0.009580, -0.070250, 
-0.037230, -0.004920, 0.041550, -0.131160, -0.003640, -0.170210, -0.018080, 0.048270, 0.007470, -0.118050, 
0.178820, -0.009920, -0.206630, 0.048250, 0.009360, -0.256020, -0.032860, -0.072040, -0.155450, 0.012930, 
-0.181830, -0.157760, 0.036580, -0.112180, -0.118620, -0.153340, -0.000010, -0.154900, 0.008570, -0.104660, 
-0.129090, -0.025350, -0.037600, -0.166800, 0.171550, -0.003440, -0.313160, 0.039270, -0.008480, -0.150860, 
-0.054260, -0.062950, -0.201960, 0.048000, -0.183710, -0.169820, 0.016510, -0.056550, -0.121950, -0.110680, 
0.074950, -0.169320, -0.106800, 0.021500, -0.083000, -0.088610, 0.001390, -0.101040, 0.167530, 0.168980, 
-0.441880, 0.162410, 0.021020, -0.264180, 0.101000, -0.076920, -0.408550, 0.062140, -0.093380, -0.334970, 
0.136480, -0.086740, -0.308960, 0.147540, 0.034510, -0.353330, 0.192950, -0.033000, -0.326590, -0.000730, 
-0.057910, -0.255400, 0.270170, 0.095100, -0.578000, 0.429040, -0.060440, -0.586420, 0.017340, -0.094440, 
-0.217250, -0.161510, -0.099510, -0.091550, -0.000500, -0.002520, -0.094910, 0.177920, -0.112680, -0.084990, 
0.082500, -0.042880, -0.184640, 0.021580, -0.089100, -0.075850, 0.203970, 0.009600, -0.326870, 0.475420, 
-0.129040, -0.411900, -0.034380, -0.151040, -0.064780, -0.084180, -0.129590, 0.005060, -0.128920, 0.010020, 
0.025010, -0.030220, -0.222030, 0.153080, -0.068380, -0.118740, 0.090090, 0.027100, -0.133890, 0.008510, 
0.150570, -0.036310, 0.049150, 0.242370, -0.214380, -0.003030, -0.021100, -0.204740, 0.074690, 0.024570, 
-0.098340, -0.053570, -0.115070, 0.054210, 0.092620, -0.060780, -0.162850, 0.213980, -0.173370, -0.048970, 
0.236450, 0.009290, -0.032840, 0.047620, 0.040730, -0.061800, 0.219480, 0.104900, -0.118070, 0.176310, 
-0.038370, -0.047660, 0.069610, 0.053580, 0.070910, -0.108560, -0.098970, 0.154480, 0.052050, -0.077920, 
0.002690, 0.087230, -0.209920, 0.077520, 0.118040, -0.019310, 0.165430, -0.042630, 0.043050, -0.026400, 
0.080850, 0.011590, 0.036930, -0.025610, 0.019470, -0.025810, -0.023950, 0.022760, 0.126780, -0.096010, 
-0.064620, 0.098640, 0.007780, -0.137970, -0.018770, 0.078580, -0.219450, -0.007650, 0.143380, -0.131180, 
0.147080, -0.036410, -0.062740, 0.105630, 0.001410, -0.133950, 0.157160, -0.011870, 0.073690, -0.160070, 
0.037970, -0.001500, 0.002500, -0.005960, -0.010500, 0.015600, 0.019230, 0.099750, -0.112220, -0.020570, 
-0.103790, -0.006690, 0.126280, -0.098720, 0.054650, 0.006720, -0.105140, 0.089730, 0.104390, -0.103300, 
0.007380, 0.071740, 
0.018980, -0.028390, 0.008390, 0.033680, 0.184250, -0.153390, -0.087360, 0.133630, 0.047680, -0.104310, 
-0.053980, 0.028260, -0.180170, 0.139570, 0.187200, -0.074110, -0.023150, 0.133410, -0.240150, 0.269500, 
-0.003720, -0.138060, 0.289730, -0.074320, -0.051310, -0.059100, 0.053150, -0.106500, 0.131380, -0.063790, 
-0.153470, -0.018210, 0.084570, 0.020970, -0.077110, -0.053790, 0.024780, -0.147070, 0.078680, -0.075820, 
-0.135230, 0.156700, -0.191170, 0.319710, -0.040740, -0.292850, 0.409200, -0.001260, 0.013530, -0.108210, 
0.058110, -0.133070, 0.154520, -0.027600, 0.052760, -0.018450, -0.021200, 0.094370, -0.063740, -0.144540, 
0.223610, -0.161050, 0.067550, 0.085800, -0.201170, 0.064350, -0.237580, 0.377880, -0.065360, -0.265170, 
0.249160, 0.067080, 0.079200, -0.130880, 0.039810, -0.069160, 0.007620, 0.055520, 0.186310, -0.106250, 
0.027170, 0.227770, -0.090090, -0.068420, 0.148200, -0.240830, 0.088280, 0.103120, -0.136530, 0.062160, 
-0.181650, 0.325180, 0.041010, -0.087730, 0.067240, -0.038380, 0.037490, -0.174440, -0.002640, -0.154120, 
-0.066230, 0.120660, 0.138510, -0.092650, -0.100810, 0.229870, -0.194660, -0.136220, 0.072850, -0.243200, 
0.023630, 0.049570, -0.008730, -0.063530, -0.179730, 0.127190, 0.187870, -0.225200, -0.121680, 0.040710, 
-0.102450, -0.354220, -0.086480, -0.219120, -0.326250, -0.020710, 0.101990, -0.154490, -0.356210, 0.003780, 
-0.511290, 0.098410, -0.056130, -0.217190, -0.130960, 0.002790, -0.088560, -0.260320, -0.061460, -0.342560, 
-0.101410, -0.262910, -0.555640, 0.323640, -0.212490, -0.421510, 0.225700, -0.245850, -0.615620, 0.453690, 
0.029750, -0.218140, 0.032790, 0.126980, -0.727950, 0.351170, 0.154750, -0.465160, 0.041800, 0.257060, 
-0.550250, 0.107830, -0.148900, -0.443090, 0.155860, -0.282400, -0.657750, 0.597930, -0.036850, -0.270230, 
-0.194290, -0.135510, -0.386410, 0.080660, -0.055100, -0.315930, -0.118530, 0.179650, -0.429760, -0.001900, 
-0.011420, -0.253550, -0.171550, 0.098260, -0.304010, -0.185450, -0.369150, -0.252190, 0.062970, -0.318250, 
-0.161100, 0.227790, -0.030430, -0.120250, -0.064340, -0.117780, -0.259270, 0.090110, 0.019340, -0.294040, 
0.014090, 0.154570, -0.207770, 0.071390, -0.068250, -0.033860, -0.064970, 0.062730, -0.001440, -0.088410, 
-0.042260, 0.163500, -0.224460, -0.224780, 0.349810, -0.081000, -0.019860, -0.029540, -0.046450, -0.057300, 
-0.145580, 0.100830, 0.006500, -0.123890, 0.037340, 0.231380, -0.224920, -0.047140, -0.119760, 0.060520, 
0.163730, 0.041770, -0.007060, 0.083960, -0.168650, 0.485890, -0.058230, -0.225330, 0.405050, -0.103820, 
-0.019580, -0.153130, 0.086690, -0.165800, 0.015020, 0.019840, 0.049520, -0.023240, 0.082960, 0.164500, 
0.073190, -0.179910, -0.009910, 0.045400, 0.169870, 0.005100, -0.000950, 0.141860, -0.166720, 0.295470, 
-0.057240, -0.240390, 0.441200, -0.133790, 0.025390, -0.088610, 0.084040, 0.021070, -0.066440, 0.072670, 
0.032920, 0.053730, 0.181830, 0.153980, 0.064060, -0.063780, 0.034700, 0.138090, 0.095910, -0.062480, 
0.009190, 0.267560, -0.064750, 0.053300, 0.115210, -0.246120, 0.323600, 0.004270, 0.126560, -0.098900, 
0.081780, 0.181690, -0.180640, 0.065220, 0.080850, 0.101960, 0.086360, 0.007000, 0.120750, -0.036450, 
0.172480, 0.031700, -0.067740, 0.119550, 0.040000, 0.077760, 0.218470, 0.111210, -0.128890, -0.107890, 
0.301550, -0.028530, 
-0.007120, -0.015490, -0.098050, -0.044550, -0.022830, -0.054530, -0.062600, 0.010480, -0.053980, -0.014780, 
0.025210, -0.035930, -0.056050, -0.013310, -0.049200, -0.021380, -0.003690, -0.056500, 0.025850, -0.013520, 
-0.050080, -0.029380, -0.051440, 0.004860, -0.011450, -0.016200, -0.081750, -0.040740, -0.016550, -0.045080, 
-0.030260, -0.000150, -0.065220, -0.039370, 0.004200, -0.033930, -0.023430, -0.013050, -0.040190, 0.002990, 
-0.011160, -0.067560, 0.030520, -0.045790, -0.041570, -0.036110, -0.044540, -0.036850, -0.001180, -0.013320, 
-0.072180, -0.009870, -0.032790, -0.060330, -0.048070, -0.001870, -0.043800, -0.051280, 0.005390, -0.040070, 
-0.076160, -0.034980, -0.016150, -0.028100, -0.018420, -0.047710, 0.024790, -0.061750, -0.045900, -0.046860, 
-0.037990, -0.038200, -0.012480, -0.040710, -0.067970, 0.005880, -0.049540, -0.067380, -0.078930, -0.039230, 
-0.005960, -0.065150, 0.002920, -0.053730, -0.070530, -0.051490, -0.019780, -0.029340, -0.021810, -0.039980, 
-0.000220, -0.070480, -0.028950, -0.048000, -0.037440, -0.034080, -0.034470, -0.028240, -0.082040, -0.020020, 
-0.057040, -0.080570, -0.061670, -0.039790, -0.034750, -0.091140, -0.026340, -0.057480, -0.034090, -0.059990, 
-0.046580, -0.028300, -0.053270, -0.081480, 0.031850, -0.071160, -0.108940, -0.035180, -0.033150, -0.014310, 
-0.024660, -0.029880, -0.063160, -0.011300, -0.060280, -0.046460, -0.075270, -0.045700, -0.008930, -0.061280, 
-0.013880, -0.039300, -0.054990, -0.043200, -0.021770, -0.037860, -0.054650, -0.022740, 0.028790, -0.032530, 
-0.079070, 0.014590, -0.056250, -0.029420, 0.055900, -0.040980, -0.161370, 0.024730, -0.051720, -0.130870, 
0.001830, -0.049440, -0.112750, 0.039830, -0.006510, -0.143290, 0.044430, -0.033320, -0.136780, -0.003550, 
-0.043350, -0.103180, 0.104170, -0.030200, -0.168490, 0.127330, -0.074760, -0.162130, 0.002660, -0.058690, 
-0.062850, -0.020870, -0.048930, -0.068690, -0.036910, -0.010030, -0.048770, -0.002390, -0.019500, -0.035180, 
0.008650, -0.041130, -0.063680, -0.009310, -0.043350, -0.043550, 0.075780, -0.042480, -0.095320, 0.115780, 
-0.096540, -0.086150, -0.010320, -0.066040, -0.067290, 0.000200, -0.054800, -0.063470, -0.061260, 0.004440, 
-0.058690, -0.038420, -0.039940, -0.020720, -0.016900, -0.019320, -0.074580, -0.013610, -0.049670, -0.053350, 
0.050960, -0.036570, -0.059670, 0.088140, -0.115750, -0.021510, -0.027480, -0.045010, -0.040110, -0.010530, 
-0.023880, -0.065620, -0.062980, 0.019750, -0.048510, -0.045320, -0.027990, -0.011730, -0.036090, -0.015770, 
-0.030660, -0.038520, -0.009090, -0.032000, 0.029060, -0.062750, -0.021400, 0.031680, -0.091080, 0.018630, 
-0.050920, 0.013210, -0.021680, -0.007150, 0.006230, -0.053600, -0.058360, 0.023710, -0.015640, -0.054450, 
-0.002110, 0.007350, -0.070420, 0.017960, -0.027740, -0.042410, 0.031400, -0.038940, 0.012410, -0.044100, 
-0.023860, 0.004080, -0.036400, -0.009150, -0.050290, 0.011700, -0.020550, -0.049320, 0.033660, -0.044520, 
-0.064860, 0.016500, -0.019310, -0.086010, 0.000070, 0.003360, -0.088510, -0.004330, 0.013280, -0.076730, 
0.044010, -0.038610, -0.035450, -0.007840, -0.021970, -0.038670, 0.004280, -0.013900, -0.060810, -0.021030, 
-0.001330, -0.055380, 0.024350, -0.023910, -0.066540, -0.003960, 0.010940, -0.033570, -0.021340, 0.002000, 
-0.093180, -0.002700, 0.039610, -0.094630, 0.028150, 0.006150, -0.059520, -0.003780, 0.015810, -0.032950, 
-0.033730, 0.012230, 
-0.014130, -0.362280, 0.073580, 0.003710, -0.298510, 0.067860, -0.058240, -0.175810, -0.096310, -0.174040, 
-0.250820, -0.210690, -0.000490, -0.262460, -0.014540, -0.137640, -0.340220, 0.025200, -0.033040, -0.262260, 
0.003650, -0.023060, -0.331830, -0.076460, 0.082030, -0.319270, -0.081380, 0.019140, -0.259200, -0.040310, 
-0.265380, -0.101010, -0.124490, 0.000240, -0.097860, -0.213870, 0.053980, -0.235260, -0.259310, -0.161770, 
-0.311120, -0.036840, 0.187300, -0.499330, 0.138370, -0.067920, -0.182430, 0.006160, 0.032630, -0.309930, 
-0.031780, -0.166710, -0.204260, 0.087220, -0.140780, -0.016330, -0.128340, 0.000350, -0.130940, -0.037420, 
0.129740, -0.094300, -0.096800, -0.177290, -0.255210, 0.084930, 0.428850, -0.343780, -0.078730, 0.119910, 
-0.267350, -0.052590, -0.036420, -0.210630, -0.150050, -0.390310, -0.089110, 0.120550, 0.005680, -0.116670, 
-0.175700, 0.070120, -0.149930, -0.044610, -0.087100, -0.085970, 0.018580, -0.191050, -0.230290, 0.020530, 
0.332580, -0.145120, -0.170070, 0.458260, -0.441530, -0.471620, -0.029500, -0.154240, -0.206040, -0.277600, 
-0.042930, 0.106580, -0.105810, -0.178560, 0.097800, -0.025920, -0.227460, 0.116750, -0.147260, -0.038140, 
0.165920, -0.232580, -0.071140, 0.134750, 0.120470, -0.409320, 0.367990, 0.447700, -0.663030, -0.283520, 
-0.124720, -0.144900, -0.223300, -0.307300, -0.171000, -0.001500, -0.174270, -0.053150, -0.040700, -0.217060, 
-0.331730, 0.318650, -0.535010, 0.073080, 0.396680, -0.339820, 0.118720, 0.108110, -0.115380, -0.424850, 
0.291510, -0.041100, -0.546440, 0.284880, -0.532590, -0.059750, 0.263870, -0.406290, -0.258860, 0.429010, 
-0.500720, 0.004370, 0.524360, -0.533920, -0.048400, 0.596410, -0.856070, 0.075110, 0.786240, -0.458680, 
-0.156740, 0.671690, -0.592120, -0.350910, 0.806210, -0.565730, -0.423590, 0.838750, -0.179890, 0.041010, 
-0.215760, -0.146620, -0.192220, 0.130030, -0.093190, -0.104850, 0.055500, 0.039220, -0.024260, 0.009880, 
-0.223150, 0.025330, 0.140490, -0.270000, -0.080220, 0.149930, -0.415350, -0.483570, 0.495640, -0.110720, 
-0.281920, 0.359850, 0.036130, -0.056580, -0.054430, -0.167230, -0.111420, 0.232640, 0.115250, -0.108340, 
0.194280, 0.169320, 0.002250, 0.088070, 0.026590, -0.139310, 0.436760, -0.057040, 0.069420, 0.289920, 
0.080040, -0.364740, 0.118070, 0.028310, -0.013540, -0.004440, 0.177740, -0.169060, -0.044820, 0.019640, 
-0.155390, 0.115650, -0.069080, 0.056450, 0.188370, 0.174020, -0.060840, -0.018290, -0.127260, 0.097310, 
0.382750, -0.037200, 0.083040, 0.194490, 0.209840, -0.204400, 0.259180, 0.077570, -0.301660, 0.150190, 
0.192580, -0.381960, 0.099030, -0.062120, -0.209410, 0.181750, 0.154310, 0.095100, -0.024560, 0.259020, 
0.095670, -0.157060, 0.089460, 0.093730, 0.205830, 0.182780, -0.116680, 0.119390, -0.067620, -0.217180, 
0.367150, 0.231360, -0.164840, -0.003070, 0.117340, -0.330550, 0.102420, -0.027110, -0.285020, 0.154840, 
-0.103480, 0.068390, 0.128380, 0.319750, -0.177650, -0.049780, -0.082870, 0.120130, 0.190130, -0.011820, 
-0.297180, 0.298170, 0.155380, -0.299990, 0.170990, -0.092020, -0.166450, 0.097400, 0.107720, -0.303020, 
0.042210, 0.157200, -0.447200, 0.113390, -0.265890, 0.030100, 0.094140, -0.103000, -0.200700, 0.046650, 
-0.208430, -0.072180, 0.004430, -0.011020, -0.322570, 0.105950, 0.086150, -0.220980, 0.019940, -0.091770, 
-0.040800, -0.120290, 
0.111110, 0.166660, -0.028490, 0.041120, 0.167800, 0.006250, 0.007330, 0.071990, 0.142880, -0.166890, 
0.210910, 0.007140, 0.148560, 0.031190, 0.156400, 0.022820, 0.039990, 0.110660, -0.053750, 0.052460, 
0.024280, -0.014040, 0.058780, 0.194780, 0.249340, 0.070800, -0.116990, 0.054350, 0.147430, -0.028990, 
-0.011040, -0.020180, 0.148750, -0.085740, 0.242630, -0.066200, 0.129300, -0.025520, 0.136280, 0.069450, 
-0.088100, 0.191390, 0.018010, -0.145700, 0.167860, -0.072780, 0.059590, 0.137960, 0.302260, -0.074560, 
-0.104910, -0.056570, 0.092930, 0.103760, 0.046860, 0.076170, 0.003510, -0.176570, 0.387520, -0.119320, 
0.041740, 0.001640, 0.208850, -0.084240, -0.079540, 0.136970, 0.059320, -0.134090, 0.329680, -0.090900, 
-0.026820, 0.043260, 0.264210, -0.117160, -0.186350, -0.155220, -0.005200, 0.211060, -0.011350, 0.131970, 
-0.269920, -0.177370, 0.104460, -0.109830, 0.075630, 0.032330, 0.033720, -0.140400, -0.140280, 0.046060, 
-0.275460, -0.012190, 0.131170, -0.342900, -0.023850, -0.168740, 0.067550, -0.059150, -0.208930, -0.250210, 
0.051630, 0.073790, -0.201690, 0.069380, -0.226150, -0.336460, 0.108410, -0.144100, -0.271500, 0.193230, 
0.031400, -0.365540, 0.029130, 0.050510, -0.597360, 0.222380, 0.089890, -0.529560, -0.017710, -0.177730, 
-0.193790, 0.099530, -0.199110, -0.364330, 0.144820, 0.025750, -0.297510, 0.040440, -0.260520, -0.552810, 
0.141030, -0.122800, -0.363290, 0.233560, 0.014230, -0.499900, 0.135740, 0.015550, -0.683230, 0.237800, 
-0.136960, -0.741760, 0.171850, -0.069340, -0.554650, 0.151860, 0.058400, -0.551040, 0.033630, 0.250260, 
-0.377480, -0.033200, 0.166260, -0.737620, 0.258470, 0.192330, -0.543360, 0.135710, 0.358440, -0.682970, 
0.126680, 0.338730, -0.708270, 0.066890, 0.141370, -0.896620, 0.259520, 0.164600, -0.237310, 0.060800, 
-0.145190, -0.311170, -0.062630, 0.054840, -0.112000, 0.023160, -0.057940, -0.401880, 0.017390, 0.168470, 
-0.316310, 0.084390, 0.208930, -0.415160, 0.014320, 0.250320, -0.649040, -0.079100, 0.395020, -0.792590, 
0.219890, 0.148730, 0.009430, -0.068060, -0.229890, -0.187530, -0.068640, -0.066120, 0.064730, 0.103870, 
-0.099660, -0.039170, 0.022340, 0.066000, 0.029110, 0.042260, 0.181710, -0.051260, -0.014010, 0.231730, 
-0.298160, -0.192760, 0.199250, -0.340300, -0.035570, 0.022780, 0.050760, -0.116540, -0.172400, -0.082960, 
-0.091900, -0.015410, 0.080450, 0.106940, -0.078830, 0.046740, -0.010030, -0.005270, 0.160190, 0.112710, 
0.147350, 0.112150, -0.011920, 0.164450, -0.045430, -0.253140, 0.066870, -0.082530, -0.188650, -0.046420, 
0.045120, -0.139260, -0.031140, -0.043800, -0.102380, 0.050290, 0.003680, 0.250290, -0.085130, -0.027580, 
0.224050, 0.013020, -0.018520, 0.105960, 0.217550, 0.002320, 0.011570, 0.211080, 0.026560, -0.105090, 
0.111930, -0.081790, 0.030700, -0.064490, 0.029690, -0.010530, -0.093180, 0.071040, -0.136880, -0.017070, 
-0.222850, 0.233560, 0.030390, -0.072560, 0.111060, 0.018560, -0.267970, 0.142050, 0.236770, -0.325920, 
0.019690, 0.273740, 0.119380, -0.109310, -0.018420, -0.083140, -0.095440, -0.142050, 0.080110, 0.096840, 
-0.128330, 0.132340, -0.023630, -0.073590, -0.013780, 0.079700, -0.163840, 0.031300, 0.148360, -0.157930, 
-0.226180, 0.057500, -0.022580, -0.141140, 0.094480, -0.007540, 0.388770, 0.105700, -0.293910, -0.045650, 
-0.084080, -0.259060, 
-0.164510, -0.009090, -0.043870, -0.189770, 0.039610, -0.040010, -0.121090, 0.085010, -0.098190, -0.097270, 
-0.107500, 0.065410, -0.205540, 0.050050, 0.057820, -0.132720, -0.033320, 0.011530, -0.199170, 0.249500, 
-0.081400, -0.128750, 0.101420, -0.050340, -0.195720, -0.034820, 0.062770, -0.183960, -0.020470, 0.067040, 
-0.169710, -0.014210, 0.066540, -0.053230, -0.033940, 0.083160, -0.160620, -0.033750, 0.091400, -0.181920, 
0.019420, 0.061140, -0.135780, 0.238100, -0.051660, -0.173200, 0.206110, 0.008940, -0.195520, -0.058910, 
0.123780, -0.153480, 0.020900, 0.010160, -0.156250, -0.002020, 0.108820, -0.036150, -0.029560, 0.053990, 
-0.167950, -0.082460, 0.168400, -0.153540, 0.041850, 0.095950, -0.086170, 0.111910, 0.015260, -0.194800, 
0.187900, 0.122700, -0.149290, -0.088150, 0.059250, -0.112720, 0.025640, -0.097470, -0.090220, -0.034900, 
0.104560, 0.038580, -0.036370, -0.008870, -0.200710, -0.046710, 0.140440, -0.096060, 0.080550, -0.004960, 
-0.137240, 0.071140, 0.140810, -0.193330, 0.119570, 0.126490, -0.112080, -0.112250, -0.021510, -0.096010, 
-0.036120, -0.116130, -0.040710, -0.038050, -0.013680, 0.108550, -0.079760, -0.083670, -0.126490, -0.133490, 
0.048540, -0.044960, 0.010350, -0.062260, 0.054170, -0.064980, 0.033450, -0.063930, -0.072260, 0.044530, 
-0.058270, -0.222830, -0.038080, -0.075460, -0.225240, -0.074380, -0.029400, -0.098800, -0.043600, 0.128690, 
-0.163760, 0.008790, -0.104960, -0.205830, 0.018730, -0.026850, -0.110820, -0.043220, 0.154760, -0.281730, 
-0.034170, 0.032010, -0.332630, 0.170490, 0.105880, -0.276460, -0.060130, -0.005160, -0.301600, 0.014860, 
-0.036990, -0.047630, -0.048630, 0.144580, -0.207860, 0.046150, 0.095540, -0.220250, -0.066270, 0.067240, 
-0.260280, 0.035150, 0.234680, -0.295650, -0.070560, 0.209150, -0.459120, 0.179140, -0.015420, -0.203660, 
-0.098290, -0.031030, -0.244490, -0.060650, -0.152780, -0.069840, -0.060250, -0.004600, -0.128910, -0.022990, 
-0.032570, -0.138230, -0.150460, 0.038760, -0.188280, -0.096230, 0.041710, -0.208430, -0.083910, 0.076060, 
-0.283510, 0.119400, -0.119760, -0.096340, -0.000160, 0.030290, -0.172140, -0.052420, -0.175780, -0.073700, 
-0.043560, -0.024820, -0.196530, 0.043060, -0.116530, -0.044030, -0.051370, -0.007320, -0.066820, -0.118350, 
0.039350, -0.039850, -0.100600, -0.036770, 0.007170, 0.064730, -0.192910, -0.021150, 0.119850, 0.012700, 
-0.116150, 0.039730, -0.130420, -0.009460, 0.040470, 0.049350, -0.209640, 0.029150, -0.063900, -0.026390, 
0.040440, -0.009690, 0.000290, 0.022870, 0.046580, 0.113230, -0.010780, -0.128590, 0.054820, 0.142730, 
-0.179150, -0.026170, 0.141570, -0.028480, -0.020170, -0.015210, -0.115810, 0.006240, 0.113500, 0.070200, 
-0.088400, -0.027780, -0.059810, -0.043040, 0.116550, -0.091420, 0.026060, 0.071900, -0.056970, 0.085540, 
-0.013430, -0.047660, 0.044640, 0.095530, -0.113640, -0.066990, 0.036980, 0.022840, -0.115410, -0.062580, 
-0.046170, 0.033240, 0.039810, -0.016820, 0.025270, -0.085860, 0.017610, -0.013430, -0.019160, -0.047780, 
0.007430, 0.033080, 0.004940, -0.074430, 0.014650, -0.047260, 0.033830, 0.004990, 0.049890, -0.221590, 
-0.038570, 0.132350, -0.248950, -0.108720, -0.046680, 0.098860, -0.032020, 0.028080, -0.028510, -0.054580, 
0.094690, -0.007350, -0.063560, -0.037500, -0.022800, 0.033150, 0.155640, -0.134870, -0.141620, 0.077770, 
-0.023210, -0.030840, 
0.085870, 0.082410, -0.064220, -0.004660, 0.053620, 0.101780, -0.031050, 0.191660, 0.073960, 0.052630, 
0.065770, -0.257380, -0.018040, -0.077060, 0.063430, -0.112910, 0.124720, 0.174400, 0.156960, -0.015320, 
0.018060, -0.026600, 0.039470, -0.055220, 0.048120, 0.145190, -0.079180, 0.144050, 0.100290, -0.105210, 
-0.225840, 0.173240, 0.131020, -0.024180, 0.296920, -0.164240, -0.071200, 0.049660, -0.117060, -0.011840, 
0.078300, 0.136640, 0.116780, 0.066780, -0.075380, 0.108240, 0.076830, 0.034180, -0.008050, -0.068310, 
0.055600, -0.027690, -0.038310, 0.080750, -0.066060, -0.036810, -0.008850, 0.103980, 0.048150, -0.027240, 
-0.004570, 0.191870, -0.146260, 0.042160, -0.124570, -0.003010, 0.192400, 0.127940, 0.074520, -0.071880, 
0.030200, 0.121200, -0.218060, 0.018120, 0.039760, -0.112400, -0.123580, 0.169010, -0.021950, -0.025940, 
-0.189940, 0.157830, -0.134580, -0.009860, 0.041820, 0.207520, -0.331950, -0.004280, -0.258700, -0.001000, 
-0.137870, 0.275550, 0.255260, -0.004410, -0.190190, 0.033660, -0.162990, 0.053160, -0.336020, 0.084530, 
0.071920, -0.232320, -0.132310, 0.064050, -0.131130, -0.158240, 0.068070, -0.282730, -0.157010, 0.457590, 
-0.421650, -0.158330, -0.123540, -0.070940, -0.275750, 0.147400, -0.062490, 0.152560, -0.159370, -0.299160, 
-0.139960, 0.117210, -0.637930, -0.202940, 0.045780, -0.453740, -0.042430, 0.040990, -0.437310, -0.093430, 
-0.110920, -0.380570, -0.320400, 0.305950, -0.254830, -0.240290, 0.129880, -0.295660, -0.600460, 0.052380, 
-0.119910, 0.168800, -0.102200, -0.359580, -0.828760, 0.035640, 0.062810, -0.521600, -0.091620, 0.009690, 
-0.418700, 0.073920, 0.049690, -0.803570, 0.237010, 0.245470, -0.898920, 0.187800, 0.524920, -0.701500, 
0.060490, 0.330080, -1.394800, -0.079330, 0.818820, -0.544250, -0.234900, 0.500140, 0.094860, -0.072050, 
-0.770000, 0.033040, -0.139480, -0.395780, 0.133690, -0.109660, -0.446810, 0.311410, -0.297200, -0.276620, 
-0.194230, 0.086680, -0.162850, -0.165190, -0.053230, -0.304750, 0.391910, -0.379940, -0.349990, 0.881200, 
-0.803320, -0.364440, 0.340040, -0.289840, -0.490040, -0.030410, -0.154310, -0.218770, 0.296210, -0.375500, 
-0.068170, 0.356600, -0.304970, -0.151650, 0.398860, -0.186270, -0.074670, -0.000040, -0.280830, 0.085610, 
0.773220, -0.568590, -0.379820, 1.349560, -0.846500, -0.527170, 0.163700, -0.437840, -0.075300, -0.020920, 
-0.430640, 0.027230, -0.066720, -0.449840, 0.248500, 0.048210, -0.392370, -0.054410, -0.103590, -0.286020, 
0.353130, -0.188260, -0.377830, 0.235620, 0.800490, -0.587660, -0.517570, 0.834700, -0.849000, -0.121930, 
0.074970, -0.439140, 0.039070, 0.024450, -0.506920, 0.188350, -0.178990, -0.432920, 0.355340, -0.102290, 
-0.230450, 0.069950, -0.077100, -0.254010, 0.239010, -0.065640, -0.459560, 0.204120, 0.255380, -0.450050, 
-0.173600, 0.477980, -0.635030, -0.177400, 0.190860, -0.308920, -0.176550, 0.117670, -0.425360, -0.025500, 
-0.267980, -0.338770, 0.348840, -0.158470, -0.144090, 0.033750, -0.006430, -0.129950, -0.034740, -0.362990, 
-0.296450, 0.255950, 0.248390, -0.389810, -0.355540, 0.054600, -0.512490, -0.051300, 0.176000, -0.345680, 
-0.045990, 0.214660, -0.540320, 0.096920, -0.145760, -0.283730, 0.143790, -0.199900, -0.286240, 0.070340, 
0.243470, -0.290850, -0.214450, -0.067780, -0.434110, 0.156070, 0.361660, -0.365200, -0.274880, 0.021380, 
-0.321810, -0.123280, 
0.006810, -0.239740, 0.077580, -0.155190, -0.120210, 0.183260, -0.220700, 0.097330, -0.023810, -0.127170, 
0.028600, -0.360670, -0.103940, -0.066670, -0.033730, -0.114460, -0.122200, 0.051500, -0.008840, -0.302890, 
0.083820, -0.248390, -0.011210, -0.137250, 0.165400, -0.246430, -0.094650, 0.124840, -0.225280, -0.064980, 
-0.258430, -0.048640, -0.012470, -0.001900, 0.152930, -0.241280, 0.066030, -0.029810, -0.284070, -0.026170, 
-0.173010, -0.013590, 0.228360, -0.565270, 0.322740, -0.012260, -0.210440, 0.042320, 0.164910, -0.358480, 
0.018810, 0.015980, -0.285930, 0.108840, -0.169870, 0.014900, -0.075560, 0.136910, -0.005620, -0.073310, 
0.136050, 0.087690, -0.180450, -0.087730, -0.167980, 0.010000, 0.283920, -0.352330, 0.466620, 0.083190, 
-0.375540, 0.106940, 0.027140, -0.245650, -0.194680, -0.204930, -0.242440, 0.088640, -0.143250, -0.045690, 
-0.203290, 0.039000, -0.000320, -0.156860, -0.094180, 0.114120, -0.218680, -0.093590, -0.177350, -0.100110, 
-0.046520, -0.072840, 0.288170, 0.083410, -0.410890, -0.318780, -0.046720, -0.154780, -0.448270, -0.105320, 
-0.144880, -0.130520, -0.382790, -0.066390, -0.017960, -0.198140, -0.028450, -0.278550, -0.448660, 0.237270, 
-0.082200, -0.293260, -0.027000, -0.082860, -0.271310, -0.235960, 0.318680, 0.484430, -0.586340, -0.546920, 
-0.174940, -0.073890, -0.505350, -0.329730, -0.156890, -0.207610, -0.403760, 0.046860, -0.173020, -0.402030, 
-0.107570, -0.099340, -0.813270, 0.314810, 0.210330, -0.541060, 0.341090, -0.169770, -0.443180, -0.268880, 
0.257590, 0.334070, -0.486510, -0.073890, -0.786650, -0.142790, 0.304750, -0.621760, -0.360690, 0.451100, 
-0.719540, 0.159490, 0.398190, -0.919110, 0.245920, 0.451190, -1.222770, 0.378810, 0.757290, -0.857180, 
0.188660, 0.491180, -0.949250, -0.278580, 0.952190, -0.485500, -0.330240, 0.652540, -0.064280, -0.101800, 
-0.471050, -0.113060, -0.312210, -0.013330, 0.023130, -0.096100, -0.177320, 0.134940, -0.325230, -0.000650, 
-0.278540, 0.279840, -0.078460, -0.285480, 0.080120, -0.172430, -0.002870, -0.373550, 0.016100, 0.494480, 
-0.687250, 0.052720, 0.234380, -0.243920, -0.248290, -0.145430, -0.190280, 0.099410, 0.062410, -0.156900, 
0.161260, 0.277430, -0.153870, -0.013360, 0.080210, 0.079480, 0.252280, -0.052840, 0.112740, 0.084890, 
0.364910, -0.449630, -0.011170, 0.762180, -0.526680, -0.140170, 0.333220, -0.289390, -0.119620, 0.092910, 
-0.195810, 0.004260, -0.053120, 0.011900, 0.164780, 0.207640, -0.180980, -0.071430, -0.137450, 0.174920, 
0.432790, -0.076090, 0.124000, 0.092510, 0.744300, -0.388740, -0.191740, 0.649030, -0.599740, 0.079960, 
0.189420, -0.295030, 0.100220, -0.003640, -0.105400, 0.104940, -0.109300, 0.202860, 0.219830, 0.139040, 
0.289500, -0.112030, -0.248410, 0.321420, 0.353450, -0.041990, 0.067830, 0.208960, 0.270720, -0.225270, 
0.114530, 0.481560, -0.350810, -0.117910, 0.148050, -0.109860, -0.000900, 0.039090, -0.138620, 0.090770, 
-0.341630, 0.157110, 0.393830, 0.155810, 0.148190, -0.027690, -0.339720, 0.428980, 0.187410, -0.325770, 
0.045810, 0.353330, 0.078760, -0.141730, -0.021590, -0.006050, -0.166660, 0.038050, 0.185520, -0.171140, 
0.032280, 0.263490, -0.289940, 0.101960, -0.329570, 0.163540, 0.201590, -0.034500, -0.065440, 0.169180, 
-0.185480, 0.206720, -0.048710, -0.196520, -0.072960, 0.174560, 0.363440, -0.107010, -0.176330, 0.126400, 
-0.054840, -0.113710, 
0.021630, -0.132620, -0.067480, -0.034610, -0.080340, -0.041950, 0.029940, 0.073870, -0.132100, 0.089650, 
-0.177160, 0.080790, -0.051300, -0.039050, 0.042930, 0.027640, -0.100180, 0.018890, -0.081600, 0.080330, 
-0.011780, -0.086540, -0.108020, 0.083200, -0.033970, -0.077400, -0.014010, -0.052950, -0.087000, 0.019430, 
-0.080180, 0.048700, -0.020650, 0.018570, -0.064170, 0.094930, 0.036250, -0.078490, -0.015500, 0.000740, 
0.041940, -0.006180, 0.050740, 0.047530, 0.028310, -0.065260, -0.084040, 0.167020, -0.016610, -0.061760, 
-0.041830, -0.034220, -0.020720, -0.090280, -0.066380, 0.067140, -0.022380, -0.013590, 0.037910, 0.010430, 
0.005370, -0.012460, -0.035660, -0.008880, 0.148230, -0.054530, 0.106550, -0.043350, -0.051770, -0.002300, 
-0.061870, 0.137630, -0.080290, -0.072170, -0.052880, 0.003360, -0.047550, -0.150570, -0.053040, 0.024210, 
0.009430, 0.033110, -0.021810, -0.032850, -0.098220, -0.009820, -0.022610, -0.053410, 0.205340, -0.110010, 
0.036770, -0.076710, 0.049140, 0.055960, -0.181300, 0.124800, -0.135500, -0.047730, -0.063800, -0.044850, 
-0.147610, -0.146620, -0.084920, 0.017790, -0.013130, 0.152120, -0.123370, -0.078340, -0.144860, -0.125390, 
0.025420, -0.066410, 0.069020, -0.063340, 0.205560, -0.253920, 0.014730, 0.092170, -0.390900, 0.147820, 
-0.054720, -0.207160, -0.089330, 0.036960, -0.367670, -0.106190, -0.093480, -0.035400, -0.027400, 0.170230, 
-0.236830, 0.104080, -0.140470, -0.146380, 0.014150, -0.075320, -0.046250, -0.014470, 0.281200, -0.479570, 
0.030770, 0.163070, -0.696760, 0.397740, 0.184970, -0.287620, -0.150800, 0.210530, -0.443960, -0.068660, 
-0.082070, -0.032250, 0.030460, 0.233920, -0.293690, 0.144290, 0.071620, -0.208800, -0.086880, 0.089460, 
-0.252790, 0.029520, 0.388470, -0.514730, 0.079130, 0.344250, -0.754820, 0.414060, 0.054740, -0.233780, 
-0.160200, 0.168180, -0.375060, -0.138810, -0.244570, -0.121410, 0.060800, 0.126820, -0.275890, 0.007250, 
-0.123070, -0.107800, -0.094120, 0.028460, -0.153380, -0.120520, 0.162030, -0.375880, 0.047950, 0.173100, 
-0.498430, 0.321720, -0.029740, -0.151000, -0.066450, 0.178600, -0.257860, -0.136650, -0.266280, -0.169960, 
0.078420, -0.071820, -0.251650, 0.048870, -0.239830, -0.095070, -0.000690, -0.086220, 0.015960, -0.172010, 
0.215540, -0.240910, -0.087580, 0.033080, -0.112810, 0.174110, -0.083980, -0.046430, 0.038330, 0.088140, 
-0.091090, -0.061710, -0.177900, -0.033860, 0.046950, -0.088150, -0.170960, 0.053800, -0.228860, -0.000470, 
0.035820, -0.171190, 0.160070, -0.056220, 0.135580, 0.067070, -0.040360, -0.022390, 0.029760, 0.123410, 
-0.061030, -0.023260, 0.055900, -0.006160, 0.075360, -0.100680, -0.110130, 0.019290, 0.080640, 0.011580, 
-0.060760, -0.036680, -0.129620, 0.011390, 0.015220, -0.204980, 0.145390, -0.011440, 0.035020, 0.129290, 
-0.069460, 0.018490, 0.009310, 0.048250, -0.024270, -0.043000, 0.018770, 0.102570, -0.045840, -0.087330, 
-0.015600, 0.046240, 0.047540, -0.001500, -0.033090, 0.012420, -0.018900, 0.033840, -0.022840, -0.099990, 
0.066180, 0.054790, 0.050240, -0.072240, 0.026490, 0.009020, 0.003660, 0.042840, 0.150690, -0.155980, 
-0.054110, 0.204340, -0.203140, -0.070650, -0.025220, 0.135050, 0.036530, 0.038750, -0.064450, 0.086620, 
0.013510, -0.017130, 0.037020, -0.049490, 0.020230, 0.110930, 0.254190, -0.122030, -0.131410, 0.148090, 
-0.066000, 0.045190, 
0.018510, 0.020680, -0.231880, -0.253970, 0.104300, -0.182910, 0.089180, -0.012440, -0.327270, 0.153870, 
0.146710, -0.173370, 0.104690, -0.220850, -0.157190, 0.113890, 0.078370, -0.186480, 0.416550, -0.003420, 
-0.426560, -0.035710, -0.208380, -0.028430, -0.039590, 0.017580, -0.106140, -0.186840, 0.005130, -0.085350, 
0.030880, -0.129140, -0.187400, -0.052860, 0.016730, -0.087300, 0.228680, -0.388760, -0.153230, 0.083910, 
0.065740, -0.157900, 0.472720, -0.232400, -0.242780, 0.148630, -0.498410, 0.049490, -0.044560, -0.002530, 
-0.088190, -0.054540, -0.078860, -0.137810, 0.053630, -0.121490, -0.211450, -0.193360, 0.172040, -0.125280, 
0.270350, -0.363510, -0.178000, -0.053130, 0.220300, -0.185960, 0.450970, -0.419380, -0.211160, 0.143750, 
-0.455850, -0.075240, -0.184310, 0.031120, -0.146390, 0.012060, -0.176400, -0.213330, 0.016770, -0.085850, 
-0.239360, -0.141420, 0.150440, -0.201530, 0.175580, -0.256930, -0.211660, -0.099480, 0.269310, -0.251640, 
0.300140, -0.271740, -0.258140, 0.203210, -0.390430, -0.200290, -0.330650, 0.196450, -0.216650, -0.039840, 
-0.174300, -0.237860, -0.056960, 0.068390, -0.290090, -0.195600, 0.218120, -0.178870, -0.002760, -0.071920, 
-0.217780, -0.229420, 0.312260, -0.224610, 0.363320, -0.077310, -0.399440, 0.122300, -0.244620, -0.034360, 
-0.189910, 0.091670, -0.205850, 0.166060, -0.350500, -0.214940, -0.084590, 0.242180, -0.237090, -0.031100, 
0.194300, -0.127810, 0.011630, 0.085760, -0.302620, -0.132600, 0.301640, -0.204390, 0.359040, 0.146680, 
-0.389440, 0.129110, -0.133720, -0.102570, 0.055370, -0.007460, -0.267880, 0.219930, -0.263350, -0.308300, 
-0.103860, 0.281060, -0.185850, 0.089310, 0.230710, -0.231790, 0.091280, 0.065710, -0.324550, -0.078610, 
0.293080, -0.303170, 0.274890, 0.121590, -0.282880, 0.352680, -0.135250, -0.269150, 0.004720, -0.092160, 
-0.049350, -0.030400, -0.224180, -0.049550, -0.084630, 0.147450, -0.047490, 0.044330, 0.052930, 0.013160, 
-0.005370, -0.079080, -0.092810, 0.030440, 0.175190, -0.100180, 0.282690, -0.115320, 0.037510, 0.282860, 
-0.232770, 0.149450, 0.005410, -0.112490, -0.070770, 0.050070, -0.122960, -0.102220, -0.148370, -0.002980, 
-0.015860, -0.045060, -0.009510, -0.024250, -0.171760, -0.084350, -0.035590, -0.033550, 0.066030, -0.130160, 
0.084560, -0.253000, 0.314180, 0.235390, -0.341950, 0.272430, 0.145640, -0.195700, 0.011660, 0.165360, 
-0.057790, -0.135320, -0.056620, 0.007270, -0.039370, -0.075900, -0.102570, 0.114490, -0.208900, -0.039930, 
0.057000, -0.037080, 0.171970, -0.145250, -0.085310, -0.172040, 0.351600, 0.094880, -0.094340, 0.091500, 
0.146900, -0.058340, -0.007450, 0.191360, 0.129980, -0.192430, -0.061480, 0.065860, 0.067950, -0.065440, 
-0.255730, 0.260370, -0.174700, -0.043920, 0.093570, -0.112410, 0.232030, -0.096920, -0.073010, 0.004840, 
0.215160, -0.144370, 0.118290, -0.046370, 0.143150, -0.018180, -0.060940, 0.143110, 0.137220, -0.121890, 
0.010930, -0.004040, 0.053590, -0.077700, -0.309980, 0.249280, -0.099120, -0.097770, 0.061600, -0.051870, 
0.133260, -0.047760, -0.112140, 0.072900, 0.061310, -0.248330, 0.098000, -0.008860, 0.166420, -0.173530, 
0.098410, 0.055300, -0.071680, 0.104170, 0.151950, -0.156880, -0.028330, 0.093670, -0.340480, 0.127720, 
0.043870, -0.165070, 0.073540, 0.087250, -0.024460, -0.036170, 0.021700, 0.095040, -0.062250, -0.139600, 
-0.134920, 0.213450, 
-0.306820, -0.090840, 0.112530, -0.487020, 0.019300, 0.095390, -0.138990, -0.130100, 0.190160, -0.127850, 
-0.053010, 0.357340, -0.183570, -0.114180, 0.319280, -0.079710, -0.079510, 0.128050, -0.020190, -0.075670, 
0.080810, -0.401400, -0.223520, 0.522470, -0.137860, -0.128940, 0.032080, -0.353040, 0.011480, 0.057190, 
0.055710, -0.137550, 0.031330, -0.047580, 0.051300, 0.104390, 0.046520, -0.227860, 0.187440, 0.023940, 
-0.021140, -0.046430, -0.054910, -0.105560, 0.164000, -0.415090, -0.038000, 0.291640, -0.093390, -0.190510, 
-0.001850, -0.151800, -0.031560, -0.117320, 0.026280, -0.053840, -0.114430, 0.044760, 0.032340, -0.232030, 
0.079710, -0.309670, 0.019720, -0.011150, 0.026040, -0.108800, -0.071560, -0.217480, 0.080320, -0.337090, 
0.081690, 0.045760, 0.067840, -0.260930, -0.136930, -0.071620, -0.118950, -0.244750, 0.167290, -0.185260, 
-0.171940, 0.132880, -0.070290, -0.306510, 0.168570, -0.360750, -0.010690, 0.207320, 0.041810, -0.311640, 
0.246330, -0.330240, -0.177600, -0.119900, -0.156180, -0.081250, 0.057570, -0.121300, -0.175020, -0.120290, 
-0.160740, -0.237800, -0.016190, -0.290030, -0.071340, 0.047450, -0.154110, -0.079250, 0.115100, -0.494770, 
0.027020, 0.047910, -0.042910, -0.219080, 0.333510, -0.335860, -0.098480, 0.004990, -0.341980, 0.025400, 
0.042660, -0.008870, -0.185140, -0.051280, -0.175480, -0.091920, -0.100660, -0.189510, 0.012810, -0.095800, 
-0.051320, 0.110650, 0.038580, -0.282290, -0.029150, -0.178070, 0.063210, -0.023070, 0.184470, -0.269710, 
0.043840, -0.204470, -0.361030, 0.223670, 0.447490, -0.105170, -0.600070, 0.140800, -0.170880, -0.296620, 
0.104710, -0.080160, -0.349840, 0.191970, 0.014600, -0.271690, 0.475260, -0.103010, -0.555510, 0.053360, 
0.115370, -0.377260, 0.587650, -0.045090, -0.695610, 0.222070, -0.173710, -0.319390, -0.033820, -0.024550, 
-0.229850, 0.021200, -0.173600, -0.214260, -0.180550, 0.031790, -0.231530, -0.276100, 0.066440, -0.006590, 
0.108780, 0.007920, -0.386670, -0.135020, 0.188780, -0.224830, 0.101660, -0.023120, -0.374240, -0.096430, 
0.046180, -0.121380, -0.090710, -0.045540, -0.168880, 0.158030, -0.218740, -0.201870, -0.136310, 0.224730, 
-0.451560, 0.010230, 0.073650, -0.139830, -0.083290, 0.089330, -0.411780, -0.058760, 0.357400, -0.453230, 
0.196620, 0.103330, -0.520580, -0.083450, 0.087570, -0.099800, 0.007930, -0.047790, -0.129670, 0.146330, 
-0.179780, -0.143920, -0.069040, 0.298310, -0.433870, -0.070770, 0.240510, -0.172320, 0.040070, 0.128020, 
-0.370360, -0.127050, 0.388560, -0.333560, 0.339970, 0.081590, -0.520750, 0.049940, -0.114810, -0.099190, 
0.055700, -0.091790, -0.024630, 0.155620, -0.210920, -0.060350, 0.182060, 0.057530, -0.393740, 0.100970, 
0.091240, -0.160120, 0.183040, -0.105540, -0.203670, -0.071920, 0.335850, -0.241400, 0.297880, -0.013250, 
-0.295960, 0.062960, -0.188620, 0.026870, 0.163720, -0.135020, -0.117150, 0.233160, -0.189620, -0.183460, 
0.021830, -0.023190, -0.308130, -0.049010, -0.100190, -0.044120, -0.024740, -0.139520, -0.089730, 0.138340, 
0.137060, -0.301890, 0.354510, -0.230050, -0.054900, 0.205740, -0.263550, 0.040860, 0.269710, -0.109790, 
-0.291190, 0.211110, -0.074150, -0.279020, -0.015590, 0.053000, -0.188110, 0.117900, -0.268710, 0.053050, 
-0.058670, -0.080590, -0.012620, -0.073590, 0.222900, -0.243570, 0.225990, -0.144010, 0.009320, 0.362320, 
-0.518150, 0.143300, 
-0.040420, -0.028010, -0.026520, -0.041890, -0.006470, -0.040670, -0.037430, -0.001520, -0.040910, -0.056740, 
-0.008030, -0.037850, -0.040530, -0.005510, -0.022040, -0.045720, -0.014110, -0.022900, -0.067280, 0.008110, 
-0.038160, -0.035640, 0.008820, -0.049040, -0.034210, -0.017540, -0.032580, -0.039330, -0.017550, -0.035430, 
-0.071940, -0.013560, -0.019110, -0.044690, -0.027380, -0.037440, -0.038250, -0.035720, -0.033440, -0.057440, 
-0.032830, -0.006580, -0.043300, 0.009000, -0.047090, -0.059380, 0.021420, -0.030890, -0.023380, -0.020980, 
-0.023850, -0.037830, -0.012290, -0.016590, -0.036590, -0.000460, -0.044880, -0.034000, -0.016560, -0.040040, 
-0.000850, -0.027530, -0.036250, -0.031760, -0.043210, -0.020830, -0.021960, 0.031110, -0.063750, -0.033860, 
0.008380, -0.036190, -0.011980, -0.032080, -0.044860, -0.047130, -0.022740, -0.018700, -0.002140, -0.009760, 
-0.080870, 0.004550, -0.036930, -0.046790, -0.006400, -0.022840, -0.044340, -0.017600, -0.039220, -0.037660, 
-0.034440, 0.032920, -0.047190, 0.005180, -0.002020, -0.071570, -0.030150, -0.038240, -0.053110, -0.055040, 
-0.044630, -0.031030, -0.014850, -0.005590, -0.076340, -0.000550, -0.035730, -0.041880, -0.035550, -0.014130, 
-0.039010, -0.031100, -0.019810, -0.044660, -0.052120, 0.010820, -0.008620, -0.030560, -0.043780, -0.070750, 
-0.055700, -0.070760, -0.065480, -0.081260, -0.088760, -0.040580, -0.035730, -0.044630, -0.110230, -0.038930, 
-0.102950, -0.036600, -0.070900, -0.041360, -0.039480, -0.056850, -0.030490, -0.068440, -0.095260, -0.062970, 
-0.001910, -0.076260, -0.109000, 0.014600, -0.120330, -0.075670, 0.048150, -0.107550, -0.132950, 0.091860, 
-0.067330, -0.052780, 0.012390, -0.076890, -0.125360, 0.086130, -0.118620, -0.084520, 0.059680, -0.068820, 
-0.082090, 0.039360, -0.146950, -0.112150, 0.099060, -0.147340, -0.117630, 0.148120, -0.061090, -0.060960, 
-0.076720, -0.058760, -0.081390, -0.023400, -0.046280, -0.075600, -0.055420, -0.018320, -0.092090, -0.033870, 
-0.051900, -0.067220, -0.041940, -0.034230, -0.057530, -0.052840, -0.088460, -0.086530, -0.008090, -0.080770, 
-0.089380, 0.032510, -0.027500, -0.042670, -0.044550, -0.048370, -0.062340, -0.011300, -0.015130, -0.066290, 
-0.012860, -0.000880, -0.049220, -0.017590, -0.032910, -0.041120, -0.007810, -0.029750, -0.026220, -0.023430, 
-0.056600, -0.049660, -0.038690, -0.053570, 0.006830, -0.025650, -0.027920, -0.018160, -0.048480, -0.042370, 
-0.042760, -0.012120, -0.014620, -0.051380, -0.018110, -0.001770, -0.051390, -0.038420, -0.021020, -0.028440, 
0.001130, -0.010860, -0.041240, -0.011300, -0.039510, 0.010440, -0.035170, -0.059010, 0.007460, -0.039030, 
-0.001280, -0.052950, -0.042330, -0.039300, -0.048440, -0.004020, -0.021790, -0.021770, -0.029990, 0.002260, 
-0.024900, -0.045830, -0.018000, -0.018870, -0.000480, -0.013800, -0.033870, 0.001270, -0.052910, -0.000350, 
-0.021000, -0.054420, 0.024380, -0.035120, 0.006700, -0.033250, -0.045790, -0.010820, -0.053970, -0.019180, 
-0.033290, -0.004330, -0.004130, 0.015080, -0.029870, -0.031250, -0.019030, 0.001730, -0.030220, -0.026110, 
-0.023440, 0.008810, -0.037380, -0.013600, -0.025670, -0.063020, 0.002590, -0.022780, 0.004750, -0.045080, 
-0.035390, 0.021490, -0.080810, -0.010220, -0.040270, -0.011110, -0.019900, -0.016840, -0.026540, -0.031300, 
0.000360, -0.027770, -0.058090, -0.003720, -0.032490, -0.023330, -0.003340, -0.017290, -0.036310, -0.047210, 
0.002840, -0.044590, 
-0.150990, -0.028720, 0.070160, -0.199520, 0.169740, -0.018700, -0.094370, 0.118060, 0.006860, -0.176190, 
0.360180, -0.266560, -0.188020, -0.050120, 0.066620, -0.080390, 0.074490, 0.103310, -0.158340, -0.043940, 
0.021940, -0.277430, 0.172790, -0.192120, -0.377540, 0.063290, 0.116170, -0.429140, 0.319420, 0.012750, 
-0.191120, -0.017450, 0.008220, -0.349370, 0.172840, -0.033640, -0.055240, -0.198030, -0.067830, -0.281110, 
0.171350, 0.072120, 0.040290, 0.007600, -0.097190, -0.357970, 0.242670, -0.092540, -0.250590, -0.063550, 
0.270930, -0.355130, 0.197830, 0.063640, -0.164430, 0.195070, -0.188040, -0.286720, 0.494070, -0.250130, 
-0.067600, -0.097070, 0.135540, -0.209050, 0.081140, 0.051590, -0.318640, 0.150150, 0.024950, -0.364240, 
0.299690, -0.034970, -0.149140, -0.040750, 0.155800, -0.204110, 0.146380, -0.014810, 0.018290, 0.163490, 
-0.273570, -0.145850, 0.323550, -0.188880, -0.163520, 0.100350, -0.020700, -0.025720, 0.094990, -0.097810, 
-0.566530, 0.680160, 0.005570, -0.232560, 0.431580, -0.245800, -0.136110, -0.006330, -0.035570, -0.202340, 
0.075800, 0.062610, -0.025180, 0.137000, -0.317250, -0.039020, 0.293380, -0.408970, -0.107420, 0.015230, 
-0.128870, -0.050360, 0.197500, -0.279880, -0.352970, 0.471620, -0.115620, -0.375890, 0.200200, -0.084620, 
-0.114330, -0.341590, -0.102580, -0.190810, -0.339620, -0.025440, -0.036090, 0.040070, -0.501440, -0.112730, 
0.034450, -0.271990, -0.209180, -0.106850, -0.123350, -0.242970, 0.155050, -0.377080, -0.337240, -0.280030, 
0.329350, -0.377760, -0.398320, 0.369200, -0.186510, -0.521550, 0.220690, -0.109010, -0.737520, 0.442220, 
-0.155460, 0.130740, -0.242730, -0.031300, -0.383690, 0.156530, -0.052400, -0.174790, -0.199090, -0.051530, 
-0.143090, -0.224380, -0.292520, -0.636250, 0.428470, -0.119020, -0.835030, 0.670370, -0.009050, -0.315760, 
-0.315360, -0.027330, -0.455030, -0.092710, -0.326480, -0.011980, -0.246830, -0.204940, -0.127630, 0.039390, 
-0.099090, 0.061460, -0.395250, -0.008520, -0.052240, -0.539180, -0.167720, -0.812940, 0.350220, -0.074680, 
-0.924290, 0.573810, -0.079300, -0.045940, -0.193780, -0.007690, -0.096350, -0.200380, -0.294720, -0.036460, 
-0.036660, -0.277100, 0.250300, 0.069670, -0.121220, 0.203530, -0.165020, -0.067100, 0.193350, -0.411100, 
0.059840, -0.417470, 0.124710, -0.125470, -0.179210, 0.107590, -0.169050, 0.048610, 0.072650, -0.033050, 
-0.060550, 0.076640, -0.174840, 0.000130, -0.005700, -0.108790, -0.013510, -0.010010, -0.217610, 0.249150, 
0.150040, -0.157920, 0.274750, -0.081860, 0.119530, -0.013330, -0.069450, -0.064260, 0.092970, -0.187860, 
-0.189100, 0.117120, 0.154780, -0.154490, 0.203880, 0.045480, -0.073520, 0.000500, 0.045270, 0.085480, 
0.062300, -0.070260, 0.119210, 0.161230, 0.036900, -0.026540, 0.173050, 0.030790, -0.055230, 0.067240, 
-0.041550, 0.136260, 0.109410, -0.317320, 0.012980, 0.192600, 0.094940, 0.104310, 0.083740, 0.140590, 
0.009400, -0.009210, 0.243070, 0.131670, 0.102370, 0.039670, 0.061810, 0.128650, 0.105080, 0.007060, 
0.128000, 0.286460, -0.010370, -0.056850, 0.016120, 0.021010, 0.158430, -0.335600, 0.323890, -0.082620, 
0.117620, 0.466710, -0.249990, 0.145040, 0.199230, 0.010200, -0.034880, 0.129490, -0.012460, 0.097380, 
0.391090, -0.165150, -0.119670, 0.263180, -0.142760, 0.081030, 0.265200, -0.212340, -0.078040, 0.222570, 
-0.236680, 0.044510, 
0.144630, -0.185820, -0.019700, 0.247450, -0.067110, -0.152970, -0.168320, 0.160770, -0.018800, -0.293900, 
0.057500, -0.148570, -0.211630, 0.023980, 0.120110, -0.269560, 0.092950, 0.048490, 0.084930, 0.211820, 
-0.249110, 0.333150, 0.042280, -0.283820, 0.098310, -0.152260, -0.076820, 0.131160, -0.074620, -0.110700, 
-0.364480, 0.046910, 0.092760, -0.133590, 0.027600, -0.144030, -0.130260, -0.133620, 0.046550, -0.281690, 
-0.051240, 0.130860, 0.230210, 0.257220, -0.370220, 0.289110, 0.158370, -0.272550, 0.121310, -0.156720, 
-0.003320, -0.066900, -0.031160, 0.133500, -0.071030, 0.066620, -0.077020, 0.178610, -0.218590, -0.086750, 
0.151190, -0.070270, 0.006110, 0.001870, -0.285670, 0.115330, 0.439000, 0.235800, -0.408300, 0.320660, 
0.093230, -0.245000, 0.096870, -0.127900, -0.023650, -0.142660, -0.042940, 0.196760, 0.190450, -0.033480, 
-0.145020, 0.349420, -0.178840, -0.044020, 0.239590, -0.168310, -0.059180, 0.163680, -0.320730, 0.063470, 
0.297030, 0.084960, -0.166320, 0.468140, -0.198130, -0.315710, 0.019970, -0.099090, -0.193070, -0.135290, 
-0.008770, 0.036030, 0.132640, 0.032270, -0.268700, 0.100410, 0.060880, -0.223210, 0.191580, 0.009860, 
-0.282780, -0.032600, 0.029900, -0.110660, -0.057120, -0.026980, 0.225200, 0.244320, -0.343090, -0.173090, 
-0.272610, -0.134370, -0.344990, -0.365130, -0.158480, -0.201820, -0.065590, 0.037410, -0.525280, -0.180560, 
-0.264770, -0.154600, -0.455880, 0.093870, -0.174680, -0.128500, 0.167200, -0.398640, -0.183800, -0.345850, 
0.087370, -0.281820, -0.443180, 0.310330, -0.637870, -0.158260, 0.317900, -0.427890, -0.479660, 0.535460, 
-0.236340, 0.089580, 0.035720, -0.329570, -0.262980, 0.395260, -0.566880, 0.035650, 0.339210, -0.201070, 
-0.057940, 0.298080, -0.745150, -0.286120, 0.771960, -0.686360, -0.377480, 0.914120, -0.210380, -0.059770, 
-0.282140, -0.143990, -0.151540, -0.066630, 0.054430, -0.147300, -0.382250, 0.304410, -0.396090, -0.273520, 
0.032320, -0.020120, -0.386360, 0.088780, -0.063350, -0.389830, -0.252740, -0.145090, -0.005350, -0.096230, 
-0.210100, 0.159150, -0.106620, -0.096100, 0.036780, -0.295710, -0.100120, 0.212770, 0.173880, -0.238980, 
-0.103960, 0.408130, -0.091610, -0.090940, 0.276770, -0.020060, -0.162170, 0.179900, -0.038310, -0.108270, 
0.028130, 0.099490, -0.180900, 0.017350, 0.304740, -0.176820, -0.153230, -0.024840, 0.058630, -0.269250, 
-0.064080, 0.226960, 0.197610, -0.192490, -0.071030, 0.450470, -0.240100, -0.207330, 0.135890, -0.030440, 
0.093630, 0.206620, -0.142380, -0.026020, 0.017840, 0.388100, -0.225210, -0.002840, 0.131420, -0.053700, 
-0.057370, -0.135220, 0.129280, -0.381680, -0.015210, 0.294500, 0.273570, -0.130610, -0.041260, 0.432250, 
-0.067810, -0.237240, 0.152280, -0.032860, 0.162410, 0.301680, -0.250990, 0.051190, -0.152590, 0.360890, 
-0.053330, 0.007310, 0.286510, -0.045260, -0.016690, 0.034370, 0.041970, -0.064170, -0.005960, 0.101160, 
0.151640, 0.057040, 0.079830, 0.423230, -0.040230, -0.127300, 0.196130, 0.166730, -0.055070, 0.184240, 
-0.162590, 0.145110, 0.134590, 0.147940, -0.020550, -0.152080, 0.212170, 0.154130, -0.085980, 0.164690, 
0.133790, -0.009520, 0.040060, 0.126610, -0.062380, 0.182560, 0.161500, -0.048230, 0.104780, 0.001890, 
0.209470, 0.065100, -0.060080, 0.109210, -0.153800, 0.124230, 0.144960, 0.190340, 0.090380, -0.200640, 
0.375270, 0.043330, 
-0.089210, 0.043900, 0.008680, -0.029540, -0.074060, 0.044010, -0.049870, -0.124990, 0.107050, -0.090930, 
-0.055780, 0.006340, -0.050810, 0.047620, 0.004770, -0.091520, -0.017650, -0.005040, -0.042330, -0.048640, 
0.009590, -0.020060, -0.025790, 0.056080, -0.022510, 0.010810, -0.045560, 0.006070, -0.047400, -0.037860, 
0.031230, -0.031940, 0.003120, -0.050140, 0.055540, -0.058220, -0.030200, 0.149340, -0.034210, -0.006670, 
0.024240, -0.045700, -0.116110, -0.077330, 0.082890, -0.053630, 0.052350, 0.009690, 0.015370, 0.053580, 
-0.147630, -0.045300, 0.037800, -0.068790, 0.037260, -0.019430, -0.018660, -0.044720, 0.061340, -0.082040, 
-0.082970, 0.214060, -0.109500, -0.024990, 0.014350, -0.093790, -0.134700, -0.009630, 0.008160, -0.059830, 
-0.024560, -0.038440, 0.038380, 0.082570, -0.190630, -0.036080, 0.069120, -0.078480, 0.019330, -0.046280, 
-0.040920, -0.074930, 0.102240, -0.129050, -0.044110, 0.183810, -0.124600, -0.032470, -0.034140, -0.088510, 
-0.099750, 0.079560, -0.184040, -0.103830, 0.081710, -0.062630, 0.084680, 0.039020, -0.156980, -0.011780, 
0.090740, -0.087430, 0.043390, -0.085670, -0.033740, -0.035460, 0.034780, -0.113240, 0.009270, 0.172290, 
-0.145830, 0.043870, -0.097560, -0.064570, -0.094910, 0.091130, -0.173890, -0.072950, 0.149610, -0.140920, 
0.107080, 0.048710, -0.187420, 0.040110, 0.122690, -0.147040, 0.056040, -0.042350, -0.061210, 0.012560, 
0.030260, -0.117710, 0.096600, 0.153230, -0.156300, 0.064200, -0.122410, -0.041570, -0.018660, 0.064550, 
-0.198760, 0.008840, 0.132080, -0.260680, 0.023590, 0.086510, -0.236830, 0.009730, 0.126770, -0.224120, 
0.053980, -0.104490, -0.113430, -0.021610, 0.020200, -0.206700, 0.017010, 0.110190, -0.170930, 0.007950, 
-0.117520, -0.082860, -0.028530, 0.123190, -0.320530, -0.003340, 0.139350, -0.390090, -0.011780, 0.029540, 
-0.085970, -0.037430, 0.075120, -0.091620, 0.088860, -0.093170, -0.045150, -0.002450, -0.062920, -0.121160, 
-0.039210, 0.028900, -0.007980, 0.014490, -0.196610, 0.058360, -0.097430, 0.148030, -0.181390, -0.078040, 
0.156890, -0.269450, -0.021770, -0.035090, -0.049210, -0.058270, 0.009440, -0.054300, 0.099590, -0.067790, 
-0.052910, -0.051030, -0.062220, -0.072550, 0.008370, -0.058660, 0.017690, 0.008980, -0.167010, 0.055360, 
-0.081820, 0.073410, -0.068780, -0.129650, 0.055570, -0.110910, -0.032990, -0.044770, -0.092100, -0.087970, 
0.015080, -0.082660, 0.067360, -0.055480, -0.079120, -0.064420, -0.005890, -0.081960, -0.003220, 0.015280, 
-0.062200, -0.018180, -0.091950, -0.015710, -0.105580, 0.050040, -0.142460, -0.067840, 0.023480, -0.089260, 
-0.069460, -0.093590, -0.029440, -0.093710, -0.083740, -0.020470, 0.018260, -0.071140, -0.067200, -0.083700, 
0.057460, -0.083750, -0.055660, 0.017140, -0.050830, -0.017160, -0.110250, 0.025570, -0.079150, -0.000550, 
-0.043100, -0.102750, -0.047150, 0.035670, -0.090310, -0.133170, 0.076010, -0.120150, -0.122090, 0.077710, 
-0.054000, -0.072880, -0.034940, -0.083200, -0.015630, -0.006820, -0.059110, -0.083390, 0.041660, -0.070240, 
-0.129380, 0.057210, -0.086240, -0.070250, 0.056110, -0.079680, -0.102730, 0.107600, -0.114150, -0.081390, 
0.042560, -0.109300, -0.081760, 0.044720, -0.084040, -0.042140, 0.003510, -0.090290, -0.000690, -0.035520, 
-0.154540, 0.002700, 0.036670, -0.103910, -0.047480, 0.047660, -0.001740, -0.057790, -0.019750, -0.099660, 
-0.022580, -0.016550, 
-0.104930, 0.091660, -0.416290, -0.219570, 0.098630, -0.409580, 0.007860, 0.041970, -0.487640, -0.046980, 
0.083380, 0.026950, 0.131600, 0.188910, -0.310300, 0.255820, 0.049140, -0.519180, 0.188140, 0.146370, 
-0.473420, 0.336470, -0.391050, -0.008850, -0.054270, -0.237710, -0.260900, -0.286040, -0.077230, -0.213190, 
-0.170860, -0.057620, -0.127530, -0.113920, 0.032910, 0.074670, -0.094730, 0.104030, 0.147200, -0.055830, 
0.054110, -0.227120, -0.030240, -0.332750, 0.121670, 0.323520, -0.428410, -0.128210, -0.113350, -0.053970, 
-0.299790, -0.172170, 0.157500, -0.390870, -0.393450, 0.035390, 0.153210, -0.155860, -0.047170, -0.121180, 
-0.255680, -0.117440, 0.285660, -0.394470, 0.232130, -0.095290, -0.095760, -0.399860, 0.226830, -0.227570, 
0.130840, -0.063350, 0.032520, -0.060150, -0.267480, -0.153480, 0.385290, -0.602630, -0.197220, -0.197890, 
0.109320, -0.180440, 0.009780, -0.152650, -0.259690, -0.153760, 0.375250, -0.217540, 0.317340, -0.343670, 
-0.108290, -0.467110, 0.225530, -0.293320, 0.054840, 0.153470, -0.075950, 0.033040, -0.077350, -0.322200, 
0.248180, -0.363950, -0.396820, -0.067250, 0.090520, -0.175070, 0.063010, -0.119280, 0.031500, -0.510790, 
0.190370, -0.245340, 0.201250, -0.270740, 0.090620, -0.291780, 0.247810, -0.415300, 0.184020, 0.184000, 
-0.161830, 0.028710, 0.184210, -0.451740, 0.180280, 0.131490, -0.440570, -0.019160, 0.290070, 0.016620, 
0.003030, 0.191910, -0.049630, -0.181750, 0.075400, -0.063720, -0.000600, 0.075500, 0.100750, -0.272990, 
0.302870, -0.556970, -0.138590, 0.433910, 0.384210, -0.092220, -0.301790, -0.160020, 0.036420, -0.101610, 
0.119010, -0.194730, -0.310720, 0.548070, -0.447870, -0.144970, 0.697630, -0.260130, -0.621440, 0.178830, 
-0.141490, -0.298890, 1.400030, -0.212630, -1.139680, 0.240830, -0.282600, -0.139450, -0.455650, -0.080580, 
0.392030, -0.351420, -0.080570, 0.025480, -0.369230, -0.203810, -0.098260, -0.136510, -0.204090, 0.014510, 
0.307950, -0.393290, -0.307100, -0.191230, -0.040500, -0.111230, 0.573000, -0.427870, -0.439340, -0.226910, 
-0.013590, -0.147570, -0.636200, 0.038760, 0.407170, -0.105530, -0.111090, -0.039190, -0.405790, 0.163090, 
-0.460820, -0.134580, 0.147250, -0.341390, 0.088900, -0.170970, -0.603080, -0.174160, 0.410940, -0.623880, 
0.526880, -0.039100, -0.592200, 0.356060, -0.017910, -0.334170, -0.703400, 0.159500, 0.369480, -0.346850, 
0.074270, 0.153280, -0.208630, 0.362900, -0.587260, 0.148630, 0.255970, -0.452450, 0.241620, -0.044750, 
-0.616700, -0.034360, 0.526550, -0.582380, 0.836080, 0.000500, -0.550480, 0.413260, -0.018520, -0.183750, 
-0.589480, 0.104950, 0.449620, -0.316980, -0.046410, 0.304550, 0.107580, 0.140270, -0.455890, 0.232660, 
-0.040820, -0.132580, 0.260970, -0.258990, -0.211810, -0.175640, 0.453490, -0.263140, 0.767530, -0.112770, 
-0.237290, 0.237930, 0.081090, 0.019280, -0.331150, -0.099000, 0.285370, -0.098590, -0.153540, 0.142580, 
-0.059780, 0.039400, -0.478560, 0.211210, -0.042750, -0.168320, 0.118220, -0.232750, -0.263430, 0.231770, 
0.163090, -0.543320, 0.302730, -0.199570, 0.135090, 0.475250, -0.035010, 0.037970, 0.067860, -0.195390, 
-0.068940, 0.110770, -0.123210, -0.165920, -0.317210, 0.132100, -0.119750, 0.669010, -0.401180, -0.012230, 
0.001060, -0.238880, 0.138070, -0.121600, 0.252790, -0.241310, 0.257780, -0.465860, 0.219350, 0.716490, 
-0.417060, 0.186120, 
-0.327200, 0.388670, -0.081450, -0.399700, 0.245020, -0.013920, -0.084260, -0.239120, 0.151380, -0.176840, 
0.037950, -0.264640, -0.037120, -0.034940, 0.039580, -0.178180, -0.028540, -0.013880, -0.147610, 0.044900, 
-0.007550, 0.055410, 0.017760, 0.212230, -0.139380, 0.244750, -0.220120, -0.270370, 0.207170, -0.138490, 
0.161470, -0.232160, -0.107450, -0.005190, 0.049030, -0.316330, 0.065880, 0.091900, -0.112520, 0.015700, 
-0.028310, -0.118530, -0.064560, -0.115620, -0.019570, 0.221020, -0.064270, 0.048060, 0.081480, 0.116960, 
-0.294580, -0.133610, 0.129040, -0.107910, 0.073710, -0.094710, -0.057280, -0.017810, 0.077910, -0.198510, 
0.110770, 0.184800, -0.108870, 0.116660, -0.101210, -0.116230, 0.101710, -0.146450, 0.149500, 0.159850, 
-0.132490, 0.065320, 0.297750, 0.043570, -0.416010, 0.002310, 0.008940, -0.111640, 0.061240, -0.048550, 
-0.111820, -0.066000, 0.149490, -0.134700, 0.135030, 0.299420, -0.114440, 0.152680, -0.219990, -0.079590, 
-0.022560, -0.229560, 0.027020, -0.039380, -0.174070, 0.147180, 0.377020, -0.124580, -0.411010, 0.071490, 
-0.037100, -0.092700, 0.016780, -0.225920, 0.037820, -0.203930, -0.013770, 0.090890, 0.026330, 0.271170, 
-0.034490, 0.051860, -0.319800, 0.042840, -0.392370, -0.014760, 0.010660, -0.257270, -0.139690, 0.254280, 
0.280260, -0.136600, -0.247440, -0.066330, 0.140580, -0.038780, -0.087630, -0.178360, 0.139150, -0.450940, 
-0.048840, 0.122650, -0.016100, 0.252430, -0.019330, -0.027640, -0.361620, 0.101570, -0.714660, 0.185660, 
0.166680, -0.210430, -0.041680, 0.062020, 0.090860, -0.033050, -0.244640, -0.176000, 0.220720, -0.121970, 
0.034740, -0.179460, -0.072160, -0.403940, 0.142350, -0.177690, 0.008710, 0.312330, -0.213760, -0.100570, 
-0.197410, 0.051370, -0.415430, 0.324600, -0.238090, -0.116610, 0.187110, -0.356140, 0.155600, 0.056010, 
-0.266360, -0.209730, 0.387020, -0.169620, 0.132870, -0.030110, -0.187080, -0.345130, 0.095130, -0.231230, 
0.085830, 0.200980, -0.218780, -0.056860, -0.184540, 0.046150, -0.216410, 0.312030, -0.412720, -0.026780, 
0.223920, -0.525450, 0.009500, 0.152850, -0.179170, -0.286630, 0.374590, -0.145020, 0.106080, 0.204490, 
-0.151400, -0.282670, 0.376250, -0.151680, 0.090030, 0.219440, -0.173620, -0.002980, -0.046550, 0.111980, 
-0.043100, 0.278780, -0.435320, -0.146770, 0.266060, -0.495290, -0.003400, 0.092780, -0.153660, -0.136720, 
0.235970, -0.108740, 0.188380, 0.001260, 0.029440, -0.203140, 0.320970, -0.105680, 0.048170, 0.135870, 
-0.011510, 0.024700, -0.114740, 0.186950, -0.086720, 0.222130, -0.359380, -0.153680, 0.390180, -0.531150, 
-0.074850, 0.017120, -0.037860, -0.212340, 0.091870, 0.054020, 0.029190, 0.005790, 0.040000, -0.371170, 
0.280400, 0.124040, 0.000000, 0.078200, 0.080360, -0.059420, -0.133950, 0.260920, 0.007740, 0.336750, 
-0.323450, -0.207730, 0.328380, -0.332770, -0.196750, 0.081120, 0.120200, -0.211380, 0.109920, 0.095540, 
-0.017280, -0.041830, 0.044340, -0.318290, 0.316180, 0.027530, -0.107320, 0.109650, 0.140090, -0.073220, 
-0.116580, 0.208600, -0.255690, 0.372020, -0.145610, -0.337500, 0.325980, -0.242190, -0.317700, 0.226540, 
0.215640, -0.170490, 0.172160, 0.103510, -0.056480, 0.027610, -0.037070, -0.342920, 0.391180, -0.039640, 
-0.199220, 0.245690, -0.010290, -0.136090, 0.150210, 0.142520, -0.349670, 0.456240, 0.082980, -0.292050, 
0.390270, -0.280710, 
0.036270, -0.117770, 0.033290, 0.044310, -0.069330, -0.002120, -0.042100, -0.007580, -0.024120, -0.053590, 
-0.087870, -0.014310, -0.043770, -0.040710, 0.041130, -0.030070, -0.100800, 0.028900, 0.010780, -0.050080, 
-0.025710, 0.058170, -0.068190, -0.022960, 0.040280, -0.088770, -0.024060, 0.005260, -0.043490, -0.022130, 
-0.096290, -0.029580, 0.005580, 0.025640, -0.038950, -0.062080, 0.029420, -0.076830, -0.020490, -0.068770, 
-0.114760, 0.041560, 0.071850, -0.090780, -0.004620, 0.020970, -0.042110, -0.007320, 0.050300, -0.079130, 
-0.026850, -0.055210, -0.011390, 0.033180, 0.003420, -0.016110, -0.023960, 0.063390, -0.066230, -0.047570, 
0.116160, -0.040970, -0.015630, -0.010460, -0.110590, 0.035010, 0.178670, -0.060590, -0.024170, 0.073510, 
-0.047060, -0.035790, 0.032100, -0.074930, -0.041790, -0.110460, -0.020350, 0.063240, 0.054770, -0.052440, 
-0.034160, 0.093390, -0.062530, -0.015910, 0.044520, -0.053130, 0.004540, -0.005800, -0.081060, 0.031810, 
0.154250, -0.026970, -0.038940, 0.134850, -0.105340, -0.159880, -0.040110, -0.066150, -0.076020, -0.157590, 
-0.014420, 0.037310, -0.029410, -0.024420, -0.032370, 0.028850, -0.090060, -0.018830, -0.040150, -0.036400, 
0.014490, -0.064130, -0.003040, -0.004390, 0.022360, -0.077580, 0.102160, 0.102880, -0.209310, -0.104960, 
-0.175230, -0.093360, -0.108920, -0.255780, -0.094270, -0.040820, -0.117680, -0.040490, -0.138360, -0.154570, 
-0.186120, 0.066080, -0.251320, -0.045350, 0.033940, -0.179650, 0.049400, -0.079340, -0.093590, -0.184410, 
0.021210, -0.110350, -0.289080, 0.121260, -0.322990, -0.084290, 0.116430, -0.342830, -0.187850, 0.279690, 
-0.220730, -0.055790, 0.157120, -0.249780, -0.184160, 0.249990, -0.356250, -0.092770, 0.275230, -0.258890, 
-0.071350, 0.216350, -0.276330, -0.228080, 0.286720, -0.321990, -0.278700, 0.459010, -0.129090, -0.031240, 
-0.179650, -0.177050, -0.110530, -0.015430, -0.065490, -0.122070, -0.112890, -0.009370, -0.131520, -0.082640, 
-0.144520, -0.050390, -0.067610, -0.168520, -0.029350, -0.099590, -0.168700, -0.161270, 0.024150, -0.144190, 
-0.086970, 0.063440, -0.055280, -0.022130, -0.067340, -0.182670, -0.073460, 0.063840, -0.019280, -0.095750, 
0.002660, 0.064320, -0.034020, -0.051220, -0.076420, -0.019190, 0.048010, -0.041360, 0.038240, -0.032180, 
-0.067720, -0.035940, -0.062080, -0.106840, 0.127060, -0.035690, 0.000440, 0.004080, -0.110900, -0.078830, 
-0.036490, -0.000600, -0.013000, -0.012250, -0.036800, 0.094000, -0.051610, -0.099560, -0.045470, 0.049350, 
0.034510, 0.018980, 0.017580, -0.019820, -0.021330, 0.049600, -0.005380, -0.056040, 0.037040, -0.022870, 
0.042850, -0.131800, -0.044410, -0.092130, -0.054910, 0.005880, -0.003040, 0.061210, -0.046110, 0.086940, 
-0.002870, -0.085450, -0.046460, 0.047230, 0.073820, 0.001470, -0.026160, 0.027620, -0.060050, 0.020820, 
0.018480, -0.056400, 0.081200, -0.031510, 0.018130, -0.079340, -0.006020, -0.002730, -0.094050, -0.001650, 
-0.041560, 0.054580, 0.058550, 0.090730, -0.065920, -0.006410, -0.048750, 0.082030, 0.024770, -0.055310, 
-0.032270, 0.085760, -0.007200, -0.041410, 0.035160, -0.112710, 0.056530, 0.016990, 0.009940, -0.073840, 
0.015710, 0.051890, -0.148030, 0.016160, -0.128530, 0.042070, 0.085950, -0.067760, -0.038420, 0.030580, 
-0.083470, 0.002510, 0.018450, -0.045530, -0.023780, 0.039920, 0.051950, -0.020900, -0.005140, -0.087700, 
0.058410, -0.018470, 
-0.122300, -0.062960, -0.029560, -0.156860, -0.028670, -0.009740, -0.147880, 0.068290, -0.037250, -0.046930, 
-0.112180, 0.134160, -0.156700, -0.039340, 0.112140, -0.105590, -0.042320, 0.073610, -0.081150, 0.117630, 
-0.027330, -0.068220, -0.057500, 0.053280, -0.149970, -0.030060, 0.041020, -0.172250, -0.022910, 0.072650, 
-0.197840, 0.055680, 0.100600, -0.064250, -0.015590, 0.128090, -0.154970, -0.038540, 0.136720, -0.135030, 
0.052460, 0.066430, -0.012450, 0.114260, -0.036300, -0.118840, 0.058650, 0.068310, -0.169000, -0.026260, 
0.086080, -0.125230, 0.019480, -0.006790, -0.193490, 0.051250, 0.120830, -0.053210, -0.002920, 0.068440, 
-0.158250, -0.074200, 0.164160, -0.124610, 0.094360, 0.087830, 0.013960, 0.016750, 0.007830, -0.142720, 
0.095930, 0.131940, -0.132790, -0.067980, 0.032840, -0.082740, 0.002060, -0.079030, -0.129950, 0.003930, 
0.085430, 0.015450, -0.028950, 0.018730, -0.138820, -0.086200, 0.121730, -0.066470, 0.106750, -0.036000, 
-0.023730, -0.073920, 0.111570, -0.153880, 0.008420, 0.168860, -0.088610, -0.062850, -0.075550, -0.055060, 
-0.065300, -0.189470, -0.059200, -0.015240, -0.064750, 0.108270, -0.067140, -0.078850, -0.074490, -0.166520, 
-0.002200, -0.021300, 0.008710, -0.113890, 0.111950, -0.204590, 0.031620, -0.019350, -0.202860, 0.087730, 
-0.030700, -0.154380, -0.089040, -0.004960, -0.213760, -0.125120, -0.048650, -0.060090, -0.075910, 0.124250, 
-0.115840, -0.033020, -0.073140, -0.158940, -0.028420, 0.004700, -0.083680, -0.077730, 0.165100, -0.315720, 
-0.028320, 0.061940, -0.422300, 0.210240, 0.175470, -0.194350, -0.181780, 0.091690, -0.247620, -0.099100, 
0.011590, -0.023530, -0.105710, 0.180880, -0.120970, -0.046220, 0.148150, -0.163720, -0.138500, 0.106360, 
-0.170290, -0.046230, 0.226450, -0.259600, -0.040740, 0.236520, -0.492080, 0.216170, 0.034260, -0.150950, 
-0.152180, 0.076890, -0.225280, -0.143140, -0.092840, -0.031370, -0.122830, 0.049540, -0.085940, -0.077550, 
0.027160, -0.069870, -0.210740, 0.069070, -0.098230, -0.184040, 0.039480, -0.171550, -0.073190, 0.075920, 
-0.291170, 0.115680, -0.037770, -0.100640, -0.091120, 0.120490, -0.197850, -0.135000, -0.137920, -0.058740, 
-0.116690, 0.032740, -0.195250, -0.020110, -0.051460, -0.042430, -0.132480, 0.039800, -0.059500, -0.200490, 
0.044800, -0.053040, -0.130090, -0.025510, -0.062000, 0.085000, -0.100720, -0.037630, 0.028340, 0.078160, 
-0.126100, -0.043530, -0.116830, -0.019490, -0.040990, 0.044100, -0.181210, 0.005950, -0.027210, -0.040140, 
-0.042740, 0.014810, -0.006410, -0.057880, 0.058510, 0.025210, -0.070660, -0.102940, -0.020080, 0.170710, 
-0.084230, -0.025940, 0.036350, 0.035480, -0.033490, -0.073170, -0.084400, -0.024740, 0.041160, 0.077000, 
-0.124050, -0.036160, -0.067670, -0.042840, 0.065400, -0.089170, 0.043810, 0.000840, -0.013050, 0.054190, 
-0.048130, -0.025730, -0.061530, 0.131180, -0.067060, -0.021540, -0.059530, 0.101470, -0.079560, -0.136570, 
-0.061920, 0.029760, -0.017400, -0.046270, -0.004780, -0.080830, -0.005280, -0.010990, -0.047980, -0.031030, 
0.047090, -0.038230, 0.071760, -0.058450, -0.035650, -0.025850, -0.059020, 0.052530, 0.050210, -0.105450, 
-0.150990, 0.097340, -0.137550, -0.175300, -0.096280, 0.135170, -0.071550, -0.028000, 0.023140, -0.063090, 
0.009370, 0.010060, -0.047520, -0.094560, 0.063840, -0.029120, 0.164180, -0.085900, -0.172390, 0.090640, 
-0.091140, -0.051380, 
-0.148810, 0.108430, -0.113220, -0.258670, 0.121990, -0.063360, -0.351400, 0.323870, -0.071280, -0.149350, 
0.186230, 0.158450, -0.302200, 0.091080, 0.032230, -0.207440, 0.277770, 0.058360, -0.022090, 0.198440, 
0.154870, -0.072780, -0.164820, 0.212110, -0.200330, 0.136490, -0.057440, -0.279860, 0.150170, -0.042860, 
-0.291730, 0.103800, 0.020600, -0.106970, -0.003240, 0.075650, -0.117580, -0.093200, 0.006720, -0.041740, 
0.119070, -0.021830, 0.076050, 0.075100, 0.099120, -0.052390, -0.221980, 0.160800, -0.202570, 0.085060, 
-0.000690, -0.132380, 0.060090, -0.127760, -0.118040, 0.001580, -0.034980, 0.124140, -0.091570, -0.070880, 
-0.088760, -0.254000, 0.117080, 0.047130, 0.058790, -0.057940, 0.371540, -0.222710, -0.051490, 0.054530, 
-0.184160, 0.099000, -0.243260, -0.038300, 0.040640, -0.026740, -0.137940, -0.171020, -0.151370, -0.076630, 
0.055950, 0.148570, -0.066360, -0.140630, -0.060280, -0.317030, 0.116930, 0.062720, -0.003170, -0.071710, 
0.343780, -0.317570, 0.100440, 0.040710, -0.328500, 0.161060, -0.333000, -0.014140, -0.110820, -0.030910, 
-0.206790, -0.311980, -0.047500, -0.054400, -0.154170, -0.031240, 0.058350, -0.240310, -0.083260, -0.256170, 
-0.079470, -0.101970, -0.030280, -0.134100, 0.476240, -0.456460, -0.154890, 0.223990, -0.494410, 0.241020, 
-0.210290, -0.041950, -0.169770, 0.065860, -0.366140, -0.208670, 0.057340, -0.107400, -0.204170, 0.034390, 
0.168970, -0.298370, -0.152080, -0.168620, -0.155470, -0.058970, -0.062700, -0.143890, 0.547980, -0.224810, 
-0.423450, 0.507820, -0.584510, 0.105280, 0.136900, -0.156700, -0.334530, 0.193590, -0.345600, -0.345820, 
0.093190, 0.049290, -0.302530, 0.223310, 0.188990, -0.335920, 0.119640, -0.181960, -0.239500, -0.016350, 
-0.058440, -0.255800, 0.366970, -0.121520, -0.364420, 0.670720, -0.661850, -0.015910, 0.126700, -0.164450, 
-0.358840, 0.172670, -0.301640, -0.336460, -0.099770, 0.108570, -0.257040, 0.232290, 0.133250, -0.285970, 
0.016800, -0.106930, -0.274780, 0.132030, -0.019470, -0.351710, 0.234970, -0.023920, -0.251910, 0.659670, 
-0.560560, 0.024480, 0.020170, -0.218170, -0.209330, 0.311480, -0.312100, -0.277090, -0.248220, -0.010340, 
-0.153900, 0.033740, -0.051620, -0.133850, -0.003530, -0.123060, -0.235730, 0.141260, -0.153430, -0.288830, 
-0.105570, -0.039510, 0.312660, 0.315900, -0.537880, 0.430430, -0.089300, -0.234700, 0.101420, 0.207280, 
-0.219490, -0.130140, -0.344720, -0.050480, 0.189290, -0.029690, -0.180590, 0.106550, -0.147050, -0.184730, 
0.131140, -0.052050, -0.102860, 0.016180, -0.257220, -0.112850, 0.649330, -0.062130, -0.290450, 0.667280, 
-0.172340, -0.025520, 0.180730, 0.116740, 0.114550, -0.173950, -0.429480, 0.039910, 0.428040, -0.056740, 
-0.190300, 0.252070, -0.378420, -0.047220, 0.381170, -0.179960, 0.114090, 0.081500, -0.054130, 0.005330, 
0.369630, -0.074300, -0.078660, 0.496940, -0.174910, 0.043570, 0.031610, 0.048740, 0.228890, -0.258450, 
-0.350610, 0.085480, 0.327080, -0.298450, -0.026590, 0.249050, -0.326270, -0.069160, 0.289600, -0.237480, 
0.190010, 0.019460, -0.123840, 0.057570, 0.221500, -0.204100, 0.062570, 0.271640, -0.176300, -0.149020, 
0.096900, -0.068440, 0.027220, -0.065800, -0.258320, 0.109940, 0.208310, -0.171630, -0.008890, 0.195630, 
-0.205830, -0.047300, 0.283580, -0.275370, 0.116140, 0.107830, -0.019530, -0.030870, 0.106950, -0.074640, 
-0.120790, 0.288200, 
0.224420, 0.114990, -0.116630, 0.245510, 0.034440, -0.107710, 0.204160, 0.026610, 0.028910, 0.387330, 
0.362540, -0.267610, 0.045540, 0.076370, 0.225220, 0.358380, 0.094750, 0.149340, 0.745370, -0.091800, 
0.042710, 0.171510, 0.068390, 0.352880, 0.131550, -0.034290, 0.053270, 0.030310, 0.057890, -0.055890, 
0.420640, -0.015150, -0.117400, 0.119260, 0.144900, -0.010420, -0.180410, 0.082400, 0.364040, 0.458820, 
-0.119510, 0.035290, 0.546460, -0.453730, 0.475140, -0.116570, 0.297510, 0.016680, 0.185690, -0.063590, 
-0.100100, -0.123130, 0.066670, -0.058620, 0.326610, 0.012500, -0.210320, 0.149620, 0.318620, -0.279730, 
-0.232520, 0.079030, 0.246690, 0.186440, -0.225160, 0.039490, -0.246570, -0.276100, 0.643190, -0.298960, 
-0.083410, -0.060820, 0.062550, -0.052850, -0.089480, -0.039580, -0.175830, -0.079580, 0.123370, -0.282440, 
0.042450, -0.219990, 0.343830, -0.498470, 0.005670, -0.137760, 0.118430, 0.198560, -0.371490, 0.020330, 
0.003200, 0.077440, -0.261530, -0.186870, 0.125560, -0.291500, 0.041360, -0.171430, -0.089600, -0.096970, 
-0.348620, -0.002980, -0.066210, -0.427570, 0.047690, -0.425790, 0.109740, -0.475970, 0.108870, -0.233620, 
-0.078160, 0.228430, -0.538940, -0.109340, -0.225870, 0.191390, -0.120380, -0.130090, 0.205300, -0.037400, 
-0.056790, -0.307400, -0.087540, 0.067430, -0.413570, 0.042990, -0.176270, -0.241210, -0.082030, -0.490230, 
0.516090, -0.378980, -0.169220, 0.332980, -0.206780, -0.081220, -0.307890, -0.081400, 0.404250, 0.476330, 
-0.641690, 0.106600, 0.311840, -0.449470, -0.132770, -0.272010, -0.291070, -0.086630, -0.231050, -0.296880, 
-0.115890, -0.147080, -0.505360, -0.353000, 0.457370, -0.602610, -0.074470, 0.473880, -0.577750, -0.298360, 
-0.224230, -0.335570, 0.771140, 0.737060, -1.572180, 0.697450, 0.525180, -1.507130, -0.149470, -0.177140, 
-0.032380, -0.201340, -0.187160, -0.029030, -0.050240, 0.152050, -0.302360, -0.111220, 0.315590, -0.341860, 
-0.090700, 0.314170, -0.405550, -0.192200, -0.210230, 0.012630, 0.515740, 0.318030, -1.028520, 0.817880, 
-0.032460, -1.048820, -0.184060, -0.314240, 0.214620, -0.054580, -0.204340, 0.061870, -0.104700, 0.441660, 
-0.339510, -0.320050, 0.288290, -0.071350, 0.017800, 0.168170, -0.194620, -0.046900, -0.074090, -0.013380, 
0.251740, 0.367470, -0.060180, 0.406700, 0.163660, -0.358470, -0.031780, -0.480970, 0.291550, 0.069110, 
-0.179050, -0.067050, 0.049980, 0.335490, -0.471770, 0.178150, -0.176530, -0.200090, -0.088310, 0.132210, 
0.011130, -0.024480, 0.021990, -0.121170, 0.013550, 0.356410, -0.105190, 0.403280, 0.016690, -0.045690, 
-0.009720, -0.446570, 0.344350, 0.228920, -0.337870, 0.011390, 0.383280, -0.145040, -0.294320, 0.217660, 
0.145130, -0.437020, 0.024320, -0.020490, -0.030190, 0.214660, 0.119140, -0.125510, 0.368600, -0.273290, 
0.275850, 0.222250, 0.071600, -0.193560, 0.073910, -0.398360, 0.226320, 0.035350, -0.068640, -0.063630, 
0.081280, -0.077440, -0.269160, 0.030850, 0.130080, -0.117700, -0.159430, -0.184510, 0.284470, -0.124730, 
0.101810, -0.185380, -0.117940, -0.166520, 0.538360, -0.072890, 0.422020, -0.111480, 0.141360, -0.393610, 
0.106660, 0.073480, -0.120930, -0.144290, -0.120250, -0.021700, -0.058080, -0.017290, -0.043490, -0.171810, 
-0.300270, -0.129810, 0.320950, -0.307050, -0.040490, 0.011660, -0.111170, 0.055380, 0.288270, -0.258030, 
0.106090, 0.177370, 
-0.258660, 0.130840, 0.137670, -0.111340, -0.051930, 0.158590, 0.094340, -0.278090, 0.147140, -0.240330, 
-0.124910, 0.011710, 0.069740, -0.045190, -0.013390, -0.133490, -0.082800, -0.014790, -0.330750, 0.031890, 
0.116900, -0.070970, 0.246980, -0.047030, -0.038850, -0.064140, 0.150120, 0.004240, -0.106870, 0.065860, 
0.153590, -0.242980, 0.200590, -0.159930, -0.039780, 0.080970, -0.033100, 0.032180, 0.131500, -0.098120, 
-0.087860, 0.111470, -0.427520, 0.001220, 0.163740, -0.153520, 0.267450, -0.030570, 0.036910, -0.082850, 
-0.061290, 0.013330, -0.062730, -0.025780, 0.104010, -0.218980, 0.177760, -0.097650, -0.011470, 0.031890, 
-0.105170, 0.114110, 0.059780, -0.100200, -0.132590, 0.012400, -0.464530, 0.160970, 0.011920, -0.223360, 
0.247450, -0.068750, 0.130360, -0.027510, -0.177120, -0.019580, 0.101250, -0.078220, 0.093710, -0.069350, 
-0.013840, -0.069240, 0.096250, -0.105590, 0.057520, 0.195730, -0.101790, -0.023390, -0.200940, -0.019690, 
-0.316260, 0.287220, -0.417730, -0.311760, 0.519160, -0.352380, 0.207300, -0.056650, -0.166400, -0.085150, 
0.159050, -0.073000, 0.196880, 0.025450, -0.152450, 0.078990, 0.127900, -0.199720, 0.196230, 0.312520, 
-0.254040, 0.144150, -0.220740, -0.035890, -0.205030, 0.307470, -0.550430, -0.288060, 0.646340, -0.573170, 
0.139150, 0.027220, -0.182220, -0.072990, 0.259380, -0.165780, 0.112690, 0.000390, -0.116220, 0.052710, 
0.051220, -0.159700, 0.277290, 0.242640, -0.261930, 0.117370, -0.225750, 0.031540, -0.119020, 0.221940, 
-0.414350, -0.358810, 0.727090, -0.674160, -0.164410, 0.134540, -0.113590, -0.098100, 0.200090, -0.151520, 
0.021430, -0.232830, 0.100610, -0.004830, -0.150900, -0.048880, 0.087980, -0.001040, 0.036110, 0.079770, 
-0.300070, 0.124170, -0.185810, 0.141760, -0.118460, -0.471560, 0.670560, -0.509890, -0.035480, -0.044650, 
-0.044410, -0.008920, -0.013920, -0.096120, 0.089460, -0.172790, 0.046050, -0.037210, -0.226300, -0.068630, 
-0.005560, -0.110290, 0.154820, 0.092530, -0.438180, 0.212020, -0.258690, 0.059750, 0.161100, -0.317320, 
0.289870, -0.429530, -0.004070, -0.113040, -0.074400, -0.053750, -0.023540, -0.131390, 0.057410, -0.088380, 
-0.017580, -0.175430, -0.121130, -0.013090, -0.050970, -0.079480, 0.093610, 0.049910, -0.344810, 0.205630, 
-0.179160, -0.109110, 0.070550, -0.071130, -0.062560, -0.435740, -0.032550, -0.127990, -0.092980, -0.137890, 
0.001720, -0.133070, 0.027120, -0.067570, -0.067710, -0.169460, 0.089380, -0.092880, -0.053210, -0.005660, 
-0.023720, 0.029650, -0.236510, 0.071620, -0.213290, -0.128410, -0.003640, 0.111510, -0.082570, -0.357180, 
0.019550, -0.135020, -0.093040, -0.048190, -0.114870, -0.059190, -0.023650, -0.029680, -0.167180, -0.167620, 
0.229820, -0.141260, -0.105250, -0.006820, -0.031170, 0.067110, -0.181390, 0.015840, -0.045740, -0.056670, 
-0.081380, -0.010440, 0.094760, -0.168900, 0.018070, -0.122720, 0.055790, 0.009210, -0.096010, 0.005570, 
-0.080950, 0.071210, -0.180790, -0.062180, 0.180920, -0.133290, -0.098250, -0.058880, 0.109050, 0.014980, 
-0.107860, 0.018320, -0.043230, -0.005810, -0.014610, -0.014810, 0.021240, -0.001460, -0.050890, -0.018010, 
0.134800, 0.009490, -0.041580, 0.119360, 0.023520, 0.086860, -0.178380, 0.020750, 0.200910, -0.151160, 
-0.113630, 0.055140, 0.048040, 0.032290, 0.044750, 0.018080, 0.060810, 0.049440, -0.034520, -0.048680, 
0.085290, -0.055820, 
0.044390, -0.149590, -0.004640, -0.078870, -0.111150, 0.033050, 0.215260, -0.004230, -0.221090, 0.356060, 
-0.119190, 0.165200, 0.109490, -0.146690, -0.034310, 0.246550, -0.018730, -0.051230, 0.031780, 0.027520, 
0.059810, 0.010130, -0.118410, 0.196320, -0.123770, -0.112530, 0.052520, -0.184770, -0.074570, 0.086110, 
0.068390, -0.138400, -0.015350, 0.173430, -0.029320, 0.153360, 0.124840, -0.183000, -0.038800, 0.117940, 
0.133750, -0.156530, 0.220070, 0.020990, -0.143470, -0.102970, 0.070800, 0.001690, -0.273760, -0.078640, 
0.100940, -0.195510, 0.036250, -0.080550, -0.235050, -0.062700, 0.185160, -0.064860, 0.099360, 0.027510, 
-0.193510, -0.117940, 0.106050, -0.114070, 0.297250, -0.086040, 0.278950, -0.154000, -0.260190, -0.034750, 
0.049910, -0.057490, -0.455100, -0.004150, 0.146550, -0.262370, 0.061830, -0.114360, -0.354870, -0.080620, 
0.275580, -0.201730, 0.154600, 0.047120, -0.300830, -0.139930, 0.173420, -0.215940, 0.379580, -0.104390, 
0.268560, -0.272660, -0.141890, -0.182430, -0.027860, 0.134620, -0.579310, 0.182820, 0.044600, -0.336040, 
0.064990, -0.176460, -0.382550, -0.089270, 0.176940, -0.231570, 0.050430, 0.074800, -0.336920, -0.325800, 
0.234920, -0.235870, 0.131840, -0.047460, 0.536380, -0.374750, -0.231310, -0.020400, -0.319660, 0.327320, 
-0.444900, 0.068270, -0.002390, -0.222270, -0.194380, -0.077170, -0.510070, -0.173910, 0.392170, -0.161480, 
0.097390, 0.215060, -0.312830, -0.357080, 0.217420, -0.271720, -0.045130, 0.175260, 0.659540, -0.485090, 
-0.159720, 0.229370, -0.663790, 0.452740, 0.144910, -0.126420, -0.336250, 0.088520, -0.244640, -0.268220, 
-0.265120, -0.176550, 0.176920, 0.110290, 0.031110, 0.012440, 0.044200, -0.361930, -0.122500, -0.109440, 
-0.202190, 0.068960, 0.870410, -0.479620, -0.305490, 0.844620, -0.806170, 0.147230, -0.101300, -0.109790, 
-0.176510, 0.003020, -0.216250, -0.236280, -0.404560, -0.259190, 0.184850, 0.060910, -0.050600, -0.137500, 
-0.125260, -0.328250, -0.117340, -0.003270, -0.179280, -0.132610, 0.817190, -0.382390, -0.437150, 0.748730, 
-0.564970, -0.030740, -0.241780, 0.008290, -0.118780, 0.100520, -0.111100, -0.310770, -0.377840, -0.232200, 
-0.083470, -0.031780, -0.187860, -0.234140, -0.154970, -0.295180, -0.232260, 0.058100, -0.090140, -0.442570, 
0.787370, -0.279140, -0.482050, 0.533880, -0.361310, 0.023890, -0.315820, 0.115840, 0.062880, 0.029060, 
0.065770, -0.155040, -0.326610, -0.001810, -0.123220, -0.024160, -0.131650, -0.089760, -0.064800, -0.198340, 
-0.186370, -0.001780, 0.169600, -0.368150, 0.497440, 0.007120, -0.268700, 0.272990, -0.157870, 0.125330, 
-0.351450, 0.132550, 0.272210, -0.099240, 0.230770, -0.048460, -0.262580, 0.014650, 0.088940, 0.114940, 
-0.167260, 0.001990, -0.044990, -0.127480, 0.022390, -0.229400, 0.366440, -0.163490, 0.330380, 0.068520, 
-0.112250, 0.234280, -0.112710, 0.250520, -0.304010, 0.072060, 0.206690, -0.051800, 0.136870, -0.042670, 
-0.172140, 0.054980, 0.046840, -0.019270, -0.028310, 0.128500, -0.101210, -0.060670, 0.072520, -0.106440, 
0.351350, -0.086850, 0.343490, -0.059310, 0.090660, 0.110350, -0.181650, 0.314090, 0.077750, -0.194460, 
0.000190, 0.088290, -0.124420, -0.052020, -0.094740, 0.170030, -0.047720, 0.100680, 0.034150, 0.100600, 
0.023730, -0.003450, 0.073910, -0.052310, 0.311770, -0.067690, 0.556360, -0.220710, -0.096170, 0.242550, 
-0.415440, 0.366170, 
0.444490, -0.260300, -0.410030, 0.235330, -0.300740, -0.277290, 0.301530, 0.050990, -0.443410, 0.258420, 
-0.158200, -0.087640, 0.265850, -0.278440, -0.089580, 0.240610, -0.161480, -0.057980, 0.265750, -0.062280, 
-0.043830, 0.193030, -0.557950, 0.181280, 0.283760, -0.206550, -0.235190, 0.183700, -0.295470, -0.151540, 
-0.022330, 0.025700, -0.108510, -0.143440, 0.113050, 0.115010, 0.211800, -0.241500, 0.024380, 0.105510, 
0.149150, -0.108480, 0.313770, -0.191060, 0.150260, 0.037030, -0.476900, 0.342760, 0.313560, -0.177240, 
-0.222830, 0.311630, -0.260370, -0.261060, -0.113170, 0.047280, -0.028690, -0.196630, 0.142960, 0.076370, 
0.088530, -0.061050, -0.054380, 0.028900, 0.289120, -0.045100, 0.270540, -0.192980, 0.067760, 0.129080, 
-0.359420, 0.271260, 0.183330, -0.105900, -0.274700, 0.410750, -0.275210, -0.385620, -0.095750, 0.066230, 
-0.074030, 0.221250, -0.039840, -0.042230, -0.134080, 0.012960, -0.091630, -0.066540, 0.421030, -0.156120, 
0.149240, -0.042090, 0.040070, 0.190380, -0.392140, 0.136620, 0.069970, 0.017500, -0.259820, 0.264980, 
-0.292200, -0.342770, -0.251940, 0.197460, -0.073450, 0.308510, -0.164880, 0.034060, -0.197630, -0.058150, 
0.036870, -0.086340, 0.281440, -0.071410, 0.290560, -0.262670, 0.071140, 0.034930, -0.345650, 0.102320, 
0.060040, -0.162600, -0.255810, 0.317940, -0.596130, -0.211250, -0.324050, 0.177900, -0.076090, 0.037270, 
-0.200540, 0.207950, -0.196650, -0.031300, -0.100510, -0.036590, 0.083410, -0.036350, 0.315590, -0.427890, 
0.031930, 0.010160, -0.506060, 0.288380, 0.265910, -0.320170, -0.175410, 0.383410, -0.630780, -0.030420, 
-0.316380, 0.026530, 0.154270, -0.058240, -0.173140, 0.221210, 0.036680, -0.185310, -0.123730, 0.066200, 
-0.158640, 0.098900, 0.325370, -0.546820, 0.187000, -0.020200, -0.545670, 0.458770, 0.121380, -0.329590, 
-0.113350, 0.322270, -0.538560, -0.109290, -0.281390, -0.189930, 0.111600, -0.054910, -0.426780, 0.066480, 
-0.140000, -0.087340, -0.136980, 0.030970, -0.092270, -0.053430, 0.152700, -0.384890, 0.141640, -0.012040, 
-0.334220, 0.518320, 0.030980, -0.252190, -0.052270, 0.283480, -0.422580, -0.087050, -0.280700, -0.348820, 
0.194150, -0.359000, -0.441280, 0.333470, -0.253240, -0.112150, -0.083190, -0.142570, 0.067160, -0.099660, 
0.218330, -0.166200, -0.013650, -0.074500, 0.010510, 0.399460, 0.022820, -0.098380, -0.070770, 0.204730, 
-0.146410, -0.216220, -0.170070, -0.143540, -0.000180, -0.296530, -0.338630, 0.242320, -0.159630, -0.034570, 
-0.137810, -0.256060, 0.274370, -0.136970, 0.216080, 0.165420, -0.045850, -0.155480, 0.134410, 0.238370, 
0.090340, -0.061600, -0.069860, 0.159990, 0.113430, -0.306100, -0.039320, -0.042540, 0.000170, -0.015090, 
-0.176870, -0.009920, -0.068690, -0.043080, -0.067860, -0.120950, 0.269300, -0.209470, 0.123370, 0.300120, 
-0.124820, -0.033100, 0.063230, 0.156990, 0.037590, 0.052840, -0.033460, 0.179910, 0.057820, -0.182000, 
-0.008450, 0.110680, -0.040850, -0.022500, -0.231480, 0.186880, -0.057710, 0.022120, -0.062260, 0.019520, 
0.206520, -0.089530, 0.148970, 0.050050, 0.066280, 0.021750, 0.043660, 0.110760, 0.100430, -0.048620, 
-0.104370, 0.143020, -0.079420, -0.096240, 0.016820, 0.170950, -0.042320, -0.120740, -0.082600, 0.218180, 
-0.088650, 0.024220, 0.090660, -0.084730, 0.209680, 0.026740, 0.364650, -0.049570, -0.108420, 0.261730, 
-0.157160, 0.120020, 
0.172920, -0.169220, -0.015380, 0.203060, -0.123100, -0.062090, -0.027960, 0.013890, -0.068030, 0.003310, 
-0.096590, -0.057620, 0.003800, -0.059450, -0.006340, 0.007840, -0.117940, -0.003220, 0.286830, -0.125830, 
-0.121220, 0.319230, -0.188680, -0.079890, 0.095040, -0.082240, -0.088580, 0.033310, -0.003990, -0.081410, 
-0.148880, 0.043410, -0.003440, 0.072310, -0.054410, -0.103270, 0.067110, -0.093160, -0.052580, -0.122870, 
-0.100550, 0.047590, 0.192880, -0.082690, -0.114960, 0.150610, -0.058230, -0.086840, 0.044400, -0.044770, 
-0.021740, -0.093250, 0.050060, 0.024220, -0.042790, 0.034410, 0.019510, 0.108570, -0.121480, -0.080510, 
0.166930, -0.023480, -0.045940, -0.014950, -0.106960, 0.049740, 0.333470, -0.071290, -0.141830, 0.130970, 
-0.025690, -0.075080, -0.009090, -0.009670, -0.010850, -0.175310, 0.052630, 0.114750, 0.041610, -0.026890, 
0.090580, 0.151980, -0.062920, 0.054890, 0.057300, -0.074840, 0.100260, -0.063550, -0.049420, 0.133600, 
0.209480, -0.061780, 0.016860, 0.200310, -0.124790, -0.128740, -0.074660, 0.018840, -0.169230, -0.220660, 
0.101030, -0.054910, -0.011800, 0.020920, -0.062860, 0.087920, -0.099350, 0.025110, 0.002770, -0.044250, 
-0.011170, -0.135320, 0.076770, -0.048200, 0.066420, -0.131930, 0.153820, 0.098970, -0.263620, -0.099900, 
-0.251540, -0.016040, -0.285630, -0.314320, -0.021540, -0.252720, -0.143250, 0.023610, -0.248710, -0.175650, 
-0.273610, 0.008690, -0.332020, -0.032690, -0.084670, -0.270500, 0.121420, -0.237260, -0.097140, -0.241320, 
-0.102380, -0.192030, -0.311990, 0.111320, -0.346000, -0.007820, -0.027540, -0.402440, -0.180100, 0.205350, 
-0.309830, -0.053070, 0.168050, -0.201950, -0.330730, 0.223050, -0.436520, -0.184690, 0.292890, -0.272320, 
-0.072650, 0.193960, -0.381910, -0.304710, 0.423410, -0.464310, -0.357800, 0.655140, -0.132270, 0.056260, 
-0.369820, -0.217510, -0.040670, -0.169110, -0.108900, -0.151100, -0.198780, -0.028550, -0.106330, -0.247150, 
-0.202030, -0.060140, -0.182010, -0.255490, 0.052970, -0.229650, -0.268250, -0.074030, 0.000670, -0.293780, 
0.080750, 0.044860, -0.081600, 0.061780, -0.175910, -0.228860, -0.048670, 0.025440, -0.069930, -0.133060, 
-0.026920, 0.072060, -0.046660, -0.109230, -0.093110, 0.026420, -0.047680, -0.056890, 0.059230, -0.111150, 
-0.120430, 0.168550, -0.195860, -0.270080, 0.371290, -0.128020, -0.014570, 0.088160, -0.242090, -0.134080, 
0.036160, -0.053500, -0.033330, -0.008470, -0.074280, 0.118890, -0.095300, -0.123520, -0.049520, 0.099620, 
-0.044590, 0.036850, 0.010210, -0.060990, -0.093330, 0.201400, -0.065760, -0.166420, 0.193340, -0.091180, 
0.029110, -0.110740, -0.076800, -0.117230, -0.020390, -0.031840, 0.000720, 0.084960, -0.053960, 0.124340, 
-0.045860, -0.098560, -0.101050, 0.083340, 0.116800, 0.006610, -0.057230, 0.061940, -0.190020, 0.187490, 
0.023580, -0.159390, 0.254450, -0.036490, -0.020110, -0.097420, -0.016390, -0.000650, -0.080990, -0.042950, 
-0.075270, 0.105410, 0.115330, 0.095770, -0.139710, 0.037640, -0.116000, 0.147710, 0.054070, -0.062320, 
-0.021430, 0.150840, -0.056820, 0.111570, 0.019200, -0.200610, 0.202350, 0.066520, -0.075980, -0.042730, 
0.041250, -0.014220, -0.100800, 0.007740, -0.237280, 0.115480, 0.177750, -0.171780, 0.061620, 0.059010, 
-0.179050, 0.054740, 0.105340, -0.094220, 0.067450, 0.056100, -0.028330, 0.051140, 0.076990, -0.198880, 
0.193350, 0.023650, 
-0.125170, 0.429640, -0.424180, -0.039610, 0.250300, -0.359840, -0.054550, -0.198670, 0.100240, -0.362290, 
-0.137400, 0.023980, -0.143560, 0.258910, 0.035990, -0.262770, 0.075280, 0.012480, 0.151690, 0.126820, 
-0.379150, 0.171010, 0.110430, -0.292370, 0.004470, 0.210550, -0.344530, 0.025580, 0.039740, -0.280400, 
0.100000, -0.048780, 0.145060, -0.350000, 0.409610, 0.181390, -0.016380, 0.602890, 0.021320, -0.000410, 
0.249900, -0.006220, -0.107250, -0.100070, 0.361520, -0.098280, 0.335650, -0.207880, 0.011770, 0.133720, 
-0.473830, -0.199060, 0.111310, -0.236600, 0.146230, 0.018380, -0.033900, 0.007420, 0.132500, 0.061010, 
0.072090, 0.533220, -0.244400, 0.065260, 0.001870, -0.056080, -0.199560, -0.004470, 0.413160, -0.172850, 
-0.159180, -0.088460, -0.163230, 0.141940, -0.361920, -0.222040, -0.041130, -0.109110, 0.135370, -0.180260, 
-0.017870, 0.027160, 0.134310, -0.227590, -0.142960, 0.583990, -0.237170, 0.067920, -0.301530, -0.069790, 
-0.265440, 0.399870, -0.257970, -0.310120, -0.255980, 0.103900, -0.071680, 0.004740, 0.092000, -0.324800, 
0.131150, 0.189590, 0.173680, -0.563890, 0.408760, -0.112470, -0.068950, -0.116620, 0.083620, 0.205460, 
0.043790, 0.155090, -0.497760, 0.107200, -0.353630, 0.010600, 0.240010, -0.162950, 0.271890, 0.076520, 
0.032270, 0.224010, -0.337870, -0.014680, 0.436310, -0.332510, 0.167850, -0.149720, 0.035480, -0.141670, 
0.411490, -0.210420, 0.223220, 0.807600, -0.255270, 0.094350, -0.081530, -0.145630, -0.044150, 0.150200, 
0.045890, -0.024040, 0.655350, -0.509830, -0.186320, 0.502200, -0.682030, -0.114860, 0.683220, -0.800110, 
0.125660, 0.031100, -0.430110, -0.116770, 0.676080, -0.707960, -0.030300, 1.185370, -0.733420, -0.108830, 
0.127990, -0.402600, 0.096250, 0.930750, -1.365370, 0.115680, 1.015060, -1.602010, -0.225320, 0.508780, 
-0.378640, -0.099690, 0.436060, -0.408070, 0.261040, -0.270520, -0.011690, 0.295240, 0.030880, -0.415320, 
-0.059580, 0.451120, -0.230580, 0.140110, -0.449360, 0.140170, -0.065690, 0.594520, -0.852040, -0.073740, 
0.492610, -0.748200, -0.235160, 0.048870, 0.005700, -0.089280, 0.126730, -0.116920, 0.206580, -0.161350, 
0.007160, -0.170560, -0.215320, 0.045030, -0.094850, -0.066340, 0.169380, 0.053920, -0.332280, 0.245580, 
-0.042430, -0.010880, 0.105770, -0.248850, -0.087900, 0.162700, -0.102650, -0.086370, -0.082230, -0.099770, 
0.038430, -0.216500, 0.054910, 0.115220, -0.168270, -0.212180, -0.095740, 0.005660, -0.273430, 0.468330, 
-0.087360, -0.120370, -0.145120, 0.112340, -0.112350, 0.249000, -0.001540, -0.149100, 0.115850, 0.135840, 
-0.051420, -0.140060, -0.315300, -0.211230, 0.052700, -0.332320, 0.092810, -0.066210, -0.302010, -0.201840, 
0.149240, -0.238150, -0.207430, 0.368370, -0.319380, -0.084130, -0.130680, -0.084000, -0.367440, 0.325650, 
0.214410, -0.473510, 0.035300, 0.264780, -0.097290, -0.113510, -0.202820, -0.229440, 0.027260, -0.254770, 
0.081910, -0.116680, -0.392910, -0.116380, 0.134640, -0.219560, 0.054770, 0.013760, -0.262760, -0.191340, 
-0.228630, -0.116500, -0.489080, 0.335990, 0.242650, -0.259370, 0.374280, 0.095740, 0.056510, -0.229740, 
-0.276190, 0.110330, -0.152060, -0.288240, 0.169890, -0.085050, -0.287370, -0.049130, -0.099940, -0.200220, 
0.025510, 0.019590, -0.197420, -0.151260, -0.266310, 0.032970, 0.287170, 0.196530, -0.421450, -0.171100, 
0.373640, -0.300350, 
0.013590, -0.047790, -0.018040, -0.000870, 0.023300, -0.054180, -0.069840, 0.049470, -0.031260, -0.064260, 
-0.033360, -0.027020, -0.082110, 0.018240, 0.044130, -0.039930, -0.039100, 0.015910, 0.038500, -0.008900, 
-0.074070, 0.026710, -0.058250, -0.007570, -0.019310, -0.031100, -0.032650, -0.083370, 0.040010, -0.058840, 
-0.144630, 0.017780, -0.005400, -0.011430, -0.026680, -0.055480, 0.007030, -0.049130, -0.017940, -0.107590, 
-0.072070, 0.054000, 0.047270, -0.041740, -0.039870, -0.046400, -0.018900, 0.023460, 0.001180, -0.024370, 
-0.028160, -0.132550, 0.069340, -0.012910, -0.069370, 0.062050, -0.045550, 0.009620, 0.004330, -0.095170, 
0.068980, -0.009810, -0.004770, -0.068650, -0.060290, 0.033110, 0.102570, -0.030270, -0.042680, 0.000760, 
-0.034910, -0.022900, -0.007310, -0.025750, -0.044220, -0.140030, 0.037270, 0.031430, 0.009690, 0.001580, 
-0.014240, 0.015650, 0.032270, -0.045620, -0.001040, -0.042970, 0.032300, -0.061450, -0.028040, 0.044450, 
0.080990, 0.008260, -0.057790, 0.062740, -0.067420, -0.150730, -0.090500, -0.050760, -0.037390, -0.191810, 
-0.000960, 0.061080, -0.051580, -0.014680, -0.037060, -0.000550, -0.058470, -0.026240, -0.056550, -0.076500, 
0.025600, -0.113000, 0.032450, -0.013240, -0.002450, -0.044220, 0.068340, -0.004570, -0.204450, -0.069180, 
-0.199920, -0.122420, -0.078570, -0.282050, -0.132400, -0.011820, -0.131910, -0.067670, -0.129250, -0.189730, 
-0.241140, 0.085610, -0.248010, -0.089940, 0.047240, -0.196230, -0.005610, -0.084970, -0.067350, -0.240810, 
-0.022570, -0.157070, -0.363120, 0.166940, -0.299540, -0.145540, 0.128950, -0.357340, -0.277870, 0.301830, 
-0.224220, -0.087500, 0.155950, -0.221570, -0.298800, 0.269490, -0.302430, -0.188260, 0.257370, -0.220110, 
-0.190760, 0.201220, -0.161850, -0.322510, 0.174010, -0.261970, -0.404530, 0.469170, -0.129620, -0.075580, 
-0.173340, -0.208320, -0.166990, 0.018630, -0.132560, -0.159150, -0.049660, -0.077750, -0.158530, -0.037730, 
-0.185090, -0.118240, -0.032040, -0.185990, -0.092770, -0.056360, -0.214110, -0.213100, 0.031850, -0.186190, 
-0.141150, 0.176560, -0.064020, -0.009720, -0.113680, -0.165110, -0.086650, 0.042790, -0.065440, -0.112590, 
0.015590, 0.002010, -0.026300, -0.003440, -0.112090, -0.010750, 0.031720, -0.054190, 0.038470, -0.040830, 
-0.086910, -0.005190, -0.092970, -0.162230, 0.146520, 0.002370, 0.000450, 0.031020, -0.156750, -0.073810, 
-0.007600, -0.021710, -0.023980, 0.004090, -0.020290, 0.077410, -0.025380, -0.084030, -0.041800, 0.090960, 
0.008670, -0.002020, 0.052620, -0.015230, -0.058930, 0.160600, -0.063640, -0.111070, 0.110610, -0.037200, 
0.016850, -0.078410, -0.058120, -0.087170, 0.005590, -0.028780, 0.018130, 0.089520, -0.053880, 0.083360, 
0.058030, -0.097700, -0.042470, 0.071070, 0.069890, -0.013280, 0.008180, 0.037780, -0.074930, 0.084930, 
-0.036930, -0.088570, 0.157710, -0.046840, 0.006490, -0.058120, -0.013150, 0.017620, -0.061120, -0.021340, 
-0.014600, 0.079160, 0.068400, 0.075200, -0.025030, -0.007610, -0.053810, 0.102150, 0.035330, -0.064160, 
0.007040, 0.102970, -0.021060, -0.004260, 0.043880, -0.115800, 0.098430, -0.007880, 0.033160, -0.081740, 
0.012400, 0.083740, -0.117580, 0.002780, -0.073120, 0.056180, 0.097890, -0.038310, 0.000870, 0.030250, 
-0.045590, 0.007970, 0.021150, -0.015630, 0.032640, 0.042070, 0.093500, -0.011280, -0.011170, -0.059310, 
0.077200, 0.001050, 
-0.062420, 0.035730, -0.028380, -0.042900, -0.006420, -0.001710, -0.040690, -0.030080, 0.023780, -0.092600, 
-0.005030, -0.023140, -0.032090, 0.019750, -0.011580, -0.084750, -0.003080, 0.001410, -0.068520, 0.001980, 
-0.024730, -0.028140, 0.026690, -0.026650, -0.011350, 0.011880, -0.053430, -0.003350, -0.007490, -0.042850, 
-0.017310, 0.001980, -0.008430, -0.056840, 0.024330, -0.053770, -0.033440, 0.059390, -0.023700, -0.037920, 
0.004890, -0.028010, -0.083410, -0.000190, -0.013300, -0.042160, 0.040960, -0.042860, 0.003660, 0.010660, 
-0.100570, -0.018140, 0.005500, -0.050480, -0.002930, -0.011970, -0.047200, -0.021900, 0.007840, -0.050020, 
-0.022640, 0.082710, -0.070170, -0.031010, -0.008590, -0.048450, -0.067830, 0.030470, -0.045290, -0.038490, 
0.004430, -0.047590, 0.014940, 0.024730, -0.124480, -0.042750, 0.013060, -0.046170, 0.015560, -0.016510, 
-0.072940, -0.039630, 0.003830, -0.072040, -0.002620, 0.060840, -0.090720, -0.033250, -0.039020, -0.057430, 
-0.056200, 0.042750, -0.117060, -0.061500, 0.014090, -0.069120, 0.021600, -0.015020, -0.109700, -0.029930, 
0.010630, -0.051610, 0.010400, -0.037610, -0.047560, -0.026300, -0.020280, -0.059900, -0.020900, 0.067410, 
-0.090070, -0.007300, -0.058050, -0.043070, -0.116510, 0.040030, -0.073370, -0.048050, 0.043230, -0.110850, 
0.009160, 0.005720, -0.084520, -0.022720, 0.058910, -0.065490, 0.000150, -0.032460, -0.045560, -0.035800, 
-0.009740, -0.069530, 0.016640, 0.058440, -0.087010, -0.014190, -0.044500, -0.036410, -0.119730, 0.044100, 
-0.065840, -0.064260, 0.053130, -0.126880, -0.070650, 0.036410, -0.058740, -0.074080, 0.042250, -0.061650, 
-0.027090, -0.066950, -0.025000, -0.091580, -0.010070, -0.039910, -0.083450, 0.031780, -0.031790, -0.080030, 
-0.028250, -0.004880, -0.164630, 0.049680, -0.063740, -0.140210, 0.084590, -0.106310, -0.039420, 0.010160, 
-0.047320, -0.053170, 0.013630, -0.035230, 0.024260, -0.045320, -0.048640, -0.015980, -0.048280, -0.053580, 
-0.047620, 0.004870, -0.026660, -0.027100, -0.080250, 0.019810, -0.129080, 0.052570, -0.055570, -0.120110, 
0.064220, -0.104470, -0.039260, -0.027820, -0.026380, -0.059040, -0.024110, -0.010690, 0.041510, -0.035530, 
-0.046050, -0.022590, -0.044010, -0.028960, -0.001330, -0.032000, -0.006570, -0.015240, -0.086350, 0.036400, 
-0.092940, 0.013090, -0.040940, -0.103120, -0.003190, -0.075970, -0.033410, -0.026360, -0.041770, -0.079010, 
-0.021990, -0.012450, 0.017410, -0.048490, -0.034630, -0.043720, -0.025340, -0.033860, -0.019310, -0.007610, 
-0.019310, -0.023680, -0.065110, 0.018370, -0.086830, 0.003300, -0.053420, -0.049920, -0.032260, -0.058870, 
-0.042270, -0.046060, -0.029080, -0.067960, -0.071440, 0.012050, -0.017070, -0.039520, -0.054180, -0.074440, 
0.003160, -0.029250, -0.053790, -0.008700, -0.022510, -0.029310, -0.082160, 0.001900, -0.048770, -0.010400, 
-0.049200, -0.062840, -0.045110, -0.017670, -0.067230, -0.047950, 0.004610, -0.088330, -0.076090, 0.031500, 
-0.066570, -0.029880, -0.037220, -0.069010, -0.014920, -0.013320, -0.072980, -0.023240, 0.002850, -0.072000, 
-0.063330, 0.024250, -0.069480, -0.026920, -0.017640, -0.067690, -0.042250, 0.018620, -0.097990, -0.000710, 
-0.007030, -0.090340, -0.033270, 0.001880, -0.086120, -0.023910, -0.022330, -0.091900, 0.005660, -0.037430, 
-0.115080, 0.002750, -0.007610, -0.078380, -0.025850, 0.016140, -0.051910, 0.004860, -0.037750, -0.098510, 
0.008190, -0.040370, 
-0.046820, 0.299170, -0.006600, 0.041710, 0.296760, -0.055190, 0.123520, -0.026330, -0.011440, -0.004560, 
0.140600, -0.200260, 0.154630, 0.090310, -0.021670, 0.080760, 0.024920, -0.076210, 0.210420, 0.357410, 
-0.487280, 0.471780, 0.469430, -0.427920, -0.020630, 0.081050, 0.052560, -0.115710, 0.130460, 0.118180, 
0.067280, -0.111120, 0.167150, -0.005750, 0.179620, 0.014110, 0.118630, -0.073820, 0.186140, 0.029180, 
-0.108550, 0.150970, 0.142850, 0.301130, -0.362300, 0.190530, 0.360120, -0.047620, 0.042110, -0.086840, 
0.063360, -0.237930, -0.024050, 0.333040, 0.174330, -0.101050, 0.046430, -0.055130, 0.061880, 0.163590, 
0.229330, -0.125930, 0.219090, 0.091020, -0.345840, 0.156190, 0.115140, 0.147460, -0.036240, 0.222080, 
-0.099250, 0.091170, 0.153450, -0.310070, 0.043330, -0.362870, -0.198630, 0.455820, 0.172700, -0.182610, 
-0.131290, 0.017830, -0.181480, 0.131560, 0.195460, -0.109250, 0.094730, 0.139190, -0.581270, 0.125210, 
0.135250, -0.019070, -0.183520, 0.012870, -0.269950, 0.022190, 0.105530, -0.324860, -0.037020, -0.234150, 
-0.220650, 0.317870, 0.055290, -0.259110, -0.082950, 0.072820, -0.300800, 0.089600, 0.015670, -0.015550, 
0.007560, 0.040670, -0.406760, 0.038150, -0.452220, 0.180630, 0.000630, -0.282850, -0.188030, -0.065740, 
-0.201800, -0.100100, -0.078040, -0.365930, -0.012120, 0.098960, 0.004010, -0.126650, -0.296700, -0.166290, 
-0.217320, -0.030940, -0.056410, 0.049660, -0.063010, 0.050100, -0.174230, -0.165360, -0.869140, 0.370190, 
-0.068720, -0.825780, 0.230480, 0.005430, -0.613690, 0.062260, 0.132820, -0.499680, -0.036630, 0.197770, 
-0.089010, -0.101800, -0.080030, -0.339830, -0.041420, 0.127510, -0.174980, 0.146670, -0.011240, -0.115200, 
0.005040, -0.008520, -1.146920, 0.494870, -0.026920, -1.036260, 0.598230, -0.086530, -0.249880, 0.022560, 
-0.134640, -0.404910, 0.066580, -0.002070, 0.174330, 0.001020, -0.406490, -0.027650, -0.114700, -0.100790, 
0.093430, 0.174420, -0.225400, -0.033330, 0.006960, -0.212480, -0.640000, 0.211740, -0.056500, -0.801610, 
0.571350, -0.318910, -0.019250, -0.148190, -0.014460, -0.482770, 0.004000, 0.106190, 0.355880, -0.055780, 
-0.221340, 0.295890, 0.007300, -0.090940, 0.354130, 0.025710, -0.039740, 0.229000, -0.053200, -0.005070, 
-0.500660, 0.031730, 0.071010, -0.497400, 0.369980, -0.320330, 0.026620, -0.288710, 0.125810, -0.358820, 
-0.150700, 0.267550, 0.364300, -0.213890, -0.064730, 0.394870, -0.101380, -0.156760, 0.280600, -0.034600, 
0.147220, 0.414090, -0.235820, 0.013400, -0.303860, -0.014510, 0.129370, -0.060260, 0.056650, -0.087910, 
0.048360, -0.377610, 0.227720, -0.297700, -0.336710, 0.421970, 0.263970, -0.154270, -0.097490, 0.307860, 
0.005760, 0.006030, 0.158590, -0.084780, 0.226360, 0.368800, -0.346440, 0.168790, 0.033190, -0.043970, 
0.144140, -0.140460, 0.150210, 0.099220, 0.040820, -0.193840, 0.213530, -0.150450, -0.190380, 0.316540, 
0.018750, -0.020340, -0.050290, 0.264140, 0.099100, -0.092440, 0.121950, -0.018330, 0.093250, 0.129570, 
-0.201090, 0.118670, 0.084020, 0.070850, 0.048840, -0.235510, 0.018630, 0.182120, -0.059820, 0.094320, 
0.176850, -0.093620, 0.050310, 0.224820, -0.020830, 0.067160, -0.199780, 0.208510, 0.230050, -0.271330, 
0.045500, -0.056380, -0.114560, 0.172180, 0.003980, -0.147790, 0.110590, 0.258500, 0.085860, -0.229190, 
0.117270, -0.001360, 
0.218660, -0.268120, -0.002810, 0.241490, -0.222090, -0.036300, -0.137470, 0.074340, -0.134840, -0.099200, 
-0.130340, -0.115850, -0.079290, -0.045900, -0.049930, -0.082060, -0.142680, -0.037830, 0.515080, -0.166880, 
-0.238590, 0.545390, -0.310910, -0.167350, 0.155100, -0.173770, -0.118310, 0.032950, -0.075170, -0.056960, 
-0.327480, 0.071400, 0.015920, 0.079140, -0.066480, -0.165200, -0.018080, -0.103490, -0.056720, -0.274290, 
-0.108960, 0.068590, 0.330880, -0.162370, -0.152370, 0.338050, -0.144010, -0.173690, 0.084150, -0.136500, 
0.045520, -0.171540, -0.007550, 0.201170, -0.047370, 0.040120, 0.026100, 0.208090, -0.237490, -0.073920, 
0.218910, -0.025550, -0.079790, -0.059880, -0.183450, 0.118260, 0.594630, -0.163100, -0.201780, 0.345750, 
-0.136730, -0.084090, 0.028970, -0.055370, 0.017530, -0.310530, 0.027840, 0.293510, 0.011210, -0.072810, 
0.201270, 0.244420, -0.088770, 0.146050, 0.105160, -0.088470, 0.128410, -0.108620, -0.099350, 0.226120, 
0.324160, -0.142200, 0.083160, 0.351800, -0.270560, -0.156520, -0.080470, 0.022880, -0.273440, -0.300580, 
0.164590, -0.064600, -0.055170, 0.004870, -0.018650, 0.030920, -0.144790, 0.111270, 0.026250, 0.029520, 
-0.073830, -0.266350, 0.109620, -0.010100, 0.092010, -0.228340, 0.334440, 0.243410, -0.443540, -0.099100, 
-0.300710, 0.031990, -0.543540, -0.372720, -0.003400, -0.418460, -0.276090, 0.055960, -0.324850, -0.318370, 
-0.338720, 0.007830, -0.598560, 0.109580, -0.105270, -0.422650, 0.311160, -0.352990, -0.111050, -0.330510, 
-0.058600, -0.198610, -0.456220, 0.175020, -0.493240, 0.093810, -0.169130, -0.463930, -0.206230, 0.156410, 
-0.431090, 0.019980, 0.163670, -0.320070, -0.290930, 0.184590, -0.696590, -0.093980, 0.379800, -0.442820, 
0.015080, 0.234740, -0.681830, -0.338490, 0.753340, -0.721930, -0.442300, 1.016670, -0.090090, 0.142440, 
-0.659670, -0.154600, -0.040110, -0.356720, 0.009210, -0.141040, -0.461660, 0.131070, -0.168550, -0.485840, 
-0.150970, 0.043000, -0.423190, -0.256020, 0.170720, -0.461110, -0.305350, -0.098130, 0.023980, -0.336540, 
0.121470, 0.052210, -0.033230, -0.007690, -0.235710, -0.230580, -0.161460, 0.079650, 0.008250, -0.139620, 
-0.089680, 0.269100, -0.090850, -0.237510, -0.002900, 0.050300, -0.089060, 0.003520, 0.097560, -0.160640, 
-0.145550, 0.166560, -0.145100, -0.343690, 0.468100, -0.092920, 0.103610, 0.004130, -0.271570, -0.094680, 
-0.080380, 0.007060, 0.104260, -0.032510, -0.144590, 0.318110, -0.203660, -0.215130, 0.059980, 0.116340, 
-0.056690, 0.205480, -0.014090, -0.129010, -0.058450, 0.204310, 0.015460, -0.153720, 0.146990, 0.007490, 
0.156800, -0.247420, -0.077470, -0.089910, -0.114430, 0.063250, 0.158100, 0.088040, -0.120600, 0.363730, 
-0.117960, -0.199440, -0.002280, 0.093360, 0.124970, 0.221230, -0.144460, 0.024770, -0.154970, 0.281410, 
0.070760, -0.086450, 0.336850, -0.028150, 0.059090, -0.138910, -0.007230, 0.058660, -0.106180, -0.045380, 
0.022840, 0.194080, 0.095480, 0.297460, -0.239040, -0.038970, 0.026980, 0.211940, -0.017610, 0.055520, 
-0.086220, 0.164390, 0.029700, 0.212080, 0.031870, -0.215650, 0.299400, 0.144870, -0.057340, 0.004810, 
0.030670, 0.005620, -0.077170, -0.013420, -0.274370, 0.267880, 0.200500, -0.158020, 0.102670, 0.011700, 
-0.163420, 0.136360, 0.078910, -0.047350, 0.058790, 0.029820, 0.034040, 0.184970, 0.145190, -0.169680, 
0.299590, 0.044850, 
-0.083780, -0.058100, 0.451910, -0.031750, 0.246800, 0.210390, 0.023610, 0.142380, 0.337140, 0.052670, 
-0.083900, 0.299760, 0.019710, 0.116340, 0.344720, 0.144630, -0.011050, 0.312470, 0.050150, -0.031260, 
0.355380, -0.000690, 0.213520, 0.125110, -0.213830, 0.019470, 0.317280, -0.246440, 0.286130, 0.054350, 
-0.067280, -0.066950, 0.236170, 0.182310, -0.197360, 0.095290, 0.286420, -0.208450, -0.042960, 0.016930, 
-0.100460, 0.129500, -0.008050, 0.062160, 0.144240, -0.237910, 0.232720, 0.211610, -0.176330, 0.047740, 
0.208590, -0.389340, 0.349490, 0.090210, 0.099610, -0.031400, 0.077430, 0.181270, -0.013140, -0.183080, 
0.342590, -0.164180, -0.012170, 0.065390, -0.049530, 0.015100, -0.141880, 0.167450, 0.037760, -0.314000, 
0.272100, 0.116200, -0.188010, 0.036280, 0.222850, -0.410930, 0.319130, 0.175370, 0.086150, 0.035590, 
0.164700, 0.149380, -0.063860, 0.058910, 0.106200, -0.178220, 0.140000, -0.003400, -0.053680, 0.195300, 
-0.218540, 0.156530, 0.292990, -0.264520, 0.047570, 0.173290, -0.230490, -0.052070, 0.102570, -0.472440, 
0.192780, 0.150890, 0.057760, 0.080680, -0.051440, 0.168980, -0.145550, -0.020250, -0.006640, -0.147790, 
0.034960, -0.051850, 0.019410, 0.026660, -0.137780, 0.054820, 0.245750, -0.321950, -0.274970, 0.123490, 
-0.279850, -0.246590, 0.030990, -0.424810, -0.194230, 0.035070, 0.067250, -0.020460, -0.274380, 0.105830, 
-0.384230, 0.136970, -0.164120, -0.271340, 0.069150, -0.092040, -0.029850, -0.068010, -0.111940, -0.304570, 
0.060100, -0.151990, -0.716400, 0.431330, -0.399880, -0.159370, 0.213410, -0.495030, -0.261670, 0.384320, 
-0.081290, -0.080490, 0.153580, 0.191740, -0.568340, 0.384180, 0.007960, -0.444960, 0.209770, 0.135660, 
-0.295780, 0.208300, -0.133420, -0.596620, 0.438630, -0.248640, -0.678730, 0.778800, -0.304580, 0.048980, 
-0.216040, -0.444630, -0.036470, 0.049930, -0.014890, -0.240200, -0.156890, 0.283470, -0.294600, -0.108120, 
-0.071890, -0.120890, -0.182730, 0.031130, -0.012450, -0.270940, -0.351690, -0.207420, 0.130230, -0.360280, 
-0.085960, 0.251920, -0.270360, 0.065580, -0.094240, -0.356630, -0.098120, 0.155220, -0.022820, -0.219600, 
-0.101210, 0.252210, -0.283190, -0.121650, -0.181030, -0.089310, 0.047670, 0.074340, -0.036920, -0.114080, 
-0.219880, 0.122520, 0.011450, -0.368160, 0.289540, 0.042570, -0.185230, 0.094960, -0.132550, -0.200200, 
-0.087260, 0.056280, -0.083690, -0.057110, -0.064660, 0.238640, -0.370960, -0.126550, -0.235550, 0.025650, 
0.153720, -0.080640, 0.062450, 0.083800, -0.299440, 0.258710, 0.235150, -0.288930, 0.168210, 0.014970, 
-0.191310, -0.064720, -0.037150, -0.318350, 0.037260, -0.027570, -0.068360, 0.133210, -0.153180, 0.196700, 
0.002330, -0.403130, -0.170340, 0.185060, 0.042840, -0.107130, 0.069670, 0.008980, -0.226340, 0.035250, 
0.005460, -0.244380, 0.352610, -0.312510, -0.113260, -0.113640, -0.085730, -0.052390, -0.215210, -0.050390, 
-0.206350, 0.283100, -0.063230, -0.031860, 0.284550, -0.423420, -0.270020, 0.370310, -0.150760, -0.155130, 
0.131750, 0.057830, -0.086090, -0.117560, -0.188060, -0.236100, 0.360820, -0.374060, -0.001100, -0.118240, 
-0.082820, 0.072600, -0.214670, -0.047170, -0.220420, 0.355210, -0.143560, -0.185980, 0.384120, -0.300530, 
-0.094130, 0.176110, -0.236680, 0.015310, 0.114360, -0.098060, 0.063950, 0.062460, -0.409310, -0.026690, 
0.279230, -0.476850, 
0.045570, -0.067800, 0.002290, 0.040570, 0.014600, -0.068240, -0.048240, 0.059590, -0.038270, -0.046440, 
-0.032480, -0.026640, -0.066680, 0.033530, 0.044880, -0.048690, -0.035190, 0.019380, 0.063090, -0.016490, 
-0.059360, 0.081090, -0.048210, -0.015230, -0.018360, -0.033050, -0.036090, -0.087380, 0.057580, -0.067920, 
-0.159810, 0.036480, 0.005480, 0.004160, -0.019720, -0.085520, 0.011250, -0.055000, -0.019810, -0.107890, 
-0.083840, 0.060050, 0.085980, -0.018040, -0.066330, -0.022090, 0.011260, -0.001450, -0.007520, -0.033240, 
-0.028860, -0.137420, 0.111060, 0.000430, -0.060170, 0.057520, -0.044020, 0.035390, 0.002820, -0.117720, 
0.094580, -0.020610, -0.021130, -0.045050, -0.080920, 0.035660, 0.119390, 0.006800, -0.069390, 0.004840, 
-0.010760, -0.039450, -0.022170, -0.018130, -0.030630, -0.156180, 0.046830, 0.043300, 0.018870, -0.001020, 
-0.001640, 0.064210, 0.005810, -0.036800, 0.013820, -0.051670, 0.049930, -0.047820, -0.036180, 0.065470, 
0.095110, 0.052360, -0.050840, 0.090540, -0.061180, -0.154950, -0.090990, -0.044160, -0.065400, -0.203940, 
0.003870, 0.053320, -0.039650, -0.003380, -0.069160, 0.027920, -0.059480, -0.055550, -0.033960, -0.066340, 
0.027140, -0.115780, 0.039270, -0.038840, -0.005680, -0.035280, 0.089870, -0.007470, -0.218570, -0.060800, 
-0.213930, -0.141700, -0.125920, -0.279840, -0.151020, -0.045630, -0.122760, -0.064810, -0.185760, -0.171490, 
-0.291050, 0.079820, -0.257650, -0.101610, 0.016200, -0.191290, 0.004340, -0.135670, -0.077160, -0.250600, 
-0.036880, -0.171120, -0.404750, 0.184190, -0.320110, -0.174530, 0.131290, -0.366730, -0.325110, 0.337940, 
-0.238830, -0.100810, 0.149660, -0.190210, -0.365830, 0.293980, -0.296190, -0.233810, 0.261780, -0.192420, 
-0.210580, 0.211890, -0.206580, -0.364430, 0.242920, -0.310350, -0.467400, 0.554760, -0.116420, -0.073980, 
-0.225090, -0.210650, -0.174090, -0.013610, -0.129810, -0.172030, -0.094180, -0.060710, -0.189640, -0.062080, 
-0.163900, -0.125730, -0.069650, -0.156110, -0.104770, -0.116860, -0.272410, -0.195760, 0.045000, -0.221640, 
-0.135590, 0.187340, -0.053510, -0.012170, -0.135680, -0.166640, -0.077610, 0.033040, -0.064020, -0.140510, 
-0.003330, 0.025050, -0.026180, -0.027060, -0.092790, 0.017360, -0.017560, -0.031720, 0.051770, -0.074680, 
-0.108540, 0.049230, -0.104890, -0.202930, 0.238300, -0.027670, 0.020500, 0.047550, -0.180990, -0.086970, 
-0.007700, -0.028050, -0.007310, -0.004050, -0.054110, 0.105890, -0.021650, -0.117570, -0.044590, 0.107400, 
0.008230, 0.024640, 0.038230, -0.032960, -0.085390, 0.250070, -0.078310, -0.135320, 0.176480, -0.055810, 
0.041790, -0.090170, -0.072630, -0.092760, 0.002600, -0.033510, 0.023930, 0.082360, -0.039980, 0.119200, 
0.054030, -0.130080, -0.037370, 0.082730, 0.080270, 0.025000, 0.001740, 0.031950, -0.100840, 0.144330, 
-0.038270, -0.108650, 0.223460, -0.065490, 0.032290, -0.061070, -0.020230, 0.048170, -0.051160, -0.025590, 
-0.008770, 0.075850, 0.091760, 0.116760, -0.035930, -0.013780, -0.023880, 0.126620, 0.057680, -0.050740, 
0.018800, 0.122780, -0.034880, 0.018400, 0.068560, -0.132220, 0.133600, 0.007620, 0.049780, -0.074040, 
0.035740, 0.098010, -0.116560, 0.019700, -0.092170, 0.068510, 0.124980, -0.031560, 0.017050, 0.051780, 
-0.036320, 0.027940, 0.052340, -0.002470, 0.042460, 0.075630, 0.102120, 0.008030, -0.005330, -0.086630, 
0.125280, 0.012540, 
0.140950, -0.137350, -0.164580, -0.113030, -0.039260, -0.073030, -0.000840, -0.028120, -0.069280, 0.059930, 
0.067490, -0.014530, -0.051750, -0.165100, 0.011580, 0.064010, -0.028450, 0.029470, 0.057840, -0.055210, 
-0.022960, -0.324670, -0.157330, 0.274110, 0.205430, -0.122160, -0.263930, 0.016390, -0.058030, -0.186160, 
0.064730, -0.077230, -0.128250, -0.041860, 0.035500, -0.066030, 0.092030, -0.242670, -0.040730, 0.135910, 
-0.023530, -0.164600, 0.185750, -0.139270, -0.029350, -0.164690, -0.180580, 0.135070, 0.246510, -0.160250, 
-0.272290, 0.134610, -0.131840, -0.254000, 0.035110, 0.022030, -0.207700, -0.049170, 0.062910, -0.120890, 
-0.003970, -0.235970, -0.010880, 0.050650, 0.025160, -0.149490, 0.080210, -0.130980, -0.003340, -0.111590, 
-0.195040, 0.002800, 0.234850, -0.211950, -0.267100, 0.156330, -0.295710, -0.248470, 0.003980, 0.004880, 
-0.136820, -0.071480, 0.008620, -0.113210, 0.085570, -0.239850, -0.074500, 0.083500, 0.133520, -0.229460, 
0.144140, -0.176410, -0.097010, -0.098590, -0.180640, -0.048730, 0.136390, -0.136650, -0.305600, 0.132700, 
-0.334460, -0.271570, -0.079180, 0.050470, -0.219070, -0.133230, 0.083650, -0.155310, 0.081910, -0.113520, 
-0.205710, -0.057210, 0.188450, -0.266100, -0.009750, -0.154090, -0.061850, -0.136940, -0.192130, 0.058150, 
0.073800, -0.044860, -0.325930, 0.171030, -0.300310, -0.229200, -0.091050, 0.160270, -0.218090, -0.142940, 
0.245890, -0.160070, 0.016670, 0.104340, -0.249890, -0.130220, 0.317360, -0.219580, -0.052760, 0.107010, 
-0.103830, 0.002320, -0.181570, -0.006970, 0.187460, -0.034780, -0.536050, 0.166730, -0.196660, -0.369860, 
0.030140, 0.258740, -0.401320, 0.013860, 0.355250, -0.394140, 0.213550, 0.216990, -0.573980, 0.000510, 
0.354360, -0.450840, 0.115120, 0.281900, -0.506720, 0.150220, -0.015900, -0.381730, 0.112580, -0.062200, 
-0.308740, 0.058270, -0.231860, -0.216050, -0.016630, 0.293650, -0.300640, -0.000200, 0.239670, -0.240080, 
0.177970, 0.157370, -0.436340, 0.079740, 0.300960, -0.307040, 0.284870, 0.090030, -0.404750, 0.276990, 
-0.127920, -0.352580, 0.128200, -0.171450, -0.162960, 0.150980, -0.270770, -0.113290, -0.029300, 0.153040, 
-0.287140, 0.059530, 0.031080, -0.111540, 0.071370, 0.023980, -0.276100, 0.141770, 0.155650, -0.275800, 
0.376650, -0.105640, -0.282590, 0.291610, -0.258720, -0.142700, 0.169130, -0.247440, -0.033090, 0.206680, 
-0.245670, -0.071380, 0.023230, 0.047970, -0.190830, -0.025920, -0.081990, 0.091510, -0.022080, -0.094260, 
-0.010650, 0.106990, 0.015850, -0.097720, 0.122280, -0.229370, 0.070810, 0.218770, -0.296790, 0.020920, 
0.112890, -0.159560, 0.022760, 0.186830, -0.111820, -0.072360, 0.018300, 0.018490, -0.045040, -0.039830, 
-0.207640, 0.182360, -0.169630, -0.100300, 0.130700, 0.013120, 0.104900, -0.021580, 0.105920, -0.135530, 
0.049210, 0.011070, -0.170660, 0.032270, 0.155910, -0.090810, -0.138010, 0.144010, 0.009500, -0.170740, 
-0.029750, 0.024710, -0.093380, -0.129040, -0.291530, 0.178100, -0.308470, -0.072070, 0.156360, -0.113090, 
0.136140, -0.051390, 0.117440, -0.043260, -0.086840, -0.071610, -0.018940, -0.085650, 0.161060, -0.171490, 
-0.157280, 0.114170, -0.092660, -0.122190, -0.029940, -0.030920, -0.108230, 0.062250, -0.417160, 0.091850, 
-0.264410, -0.070240, 0.133510, -0.126800, 0.069520, -0.104710, -0.017380, 0.077440, -0.106210, -0.132290, 
-0.127380, 0.018370, 
-0.447810, -0.281690, 0.257710, 0.617200, 0.785130, 1.015610, 0.503830, 0.593360, 0.131160, 0.069590, 
-0.539380, -1.511890, 0.364710, -1.755870, -0.904590, -0.440900, 0.432190, 0.919910, -0.054200, -0.282690, 
-0.619670, -0.495210, 1.128180, -1.606430, -0.256520, 0.238710, 0.714180, 0.336910, -1.606480, 0.626470, 
0.791280, -0.277040, -0.875340, -0.086290, -0.376130, -1.151680, -0.577570, -0.175620, -0.120070, 0.766180, 

0.379260, -0.996750, 0.382390, -1.154680, 0.586170, -1.455120, -0.666940, 0.327450, -0.773360, 0.099340, 
-0.354490, 0.002140, -0.804900, -0.140480, -0.226550, -1.752550, -1.482190, -0.815200, -0.068580, -0.728100, 
-0.425560, 0.379420, -0.153080, 0.647740, -0.184310, -0.883600, -0.754840, 0.793950, 0.232490, -1.466580, 
-1.475950, -0.750440, 1.116130, -0.034960, 0.107400, 0.500870, -0.875280, -0.596590, -0.173790, -0.995010, 

-0.895750, 0.512150, -0.430300, -0.504420, -1.034020, -0.589300, 0.236020, -0.461210, 0.559030, -0.172450, 
0.567120, 0.172710, -0.017780, 1.658900, 0.973060, -0.361530, -0.002130, -0.641850, 0.021650, 0.687610, 
0.507540, -0.149230, -0.969590, -0.041560, 0.143010, -0.283560, -0.580650, -0.995250, -0.092540, -0.232520, 
0.097780, 0.332330, -1.037410, 0.397830, -0.134790, 0.183360, 1.001270, 0.537080, 0.388380, -0.461930, 


  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[356] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.010000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, 0.009980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.009170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.002710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.008150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, -0.000540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.000910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, 0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, -0.006630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.008630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, -0.001360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, -0.001120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, 0.008980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, 0.009620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.004950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, -0.007520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.000630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, -0.008410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, -0.000310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, -0.006210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, 0.006230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.001410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, 0.008460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, -0.006310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, -0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, 0.007630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.007880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, -0.005690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, 0.002430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, -0.003580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.003620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, -0.005050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.009880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, -0.002490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.007470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.002350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.005420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, 0.006270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, 0.000070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, -0.000190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, 0.003680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, -0.004030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, 0.002660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, -0.007530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, 0.002580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, 0.001440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, -0.000850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, -0.003360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, 0.006580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, -0.006620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.007240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, -0.005380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.008950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, -0.009330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, 0.003310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.008360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, 0.004590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.008510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.003520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.006200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.000720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.001380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.000240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, -0.004780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, -0.007430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, -0.001560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, 0.003330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, 0.002140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, 0.006460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.007760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.007050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.006220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, -0.009100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.008090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.003720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.007460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, 0.009920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, 0.009990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, 0.006140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, -0.001740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, 0.002500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, 0.009460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.000700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, -0.005710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.001160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.004240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.007070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.000520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, 0.004670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, -0.005670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, 0.000640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.006060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.001060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.005140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.000680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, -0.007380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, 0.007320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, -0.006920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.009640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, -0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, -0.003400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, -0.006000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.007140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, -0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.005490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.002680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.008890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, -0.007700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.001100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.006740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.001500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.000400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, 0.009380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, -0.002170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, -0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.006350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.000500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, -0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, 0.003820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, -0.008850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.002240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, -0.008610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.008230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, 0.003250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, -0.000660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.005360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, -0.005040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.008180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.007080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, 0.006510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, 0.001620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, 0.004070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, 0.002440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, 0.001630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, 0.002380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, 0.004000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, 0.009580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, 0.009260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.005580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, 0.000110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, -0.007650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 165 (Old: 165) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 166 (Old: 166) */
      0.0, 0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 167 (Old: 167) */
      0.0, 0.007600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 168 (Old: 168) */
      0.0, -0.000960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 169 (Old: 169) */
      0.0, 0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 170 (Old: 170) */
      0.0, 0.000860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 171 (Old: 171) */
      0.0, -0.001760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 172 (Old: 172) */
      0.0, -0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 173 (Old: 173) */
      0.0, 0.008600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 174 (Old: 174) */
      0.0, -0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 175 (Old: 175) */
      0.0, 0.001940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 176 (Old: 176) */
      0.0, -0.001710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 177 (Old: 177) */
      0.0, 0.006180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 178 (Old: 178) */
      0.0, -0.007850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 179 (Old: 179) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 180 (Old: 180) */
      0.0, 0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 181 (Old: 181) */
      0.0, 0.007690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 182 (Old: 182) */
      0.0, 0.006820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 183 (Old: 183) */
      0.0, -0.009850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 184 (Old: 184) */
      0.0, -0.003630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 185 (Old: 185) */
      0.0, -0.006240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 186 (Old: 186) */
      0.0, -0.002840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 187 (Old: 187) */
      0.0, 0.003410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 188 (Old: 188) */
      0.0, -0.004750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 189 (Old: 189) */
      0.0, -0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 190 (Old: 190) */
      0.0, -0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 191 (Old: 191) */
      0.0, -0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 192 (Old: 192) */
      0.0, 0.002820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 193 (Old: 193) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 194 (Old: 194) */
      0.0, 0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 195 (Old: 195) */
      0.0, -0.006300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 196 (Old: 196) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 197 (Old: 197) */
      0.0, 0.004510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 198 (Old: 198) */
      0.0, 0.009110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 199 (Old: 199) */
      0.0, -0.002020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 200 (Old: 200) */
      0.0, -0.000280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 201 (Old: 201) */
      0.0, -0.002600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 202 (Old: 202) */
      0.0, 0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 203 (Old: 203) */
      0.0, 0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 204 (Old: 204) */
      0.0, 0.000950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 205 (Old: 205) */
      0.0, -0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 206 (Old: 206) */
      0.0, -0.004860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 207 (Old: 207) */
      0.0, 0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 208 (Old: 208) */
      0.0, -0.002360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 209 (Old: 209) */
      0.0, -0.002370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 210 (Old: 210) */
      0.0, -0.007090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 211 (Old: 211) */
      0.0, 0.006370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 212 (Old: 212) */
      0.0, 0.003840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 213 (Old: 213) */
      0.0, 0.009530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 214 (Old: 214) */
      0.0, 0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 215 (Old: 215) */
      0.0, -0.009030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 216 (Old: 216) */
      0.0, -0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 217 (Old: 217) */
      0.0, 0.005900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 218 (Old: 218) */
      0.0, -0.002080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 219 (Old: 219) */
      0.0, -0.008710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 220 (Old: 220) */
      0.0, -0.001190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 221 (Old: 221) */
      0.0, -0.000940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 222 (Old: 222) */
      0.0, 0.001220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 223 (Old: 223) */
      0.0, 0.001000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 224 (Old: 224) */
      0.0, 0.003860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 225 (Old: 225) */
      0.0, 0.005980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 226 (Old: 226) */
      0.0, 0.005680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 227 (Old: 227) */
      0.0, 0.009000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 228 (Old: 228) */
      0.0, 0.005810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 229 (Old: 229) */
      0.0, -0.001490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 230 (Old: 230) */
      0.0, -0.008300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 231 (Old: 231) */
      0.0, 0.001690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 232 (Old: 232) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 233 (Old: 233) */
      0.0, 0.002890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 234 (Old: 234) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 235 (Old: 235) */
      0.0, 0.002160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 236 (Old: 236) */
      0.0, 0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 237 (Old: 237) */
      0.0, 0.004290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 238 (Old: 238) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 239 (Old: 239) */
      0.0, 0.001110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 240 (Old: 240) */
      0.0, -0.008520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 241 (Old: 241) */
      0.0, -0.008430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 242 (Old: 242) */
      0.0, -0.002120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 243 (Old: 243) */
      0.0, -0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 244 (Old: 244) */
      0.0, 0.009710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 245 (Old: 245) */
      0.0, -0.003730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 246 (Old: 246) */
      0.0, -0.006890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 247 (Old: 247) */
      0.0, 0.007410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 248 (Old: 248) */
      0.0, 0.008810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 249 (Old: 249) */
      0.0, 0.009740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 250 (Old: 250) */
      0.0, 0.002180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 251 (Old: 251) */
      0.0, -0.007310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 252 (Old: 252) */
      0.0, 0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 253 (Old: 253) */
      0.0, -0.008490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 254 (Old: 254) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 255 (Old: 255) */
      0.0, -0.003240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 256 (Old: 256) */
      0.0, -0.003100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 257 (Old: 257) */
      0.0, 0.008470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 258 (Old: 258) */
      0.0, 0.008140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 259 (Old: 259) */
      0.0, 0.009930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 260 (Old: 260) */
      0.0, -0.000530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 261 (Old: 261) */
      0.0, -0.005800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 262 (Old: 262) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 263 (Old: 263) */
      0.0, -0.000920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 264 (Old: 264) */
      0.0, -0.005970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 265 (Old: 265) */
      0.0, -0.004540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 266 (Old: 266) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 267 (Old: 267) */
      0.0, 0.004900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 268 (Old: 268) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 269 (Old: 269) */
      0.0, 0.000340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 270 (Old: 270) */
      0.0, 0.000650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 271 (Old: 271) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 272 (Old: 272) */
      0.0, -0.000080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 273 (Old: 273) */
      0.0, -0.007170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 274 (Old: 274) */
      0.0, 0.009800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 275 (Old: 275) */
      0.0, -0.006430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 276 (Old: 276) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 277 (Old: 277) */
      0.0, 0.009610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 278 (Old: 278) */
      0.0, -0.008590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 279 (Old: 279) */
      0.0, 0.008740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 280 (Old: 280) */
      0.0, 0.009240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 281 (Old: 281) */
      0.0, 0.006190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 282 (Old: 282) */
      0.0, 0.004470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 283 (Old: 283) */
      0.0, 0.001050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 284 (Old: 284) */
      0.0, -0.002990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 285 (Old: 285) */
      0.0, 0.006980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 286 (Old: 286) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 287 (Old: 287) */
      0.0, -0.002990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 288 (Old: 288) */
      0.0, -0.000690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 289 (Old: 289) */
      0.0, 0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 290 (Old: 290) */
      0.0, 0.002120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 291 (Old: 291) */
      0.0, -0.004440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 292 (Old: 292) */
      0.0, -0.004490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 293 (Old: 293) */
      0.0, 0.003880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 294 (Old: 294) */
      0.0, 0.007870, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 295 (Old: 295) */
      0.0, -0.008220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 296 (Old: 296) */
      0.0, -0.004820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 297 (Old: 297) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 298 (Old: 298) */
      0.0, -0.003030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 299 (Old: 299) */
      0.0, 0.002630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 300 (Old: 300) */
      0.0, 0.009480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 301 (Old: 301) */
      0.0, -0.006990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 302 (Old: 302) */
      0.0, 0.009160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 303 (Old: 303) */
      0.0, 0.008880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 304 (Old: 304) */
      0.0, 0.001480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 305 (Old: 305) */
      0.0, 0.000410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 306 (Old: 306) */
      0.0, -0.000030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 307 (Old: 307) */
      0.0, -0.009610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 308 (Old: 308) */
      0.0, -0.002150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 309 (Old: 309) */
      0.0, -0.008250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 310 (Old: 310) */
      0.0, -0.005010, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 311 (Old: 311) */
      0.0, -0.004280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 312 (Old: 312) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 313 (Old: 313) */
      0.0, -0.327010, 312,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 314 (Old: 314) */
      0.0, -0.464420, 312,
       &Sources[312] , 
       &Weights[312] , 
      },
    { /* unit 315 (Old: 315) */
      0.0, -0.419600, 312,
       &Sources[624] , 
       &Weights[624] , 
      },
    { /* unit 316 (Old: 316) */
      0.0, -0.305440, 312,
       &Sources[936] , 
       &Weights[936] , 
      },
    { /* unit 317 (Old: 317) */
      0.0, -0.435480, 312,
       &Sources[1248] , 
       &Weights[1248] , 
      },
    { /* unit 318 (Old: 318) */
      0.0, -0.445830, 312,
       &Sources[1560] , 
       &Weights[1560] , 
      },
    { /* unit 319 (Old: 319) */
      0.0, -0.278930, 312,
       &Sources[1872] , 
       &Weights[1872] , 
      },
    { /* unit 320 (Old: 320) */
      0.0, -0.328260, 312,
       &Sources[2184] , 
       &Weights[2184] , 
      },
    { /* unit 321 (Old: 321) */
      0.0, -0.484800, 312,
       &Sources[2496] , 
       &Weights[2496] , 
      },
    { /* unit 322 (Old: 322) */
      0.0, -0.143750, 312,
       &Sources[2808] , 
       &Weights[2808] , 
      },
    { /* unit 323 (Old: 323) */
      0.0, -0.390920, 312,
       &Sources[3120] , 
       &Weights[3120] , 
      },
    { /* unit 324 (Old: 324) */
      0.0, -0.491800, 312,
       &Sources[3432] , 
       &Weights[3432] , 
      },
    { /* unit 325 (Old: 325) */
      0.0, -0.252880, 312,
       &Sources[3744] , 
       &Weights[3744] , 
      },
    { /* unit 326 (Old: 326) */
      0.0, -0.562780, 312,
       &Sources[4056] , 
       &Weights[4056] , 
      },
    { /* unit 327 (Old: 327) */
      0.0, -0.574570, 312,
       &Sources[4368] , 
       &Weights[4368] , 
      },
    { /* unit 328 (Old: 328) */
      0.0, -0.348820, 312,
       &Sources[4680] , 
       &Weights[4680] , 
      },
    { /* unit 329 (Old: 329) */
      0.0, -0.253850, 312,
       &Sources[4992] , 
       &Weights[4992] , 
      },
    { /* unit 330 (Old: 330) */
      0.0, -0.379730, 312,
       &Sources[5304] , 
       &Weights[5304] , 
      },
    { /* unit 331 (Old: 331) */
      0.0, -0.163450, 312,
       &Sources[5616] , 
       &Weights[5616] , 
      },
    { /* unit 332 (Old: 332) */
      0.0, -0.521740, 312,
       &Sources[5928] , 
       &Weights[5928] , 
      },
    { /* unit 333 (Old: 333) */
      0.0, -0.589400, 312,
       &Sources[6240] , 
       &Weights[6240] , 
      },
    { /* unit 334 (Old: 334) */
      0.0, -0.175750, 312,
       &Sources[6552] , 
       &Weights[6552] , 
      },
    { /* unit 335 (Old: 335) */
      0.0, -0.185920, 312,
       &Sources[6864] , 
       &Weights[6864] , 
      },
    { /* unit 336 (Old: 336) */
      0.0, -0.247630, 312,
       &Sources[7176] , 
       &Weights[7176] , 
      },
    { /* unit 337 (Old: 337) */
      0.0, -0.319200, 312,
       &Sources[7488] , 
       &Weights[7488] , 
      },
    { /* unit 338 (Old: 338) */
      0.0, -0.234440, 312,
       &Sources[7800] , 
       &Weights[7800] , 
      },
    { /* unit 339 (Old: 339) */
      0.0, -0.334370, 312,
       &Sources[8112] , 
       &Weights[8112] , 
      },
    { /* unit 340 (Old: 340) */
      0.0, -0.773050, 312,
       &Sources[8424] , 
       &Weights[8424] , 
      },
    { /* unit 341 (Old: 341) */
      0.0, -0.242330, 312,
       &Sources[8736] , 
       &Weights[8736] , 
      },
    { /* unit 342 (Old: 342) */
      0.0, -0.390100, 312,
       &Sources[9048] , 
       &Weights[9048] , 
      },
    { /* unit 343 (Old: 343) */
      0.0, -0.400370, 312,
       &Sources[9360] , 
       &Weights[9360] , 
      },
    { /* unit 344 (Old: 344) */
      0.0, -0.451110, 312,
       &Sources[9672] , 
       &Weights[9672] , 
      },
    { /* unit 345 (Old: 345) */
      0.0, -0.496990, 312,
       &Sources[9984] , 
       &Weights[9984] , 
      },
    { /* unit 346 (Old: 346) */
      0.0, -0.364860, 312,
       &Sources[10296] , 
       &Weights[10296] , 
      },
    { /* unit 347 (Old: 347) */
      0.0, -0.142410, 312,
       &Sources[10608] , 
       &Weights[10608] , 
      },
    { /* unit 348 (Old: 348) */
      0.0, -0.579990, 312,
       &Sources[10920] , 
       &Weights[10920] , 
      },
    { /* unit 349 (Old: 349) */
      0.0, -0.628250, 312,
       &Sources[11232] , 
       &Weights[11232] , 
      },
    { /* unit 350 (Old: 350) */
      0.0, -0.447280, 312,
       &Sources[11544] , 
       &Weights[11544] , 
      },
    { /* unit 351 (Old: 351) */
      0.0, -0.409610, 312,
       &Sources[11856] , 
       &Weights[11856] , 
      },
    { /* unit 352 (Old: 352) */
      0.0, -0.382170, 312,
       &Sources[12168] , 
       &Weights[12168] , 
      },
    { /* unit 353 (Old: 353) */
      0.0, -0.690900, 40,
       &Sources[12480] , 
       &Weights[12480] , 
      },
    { /* unit 354 (Old: 354) */
      0.0, -0.264690, 40,
       &Sources[12520] , 
       &Weights[12520] , 
      },
    { /* unit 355 (Old: 355) */
      0.0, -0.153500, 40,
       &Sources[12560] , 
       &Weights[12560] , 
      }

  };



int step3_net(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[312] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, Units + 311, Units + 312}; /* members */

  static pUnit Hidden1[40] = {Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, Units + 351, Units + 352}; /* members */

  static pUnit Output1[3] = {Units + 353, Units + 354, Units + 355}; /* members */

  static int Output[3] = {353, 354, 355};

  for(member = 0; member < 312; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 40; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
