/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  step3_net111.c
  --------------------------------------------------------
  generated at Mon Jun 28 13:25:33 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[356];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, 
Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, 
Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, 
Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, 
Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, 
Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, 
Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, 
Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, 
Units + 311, Units + 312, 
Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, Units + 321, Units + 322, 
Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, Units + 331, Units + 332, 
Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, Units + 341, Units + 342, 
Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, Units + 351, Units + 352, 

Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, Units + 321, Units + 322, 
Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, Units + 331, Units + 332, 
Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, Units + 341, Units + 342, 
Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, Units + 351, Units + 352, 

Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, Units + 321, Units + 322, 
Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, Units + 331, Units + 332, 
Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, Units + 341, Units + 342, 
Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, Units + 351, Units + 352, 


  };

  /* Weigths definition section */
  static float Weights[] =  {
-0.173480, 0.199620, -0.091230, -0.125970, 0.055900, -0.048420, -0.055550, -0.113310, -0.029500, -0.141050, 
0.032250, -0.179320, -0.027850, 0.046320, -0.147440, -0.090440, 0.001920, -0.119020, -0.134750, 0.028160, 
-0.044450, -0.147020, 0.121730, -0.043060, -0.052330, 0.054190, -0.063840, -0.025430, -0.020500, -0.063520, 
0.097060, -0.106660, -0.074490, -0.085580, 0.052410, -0.109710, -0.032990, 0.106390, -0.064760, 0.036190, 
-0.040430, -0.108720, -0.155080, -0.069230, 0.097980, -0.056740, 0.045100, -0.074050, 0.018850, 0.044870, 
-0.142480, -0.045020, 0.007210, -0.082890, 0.064700, -0.102340, -0.064930, -0.023960, 0.018470, -0.094220, 
-0.071820, 0.144010, -0.088380, 0.025540, -0.088200, -0.083210, -0.179950, -0.030250, 0.117590, 0.000590, 
-0.038870, -0.097730, 0.079110, 0.001260, -0.210250, 0.001650, -0.025280, -0.116980, -0.003550, -0.091440, 
-0.065560, -0.097290, 0.059340, -0.134250, -0.057280, 0.195130, -0.146770, 0.019840, -0.168450, -0.084690, 
-0.111440, 0.013360, -0.177260, -0.070330, 0.005210, -0.089590, 0.130050, -0.077330, -0.126120, 0.046550, 
-0.061900, -0.053880, 0.007180, -0.172500, 0.045710, -0.132520, 0.017450, -0.075180, -0.020060, 0.119180, 
-0.076090, 0.074710, -0.251700, 0.016830, -0.191440, 0.097240, -0.145330, -0.032050, 0.106890, -0.129600, 
0.143050, 0.050240, -0.093440, 0.017710, 0.156750, -0.046680, 0.035830, -0.079310, 0.071540, -0.071710, 
0.099320, -0.083140, 0.071130, 0.170580, -0.054960, 0.090660, -0.186840, 0.043300, -0.191080, 0.240400, 
-0.141810, 0.020350, 0.344160, -0.309770, 0.022410, 0.160660, -0.335220, -0.058310, 0.356320, -0.396510, 
0.127500, -0.046540, -0.276650, -0.048670, 0.219640, -0.416010, 0.048030, 0.304250, -0.380650, 0.026540, 
-0.009870, -0.245780, -0.010250, 0.479850, -0.659640, 0.029400, 0.557090, -0.824250, 0.000710, 0.094970, 
-0.106750, -0.081570, 0.236910, -0.131970, 0.094260, 0.035540, -0.113800, -0.010920, 0.030130, -0.162170, 
0.026290, 0.120430, -0.087260, 0.040990, -0.182490, 0.032950, -0.075740, 0.276780, -0.330920, 0.052400, 
0.255380, -0.483960, -0.006640, 0.025300, -0.015220, -0.075840, 0.141930, -0.052210, 0.053840, 0.155960, 
-0.058210, -0.164560, 0.145630, -0.055580, 0.034590, 0.068310, -0.002450, -0.002690, -0.117210, 0.106940, 
-0.060050, 0.091720, -0.099270, -0.051430, 0.035860, -0.167930, -0.003750, -0.040830, -0.002650, -0.054390, 
0.032600, -0.051660, 0.010920, 0.150800, -0.066750, -0.146670, 0.200200, -0.101900, -0.040400, 0.143280, 
-0.071730, -0.059600, 0.015330, 0.033030, -0.132320, 0.088840, -0.159650, -0.056900, 0.066520, -0.139300, 
-0.035170, -0.056520, 0.003050, -0.046010, -0.039630, 0.011010, -0.016700, 0.072490, -0.090690, -0.180160, 
0.272490, -0.108150, -0.043690, 0.137430, -0.127920, -0.047830, 0.018730, -0.013590, -0.072890, 0.103480, 
-0.118400, -0.067180, 0.069360, -0.060480, -0.082750, -0.033890, 0.065940, -0.110650, -0.024900, 0.039140, 
-0.045810, -0.003490, -0.103940, -0.131890, 0.222850, -0.119300, -0.055050, 0.011670, -0.005360, -0.074450, 
-0.014100, -0.032920, -0.183090, 0.071180, 0.029890, -0.102610, 0.098910, -0.068510, -0.132720, 0.061640, 
-0.002870, -0.137150, 0.097970, -0.039540, -0.088600, 0.070210, -0.109540, -0.155740, 0.195030, -0.121210, 
-0.126210, 0.112180, -0.076780, -0.130440, 0.056400, -0.033520, -0.160890, 0.104050, -0.046180, -0.185260, 
0.180550, -0.106540, 
0.251820, -0.246020, -0.026330, 0.240350, -0.196020, -0.008110, -0.025610, 0.049060, -0.073020, -0.036330, 
0.014730, -0.084790, -0.001740, 0.007150, 0.035070, 0.000920, -0.072040, 0.040320, 0.369490, -0.015050, 
-0.218800, 0.493590, -0.259490, -0.107040, 0.153500, -0.136100, -0.087660, 0.059060, -0.089040, -0.049850, 
-0.146290, 0.088470, -0.038660, 0.038330, 0.053170, -0.097620, 0.067370, -0.017980, 0.016120, -0.034350, 
-0.084370, 0.084270, 0.372270, -0.006760, -0.163450, 0.264830, -0.084970, -0.078310, 0.048560, -0.020550, 
-0.088740, -0.096530, 0.046340, 0.031820, -0.013960, 0.108190, -0.077480, 0.108270, -0.057020, -0.062900, 
0.207800, 0.021860, -0.063610, 0.029490, -0.139450, 0.086290, 0.468510, 0.091680, -0.311770, 0.253970, 
0.006430, -0.088210, 0.009150, 0.038870, -0.122440, -0.093570, 0.044160, 0.005630, 0.020650, 0.014720, 
0.017990, 0.186320, -0.029930, -0.071300, 0.057430, 0.005620, -0.011510, -0.012420, -0.036650, 0.075990, 
0.272810, 0.174700, -0.191460, 0.241610, -0.054960, -0.174240, -0.077580, 0.020930, -0.225150, -0.190940, 
0.059780, -0.072620, -0.035560, 0.100790, -0.147640, 0.115220, 0.016980, -0.244700, 0.022290, 0.001710, 
-0.105670, -0.120020, 0.133190, -0.138570, -0.008380, -0.001670, 0.108680, 0.144100, -0.276470, -0.066270, 
-0.236190, -0.079380, -0.376430, -0.289250, -0.109290, -0.313890, -0.173140, 0.065390, -0.416770, -0.218920, 
-0.209230, -0.128600, -0.410880, 0.056750, -0.159350, -0.263260, 0.133580, -0.353700, -0.098530, -0.287470, 
-0.002480, -0.201790, -0.466740, 0.250670, -0.447540, -0.088800, 0.134340, -0.433470, -0.329370, 0.387250, 
-0.354550, 0.046930, 0.084510, -0.368920, -0.201430, 0.288830, -0.544270, -0.070870, 0.348180, -0.369370, 
-0.097710, 0.298770, -0.598960, -0.453190, 0.818170, -0.589940, -0.490770, 0.969790, -0.065620, -0.048080, 
-0.519980, -0.146620, -0.190720, -0.264540, -0.091520, -0.114520, -0.401310, 0.003460, -0.182020, -0.378970, 
-0.119010, -0.093950, -0.377150, -0.169070, -0.011230, -0.366900, -0.323180, -0.269470, 0.133380, -0.222490, 
-0.211760, 0.202840, 0.005220, -0.105050, -0.235430, -0.114110, -0.173280, -0.049530, -0.043180, -0.115580, 
-0.166880, 0.109300, 0.007020, -0.222880, 0.027110, 0.030870, -0.186190, -0.023560, 0.064750, -0.191740, 
-0.124530, 0.148030, -0.151100, -0.193850, 0.306970, -0.077200, 0.070990, -0.038820, -0.217370, -0.050910, 
-0.090300, -0.064470, -0.015280, 0.001220, -0.140870, 0.209740, -0.220220, -0.120630, 0.020810, 0.062950, 
-0.075760, 0.069020, -0.052500, -0.105130, -0.110510, 0.391750, -0.150700, -0.151410, 0.250510, -0.064230, 
0.069450, -0.168560, -0.060830, -0.082420, -0.081640, 0.016260, 0.048260, 0.052680, -0.062220, 0.187950, 
-0.030520, -0.120180, -0.015390, 0.047330, 0.067700, 0.129100, -0.101640, 0.040320, -0.168600, 0.405320, 
-0.086650, -0.119330, 0.319590, -0.067610, 0.011140, -0.042020, -0.041430, 0.035070, -0.050280, -0.069930, 
0.014070, 0.120750, 0.042850, 0.151910, -0.058870, 0.015220, -0.018180, 0.166510, 0.019570, -0.050140, 
0.015850, 0.101530, -0.085040, 0.222260, 0.041910, -0.190190, 0.286200, 0.026370, 0.015550, -0.033850, 
-0.016100, 0.075620, -0.100160, -0.051850, -0.200890, 0.239750, 0.153340, -0.100860, 0.103670, 0.054590, 
-0.068970, 0.150390, 0.053680, -0.079160, 0.106780, 0.082110, 0.092440, 0.187960, 0.034550, -0.104470, 
0.324940, -0.017090, 
0.020290, 0.045490, -0.038250, 0.046340, -0.043350, 0.004060, -0.014710, -0.067130, 0.067810, 0.048630, 
0.041640, -0.004570, -0.034300, 0.025630, 0.042070, 0.028580, -0.005280, 0.046810, 0.197910, -0.053250, 
-0.016870, 0.023920, -0.067430, 0.127230, 0.005470, -0.025470, 0.033000, 0.012820, -0.042270, 0.006850, 
0.091260, -0.052850, -0.004340, 0.040280, -0.033160, 0.007640, -0.074520, 0.041080, 0.089140, 0.133860, 
-0.103130, 0.034590, 0.073630, -0.164830, 0.116770, 0.022750, -0.095830, 0.044420, 0.010560, -0.008700, 
-0.073310, -0.026820, -0.003690, -0.034960, 0.021460, -0.055590, 0.005700, 0.003280, 0.014810, -0.037900, 
-0.137210, 0.027880, 0.055300, 0.042390, -0.102930, -0.011580, -0.061880, -0.121390, 0.084240, -0.058510, 
-0.069620, -0.049440, 0.023130, -0.052500, -0.044350, 0.002740, -0.091600, -0.017550, -0.036770, -0.096670, 
0.031040, -0.097460, 0.072700, -0.104770, -0.046500, -0.042080, -0.000130, 0.035120, -0.135970, -0.012160, 
-0.026080, -0.069170, -0.134810, -0.105560, 0.032240, -0.079480, 0.042150, -0.068290, -0.039420, 0.005200, 
-0.092010, -0.016560, 0.018360, -0.124570, -0.024110, -0.198370, 0.078600, -0.120680, 0.010640, -0.015970, 
-0.075810, 0.038360, -0.155380, -0.028610, -0.048710, 0.083170, -0.198960, -0.074530, 0.135340, -0.057000, 
0.041650, 0.016360, -0.094080, 0.021730, -0.000530, -0.052270, -0.034060, -0.026160, -0.030760, -0.105760, 
0.191970, -0.167800, -0.011380, 0.138180, -0.112660, 0.011920, -0.095630, -0.015930, 0.105040, 0.284460, 
-0.376910, 0.061430, 0.265970, -0.323740, 0.131330, 0.049130, -0.391160, 0.058920, 0.077980, -0.351950, 
0.084520, -0.028530, -0.348800, 0.007400, 0.159680, -0.401300, 0.068130, 0.172850, -0.411610, -0.018180, 
-0.013400, -0.285870, 0.251860, 0.405140, -0.779340, 0.270440, 0.351290, -0.760810, 0.034260, -0.026530, 
-0.102390, -0.034680, 0.004930, -0.087390, 0.006590, 0.050250, -0.125870, -0.093770, 0.042290, -0.078590, 
-0.003140, 0.048730, -0.116760, -0.042350, -0.120750, -0.015790, 0.047390, 0.251120, -0.358180, 0.176940, 
0.126190, -0.397680, 0.024050, -0.124880, 0.028890, -0.007550, -0.063700, 0.029870, 0.009440, 0.112570, 
-0.077860, -0.130500, 0.032380, 0.026570, 0.035600, 0.017650, -0.046740, 0.018630, -0.126200, 0.034630, 
-0.080510, 0.104490, 0.063330, 0.041300, -0.075420, 0.002230, 0.031720, -0.167900, 0.067620, 0.026570, 
-0.068940, 0.005930, 0.029180, 0.077190, -0.070110, -0.020970, 0.068390, 0.006080, 0.056490, 0.023970, 
-0.053220, 0.002320, -0.033240, 0.007920, -0.071200, 0.007300, 0.041760, 0.060130, -0.085590, 0.066940, 
0.019750, -0.107530, 0.042160, 0.095410, -0.073210, -0.017360, 0.071180, -0.015200, -0.058990, -0.068130, 
0.136430, -0.005830, 0.004730, 0.021070, -0.036020, 0.034240, 0.043830, -0.015730, 0.088750, -0.058320, 
0.033510, 0.054680, -0.044850, 0.014650, 0.009240, -0.065370, 0.036970, 0.018610, -0.001390, 0.004160, 
0.034960, -0.016430, -0.042100, -0.057710, 0.063010, 0.027930, -0.045070, -0.043080, 0.099550, -0.048710, 
0.062650, -0.046120, 0.015040, -0.010820, 0.067350, 0.051000, 0.021010, -0.015730, -0.003030, -0.003490, 
0.004360, -0.037230, 0.083670, -0.051040, 0.022690, 0.017150, -0.016030, 0.042750, -0.018890, -0.029330, 
-0.107170, 0.080800, 0.064610, -0.105500, 0.093500, -0.003840, 0.012480, 0.021400, 0.042740, -0.033550, 
0.034420, -0.001540, 
-0.000640, -0.024130, -0.198780, -0.144210, 0.012010, -0.130220, 0.055300, -0.026710, -0.209930, 0.110280, 
-0.028020, -0.077510, 0.060520, -0.111990, -0.131660, 0.053310, -0.011720, -0.121780, 0.337840, -0.087760, 
-0.256530, 0.100570, -0.273530, -0.029170, -0.015080, -0.022700, -0.149710, -0.127300, -0.024440, -0.100090, 
0.013020, -0.053340, -0.157110, -0.016550, -0.046700, -0.052800, 0.131540, -0.181170, -0.149600, 0.060100, 
0.003750, -0.142440, 0.378090, -0.195110, -0.202500, 0.181050, -0.376720, 0.008240, -0.042900, -0.017860, 
-0.144020, -0.042370, -0.053530, -0.150890, 0.010460, -0.049810, -0.178950, -0.104290, 0.062770, -0.091290, 
0.099370, -0.160700, -0.126140, 0.002020, 0.080500, -0.167840, 0.380280, -0.309760, -0.198460, 0.173900, 
-0.340580, -0.045780, -0.086730, 0.020430, -0.183360, 0.031030, -0.088750, -0.210750, -0.047650, 0.012080, 
-0.189080, -0.068770, 0.069310, -0.155040, 0.000590, -0.099890, -0.169040, -0.052470, 0.107620, -0.185720, 
0.272540, -0.203340, -0.184670, 0.184330, -0.306510, -0.079580, -0.125860, 0.076720, -0.221040, 0.021390, 
-0.110670, -0.226350, -0.107640, 0.133500, -0.223830, -0.082680, 0.101930, -0.152020, -0.072200, -0.000460, 
-0.186270, -0.172310, 0.172310, -0.153880, 0.338200, -0.107530, -0.310100, 0.132810, -0.239420, -0.034520, 
-0.041300, 0.012630, -0.256430, 0.141940, -0.198480, -0.241270, -0.173050, 0.201640, -0.170030, 0.008580, 
0.087540, -0.110760, -0.019390, 0.048720, -0.252650, -0.126470, 0.146870, -0.156740, 0.334340, -0.051790, 
-0.310040, 0.189520, -0.227810, -0.090380, 0.133400, -0.052160, -0.316490, 0.197500, -0.180660, -0.278870, 
-0.150710, 0.216680, -0.160190, -0.010500, 0.147000, -0.150950, 0.006210, 0.067460, -0.252800, -0.081910, 
0.123350, -0.207000, 0.263230, -0.028450, -0.234630, 0.285140, -0.185760, -0.149040, -0.001400, -0.094320, 
-0.083050, 0.001830, -0.173730, -0.067590, -0.195760, 0.097710, 0.014210, -0.105050, 0.027260, 0.021520, 
-0.143020, 0.012700, -0.049650, -0.069360, 0.055590, -0.048020, 0.124560, -0.131960, 0.045400, 0.111670, 
-0.184440, 0.150670, -0.017920, -0.148650, -0.062200, 0.030040, -0.171800, -0.077490, -0.215800, -0.011760, 
0.056140, -0.141560, -0.098660, 0.078160, -0.207510, -0.061180, 0.027870, -0.106320, 0.002210, -0.020370, 
-0.019600, -0.196470, 0.215220, 0.030990, -0.235650, 0.254090, 0.057950, -0.150410, -0.041350, 0.080180, 
-0.127850, -0.084270, -0.141650, -0.016520, 0.039920, -0.143070, -0.100620, 0.130470, -0.206350, -0.048000, 
0.066680, -0.147580, 0.060860, -0.022930, -0.084290, -0.140510, 0.225560, -0.037840, -0.102560, 0.123990, 
0.062520, -0.047020, -0.084760, 0.086790, 0.015170, -0.150180, -0.138550, 0.019800, 0.073530, -0.099870, 
-0.140970, 0.127810, -0.175270, -0.009730, 0.031780, -0.158870, 0.114090, -0.022910, -0.095040, -0.017530, 
0.152190, -0.144970, -0.026520, 0.068560, 0.058050, -0.009180, -0.062770, 0.059410, 0.046990, -0.083140, 
-0.084780, 0.012660, 0.042460, -0.096240, -0.129550, 0.134910, -0.128890, -0.014160, 0.044140, -0.104180, 
0.071370, 0.010660, -0.110330, 0.084300, 0.071930, -0.154530, 0.042020, 0.054420, 0.064190, -0.043970, 
0.023740, 0.041600, -0.032380, 0.046760, 0.020860, -0.043410, 0.015380, 0.026630, -0.167520, 0.127330, 
-0.070210, -0.047400, 0.100160, -0.010680, 0.010260, 0.054270, -0.008100, 0.070300, -0.019390, -0.056170, 
-0.004080, 0.128190, 
0.039690, 0.051420, -0.024920, 0.042030, -0.026920, -0.005970, -0.017230, -0.036860, 0.065670, 0.079760, 
0.026850, 0.027560, -0.033990, 0.043230, 0.045940, 0.060330, 0.019020, 0.067840, 0.205460, 0.002790, 
-0.049880, 0.012180, -0.039910, 0.108750, 0.036220, -0.010140, 0.015310, 0.000560, -0.014420, 0.006480, 
0.081960, -0.037190, 0.009410, 0.032080, -0.008480, 0.025060, -0.059560, 0.034620, 0.095580, 0.131590, 
-0.082580, 0.031600, 0.117030, -0.087390, 0.063900, 0.009080, -0.027270, 0.021660, 0.061340, 0.018160, 
-0.111890, -0.000910, 0.021200, -0.063210, 0.019410, -0.029530, -0.012480, 0.027700, 0.044640, -0.058970, 
-0.103710, 0.021910, 0.049970, 0.066670, -0.069080, 0.001120, 0.014090, -0.071280, 0.001120, -0.027710, 
-0.065450, -0.081600, 0.010260, 0.013190, -0.082320, 0.030490, -0.047850, -0.043940, -0.030620, -0.071080, 
0.020980, -0.088260, 0.101620, -0.101350, -0.013050, -0.039270, -0.009660, 0.026780, -0.069610, -0.023770, 
0.038670, -0.053010, -0.163390, -0.052380, 0.072210, -0.127770, 0.011410, -0.011840, -0.060250, 0.018940, 
-0.056480, -0.077020, 0.009360, -0.083880, -0.022920, -0.190470, 0.101400, -0.124770, 0.025430, -0.010910, 
-0.071570, 0.015850, -0.098440, -0.062380, 0.029620, 0.062350, -0.221840, -0.047540, 0.123420, -0.060450, 
0.020440, 0.057390, -0.109930, 0.034490, 0.022230, -0.074390, -0.068060, -0.009340, -0.005950, -0.128710, 
0.217930, -0.155680, -0.034070, 0.108310, -0.098660, -0.024610, -0.062520, -0.000570, 0.197120, 0.257210, 
-0.397180, 0.128050, 0.213820, -0.300280, 0.130680, 0.075560, -0.396970, 0.093680, 0.080640, -0.360170, 
0.059850, -0.018380, -0.306560, 0.011450, 0.188780, -0.381910, 0.109640, 0.131980, -0.398580, -0.021390, 
0.001960, -0.272240, 0.300050, 0.376260, -0.747350, 0.347630, 0.252530, -0.713290, 0.029980, -0.014290, 
-0.075090, -0.033530, -0.005150, -0.070000, 0.011600, 0.033750, -0.092920, -0.032110, 0.039740, -0.082460, 
0.024120, 0.009300, -0.117610, 0.000420, -0.132260, 0.004080, 0.102230, 0.237970, -0.352800, 0.275410, 
0.059750, -0.374450, -0.000670, -0.145660, 0.083340, -0.000420, -0.085020, 0.055670, -0.038530, 0.071970, 
-0.008760, -0.115030, -0.009530, 0.063390, 0.018020, -0.005730, -0.007950, 0.018730, -0.134770, 0.068330, 
-0.044310, 0.089540, 0.087340, 0.076880, -0.113380, 0.080890, 0.011230, -0.176920, 0.121480, 0.019410, 
-0.080140, 0.031670, -0.017730, 0.052280, 0.002140, -0.043710, 0.052780, 0.056500, 0.013100, 0.006910, 
0.040410, -0.003060, -0.041090, 0.044190, -0.061210, 0.009900, 0.119670, 0.049480, -0.101130, 0.172720, 
0.013030, -0.091300, 0.089330, 0.068470, -0.031310, -0.009680, -0.009950, 0.018550, 0.034390, -0.122830, 
0.133730, 0.049320, -0.080860, 0.036060, 0.050540, -0.028490, 0.071980, 0.019480, 0.060820, -0.042610, 
0.081330, 0.038450, -0.064070, 0.090900, -0.001870, -0.060770, 0.066740, -0.001100, 0.020630, -0.001320, 
-0.037010, 0.021350, 0.024480, -0.142820, 0.076080, 0.072630, -0.134300, -0.013670, 0.163730, -0.115030, 
0.115020, -0.013990, -0.016700, 0.042360, 0.091100, -0.014680, 0.067330, 0.022940, -0.013800, 0.012410, 
0.032290, -0.053850, 0.127850, -0.037520, -0.031540, 0.062910, 0.037740, -0.027900, 0.049640, -0.009250, 
-0.170940, 0.122660, 0.120880, -0.152840, 0.166610, 0.021600, -0.033380, 0.075540, 0.081500, -0.081510, 
0.068550, 0.021640, 
-0.074050, 0.036130, -0.182720, -0.115270, 0.023510, -0.177420, 0.032940, 0.015430, -0.231900, 0.058870, 
-0.061050, 0.026730, 0.033680, 0.035590, -0.131320, 0.074770, -0.002680, -0.203960, -0.050790, 0.075570, 
-0.176650, -0.095120, -0.092560, 0.100350, -0.104770, -0.041800, -0.117210, -0.207570, 0.008800, -0.088920, 
-0.118810, 0.041690, -0.093640, -0.074130, 0.048230, 0.002430, -0.065780, 0.055420, -0.023430, -0.046130, 
0.069580, -0.163910, -0.022140, -0.109760, -0.015160, -0.084350, -0.101240, 0.061350, -0.161580, -0.007170, 
-0.091770, -0.161950, 0.090010, -0.157560, -0.251150, 0.030110, 0.047400, -0.169300, 0.090600, -0.060610, 
-0.189540, 0.009850, 0.056920, -0.209350, 0.207040, -0.121930, -0.083260, -0.146020, 0.029130, -0.190890, 
0.033990, -0.010790, -0.160120, 0.019650, -0.068750, -0.167450, 0.164090, -0.170590, -0.150220, -0.055720, 
0.021340, -0.149020, 0.076290, -0.087070, -0.114700, -0.086110, 0.054740, -0.172080, 0.240430, -0.181690, 
0.109390, -0.271730, -0.060850, -0.201180, -0.001150, 0.066570, -0.227270, 0.060130, 0.054820, -0.286300, 
0.112750, -0.012790, -0.171690, -0.071460, 0.038290, -0.108360, 0.035420, -0.032570, -0.029000, -0.260470, 
0.093450, -0.094210, 0.066420, -0.075010, 0.230160, -0.279570, 0.024960, -0.285920, -0.112780, 0.278480, 
-0.270470, 0.051050, 0.120610, -0.336810, 0.023840, 0.138150, -0.270390, -0.094280, 0.168220, -0.102320, 
0.024180, 0.129460, -0.068770, -0.187100, 0.044530, -0.128660, -0.016490, 0.082750, 0.214990, -0.293410, 
0.037240, -0.155420, -0.279270, 0.286970, 0.151950, 0.003180, -0.255240, -0.012920, -0.035570, -0.132070, 
0.123220, -0.122520, -0.222990, 0.339200, -0.057570, -0.266440, 0.479110, -0.182170, -0.443010, 0.133920, 
-0.068100, -0.208070, 0.983000, -0.214720, -0.691520, 0.433810, -0.371980, -0.105300, -0.258640, 0.040970, 
0.066170, -0.192010, -0.041020, 0.001460, -0.228960, -0.053960, -0.033960, -0.196340, 0.104670, -0.074920, 
0.050750, -0.124760, -0.179440, -0.126120, 0.005840, -0.122350, 0.378010, -0.187040, -0.308380, 0.009990, 
-0.188660, -0.001870, -0.324470, 0.120760, 0.037300, -0.092050, 0.006590, -0.071150, -0.211350, 0.088440, 
-0.277610, -0.147580, 0.098210, -0.198610, -0.021960, -0.043220, -0.336010, -0.083240, 0.195990, -0.395870, 
0.364230, -0.143410, -0.393970, 0.144750, -0.065860, -0.130680, -0.289950, 0.176870, 0.003400, -0.121080, 
0.077250, -0.072670, -0.026230, 0.164470, -0.416440, 0.061530, 0.106760, -0.307310, 0.220340, -0.023270, 
-0.451200, 0.032730, 0.261460, -0.430490, 0.437020, -0.065400, -0.367510, 0.302380, -0.117450, -0.178250, 
-0.263720, 0.114690, 0.095310, -0.182030, 0.097730, -0.006420, 0.071880, 0.057550, -0.318560, 0.146240, 
0.038090, -0.195940, 0.184760, -0.081610, -0.239910, -0.021720, 0.214360, -0.305590, 0.382770, -0.112220, 
-0.174610, 0.293560, -0.137430, -0.094980, -0.154820, 0.003980, 0.048470, -0.087680, 0.030590, -0.008830, 
0.055010, 0.006760, -0.258530, 0.041290, -0.007670, -0.103980, 0.133760, -0.113200, -0.187810, 0.121680, 
0.098940, -0.277940, 0.316810, -0.210030, -0.021910, 0.375450, -0.251350, 0.003830, 0.044400, -0.056940, 
-0.071670, 0.047090, -0.033450, -0.087770, 0.021430, 0.031250, -0.171690, 0.239460, -0.113610, -0.090170, 
0.130670, -0.082600, -0.056070, 0.075290, 0.121690, -0.186810, 0.437990, -0.275310, -0.060830, 0.457770, 
-0.394640, 0.098060, 
-0.119580, -0.052580, -0.011060, -0.160870, 0.028210, -0.007410, -0.075240, 0.025650, -0.037880, -0.106280, 
-0.062210, 0.037760, -0.156420, 0.034290, 0.040420, -0.098940, -0.046850, 0.037840, -0.164290, 0.110630, 
0.004360, -0.122500, 0.040620, 0.006660, -0.161420, -0.042890, 0.052330, -0.175910, -0.032220, 0.063640, 
-0.137930, -0.036780, 0.041570, -0.122440, -0.014140, 0.087760, -0.090590, -0.042060, 0.048880, -0.139860, 
-0.031010, 0.080380, -0.138740, 0.110940, 0.065670, -0.162770, 0.089950, 0.075400, -0.154270, -0.021000, 
0.073190, -0.176600, 0.024300, 0.045520, -0.110070, -0.004500, 0.047960, -0.103400, -0.001410, 0.036710, 
-0.104710, -0.026040, 0.085280, -0.122580, -0.011470, 0.091460, -0.124740, 0.096900, 0.070070, -0.161370, 
0.059360, 0.106950, -0.146160, -0.007040, -0.002240, -0.138910, 0.024750, -0.030030, -0.072330, -0.015900, 
0.039150, -0.039530, 0.007710, -0.025230, -0.156800, 0.024870, 0.045980, -0.100620, 0.005570, 0.015590, 
-0.166130, 0.098650, 0.111660, -0.104790, 0.032230, 0.048920, -0.137360, -0.032300, -0.018280, -0.138000, 
-0.013030, -0.033030, -0.049230, -0.022140, -0.031230, 0.026240, -0.038740, -0.117380, -0.124590, -0.039040, 
0.015040, -0.073470, 0.034740, -0.063540, -0.022560, -0.017710, 0.074200, -0.049910, -0.089530, 0.049960, 
-0.126730, -0.148720, -0.041370, -0.142700, -0.154390, -0.042410, -0.060480, -0.061270, -0.076770, 0.001630, 
-0.162090, -0.017880, -0.120700, -0.104330, -0.013410, -0.061890, -0.071630, -0.083110, 0.071730, -0.287120, 
0.093170, 0.005460, -0.348970, 0.202720, -0.072770, -0.187320, 0.053360, -0.081410, -0.252810, 0.141920, 
-0.081020, -0.045320, 0.009670, 0.053090, -0.222910, 0.105750, -0.042940, -0.141010, 0.028710, 0.001810, 
-0.219580, 0.068270, 0.106680, -0.358250, 0.158560, 0.105910, -0.457350, 0.314200, -0.065970, -0.123410, 
-0.122260, -0.058910, -0.183870, -0.050260, -0.121790, -0.081590, -0.042720, -0.013840, -0.126450, -0.059010, 
-0.085420, -0.105520, -0.108180, -0.012600, -0.145280, -0.109550, 0.056150, -0.288330, 0.032960, 0.091830, 
-0.345200, 0.147760, -0.100830, -0.065440, -0.039160, -0.035450, -0.105170, -0.015410, -0.128750, -0.064230, 
0.011890, -0.051120, -0.073590, -0.003280, -0.118080, -0.049160, -0.014370, -0.046640, -0.020340, -0.099560, 
0.087830, -0.118780, -0.032470, 0.014610, -0.027710, 0.040260, -0.124290, -0.042220, 0.068990, -0.052940, 
-0.073930, 0.048970, -0.122040, -0.017190, 0.055650, -0.009250, -0.136400, 0.041230, -0.124220, 0.004110, 
0.051970, -0.083120, 0.025590, 0.010360, 0.027090, 0.068240, 0.008120, -0.024620, 0.041070, 0.020970, 
-0.119760, -0.061480, 0.090270, -0.107930, -0.024400, 0.029080, -0.093570, -0.014410, 0.075230, 0.016020, 
-0.054750, -0.006940, -0.063020, -0.014270, 0.059090, -0.092930, -0.002450, 0.059280, -0.067970, 0.060310, 
0.027500, -0.017090, 0.043510, -0.013180, -0.087370, -0.078280, 0.055000, -0.023660, -0.109430, 0.031110, 
-0.026790, -0.024130, 0.038710, 0.005380, -0.005830, -0.023760, -0.026970, -0.019710, 0.009010, -0.078060, 
-0.032760, 0.070430, -0.039500, -0.051500, 0.020580, -0.030100, 0.030600, -0.026120, 0.041440, -0.192180, 
0.028040, 0.083850, -0.203840, 0.001440, -0.020850, 0.003900, -0.013690, 0.023560, -0.074910, 0.016370, 
0.043840, -0.060810, -0.030710, -0.021150, -0.086570, 0.046920, 0.116760, -0.109190, -0.086830, 0.052430, 
-0.041830, -0.036930, 
-0.038940, 0.027300, -0.047400, -0.088510, 0.017880, -0.017140, -0.103730, 0.037490, 0.034370, 0.012100, 
0.055340, 0.066360, -0.101320, 0.016000, 0.069420, -0.033880, 0.043800, 0.072120, 0.083620, -0.004720, 
0.010420, -0.087170, -0.089540, 0.167600, -0.014910, -0.007920, -0.041370, -0.083270, 0.008220, -0.022840, 
-0.030720, -0.002740, 0.017950, -0.029450, 0.006150, 0.033520, -0.050200, -0.049660, 0.070390, 0.044150, 
-0.033370, 0.015680, 0.105670, -0.115610, 0.050140, -0.049080, -0.076250, 0.065810, 0.025100, -0.021470, 
-0.088470, -0.015330, -0.007050, -0.089680, -0.022970, -0.025510, -0.023040, -0.003150, 0.020770, -0.049010, 
-0.081190, -0.075010, 0.040310, 0.022170, -0.024940, -0.027920, 0.083130, -0.162560, 0.001710, -0.049070, 
-0.091110, -0.037410, 0.026680, -0.060850, -0.089960, 0.036380, -0.074450, -0.098430, -0.008930, -0.060050, 
-0.026770, -0.025090, 0.007960, -0.103560, 0.002580, -0.132160, 0.000900, 0.042010, -0.019860, -0.085600, 
0.146960, -0.130030, -0.128960, -0.035000, -0.045780, -0.080170, 0.010700, -0.047870, -0.114940, 0.018050, 
-0.112700, -0.109800, -0.001860, -0.066680, -0.080900, -0.082320, 0.018830, -0.091130, 0.034950, -0.106190, 
-0.087500, 0.011920, -0.053100, -0.088670, 0.150600, -0.050690, -0.197900, -0.033210, -0.027330, -0.002580, 
0.001790, -0.021110, -0.135830, 0.049600, -0.108470, -0.085710, -0.077910, 0.001570, -0.044110, -0.083670, 
0.122720, -0.082850, -0.037540, -0.000220, -0.068280, -0.068730, -0.009760, -0.031420, 0.202900, 0.110200, 
-0.270140, 0.067480, 0.013940, -0.085470, 0.171260, -0.022630, -0.394010, 0.137340, -0.060250, -0.321890, 
0.072350, -0.011060, -0.297420, 0.070400, 0.127870, -0.310980, 0.172000, 0.044990, -0.372690, 0.027440, 
0.026250, -0.286010, 0.348000, 0.181870, -0.602470, 0.332420, 0.049100, -0.458270, 0.055980, -0.041100, 
-0.177190, 0.033260, -0.077800, -0.134850, 0.010610, 0.046080, -0.149740, 0.016610, 0.037540, -0.113500, 
0.090640, 0.011120, -0.206800, 0.024130, -0.029340, -0.115610, 0.178230, 0.113490, -0.301360, 0.280790, 
-0.012950, -0.245060, 0.005150, -0.099740, -0.046260, 0.047530, -0.111330, -0.050570, -0.075920, 0.062470, 
-0.083490, -0.032170, -0.027700, 0.001870, 0.025800, -0.013510, -0.104370, 0.033070, -0.049100, -0.083230, 
0.063510, -0.001220, -0.023940, 0.130610, -0.127380, 0.042070, 0.022620, -0.154650, 0.032570, 0.064630, 
-0.104900, -0.031870, -0.048470, 0.042270, -0.030300, -0.010400, -0.032840, 0.036970, -0.003000, -0.030670, 
0.004260, 0.004030, -0.013540, -0.020280, 0.014810, -0.100900, 0.115310, 0.053850, -0.150200, 0.177900, 
0.015930, -0.057570, 0.014250, 0.075460, -0.023480, -0.063430, -0.038820, 0.036380, 0.011130, -0.016740, 
0.007370, 0.043540, -0.068050, -0.003120, 0.048430, -0.021860, 0.088930, -0.020140, 0.041370, -0.102000, 
0.099810, 0.013700, -0.100440, 0.108690, 0.019610, -0.028810, -0.026220, 0.043750, 0.044750, -0.078360, 
-0.057610, 0.049110, -0.006720, -0.097760, 0.002370, 0.069580, -0.152500, -0.002380, 0.082310, -0.073870, 
0.123960, -0.044780, -0.012480, -0.026830, 0.074540, -0.057820, 0.003570, 0.064780, 0.008060, -0.039000, 
-0.008620, -0.015300, 0.033420, -0.043140, -0.073940, 0.034250, 0.035120, -0.019310, -0.054190, 0.041120, 
-0.155820, 0.034050, 0.113640, -0.148140, 0.115850, 0.008160, -0.047440, 0.016740, 0.097620, -0.062590, 
-0.027780, 0.079520, 
-0.168520, 0.001940, 0.025340, -0.209640, 0.140090, -0.034180, -0.139860, 0.100580, -0.000320, -0.205550, 
0.140510, -0.051110, -0.235430, 0.123310, 0.088070, -0.181290, 0.061550, 0.072190, -0.260100, 0.174470, 
0.037190, -0.246130, 0.129320, -0.017770, -0.249880, 0.013670, 0.071360, -0.313340, 0.108350, 0.060470, 
-0.206180, 0.014300, 0.031550, -0.239400, 0.109640, 0.033480, -0.143040, -0.007450, 0.040000, -0.218850, 
0.014090, 0.126390, -0.201130, 0.196230, 0.059470, -0.295360, 0.208200, 0.068760, -0.236770, 0.026140, 
0.082470, -0.299550, 0.133500, 0.055360, -0.171580, 0.104650, -0.008150, -0.176330, 0.173960, -0.026530, 
-0.129210, 0.030990, 0.084090, -0.205860, 0.021640, 0.112930, -0.267840, 0.250590, 0.044220, -0.268180, 
0.191420, 0.090560, -0.162640, 0.061620, -0.044310, -0.207020, 0.108020, -0.041380, -0.065290, 0.046850, 
-0.054850, -0.084740, 0.146170, -0.121020, -0.210520, 0.114580, -0.002970, -0.107570, 0.052690, -0.019390, 
-0.366700, 0.391620, 0.094820, -0.211590, 0.237480, -0.046860, -0.158280, 0.019890, -0.094410, -0.238930, 
0.087750, -0.052900, -0.030580, 0.032290, -0.152170, 0.013350, 0.104330, -0.314000, -0.144650, 0.013340, 
-0.066590, -0.061120, 0.118000, -0.198090, -0.225500, 0.190510, 0.070030, -0.220130, 0.092330, -0.024790, 
-0.193030, -0.162200, -0.123810, -0.258830, -0.160760, -0.085170, -0.066390, -0.032840, -0.256770, -0.039390, 
-0.165440, -0.141590, -0.217190, -0.028030, -0.076460, -0.104860, -0.025540, -0.249950, -0.140890, -0.324450, 
0.196950, -0.186590, -0.390180, 0.290350, -0.229570, -0.278660, 0.205230, -0.229730, -0.409430, 0.351310, 
-0.152830, -0.022540, 0.024870, -0.055640, -0.304560, 0.201870, -0.166630, -0.140320, 0.118920, -0.076290, 
-0.276910, 0.098960, -0.183450, -0.519370, 0.428750, -0.078430, -0.665060, 0.605740, -0.087780, -0.195710, 
-0.222150, -0.132680, -0.275810, -0.049090, -0.174460, -0.127120, -0.122030, -0.020490, -0.218700, -0.080310, 
-0.113870, -0.102870, -0.152140, -0.042010, -0.179320, -0.212300, -0.056420, -0.520020, 0.120990, 0.083490, 
-0.620540, 0.296620, -0.093940, -0.096510, -0.059870, -0.077930, -0.142000, -0.032800, -0.140340, -0.077490, 
0.000550, -0.124390, -0.002030, 0.007410, -0.123850, 0.018890, -0.038430, -0.052110, 0.038120, -0.152600, 
0.131590, -0.177680, -0.062730, 0.047440, -0.062240, 0.005620, -0.115580, -0.037900, 0.061530, -0.038040, 
-0.080410, 0.065610, -0.134320, 0.043020, 0.046270, 0.008400, -0.100750, 0.027380, -0.166430, 0.116560, 
0.084800, -0.098510, 0.080060, 0.025360, 0.043500, 0.114890, -0.053590, 0.015730, 0.133900, -0.093380, 
-0.129860, -0.045520, 0.118840, -0.127050, 0.051280, 0.037470, -0.070910, 0.037710, 0.088280, 0.052800, 
0.039250, -0.052880, -0.022770, 0.084090, 0.037800, -0.030740, 0.040500, 0.067290, -0.055800, 0.120520, 
-0.037850, 0.027940, 0.126720, -0.158370, -0.016380, -0.062470, 0.067200, 0.047290, -0.096410, 0.071590, 
0.013970, 0.006310, 0.108620, 0.087650, 0.055430, -0.015750, -0.006000, 0.065330, 0.063400, -0.052600, 
0.002360, 0.164140, -0.041910, -0.032180, 0.030940, -0.004100, 0.103130, -0.102550, 0.182790, -0.226120, 
0.087250, 0.221750, -0.267510, 0.058300, 0.039760, 0.010910, 0.048470, 0.155660, -0.090090, 0.041560, 
0.199610, -0.069900, -0.052090, 0.112530, -0.102080, 0.083110, 0.264060, -0.166960, -0.104030, 0.138510, 
-0.063960, -0.031130, 
-0.018080, 0.002490, -0.002880, 0.002660, -0.053810, 0.028140, -0.031790, -0.080430, 0.063540, 0.001790, 
-0.018750, 0.012340, -0.038040, -0.021480, 0.036500, -0.003960, -0.040860, 0.016170, 0.061470, -0.035070, 
-0.013040, 0.023640, -0.029040, 0.047590, -0.009650, -0.021080, 0.004590, 0.006090, -0.042760, 0.012150, 
0.041310, -0.050860, -0.002450, 0.009440, -0.027800, -0.011310, -0.041090, 0.028630, 0.048220, 0.045390, 
-0.064040, -0.009370, -0.008930, -0.085960, 0.047250, -0.000660, -0.046120, 0.001500, 0.002770, 0.016180, 
-0.060940, -0.011570, -0.007300, -0.024580, 0.020940, -0.044510, -0.006890, -0.008710, -0.012520, -0.030460, 
-0.084470, 0.042860, -0.004550, 0.012610, -0.063510, -0.036880, -0.071140, -0.036250, 0.007910, -0.044810, 
-0.031790, -0.040680, -0.003770, 0.000000, -0.072680, -0.007670, -0.014600, -0.031790, -0.022850, -0.056210, 
-0.008930, -0.083210, 0.051180, -0.084480, -0.034020, 0.026920, -0.059400, 0.003920, -0.065700, -0.034630, 
-0.039570, -0.001820, -0.120570, -0.069520, 0.030090, -0.069940, 0.013530, -0.011980, -0.065060, -0.011170, 
-0.016570, -0.032830, 0.008350, -0.060130, -0.028660, -0.110210, 0.037880, -0.074950, 0.009830, 0.031780, 
-0.077100, 0.025040, -0.096300, -0.052940, -0.061910, 0.071820, -0.167580, -0.057310, 0.122760, -0.073640, 
0.029590, 0.042740, -0.084320, 0.003990, 0.065140, -0.043710, -0.006300, -0.017930, -0.036510, -0.060170, 
0.092150, -0.111040, 0.014180, 0.072200, -0.095620, 0.027220, -0.072710, -0.023570, 0.018550, 0.166180, 
-0.235070, 0.027360, 0.196610, -0.229870, 0.037610, 0.082820, -0.249040, 0.002260, 0.109270, -0.230450, 
0.039910, -0.037380, -0.211710, -0.008160, 0.099480, -0.256070, 0.013470, 0.100370, -0.243140, -0.008970, 
-0.014880, -0.167930, 0.087850, 0.238090, -0.446070, 0.090370, 0.231030, -0.468170, -0.006620, 0.010670, 
-0.033130, -0.048990, 0.062510, -0.051610, 0.011810, 0.020650, -0.059270, -0.048970, 0.025030, -0.036320, 
-0.026230, 0.026950, -0.030200, -0.026840, -0.083970, 0.023240, -0.010890, 0.169390, -0.181920, 0.033810, 
0.104870, -0.222840, -0.003460, -0.053020, 0.004010, -0.041710, -0.007150, 0.011870, 0.024730, 0.027950, 
-0.049160, -0.060670, 0.000930, 0.005810, 0.016510, 0.000490, -0.026320, 0.000150, -0.107080, 0.052150, 
-0.093070, 0.079750, 0.004970, -0.028190, -0.016500, -0.023170, -0.000810, -0.067090, -0.008300, -0.028280, 
-0.024500, -0.021890, 0.034750, 0.000270, -0.053610, -0.022330, 0.017590, -0.025140, 0.033640, -0.015810, 
-0.044330, 0.002340, -0.060770, 0.006740, -0.083500, -0.004550, 0.000340, -0.005780, -0.050150, 0.011390, 
0.006470, -0.047370, -0.007850, 0.028120, -0.064520, -0.010050, 0.037040, -0.028670, -0.044750, -0.054770, 
0.064770, -0.015580, -0.002110, -0.004270, -0.051380, 0.024140, -0.026310, -0.024560, 0.017230, -0.062930, 
-0.005330, 0.004030, -0.051500, 0.008450, -0.000900, -0.057700, 0.031920, -0.029230, -0.033290, 0.019560, 
0.010870, -0.041000, -0.031720, -0.040510, 0.002580, -0.008020, -0.020940, -0.055090, 0.041380, -0.023850, 
-0.018990, -0.027020, -0.017480, -0.043460, 0.030470, 0.018770, -0.037280, 0.001800, -0.035360, -0.009140, 
0.009000, -0.040970, 0.034370, -0.015350, 0.001650, -0.038600, -0.012820, -0.000970, -0.012600, -0.036670, 
-0.079120, 0.017910, 0.032010, -0.056070, 0.010420, 0.005080, -0.045910, 0.000150, 0.035640, -0.035720, 
-0.001310, -0.016240, 
0.076820, -0.108620, -0.075170, 0.074440, -0.079930, -0.072470, -0.052180, 0.046570, -0.068680, -0.065540, 
0.012390, -0.149620, -0.023760, 0.019970, -0.057640, -0.049580, -0.003970, -0.033070, 0.022980, 0.047150, 
-0.140370, 0.063980, 0.041330, -0.174020, 0.091130, -0.100780, -0.083280, 0.068410, -0.080540, -0.064740, 
-0.090300, -0.008860, -0.023430, -0.027380, 0.028810, -0.089000, 0.000860, -0.050560, -0.056560, -0.061350, 
-0.063420, 0.013750, 0.090530, 0.017310, -0.104890, 0.064020, 0.042320, -0.111620, 0.087260, -0.127460, 
-0.029990, 0.002310, -0.128180, 0.039540, 0.012870, -0.018770, -0.085920, 0.055600, -0.072420, -0.059440, 
0.059080, -0.057110, -0.032910, 0.015420, -0.148780, 0.030970, 0.156820, 0.041960, -0.109290, 0.147290, 
-0.067300, -0.095780, 0.083790, -0.121850, -0.077650, -0.029700, -0.114560, 0.050540, 0.087410, -0.051520, 
-0.134610, 0.109360, -0.104840, -0.057940, 0.045910, -0.029300, -0.086430, 0.055970, -0.168730, -0.014370, 
0.111810, 0.040920, -0.081100, 0.157020, -0.100340, -0.163970, 0.019200, -0.091550, -0.162360, -0.035860, 
-0.065000, -0.039690, -0.015110, -0.024050, -0.138170, 0.035410, -0.034790, -0.164740, -0.047780, 0.042560, 
-0.121460, -0.024930, -0.031430, -0.094840, -0.085720, -0.009920, 0.040060, 0.170390, -0.173680, -0.190610, 
-0.107390, -0.096560, -0.173540, -0.143380, -0.126120, -0.071170, -0.071040, -0.026420, -0.206280, -0.147350, 
-0.111030, -0.090030, -0.272350, 0.078700, -0.019500, -0.167910, 0.057170, -0.127920, -0.218430, -0.090390, 
0.057630, -0.079530, -0.215760, 0.085020, -0.403900, -0.109250, 0.232470, -0.355430, -0.217480, 0.350130, 
-0.278010, -0.030490, 0.151930, -0.399200, -0.077960, 0.314800, -0.509600, 0.036350, 0.360450, -0.354930, 
-0.033290, 0.280440, -0.656810, -0.162770, 0.598990, -0.440990, -0.236270, 0.492660, -0.068140, -0.114900, 
-0.184600, -0.087260, -0.199080, -0.010640, 0.038760, -0.115460, -0.202700, 0.090270, -0.200850, -0.110660, 
-0.059960, -0.047140, -0.114740, -0.070380, -0.085500, -0.118750, -0.111480, -0.200820, 0.029440, 0.061520, 
-0.256070, 0.014520, 0.026300, -0.160850, -0.071530, -0.079330, -0.152900, 0.065390, 0.129510, -0.158290, 
-0.044300, 0.196680, -0.142050, -0.042190, 0.093670, -0.081290, 0.014450, 0.069360, -0.098480, 0.010860, 
0.077860, -0.147430, -0.035790, 0.179140, -0.140430, -0.094650, 0.045880, -0.149000, -0.031900, -0.032960, 
-0.141380, 0.045250, 0.041780, -0.113060, 0.037660, 0.160470, -0.159310, -0.036080, 0.006510, -0.058920, 
0.113580, 0.050060, -0.116900, 0.041260, 0.104180, -0.049950, -0.062520, 0.124210, -0.126350, -0.025880, 
0.049200, -0.184570, 0.018340, -0.038420, -0.130470, 0.070030, 0.027510, -0.043610, 0.045430, 0.139880, 
-0.037900, -0.071980, 0.015410, -0.036120, 0.110280, 0.095910, -0.149930, 0.064350, 0.029810, -0.002580, 
-0.020180, 0.114990, -0.059760, -0.039880, 0.064090, -0.105240, -0.019130, 0.045430, -0.130410, 0.021080, 
-0.044520, 0.012470, 0.058040, 0.115530, -0.030240, -0.024190, -0.016760, 0.065990, 0.038400, -0.035390, 
-0.094840, 0.100160, 0.111950, -0.036590, -0.065480, 0.021070, -0.037260, -0.008890, 0.074250, -0.073020, 
-0.035430, 0.115500, -0.147630, -0.017300, -0.082760, 0.071820, 0.012950, -0.020130, -0.000790, -0.000260, 
0.024430, 0.034410, -0.091300, -0.018870, -0.062990, 0.022710, 0.181100, -0.051360, -0.096640, 0.041140, 
0.029310, -0.105440, 
-0.006810, 0.104660, -0.023070, -0.010190, 0.051310, -0.009090, -0.024560, -0.007740, 0.057900, -0.065700, 
0.096080, -0.060410, 0.044430, 0.015440, -0.007380, -0.010860, 0.035590, -0.024500, -0.001620, 0.054670, 
-0.097850, 0.002090, 0.089240, -0.012180, 0.049150, 0.024700, -0.054730, 0.015390, 0.035630, -0.028940, 
0.019160, -0.052950, 0.045020, -0.023220, 0.043780, -0.056270, 0.012500, -0.000420, 0.034730, 0.010350, 
-0.044200, 0.024440, -0.052330, 0.006960, -0.028120, 0.016830, 0.025120, -0.041080, 0.065500, -0.032910, 
-0.028950, -0.012570, -0.041210, 0.043630, 0.031760, -0.055800, 0.012230, -0.046360, 0.025660, 0.007740, 
0.008000, -0.003780, 0.034370, 0.001490, -0.100470, 0.026040, -0.077340, 0.010060, 0.072320, 0.001980, 
-0.058170, -0.014760, 0.070950, -0.088950, -0.031570, -0.086180, -0.062320, 0.118300, 0.006740, -0.049390, 
-0.086040, -0.089940, -0.060910, 0.037240, 0.055420, -0.002390, -0.027280, 0.002860, -0.174480, 0.025710, 
-0.193250, 0.033670, -0.013870, -0.174950, -0.012370, -0.008710, 0.010400, -0.103810, -0.023800, -0.132320, 
-0.021750, 0.063580, -0.089270, -0.083190, -0.010620, -0.153750, -0.045280, 0.051720, -0.095690, 0.075010, 
-0.005700, -0.098000, -0.125090, 0.052540, -0.517220, 0.135990, 0.092550, -0.307430, 0.029400, -0.009200, 
-0.135000, 0.019880, -0.009350, -0.233390, 0.110090, 0.053820, -0.091270, -0.049240, -0.048490, -0.253690, 
-0.005010, 0.001010, -0.122990, 0.095900, -0.014800, -0.154340, -0.025830, 0.008320, -0.694190, 0.273240, 
0.068720, -0.481930, 0.252630, -0.080970, -0.341960, 0.120350, 0.072250, -0.379040, 0.165780, 0.101750, 
-0.149060, -0.042220, 0.048670, -0.403900, 0.116910, 0.061020, -0.271020, 0.114290, 0.112110, -0.300780, 
0.048380, 0.113510, -0.727310, 0.299370, 0.108450, -0.637850, 0.401180, -0.061310, -0.201420, 0.062520, 
0.006300, -0.303150, 0.125180, 0.043450, -0.009020, 0.034550, -0.080840, -0.191990, 0.006360, 0.033500, 
-0.125620, 0.091380, 0.034710, -0.189360, 0.014320, 0.109670, -0.489380, 0.182920, 0.080510, -0.520290, 
0.308600, -0.085320, -0.061740, -0.007240, -0.027250, -0.224330, 0.047810, 0.049370, 0.093690, 0.034740, 
-0.063420, -0.034770, 0.050360, 0.008660, 0.006500, 0.019290, 0.049630, -0.021940, -0.074050, 0.148770, 
-0.345480, 0.119980, 0.064530, -0.341720, 0.127640, -0.063590, 0.004010, -0.043490, -0.045410, -0.114290, 
-0.020460, 0.026120, 0.083450, -0.024580, -0.012790, 0.014110, 0.048120, -0.019810, 0.042260, 0.018500, 
0.050230, 0.069970, -0.119160, 0.098790, -0.205410, -0.011250, 0.026510, -0.151850, 0.017730, -0.063500, 
0.032560, -0.066180, 0.002380, 0.000910, -0.098040, 0.061580, 0.042570, 0.015900, -0.010030, -0.031880, 
0.100140, 0.019100, 0.002220, 0.004170, 0.071850, 0.080470, -0.080540, 0.083340, -0.078050, 0.006640, 
0.010780, -0.097540, 0.025010, -0.006000, 0.023980, -0.017360, 0.027880, 0.017020, -0.063140, 0.053670, 
-0.018500, 0.009400, 0.005010, 0.016360, 0.033560, 0.003840, -0.034280, 0.001150, 0.082890, -0.008990, 
-0.039240, 0.084090, -0.044330, 0.074080, -0.008500, -0.079140, 0.030810, -0.051610, -0.028470, 0.110780, 
0.011650, 0.006130, 0.065310, 0.001040, 0.021520, 0.002880, -0.039060, 0.019110, 0.106500, -0.098100, 
-0.012680, 0.042000, -0.034800, 0.020250, 0.039820, -0.040610, -0.023440, 0.131510, -0.037850, -0.125110, 
0.108280, -0.111590, 
-0.007880, -0.024140, -0.077380, -0.032070, -0.028870, -0.049820, -0.013680, -0.008200, -0.073690, -0.009450, 
-0.051270, -0.005950, -0.028840, -0.031140, -0.035200, -0.012270, -0.038550, -0.038070, 0.016020, -0.006370, 
-0.048170, -0.018190, -0.071770, -0.004450, -0.022440, -0.025400, -0.062840, -0.029780, -0.035310, -0.038100, 
-0.041420, -0.020330, -0.034940, -0.024370, -0.029240, 0.001370, -0.022710, -0.042320, -0.038460, -0.024640, 
-0.018040, -0.029800, 0.015880, -0.009770, -0.046170, -0.013680, -0.074120, 0.020330, -0.028750, -0.038540, 
-0.053880, -0.026800, -0.034110, -0.059770, -0.048570, -0.000540, -0.039980, -0.043350, -0.012380, -0.014430, 
-0.034140, -0.045730, -0.032250, -0.028420, 0.003050, -0.044120, 0.032340, -0.041720, -0.040140, -0.008500, 
-0.067750, 0.014820, -0.032460, -0.033260, -0.061880, -0.004200, -0.048720, -0.082820, -0.047490, -0.012670, 
-0.021370, -0.032900, -0.020190, -0.045250, -0.049020, -0.045030, -0.035470, -0.032120, 0.014340, -0.058460, 
0.023980, -0.058170, -0.019670, -0.006700, -0.085230, 0.012920, -0.037180, -0.032040, -0.070490, -0.006860, 
-0.051280, -0.065470, -0.043630, -0.004600, -0.053050, -0.015230, -0.029530, -0.050340, -0.039610, -0.046200, 
-0.048580, -0.034000, -0.012520, -0.052350, 0.063540, -0.085220, -0.038370, -0.000180, -0.124080, 0.018330, 
-0.011080, -0.049450, -0.075290, 0.009190, -0.103580, -0.051730, -0.045780, -0.013910, -0.037310, 0.005030, 
-0.038690, -0.012480, -0.013150, -0.050670, -0.054140, -0.028780, -0.040170, -0.035140, 0.082240, -0.114800, 
-0.023050, 0.048860, -0.176760, 0.054700, 0.066590, -0.067570, -0.092160, 0.063860, -0.127240, -0.064120, 
-0.025240, -0.018730, -0.048750, 0.060720, -0.062390, -0.037710, 0.064800, -0.055120, -0.084210, 0.025910, 
-0.058020, -0.044180, 0.154980, -0.134250, -0.033450, 0.123170, -0.206690, 0.024600, 0.027300, -0.070210, 
-0.072710, 0.020630, -0.099970, -0.065880, -0.060130, -0.029520, -0.019480, -0.005250, -0.052470, -0.030450, 
-0.004670, -0.049750, -0.079460, -0.004850, -0.047240, -0.046340, 0.083560, -0.092060, -0.027000, 0.066920, 
-0.139960, 0.039360, -0.001770, -0.045060, -0.067190, 0.043070, -0.079920, -0.077950, -0.076600, -0.022920, 
-0.035020, -0.033350, -0.048290, -0.019310, -0.048550, -0.028210, -0.055490, -0.024240, -0.025390, -0.074570, 
0.063670, -0.072670, -0.042140, 0.050520, -0.084460, 0.014000, -0.024820, -0.017230, -0.043100, 0.024850, 
-0.041260, -0.050540, -0.057940, -0.014710, -0.019660, -0.030460, -0.048590, -0.004720, -0.045210, -0.013950, 
-0.028780, -0.043900, 0.012470, -0.032590, 0.037180, -0.028590, -0.012700, 0.003720, -0.049000, 0.019280, 
-0.036650, -0.010420, -0.018350, -0.004290, -0.006490, -0.051910, -0.060240, 0.010670, 0.007620, -0.022880, 
-0.038660, 0.009950, -0.048590, -0.010560, -0.012220, -0.061220, 0.024050, -0.009950, -0.001360, -0.019510, 
-0.001500, -0.016550, -0.030900, 0.011310, -0.016320, -0.013870, -0.034980, -0.010010, -0.016840, -0.045430, 
-0.029170, 0.001630, -0.003330, -0.039170, -0.019830, 0.003450, -0.049280, -0.018150, -0.015120, -0.052140, 
0.001330, -0.018030, -0.008430, -0.025800, -0.018580, -0.017990, -0.020810, -0.000140, -0.005470, -0.043290, 
-0.018060, -0.000420, -0.046570, -0.026400, -0.019140, -0.003710, -0.007810, -0.015840, -0.042600, 0.005620, 
-0.022010, -0.014720, 0.003860, -0.039880, -0.014580, 0.010540, 0.019110, -0.036760, -0.020210, 0.002220, 
-0.038040, 0.002860, 
0.008060, 0.012580, 0.005540, 0.011780, 0.022450, 0.014630, -0.079270, 0.006960, 0.100940, -0.107170, 
0.076730, -0.025570, -0.007320, 0.004250, 0.053150, -0.066220, 0.028100, 0.043870, -0.057760, 0.049650, 
-0.062700, -0.035330, 0.142690, -0.096940, 0.009970, 0.005980, -0.009570, 0.006410, 0.014220, -0.004680, 
-0.057130, -0.019000, 0.087890, -0.101580, 0.073810, -0.017320, -0.011020, -0.035580, 0.072790, -0.055800, 
-0.018160, 0.089520, -0.061620, 0.042350, -0.026880, -0.086780, 0.126660, -0.039270, 0.038790, -0.052740, 
-0.005480, -0.023860, -0.020210, 0.058130, 0.004340, -0.006680, -0.001840, -0.017560, 0.021290, 0.002060, 
0.038150, -0.040340, 0.041750, -0.049620, -0.073300, 0.065590, -0.044800, 0.096310, -0.016770, -0.055190, 
0.026440, -0.016480, 0.037490, -0.059250, -0.027940, -0.087030, -0.054910, 0.089870, 0.035470, 0.033470, 
-0.117950, 0.003480, -0.039350, -0.008380, 0.055440, 0.003060, -0.035250, -0.011630, -0.113860, 0.029520, 
-0.104070, 0.119550, -0.056900, -0.104610, 0.027430, -0.094330, 0.024900, -0.044760, -0.130110, -0.061880, 
-0.002370, -0.029880, -0.041980, 0.043740, -0.149050, -0.027090, 0.038320, -0.127790, -0.045810, 0.127760, 
-0.126940, -0.063810, 0.004380, -0.066580, -0.323340, 0.176350, -0.000110, -0.115250, 0.027570, -0.187150, 
-0.097820, 0.005770, -0.134490, -0.143330, 0.015370, -0.067290, -0.033220, 0.036480, -0.211540, -0.105610, 
-0.013050, -0.120800, -0.143400, 0.111620, -0.086540, -0.098740, 0.056170, -0.116770, -0.468860, 0.164380, 
-0.003640, -0.313350, 0.151950, -0.121080, -0.369620, 0.031000, 0.130260, -0.370660, -0.020650, 0.209810, 
-0.205240, -0.012270, 0.124900, -0.363900, -0.014850, 0.221670, -0.356480, 0.043680, 0.281340, -0.307320, 
0.029510, 0.180490, -0.818580, 0.061860, 0.439100, -0.619330, 0.141740, 0.246210, -0.093980, -0.034730, 
-0.111200, -0.152300, -0.060770, 0.008590, 0.101090, -0.050690, -0.148960, 0.072930, -0.139900, -0.035400, 
0.010380, 0.006010, -0.040900, -0.048530, -0.045150, -0.019060, -0.308670, -0.023130, 0.122510, -0.214470, 
0.030380, -0.028760, 0.025690, -0.106020, -0.058120, -0.148230, -0.069020, 0.035120, 0.176770, -0.114980, 
-0.046570, 0.176410, -0.130610, -0.007150, 0.127660, -0.063530, 0.049540, 0.085940, -0.121320, 0.079410, 
-0.160870, -0.033360, 0.075570, 0.000420, -0.051590, -0.085950, 0.055780, -0.107540, -0.051320, -0.088830, 
-0.084940, 0.020330, 0.091490, -0.095690, 0.020210, 0.105100, -0.071110, -0.002240, 0.055450, -0.030820, 
0.087140, 0.089920, -0.141980, 0.095490, -0.055900, -0.053650, 0.013700, 0.070050, -0.108780, -0.050390, 
0.063700, -0.122410, -0.028220, -0.011070, -0.116310, 0.050350, 0.046270, -0.033010, 0.018060, 0.080140, 
0.033920, -0.011700, 0.007930, -0.012290, 0.096700, 0.099960, -0.119350, 0.078860, -0.028420, -0.027050, 
0.026090, 0.016880, -0.031400, -0.024260, 0.076300, -0.067600, -0.023470, 0.062740, -0.094500, 0.011290, 
-0.083540, 0.044780, 0.062520, 0.047210, 0.014670, 0.007930, -0.067840, 0.063600, 0.086660, -0.061010, 
-0.036980, 0.100480, 0.035490, -0.007160, -0.013900, -0.033740, -0.021990, -0.004500, 0.053730, 0.018280, 
-0.032920, 0.096710, -0.040710, -0.008450, -0.041890, 0.050060, -0.019280, 0.028830, 0.058790, -0.072250, 
-0.036560, 0.031050, -0.034790, -0.005270, 0.013190, -0.003880, 0.083910, 0.059040, -0.077020, -0.053090, 
0.030670, -0.085520, 
0.005390, 0.000490, -0.032870, 0.008800, 0.027700, -0.037280, -0.079280, 0.031080, 0.046820, -0.120900, 
0.079080, -0.103360, -0.025040, 0.009910, -0.009880, -0.065590, 0.054290, 0.004120, -0.038620, 0.076760, 
-0.161840, 0.019100, 0.180290, -0.206020, -0.002780, -0.000980, -0.024680, -0.009840, 0.015630, -0.022120, 
-0.096460, -0.003950, 0.080210, -0.108160, 0.084550, -0.038210, -0.016540, -0.035610, 0.054330, -0.088250, 
-0.019870, 0.093260, -0.046670, 0.073360, -0.094810, -0.055510, 0.149820, -0.097100, -0.000600, -0.054430, 
0.021610, -0.052430, -0.051750, 0.078280, 0.000520, -0.009950, -0.015460, -0.009420, -0.024360, 0.011610, 
0.034580, -0.059480, 0.047620, -0.036800, -0.112690, 0.076180, 0.004490, 0.120300, -0.107400, -0.027590, 
0.047580, -0.064100, -0.004620, -0.070200, -0.004180, -0.104110, -0.063000, 0.122120, 0.028800, 0.029650, 
-0.136430, 0.034460, -0.069430, -0.009740, 0.037560, -0.020270, -0.036780, -0.013520, -0.156230, 0.056200, 
-0.056890, 0.139880, -0.107010, -0.046100, 0.013890, -0.140560, 0.010050, -0.047830, -0.161470, -0.038780, 
-0.029760, -0.050460, -0.019430, 0.053800, -0.201590, 0.018000, 0.010890, -0.169670, -0.049000, 0.112150, 
-0.148960, -0.045580, -0.019250, -0.103660, -0.279560, 0.181690, -0.075240, -0.013700, -0.003920, -0.282190, 
-0.100880, -0.015560, -0.183580, -0.100350, -0.028890, -0.105140, 0.009230, 0.029360, -0.268640, -0.074880, 
-0.045260, -0.162630, -0.148760, 0.115080, -0.100780, -0.078260, 0.043860, -0.154140, -0.406700, 0.162440, 
-0.098990, -0.227560, 0.125140, -0.184810, -0.408630, -0.010340, 0.143190, -0.345620, -0.075670, 0.221350, 
-0.206810, -0.011990, 0.094580, -0.361060, -0.037870, 0.241920, -0.412970, 0.045450, 0.303600, -0.286110, 
0.009620, 0.201050, -0.889920, 0.023730, 0.505060, -0.600670, 0.080230, 0.280210, -0.028850, -0.089490, 
-0.167420, -0.093870, -0.121190, -0.027130, 0.175120, -0.068940, -0.231890, 0.184760, -0.200720, -0.082800, 
0.062300, -0.010590, -0.103100, 0.019250, -0.072720, -0.098730, -0.225040, -0.076330, 0.064420, -0.055490, 
-0.043340, -0.082920, 0.067820, -0.175210, -0.082070, -0.124990, -0.141500, 0.047120, 0.205910, -0.169250, 
-0.064440, 0.277770, -0.198260, -0.025210, 0.176350, -0.106130, 0.027670, 0.121340, -0.175360, 0.072350, 
-0.095630, -0.097180, 0.067570, 0.151570, -0.156820, -0.132720, 0.064470, -0.166740, -0.029490, -0.088370, 
-0.149950, 0.055920, 0.107520, -0.158800, 0.048550, 0.167540, -0.164330, -0.008600, 0.064360, -0.089390, 
0.114390, 0.092090, -0.201190, 0.104560, -0.003160, -0.110390, 0.011390, 0.195180, -0.211310, -0.050440, 
0.079710, -0.191860, 0.011370, -0.023480, -0.183390, 0.098100, 0.060870, -0.093570, 0.034480, 0.125920, 
-0.038800, -0.025260, 0.024000, -0.072230, 0.110910, 0.142800, -0.218470, 0.103210, 0.064640, -0.090490, 
-0.019460, 0.114410, -0.112650, -0.031710, 0.082520, -0.113640, -0.011070, 0.059680, -0.159540, 0.038550, 
-0.069690, -0.019670, 0.060330, 0.102210, -0.054340, -0.009110, -0.054370, 0.003650, 0.061670, -0.048210, 
-0.129770, 0.126770, 0.113720, -0.083490, -0.079100, 0.047440, -0.106130, -0.012910, 0.062120, -0.036490, 
-0.030360, 0.108550, -0.083680, -0.012590, -0.042530, 0.014820, -0.011040, 0.036270, -0.003650, -0.062520, 
-0.002890, -0.002720, -0.056320, 0.005470, -0.056510, -0.009410, 0.153240, -0.015690, -0.122600, 0.005740, 
-0.045440, -0.096350, 
0.024780, -0.140700, -0.100410, -0.042910, -0.123990, -0.048870, 0.053610, -0.004530, -0.132280, 0.061650, 
-0.203460, 0.057150, -0.024840, -0.043510, 0.016750, 0.015790, -0.138480, -0.008020, -0.023880, 0.112010, 
-0.042790, -0.027430, -0.081620, 0.088630, 0.008040, -0.119730, -0.056800, -0.052950, -0.120630, -0.011340, 
-0.043670, -0.010970, -0.029170, 0.009210, -0.066350, 0.081320, 0.036050, -0.074430, 0.002020, -0.010460, 
-0.037360, 0.030860, 0.010770, 0.083900, 0.100010, -0.045970, -0.039170, 0.194740, 0.026200, -0.101790, 
-0.069710, -0.038120, -0.067240, -0.057940, -0.023860, -0.015450, 0.013430, 0.003980, -0.012360, 0.024910, 
0.019290, -0.027960, 0.023460, 0.028780, -0.001620, 0.030330, 0.070480, 0.045650, -0.000140, -0.017760, 
-0.019410, 0.152890, -0.026860, -0.094200, -0.106710, 0.009180, -0.094330, -0.128600, -0.050620, -0.034510, 
0.035010, 0.089800, -0.061510, -0.059680, -0.104610, -0.020960, -0.003460, -0.044960, 0.049770, -0.028090, 
0.003420, 0.011660, 0.053670, 0.020130, -0.095580, 0.096150, -0.084420, -0.086970, -0.065090, -0.040460, 
-0.190570, -0.082010, -0.065560, -0.010020, 0.000960, 0.189660, -0.149180, -0.093290, -0.122650, -0.076550, 
0.009990, -0.050930, -0.014300, -0.004140, 0.152960, -0.164390, 0.042580, 0.051130, -0.282140, 0.135500, 
-0.053570, -0.237250, -0.103030, 0.004390, -0.377580, -0.093700, -0.114440, -0.048550, -0.057370, 0.147670, 
-0.285820, 0.110140, -0.116520, -0.136220, -0.014960, -0.056640, -0.140660, 0.000250, 0.268490, -0.414290, 
0.052270, 0.146140, -0.600650, 0.367840, 0.065230, -0.279230, -0.042400, 0.120380, -0.462640, 0.060350, 
-0.134280, -0.059730, 0.073510, 0.167270, -0.323840, 0.236720, 0.010870, -0.208980, -0.003000, 0.076780, 
-0.331990, 0.147270, 0.346950, -0.478810, 0.173350, 0.256650, -0.657170, 0.472120, 0.038890, -0.221410, 
-0.165280, 0.127240, -0.372270, -0.090680, -0.220110, -0.123570, 0.055040, 0.106000, -0.318080, 0.043620, 
-0.143820, -0.154480, -0.061330, 0.056200, -0.245670, -0.055070, 0.127920, -0.299680, 0.134240, 0.133500, 
-0.391070, 0.344240, -0.007850, -0.162110, -0.070890, 0.156610, -0.267650, -0.082790, -0.215820, -0.128910, 
0.076450, -0.052040, -0.228140, 0.074210, -0.190000, -0.105750, 0.021620, -0.031120, -0.057150, -0.069170, 
0.152330, -0.126510, -0.003420, 0.037820, 0.011680, 0.188120, -0.051950, -0.088940, 0.001660, 0.072050, 
-0.116730, -0.042830, -0.146190, -0.007160, 0.036310, -0.031860, -0.190110, 0.063660, -0.195770, 0.001750, 
0.032350, -0.136070, 0.101570, -0.001490, 0.083070, 0.156290, 0.031850, -0.034490, 0.116880, 0.149730, 
-0.035510, -0.099090, 0.041030, -0.013880, -0.023870, -0.057390, -0.113240, 0.054260, 0.064250, 0.027240, 
-0.056410, -0.040160, -0.137090, 0.013850, 0.038420, -0.181010, 0.079900, 0.039380, -0.036530, 0.197480, 
-0.019750, -0.014910, 0.107150, 0.025680, 0.004140, -0.106420, 0.002370, 0.073730, -0.095190, -0.071470, 
-0.038180, 0.016570, 0.057420, -0.017200, -0.016040, -0.009170, -0.049640, 0.016150, 0.025230, -0.122530, 
0.021780, 0.068190, 0.003630, -0.013940, 0.055030, -0.031780, 0.036410, 0.040580, 0.149990, -0.203250, 
-0.034800, 0.203640, -0.248490, -0.058090, -0.061430, 0.093790, 0.044720, -0.022450, -0.067830, 0.092940, 
-0.049750, -0.021960, 0.065620, -0.049050, -0.051260, 0.132530, 0.226780, -0.098530, -0.039170, 0.080590, 
0.004110, 0.075300, 
0.029110, -0.060490, -0.146490, -0.069910, -0.034380, -0.109330, 0.035690, -0.033280, -0.132140, 0.034550, 
-0.010850, 0.007720, 0.024480, -0.074270, -0.055460, 0.050070, -0.018450, -0.070090, 0.023050, 0.004080, 
-0.093500, -0.150340, -0.107860, 0.148280, 0.101290, -0.091040, -0.197530, -0.012460, -0.051960, -0.157630, 
0.060560, -0.059590, -0.163590, 0.010490, -0.014010, -0.069080, 0.102650, -0.150200, -0.110090, 0.080950, 
-0.020600, -0.143620, 0.155450, -0.094920, -0.113920, -0.067020, -0.161390, 0.101200, 0.141210, -0.119870, 
-0.226850, 0.073890, -0.096660, -0.205500, 0.034220, -0.047710, -0.171190, -0.015600, -0.011360, -0.131520, 
0.061210, -0.189010, -0.079930, 0.056250, 0.001450, -0.159840, 0.140000, -0.185300, -0.073010, -0.059210, 
-0.196920, 0.039570, 0.099210, -0.131320, -0.218550, 0.087630, -0.151490, -0.193070, 0.027670, -0.053250, 
-0.160100, -0.009070, -0.038590, -0.147500, 0.092200, -0.195820, -0.110970, 0.040980, 0.036170, -0.200350, 
0.230160, -0.249410, -0.154350, -0.022380, -0.228090, -0.000180, 0.047090, -0.055140, -0.218040, 0.057790, 
-0.181400, -0.167560, -0.058450, -0.006150, -0.157000, -0.075200, 0.048090, -0.114040, 0.036180, -0.118800, 
-0.137290, -0.058510, 0.082310, -0.158750, 0.203450, -0.188060, -0.165670, -0.073220, -0.224590, 0.067450, 
0.021720, -0.006700, -0.228470, 0.091190, -0.167420, -0.167480, -0.126130, 0.100410, -0.119270, -0.104070, 
0.148830, -0.060660, 0.004850, 0.034400, -0.182620, -0.159590, 0.184420, -0.102080, 0.181510, -0.023050, 
-0.178850, -0.007170, -0.139760, 0.008820, 0.211890, -0.000490, -0.458820, 0.211650, -0.142430, -0.367550, 
0.051410, 0.155870, -0.361600, 0.094380, 0.245040, -0.350430, 0.247330, 0.118860, -0.497270, 0.020390, 
0.239370, -0.384190, 0.412690, 0.127880, -0.578820, 0.300020, -0.059360, -0.351360, 0.096710, -0.017840, 
-0.267790, 0.119420, -0.167240, -0.219560, -0.001410, 0.171520, -0.256870, -0.003100, 0.183740, -0.191830, 
0.109930, 0.083380, -0.333170, 0.012170, 0.194730, -0.249460, 0.299640, 0.044870, -0.357540, 0.237330, 
-0.067900, -0.215390, 0.085150, -0.102960, -0.166690, 0.154380, -0.192060, -0.151550, -0.026640, 0.097620, 
-0.240450, 0.017120, 0.079840, -0.159420, 0.045980, 0.015590, -0.271860, 0.053360, 0.120350, -0.232500, 
0.307320, -0.121880, -0.219930, 0.262590, -0.163090, -0.079140, 0.120220, -0.162240, -0.067830, 0.165310, 
-0.174510, -0.090740, 0.025730, 0.011360, -0.188710, 0.016840, -0.022200, -0.046290, 0.029410, -0.043000, 
-0.127650, 0.048670, 0.049580, -0.142060, 0.197930, -0.181960, -0.040700, 0.230180, -0.212840, 0.008820, 
0.072680, -0.115540, -0.042390, 0.120330, -0.097510, -0.097600, 0.017720, -0.028980, -0.089580, 0.019460, 
-0.111890, 0.028190, -0.048970, -0.069120, -0.011140, -0.032970, 0.060420, -0.067200, 0.138540, -0.152300, 
0.030600, 0.093170, -0.206760, 0.079890, 0.080080, -0.075370, -0.092780, 0.112420, -0.034780, -0.100940, 
-0.033180, -0.015070, -0.059840, -0.072840, -0.177390, 0.088270, -0.145880, -0.053510, 0.040970, -0.042340, 
0.071820, -0.068490, 0.097790, -0.121120, 0.014710, 0.009700, -0.139350, 0.056890, 0.081300, -0.086730, 
-0.067640, 0.089320, -0.081610, -0.058760, -0.026680, -0.026240, -0.042250, 0.034950, -0.233290, 0.095880, 
-0.119470, -0.056750, 0.091120, -0.076320, 0.059950, -0.018860, 0.046690, -0.050170, 0.016860, 0.024140, 
-0.184330, 0.075220, 
-0.211600, 0.027860, -0.004600, -0.243990, 0.040280, 0.009180, -0.111360, 0.068870, -0.057640, -0.000020, 
-0.129990, 0.219720, -0.146440, -0.006580, 0.060850, -0.090060, 0.013560, 0.000790, -0.074910, 0.218660, 
-0.126260, -0.015930, -0.058700, 0.065340, -0.260160, 0.028020, 0.089660, -0.321040, 0.060640, 0.108310, 
-0.185640, 0.006100, 0.091800, -0.035200, -0.051970, 0.206190, -0.099510, -0.042050, 0.086120, -0.103520, 
0.097330, -0.006030, 0.089740, 0.153620, -0.076850, -0.069230, 0.006550, 0.093170, -0.298920, 0.015580, 
0.107200, -0.254540, 0.092670, 0.024550, -0.208360, -0.044060, 0.161800, -0.059000, -0.057080, 0.101820, 
-0.162360, -0.117640, 0.174330, -0.149670, 0.133560, 0.009100, 0.179530, -0.041570, -0.120930, -0.071480, 
-0.014730, 0.061710, -0.324680, -0.046670, 0.126680, -0.257760, 0.029750, -0.001280, -0.150580, -0.111770, 
0.142100, -0.083800, -0.050680, 0.038660, -0.135340, -0.192370, 0.173860, -0.143650, 0.123110, -0.042100, 
0.267530, -0.285080, -0.090170, -0.100370, -0.145000, 0.145420, -0.343150, -0.004190, 0.118740, -0.235040, 
-0.060030, 0.003020, -0.141330, -0.068720, 0.052400, -0.066270, 0.040010, 0.009790, -0.081980, -0.241320, 
0.086860, -0.108710, 0.008760, -0.014880, 0.470630, -0.397540, -0.157440, 0.004450, -0.351590, 0.241500, 
-0.237080, -0.021700, 0.024450, -0.119090, -0.224310, 0.029630, -0.185280, -0.040180, 0.073920, -0.025290, 
0.076140, 0.074720, -0.087200, -0.193980, 0.019940, -0.143550, -0.017670, 0.055750, 0.546080, -0.355400, 
-0.185150, 0.197220, -0.498730, 0.265200, 0.191040, -0.091310, -0.352000, 0.222340, -0.284450, -0.224230, 
0.059150, -0.000230, -0.215560, 0.299530, 0.032970, -0.191740, 0.380590, -0.165570, -0.393270, 0.136200, 
-0.080070, -0.161280, 0.959350, -0.252490, -0.552940, 0.765660, -0.604090, -0.049480, -0.096230, -0.049650, 
-0.114680, 0.036150, -0.208060, -0.125660, -0.138010, -0.008600, -0.106810, 0.002710, 0.055670, -0.112150, 
0.091770, -0.135960, -0.254650, 0.035770, -0.069760, -0.188150, 0.536800, -0.215530, -0.261880, 0.417760, 
-0.408270, 0.032880, -0.214070, -0.003230, -0.053240, 0.019680, -0.118570, -0.138950, -0.204960, 0.038410, 
-0.216430, 0.057620, -0.070260, -0.145110, -0.017340, -0.091820, -0.261530, 0.017880, -0.006580, -0.322880, 
0.338730, -0.250160, -0.129660, 0.363990, -0.316700, 0.047990, -0.293100, 0.032670, 0.105160, -0.083790, 
-0.026690, -0.016630, -0.176520, 0.056960, -0.126970, 0.021200, -0.073320, -0.096610, 0.034070, -0.106660, 
-0.141350, -0.015760, 0.094790, -0.228490, 0.168210, -0.174740, 0.083370, 0.154620, -0.241490, 0.171510, 
-0.301950, 0.013220, 0.217330, -0.149370, 0.037290, 0.079570, -0.207970, -0.001190, 0.066460, -0.016840, 
-0.088440, 0.037430, -0.115610, -0.127380, 0.134990, -0.200550, 0.176700, -0.051070, 0.030970, -0.104140, 
0.175480, 0.086460, -0.199740, 0.275850, -0.250750, -0.003670, 0.173190, -0.102020, 0.029870, 0.033880, 
-0.175010, 0.024280, 0.054990, -0.208680, 0.028080, 0.103500, -0.140910, -0.065900, 0.104550, -0.122470, 
0.180270, -0.054780, 0.129660, -0.144750, 0.160930, 0.051520, -0.219820, 0.254220, -0.090390, -0.062360, 
0.026610, -0.010220, -0.056870, -0.008260, -0.146040, 0.140710, -0.010160, -0.034450, 0.009090, 0.028430, 
-0.077800, 0.023020, 0.085000, -0.139090, 0.204780, -0.067160, 0.246270, -0.107670, 0.018660, 0.173180, 
-0.253700, 0.176400, 
-0.036820, -0.011900, -0.028660, -0.033040, -0.014670, -0.032240, -0.033240, -0.018510, -0.023430, -0.045580, 
-0.002320, -0.035880, -0.026690, -0.004970, -0.028780, -0.037510, -0.009270, -0.027230, -0.047470, -0.007040, 
-0.038850, -0.022060, 0.003830, -0.044440, -0.019110, -0.007350, -0.037090, -0.020140, -0.018210, -0.038680, 
-0.042030, -0.013190, -0.023780, -0.033000, -0.013480, -0.045090, -0.031520, -0.012920, -0.032240, -0.032950, 
-0.020300, -0.022170, -0.040710, -0.007730, -0.043390, -0.037750, 0.016040, -0.049780, -0.012220, -0.003800, 
-0.035810, -0.018820, -0.013750, -0.020440, -0.022190, -0.003340, -0.038910, -0.023880, -0.011690, -0.042260, 
-0.012800, -0.006390, -0.040050, -0.017140, -0.034490, -0.029880, -0.024460, 0.011870, -0.057480, -0.023090, 
-0.005370, -0.048020, -0.005710, -0.010970, -0.049260, -0.035870, -0.011410, -0.020740, -0.003300, -0.013180, 
-0.068370, -0.000150, -0.028220, -0.050740, -0.005730, -0.004730, -0.049560, -0.008380, -0.036520, -0.040480, 
-0.036710, 0.016540, -0.055850, -0.011880, 0.000850, -0.054700, -0.018530, -0.011450, -0.059240, -0.041090, 
-0.016670, -0.046540, -0.006090, -0.011280, -0.064700, -0.011550, -0.020190, -0.044060, -0.024520, 0.010410, 
-0.048190, -0.013960, -0.028350, -0.043490, -0.065270, 0.016500, -0.032760, -0.036450, -0.007360, -0.069250, 
-0.032760, -0.020200, -0.060300, -0.059220, -0.023270, -0.039950, -0.016910, -0.032710, -0.077790, -0.026680, 
-0.051240, -0.051350, -0.043440, -0.003930, -0.039990, -0.033690, -0.024920, -0.044970, -0.105680, -0.003310, 
-0.011860, -0.072740, -0.028170, -0.022440, -0.091010, -0.012510, 0.004680, -0.088140, -0.040010, 0.030040, 
-0.041530, -0.038050, -0.014310, -0.067590, -0.055750, 0.022240, -0.096380, -0.031100, 0.017160, -0.061280, 
-0.040050, 0.006870, -0.157150, -0.033690, 0.051900, -0.135590, -0.020020, 0.050420, -0.053440, -0.021010, 
-0.059130, -0.058550, -0.019370, -0.028880, -0.021010, -0.042790, -0.055660, -0.020760, -0.048120, -0.040900, 
-0.035070, -0.033750, -0.038710, -0.025230, -0.039180, -0.031010, -0.083910, -0.025740, -0.021240, -0.070980, 
-0.023830, -0.015980, -0.024800, -0.024550, -0.042700, -0.046920, -0.027450, -0.023710, 0.004740, -0.033110, 
-0.035120, -0.006280, -0.028510, -0.034380, -0.016820, -0.020120, -0.027330, -0.022600, -0.030500, -0.017300, 
-0.063420, -0.014280, -0.044290, -0.048100, 0.006580, -0.043530, -0.031990, -0.009800, -0.049690, -0.052820, 
-0.019090, -0.027540, -0.003650, -0.035050, -0.033770, -0.017880, -0.025750, -0.040130, -0.010710, -0.017480, 
-0.026740, -0.007150, -0.047490, -0.018180, -0.042840, 0.008310, -0.054800, -0.052590, 0.001240, -0.049590, 
-0.017890, -0.033660, -0.043750, -0.042310, -0.040490, -0.005530, -0.021650, -0.018980, -0.034110, -0.022520, 
-0.009780, -0.037250, -0.023840, -0.009160, -0.019180, -0.014880, -0.032170, -0.004360, -0.043540, 0.001330, 
-0.034290, -0.054940, 0.015120, -0.033280, -0.018000, -0.018960, -0.040270, -0.035850, -0.038120, -0.016440, 
-0.036310, -0.007300, -0.015340, -0.015870, -0.018220, -0.023370, -0.028110, -0.006360, -0.027270, -0.035270, 
-0.021290, -0.004410, -0.048960, 0.006230, -0.034100, -0.058430, 0.004530, -0.024330, -0.031030, -0.020070, 
-0.034580, -0.023840, -0.041300, -0.013960, -0.048910, -0.012130, -0.019790, -0.030960, -0.012940, -0.036470, 
-0.027550, -0.012710, -0.048300, -0.028100, -0.020040, -0.023730, -0.038640, 0.001060, -0.029580, -0.062620, 
0.006290, -0.043900, 
0.037470, -0.089870, 0.016780, -0.004210, 0.059590, -0.046030, -0.057750, 0.064160, 0.058390, -0.091150, 
0.011320, 0.042270, -0.146470, 0.123380, 0.154830, -0.053690, -0.011080, 0.157640, -0.104010, 0.182900, 
0.034010, -0.034850, 0.170460, -0.047790, -0.050370, -0.089560, 0.040600, -0.134390, 0.020890, 0.010620, 
-0.117940, -0.038210, 0.094870, -0.017660, 0.024440, 0.000010, 0.030150, -0.069340, 0.091770, -0.042240, 
-0.116680, 0.164530, -0.022420, 0.188760, 0.051550, -0.147260, 0.244900, 0.042910, -0.049210, -0.067020, 
0.066170, -0.244430, 0.092960, 0.097200, 0.001930, 0.033930, 0.010250, 0.056270, 0.017220, -0.044310, 
0.121550, -0.076800, 0.094870, 0.027640, -0.180430, 0.154560, -0.047410, 0.282020, -0.059870, -0.130780, 
0.197460, 0.072490, -0.054040, -0.051720, 0.010830, -0.170160, 0.022420, 0.075530, 0.055640, -0.080190, 
0.076380, 0.118720, -0.037690, -0.082220, -0.006410, -0.080680, 0.090130, 0.032090, -0.128160, 0.120740, 
-0.104600, 0.262150, 0.061500, -0.028190, 0.068730, -0.043960, -0.083480, -0.087130, -0.058260, -0.197200, 
-0.038070, 0.068330, 0.031200, -0.039860, -0.069070, 0.101290, -0.072040, -0.254740, -0.045470, -0.086170, 
-0.020770, -0.042450, 0.022390, -0.075910, -0.148760, 0.059040, 0.206570, -0.111490, -0.148890, 0.072310, 
-0.181400, -0.281130, -0.119360, -0.286650, -0.281640, -0.034390, -0.026490, -0.115540, -0.267570, -0.013190, 
-0.427530, -0.009830, -0.211080, -0.093000, -0.055530, -0.108250, -0.101210, -0.193590, -0.080400, -0.457000, 
0.186000, -0.210940, -0.600100, 0.424840, -0.332610, -0.332760, 0.310800, -0.354810, -0.543120, 0.573230, 
-0.207480, -0.130520, 0.150230, -0.093120, -0.544320, 0.425950, -0.216120, -0.281910, 0.286030, -0.092690, 
-0.430060, 0.285930, -0.347660, -0.587940, 0.606680, -0.319000, -0.812530, 0.941250, -0.074490, -0.219950, 
-0.277040, -0.158880, -0.373780, -0.016620, -0.101500, -0.231190, -0.196870, 0.058600, -0.382300, -0.116310, 
-0.091940, -0.218830, -0.187360, 0.015590, -0.286400, -0.233560, -0.278540, -0.468200, 0.261720, -0.124070, 
-0.444860, 0.376510, -0.061480, -0.151770, -0.113440, -0.101860, -0.219340, 0.018820, 0.009410, -0.210090, 
-0.058560, 0.002110, -0.068600, -0.036850, -0.066070, -0.032900, -0.108870, 0.053290, -0.044140, -0.169270, 
-0.061220, 0.014640, -0.047770, -0.125460, 0.157190, 0.012820, -0.048320, -0.053240, -0.033980, -0.085940, 
-0.071290, 0.044260, -0.069000, -0.032600, 0.014060, 0.093770, -0.125520, -0.024460, -0.134110, 0.090540, 
0.071910, -0.021580, 0.022070, 0.012970, -0.165890, 0.385370, 0.011830, -0.169710, 0.317970, -0.024350, 
-0.051140, -0.135560, 0.060490, -0.167610, 0.034250, 0.004520, 0.002430, 0.102660, 0.011490, 0.087910, 
0.207840, -0.199110, -0.036830, 0.187310, 0.021340, -0.044910, 0.088570, 0.068940, -0.181750, 0.385970, 
-0.046230, -0.177800, 0.433550, -0.127310, 0.004290, -0.060860, 0.003230, 0.006130, -0.071710, 0.013360, 
0.004970, 0.166050, 0.072470, 0.049400, 0.182700, -0.075950, -0.043500, 0.239370, 0.033420, -0.152610, 
0.113340, 0.165850, -0.108490, 0.179150, 0.017850, -0.196190, 0.334030, -0.062810, 0.142510, -0.137790, 
-0.007540, 0.173530, -0.162460, -0.024630, -0.030160, 0.220340, 0.047420, 0.004550, 0.127330, -0.009500, 
0.058550, 0.143050, -0.092920, -0.010270, 0.084420, 0.084860, 0.206670, 0.097400, -0.093580, -0.069170, 
0.276700, -0.074300, 
0.103630, -0.253640, 0.006670, 0.076860, -0.248060, 0.033040, -0.122910, -0.007390, -0.104980, -0.125700, 
-0.076940, -0.128900, -0.121140, -0.022620, -0.025780, -0.114060, -0.158650, 0.027180, 0.169810, -0.054030, 
-0.121250, 0.171720, -0.120160, -0.085050, 0.092880, -0.222410, -0.058950, -0.003000, -0.170840, -0.022640, 
-0.192250, -0.044890, -0.012610, 0.022770, -0.012210, -0.158260, 0.004140, -0.082580, -0.058410, -0.088320, 
-0.199480, 0.065840, 0.246310, -0.152880, 0.012910, 0.140620, -0.117730, -0.049140, 0.073410, -0.183830, 
-0.052670, -0.164230, -0.094240, 0.096690, -0.006000, -0.035510, -0.077970, 0.086890, -0.112860, -0.106700, 
0.141410, -0.074620, -0.055040, -0.016720, -0.266000, 0.108670, 0.419610, -0.138220, -0.049050, 0.219870, 
-0.219760, -0.028720, 0.008920, -0.106230, -0.098360, -0.222630, -0.075160, 0.107550, 0.081370, -0.165210, 
-0.026060, 0.174340, -0.148820, -0.062650, 0.048490, -0.100980, 0.002130, 0.019640, -0.241070, 0.089780, 
0.239310, -0.142040, 0.001470, 0.317930, -0.365270, -0.152380, -0.112130, -0.062830, -0.192440, -0.290880, 
0.019710, 0.000830, -0.092410, -0.079520, -0.021710, 0.006470, -0.130690, -0.127580, -0.124020, -0.013310, 
-0.016060, -0.154270, -0.017370, -0.036130, -0.127670, -0.246370, 0.400050, 0.292480, -0.520610, -0.064190, 
-0.323370, -0.095790, -0.244240, -0.423700, -0.122520, -0.113590, -0.216240, -0.015320, -0.247380, -0.265820, 
-0.224280, 0.033440, -0.569890, 0.099760, 0.038680, -0.374070, 0.172980, -0.151630, -0.222350, -0.378550, 
0.254220, -0.176120, -0.598140, 0.374000, -0.672710, -0.057830, 0.312090, -0.668240, -0.219660, 0.521230, 
-0.502980, 0.047590, 0.305230, -0.547110, -0.086900, 0.462910, -0.797520, 0.041170, 0.567810, -0.594440, 
0.003090, 0.492210, -0.826630, -0.451240, 1.034420, -0.628830, -0.534540, 1.048540, -0.203720, 0.020550, 
-0.368180, -0.266460, -0.128570, -0.089150, -0.022670, -0.108100, -0.298160, 0.017610, -0.166640, -0.266640, 
-0.165850, -0.019010, -0.246470, -0.208580, -0.012230, -0.230030, -0.205710, -0.318640, 0.136410, 0.078220, 
-0.247260, 0.130480, -0.044160, -0.070230, -0.143860, -0.226110, -0.084260, 0.058490, 0.047030, -0.134900, 
-0.039490, 0.160950, -0.043770, -0.131500, -0.026460, -0.037270, 0.018900, 0.007740, 0.028770, -0.050530, 
0.093230, -0.113860, -0.038360, 0.074250, 0.045750, -0.038210, 0.029340, -0.111590, -0.125470, -0.120050, 
-0.049570, 0.006400, -0.065370, -0.010750, 0.057150, 0.102770, -0.130940, -0.047060, -0.136820, 0.061500, 
0.164830, -0.033640, -0.014900, 0.045550, 0.189180, 0.070510, -0.038370, 0.146860, -0.116810, 0.058060, 
0.079880, -0.244740, 0.029450, -0.092150, -0.111130, 0.087970, 0.059800, 0.055320, 0.054130, 0.178530, 
0.036080, -0.061900, -0.012340, 0.055450, 0.175560, 0.095690, -0.111430, 0.156770, 0.079180, 0.081130, 
0.032980, 0.171630, 0.070590, -0.035240, 0.044790, -0.162270, 0.048130, 0.040980, -0.183780, 0.051030, 
-0.036410, 0.088380, 0.159990, 0.179170, -0.082010, 0.055160, -0.048870, 0.148050, 0.095240, -0.074310, 
-0.092030, 0.237250, 0.133110, 0.007140, 0.040110, 0.000340, 0.107070, 0.018810, 0.061850, -0.213760, 
0.101800, 0.137970, -0.294850, 0.076910, -0.280650, 0.155480, 0.230210, -0.121920, -0.013520, 0.136260, 
-0.141390, 0.082970, 0.067950, -0.141960, -0.048950, 0.189990, 0.255900, -0.058980, 0.014380, 0.002940, 
0.165750, -0.054360, 
-0.048900, 0.087220, -0.023090, 0.005900, -0.013330, 0.002790, -0.019830, -0.076070, 0.060480, -0.011950, 
0.040820, -0.035630, -0.032450, 0.046300, -0.009600, -0.016620, 0.009980, -0.018050, 0.123140, -0.014530, 
-0.075710, 0.095100, -0.033320, 0.008930, -0.060510, -0.017030, 0.056700, 0.008200, -0.054280, 0.020060, 
0.086580, -0.078150, 0.005980, 0.016630, -0.064400, 0.001820, -0.063360, 0.036620, 0.095420, 0.084190, 
-0.100610, 0.027340, -0.003360, -0.163780, 0.119400, 0.075340, -0.137180, 0.056860, -0.059290, 0.008740, 
-0.000600, -0.057130, -0.032480, 0.041580, 0.028300, -0.105160, 0.057530, -0.018780, -0.074950, 0.020020, 
-0.126940, 0.037860, 0.037630, 0.022800, -0.149370, 0.023990, -0.170150, -0.119890, 0.137760, -0.049610, 
-0.113270, 0.021910, -0.046170, -0.046570, 0.015800, -0.057860, -0.111330, 0.089160, -0.039770, -0.129330, 
0.066770, -0.126090, -0.014560, -0.019290, -0.068800, -0.003720, 0.015420, 0.003840, -0.206040, 0.044770, 
-0.143190, -0.031170, -0.074650, -0.121090, -0.021300, 0.017690, -0.019280, -0.091730, 0.043600, -0.062790, 
-0.090220, 0.089410, -0.002960, -0.156650, 0.038960, -0.165110, 0.017410, -0.026830, -0.004800, 0.003300, 
-0.057010, 0.027830, -0.212950, 0.040460, -0.200280, 0.145900, -0.151360, -0.116310, 0.166280, -0.053430, 
0.011720, 0.006370, -0.030200, -0.044250, 0.059970, 0.012390, 0.008780, -0.015660, -0.040490, -0.066110, 
0.143740, -0.138000, 0.025520, 0.153980, -0.137490, 0.040600, -0.139210, -0.000260, -0.073940, 0.325520, 
-0.306440, -0.038640, 0.387950, -0.367090, -0.004510, 0.111920, -0.276060, -0.065200, 0.166980, -0.260750, 
0.042540, 0.001050, -0.290360, -0.066830, 0.117280, -0.310450, -0.037350, 0.221280, -0.342150, -0.056990, 
-0.009970, -0.228260, 0.029490, 0.430470, -0.658670, 0.031250, 0.462970, -0.708990, -0.015050, -0.000700, 
-0.041080, -0.097090, 0.075010, -0.057180, -0.000660, 0.066130, -0.109960, -0.149490, 0.001710, -0.019390, 
-0.073580, 0.090280, -0.059180, -0.075780, -0.126450, 0.044450, -0.113190, 0.259850, -0.225830, -0.047730, 
0.230020, -0.331250, 0.040850, -0.098390, 0.009000, -0.037630, -0.031300, 0.005510, 0.052130, 0.071170, 
-0.085700, -0.111270, 0.018220, 0.008070, 0.055200, 0.010200, -0.051390, 0.002280, -0.171680, 0.067630, 
-0.184130, 0.124010, 0.056550, -0.074770, 0.006670, -0.055670, 0.054340, -0.130080, 0.008830, -0.007290, 
-0.050540, 0.001320, 0.096920, 0.009140, -0.070050, 0.025860, 0.026970, -0.025220, 0.107700, -0.015930, 
-0.085650, 0.048030, -0.112130, -0.004500, -0.136010, 0.017280, -0.018400, 0.042790, -0.035810, -0.048860, 
0.060870, -0.116960, 0.015350, 0.071930, -0.128120, 0.019370, 0.143450, -0.071430, -0.065730, 0.023350, 
0.086320, -0.051050, 0.079870, -0.017940, -0.081310, 0.109170, -0.063240, -0.020610, 0.075110, -0.055550, 
0.007470, 0.091570, -0.074290, -0.008690, 0.047620, -0.082110, 0.070970, 0.022200, -0.043480, 0.054780, 
0.141670, -0.096530, -0.064380, 0.078820, -0.001450, -0.016530, 0.115360, -0.123230, 0.024890, 0.067290, 
-0.048190, -0.029950, 0.033890, -0.049400, 0.097290, 0.154550, -0.080240, -0.020490, 0.001510, 0.029020, 
0.007990, -0.016640, 0.080810, -0.018950, 0.129710, -0.051600, -0.044150, 0.104410, -0.029780, -0.059820, 
0.001520, 0.026890, 0.017340, 0.003510, 0.010900, -0.008040, 0.062120, 0.006260, 0.041210, 0.037830, 
0.003970, -0.019380, 
-0.111810, -0.055730, -0.047880, -0.198920, -0.037290, -0.027710, -0.030840, -0.051970, -0.057050, -0.076200, 
-0.023990, 0.117820, -0.080940, -0.043080, 0.037220, -0.042980, -0.035790, -0.039900, -0.056650, 0.043030, 
-0.070760, -0.219640, -0.040750, 0.148330, -0.027730, -0.112460, -0.113660, -0.146730, -0.065490, -0.071650, 
0.009250, -0.043840, -0.127650, -0.080580, 0.041420, -0.045760, 0.024710, -0.091230, -0.057970, -0.006040, 
-0.033210, -0.157000, -0.024040, -0.041690, -0.044300, -0.211110, -0.038220, 0.109150, 0.002050, -0.152950, 
-0.134250, -0.045660, -0.081430, -0.162510, -0.014100, -0.084260, -0.141380, -0.032180, -0.015840, -0.189760, 
0.052700, -0.227440, -0.082190, -0.044980, 0.001690, -0.149870, -0.031810, -0.116210, -0.041990, -0.181040, 
-0.038930, 0.033840, 0.033350, -0.165840, -0.169040, -0.027150, -0.123290, -0.177410, 0.064090, -0.178780, 
-0.170540, 0.043540, -0.086390, -0.211020, 0.120010, -0.277780, -0.081930, 0.037490, -0.004710, -0.237140, 
0.323620, -0.304270, -0.300610, -0.074960, -0.190410, -0.012440, 0.003650, -0.063950, -0.130720, -0.061510, 
-0.143580, -0.107050, -0.060270, -0.188370, -0.058130, -0.034180, -0.075530, -0.054570, 0.074330, -0.334920, 
-0.014300, -0.035510, -0.043620, -0.093210, 0.368260, -0.298270, -0.200760, -0.101640, -0.258900, 0.126650, 
-0.054800, 0.039470, -0.138560, -0.060850, -0.115580, -0.054430, -0.154890, -0.049010, -0.005030, -0.158810, 
0.026780, 0.104020, -0.021250, -0.127460, -0.031460, -0.224690, 0.087930, 0.016160, 0.235410, -0.102610, 
-0.134460, -0.097220, -0.171040, 0.097100, 0.217600, 0.056070, -0.522260, 0.147800, -0.077170, -0.354630, 
0.154950, 0.047020, -0.423930, 0.221150, 0.163880, -0.405770, 0.438490, 0.000140, -0.575380, 0.043470, 
0.218820, -0.420900, 0.765360, 0.105950, -0.907980, 0.357470, -0.018270, -0.454760, -0.096220, 0.085610, 
-0.220850, -0.000490, -0.041820, -0.217670, -0.074780, 0.131060, -0.284320, -0.110740, 0.209350, -0.197610, 
0.098910, 0.060750, -0.343980, -0.146230, 0.272650, -0.274680, 0.296570, 0.106810, -0.490290, 0.060780, 
0.070500, -0.255700, -0.117610, 0.056150, -0.193250, 0.025550, -0.074660, -0.193630, -0.082010, 0.211390, 
-0.376160, 0.015950, 0.166040, -0.271660, -0.004470, 0.079050, -0.383340, -0.070250, 0.321660, -0.376800, 
0.417110, -0.014520, -0.470200, 0.170100, 0.051500, -0.237800, -0.054570, -0.015140, -0.146230, 0.017250, 
-0.062470, -0.140780, -0.019270, 0.160970, -0.352470, 0.026430, 0.144630, -0.217350, 0.085350, 0.040520, 
-0.318050, -0.055230, 0.221170, -0.291640, 0.415870, -0.086320, -0.392640, 0.315980, -0.156240, -0.176760, 
0.007030, -0.077400, -0.068310, 0.036120, -0.102570, -0.106000, 0.092400, 0.011880, -0.308580, 0.092720, 
-0.011940, -0.168260, 0.095180, -0.088190, -0.189540, -0.026890, 0.132250, -0.216720, 0.348090, -0.165450, 
-0.184900, 0.269470, -0.248570, -0.054610, 0.042550, -0.109100, -0.072850, 0.069080, -0.103040, -0.097430, 
0.000720, -0.068850, -0.211750, -0.018080, -0.128910, -0.044550, -0.026860, -0.131590, -0.099870, 0.039260, 
0.060770, -0.218290, 0.274800, -0.239690, -0.056730, 0.261060, -0.289010, 0.004910, 0.081510, -0.088490, 
-0.138800, 0.091580, -0.102700, -0.113080, 0.024220, -0.050580, -0.158720, 0.101070, -0.251950, -0.002470, 
-0.033560, -0.088210, -0.051030, -0.042180, 0.088480, -0.165890, 0.208870, -0.196420, -0.005700, 0.293360, 
-0.401820, 0.017810, 
-0.181820, 0.165930, 0.081060, -0.143250, 0.058030, 0.097030, -0.039260, -0.125460, 0.113990, -0.133630, 
0.036560, -0.082870, 0.018300, -0.022920, -0.058570, -0.041240, -0.040860, -0.031210, -0.151020, 0.047240, 
0.026180, -0.083920, 0.189920, -0.025280, -0.075250, 0.078250, 0.054330, -0.005530, 0.029700, 0.013830, 
0.082400, -0.093940, 0.040650, -0.079840, 0.016080, -0.032900, -0.053460, 0.077750, 0.039920, 0.001530, 
-0.063700, 0.014630, -0.251150, 0.008770, 0.081080, -0.020390, 0.083090, -0.060400, -0.001460, 0.021500, 
-0.015330, 0.022080, -0.016740, -0.001240, 0.071000, -0.117550, 0.041980, -0.061850, 0.011050, 0.021230, 
-0.075510, 0.085490, -0.013250, -0.006310, -0.101990, -0.015850, -0.288600, 0.076690, 0.075550, -0.024110, 
0.116210, -0.100320, 0.067510, -0.006580, -0.049510, -0.014200, -0.006780, -0.005460, 0.016060, -0.021310, 
-0.063750, -0.110780, 0.048500, -0.034790, -0.004300, 0.131250, -0.080770, 0.014070, -0.147480, -0.017900, 
-0.229140, 0.122410, -0.146370, -0.154740, 0.193750, -0.129680, 0.115360, -0.079410, -0.043350, -0.005000, 
0.008690, -0.000360, 0.040380, -0.086300, -0.026320, -0.094510, 0.004590, -0.016610, 0.046000, 0.116420, 
-0.116200, 0.085870, -0.231710, 0.016660, -0.357090, 0.249110, -0.175950, -0.149290, 0.349910, -0.257260, 
0.092820, 0.039670, -0.046060, -0.056160, 0.213320, 0.001080, 0.093660, -0.073220, 0.008630, 0.005720, 
0.024020, -0.107170, 0.132090, 0.116050, -0.125110, 0.117120, -0.190170, 0.053190, -0.360790, 0.458800, 
-0.215460, -0.197570, 0.676510, -0.480750, -0.060370, 0.126300, -0.120290, -0.138910, 0.307440, -0.190620, 
0.087230, -0.121650, -0.088480, -0.063010, 0.022000, -0.158750, 0.006800, 0.098880, -0.104820, 0.033480, 
-0.105300, -0.028460, -0.303550, 0.505900, -0.312340, -0.296750, 0.797270, -0.652740, -0.021960, -0.013060, 
0.071820, -0.125980, 0.154260, 0.016630, 0.077590, -0.005160, 0.014090, -0.068640, -0.094290, 0.045580, 
0.016330, -0.011580, 0.108550, 0.003380, -0.205190, 0.179660, -0.283640, 0.372440, -0.055010, -0.244570, 
0.480330, -0.387580, 0.030190, -0.067120, 0.030630, -0.118510, 0.040530, 0.007020, 0.122820, 0.055970, 
-0.060860, -0.072460, 0.037910, -0.016900, 0.103500, -0.021670, 0.005800, 0.056970, -0.229160, 0.146770, 
-0.305010, 0.172280, 0.050450, -0.168460, 0.144390, -0.270870, 0.049240, -0.098930, -0.017560, -0.061970, 
-0.019170, -0.026510, 0.138000, -0.010860, -0.071800, -0.021380, 0.125170, -0.076960, 0.116550, -0.018680, 
-0.064410, 0.122620, -0.176820, 0.026850, -0.292280, 0.044260, 0.001810, -0.081660, 0.063730, -0.179730, 
0.074060, -0.057620, -0.019670, 0.049190, -0.125890, 0.027690, 0.148300, -0.028890, -0.135370, -0.055450, 
0.169670, -0.085160, 0.115870, -0.008340, -0.107280, 0.175280, -0.123880, -0.066860, -0.061460, 0.009260, 
-0.047020, -0.033380, 0.095500, -0.086360, 0.004760, -0.044820, 0.105900, -0.000080, -0.050020, 0.093700, 
0.079080, -0.018060, -0.073770, 0.021470, 0.083930, -0.072130, 0.056810, -0.065140, 0.036780, 0.084370, 
-0.105040, -0.038800, -0.120930, 0.078920, 0.062890, -0.030930, 0.110140, -0.061100, -0.139030, 0.100600, 
0.141990, -0.131580, 0.122390, 0.092920, 0.027670, -0.020470, -0.025350, -0.005810, 0.107780, -0.068000, 
-0.037370, 0.026950, 0.023070, 0.030260, -0.029390, 0.008940, -0.247490, 0.133820, 0.171160, -0.177380, 
0.181140, -0.024070, 
-0.052630, 0.029160, 0.008030, -0.024760, -0.030900, 0.019580, -0.039250, -0.070550, 0.049080, -0.060350, 
-0.029790, 0.000550, -0.026890, -0.020720, 0.019260, -0.041800, -0.028890, 0.008190, -0.061640, -0.003280, 
-0.019370, -0.033580, 0.033360, -0.005550, -0.010510, 0.017430, -0.028700, 0.011400, -0.005620, -0.031920, 
0.008570, -0.025600, -0.004470, -0.023330, 0.017400, -0.049430, -0.039240, 0.043400, 0.006860, -0.010600, 
-0.021460, -0.027560, -0.093290, -0.008870, 0.003790, -0.044350, 0.036130, -0.048980, 0.008020, 0.039500, 
-0.096370, -0.008130, 0.020230, -0.048770, 0.022390, -0.022800, -0.023990, -0.021650, 0.020470, -0.045330, 
-0.047680, 0.083110, -0.046760, -0.012620, -0.002860, -0.055250, -0.096320, 0.028950, -0.016450, -0.048610, 
0.029230, -0.058520, 0.014510, 0.030990, -0.098060, -0.033000, 0.032710, -0.044940, -0.017470, -0.003310, 
-0.058050, -0.053370, 0.037380, -0.077030, -0.026390, 0.080380, -0.094940, -0.026120, -0.009250, -0.056420, 
-0.088600, 0.063090, -0.117820, -0.092980, 0.059050, -0.066210, 0.027260, 0.018260, -0.095710, -0.019680, 
0.038110, -0.060740, -0.014620, -0.007990, -0.042070, -0.065000, 0.024570, -0.065940, -0.020570, 0.089350, 
-0.086820, -0.004450, -0.037330, -0.031980, -0.133580, 0.085220, -0.102860, -0.069660, 0.101910, -0.096420, 
0.023690, 0.062920, -0.090050, -0.029000, 0.109090, -0.062210, 0.009920, -0.000460, -0.048690, -0.035250, 
0.050260, -0.076460, 0.025160, 0.071420, -0.097140, 0.014650, -0.028250, -0.013850, -0.111390, 0.131350, 
-0.125530, -0.059460, 0.164060, -0.184700, -0.042860, 0.093340, -0.140030, -0.049740, 0.141740, -0.140460, 
0.015040, -0.033600, -0.102010, -0.071470, 0.067830, -0.139830, -0.034610, 0.077890, -0.118850, -0.044510, 
0.010710, -0.074650, -0.118880, 0.166900, -0.206810, -0.094380, 0.197240, -0.259850, -0.044070, 0.031500, 
-0.012760, -0.072380, 0.072970, -0.018510, 0.026190, -0.011070, -0.041630, -0.023740, -0.011360, -0.016690, 
-0.035350, 0.030190, 0.006220, -0.030020, -0.072510, 0.052440, -0.092000, 0.114920, -0.078110, -0.086110, 
0.106410, -0.148340, -0.032120, -0.020450, 0.008720, -0.084410, 0.006730, 0.001660, 0.040960, -0.017050, 
-0.031440, -0.035770, -0.022450, -0.019050, -0.011410, -0.021520, 0.008760, -0.011520, -0.095150, 0.055930, 
-0.098070, 0.049860, -0.026720, -0.081980, 0.014940, -0.049080, -0.041360, -0.027440, -0.012560, -0.068440, 
-0.017760, -0.022560, 0.014620, -0.037040, -0.034430, -0.040660, 0.004810, -0.037630, -0.014250, -0.020000, 
-0.034940, -0.011270, -0.073480, 0.007790, -0.100540, 0.011500, -0.044250, -0.045640, -0.013970, -0.041260, 
-0.027350, -0.053150, -0.022490, -0.048540, -0.061450, 0.000480, -0.018380, -0.030540, -0.036860, -0.075790, 
0.028500, -0.022000, -0.032010, -0.014550, -0.029750, -0.017160, -0.050450, -0.002750, -0.038430, -0.024840, 
-0.032540, -0.055980, -0.038340, 0.006070, -0.040610, -0.038190, 0.018790, -0.070160, -0.048490, 0.023670, 
-0.037580, -0.039390, -0.014930, -0.057960, -0.003070, -0.010910, -0.036940, -0.049470, 0.017010, -0.047980, 
-0.050440, -0.001730, -0.057040, -0.031140, 0.001170, -0.036150, -0.049430, 0.011550, -0.069020, 0.015650, 
-0.002770, -0.079380, -0.001200, -0.003350, -0.045670, -0.013990, -0.019900, -0.054020, 0.013340, -0.053460, 
-0.081600, 0.016560, -0.008990, -0.050710, -0.007030, -0.008140, -0.064970, -0.004440, -0.007750, -0.087340, 
-0.006210, -0.028740, 
0.004770, -0.045530, -0.095750, -0.028740, -0.030900, -0.069260, -0.001000, -0.005900, -0.094110, 0.022350, 
-0.058160, 0.000820, -0.013180, -0.039970, -0.051500, -0.000860, -0.026110, -0.037210, 0.045650, 0.006080, 
-0.060160, 0.002060, -0.093560, 0.009010, -0.001990, -0.038480, -0.076870, -0.032790, -0.046010, -0.041260, 
-0.023890, -0.003210, -0.049630, -0.015220, -0.034070, 0.006950, -0.000660, -0.058590, -0.050770, 0.006460, 
-0.013080, -0.050220, 0.066470, -0.027830, -0.057230, -0.006400, -0.095760, 0.034480, -0.014540, -0.034320, 
-0.063460, -0.017360, -0.035290, -0.067370, -0.027090, -0.012640, -0.038150, -0.035310, -0.007630, -0.018970, 
-0.013290, -0.057090, -0.031140, -0.005240, 0.013200, -0.036610, 0.067020, -0.048890, -0.049660, 0.000380, 
-0.081030, 0.025170, -0.021590, -0.031360, -0.078330, 0.016710, -0.052240, -0.080150, -0.045350, -0.006430, 
-0.033590, -0.021260, -0.009760, -0.042280, -0.041550, -0.046960, -0.037390, -0.028680, 0.029720, -0.069870, 
0.041870, -0.071810, -0.022900, 0.032710, -0.108290, 0.018150, -0.035000, -0.011860, -0.081040, -0.011430, 
-0.064190, -0.090540, -0.036030, 0.002140, -0.062350, 0.018530, -0.015460, -0.055770, -0.037900, -0.056010, 
-0.056770, -0.041270, 0.015550, -0.066280, 0.101510, -0.111610, -0.045010, 0.021650, -0.140850, 0.018270, 
-0.020680, -0.061500, -0.082880, 0.008190, -0.127880, -0.073050, -0.063970, 0.000740, -0.063340, 0.014480, 
-0.049760, -0.027780, -0.022010, -0.041080, -0.064510, -0.036250, -0.018410, -0.053600, 0.120150, -0.154960, 
-0.039990, 0.060500, -0.223400, 0.065810, 0.063750, -0.073850, -0.108130, 0.078310, -0.147140, -0.067520, 
-0.032170, 0.008200, -0.039000, 0.060360, -0.059370, -0.027940, 0.059230, -0.055260, -0.075950, 0.037810, 
-0.050740, -0.035370, 0.175860, -0.149170, -0.025170, 0.154300, -0.249130, 0.076080, 0.019110, -0.071800, 
-0.077460, 0.040280, -0.123500, -0.063160, -0.072280, -0.007280, -0.015570, 0.005830, -0.053760, -0.018320, 
-0.030730, -0.026030, -0.080790, -0.008650, -0.027400, -0.069280, 0.089620, -0.125000, -0.013040, 0.070030, 
-0.171190, 0.061710, 0.010170, -0.059450, -0.075360, 0.046760, -0.100050, -0.067360, -0.086520, -0.024960, 
-0.018630, -0.034770, -0.046730, -0.016150, -0.064940, -0.036010, -0.040910, -0.024930, -0.020100, -0.076810, 
0.075310, -0.089790, -0.029810, 0.059130, -0.095240, 0.042160, -0.013970, -0.026320, -0.030210, 0.027530, 
-0.043360, -0.039430, -0.077910, -0.015700, -0.005990, -0.047970, -0.036130, 0.021610, -0.076580, -0.007480, 
-0.009370, -0.055130, 0.025470, -0.021520, 0.021470, -0.029100, 0.007990, 0.022250, -0.042000, 0.038330, 
-0.016450, -0.014950, -0.015790, -0.007740, 0.018980, -0.051950, -0.070300, 0.003190, 0.024920, -0.023530, 
-0.044830, 0.023870, -0.069210, -0.000400, 0.018330, -0.086250, 0.043000, -0.005250, -0.017830, 0.011600, 
0.005630, -0.011690, -0.030020, 0.012850, -0.017260, -0.000800, -0.024880, 0.016390, -0.000140, -0.031430, 
-0.049570, 0.002190, 0.027330, -0.043140, -0.040890, 0.026970, -0.042320, -0.010920, 0.004770, -0.046370, 
0.011530, 0.008090, -0.012640, -0.001120, 0.006040, -0.033300, -0.024500, 0.028390, 0.026260, -0.035530, 
-0.020520, 0.016780, -0.047540, -0.014890, -0.025560, 0.007590, 0.009200, -0.011210, -0.045810, 0.036720, 
-0.033690, -0.034440, 0.041930, -0.027600, -0.014370, 0.025190, 0.027560, -0.018190, -0.020050, 0.009980, 
-0.044660, 0.029020, 
0.013530, -0.009030, -0.214240, -0.160630, 0.032090, -0.163520, 0.063700, -0.017690, -0.218780, 0.113450, 
0.015090, -0.099810, 0.084820, -0.131410, -0.163860, 0.082870, 0.014300, -0.149920, 0.321800, -0.039010, 
-0.334480, 0.058360, -0.235930, -0.032570, -0.001660, -0.027540, -0.157920, -0.165170, 0.009990, -0.133600, 
0.028880, -0.073760, -0.193610, -0.011670, -0.027300, -0.088640, 0.153270, -0.221350, -0.170550, 0.085690, 
-0.002940, -0.162360, 0.412430, -0.178440, -0.283360, 0.161960, -0.367910, -0.009390, -0.035110, -0.024160, 
-0.151050, -0.081950, -0.032850, -0.174050, 0.016880, -0.046910, -0.211850, -0.105410, 0.059400, -0.136550, 
0.141860, -0.204880, -0.162860, 0.021550, 0.087310, -0.205510, 0.397160, -0.316620, -0.262710, 0.148180, 
-0.390650, -0.051500, -0.098670, 0.021850, -0.187890, -0.028280, -0.076190, -0.207510, -0.012780, 0.009960, 
-0.215010, -0.083580, 0.081360, -0.169060, 0.078620, -0.129570, -0.177760, -0.065550, 0.139470, -0.209100, 
0.332330, -0.242320, -0.261160, 0.137580, -0.314750, -0.116070, -0.176470, 0.113920, -0.241270, -0.039770, 
-0.091180, -0.215630, -0.107920, 0.149440, -0.244340, -0.149460, 0.173020, -0.139600, -0.031540, 0.015390, 
-0.223660, -0.221000, 0.255140, -0.188720, 0.325640, -0.076420, -0.343720, 0.050850, -0.189720, -0.053730, 
-0.104550, 0.094120, -0.263170, 0.073670, -0.163370, -0.216000, -0.151380, 0.240610, -0.238490, -0.082270, 
0.195670, -0.138940, -0.052900, 0.133050, -0.290430, -0.186910, 0.282480, -0.196480, 0.316020, 0.083500, 
-0.368850, 0.142360, -0.118290, -0.165980, 0.104210, 0.021670, -0.402450, 0.182940, -0.129330, -0.382020, 
-0.030080, 0.259320, -0.330610, 0.025460, 0.259270, -0.315220, 0.138900, 0.140240, -0.457210, -0.022440, 
0.242080, -0.366260, 0.386020, 0.104640, -0.510640, 0.358840, -0.062420, -0.385260, 0.039180, -0.075560, 
-0.160870, 0.032150, -0.166960, -0.133300, -0.105100, 0.140680, -0.109950, -0.039300, 0.098580, -0.098990, 
-0.014320, 0.043220, -0.186270, -0.001740, 0.111700, -0.149560, 0.267050, -0.058060, -0.159620, 0.244180, 
-0.127800, -0.047530, 0.014510, -0.163210, -0.081750, 0.042470, -0.185720, -0.081990, -0.114140, -0.014250, 
-0.059750, -0.071500, -0.075590, 0.025230, -0.113890, -0.086510, -0.057870, -0.037980, 0.006320, -0.091460, 
0.061800, -0.206650, 0.121960, 0.136150, -0.236950, 0.167940, 0.095090, -0.189050, -0.047290, 0.125200, 
-0.164110, -0.094550, -0.056720, -0.019160, -0.046480, -0.079980, -0.104150, 0.093220, -0.129300, -0.066750, 
0.026080, -0.059630, 0.018330, -0.058730, -0.041240, -0.187720, 0.222340, 0.070520, -0.178580, 0.115140, 
0.109630, -0.092080, -0.089410, 0.149810, -0.034080, -0.172330, -0.083820, -0.011540, 0.017680, -0.080240, 
-0.194530, 0.147220, -0.125390, -0.051520, 0.028920, -0.115890, 0.069730, -0.053600, -0.037570, -0.070090, 
0.143140, -0.091160, -0.080660, 0.072990, 0.119040, -0.050620, -0.095930, 0.118130, 0.000670, -0.107840, 
-0.067850, -0.038490, 0.051340, -0.091060, -0.190950, 0.149080, -0.149510, -0.067980, 0.083140, -0.077910, 
0.033210, -0.020930, -0.095990, 0.013760, 0.070550, -0.177160, -0.008420, 0.079490, 0.093160, -0.095200, 
0.014960, 0.074850, -0.068030, 0.042960, 0.069680, -0.108630, 0.001140, 0.081370, -0.240890, 0.133300, 
-0.051820, -0.078350, 0.117320, 0.005350, -0.014170, 0.030690, -0.021570, 0.044170, 0.013540, -0.077350, 
-0.086990, 0.185670, 
0.078780, 0.169160, -0.220580, 0.096550, 0.051080, -0.143260, -0.052370, 0.089580, -0.085350, -0.001510, 
0.207650, -0.087920, -0.073200, 0.210120, -0.108570, 0.004930, 0.168770, -0.051190, 0.153600, 0.108720, 
-0.139870, 0.006520, 0.021300, 0.095520, 0.096930, 0.061550, -0.113050, 0.051820, 0.038640, -0.109090, 
0.075680, 0.072510, -0.095320, 0.001040, 0.094740, -0.046710, -0.110820, 0.160550, 0.018240, 0.126020, 
0.031690, -0.046530, 0.115740, -0.085170, 0.073070, 0.021550, -0.026390, 0.001070, 0.093780, 0.053700, 
-0.182470, 0.048810, 0.020170, -0.129510, 0.005490, -0.005310, -0.012370, 0.013140, 0.053100, -0.075050, 
-0.154980, 0.051220, 0.055450, 0.038190, -0.042450, -0.004630, -0.040500, -0.091950, 0.059140, -0.049990, 
-0.054340, -0.079820, 0.052280, -0.023080, -0.084210, 0.045010, -0.100110, -0.044720, -0.047510, -0.130930, 
0.088200, -0.088270, 0.075870, -0.104450, -0.048550, -0.060960, 0.065020, 0.031230, -0.135540, 0.036640, 
0.002710, -0.111120, -0.099040, -0.133860, -0.007430, -0.013210, -0.012910, -0.099490, 0.044450, -0.008020, 
-0.147300, 0.047990, -0.053640, -0.172140, 0.133940, -0.231190, 0.081940, -0.049660, -0.018570, -0.114860, 
0.067950, 0.029480, -0.241540, 0.090250, 0.011050, 0.005390, -0.140190, -0.097190, 0.046860, 0.096090, 
0.015390, -0.045340, 0.006300, 0.004950, -0.048750, 0.067580, -0.170090, -0.062190, 0.191920, -0.210770, 
0.196550, -0.056460, -0.107330, 0.059100, 0.068420, -0.038180, -0.159330, 0.159800, 0.125920, 0.318830, 
-0.338920, 0.103130, 0.212280, -0.237310, 0.156070, 0.027760, -0.403780, 0.112470, 0.076600, -0.372010, 
0.072620, -0.030080, -0.335590, 0.009240, 0.250250, -0.473390, 0.128550, 0.181830, -0.466360, -0.010800, 
-0.021190, -0.264520, 0.473320, 0.584770, -1.067660, 0.435800, 0.402230, -0.935670, 0.016230, -0.048680, 
-0.064280, 0.021980, -0.044050, -0.088720, 0.004670, 0.089950, -0.157670, -0.027030, 0.033020, -0.160840, 
0.047930, 0.043460, -0.192380, -0.019340, -0.123500, -0.033870, 0.244610, 0.351200, -0.583230, 0.404310, 
0.120060, -0.545440, -0.003730, -0.187370, 0.107530, 0.045070, -0.119120, 0.031600, -0.060630, 0.195070, 
-0.101840, -0.146170, 0.084680, -0.026560, 0.020240, 0.077770, -0.110820, -0.028190, -0.058780, 0.004960, 
0.043550, 0.131810, 0.011060, 0.151670, -0.138840, 0.035410, 0.013970, -0.224090, 0.172550, 0.046870, 
-0.087370, 0.034520, -0.053660, 0.199890, -0.083820, -0.057620, 0.134350, -0.007420, 0.030320, 0.081480, 
-0.083550, -0.037290, 0.053300, -0.040550, 0.008820, 0.001160, 0.056560, 0.117890, -0.102600, 0.146000, 
0.002550, -0.135350, 0.148440, 0.084530, -0.096580, 0.031400, 0.024690, 0.025630, -0.010450, -0.101900, 
0.157880, 0.039350, -0.038280, 0.031360, -0.012510, 0.014210, 0.113250, -0.021930, 0.120210, -0.022410, 
0.094270, 0.087640, -0.064390, 0.094170, 0.003600, -0.092460, 0.108390, 0.022180, 0.001080, 0.031270, 
-0.015870, -0.036840, 0.027850, -0.119680, 0.075690, 0.109580, -0.108530, -0.057060, 0.182230, -0.102630, 
0.120320, -0.015960, -0.005650, 0.041370, 0.104010, 0.037330, 0.059700, 0.070940, -0.034070, 0.019870, 
0.059040, -0.077230, 0.159240, -0.029260, -0.040730, 0.018880, 0.088870, 0.022420, -0.033120, 0.065760, 
-0.166770, 0.065320, 0.173530, -0.201730, 0.150120, 0.081340, -0.016140, 0.046090, 0.132810, -0.057560, 
0.055660, 0.093170, 
-0.178380, 0.132470, 0.021710, -0.131660, 0.016480, 0.051110, -0.033770, -0.145780, 0.041180, -0.126520, 
-0.007710, -0.121940, -0.013990, -0.002570, -0.064030, -0.069400, -0.037460, -0.064170, -0.154700, 0.008670, 
0.020740, -0.115170, 0.131340, -0.028480, -0.059300, 0.050720, 0.016010, -0.030890, -0.006170, -0.016850, 
0.107070, -0.126040, -0.034320, -0.064030, 0.020020, -0.095180, -0.021800, 0.075130, -0.025980, 0.016140, 
-0.063570, -0.056320, -0.207650, -0.039630, 0.104650, -0.065850, 0.072370, -0.056440, 0.001570, 0.047140, 
-0.100050, -0.009470, 0.000840, -0.042540, 0.072520, -0.115940, -0.034530, -0.021550, 0.011670, -0.059620, 
-0.070860, 0.125560, -0.070530, 0.005880, -0.084730, -0.063120, -0.219510, 0.017540, 0.090800, -0.020030, 
0.026630, -0.089390, 0.074950, 0.018360, -0.143140, -0.006790, 0.031440, -0.067420, 0.010380, -0.075950, 
-0.060030, -0.081940, 0.061740, -0.098990, -0.029840, 0.161940, -0.120900, 0.036930, -0.158450, -0.057080, 
-0.161800, 0.049180, -0.146550, -0.113130, 0.107080, -0.106110, 0.129270, -0.042340, -0.111740, 0.020730, 
0.002530, -0.043020, 0.059040, -0.138710, 0.002490, -0.070520, 0.011800, -0.051670, 0.027690, 0.099980, 
-0.081480, 0.102040, -0.253330, 0.011430, -0.250050, 0.107780, -0.131430, -0.102200, 0.217050, -0.141770, 
0.110810, 0.049440, -0.097250, -0.013280, 0.192230, -0.054200, 0.098120, -0.120540, 0.020850, -0.017470, 
0.011960, -0.101320, 0.132080, 0.085720, -0.099590, 0.148880, -0.235390, 0.030660, -0.256560, 0.272770, 
-0.137870, -0.087600, 0.424630, -0.345300, 0.004230, 0.144410, -0.240710, -0.077680, 0.315340, -0.289500, 
0.152620, -0.143200, -0.182570, -0.012950, 0.079190, -0.309620, 0.094150, 0.116140, -0.262020, 0.098330, 
-0.109270, -0.157600, -0.102290, 0.401730, -0.465870, -0.112310, 0.568910, -0.674530, -0.009710, 0.069170, 
-0.036710, -0.104640, 0.198850, -0.081940, 0.126870, -0.025030, -0.065390, -0.015270, -0.047610, -0.089910, 
0.071330, 0.016450, -0.012640, 0.077260, -0.203710, 0.081740, -0.144130, 0.259920, -0.192140, -0.067720, 
0.306800, -0.412980, 0.007020, 0.014210, -0.012820, -0.078990, 0.121540, -0.044930, 0.090630, 0.085210, 
-0.071640, -0.119920, 0.105530, -0.072230, 0.084460, 0.023630, -0.010540, 0.044150, -0.144550, 0.101730, 
-0.125700, 0.117330, -0.071010, -0.104850, 0.095340, -0.229890, -0.006880, -0.032990, -0.019540, -0.075700, 
0.056140, -0.048050, 0.051350, 0.058990, -0.047700, -0.107550, 0.176300, -0.076960, 0.026400, 0.056870, 
-0.069250, 0.016970, -0.060380, 0.008840, -0.183180, 0.081190, -0.120100, -0.091590, 0.096570, -0.169260, 
-0.023870, -0.037790, 0.013840, -0.033960, -0.057410, 0.030370, -0.005340, 0.046180, -0.068240, -0.151780, 
0.237530, -0.071740, -0.013340, 0.079680, -0.089840, 0.017270, -0.016990, -0.009310, -0.078570, 0.069350, 
-0.087390, -0.088100, 0.089570, -0.077590, -0.074290, -0.030720, 0.104430, -0.089120, -0.026430, 0.087690, 
-0.053050, 0.023010, -0.059570, -0.120400, 0.184450, -0.055940, -0.034120, -0.003100, 0.040090, -0.018110, 
-0.041050, 0.005160, -0.173430, 0.070960, 0.023410, -0.107600, 0.102900, -0.032610, -0.135530, 0.069390, 
0.071630, -0.147280, 0.107890, 0.040160, -0.073170, 0.048930, -0.058020, -0.133240, 0.199690, -0.071490, 
-0.110240, 0.088660, -0.021980, -0.071440, 0.043100, 0.003730, -0.195830, 0.103480, 0.035620, -0.195530, 
0.179030, -0.073020, 
0.057610, -0.119030, -0.144070, -0.021030, -0.110160, -0.094520, 0.067820, -0.016380, -0.130470, 0.159340, 
-0.205790, 0.084500, 0.015160, -0.084610, 0.007920, 0.056200, -0.076800, 0.007590, 0.138990, 0.018950, 
-0.099600, -0.012100, -0.156390, 0.096840, 0.040180, -0.123680, -0.087670, -0.046290, -0.105710, -0.025520, 
-0.024030, -0.028440, 0.003110, 0.036440, -0.061560, 0.128930, 0.038750, -0.087180, 0.020100, 0.022060, 
0.036530, -0.007150, 0.244430, -0.078260, -0.029580, 0.003380, -0.160210, 0.164880, 0.055130, -0.122820, 
-0.124350, 0.027870, -0.073970, -0.134860, -0.078810, -0.004590, 0.034760, -0.039630, 0.009740, 0.034010, 
-0.046490, -0.042280, 0.042550, -0.024720, 0.120220, -0.037390, 0.230010, -0.165580, -0.123770, 0.104670, 
-0.191140, 0.102620, -0.012180, -0.088290, -0.135590, 0.052450, -0.095300, -0.190790, -0.127700, -0.015450, 
0.033650, -0.047670, -0.014250, -0.026060, -0.135690, -0.070330, 0.001440, -0.113850, 0.137930, -0.070620, 
0.234840, -0.214450, -0.091730, 0.085230, -0.248050, 0.125660, -0.101480, -0.036380, -0.077080, 0.001450, 
-0.175390, -0.107460, -0.150640, 0.002400, 0.004370, 0.052190, -0.120370, 0.017930, -0.132140, -0.137430, 
0.026020, -0.101430, 0.008280, 0.017470, 0.450560, -0.333060, -0.137820, 0.118580, -0.426580, 0.213950, 
-0.053730, -0.107920, -0.113720, 0.095400, -0.347500, -0.084020, -0.221580, 0.012160, 0.061980, 0.096050, 
-0.142750, 0.141680, -0.069900, -0.159260, 0.017870, -0.093920, -0.074340, 0.083140, 0.543590, -0.428640, 
-0.059970, 0.310190, -0.637850, 0.343750, 0.203260, -0.156370, -0.237310, 0.317810, -0.381580, -0.156650, 
-0.130170, 0.026870, 0.022210, 0.180320, -0.092230, 0.061610, 0.130040, -0.161290, -0.138030, 0.065540, 
-0.170030, 0.037770, 0.663180, -0.420420, -0.070530, 0.564400, -0.660650, 0.261270, 0.075270, -0.141040, 
-0.152520, 0.249640, -0.317480, -0.166690, -0.229400, -0.064320, 0.077510, 0.073840, -0.182590, 0.007620, 
-0.107590, -0.111670, -0.070210, 0.036920, -0.095960, -0.072020, 0.319340, -0.339510, 0.054350, 0.286080, 
-0.443150, 0.313670, -0.018820, -0.103430, -0.112080, 0.259760, -0.245550, -0.206280, -0.258940, -0.117160, 
0.039390, -0.078830, -0.216770, 0.014780, -0.218620, -0.110110, -0.030470, -0.047850, 0.005760, -0.175130, 
0.290020, -0.252560, -0.036180, 0.171740, -0.208650, 0.260380, -0.041390, -0.026500, -0.081030, 0.174700, 
-0.070760, -0.166630, -0.216880, 0.039540, -0.006500, -0.117980, -0.122420, 0.034190, -0.229790, 0.011870, 
-0.034810, -0.150150, 0.190170, -0.126540, 0.202360, -0.060840, 0.014180, 0.083770, -0.102100, 0.211000, 
0.006280, -0.011260, -0.057300, 0.077880, 0.039120, -0.183190, -0.177120, 0.055490, 0.024620, -0.065070, 
-0.065860, -0.015750, -0.156340, 0.054730, -0.026640, -0.242280, 0.249060, -0.098730, 0.117400, 0.009050, 
-0.051900, 0.109040, -0.107940, 0.109580, 0.061400, 0.005000, -0.108640, 0.151650, 0.001580, -0.182520, 
-0.071640, 0.052900, -0.037100, -0.066210, -0.004770, -0.005760, -0.039580, 0.028330, -0.055430, -0.074730, 
0.150720, -0.077650, 0.193460, -0.075030, -0.048070, 0.079740, -0.110720, 0.042230, 0.210980, -0.107830, 
-0.157150, 0.215360, -0.130680, -0.133400, -0.019750, 0.138360, -0.081500, 0.009480, -0.008680, 0.033440, 
-0.000220, 0.048610, 0.007310, -0.009200, 0.104340, -0.008770, 0.375830, -0.144410, -0.124510, 0.179070, 
-0.148250, 0.064150, 
0.145430, -0.196660, -0.169310, 0.054290, -0.173490, -0.089050, 0.084570, 0.032520, -0.189090, 0.092870, 
-0.254300, 0.080240, -0.050220, -0.030200, 0.040980, 0.084260, -0.182140, 0.020570, -0.056870, 0.226630, 
-0.068960, -0.001290, -0.116040, 0.116140, 0.085750, -0.157910, -0.108840, 0.035140, -0.226680, -0.011890, 
-0.088870, -0.014760, -0.001210, 0.019260, -0.027490, 0.144200, 0.084120, -0.083030, 0.045070, 0.034850, 
-0.089260, 0.078940, 0.081490, 0.257230, 0.042730, -0.092250, 0.060240, 0.214400, 0.106240, -0.132310, 
-0.124800, 0.040550, -0.093670, -0.097730, -0.025140, 0.040700, 0.007510, 0.001120, -0.008030, 0.092420, 
0.063300, 0.032470, 0.043440, 0.027150, -0.009130, 0.107990, 0.112540, 0.261760, -0.155550, -0.030570, 
0.076800, 0.157380, 0.069390, -0.098870, -0.189890, 0.086080, -0.100910, -0.183140, -0.029780, -0.068780, 
0.113920, 0.168340, -0.075720, -0.044690, -0.109090, 0.000860, 0.008810, -0.022080, 0.075680, -0.000590, 
-0.087750, 0.262180, 0.015290, 0.012510, -0.010240, 0.072120, 0.008540, -0.105630, -0.099110, -0.008620, 
-0.188840, -0.087870, -0.058950, -0.033790, 0.100620, 0.324100, -0.200500, -0.143700, -0.088730, -0.116760, 
0.088440, -0.041860, 0.066030, -0.010530, 0.078350, -0.069370, 0.167520, -0.012620, -0.320820, 0.243560, 
-0.016520, -0.367010, -0.123380, 0.015590, -0.479570, -0.121330, -0.093020, -0.102910, -0.051140, 0.155550, 
-0.420960, 0.166150, -0.124790, -0.174510, 0.015860, -0.018150, -0.148770, -0.033860, 0.289870, -0.562270, 
0.140190, 0.112010, -0.868490, 0.581850, 0.105060, -0.414120, 0.005090, 0.161290, -0.681910, 0.193350, 
-0.142580, -0.110340, 0.151460, 0.231660, -0.411130, 0.339790, 0.070330, -0.304160, 0.059130, 0.161500, 
-0.475380, 0.230360, 0.390640, -0.678260, 0.331580, 0.344650, -0.981710, 0.709400, 0.133430, -0.337040, 
-0.211270, 0.207080, -0.559370, -0.041290, -0.279670, -0.185020, 0.086890, 0.164390, -0.480530, 0.088410, 
-0.167360, -0.272080, -0.031070, 0.128250, -0.340260, -0.058310, 0.128900, -0.431250, 0.217030, 0.186110, 
-0.578280, 0.466110, 0.041920, -0.259760, -0.021210, 0.264900, -0.444060, -0.029830, -0.265830, -0.239350, 
0.196330, -0.117140, -0.266540, 0.196200, -0.233020, -0.146020, 0.080490, -0.049270, -0.039320, -0.036410, 
0.332390, -0.144760, -0.068890, 0.054670, 0.133270, 0.187560, -0.018200, -0.116940, 0.074900, 0.138630, 
-0.184900, -0.000570, -0.195780, -0.022010, 0.109870, 0.028550, -0.311880, 0.109260, -0.241950, -0.005860, 
0.105550, -0.169880, 0.154420, 0.026720, 0.111180, 0.342890, 0.029140, -0.025940, 0.276510, 0.107840, 
-0.009460, -0.131500, 0.070820, -0.000040, 0.031100, -0.077050, -0.155550, 0.106670, 0.109990, 0.072260, 
0.024450, -0.107380, -0.129950, 0.074230, 0.058160, -0.166370, 0.151940, 0.057280, -0.046210, 0.434440, 
-0.082380, 0.054820, 0.249450, -0.045690, 0.053210, -0.049530, -0.043630, 0.143210, -0.058050, -0.114720, 
-0.004060, 0.099370, 0.064880, 0.041860, 0.101570, -0.047870, 0.013760, 0.121910, 0.003640, -0.113210, 
0.125520, 0.092550, 0.088780, 0.025420, 0.067810, 0.055190, 0.130930, 0.020090, 0.270770, -0.177370, 
-0.136180, 0.345430, -0.219750, -0.168680, 0.001430, 0.236220, -0.011320, 0.049180, 0.066140, 0.009900, 
0.037500, 0.100790, 0.000000, 0.029490, 0.080070, 0.115810, 0.458590, -0.073990, -0.154250, 0.190150, 
0.139480, 0.024350, 
-0.024720, -0.005680, -0.030510, -0.021720, -0.010230, -0.030700, -0.035140, -0.009760, -0.027820, -0.043110, 
-0.014620, -0.042920, -0.036780, -0.007620, -0.027250, -0.035070, -0.011180, -0.016290, -0.033820, -0.012040, 
-0.038520, -0.030060, -0.000990, -0.037120, -0.029220, -0.012930, -0.035390, -0.019390, -0.017940, -0.027720, 
-0.025990, -0.008630, -0.035680, -0.028680, -0.005980, -0.037730, -0.026980, -0.009450, -0.039630, -0.033990, 
-0.021540, -0.019990, -0.028440, -0.004400, -0.042140, -0.031310, 0.007840, -0.051110, -0.014420, -0.008090, 
-0.042680, -0.026810, -0.023270, -0.027070, -0.024820, -0.013740, -0.039480, -0.015210, -0.027240, -0.032030, 
-0.007330, 0.000280, -0.049060, -0.015170, -0.035100, -0.032830, -0.016530, 0.008860, -0.045430, -0.015040, 
-0.004840, -0.051020, -0.018070, -0.010550, -0.042240, -0.035590, -0.028100, -0.019810, -0.007970, -0.007840, 
-0.061590, -0.006640, -0.033630, -0.036120, -0.020010, 0.000010, -0.043800, -0.014060, -0.037470, -0.022150, 
-0.020500, 0.017060, -0.047910, -0.014290, -0.017350, -0.052020, -0.010870, -0.015610, -0.065190, -0.039900, 
-0.015280, -0.041310, -0.020590, -0.015800, -0.058110, -0.007650, -0.022470, -0.042740, -0.032090, -0.000950, 
-0.043800, -0.021490, -0.016980, -0.043780, -0.063500, 0.000410, -0.022330, -0.020260, -0.014150, -0.066670, 
-0.045170, -0.023380, -0.043850, -0.056800, -0.017360, -0.048520, -0.008250, -0.017170, -0.060770, -0.042440, 
-0.050400, -0.052070, -0.040410, -0.014680, -0.052810, -0.040950, -0.034850, -0.052410, -0.098150, -0.012060, 
-0.031250, -0.067270, -0.018790, -0.030020, -0.078790, -0.024950, 0.008920, -0.093780, -0.036540, 0.031510, 
-0.053540, -0.035910, -0.009010, -0.065860, -0.057530, 0.010570, -0.093650, -0.016080, 0.015740, -0.062200, 
-0.034850, 0.009350, -0.151660, -0.030610, 0.043040, -0.119080, -0.037580, 0.033000, -0.036780, -0.031860, 
-0.051990, -0.046440, -0.029760, -0.034290, -0.012760, -0.030160, -0.061550, -0.020750, -0.048290, -0.043420, 
-0.034650, -0.021830, -0.046620, -0.043140, -0.031230, -0.041170, -0.084480, -0.021080, -0.008220, -0.068730, 
-0.022530, -0.028770, -0.024280, -0.011820, -0.040130, -0.053020, -0.019630, -0.016020, -0.012910, -0.040190, 
-0.035110, -0.015070, -0.027110, -0.037510, -0.007710, -0.026000, -0.020330, -0.018510, -0.045340, -0.028950, 
-0.045180, -0.005770, -0.031420, -0.052960, -0.017030, -0.043960, -0.028190, -0.026340, -0.046300, -0.043540, 
-0.016470, -0.021820, -0.014590, -0.030090, -0.038820, -0.002620, -0.033270, -0.040170, -0.016990, -0.015530, 
-0.025140, -0.023860, -0.034620, -0.018240, -0.037150, -0.004320, -0.044650, -0.033320, -0.011940, -0.049460, 
-0.024790, -0.029520, -0.026540, -0.037720, -0.027620, -0.026240, -0.020060, -0.013770, -0.034400, -0.015170, 
-0.014000, -0.042610, -0.026110, -0.003490, -0.022840, -0.024070, -0.046520, -0.011740, -0.051240, 0.014320, 
-0.042090, -0.046820, -0.006200, -0.031780, -0.021610, -0.028370, -0.036690, -0.032810, -0.040180, -0.009650, 
-0.032610, -0.018440, -0.026850, -0.023970, -0.026370, -0.020050, -0.040040, -0.000660, -0.032670, -0.040780, 
-0.033350, -0.001430, -0.043230, 0.000910, -0.044860, -0.039540, -0.008240, -0.032310, -0.021640, -0.011000, 
-0.030270, -0.030870, -0.027350, -0.020730, -0.044790, -0.019540, -0.038490, -0.048480, 0.001170, -0.028260, 
-0.032670, -0.010550, -0.049170, -0.022270, -0.033550, -0.027260, -0.030900, -0.008350, -0.050270, -0.052160, 
0.003450, -0.050060, 
-0.077480, 0.293270, -0.244970, -0.018550, 0.149370, -0.186850, 0.023750, -0.004570, -0.125970, -0.061120, 
0.172770, -0.263790, 0.052500, 0.159950, -0.251430, -0.009200, 0.131400, -0.224040, 0.147620, 0.057730, 
-0.241610, 0.121020, 0.070000, -0.149910, -0.066860, 0.093470, -0.028010, -0.002270, 0.007900, -0.051830, 
0.145230, -0.049260, -0.063420, -0.096230, 0.065490, -0.038260, -0.057630, 0.190500, -0.007110, 0.091370, 
-0.006880, -0.071850, -0.043790, -0.104730, 0.175050, 0.099940, -0.083250, -0.003090, -0.100300, 0.041320, 
-0.037150, -0.122140, 0.006360, 0.038680, 0.069720, -0.109870, 0.027840, -0.004970, -0.081550, 0.027670, 
-0.102470, 0.125130, 0.002770, 0.050340, -0.163160, 0.044070, -0.215740, -0.127270, 0.268500, 0.000330, 
-0.195640, 0.068760, -0.092860, -0.034890, -0.001970, -0.142000, -0.090560, 0.113180, -0.020740, -0.224220, 
0.119500, -0.115180, -0.068440, -0.028980, -0.093450, 0.090540, 0.005310, 0.048170, -0.346400, 0.097090, 
-0.209560, -0.056490, -0.071200, -0.159980, -0.142810, 0.118720, -0.035790, -0.150870, 0.110920, -0.104500, 
-0.141450, 0.183570, -0.007980, -0.304640, 0.220130, -0.225230, -0.013250, 0.001910, -0.027840, -0.016390, 
0.047340, 0.036020, -0.394720, 0.180240, -0.399530, 0.158080, -0.090450, -0.088950, 0.086570, 0.008230, 
-0.001480, 0.016560, 0.013500, -0.081980, 0.129960, 0.041780, -0.002190, -0.097190, 0.063290, -0.127700, 
0.152510, -0.123540, 0.002200, 0.199350, -0.041540, 0.072100, -0.227690, 0.048700, -0.277840, 0.452770, 
-0.267780, -0.037250, 0.476370, -0.400440, -0.096960, 0.167330, -0.310090, -0.128420, 0.318600, -0.374410, 
0.023570, 0.009360, -0.366800, -0.164730, 0.307030, -0.436030, -0.124690, 0.440800, -0.454620, -0.127090, 
0.062060, -0.290710, -0.015160, 0.673690, -0.916610, -0.009820, 0.706940, -1.000820, -0.055240, 0.017440, 
-0.063300, -0.128850, 0.133200, -0.101390, -0.016030, 0.080680, -0.119770, -0.119000, 0.002840, -0.103980, 
-0.148390, 0.190810, -0.077190, -0.096020, -0.177180, 0.050430, -0.171900, 0.346450, -0.353650, -0.066080, 
0.307170, -0.510160, 0.017450, -0.142970, 0.069310, -0.039940, -0.040530, 0.022460, 0.031010, 0.104210, 
-0.041240, -0.222080, 0.065550, 0.033820, -0.016990, 0.027560, 0.033680, -0.072720, -0.205150, 0.171320, 
-0.177050, 0.081690, 0.055740, -0.162750, -0.018180, -0.044080, 0.021320, -0.203330, 0.121350, -0.005810, 
-0.149930, 0.070130, 0.024690, 0.101510, -0.029510, -0.066300, 0.052050, 0.000030, -0.021340, 0.095130, 
-0.046300, -0.065600, -0.082960, 0.089980, -0.196880, 0.002920, 0.009850, -0.032000, -0.028700, -0.030180, 
0.054270, -0.208880, 0.069360, 0.071590, -0.251240, 0.106900, 0.129600, -0.084580, -0.068400, -0.027110, 
0.153210, -0.079720, 0.067010, 0.026630, -0.115820, 0.107750, -0.110740, 0.010290, 0.003230, 0.041400, 
0.013020, 0.064220, -0.107980, 0.009600, 0.045030, -0.143550, 0.089360, 0.017450, -0.128640, 0.088900, 
0.162560, -0.154950, -0.101130, 0.097010, 0.082840, -0.110760, 0.141280, -0.126390, -0.009120, 0.085800, 
-0.118100, -0.046440, -0.066940, 0.041050, 0.075290, 0.121800, 0.037240, -0.071720, -0.004860, 0.064400, 
-0.038570, 0.010310, 0.106130, -0.080620, 0.131170, -0.003620, -0.151250, 0.077970, 0.076080, -0.174700, 
0.048200, 0.076150, -0.109440, -0.007250, 0.032970, -0.073210, 0.053750, 0.088150, -0.075960, -0.016630, 
0.146140, -0.151820, 
-0.047600, 0.033590, -0.021340, -0.034610, -0.007990, -0.002590, -0.050380, -0.024920, 0.015780, -0.066170, 
0.003510, -0.032470, -0.035050, -0.007100, -0.010970, -0.039880, -0.001190, -0.019720, -0.051090, 0.005950, 
-0.038300, -0.042860, 0.021430, -0.026090, -0.017930, 0.009780, -0.033410, -0.007370, -0.006810, -0.043180, 
-0.009980, -0.020450, -0.026080, -0.028540, 0.002200, -0.043820, -0.025040, 0.020830, -0.022540, -0.019260, 
-0.011670, -0.026560, -0.079200, -0.001030, -0.035100, -0.034330, 0.023040, -0.048890, 0.004090, 0.019410, 
-0.065680, -0.018830, -0.008370, -0.043300, -0.008070, -0.006940, -0.048920, -0.010790, 0.000370, -0.051830, 
-0.025100, 0.039250, -0.045520, -0.026410, -0.009250, -0.043740, -0.074920, 0.014330, -0.022480, -0.025700, 
0.008990, -0.058470, 0.010790, 0.016740, -0.080600, -0.037350, 0.015670, -0.034240, -0.010470, -0.003610, 
-0.057370, -0.040870, 0.013440, -0.052350, -0.020530, 0.047670, -0.071090, -0.024060, -0.033570, -0.039570, 
-0.079640, 0.019790, -0.077910, -0.070520, 0.023540, -0.055180, 0.000470, 0.000500, -0.063970, -0.027120, 
0.017500, -0.035490, -0.015590, -0.030110, -0.041970, -0.035400, -0.000860, -0.047100, -0.016250, 0.041020, 
-0.078420, -0.017540, -0.036450, -0.035370, -0.126300, 0.041360, -0.058810, -0.066320, 0.040560, -0.080560, 
0.003140, 0.036420, -0.065150, -0.042890, 0.063570, -0.032660, -0.001070, -0.013250, -0.035750, -0.056210, 
0.023520, -0.070800, 0.001660, 0.057260, -0.057470, -0.007030, -0.016590, -0.027260, -0.136970, 0.083770, 
-0.064870, -0.086260, 0.102210, -0.108870, -0.059040, 0.057540, -0.074410, -0.087130, 0.084680, -0.082330, 
-0.006270, -0.015240, -0.062930, -0.088690, 0.028170, -0.078450, -0.064130, 0.061740, -0.066690, -0.060430, 
-0.007360, -0.046850, -0.153020, 0.115150, -0.115790, -0.133980, 0.141660, -0.144610, -0.050210, 0.017210, 
-0.030450, -0.071360, 0.038330, -0.021130, 0.008340, -0.003590, -0.049300, -0.029500, -0.004770, -0.042010, 
-0.034210, 0.026130, -0.027820, -0.044430, -0.040250, 0.023660, -0.109380, 0.072420, -0.063010, -0.095010, 
0.088410, -0.096890, -0.031970, -0.004210, -0.029080, -0.066400, 0.010890, -0.014870, 0.020430, -0.001290, 
-0.043800, -0.020150, -0.009640, -0.018880, -0.007050, -0.006510, -0.012440, -0.015910, -0.059650, 0.030960, 
-0.087530, 0.033020, -0.039240, -0.079580, 0.010950, -0.058250, -0.030310, -0.026610, -0.035240, -0.057490, 
-0.015020, -0.019000, 0.002640, -0.022480, -0.023470, -0.032120, 0.003460, -0.030330, -0.010910, -0.004700, 
-0.031400, -0.027200, -0.044820, 0.003230, -0.080050, 0.008560, -0.059920, -0.066040, -0.004180, -0.055860, 
-0.038350, -0.024490, -0.026440, -0.045910, -0.038790, -0.002940, -0.010490, -0.016050, -0.046650, -0.051500, 
0.024310, -0.022280, -0.035660, -0.019030, -0.020880, -0.020580, -0.057380, -0.001240, -0.055740, -0.016200, 
-0.033410, -0.046660, -0.010020, -0.015050, -0.047210, -0.032340, 0.003000, -0.061530, -0.041490, 0.010470, 
-0.036850, -0.021700, -0.021500, -0.059960, 0.004120, -0.018100, -0.053990, -0.030350, -0.004140, -0.043580, 
-0.057980, -0.005230, -0.059900, -0.005980, -0.015980, -0.060370, -0.021340, -0.019540, -0.067970, -0.003390, 
-0.020970, -0.059200, -0.002080, -0.018130, -0.039250, -0.022130, -0.025270, -0.060090, 0.002580, -0.036840, 
-0.056740, -0.012320, -0.034180, -0.047620, -0.017290, -0.023800, -0.072840, 0.002440, -0.015740, -0.071690, 
-0.005320, -0.028740, 
-0.098570, 0.118400, -0.044940, -0.069880, 0.024670, 0.002600, -0.026510, -0.071350, 0.024480, -0.092760, 
0.019400, -0.073250, -0.006140, 0.019660, -0.046510, -0.059770, -0.005810, -0.033420, -0.042400, 0.025610, 
-0.052320, -0.039770, 0.070090, -0.031000, -0.020530, 0.054500, -0.042350, 0.003820, 0.014190, -0.049500, 
0.053290, -0.037200, -0.018310, -0.059810, 0.041610, -0.069680, -0.031490, 0.089590, -0.006960, 0.017760, 
-0.014400, -0.054940, -0.119470, -0.016300, 0.049420, -0.036410, 0.045380, -0.049480, 0.003030, 0.049970, 
-0.112410, -0.016240, 0.019050, -0.053690, 0.028680, -0.053130, -0.029520, -0.034860, 0.028600, -0.039160, 
-0.072110, 0.143220, -0.065110, -0.012200, -0.027400, -0.053550, -0.167130, 0.027140, 0.041750, -0.050100, 
0.001350, -0.041890, 0.016580, 0.036360, -0.120060, -0.053880, 0.010600, -0.034130, -0.012380, -0.047110, 
-0.032240, -0.106050, 0.049320, -0.070480, -0.036740, 0.119070, -0.093630, -0.020480, -0.095430, -0.043350, 
-0.138960, 0.047150, -0.131220, -0.126050, 0.028310, -0.034710, 0.037600, -0.035760, -0.075440, -0.032320, 
-0.003130, -0.016390, -0.006420, -0.096660, 0.031640, -0.109590, 0.020080, -0.036010, -0.026920, 0.096100, 
-0.067700, 0.017380, -0.158750, 0.015960, -0.236820, 0.104460, -0.093750, -0.097150, 0.125070, -0.090230, 
0.052210, 0.057060, -0.069150, -0.022400, 0.163190, -0.045730, 0.019000, -0.040740, 0.019220, -0.059560, 
0.089660, -0.099830, 0.056960, 0.137140, -0.092810, 0.034570, -0.098350, 0.014270, -0.206890, 0.251110, 
-0.157130, -0.057270, 0.311700, -0.286190, -0.037810, 0.156750, -0.212370, -0.079840, 0.246290, -0.259420, 
0.031970, -0.048890, -0.161070, -0.082420, 0.149310, -0.250230, -0.036990, 0.174180, -0.225870, -0.052760, 
0.012410, -0.134560, -0.123080, 0.357170, -0.440790, -0.084210, 0.432410, -0.550340, -0.040010, 0.069280, 
-0.022060, -0.098720, 0.145160, -0.045060, 0.038600, 0.020120, -0.039090, -0.044960, -0.000280, -0.041190, 
-0.041930, 0.073490, -0.010160, -0.018210, -0.119330, 0.090200, -0.137740, 0.235110, -0.182350, -0.090950, 
0.230270, -0.292730, -0.036860, -0.027520, 0.026600, -0.078170, 0.032670, 0.009630, 0.047030, 0.049560, 
-0.032210, -0.103290, 0.029240, 0.002630, 0.004750, 0.011580, 0.016660, -0.013620, -0.133590, 0.118580, 
-0.130930, 0.087310, -0.024870, -0.130990, 0.026070, -0.095510, -0.019610, -0.057900, 0.011490, -0.076770, 
-0.007610, -0.002330, 0.035790, 0.008050, -0.025720, -0.083810, 0.068060, -0.032750, -0.010010, 0.034340, 
-0.032700, -0.028910, -0.063110, 0.050780, -0.137310, 0.040030, -0.063120, -0.056580, -0.010540, -0.063130, 
-0.019470, -0.063980, 0.011010, -0.021020, -0.091890, 0.034330, 0.011210, -0.017440, -0.051830, -0.118730, 
0.126900, -0.040240, -0.039560, 0.028250, -0.046710, -0.004090, -0.055250, 0.004990, -0.034980, 0.012540, 
-0.054400, -0.038870, -0.037260, -0.009740, -0.047950, -0.055860, 0.056140, -0.071340, -0.066180, 0.053060, 
-0.014260, -0.041810, -0.054220, -0.064010, 0.063660, -0.041030, -0.025470, -0.047820, 0.016730, -0.033570, 
-0.053030, 0.007950, -0.094150, 0.009020, 0.019640, -0.022420, -0.007390, -0.005690, -0.095430, 0.051740, 
-0.003660, -0.099160, 0.052320, -0.024450, -0.037960, 0.002610, -0.054100, -0.069350, 0.080830, -0.088220, 
-0.091820, 0.047260, -0.027770, -0.054450, 0.013890, -0.008910, -0.079960, 0.046880, -0.018840, -0.102140, 
0.078450, -0.067950, 
-0.045710, 0.130120, -0.056630, -0.055270, 0.087210, -0.023950, -0.070810, 0.004660, 0.029770, -0.075680, 
0.082920, -0.090950, 0.010110, 0.023010, -0.008330, -0.040650, 0.025520, -0.022640, 0.023970, 0.038060, 
-0.133430, 0.050070, 0.028350, 0.001080, 0.034480, 0.062490, -0.093740, -0.023800, 0.076920, -0.080960, 
0.027470, -0.022930, -0.024200, 0.009640, 0.067090, -0.095250, 0.015800, 0.021970, 0.014960, 0.003890, 
-0.024460, -0.018560, 0.043990, -0.012160, -0.102780, 0.099550, -0.016620, -0.058560, 0.054520, 0.011230, 
-0.079450, -0.027560, -0.001960, 0.006530, 0.021940, -0.029890, -0.030070, -0.010820, 0.052140, -0.049580, 
0.017520, 0.044440, -0.007670, 0.012830, -0.076110, -0.018330, 0.002530, -0.042630, 0.028640, 0.095780, 
-0.108940, -0.052530, 0.071950, -0.075850, -0.060030, -0.102580, -0.039340, 0.090280, -0.006330, -0.023870, 
-0.087090, -0.080780, -0.012060, 0.002440, 0.048680, 0.044260, -0.027070, 0.026310, -0.156570, 0.003980, 
-0.130940, -0.032230, 0.004860, -0.093370, -0.092710, 0.027470, 0.008960, -0.116680, -0.046510, -0.140370, 
-0.022620, 0.075650, -0.098730, -0.106310, 0.007410, -0.161550, -0.087590, 0.110660, -0.101410, 0.054940, 
0.014250, -0.079140, -0.157980, 0.065610, -0.491020, 0.058300, 0.139740, -0.274790, -0.073550, 0.071610, 
-0.145190, -0.025410, 0.010780, -0.267990, 0.096300, 0.069840, -0.110110, -0.092330, -0.008300, -0.282760, 
-0.061650, 0.052210, -0.145640, 0.071540, 0.004300, -0.162660, -0.074100, 0.038360, -0.723580, 0.181160, 
0.157030, -0.447100, 0.104310, 0.028390, -0.316240, 0.113060, 0.030570, -0.372630, 0.175470, 0.078180, 
-0.115030, -0.055090, 0.015900, -0.358500, 0.091370, 0.023760, -0.225980, 0.104610, 0.028410, -0.262720, 
0.037620, 0.068450, -0.685360, 0.266370, 0.054640, -0.559620, 0.283390, -0.043160, -0.198480, 0.117590, 
-0.058230, -0.333050, 0.189660, 0.008360, -0.025270, 0.062470, -0.120780, -0.239700, 0.064370, -0.019530, 
-0.113870, 0.127790, -0.042840, -0.190560, 0.040810, 0.050450, -0.431340, 0.206260, -0.024900, -0.476120, 
0.306490, -0.117910, -0.103720, 0.095540, -0.064620, -0.247840, 0.141250, -0.019610, 0.047620, 0.102940, 
-0.113610, -0.103920, 0.133470, -0.027020, -0.017470, 0.109330, -0.021690, -0.046750, 0.002260, 0.086500, 
-0.307690, 0.199620, -0.073720, -0.375910, 0.227610, -0.129610, -0.032180, 0.054250, -0.082770, -0.145530, 
0.079650, -0.028780, 0.084790, 0.017830, -0.058650, -0.037420, 0.104310, -0.040420, 0.029240, 0.090770, 
-0.005180, 0.038620, -0.061980, 0.077380, -0.188200, 0.082210, -0.093320, -0.212540, 0.156410, -0.127970, 
-0.013580, 0.008210, -0.017620, -0.068790, -0.027520, 0.050230, 0.011370, 0.053450, -0.022640, -0.079350, 
0.166740, 0.007200, -0.012690, 0.075220, 0.055760, 0.030680, -0.028720, 0.080870, -0.084240, 0.082420, 
-0.036830, -0.140930, 0.114260, -0.066340, -0.031020, 0.033410, 0.042020, -0.049070, 0.008760, 0.055820, 
-0.056510, 0.056300, 0.021550, -0.044480, 0.101190, 0.007610, -0.067160, 0.079570, 0.079210, -0.050460, 
-0.001830, 0.094440, -0.090070, 0.144120, -0.017590, -0.104190, 0.091900, -0.071920, -0.072500, 0.117450, 
0.039800, -0.047540, 0.111970, 0.019440, -0.020410, 0.040310, -0.017470, -0.055070, 0.148750, -0.078530, 
-0.080650, 0.092750, -0.017770, -0.017400, 0.087110, -0.009120, -0.093070, 0.186200, -0.013540, -0.143050, 
0.155790, -0.102380, 
0.051340, -0.139480, -0.001930, 0.036410, -0.098800, 0.011930, -0.101450, 0.039860, -0.024940, -0.115610, 
0.008050, -0.111370, -0.056370, 0.017780, -0.023750, -0.083780, -0.018310, 0.030240, -0.014930, -0.009030, 
-0.085950, -0.009260, 0.030780, -0.118230, 0.069480, -0.157940, -0.023370, 0.044780, -0.131910, 0.004570, 
-0.161280, -0.022990, 0.052510, -0.082110, 0.055500, -0.045750, -0.035100, -0.060440, 0.000450, -0.096750, 
-0.070160, 0.089340, 0.060600, -0.089470, 0.023110, -0.003400, -0.021210, -0.023520, 0.092650, -0.203180, 
0.042080, -0.009780, -0.175490, 0.130160, -0.039360, -0.023920, -0.018760, -0.013650, -0.060450, 0.022820, 
0.014260, -0.055550, 0.033820, -0.051350, -0.167570, 0.109240, 0.101660, 0.007290, 0.053950, 0.090990, 
-0.139700, 0.013290, 0.054880, -0.142590, -0.028290, -0.080490, -0.167160, 0.119350, 0.001560, -0.056710, 
-0.073350, 0.055130, -0.102010, 0.007280, -0.013440, -0.014110, -0.034780, 0.002200, -0.180200, 0.040110, 
0.040890, 0.041570, 0.021820, 0.115160, -0.148850, -0.120260, -0.009290, -0.100940, -0.160040, -0.067290, 
-0.062080, -0.031620, -0.091520, -0.005630, -0.096330, -0.027470, -0.009390, -0.157260, -0.127830, 0.106450, 
-0.089200, -0.076400, -0.031870, -0.068720, -0.156250, 0.004410, 0.089810, 0.206690, -0.227430, -0.228360, 
-0.150030, -0.080750, -0.210200, -0.161370, -0.109070, -0.099100, -0.152030, 0.029030, -0.202850, -0.243610, 
-0.043270, -0.098030, -0.392970, 0.167450, -0.001200, -0.250520, 0.148000, -0.142630, -0.250520, -0.054270, 
0.020180, -0.036510, -0.224170, 0.022500, -0.515520, -0.106370, 0.285490, -0.456340, -0.224370, 0.414220, 
-0.421820, 0.030390, 0.241180, -0.578350, 0.009320, 0.375610, -0.668990, 0.111380, 0.467260, -0.527630, 
0.054200, 0.340720, -0.809690, -0.154090, 0.658340, -0.473210, -0.206860, 0.491190, -0.111720, -0.129050, 
-0.181240, -0.162180, -0.234300, 0.043250, 0.015840, -0.095150, -0.195410, 0.037530, -0.216370, -0.064740, 
-0.131940, 0.013610, -0.080010, -0.136370, -0.045710, -0.099090, -0.114480, -0.223780, 0.015940, 0.130530, 
-0.303580, -0.004280, 0.024490, -0.208750, -0.049000, -0.145950, -0.201580, 0.126090, 0.107660, -0.173810, 
0.013730, 0.207410, -0.173530, -0.027020, 0.055050, -0.092660, 0.080270, 0.027490, -0.101000, 0.067740, 
0.142620, -0.218910, -0.009970, 0.311480, -0.252550, -0.097910, 0.074770, -0.218410, 0.004450, -0.034480, 
-0.204030, 0.075020, -0.015680, -0.124260, 0.101590, 0.132630, -0.195200, 0.003620, -0.063640, -0.045700, 
0.206110, -0.008250, -0.115500, 0.116010, 0.245140, -0.153310, -0.078810, 0.325860, -0.273660, -0.039080, 
0.064940, -0.227080, 0.026940, -0.021350, -0.190230, 0.088080, -0.037310, -0.051460, 0.118400, 0.102340, 
0.004070, -0.058780, -0.071900, -0.024660, 0.184650, 0.060690, -0.152110, 0.115590, 0.119310, -0.089760, 
-0.024520, 0.245870, -0.165260, -0.072400, 0.093820, -0.141470, -0.018280, 0.059000, -0.173920, 0.032990, 
-0.116640, 0.014480, 0.123990, 0.079410, -0.024620, -0.016860, -0.097610, 0.069770, 0.079210, -0.128460, 
-0.077970, 0.160650, 0.154250, -0.093930, -0.069620, 0.067820, -0.097030, -0.026650, 0.106150, -0.118050, 
-0.029730, 0.132460, -0.197980, -0.006370, -0.137860, 0.072060, 0.033930, -0.032500, -0.028910, -0.007390, 
-0.037160, 0.045070, -0.075300, -0.065330, -0.062460, 0.020790, 0.241020, -0.099750, -0.150650, 0.063590, 
-0.017440, -0.136790, 
-0.064460, -0.008540, -0.061100, -0.082840, 0.065520, -0.071040, -0.029220, 0.059920, -0.086570, -0.077780, 
0.025140, -0.066190, -0.090170, 0.068670, -0.028180, -0.061890, 0.031600, -0.021590, -0.110520, 0.129840, 
-0.038850, -0.083330, 0.025900, -0.049090, -0.128950, 0.010060, -0.008250, -0.161780, 0.026030, -0.009700, 
-0.121800, 0.017320, -0.038160, -0.107470, 0.040900, 0.000510, -0.071240, -0.006580, -0.024290, -0.103200, 
0.009570, 0.018850, -0.080270, 0.141310, -0.032260, -0.142870, 0.094850, 0.011110, -0.126740, 0.023220, 
-0.009390, -0.181530, 0.067890, 0.004140, -0.092990, 0.070870, -0.059190, -0.097220, 0.067480, -0.038390, 
-0.071170, 0.043360, -0.019010, -0.103090, 0.024220, 0.021890, -0.109970, 0.179600, -0.066600, -0.117470, 
0.095690, 0.010850, -0.111790, 0.035870, -0.056640, -0.108300, 0.056140, -0.066890, -0.052980, 0.033190, 
-0.054940, -0.055530, 0.081880, -0.100620, -0.114310, 0.059660, -0.050170, -0.064110, 0.055240, -0.045910, 
-0.163310, 0.240560, -0.017570, -0.077230, 0.126120, -0.062920, -0.103440, 0.003230, -0.078350, -0.126680, 
0.017220, -0.060960, -0.044580, 0.032200, -0.117340, 0.007460, 0.044130, -0.201020, -0.099620, 0.026670, 
-0.079440, -0.060370, 0.081250, -0.147930, -0.087410, 0.102770, 0.020150, -0.074010, 0.003020, -0.053500, 
-0.106620, -0.118220, -0.086060, -0.145870, -0.125440, -0.088400, -0.066180, -0.034870, -0.173140, -0.037450, 
-0.147730, -0.081590, -0.130910, -0.041730, -0.077070, -0.068280, -0.043300, -0.155280, -0.046450, -0.216890, 
0.070110, -0.078160, -0.296570, 0.142520, -0.128880, -0.186990, 0.102150, -0.117420, -0.282320, 0.185010, 
-0.111880, -0.039840, 0.025080, -0.027170, -0.204870, 0.121000, -0.094810, -0.123740, 0.069550, -0.038450, 
-0.193590, 0.081280, -0.043900, -0.345750, 0.225500, -0.003430, -0.446990, 0.338740, -0.033850, -0.127270, 
-0.164660, -0.061160, -0.202450, -0.067830, -0.128710, -0.107420, -0.067060, -0.017130, -0.167990, -0.068550, 
-0.071750, -0.116660, -0.094660, -0.016120, -0.137370, -0.134780, 0.000450, -0.309430, 0.012290, 0.045080, 
-0.378360, 0.133390, -0.033060, -0.077470, -0.063770, -0.009430, -0.107090, -0.038620, -0.072050, -0.097170, 
-0.022420, -0.041580, -0.056720, -0.017640, -0.055400, -0.040240, -0.046790, -0.020410, -0.020730, -0.105750, 
0.106720, -0.108650, -0.102200, 0.048460, -0.022550, -0.050150, -0.039770, -0.031680, 0.001910, 0.005020, 
-0.070100, -0.002110, -0.051030, -0.023890, -0.009750, 0.060630, -0.111440, -0.027540, -0.046320, 0.009920, 
-0.008440, -0.035290, 0.021770, -0.018850, 0.029860, 0.099110, -0.062660, 0.022860, 0.105990, -0.089010, 
-0.051520, -0.027170, 0.030370, -0.048080, 0.021050, -0.000510, -0.028950, -0.007510, 0.037020, 0.067790, 
-0.015820, -0.051450, 0.020160, 0.005190, 0.005480, -0.011080, 0.000630, 0.012270, -0.035880, 0.101020, 
-0.040020, 0.028190, 0.076390, -0.089480, 0.010460, -0.018840, -0.021920, 0.030480, -0.042360, -0.017500, 
0.031760, 0.004650, 0.013700, 0.067870, 0.042420, -0.055160, 0.031540, 0.041770, -0.039530, 0.002730, 
0.006990, 0.040790, 0.017110, -0.012950, -0.034680, 0.051730, 0.048960, -0.082430, 0.102940, -0.091700, 
-0.030480, 0.126540, -0.113280, -0.034290, 0.038120, 0.074220, -0.054470, 0.099690, 0.005080, -0.043410, 
0.125690, 0.003920, -0.091880, 0.060720, 0.000840, -0.021190, 0.198990, -0.052050, -0.116320, 0.113060, 
0.029160, -0.095770, 
-0.005490, -0.008970, -0.016730, -0.006370, -0.005260, -0.037600, -0.024280, 0.019860, -0.030870, -0.038810, 
0.008940, -0.036160, -0.026690, 0.015840, -0.018890, -0.049190, 0.009190, -0.020320, -0.033460, 0.014140, 
-0.037540, -0.000270, 0.025830, -0.046870, -0.020850, -0.015780, -0.034780, -0.037100, -0.003000, -0.036880, 
-0.051060, 0.004970, -0.018780, -0.031650, 0.009900, -0.045140, -0.024340, -0.007320, -0.029040, -0.042860, 
-0.021560, 0.002310, -0.000720, 0.009450, -0.060770, -0.017550, 0.024200, -0.040490, -0.007140, -0.023620, 
-0.039760, -0.029950, 0.000740, -0.007220, -0.015800, -0.004600, -0.047530, 0.003420, -0.001670, -0.047510, 
0.012330, -0.015930, -0.042560, -0.016690, -0.036620, -0.006580, 0.011200, 0.026880, -0.055920, 0.008010, 
0.005960, -0.049400, 0.004070, -0.010490, -0.057810, -0.028340, -0.015620, -0.027570, 0.013100, -0.006270, 
-0.059990, 0.031730, -0.032840, -0.042560, -0.002030, 0.006450, -0.041180, -0.001170, -0.041720, -0.014710, 
-0.004820, 0.051380, -0.051340, 0.017290, -0.001530, -0.073880, -0.022880, -0.019940, -0.066240, -0.036220, 
-0.019200, -0.033290, -0.014760, -0.010040, -0.076500, 0.016280, -0.027290, -0.076790, -0.018930, 0.006140, 
-0.042410, -0.027680, -0.017830, -0.058720, -0.062520, 0.006230, 0.003060, -0.016240, -0.050010, -0.062570, 
-0.063660, -0.050990, -0.073160, -0.066800, -0.060870, -0.039560, -0.030290, -0.028950, -0.096210, -0.051790, 
-0.088120, -0.044110, -0.072610, -0.015840, -0.033210, -0.051220, -0.014600, -0.077520, -0.121170, -0.042380, 
0.008060, -0.096280, -0.094860, 0.021960, -0.135460, -0.065150, 0.076620, -0.139070, -0.093040, 0.115820, 
-0.085930, -0.038990, 0.036200, -0.101610, -0.102490, 0.091660, -0.139150, -0.054490, 0.096590, -0.090780, 
-0.071940, 0.081140, -0.214780, -0.093360, 0.161700, -0.184940, -0.114770, 0.186860, -0.056170, -0.043150, 
-0.084330, -0.073790, -0.072790, -0.030580, -0.025660, -0.055660, -0.088130, -0.016080, -0.082340, -0.055150, 
-0.039520, -0.037490, -0.056690, -0.033990, -0.058470, -0.063050, -0.124450, -0.077080, 0.014380, -0.082280, 
-0.072810, 0.030340, -0.024620, -0.029670, -0.053740, -0.052200, -0.027660, -0.015730, -0.004140, -0.062900, 
-0.037690, 0.020880, -0.037650, -0.038730, -0.004200, -0.018450, -0.030350, -0.003910, -0.031480, -0.022610, 
-0.050400, -0.016450, -0.027700, -0.054220, 0.020810, -0.037610, -0.008800, -0.009030, -0.050240, -0.048790, 
-0.028610, -0.011390, -0.000280, -0.032160, -0.037500, 0.021420, -0.032320, -0.044360, -0.021090, -0.003810, 
-0.004070, -0.008790, -0.039010, -0.014900, -0.038580, 0.042450, -0.044790, -0.042570, 0.026690, -0.053510, 
-0.015630, -0.024560, -0.036270, -0.053450, -0.018200, -0.009400, -0.019490, 0.007230, -0.023810, 0.022040, 
-0.006910, -0.053910, -0.023810, -0.000130, -0.003420, 0.006920, -0.036810, -0.008820, -0.060920, 0.048000, 
-0.031710, -0.042680, 0.059930, -0.046630, -0.003230, -0.014090, -0.038540, -0.002840, -0.022350, -0.018860, 
-0.033670, 0.020920, -0.011400, -0.002600, 0.009880, -0.038670, -0.024730, 0.047830, -0.014690, -0.039590, 
-0.004810, -0.000190, -0.045100, 0.018700, -0.025160, -0.060490, 0.032540, -0.041290, 0.005930, -0.011910, 
-0.038800, 0.015060, -0.033700, -0.024610, -0.048760, 0.024400, -0.034680, -0.025090, 0.013360, -0.019700, 
-0.013420, 0.021640, -0.047780, -0.011050, -0.003330, -0.013800, -0.010870, 0.016510, -0.057040, -0.044680, 
0.039720, -0.053380, 
-0.027970, 0.007050, -0.081570, -0.092010, 0.021210, -0.047590, -0.066480, 0.026030, -0.036220, -0.008940, 
0.024450, 0.020200, -0.071050, -0.025350, -0.002680, -0.025080, 0.013110, 0.004540, 0.053340, -0.008070, 
-0.036700, -0.090170, -0.101650, 0.107420, -0.002270, -0.023490, -0.098590, -0.065600, -0.005020, -0.071490, 
-0.029140, -0.024760, -0.031620, -0.021260, -0.014220, 0.006370, -0.003590, -0.078250, -0.014600, 0.021290, 
-0.021920, -0.050340, 0.099420, -0.090140, -0.035090, -0.054590, -0.122390, 0.053450, 0.026760, -0.043190, 
-0.119740, 0.001890, -0.030730, -0.100030, -0.026370, -0.021880, -0.066850, -0.039840, 0.007630, -0.040530, 
-0.030550, -0.101310, -0.005320, 0.003540, -0.011880, -0.061760, 0.085210, -0.150510, -0.031600, -0.033760, 
-0.124440, 0.001280, 0.014980, -0.060610, -0.102810, 0.040160, -0.090290, -0.125960, -0.025530, -0.042000, 
-0.056820, -0.018060, -0.013070, -0.074940, 0.005720, -0.120590, -0.044330, 0.028030, -0.002450, -0.102280, 
0.125360, -0.159220, -0.093440, -0.003240, -0.120970, -0.029410, 0.000340, -0.052460, -0.122310, 0.028270, 
-0.120130, -0.128420, -0.018990, -0.040660, -0.102220, -0.053620, 0.003000, -0.067890, 0.027270, -0.094350, 
-0.090320, -0.009110, -0.022720, -0.104380, 0.138630, -0.106800, -0.151950, -0.012860, -0.132190, 0.004320, 
0.012380, -0.034830, -0.135970, 0.041260, -0.129910, -0.093020, -0.073610, 0.013800, -0.049010, -0.041590, 
0.049130, -0.056180, -0.013530, -0.025640, -0.085560, -0.053750, 0.005990, -0.059620, 0.145670, 0.004690, 
-0.175340, 0.067450, -0.103310, -0.029170, 0.171570, -0.043270, -0.340490, 0.137830, -0.093410, -0.267130, 
0.063520, 0.022300, -0.237980, 0.102680, 0.071320, -0.248560, 0.194850, 0.002130, -0.323980, 0.060570, 
0.034600, -0.246970, 0.322040, 0.059000, -0.442750, 0.302450, -0.085740, -0.288280, 0.080410, -0.045750, 
-0.148850, 0.047580, -0.118270, -0.129420, -0.005870, 0.040710, -0.116310, 0.044320, 0.014300, -0.091410, 
0.082400, -0.010790, -0.168660, 0.045960, 0.003360, -0.121890, 0.200140, -0.016520, -0.209200, 0.215220, 
-0.106970, -0.142080, 0.040050, -0.100090, -0.090700, 0.064650, -0.131870, -0.075280, -0.055780, 0.009940, 
-0.078760, 0.016150, -0.064450, -0.030420, 0.018150, -0.028970, -0.117160, 0.044830, -0.037720, -0.108510, 
0.133520, -0.090730, -0.051300, 0.140350, -0.176330, 0.026900, 0.026440, -0.111770, -0.025640, 0.060640, 
-0.104180, -0.046650, -0.033340, 0.008710, -0.041320, -0.003070, -0.059070, 0.029190, -0.009010, -0.047940, 
-0.021040, -0.001460, -0.026790, -0.039010, 0.069300, -0.138020, 0.073120, 0.089700, -0.173320, 0.101010, 
-0.003580, -0.042690, -0.012340, 0.059450, -0.022470, -0.067510, -0.038810, 0.023260, 0.001850, -0.045690, 
-0.049810, 0.034150, -0.086030, -0.022910, 0.022970, -0.051100, 0.061080, -0.028640, 0.056170, -0.101060, 
0.064760, 0.017520, -0.119300, 0.068040, -0.002380, -0.020230, -0.051400, 0.022980, 0.024620, -0.082020, 
-0.066360, 0.033230, -0.018360, -0.098710, -0.038290, 0.051760, -0.137860, -0.022500, 0.056550, -0.085480, 
0.069700, -0.025870, 0.005170, -0.035160, 0.021170, -0.040000, -0.039200, 0.024910, -0.008800, -0.033900, 
-0.014240, -0.002060, -0.004220, -0.028190, -0.059460, 0.021790, -0.005220, -0.020370, -0.074880, 0.028140, 
-0.139020, 0.010120, 0.074530, -0.120600, 0.081120, -0.000890, -0.039900, 0.007000, 0.025280, -0.031430, 
-0.066740, 0.064290, 
-0.871670, -0.606010, 0.156680, 0.493450, 0.273700, 1.139440, 0.186060, 0.311330, -0.017220, 0.038560, 
-0.495320, -1.351600, 0.082210, -1.026500, -0.980240, -0.007020, 0.857530, 0.659460, -0.189260, -0.309270, 
-0.556480, -0.077280, 1.243900, -1.095550, -0.272330, -0.014690, 0.778220, 0.348540, -0.963760, 0.274850, 
0.444750, -0.147440, -0.496580, -0.296150, -0.535530, -1.273320, -0.620530, 0.036650, -0.212380, 0.400850, 

0.641300, -1.065500, 0.426660, -1.207920, 0.387380, -0.992190, -0.582440, 0.061790, -0.624410, 0.364490, 
-0.114540, 0.189310, -0.260740, 0.152220, 0.200700, -1.132750, -0.949660, -1.180810, 0.045170, -0.371750, 
-0.408400, 0.502420, -1.184330, 0.209460, 0.363090, -0.409900, -1.350910, 0.362210, 0.252650, -1.214190, 
-0.973000, 0.056560, 0.776390, 0.236490, 0.409390, 0.299290, 0.121540, -0.509030, -0.021070, -0.141060, 

-0.296280, 0.951990, -0.446770, -0.182040, -0.429800, -0.869890, 0.201340, -0.752690, 0.462800, -0.309760, 
0.394870, -0.095860, -0.203970, 0.021090, 0.211260, -0.098870, -0.539720, -0.397230, 0.023830, 0.776900, 
0.633230, -0.458090, -0.790240, -0.390910, -0.090900, -0.250070, -0.107720, -0.528920, -0.232590, -0.357920, 
0.414160, 0.033570, -0.653410, -0.066960, -0.218230, 0.048940, 0.593720, 0.288500, 0.130760, -0.593270, 


  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[356] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.010000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, 0.009980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.009170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.002710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.008150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, -0.000540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.000910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, 0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, -0.006630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.008630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, -0.001360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, -0.001120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, 0.008980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, 0.009620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.004950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, -0.007520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.000630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, -0.008410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, -0.000310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, -0.006210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, 0.006230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.001410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, 0.008460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, -0.006310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, -0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, 0.007630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.007880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, -0.005690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, 0.002430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, -0.003580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.003620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, -0.005050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.009880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, -0.002490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.007470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.002350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.005420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, 0.006270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, 0.000070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, -0.000190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, 0.003680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, -0.004030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, 0.002660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, -0.007530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, 0.002580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, 0.001440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, -0.000850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, -0.003360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, 0.006580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, -0.006620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.007240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, -0.005380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.008950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, -0.009330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, 0.003310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.008360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, 0.004590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.008510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.003520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.006200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.000720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.001380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.000240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, -0.004780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, -0.007430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, -0.001560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, 0.003330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, 0.002140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, 0.006460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.007760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.007050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.006220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, -0.009100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.008090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.003720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.007460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, 0.009920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, 0.009990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, 0.006140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, -0.001740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, 0.002500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, 0.009460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.000700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, -0.005710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.001160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.004240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.007070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.000520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, 0.004670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, -0.005670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, 0.000640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.006060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.001060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.005140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.000680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, -0.007380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, 0.007320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, -0.006920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.009640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, -0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, -0.003400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, -0.006000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.007140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, -0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.005490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.002680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.008890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, -0.007700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.001100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.006740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.001500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.000400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, 0.009380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, -0.002170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, -0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.006350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.000500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, -0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, 0.003820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, -0.008850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.002240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, -0.008610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.008230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, 0.003250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, -0.000660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.005360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, -0.005040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.008180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.007080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, 0.006510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, 0.001620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, 0.004070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, 0.002440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, 0.001630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, 0.002380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, 0.004000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, 0.009580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, 0.009260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.005580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, 0.000110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, -0.007650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 165 (Old: 165) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 166 (Old: 166) */
      0.0, 0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 167 (Old: 167) */
      0.0, 0.007600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 168 (Old: 168) */
      0.0, -0.000960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 169 (Old: 169) */
      0.0, 0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 170 (Old: 170) */
      0.0, 0.000860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 171 (Old: 171) */
      0.0, -0.001760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 172 (Old: 172) */
      0.0, -0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 173 (Old: 173) */
      0.0, 0.008600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 174 (Old: 174) */
      0.0, -0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 175 (Old: 175) */
      0.0, 0.001940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 176 (Old: 176) */
      0.0, -0.001710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 177 (Old: 177) */
      0.0, 0.006180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 178 (Old: 178) */
      0.0, -0.007850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 179 (Old: 179) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 180 (Old: 180) */
      0.0, 0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 181 (Old: 181) */
      0.0, 0.007690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 182 (Old: 182) */
      0.0, 0.006820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 183 (Old: 183) */
      0.0, -0.009850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 184 (Old: 184) */
      0.0, -0.003630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 185 (Old: 185) */
      0.0, -0.006240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 186 (Old: 186) */
      0.0, -0.002840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 187 (Old: 187) */
      0.0, 0.003410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 188 (Old: 188) */
      0.0, -0.004750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 189 (Old: 189) */
      0.0, -0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 190 (Old: 190) */
      0.0, -0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 191 (Old: 191) */
      0.0, -0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 192 (Old: 192) */
      0.0, 0.002820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 193 (Old: 193) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 194 (Old: 194) */
      0.0, 0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 195 (Old: 195) */
      0.0, -0.006300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 196 (Old: 196) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 197 (Old: 197) */
      0.0, 0.004510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 198 (Old: 198) */
      0.0, 0.009110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 199 (Old: 199) */
      0.0, -0.002020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 200 (Old: 200) */
      0.0, -0.000280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 201 (Old: 201) */
      0.0, -0.002600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 202 (Old: 202) */
      0.0, 0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 203 (Old: 203) */
      0.0, 0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 204 (Old: 204) */
      0.0, 0.000950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 205 (Old: 205) */
      0.0, -0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 206 (Old: 206) */
      0.0, -0.004860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 207 (Old: 207) */
      0.0, 0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 208 (Old: 208) */
      0.0, -0.002360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 209 (Old: 209) */
      0.0, -0.002370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 210 (Old: 210) */
      0.0, -0.007090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 211 (Old: 211) */
      0.0, 0.006370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 212 (Old: 212) */
      0.0, 0.003840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 213 (Old: 213) */
      0.0, 0.009530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 214 (Old: 214) */
      0.0, 0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 215 (Old: 215) */
      0.0, -0.009030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 216 (Old: 216) */
      0.0, -0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 217 (Old: 217) */
      0.0, 0.005900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 218 (Old: 218) */
      0.0, -0.002080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 219 (Old: 219) */
      0.0, -0.008710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 220 (Old: 220) */
      0.0, -0.001190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 221 (Old: 221) */
      0.0, -0.000940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 222 (Old: 222) */
      0.0, 0.001220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 223 (Old: 223) */
      0.0, 0.001000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 224 (Old: 224) */
      0.0, 0.003860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 225 (Old: 225) */
      0.0, 0.005980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 226 (Old: 226) */
      0.0, 0.005680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 227 (Old: 227) */
      0.0, 0.009000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 228 (Old: 228) */
      0.0, 0.005810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 229 (Old: 229) */
      0.0, -0.001490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 230 (Old: 230) */
      0.0, -0.008300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 231 (Old: 231) */
      0.0, 0.001690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 232 (Old: 232) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 233 (Old: 233) */
      0.0, 0.002890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 234 (Old: 234) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 235 (Old: 235) */
      0.0, 0.002160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 236 (Old: 236) */
      0.0, 0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 237 (Old: 237) */
      0.0, 0.004290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 238 (Old: 238) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 239 (Old: 239) */
      0.0, 0.001110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 240 (Old: 240) */
      0.0, -0.008520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 241 (Old: 241) */
      0.0, -0.008430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 242 (Old: 242) */
      0.0, -0.002120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 243 (Old: 243) */
      0.0, -0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 244 (Old: 244) */
      0.0, 0.009710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 245 (Old: 245) */
      0.0, -0.003730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 246 (Old: 246) */
      0.0, -0.006890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 247 (Old: 247) */
      0.0, 0.007410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 248 (Old: 248) */
      0.0, 0.008810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 249 (Old: 249) */
      0.0, 0.009740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 250 (Old: 250) */
      0.0, 0.002180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 251 (Old: 251) */
      0.0, -0.007310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 252 (Old: 252) */
      0.0, 0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 253 (Old: 253) */
      0.0, -0.008490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 254 (Old: 254) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 255 (Old: 255) */
      0.0, -0.003240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 256 (Old: 256) */
      0.0, -0.003100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 257 (Old: 257) */
      0.0, 0.008470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 258 (Old: 258) */
      0.0, 0.008140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 259 (Old: 259) */
      0.0, 0.009930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 260 (Old: 260) */
      0.0, -0.000530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 261 (Old: 261) */
      0.0, -0.005800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 262 (Old: 262) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 263 (Old: 263) */
      0.0, -0.000920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 264 (Old: 264) */
      0.0, -0.005970, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 265 (Old: 265) */
      0.0, -0.004540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 266 (Old: 266) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 267 (Old: 267) */
      0.0, 0.004900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 268 (Old: 268) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 269 (Old: 269) */
      0.0, 0.000340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 270 (Old: 270) */
      0.0, 0.000650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 271 (Old: 271) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 272 (Old: 272) */
      0.0, -0.000080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 273 (Old: 273) */
      0.0, -0.007170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 274 (Old: 274) */
      0.0, 0.009800, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 275 (Old: 275) */
      0.0, -0.006430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 276 (Old: 276) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 277 (Old: 277) */
      0.0, 0.009610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 278 (Old: 278) */
      0.0, -0.008590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 279 (Old: 279) */
      0.0, 0.008740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 280 (Old: 280) */
      0.0, 0.009240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 281 (Old: 281) */
      0.0, 0.006190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 282 (Old: 282) */
      0.0, 0.004470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 283 (Old: 283) */
      0.0, 0.001050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 284 (Old: 284) */
      0.0, -0.002990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 285 (Old: 285) */
      0.0, 0.006980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 286 (Old: 286) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 287 (Old: 287) */
      0.0, -0.002990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 288 (Old: 288) */
      0.0, -0.000690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 289 (Old: 289) */
      0.0, 0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 290 (Old: 290) */
      0.0, 0.002120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 291 (Old: 291) */
      0.0, -0.004440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 292 (Old: 292) */
      0.0, -0.004490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 293 (Old: 293) */
      0.0, 0.003880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 294 (Old: 294) */
      0.0, 0.007870, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 295 (Old: 295) */
      0.0, -0.008220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 296 (Old: 296) */
      0.0, -0.004820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 297 (Old: 297) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 298 (Old: 298) */
      0.0, -0.003030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 299 (Old: 299) */
      0.0, 0.002630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 300 (Old: 300) */
      0.0, 0.009480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 301 (Old: 301) */
      0.0, -0.006990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 302 (Old: 302) */
      0.0, 0.009160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 303 (Old: 303) */
      0.0, 0.008880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 304 (Old: 304) */
      0.0, 0.001480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 305 (Old: 305) */
      0.0, 0.000410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 306 (Old: 306) */
      0.0, -0.000030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 307 (Old: 307) */
      0.0, -0.009610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 308 (Old: 308) */
      0.0, -0.002150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 309 (Old: 309) */
      0.0, -0.008250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 310 (Old: 310) */
      0.0, -0.005010, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 311 (Old: 311) */
      0.0, -0.004280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 312 (Old: 312) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 313 (Old: 313) */
      0.0, -0.137970, 312,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 314 (Old: 314) */
      0.0, -0.457600, 312,
       &Sources[312] , 
       &Weights[312] , 
      },
    { /* unit 315 (Old: 315) */
      0.0, -0.222390, 312,
       &Sources[624] , 
       &Weights[624] , 
      },
    { /* unit 316 (Old: 316) */
      0.0, -0.243710, 312,
       &Sources[936] , 
       &Weights[936] , 
      },
    { /* unit 317 (Old: 317) */
      0.0, -0.186550, 312,
       &Sources[1248] , 
       &Weights[1248] , 
      },
    { /* unit 318 (Old: 318) */
      0.0, -0.203390, 312,
       &Sources[1560] , 
       &Weights[1560] , 
      },
    { /* unit 319 (Old: 319) */
      0.0, -0.222890, 312,
       &Sources[1872] , 
       &Weights[1872] , 
      },
    { /* unit 320 (Old: 320) */
      0.0, -0.239130, 312,
       &Sources[2184] , 
       &Weights[2184] , 
      },
    { /* unit 321 (Old: 321) */
      0.0, -0.330580, 312,
       &Sources[2496] , 
       &Weights[2496] , 
      },
    { /* unit 322 (Old: 322) */
      0.0, -0.146460, 312,
       &Sources[2808] , 
       &Weights[2808] , 
      },
    { /* unit 323 (Old: 323) */
      0.0, -0.288520, 312,
       &Sources[3120] , 
       &Weights[3120] , 
      },
    { /* unit 324 (Old: 324) */
      0.0, -0.209130, 312,
       &Sources[3432] , 
       &Weights[3432] , 
      },
    { /* unit 325 (Old: 325) */
      0.0, -0.117420, 312,
       &Sources[3744] , 
       &Weights[3744] , 
      },
    { /* unit 326 (Old: 326) */
      0.0, -0.252290, 312,
       &Sources[4056] , 
       &Weights[4056] , 
      },
    { /* unit 327 (Old: 327) */
      0.0, -0.275270, 312,
       &Sources[4368] , 
       &Weights[4368] , 
      },
    { /* unit 328 (Old: 328) */
      0.0, -0.324170, 312,
       &Sources[4680] , 
       &Weights[4680] , 
      },
    { /* unit 329 (Old: 329) */
      0.0, -0.286810, 312,
       &Sources[4992] , 
       &Weights[4992] , 
      },
    { /* unit 330 (Old: 330) */
      0.0, -0.264400, 312,
       &Sources[5304] , 
       &Weights[5304] , 
      },
    { /* unit 331 (Old: 331) */
      0.0, -0.108030, 312,
       &Sources[5616] , 
       &Weights[5616] , 
      },
    { /* unit 332 (Old: 332) */
      0.0, -0.427260, 312,
       &Sources[5928] , 
       &Weights[5928] , 
      },
    { /* unit 333 (Old: 333) */
      0.0, -0.447910, 312,
       &Sources[6240] , 
       &Weights[6240] , 
      },
    { /* unit 334 (Old: 334) */
      0.0, -0.214660, 312,
       &Sources[6552] , 
       &Weights[6552] , 
      },
    { /* unit 335 (Old: 335) */
      0.0, -0.319950, 312,
       &Sources[6864] , 
       &Weights[6864] , 
      },
    { /* unit 336 (Old: 336) */
      0.0, -0.075520, 312,
       &Sources[7176] , 
       &Weights[7176] , 
      },
    { /* unit 337 (Old: 337) */
      0.0, -0.089920, 312,
       &Sources[7488] , 
       &Weights[7488] , 
      },
    { /* unit 338 (Old: 338) */
      0.0, -0.135870, 312,
       &Sources[7800] , 
       &Weights[7800] , 
      },
    { /* unit 339 (Old: 339) */
      0.0, -0.270950, 312,
       &Sources[8112] , 
       &Weights[8112] , 
      },
    { /* unit 340 (Old: 340) */
      0.0, -0.196140, 312,
       &Sources[8424] , 
       &Weights[8424] , 
      },
    { /* unit 341 (Old: 341) */
      0.0, -0.100820, 312,
       &Sources[8736] , 
       &Weights[8736] , 
      },
    { /* unit 342 (Old: 342) */
      0.0, -0.273610, 312,
       &Sources[9048] , 
       &Weights[9048] , 
      },
    { /* unit 343 (Old: 343) */
      0.0, -0.393860, 312,
       &Sources[9360] , 
       &Weights[9360] , 
      },
    { /* unit 344 (Old: 344) */
      0.0, -0.110960, 312,
       &Sources[9672] , 
       &Weights[9672] , 
      },
    { /* unit 345 (Old: 345) */
      0.0, -0.273660, 312,
       &Sources[9984] , 
       &Weights[9984] , 
      },
    { /* unit 346 (Old: 346) */
      0.0, -0.100020, 312,
       &Sources[10296] , 
       &Weights[10296] , 
      },
    { /* unit 347 (Old: 347) */
      0.0, -0.147720, 312,
       &Sources[10608] , 
       &Weights[10608] , 
      },
    { /* unit 348 (Old: 348) */
      0.0, -0.227290, 312,
       &Sources[10920] , 
       &Weights[10920] , 
      },
    { /* unit 349 (Old: 349) */
      0.0, -0.322070, 312,
       &Sources[11232] , 
       &Weights[11232] , 
      },
    { /* unit 350 (Old: 350) */
      0.0, -0.236910, 312,
       &Sources[11544] , 
       &Weights[11544] , 
      },
    { /* unit 351 (Old: 351) */
      0.0, -0.137220, 312,
       &Sources[11856] , 
       &Weights[11856] , 
      },
    { /* unit 352 (Old: 352) */
      0.0, -0.220630, 312,
       &Sources[12168] , 
       &Weights[12168] , 
      },
    { /* unit 353 (Old: 353) */
      0.0, -0.603090, 40,
       &Sources[12480] , 
       &Weights[12480] , 
      },
    { /* unit 354 (Old: 354) */
      0.0, -0.163730, 40,
       &Sources[12520] , 
       &Weights[12520] , 
      },
    { /* unit 355 (Old: 355) */
      0.0, -0.107430, 40,
       &Sources[12560] , 
       &Weights[12560] , 
      }

  };



int step3_net111(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[312] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, Units + 231, Units + 232, Units + 233, Units + 234, Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, Units + 265, Units + 266, Units + 267, Units + 268, Units + 269, Units + 270, Units + 271, Units + 272, Units + 273, Units + 274, Units + 275, Units + 276, Units + 277, Units + 278, Units + 279, Units + 280, Units + 281, Units + 282, Units + 283, Units + 284, Units + 285, Units + 286, Units + 287, Units + 288, Units + 289, Units + 290, Units + 291, Units + 292, Units + 293, Units + 294, Units + 295, Units + 296, Units + 297, Units + 298, Units + 299, Units + 300, Units + 301, Units + 302, Units + 303, Units + 304, Units + 305, Units + 306, Units + 307, Units + 308, Units + 309, Units + 310, Units + 311, Units + 312}; /* members */

  static pUnit Hidden1[40] = {Units + 313, Units + 314, Units + 315, Units + 316, Units + 317, Units + 318, Units + 319, Units + 320, Units + 321, Units + 322, Units + 323, Units + 324, Units + 325, Units + 326, Units + 327, Units + 328, Units + 329, Units + 330, Units + 331, Units + 332, Units + 333, Units + 334, Units + 335, Units + 336, Units + 337, Units + 338, Units + 339, Units + 340, Units + 341, Units + 342, Units + 343, Units + 344, Units + 345, Units + 346, Units + 347, Units + 348, Units + 349, Units + 350, Units + 351, Units + 352}; /* members */

  static pUnit Output1[3] = {Units + 353, Units + 354, Units + 355}; /* members */

  static int Output[3] = {353, 354, 355};

  for(member = 0; member < 312; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 40; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
