/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  step4_net.c
  --------------------------------------------------------
  generated at Mon Jun 28 19:01:09 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[268];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, 
Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, 
Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, 

Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, 
Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, 
Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, 

Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, 
Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, 
Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, 


  };

  /* Weigths definition section */
  static float Weights[] =  {
0.285510, 0.122030, -0.414060, 0.183430, 0.003460, -0.236800, 0.246640, 0.295940, -0.132470, 0.154120, 
0.161180, -0.024330, 0.237270, -0.021160, 0.211940, 0.099190, 0.080730, -0.068770, 0.102280, 0.075990, 
-0.290600, -0.102890, -0.122550, 0.122840, -0.066900, 0.084110, 0.236880, -0.196470, 0.190930, -0.092980, 
0.248600, -0.028390, 0.204020, 0.105490, 0.075770, -0.069220, -0.149120, 0.105140, -0.205620, -0.252050, 
-0.197840, 0.213490, -0.155390, -0.095170, 0.356790, -0.129580, 0.110980, -0.129120, 0.240080, -0.034330, 
0.182780, 0.093840, 0.069910, -0.095950, -0.291510, 0.184420, -0.253940, -0.102740, -0.176910, 0.193600, 
0.013240, -0.104420, 0.226370, -0.126330, 0.111540, -0.109630, 0.185680, -0.038660, 0.176830, 0.084970, 
0.070460, -0.122200, -0.362230, 0.262020, -0.104930, -0.066690, -0.232890, 0.330490, 0.027920, -0.062440, 
0.310190, 0.175240, -0.515630, -0.108950, 0.216280, -0.036000, 0.163140, 0.087440, 0.061130, -0.099630, 
-0.240630, 0.640580, -0.712090, -0.042460, 0.165940, -0.172910, 0.063410, 0.136610, -0.123330, 0.138410, 
0.012560, -0.093230, 0.247540, -0.050860, 0.159680, 0.079330, 0.064550, -0.101240, -0.235370, 1.486880, 
-1.643310, 0.063630, 0.458610, -1.085960, 0.235170, 0.163730, -0.857320, -0.073960, -0.285540, -0.184520, 
0.152470, -0.048020, 0.122300, 0.067340, 0.036530, -0.116700, -0.383690, 0.783170, -0.768030, -0.142380, 
0.046680, -0.258410, 0.092940, -0.116310, -0.035150, 0.078030, -0.054410, -0.134270, 0.233070, -0.047260, 
0.156450, 0.080930, 0.064000, -0.099420, -0.481410, 0.215540, -0.019240, -0.256380, -0.206040, 0.201080, 
-0.038580, -0.358860, 0.343880, -0.160280, -0.017600, -0.080010, 0.242880, -0.032070, 0.160170, 0.086370, 
0.071370, -0.078960, -0.328570, 0.278020, -0.313060, -0.204670, -0.042400, -0.038030, 0.004150, -0.343550, 
0.099900, -0.175810, 0.218390, -0.011210, 0.157120, -0.039800, 0.157790, 0.086340, 0.056250, -0.071990, 
-0.272030, 0.356300, -0.294070, -0.095610, -0.195810, 0.054060, -0.048340, -0.188640, -0.063180, 0.086290, 
0.031210, 0.052610, 0.145410, -0.021710, 0.167180, 0.088450, 0.052300, -0.057920, -0.196370, 0.355610, 
-0.138930, 0.017010, -0.212760, 0.151930, 0.025790, 0.044870, -0.204600, 0.088340, 0.058840, 0.113940, 
0.211210, -0.014470, 0.163980, 0.105400, 0.063020, -0.043250, 0.079020, 0.272370, -0.254120, 0.213270, 
-0.009990, -0.263040, 0.224200, 0.237870, -0.536250, -0.057230, -0.037600, 0.160550, 0.243400, -0.006840, 
0.168790, 0.115990, 0.075070, -0.021560, 
-0.142210, -0.015230, 0.325680, -0.280710, 0.165620, 0.258590, -0.263570, 0.560550, -0.207830, -0.081390, 
0.013240, 0.126590, -0.192090, 0.073450, -0.154590, -0.009000, 0.004110, -0.039840, 0.062300, -0.176480, 
0.153650, 0.159540, -0.113010, 0.096480, -0.032940, 0.284300, -0.215210, -0.172380, -0.155650, 0.180010, 
-0.187280, 0.080290, -0.155570, -0.014410, -0.002730, -0.030450, -0.046200, -0.189600, 0.110670, 0.147850, 
-0.084410, 0.084000, -0.082930, 0.150630, -0.127050, -0.131580, -0.208910, 0.236900, -0.213010, 0.069820, 
-0.160380, -0.018140, -0.014310, -0.039050, 0.214940, -0.363280, -0.084480, 0.188410, -0.089940, 0.001200, 
-0.048100, 0.000890, -0.138050, -0.324170, 0.188160, 0.165400, -0.211940, 0.071140, -0.180910, -0.032880, 
-0.036540, -0.047760, 0.350270, -0.335590, -0.276080, -0.044470, -0.143000, 0.144200, -0.326670, -0.124220, 
0.140110, -0.640570, 0.182290, 0.088230, -0.266750, 0.068640, -0.205910, -0.035960, -0.040800, -0.055950, 
0.158410, -0.036340, -0.276650, -0.265920, 0.056940, -0.049470, -0.603790, -0.002470, 0.134630, -0.404840, 
-0.121100, 0.006350, -0.255770, 0.072030, -0.213540, -0.045590, -0.046080, -0.076210, 1.060480, 0.237000, 
-1.712320, 1.037590, 0.219880, -1.900140, 0.358060, 0.176300, -1.307420, -0.063640, -0.193810, -0.076110, 
-0.304520, 0.068610, -0.240610, -0.071320, -0.066800, -0.081280, 0.047280, 0.139540, -0.959970, -0.028250, 
0.231530, -1.046220, -0.396280, 0.476370, -0.764820, 0.353860, 0.390280, -0.042990, -0.287590, 0.068870, 
-0.238860, -0.066130, -0.055020, -0.079010, 0.184070, -0.018070, -0.883090, 0.311910, 0.108790, -1.064200, 
-0.099240, 0.452950, -0.806500, 0.363700, 0.458300, -0.037940, -0.283950, 0.065110, -0.241200, -0.050800, 
-0.051710, -0.065180, 0.286360, -0.223340, -0.749240, 0.439480, -0.149560, -0.717680, 0.189340, 0.137070, 
-0.587390, 0.537130, 0.074050, 0.004480, -0.280060, 0.071510, -0.234040, -0.045300, -0.053010, -0.071610, 
0.347480, -0.424500, -0.533350, 0.313640, -0.257620, -0.296380, 0.220410, -0.053230, -0.268990, 0.176430, 
-0.030670, 0.027040, -0.261240, 0.070860, -0.228020, -0.034370, -0.048110, -0.071760, 0.168950, -0.348100, 
-0.357180, 0.129310, -0.300330, -0.210180, 0.112560, -0.185790, -0.136840, -0.210210, -0.224100, 0.020920, 
-0.269630, 0.073610, -0.232410, -0.031370, -0.036830, -0.072470, 0.021490, -0.415540, -0.183970, -0.313680, 
-0.354480, 0.151330, -0.282620, -0.160710, 0.061990, -0.242050, -0.254420, -0.071570, -0.272220, 0.056830, 
-0.233210, -0.025140, -0.057240, -0.085890, 
0.210760, 0.314650, -0.320480, 0.071570, 0.136770, -0.212340, 0.132920, -0.074000, 0.170270, 0.104640, 
0.255310, -0.133070, 0.494220, -0.035240, 0.134510, 0.072050, 0.032350, -0.022820, 0.212450, 0.211960, 
-0.273770, 0.029840, 0.127070, -0.128210, 0.105450, -0.100690, 0.205510, -0.065930, 0.010490, -0.151870, 
0.484190, -0.040540, 0.140240, 0.087860, 0.018040, -0.023950, 0.212410, 0.058510, -0.211410, 0.095260, 
-0.041440, -0.103600, 0.158290, -0.197330, 0.165550, 0.061940, -0.002700, -0.193550, 0.473970, -0.031570, 
0.116320, 0.072980, 0.024740, -0.042190, 0.060980, 0.072260, -0.315990, 0.106530, -0.149130, -0.130240, 
0.192490, -0.262140, 0.001580, 0.085920, 0.231170, -0.280980, 0.416750, -0.040430, 0.113110, 0.078960, 
-0.000270, -0.050650, -0.340320, 0.278400, -0.118150, -0.089890, -0.128090, -0.129270, 0.035290, -0.303650, 
0.054530, 0.169570, 0.147920, -0.346140, 0.390740, -0.051550, 0.099460, 0.074130, -0.014700, -0.067740, 
-0.713890, 0.671780, -0.112680, -0.228180, 0.012980, -0.151950, -0.138750, -0.087790, 0.003180, 0.109180, 
0.415560, -0.392460, 0.434290, -0.057870, 0.101500, 0.078190, -0.005670, -0.053080, -1.007640, 0.976980, 
-0.109240, -0.511470, 0.190620, -0.137700, -0.594160, 0.163060, 0.044150, 0.066470, 0.280400, -0.433870, 
0.394250, -0.059550, 0.079220, 0.058790, -0.020460, -0.062250, -0.577350, 0.791560, -0.295470, -0.150700, 
0.195510, -0.343340, -0.234580, 0.050670, -0.124260, 0.221010, 0.251500, -0.415290, 0.431990, -0.051190, 
0.090240, 0.057900, -0.017920, -0.047960, -0.369020, 0.511550, -0.192650, -0.134260, 0.116870, -0.230240, 
-0.055290, -0.158060, -0.062490, 0.107930, 0.268060, -0.269920, 0.429250, -0.046650, 0.120450, 0.064010, 
0.006310, -0.043590, -0.323270, 0.349390, -0.196100, -0.118950, 0.126670, -0.319990, 0.057960, -0.234680, 
-0.171870, 0.315650, 0.161720, -0.167760, 0.377900, -0.042050, 0.131060, 0.075450, -0.002200, -0.031550, 
-0.350590, 0.333300, -0.133240, -0.180610, 0.022190, -0.164410, 0.078590, -0.182860, -0.150510, 0.243270, 
0.085440, -0.072400, 0.365730, -0.040930, 0.131010, 0.064380, -0.001920, -0.034330, -0.339530, 0.390310, 
-0.041850, -0.164430, -0.108190, -0.011740, 0.098640, -0.100560, -0.146700, 0.095110, 0.078920, 0.000280, 
0.373720, -0.034600, 0.137540, 0.068470, -0.018100, -0.010450, -0.243600, 0.312320, 0.030690, 0.041160, 
-0.130090, -0.067640, 0.200760, -0.053280, -0.148470, -0.071690, 0.092680, 0.083400, 0.379030, -0.023640, 
0.151050, 0.080830, 0.004320, 0.001230, 
0.193200, -0.175250, -0.135770, -0.110480, 0.003020, -0.363020, -0.262200, -0.208850, -0.171840, 0.007450, 
0.377960, 0.131070, -0.033420, 0.010280, 0.011990, -0.016040, -0.055750, 0.165240, 0.184720, -0.249970, 
-0.004310, -0.146460, 0.042960, -0.276840, -0.220440, -0.141390, -0.145250, -0.089830, 0.169190, 0.167650, 
-0.033290, 0.012870, 0.035280, -0.019250, -0.041480, 0.158080, 0.349840, -0.171150, 0.088880, 0.031960, 
-0.126180, -0.185350, -0.087450, -0.169970, -0.125790, -0.232500, -0.208040, 0.210770, -0.013880, 0.010140, 
0.047640, -0.002530, -0.046650, 0.170860, 0.265040, 0.004350, -0.076410, 0.104790, 0.013100, -0.475640, 
0.005570, -0.152050, -0.311160, -0.212920, -0.198040, 0.218120, -0.028570, 0.010640, 0.046530, 0.002750, 
-0.047330, 0.188860, 0.021290, 0.072540, -0.106550, 0.027240, 0.099240, -0.688480, -0.089600, -0.119380, 
-0.548700, -0.035750, -0.388110, 0.067810, -0.082590, 0.012170, 0.032690, -0.017040, -0.061810, 0.166760, 
-0.436940, -0.190120, 0.238810, -0.124510, -0.004290, -0.576150, -0.280840, -0.222280, -0.515590, -0.308290, 
-0.283340, 0.011780, -0.237470, -0.004790, 0.007960, -0.033290, -0.087600, 0.146520, -0.943210, -0.446320, 
1.447400, -0.878970, -0.222790, 0.884820, -1.092060, -0.470120, 0.936370, -0.154790, -0.324350, 0.072410, 
-0.136790, 0.003890, 0.029880, -0.011800, -0.073670, 0.160370, 0.217540, -0.439040, 0.196270, 0.158570, 
-0.272340, -0.298160, -0.136420, -0.625900, -0.139210, -0.170150, -0.307590, 0.028120, -0.211100, -0.012920, 
0.034460, -0.030480, -0.085960, 0.161140, 0.535120, -0.176570, 0.079790, 0.127930, -0.128920, -0.108820, 
0.072910, -0.416830, 0.028670, -0.068040, -0.175090, 0.212330, -0.049560, 0.008710, 0.064020, -0.007890, 
-0.053720, 0.162530, 0.455360, -0.130960, 0.191580, 0.058260, 0.001020, -0.196480, 0.170520, -0.322160, 
-0.002440, 0.053410, -0.389600, 0.220900, 0.027860, 0.014420, 0.086600, -0.015460, -0.050520, 0.165090, 
0.343340, -0.235020, 0.274400, -0.006010, -0.000440, -0.015550, 0.269460, -0.174950, 0.051300, 0.048860, 
-0.060040, 0.226780, 0.061700, 0.013640, 0.084400, -0.020940, -0.029590, 0.170230, 0.171260, -0.171500, 
0.310550, -0.089990, 0.023650, 0.120790, 0.187270, 0.004160, 0.083490, 0.200490, -0.019460, 0.250790, 
0.052370, 0.034200, 0.102100, -0.037840, -0.044760, 0.147470, -0.006630, -0.052240, 0.234170, 0.062080, 
-0.093210, 0.019290, 0.278610, -0.284630, 0.215940, 0.152650, 0.095570, 0.258260, 0.030330, 0.019250, 
0.090530, -0.035070, -0.038210, 0.161820, 
-0.017270, -0.013040, 0.026700, -0.144930, 0.078770, -0.098990, -0.137870, -0.113430, -0.014160, 0.006610, 
-0.010740, 0.055760, -0.019580, -0.004090, -0.038520, 0.010380, 0.026430, 0.063390, 0.001370, -0.063900, 
0.040650, -0.125490, 0.018630, -0.045900, -0.116640, -0.113890, -0.018580, -0.056100, -0.081240, 0.082500, 
-0.038070, -0.002730, -0.031600, 0.012660, 0.013280, 0.069020, 0.055910, -0.022330, 0.065520, -0.073270, 
0.003350, -0.033710, -0.037550, -0.074710, -0.038140, -0.035350, -0.190130, 0.125360, -0.022490, -0.010210, 
-0.031610, 0.013620, 0.018600, 0.068890, 0.013130, 0.011530, 0.043180, -0.084460, 0.108360, -0.163210, 
-0.016540, -0.042550, -0.107440, -0.096080, -0.076460, 0.116770, -0.027740, -0.002150, -0.027310, 0.007480, 
0.016050, 0.071350, -0.096830, -0.029290, 0.103140, -0.151310, 0.102220, -0.172690, -0.119580, -0.081730, 
-0.131740, -0.081570, -0.002160, 0.040750, -0.060290, -0.006540, -0.021370, 0.013150, 0.005900, 0.074770, 
-0.302120, -0.224480, 0.215230, -0.244910, -0.023150, -0.190920, -0.238970, -0.203750, -0.125940, -0.212270, 
-0.026180, -0.057890, -0.161070, -0.018090, -0.055600, -0.014650, -0.004850, 0.040970, -0.410890, -0.412470, 
0.727350, -0.485470, -0.134590, 0.402260, -0.562530, -0.321270, 0.482540, -0.023400, 0.063840, -0.032850, 
-0.107420, -0.008870, -0.041320, 0.005030, 0.006060, 0.055110, -0.092400, -0.308110, 0.170340, -0.139050, 
-0.113900, -0.123900, -0.232360, -0.314210, -0.037320, -0.077850, 0.037080, -0.052390, -0.155420, -0.010920, 
-0.036630, -0.003430, -0.018340, 0.053570, 0.024570, -0.066020, 0.056130, -0.086820, 0.010990, -0.088390, 
-0.131910, -0.103300, -0.009000, 0.059620, 0.029940, 0.013270, -0.064390, -0.011440, -0.015980, -0.001390, 
0.006710, 0.064900, 0.014890, -0.014350, 0.041380, -0.091870, 0.063570, -0.111830, -0.064630, -0.033680, 
-0.031430, 0.003730, -0.108080, 0.023820, -0.006500, 0.000830, -0.009800, -0.003260, 0.011550, 0.060860, 
-0.013890, -0.073400, 0.046240, -0.121450, 0.052650, -0.036640, -0.015960, -0.000880, 0.001460, -0.025360, 
0.007150, 0.005170, 0.013340, 0.006310, -0.005670, -0.010490, 0.019890, 0.044430, -0.097400, -0.109860, 
0.100870, -0.104020, 0.031080, -0.039420, 0.009770, -0.025820, 0.030730, -0.055300, -0.067510, 0.022910, 
-0.008600, -0.002450, -0.010310, -0.000140, 0.008790, 0.046020, -0.100510, -0.140210, 0.059460, 0.016610, 
-0.076160, -0.067580, 0.124570, -0.242140, 0.108960, -0.070010, -0.008130, 0.021770, -0.014530, 0.005450, 
-0.011940, -0.012670, 0.020080, 0.045930, 
-0.071070, -0.029260, -0.036680, -0.098560, -0.002060, -0.059580, -0.076500, -0.046030, -0.074950, -0.085140, 
-0.081490, -0.057790, -0.060240, 0.006000, -0.050880, -0.008530, -0.007960, -0.018930, -0.058690, -0.019420, 
-0.037900, -0.083260, -0.026800, -0.067560, -0.073280, -0.038470, -0.081700, -0.046260, -0.010610, -0.056880, 
-0.059030, 0.012690, -0.043750, -0.000100, -0.024190, -0.004960, -0.066890, 0.005320, -0.047470, -0.097860, 
-0.000420, -0.056990, -0.094720, -0.012770, -0.079230, -0.013940, -0.027340, -0.037980, -0.065750, 0.011200, 
-0.044180, 0.001520, -0.010050, -0.002080, -0.046400, 0.023480, -0.053260, -0.101840, 0.014660, -0.074510, 
-0.097190, -0.039750, -0.089960, -0.057490, -0.014900, -0.060960, -0.054690, 0.010340, -0.054810, -0.004350, 
-0.024250, -0.009620, -0.009210, -0.074080, -0.060360, -0.101720, -0.051130, -0.060370, -0.106350, -0.101250, 
-0.067200, -0.115010, -0.017450, -0.067670, -0.071750, -0.002110, -0.051640, -0.008300, -0.013860, -0.015770, 
0.033890, -0.172840, -0.045650, -0.100200, -0.132280, -0.038430, -0.098690, -0.187690, -0.019850, -0.135890, 
-0.067430, -0.076540, -0.086540, 0.004170, -0.049750, -0.016340, -0.025190, -0.019700, 0.142810, -0.285170, 
-0.059970, 0.027590, -0.181570, -0.052170, 0.027320, -0.268160, -0.047150, -0.089960, -0.069070, -0.071330, 
-0.083080, -0.004850, -0.052500, -0.010620, -0.013610, -0.003520, 0.037200, -0.234810, -0.063130, -0.044170, 
-0.165270, -0.049480, -0.019330, -0.211000, -0.058800, -0.121010, -0.081560, -0.071790, -0.091730, 0.010760, 
-0.058040, -0.016030, -0.030730, -0.012860, 0.007560, -0.140840, -0.071780, -0.004470, -0.123970, -0.084360, 
-0.030420, -0.118440, -0.071810, -0.074560, -0.071560, -0.082740, -0.057220, 0.011570, -0.053960, -0.011570, 
-0.024830, -0.003780, 0.005040, -0.078970, -0.056540, -0.001350, -0.096140, -0.031930, -0.021210, -0.058800, 
-0.045380, -0.074910, -0.055330, -0.081640, -0.027990, -0.005050, -0.059050, -0.013130, -0.022100, -0.015190, 
-0.006070, -0.041600, -0.061220, -0.012340, -0.051460, -0.016030, -0.047160, -0.013700, -0.036640, -0.077630, 
-0.023600, -0.080930, -0.022850, 0.010440, -0.047080, 0.002880, -0.015330, -0.002070, 0.001130, -0.050430, 
-0.062170, 0.011460, -0.013580, -0.046100, -0.041310, -0.022640, -0.027030, -0.038080, -0.043790, -0.082250, 
-0.024600, 0.007040, -0.041230, -0.000390, -0.011830, -0.004030, 0.010270, -0.026710, -0.063930, 0.008620, 
-0.006710, -0.042060, -0.011220, -0.019370, -0.030220, -0.000770, -0.058210, -0.088740, -0.008180, -0.001850, 
-0.036800, -0.005350, -0.005250, -0.008200, 
-0.008670, 0.021150, -0.070280, -0.153940, 0.067370, -0.088050, -0.033620, -0.183830, -0.078400, 0.097030, 
0.058820, -0.155700, 0.234940, 0.024750, -0.078900, 0.028820, -0.038560, -0.044130, -0.029840, 0.056740, 
-0.019650, -0.188320, 0.006690, 0.007710, -0.091630, -0.183260, -0.010410, 0.163020, 0.105500, -0.104890, 
0.233450, 0.011460, -0.091390, 0.025260, -0.047470, -0.031700, -0.013410, 0.130290, -0.045220, -0.202140, 
0.011760, 0.047560, -0.202890, -0.133020, 0.026520, 0.227840, 0.064180, -0.089660, 0.224920, 0.026790, 
-0.066430, 0.026580, -0.044240, -0.025180, 0.037660, 0.063800, -0.071890, -0.176420, -0.019170, -0.058930, 
-0.203810, -0.233110, -0.070480, 0.067410, 0.020820, -0.104560, 0.225720, 0.031950, -0.081860, 0.026730, 
-0.056040, -0.013470, 0.163990, -0.310100, 0.033520, -0.120980, -0.326770, 0.100060, -0.130320, -0.504290, 
0.030710, -0.036740, -0.086610, -0.144680, 0.199140, 0.017660, -0.092820, 0.021880, -0.051910, -0.019170, 
0.409180, -0.797150, 0.092000, -0.056820, -0.575900, 0.105590, -0.038480, -0.825340, 0.114670, -0.069060, 
-0.212280, -0.210930, 0.126510, 0.020540, -0.103060, 0.023730, -0.075230, -0.034140, 0.761850, -0.928680, 
-0.151660, 0.260290, -0.651070, -0.059900, 0.364890, -1.032110, 0.058670, -0.027100, -0.262660, -0.196880, 
0.162790, 0.019030, -0.090020, 0.010780, -0.057160, -0.032820, 0.287370, -0.764750, -0.033810, 0.030270, 
-0.606600, -0.000420, 0.191660, -0.846760, 0.048640, -0.136170, -0.177270, -0.194900, 0.125050, 0.014140, 
-0.101290, 0.017070, -0.078190, -0.048320, 0.133170, -0.425450, -0.061130, 0.075800, -0.389690, -0.014310, 
0.094130, -0.419530, -0.001950, -0.101600, -0.098050, -0.170600, 0.216580, 0.018810, -0.084080, 0.025650, 
-0.050430, -0.024450, 0.097260, -0.131910, -0.099190, 0.069610, -0.220930, 0.054790, -0.001600, -0.105010, 
0.043890, -0.077740, 0.000470, -0.139210, 0.301990, 0.023330, -0.079680, 0.027290, -0.041840, -0.022220, 
0.018320, -0.032490, -0.073830, 0.037860, -0.102880, 0.101130, -0.101960, 0.093540, 0.089750, 0.013770, 
0.041970, -0.119530, 0.337200, 0.026480, -0.062670, 0.028890, -0.033860, -0.020390, -0.022150, -0.068250, 
0.006010, 0.066360, -0.027000, 0.079810, -0.117000, 0.184040, 0.121150, 0.106030, 0.026530, -0.123400, 
0.376510, 0.035670, -0.062820, 0.040810, -0.013200, -0.017910, 0.127200, 0.083120, -0.130850, 0.135970, 
0.095680, 0.006830, -0.020330, 0.275760, 0.095610, 0.159820, -0.045330, -0.139630, 0.410530, 0.031200, 
-0.065940, 0.038590, -0.010380, -0.021880, 
-0.039580, -0.054920, -0.097210, 0.002530, -0.108980, -0.101530, 0.030860, -0.062150, -0.218250, -0.335430, 
-0.123320, -0.180760, -0.079520, 0.016490, -0.070840, -0.022990, -0.034940, -0.051810, 0.020270, -0.111910, 
-0.110710, 0.098250, -0.176210, -0.112440, 0.038390, -0.132380, -0.182910, -0.126300, 0.126510, -0.153860, 
-0.074590, 0.018090, -0.077570, -0.016790, -0.023020, -0.046880, 0.101130, -0.118930, -0.159230, 0.095670, 
-0.179570, -0.141160, 0.022710, -0.134240, -0.184370, 0.128240, 0.270750, -0.161370, -0.072120, 0.029010, 
-0.081450, -0.009070, -0.037590, -0.063050, 0.135120, -0.108680, -0.195620, 0.118530, -0.171270, -0.188130, 
0.050170, -0.168470, -0.229020, 0.204030, 0.307340, -0.187700, -0.080240, 0.025980, -0.081280, -0.012280, 
-0.038890, -0.062460, 0.164760, -0.118910, -0.267530, 0.045480, -0.209280, -0.208510, -0.010900, -0.228870, 
-0.215420, 0.017860, 0.235760, -0.217360, -0.087380, 0.013650, -0.077000, -0.026260, -0.046400, -0.071300, 
0.248260, -0.142090, -0.332530, -0.010630, -0.194670, -0.226850, -0.080640, -0.246620, -0.179320, 0.014550, 
0.038330, -0.227890, -0.101880, 0.025650, -0.093550, -0.024450, -0.046950, -0.073290, 0.648040, -0.200540, 
-0.723520, 0.323780, -0.221750, -0.569700, 0.304250, -0.283130, -0.495930, 0.033670, 0.104610, -0.240780, 
-0.106510, 0.019000, -0.100280, -0.020060, -0.056100, -0.067890, 0.289200, -0.267420, -0.314120, -0.023350, 
-0.269100, -0.188120, 0.029560, -0.269370, -0.172670, -0.028830, -0.001310, -0.233010, -0.098590, 0.022640, 
-0.091960, -0.032780, -0.041130, -0.067320, 0.099940, -0.295650, -0.058850, -0.039780, -0.296940, -0.034900, 
-0.084080, -0.251810, 0.008420, -0.030360, -0.094230, -0.236460, -0.087600, 0.026180, -0.100870, -0.021320, 
-0.041860, -0.068690, 0.050290, -0.231240, 0.025180, -0.000450, -0.329350, 0.181430, -0.087200, -0.211920, 
0.145610, -0.183370, 0.021170, -0.179450, -0.057240, 0.027730, -0.076180, -0.010150, -0.028900, -0.050040, 
0.056900, -0.056210, -0.085740, -0.002960, -0.165760, 0.147630, -0.094630, -0.015820, 0.074980, -0.069310, 
0.113320, -0.129790, -0.056050, 0.016160, -0.069900, 0.005520, -0.015610, -0.047720, 0.028320, 0.049770, 
-0.140240, 0.013260, 0.006250, -0.006590, -0.066200, 0.048810, 0.048150, 0.025590, 0.008640, -0.131810, 
-0.039280, 0.017160, -0.077050, 0.008660, -0.007840, -0.038010, 0.103730, 0.009880, -0.152880, 0.024840, 
0.040750, 0.029640, -0.035460, 0.129930, 0.003520, 0.121520, -0.120820, -0.154530, -0.026410, 0.025970, 
-0.078970, 0.017410, -0.008930, -0.034770, 
0.048170, 0.098670, -0.155960, 0.204830, 0.027620, -0.291520, 0.264430, 0.002270, -0.487260, -0.236630, 
-0.331600, 0.291540, -0.566070, 0.031340, -0.110340, -0.027640, -0.021350, -0.027760, 0.136700, -0.126900, 
-0.133380, 0.281190, -0.157480, -0.266770, 0.264680, -0.142220, -0.377330, -0.018810, 0.114300, 0.300760, 
-0.555850, 0.022970, -0.108650, -0.022080, -0.031380, -0.032420, 0.146360, -0.151600, -0.132390, 0.209740, 
-0.137880, -0.226490, 0.193850, -0.136150, -0.329920, 0.183180, 0.364450, 0.316230, -0.555120, 0.032570, 
-0.117950, -0.021520, -0.033940, -0.035930, 0.104740, -0.051460, -0.183280, 0.164250, -0.053340, -0.354690, 
0.123600, -0.065650, -0.389180, 0.124070, 0.264680, 0.280830, -0.559150, 0.035790, -0.123920, -0.029990, 
-0.042010, -0.043980, 0.231640, -0.006770, -0.363700, 0.072580, 0.052970, -0.477230, 0.028490, 0.025340, 
-0.434020, -0.088320, 0.262060, 0.253520, -0.584530, 0.028620, -0.143740, -0.036790, -0.050320, -0.045140, 
0.423380, -0.025730, -0.443310, 0.004400, 0.095800, -0.435360, -0.126490, 0.106910, -0.313940, -0.094050, 
0.102150, 0.221260, -0.589870, 0.034840, -0.147550, -0.043010, -0.059480, -0.052470, 0.631260, -0.197570, 
-0.594530, 0.204910, -0.008440, -0.530950, 0.217920, -0.010340, -0.448970, -0.061530, 0.202780, 0.217330, 
-0.589930, 0.033660, -0.129740, -0.054790, -0.047380, -0.041780, 0.225510, -0.309020, -0.059050, -0.205270, 
-0.134580, -0.008980, -0.133710, -0.077760, 0.041410, -0.240180, -0.014180, 0.240810, -0.579730, 0.035130, 
-0.131750, -0.043540, -0.049310, -0.041500, 0.034080, -0.353740, 0.077090, -0.139320, -0.235850, 0.078700, 
-0.201780, -0.092780, 0.116660, -0.245170, -0.087870, 0.185780, -0.602380, 0.033400, -0.154700, -0.043150, 
-0.043510, -0.050520, -0.012500, -0.232530, 0.050200, -0.034200, -0.285070, 0.232510, -0.112770, -0.027320, 
0.091810, -0.456170, 0.147230, 0.201830, -0.567980, 0.025760, -0.142320, -0.025790, -0.043380, -0.058050, 
-0.036050, -0.091730, -0.013040, -0.060200, -0.105910, 0.153230, -0.140610, 0.072470, 0.018950, -0.217680, 
0.255370, 0.209340, -0.533330, 0.026860, -0.150570, -0.000170, -0.035020, -0.047870, -0.105910, 0.051210, 
0.005740, -0.018450, 0.060570, 0.020230, -0.130620, 0.086890, 0.059040, -0.105280, 0.156710, 0.207710, 
-0.505390, 0.026200, -0.141990, 0.001870, -0.011460, -0.043050, -0.034300, -0.029680, 0.055450, -0.029910, 
0.081950, 0.132090, -0.147180, 0.159110, 0.133610, 0.050630, 0.017620, 0.184340, -0.475450, 0.023710, 
-0.147430, 0.000430, -0.017940, -0.043270, 
-0.302050, 0.393190, 0.055550, -0.133690, 0.391440, -0.214870, -0.035250, 0.366960, -0.383060, -0.125860, 
-0.385070, 0.351310, -0.509280, 0.037900, -0.163970, -0.050650, 0.017990, 0.012160, -0.162730, 0.198730, 
0.017600, -0.048800, 0.125290, -0.149320, -0.000300, 0.046600, -0.199970, 0.048660, -0.199500, 0.360970, 
-0.509250, 0.034460, -0.168230, -0.067810, -0.004460, 0.000710, -0.266920, 0.145500, 0.029540, -0.119030, 
0.089420, -0.086160, -0.045970, -0.035720, -0.143190, 0.204050, -0.026450, 0.362810, -0.536490, 0.033260, 
-0.171410, -0.072180, -0.000310, 0.014170, -0.261010, 0.014450, 0.063960, -0.139390, 0.014030, -0.063820, 
-0.101370, -0.107890, -0.054120, 0.159870, 0.065310, 0.321570, -0.531190, 0.028440, -0.173040, -0.072980, 
-0.022010, 0.002860, -0.135690, -0.157480, -0.122110, -0.217340, 0.011040, -0.099130, -0.230420, -0.114040, 
-0.007350, -0.149240, 0.091870, 0.265580, -0.581410, 0.022660, -0.202540, -0.090050, -0.036180, -0.016790, 
-0.121110, -0.167670, -0.129520, -0.341800, -0.020820, -0.022100, -0.475770, -0.134970, 0.214250, -0.033390, 
0.028380, 0.233490, -0.573670, 0.024330, -0.209280, -0.109440, -0.035540, -0.009100, 0.677230, -0.385840, 
-0.909540, 0.441920, -0.170150, -0.794730, 0.241640, -0.217410, -0.503960, -0.082280, -0.077100, 0.212320, 
-0.593930, 0.026080, -0.200130, -0.112760, -0.040010, -0.019560, 0.355490, -0.505490, -0.616480, 0.095710, 
-0.228100, -0.493580, 0.036620, -0.075680, -0.372850, -0.216240, -0.190680, 0.230370, -0.589350, 0.040230, 
-0.200370, -0.098260, -0.044630, -0.009860, 0.171580, -0.433170, -0.397460, 0.114490, -0.169090, -0.378570, 
-0.025420, 0.052770, -0.272710, -0.245260, -0.283250, 0.245100, -0.588040, 0.024840, -0.208290, -0.105770, 
-0.033510, -0.026250, -0.107880, -0.289170, -0.025720, 0.008300, -0.147370, 0.104660, -0.118970, 0.102250, 
0.064110, -0.414680, 0.004830, 0.347520, -0.563160, 0.027650, -0.198770, -0.074910, -0.027510, 0.000590, 
-0.243550, -0.027980, 0.058660, -0.209250, 0.032520, 0.324370, -0.290130, 0.236660, 0.181440, -0.331750, 
0.239940, 0.422060, -0.531530, 0.037990, -0.179470, -0.053150, -0.006840, -0.003800, -0.355550, 0.145420, 
0.083990, -0.356280, 0.198710, 0.244360, -0.354520, 0.174510, 0.218220, -0.121010, 0.393870, 0.406960, 
-0.507940, 0.038250, -0.184830, -0.052940, -0.006340, 0.014470, -0.353920, -0.087700, 0.225480, -0.532780, 
0.111420, 0.440100, -0.415440, 0.048950, 0.286770, 0.020440, 0.199020, 0.288560, -0.486100, 0.040340, 
-0.182520, -0.052620, 0.003520, 0.007740, 
-0.226950, 0.078860, 0.177100, -0.090480, 0.198590, 0.020960, -0.025150, 0.399120, -0.302870, -0.200880, 
-0.234010, 0.174750, -0.404430, 0.051740, -0.133430, -0.063810, -0.024120, -0.007000, -0.076450, -0.178560, 
0.085370, 0.119060, -0.110040, -0.063870, 0.094350, 0.017440, -0.240460, -0.183410, -0.350400, 0.154850, 
-0.404150, 0.045210, -0.137430, -0.073350, -0.028640, -0.011930, -0.155800, -0.226720, 0.025490, 0.177510, 
-0.208220, -0.145530, 0.073590, -0.124850, -0.179070, 0.033520, -0.216370, 0.148410, -0.429840, 0.053490, 
-0.146400, -0.080110, -0.043400, -0.008130, 0.041590, -0.235570, -0.173900, 0.321800, -0.138340, -0.317660, 
0.169900, -0.097270, -0.247350, 0.233530, -0.079860, 0.137410, -0.455760, 0.056150, -0.160960, -0.102870, 
-0.063610, -0.024480, 0.095210, -0.090200, -0.396380, 0.226790, 0.055940, -0.514430, 0.016020, 0.102830, 
-0.352520, 0.100870, -0.012460, 0.091880, -0.490170, 0.052840, -0.183860, -0.114170, -0.068170, -0.038720, 
0.038700, 0.231630, -0.581760, 0.035370, 0.288110, -0.666640, -0.360920, 0.400470, -0.332330, 0.149050, 
-0.012060, 0.057870, -0.479670, 0.037520, -0.178970, -0.110710, -0.065450, -0.023370, 0.624610, 0.251650, 
-1.362600, 0.500940, 0.305900, -1.426500, 0.006530, 0.547970, -0.993290, 0.163980, -0.055580, 0.018450, 
-0.506210, 0.046370, -0.185890, -0.117600, -0.086740, -0.028940, 0.489030, -0.149690, -0.937900, 0.131040, 
0.096190, -0.889530, -0.182310, 0.487200, -0.589960, 0.012590, -0.096960, 0.070370, -0.489460, 0.035280, 
-0.186200, -0.117470, -0.080860, -0.037070, 0.391050, -0.333210, -0.482530, 0.169280, -0.038230, -0.514110, 
-0.115360, 0.292840, -0.256790, 0.040240, -0.297530, 0.068780, -0.476000, 0.043370, -0.186040, -0.110090, 
-0.059000, -0.040080, 0.222910, -0.430740, -0.073230, 0.083440, -0.164400, 0.083640, -0.084050, 0.125960, 
0.139660, -0.050740, -0.037330, 0.182320, -0.463920, 0.056470, -0.177010, -0.106790, -0.059220, -0.030260, 
0.219250, -0.364930, 0.001280, 0.038080, -0.160980, 0.329910, -0.039590, 0.144290, 0.209100, -0.030430, 
0.048260, 0.282580, -0.452600, 0.051830, -0.152460, -0.084310, -0.040540, -0.018660, 0.142620, -0.102860, 
-0.129870, -0.053490, 0.058400, 0.099650, -0.009050, 0.092430, 0.084090, -0.006180, -0.054240, 0.227580, 
-0.448900, 0.038940, -0.160580, -0.071810, -0.037880, -0.004000, 0.039420, -0.140910, -0.159910, -0.277010, 
0.156500, 0.142130, -0.185040, 0.131290, 0.031750, 0.034560, -0.201130, 0.096930, -0.438000, 0.043460, 
-0.181020, -0.061010, -0.041130, -0.022000, 
-0.007870, -0.032190, -0.088380, -0.038160, -0.026770, -0.102940, 0.034320, -0.118920, -0.160670, -0.150850, 
-0.019810, -0.211110, 0.083090, 0.015680, -0.100140, 0.012020, -0.036840, -0.052470, -0.000330, 0.011600, 
-0.070300, -0.021030, -0.068920, -0.083610, -0.013940, -0.105820, -0.116400, -0.036470, 0.127410, -0.190480, 
0.091990, 0.021020, -0.096270, 0.002610, -0.038130, -0.042330, 0.044890, 0.044320, -0.104250, -0.046380, 
-0.033960, -0.086620, -0.098270, -0.077830, -0.106550, 0.081090, 0.082060, -0.174460, 0.088900, 0.030360, 
-0.094580, 0.000950, -0.038600, -0.034040, 0.087180, 0.042270, -0.124480, -0.048780, -0.077050, -0.112710, 
-0.115790, -0.152150, -0.154880, 0.029210, 0.133700, -0.200330, 0.083540, 0.029570, -0.088680, 0.009400, 
-0.036640, -0.052050, 0.186930, -0.212760, -0.105660, -0.054870, -0.278730, -0.006370, -0.093090, -0.361120, 
-0.064650, -0.070660, 0.045170, -0.230360, 0.052160, 0.025760, -0.100890, 0.001350, -0.041720, -0.049290, 
0.335680, -0.489590, -0.066320, -0.050840, -0.441910, 0.036880, -0.074620, -0.561500, 0.021770, -0.097620, 
-0.161740, -0.249540, 0.035510, 0.026670, -0.101270, 0.000140, -0.065290, -0.047560, 0.682170, -0.614550, 
-0.316040, 0.301540, -0.505530, -0.207490, 0.339840, -0.711670, -0.142110, -0.017360, -0.143450, -0.249900, 
0.042190, 0.024900, -0.107400, -0.014430, -0.061150, -0.045320, 0.241520, -0.524040, -0.115460, 0.012960, 
-0.472140, -0.032550, 0.132780, -0.603260, -0.038000, -0.050230, -0.137630, -0.255470, 0.026370, 0.013910, 
-0.094890, -0.004190, -0.056190, -0.048460, 0.138670, -0.354340, -0.098010, 0.104700, -0.373310, -0.050320, 
0.073290, -0.357660, -0.052950, 0.001470, -0.113710, -0.238590, 0.084110, 0.014070, -0.106680, -0.002950, 
-0.045170, -0.061270, 0.129790, -0.169860, -0.103590, 0.134750, -0.281250, 0.017030, 0.068870, -0.167140, 
-0.007060, -0.009640, -0.072440, -0.214910, 0.138780, 0.021490, -0.087500, 0.010280, -0.034650, -0.032650, 
0.094690, -0.050820, -0.127770, 0.105900, -0.137650, 0.023000, -0.017990, 0.026860, 0.006070, 0.035630, 
-0.031280, -0.176240, 0.151110, 0.023970, -0.087360, 0.024030, -0.024740, -0.033730, 0.049110, 0.004160, 
-0.118810, 0.128520, -0.028530, -0.043800, -0.024420, 0.113550, 0.009260, 0.117510, -0.015160, -0.191770, 
0.186190, 0.034600, -0.088710, 0.026300, -0.023770, -0.040990, 0.137990, 0.065700, -0.183050, 0.142560, 
0.056310, -0.029100, 0.007460, 0.202690, -0.003110, 0.195590, -0.085210, -0.188180, 0.204680, 0.022930, 
-0.070780, 0.024260, -0.018660, -0.043780, 
-0.034860, 0.294840, 0.014070, -0.126700, 0.185300, 0.006150, -0.126340, -0.121000, 0.288430, 0.219570, 
-0.394150, 0.180220, -0.069120, -0.005290, 0.088140, 0.052870, 0.053310, 0.101820, -0.007860, 0.043650, 
0.068670, -0.083040, 0.099290, 0.014260, -0.177300, -0.050760, 0.176260, -0.012630, -0.068850, 0.188840, 
-0.101430, -0.010510, 0.092870, 0.057400, 0.046150, 0.090470, 0.101740, -0.063890, 0.097790, 0.054450, 
-0.060140, 0.012750, -0.041450, -0.107760, 0.118830, 0.164640, -0.251810, 0.202130, -0.128990, -0.002370, 
0.096350, 0.068200, 0.062380, 0.080200, -0.098890, -0.053140, 0.067190, -0.062770, -0.032090, -0.085960, 
0.027290, -0.249650, -0.074230, 0.119170, -0.105080, 0.122090, -0.181800, -0.027470, 0.084350, 0.052150, 
0.039000, 0.084930, -0.733050, 0.180880, 0.304980, -0.431410, -0.031790, -0.012730, -0.298500, -0.312410, 
-0.035920, -0.084380, -0.274480, -0.054730, -0.254390, -0.016380, 0.065280, 0.034260, 0.001790, 0.071940, 
-1.356960, 0.409130, 0.510780, -0.815280, 0.065330, 0.005670, -0.763900, -0.085710, 0.018950, -0.240260, 
-0.313160, -0.208980, -0.327080, -0.029740, 0.046460, 0.027660, -0.007210, 0.040900, -1.718550, 0.595970, 
0.897530, -1.391990, 0.150350, 0.535400, -1.607910, 0.146410, 0.652230, 0.018150, 0.133390, -0.248030, 
-0.321650, -0.037140, 0.040260, 0.036810, -0.009510, 0.050730, -0.987890, 0.476680, 0.367090, -0.827760, 
0.098520, 0.142820, -1.105640, -0.012090, 0.297740, 0.095570, 0.359410, -0.234170, -0.324660, -0.039550, 
0.034440, 0.037810, -0.012860, 0.044000, -0.324110, 0.308880, 0.099030, -0.347120, -0.043760, 0.033220, 
-0.524940, -0.152840, 0.198490, -0.117280, 0.166840, -0.082430, -0.284420, -0.026110, 0.057600, 0.027250, 
-0.000170, 0.056380, -0.086930, 0.061280, 0.112390, -0.152790, -0.029060, 0.014360, -0.152240, -0.230510, 
0.106840, -0.247910, -0.184070, 0.060250, -0.253990, -0.015190, 0.098720, 0.038060, 0.008280, 0.073760, 
-0.056630, 0.061100, -0.023350, -0.235020, 0.079020, 0.077220, -0.026820, -0.093350, 0.065530, -0.110380, 
0.043610, 0.187450, -0.248050, -0.003520, 0.109720, 0.043220, 0.014780, 0.062370, -0.107740, 0.075640, 
0.116830, -0.192290, 0.053970, 0.109090, 0.064100, -0.077030, 0.135650, -0.043590, -0.175270, 0.311120, 
-0.240970, 0.002180, 0.100190, 0.046660, 0.012010, 0.084520, -0.082750, 0.121570, 0.109150, 0.158430, 
0.068220, -0.023200, 0.280650, -0.130630, 0.210430, -0.066130, -0.310840, 0.399750, -0.246830, 0.014450, 
0.111790, 0.046590, 0.031670, 0.097710, 
0.049890, -0.074350, -0.018110, 0.274910, -0.214710, 0.200390, 0.316740, 0.084840, 0.164440, 0.023330, 
0.453690, -0.052770, 0.364340, -0.011360, -0.027270, 0.155310, 0.173700, -0.148110, -0.178800, 0.004520, 
-0.185640, -0.081500, -0.342800, 0.327630, -0.012160, -0.106760, 0.276110, -0.142520, 0.310400, -0.058810, 
0.298630, -0.003700, -0.032500, 0.142110, 0.176160, -0.176750, -0.332570, 0.116260, -0.277750, -0.148690, 
-0.194250, 0.115170, 0.022940, -0.137660, 0.211870, -0.002300, -0.106570, -0.005910, 0.228390, -0.000150, 
-0.046000, 0.140800, 0.171450, -0.184060, -0.221380, 0.385670, -0.599400, 0.185080, 0.052500, -0.114020, 
0.285130, -0.024470, 0.143950, -0.115300, 0.358580, 0.023880, 0.185180, -0.016730, -0.048890, 0.123590, 
0.181880, -0.206010, -0.200140, 0.490350, -0.717950, 0.301720, -0.029050, -0.197100, 0.220550, -0.194340, 
0.075730, 0.063840, -0.101030, -0.078210, 0.113070, -0.007420, -0.084540, 0.108060, 0.151480, -0.210150, 
0.062760, 0.694880, -1.548020, 0.213240, 0.251130, -0.731410, 0.258240, -0.171980, -0.465460, 0.269610, 
0.281070, -0.115500, 0.097850, -0.009580, -0.093670, 0.103270, 0.154440, -0.218360, 0.519610, 1.059440, 
-2.572400, 0.331930, 0.513620, -1.847820, 0.581370, -0.175540, -1.362460, 0.162140, 0.114880, -0.202300, 
0.005280, -0.019000, -0.130390, 0.081410, 0.121990, -0.228990, 0.342980, 0.625640, -1.592800, -0.129480, 
0.279980, -0.966290, 0.261630, -0.149390, -0.598380, 0.085910, 0.158530, -0.133440, 0.109340, -0.004790, 
-0.116870, 0.098580, 0.157810, -0.195790, -0.029820, 0.268730, -0.401570, -0.347530, -0.002650, -0.239450, 
-0.116890, -0.374300, 0.217750, 0.058380, 0.139680, -0.076610, 0.149780, -0.006850, -0.099050, 0.105830, 
0.169680, -0.173770, 0.026780, 0.150850, -0.577940, -0.296300, -0.064340, -0.079110, -0.040350, -0.485600, 
0.193260, -0.158370, 0.266490, -0.005860, 0.111350, -0.003170, -0.090820, 0.119310, 0.165600, -0.171890, 
-0.078820, 0.144270, -0.362190, -0.168280, -0.323410, 0.337000, 0.003270, -0.218660, 0.048120, 0.121540, 
0.153670, 0.100010, 0.104050, 0.013100, -0.096750, 0.137390, 0.175140, -0.142430, 0.036330, -0.119970, 
-0.190700, -0.156870, -0.238050, 0.452860, 0.003330, -0.087800, 0.048450, 0.191520, -0.085270, 0.145390, 
0.164660, 0.019680, -0.098540, 0.164550, 0.167190, -0.126810, 0.057190, -0.248880, -0.253970, -0.080280, 
-0.136680, 0.079280, 0.115280, -0.035400, -0.150290, 0.073560, -0.003860, 0.118040, 0.129720, 0.026690, 
-0.108530, 0.193170, 0.169230, -0.135480, 
0.002360, 0.037330, 0.094390, -0.239700, 0.413310, -0.096220, -0.145680, 0.017570, -0.019180, 0.020510, 
-0.096390, -0.019160, 0.493030, 0.012150, -0.089200, 0.031010, 0.013170, 0.074940, -0.075200, 0.202330, 
0.024000, -0.367950, 0.279660, 0.083150, -0.226240, 0.044780, -0.025750, 0.101750, -0.179590, 0.019140, 
0.455380, 0.007250, -0.079820, 0.023600, 0.014180, 0.075390, -0.132310, 0.299850, 0.118340, -0.387820, 
0.275510, 0.081470, -0.266680, 0.081220, 0.024480, 0.211900, -0.258910, 0.066930, 0.448350, 0.014620, 
-0.056340, 0.034590, 0.029430, 0.084450, -0.146680, 0.312630, 0.067430, -0.340510, 0.423810, -0.246800, 
-0.225860, -0.036910, -0.060870, -0.036960, -0.250070, 0.033110, 0.432910, 0.009460, -0.060700, 0.023760, 
0.004450, 0.093460, -0.137260, 0.106050, 0.085000, -0.288010, 0.281170, -0.277480, -0.230190, -0.219670, 
-0.123960, -0.111220, -0.136180, -0.065050, 0.385080, 0.009210, -0.062220, 0.026140, 0.001440, 0.094720, 
-0.029250, -0.673070, 0.119640, -0.195800, -0.141820, -0.407910, -0.159280, -0.648090, -0.261380, -0.243600, 
-0.036060, -0.225070, 0.177430, 0.002260, -0.115310, 0.005440, -0.026070, 0.061270, 0.140110, -1.263420, 
0.630690, -0.295460, -0.453400, 0.280800, -0.268230, -1.011920, 0.465230, -0.070720, -0.249560, -0.172840, 
0.238870, 0.004250, -0.089310, 0.016940, -0.020290, 0.074140, 0.165210, -0.963090, 0.040600, -0.051800, 
-0.468290, -0.293570, -0.014900, -0.920630, -0.119360, -0.306450, -0.284410, -0.196310, 0.157860, -0.003470, 
-0.103160, -0.000420, -0.025230, 0.055830, 0.283130, -0.367330, -0.198390, 0.051880, -0.102420, -0.241200, 
0.072540, -0.291800, -0.198520, 0.094300, -0.323950, -0.116800, 0.372050, 0.003720, -0.080820, 0.011590, 
-0.003100, 0.080020, 0.224120, -0.161980, -0.120350, -0.005460, 0.121120, -0.127150, 0.010020, 0.091140, 
-0.098700, 0.054840, -0.245530, -0.057010, 0.534030, 0.011640, -0.054610, 0.019250, 0.027980, 0.084350, 
0.046830, -0.156870, 0.017270, -0.117350, 0.205230, 0.145820, -0.081740, 0.319010, 0.088190, 0.261060, 
0.085950, -0.035300, 0.573780, 0.021110, -0.036510, 0.037750, 0.040300, 0.089100, -0.069660, -0.224270, 
0.153720, -0.042010, 0.132580, 0.152930, -0.013620, 0.276470, 0.135940, 0.347640, 0.068810, -0.048380, 
0.583230, 0.023470, -0.039330, 0.028990, 0.043420, 0.073150, 0.119870, -0.136270, -0.065510, 0.318440, 
0.031970, -0.161400, 0.372370, -0.039730, 0.128370, 0.256780, 0.195710, -0.060440, 0.561690, 0.028660, 
-0.038230, 0.022870, 0.034620, 0.081760, 
-0.071480, -0.029230, -0.065580, -0.052850, -0.044850, -0.074390, -0.048870, -0.026740, -0.073780, -0.060690, 
-0.061770, -0.061250, -0.029780, -0.008320, -0.009840, -0.006890, -0.008100, -0.021810, -0.063700, -0.023400, 
-0.084230, -0.059870, -0.053750, -0.077660, -0.046720, -0.039720, -0.072440, -0.070120, -0.028640, -0.060360, 
-0.027410, -0.009420, -0.016120, -0.008340, -0.021540, -0.016310, -0.059940, -0.034690, -0.089350, -0.047900, 
-0.040130, -0.076980, -0.059640, -0.064580, -0.076470, -0.060360, -0.032080, -0.073100, -0.031210, -0.002100, 
-0.005690, -0.005680, -0.010170, -0.021770, -0.052130, -0.042080, -0.084020, -0.049970, -0.059440, -0.073470, 
-0.052050, -0.062350, -0.062560, -0.056920, -0.041060, -0.065100, -0.035930, -0.011060, -0.003410, -0.002880, 
-0.019970, -0.016330, -0.044610, -0.045200, -0.082080, -0.059600, -0.077900, -0.075130, -0.060950, -0.068740, 
-0.048560, -0.077530, -0.063470, -0.059560, -0.043520, -0.002650, -0.018000, -0.003360, -0.007430, -0.022690, 
-0.032080, -0.063900, -0.071150, -0.049850, -0.068300, -0.039930, -0.052810, -0.090650, -0.022120, -0.049250, 
-0.057810, -0.058840, -0.014440, -0.012350, -0.018040, -0.003860, -0.014130, -0.013650, -0.035110, -0.047610, 
-0.097630, -0.045430, -0.077640, -0.064470, -0.028560, -0.105270, -0.063730, -0.054620, -0.074900, -0.061440, 
-0.038480, 0.001520, -0.016310, -0.012760, -0.015410, -0.020650, -0.052510, -0.046570, -0.075060, -0.061870, 
-0.074610, -0.044310, -0.049390, -0.093960, -0.030960, -0.054070, -0.071590, -0.060030, -0.022680, -0.012670, 
-0.019420, -0.009490, -0.004200, -0.011690, -0.052810, -0.048040, -0.081310, -0.047590, -0.071490, -0.080540, 
-0.040340, -0.086110, -0.052890, -0.056560, -0.061230, -0.064400, -0.041450, 0.006710, -0.010610, -0.001910, 
-0.003240, -0.013890, -0.036800, -0.032780, -0.098820, -0.051840, -0.046760, -0.078490, -0.047610, -0.070430, 
-0.068640, -0.061600, -0.042400, -0.055490, -0.042220, -0.006480, -0.019130, -0.014970, -0.009040, -0.019930, 
-0.033120, -0.010130, -0.096950, -0.045990, -0.031510, -0.097340, -0.046320, -0.055210, -0.070520, -0.058940, 
-0.053990, -0.043350, -0.039000, 0.001750, -0.009640, -0.005520, -0.005960, -0.015340, -0.028130, -0.008750, 
-0.109260, -0.043300, -0.028230, -0.093310, -0.045800, -0.038750, -0.074110, -0.045780, -0.043850, -0.055030, 
-0.026600, -0.000150, -0.013600, -0.006070, -0.012190, -0.011210, -0.032740, -0.011180, -0.102050, -0.037130, 
-0.024760, -0.082260, -0.059440, -0.036410, -0.092450, -0.047280, -0.050110, -0.039290, -0.032490, -0.010580, 
-0.007940, -0.007110, -0.001440, -0.005160, 
0.088120, 0.100790, -0.276100, 0.052100, 0.019830, -0.117310, 0.046500, 0.294000, -0.128580, 0.161210, 
-0.065350, 0.026720, 0.099920, -0.015650, 0.144190, 0.058530, 0.050650, -0.044870, -0.021580, -0.012560, 
-0.194480, -0.096290, -0.155080, 0.065110, -0.079630, 0.062470, 0.089690, -0.048580, -0.018730, -0.019530, 
0.095590, -0.017490, 0.137400, 0.049680, 0.046040, -0.068430, -0.147150, -0.015980, -0.181930, -0.167710, 
-0.210350, 0.084550, -0.126210, -0.124050, 0.135000, -0.014360, 0.004360, -0.037820, 0.073060, -0.017780, 
0.136790, 0.048760, 0.041420, -0.085710, -0.196890, -0.013110, -0.169500, -0.061530, -0.222770, 0.126660, 
-0.001280, -0.133850, 0.125040, -0.012620, -0.064510, -0.011540, 0.037510, -0.018600, 0.121690, 0.037030, 
0.038360, -0.085570, -0.229240, 0.108090, -0.081670, -0.060510, -0.226550, 0.204400, 0.000750, -0.109120, 
0.205890, 0.053690, -0.512180, 0.020910, 0.065500, -0.018390, 0.116640, 0.039460, 0.044060, -0.085010, 
-0.154190, 0.451720, -0.428300, -0.063430, 0.025960, -0.017810, 0.032430, 0.004110, 0.001660, 0.052750, 
-0.140430, 0.068650, 0.128990, -0.012960, 0.118570, 0.038920, 0.053910, -0.065760, -0.110250, 1.006890, 
-1.189230, 0.065120, 0.171250, -0.740280, 0.194560, 0.032520, -0.623210, -0.185770, -0.349890, 0.006060, 
0.048460, -0.016710, 0.090260, 0.026330, 0.035220, -0.088290, -0.226550, 0.478410, -0.543660, -0.106920, 
-0.069860, -0.141080, 0.074310, -0.113550, -0.034460, -0.039970, -0.084290, 0.032550, 0.110850, -0.023260, 
0.112780, 0.044740, 0.049780, -0.060140, -0.310430, 0.203590, -0.114770, -0.168050, -0.127770, 0.054990, 
-0.016290, -0.206920, 0.147260, -0.147830, 0.026710, 0.059160, 0.101000, -0.018660, 0.108440, 0.037350, 
0.048880, -0.061770, -0.209000, 0.267700, -0.276910, -0.133880, 0.039120, -0.083250, -0.027530, -0.117020, 
-0.005370, -0.108120, 0.143390, 0.128290, 0.057420, -0.010230, 0.115600, 0.049130, 0.039620, -0.060390, 
-0.153230, 0.312600, -0.291000, -0.037330, -0.043780, -0.038800, -0.042100, -0.035050, -0.121940, 0.106960, 
0.006480, 0.166570, 0.041310, -0.016250, 0.120740, 0.058070, 0.033830, -0.032550, -0.073990, 0.272700, 
-0.173360, 0.068850, -0.137970, 0.061250, 0.046670, 0.011520, -0.150720, 0.113750, 0.039550, 0.205240, 
0.078610, -0.005970, 0.118110, 0.073910, 0.043910, -0.021570, 0.116870, 0.065840, -0.164060, 0.170380, 
-0.133230, -0.098080, 0.100110, 0.051310, -0.272590, 0.057060, -0.079720, 0.226760, 0.081050, -0.009270, 
0.123540, 0.078220, 0.047870, -0.024290, 
0.305990, 0.082590, 0.016450, 0.032990, 0.222330, -0.253600, 0.074640, -0.135300, -0.035200, 0.286370, 
0.176590, 0.123480, 0.178850, -0.035030, -0.072550, 0.034870, 0.027310, 0.109690, 0.233290, 0.019680, 
-0.040350, -0.090540, 0.070670, -0.144140, 0.050150, -0.237060, -0.033430, -0.023680, -0.154540, 0.135590, 
0.121450, -0.030700, -0.065870, 0.018850, 0.022960, 0.113330, 0.329230, -0.056470, 0.005170, 0.012960, 
-0.008430, -0.105840, 0.166080, -0.247350, -0.026890, -0.066060, -0.439290, 0.186670, 0.104500, -0.032380, 
-0.048720, 0.025430, 0.031750, 0.126780, 0.217990, -0.136610, 0.114670, -0.005200, 0.080660, -0.179460, 
0.152080, -0.267100, -0.003630, -0.093550, 0.030780, 0.180710, 0.090600, -0.025000, -0.048670, 0.030830, 
0.015300, 0.141410, -0.030630, -0.228560, 0.180590, -0.105000, -0.053450, -0.171600, -0.036460, -0.348050, 
-0.111030, 0.099170, 0.294540, -0.010780, 0.019070, -0.036730, -0.063230, 0.016610, 0.005320, 0.120890, 
-0.399350, -0.565920, 0.275070, -0.268340, -0.310160, -0.295160, -0.288470, -0.589470, -0.177840, -0.071950, 
0.312790, -0.206300, -0.192660, -0.043230, -0.121740, -0.019720, -0.047680, 0.080220, -0.712820, -0.739700, 
1.213130, -0.753860, -0.399280, 0.717230, -0.937760, -0.760610, 0.944880, 0.180660, 0.191370, -0.158700, 
-0.123600, -0.036800, -0.102660, -0.007140, -0.024080, 0.103740, -0.064700, -0.405130, 0.039410, -0.083250, 
-0.172380, -0.469180, -0.280440, -0.541330, -0.151870, -0.022440, -0.048990, -0.205060, -0.202200, -0.042020, 
-0.101190, -0.016830, -0.043390, 0.080580, 0.121050, 0.077130, -0.031420, -0.203280, 0.176820, -0.249710, 
-0.277010, -0.127330, 0.015980, 0.140260, -0.105650, -0.021930, -0.002520, -0.040440, -0.074770, 0.007620, 
-0.011020, 0.105020, 0.117810, 0.144740, -0.014520, -0.213390, 0.298550, -0.284710, -0.164260, 0.015800, 
-0.058070, 0.137570, -0.187710, -0.003320, 0.099600, -0.028340, -0.055310, 0.009120, 0.000510, 0.105050, 
0.085080, -0.025360, 0.005550, -0.187950, 0.168270, -0.107810, -0.019930, 0.120440, -0.070680, 0.140400, 
0.074090, 0.011000, 0.122580, -0.021040, -0.031740, 0.003380, 0.010300, 0.091970, -0.046380, -0.113960, 
0.148070, -0.198370, 0.189690, -0.098220, 0.052700, 0.158510, -0.062280, -0.016310, 0.003050, 0.026490, 
0.143840, -0.014160, -0.037340, -0.019970, 0.010510, 0.094390, -0.122300, -0.015690, 0.087850, -0.064860, 
0.139890, -0.135140, 0.169910, -0.132980, 0.131490, -0.207620, 0.090080, 0.014560, 0.096890, -0.026760, 
-0.022900, -0.018060, 0.013420, 0.085050, 
0.291150, 0.138200, 0.024000, 0.080110, 0.280340, -0.225710, 0.135650, -0.093530, 0.003340, 0.266250, 
0.163820, 0.011540, 0.332190, -0.025190, -0.069510, 0.032010, 0.031240, 0.083860, 0.217360, 0.114930, 
-0.086520, -0.047600, 0.154040, -0.138250, 0.081960, -0.177540, -0.053350, -0.047470, -0.263160, 0.006540, 
0.271060, -0.034870, -0.061250, 0.032350, 0.016030, 0.089600, 0.279620, 0.020120, -0.048550, 0.016830, 
0.064970, -0.144130, 0.171950, -0.228420, -0.033700, -0.103410, -0.504030, 0.038950, 0.229470, -0.042480, 
-0.068390, 0.021990, 0.026080, 0.092810, 0.182770, -0.162410, 0.113950, 0.007540, 0.078030, -0.161120, 
0.135780, -0.299700, 0.090190, -0.145820, -0.062630, 0.035280, 0.231460, -0.036950, -0.052760, 0.033450, 
0.010170, 0.101170, -0.012110, -0.310380, 0.196250, -0.028520, -0.117570, -0.129220, -0.009130, -0.454290, 
0.018030, 0.086210, 0.319420, -0.119070, 0.165830, -0.041940, -0.077240, 0.013450, 0.005720, 0.084840, 
-0.222970, -0.741270, 0.206460, -0.084790, -0.442450, -0.309640, -0.133010, -0.763160, -0.107470, -0.016170, 
0.357980, -0.326320, -0.056900, -0.044330, -0.123130, -0.009860, -0.042940, 0.057960, -0.408600, -0.928870, 
0.991350, -0.417540, -0.518490, 0.511520, -0.608280, -0.897990, 0.804260, 0.199380, 0.131940, -0.279100, 
0.012710, -0.044220, -0.106310, 0.014100, -0.018020, 0.065020, -0.040840, -0.499840, 0.023670, -0.000420, 
-0.262780, -0.449230, -0.145990, -0.611220, -0.154370, -0.066850, -0.132110, -0.315100, -0.062790, -0.059920, 
-0.113960, -0.006280, -0.045860, 0.066650, 0.151510, 0.027370, -0.160400, -0.119380, 0.180000, -0.359640, 
-0.130880, -0.083340, -0.104460, 0.167680, -0.191980, -0.142320, 0.135680, -0.045730, -0.077670, -0.000690, 
-0.018530, 0.086170, 0.102760, 0.157760, -0.190990, -0.153850, 0.346670, -0.379900, -0.121050, 0.121390, 
-0.164670, 0.188670, -0.225880, -0.120670, 0.238470, -0.040490, -0.063080, 0.013710, -0.003410, 0.076810, 
0.021220, -0.030500, -0.057520, -0.204860, 0.214370, -0.107140, -0.101600, 0.219160, -0.072740, 0.190250, 
0.036040, -0.121740, 0.271940, -0.021550, -0.037170, 0.006810, 0.005380, 0.087000, -0.110950, -0.077310, 
0.112610, -0.219470, 0.243050, -0.098220, -0.053760, 0.279300, -0.043710, -0.005420, 0.013420, -0.123080, 
0.292550, -0.027060, -0.037860, -0.004390, 0.024470, 0.075930, -0.197590, 0.086720, 0.022120, -0.099910, 
0.258420, -0.175550, 0.091120, 0.054820, 0.087480, -0.251290, 0.127790, -0.120980, 0.265480, -0.015190, 
-0.025860, -0.018060, 0.014910, 0.057690, 
-0.103990, 0.130510, 0.119830, -0.146930, 0.194510, -0.007630, -0.014800, 0.132960, -0.213100, -0.102240, 
-0.420480, 0.287260, -0.584220, 0.019670, -0.192520, -0.015190, -0.015160, -0.005500, 0.115260, 0.017070, 
0.076920, 0.034880, 0.014110, -0.020420, 0.069850, -0.012780, -0.134240, 0.098250, -0.154470, 0.304870, 
-0.577110, 0.035080, -0.180210, -0.015630, -0.022060, -0.007130, 0.181770, -0.004610, -0.034540, 0.071810, 
0.030090, -0.071010, 0.015420, 0.016980, -0.180860, 0.114400, -0.164470, 0.311510, -0.587510, 0.031500, 
-0.184720, -0.024000, -0.012440, -0.006500, 0.199340, -0.024650, -0.012590, 0.074160, 0.021770, -0.125400, 
-0.022350, -0.041070, -0.210310, -0.153600, -0.128510, 0.283130, -0.578650, 0.030380, -0.194040, -0.011450, 
-0.025520, 0.004760, 0.324320, -0.188870, -0.079690, 0.043500, -0.094470, -0.059310, -0.027390, -0.240950, 
-0.100460, -0.362020, 0.064590, 0.275890, -0.600650, 0.031240, -0.201590, -0.033670, -0.035440, -0.009750, 
0.428460, -0.324330, -0.009130, 0.073850, -0.175420, 0.000900, -0.023820, -0.391180, 0.081120, -0.309220, 
-0.123080, 0.266110, -0.617640, 0.023350, -0.209070, -0.024470, -0.044370, -0.006310, 0.853990, -0.463370, 
-0.396320, 0.755290, -0.276430, -0.490570, 0.764160, -0.549170, -0.338590, -0.118420, 0.013230, 0.267530, 
-0.621290, 0.034450, -0.208700, -0.024840, -0.049330, -0.020640, 0.138450, -0.383190, 0.051760, 0.178340, 
-0.255830, -0.072920, 0.253180, -0.309320, -0.019740, -0.102540, -0.151190, 0.279210, -0.628320, 0.026400, 
-0.208700, -0.035930, -0.044330, -0.011570, -0.077020, -0.271730, 0.026030, 0.128960, -0.175320, -0.104500, 
0.028750, -0.041680, -0.081230, 0.002520, -0.122570, 0.183710, -0.613760, 0.020880, -0.228910, -0.021140, 
-0.042860, -0.027410, -0.056870, -0.076310, -0.088270, 0.158590, -0.187510, 0.001270, -0.017080, 0.143670, 
-0.109100, -0.160040, 0.018880, 0.150350, -0.571010, 0.032310, -0.218440, -0.023880, -0.044140, -0.021780, 
-0.088940, 0.023270, -0.092900, 0.055410, -0.048180, 0.012100, -0.142140, 0.240390, -0.104070, -0.016120, 
0.025010, 0.116720, -0.538300, 0.015590, -0.226490, -0.016020, -0.023270, -0.013560, -0.128930, 0.047650, 
-0.086400, 0.105280, -0.020370, -0.140630, -0.114430, 0.160250, -0.071270, 0.057140, 0.018140, 0.087500, 
-0.524290, 0.024540, -0.212020, -0.005390, -0.019190, -0.015680, 0.073370, -0.065940, -0.064530, 0.126550, 
-0.050540, -0.022770, -0.037250, 0.160710, -0.081570, 0.186750, -0.113160, 0.055340, -0.463560, 0.018610, 
-0.216640, 0.001780, -0.003200, -0.021370, 
0.070700, 0.003140, 0.065280, -0.155660, 0.094220, -0.136660, -0.184480, -0.186360, 0.033570, 0.110760, 
0.167110, 0.169520, -0.016430, -0.001270, -0.037730, 0.019270, 0.019690, 0.125570, 0.106910, -0.160690, 
0.114420, -0.121330, -0.023550, -0.053260, -0.125650, -0.218570, 0.024620, 0.010790, 0.074500, 0.200500, 
-0.039570, -0.011730, -0.026430, 0.016550, 0.013700, 0.121540, 0.228750, -0.177450, 0.171290, -0.008120, 
-0.148060, 0.051550, 0.003120, -0.206590, 0.023770, 0.007110, -0.106400, 0.266170, -0.037080, -0.008210, 
0.004700, 0.023540, 0.033790, 0.127480, 0.133940, -0.102480, 0.153540, 0.001060, -0.016560, -0.113040, 
0.050980, -0.164630, -0.075400, -0.057570, 0.020130, 0.246300, -0.059300, 0.006510, 0.007140, 0.019450, 
0.021030, 0.140190, -0.121950, -0.051150, 0.151560, -0.175920, 0.058750, -0.210000, -0.147350, -0.135360, 
-0.213690, -0.022930, -0.163400, 0.111640, -0.104500, 0.002310, -0.007610, 0.013960, 0.004490, 0.117770, 
-0.608580, -0.167040, 0.379710, -0.444130, 0.013230, -0.227050, -0.489570, -0.166580, -0.213290, -0.259500, 
-0.122830, -0.019610, -0.260650, -0.018010, -0.041970, -0.011360, -0.026630, 0.098610, -0.953610, -0.296170, 
1.194560, -1.025260, -0.072120, 0.748870, -1.169280, -0.280900, 0.791860, -0.028550, 0.099180, 0.006500, 
-0.194810, -0.005120, -0.031920, -0.001370, -0.020960, 0.117740, 0.026160, -0.225240, 0.075270, -0.076110, 
-0.048400, -0.342820, -0.311490, -0.352050, -0.200320, -0.043610, 0.146560, -0.037480, -0.268170, -0.013720, 
-0.052300, 0.000360, -0.032910, 0.100980, 0.213810, -0.079840, 0.145900, -0.114240, 0.020480, -0.057810, 
-0.238660, -0.234220, 0.100100, -0.001280, 0.079630, 0.094590, -0.116650, -0.007940, -0.014890, 0.009750, 
-0.010960, 0.115970, 0.200950, -0.098290, 0.173820, -0.112480, 0.028230, -0.092560, -0.075350, -0.207310, 
0.066940, -0.119480, -0.064380, 0.108610, -0.048240, 0.003310, 0.008860, -0.007790, 0.005440, 0.116190, 
0.126500, -0.141110, 0.101030, -0.149320, 0.055010, -0.082510, 0.078550, -0.114110, -0.009610, -0.088750, 
0.107800, 0.119880, -0.045950, 0.005910, 0.009800, -0.003480, 0.002630, 0.114070, -0.078970, -0.093350, 
0.131290, -0.192480, 0.081570, -0.072310, 0.070430, -0.063360, 0.001340, -0.054170, -0.045970, 0.126580, 
-0.045640, 0.003450, 0.012830, -0.009170, 0.011490, 0.090320, -0.137880, -0.098360, 0.114570, -0.061130, 
-0.039250, -0.079240, 0.149070, -0.302520, 0.159530, -0.093050, 0.045650, 0.122710, -0.090260, -0.006500, 
0.000060, -0.027730, -0.002950, 0.084840, 
-0.189330, 0.078240, 0.135940, -0.247570, 0.079900, 0.084330, -0.115930, 0.012400, -0.078230, -0.077720, 
-0.228580, 0.085150, -0.413870, 0.021190, -0.169990, 0.012100, -0.028940, -0.041870, -0.045590, 0.059810, 
0.094590, -0.114150, -0.021670, 0.083910, -0.052970, -0.028740, -0.054460, 0.088650, -0.042880, 0.136200, 
-0.385170, 0.019470, -0.157160, 0.010940, -0.024500, -0.028930, -0.025120, 0.069060, -0.000670, -0.136570, 
0.032350, 0.056680, -0.134620, 0.012290, -0.068840, 0.112710, -0.115930, 0.137360, -0.400160, 0.028710, 
-0.155690, 0.007580, -0.020190, -0.021930, -0.033310, 0.016560, 0.088310, -0.182730, -0.020080, 0.096570, 
-0.210360, -0.096840, -0.028160, -0.142190, -0.082060, 0.104210, -0.395580, 0.034540, -0.170920, -0.007290, 
-0.026000, -0.022390, 0.101730, -0.293840, 0.103270, -0.214970, -0.255540, 0.270730, -0.216680, -0.397150, 
0.179930, -0.314250, -0.006760, 0.088730, -0.422850, 0.034560, -0.174050, 0.001420, -0.041850, -0.027000, 
0.231170, -0.576620, 0.183790, -0.163200, -0.447380, 0.375010, -0.134090, -0.723530, 0.395040, -0.248570, 
-0.227930, 0.057390, -0.457980, 0.024800, -0.181650, -0.014910, -0.043450, -0.050130, 0.784730, -0.751810, 
-0.256450, 0.613810, -0.565280, -0.206300, 0.720270, -0.926800, -0.071720, -0.042610, -0.118480, 0.061840, 
-0.438320, 0.032940, -0.182320, -0.006110, -0.047220, -0.045180, 0.161520, -0.559020, 0.010400, 0.190230, 
-0.444050, -0.045790, 0.316550, -0.624210, 0.022100, -0.008040, -0.199600, 0.064140, -0.451100, 0.023360, 
-0.182270, -0.005250, -0.053470, -0.048900, -0.030080, -0.300890, -0.083120, 0.150360, -0.254660, -0.143610, 
0.087720, -0.205990, -0.129000, 0.108510, -0.208620, 0.004990, -0.435800, 0.023310, -0.200370, -0.019010, 
-0.046970, -0.048610, -0.105870, -0.064180, -0.080700, 0.093300, -0.157050, 0.023600, -0.053230, 0.063640, 
-0.061600, 0.017730, -0.049410, 0.034580, -0.371090, 0.032000, -0.188580, 0.008460, -0.027160, -0.042820, 
-0.165820, 0.129420, -0.107840, -0.041740, -0.003940, 0.043230, -0.203590, 0.238640, -0.037310, 0.060710, 
0.034730, 0.022810, -0.339800, 0.033900, -0.174910, 0.012540, -0.022500, -0.029210, -0.153570, 0.078480, 
-0.084000, -0.021030, 0.020090, -0.061640, -0.202450, 0.179830, -0.025930, 0.081890, 0.013370, -0.009960, 
-0.337160, 0.022090, -0.187680, 0.018060, -0.022750, -0.039420, 0.026170, -0.045270, -0.079560, 0.001610, 
-0.064030, 0.048250, -0.109140, 0.104510, 0.004340, 0.169700, -0.128200, -0.042260, -0.284680, 0.029640, 
-0.179540, 0.019090, -0.015000, -0.044510, 
0.011200, -0.246240, 0.557710, -0.265330, 0.289020, 0.058620, -0.258300, 0.225650, -0.327700, -0.161510, 
-0.079890, 0.131500, -1.161230, 0.058680, -0.457650, -0.104520, -0.043090, 0.177530, 0.283450, -0.390800, 
0.565870, 0.107350, -0.016520, -0.009400, 0.052070, -0.006230, -0.233140, 0.015370, 0.300950, 0.194400, 
-1.145510, 0.059000, -0.435050, -0.112880, -0.050590, 0.197610, 0.554320, -0.445780, 0.533580, 0.350100, 
-0.174090, 0.082440, 0.222800, -0.017680, -0.177320, -0.077790, -0.198840, 0.304750, -1.117210, 0.079790, 
-0.417000, -0.105190, -0.042440, 0.213640, 0.526160, -0.348210, 0.578150, 0.212570, -0.087400, -0.029320, 
0.095640, -0.110960, -0.226240, -0.249200, -0.172500, 0.309130, -1.142210, 0.070400, -0.410540, -0.104000, 
-0.055440, 0.223330, 0.525300, -0.588500, 0.500820, 0.068390, 0.023790, -0.037780, -0.007710, -0.197980, 
-0.281580, -0.026060, 0.078740, 0.255980, -1.173730, 0.083550, -0.414930, -0.124760, -0.063500, 0.215670, 
0.417890, -0.828290, 0.547780, -0.063370, 0.135690, -0.272880, -0.208280, -0.321020, -0.246300, -0.031560, 
-0.071280, 0.138340, -1.356100, 0.068990, -0.448350, -0.142380, -0.096460, 0.197140, 0.621270, -0.975050, 
0.855420, 0.129500, 0.013010, 0.133930, 0.061250, -0.646210, 0.348440, 0.548130, 0.376280, 0.214070, 
-1.251060, 0.067760, -0.432020, -0.127610, -0.066760, 0.208740, 0.337020, -0.249750, 0.375510, -0.107140, 
0.342640, -0.257670, -0.181590, -0.068060, -0.170780, 0.247090, 0.200620, 0.173020, -1.320960, 0.062300, 
-0.447310, -0.145620, -0.096420, 0.197650, 0.247200, -0.139300, 0.392390, -0.051760, 0.240070, -0.066720, 
-0.333600, 0.172230, 0.095450, 0.223770, 0.132310, 0.071240, -1.241750, 0.065470, -0.445060, -0.135890, 
-0.075980, 0.174100, 0.215280, 0.014640, 0.370450, 0.098960, -0.007120, -0.029020, -0.236730, 0.124460, 
0.151680, -0.102350, 0.163240, -0.038170, -1.168790, 0.065290, -0.444110, -0.127390, -0.083120, 0.157280, 
0.059700, 0.065370, 0.528150, 0.085340, 0.155270, -0.097500, -0.156270, 0.258250, 0.210380, -0.233000, 
0.104760, -0.125350, -1.118640, 0.073650, -0.444970, -0.126890, -0.055500, 0.142280, 0.144410, -0.296420, 
0.519050, 0.277080, 0.292830, -0.413750, 0.066440, 0.199410, 0.113620, -0.299330, -0.413010, -0.174370, 
-1.109570, 0.064830, -0.437660, -0.133450, -0.049540, 0.137100, 0.232440, -0.427050, 0.465670, 0.256380, 
0.005460, -0.088640, 0.267300, -0.276970, 0.320060, -0.054870, -0.503380, -0.274810, -1.087440, 0.047580, 
-0.429920, -0.152040, -0.023230, 0.097140, 
0.152080, 0.192540, -0.170670, -0.007380, -0.051290, -0.181670, -0.180780, -0.246810, 0.114640, 0.113930, 
0.595570, 0.140200, 0.159000, -0.026790, 0.109260, 0.011290, -0.005830, 0.135040, 0.090090, 0.044310, 
-0.019390, -0.159120, -0.044630, -0.010500, -0.247200, -0.183950, 0.178850, 0.085650, 0.371070, 0.170080, 
0.136700, -0.021440, 0.114540, 0.010190, -0.001220, 0.124770, 0.184230, -0.104300, 0.155220, -0.098390, 
-0.227660, 0.133090, -0.147700, -0.238540, 0.205790, 0.270250, 0.353460, 0.180150, 0.131470, -0.021540, 
0.128810, 0.002410, -0.002550, 0.142250, 0.053480, -0.071030, 0.086400, -0.072190, -0.202560, -0.025710, 
-0.032020, -0.295630, 0.098190, 0.336460, 0.371530, 0.129950, 0.095510, -0.025910, 0.124180, 0.015770, 
-0.015470, 0.135650, -0.213510, 0.141550, -0.058460, -0.217840, -0.028090, -0.396530, -0.123030, -0.233320, 
-0.270690, 0.510920, -0.030100, -0.033170, 0.044230, -0.022360, 0.100500, -0.005980, -0.029780, 0.127680, 
-0.750810, 0.242160, 0.024430, -0.474940, 0.074820, -0.467960, -0.478360, -0.034720, -0.402880, 0.223150, 
0.114650, -0.186020, -0.043730, -0.026050, 0.087900, -0.016180, -0.041060, 0.106780, -1.398920, 0.227440, 
0.974370, -1.453660, 0.030350, 0.729450, -1.513780, -0.015570, 0.713890, 0.148300, 0.099750, -0.175870, 
-0.021530, -0.040200, 0.081900, -0.002060, -0.036280, 0.101540, 0.353300, 0.080810, -0.396230, 0.057390, 
-0.045260, -0.650180, -0.158430, -0.344930, -0.442010, -0.118450, 0.010910, -0.215500, -0.063040, -0.049870, 
0.075490, -0.010750, -0.056430, 0.112410, 0.658670, -0.053410, -0.107750, -0.039020, -0.130130, -0.171300, 
-0.067740, -0.491860, 0.052350, -0.208920, -0.042040, -0.012500, 0.036810, -0.029900, 0.122730, -0.009500, 
-0.030150, 0.123750, 0.507080, -0.194160, 0.071640, -0.041710, -0.136420, -0.143420, 0.065500, -0.524190, 
0.067010, -0.330930, -0.020090, 0.068900, 0.088820, -0.025070, 0.137880, -0.003600, -0.010350, 0.126060, 
0.330220, -0.165310, 0.001980, -0.125360, -0.041940, -0.154070, 0.216810, -0.372680, -0.076960, -0.057820, 
0.318140, 0.122640, 0.083590, -0.007830, 0.139500, -0.008790, -0.011600, 0.130290, 0.053860, 0.010690, 
0.011150, -0.162000, 0.034580, -0.170360, 0.179890, -0.151840, -0.110950, 0.017960, 0.210530, 0.168150, 
0.069720, -0.009000, 0.141560, -0.010340, -0.024220, 0.113620, -0.001820, 0.066140, -0.026060, 0.025840, 
0.022090, -0.246310, 0.224130, -0.200240, 0.026270, -0.163220, 0.337930, 0.214670, 0.046310, -0.011630, 
0.158990, -0.018920, -0.018440, 0.116580, 
0.158640, -0.013030, 0.009350, 0.009640, 0.093230, -0.166210, 0.018030, -0.185850, -0.002430, 0.116060, 
0.061230, 0.107010, 0.041670, -0.019320, -0.040450, 0.016290, 0.015100, 0.083220, 0.129460, -0.053060, 
-0.007230, -0.026510, 0.009220, -0.107960, 0.005280, -0.191490, -0.034060, -0.039080, -0.110950, 0.111030, 
0.012850, -0.019460, -0.051080, 0.008760, 0.014960, 0.074610, 0.200060, -0.051520, 0.003880, 0.029390, 
-0.024600, -0.097800, 0.085780, -0.158030, -0.059500, -0.055580, -0.289140, 0.151770, 0.014910, -0.016960, 
-0.029140, 0.009320, 0.029660, 0.080660, 0.150710, -0.048850, 0.026460, 0.007630, 0.074390, -0.180300, 
0.085500, -0.138960, -0.073220, -0.112190, -0.027910, 0.150290, 0.003060, -0.019720, -0.020650, 0.012820, 
0.021390, 0.088650, -0.048290, -0.108310, 0.099460, -0.104500, 0.021340, -0.164130, -0.056760, -0.183680, 
-0.115400, -0.016760, 0.131290, 0.031430, -0.025080, -0.017480, -0.042920, 0.017210, 0.008490, 0.070090, 
-0.331200, -0.327080, 0.238670, -0.239430, -0.139970, -0.184880, -0.251580, -0.323660, -0.110020, -0.141900, 
0.105110, -0.097160, -0.184480, -0.029110, -0.060030, -0.005370, -0.023580, 0.052670, -0.522070, -0.491610, 
0.861280, -0.560380, -0.219250, 0.496110, -0.682470, -0.442680, 0.628920, 0.044420, 0.149850, -0.059630, 
-0.112420, -0.016400, -0.046030, 0.014980, -0.006250, 0.072230, -0.135480, -0.270400, 0.136480, -0.160180, 
-0.100110, -0.199650, -0.283620, -0.332320, -0.049530, -0.030650, 0.022490, -0.090400, -0.174310, -0.028920, 
-0.066880, -0.010870, -0.025310, 0.060510, 0.029080, 0.025300, 0.013960, -0.163360, 0.108840, -0.134490, 
-0.206060, -0.075080, -0.017680, 0.090420, 0.006770, 0.012590, -0.048910, -0.027220, -0.032000, 0.011930, 
-0.006780, 0.061080, 0.017100, 0.077820, -0.010690, -0.142670, 0.180730, -0.190830, -0.117490, 0.012390, 
-0.068580, 0.056800, -0.121310, 0.011860, 0.028260, -0.014720, -0.028500, 0.001640, 0.013400, 0.073360, 
-0.006230, -0.019570, 0.013770, -0.152050, 0.112850, -0.092280, -0.040830, 0.063060, -0.056290, 0.024660, 
0.044400, 0.002600, 0.037640, -0.011960, -0.026270, -0.013850, 0.003020, 0.061520, -0.094600, -0.076730, 
0.074240, -0.159090, 0.111120, -0.092470, -0.015580, 0.071880, -0.027320, -0.041030, -0.046370, 0.027810, 
0.018770, -0.006620, -0.009850, -0.009360, 0.001090, 0.060800, -0.139270, -0.030460, 0.046690, -0.065020, 
0.043610, -0.111640, 0.092310, -0.140270, 0.072270, -0.128580, 0.002920, 0.024030, -0.002270, -0.017560, 
-0.024320, -0.009820, 0.010000, 0.040700, 
-0.077530, -0.019020, -0.100470, -0.061410, -0.045530, -0.059970, -0.063690, 0.014320, -0.074450, -0.037890, 
-0.052480, -0.078660, -0.004440, -0.000960, 0.016590, 0.000640, -0.003100, -0.023470, -0.076480, -0.034640, 
-0.078710, -0.060140, -0.076360, -0.031520, -0.057820, -0.040840, -0.038950, -0.076440, -0.008950, -0.070620, 
-0.003580, -0.005160, 0.022520, -0.008370, -0.007610, -0.018120, -0.076720, -0.053320, -0.097270, -0.054590, 
-0.094470, -0.055600, -0.051570, -0.076800, -0.050930, -0.075660, -0.003160, -0.091940, -0.006460, -0.014000, 
0.015830, 0.005120, -0.002360, -0.035300, -0.063210, -0.076540, -0.110320, -0.028390, -0.122750, -0.028970, 
-0.030980, -0.091600, -0.050520, -0.057400, -0.051670, -0.070180, -0.009060, -0.010380, 0.017080, -0.012230, 
-0.009200, -0.024550, -0.066910, -0.052440, -0.109470, -0.030550, -0.110640, -0.021550, -0.029540, -0.090270, 
-0.029330, -0.063010, -0.125730, -0.064250, -0.000980, -0.007270, 0.003910, -0.000290, -0.011060, -0.030530, 
-0.043780, 0.045070, -0.114060, -0.030790, -0.048690, 0.001610, -0.028610, -0.045420, 0.002140, -0.004620, 
-0.067740, -0.027010, 0.040230, -0.014760, 0.009270, -0.003550, -0.001720, -0.026260, -0.043060, 0.158080, 
-0.291480, -0.003520, -0.025410, -0.194270, 0.018360, -0.036600, -0.172890, -0.059310, -0.113130, -0.061970, 
0.016030, -0.005920, 0.003540, -0.002970, 0.000100, -0.029620, -0.068420, 0.073950, -0.157290, -0.054070, 
-0.038790, -0.075500, -0.011800, -0.029370, -0.033150, -0.008890, -0.071630, -0.042170, 0.030650, -0.013150, 
0.011130, 0.004900, -0.004520, -0.023490, -0.087080, 0.035200, -0.115970, -0.046040, -0.055860, -0.083610, 
-0.012540, -0.062900, -0.052470, -0.047140, -0.039240, -0.048360, 0.003260, -0.009270, 0.005290, -0.004870, 
-0.003440, -0.018900, -0.068840, 0.044690, -0.151870, -0.034970, -0.016750, -0.098170, -0.012180, -0.043950, 
-0.086830, -0.040490, 0.017210, -0.038830, -0.008230, -0.007690, -0.000090, 0.001140, -0.009980, -0.026960, 
-0.044250, 0.064780, -0.156860, -0.014540, -0.011730, -0.112660, -0.014950, -0.035490, -0.119520, -0.012710, 
-0.012770, -0.008380, -0.013100, -0.000610, 0.000380, 0.000630, -0.012540, -0.023240, -0.019880, 0.061610, 
-0.136710, -0.013260, -0.022020, -0.093060, -0.022990, -0.004970, -0.137450, -0.005550, 0.013760, -0.003630, 
0.004440, -0.013430, 0.012100, 0.009790, -0.011700, -0.016770, 0.004830, 0.018920, -0.120490, -0.020500, 
-0.021580, -0.080530, -0.047710, 0.004330, -0.117470, -0.008660, -0.012190, -0.010170, -0.009950, 0.001740, 
0.006660, 0.001440, -0.007670, -0.020490, 
0.305400, -0.098870, -0.122040, -0.036950, 0.144410, -0.370940, -0.174880, -0.116090, -0.193340, 0.047070, 
0.350620, 0.274000, 0.021440, 0.007950, 0.034860, 0.009950, -0.048320, 0.196410, 0.261400, -0.193060, 
-0.005280, -0.115960, 0.169760, -0.316920, -0.182160, -0.050380, -0.207630, -0.199800, 0.047010, 0.309060, 
-0.014070, -0.000050, 0.046690, -0.004190, -0.056590, 0.192750, 0.405080, -0.087360, 0.025780, 0.082550, 
0.008910, -0.287690, -0.033180, -0.040420, -0.234610, -0.364020, -0.345250, 0.367510, 0.019720, 0.007060, 
0.057780, 0.005330, -0.044810, 0.199970, 0.261590, 0.096040, -0.096390, 0.109110, 0.141050, -0.608510, 
0.051470, -0.046490, -0.407570, -0.353200, -0.215660, 0.333920, -0.010750, 0.004660, 0.053810, -0.005170, 
-0.050270, 0.212750, -0.028190, 0.032280, 0.026360, -0.002230, 0.125610, -0.637890, -0.104520, -0.118040, 
-0.552120, 0.026210, -0.184770, 0.179550, -0.053930, 0.008000, 0.044830, -0.010390, -0.074360, 0.189620, 
-0.446450, -0.354820, 0.391200, -0.121240, -0.066500, -0.541610, -0.257450, -0.361770, -0.449750, -0.255440, 
-0.106270, 0.106930, -0.254160, -0.005940, 0.020950, -0.020770, -0.089860, 0.157920, -0.991820, -0.645180, 
1.767920, -0.852750, -0.316420, 1.075230, -1.145040, -0.636230, 1.198520, -0.006690, -0.130040, 0.192430, 
-0.168740, -0.007750, 0.038940, -0.015990, -0.072260, 0.182850, 0.117130, -0.530420, 0.418140, 0.145690, 
-0.282640, -0.238710, -0.242620, -0.693860, 0.004650, -0.044490, -0.264510, 0.136690, -0.238550, -0.015700, 
0.024000, -0.015570, -0.095900, 0.174450, 0.527880, -0.123930, 0.007160, 0.125580, -0.016720, -0.270500, 
0.011830, -0.304270, -0.082930, 0.065790, -0.170460, 0.263920, -0.052050, -0.011570, 0.063970, -0.008450, 
-0.077030, 0.181280, 0.389470, 0.039700, 0.100930, -0.070400, 0.168330, -0.287400, 0.044910, -0.174790, 
-0.061680, 0.288830, -0.382900, 0.271890, 0.080430, 0.012220, 0.087840, -0.015950, -0.052620, 0.181930, 
0.315160, -0.231500, 0.272400, -0.154910, 0.128770, 0.016360, 0.117240, -0.031480, 0.104990, 0.214240, 
-0.015380, 0.261100, 0.100590, 0.013010, 0.094600, -0.035380, -0.055180, 0.172670, 0.100550, -0.175920, 
0.412970, -0.201850, 0.075780, 0.204030, 0.081820, 0.117870, 0.167180, 0.279770, -0.008700, 0.292140, 
0.119500, 0.015060, 0.106520, -0.035070, -0.045200, 0.158680, 0.001360, -0.140940, 0.323250, 0.096840, 
-0.108330, 0.050850, 0.304260, -0.250580, 0.273980, 0.094720, 0.118310, 0.290830, 0.088710, 0.026870, 
0.106030, -0.043490, -0.056360, 0.166080, 
-0.052670, 0.150910, -0.267720, -0.006810, 0.100510, -0.223670, -0.016060, 0.313910, -0.282380, 0.109040, 
-0.334510, 0.214210, -0.085760, 0.006140, 0.076940, 0.033740, 0.033960, -0.056340, -0.096760, 0.065990, 
-0.176170, -0.074490, -0.096390, -0.024860, -0.075220, 0.067600, -0.062020, -0.003660, -0.169950, 0.203750, 
-0.083860, -0.003330, 0.063160, 0.032340, 0.019400, -0.052230, -0.218080, 0.063700, -0.157330, -0.154620, 
-0.097980, 0.023780, -0.123410, -0.071720, 0.018220, 0.052160, -0.066900, 0.194750, -0.089650, -0.006380, 
0.049550, 0.012250, 0.026820, -0.068680, -0.269930, 0.045470, -0.105470, -0.103820, -0.097490, 0.076150, 
-0.057890, -0.083270, 0.067730, 0.018000, -0.062160, 0.231100, -0.127700, 0.005040, 0.049210, 0.017020, 
0.021410, -0.072290, -0.271940, 0.109910, -0.059110, -0.132330, -0.129850, 0.167130, -0.096600, -0.111310, 
0.214470, -0.061740, -0.373800, 0.258420, -0.100560, -0.005180, 0.042770, 0.008510, 0.016140, -0.076290, 
-0.127310, 0.381710, -0.342770, -0.108740, 0.027260, -0.012500, -0.078000, -0.073950, 0.093480, -0.015240, 
-0.115460, 0.290170, -0.046120, -0.002870, 0.054280, 0.012980, 0.023790, -0.070410, 0.159690, 0.728430, 
-1.191410, 0.183240, 0.083560, -0.827860, 0.293840, -0.079890, -0.673020, -0.205460, -0.222840, 0.227470, 
-0.106890, 0.000060, 0.031250, 0.011450, 0.025900, -0.078240, -0.082860, 0.293270, -0.561920, -0.082110, 
-0.082410, -0.254060, 0.106210, -0.094480, -0.135780, -0.076610, -0.058780, 0.269040, -0.071630, 0.007610, 
0.032510, 0.014250, 0.027810, -0.072300, -0.224430, 0.157490, -0.144440, -0.101660, -0.091920, -0.058310, 
-0.018980, -0.085180, 0.063850, -0.156040, -0.048940, 0.280880, -0.076690, 0.001200, 0.036190, 0.015370, 
0.037420, -0.062750, -0.204050, 0.198980, -0.168770, -0.115240, 0.033820, 0.037980, -0.077150, 0.018500, 
0.062050, -0.156160, 0.118100, 0.349960, -0.102150, 0.007370, 0.049660, 0.028340, 0.040630, -0.055760, 
-0.164530, 0.254270, -0.205920, -0.068570, 0.021310, 0.111930, -0.124450, 0.120960, -0.015760, 0.045560, 
0.056060, 0.399480, -0.098080, 0.013950, 0.039150, 0.027930, 0.036310, -0.046200, -0.099150, 0.273940, 
-0.197860, 0.024780, 0.003630, 0.057080, -0.055390, 0.130320, -0.108830, 0.081850, 0.099520, 0.400110, 
-0.076170, 0.007400, 0.047670, 0.051310, 0.035160, -0.032720, 0.098180, 0.103180, -0.246740, 0.069850, 
0.041380, -0.102240, -0.025830, 0.205480, -0.258950, 0.118950, 0.004960, 0.396480, -0.072250, 0.007080, 
0.032540, 0.044820, 0.032620, -0.021240, 
-0.074420, -0.109080, 0.036920, -0.109940, -0.180740, 0.155320, -0.118500, -0.087000, 0.163020, -0.019540, 
0.059610, -0.135120, 0.124820, -0.006160, 0.036880, -0.003830, -0.005650, -0.028410, -0.106780, -0.079600, 
-0.005000, -0.135640, -0.163940, 0.121940, -0.140830, -0.069130, 0.107600, -0.062390, -0.002790, -0.159760, 
0.112660, -0.009660, 0.043230, -0.012220, -0.016610, -0.025050, -0.114380, -0.067360, -0.064180, -0.099930, 
-0.144460, 0.027470, -0.101930, -0.072370, 0.046170, -0.047950, -0.057160, -0.175820, 0.106700, -0.012480, 
0.023400, -0.021420, -0.016710, -0.031750, -0.089380, -0.016280, -0.145030, -0.046200, -0.122320, -0.055080, 
-0.056920, -0.045210, -0.042770, 0.018490, -0.077080, -0.192230, 0.088770, -0.021940, 0.021150, -0.017350, 
-0.014430, -0.042140, -0.083080, 0.086490, -0.209710, -0.034430, -0.019390, -0.161300, -0.038300, 0.067990, 
-0.128240, 0.071940, -0.149680, -0.193770, 0.105010, -0.024600, 0.019350, -0.022120, -0.011970, -0.041210, 
-0.125090, 0.245640, -0.258070, -0.053810, 0.098960, -0.170840, -0.057020, 0.184030, -0.135070, 0.067720, 
-0.047330, -0.180840, 0.132380, -0.023620, 0.041870, -0.019300, -0.012750, -0.031810, -0.273580, 0.345800, 
-0.202030, -0.156370, 0.148580, -0.102990, -0.154640, 0.187980, -0.081640, 0.004170, -0.080120, -0.186430, 
0.114960, -0.008140, 0.031010, -0.014210, -0.002700, -0.034740, -0.126660, 0.212350, -0.191960, -0.060320, 
0.072440, -0.095710, -0.057040, 0.059120, -0.057420, -0.008100, -0.056640, -0.190560, 0.128130, -0.018470, 
0.036840, -0.011190, -0.010490, -0.023910, -0.080850, 0.044820, -0.083760, -0.103870, -0.015360, -0.016480, 
-0.029670, -0.099690, 0.000680, -0.051600, 0.035750, -0.152610, 0.117280, -0.006260, 0.027180, -0.009660, 
-0.011410, -0.030120, -0.062300, 0.001350, -0.058430, -0.081120, -0.061690, -0.019320, 0.005640, -0.166400, 
0.002520, 0.009370, 0.058990, -0.142510, 0.100880, -0.009810, 0.040080, -0.019130, 0.004280, -0.023300, 
-0.024770, -0.024010, -0.030020, -0.030330, -0.104760, 0.035280, 0.035080, -0.203160, 0.019040, 0.031080, 
0.021730, -0.101990, 0.118430, -0.016360, 0.041880, -0.018460, -0.009090, -0.029740, 0.002860, -0.029320, 
-0.000700, -0.002240, -0.117040, 0.071650, 0.052780, -0.158970, 0.002650, 0.000410, 0.001090, -0.086140, 
0.123370, -0.003670, 0.053420, -0.001760, -0.007910, -0.009640, 0.048740, -0.034640, -0.021710, 0.031660, 
-0.070880, 0.003150, 0.084390, -0.084380, -0.048210, -0.034900, -0.069990, -0.048510, 0.133410, -0.010100, 
0.038780, -0.005630, 0.002200, -0.019480, 
0.066380, -0.011460, 0.281900, -0.014750, 0.133350, 0.043450, 0.058320, -0.302260, 0.198900, -0.177500, 
0.650000, 0.237940, 0.518460, 0.011680, -0.153560, -0.008090, -0.029250, 0.077390, -0.140520, -0.021920, 
0.149320, -0.229100, 0.054470, 0.103900, -0.114850, -0.184030, 0.035400, -0.079000, 0.229050, 0.209450, 
0.419410, 0.007370, -0.151420, -0.025960, -0.057170, 0.074550, -0.187530, 0.127270, 0.103180, -0.320810, 
0.180710, 0.070700, -0.153100, -0.031620, -0.001360, 0.016690, -0.144440, 0.272270, 0.395320, 0.014200, 
-0.128440, -0.010450, -0.050890, 0.085460, -0.214980, 0.016610, 0.448670, -0.424320, 0.368440, 0.098820, 
-0.253370, -0.158730, 0.344010, 0.008710, 0.202130, 0.256130, 0.464900, 0.020700, -0.115910, -0.020210, 
-0.049650, 0.100620, -0.211310, -0.080530, 0.328740, -0.368170, 0.198940, -0.048370, -0.289390, -0.484370, 
0.177230, 0.048390, 0.670540, 0.073130, 0.385600, 0.027650, -0.132340, -0.033520, -0.064630, 0.104890, 
-0.156100, -0.827880, 0.387910, -0.238730, -0.255800, -0.215750, -0.246140, -0.920000, 0.069600, -0.004130, 
0.435340, -0.138540, 0.170060, 0.005340, -0.171060, -0.053610, -0.095450, 0.062700, -0.133600, -1.397080, 
1.227690, -0.487150, -0.294300, 0.540990, -0.495290, -0.957500, 0.824730, 0.181560, 0.534700, -0.057730, 
0.269270, 0.004740, -0.161380, -0.039880, -0.090130, 0.070050, -0.130870, -0.522730, 0.164690, -0.254780, 
0.052930, -0.455020, -0.232690, -0.588690, -0.222470, -0.242470, 0.321260, -0.120940, 0.179340, 0.004150, 
-0.170240, -0.056890, -0.097460, 0.057220, 0.049390, -0.155880, -0.093070, -0.334150, 0.249580, -0.320070, 
-0.304020, -0.151970, -0.145320, 0.250380, -0.045780, -0.063450, 0.371540, 0.005960, -0.144110, -0.045430, 
-0.074030, 0.060390, -0.040510, -0.096640, -0.043840, -0.412010, 0.225770, -0.054930, -0.424130, 0.068110, 
0.047900, -0.077110, -0.189660, -0.105950, 0.546020, 0.008930, -0.132430, -0.039900, -0.051900, 0.067890, 
-0.182330, -0.020710, -0.167100, -0.489030, 0.259310, 0.022710, -0.425330, 0.294210, 0.000150, -0.126210, 
0.115510, -0.174860, 0.561180, 0.019180, -0.123990, -0.041490, -0.065940, 0.052440, -0.216770, -0.228680, 
-0.321260, -0.405200, 0.377120, -0.357220, -0.290160, 0.279860, -0.195580, -0.112700, -0.081110, -0.218050, 
0.486030, 0.002340, -0.141450, -0.064680, -0.068010, 0.030200, -0.123320, -0.136500, -0.499150, -0.043700, 
0.398190, -0.678100, 0.099030, -0.041500, -0.224310, -0.234720, 0.241930, -0.230920, 0.454600, 0.003740, 
-0.146360, -0.079610, -0.062020, 0.015620, 
-0.852770, 1.776030, -1.998120, -0.478920, -0.008230, 0.198280, 0.627490, 0.724780, 0.676610, 1.196790, 
1.570140, 0.614010, -1.970400, 0.447470, 0.475730, 0.065510, -0.014860, -0.350590, -0.412500, 0.170730, 
-0.147170, 0.056880, 0.883350, -1.578390, -0.170040, 0.046010, -0.677780, 0.673140, -0.639230, -0.098520, 

0.571300, -1.633750, 0.440990, -0.474590, -0.331520, -0.259850, -1.585320, -0.767250, -1.146720, -0.892200, 
-1.265730, -1.151140, 0.203340, 1.983840, -0.920020, 0.102680, 0.622460, -0.573100, -0.626310, -1.573470, 
-0.184140, -1.699160, -1.526370, 0.169170, -0.274240, 0.267510, -0.461080, 0.921880, -0.490130, -0.938800, 

-0.856010, -1.279140, -0.176660, 0.489120, 0.275550, -0.057800, 0.443200, -0.325310, -0.470140, -0.817180, 
-0.678960, 0.076690, 0.558130, -1.687770, 0.645660, -0.120070, -0.713600, 0.659670, 0.769730, -0.396470, 
0.712670, -0.457940, 0.653090, 0.633570, 0.447380, -0.257470, 0.347790, -0.280980, -0.663680, 0.595110, 


  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[268] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.010000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, 0.009980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.009170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.002710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.008150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, -0.000540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.000910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, 0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, -0.006630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.008630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, -0.001360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, -0.001120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, 0.008980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, 0.009620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.004950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, -0.007520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.000630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, -0.008410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, -0.000310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, -0.006210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, 0.006230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.001410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, 0.008460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, -0.006310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, -0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, 0.007630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.007880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, -0.005690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, 0.002430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, -0.003580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.003620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, -0.005050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.009880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, -0.002490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.007470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.002350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.005420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, 0.006270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, 0.000070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, -0.000190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, 0.003680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, -0.004030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, 0.002660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, -0.007530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, 0.002580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, 0.001440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, -0.000850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, -0.003360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, 0.006580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, -0.006620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.007240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, -0.005380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.008950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, -0.009330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, 0.003310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.008360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, 0.004590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.008510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.003520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.006200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.000720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.001380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.000240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, -0.004780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, -0.007430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, -0.001560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, 0.003330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, 0.002140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, 0.006460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.007760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.007050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.006220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, -0.009100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.008090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.003720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.007460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, 0.009920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, 0.009990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, 0.006140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, -0.001740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, 0.002500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, 0.009460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.000700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, -0.005710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.001160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.004240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.007070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.000520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, 0.004670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, -0.005670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, 0.000640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.006060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.001060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.005140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.000680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, -0.007380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, 0.007320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, -0.006920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.009640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, -0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, -0.003400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, -0.006000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.007140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, -0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.005490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.002680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.008890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, -0.007700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.001100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.006740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.001500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.000400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, 0.009380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, -0.002170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, -0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.006350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.000500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, -0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, 0.003820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, -0.008850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.002240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, -0.008610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.008230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, 0.003250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, -0.000660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.005360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, -0.005040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.008180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.007080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, 0.006510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, 0.001620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, 0.004070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, 0.002440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, 0.001630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, 0.002380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, 0.004000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, 0.009580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, 0.009260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.005580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, 0.000110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, -0.007650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 165 (Old: 165) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 166 (Old: 166) */
      0.0, 0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 167 (Old: 167) */
      0.0, 0.007600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 168 (Old: 168) */
      0.0, -0.000960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 169 (Old: 169) */
      0.0, 0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 170 (Old: 170) */
      0.0, 0.000860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 171 (Old: 171) */
      0.0, -0.001760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 172 (Old: 172) */
      0.0, -0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 173 (Old: 173) */
      0.0, 0.008600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 174 (Old: 174) */
      0.0, -0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 175 (Old: 175) */
      0.0, 0.001940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 176 (Old: 176) */
      0.0, -0.001710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 177 (Old: 177) */
      0.0, 0.006180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 178 (Old: 178) */
      0.0, -0.007850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 179 (Old: 179) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 180 (Old: 180) */
      0.0, 0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 181 (Old: 181) */
      0.0, 0.007690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 182 (Old: 182) */
      0.0, 0.006820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 183 (Old: 183) */
      0.0, -0.009850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 184 (Old: 184) */
      0.0, -0.003630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 185 (Old: 185) */
      0.0, -0.006240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 186 (Old: 186) */
      0.0, -0.002840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 187 (Old: 187) */
      0.0, 0.003410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 188 (Old: 188) */
      0.0, -0.004750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 189 (Old: 189) */
      0.0, -0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 190 (Old: 190) */
      0.0, -0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 191 (Old: 191) */
      0.0, -0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 192 (Old: 192) */
      0.0, 0.002820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 193 (Old: 193) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 194 (Old: 194) */
      0.0, 0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 195 (Old: 195) */
      0.0, -0.006300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 196 (Old: 196) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 197 (Old: 197) */
      0.0, 0.004510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 198 (Old: 198) */
      0.0, 0.009110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 199 (Old: 199) */
      0.0, -0.002020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 200 (Old: 200) */
      0.0, -0.000280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 201 (Old: 201) */
      0.0, -0.002600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 202 (Old: 202) */
      0.0, 0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 203 (Old: 203) */
      0.0, 0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 204 (Old: 204) */
      0.0, 0.000950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 205 (Old: 205) */
      0.0, -0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 206 (Old: 206) */
      0.0, -0.004860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 207 (Old: 207) */
      0.0, 0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 208 (Old: 208) */
      0.0, -0.002360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 209 (Old: 209) */
      0.0, -0.002370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 210 (Old: 210) */
      0.0, -0.007090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 211 (Old: 211) */
      0.0, 0.006370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 212 (Old: 212) */
      0.0, 0.003840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 213 (Old: 213) */
      0.0, 0.009530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 214 (Old: 214) */
      0.0, 0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 215 (Old: 215) */
      0.0, -0.009030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 216 (Old: 216) */
      0.0, -0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 217 (Old: 217) */
      0.0, 0.005900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 218 (Old: 218) */
      0.0, -0.002080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 219 (Old: 219) */
      0.0, -0.008710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 220 (Old: 220) */
      0.0, -0.001190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 221 (Old: 221) */
      0.0, -0.000940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 222 (Old: 222) */
      0.0, 0.001220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 223 (Old: 223) */
      0.0, 0.001000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 224 (Old: 224) */
      0.0, 0.003860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 225 (Old: 225) */
      0.0, 0.005980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 226 (Old: 226) */
      0.0, 0.005680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 227 (Old: 227) */
      0.0, 0.009000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 228 (Old: 228) */
      0.0, 0.005810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 229 (Old: 229) */
      0.0, -0.001490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 230 (Old: 230) */
      0.0, -0.008300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 231 (Old: 231) */
      0.0, 0.001690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 232 (Old: 232) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 233 (Old: 233) */
      0.0, 0.002890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 234 (Old: 234) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 235 (Old: 235) */
      0.0, -0.592890, 234,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 236 (Old: 236) */
      0.0, -0.668660, 234,
       &Sources[234] , 
       &Weights[234] , 
      },
    { /* unit 237 (Old: 237) */
      0.0, -0.607250, 234,
       &Sources[468] , 
       &Weights[468] , 
      },
    { /* unit 238 (Old: 238) */
      0.0, -0.620370, 234,
       &Sources[702] , 
       &Weights[702] , 
      },
    { /* unit 239 (Old: 239) */
      0.0, -0.433950, 234,
       &Sources[936] , 
       &Weights[936] , 
      },
    { /* unit 240 (Old: 240) */
      0.0, -0.250640, 234,
       &Sources[1170] , 
       &Weights[1170] , 
      },
    { /* unit 241 (Old: 241) */
      0.0, -0.599810, 234,
       &Sources[1404] , 
       &Weights[1404] , 
      },
    { /* unit 242 (Old: 242) */
      0.0, -0.429020, 234,
       &Sources[1638] , 
       &Weights[1638] , 
      },
    { /* unit 243 (Old: 243) */
      0.0, -0.266200, 234,
       &Sources[1872] , 
       &Weights[1872] , 
      },
    { /* unit 244 (Old: 244) */
      0.0, -0.446050, 234,
       &Sources[2106] , 
       &Weights[2106] , 
      },
    { /* unit 245 (Old: 245) */
      0.0, -0.435060, 234,
       &Sources[2340] , 
       &Weights[2340] , 
      },
    { /* unit 246 (Old: 246) */
      0.0, -0.469770, 234,
       &Sources[2574] , 
       &Weights[2574] , 
      },
    { /* unit 247 (Old: 247) */
      0.0, -1.025180, 234,
       &Sources[2808] , 
       &Weights[2808] , 
      },
    { /* unit 248 (Old: 248) */
      0.0, -1.093340, 234,
       &Sources[3042] , 
       &Weights[3042] , 
      },
    { /* unit 249 (Old: 249) */
      0.0, -0.834430, 234,
       &Sources[3276] , 
       &Weights[3276] , 
      },
    { /* unit 250 (Old: 250) */
      0.0, -0.188460, 234,
       &Sources[3510] , 
       &Weights[3510] , 
      },
    { /* unit 251 (Old: 251) */
      0.0, -0.412580, 234,
       &Sources[3744] , 
       &Weights[3744] , 
      },
    { /* unit 252 (Old: 252) */
      0.0, -0.853190, 234,
       &Sources[3978] , 
       &Weights[3978] , 
      },
    { /* unit 253 (Old: 253) */
      0.0, -0.857070, 234,
       &Sources[4212] , 
       &Weights[4212] , 
      },
    { /* unit 254 (Old: 254) */
      0.0, -0.155590, 234,
       &Sources[4446] , 
       &Weights[4446] , 
      },
    { /* unit 255 (Old: 255) */
      0.0, -0.643910, 234,
       &Sources[4680] , 
       &Weights[4680] , 
      },
    { /* unit 256 (Old: 256) */
      0.0, -0.337950, 234,
       &Sources[4914] , 
       &Weights[4914] , 
      },
    { /* unit 257 (Old: 257) */
      0.0, 0.032680, 234,
       &Sources[5148] , 
       &Weights[5148] , 
      },
    { /* unit 258 (Old: 258) */
      0.0, -0.886030, 234,
       &Sources[5382] , 
       &Weights[5382] , 
      },
    { /* unit 259 (Old: 259) */
      0.0, -0.536750, 234,
       &Sources[5616] , 
       &Weights[5616] , 
      },
    { /* unit 260 (Old: 260) */
      0.0, -0.177160, 234,
       &Sources[5850] , 
       &Weights[5850] , 
      },
    { /* unit 261 (Old: 261) */
      0.0, -0.632410, 234,
       &Sources[6084] , 
       &Weights[6084] , 
      },
    { /* unit 262 (Old: 262) */
      0.0, -0.331520, 234,
       &Sources[6318] , 
       &Weights[6318] , 
      },
    { /* unit 263 (Old: 263) */
      0.0, -0.232430, 234,
       &Sources[6552] , 
       &Weights[6552] , 
      },
    { /* unit 264 (Old: 264) */
      0.0, -0.863080, 234,
       &Sources[6786] , 
       &Weights[6786] , 
      },
    { /* unit 265 (Old: 265) */
      0.0, -1.083590, 30,
       &Sources[7020] , 
       &Weights[7020] , 
      },
    { /* unit 266 (Old: 266) */
      0.0, 0.509830, 30,
       &Sources[7050] , 
       &Weights[7050] , 
      },
    { /* unit 267 (Old: 267) */
      0.0, -0.528230, 30,
       &Sources[7080] , 
       &Weights[7080] , 
      }

  };



int step4_net(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[234] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, Units + 231, Units + 232, Units + 233, Units + 234}; /* members */

  static pUnit Hidden1[30] = {Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264}; /* members */

  static pUnit Output1[3] = {Units + 265, Units + 266, Units + 267}; /* members */

  static int Output[3] = {265, 266, 267};

  for(member = 0; member < 234; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 30; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
