/************************************************************************/
/*                            Prof v1.0                                 */
/*                     Author : Mohammed OUALI                          */
/*  A full description of the method is given in the paper entitled     */
/* "Cascaded Mutiple Classifers for Secondary Structure Prediction"     */
/*              by Mohammed OUALI and Ross D. KING                      */
/*                 (Submitted for publication)                          */
/*                                                                      */
/*   Copyright (C) 1999 Mohammed OUALI and University of Wales          */
/*             (Aberystwyth) Penglais, Aberystwyth                      */
/*                 Ceredigion SY23 3DB WALES                            */
/*                        U.K.                                          */
/*                                                                      */
/* This software can be copied and used freely providing it is not      */
/* resold in any form and its use is acknowledged.                      */
/* This software is provided by ``as is'' and any express or implied    */
/* warranties, including, but not limited to, the implied warranties of */
/* merchantability and fitness for a particular purpose are disclaimed. */
/* In no event shall the regents or contributors be liable for any      */
/* direct, indirect, incidental, special, exemplary, or consequential   */
/* damages (including, but not limited to, procurement of substitute    */
/* goods or services; loss of use, data, or profits; or business        */
/* interruption) however caused and on any theory of liability, whether */
/* in contract, strict liability, or tort (including negligence or      */
/* otherwise) arising in any way out of the use of this software, even  */
/* if advised of the possibility of such damage.                        */
/*                                                                      */
/************************************************************************/
/*********************************************************
  step4_net111.c
  --------------------------------------------------------
  generated at Mon Jun 28 19:01:32 1999
  by snns2c ( Bernward Kett 1995 ) 
*********************************************************/

#include <math.h>

#define Act_Logistic(sum, bias)  ( (sum+bias<10000.0) ? ( 1.0/(1.0 + exp(-sum-bias) ) ) : 0.0 )
#ifndef NULL
#define NULL (void *)0
#endif

typedef struct UT {
          float act;         /* Activation       */
          float Bias;        /* Bias of the Unit */
          int   NoOfSources; /* Number of predecessor units */
   struct UT   **sources; /* predecessor units */
          float *weights; /* weights from predecessor units */
        } UnitType, *pUnit;

  /* Forward Declaration for all unit types */
  static UnitType Units[268];
  /* Sources definition section */
  static pUnit Sources[] =  {
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, 
Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, 
Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, 
Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, 
Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, 
Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, 
Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, 
Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, 
Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, 
Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, 
Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, 
Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, 
Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, 
Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, 
Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, 
Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, 
Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, 
Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, 
Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, 
Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, 
Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, 
Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, 
Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, 
Units + 231, Units + 232, Units + 233, Units + 234, 
Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, 
Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, 
Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, 

Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, 
Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, 
Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, 

Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, 
Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, 
Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264, 


  };

  /* Weigths definition section */
  static float Weights[] =  {
0.133400, -0.044730, 0.006110, 0.122460, -0.268050, 0.231000, 0.193510, -0.136580, 0.352460, 0.129830, 
0.285480, -0.065790, 0.265080, -0.032490, 0.095780, 0.113830, 0.179680, -0.088290, -0.049440, -0.078050, 
-0.062510, -0.100290, -0.338020, 0.313430, 0.001150, -0.284280, 0.359680, -0.112850, 0.234310, -0.124660, 
0.258970, -0.043070, 0.086540, 0.123670, 0.175070, -0.090190, -0.185640, 0.047010, -0.192450, -0.235670, 
-0.138480, 0.099760, 0.042550, -0.178480, 0.204900, -0.089630, 0.068620, -0.128390, 0.224220, -0.045760, 
0.068520, 0.116500, 0.172040, -0.110720, -0.144460, 0.155730, -0.505410, 0.037290, 0.011260, -0.105720, 
0.331630, 0.055480, -0.078450, -0.183270, 0.202980, -0.121460, 0.180470, -0.047890, 0.064030, 0.113110, 
0.173490, -0.134170, -0.080660, 0.210100, -0.658470, 0.207400, 0.012070, -0.248690, 0.352010, 0.165190, 
-0.180990, -0.229490, -0.072440, -0.140250, 0.136230, -0.051120, 0.046500, 0.114570, 0.159530, -0.119300, 
0.151080, 0.448700, -1.175200, 0.209200, 0.134810, -0.535540, 0.362500, 0.032500, -0.342320, -0.141060, 
0.198340, -0.136230, 0.187200, -0.066240, 0.047970, 0.106790, 0.162930, -0.121830, 0.142460, 0.687360, 
-1.850450, 0.200910, 0.174950, -1.288050, 0.426270, -0.122470, -0.961940, -0.122130, 0.013520, -0.266790, 
0.042670, -0.066590, -0.000680, 0.084830, 0.124210, -0.145620, -0.004500, 0.423110, -0.946340, -0.024920, 
0.122130, -0.531560, 0.232630, -0.063750, -0.251970, 0.139440, 0.246240, -0.168550, 0.186030, -0.061050, 
0.047720, 0.105090, 0.165130, -0.118790, -0.135830, 0.284470, -0.416100, -0.106300, 0.066420, -0.280880, 
0.101190, -0.133160, -0.146400, -0.049270, 0.332480, -0.091650, 0.162920, -0.044800, 0.048790, 0.112480, 
0.171730, -0.096690, -0.087220, 0.037920, -0.400680, -0.101060, 0.076200, -0.181280, 0.093120, -0.159750, 
-0.262970, -0.015040, 0.221280, -0.021750, 0.102140, -0.051480, 0.049220, 0.117730, 0.163410, -0.086790, 
-0.019910, 0.023620, -0.396830, -0.019380, -0.173370, 0.083870, 0.072220, -0.172960, -0.259070, 0.367240, 
0.054930, 0.056460, 0.090960, -0.032320, 0.057590, 0.124500, 0.160410, -0.068010, 0.003220, -0.081380, 
-0.119630, -0.066750, -0.309590, 0.375090, 0.120080, -0.279130, -0.059900, 0.237030, -0.021400, 0.102270, 
0.115030, -0.029070, 0.045610, 0.138990, 0.158490, -0.052700, 0.073850, -0.262460, -0.051440, 0.015990, 
-0.371450, 0.291220, 0.163040, -0.385000, -0.008780, 0.075280, 0.059580, 0.145710, 0.125840, -0.025430, 
0.044200, 0.149950, 0.149040, -0.034100, 
-0.387420, 0.082560, 0.698470, -0.611080, 0.446690, 0.369020, -0.292470, 0.693520, -0.069460, 0.146610, 
0.206870, 0.499190, -0.850060, 0.079980, -0.279880, -0.174510, -0.080450, 0.033990, -0.013730, -0.218800, 
0.253960, 0.054010, 0.048470, -0.170280, 0.162450, 0.208040, -0.353210, -0.064580, -0.348430, 0.394930, 
-0.861040, 0.079600, -0.295700, -0.202520, -0.108350, 0.027530, -0.155900, -0.293890, -0.009130, 0.283530, 
-0.129830, -0.375190, 0.052620, -0.048260, -0.346790, -0.082560, -0.473200, 0.307570, -0.890220, 0.063950, 
-0.315020, -0.224010, -0.135020, 0.005710, 0.157590, -0.614250, -0.317350, 0.515080, -0.267430, -0.670370, 
0.109480, -0.219270, -0.507610, -0.179190, -0.146050, 0.223030, -0.919460, 0.062160, -0.345990, -0.246160, 
-0.169470, -0.006460, 0.147120, -0.554660, -0.202510, 0.343130, -0.247620, -0.422600, 0.045670, -0.154540, 
-0.231520, -0.412730, 0.438210, 0.317090, -0.949630, 0.063180, -0.348180, -0.235170, -0.150930, 0.001190, 
-0.137680, -0.028690, -0.215890, 0.274740, 0.058430, -0.682690, -0.297220, 0.318230, -0.274860, -0.564240, 
-0.132030, 0.294740, -0.946500, 0.066550, -0.350130, -0.247650, -0.154200, -0.025860, 0.463180, 0.454970, 
-1.351420, 1.264820, 0.361360, -2.100130, 0.185940, 0.755110, -1.246880, -0.395570, -0.197240, 0.251810, 
-0.955450, 0.065160, -0.364950, -0.267830, -0.166480, -0.027470, -0.027040, 0.096860, -0.970240, 0.506750, 
0.173670, -1.358810, -0.408740, 0.893760, -0.760730, -0.074210, 0.090100, 0.292920, -0.941520, 0.065490, 
-0.364850, -0.261830, -0.153830, -0.026360, -0.010510, -0.395000, -0.596810, 0.641860, -0.083280, -0.888120, 
-0.146950, 0.686980, -0.476020, 0.368790, 0.170670, 0.300890, -0.945850, 0.060480, -0.366450, -0.246050, 
-0.151080, -0.012260, 0.080320, -0.453060, -0.258420, 0.535650, -0.271290, -0.364650, 0.096920, 0.394110, 
-0.109960, 0.406380, 0.139740, 0.384420, -0.938600, 0.067720, -0.354420, -0.234420, -0.149110, -0.016970, 
0.277960, -0.673230, 0.112880, 0.325800, -0.216350, -0.013950, 0.170710, 0.265710, 0.132920, 0.057490, 
-0.010870, 0.494950, -0.913140, 0.068660, -0.331470, -0.215690, -0.132760, -0.011070, 0.206890, -0.464170, 
-0.052020, 0.064340, -0.207530, -0.117480, 0.026040, 0.156120, -0.074330, -0.102350, 0.233080, 0.389520, 
-0.932310, 0.064580, -0.345390, -0.223040, -0.119660, -0.027640, -0.074450, -0.241750, -0.152960, -0.320250, 
-0.152230, -0.079400, -0.230990, 0.114450, -0.282910, -0.128060, 0.494990, 0.129800, -0.939400, 0.040780, 
-0.363750, -0.229510, -0.140720, -0.045780, 
-0.306750, 0.534120, -0.537760, -0.043750, 0.159040, -0.346140, 0.002750, 0.058610, 0.176600, 0.105930, 
0.155220, -0.686560, 0.822390, -0.071670, 0.153460, 0.108580, 0.082230, -0.188920, -0.276620, 0.185440, 
-0.231020, -0.151630, 0.378360, -0.144580, 0.033140, 0.065420, 0.229780, -0.040630, -0.239400, -0.698710, 
0.866450, -0.072600, 0.157800, 0.135220, 0.086730, -0.193680, -0.294350, 0.170750, -0.322280, -0.198200, 
0.344330, -0.207450, 0.118120, -0.134960, 0.180750, -0.202460, 0.286570, -0.775420, 0.859760, -0.067370, 
0.121770, 0.122330, 0.092440, -0.222820, -0.278000, 0.157440, -0.531940, -0.068940, 0.147800, -0.105470, 
0.262030, -0.106380, 0.087050, -0.120550, 0.440390, -0.821500, 0.828710, -0.079710, 0.123110, 0.130950, 
0.082000, -0.244500, -0.496570, 0.569390, -0.434270, 0.002300, 0.053790, -0.160270, 0.314670, -0.057320, 
0.171500, -0.337650, 0.228350, -0.747040, 0.827920, -0.091630, 0.122390, 0.139560, 0.082740, -0.254230, 
-0.596710, 1.044540, -0.412220, 0.155430, -0.010170, -0.016640, 0.437100, 0.130470, 0.144240, -0.521520, 
0.232100, -0.646210, 1.018330, -0.094530, 0.162240, 0.168080, 0.117700, -0.214980, -1.124330, 1.199680, 
-0.439520, -0.269380, -0.044610, -0.168290, -0.103310, 0.295080, -0.218590, -0.850710, 0.137850, -0.771480, 
0.858360, -0.105550, 0.112320, 0.131690, 0.081500, -0.241330, -0.710570, 0.584460, 0.020830, 0.095300, 
-0.114330, 0.159360, 0.194040, 0.137830, 0.087540, -0.041900, 0.278680, -0.667880, 1.009660, -0.088300, 
0.147580, 0.146380, 0.108060, -0.211240, -0.679400, 0.220200, 0.042930, 0.092250, -0.069020, -0.067220, 
0.344520, -0.174090, -0.191900, 0.203640, 0.383930, -0.601230, 0.857510, -0.089040, 0.151540, 0.137840, 
0.113120, -0.217080, -0.687210, 0.242690, -0.176340, 0.018580, 0.073650, -0.366870, 0.402480, -0.322770, 
-0.426350, 0.615280, 0.075100, -0.571850, 0.741060, -0.094290, 0.145730, 0.145770, 0.097070, -0.209130, 
-0.444590, 0.246080, -0.366850, -0.046990, -0.041870, -0.382950, 0.471390, -0.502140, -0.510060, 0.784310, 
0.037940, -0.507780, 0.730420, -0.096380, 0.134770, 0.134620, 0.086350, -0.205940, -0.532210, 0.583850, 
-0.329230, -0.423400, -0.196150, 0.131720, 0.133030, -0.536800, -0.222800, 0.467690, 0.615040, -0.446330, 
0.716880, -0.095150, 0.129790, 0.136230, 0.054200, -0.178730, -0.797140, 0.627800, -0.138470, -0.707980, 
0.008800, 0.190910, -0.351640, -0.059550, -0.245200, 0.000600, 0.996970, -0.375390, 0.717160, -0.093570, 
0.133680, 0.146520, 0.055770, -0.159380, 
-0.014160, 0.226120, 0.303050, -0.475070, 0.440990, -0.229830, -0.353130, -0.125530, 0.147650, 0.340930, 
-0.140510, 0.151130, -0.125720, -0.011300, -0.144790, 0.009100, 0.088160, 0.212490, 0.215900, -0.158700, 
0.217580, -0.261530, -0.033460, -0.032110, -0.197850, -0.331840, 0.078110, -0.008140, 0.000460, 0.225700, 
-0.181510, -0.012020, -0.119160, -0.002330, 0.094070, 0.201180, 0.423120, -0.301140, 0.365430, -0.021470, 
-0.188390, 0.170470, 0.050610, -0.243250, 0.108380, 0.080420, -0.364670, 0.386480, -0.165100, -0.010580, 
-0.084380, 0.017270, 0.094660, 0.229060, 0.341800, -0.296830, 0.418910, 0.074920, 0.038800, 0.042550, 
0.307290, -0.242380, -0.054390, -0.148880, -0.169410, 0.430620, -0.183940, -0.008810, -0.076570, 0.026570, 
0.090150, 0.259470, -0.188460, -0.346780, 0.530400, -0.205860, 0.010390, 0.001170, -0.063570, -0.223750, 
-0.202360, -0.201730, -0.563520, 0.166530, -0.300010, -0.010020, -0.108630, -0.005590, 0.045600, 0.230390, 
-1.172440, -0.299410, 0.828990, -0.808090, 0.059230, -0.267830, -0.870660, -0.223400, -0.260140, -0.500260, 
-0.575230, -0.135640, -0.592290, -0.033200, -0.178840, -0.044470, -0.009750, 0.185170, -1.737870, -0.021840, 
1.882300, -1.653980, 0.207460, 0.881730, -1.940580, -0.273130, 1.183130, 0.009080, 0.181930, -0.100730, 
-0.462450, -0.022930, -0.156630, -0.016040, 0.004010, 0.202350, -0.294370, -0.143570, 0.267800, -0.281440, 
0.067100, -0.659120, -0.729240, -0.478000, -0.138410, 0.217920, 0.667820, -0.196660, -0.645540, -0.047360, 
-0.167800, -0.048180, -0.029160, 0.192280, 0.128430, -0.034870, 0.348150, -0.254300, 0.013280, -0.082660, 
-0.568300, -0.300260, 0.327450, 0.046330, 0.459390, 0.030620, -0.421330, -0.021620, -0.122350, -0.028640, 
0.004100, 0.196000, 0.355010, -0.226560, 0.224270, -0.104370, -0.026360, -0.099430, -0.187650, -0.268850, 
0.099660, -0.256690, -0.041400, 0.093560, -0.309380, -0.006410, -0.087100, -0.030220, 0.010880, 0.199390, 
0.280600, -0.286550, -0.077460, -0.261020, -0.044610, -0.090290, -0.044270, -0.162820, -0.087930, -0.120470, 
0.105250, 0.081950, -0.328430, -0.005970, -0.100510, -0.041910, 0.018580, 0.193490, -0.255210, -0.240630, 
0.225490, -0.345120, 0.050090, -0.144250, -0.021650, -0.105510, -0.019950, -0.070780, -0.266760, 0.090350, 
-0.335650, 0.019550, -0.088450, -0.051460, 0.010490, 0.169410, -0.261390, -0.309850, 0.186870, -0.144340, 
-0.040720, -0.198590, 0.232090, -0.570370, 0.239760, 0.034310, -0.289170, 0.107310, -0.368880, 0.003890, 
-0.105580, -0.045300, 0.018610, 0.180010, 
0.005550, -0.031680, -0.173900, 0.003960, -0.184640, -0.016150, -0.027580, -0.071250, 0.050980, 0.022400, 
0.095780, -0.064560, 0.084830, -0.017720, 0.091680, 0.016170, 0.014050, -0.023870, -0.051090, 0.019680, 
-0.163210, -0.071440, -0.087450, 0.002020, -0.099110, -0.006740, 0.042720, -0.073340, 0.026510, -0.068960, 
0.084430, -0.018110, 0.089830, 0.022020, 0.003660, -0.025760, -0.095050, 0.010020, -0.157740, -0.114810, 
-0.060240, -0.057160, -0.109400, -0.012650, -0.016870, -0.076460, 0.027610, -0.093210, 0.076990, -0.031010, 
0.070720, 0.016780, -0.000040, -0.042890, -0.124010, 0.012570, -0.205910, -0.104350, -0.099300, -0.041110, 
-0.075770, 0.001230, -0.053280, 0.004930, 0.001580, -0.104280, 0.063450, -0.026590, 0.070920, 0.006770, 
0.002910, -0.051530, -0.139810, 0.086950, -0.192350, -0.062240, -0.071090, -0.123580, -0.039470, -0.003530, 
-0.092920, 0.071680, -0.120600, -0.092520, 0.060500, -0.029070, 0.081870, 0.019850, -0.001030, -0.040750, 
-0.153330, 0.282140, -0.270800, -0.021980, 0.023300, -0.149670, 0.033670, 0.050280, -0.082980, 0.089720, 
-0.044350, -0.072490, 0.127530, -0.031010, 0.078240, 0.011150, 0.013220, -0.050390, -0.277490, 0.454880, 
-0.398310, -0.105640, 0.053950, -0.282650, -0.067220, 0.060470, -0.195240, -0.012020, -0.153230, -0.120310, 
0.075950, -0.028280, 0.066350, 0.014540, 0.004220, -0.049640, -0.165990, 0.308140, -0.188160, -0.031220, 
0.000340, -0.086150, -0.008580, -0.042750, 0.003940, 0.078360, -0.074430, -0.083050, 0.142750, -0.021500, 
0.091600, 0.018070, 0.003730, -0.033830, -0.172310, 0.131030, -0.085520, -0.076220, -0.097740, -0.034110, 
-0.005660, -0.176560, 0.012620, -0.049930, -0.002340, -0.071450, 0.093340, -0.025150, 0.092430, 0.010240, 
0.011280, -0.026070, -0.163320, 0.046980, -0.091360, -0.086010, -0.087330, -0.083670, -0.022520, -0.212040, 
-0.026310, 0.011440, -0.008210, -0.041610, 0.046780, -0.018360, 0.088620, 0.007220, 0.005340, -0.030930, 
-0.121320, 0.056620, -0.092520, -0.058710, -0.127620, -0.069470, -0.001930, -0.236360, -0.033610, 0.038270, 
-0.050920, -0.014330, 0.056220, -0.014160, 0.093200, 0.007900, 0.008740, -0.037140, -0.081760, 0.041920, 
-0.061010, -0.025770, -0.174430, 0.007640, 0.024430, -0.200410, -0.037250, -0.038720, -0.015960, 0.026420, 
0.049330, -0.022120, 0.087660, 0.025730, -0.004190, -0.024620, -0.019460, 0.020870, -0.096780, 0.031230, 
-0.129040, -0.068570, 0.051800, -0.126440, -0.114870, -0.070600, -0.031090, 0.065240, 0.067580, -0.013590, 
0.089170, 0.021210, 0.008660, -0.013870, 
-0.126220, -0.053070, 0.075300, -0.125760, -0.052370, 0.142880, -0.065470, 0.041060, -0.008730, -0.128220, 
-0.046670, -0.131750, -0.017500, 0.011830, -0.046170, -0.008320, -0.009540, -0.043470, -0.106370, -0.072400, 
0.080590, -0.070210, -0.115040, 0.116750, -0.051420, -0.023940, 0.020170, -0.055230, 0.122530, -0.141440, 
-0.006090, 0.018740, -0.042150, 0.001150, -0.027100, -0.030330, -0.090260, -0.119680, 0.039570, -0.060090, 
-0.116290, 0.088200, -0.060280, -0.063800, 0.007060, 0.005830, 0.142780, -0.138820, -0.023970, 0.015900, 
-0.049120, -0.000570, -0.018230, -0.032750, -0.016750, -0.121940, -0.019780, -0.035760, -0.136570, 0.067670, 
-0.035700, -0.105800, -0.028510, -0.007830, 0.113820, -0.161950, -0.020280, 0.013610, -0.062520, -0.009350, 
-0.033640, -0.044600, 0.053300, -0.127320, -0.151860, -0.047530, -0.140010, -0.011320, -0.040260, -0.109750, 
-0.083190, -0.111850, 0.005920, -0.159390, -0.041190, 0.000010, -0.062370, -0.013870, -0.025290, -0.051610, 
0.152430, -0.035830, -0.226040, -0.099370, -0.111630, 0.040620, -0.078160, -0.095670, 0.002050, -0.061800, 
-0.067810, -0.139040, 0.002090, 0.009170, -0.051440, -0.017430, -0.029230, -0.048640, 0.283780, -0.059770, 
-0.484470, 0.065470, -0.118920, -0.242660, 0.100620, -0.127640, -0.281550, -0.112840, -0.106530, -0.165330, 
-0.031950, -0.001940, -0.063580, -0.018910, -0.025770, -0.037880, 0.076050, -0.091350, -0.199230, -0.150550, 
-0.119400, 0.031830, -0.040070, -0.076530, -0.039950, -0.101940, -0.114520, -0.148020, -0.000500, 0.016790, 
-0.062530, -0.019820, -0.034840, -0.041410, -0.049890, -0.100730, -0.028320, -0.110910, -0.144350, 0.056410, 
-0.081590, -0.082600, 0.020980, -0.106500, -0.107170, -0.168800, -0.011090, 0.016570, -0.064650, -0.016010, 
-0.031430, -0.032700, -0.024040, -0.091300, 0.032340, -0.059040, -0.161770, 0.178210, -0.050650, -0.068410, 
0.095980, -0.091800, 0.000260, -0.144770, -0.006300, -0.001530, -0.070890, -0.013430, -0.028630, -0.040500, 
0.010130, 0.015910, -0.029730, -0.033080, -0.087950, 0.162060, -0.096910, 0.033780, 0.055690, -0.035050, 
0.034720, -0.116350, -0.000140, 0.013850, -0.056780, 0.009270, -0.019590, -0.022060, 0.033000, 0.077180, 
-0.084030, 0.014210, 0.003800, 0.077330, -0.094330, 0.075210, 0.011290, 0.012950, -0.006070, -0.116260, 
0.002390, 0.009680, -0.052020, 0.010040, -0.014560, -0.021000, 0.058990, 0.069130, -0.058840, -0.019410, 
0.046650, 0.111400, -0.118310, 0.180690, -0.021530, 0.044160, -0.055860, -0.113200, 0.026140, 0.001390, 
-0.046920, 0.008820, -0.005390, -0.022340, 
-0.095560, 0.005370, 0.021040, -0.165100, 0.126750, -0.039800, 0.015420, 0.025200, -0.112920, -0.263210, 
-0.212220, 0.014860, -0.218960, 0.022340, -0.158220, -0.015180, 0.019600, -0.036450, -0.044100, -0.023350, 
0.042490, -0.102680, 0.008470, 0.038740, 0.036910, -0.017960, -0.045790, -0.247410, -0.119210, 0.054020, 
-0.200110, 0.010240, -0.172630, -0.016030, 0.012230, -0.026070, -0.112820, 0.041260, 0.006380, -0.136610, 
0.064780, 0.065440, -0.124640, 0.039200, -0.008310, -0.268490, -0.351210, 0.069740, -0.217420, 0.024840, 
-0.153940, -0.016090, 0.012800, -0.024730, -0.106140, 0.047750, 0.028670, -0.178040, 0.069580, 0.101250, 
-0.232260, -0.010090, 0.016680, -0.478610, -0.089880, 0.090070, -0.201700, 0.030630, -0.169180, -0.014440, 
0.002730, -0.014840, 0.014220, -0.188390, 0.037910, -0.188520, -0.094800, 0.254310, -0.247830, -0.161650, 
0.137060, -0.664990, 0.035420, 0.078080, -0.222690, 0.015890, -0.180410, -0.018060, 0.007630, -0.018520, 
0.106200, -0.311690, 0.040380, -0.136610, -0.160150, 0.168860, -0.190910, -0.306330, 0.158620, -0.554570, 
-0.206080, 0.029450, -0.250210, 0.020780, -0.185440, -0.017000, -0.012000, -0.029780, 0.603190, -0.405970, 
-0.376020, 0.594180, -0.227500, -0.441930, 0.483110, -0.482400, -0.240970, -0.230670, -0.128710, 0.036550, 
-0.213030, 0.020530, -0.173610, -0.033190, 0.004820, -0.028830, -0.175150, -0.256520, -0.100960, 0.008390, 
-0.205810, -0.210120, 0.060150, -0.298180, -0.165380, -0.029920, -0.059830, 0.010010, -0.253840, 0.014890, 
-0.189480, -0.027460, -0.018910, -0.046530, -0.282470, -0.051360, -0.170410, 0.076950, -0.083010, -0.305090, 
0.053280, -0.029110, -0.287330, 0.159760, 0.008880, 0.002120, -0.213780, 0.016140, -0.180460, -0.021310, 
0.002190, -0.026950, -0.116120, 0.034550, -0.264950, 0.193960, -0.055600, -0.305170, 0.160830, 0.084870, 
-0.322230, 0.231200, -0.082760, 0.005890, -0.174610, 0.015870, -0.184200, -0.021470, 0.003030, -0.030600, 
-0.107490, 0.107760, -0.272630, 0.178160, 0.000520, -0.234810, 0.097970, 0.182110, -0.261840, 0.094750, 
-0.123090, 0.009190, -0.154090, 0.016050, -0.171210, -0.019270, 0.004640, -0.031250, -0.067030, 0.014210, 
-0.238580, 0.204970, -0.016340, -0.250530, 0.072510, 0.160460, -0.257210, 0.057200, -0.027430, -0.015030, 
-0.138920, 0.022020, -0.178740, -0.009240, 0.015760, -0.032690, 0.024040, -0.043120, -0.191940, 0.166710, 
-0.098020, -0.101080, 0.063860, 0.096280, -0.181020, 0.144660, -0.132180, -0.042470, -0.120670, 0.013770, 
-0.187490, -0.012940, 0.010130, -0.039240, 
-0.081160, -0.062990, 0.044690, -0.125950, -0.085260, 0.085180, -0.054270, 0.106650, -0.175610, -0.364090, 
0.025700, -0.173090, 0.052510, 0.053990, -0.113910, 0.007190, -0.056590, -0.079940, -0.018410, -0.082400, 
-0.004620, 0.069970, -0.178050, 0.012550, -0.082130, 0.068060, -0.135890, -0.229730, 0.075080, -0.131460, 
0.055290, 0.055960, -0.124480, 0.014300, -0.051850, -0.073810, 0.078610, -0.148090, -0.085880, 0.086710, 
-0.218330, 0.002450, -0.197580, 0.048050, -0.088360, 0.015550, 0.083890, -0.120840, 0.039810, 0.066400, 
-0.132150, 0.019320, -0.075490, -0.090990, 0.279090, -0.279320, -0.169960, 0.077440, -0.296580, 0.036590, 
-0.224760, -0.083420, -0.077280, -0.005770, 0.347060, -0.154330, 0.025870, 0.062820, -0.136550, 0.012340, 
-0.085490, -0.094310, 0.402870, -0.317990, -0.330460, -0.039890, -0.410950, 0.011590, -0.311830, -0.250080, 
-0.066350, -0.130170, 0.322460, -0.219380, -0.005880, 0.048410, -0.141190, -0.006800, -0.101360, -0.108680, 
0.493410, -0.198610, -0.503940, -0.102990, -0.316910, -0.167650, -0.346310, -0.238450, -0.196610, -0.064540, 
0.047260, -0.264360, -0.012920, 0.059920, -0.163480, -0.009370, -0.103930, -0.112460, 1.025330, -0.173680, 
-1.239670, 0.538620, -0.256030, -1.087970, 0.258500, -0.248270, -0.931250, 0.013740, -0.008650, -0.324970, 
-0.038930, 0.054270, -0.179260, -0.014590, -0.121850, -0.110610, 0.516140, -0.249290, -0.704020, -0.076890, 
-0.313000, -0.457100, -0.160030, -0.238100, -0.410220, 0.176940, 0.164640, -0.310070, -0.019930, 0.058940, 
-0.168810, -0.026140, -0.104650, -0.107740, 0.472040, -0.341000, -0.525340, 0.114330, -0.389390, -0.430520, 
-0.000870, -0.283000, -0.311030, 0.174350, 0.156240, -0.301680, -0.005620, 0.063190, -0.176070, -0.013450, 
-0.104640, -0.108500, 0.424240, -0.371770, -0.374480, 0.193500, -0.500960, -0.157220, 0.125630, -0.373670, 
-0.105110, 0.247830, 0.118860, -0.244020, 0.025440, 0.064720, -0.150880, -0.004090, -0.090920, -0.091590, 
0.340370, -0.293960, -0.330360, 0.180680, -0.457240, 0.013310, 0.061420, -0.252620, 0.011210, 0.104110, 
0.107300, -0.199940, 0.033770, 0.054610, -0.144520, 0.011910, -0.076490, -0.089840, 0.209520, -0.139250, 
-0.344520, 0.177180, -0.339590, -0.054260, 0.058210, -0.153340, -0.014010, -0.030640, -0.003530, -0.204640, 
0.049100, 0.056950, -0.152510, 0.014880, -0.068430, -0.080990, 0.078040, -0.102940, -0.227500, -0.005560, 
-0.301170, 0.179530, -0.086920, -0.036780, 0.095350, -0.145520, -0.121330, -0.229180, 0.061120, 0.067720, 
-0.154420, 0.024980, -0.063870, -0.073770, 
-0.103990, 0.085220, -0.080570, -0.137560, 0.072640, -0.027330, -0.180460, 0.287650, -0.278290, -0.528960, 
0.082030, -0.184390, 0.042330, 0.060090, -0.082400, -0.008530, -0.069010, -0.083840, 0.058740, -0.105520, 
-0.104220, 0.072920, -0.135600, -0.050200, -0.155910, 0.143190, -0.187990, -0.285610, 0.244060, -0.168790, 
0.055420, 0.052680, -0.085020, -0.001980, -0.086380, -0.087120, 0.240160, -0.241810, -0.157630, 0.139090, 
-0.244800, -0.069020, -0.205260, 0.020130, -0.141130, 0.167460, 0.363020, -0.152250, 0.036270, 0.062130, 
-0.099640, -0.004360, -0.098530, -0.092600, 0.362780, -0.314090, -0.252050, 0.128270, -0.337580, -0.136860, 
-0.184050, -0.175570, -0.176950, 0.383420, 0.448130, -0.202000, 0.014850, 0.064010, -0.111060, -0.016140, 
-0.115220, -0.104350, 0.402950, -0.301630, -0.374340, -0.040460, -0.372650, -0.190270, -0.232030, -0.330270, 
-0.225390, 0.215040, 0.363800, -0.260520, -0.036190, 0.054210, -0.138710, -0.026510, -0.129960, -0.109240, 
0.510490, -0.186540, -0.531390, -0.195280, -0.258460, -0.230800, -0.357910, -0.246330, -0.246840, 0.226790, 
0.123210, -0.312250, -0.039860, 0.059860, -0.145900, -0.034970, -0.140130, -0.117580, 1.055330, -0.185690, 
-1.210090, 0.258680, -0.205030, -0.887710, 0.157870, -0.239530, -0.821650, 0.151390, 0.119300, -0.358740, 
-0.055960, 0.058510, -0.135520, -0.053980, -0.134970, -0.110360, 0.679840, -0.296710, -0.733270, -0.209960, 
-0.292220, -0.351540, -0.154290, -0.244000, -0.339550, -0.056490, 0.098190, -0.329270, -0.038190, 0.060820, 
-0.135750, -0.042610, -0.135430, -0.107170, 0.327510, -0.427240, -0.204990, -0.238470, -0.423120, 0.027140, 
-0.294780, -0.305600, 0.096610, -0.044490, -0.062200, -0.309990, -0.030950, 0.063980, -0.144120, -0.039460, 
-0.122260, -0.106170, 0.255460, -0.446680, 0.007620, -0.055200, -0.540370, 0.373900, -0.159710, -0.330510, 
0.353160, -0.168200, 0.139200, -0.223470, 0.012550, 0.061640, -0.122290, -0.021570, -0.115360, -0.110080, 
0.281780, -0.202920, -0.167510, 0.054510, -0.361130, 0.330460, -0.109260, -0.030880, 0.221940, -0.128110, 
0.245570, -0.121950, 0.035180, 0.066290, -0.119490, 0.012050, -0.104880, -0.092250, 0.195600, 0.096840, 
-0.298390, 0.107190, -0.085920, 0.068770, -0.063840, 0.131740, 0.080180, -0.103870, 0.012070, -0.139960, 
0.046480, 0.065720, -0.118480, 0.013920, -0.080140, -0.089550, 0.188160, 0.142990, -0.217450, 0.017900, 
0.043110, 0.235090, -0.139540, 0.335060, 0.164300, -0.024960, -0.205780, -0.157350, 0.078820, 0.066200, 
-0.123080, 0.014130, -0.076990, -0.083630, 
0.056970, 0.049440, -0.051680, 0.205790, 0.184640, -0.381810, 0.413890, 0.401190, -0.781440, -0.440130, 
-0.760290, 0.337330, -1.225370, 0.041540, -0.326630, -0.075100, 0.003360, 0.027370, 0.249280, -0.495320, 
-0.085500, 0.505130, -0.312820, -0.402790, 0.518950, -0.033430, -0.554680, -0.242740, 0.134170, 0.271510, 
-1.242380, 0.034540, -0.338190, -0.104750, -0.029550, 0.005630, 0.347470, -0.648720, -0.143690, 0.458340, 
-0.439240, -0.260230, 0.368500, -0.102110, -0.505410, -0.055270, 0.429020, 0.232650, -1.271840, 0.029530, 
-0.346510, -0.115500, -0.029250, 0.011370, 0.188180, -0.479120, -0.225180, 0.388690, -0.219800, -0.566820, 
0.138160, 0.055540, -0.670670, -0.092230, 0.058120, 0.193940, -1.289820, 0.021440, -0.351710, -0.119400, 
-0.053570, -0.008860, 0.338100, -0.233880, -0.414430, 0.098610, 0.176370, -0.650910, -0.126490, 0.391980, 
-0.620380, -0.250550, 0.198380, 0.185050, -1.303330, 0.016720, -0.370230, -0.130360, -0.055530, -0.027340, 
0.660150, -0.048520, -0.372260, 0.048850, 0.354510, -0.628840, -0.332690, 0.691580, -0.448030, -0.497160, 
0.115560, 0.219450, -1.293200, 0.018510, -0.373000, -0.149250, -0.053590, -0.022660, 0.854190, 0.095740, 
-0.524940, 0.231700, 0.321140, -0.615200, 0.208600, 0.621550, -0.512390, -0.115270, 0.465190, 0.242860, 
-1.263440, 0.023720, -0.350390, -0.144310, -0.048160, -0.026870, 0.461440, -0.368530, 0.153390, -0.172520, 
0.047540, 0.159930, -0.046770, 0.451720, 0.136300, -0.100670, 0.116270, 0.272780, -1.261550, 0.038100, 
-0.351540, -0.127070, -0.050520, -0.019770, 0.055930, -0.602190, 0.323680, -0.039600, -0.188960, 0.150770, 
-0.085240, 0.305080, 0.125440, -0.074140, 0.146220, 0.137280, -1.336090, 0.011970, -0.391470, -0.142140, 
-0.056110, -0.068630, -0.067860, -0.324380, 0.222980, 0.080120, -0.384720, 0.290700, -0.001130, 0.237870, 
0.057650, -0.518250, 0.335540, 0.056470, -1.310630, 0.007580, -0.401170, -0.118780, -0.057030, -0.058490, 
-0.086020, -0.265240, 0.163280, 0.026980, -0.198390, 0.121180, -0.099780, 0.187120, -0.015900, -0.195930, 
0.248050, 0.001380, -1.256300, 0.016780, -0.390010, -0.111900, -0.023410, -0.086360, -0.087720, -0.052320, 
0.144240, 0.151750, -0.007450, -0.113580, -0.062560, 0.201030, 0.018560, 0.057730, 0.066560, 0.003780, 
-1.177330, 0.017680, -0.376280, -0.116420, -0.004380, -0.069420, -0.094780, -0.086690, 0.257440, 0.104250, 
0.021150, 0.053920, -0.096210, 0.250450, 0.187050, 0.404550, -0.230130, -0.084000, -1.117480, 0.023870, 
-0.363420, -0.109480, 0.029040, -0.062850, 
-0.168210, 0.416610, -0.032380, -0.058460, 0.282710, -0.226060, -0.093550, 0.600010, -0.376630, 0.395630, 
-0.375540, 0.506850, -0.202750, 0.062200, -0.048710, -0.013990, 0.065320, -0.088680, -0.062950, 0.259770, 
-0.031190, 0.036410, -0.060290, -0.047920, -0.029060, 0.127330, -0.074430, 0.357430, -0.306230, 0.530350, 
-0.189900, 0.060140, -0.049710, -0.016650, 0.070830, -0.090300, -0.271250, 0.442990, -0.080270, -0.160810, 
0.129750, -0.165230, -0.161900, 0.047180, -0.099900, 0.441920, -0.212740, 0.506470, -0.219560, 0.069940, 
-0.064430, -0.023760, 0.056740, -0.090970, -0.252680, 0.377600, -0.062710, -0.181630, 0.052790, -0.041430, 
-0.170850, 0.034570, -0.012190, 0.232310, 0.044070, 0.496630, -0.264180, 0.071420, -0.083230, -0.052410, 
0.033480, -0.109710, -0.041990, 0.095780, -0.094720, -0.259870, -0.221010, 0.195770, -0.292520, -0.277980, 
0.349250, -0.152330, -0.264170, 0.513880, -0.336090, 0.066670, -0.116610, -0.063500, 0.020680, -0.122540, 
-0.092600, 0.322320, -0.147340, -0.477040, -0.236970, 0.342810, -0.578640, -0.551270, 0.764630, 0.079450, 
-0.069760, 0.446120, -0.271500, 0.051790, -0.111440, -0.060060, 0.028070, -0.106310, 0.745510, 0.252690, 
-1.505370, 0.535070, -0.277110, -1.116470, 0.467370, -0.669150, -0.652370, -0.090700, 0.073480, 0.353740, 
-0.351730, 0.057170, -0.134140, -0.077290, -0.005630, -0.120270, 0.346720, -0.182270, -0.981400, 0.068060, 
-0.264510, -0.632880, 0.190480, -0.353170, -0.419010, 0.035550, 0.119140, 0.418340, -0.263310, 0.050390, 
-0.123590, -0.071150, 0.011440, -0.118840, 0.068310, -0.212330, -0.538020, 0.082000, -0.181070, -0.500490, 
0.089890, -0.125170, -0.273960, -0.288250, -0.118560, 0.436020, -0.262760, 0.060740, -0.122600, -0.063190, 
0.033690, -0.117690, -0.062480, -0.251400, -0.208250, -0.000850, -0.095230, -0.017830, 0.010710, -0.032730, 
0.013530, -0.563390, -0.095140, 0.531280, -0.260660, 0.070320, -0.117570, -0.060170, 0.029250, -0.106740, 
-0.154280, -0.138120, -0.103500, -0.171720, -0.097880, 0.448550, -0.269660, -0.001830, 0.295380, -0.299730, 
-0.100110, 0.626630, -0.231170, 0.063630, -0.095310, -0.036780, 0.044500, -0.092740, -0.408410, 0.158840, 
-0.124450, -0.379970, 0.035440, 0.441830, -0.427880, 0.048430, 0.253500, -0.136380, 0.355060, 0.571640, 
-0.203300, 0.050620, -0.110130, -0.019050, 0.039450, -0.076830, -0.386920, 0.006550, -0.065290, -0.722630, 
0.204930, 0.499730, -0.730200, 0.406670, 0.094230, 0.130480, 0.086420, 0.501860, -0.182220, 0.058390, 
-0.130950, -0.001370, 0.035010, -0.094210, 
-0.125220, -0.023700, 0.014880, -0.215350, 0.124280, -0.004010, 0.014820, 0.051110, -0.135820, -0.348840, 
-0.253380, -0.013810, -0.245250, 0.007470, -0.189910, -0.015010, 0.026670, -0.047310, -0.056500, -0.074260, 
0.053080, -0.096020, -0.042740, 0.066900, 0.051500, -0.029720, -0.048690, -0.356220, -0.154530, 0.013760, 
-0.222870, 0.015560, -0.184640, -0.023100, 0.027900, -0.035840, -0.135230, 0.000670, 0.013320, -0.133220, 
0.051350, 0.050840, -0.116270, 0.022560, -0.029150, -0.398040, -0.471450, 0.042450, -0.229800, 0.026270, 
-0.184240, -0.026040, 0.027130, -0.029890, -0.097650, 0.007510, 0.037810, -0.163590, 0.045510, 0.122350, 
-0.222880, 0.002710, -0.006580, -0.631840, -0.114540, 0.055200, -0.221720, 0.026980, -0.176680, -0.015800, 
0.030480, -0.046970, 0.029090, -0.222060, 0.025650, -0.191100, -0.093500, 0.314840, -0.263890, -0.143620, 
0.171250, -0.840810, 0.002300, 0.067890, -0.248400, 0.023290, -0.187410, -0.021370, 0.027180, -0.041050, 
0.101850, -0.288480, 0.049600, -0.163880, -0.150540, 0.271750, -0.243050, -0.269650, 0.233730, -0.702350, 
-0.268770, 0.059940, -0.237860, 0.025070, -0.185240, -0.024970, 0.004660, -0.038790, 0.626450, -0.333870, 
-0.474600, 0.669320, -0.201910, -0.534000, 0.512010, -0.418730, -0.338160, -0.326800, -0.142510, 0.041070, 
-0.234650, 0.024150, -0.194790, -0.044530, 0.005970, -0.038210, -0.261520, -0.196930, -0.106970, -0.009950, 
-0.176280, -0.184640, 0.038950, -0.219940, -0.197240, 0.001940, -0.054730, 0.009930, -0.251270, 0.012640, 
-0.185950, -0.034500, 0.008650, -0.042820, -0.366480, -0.000160, -0.205450, 0.117690, -0.064540, -0.333010, 
0.053580, 0.056750, -0.361550, 0.253310, 0.059730, 0.009750, -0.216820, 0.011460, -0.201670, -0.033290, 
0.016760, -0.056930, -0.151080, 0.089180, -0.349920, 0.258690, -0.029620, -0.382890, 0.232270, 0.154880, 
-0.435850, 0.337280, -0.039170, 0.006670, -0.191580, 0.015340, -0.188860, -0.022480, 0.020800, -0.033270, 
-0.107430, 0.142250, -0.353430, 0.241080, 0.031760, -0.304580, 0.154230, 0.252620, -0.351550, 0.156600, 
-0.140580, 0.027960, -0.188680, 0.015760, -0.191620, -0.009580, 0.025390, -0.037280, -0.051060, 0.046380, 
-0.326430, 0.291300, -0.009820, -0.321850, 0.141920, 0.208690, -0.331770, 0.142830, -0.054780, -0.009130, 
-0.166090, 0.024340, -0.197880, -0.009220, 0.019900, -0.049140, 0.064620, -0.073960, -0.237780, 0.228740, 
-0.112980, -0.115580, 0.106820, 0.117560, -0.226320, 0.247570, -0.205490, -0.018350, -0.151190, 0.011070, 
-0.182540, -0.012220, 0.021990, -0.054780, 
0.259610, 0.121940, -0.507030, 0.226330, 0.053630, -0.220990, 0.168560, 0.251310, -0.139540, 0.092070, 
-0.020630, -0.085620, 0.275380, 0.005800, 0.233670, 0.020270, -0.051570, -0.010990, 0.185090, -0.052100, 
-0.280440, 0.073470, 0.047230, -0.077520, -0.007660, 0.144450, 0.070770, 0.071930, -0.185940, -0.126200, 
0.289340, -0.000300, 0.226580, 0.029060, -0.050920, -0.027980, 0.040990, -0.179190, -0.208590, -0.027290, 
-0.161180, -0.029500, -0.115550, -0.104560, 0.133680, 0.030120, -0.043460, -0.246010, 0.245080, 0.000450, 
0.194300, 0.029530, -0.049490, -0.065800, -0.160900, -0.237390, -0.201440, -0.143670, -0.420140, 0.227400, 
-0.221220, -0.205700, 0.186600, 0.287800, -0.126110, -0.341630, 0.216520, -0.027850, 0.176340, 0.008470, 
-0.059760, -0.080670, -0.443730, -0.008340, -0.025850, -0.294600, -0.414650, 0.275340, -0.269990, -0.179660, 
0.255000, 0.274860, -0.447570, -0.324880, 0.204650, -0.013740, 0.176780, 0.008530, -0.072560, -0.080000, 
-0.600740, 0.621330, -0.172410, -0.356400, -0.088990, 0.290120, -0.290870, 0.150770, 0.263900, 0.104280, 
-0.008790, -0.281530, 0.360420, -0.014920, 0.205950, 0.031200, -0.043830, -0.077460, -0.838670, 1.226880, 
-0.711070, -0.538960, 0.191920, -0.228560, -0.606390, 0.483950, -0.218830, -0.291630, -0.212980, -0.359900, 
0.251720, -0.029420, 0.177150, 0.024910, -0.062820, -0.080040, -0.550350, 0.868100, -0.371640, -0.352310, 
0.143040, -0.004660, -0.458610, 0.381440, -0.013910, -0.083340, -0.010680, -0.308410, 0.364110, -0.024410, 
0.188120, 0.039230, -0.044880, -0.073670, -0.466620, 0.343160, -0.050000, -0.321530, -0.033910, 0.076270, 
-0.278180, -0.009340, 0.058190, -0.373660, 0.056940, -0.224400, 0.292210, -0.014880, 0.190550, 0.026370, 
-0.042920, -0.063200, -0.305730, 0.232700, -0.051320, -0.160750, 0.025700, -0.011670, -0.098120, -0.150070, 
0.024010, -0.179700, -0.034620, -0.131320, 0.243410, -0.013870, 0.217370, 0.034370, -0.043040, -0.047120, 
-0.115670, 0.167150, -0.058690, 0.022110, -0.097040, 0.025170, 0.100380, -0.318570, 0.044060, -0.070600, 
-0.204760, -0.040470, 0.261600, -0.007390, 0.226250, 0.044460, -0.042970, -0.047870, 0.024580, 0.210290, 
-0.117420, 0.151140, -0.342940, 0.243480, 0.248250, -0.266650, -0.003380, 0.047510, 0.019790, 0.042920, 
0.288240, -0.005980, 0.212750, 0.048020, -0.055760, -0.018340, 0.082270, 0.274200, -0.081560, 0.281080, 
-0.216410, 0.155140, 0.256490, 0.076630, -0.198960, 0.131190, -0.088410, 0.124050, 0.329030, 0.005660, 
0.227560, 0.052780, -0.035690, 0.004020, 
0.210630, 0.169530, -0.484460, 0.214090, -0.214010, -0.243840, 0.236970, -0.001850, -0.055890, -0.119580, 
-0.058010, 0.312990, 0.122560, -0.044000, 0.215570, 0.126010, 0.182670, -0.090990, 0.171790, 0.222320, 
-0.568010, 0.089130, -0.249630, -0.114140, 0.174430, -0.131900, -0.029070, -0.286920, 0.037420, 0.281870, 
0.133940, -0.034120, 0.211070, 0.121500, 0.198280, -0.112480, -0.051590, 0.187790, -0.542790, 0.046660, 
-0.093440, -0.226720, 0.269900, -0.044910, -0.128280, -0.181640, 0.110200, 0.271140, 0.116880, -0.030220, 
0.196150, 0.127740, 0.194500, -0.118070, -0.062010, 0.311400, -0.694030, 0.279270, -0.104550, -0.215220, 
0.596350, 0.058780, -0.241010, 0.031260, 0.113250, 0.315160, 0.057620, -0.048220, 0.200780, 0.116340, 
0.208260, -0.141550, -0.221580, 0.413110, -0.394390, 0.246460, -0.061560, -0.039860, 0.505550, 0.083320, 
0.095440, 0.090110, 0.004070, 0.395400, 0.073800, -0.033370, 0.190770, 0.125950, 0.199250, -0.124150, 
-0.033340, 0.794080, -0.905110, 0.218000, 0.084010, -0.361440, 0.426800, -0.023400, -0.047870, 0.420000, 
0.181350, 0.389210, 0.151150, -0.033830, 0.197970, 0.133870, 0.217130, -0.125070, 0.121100, 1.312980, 
-2.094760, 0.378350, 0.245270, -1.559030, 0.576100, -0.058370, -1.073110, 0.176110, -0.007450, 0.231670, 
-0.000130, -0.048360, 0.143290, 0.099850, 0.171520, -0.146860, -0.238580, 0.701380, -0.770900, 0.030620, 
-0.018260, -0.489520, 0.238980, -0.252960, 0.030290, 0.300400, 0.281270, 0.312620, 0.127260, -0.032800, 
0.162850, 0.119500, 0.210500, -0.114660, -0.441370, 0.353780, 0.010790, -0.195860, -0.061280, 0.040660, 
-0.073010, -0.367740, 0.371020, 0.048580, 0.116850, 0.336570, 0.120570, -0.034150, 0.171350, 0.124260, 
0.217050, -0.090180, -0.231950, 0.199980, -0.214450, -0.287020, 0.119220, 0.172290, -0.169990, -0.252340, 
0.206430, 0.074440, 0.475370, 0.433250, 0.055700, -0.034990, 0.181140, 0.141020, 0.214640, -0.078530, 
-0.159580, 0.321500, -0.373080, -0.188000, -0.067850, 0.219340, -0.165640, -0.223790, 0.020380, 0.123270, 
0.307550, 0.550900, -0.002130, -0.027600, 0.166550, 0.148690, 0.206460, -0.046360, -0.252150, 0.213610, 
-0.408550, -0.213120, -0.255200, 0.184150, -0.191760, -0.203410, -0.114820, -0.192780, 0.068480, 0.518060, 
-0.050010, -0.033410, 0.136210, 0.154890, 0.162960, -0.040740, -0.040200, 0.066520, -0.447620, -0.112110, 
-0.090420, -0.222560, -0.243370, 0.115070, -0.420820, -0.230660, 0.396990, 0.602420, -0.063400, -0.025130, 
0.139790, 0.184450, 0.166280, -0.033330, 
0.229610, -0.115590, 0.003500, -0.039330, 0.247210, -0.314880, 0.017960, -0.095460, -0.224390, -0.117350, 
-0.061260, 0.075850, -0.022330, -0.029490, -0.061230, 0.052330, 0.043210, 0.064360, 0.150330, -0.022920, 
0.046480, -0.158440, 0.062630, -0.109270, -0.040100, -0.143790, -0.111790, -0.083750, -0.009270, 0.131640, 
-0.022360, -0.033800, -0.043910, 0.050930, 0.048610, 0.066460, 0.052830, 0.309690, 0.065550, -0.196850, 
0.155660, -0.039100, -0.078860, 0.104620, -0.109300, -0.320720, -0.080120, 0.205670, 0.022040, -0.025270, 
-0.014090, 0.068110, 0.070320, 0.079820, -0.096550, 0.527700, 0.116750, -0.243110, 0.540350, -0.317720, 
-0.106620, 0.193390, -0.217240, -0.477000, 0.018520, 0.217180, 0.020370, -0.027040, -0.010380, 0.060610, 
0.051750, 0.094670, -0.251070, 0.363740, 0.105760, -0.450780, 0.511300, -0.285590, -0.324220, 0.221990, 
-0.403700, -0.334060, -0.010890, 0.061090, -0.050420, -0.027940, -0.020660, 0.056670, 0.037540, 0.091520, 
-0.528840, -0.347810, 0.315560, -0.605410, 0.156620, -0.420140, -0.466880, -0.163420, -0.576740, -0.634940, 
0.060160, -0.191510, -0.352570, -0.037090, -0.096170, 0.023610, -0.002180, 0.045500, -0.341900, -0.855780, 
1.118460, -0.701990, -0.179850, 0.626560, -0.608100, -0.556610, 0.502490, -0.119280, 0.037510, -0.072160, 
-0.194570, -0.029070, -0.049860, 0.051400, 0.021050, 0.071770, 0.087460, -0.792980, 0.143270, -0.107400, 
-0.460220, -0.358980, -0.017020, -0.844950, -0.337120, -0.020250, -0.216400, -0.137540, -0.385750, -0.043510, 
-0.081270, 0.022930, -0.002190, 0.041200, 0.283860, -0.074760, -0.004480, 0.054400, -0.055150, -0.248710, 
0.170560, -0.346720, -0.151410, 0.282330, -0.352660, 0.001890, -0.105590, -0.032320, -0.041990, 0.039410, 
0.030980, 0.073630, 0.132680, 0.274880, 0.088250, 0.011960, 0.238980, -0.224720, 0.217730, -0.042010, 
-0.121210, -0.105310, -0.429700, 0.083330, 0.063580, -0.019930, -0.010090, 0.045770, 0.065140, 0.079610, 
0.060880, 0.081920, 0.246690, -0.151390, 0.278260, 0.177160, 0.123140, 0.178160, 0.113730, 0.028450, 
-0.023350, 0.128660, 0.097730, -0.007920, 0.010890, 0.064140, 0.078480, 0.086190, -0.022000, 0.019150, 
0.242230, 0.037070, 0.174020, 0.037090, 0.238810, 0.180030, 0.032720, 0.126740, 0.046230, 0.123680, 
0.083470, -0.005290, 0.005180, 0.054090, 0.076300, 0.069990, 0.107030, -0.144740, 0.145600, 0.424510, 
-0.194190, -0.139280, 0.636840, -0.386950, 0.136910, 0.043360, 0.228560, 0.104760, 0.032380, -0.002360, 
-0.000050, 0.045420, 0.060800, 0.076890, 
-0.026420, 0.067420, -0.201000, -0.003630, -0.053880, -0.077860, -0.027630, 0.138440, -0.060140, 0.047480, 
0.001480, 0.014960, 0.028620, -0.018780, 0.113080, 0.025030, 0.024200, -0.055050, -0.046240, 0.005820, 
-0.157450, -0.065320, -0.099550, -0.000830, -0.061680, 0.041600, 0.010930, -0.053130, 0.022670, -0.005590, 
0.039400, -0.021430, 0.100350, 0.025990, 0.013750, -0.055790, -0.099030, -0.041970, -0.160160, -0.085360, 
-0.096720, -0.034730, -0.077270, -0.054270, -0.014530, -0.060490, 0.066820, -0.048870, 0.022910, -0.017390, 
0.100820, 0.026070, 0.021340, -0.071180, -0.083860, -0.066920, -0.204760, -0.027330, -0.167520, -0.008400, 
-0.007670, -0.037340, -0.037690, 0.002880, -0.025180, -0.037260, -0.005400, -0.029660, 0.100310, 0.025320, 
0.013180, -0.074140, -0.109340, 0.042110, -0.166210, -0.012480, -0.170450, -0.013840, 0.002660, -0.020640, 
0.027330, 0.019080, -0.230660, 0.014420, -0.007580, -0.021020, 0.084620, 0.027960, 0.025500, -0.077300, 
-0.026470, 0.280300, -0.278220, 0.013960, -0.037350, -0.000670, 0.050550, -0.002480, 0.082710, 0.097830, 
-0.067610, 0.063660, 0.111660, -0.026680, 0.098570, 0.038460, 0.029510, -0.056170, -0.095930, 0.576410, 
-0.766960, 0.014940, 0.041250, -0.504080, 0.084030, 0.017510, -0.403400, -0.110990, -0.223310, -0.009560, 
0.001000, -0.018720, 0.077420, 0.015820, 0.011270, -0.074880, -0.128500, 0.352850, -0.296720, -0.078070, 
0.015700, -0.077270, -0.007610, 0.031840, 0.011930, 0.034800, -0.053220, 0.040290, 0.101070, -0.026620, 
0.090870, 0.027630, 0.039730, -0.052180, -0.182370, 0.196830, -0.141870, -0.104700, -0.008390, -0.075240, 
-0.038390, -0.026840, -0.025710, -0.127350, 0.005640, 0.051650, 0.028480, -0.005830, 0.097840, 0.033230, 
0.037910, -0.049450, -0.132560, 0.130170, -0.181970, -0.094710, 0.051350, -0.093780, -0.066390, -0.028650, 
-0.079750, -0.050360, 0.090330, 0.088190, -0.018400, -0.020520, 0.086970, 0.021140, 0.029770, -0.052650, 
-0.081700, 0.117540, -0.177570, -0.030460, -0.032590, -0.070280, -0.057630, -0.082880, -0.079440, 0.057400, 
-0.031410, 0.134480, -0.021370, -0.011780, 0.096670, 0.035670, 0.028880, -0.039380, -0.032220, 0.089910, 
-0.147410, 0.006620, -0.145260, 0.056980, -0.012770, -0.112630, -0.049420, 0.041000, 0.025310, 0.134850, 
-0.002190, -0.011690, 0.090540, 0.039920, 0.019730, -0.027190, 0.018130, 0.019410, -0.109160, 0.040080, 
-0.129800, 0.020490, -0.030950, -0.034510, -0.119970, 0.042420, -0.018330, 0.183710, -0.004610, -0.021830, 
0.097360, 0.043690, 0.029470, -0.013520, 
0.204420, 0.132150, -0.302880, 0.152230, -0.004220, -0.009580, 0.098690, 0.322440, 0.059540, 0.219900, 
-0.110290, 0.114280, 0.032660, -0.044630, 0.244070, 0.065850, 0.085910, -0.084930, 0.088430, -0.106670, 
-0.063700, -0.098200, -0.307180, 0.355930, -0.115280, -0.066550, 0.446860, -0.017300, -0.105300, 0.021320, 
0.042190, -0.050740, 0.228330, 0.061820, 0.083120, -0.115270, -0.201830, -0.121400, 0.000080, -0.260330, 
-0.348800, 0.357960, -0.202820, -0.293620, 0.484480, -0.115380, -0.046780, -0.048290, 0.003590, -0.052900, 
0.217110, 0.060560, 0.073400, -0.140490, -0.265100, -0.204650, 0.012780, -0.185950, -0.396800, 0.451970, 
-0.147510, -0.193630, 0.438410, -0.097250, 0.108500, -0.040320, -0.052970, -0.056630, 0.197940, 0.048240, 
0.070200, -0.148850, -0.353910, 0.096070, -0.064990, -0.166160, -0.322960, 0.370060, -0.157030, 0.017570, 
0.355600, -0.142860, -0.121380, 0.002160, -0.058790, -0.059890, 0.190960, 0.054470, 0.075340, -0.150030, 
-0.165250, 0.586660, -0.674190, -0.171860, -0.097610, 0.066450, -0.105400, 0.106940, 0.061690, -0.196460, 
0.141410, 0.036920, 0.033110, -0.053860, 0.196930, 0.056230, 0.085530, -0.128410, -0.147060, 1.053450, 
-1.525870, -0.081240, -0.030260, -0.749260, 0.016910, 0.091480, -0.684330, -0.448760, -0.240250, -0.064540, 
-0.085490, -0.060780, 0.159750, 0.035920, 0.058300, -0.158390, -0.322300, 0.425210, -0.543920, -0.275130, 
-0.327650, 0.140960, -0.116210, -0.129460, 0.232960, -0.251130, -0.175770, 0.004550, 0.031090, -0.063190, 
0.194850, 0.060820, 0.084050, -0.121690, -0.295050, 0.160760, -0.151110, -0.171580, -0.306230, 0.160400, 
-0.033700, -0.234460, 0.193750, -0.448370, -0.160640, 0.068230, -0.007660, -0.056590, 0.191010, 0.056280, 
0.084110, -0.116570, -0.234400, 0.105960, -0.113830, -0.082930, -0.114370, 0.169210, -0.075940, -0.127740, 
0.118040, -0.225180, 0.012560, 0.176710, -0.050070, -0.047630, 0.204740, 0.072970, 0.082340, -0.109560, 
-0.076590, 0.030580, -0.183340, 0.033430, -0.254760, 0.310040, -0.130500, -0.095510, 0.068010, 0.220390, 
-0.076190, 0.241530, -0.061090, -0.051780, 0.211750, 0.086090, 0.075530, -0.072310, 0.127920, 0.072960, 
-0.192930, 0.259910, -0.379860, 0.366230, 0.135460, -0.048560, -0.054220, 0.127820, -0.009780, 0.291280, 
-0.026120, -0.040790, 0.206570, 0.104200, 0.079030, -0.052760, 0.237790, 0.039570, -0.165730, 0.354740, 
-0.249770, 0.249090, 0.122710, 0.175040, -0.172610, -0.000680, -0.103220, 0.375180, 0.006510, -0.041250, 
0.220200, 0.116410, 0.083550, -0.041770, 
0.126770, 0.045160, -0.081530, 0.000240, 0.046400, -0.262190, -0.026200, -0.199400, -0.059390, 0.092670, 
0.023470, 0.035980, 0.052680, -0.030630, -0.016210, 0.029140, 0.026490, 0.045500, 0.139280, -0.043760, 
-0.083090, -0.041400, -0.063640, -0.175660, -0.032120, -0.227030, -0.042900, -0.035350, -0.042550, 0.063460, 
0.039660, -0.023450, -0.003070, 0.018860, 0.030480, 0.052590, 0.195110, -0.044390, -0.045800, 0.034850, 
-0.093720, -0.142650, 0.051760, -0.165630, -0.075950, -0.024940, -0.177220, 0.102880, 0.046340, -0.025430, 
0.012360, 0.026830, 0.041110, 0.063010, 0.190360, -0.057800, -0.008980, 0.046570, 0.023960, -0.224200, 
0.130510, -0.142040, -0.157140, -0.058390, 0.041710, 0.104300, 0.040650, -0.018520, 0.016490, 0.032630, 
0.028990, 0.075030, -0.052140, -0.027790, 0.040690, -0.077610, -0.010340, -0.209240, -0.005150, -0.135650, 
-0.240930, -0.012630, 0.005390, -0.014060, -0.001790, -0.026890, 0.009210, 0.024640, 0.022170, 0.061190, 
-0.533460, -0.102980, 0.182500, -0.367790, -0.061170, -0.266670, -0.331020, -0.154710, -0.299680, -0.202020, 
-0.005110, -0.162310, -0.139550, -0.028020, -0.038210, -0.002630, -0.017000, 0.031280, -0.845010, -0.048140, 
0.779660, -0.807580, -0.035400, 0.418760, -0.900350, -0.186740, 0.463460, -0.002200, 0.130440, -0.139750, 
-0.094700, -0.021830, -0.028910, 0.006730, -0.000010, 0.052630, -0.213650, -0.056410, 0.003470, -0.228620, 
-0.076890, -0.310430, -0.371980, -0.299050, -0.125520, 0.033880, 0.159900, -0.159960, -0.179050, -0.026400, 
-0.023650, -0.003080, -0.017390, 0.033530, 0.014930, 0.111970, 0.023930, -0.194470, 0.020410, -0.099760, 
-0.229090, -0.185940, 0.048510, 0.075540, 0.102620, -0.016020, -0.048510, -0.027270, -0.009180, 0.014930, 
0.003720, 0.053130, 0.070490, 0.096880, 0.042950, -0.128460, 0.086540, -0.155210, -0.034590, -0.113690, 
-0.058920, -0.026910, -0.074540, 0.034410, 0.012020, -0.015310, 0.008870, 0.018080, 0.011420, 0.055470, 
0.027300, 0.025010, 0.036190, -0.175810, 0.058220, -0.031860, 0.007980, -0.017820, -0.055980, -0.016330, 
0.025340, 0.084430, 0.016000, -0.008600, 0.030240, 0.015560, 0.018250, 0.045530, -0.081030, 0.048010, 
0.067080, -0.173950, 0.072640, -0.052800, 0.039580, 0.038250, -0.075080, -0.023040, -0.091270, 0.114700, 
0.018400, -0.002850, 0.021260, -0.005990, 0.013190, 0.052190, -0.095280, 0.016640, 0.025400, -0.030420, 
-0.007000, -0.100080, 0.132670, -0.169550, 0.031990, -0.093040, -0.014690, 0.115050, -0.023670, -0.016360, 
0.034670, -0.000380, 0.014030, 0.047310, 
0.623970, -0.080660, -0.107000, 0.345790, 0.003380, -0.439040, 0.409850, -0.448970, -0.094230, 0.385950, 
0.092530, 0.139810, 0.075370, -0.092580, -0.099840, 0.038830, 0.055640, 0.068610, 0.360250, 0.062010, 
-0.114220, -0.059400, -0.099590, -0.136990, 0.086370, -0.426310, 0.019570, -0.078480, -0.139780, 0.153670, 
0.045250, -0.100270, -0.084670, 0.042370, 0.043440, 0.077610, 0.397950, 0.250840, -0.153620, -0.101990, 
0.082180, -0.113230, 0.075690, -0.148730, 0.041080, -0.357930, -0.511230, 0.231550, 0.061210, -0.103800, 
-0.080640, 0.037830, 0.063650, 0.087130, 0.278810, 0.204840, 0.089110, -0.123680, 0.329990, -0.181430, 
0.121530, -0.084490, 0.037170, -0.325170, 0.017760, 0.275260, 0.065830, -0.093960, -0.057960, 0.051350, 
0.053040, 0.103440, 0.117980, -0.080020, 0.091610, -0.190120, 0.122630, -0.135910, -0.048880, -0.119360, 
-0.237170, -0.006830, 0.538580, 0.052410, -0.009630, -0.099500, -0.092760, 0.025800, 0.037020, 0.084580, 
-0.450730, -0.552280, 0.053620, -0.434630, -0.227390, -0.542990, -0.381300, -0.452120, -0.621720, -0.315250, 
0.417820, -0.315170, -0.405760, -0.107220, -0.178190, -0.022780, -0.034980, 0.034950, -0.716560, -0.641480, 
1.181330, -0.838920, -0.263420, 0.689800, -0.938620, -0.619340, 0.723450, 0.276860, 0.263720, -0.203230, 
-0.225770, -0.099380, -0.139090, 0.018770, 0.007440, 0.055990, -0.324710, -0.257190, -0.155830, -0.337590, 
-0.122910, -0.722640, -0.434000, -0.556940, -0.416180, 0.112750, -0.158340, -0.301920, -0.476970, -0.126540, 
-0.176460, -0.019130, -0.049950, 0.034420, -0.126160, 0.459140, -0.193310, -0.456860, 0.363410, -0.436350, 
-0.419460, -0.050750, -0.087900, 0.365030, -0.340850, -0.030040, -0.170600, -0.103990, -0.115370, -0.006420, 
-0.009460, 0.067230, -0.100410, 0.521010, -0.093850, -0.297780, 0.455840, -0.479390, -0.177820, 0.033820, 
-0.191240, 0.280750, -0.448470, 0.025530, -0.032450, -0.093290, -0.089300, 0.007450, 0.012710, 0.063230, 
-0.022250, 0.259750, -0.002950, -0.221680, 0.126850, -0.073810, -0.029800, 0.123520, -0.094770, 0.292020, 
-0.098670, 0.050890, 0.008300, -0.070800, -0.059570, 0.001470, 0.023740, 0.077000, -0.087920, 0.118130, 
0.092250, -0.113630, 0.093580, -0.215050, 0.120210, 0.164270, -0.204170, -0.082330, -0.045960, 0.031690, 
0.022210, -0.076870, -0.065400, -0.010810, 0.040250, 0.062250, -0.109010, -0.083600, 0.105890, -0.056670, 
-0.090010, -0.093200, 0.232030, -0.294570, 0.121190, -0.414230, 0.084420, 0.008620, -0.014790, -0.065170, 
-0.058670, -0.024900, 0.029270, 0.037870, 
-0.465240, -0.156050, 0.634760, -0.933840, 0.548210, 0.041110, -0.508380, 0.206790, -0.149940, 0.104890, 
0.313300, 0.309300, -0.973170, 0.041650, -0.503080, -0.002190, -0.017010, 0.266760, -0.079230, -0.370940, 
0.509820, -0.504430, 0.132440, 0.263400, -0.147760, -0.021410, -0.068090, 0.093860, 0.308820, 0.442470, 
-0.949460, 0.060940, -0.468600, -0.008450, -0.021050, 0.287980, 0.314930, -0.607010, 0.249080, -0.374790, 
0.086740, 0.422050, -0.119550, 0.102660, -0.081880, 0.041970, 0.125320, 0.557810, -0.899280, 0.064310, 
-0.446660, -0.011810, 0.001920, 0.307160, 0.102350, -0.634010, 0.496290, -0.373300, 0.215670, 0.390780, 
-0.168300, 0.077920, -0.133190, -0.147240, 0.048900, 0.520720, -0.886200, 0.068290, -0.452850, 0.007320, 
-0.010230, 0.332560, 0.350910, -0.884770, 0.151920, -0.186400, 0.096790, 0.183720, -0.017940, -0.160980, 
-0.346140, 0.085520, 0.143990, 0.293620, -0.943630, 0.065230, -0.476950, -0.031280, -0.036000, 0.302310, 
0.572850, -1.248190, 0.230230, -0.009160, -0.063890, -0.212380, -0.012190, -0.557200, -0.277560, 0.072660, 
-0.055440, 0.132460, -1.098850, 0.052930, -0.520010, -0.045670, -0.077190, 0.280360, 0.889430, -1.277740, 
0.630920, 0.443640, 0.030590, -0.216560, 0.386110, -0.575060, 0.193950, 0.168750, 0.310010, 0.242280, 
-0.976590, 0.073770, -0.491620, -0.026050, -0.058550, 0.285770, -0.059960, -0.744550, 0.359130, 0.040110, 
0.341450, -0.595620, -0.102000, -0.032670, -0.251340, -0.264320, 0.348530, 0.140540, -1.139240, 0.053580, 
-0.529090, -0.055310, -0.083860, 0.266940, -0.609960, -0.575390, 0.507650, -0.138010, 0.248960, -0.158560, 
-0.457760, 0.249910, 0.110750, -0.071430, 0.457420, 0.062880, -0.984470, 0.053380, -0.529210, -0.035620, 
-0.076390, 0.254420, -0.638700, -0.325970, 0.443370, -0.098950, -0.188850, 0.183690, -0.387220, 0.229510, 
0.176410, 0.151720, 0.479520, -0.029850, -0.875280, 0.071260, -0.519300, -0.045760, -0.088450, 0.249020, 
-0.347400, -0.349890, 0.136370, 0.157780, -0.307480, -0.043950, -0.025790, 0.241550, -0.181730, 0.187000, 
0.658050, -0.138870, -0.874140, 0.052190, -0.533090, -0.052920, -0.066050, 0.229560, -0.489580, -0.608790, 
0.463880, 0.039190, -0.163050, -0.163400, -0.143490, 0.178950, -0.011110, 0.040370, -0.085130, -0.246340, 
-0.838070, 0.055660, -0.520990, -0.047290, -0.041510, 0.199510, -0.251760, -0.550190, 0.247230, -0.011590, 
-0.275840, -0.298890, 0.035350, -0.265310, -0.084810, 0.038590, -0.075930, -0.468970, -0.815570, 0.040220, 
-0.548690, -0.058100, -0.023240, 0.161220, 
-0.154560, 0.149470, 0.131050, -0.175930, 0.147570, 0.023150, -0.167040, -0.187240, 0.247170, 0.223190, 
-0.456060, 0.184810, -0.020610, -0.002190, 0.030940, 0.030990, 0.045590, 0.071740, -0.154450, -0.019530, 
0.167050, -0.178120, 0.115330, 0.065800, -0.294990, -0.062740, 0.156970, 0.035690, -0.101890, 0.188940, 
-0.051260, -0.014830, 0.034290, 0.029420, 0.035710, 0.059580, -0.153700, 0.041820, 0.121510, -0.116850, 
0.049250, 0.040780, -0.216130, 0.018170, -0.011820, 0.249800, -0.214790, 0.229500, -0.080900, -0.014930, 
0.056880, 0.033520, 0.046970, 0.056190, -0.279910, 0.017560, 0.121040, -0.220670, 0.125150, -0.089890, 
-0.149510, 0.014910, -0.206760, 0.205150, -0.111780, 0.148540, -0.115370, -0.006030, 0.050940, 0.027140, 
0.026360, 0.058770, -0.773800, 0.187910, 0.298920, -0.508780, 0.071030, -0.037970, -0.392700, -0.066520, 
-0.206360, 0.078550, -0.263610, -0.001060, -0.169470, -0.011150, 0.028270, 0.022260, -0.001600, 0.036800, 
-1.235670, 0.261330, 0.396740, -0.761920, 0.055290, -0.159770, -0.753810, 0.028010, -0.257880, -0.075120, 
-0.342780, -0.174570, -0.292270, -0.029820, -0.009500, -0.002930, -0.034560, 0.019990, -1.521970, 0.428680, 
0.759000, -1.242750, 0.104510, 0.375900, -1.411570, 0.138250, 0.378160, 0.194360, -0.009990, -0.209650, 
-0.273250, -0.018380, -0.016180, -0.001870, -0.042360, 0.032270, -0.871260, 0.248390, 0.364100, -0.712530, 
-0.004420, 0.064540, -0.971030, -0.060690, 0.145570, 0.199820, 0.164670, -0.196870, -0.309480, -0.023330, 
-0.025400, 0.004820, -0.041530, 0.024430, -0.267330, 0.141030, 0.115330, -0.312420, -0.042080, -0.042940, 
-0.460830, -0.101360, 0.025900, -0.055050, -0.033380, -0.065420, -0.237640, -0.019860, 0.004420, 0.008060, 
-0.028680, 0.036530, -0.027850, 0.055730, 0.053100, -0.147540, 0.008680, -0.008360, -0.095780, -0.055240, 
-0.048010, -0.183050, -0.254730, 0.117080, -0.187180, -0.000270, 0.047190, 0.004510, 0.001370, 0.050810, 
0.015350, -0.027120, 0.008770, -0.226550, 0.103960, 0.104350, 0.003140, 0.055250, -0.039490, -0.021130, 
-0.077780, 0.256760, -0.167610, 0.008830, 0.059600, 0.020420, 0.010570, 0.062000, 0.022580, 0.024670, 
0.082860, -0.108700, 0.114860, 0.140070, 0.148300, 0.100180, -0.009410, 0.115280, -0.300490, 0.365140, 
-0.136240, 0.015900, 0.075080, 0.028120, 0.031780, 0.055790, 0.068000, 0.030790, 0.004850, 0.252710, 
0.136870, -0.102430, 0.380380, 0.044400, -0.052920, 0.006640, -0.434180, 0.427130, -0.162830, 0.009060, 
0.070470, 0.018230, 0.022580, 0.063950, 
0.200060, 0.095850, -0.031500, -0.160790, 0.160700, -0.149620, 0.124420, -0.289090, 0.040050, 0.466230, 
-0.254830, 0.237600, -0.232190, -0.017870, -0.306340, 0.132050, -0.139910, -0.102040, 0.243730, -0.013380, 
-0.012110, 0.101320, -0.171370, 0.051300, 0.262620, -0.525000, 0.005650, 0.425680, -0.503040, 0.337160, 
-0.218720, -0.019540, -0.289840, 0.124920, -0.143490, -0.078210, 0.487990, 0.043970, -0.271650, 0.107020, 
-0.236960, 0.196790, 0.117910, -0.503790, -0.005180, 0.302210, -0.199920, 0.396530, -0.197420, -0.004450, 
-0.274950, 0.123540, -0.139030, -0.056480, 0.577010, -0.014790, -0.344280, 0.069360, -0.201470, 0.010200, 
0.016480, -0.545980, -0.175670, 0.006350, -0.222350, 0.353720, -0.229300, 0.002840, -0.289290, 0.106090, 
-0.154410, -0.047290, 0.576120, -0.331050, -0.298910, -0.034740, -0.424520, 0.050400, -0.059640, -0.824040, 
-0.073630, 0.013130, -0.274540, 0.237840, -0.344150, 0.000210, -0.308050, 0.103040, -0.188210, -0.058950, 
0.968150, -1.055610, -0.073960, -0.137630, -0.548730, -0.003270, -0.099820, -1.170200, 0.099870, -0.153620, 
-0.209270, 0.076460, -0.494270, -0.014140, -0.347190, 0.070080, -0.210830, -0.103520, 1.175060, -1.256210, 
0.389300, 0.230130, -0.631820, 0.220100, 0.369060, -1.386490, 0.536720, -0.032960, -0.002700, 0.150300, 
-0.378630, 0.002400, -0.330050, 0.089760, -0.197810, -0.083980, 0.252330, -0.963060, 0.468880, -0.139960, 
-0.554910, 0.117050, 0.162770, -1.133380, 0.355260, 0.094640, 0.002830, 0.123700, -0.485350, -0.012730, 
-0.345080, 0.080230, -0.219190, -0.099590, -0.014110, -0.454790, 0.058450, -0.074950, -0.321560, -0.020990, 
-0.034400, -0.583310, 0.158830, -0.134330, -0.438190, 0.104330, -0.367440, -0.002560, -0.346930, 0.066760, 
-0.208130, -0.095200, -0.010850, -0.129060, -0.233880, 0.025410, -0.272350, 0.001260, -0.070110, -0.267800, 
0.040510, -0.281520, -0.292960, 0.121330, -0.230100, 0.016100, -0.322600, 0.088590, -0.184210, -0.089250, 
0.093440, 0.033550, -0.367760, 0.195380, -0.248990, 0.055890, 0.000640, 0.029290, -0.021940, 0.091830, 
-0.520510, 0.139180, -0.113860, 0.033860, -0.280750, 0.092360, -0.158310, -0.074470, 0.082830, 0.160100, 
-0.200310, 0.267530, -0.016290, 0.125410, -0.071660, 0.393550, 0.101660, 0.101710, -0.298800, 0.142890, 
0.019100, 0.039150, -0.262990, 0.106060, -0.124820, -0.078470, 0.185550, 0.391480, 0.011590, 0.047860, 
0.152650, 0.494630, -0.140530, 0.660280, 0.435160, -0.070070, 0.023690, 0.128800, 0.155180, 0.061140, 
-0.236120, 0.117230, -0.081470, -0.071230, 
0.105750, -0.066040, -0.112600, -0.623000, 0.729780, -0.601940, -0.086230, -0.407760, -0.105040, -0.023190, 
0.051420, -0.124400, 0.491730, -0.004020, -0.212750, 0.182060, -0.104250, 0.036960, 0.074160, -0.003450, 
0.114150, -0.557750, 0.264670, 0.051980, -0.023310, -0.488680, 0.092360, 0.226060, -0.185970, 0.023210, 
0.510270, -0.002320, -0.177310, 0.171280, -0.097050, 0.069020, 0.113610, 0.345500, 0.088810, -0.477810, 
0.377350, 0.206700, -0.304400, -0.100760, 0.182130, 0.190970, -0.115340, 0.138590, 0.608850, 0.023940, 
-0.144840, 0.182960, -0.082130, 0.093690, -0.040120, 0.414840, 0.075690, -0.401820, 0.601260, -0.216920, 
-0.441710, -0.115600, -0.056020, -0.153100, -0.094910, 0.131830, 0.527920, 0.011910, -0.139310, 0.178970, 
-0.092360, 0.108070, -0.082290, -0.228860, 0.314840, -0.506950, 0.173440, 0.021800, -0.580770, -0.312770, 
-0.139840, -0.237070, -0.156090, -0.009190, 0.415500, 0.020410, -0.174530, 0.154660, -0.118720, 0.095960, 
0.334840, -1.625360, 0.820580, -0.454460, -0.332510, 0.019460, -0.494970, -1.082840, 0.195780, -0.537330, 
-0.198450, -0.196290, 0.171820, 0.005740, -0.223800, 0.134220, -0.151260, 0.070730, 1.452460, -1.976550, 
0.489460, 0.312610, -0.563880, -0.215150, 0.296830, -1.696820, 0.404250, -0.259160, -0.398090, -0.133950, 
0.305080, 0.007580, -0.214490, 0.149600, -0.121050, 0.087480, 0.518890, -1.880810, 0.296720, 0.029280, 
-0.901220, -0.500010, 0.159570, -1.699360, 0.047390, -0.238230, -0.129160, -0.196040, -0.001600, -0.007220, 
-0.257490, 0.109770, -0.179840, 0.055440, 0.345050, -0.637640, -0.072510, 0.261230, -0.270790, -0.460820, 
0.099360, -0.575360, 0.022960, 0.121090, -0.016640, -0.069870, 0.372780, 0.027430, -0.202910, 0.147080, 
-0.107520, 0.087440, 0.268880, 0.112680, -0.174780, 0.062930, 0.138930, -0.187200, -0.143190, 0.093080, 
0.240380, 0.121070, 0.030940, 0.097890, 0.572140, 0.055120, -0.152610, 0.175680, -0.076390, 0.114590, 
-0.062800, -0.192700, 0.039630, -0.066410, 0.052100, 0.124420, -0.276560, 0.276070, 0.368790, 0.059430, 
0.204750, 0.139120, 0.571970, 0.073850, -0.147410, 0.171940, -0.065310, 0.117690, -0.191670, -0.460480, 
0.177120, 0.186640, -0.028510, -0.042610, -0.084050, 0.441110, 0.162990, 0.146350, 0.453600, 0.069690, 
0.646650, 0.081660, -0.141000, 0.169360, -0.066770, 0.126180, 0.379730, -0.207410, -0.228680, 0.669290, 
-0.156970, -0.345000, 0.589070, -0.170050, 0.300960, 0.364720, 0.383020, 0.013790, 0.708160, 0.080090, 
-0.125470, 0.160810, -0.028620, 0.109260, 
0.267650, 0.320610, -0.298450, 0.047060, -0.034290, -0.251140, -0.158500, -0.248860, 0.171150, 0.130670, 
0.665050, 0.156880, 0.249870, -0.057340, 0.161540, 0.082610, 0.025780, 0.078250, 0.250050, 0.186720, 
-0.193780, -0.159530, 0.011410, -0.140390, -0.251210, -0.217790, 0.208590, -0.014870, 0.185780, 0.184140, 
0.213630, -0.054360, 0.162940, 0.081270, 0.026190, 0.063540, 0.361650, 0.029440, -0.056900, -0.070980, 
-0.190160, -0.043000, -0.095240, -0.277780, 0.193320, 0.245740, 0.199790, 0.192520, 0.203470, -0.056490, 
0.174630, 0.073850, 0.022070, 0.078120, 0.242320, -0.135600, -0.063400, 0.012230, -0.275290, -0.124330, 
0.147710, -0.358280, 0.033430, 0.332870, 0.480010, 0.107770, 0.168020, -0.061770, 0.166410, 0.088370, 
0.008550, 0.067190, -0.205510, 0.056090, 0.002470, -0.112880, -0.310550, -0.240150, 0.086090, -0.452400, 
-0.181080, 0.594920, 0.226410, -0.041230, 0.126580, -0.056120, 0.143010, 0.071560, -0.006470, 0.061820, 
-1.002940, 0.235180, 0.072350, -0.482840, -0.242090, -0.282030, -0.387160, -0.231670, -0.336840, 0.256060, 
0.512630, -0.236340, 0.035630, -0.059790, 0.124410, 0.062240, -0.019760, 0.040200, -1.695470, 0.631580, 
0.692750, -1.558070, 0.006800, 0.614280, -1.618460, 0.056040, 0.552400, 0.042580, 0.250410, -0.227960, 
0.032430, -0.074890, 0.113430, 0.076390, -0.018740, 0.033520, 0.185000, 0.471200, -0.661920, 0.026490, 
0.064070, -0.812850, -0.230870, -0.135390, -0.602270, -0.067250, 0.098880, -0.255100, 0.008010, -0.083540, 
0.112710, 0.068270, -0.035240, 0.048340, 0.511700, 0.354390, -0.222050, -0.223520, 0.029880, -0.175340, 
-0.187420, -0.245070, -0.055220, -0.112740, 0.067160, 0.022350, 0.125680, -0.059310, 0.172570, 0.074210, 
-0.002610, 0.069150, 0.363770, 0.133620, 0.042690, -0.283630, 0.038660, -0.128580, -0.052120, -0.354630, 
-0.014880, -0.155340, 0.028790, 0.141480, 0.184430, -0.051520, 0.195040, 0.082680, 0.021900, 0.074600, 
0.245590, 0.153240, -0.021750, -0.312300, 0.001740, -0.053370, 0.138070, -0.283090, -0.125180, -0.064990, 
0.305570, 0.201260, 0.183800, -0.032950, 0.197460, 0.078020, 0.017030, 0.082700, 0.019360, 0.321570, 
0.000990, -0.231940, -0.009870, -0.058490, 0.186330, -0.088710, -0.156350, -0.054120, 0.264150, 0.266830, 
0.180950, -0.030330, 0.201580, 0.079800, 0.003640, 0.072920, 0.028040, 0.344130, -0.022170, 0.115810, 
0.012800, -0.209380, 0.364960, -0.095150, -0.073240, -0.239810, 0.355720, 0.363270, 0.180870, -0.029920, 
0.225600, 0.075520, 0.015230, 0.084890, 
-0.045680, -0.055360, -0.106430, -0.055780, -0.116140, -0.046830, -0.096930, -0.121100, 0.012450, -0.028550, 
0.013790, -0.047070, 0.048010, -0.014050, 0.040410, 0.001730, -0.007720, -0.001130, -0.082480, -0.008900, 
-0.120520, -0.079380, -0.056150, -0.069440, -0.117600, -0.046170, -0.035470, -0.067160, -0.027100, -0.054690, 
0.049920, -0.013360, 0.027270, -0.001460, -0.003220, -0.010930, -0.085680, 0.003130, -0.122140, -0.090320, 
-0.041970, -0.103310, -0.111860, -0.032720, -0.078650, -0.056670, -0.038620, -0.066460, 0.047950, -0.013840, 
0.036150, -0.004540, 0.006120, -0.015920, -0.084530, 0.040430, -0.152560, -0.092090, -0.018060, -0.128220, 
-0.098770, -0.017430, -0.094530, -0.038260, -0.031680, -0.068250, 0.040460, -0.018660, 0.043550, -0.003490, 
0.002630, -0.015210, -0.137420, 0.097320, -0.147380, -0.103930, 0.006130, -0.185670, -0.086390, -0.010060, 
-0.139190, -0.008090, -0.063890, -0.084460, 0.055060, -0.013060, 0.031660, 0.009570, -0.000430, -0.024650, 
-0.197840, 0.158650, -0.150300, -0.111930, 0.033350, -0.188230, -0.092340, 0.034770, -0.160250, -0.019310, 
-0.040090, -0.097560, 0.038030, -0.016140, 0.042490, 0.003570, -0.008370, -0.021320, -0.309570, 0.180480, 
-0.044680, -0.239300, 0.028920, -0.058180, -0.239750, 0.017490, -0.030410, -0.042820, -0.035500, -0.101980, 
0.045280, -0.006830, 0.040150, 0.013810, -0.003540, -0.009640, -0.140800, 0.120650, -0.116120, -0.095230, 
-0.018650, -0.132260, -0.094160, -0.079620, -0.083680, -0.013540, -0.052380, -0.102180, 0.044710, -0.014450, 
0.029680, -0.004820, -0.009440, -0.012780, -0.071020, 0.034430, -0.082240, -0.090530, -0.073230, -0.071100, 
-0.042620, -0.172910, -0.051280, -0.026870, -0.025250, -0.081730, 0.051030, -0.018080, 0.041080, 0.009410, 
-0.007340, -0.020040, -0.092410, -0.004130, -0.063780, -0.081970, -0.077020, -0.077090, -0.031160, -0.180410, 
-0.040420, -0.033650, -0.072400, -0.066870, 0.050000, -0.010420, 0.036200, 0.001310, 0.004450, -0.006140, 
-0.081150, -0.000140, -0.049190, -0.077770, -0.090870, -0.067560, -0.017260, -0.170460, -0.039890, -0.042080, 
-0.054500, -0.042490, 0.047280, -0.009960, 0.038240, -0.006890, -0.008200, -0.011260, -0.068850, -0.009470, 
-0.069090, -0.064390, -0.101020, -0.058960, -0.011030, -0.140240, -0.040790, -0.049180, -0.059560, -0.004770, 
0.026520, -0.006400, 0.053020, 0.002250, -0.012970, -0.004950, -0.049570, 0.002870, -0.093340, -0.021910, 
-0.094130, -0.104350, 0.024500, -0.133660, -0.089810, -0.069480, -0.041010, 0.008770, 0.022180, -0.017630, 
0.039130, 0.007250, -0.004150, -0.018590, 
-0.055830, 0.105010, -0.227300, -0.045870, -0.012220, -0.069750, -0.071180, 0.217470, -0.073600, 0.073330, 
-0.038520, 0.046270, 0.006320, -0.009020, 0.128870, 0.038560, 0.042860, -0.057600, -0.077240, -0.018290, 
-0.119280, -0.095930, -0.130780, 0.072230, -0.099660, 0.024720, 0.067540, -0.049360, 0.016410, 0.032030, 
0.016850, -0.014410, 0.127530, 0.032150, 0.041400, -0.058490, -0.132060, -0.054440, -0.151200, -0.113160, 
-0.154040, 0.002160, -0.077550, -0.084380, 0.020150, -0.052050, 0.084750, -0.016320, 0.000870, -0.025800, 
0.111170, 0.043130, 0.042510, -0.084790, -0.095680, -0.082480, -0.247000, -0.007320, -0.206830, 0.004680, 
0.021890, -0.060690, -0.058450, -0.000030, -0.029290, 0.005530, -0.029020, -0.025300, 0.109310, 0.021600, 
0.035220, -0.082000, -0.134740, 0.056790, -0.210590, 0.000230, -0.174640, 0.013890, 0.019200, -0.028850, 
0.029390, -0.001160, -0.267930, 0.057570, -0.023450, -0.022470, 0.094240, 0.036450, 0.032240, -0.085020, 
-0.018200, 0.376500, -0.347740, -0.013150, -0.023370, 0.026490, 0.027070, 0.007380, 0.109660, 0.085360, 
-0.066880, 0.130860, 0.098770, -0.026840, 0.111480, 0.042600, 0.050450, -0.071010, -0.029850, 0.694320, 
-1.003960, 0.036470, 0.042650, -0.643820, 0.118860, 0.004780, -0.511720, -0.171040, -0.241110, 0.022370, 
-0.009120, -0.023650, 0.083210, 0.029010, 0.035140, -0.086320, -0.112890, 0.362180, -0.401570, -0.118810, 
-0.011660, -0.116710, 0.006480, 0.027320, 0.007510, -0.011630, -0.059130, 0.091130, 0.078710, -0.025300, 
0.105880, 0.044840, 0.046010, -0.068240, -0.191710, 0.230350, -0.172850, -0.118520, -0.012940, -0.076170, 
-0.026540, -0.015900, -0.015070, -0.177250, 0.003110, 0.109250, 0.020920, -0.019370, 0.100640, 0.035780, 
0.047830, -0.057600, -0.148770, 0.161810, -0.205710, -0.087340, 0.072830, -0.055800, -0.050930, 0.013530, 
-0.060420, -0.074470, 0.160080, 0.152190, -0.017710, -0.018440, 0.095500, 0.045050, 0.041650, -0.060760, 
-0.075540, 0.153430, -0.221900, -0.006850, -0.018980, -0.004260, -0.051670, -0.029430, -0.090000, 0.096750, 
0.026180, 0.217860, -0.024860, -0.010580, 0.097250, 0.050560, 0.036810, -0.047750, -0.015230, 0.150310, 
-0.183740, 0.031030, -0.125430, 0.100650, -0.007020, -0.045210, -0.093430, 0.079020, 0.077610, 0.227070, 
-0.001450, -0.021930, 0.105780, 0.064660, 0.034720, -0.033660, 0.066060, 0.054320, -0.155090, 0.043180, 
-0.094430, 0.051940, -0.046160, 0.060450, -0.137080, 0.085860, 0.027490, 0.250110, -0.011870, -0.006200, 
0.101020, 0.061290, 0.037590, -0.030170, 
0.318270, -0.278100, -0.168720, 0.019350, -0.250510, -0.450170, -0.260890, -0.400580, -0.068460, 0.109640, 
0.428070, 0.288940, 0.023660, 0.013680, 0.079380, 0.068630, -0.170260, 0.221550, 0.329420, -0.352170, 
-0.032390, -0.121360, -0.209670, -0.250850, -0.369340, -0.274470, -0.005330, -0.267260, 0.195080, 0.367490, 
0.000660, 0.006920, 0.100090, 0.057980, -0.167880, 0.221250, 0.546570, -0.249010, 0.003110, 0.107720, 
-0.361840, -0.238540, -0.240210, -0.206330, -0.060610, -0.517480, -0.307240, 0.460630, 0.025020, 0.014840, 
0.115340, 0.067400, -0.157530, 0.232700, 0.429030, -0.109570, -0.090980, 0.261600, -0.262200, -0.460230, 
0.066130, -0.250720, -0.221990, -0.473100, -0.332540, 0.439060, 0.002060, 0.015050, 0.115160, 0.059190, 
-0.155890, 0.249630, -0.006340, -0.142960, -0.043050, 0.134570, -0.201030, -0.688000, -0.151720, -0.249440, 
-0.589110, -0.060500, -0.461490, 0.257510, -0.077570, 0.018590, 0.098830, 0.048850, -0.190970, 0.223360, 
-0.724990, -0.268050, 0.344250, -0.067480, -0.202540, -0.724210, -0.389710, -0.305730, -0.585120, -0.289430, 
-0.063850, 0.200750, -0.265790, 0.006660, 0.071130, 0.041510, -0.204800, 0.194230, -1.402630, -0.299060, 
1.826140, -0.943020, -0.360950, 0.989980, -1.464600, -0.541160, 1.261250, -0.006970, 0.085140, 0.281460, 
-0.158720, 0.007140, 0.086960, 0.049850, -0.184260, 0.223590, 0.099980, -0.416370, 0.422060, 0.162420, 
-0.424250, -0.295090, -0.476780, -0.818270, 0.216520, -0.218120, -0.065150, 0.215250, -0.283330, -0.003810, 
0.065060, 0.042980, -0.214020, 0.210950, 0.876700, -0.147790, -0.027720, 0.264610, -0.214330, -0.257880, 
0.070550, -0.609630, 0.143170, -0.383140, 0.166760, 0.421280, -0.072560, 0.006880, 0.122910, 0.047660, 
-0.196860, 0.227840, 0.812040, -0.247140, 0.166660, 0.103140, -0.077790, -0.287510, 0.183110, -0.524290, 
0.047540, 0.059810, -0.318250, 0.443370, 0.049290, 0.033200, 0.152660, 0.031160, -0.174520, 0.223860, 
0.717360, -0.463330, 0.245220, 0.029970, -0.132980, -0.027790, 0.284570, -0.357700, 0.127200, 0.211480, 
-0.094860, 0.409510, 0.064580, 0.034730, 0.152510, 0.004370, -0.184990, 0.213250, 0.450580, -0.321590, 
0.296300, -0.169660, -0.028310, 0.096730, 0.093110, -0.007790, 0.082970, 0.484560, 0.119920, 0.413020, 
0.079340, 0.037790, 0.159420, -0.000690, -0.180260, 0.195810, 0.068940, 0.117970, 0.111840, -0.137140, 
-0.001130, -0.083960, 0.041140, -0.221180, 0.153330, 0.390820, -0.060130, 0.379660, 0.036770, 0.048210, 
0.157170, -0.012710, -0.196220, 0.200430, 
-0.060150, 0.166700, -0.270290, -0.068790, 0.049210, -0.110140, -0.083770, 0.379750, -0.147960, 0.068340, 
-0.126040, 0.125930, -0.002300, -0.010220, 0.159900, 0.070650, 0.087600, -0.084280, -0.071160, 0.017400, 
-0.166740, -0.114520, -0.144260, 0.074380, -0.104050, 0.102170, 0.032860, -0.064750, 0.010810, 0.097620, 
0.014450, -0.021320, 0.141430, 0.073160, 0.076950, -0.082790, -0.133930, -0.032910, -0.215520, -0.106730, 
-0.159220, 0.012600, -0.032870, -0.069230, 0.001620, -0.013270, 0.124670, 0.059490, 0.002430, -0.026040, 
0.121190, 0.054460, 0.081950, -0.102850, -0.116400, -0.038420, -0.301290, 0.051090, -0.195550, -0.017280, 
0.136580, -0.048750, -0.080770, 0.082370, 0.006690, 0.079760, -0.064010, -0.016520, 0.118770, 0.058050, 
0.073760, -0.111960, -0.169480, 0.126720, -0.213890, 0.020720, -0.175320, 0.050000, 0.061030, -0.011350, 
0.101240, 0.068230, -0.307590, 0.131130, -0.045210, -0.027870, 0.113130, 0.053220, 0.068420, -0.114840, 
-0.008500, 0.534030, -0.539380, -0.034460, 0.044540, -0.083930, 0.004700, 0.015420, 0.084410, 0.166400, 
-0.060320, 0.170380, 0.048740, -0.025040, 0.130880, 0.063810, 0.078930, -0.105470, 0.132360, 0.954940, 
-1.519390, 0.138390, 0.140280, -1.067090, 0.241650, 0.000930, -0.815140, -0.158060, -0.260870, 0.047960, 
-0.075520, -0.027150, 0.090650, 0.051350, 0.067910, -0.123110, -0.057890, 0.478490, -0.640150, -0.124250, 
0.012540, -0.301070, 0.045900, -0.003690, -0.066130, 0.012490, -0.052820, 0.131500, 0.022580, -0.014760, 
0.105160, 0.060620, 0.083180, -0.107050, -0.214920, 0.277750, -0.142130, -0.185620, -0.002190, -0.062500, 
-0.102130, -0.049740, 0.109600, -0.198660, -0.054140, 0.169590, -0.004340, -0.018940, 0.110460, 0.062120, 
0.093460, -0.092400, -0.167330, 0.182440, -0.185150, -0.173350, 0.092220, 0.036640, -0.141980, -0.009120, 
0.067750, -0.131080, 0.180910, 0.250480, -0.056220, -0.013310, 0.122740, 0.075390, 0.095750, -0.083200, 
-0.085250, 0.209620, -0.296690, -0.059780, -0.007850, 0.103930, -0.140060, 0.036890, -0.053630, 0.113530, 
0.063350, 0.321020, -0.065130, -0.006250, 0.111320, 0.077670, 0.086620, -0.066630, -0.048940, 0.253780, 
-0.295500, 0.003650, -0.085560, 0.114190, -0.059710, 0.039280, -0.142600, 0.042120, 0.058550, 0.316790, 
-0.054900, -0.012500, 0.114020, 0.102180, 0.077890, -0.047870, 0.095230, 0.104400, -0.301500, 0.028670, 
-0.019580, -0.033430, -0.083850, 0.202470, -0.296150, 0.038870, 0.035840, 0.355920, -0.048900, -0.012500, 
0.102020, 0.099960, 0.072770, -0.028550, 
0.079420, -0.111690, -0.149060, -0.006490, -0.255670, 0.106240, 0.078220, -0.134670, 0.207880, 0.048420, 
0.222110, -0.148680, 0.235520, -0.029070, 0.119310, 0.049330, 0.029100, -0.065400, -0.061040, -0.061970, 
-0.101610, -0.169100, -0.252910, 0.247980, -0.060600, -0.113710, 0.256860, -0.130910, 0.239370, -0.184130, 
0.245830, -0.033730, 0.121640, 0.046370, 0.025610, -0.068750, -0.201310, -0.069380, -0.123140, -0.248030, 
-0.195740, 0.203620, -0.094400, -0.101500, 0.191560, -0.120530, 0.320100, -0.226440, 0.229380, -0.040060, 
0.091870, 0.035320, 0.022510, -0.086100, -0.241570, 0.065040, -0.319280, -0.141290, -0.163110, 0.119370, 
0.012870, 0.044630, -0.041270, 0.088280, 0.233650, -0.252510, 0.184240, -0.053400, 0.086030, 0.036220, 
0.024720, -0.105600, -0.247660, 0.193990, -0.435140, -0.103620, 0.008370, -0.098490, 0.059680, 0.270400, 
-0.217400, 0.168470, -0.109000, -0.243530, 0.192180, -0.056950, 0.081700, 0.032500, 0.023930, -0.105240, 
-0.198480, 0.552180, -0.624560, -0.056270, 0.202030, -0.218680, 0.153530, 0.359510, -0.244640, 0.157020, 
0.022840, -0.204760, 0.301100, -0.052570, 0.114330, 0.042500, 0.029200, -0.088350, -0.374560, 0.823820, 
-0.946550, -0.112240, 0.210030, -0.500730, 0.119910, 0.225100, -0.473650, -0.006230, -0.242730, -0.275750, 
0.197400, -0.043090, 0.081870, 0.033500, 0.022650, -0.103220, -0.288970, 0.426930, -0.380880, -0.076490, 
0.055530, -0.014610, 0.117700, 0.005910, 0.001870, 0.242400, -0.076720, -0.221450, 0.301090, -0.046250, 
0.106250, 0.045980, 0.034390, -0.077620, -0.347740, 0.198190, -0.155820, -0.165480, -0.056730, 0.062320, 
0.097500, -0.232180, -0.023020, -0.038070, 0.075430, -0.153860, 0.235220, -0.031490, 0.096630, 0.046300, 
0.031420, -0.078560, -0.315840, 0.198360, -0.172210, -0.138730, 0.023760, -0.074130, 0.090410, -0.221120, 
-0.162030, 0.112080, 0.122280, -0.110320, 0.176500, -0.035400, 0.109260, 0.037670, 0.045840, -0.070000, 
-0.231240, 0.345830, -0.198120, -0.114280, 0.037710, -0.037670, 0.068460, -0.198490, -0.186350, 0.202820, 
0.001950, -0.030370, 0.202910, -0.040190, 0.113080, 0.044230, 0.029840, -0.067340, -0.170920, 0.281890, 
-0.024710, -0.116180, -0.027510, 0.189620, 0.065810, -0.123550, -0.129110, 0.068310, 0.087780, 0.020830, 
0.229310, -0.024430, 0.126160, 0.067530, 0.030080, -0.037180, 0.003600, 0.226420, -0.067270, -0.019280, 
0.046770, 0.059790, 0.132400, 0.039220, -0.244340, 0.004470, 0.027410, 0.096450, 0.256010, -0.030490, 
0.114190, 0.069710, 0.037710, -0.038120, 
0.333120, 0.087640, 0.178060, -0.238980, 0.414760, -0.055000, 0.122190, -0.130400, 0.220410, 0.191110, 
0.446550, -0.009140, 0.888700, -0.104450, -0.135410, 0.084980, 0.012810, -0.010770, 0.146290, 0.339910, 
-0.212380, -0.554910, 0.258700, 0.156200, -0.033360, -0.211380, 0.030980, -0.444040, -0.114920, 0.001120, 
0.772620, -0.114220, -0.130250, 0.063550, -0.015420, -0.017880, 0.150410, 0.221600, -0.355430, -0.475450, 
0.307750, -0.003250, 0.029220, -0.101920, -0.150050, -0.434300, -0.658970, 0.100650, 0.746750, -0.105560, 
-0.094610, 0.077280, -0.011250, -0.006260, 0.239810, -0.290890, 0.103100, -0.217310, 0.310720, -0.236270, 
0.142050, -0.412110, 0.052070, -0.220540, 0.098700, 0.148830, 0.733950, -0.100780, -0.090250, 0.062810, 
-0.015430, 0.019340, 0.020000, -0.662540, 0.430750, -0.142930, -0.045710, 0.009910, -0.076550, -0.592040, 
0.095740, 0.400710, 0.888940, -0.101690, 0.685980, -0.089830, -0.106860, 0.048670, -0.035460, 0.034190, 
0.064910, -1.746660, 0.105400, -0.135000, -0.733430, -0.741520, -0.304300, -1.294000, -0.441630, 0.058230, 
0.790860, -0.596000, 0.104160, -0.126000, -0.209790, -0.013420, -0.111270, -0.050000, -0.004990, -1.835240, 
1.372340, -0.523920, -0.802320, 0.634810, -0.757100, -1.682670, 1.173710, 0.329330, 0.060990, -0.429190, 
0.312610, -0.118750, -0.180940, 0.022010, -0.085830, -0.025140, -0.052300, -1.279840, 0.069840, -0.082330, 
-0.704580, -0.814150, -0.139570, -1.479120, -0.236710, -0.234760, -0.134630, -0.517290, 0.007020, -0.129340, 
-0.215780, -0.016780, -0.120550, -0.056230, 0.385130, -0.040520, -0.249890, -0.133120, 0.231130, -0.560140, 
-0.089220, -0.357710, 0.022200, 0.142110, -0.376550, -0.150160, 0.496520, -0.095460, -0.119480, 0.018740, 
-0.046340, -0.002960, 0.327220, 0.100170, -0.226670, -0.097110, 0.579990, -0.486310, -0.224470, 0.182810, 
0.120450, 0.129800, -0.385830, 0.009370, 0.702420, -0.073050, -0.071320, 0.028450, -0.005890, 0.030950, 
0.151000, -0.248720, -0.117780, -0.244660, 0.295510, 0.029670, -0.284020, 0.538420, 0.100740, 0.471560, 
0.263190, 0.057650, 0.702290, -0.051450, -0.049280, 0.029570, -0.014710, 0.030680, -0.015360, -0.460310, 
0.258660, -0.225000, 0.519060, -0.110900, -0.208970, 0.888800, 0.095690, 0.039130, -0.082900, 0.040610, 
0.783370, -0.048820, -0.040760, 0.022890, 0.008540, 0.031410, -0.068520, 0.144980, -0.108050, 0.006410, 
0.627870, -0.447120, 0.146100, 0.417220, 0.302080, -0.725900, 0.319030, -0.012290, 0.738820, -0.038460, 
-0.043960, 0.007080, 0.024040, 0.017020, 
-0.084360, 1.665670, -1.384230, -0.724410, -0.536870, 0.440870, 0.325370, 1.622800, 1.470200, 1.475490, 
0.921590, 0.655700, -1.384830, -0.441830, -0.179860, 0.029280, -0.064710, -0.515800, -0.547310, 0.306070, 
-1.874300, 0.617580, 0.453450, -1.418680, -0.432250, 0.203530, -0.995500, 0.361400, -0.852310, -0.106750, 

1.380450, -3.348360, 0.991180, -0.015990, 0.076070, -0.102250, -0.785490, -0.770270, -1.187510, -2.711460, 
0.246130, -0.681500, 0.162630, 1.436150, -0.901350, 0.550000, 1.076630, -0.167540, -1.199190, -1.899040, 
0.220680, -2.090900, -1.602170, 0.330400, -0.153130, 0.633470, 0.173440, 0.901820, -0.143160, -1.078210, 

-1.341890, -0.308770, -0.363870, 0.979670, -0.244560, -0.377450, -0.593660, -1.245090, -0.975610, 0.042950, 
-1.417960, -0.660640, -0.744800, -0.632290, 0.673580, -0.219600, -0.433450, 0.311690, 0.982520, 0.458590, 
0.302520, 0.216950, 0.829890, 0.472890, -0.008190, -0.315510, 0.645190, -0.604760, -0.728300, 1.042460, 


  };

  /* unit definition section (see also UnitType) */
  static UnitType Units[268] = 
  {
    { 0.0, 0.0, 0, NULL , NULL },
    { /* unit 1 (Old: 1) */
      0.0, 0.010000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 2 (Old: 2) */
      0.0, 0.009980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 3 (Old: 3) */
      0.0, 0.009170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 4 (Old: 4) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 5 (Old: 5) */
      0.0, 0.002710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 6 (Old: 6) */
      0.0, 0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 7 (Old: 7) */
      0.0, 0.008150, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 8 (Old: 8) */
      0.0, 0.000260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 9 (Old: 9) */
      0.0, -0.000540, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 10 (Old: 10) */
      0.0, 0.000910, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 11 (Old: 11) */
      0.0, 0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 12 (Old: 12) */
      0.0, -0.006630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 13 (Old: 13) */
      0.0, -0.008630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 14 (Old: 14) */
      0.0, -0.001360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 15 (Old: 15) */
      0.0, -0.001120, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 16 (Old: 16) */
      0.0, 0.008980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 17 (Old: 17) */
      0.0, -0.005340, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 18 (Old: 18) */
      0.0, 0.009620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 19 (Old: 19) */
      0.0, 0.004950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 20 (Old: 20) */
      0.0, 0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 21 (Old: 21) */
      0.0, -0.007520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 22 (Old: 22) */
      0.0, -0.000630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 23 (Old: 23) */
      0.0, -0.008410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 24 (Old: 24) */
      0.0, -0.000310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 25 (Old: 25) */
      0.0, -0.006210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 26 (Old: 26) */
      0.0, 0.006230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 27 (Old: 27) */
      0.0, -0.007730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 28 (Old: 28) */
      0.0, -0.001410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 29 (Old: 29) */
      0.0, 0.008460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 30 (Old: 30) */
      0.0, -0.006310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 31 (Old: 31) */
      0.0, -0.009700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 32 (Old: 32) */
      0.0, 0.007630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 33 (Old: 33) */
      0.0, -0.007880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 34 (Old: 34) */
      0.0, -0.005690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 35 (Old: 35) */
      0.0, 0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 36 (Old: 36) */
      0.0, 0.004930, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 37 (Old: 37) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 38 (Old: 38) */
      0.0, 0.002430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 39 (Old: 39) */
      0.0, -0.003580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 40 (Old: 40) */
      0.0, -0.003620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 41 (Old: 41) */
      0.0, -0.005050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 42 (Old: 42) */
      0.0, 0.009880, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 43 (Old: 43) */
      0.0, -0.002490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 44 (Old: 44) */
      0.0, 0.007470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 45 (Old: 45) */
      0.0, -0.002350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 46 (Old: 46) */
      0.0, -0.005420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 47 (Old: 47) */
      0.0, 0.006270, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 48 (Old: 48) */
      0.0, 0.000070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 49 (Old: 49) */
      0.0, -0.000190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 50 (Old: 50) */
      0.0, 0.003680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 51 (Old: 51) */
      0.0, -0.004030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 52 (Old: 52) */
      0.0, 0.002660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 53 (Old: 53) */
      0.0, -0.007530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 54 (Old: 54) */
      0.0, 0.002580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 55 (Old: 55) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 56 (Old: 56) */
      0.0, 0.001440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 57 (Old: 57) */
      0.0, -0.000850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 58 (Old: 58) */
      0.0, -0.003360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 59 (Old: 59) */
      0.0, 0.006580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 60 (Old: 60) */
      0.0, -0.006620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 61 (Old: 61) */
      0.0, -0.007240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 62 (Old: 62) */
      0.0, -0.005380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 63 (Old: 63) */
      0.0, 0.008950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 64 (Old: 64) */
      0.0, -0.009330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 65 (Old: 65) */
      0.0, 0.003310, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 66 (Old: 66) */
      0.0, 0.008360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 67 (Old: 67) */
      0.0, 0.004590, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 68 (Old: 68) */
      0.0, 0.008510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 69 (Old: 69) */
      0.0, -0.003520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 70 (Old: 70) */
      0.0, -0.006200, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 71 (Old: 71) */
      0.0, 0.000720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 72 (Old: 72) */
      0.0, -0.001380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 73 (Old: 73) */
      0.0, -0.000240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 74 (Old: 74) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 75 (Old: 75) */
      0.0, -0.004780, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 76 (Old: 76) */
      0.0, -0.007430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 77 (Old: 77) */
      0.0, -0.001560, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 78 (Old: 78) */
      0.0, -0.009290, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 79 (Old: 79) */
      0.0, 0.003330, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 80 (Old: 80) */
      0.0, 0.002140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 81 (Old: 81) */
      0.0, 0.006460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 82 (Old: 82) */
      0.0, 0.007760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 83 (Old: 83) */
      0.0, -0.007050, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 84 (Old: 84) */
      0.0, -0.006220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 85 (Old: 85) */
      0.0, -0.009100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 86 (Old: 86) */
      0.0, -0.008090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 87 (Old: 87) */
      0.0, 0.007220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 88 (Old: 88) */
      0.0, -0.003720, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 89 (Old: 89) */
      0.0, 0.007460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 90 (Old: 90) */
      0.0, 0.009920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 91 (Old: 91) */
      0.0, 0.009990, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 92 (Old: 92) */
      0.0, 0.006140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 93 (Old: 93) */
      0.0, -0.001740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 94 (Old: 94) */
      0.0, 0.002500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 95 (Old: 95) */
      0.0, 0.009460, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 96 (Old: 96) */
      0.0, 0.000700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 97 (Old: 97) */
      0.0, -0.005710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 98 (Old: 98) */
      0.0, 0.001160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 99 (Old: 99) */
      0.0, 0.004240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 100 (Old: 100) */
      0.0, -0.007070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 101 (Old: 101) */
      0.0, -0.000520, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 102 (Old: 102) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 103 (Old: 103) */
      0.0, 0.004670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 104 (Old: 104) */
      0.0, -0.005670, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 105 (Old: 105) */
      0.0, 0.000640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 106 (Old: 106) */
      0.0, 0.006060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 107 (Old: 107) */
      0.0, 0.001060, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 108 (Old: 108) */
      0.0, -0.004570, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 109 (Old: 109) */
      0.0, -0.009320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 110 (Old: 110) */
      0.0, -0.005140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 111 (Old: 111) */
      0.0, 0.000680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 112 (Old: 112) */
      0.0, -0.007380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 113 (Old: 113) */
      0.0, 0.007320, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 114 (Old: 114) */
      0.0, -0.006920, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 115 (Old: 115) */
      0.0, 0.009640, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 116 (Old: 116) */
      0.0, -0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 117 (Old: 117) */
      0.0, -0.003400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 118 (Old: 118) */
      0.0, -0.006000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 119 (Old: 119) */
      0.0, 0.007140, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 120 (Old: 120) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 121 (Old: 121) */
      0.0, -0.008170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 122 (Old: 122) */
      0.0, -0.005490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 123 (Old: 123) */
      0.0, 0.002680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 124 (Old: 124) */
      0.0, -0.008890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 125 (Old: 125) */
      0.0, -0.007700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 126 (Old: 126) */
      0.0, 0.001100, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 127 (Old: 127) */
      0.0, 0.006740, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 128 (Old: 128) */
      0.0, 0.001500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 129 (Old: 129) */
      0.0, 0.000400, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 130 (Old: 130) */
      0.0, 0.009380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 131 (Old: 131) */
      0.0, -0.002170, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 132 (Old: 132) */
      0.0, -0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 133 (Old: 133) */
      0.0, 0.006350, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 134 (Old: 134) */
      0.0, -0.000500, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 135 (Old: 135) */
      0.0, -0.007980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 136 (Old: 136) */
      0.0, 0.003820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 137 (Old: 137) */
      0.0, -0.008850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 138 (Old: 138) */
      0.0, 0.002240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 139 (Old: 139) */
      0.0, -0.008610, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 140 (Old: 140) */
      0.0, -0.008230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 141 (Old: 141) */
      0.0, 0.003250, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 142 (Old: 142) */
      0.0, -0.000660, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 143 (Old: 143) */
      0.0, -0.004040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 144 (Old: 144) */
      0.0, -0.009420, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 145 (Old: 145) */
      0.0, -0.005360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 146 (Old: 146) */
      0.0, -0.005040, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 147 (Old: 147) */
      0.0, 0.008180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 148 (Old: 148) */
      0.0, -0.007080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 149 (Old: 149) */
      0.0, 0.006510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 150 (Old: 150) */
      0.0, 0.009600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 151 (Old: 151) */
      0.0, 0.001620, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 152 (Old: 152) */
      0.0, 0.004070, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 153 (Old: 153) */
      0.0, 0.002440, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 154 (Old: 154) */
      0.0, 0.001630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 155 (Old: 155) */
      0.0, 0.007230, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 156 (Old: 156) */
      0.0, 0.002380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 157 (Old: 157) */
      0.0, 0.004000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 158 (Old: 158) */
      0.0, 0.009580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 159 (Old: 159) */
      0.0, 0.005220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 160 (Old: 160) */
      0.0, 0.009260, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 161 (Old: 161) */
      0.0, 0.005580, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 162 (Old: 162) */
      0.0, -0.000510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 163 (Old: 163) */
      0.0, 0.000110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 164 (Old: 164) */
      0.0, -0.007650, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 165 (Old: 165) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 166 (Old: 166) */
      0.0, 0.008820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 167 (Old: 167) */
      0.0, 0.007600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 168 (Old: 168) */
      0.0, -0.000960, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 169 (Old: 169) */
      0.0, 0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 170 (Old: 170) */
      0.0, 0.000860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 171 (Old: 171) */
      0.0, -0.001760, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 172 (Old: 172) */
      0.0, -0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 173 (Old: 173) */
      0.0, 0.008600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 174 (Old: 174) */
      0.0, -0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 175 (Old: 175) */
      0.0, 0.001940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 176 (Old: 176) */
      0.0, -0.001710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 177 (Old: 177) */
      0.0, 0.006180, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 178 (Old: 178) */
      0.0, -0.007850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 179 (Old: 179) */
      0.0, 0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 180 (Old: 180) */
      0.0, 0.005850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 181 (Old: 181) */
      0.0, 0.007690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 182 (Old: 182) */
      0.0, 0.006820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 183 (Old: 183) */
      0.0, -0.009850, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 184 (Old: 184) */
      0.0, -0.003630, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 185 (Old: 185) */
      0.0, -0.006240, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 186 (Old: 186) */
      0.0, -0.002840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 187 (Old: 187) */
      0.0, 0.003410, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 188 (Old: 188) */
      0.0, -0.004750, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 189 (Old: 189) */
      0.0, -0.006470, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 190 (Old: 190) */
      0.0, -0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 191 (Old: 191) */
      0.0, -0.003160, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 192 (Old: 192) */
      0.0, 0.002820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 193 (Old: 193) */
      0.0, -0.002210, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 194 (Old: 194) */
      0.0, 0.001700, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 195 (Old: 195) */
      0.0, -0.006300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 196 (Old: 196) */
      0.0, -0.005480, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 197 (Old: 197) */
      0.0, 0.004510, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 198 (Old: 198) */
      0.0, 0.009110, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 199 (Old: 199) */
      0.0, -0.002020, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 200 (Old: 200) */
      0.0, -0.000280, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 201 (Old: 201) */
      0.0, -0.002600, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 202 (Old: 202) */
      0.0, 0.006380, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 203 (Old: 203) */
      0.0, 0.004430, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 204 (Old: 204) */
      0.0, 0.000950, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 205 (Old: 205) */
      0.0, -0.002860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 206 (Old: 206) */
      0.0, -0.004860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 207 (Old: 207) */
      0.0, 0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 208 (Old: 208) */
      0.0, -0.002360, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 209 (Old: 209) */
      0.0, -0.002370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 210 (Old: 210) */
      0.0, -0.007090, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 211 (Old: 211) */
      0.0, 0.006370, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 212 (Old: 212) */
      0.0, 0.003840, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 213 (Old: 213) */
      0.0, 0.009530, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 214 (Old: 214) */
      0.0, 0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 215 (Old: 215) */
      0.0, -0.009030, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 216 (Old: 216) */
      0.0, -0.009820, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 217 (Old: 217) */
      0.0, 0.005900, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 218 (Old: 218) */
      0.0, -0.002080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 219 (Old: 219) */
      0.0, -0.008710, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 220 (Old: 220) */
      0.0, -0.001190, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 221 (Old: 221) */
      0.0, -0.000940, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 222 (Old: 222) */
      0.0, 0.001220, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 223 (Old: 223) */
      0.0, 0.001000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 224 (Old: 224) */
      0.0, 0.003860, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 225 (Old: 225) */
      0.0, 0.005980, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 226 (Old: 226) */
      0.0, 0.005680, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 227 (Old: 227) */
      0.0, 0.009000, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 228 (Old: 228) */
      0.0, 0.005810, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 229 (Old: 229) */
      0.0, -0.001490, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 230 (Old: 230) */
      0.0, -0.008300, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 231 (Old: 231) */
      0.0, 0.001690, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 232 (Old: 232) */
      0.0, -0.003080, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 233 (Old: 233) */
      0.0, 0.002890, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 234 (Old: 234) */
      0.0, -0.001730, 0,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 235 (Old: 235) */
      0.0, -0.824300, 234,
       &Sources[0] , 
       &Weights[0] , 
      },
    { /* unit 236 (Old: 236) */
      0.0, -0.275620, 234,
       &Sources[234] , 
       &Weights[234] , 
      },
    { /* unit 237 (Old: 237) */
      0.0, -0.212390, 234,
       &Sources[468] , 
       &Weights[468] , 
      },
    { /* unit 238 (Old: 238) */
      0.0, -1.029910, 234,
       &Sources[702] , 
       &Weights[702] , 
      },
    { /* unit 239 (Old: 239) */
      0.0, -0.326750, 234,
       &Sources[936] , 
       &Weights[936] , 
      },
    { /* unit 240 (Old: 240) */
      0.0, -0.210110, 234,
       &Sources[1170] , 
       &Weights[1170] , 
      },
    { /* unit 241 (Old: 241) */
      0.0, -0.263030, 234,
       &Sources[1404] , 
       &Weights[1404] , 
      },
    { /* unit 242 (Old: 242) */
      0.0, -0.772420, 234,
       &Sources[1638] , 
       &Weights[1638] , 
      },
    { /* unit 243 (Old: 243) */
      0.0, -0.740030, 234,
       &Sources[1872] , 
       &Weights[1872] , 
      },
    { /* unit 244 (Old: 244) */
      0.0, 0.150130, 234,
       &Sources[2106] , 
       &Weights[2106] , 
      },
    { /* unit 245 (Old: 245) */
      0.0, -0.760050, 234,
       &Sources[2340] , 
       &Weights[2340] , 
      },
    { /* unit 246 (Old: 246) */
      0.0, -0.241250, 234,
       &Sources[2574] , 
       &Weights[2574] , 
      },
    { /* unit 247 (Old: 247) */
      0.0, -0.530630, 234,
       &Sources[2808] , 
       &Weights[2808] , 
      },
    { /* unit 248 (Old: 248) */
      0.0, -0.640440, 234,
       &Sources[3042] , 
       &Weights[3042] , 
      },
    { /* unit 249 (Old: 249) */
      0.0, -0.704270, 234,
       &Sources[3276] , 
       &Weights[3276] , 
      },
    { /* unit 250 (Old: 250) */
      0.0, -0.290800, 234,
       &Sources[3510] , 
       &Weights[3510] , 
      },
    { /* unit 251 (Old: 251) */
      0.0, -0.543880, 234,
       &Sources[3744] , 
       &Weights[3744] , 
      },
    { /* unit 252 (Old: 252) */
      0.0, -0.655260, 234,
       &Sources[3978] , 
       &Weights[3978] , 
      },
    { /* unit 253 (Old: 253) */
      0.0, -0.998240, 234,
       &Sources[4212] , 
       &Weights[4212] , 
      },
    { /* unit 254 (Old: 254) */
      0.0, -0.182340, 234,
       &Sources[4446] , 
       &Weights[4446] , 
      },
    { /* unit 255 (Old: 255) */
      0.0, -1.078110, 234,
       &Sources[4680] , 
       &Weights[4680] , 
      },
    { /* unit 256 (Old: 256) */
      0.0, -0.777850, 234,
       &Sources[4914] , 
       &Weights[4914] , 
      },
    { /* unit 257 (Old: 257) */
      0.0, -1.206550, 234,
       &Sources[5148] , 
       &Weights[5148] , 
      },
    { /* unit 258 (Old: 258) */
      0.0, -1.118840, 234,
       &Sources[5382] , 
       &Weights[5382] , 
      },
    { /* unit 259 (Old: 259) */
      0.0, -0.294160, 234,
       &Sources[5616] , 
       &Weights[5616] , 
      },
    { /* unit 260 (Old: 260) */
      0.0, -0.343540, 234,
       &Sources[5850] , 
       &Weights[5850] , 
      },
    { /* unit 261 (Old: 261) */
      0.0, -0.747510, 234,
       &Sources[6084] , 
       &Weights[6084] , 
      },
    { /* unit 262 (Old: 262) */
      0.0, -0.514780, 234,
       &Sources[6318] , 
       &Weights[6318] , 
      },
    { /* unit 263 (Old: 263) */
      0.0, -0.454800, 234,
       &Sources[6552] , 
       &Weights[6552] , 
      },
    { /* unit 264 (Old: 264) */
      0.0, -1.621880, 234,
       &Sources[6786] , 
       &Weights[6786] , 
      },
    { /* unit 265 (Old: 265) */
      0.0, -0.607170, 30,
       &Sources[7020] , 
       &Weights[7020] , 
      },
    { /* unit 266 (Old: 266) */
      0.0, -0.022450, 30,
       &Sources[7050] , 
       &Weights[7050] , 
      },
    { /* unit 267 (Old: 267) */
      0.0, -0.462420, 30,
       &Sources[7080] , 
       &Weights[7080] , 
      }

  };



int step4_net111(float *in, float *out, int init)
{
  int member, source;
  float sum;
  enum{OK, Error, Not_Valid};
  pUnit unit;


  /* layer definition section (names & member units) */

  static pUnit Input[234] = {Units + 1, Units + 2, Units + 3, Units + 4, Units + 5, Units + 6, Units + 7, Units + 8, Units + 9, Units + 10, Units + 11, Units + 12, Units + 13, Units + 14, Units + 15, Units + 16, Units + 17, Units + 18, Units + 19, Units + 20, Units + 21, Units + 22, Units + 23, Units + 24, Units + 25, Units + 26, Units + 27, Units + 28, Units + 29, Units + 30, Units + 31, Units + 32, Units + 33, Units + 34, Units + 35, Units + 36, Units + 37, Units + 38, Units + 39, Units + 40, Units + 41, Units + 42, Units + 43, Units + 44, Units + 45, Units + 46, Units + 47, Units + 48, Units + 49, Units + 50, Units + 51, Units + 52, Units + 53, Units + 54, Units + 55, Units + 56, Units + 57, Units + 58, Units + 59, Units + 60, Units + 61, Units + 62, Units + 63, Units + 64, Units + 65, Units + 66, Units + 67, Units + 68, Units + 69, Units + 70, Units + 71, Units + 72, Units + 73, Units + 74, Units + 75, Units + 76, Units + 77, Units + 78, Units + 79, Units + 80, Units + 81, Units + 82, Units + 83, Units + 84, Units + 85, Units + 86, Units + 87, Units + 88, Units + 89, Units + 90, Units + 91, Units + 92, Units + 93, Units + 94, Units + 95, Units + 96, Units + 97, Units + 98, Units + 99, Units + 100, Units + 101, Units + 102, Units + 103, Units + 104, Units + 105, Units + 106, Units + 107, Units + 108, Units + 109, Units + 110, Units + 111, Units + 112, Units + 113, Units + 114, Units + 115, Units + 116, Units + 117, Units + 118, Units + 119, Units + 120, Units + 121, Units + 122, Units + 123, Units + 124, Units + 125, Units + 126, Units + 127, Units + 128, Units + 129, Units + 130, Units + 131, Units + 132, Units + 133, Units + 134, Units + 135, Units + 136, Units + 137, Units + 138, Units + 139, Units + 140, Units + 141, Units + 142, Units + 143, Units + 144, Units + 145, Units + 146, Units + 147, Units + 148, Units + 149, Units + 150, Units + 151, Units + 152, Units + 153, Units + 154, Units + 155, Units + 156, Units + 157, Units + 158, Units + 159, Units + 160, Units + 161, Units + 162, Units + 163, Units + 164, Units + 165, Units + 166, Units + 167, Units + 168, Units + 169, Units + 170, Units + 171, Units + 172, Units + 173, Units + 174, Units + 175, Units + 176, Units + 177, Units + 178, Units + 179, Units + 180, Units + 181, Units + 182, Units + 183, Units + 184, Units + 185, Units + 186, Units + 187, Units + 188, Units + 189, Units + 190, Units + 191, Units + 192, Units + 193, Units + 194, Units + 195, Units + 196, Units + 197, Units + 198, Units + 199, Units + 200, Units + 201, Units + 202, Units + 203, Units + 204, Units + 205, Units + 206, Units + 207, Units + 208, Units + 209, Units + 210, Units + 211, Units + 212, Units + 213, Units + 214, Units + 215, Units + 216, Units + 217, Units + 218, Units + 219, Units + 220, Units + 221, Units + 222, Units + 223, Units + 224, Units + 225, Units + 226, Units + 227, Units + 228, Units + 229, Units + 230, Units + 231, Units + 232, Units + 233, Units + 234}; /* members */

  static pUnit Hidden1[30] = {Units + 235, Units + 236, Units + 237, Units + 238, Units + 239, Units + 240, Units + 241, Units + 242, Units + 243, Units + 244, Units + 245, Units + 246, Units + 247, Units + 248, Units + 249, Units + 250, Units + 251, Units + 252, Units + 253, Units + 254, Units + 255, Units + 256, Units + 257, Units + 258, Units + 259, Units + 260, Units + 261, Units + 262, Units + 263, Units + 264}; /* members */

  static pUnit Output1[3] = {Units + 265, Units + 266, Units + 267}; /* members */

  static int Output[3] = {265, 266, 267};

  for(member = 0; member < 234; member++) {
    Input[member]->act = in[member];
  }

  for (member = 0; member < 30; member++) {
    unit = Hidden1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for (member = 0; member < 3; member++) {
    unit = Output1[member];
    sum = 0.0;
    for (source = 0; source < unit->NoOfSources; source++) {
      sum += unit->sources[source]->act
             * unit->weights[source];
    }
    unit->act = Act_Logistic(sum, unit->Bias);
  };

  for(member = 0; member < 3; member++) {
    out[member] = Units[Output[member]].act;
  }

  return(OK);
}
